#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<ll> w;

ll n, m, p, g;

vector<vector<pair<ll, ll>>> G;

void solve() {
	cin >> n >> m >> p >> g;
	w.assign(n, 0);
	for (ll i = 0; i < n; i++) {
		cin >> w[i];
	}
	G.assign(n, {});
	ll a, b, s;
	for (ll i = 0; i < m; i++) {
		cin >> a >> b >> s; a--; b--;
		G[a].push_back({ b, s });
	}
	ll mx = w[0], ans = 0;
	for (ll i = 0; i < n - 1; i++) {
		mx = max(mx, w[i]);
		if (G[i][0].second > p) {
			ans += (G[i][0].second - p - 1) / mx + 1;
			p += ((G[i][0].second - p - 1) / mx + 1) * mx;
		}
		p -= G[i][0].second;
	}
	cout << ans;
}

int main() {
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}

/*
5
10 4
5 4
3 4
1 4
7 4

*/