#include<bits/stdc++.h>
using namespace std;
using ll = long long;
const ll inf = 1e18;
ll n, m, p, q, mn = inf, mx = -inf;
vector<ll> w;
vector<vector<ll>> g;
vector<bool> used;
vector<ll> dist;
void dfs() {
    dist[0] = 0;
    for (int i = 0; i < n; ++i) {
        ll mx = inf, ind = -1;
        for (int j = 0; j < n; ++j) {
            if (!used[j] && (ind == -1 || mx > dist[j])) {
                mx = dist[j];
                ind = j;
            }
        }
        if (ind == -1) {
            return;
        }
        used[ind] = 1;
        for (int j = 0; j < n; ++j) {
            if (g[ind][j] != inf) {
                if (dist[j] > dist[ind] + g[ind][j]) {
                    dist[j] = dist[ind] + g[ind][j];
                }
            }
        }
    }
}
void dfso(ll v, ll kol) {
    if (v == n - 1) {
        mn = min(mn, kol);
        return;
    }
    for (int u = 0; u < n; ++u) {
        if (u != v && g[v][u] != inf) {
            if (p >= g[v][u]) {
                p -= g[v][u];
                ll c = mx;
                mx = max(mx, w[u]);
                dfso(u, kol);
                mx = c;
                p += g[v][u];
            } else {
                g[v][u] -= p;
                ll k = (g[v][u] + mx - 1) / mx;
                ll c = p, d = mx;
                p = k * mx - g[v][u];
                mx = max(mx, w[u]);

                dfso(u, kol + k);
                p = c;
                mx = d;
                g[v][u] += p;
            }
        }
    }
}
void solve() {
    cin >> n >> m >> p >> q;
    g.resize(n, vector<ll>(n, inf)); w.resize(n); used.resize(n); dist.resize(n, inf);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < m; ++i) {
        ll a, b, s;
        cin >> a >> b >> s;
        --a; --b;
        g[a][b] = min(g[a][b], s);
    }
    if (q == 1) {
        dfs();
        if (dist[n - 1] == inf) {
            cout << -1;
            return;
        }
        if (p >= dist[n - 1]) {
            cout << 0;
            return;
        }
        cout << dist[n - 1] - p;
        return;
    }
    mx = w[0];
    if (q == 2) {
        ll kol = 0;
        for (int i = 1; i < n; ++i) {
            if (p >= g[i - 1][i]) {
                p -= g[i - 1][i];
            } else {
                g[i - 1][i] -= p;
                ll k = (g[i - 1][i] + mx - 1) / mx;
                kol += k;
                p = k * mx - g[i - 1][i];
            }
            mx = max(mx, w[i]);
        }
        cout << kol;
        return;
    }
    dfso(0, 0);
    if (mn == inf) {
        cout << -1;
        return;
    }
    cout << mn << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
