#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 800;

vector <pair <int, int>> g[MAXN];

int n, w[MAXN], mn = 1e18, graph[MAXN][MAXN];

bool used[MAXN][MAXN];

void rec(int v, int sum, int cnt, int mx) {
    if (v == n - 1) {
        mn = min(mn, cnt);
        return;
    }
    for (int j = 0; j < n; ++j) {
        int to = j, ww = graph[v][j];
        if (ww == 1e18 || used[v][j])
            continue;
        used[v][j] = true;
        int need = max((int)0, (ww - sum + max(mx, w[v]) - 1) / max(mx, w[v]));
        rec(to, sum + need * max(mx, w[v]) - ww, cnt + need, max(mx, w[v]));
        used[v][j] = false;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int m, p, gr;
    cin >> n >> m >> p >> gr;
    vector <int> d(n, 1e18);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j)
            graph[i][j] = 1e18;
    }
    for (int i = 0; i < n; ++i)
        cin >> w[i];
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a;
        --b;
        g[a].push_back({b, c});
        graph[a][b] = min(graph[a][b], c);
    }
    d[0] = 0;
    set <pair <int, int>> q;
    if (gr == 1) {
        q.insert({0, 0});
        while (!q.empty()) {
            auto [ans, v] = *q.begin();
            q.erase(q.begin());
            for (auto [to, w] : g[v]) {
                if (d[to] > d[v] + w) {
                    q.erase({d[to], to});
                    d[to] = d[v] + w;
                    q.insert({d[to], to});
                }
            }
        }
        if (d[n - 1] == 1e18) {
            cout << -1 << '\n';
        } else {
            cout << max((int)0, d[n - 1] - p) << '\n';
        }
    } else if (gr == 2) {
        int mx = w[0];
        for (int i = 1; i < n; ++i) {
            int need = max((int)0, (g[i - 1].back().second - p + mx - 1) / mx);
            d[i] = d[i - 1] + need;
            p = p + need * mx - g[i - 1].back().second;
            mx = max(mx, w[i]);
        }
        cout << d[n - 1] << '\n';
    } else if (gr == 3 || gr == 0) {
        rec(0, p, 0, 0);
        if (mn == 1e18) {
            cout << -1 << '\n';
        } else {
            cout << mn << '\n';
        }
    }
    return 0;
}
