#include <iostream>
#include <cmath>
#include <iomanip>
#include <queue>
#include <vector>
#include <set>
#include <algorithm>
#define ll long long
using namespace std;
void FAST() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
vector <ll> p(0);
ll mod = 1e9 + 7;
ll binpow(ll a, ll b) {
    if (b == 0)
        return 1;
    ll q = binpow(a, b / 2);
    ll tq = q * q % mod;
    if (b % 2 == 0)
        return tq;
    else
        return (tq * a) % mod;
}
void solve() {
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    if (g == 1) {
        ll q;
        for (ll i = 0; i < n; ++i) {
            cin >> q;
        }
        vector < vector <pair<ll, ll>>> g(n);
        for (ll i = 0; i < m; ++i) {
            ll a, b, s;
            cin >> a >> b >> s;
            a--; b--;
            g[a].push_back({ b, s });
        }
        vector <ll> nw(n, 1e18);
        nw[0] = 0;
        set <pair<ll, ll>> s;
        s.insert({ 0, 0 });
        while (!s.empty()) {
            auto q = *s.begin();
            s.erase(s.begin());
            for (auto i : g[q.second]) {
                if (q.first + i.second < nw[i.first]) {
                    s.erase({ nw[i.first], i.first });
                    nw[i.first] = q.first + i.second;
                    s.insert({ nw[i.first], i.first });
                }
            }
        }
        if (nw[n - 1] == 1e18) {
            cout << -1;
        }
        else {
            cout << max(0ll, nw[n - 1] - p);
        }
    }
    if (g == 2) {
        vector <ll> w(n);
        for (ll i = 0; i < n; ++i) {
            cin >> w[i];
        }
        vector <ll> c(m);
        for (ll i = 0; i < m; ++i) {
            cin >> c[i] >> c[i] >> c[i];
        }
        ll ans = 0, opt = w[0];
        for (ll i = 0; i < m; ++i) {
            opt = max(opt, w[i]);
            if (p < c[i]) {
                ll t = c[i] - p;
                t += opt - 1;
                t /= opt;
                ans += t;
                p += t * opt;
            }
            p -= c[i];
        }
        cout << ans;
    }
}
int main()
{
    FAST();
    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}