#include <bits/stdc++.h>


typedef long long ll;
typedef unsigned long long ull;
using namespace std;
const ll INF = 1e18;



int main() {
    ios::sync_with_stdio(true);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll n, m;
    cin >> n >> m;
    ll p, t;
    cin >> p >> t;
    vector<vector<pair<ll, ll>>> g(n);
    vector<ll> c(n);
    for (ll i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (ll i = 0; i < m; ++i) {
        ll x, y, w;
        cin >> x >> y >> w;
        x--, y--;
        g[x].emplace_back(y, w);
    }
    if (t == 2) {
        vector<tuple<ll, ll, ll>> dp(n, {-1, -1, -1});
        dp[0] = {p, 0, c[0]};
        for (ll i = 0; i < n - 1; ++i) {
            auto [P, CNT, COST] = dp[i];
            auto W = g[i][0].second;
            ll conc = 0;
            COST = max(COST, c[i]);
            if (P < W) {
                conc = (W - P + COST - 1) / COST;
//                cerr << conc << "\n";
                P += conc * COST;
            }
            dp[i + 1] = {P - W, CNT + conc, COST};
//            cout << get<1>(dp[i]) << " ";
        }
        cout << get<1>(dp[n - 1]);
    }
    if (t == 1) {
        vector<ll> dist(n, INF);
        dist[0] = 0;
        vector<bool> used(n, false);
        while (true) {
            ll v = -1;
            for (ll i = 0; i < n; ++i) {
                if (!used[i] && (v == -1 || dist[v] > dist[i])) {
                    v = i;
                }
            }
            if (v == n - 1 || v == -1) break;
            used[v] = true;
            for (auto [to, w] : g[v]) {
                if (!used[to]) {
                    if (dist[v] + w < dist[to]) {
                        dist[to] = dist[v] + w;
                    }
                }
            }
        }
        if (dist[n - 1] >= INF) {
            cout << -1;
            return 0;
        }
        cout << max(0ll, dist[n - 1] - p);
    }


    return 0;
}