#include <bits/stdc++.h>
#include <unordered_map>
#include <random>


using namespace std;

typedef long long ll;
typedef double ld;
typedef unsigned long long ull;

const int N = 800;

mt19937 rnd(228);
ll n, m, p, g;
vector<pair<ll, ll>> a[N];
ll cost[N];

ll mx = 0;
struct pos {
    ll v;
    ll best;
    ll count;
    ll money;
};

vector <int> rast;


bool bfs() {
    queue <pos> q;
    q.push({0, cost[0], 0, p});
    rast[0] = 0;
    vector <vector<int>> vis(n, vector<int>(n, 0));
    while (!q.empty()) {
        auto gg = q.front();
        q.pop();
        if (gg.count>mx) continue;
        if (gg.v == n-1) return true;
        for (auto u : a[gg.v]) {
            if (vis[gg.v][u.first]>5) continue;
            vis[gg.v][u.first]++;
            pos nw;
            nw.v = u.first;
            nw.best = max(gg.best, cost[u.first]);
            if (gg.money>=u.second) {
                nw.count = gg.count;
                nw.money = gg.money - u.second;
                rast[u.first] = min(rast[u.first], rast[gg.v] + 1);
                q.push(nw);
                continue;
            }
            nw.count = gg.count + (u.second-gg.money + gg.best - 1) / gg.best;
            nw.money = (u.second-gg.money + gg.best - 1) % gg.best;
            rast[u.first] = min(rast[u.first], rast[gg.v] + 1);
            q.push(nw);
        }
    }
    return false;
}

int main() {
    cin.tie(0); cout.tie(0); ios::sync_with_stdio(0);
    cin >> n >> m >> p >> g;
    rast.assign(n, 1e9);
    for (int i=0; i<n; i++) cin >> cost[i];
    for (int i =0; i<m; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--; u--;
        a[v].push_back({u, w});
    }
    ll l = -1;
    ll r = 1e18+1e10;
    while (r-l>1){
        ll sr = (l+r)/2;
        mx = sr;
        if (bfs()) r = sr;
        else l = sr;
    }
    if (r>1e16) {
        cout << "-1\n";
        return 0;
    }
    cout << r << "\n";



}

//n*t+n*m*logn