#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <assert.h>
#include <chrono>
#include <random>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 2e9 + 7;
const ld eps = 1e-9;

signed main() {
	int n, m, p, g; cin >> n >> m >> p >> g;
	vector<int> mas(n);
	for (int x = 0; x < n; x++) {
		cin >> mas[x];
	}
	if (n >= 10) {
		vector<int> sum;
		for (int x = 0; x < m; x++) {
			int a, b, s; cin >> a >> b >> s;
			sum.push_back(s);
		}
		vector<vector<int>> dp(n, vector<int>(n, -INF));
		dp[0][0] = p;
		for (int x = 0; x < n - 1; x++) {
			for (int cnt = 0; cnt < n; cnt++) {
				if (dp[x][cnt] + mas[x] >= sum[x]) {
					dp[x + 1][cnt + 1] = max(dp[x + 1][cnt + 1], dp[x][cnt] + mas[x] - sum[x]);
				}
				if (dp[x][cnt] >= sum[x]) {
					dp[x + 1][cnt] = max(dp[x + 1][cnt], dp[x][cnt] - sum[x]);
				}
			}
		}
		for (int x = 0; x < n; x++) {
			if (dp[n][x] != -INF) {
				cout << x << endl;
				return 0;
			}
		}
		cout << -1;
		return 0;
	}
}