#include <bits/stdc++.h>

using namespace std;

#define int long long

vector <int> used;

vector <int> ww;

int best = 1e15;

void rec(vector < vector < pair <int, int> > > &g, int v, int mx, int sm, int now) {
    if (now >= best) return;
    if (v == g.size() - 1) {
        best = min(best, now);
        return;
    }
    used[v]++;
    for (auto [u, w] : g[v]) {
        if (used[u] < 2) {
            int d = 0;
            if (sm < w) {
                d = (w - sm + mx - 1) / mx;
                now += d;
                sm += d * mx;
            }
            sm -= w;
            rec(g, u, max(mx, ww[u]), sm, now);
            sm += w;
            if (d != 0) {
                now -= d;
                sm -= d * mx;
            }
        }
    }
    used[v]--;
}

vector <int> deikstra(vector < vector < pair <int, int> > > &g, int start) {
    vector <int> d(g.size(), 1e15);
    d[start] = 0;
    set < pair <int, int> > s;
    s.insert({d[start], start});
    while (!s.empty()) {
        int v = s.begin()->second;
        s.erase(s.begin());
        for (int i = 0; i < g[v].size(); i++) {
            int u = g[v][i].first, w = g[v][i].second;
            if (d[v] + w < d[u]) {
                s.erase({d[u], u});
                d[u] = d[v] + w;
                s.insert({d[u], u});
            }
        }
    }
    return d;
}

signed main () {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m, p, gg;
    cin >> n >> m >> p >> gg;
    vector < vector < pair <int, int> > > g(n);
    vector <int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    ww = w;
    int sm = 0;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].push_back({v, w});
        sm += w;
    }
    if (gg == 1) {
        vector <int> d = deikstra(g, 0);
        if (d[n - 1] == 1e15) {
            cout << -1;
        } else {
            cout << max(0ll, d[n - 1] - p);
        }
    } else if (gg == 2) {
        int res = 0;
        int need = max(0ll, sm - p);
        int mx = 0;
        for (int i = 0; i < n - 1; i++) {
            mx = max(mx, w[i]);
            if (p < g[i][0].second) {
                int d = ((g[i][0].second - p + mx - 1) / mx);
                res += d;
                p += d * mx;
            }
            p -= g[i][0].second;
        }
        cout << res << endl;
    } else if (gg == 3 || gg == 0) {
        used.resize(n);
        rec(g, 0, w[0], p, 0);
        if (best == 1e15) {
            cout << -1;
        } else {
            cout << best;
        }
    } else {

    }
    
    return 0;
} 