#include <bits/stdc++.h>

using namespace std;
#define int long long
#define double long double

vector<vector<pair<int, int> >> gr;

vector<int> deik(int st) {
    int n = (int)gr.size();
    set<pair<int, int> > q;
    q.insert({0, st});
    vector<int> dist(n, -1);
    dist[st] = 0;
    while(!q.empty()){
        auto [dst, v] = *q.begin();
        q.erase(q.begin());
        for( auto u : gr[v]) {
            if(dist[u.first] == -1){
                dist[u.first] = dst + u.second;
                q.insert({dist[u.first], u.first});
            }
            else if(dist[u.first] > dst + u.second) {
                q.erase({dist[u.first], u.first});
                dist[u.first] = dst + u.second;
                q.insert({dist[u.first], u.first});
            }
        }
    }
    return dist;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for(int i =0 ;i<n;++i)
        cin >> w[i];
    gr.resize(n);
    for(int i = 0;i<m;++i){
        int x, y, a;
        cin >> x >> y >> a;
        --x;
        --y;
        gr[x].push_back({y, a});
//        gr[y].push_back({x, a});
    }
    vector<int> dist(deik(0));
    if(dist[n - 1] == -1)
        cout << -1;
    else
        cout << max(0LL, dist[n - 1] - p);
}
