#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("-O3")

#define fi first
#define se second

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const int N = 2e5 + 5;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define fbo find_by_order
#define ook order_of_key

mt19937 rng(time(0));

int n, m, group;
vector<pair<int, ll>> g[N];
ll d[N], p, w[N];
ll ans = 2e18;
bool used[N];
multiset<ll> st;
int cnt = 0;

void dfs(int v, ll res, ll p){
    if(res - ans >= 0)return;
    if(v == n){
        ans = min(ans, res);
        return;
    }
    used[v] = 1;
    st.insert(w[v]);
    for(auto to : g[v]){
        if(used[to.fi])continue;
        if(p >= to.se){
            dfs(to.fi, res, p - to.se);
        } else {
            ll x = to.se;
            ll p2 = p;
            x -= p2;
            p2 = 0;
            ll W = *--st.end();
            ll cnt = ceil(ld(x) / ld(W));
            p2 += cnt * W;
            p2 -= x;
            dfs(to.fi, res + cnt, p2);
        }
    }
    st.erase(st.find(w[v]));
    used[v] = 0;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    ios_base::sync_with_stdio(0);

    cin >> n >> m >> p >> group;

    for(int i = 1; i <= n; i++){
        cin >> w[i];
    }

    for(int i = 0; i < m; i++){
        int a, b, s;
        cin >> a >> b >> s;
        g[a].pb({b, s});
    }

    if(group == 1){
        for(int i = 1; i <= n; i++){
            d[i] = 2e18;
        }
        d[1] = 0;
        set<pair<ll, int>> st;
        st.insert({d[1], 1});

        while(sz(st)){
            auto it = st.begin();
            int v = (*it).se;
            ll len = (*it).fi;
            for(auto to : g[v]){
                if(d[to.fi] > len + to.se){
                    st.erase({d[to.fi], to.fi});
                    d[to.fi] = len + to.se;
                    st.insert({d[to.fi], to.fi});
                }
            }
            st.erase({d[v], v});
        }

        if(d[n] == 2e18)cout << "-1\n";
        else cout << max(0LL, d[n] - p) << "\n";
        return 0;
    }

    dfs(1, 0, p);

    if(ans == 2e18)cout << "-1\n";
    else cout << ans << "\n";

    return 0;
}
