//#pragma GCC optimize("O3", "inline", "unroll-loops", "no-stack-protector")
//#pragma GCC comment("/linker:64000000")
//#pragma GCC targer("fma")
#include <bits/stdc++.h>

#include <ext/rope>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
//#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
using namespace __gnu_cxx;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

const int MAXN = 800;
vector<pii> adj[MAXN];
int w[MAXN];
bool used[MAXN];
int d[MAXN];

void solve_one(int n, int m, int p) {
    fill(used, used + MAXN, 0);
    fill(d, d + MAXN, 1e9);

    d[0] = 0;
    used[0] = 1;
    queue<int> q;
    q.push(0);

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (pii &it : adj[v]) {
            if (!used[it.X]) {
                d[it.X] = d[v] + 1;
                used[it.X] = 1;
            }
        }
    }

    if (used[n - 1] == 0) {
        cout << -1 << endl;
    } else {
        cout << max(0, d[n - 1] - p) << endl;
    }
}

inline void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;

    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }

    for (int i = 0; i < m; i++) {
        int u, v, s;
        cin >> u >> v >> s;
        --u; --v;

        adj[u].push_back({v, s});
    }

    if (g == 1) {
        solve_one(n, m, p);
    } else if (g == 2) {

    }
}


signed main() {
    fast;
//    cout.precision(10);
//    cout << fixed;

//
#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
//    freopen("./input.txt", "r", stdin);
//    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}
