//#pragma GCC optimize("O3", "inline", "unroll-loops", "no-stack-protector")
//#pragma GCC comment("/linker:64000000")
//#pragma GCC targer("fma")
#include <bits/stdc++.h>

#include <ext/rope>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
using namespace __gnu_cxx;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

const int MAXN = 800;
vector<pii> adj[MAXN];
int matr[MAXN][MAXN];
int w[MAXN];
bool used[MAXN];
ll d[MAXN];

void solve_one(int n, int m, ll p) {
    fill(used, used + MAXN, 0);
    fill(d, d + MAXN, INT64_MAX);

    d[0] = 0;
    priority_queue<pair<ll, int>> q;
    q.push({0, 0});

    while (!q.empty()) {
        int v = q.top().Y;
        q.pop();

        if (used[v]) {
            continue;
        }

        used[v] = 1;

        for (pii &it : adj[v]) {
            if (!used[it.X]) {
                if (rmin(d[it.X], d[v] + it.Y)) {
                    q.push({-d[it.X], it.X});
                }
            }
        }
    }

    if (used[n - 1] == 0) {
        cout << -1 << endl;
    } else {
        cout << max(0ll, d[n - 1] - p) << endl;
    }
}

int ceil(int a, int b) {
    return a / b + (a % b != 0);
}

void solve_second(int n, int m, int p) {
    int mi_w = w[0];
    int v = 0;
    ll cnt = 0;
    while (v != n - 1) {
        int st = adj[v][0].Y;
        if (st <= p) {
            p -= st;
        } else {
            st -= p;
            int fg = ceil(st, mi_w);
            p = fg * mi_w - st;
            cnt += fg;
        }
        v++;
        rmax(mi_w, w[v]);
    }

   cout << cnt << endl;
}

ll g_ans = INT64_MAX;

void solve_third(int n, int m, int my_p) {
    vector<int> o(n - 1);
    iota(all(o), 1);

    do {
        int p = my_p;
        int mi_w = w[0];
        ll cnt = 0;
        int v = 0;
        for (int &it : o) {
            if (matr[v][it] == 0) {
                cnt = INT64_MAX;
                break;
            }

            int st = matr[v][it];
            if (st <= p) {
                p -= st;
            } else {
                st -= p;
                int fg = ceil(st, mi_w);
                p = fg * mi_w - st;
                cnt += fg;
            }

            rmax(mi_w, w[it]);
            v = it;
            if (it == n - 1) {
                rmin(g_ans, cnt);
                break;
            }
        }
    } while (next_permutation(all(o)));

    if (g_ans == INT64_MAX) {
        cout << -1 << endl;
    } else {
        cout << g_ans << endl;
    }
}


inline void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    for (int i = 0; i < MAXN; i++) {
        for (int j = 0; j < MAXN; j++) {
            matr[i][j] = 0;
        }
    }

    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }

    for (int i = 0; i < m; i++) {
        int u, v, s;
        cin >> u >> v >> s;
        --u; --v;
        matr[u][v] = s;
        adj[u].push_back({v, s});
    }

    if (g == 1) {
        solve_one(n, m, p);
    } else if (g == 2) {
        solve_second(n, m, p);
    } else if (g == 3 || g == 0) {
        solve_third(n, m, p);
    }
}


signed main() {
    fast;
//    cout.precision(10);
//    cout << fixed;

//
#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
//    freopen("./input.txt", "r", stdin);
//    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}
