#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "lzcnt", "popcnt")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
#define int ll

cosnt ll INF = 1e18 + 42;

struct Node {
    int cnt = 0, d = 0, maxw = 0;

    Node() = default;
    Node(int cnt, int d, int maxw) : cnt(cnt), d(d), maxw(maxw) {}
};

bool operator<(const Node& a, const Node& b) {
    if (a.cnt == b.cnt) {
        if (a.d== b.d)
            return a.maxw > b.maxw;
        return a.d> b.d;
    }
    return a.cnt < b.cnt;
}

int n, m, p, gr;
vector<int> a;
vector<vector<pair<int, ll>>> g;

void solve() {
    cin >> n >> m >> p >> gr;
    a.assing(n, 0);
    for (auto& i : a)
        cin >> i;
    g.assing(n, {});
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
    }

    vector<Node> dist(n, Node(INF, INF, -INF));
    for (int i = 0; i < n; ++i)
        dist[i].maxw = a[i];
    dist[0] = Node(0, p, a[0]);
    set<pair<Node, int>> q;
    q.insert({dist[0], 0});
    while (!q.empty()) {
        auto [x, v] = *q.begin();
        q.erase(q.begin());
        for (auto& [u, w] : g[v]) {
            Node tmp = dist[v];
            if (tmp.d >= w)
                tmp.d -= w;
            else {
                int wait = (w - tmp.d + tmp.maxw - 1) / tmp.maxw;
                tmp.d += wait * tmp.maxw - w;
                tmp.cnt += wait;
            }
            tmp.maxw = max(tmp.maxw, dist[u].maxw);
            if (tmp < dist[u]) {
                q.erase({dist[u], u});
                dist[u] = tmp;
                q.insert({dist[u], u});
            }
        }
    }
    /*
    for (auto [cnt, d, maxw] : dist)
        cout << cnt << " " << d << " " << maxw << endl;
    */
    cout << (dist[n - 1].cnt == INF ? -1 : dist[n - 1].cnt) << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}