#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <iomanip>
#include <queue>
#include <deque>
#include <stack>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 500007;
ll n, m, k;
vector<pair<int, ll>>g[N];
ll a[N];
ll v[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m >> k;
	int subtask;
	cin >> subtask;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	if (subtask == 1) {
		for (int i = 0; i < m; i++) {
			int x, y;
			ll w;
			cin >> x >> y >> w;
			g[x].push_back({ y,w });
		}
		vector<ll>d(n + 1, INF);
		priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>>q;
		q.push({ 0,1 });
		d[1] = 0;
		while (!q.empty()) {
			int v = q.top().ss;
			ll dist = q.top().ff;
			q.pop();
			if (d[v] == dist) {
				for (pair<int, ll>x : g[v]) {
					int to = x.ff;
					ll w = x.ss;
					if (d[to] > d[v] + w) {
						q.push({ d[v] + w,to });
						d[to] = d[v] + w;
					}
				}
			}
		}
		if (d[n] == INF) {
			cout << -1 << endl;
		}
		else cout << max(0ll, d[n] - k) << endl;
	}
	else if (subtask == 2) {
		for (int i = 1; i <= m; i++) {
			int x, y;
			ll w;
			cin >> x >> y >> w;
			v[i] = w;
		}
	}
}