//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,tune-native")

#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define INF (int) 1e18 / 2

using namespace std;

mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

template<typename T>
using pqg = priority_queue<T, vector<T>, greater<T>>;

void solve() {
	int n, m, p, G;
	cin >> n >> m >> p >> G;
	vector g(n + 1, vector<pair<int, int>>());
	vector<int> a(n + 1);
	for (int i = 1; i <= n; i++)
		cin >> a[i];
	for (int i = 0; i < m; i++) {
		int v, u, w;
		cin >> v >> u >> w;
		g[v].push_back({u, w});
	}
	if (G == 1) {
		pqg<pair<int, int>> q;
		q.push({0, 1});
		vector<int> d(n + 1, INF);
		d[1] = 0;
		while (!q.empty()) {
			auto[cur, v] = q.top();
			q.pop();
			for (auto[u, w]: g[v])
				if (d[u] > d[v] + w)
					d[u] = d[v] + w, q.push({d[u], u});
		}
		cout << (d[n] == INF ? -1 : max(0ll, d[n] - p)) << '\n';
	} else if (G == 2) {
		int res = 0;
		for (int i = 1; i < n; i++) {
			int need = max(0ll, g[i][0].second - p);
			int d = (need + a[i] - 1) / a[i];
			res += d;
			p += d * a[i];
			p -= g[i][0].second;
		}
		cout << res << '\n';
	}
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(20);

	solve();
}
