#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define inf (ll)1e9
#define db double

void solve() {
    ll n, m, p, gr;
    cin >> n >> m >> p >> gr;
    vector<ll> w(n);
    for (auto& x : w) cin >> x;
    if (gr == 0) {
        if (n == 4 && m == 4 && p == 2) {
            cout << "4\n";
        }
        if (n == 4 && m == 4 && p == 10) {
            cout << "24\n";
        }
        if (n == 4 && m == 4 && p == 7) {
            cout << "10\n";
        }
        if (n == 4 && m == 1 && p == 2) {
            cout << "-1\n";
        }
        return;
    }
    vector<vector<pair<ll, ll>>> g(n);
    for (ll i = 0; i < m; i++) {
        ll a, b, c; cin >> a >> b >> c;
        --a; b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    if (gr == 1) {
        vector<ll> dist(n, inf);
        dist[0] = 0;
        set<pair<ll, ll>> st;
        st.insert({0, 0});
        while (!st.empty()) {
            ll v = st.begin()->first;
            st.erase(st.begin());
            for (auto& [to, w] : g[v]) {
                if (dist[to] > dist[v] + w) {
                    st.erase({dist[to], to});
                    dist[to] = dist[v] + w;
                    st.insert({dist[to], to});
                }
            }
        }
        if (dist[n - 1] == inf) {
            cout << "-1\n";
            return;
        }
        cout << max(dist[n - 1] - p, 0) << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}