#include <bits/stdc++.h>
//#include <ext/pd_ds/assoc_container.hpp>
//#include <ext/pd_ds/tree_policy.hpp>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define mp make_pair
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef int64_t ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
ostream& operator << (ostream& out, pair<T, T1> &pr) {
    out << pr.first << " " << pr.second;
    return out;
}

template<typename T, typename T1>
istream& operator >> (istream& in, pair<T, T1> &pr) {
    in >> pr.first >> pr.second;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &arr) {
    for (auto &i : arr) {out << i << " ";}
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &arr) {
    for (auto &i : arr) {in >> i;}
    return in;
}

//typedef tree<int, null_type, less<int>,
// rb_tree_tag, tree_order_statistics_node> ordered_set;

vector<vector<pii>> g;
vector<int> s;

int dfs(int v, int p, int mx, int c, int cnt) {
    if (v == sz(s) - 1) {
        return cnt;
    }
    for (auto [u, d] : g[v]) {
        if (u != p) {
            int a1 = c, b1 = cnt;
            if (c < d) {
                b1 += (d - c + mx - 1) / mx;
                a1 = (d - c + mx - 1) / mx * mx + c - d;
            }
            int a = dfs(u, v, max(s[u], mx), a1, b1);

            if (a != -1) {
                return a;
            }
        }
    }
    return -1;
}

void solve() {
    int n, m, p, gr; cin >> n >> m >> p >> gr;
    s.rs(n); cin >> s;

    g.rs(n);
    for (int i = 0; i < m; i++) {
        int a, b, c; cin >> a >> b >> c;
        a--; b--;

        g[a].pb({b, c});
        g[b].pb({a, c});
    }
    //cout << sz(g[0]) << "\n";

    if (gr == 1) {
        vector<int> dist(n, 1e18);
        dist[0] = 0;

        multiset<pii> s1;
        for (int i = 0; i < n; i++) s1.insert({dist[i], i});

        while (!(s1.empty())) {
            auto [d, v] = *s1.begin();
            s1.erase(s1.begin());

            if (d == 1e18) break;

            for (auto [u, c] : g[v]) {
                //cout << i.ff << "\n";
                if (dist[u] > d + c) {
                    auto cur = s1.lower_bound({dist[u], u});
                    if (cur == s1.end()) continue;
                    s1.erase(cur);


                    dist[u] = d + c;

                    s1.insert({dist[u], u});

                }
            }
        }

        if (dist[n - 1] == 1e18) {
            cout << -1;
            return;
        }

        cout << max(0LL, dist[n - 1] - p);
    }
    if (gr == 2) {
        cout << dfs(0, -1, 0, p, 0);
    }
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double start_time = clock();
#endif
    int test = 1;
    //cin >> test;

    while (test--) {
        solve();
#ifdef LOCAL
        cout << "--------------\n";
#endif
    }
#ifdef LOCAL
    cout << "execution time: " << (clock() - start_time) / CLOCKS_PER_SEC;
#endif
}