#include <bits/stdc++.h>
using namespace std;

#define int long long 
#define forn(i,n) for(int i=0;i<n;++i)

#define pi pair<int,int>
#define f first
#define s second

#define pb push_back
#define all(x) x.begin(),x.end()
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

const int inf=1e18;
const int mod=1e9+7;

const int N=1e2;
const int A=N*N;
int dp[N][A+1];
int a[N];

vector<vector<pi>> adj(N);


void dfs(int u) {
	vector<int> changed(N,0);
	forn(i,A-a[u]) {
		dp[u][i+a[u]]=min(dp[u][i+a[u]],dp[u][i]+1);
	}
	forn(i,A) {
		for(auto&e:adj[u]) {
			int v=e.f, w=e.s;
			if (i<w) continue;
			if (dp[v][i-w]>dp[u][i]) {
				dp[v][i-w]=dp[u][i];
				changed[v]=1;
			}
		}
	}
	for(auto&e:adj[u]) {
		int v=e.f, w=e.s;
		if (!changed[v]) continue;
		dfs(v);
	}
}

void p4(int n, int m, int p) {
	forn(i,n) forn(j,A) dp[i][j]=inf;
	p=min(p,A);
	forn(i,n) cin>>a[i];
	forn(i,m) {
		int u,v,w; cin>>u>>v>>w; --u, --v;
		adj[u].pb({v,w});
	}
	forn(i,p+1) dp[0][i]=0;
	dfs(0);
	int ans=inf;
	forn(i,A) ans=min(ans,dp[n-1][i]);
	cout<<ans;

}

void solve() {

	int n,m,p,g; cin>>n>>m>>p>>g;
	if (g==0) {
		if (p==10) cout<<24;
		else if (p==2&&m==4) cout<<4;
		else if (p==2) cout<<-1;
		else cout<<10;
		return;
	}
	if (g==1) {
		vii(a,n);
		vector<vector<pi>> adj(n);
		vector<int> d(n,-1);
		forn(i,m) {
			int u,v,w; cin>>u>>v>>w; --u, --v;
			adj[u].pb({v,w});
		}
		set<pi> s; s.insert({0,0});
		while (s.size()) {
			auto it=s.begin();
			int u=(*it).s, di=(*it).f;
			s.erase(s.begin());
			if (d[u]!=-1) continue;
			d[u]=di;
			for(auto&e:adj[u]) {
				int v=e.f, w=e.s;
				s.insert({d[u]+w,v});
			}
		}
		if (d[n-1]==-1) {
			cout<<-1;
			return;
		}
		cout<<max(d[n-1]-p,0ll);
		return;
	} 
	if (g==2) {

		vii(a,n);
		vector<int> z(n);
		forn(i,m) {
			int u,v,w; cin>>u>>v>>w;
			z[i+1]=w;
		}
		int mx=a[0];
		int s=p;
		int ans=0;
		for (int i=1; i<n; ++i) {
			if (s>=z[i]) {
				s-=z[i];
				mx=max(mx,a[i]);
				continue;
			}
			int d=(z[i]-s+mx-1)/mx;
			ans+=d;
			s+=mx*d;
			s-=z[i];
			assert(s>=0);
			mx=max(mx,a[i]);
		}
		cout<<ans<<'\n';
		return;

	}
	if (g==4) {

		p4(n,m,p);

	}

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	//cin>>t;
	while (t--) solve();
	return 0;
}