#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

#ifdef CLOWN
void dbg(ll a) {cout << a << "\n";}
void dbg(int a) {cout << a << "\n";}
void dbg(string a) {cout << a << "\n";}
void dbg(ll a, ll b) {cout << a << " " << b << "\n";}
void dbg(int a, int b) {cout << a << " " << b << "\n";}
void dbg(ll a, ll b, ll c) {cout << a << " " << b << " " << c << "\n";}
void dbg(int a, int b, int c) {cout << a << " " << b << " " << c << "\n";}
void dbg(vector<ll> & a) {for (auto i : a) cout << i << " "; cout << "\n";}
void dbg(vector<int> & a) {for (auto i : a) cout << i << " "; cout << "\n";}
#else
#define dbg(...)
#endif

#define int ll
struct line {
    int k, b;
    line(int _k = 0, int _x = 0) {
        k = _k, b = _x;
    }
    int get(int x) {
        return k * x + b;
    }
};

void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    vector<vector<pair<int, int>>> g(n);
    vector<int> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--, v--;
        g[u].push_back({v, c});
    }
//    if (G == 2) {
        vector<pair<int, int>> dp(n, {1e18, 1e18});
        dp[0] = {0, p};
        auto f = [&](pair<int, int> a1, pair<int, int> b) {
            if (a1.first == b.first) return max(a1, b);
            else return min(a1, b);
        };
        vector<int> pref(n);
        for (int i = 0; i < n - 1; i++) {
            pref[i + 1] = g[i][0].second;
        }
        for (int i = 1; i < n; i++) {
            pref[i] = pref[i - 1] + pref[i];
        }
        dbg(pref);
        for (int i = 1; i < n; i++) {
            for (int j = 0; j < i; j++) {
                int need = pref[i] - pref[j];
                auto [stations, wei] = dp[j];
                if (need <= wei) {
                    dp[i] = f(dp[i], {stations, wei - need});
                } else {
                    int v = need - wei;
                    for (int k = 0; k < i; k++) {
                        int cur = (w[k] + v - 1) / w[k];
                        int val = cur * w[k];
                        dp[i] = f(dp[i], {stations + cur, wei + val - need});
                    }
                }
            }
        }
        for (auto i : dp) {
            dbg(i.first, i.second);
        }
        cout << dp.back().first << "\n";
//    }
}

int32_t main() {
#ifdef CLOWN
    freopen("C://Users//olymp//CLionProjects//untitled//input.txt", "r", stdin);
    freopen("C://Users//olymp//CLionProjects//untitled//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
