#include <bits/stdc++.h>
#define int long long
#define pii pair < int, int >
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

const int maxn = 200 + 1, mam = 1e4 + 1, inf = 1e12 + 100, L = 20, mod = 1e9 + 7;

int a[maxn], used[maxn], ans30 = -1;
vector < pii > g[maxn];
int matr[maxn][maxn];
int dp[maxn][mam];

void dfs(int v, int n, int cnt, int sum)
{
    // cout << v << ' ' << cnt  << ' ' << sum << endl;
    if (v == n)
    {
        if (ans30 == -1)
            ans30 = cnt;
        else
            ans30 = min(ans30, cnt);
        return;
    }
    used[v] = 1;
    int now = 0;
    for (int i = 1; i <= n; ++i)
        if (used[i])
            now = max(now, a[i]);
    
    for (int u = 1; u <= n; ++u)
    {
        if (matr[v][u] == inf || used[u])
            continue;
        if (used[u] == 0)
        {
            int w = matr[v][u];
            if (sum < w)
            {
                int k = (w - sum);
                k = (k + now - 1);
                k /= now;
                int tmp = k * now;
                tmp += sum - w;
                dfs(u, n, cnt + k, tmp);
            }
            else
            {
                dfs(u, n, cnt, sum - w);
            }
        }
    }
    used[v] = 0;
}

void solve()
{
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            matr[i][j] = inf;
    for (int i = 0; i < m; ++i)
    {
        int x, b;
        int w;
        cin >> x >> b >> w;
        g[x].pb({b, w});
        matr[x][b] = min(matr[x][b], w);
    }
    if (group == 1)
    {
        set < pii > st;
        vector < int > d(n + 1, inf);
        d[1] = 0;
        st.insert({0, 1});
        while (st.size())
        {
            auto [tmp, v] = *(st.begin());
            st.erase(st.begin());
            for (auto [u, w] : g[v])
            {
                if (d[u] > (tmp + w))
                {
                    st.erase({d[u], u});
                    d[u] = tmp + w;
                    st.insert({d[u], u});
                }
            }
        }
        if (d[n] == inf)
        {
            cout << -1;
        }
        else    
        {
            cout << max(0ll, d[n] - p);
        }
    }
    if (group == 2)
    {
        vector < int > st; 
        for (int i = 1; i < n; ++i)
            st.pb(g[i][0].second);
        int now = p, ans = 0, mx = a[1];
        for (int i = 0; i + 1 < n; ++i)
        {
            if (st[i] > now)
            {
                int k = st[i] - now;
                k = (k + mx - 1) / mx;
                ans += k;
                now += mx * k;
                now -= st[i];
            }
            else
            {
                now -= st[i];
            }
            mx = max(mx, a[i + 2]);
        }
        cout << ans << endl;
    }
    // if (group == 3 || group == 0)
    // {
    //     dfs(1, n, 0, p);
    //     cout << ans30 << endl;        
    // }
    if (group == 4)
    {
        for (int i = 0; i < maxn; ++i)
            for (int j = 0; j < mam; ++j)
                dp[i][j] = inf;
        dp[1][0] = p;
        
    }
}

signed main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
        cout << endl;
    }
    return 0;
}