#include <bits/stdc++.h>
#include <unordered_map>
#include <unordered_set>

#define umap unordered_map
#define uset unordered_set

#define spc << ' ' <<
#define space << ' '
#define newl << '\n'
#define endl << endl

#define pb push_back
#define elif else if
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define repeat(a) for (int i31 = 0; i31 < a; ++i31)

using namespace std;
using str = string;
using ll = long long;
using vi = vector <int>;
using vl = vector <ll>;
using vvi = vector <vi>;
using vvl = vector <vl>;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

template <typename T>
istream& operator>>(istream& in, pair <T, T>& p) {
    in >> p.first >> p.second;
    return in;
}
template <typename T>
istream& operator>>(istream& in, vector <T>& a) {
    for (int i = 0; i < (int)a.size(); ++i) {
        in >> a[i];
    }
    return in;
}
template <typename T>
ostream& operator<<(ostream& out, pair <T, T>& p) {
    out << p.first << p.second;
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, vector <T>& a) {
    for (auto c : a) {
        out << c space;
    }
    return out;
}

const int INF = INT_MAX;
const ll LINF = LLONG_MAX;
const ll hash_power = 29;
const ll mod = 1e9 + 7;

void solve() {
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    vl w(n);
    cin >> w;
    vector <vector <pii>> gr(n);
    repeat(m) {
        int x, y, s;
        cin >> x >> y >> s; x--, y--;
        gr[x].pb({y, s});
    }

    if (g == 0) {
        if (p == 2) {
            if (m == 4) {
                cout << 4;
            }
            else {
                cout << -1;
            }
        }
        elif (p == 10) {
            cout << 24;
        }
        else {
            cout << 10;
        }
    }
    elif (g == 1) {
        vl dist(n, LINF);
        dist[0] = 0;
        vi used(n, 0);
        for (int i = 0; i < n - 1; ++i) {
            int id = -1;
            for (int j = 0; j < n; ++j) {
                if (used[j]) continue;
                if (id == -1 || dist[id] > dist[j]) {
                    id = j;
                }
            }

            if (id == -1 || dist[id] == LINF) break;
            used[id] = 1;

            for (auto p : gr[id]) {
                ll to = p.first, s = p.second;
                dist[to] = min(dist[to], dist[id] + s);
            }
        }

        if (dist[n - 1] == LINF) {
            cout << -1;
        }
        else {
            cout << max(0ll, dist[n - 1] - p);
        }
    }
    elif (g == 2) {
        ll ans = 0, ma = 0;
        for (int i = 0; i < n - 1; ++i) {
            ma = max(ma, w[i]);
            ll res = max(0ll, gr[i][0].second - p) / ma + (max(0ll, gr[i][0].second - p) % ma != 0);
            ans += res;
            p += res * ma - gr[i][0].second;
        }
        cout << ans;
    }
    elif (g == 3) {
        vector <vector <pll>> dp(1 << n, vector <pll> (n, {LINF, LINF}));
        dp[1][0] = {0, p};
        for (int mask = 1; mask < (1 << n); ++mask) {
            ll ma = 0;
            for (int i = 0; i < n; ++i) {
                if (mask && (1 << i)) ma = max(ma, w[i]);
            }

            for (int i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    if (dp[mask][i].first == LINF) continue;
                    for (auto pr : gr[i]) {
                        ll to = pr.first, s = pr.second;
                        ll cnt = max(0ll, (s + dp[mask][i].second) / ma + ((s + dp[mask][i].second) % ma != 0));
                        dp[mask | (1 << to)][to] = min(dp[mask | (1 << to)][to], {dp[mask][i].first + cnt, dp[mask][i].second - cnt * ma + s});
                    }
                }
            }

            if (dp[(1 << n) - 1][n - 1].first == LINF) {
                cout << -1;
            }
            else {
                cout << dp[(1 << n) - 1][n - 1].first;
            }
        }
    }
}

void tests() {
    int t;
    cin >> t;
    for (int i = 1; i <= t; ++i) {
        cout << "Test number:" spc i newl;
        solve();
        cout newl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    /*
    freopen("inputD.txt", "r", stdin);
    tests();*/

    solve();
}
