#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    solve();
    cout << endl;
    return 0;
}

#define int long long
#define endl '\n'
const int N = 1e5 + 100, INF = 1e15;

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    vector<vector<pair<int, int>>> gr(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        gr[a].emplace_back(b, c);
    }
    set<pair<int, int>> q;
    vector<int> d(n, INF);
    d[0] = 0;
    q.insert({0, 0});
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto u: gr[v]) {
            int len = u.second;
            if (d[v] + len < d[u.first]) {
                q.erase({d[u.first], u.first});
                d[u.first] = d[v] + len;
                q.insert({d[u.first], u.first});
            }
        }
    }
    if (d[n - 1] == INF) {
        cout << max(d[n - 1] - p, (int) 0) << endl;
    } else {
        cout << -1 << endl;
    }
}