#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#include <bits/stdc++.h>

// open-2023-122
// rma98vsm
// kpnbqsqu


using namespace std;
typedef long long ll;
typedef long double ld;

#define INF ll(1e18)
#define SIZE 2000000
#define MOD ll(1e9+7)

#define f first
#define s second
#define pb push_back
#define ppb pop_back

#define loop(i, n) for(ll i = 0; i < n; i++)
#define loopone(i, n) for(ll i = 1; i <= n; i++)
#define loopb(i, n) for(ll i = n-1; i >= 0; i--)
#define loopbone(i, n) for(ll i = n; i > 0; i--)

#define rndm drst(rng)
#define vout(x) for(auto u : x) cout << u << ' ';
#define all(x) x.begin(), x.end()

mt19937_64 rng(time(0));
uniform_int_distribution<ll> drst;

ll sussy_baka;
ll n, m, i, j, k, x, y, z;
string str, trash;
char chr;

const ll maxlg = 18;

//

vector<pair<ll, ll>> g[SIZE];
ll val[SIZE];

ll dj() {
    vector<ll> d(n+1, INF);
    d[1] = 0;
    set<pair<ll, ll>> st = {{0, 1}};
    while (st.size()) {
        pair<ll, ll> ind = *st.begin();
        st.erase(ind);
        for (auto u : g[ind.s]) {
            if (d[ind.s] + u.s < d[u.f]) {
                st.erase({d[u.f], u.f});
                d[u.f] = d[ind.s] + u.s;
                st.insert({d[u.f], u.f});
            }
        }
    }
    return d[n];
}






struct sgt {
    vector<ll> tr;
    sgt(ll n) {
        tr.assign(4*n, 0);
    }
    void add(ll ind, ll x, ll l, ll r, ll k) {
        if (ind < l or r < ind) return;
        if (l == r) {
            tr[k] += x;
            return;
        }
        ll mid = (l+r)/2;
        add(ind, x, l, mid, k*2);
        add(ind, x, mid+1, r, k*2+1);
        tr[k] = tr[k*2] + tr[k*2+1];
    }
    ll sum(ll a, ll b, ll l, ll r, ll k) {
        if (b < l or r < a) return 0;
        if (a <= l and r <= b) return tr[k];
        ll mid = (l+r)/2;
        return sum(a, b, l, mid, k*2) + sum(a, b, mid+1, r, k*2+1);
    }
};

ll solve(vector<ll> val, vector<ll> nxt) {
    vector<ll> pref = {0};
    vector<pair<ll, ll>> d(val.size(), {INF, INF});

    d[0] = {0, k};

    pair<ll, ll> mx = {val[0], 0};

    loopone (i, val.size()-1) {
        pref.pb(nxt[i-1] + pref.back());
        ll dnc = (pref.back() - pref[mx.s] - d[mx.s].s + mx.f-1) / mx.f;
        dnc = max(0ll, dnc);
        ll lft = dnc * mx.f + d[mx.s].s  - (pref.back() - pref[mx.s]);
        d[i] = {dnc + d[mx.s].f, lft};
        mx = max(mx, {val[i], i});
        //cout << lft << ' ';
    }
    //for (auto u : d) cout << u.f << ' ';
    return d.back().f;
}

ll dst[2000][2000];


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
    freopen("test.txt", "r", stdin);
    #endif

    //

    cin >> n >> m >> k >> sussy_baka;

    loop(i, 1000) loop (j, 1000) dst[i][j] = INF;

    loopone (i, n) cin >> val[i];
    loop (i, m) {
        cin >> x >> y >> z;
        g[x].pb({y, z});
        dst[x][y] = min(z, dst[x][y]);
    }

    if (sussy_baka == 1) {
        ll ans = dj();
        if (ans >= INF) cout << -1;
        else cout << ans-k;
    }

    if (sussy_baka == 2) {
        vector<ll> vl, lft;
        loopone (i, n) vl.pb(val[i]);
        loopone (i, n-1) lft.pb(g[i][0].s);
        cout << solve(vl, lft);
    }

    if (sussy_baka == 3 or sussy_baka == 0) {
        vector<ll> ways, fn;
        ll ans = INF;
        loopone (i, n) ways.pb(i), fn.pb(i);
        do {
            if (ways[0] != 1) {next_permutation(all(ways));continue;}


            vector<ll> vl, lft;
            ll bad = 0;
            for (ll i = 0; ways[i] != n; i++) {
                vl.pb(val[ways[i]]);
                if (dst[ways[i]][ways[i+1]] == INF) {bad = 1;break;}
                lft.pb(dst[ways[i]][ways[i+1]]);
            }
            if (bad) {next_permutation(all(ways));continue;}

            vl.pb(val[n]);
//vout(ways); cout << endl; cout << solve(vl, lft) << '\n';
            ans = min(ans, solve(vl, lft));
            next_permutation(all(ways));
        } while(fn != ways);

        if (ans >= INF) cout << -1;
        else cout << ans;
    }




    return 0;
}
