#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
#define pb emplace_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;
typedef long double ld;
typedef pair<ld, ld> ptld;

void fastio(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,ssse3,sse3,sse4,sse4.1")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
*/

mt19937 rnd(31);

const int MAXN = 810;

vector<pt> gr[MAXN];
ll mt[MAXN][MAXN];
int c[MAXN];

ll solve1(int n, ll p){
    for (int k = 0; k < n; k++){
        for (int i = 0; i < n; i++){
            for (int j = 0; j < n; j++){
                mt[i][j] = min(mt[i][j], mt[i][k] + mt[k][j]);
            }
        }
    }
    return max(mt[0][n - 1] - p, 0ll);
}

void run(){
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    for (int i = 0; i < n; i++)
        cin >> c[i];
    for (int i = 0; i < n; i++){
        fill(mt[i], mt[i] + n, 1e9);
    }
    for (int i = 0; i < m; i++){
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        gr[u].pb(v, w);
        mt[u][v] = min((ll)w, mt[u][v]);
    }
    if (g == 1){
        cout << solve1(n, p) << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
#ifdef LOCAL
    cerr << "\nProgram finished in " << (stop - start) / CLOCKS_PER_SEC << " sec\n";
#endif
    return 0;
}
