﻿#include <iostream>
#include <random>
#include <vector>
#include<string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <stack>
#include <iomanip>
#include <math.h>
#include <queue>
#include <deque>

using namespace std;

#define int long long

#define all(arr) arr.begin(), arr.end()
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

const int INF = 1e15;

#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
mt19937 rnd(time(0));

vector<vector<pii>> g;
vector<int> a;

bool cmp(int x, int y) {
	if (a[x] != a[y]) return a[x] > a[y];
	return x < y;
}

signed main()
{
	int n, m, p, g0;
	cin >> n >> m >> p >> g0;
	g.resize(n);
	a.resize(n);
	vector<int> pref(n, 0);

	int D = 0;
	
	for (auto& i : a) cin >> i;
	for (int i = 0; i < m; ++i) {
		int v, u, w;
		cin >> v >> u >> w;
		g[v-1].push_back({ u-1, w });
		D += w;
		pref[i + 1] = pref[i] + w;
	}

	if (g0 == 1) {
		vector<int> dist(n, INF);
		dist[0] = 0;
		for (int t = 0; t < n; ++t) {
			for (int v = 0; v < n; ++v) {
				for (auto& e : g[v]) {
					dist[e.first] = min(dist[e.first], dist[v] + e.second);
				}
			}
		}

		int d = dist[n - 1];
		if (d == INF) cout << -1;
		else cout << max(0ll, d - p);
	}
	else if (g0 == 2) {
		stack<int> b;
		
		for (int i = n - 2; i >= 0; --i) {
			int x = a[i];
			while (!b.empty() && x >= a[b.top()])
				b.pop();
			b.push(i);
		}

		int ans = 0;
		int now = p;

		while (!b.empty()) {
			int id = b.top();
			b.pop();

			int w = a[id];
			int next = n - 1;
			if (!b.empty()) next = b.top();

			int d = pref[next] - pref[id];
			
			int k = (d - now) / w;
			if ((d - now) % w != 0) k++;
			if (d <= now) k = 0;

			now = now + k * w - d;
			ans += max(k, 0ll);
		}

		cout << ans;
	}
}
