// #pragma GCC optimize("O3")
// #pragma GCC target("avx,avx2,abm,popcnt,lzcnt")
#include <algorithm>
#include <array>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <ranges>
#include <set>
#include <stack>
#include <string>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

// #include <ext/rope>
// #include <ext/pb_ds/tree_policy.hpp>
// #include <ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_cxx;
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag,
// tree_order_statistics_node_update> ordered_set;

#define int ll

using ll = long long;
using ld = long double;
// using uint = unsigned int;
using ull = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const ll inf = LLONG_MAX / 2;

void solve() {
    int n, m, left, test;
    cin >> n >> m >> left >> test;
    vector<int> w(n);
    for (auto &i : w)
        cin >> i;
    vector<vector<pi>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b, cost;
        cin >> a >> b >> cost;
        g[--a].pb({--b, cost});
    }
    if (test == 0 || test == 3) {

    } else if (test == 1) {
        vector<ll> dist(n, inf);
        dist[0] = 0;
        set<pll> st;
        st.insert({0, 0});
        while (!st.empty()) {
            int v = st.begin()->S;
            st.erase(st.begin());
            for (auto [to, cost] : g[v]) {
                if (dist[to] > dist[v] + cost) {
                    st.erase({dist[to], to});
                    dist[to] = dist[v] + cost;
                    st.insert({dist[to], to});
                }
            }
        }
        if (dist[n - 1] == inf) {
            cout << -1 << "\n";
            return;
        }
        cout << max(dist[n - 1] - left, 0LL) << "\n";
    } else if (test == 2) {
        vector<ll> dist(n, inf), p(n, -1);
        dist[0] = 0;
        set<pll> st;
        st.insert({0, 0});
        while (!st.empty()) {
            int v = st.begin()->S;
            st.erase(st.begin());
            for (auto [to, cost] : g[v]) {
                if (dist[to] > dist[v] + cost) {
                    st.erase({dist[to], to});
                    p[to] = v;
                    dist[to] = dist[v] + cost;
                    st.insert({dist[to], to});
                }
            }
        }
        if (dist[n - 1] == inf) {
            cout << -1 << "\n";
            return;
        }
        vector<int> path;
        for (int v = p[n - 1]; v != -1; v = p[v])
            path.pb(v);
        reverse(all(path));
        int mx = 0, best = -1;
        for (auto v : path)
            if (w[v] > mx) {
                mx = w[v];
                best = v;
            }
        path.pb(n - 1);
        int price = dist[n - 1];
        int ans = 0;
        for (int i = 0; i < path.size(); i++) {
            if (path[i] == best) {
                ans += (price - left) / w[path[i]] +
                       ((price - left) % w[path[i]] != 0);
                break;
            } else {
                for (auto [to, cost] : g[path[i]])
                    if (to == path[i + 1]) {
                        int operate = (cost - left) / w[path[i]] +
                                      ((cost - left) % w[path[i]] != 0);
                        ans += operate;
                        left = operate * w[path[i]] - cost + left;
                        price -= cost;
                        break;
                    }
            }
        }
        cout << ans << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //    cin >> t;
    while (t--)
        solve();
    return 0;
}