#include <bits/stdc++.h>

#include <list>
#include <numeric>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
#define pb push_back
#define int long long
//typedef ordered_set<int> = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

vector<vector<pair<int, int>>> gr(800);

void solve() {
    int n, m, p, g, a, b, s;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> s;
        a--;
        b--;
        gr[a].pb({b, s});
    }
    vector<int> dist(n, 1e18);
    vector<bool> used(n);
    dist[0] = 0;
    for (int j = 0; j < n-1; j++) {
        int y=-1, d=1e18;
        for  (int i = 0; i < n; i++) {
            if (!used[i] && dist[i] < d) {
                d = dist[i];
                y = i;
            }
        }
        if(y == -1) {
            break;
        }
        used[y] = 1;
        for (auto [i, s] : gr[y]) {
            if (dist[i] < dist[y] + s) {
                dist[i] = dist[y] + s;
            }
        }
    }
    if (dist[n-1] == 1e18) {
        cout << -1;
        return;
    }
    cout << max(0ll, dist[n-1] - p);
}

signed main() {
#ifdef LOCAL
    //auto f = freopen("C:\\clion\\input.txt", "r", stdin);
    //auto f1 = freopen("C:\\clion\\output.txt", "w", stdout);
#endif
    int t;
    t= 1;//cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}