#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const long long maxn = 801;
const long long inf = 1e14;
long long n, m, p, g, w[maxn], used[maxn];
long long a[maxn][maxn], ans = inf;
vector<long long> v[maxn];

void read(){
    cin >> n >> m >> p >> g;
    for(long long i = 1;i <= n;i++){
        cin >> w[i];
    }
    for(long long i = 1;i <= n;i++){
        for(long long j = 1;j <= n;j++){
            a[i][j] = inf;
        }
    }
    for(long long i = 1;i <= m;i++){
        long long x, b, s;
        cin >> x >> b >> s;
        a[x][b] = min(a[x][b], s);
    }
}

void rec(long long ver, long long ost, long long p){
    if(ver == n){
        ans = min(ans, p);
        return;
    }
    if(ans <= p)
        return;
    used[ver] = 1;
    for(long long x : v[ver]){
        if(used[x]) continue;
        long long dist = a[ver][x];
        if(dist == inf) continue;
        if(ost >= dist) rec(x, ost - dist, p);
        else{
            long long cnt = (dist - ost) / w[ver];
            if((dist - ost) % w[ver])
                cnt++;
            rec(x, (w[ver] - (dist - ost) % w[ver]) % w[ver], p + cnt);
        }
    }
    used[ver] = 0;
}

void solve(){
    for(long long k = 1;k <= n;k++){
        for(long long i = 1;i <= n;i++){
            for(long long j = 1;j <= n;j++){
                if(a[i][j] > a[i][k] + a[k][j]){
                    a[i][j] = a[i][k] + a[k][j];
                }
            }
        }
    }
    for(long long i = 1;i <= n;i++){
        for(long long j = 1;j <= n;j++){
            if(a[i][j] != inf){
                v[i].push_back(j);
            }
        }
    }
    if(g == 1){
       if(a[1][n] == inf)
            cout << -1 << endl;
        else
            cout << max((long long)0, a[1][n] - p) << endl;
    }
    else if(g == 2){
        vector<long long> v;
        v.push_back(1);
        long long maxx = w[1];
        for(long long i = 2;i <= n;i++){
            if(w[i] > maxx){
                maxx = w[i];
                v.push_back(i);
            }
        }
        v.push_back(n);
        long long ost = p, cnt = 0;
        a[1][1] = 0;
        for(long long i = 1;i < v.size();i++){
            long long money = a[1][v[i]] - a[1][v[i - 1]];
            if(money <= ost){
                ost -= money;
                continue;
            }
            money -= ost;
            cnt = cnt + money / w[v[i - 1]];
            if(money % w[v[i - 1]])
                cnt++;
            ost = money - money % w[v[i - 1]];
            if(ost == money)
                ost = 0;
        }
        cout << cnt << endl;
    }
    else{
        if(a[1][n] == inf){
            cout << -1 << endl;
            return;
        }
        rec(1, p, 0);
        cout << ans << endl;
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
