#include <bits/stdc++.h>
#define int long long
#define double long double

using namespace std;

const int maxn = 800;

struct edge{
    int u, w;
};

vector <edge> g[maxn];

const int inf = 1e18;

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    }
    int n, m, p, test; cin >> n >> m >> p >> test;
    vector <int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < m; ++i) {
        int v, u, w; cin >> v >> u >> w;
        v--; u--;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
    }
    int d[n][n];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            d[i][j] = inf;
        }
        d[i][i] = 0;
        set < pair <int, int> > q;
        q.insert({0, i});
        while (!q.empty()) {
            auto v = (*q.begin()).second;
            q.erase(q.begin());
            for (auto [u, w] : g[v]) {
                if (d[i][v] + w < d[i][u]) {
                    q.erase({d[i][u], u});
                    d[i][u] = d[i][v] + w;
                    q.insert({d[i][u], u});
                }
            }
        }
    }
    if (d[0][n - 1] == inf) {
        cout << "-1\n";
        return 0;
    }
    if (test == 1) {
        cout << max((int) 0, d[0][n - 1] - p) << "\n";
        return 0;
    }
    return 0;
}