#pragma GCC optimize("Ofast")

#include<bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>

#define F first
#define S second
#define pii pair<int, int>
#define pb push_back
#define ins insert
#define int long long
#define ll long long
#define orok order_of_key
#define fob find_by_order
#define endl "\n"
#define ld long double
#define TIME (ld)(clock() - start) / (ld)(CLOCKS_PER_SEC)

using namespace std;
using namespace __gnu_pbds;

mt19937 gen(time(0));

ld start = clock();

typedef tree <int, null_type, less < int > , rb_tree_tag, tree_order_statistics_node_update> oset;


const int inf = 1e18 + 10;
const int N = 3e3 + 10;
const int M = 1e4;
const int mod = 1e9 + 9;

vector < pii > g[N];
int dist[N];
int w[N];
int n, m, p, test;
int u[N];
int pref[N];
int cost[N];
int cp[N][N];

void solve1()
{
    fill(dist, dist + n, inf);

    dist[0] = 0;
    priority_queue < pii > q;
    q.push({0, 0});

    while(!q.empty())
    {
        int v = q.top().S;
        q.pop();

        if(u[v])
            continue;

        u[v] = 1;
        for(auto to : g[v])
            if(dist[to.F] > dist[v] + to.S)
        {
            dist[to.F] = dist[v] + to.S;
            q.push({-dist[to.F], to.F});
        }
    }

    if(dist[n - 1] == inf)
        cout << -1;
    else
        cout << max(0ll, dist[n - 1] - p);

}


void solve2()
{
     int mx = 0;
     int now = p;
     int ans = 0;

     for(int i = 0; i < n - 1; i++)
     {
         mx = max(mx, w[i]);
         if(now >= cost[i])
         now -= cost[i];
         else
         {
             int need = cost[i] - now;
             int cnt = need / mx + bool(need % mx);

             now += cnt * mx;
             ans += cnt;
             now -= cost[i];
         }


     }

     cout << ans;
}

int get(vector < int > all)
{
     int mx = 0;
     int now = p;
     int ans = 0;

     for(int i = 0; i < n; i++)
     {
//         cout << "!!!! " << all[i] << ' ' << cp[all[i]][all[i + 1]]  << endl;
         if(all[i] == n - 1)
            break;

         if(cp[all[i]][all[i + 1]] == inf)
            return inf;

         mx = max(mx, w[all[i]]);
         if(now >= cp[all[i]][all[i + 1]])
         now -= cp[all[i]][all[i + 1]];
         else
         {
             int need = cp[all[i]][all[i + 1]] - now;
             int cnt = need / mx + bool(need % mx);

             now += cnt * mx;
             ans += cnt;
             now -= cp[all[i]][all[i + 1]];
         }

     }

     return ans;
}
void solve()
{
    vector < int > all;
    for(int i = 0; i < n; i++)
        all.pb(i);
//    all = {0, 1, 3 ,2};

    ld t = 0.9999;
    int now = get(all);
    int bst = now;

    while(TIME < 0.95)
    {
        vector < int > p = all;
        for(int i = 0; i < 7; i++)
        {
            int x = gen() % (n - 1) + 1;
            int y = gen() % (n - 1) + 1;

            swap(all[x], all[y]);
        }

//        for(auto to : all)
//            cout << to << ' ';
//            cout << endl;

        int ans = get(all);

        bst = min(bst, ans);
        ld x = gen() % INT_MAX;
        ld y = gen() % INT_MAX;
        if(x > y)
            swap(x, y);

        if(ans < now || exp((now - ans) / t) > x / y)
        {
            now = ans;
        }
        else
            all = p;

        t *= 0.9999;


    }


    if(bst == inf)
        bst = -1;

    cout << bst;


}
int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #else

    #endif // LOCAL



    cin >> n >> m >> p >> test;

    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
        cp[i][j] = inf;

    for(int i = 0; i < n; i++)
        cin >> w[i];

    for(int i = 0; i < m; i++)
    {
        int x, y, c;
        cin >> x >> y >> c;

        x --;
        y --;

        g[x].pb({y, c});
        pref[i + 1] = pref[i] + c;
        cost[i] = c;


        cp[x][y] = min(cp[x][y], c);
//        g[y].pb({x, c});


    }

    if(test == 1)
    {
        solve1();
        return 0;
    }

    if(test == 2)
    {
        solve2();
        return 0;
    }


    solve();







    return 0;
}


