#include <iostream>
#include "array"
#include "climits"
#include "cmath"
#include "algorithm"
#include "vector"
#include "string"
#include "map"
#include "queue"
using namespace std;
#define int long long
#define all(x) x.begin(), x.end()
vector<vector<pair<int, int>>> g;
vector<vector<int>> shp;
vector<int> C;
vector<int> djkst(int v) {
    vector<int> dist(g.size(), -1);
    priority_queue<pair<int, int>, vector<pair<int, int>>, greater<>> q;
    q.push({0, v});
    while (!q.empty()) {
        auto [cn, v] = q.top();
        q.pop();
        if (dist[v] != -1)
            continue;
        dist[v] = cn;
        for (auto [i, c] : g[v])
            q.push({c+cn, i});
    }
    return dist;
}
void solve() {
    int n, m, p, stepa;
    cin >> n >> m >> p >> stepa;
    C.assign(n, {});
    g.assign(n, {});
    shp.assign(n, {});
    for (int i = 0; i < n; ++i) {
        cin >> C[i];
    }
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;b--;
        g[a].push_back({b, c});
    }
    for (int i = 0; i < shp.size(); ++i) {
        shp[i] = djkst(i);
    }
    vector<pair<int, int>> bebrs(n);
    for (int i = 0; i < n; ++i) {
        bebrs[i] = {C[i], i};
    }
    sort(all(bebrs));
    pair<int, int> NE = {1e18, 0};
    vector<pair<int, int>> dp(n, NE);
    for (int i = 0; i < n; ++i) {
        if (p >= shp[0][i] and shp[0][i] != -1) {
            for (int j = 0; j < n; ++j) {
                if (shp[i][j] != -1) {
                    int k = max(0ll, (shp[0][i] + shp[i][j] - p + C[i] - 2) / C[i]);
                    int ost = (shp[0][i] + shp[i][j] - p + k * C[i]) % C[j];
                    if (dp[j].first > k or (dp[j].first == k and ost > dp[j].second)) {
                        dp[j] = {k, ost};
                        //cout << j << '\n';
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        int v = bebrs[i].second;
        if (dp[v] != NE) {
            for (int j = 0; j < n; ++j) {
                if (shp[v][j] != -1) {
                    int k = max(0ll, (shp[v][j] - dp[v].second + C[v] - 2) / C[v]);
                    int ost = (shp[v][j] - dp[v].second + k * C[v]) % C[j];
                    k += dp[v].first;
                    if (dp[j].first > k or (dp[j].first == k and ost > dp[j].second)) {
                        dp[j] = {k, ost};
                    }
                }
            }
        }
    }
    if (dp.back() == NE)
        cout << "-1\n";
    else
        cout << dp.back().first << '\n';
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) solve();
    return 0;
}
/*
4 4 2 0   7 4 3 1   1   2 2 1 3 2 6   1 3 8

4 4 2 0
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11
 */