//#pragma GCC optimize("03,unroll-loops")
//#pragma GCC target("avx2,bmi")
#include <bits/stdc++.h>
using namespace std;
#define int long long
#define pb push_back

vector<vector<pair<int, int>>> g(801);
vector<bool> used(801);
vector<int> ans(801, 1e18);

void djikstra(int u, int n) {
    ans[u] = 0;
    for (int i = 1; i <= n; ++i) {
        int v = -1;
        for (int j = 1; j <= n; ++j) {
            if (!used[j] && (v == -1 || ans[v] > ans[j])) {
                v = j;
            }
        }
        if (v == -1) {
            break;
        }
        used[v] = 1;
        for (auto [q, w]: g[v]) {
            ans[q] = min(ans[q], ans[v] + w);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);cout.tie(nullptr);
    int n, m, p, g1, cnt = 0;
    cin >> n >> m >> p >> g1;
    vector<int> w(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> w[i];
    }
    if (g1 == 2) {
        vector<tuple<int, int, int>> a(n);
        for (int i = 0; i < m; ++i) {
            int u, v, w1;
            cin >> u >> v >> w1;
            a[i] = {u, v, w1};
        }
        int mx = w[1];
        for (auto [u, v, w1]: a) {
            p -= w1;
            if (p < 0) {
                cnt -= (p - mx + 1) / mx;
                p -= (p - mx + 1) / mx * mx;
            }
            mx = max(mx, w[v]);
        }
        cout << cnt;
    } else if (g1 == 1) {
        for (int i = 0; i < m; ++i) {
            int u, v, w1;
            cin >> u >> v >> w1;
            g[u].pb({v, w1});
        }
        djikstra(1, n);
        if (ans[n] == 1e18) {
            cout << "-1\n";
            return 0;
        }
        cout << max(0ll, ans[n] - p) << '\n';
    }
}