#include <bits/stdc++.h>
#define int long long

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e18;

ll run(vector <vector <pair <int, int>>> &graph, vector <ll> &w, vector <bool> &used, vector <ll> &niggers, ll p, int u) {
    int n = used.size();
    if (u == n -1)
        return 0;

    used[u] = true;

    bool added = niggers.empty() || niggers.back() <= w[u];
    if (added)
        niggers.push_back(w[u]);

    ll answer = INF;
    for (auto [v, s]: graph[u]) {
        if (used[v])
            continue;   

        ll t = p;
        ll k = 0 ;
        if (s > p) {
            ll best = niggers.back();
            k = (s - p + best - 1) / best;
            p += k * best;
        }

        p -=s;
        assert(p > 0);

        ll newans = k + run(graph, w, used, niggers, p, v);
        answer = min(answer, newans);
        p = t;
    }

    if (added)
        niggers.pop_back();

    used[u] = false;
    return answer;
}

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;

    vector <ll> w(n);
    for (ll &x: w) cin >> x;

    if (g == 2) {
        set <ll> niggers;

        ll answer = 0;

        ll a, b, s;
        for (int i = 0; i < m; i++) {
            cin >> a >> b >> s;
            a--, b--;

            niggers.insert(w[i]);

            if (s > p) {
                ll best = *niggers.rbegin();
                ll k = (s - p + best - 1) / best;
                p += k * best;
                answer += k; 
            }

            p -= s;
        }

        cout << answer << '\n';
        return;
    }

    int a, b, s;
    vector <vector <pair <int, int>>> graph(n);
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> s;
        a--, b--;

        graph[a].emplace_back(b, s);
    }

    for (int i = 0 ;i < n; i++) {
        sort(graph[i].begin(), graph[i].end());
        graph[i].resize(unique(graph[i].begin(), graph[i].end(), [&] (auto lhs, auto rhs) {
            return lhs.first == rhs.first;
        }) - graph[i].begin());
    }

    if (g == 3 || g == 0) {
        vector <ll> niggers;
        vector <bool> used(n);
        ll answer = run(graph, w, used, niggers, p, 0);

        if (answer >= INF) {
            cout << "-1\n";
            return;
        }

        cout << answer << '\n';
        return;
    }

    vector <ll> distances(n, INF);
    set <pair <ll, int>> niggers;

    distances[0] = 0;
    niggers.emplace(0, 0);

    while (!niggers.empty()) {
        auto [d, u] = *niggers.begin();
        niggers.erase(niggers.begin());

        for (auto [v, s]: graph[u]) {
            if (distances[v] > distances[u] + s) {
                niggers.erase({distances[v], v});
                distances[v] = distances[u] + s;
                niggers.emplace(distances[v], v);
            }
        }
    }

    if (distances[n - 1] == INF) {
        cout << "-1\n";
        return;
    }

    cout << max(distances[n - 1] - p, 0ll) << '\n'; 
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
