#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pp;
struct Edge {
    ll to, w;
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<ll> w(n);
    for (ll i = 0; i < n; i++) {
        cin >> w[i];
    }
    vector<vector<Edge>> graph(n);
    for (ll i = 0; i < m; i++) {
        ll a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        graph[a].push_back(Edge{b, s});
    }
    const ll inf = 1e16;
    vector<ll> ans(n, inf);
    ans[0] = 0;
    set<pp> choice;
    for (ll i = 0; i < n; i++) {
        choice.insert({ans[i], i});
    }
    vector<bool> used(n);
    for (ll i = 0; i < n; i++) {
        pp fr = *choice.begin();
        used[fr.second] = true;
        choice.erase(choice.begin());
        for (Edge edg:graph[fr.second]) {
            ll to = edg.to;
            ll wt = edg.w;
            if (!used[to]) {
                choice.erase({ans[to], to});
                ans[to] = min(ans[to], ans[fr.second] + wt);
                choice.insert({ans[to], to});
            }
        }
    }
    if (ans[n - 1] == inf) {
        cout << -1;
    } else {
        cout << max(0ll, ans[n - 1] - p);
    }
}