#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace __gnu_pbds;
using namespace std;
using idexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

int n, m, p, tt;
vector<vector<pair<int, int>>> g;
vector<int> w;

void de() {
    vector<int> vis(n + 1), de(n + 1, 1e18);
    set<pair<int, int>> q = {{0, 1}};
    de[1] = 0;
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        vis[v] = 1;
        for (auto [i, len]: g[v]) {
            if (vis[i]) continue;
            if (de[i] > de[v] + len) {
                q.erase({de[i], i});
                de[i] = de[v] + len;
                q.insert({de[i], i});
            }
        }
    }
    if (de[n] == 1e18) cout << -1;
    else cout << max(de[n] - p, 0ll);
    exit(0);
}

void tre() {
    int ans = 0;
    int ma = w[1];
    for (int i = 1; i < n; i++) {
        if (g[i][0].second > p) {
            int x = g[i][0].second - p;
            ans += (x + ma - 1) / ma;
            p += ((x + ma - 1) / ma) * ma;
        }
        ma = max(ma, w[i + 1]);
        p -= g[i][0].second;
    }
    cout << ans;
    exit(0);
}

void per() {
    vector<int> pr;
    int it = 1;
    for (int i = 1; i <= n; i++) pr.push_back(i), it *= i;
    vector<vector<int>> ma(n + 1, vector<int>(n + 1, -1));
    for (int i = 1; i <= n; i++) {
        for (auto [j, len]: g[i]) ma[i][j] = (ma[i][j]==-1 ? len : min(ma[i][j],len));
    }
    int ans = 1e18;
    for (int _ = 0; _ < it; _++) {
        int m = w[pr[0]], res = 0, p1 = p;
        if (pr[0] != 1) continue;
        for (int i = 0; i < n - 1; i++) {
            int v = pr[i], u = pr[i + 1];
            if (ma[v][u] == -1) {
                res = 1e18;
                break;
            }
            if (ma[v][u] > p1) {
                int x = ma[v][u] - p1;
                res += (x + m - 1) / m;
                p1 += ((x + m - 1) / m) * m;
            }
            m = max(m, w[u]);
            p1 -= ma[v][u];
            if (u == n) break;
        }
        ans = min(ans, res);
        if (res == 3) for (int i: pr) cout << i << ' ';
        next_permutation(pr.begin(), pr.end());
    }
    if (ans == 1e18)cout << -1;
    else cout << ans;
    exit(0);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> p >> tt;
    w.resize(n + 1);
    g.resize(n + 1);
    for (int i = 1; i <= n; i++) cin >> w[i];
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        g[a].push_back({b, s});
    }
    if (tt == 1) {
        de();
    }
    if (tt == 2) {
        tre();
    }
    if (tt == 3 || tt == 0) {
        per();
    }
}