#include <bits/stdc++.h>

#define int long long

using namespace std;

vector<int> w;
vector<vector<pair<int, int>>> g;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, p, test;
    cin >> n >> m >> p >> test;
    w.resize(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> w[i];
    g.resize(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        g[a].push_back({b, s});
    }
    if (test == 1) {
        vector<int> dist(n + 1, 1e17);
        dist[1] = 0;
        set<pair<int, int>> q = {{0, 1}};
        while (!q.empty()) {
            auto [d, u] = *q.begin();
            q.erase(q.begin());
            if (dist[u] != d)
                continue;
            for (auto [v, s] : g[u]) {
                if (dist[v] > d + s) {
                    dist[v] = d + s;
                    q.insert({d + s, v});
                }
            }
        }
        if (dist[n] == 1e17)
            cout << -1;
        else
            cout << max(0ll, dist[n] - p);
        exit(0);
    }
    if (test == 2) {
        int u = 1;
        int mx = 0;
        int res = 0;
        while (u != n) {
            mx = max(mx, w[u]);
            int c = g[u][0].second;
            u++;
            if (c <= p) {
                p -= c;
                continue;
            }
            int k = (c - p - 1) / mx + 1;
            p += k * mx;
            res += k;
            p -= c;
        }
        cout << res;
        exit(0);
    }
    vector<vector<int>> dist(n + 1, vector<int> (n + 1, 1e17));
    for (int i = 1; i <= n; i++) {
        dist[i][i] = 0;
        set<pair<int, int>> q = {{0, i}};
        while (!q.empty()) {
            auto [d, u] = *q.begin();
            q.erase(q.begin());
            if (dist[i][u] != d)
                continue;
            for (auto [v, s] : g[u]) {
                if (dist[i][v] > d + s) {
                    dist[i][v] = d + s;
                    q.insert({d + s, v});
                }
            }
        }
    }
    if (dist[1][n] == 1e17) {
        cout << -1;
        exit(0);
    }
    vector<pair<int, int>> kol(n + 1, {1e17, 0});
    kol[1] = {0, p};
    set<pair<pair<int, int>, int>> q = {{{0, p}, 1}};
    int res = 1e17;
    while (!q.empty()) {
        auto [para, u] = *q.begin();
        q.erase(q.begin());
        auto [k, ost] = para;
        if (kol[u].first != k || kol[u].second != ost || k >= res || dist[u][n] == 1e17)
            continue;
        int d = dist[u][n];
        if (d <= ost)
            res = min(res, k);
        else
            res = min(res, k + (d - ost - 1) / w[u] + 1);
        for (int i = 1; i <= n; i++) {
            if (dist[u][i] == 1e17)
                continue;
            if (w[i] <= w[u])
                continue;
            d = dist[u][i];
            int nowost = ost;
            int nowk = k;
            if (ost >= d)
                nowost -= d;
            else {
                int nado = (d - nowost - 1) / w[u] + 1;
                nowk += nado;
                nowost = nowost + nado * w[u] - d;
            }
            if (kol[i].first > nowk || (kol[i].first == nowk && kol[i].second < nowost)) {
                kol[i] = {nowk, nowost};
                q.insert({{nowk, nowost}, i});
            }
        }
    }
    cout << res;
}