#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

#define int ll

const int INF = 1e18;

void solve_case() {
	int n, m, p; cin >> n >> m >> p;
	int group; cin >> group;
	vector<int> w(n);
	for (int& x : w)
		cin >> x;

	vector<vector<pair<int, int>>> g(n);
	for (int i = 0; i < m; i++) {
		int a, b, w; cin >> a >> b >> w;
		a--; b--;
		g[a].emplace_back(b, w);
	}

	if (group == 1) {
		vector<int> d(n, INF);
		d[0] = 0;
		set<pair<int, int>> q = { { 0, 0 } };

		while (sz(q)) {
			auto [D, v] = *q.begin();
			q.erase(q.begin());

			for (auto& [u, w] : g[v]) {
				if (d[u] > d[v] + w) {
					q.erase({ d[u], u });
					d[u] = d[v] + w;
					q.insert({ d[u], u });
				}
			}
		}

		if (d.back() == INF) {
			cout << "-1\n";
		}
		else {
			cout << max(int(0), d.back() - p) << '\n';
		}

		return;
	}

	if (group == 2) {
		int mx = w[0];

		int res = 0;
		for (int i = 0; i < n - 1; i++) {
			mx = max(mx, w[i]);

			auto [to, price] = g[i][0];
			int need = max(int(0), price - p);
			res += (need + mx - 1) / mx;
			p += (need + mx - 1) / mx * mx;
			p -= price;
		}

		cout << res << '\n';
		return;
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
	//cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}
