#include <bits/stdc++.h>
#define int long long
using namespace std;

struct edge {
    int a, b, s;
    edge(int A = 0, int B = 0, int S = 0) {
        a = A; b = B; s = S;
    }
};

struct ans {
    int cash, num, mx;
    ans(int C = -1e9, int N = 0, int M = -1e9) {
        cash = C; num = N; mx = M;
    }
};


int p;

vector<vector<ans>> dp;
vector<vector<edge>> rev;
vector<int> w;
vector<int> used;

int choose(int v1, int v2) {
    return (w[v1] > w[v2] ? v1 : v2);
}

ans best(ans a, ans b) {
    if (a.cash + a.num * a.mx != b.cash + b.num * b.mx)
        if (a.cash + a.num * a.mx > b.cash + b.num * b.mx)
            return a;
        else
            return b;
    return (a.num > b.num ? a : b);
}

void upd(int v1, int v2, int e) {
    int n = (int)rev.size();
    for (int mx = 0; mx < n; ++mx) {
        int cw = w[mx];
        int need = max(0ll, (e - dp[v2][mx].cash + cw - 1) / cw);
        if (need > dp[v2][mx].num)
            continue;
        dp[v1][choose(v1, mx)] = best(dp[v1][choose(v1, mx)], ans(dp[v2][mx].cash + need * cw - e, dp[v2][mx].num - need, max(w[v1], w[mx])));
    }
}

void get(int v, int num0) {
    if (used[v])
        return;
    used[v] = 1;
    if (v == 0) {
        dp[v][v] = { p, num0, w[v] };
        return;
    }
    for (auto &e : rev[v]) {
        get(e.b, num0);
        if (num0 == 5 && v == 3 && e.b == 1) {
            //breakpoint
            v = 3;
        }
        upd(v, e.b, e.s);
    }
}

bool check(int m) {
    int n = (int)rev.size();
    dp.assign(n, vector<ans>(n, ans()));
    used.assign(n, 0);
    get(n - 1, m);

    for (auto &x : dp.back()) {
        if (x.mx >= 0)
            return true;
    }
    return false;
}

signed main() {
    int n, m, g;
    cin >> n >> m >> p >> g;

    w.resize(n);
    for (auto &x : w)
        cin >> x;

    rev.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        --a; --b;
        rev[b].emplace_back(b, a, s);
    }

    used.resize(n);
    dp.resize(n, vector<ans>(n, ans()));

    int l = -1, r = 5e9;
    while (l + 1 < r) {
        int M = (l + r) / 2;
        if (check(M))
            r = M;
        else
            l = M;
    }
    cout << (r == 5e9 ? -1 : r) << '\n';
}