#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<stack>
#include<queue>

using namespace std;

typedef long long ll;

int INF = 1e9, mod = 1e9 + 7;

vector<vector<int>> g;
vector<int> w, used;
int n, m, p, ntest;
void dfs_pit(int pos) {
	if (used[pos] == 1) return;
	used[pos] = 1;
	for (int i = 0; i < n; ++i) {
		if(g[pos][i] != -1)
			dfs_pit(i);
	}
}


ll ans = 1e16;

void dfs(int pos, int calc, ll day, ll donate, ll sum) {
	if (pos == n - 1) {
		ans = min(ans, day);
	}
	if (calc >= n * 2) return;
	if (donate < w[pos]) donate = w[pos];
	for (int i = 0; i < n; ++i) {
		if (g[pos][i] != -1) {
			if (g[pos][i] <= sum) {
				dfs(i, calc + 1, day, donate, sum - g[pos][i]);
			}
			else {
				int k = (g[pos][i] - sum) / donate;
				if ((g[pos][i] - sum) % donate != 0) k += 1;
				dfs(i, calc + 1, day + k, donate, sum + donate * k - g[pos][i]);
			}
		}
	}
}


int main() {
	
	
	cin >> n >> m >> p >> ntest;
	w.resize(n);
	used.resize(n, 0);
	for (int i = 0; i < n; ++i) cin >> w[i];
	g.resize(n, vector<int> (n, -1));
	for (int i = 0; i < m; ++i) {
		int a, b, s;
		cin >> a >> b >> s;
		a--;
		b--;
		if (g[a][b] == -1)
			g[a][b] = s;
		else {
			g[a][b] = min(g[a][b], s);
		}
	}
	dfs_pit(0);
	if (used[n - 1] == 0) {
		cout << -1;
		return 0;
	}
	if (ntest == 1) {
		vector<int> d(n, INF);
		vector<int> used(n, -1);
		d[0] = 0;
		for (int i = 0; i < n; ++i) {
			int mi = -1;
			for (int j = 0; j < n; ++j) {
				if (used[j] == -1 && (mi == -1 || d[mi] > d[j])) mi = j;
			}
			if (mi == -1) break;
			used[mi] = 1;
			for (int j = 0; j < n; ++j) {
				if (g[mi][j] != -1) {
					d[j] = min(d[j], d[mi] + g[mi][j]);
				}
			}
		}
		cout << max(0, d[n - 1] - p);
	}
	else if (ntest == 2) {
		dfs(0, 0, 0, w[0], p);
		cout << ans;
	}
	else {
		dfs(0, 0, 0, w[0], p);
		cout << ans;
	}
	
}