#include <bits/stdc++.h>

#define ff first
#define ss second
#define FASTIO ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;
typedef long long ll;

const ll MOD=1e9;
const ll P=31;
const ll INF=1e9;
const ll INFL=1e19;

ll n, m, p;
vector <vector <pair <ll, ll> > > g;
ll f[11][11];
vector <ll> w;

void solve1() {
    vector <ll> r(n+1, INFL);
    set <pair <ll, ll> > f;
    r[1]=0;
    f.insert({0, 1});
    while (!f.empty()) {
        pair <ll, ll> dop=*f.begin();
        f.erase(f.begin());
        ll cost=dop.ff, v=dop.ss;
        for (ll i=0; i<g[v].size(); i++) {
            ll x=g[v][i].ff, q=g[v][i].ss;
            if (r[v]+q<r[x]) {
                f.erase({r[x], x});
                r[x]=r[v]+q;
                f.insert({r[x], x});
            }
        }
    }
    if (r[n]==INFL) cout << -1;
    else cout << max(0ll, r[n]-p);
}

void solve2() {
    ll ans=0;
    set <ll> f;
    f.insert(w[1]);
    for (ll i=2; i<=n; i++) {
        ll cost=g[i-1][0].ss;
        if (p<cost) {
            ll maxi=*f.rbegin();
            ll k=(cost-p+maxi-1)/maxi;
            ans+=k;
            p=p+k*maxi-cost;
        }
        else p-=cost;
        f.insert(w[i]);
    }
    cout << ans;
}

void solve3() {
    ll k=(1<<(n+1));
    vector <vector <pair <ll, ll> > > dp(n+1, vector <pair <ll, ll> > (k, {INFL, 0}));
    dp[1][2]={0, p};
    ll mini=INFL;
    for (ll q=2; q<k; q++) {
        for (ll i=1; i<=n; i++) {
            if (q&(1<<n)) mini=min(mini, dp[i][q].ff);
            if (dp[i][q].ff==INFL) continue;
            ll maxi=0;
            for (ll j=1; j<=n; j++) {
                if ((1<<j)&q) maxi=max(maxi, w[j]);
            }
            for (ll j=1; j<=n; j++) {
                if ((1<<j)&q) continue;
                if (f[i][j]==INFL) continue;
                if (i==j) continue;
                ll cost=f[i][j];
                pair <ll, ll> dop=dp[i][q];
                if (dop.ss<cost) {
                    ll k=(cost-dop.ss+maxi-1)/maxi;
                    dop.ff+=k;
                    dop.ss=dop.ss+k*maxi-cost;
                }
                else dop.ss-=cost;
                if (dop.ff<dp[j][q+(1<<j)].ff || (dop.ff==dp[j][q+(1<<j)].ff && dop.ss>dp[j][q+(1<<j)].ss)) {
                    dp[j][q+(1<<j)]=dop;
                }
            }
        }
    }
    if (mini==INFL) cout << -1;
    else cout << mini;
}

int main()
{
    FASTIO;
    ll t;
    cin >> n >> m >> p >> t;
    g.resize(n+1);
    w.resize(n+1);
    for (ll i=1; i<=n; i++) cin >> w[i];
    if (t==3 || t==0) {
        for (ll i=1; i<=n; i++) {
            for (ll j=1; j<=n; j++) f[i][j]=INFL;
        }
        for (ll i=0; i<m; i++) {
            ll x, y, z;
            cin >> x >> y >> z;
            f[x][y]=min(f[x][y], z);
        }
    }
    else {
        for (ll i=0; i<m; i++) {
            ll x, y, z;
            cin >> x >> y >> z;
            g[x].push_back({y, z});
        }
    }
    if (t==1) solve1();
    if (t==2) solve2();
    if (t==3 || t==0) solve3();
    return 0;
}
