#include <iostream>
#include <vector>
#include <random>
#include <set>

#define int long long
typedef long  long ll;
using namespace std;

struct node {
    int times, money, max_farm;
};

//
// mt19937 rnd(time(0));
vector<int> farm; // dp - cколько раз надо шоу давать, farm - сколько мак денег за шоу можем нафармить за 1 шоу до этого города и в нем.
vector<vector<pair<int, int>>> g;
vector<vector<node>> dp;

void dfs(int v) {
    for (auto [u, w] : g[v]) {

        //if (farm[u] <= max_farm && dp[u] != (int) 1e18) continue;

        for (auto [times, money, max_farm] : dp[v]) {
            max_farm = max(max_farm, farm[v]);
            int new_times = times + (max((ll) 0, (w - money)) + max_farm - 1) / max_farm;
            int new_money = money - w;
            if (new_money < 0) {
                new_money = ((abs(new_money) + max_farm - 1) / max_farm) * max_farm - abs(new_money);
            }

            bool flag = false;
            for (int i = 0; i < dp[u].size(); i++) {
                if (dp[u][i].times <= new_times && dp[u][i].max_farm >= dp[u][i].max_farm && dp[u][i].money >= new_money) {
                    flag = true;
                }
            }

            if (!flag) {
                dp[u].push_back({new_times, new_money, max_farm});
                dfs(u);
            }


        }

    }
}

void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    g.resize(n);
    dp.resize(n);
    farm.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> farm[i];
    }

    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].emplace_back(b, c);
    }
    dp[0].push_back({0, p, farm[0]});
    dfs(0);
//    for (int i : dp) {
//        cout << i << " ";
//    }
//    cout << endl;
    if (!dp[n - 1].size()) {
        cout << -1;
    } else {
        int ans = 1e18;
        for (int i = 0;  i < dp[n - 1].size(); i++) {
            ans = min(ans, dp[n - 1][i].times);
        }
        cout << ans;
    }


}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
//
//vect a.x * b.y - b.x * a.y
//scal a.x * b.x + a.y * b.y
