#include <bits/stdc++.h>

#define F first
#define S second
#define sz size()
#define pb push_back
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

const int inf = 1e13;
const int N = 1000;
int n, m, p, gr;
int dist[N], a[N];
vector <vector <pii> > g(N);

void solve1 () {
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        dist[i] = inf;
    }

    for (int i = 1; i <= m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
//        g[v].pb({u, w});
    }

    set <pii> s;
    s.insert({0, 1});
    dist[1] = 0;
    while (!s.empty()) {
        pii cur = *s.begin();
        s.erase(s.begin());
        int v = cur.S;
        for (auto i : g[v]) {
            int to = i.F, w = i.S;
            if (dist[v] + w < dist[to]) {
                s.erase({dist[to], to});
                dist[to] = dist[v] + w;
                s.insert({dist[to], to});
            }
        }
    }

    if (dist[n] == inf) {
        cout << -1;
        return;
    }

    p -= dist[n];
    if (p < 0) {
        cout << -p;
    }
    else {
        cout << 0;
    }
}


void solve2 () {
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        dist[i] = inf;
    }

    for (int i = 1; i <= m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
    }

    int mx = a[1], ans = 0;
    for (int i = 1; i < n; i++) {
        mx = max(mx, a[i]);
        if (g[i][0].S > p) {
            int need = (g[i][0].S - p + mx - 1) / mx;
            p += need * mx;
            ans += need;
        }
        p -= g[i][0].S;
    }
    cout << ans;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n >> m >> p >> gr;


    if (gr == 1) {
        solve1();
        return 0;
    }

    if (gr == 2) {

    }

}

