#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int INF = 0x3f3f3f3f;
const ll INF_L = 0x3f3f3f3f3f3f3f3f;

struct edge {
    int u, w;
};

ll n, m, p, gr;
vector<vector<edge>> g;
vector<int> w;

void solve1() {
    vector<ll> d(n, INF_L);
    vector<bool> used(n);

    set<pair<ll, int>> q;
    d[0] = 0;
    q.insert({0, 0});

    while (!q.empty()) {
        auto [dv, v] = *q.begin();
        q.erase(q.begin());
        used[v] = true;

        for (auto [ui, wi] : g[v]) {
            if (!used[ui] && dv + wi < d[ui]) {
                q.erase({d[ui], ui});
                d[ui] = dv + wi;
                q.insert({d[ui], ui});
            }
        }
    }

    if (d[n - 1] == INF_L) {
        cout << "-1\n";
    } else {
        cout << max(0ll, d[n - 1] - p);
    }
}

void solve2() {
    vector<int> s(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int t;
        cin >> t >> t >> s[i];
    }

    ll ans = 0;
    int mi = INF;
    for (int i = 0; i < n - 1; ++i) {
        mi = min(mi, w[i]);
        ll z = (max(0ll, p - s[i]) + mi - 1) / mi;
        ans += z;
        p = p - s[i] + z * 1ll * mi;
    }
    cout << ans << "\n";
}

void solve() {
    cin >> n >> m >> p >> gr;

    w.resize(n);
    g.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }

    if (gr == 1) {
        for (int i = 0; i < m; ++i) {
            int vi, ui, wi;
            cin >> vi >> ui >> wi;
            g[vi - 1].push_back({ui - 1, wi});
        }
    }

    if (gr == 1) {
        solve1();
    } else if (gr == 2) {
        solve2();
    }
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
