#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <iomanip>
using namespace std;
#define double long double
#define int long long
#define ll long long
#define s second
#define f first
#define pb push_back
#define mod 1000000007
#define INF 1000000007
#define mod9 1000000009
#define debug(x) cerr << (#x) << ": "<<x<<endl
int max(int a, int b) {
    if (a > b) return a;
    return b;
}
int min(int a, int b) {
    if (a < b) return a;
    return b;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
ll bin_pow_make(ll a, ll n) {
    if (n == 0) return 1;
    if (n == 1) return a;
    if (n % 2 == 0) {
        ll t = bin_pow_make(a, n / 2);
        return (t * t) % mod;
    }
    ll x = bin_pow_make(a, n - 1);
    return (x * a) % mod;
}
int rev(int a) {
    return bin_pow_make(a, mod - 2);
}
int mul(int a, int b,int m) {
    return ((ll)a * b) % m;
}

int add(int a, int b,int m) {
    if (a + b >= m) return a + b - m;
    return a + b;
}
vector<vector<pair<int,int> > > gr;
vector<int> dist;
void deik(int a) {
    set<pair<int, int> > s;
    s.insert({ a,0 });
    while (s.size() > 0) {
        auto l = *(s.begin());
        s.erase(l);
        int u = l.first, cur = l.second;
        for (auto p : gr[u]) {
            int to = p.first, w = p.second;
            if (cur + w < dist[to]) {
                s.erase({ to,dist[to] });
                dist[to] = cur + w;
                s.insert({ to,cur + w });
            }
        }
    }
}

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    gr = vector<vector<pair<int, int> > >(n);
    vector<int> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    vector<int> d(n);
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--; b--;
        gr[a].pb({ b,w });
        d[a] = w;
    }
    dist = vector<int>(n, 1e18);
    deik(0);
    if (g == 1) {
        if (dist[n - 1] == 1e18) {
            cout << -1;
            return;
        }
        int ans = max(0, dist[n - 1] - p);
        cout << ans;
    }
    else if (g == 2) {
        int ans = 0, cur_mx = w[0];
        for (int i = 0; i < n - 1; i++) {
            if (p - d[i] < 0) {
                int need = (d[i] - p), cnt = (need + cur_mx - 1) / cur_mx;
                ans += cnt;
                p += cnt * cur_mx;
            }
            p -= d[i];
            cur_mx = max(cur_mx, w[i + 1]);
        }
        cout << ans;
    }
}
signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}