#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#define F first
#define S second
#define endl '\n'
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

mt19937_64 rng(time(nullptr));
ll rnd(ll n) {
    uniform_int_distribution<ll> uid;
    return abs(uid(rng)) % n;
}

const ll INF = 1e17;
ll w[810];
ll dist[810][810];

void solve() {
    int n, m; ll p; int T;
    cin >> n >> m >> p >> T;
    bool flag1 = true, flag2 = (m == n - 1);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        if (w[i] != 1)
            flag1 = false;
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            if (i != j)
                dist[i][j] = INF;
    vector <ll> pref = {0};
    pref.reserve(m);
    for (int i = 0; i < m; i++) {
        int a, b; ll x;
        cin >> a >> b >> x;
        a--, b--;
        if (a != i || b != i + 1)
            flag2 = false;
        dist[a][b] = min(dist[a][b], x);
        pref.push_back(x);
    }
    for (int k = 0; k < n; k++)
        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
    if (dist[0][n - 1] == INF) {
        cout << -1 << endl;
        return;
    }
    if (flag1) {
        cout << max(0LL, dist[0][n - 1] - p) << endl;
        return;
    }
    if (flag2) {
        for (int i = 1; i < pref.size(); i++)
            pref[i] += pref[i - 1];
        vector <int> q, nx(n + 1, n - 1);
        for (int i = 0; i < n; i++) {
            while (!q.empty() && w[i] >= w[q.back()]) {
                nx[q.back()] = i;
                q.pop_back();
            }
            q.push_back(i);
        }
        int s = 0;
        ll ans = 0;
        while (s < n - 1) {
            ll cnt = pref[nx[s]] - pref[s];
            if (cnt > p) {
                ll now = (cnt - p - 1) / w[s] + 1;
                ans += now;
                p += w[s] * now;
            }
            p -= cnt;
            s = nx[s];
        }
        cout << ans << endl;
        return;
    }
    ll ans = (dist[0][n - 1] > p ? (dist[0][n - 1] - p - 1) / w[0] + 1 : 0);
    vector <int> v(n);
    for (int i = 0; i < n; i++)
        v[i] = i;
    for (int _ = 0; _ < 20000000 / n; _++) {
        shuffle(v.begin(), v.end(), rng);
        int i1 = 0;
        while (v[i1] != 0)
            i1++;
        int i2 = 0;
        while (v[i2] != n - 1)
            i2++;
        if (i1 > i2) {
            reverse(v.begin(), v.end());
            i1 = n - i1 - 1;
            i2 = n - i2 - 1;
        }
        ll ost = p, kol = 0;
        for (int i = i1 + 1; i <= i2; i++) {
            int a = v[i - 1], b = v[i];
            ll now = (dist[a][b] > ost ? (dist[a][b] - ost - 1) / w[a] + 1 : 0);
            kol += now;
            ost += now * w[a];
            ost -= dist[a][b];
        }
        ans = min(ans, kol);
    }
    cout << ans << endl;
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    auto start_time = time(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    auto end_time = time(nullptr);
    cerr << "Ulyanovsk is the best" << endl;
    cerr << "Execution time: " << end_time - start_time << " ms" << endl;
}
