#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e17 + 2;

vector<vector<pair<int, int>>> g;
vector<int> w;

int dijkstra(int n) {
    vector<int> used(n), dist(n, INF);
    dist[0] = 0;
    set<pair<int, int>> q = {{0, 0}};
    while (!q.empty()) {
        auto[d, u] = *q.begin();
        q.erase(q.begin());
        used[u] = 1;
        for (auto[v, c] : g[u]) {
            if (used[v]) continue;
            q.erase({dist[v], v});
            dist[v] = min(dist[v], d + c);
            q.insert({dist[v], v});
        }
    }
    return dist[n - 1];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    w.resize(n), g.resize(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].emplace_back(b, c);
    }
    if (G == 1) {
        int ans = dijkstra(n);
       // cout << ans << endl;
        if (ans == INF) {
            cout << -1 << endl;
            return 0;
        }
        cout << max(0ll, ans - p) << endl;
        return 0;
    }


}