#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back
#define int long long

const int N = 1e5 + 1;
const int mod = 1e9 + 7;
const int inf = 1e15;

int a[N];
vc <pii> g[N];
int n, m, p;

int solve (vc <int> &e, vc <int> &w) {
    int cur = p, mx = 0;
    int ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        mx = max(mx, w[i]);
        int nd = (max(0ll, e[i] - cur) + mx - 1) / mx;
        ans += nd;
        cur += nd * mx;
        cur -= e[i];
    }
    return ans;
}

void solve () {
    int gr;
    cin >> n >> m >> p >> gr;
    vc <int> e, b;
    for (int i = 0; i < n; ++i)
        cin >> a[i], b.pb(a[i]);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w; --u; --v;
        g[u].pb({v, w});
        e.pb(w);
    }
    if (gr == 1) {
        vc <int> d(n, inf);
        d[0] = 0;
        vc <int> used(n);
        for (int i = 0; i < n; ++i) {
            int u = -1;
            for (int j = 0; j < n; ++j) {
                if (!used[j] && (u == -1 || d[j] < d[u]))
                    u = j;
            }
            if (u == -1)
                break;
            used[u] = 1;
            for (auto [v, w] : g[u])
                d[v] = min(d[v], d[u] + w);
        }
        if (d[n - 1] == inf) {
            cout << "-1\n";
            return;
        }
        cout << max(0ll, d[n - 1] - p) << '\n';
    }
    if (gr == 2) {
        cout << solve(e, b) << '\n';
    }
    if (gr == 3) {

    }
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
