#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

const ll mod = 998244353;

const ll INF = 1e18;

vector<vector<pair<ll, ll>>> g;
vector<ll> used, ans, w;
ll n, p;

void dfs(ll u) {
    used[u] = 1;
    if (u == n - 1) {
        ans[u] = 0;
        return;
    }
    for (auto [v, c] : g[u]) {
        if (!used[v]) {
            dfs(v);
        }
        if (ans[v] != INF)
            ans[u] = min(ans[v] + c, ans[u]);
    }
}

vector<ll> cur;
ll kol_up = INF;
vector<ll> used2;
vector<vector<ll>> matr;

void gen() {
    if (cur.back() == n - 1) {
        ll dl = (ll)cur.size();
        vector<ll> s(dl);
        for (ll i = 0; i < dl - 1; i++) {
            s[i + 1] = matr[cur[i]][cur[i + 1]];
        }
        ll i = 1;
        ll kol = 0;
        ll c = p;
        ll d = w[cur[0]];
        for (; i < dl; i++) {
            if (c >= s[i]) {
                c -= s[i];
            }
            else {
                ll h = (s[i] - c);
                ll j = (h + d - 1) / d;
                kol += j;
                c += d * j;
                c -= s[i];
            }
            if (w[cur[i]] > d) {
                d = w[cur[i]];
            }
        }
        cout << kol;
        return;
    }
    for (auto [v, c] : g[cur.back()]) {
        if (!used[v]) {
            used2[v] = 1;
            gen();
            used2[v] = 0;
            cur.pop_back();
        }
    }
}

void solve() {
    ll m, gr;
    cin >> n >> m >> p >> gr;
    g.resize(n);
    used.resize(n);
    used2.resize(n);
    ans.resize(n, INF);
    w.resize(n);
    matr.resize(n);
    if (gr == 3) {
        for (ll i = 0; i < n; i++) {
            matr[i].resize(n);
        }
    }
    for (ll i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (ll i = 0; i < m; i++) {
        ll a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        g[a].emplace_back(b, s);
        matr[a][b] = s;
    }
    if (gr == 1) {
        dfs(0);
        if (ans[0] == INF) {
            cout << -1;
            return;
        }
        cout << max(0ll, ans[0] - p);
        return;
    }

    if (gr == 2) {
        vector<ll> s(n);
        for (ll i = 0; i < n - 1; i++) {
            s[i + 1] = g[i][0].second;
        }
        ll i = 1;
        ll kol = 0;
        ll c = p;
        ll d = w[0];
        for (; i < n; i++) {
            if (c >= s[i]) {
                c -= s[i];
            }
            else {
                ll h = (s[i] - c);
                ll j = (h + d - 1) / d;
                kol += j;
                c += d * j;
                c -= s[i];
            }
            if (w[i] > d) {
                d = w[i];
            }
        }
        cout << kol;
        return;
    }
    cur.push_back(0);
    gen();
}

int main() {
    srand(time(0));
#ifdef LOCAL
    ll clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif
    for (; tpk; tpk--) {
        solve();
        cout << '\n';
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}