#include <bits/stdc++.h>
using namespace std;
#define int long long
#define fi first
#define se second
#define lwb lower_bound
#define upb upper_bound
#define em emplace_back
#define all(x) x.begin(), x.end()
#define ll long long
#define double long double
const int N = 1e6, C = 1000, K = 28, INF = 0x3f3f3f3f;
const double EPS = 1e-5;

/*
random_device r;
default_random_engine e1(r());
seed_seq seed2{r(), r(), r(), r(), r(), r(), r(), r()};
mt19937 rnd(seed2);
*/

struct hash_str {
    int P, M, n;
    vector<int> p, power;

    void init(string &s, int Pr, int Mod) {
        P = Pr;
        M = Mod;
        n = (int) s.size();
        p.resize(n + 1);
        power.resize(n + 1);
        power[0] = 1;
        for (int i = 1; i <= n; i++) {
            power[i] = (power[i - 1] * P) % M;
        }
        for (int i = 1; i <= n; i++) {
            p[i] = (p[i - 1] + (int) (s[i - 1] - 'a') * power[i]) % P;
        }
    }

    int subhash(int l, int r) {
        int val = (p[r] - p[l] + M) % M;
        val = (val * power[n - r]) % M;
        return val;
    }

    bool comp(int l1, int r1, int l2, int r2) {
        if (r2 - l2 != r1 - l1)
            return false;
        return subhash(l1, r1) == subhash(l2, r2);
    }
};

vector<int> z_func(string &s) {
    int n = (int) s.size();
    vector<int> z(n);
    for (int i = 1, l = 0, r = 0; i < n; i++) {
        if (i < r)
            z[i] = min(z[i - l], r - i);
        while (i + z[i] < n && s[i] == s[i + z[i]])
            z[i]++;
        if (i + z[i] >= r) {
            r = i + z[i];
            l = i;
        }
    }
    return z;
}

struct ed {
    int to, w;
};

vector<vector<ed>> g;

void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    g.resize(n + 1);
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> v >> u >> w;
        g[v].push_back({u, w});
    }
    if (group == 2) {
        int ans = 0, maxi = 0;
        for (int i = 1; i < n; i++) {
            int w = g[i].front().w;
            int t = 0;
            maxi = min(maxi, a[i]);
            if (p < w) {
                t = (w - p + maxi - 1) / maxi;
            }
            p += t * maxi;
            ans += t;
            p -= w;
        }
        cout << ans << endl;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    //cout << fixed << setprecision(15);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}