#include <bits/stdc++.h>
using namespace std;
#define int long long
#define fi first
#define se second
#define lwb lower_bound
#define upb upper_bound
#define em emplace_back
#define all(x) x.begin(), x.end()
#define ll long long
const int N = 1e6, C = 200, K = 28, INF = 0x3f3f3f3f;
const ll P1 = 179, P2 = 57, M1 = 1e9 + 7, M2 = 1e9 + 9;
const double EPS = 1e-5;

/*
ifstream fin("input.txt");
ofstream fout("output.txt");
#define cin fin
#define cout fout
*/

/*
random_device r;
default_random_engine e1(r());
seed_seq seed2{r(), r(), r(), r(), r(), r(), r(), r()};
mt19937 rnd(seed2);
*/

struct ed {
    int to, w;
};

int n, m;
vector<vector<ed>> g;
vector<int> used, a;

int dfs(int v, int maxi, int p) {
    if (v == n) {
        return 0;
    }
    used[v] = 0;
    int alt = INF;
    maxi = max(maxi, a[v]);
    for (auto [to, w] : g[v]) {
        if (used[to] == 0)
            continue;
        int t = 0;
        if (p < w) {
            t = (w - p + maxi - 1) / maxi;
        }
        int new_p = p + t * maxi - w;
        alt = min(alt, dfs(to, maxi, new_p) + t);
    }
    used[v] = 1;
    return alt;
}

void solve() {
    int p, group;
    cin >> n >> m >> p >> group;
    g.resize(n + 1);
    a.resize(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].push_back({v, w});
    }
    if (group == 2) {
        int ans = 0, maxi = 0;
        for (int i = 1; i < n; i++) {
            int w = g[i].front().w;
            int t = 0;
            maxi = max(maxi, a[i]);
            if (p < w) {
                t = (w - p + maxi - 1) / maxi;
            }
            p += t * maxi;
            ans += t;
            p -= w;
        }
        cout << ans << endl;
        return;
    }
    used.resize(n + 1, -1);
    int ans = dfs(1, 0, p);
    if (ans == INF)
        cout << -1 << endl;
    else
        cout << ans << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    //cout << fixed << setprecision(15);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}