#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
const int maxn = 800;
const long long inf = 1e18;
long long dp[10001][100];
#define int long long
void solve() {
    long long n, m, p, gr;
    cin >> n >> m >> p >> gr;
    vector<int> w(n);
    for (int &i: w) cin >> i;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        --u; --v;
        g[u].push_back({ v, c });
    }
    if (gr == 1) {
        vector<long long> d(n, inf);
        set<pair<long long, int>> s;
        s.insert({ 0, 0 });
        d[0] = 0;
        while (!s.empty()) {
            int v = s.begin()->second;
            s.erase(s.begin());
            for (auto [u, w] : g[v]) {
                if (d[u] > d[v] + w) {
                    s.erase({ d[u], u });
                    d[u] = d[v] + w;
                    s.insert({ d[u], u });
                }
            }
        }
        if (d[n - 1] == inf) {
            cout << -1;
            return;
        }
        cout << max(0ll, d[n - 1] - p);
        return;
    }
    if (gr == 2) {
        int mx = w[0];
        vector<int> cost(n, 0);
        for (int i = 0; i < n; ++i) {
            for (auto [v, w] : g[i]) {
                cost[v] = w;
            }
        }
        long long ans = 0;
        for (int j = 1; j < n; ++j) {
            int need = (max(0ll, cost[j] - p) + mx - 1) / mx;
            ans += need;
            p += need * mx;
            p -= cost[j];
            mx = max(mx, w[j]);
        }
        cout << ans;
        return;
    }
    if (gr == 4) {
        for (int i = 0; i <= n * 100; ++i) {
            fill(dp[i], dp[i] + n, inf);
        }
        dp[0][0] = -p;
        auto djk = [&] (int layer) {
            set<pair<long long, int>> s;
            for (int i = 0; i < n; ++i) {
                s.insert({dp[layer][i], i});
            }
            while (!s.empty()) {
                int v = s.begin()->second;
                s.erase(s.begin());
                for (auto [u, w] : g[v]) {
                    if (-dp[layer][v] < w) continue;
                    if (dp[layer][u] > dp[layer][v] + w) {
                        s.erase({ dp[layer][u], u });
                        dp[layer][u] = dp[layer][v] + w;
                        s.insert({ dp[layer][u], u });
                    }
                }
            }
        };
        djk(0);
        for (int i = 0; i < n * 100; ++i) {
            for (int j = 0; j < n; ++j) {
                if (dp[i][j] != inf)
                    dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] - w[j]);
            }
            djk(i + 1);
        }
        int ans = 0;
        for (int i = 0; i < n * 100; ++i) {
            if (dp[i][n - 1] != inf) {
                cout << i << '\n';
                return;
            }
        }
        cout << -1;
        return;
    }
    if (gr == 3) {
        vector<int> opt(1 << n, 0);
        for (int i = 0; i < (1 << n); ++i) {
            for (int j = 0; j < n; ++j) {
                if ((1 << j) & i) {
                    opt[i] = max(opt[i], w[j]);
                }
            }
        }
        vector<vector<pair<int, int>>> dp(1 << n, vector<pair<int, int>> (n, make_pair(inf, inf)));
        dp[1][0] = make_pair(0, -p);
        auto djk = [&] (int layer) {
            set<pair<pair<long long, long long>, int>> s;
            for (int i = 0; i < n; ++i) {
                s.insert({dp[layer][i], i});
            }
            while (!s.empty()) {
                int v = s.begin()->second;
                s.erase(s.begin());
                for (auto [u, w] : g[v]) {
                    int need = max(0ll, w + dp[layer][v].second + opt[layer] - 1) / opt[layer];
                    int np = dp[layer][v].second;
                    np -= need * opt[layer];
                    np += w;
                    pair<int, int> nw = { dp[layer][v].first + need, np };
                    if (dp[layer][u] > nw) {
                        s.erase({ dp[layer][u], u });
                        dp[layer][u] = nw;
                        s.insert({ dp[layer][u], u });
                    }
                }
            }
        };
        for (int mask = 1; mask < (1 << n); ++mask) {
            djk(mask);
            for (int i = 0; i < n; ++i) {
                if (!((1 << i) & mask)) {
                    dp[mask ^ (1 << i)][i] = min(dp[mask ^ (1 << i)][i], dp[mask][i]);
                }
            }
        }
        int ans = inf;
        for (int i = 0; i < (1 << n); ++i) {
            ans = min(ans, dp[i][n - 1].first);
        }
        if (ans == inf) {
            cout << -1;
        } else {
            cout << ans;
        }
        return;
    }
    vector<vector<pair<int, int>>> dp(n, vector<pair<int, int>> (n, make_pair(inf, inf)));
    vector<pair<int, int>> ord;
    for (int i = 0; i < n; ++i) {
        ord.push_back({ w[i], i });
    }
    sort(ord.begin(), ord.end());
    vector<int> rev(n);
    for (int i = 0; i < n; ++i) {
        rev[ord[i].second] = i;
    }
    dp[rev[0]][0] = { 0, -p };
    vector<int> opt;
    for (int i = 0; i < n; ++i) opt.push_back(ord[i].first);
    auto djk = [&] (int layer) {
        set<pair<pair<long long, long long>, int>> s;
        for (int i = 0; i < n; ++i) {
            s.insert({dp[layer][i], i});
        }
        while (!s.empty()) {
            int v = s.begin()->second;
            s.erase(s.begin());
            for (auto [u, w] : g[v]) {
                int need = max(0ll, w + dp[layer][v].second + opt[layer] - 1) / opt[layer];
                int np = dp[layer][v].second;
                np -= need * opt[layer];
                np += w;
                pair<int, int> nw = { dp[layer][v].first + need, np };
                if (dp[layer][u] > nw) {
                    s.erase({ dp[layer][u], u });
                    dp[layer][u] = nw;
                    s.insert({ dp[layer][u], u });
                }
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        djk(i);
        for (int j = 0; j < n; ++j) {
            dp[rev[j]][j] = min(dp[rev[j]][j], dp[i][j]);
        }
    }
    int ans = inf;
    for (int i = 0; i < n; ++i) {
        ans = min(ans, dp[i][n - 1].first);
    }
    if (ans == inf) {
        cout << -1;
    } else {
        cout << ans;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
