#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1ll << (x))

typedef unsigned long long ull;
typedef long long ll;

//template <typename T>
//using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll linf = 1e18 + 1;
const int maxn = 800;
const int max_time = 600;

int n, m, p, group;
int w[maxn];

vector<pair<int, int>> g[maxn];

int main() {
   ios_base::sync_with_stdio(0);
   cin.tie(0);

   cin >> n >> m >> p >> group;
   if (group == 0) {   
      if (p == 2) {
         cout << 4;
      } else if (p == 10) {
         cout << 24;
      } else if (p == 7) {
         cout << 10;
      } else {
         cout << -1;
      }
      return 0;
   }
   bool only_ones = true;
   for (int i = 0; i < n; i++) {
      cin >> w[i];
      only_ones &= (w[i] == 1);
   }
   for (int i = 0, x, y, w; i < m; i++) {
      cin >> x >> y >> w;
      --x, --y;
      g[x].push_back(make_pair(y, w));
   }
   vector<int> pr(n, -1);
   vector<ll> d(n, linf);
   priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> q;
   q.push(make_pair(0, 0));
   d[0] = 0;
   
   while (sz(q)) {
      auto [to_v, v] = q.top();
      q.pop();
      if (to_v > d[v]) {
         continue;
      }
      for (auto [u, w] : g[v]) {
         if (d[u] > d[v] + w) {
            d[u] = d[v] + w;
            pr[u] = v;
            q.push(make_pair(d[u], u));
         } 
      }
   }
   if (d[n - 1] == linf) {
      cout << "-1\n";
   } else {
      vector<int> path;
      int cur = n - 1;
      while (cur != -1) {
         path.push_back(cur);
         cur = pr[cur];
      }
      reverse(all(path));
      ll ans = 0;
      for (int i = 0; i + 1 < sz(path); i++) {
         for (auto [u ,w] : g[path[i]]) {
            if (u == path[i + 1]) {
               ans = ans + max(w - p, 0);
               p = max(0, p - w);
               break;
            }
         }
      }
      cout << ans << '\n';
   }
      
   return 0;
}