#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
using namespace std;
#define int long long

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    vector<int> nxt(n);
    vector<pair<pair<int, int>, int>> e(m);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        int s;
        cin >> s;
        nxt[i] = s;
        a--;
        b--;
        e.push_back({{a, b,}, s});
    }
    if (g != 2) {
        vector<int> d(n, 1e16);
        d[0] = 0;
        for (int i = 0; i < n; i++) {
            for (auto [edge, w] : e) {
                if (d[edge.first] + w < d[edge.second]) {
                    d[edge.second] = d[edge.first] + w;
                }
            }
        }
        if (d.back() < 1e16) {
            cout << d.back();
        } else {
            cout << -1;
        }
        return 0;
    }
    vector<pair<int, int>> dp(n, {1e9, 0});
    dp[0] = {0, p};
    for (int i = 1; i < n; i++) {
        int sum = 0;
        for (int j = i - 1; j >= 0; j--) {
            sum += nxt[j];

            pair<int, int> now = {dp[j].first + (sum - dp[j].second + w[j] - 1) / w[j],
                                  dp[j].second + (sum - dp[j].second + w[j] - 1) / w[j] * w[j] - sum};
            if (sum <= dp[j].second) {
                now = {dp[j].first, dp[j].second - sum};
            }
            if (now.first < dp[i].first) {
                dp[i] = now;
            } else if (now.first == dp[i].first && now.second > dp[i].second) {
                dp[i] = now;
            }
        }
    }
    cout << dp.back().first;
};

    /*
    /home/olymp/PreDay/cmake-build-debug/PreDay
    5
    1 1 2 2
    2 4
    1 3
    1 3
    2 4
    4 4
    4
    1 1 2 2
    1 2 2 1
     3 4 4 3
     3 4 3 5
     */