#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
using namespace std;
#define int long long

int d[800][800];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            d[i][j] = 1e16;
        }
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        int s;
        cin >> s;
        a--;
        b--;
        d[a][b] = min(d[a][b], s);
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
            }
        }
    }
    vector<pair<int, int>> dp(n, {1e16, 0});
    dp[0] = {0, p};
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                if (d[j][k] >= 1e16) {
                    continue;
                }
                int sum = d[j][k];
                pair<int, int> now = {dp[j].first + (sum - dp[j].second + w[j] - 1) / w[j],
                                     dp[j].second + (sum - dp[j].second + w[j] - 1) / w[j] * w[j] - sum};
                if (sum <= dp[j].second) {
                    now = {dp[j].first, dp[j].second - sum};
                }
                if (dp[k].first > now.first || (dp[k].first == now.first && dp[k].second < now.second)){
                    dp[k] = now;
                }
            }
        }
    }
    if (dp.back().first >= 1e16) {
        cout << -1;
    } else {
        cout << dp.back().first;
    }
}

    /*
    4 4 2 0
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11
     */