#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 3e3 + 5;

int n, m, p, G;
int w[N];
pii e[N];
ve<pii> g[N];
int s[N];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n >> m >> p >> G;

    fr (i, 1, n) {
        cin >> w[i];
    }

    fr (i, 1, m) {
        int a, b;
        cin >> a >> b >> s[i];
        g[a].pb({b, i});
        g[a].pb({b, i});
        e[i] = {a, b};
    }

    if (G == 2) {
        ll have = 0;
        ll ans = 0;
        ll mx = 0;

        fr (i, 1, n - 1) {
            umx(mx, (ll)w[i]);

            if (have >= s[i]) {
                have -= s[i];
                continue;
            }
            ll need = s[i] - have;
            ll take = (need + mx - 1) / mx;
            ans += take;
            have += take * mx;
            have -= s[i];
        }
        cout << ans << "\n";
        return 0;
    }

    if (G == 1) {
        set<pll> q;
        ve<ll> dist(n + 1, 1e18);
        dist[1] = 0;
        q.insert({0, 1});
        while (sz(q)) {
            int v = q.begin()->se;
            q.erase(q.begin());

            fe (to, g[v]) {
                if (dist[to.fi] > dist[v] + s[to.se]) {
                    q.erase({dist[to.fi], to.fi});
                    dist[to.fi] = dist[v] + s[to.se];
                    q.insert({dist[to.fi], to.fi});
                }
            }
        }

        if (dist[n] == 1e18) {
            cout << "-1\n";
        } else {
            cout << dist[n] << "\n";
        }

        return 0;
    }

    return 0;
}
