#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll INF = 1e18;

const ll N = 801;

ll n, m, p, g;

vector<ll> used(N), cur;

vector<vector<ll>> ab(1e5, vector<ll>(1e5));

vector<vector<ll>> ph, gr(N, vector<ll>(N));

void dfs(ll v){
    used[v]++;
    cur.push_back(v);
    if(v == n){
        ph.push_back(cur);
    } else {
        for(ll i = 1; i <= n; i++){
            if(used[i] < 2 && gr[v][i]){
                dfs(i);
            }
        }
    }
    used[v]--;
    cur.pop_back();
}

void solve() {
    cin >> n >> m >> p >> g;
    vector<ll> t(n + 1), w(n + 1);
    for(ll i = 1; i <= n; i++){
        cin >> w[i];
    }
    for(ll i = 0; i < m; i++){
        ll v, u, c;
        cin >> v >> u >> c;
        if(!gr[v][u]){
            gr[v][u] = c;
        } else {
            gr[v][u] = min(gr[v][u], c);
        }
        t[u] = c;
    }
    if(g == 2){
        vector<ll> pos;
        ll mx = 0;
        for(ll i = 1; i <= n; i++){
            if(mx < w[i]){
                mx = w[i];
                pos.push_back(i);
            }
        }
        pos.push_back(n);
        ll ans = 0;
        for(ll i = 0; i < (ll)pos.size() - 1; i++){
            ll need = 0, cur = pos[i], nx = pos[i + 1];
            for(ll j = cur + 1; j <= nx; j++){
                need += t[j];
            }
            if(need <= p){
                p -= need;
            } else {
                ll r = need - p;
                ans += (r + (w[cur] - 1)) / w[cur];
                p += ((r + (w[cur] - 1)) / w[cur]) * w[cur];
                p -= need;
            }
        }
        cout << ans;
        return;
    }
    dfs(1);
    ll ans = INF;
    for(ll i = 0; i < (ll)ph.size(); i++){
        vector<ll> pos;
        ll mx = 0, pp = p, cur = 0;
        for(ll j = 0; j < (ll)ph[i].size() - 1; j++){
            if(mx < w[ph[i][j]]){
                pos.push_back(j);
                mx = w[ph[i][j]];
            }
        }
        for(ll j = 0; j < (ll)pos.size(); j++){
            ll nx, need = 0;
            if(j == (ll)pos.size() - 1){
                nx = (ll)ph[i].size() - 1;
            } else {
                nx = pos[j + 1];
            }
            for(ll g = pos[j]; g < nx; g++){
                ll first = ph[i][g], second = ph[i][g + 1];
                need += gr[first][second];
            }
            ll start = ph[i][pos[j]];
            if(pp >= need){
                pp -= need;
            } else {
                ll r = need - pp;
                cur += (r + w[start] - 1) / w[start];
                pp += ((r + w[start] - 1) / w[start]) * w[start];
                pp -= need;
            }
        }
        ans = min(ans, cur);
    }
    if(ans == INF){
        cout << -1;
    } else {
        cout << ans;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}
