#include<bits/stdc++.h>

using namespace std;

struct edge
{
    long long ver,dist;
    edge(){};
    edge(int vi, int di)
    {
        ver = vi;
        dist = di;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

const int maxn = 805;
int n,m,p,g;
int w[maxn];
unsigned long long d[maxn],inf = -1;
vector<edge>v[maxn];

void read()
{
    cin >> n >> m >> p >> g;
    for(int i=1;i<=n;i++) cin >> w[i];
    int x,y,z;
    for(int i=1;i<=m;i++)
    {
        cin >> x >> y >> z;
        v[x].push_back({y,z});
    }
}

void dijkstra(int beg)
{
    memset(d,-1,sizeof(d));
    priority_queue<edge>q;
    d[beg] = 0;
    q.push({beg,0});
    edge e,nb;
    int sz;
    while(!q.empty())
    {
        e = q.top();
        q.pop();
        if(e.dist<=d[e.ver])
        {
            sz = v[e.ver].size();
            for(int i=0;i<sz;i++)
            {
                nb = v[e.ver][i];
                if(e.dist+nb.dist<d[nb.ver])
                {
                    nb.dist += e.dist;
                    d[nb.ver] = nb.dist;
                    q.push(nb);
                }
            }
        }
    }
}

void solve1()
{
    dijkstra(1);
    if(d[n]==inf) cout << -1 << endl;
    else cout << d[n] << endl;
}

void solve()
{
    if(g==1) solve1();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
	solve();
	return 0;
}

