#include <iostream>
#include <iomanip>
#include <set>
#include <vector>
#include <algorithm>
#include <cmath>
#include <tuple>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
struct st {
	ll kol, ost;
};
bool operator<(st a, st b) {
	return tie(a.kol, b.ost) < tie(b.kol, a.ost);
}
mt19937 rnd;
ll inf = 1e18;
ll len[800][800], kol[800];
st lenans[800][800];
bool used[800];
vector <int> tp, t, g[800];
void dfs(int v) {
	used[v] = 1;
	for (auto i : g[v]) {
		if (!used[i]) dfs(i);
	}
	t.push_back(v);
}
int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	ll n, m, p, tn; cin >> n >> m >> p >> tn;
	for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) len[i][j] = inf, lenans[i][j] = { inf, -1 };
	for (int i = 0; i < n; i++) cin >> kol[i], len[i][i] = 0, lenans[i][i] = { 0, p };
	for (int i = 0; i < m; i++) {
		ll a, b, c; cin >> a >> b >> c; a--, b--;
		len[a][b] = min(len[a][b], c);
		g[a].push_back(b);
		if (c <= p) lenans[a][b] = min(lenans[a][b], { 0, p - c });
		else {
			ll cnt = (c - p + kol[a] - 1) / kol[a];
			lenans[a][b] = min(lenans[a][b], { cnt, p + kol[a] * cnt - c });
		}
	}
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				len[i][j] = min(len[i][j], len[i][k] + len[k][j]);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i);
			reverse(t.begin(), t.end());
			for (auto i : t) tp.push_back(i);
		}
	}
	for (int kol1 = 0; kol1 < 70; kol1++) {
		for (int k = 0; k < n; k++) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (lenans[i][tp[k]].kol == inf || len[tp[k]][j] == inf) continue;
					ll cnt = (max(0ll, (len[tp[k]][j] - lenans[i][tp[k]].ost)) + kol[tp[k]] - 1) / kol[tp[k]];
					if (lenans[i][j].kol > lenans[i][tp[k]].kol + cnt) lenans[i][j] = { lenans[i][tp[k]].kol + cnt, cnt * kol[tp[k]] + lenans[i][tp[k]].ost - len[tp[k]][j] };
					else if (lenans[i][j].kol == lenans[i][tp[k]].kol + cnt) lenans[i][j].ost = max(lenans[i][j].ost, cnt * kol[tp[k]] + lenans[i][tp[k]].ost - len[tp[k]][j]);
				}
			}
		}
		random_shuffle(tp.begin(), tp.end());
	}
	if (lenans[0][n - 1].kol == inf) cout << -1;
	else cout << lenans[0][n - 1].kol;
	return 0;
}