#include <iostream>
#include <iomanip>
#include <set>
#include <vector>
#include <algorithm>
#include <cmath>
#include <tuple>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
struct st {
	ll kol, ost;
};
struct st1 {
	ll to, len;
};
bool operator<(st a, st b) {
	return tie(a.kol, b.ost) < tie(b.kol, a.ost);
}
mt19937 rnd;
ll inf = 1e18;
ll len[800][800], kol[800];
vector <int> g[800];
st lenans[800][800];
bool used[800];
vector <int> tp, t;
void dfs(int v) {
	used[v] = 1;
	for (auto i : g[v]) {
		if (!used[i]) dfs(i);
	}
	t.push_back(v);
}
int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	ll n, m, p, tn; cin >> n >> m >> p >> tn;
	if (tn == 1) {
		for (int i = 0; i < n; i++) cin >> kol[i];
		vector <vector <st1>> g1(n);
		for (int i = 0; i < m; i++) {
			ll a, b, c; cin >> a >> b >> c, a--, b--;
			g1[a].push_back({ b, c });
		}
		set <pair <ll, ll>> q;
		vector <ll> d(n, 1e18);
		q.insert({ 0, 0 });
		while (!q.empty()) {
			int v = (*q.begin()).second;
			q.erase(q.begin());
			for (auto i : g1[v]) {
				if (d[i.to] > d[v] + i.len) {
					q.erase({ d[i.to], i.to });
					d[i.to] = d[v] + i.len;
					q.insert({ d[i.to], i.to });
				}
			}
		}
		if (d[n - 1] == 1e18) { cout << -1; }
		else cout << max(0ll, d[n - 1] - p);
		return 0;
	}
	for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) len[i][j] = inf, lenans[i][j] = { inf, -1 };
	for (int i = 0; i < n; i++) cin >> kol[i], len[i][i] = 0, lenans[i][i] = { 0, p };
	vector <int> pref(n);
	for (int i = 0; i < m; i++) {
		ll a, b, c; cin >> a >> b >> c; a--, b--;
		pref[i + 1] = pref[i] + c;
		len[a][b] = min(len[a][b], c);
		g[a].push_back(b);
		if (c <= p) lenans[a][b] = min(lenans[a][b], { 0, p - c });
		else {
			ll cnt = (c - p + kol[a] - 1) / kol[a];
			lenans[a][b] = min(lenans[a][b], { cnt, p + kol[a] * cnt - c });
		}
	}
	if (tn == 2) {
		for (int i = 0; i < n; i++) {
			for (int j = i; j < n; j++) {
				len[i][j] = pref[j] - pref[i];
			}
		}
	}
	else {
		for (int k = 0; k < n; k++) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					len[i][j] = min(len[i][j], len[i][k] + len[k][j]);
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i);
			reverse(t.begin(), t.end());
			for (auto i : t) tp.push_back(i);
		}
	}
	for (int kol1 = 0; kol1 < (tn == 2 ? 1 : 50); kol1++) {
		for (int k = 0; k < n; k++) {
			for (int i = 0; i < (tn == 2 ? 1 : n); i++) {
				for (int j = 0; j < n; j++) {
					if (lenans[i][tp[k]].kol == inf || len[tp[k]][j] == inf) continue;
					ll cnt = (max(0ll, (len[tp[k]][j] - lenans[i][tp[k]].ost)) + kol[tp[k]] - 1) / kol[tp[k]];
					if (lenans[i][j].kol > lenans[i][tp[k]].kol + cnt) lenans[i][j] = { lenans[i][tp[k]].kol + cnt, cnt * kol[tp[k]] + lenans[i][tp[k]].ost - len[tp[k]][j] };
					else if (lenans[i][j].kol == lenans[i][tp[k]].kol + cnt) lenans[i][j].ost = max(lenans[i][j].ost, cnt * kol[tp[k]] + lenans[i][tp[k]].ost - len[tp[k]][j]);
				}
			}
		}
		random_shuffle(tp.begin(), tp.end());
	}
	if (lenans[0][n - 1].kol == inf) cout << -1;
	else cout << lenans[0][n - 1].kol;
	return 0;
}