#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 805;
const int M = 3005;
const ll INF = 1e18;

int n, m;
ll p;
int grp;
ll w[N];
int a[M], b[M];
ll s[M];
pair<ll, ll> d[N], kek[N];
vector<int> g[N];

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> p >> grp;
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	for (int i = 0; i < m; ++i) {
		cin >> a[i] >> b[i] >> s[i];
		--a[i];
		--b[i];
		g[a[i]].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		kek[i] = {INF, 0};
	}
	vector<int> ord;
	for (int i = 0; i < n; ++i) {
		ord.push_back(i);
	}
	sort(ord.begin(), ord.end(), [&](int i, int j) {
		return w[i] < w[j];
	});
	kek[0] = {0, -p};
	for (int st : ord) {
		if (w[st] < w[0]) {
			continue;
		}
		if (kek[st].first == INF) {
			continue;
		}
		for (int i = 0; i < n; ++i) {
			d[i] = {INF, 0};
		}
		priority_queue<pair<pair<ll, ll>, int>, vector<pair<pair<ll, ll>, int>>, greater<pair<pair<ll, ll>, int>>> q;
		d[st] = kek[st];
		q.push({d[st], st});
		while (!q.empty()) {
			auto [dd, v] = q.top();
			q.pop();
			if (dd != d[v]) {
				continue;
			}
			for (int i : g[v]) {
				int u = b[i];
				ll t = (max(0ll, s[i] + d[v].second) + w[st] - 1) / w[st];
				auto nd = d[v];
				nd.first += t;
				nd.second -= t * w[st];
				nd.second += s[i];
				assert(nd.second <= 0);
				if (nd.first > 0) {
					assert(-nd.second < w[st]);
				}
				if (nd < d[u]) {
					d[u] = nd;
					q.push({d[u], u});
				}
			}
		}
		for (int i = 0; i < n; ++i) {
			kek[i] = min(kek[i], d[i]);
		}
	}
	if (kek[n - 1].first == INF) {
		cout << "-1\n";
		return 0;
	}
	cout << kek[n - 1].first  << endl;
	return 0;
}