#include <bits/stdc++.h>
#define int long long

using namespace std;
const int inf = LLONG_MAX / 6;

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int n, m, p, tt;
  cin >> n >> m >> p >> tt;
  vector<int> W(n);
  for (int i = 0; i < n; i++) {
    cin >> W[i];
  }
  vector<vector<pair<int, int>>> g(n);
  map<pair<int, int>, int> edge;
  for (int i = 0; i < m; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    u--, v--;
    if (edge.count({u, v})) {
      edge[{u, v}] = min(edge[{u, v}], w);
    } else {
      edge[{u, v}] = w;
    }
    g[u].emplace_back(v, w);
  }
  if (tt == 1) {
    vector<int> dp(n, inf);
    dp[0] = 0;
    set<pair<int, int>> q;
    q.emplace(0, 0);
    while (!q.empty()) {
      auto [v, d] = *q.begin();
      q.erase(q.begin());
      for (auto &[to, w]: g[v]) {
        int relax = d + w;
        if (relax < dp[to]) {
          q.erase({to, dp[to]});
          dp[to] = relax;
          q.insert({to, dp[to]});
        }
      }
    }
    cout << (dp[n - 1] == inf ? -1 : max(0ll, dp[n - 1] - p));
    return 0;
  }
  if (tt == 2) {
    vector<int> a;
    for (int i = 0; i < n - 1; i++) {
      a.push_back(g[i][0].second);
    }
    int ans = 0;
    int mx = 0;
    for (int i = 0; i < n - 1; i++) {
      mx = max(mx, W[i]);
      p -= a[i];
      if (p < 0) {
        int t = (-p + mx - 1) / mx;
        ans += t;
        p += t * mx;
      }
    }
    cout << ans << '\n';
    return 0;
  }
  if (tt == 0 || tt == 3) {
    int ans = LLONG_MAX;
    vector<int> a(n);
    iota(a.begin(), a.end(), 0ll);
    do {
      int cur = 0;
      int mx = 0;
      int P = p;
      bool flag = false;
      for (int i = 1; i < n; i++) {
        if (!edge.count({a[i - 1], a[i]})) {
          flag = true;
          break;
        }
        mx = max(mx, W[a[i - 1]]);
        P -= edge[{a[i - 1], a[i]}];
        if (P < 0) {
          int t = (-P + mx - 1) / mx;
          cur += t;
          P += t * mx;
        }
        if (a[i] == n - 1) {
          break;
        }
      }
      if (!flag) {
        ans = min(ans, cur);
      }
    } while (next_permutation(a.begin() + 1, a.end()));
    cout << (ans == LLONG_MAX ? -1 : ans) << '\n';
    return 0;
  }
}