#include "bits/stdc++.h"

using namespace std;
#define sz(a) (int)a.size()
#define all(a)a.begin(),a.end()
#define int long long
const int inf = 1e18;
const int mod = 1e9 + 7;
const int R = 1 << 18;

vector<unordered_map<int, int>> g(900);

vector<int> cnt(10);
vector<int> dp(10, inf);
vector<int> w(900);

void dfs(int v, int mx, int p, int ans = 0) {
    if (cnt[v] >= 10)
        return;
    dp[v] = min(dp[v], ans);
    mx = max(mx, w[v]);
    cnt[v]++;
    for (auto [u, w]: g[v]) {
        if (w <= p)
            dfs(u, mx, p - w);
        else {
            int c = (w - p + mx - 1) / mx;
            dfs(u, mx, -(w - p - mx * c), ans + c);
        }
    }
    --cnt[v];
}

void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    for (int i = 0; i < n; ++i)
        cin >> w[i];
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        --a, --b;
        if (g[a].find(b) == g[a].end())
            g[a][b] = s;
        else
            g[a][b] = min(g[a][b], s);
    }
    if (G == 1) {
        vector<int> d(n, inf);
        d[0] = 0;
        set<pair<int, int>> st;
        st.insert({d[0], 0});
        while (!st.empty()) {
            auto [val, v] = *st.begin();
            st.erase(st.begin());
            if (val != d[v])
                continue;
            for (auto [u, w]: g[v])
                if (d[u] > val + w) {
                    d[u] = val + w;
                    st.insert({d[u], u});
                }
        }
        if (d[n - 1] == inf)
            cout << "-1\n";
        else
            cout << max(0ll, d[n - 1] - p) << "\n";
        return;
    }
    if (G == 2) {
        int mx = 0;
        int ans = 0;
        for (int i = 0; i < n - 1; ++i) {
            mx = max(mx, w[i]);
            int W = g[i].begin()->second;
            if (W <= p) {
                p -= W;
            } else {
                W -= p;
                int cnt = (W + mx - 1) / mx;
                p = -(W - mx * cnt);
                ans += cnt;
            }
        }
        cout << ans << "\n";
        return;
    }
    if (1) {
        dp[0] = 0;
        dfs(0, 0, p);
        if (dp[n - 1] == inf)
            cout << "-1\n";
        else
            cout << dp[n - 1] << "\n";
        return;
    }
//    map<int, int> mp;
//    for (int i = 0; i < n; ++i)
//        mp[w[i]] = 1;
//    vector<int> invw(n);
//    int cc = 0;
//    for (auto &[a, b]: mp)
//        b = cc++;
//    for (int i = 0; i < n; ++i)
//        invw[i] = mp[w[i]];
//    int W = sz(mp);
//    vector dp(n, vector<vector<int>>(W,));


}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}
