#include "bits/stdc++.h"

using namespace std;
#define sz(a) (int)a.size()
#define all(a)a.begin(),a.end()
#define int long long
const int inf = 1e18;
const int mod = 1e9 + 7;
const int R = 1 << 18;

vector<unordered_map<int, int>> g(900);
vector<int> W(900);

void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    for (int i = 0; i < n; ++i)
        cin >> W[i];
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        --a, --b;
        if (g[a].find(b) == g[a].end())
            g[a][b] = s;
        else
            g[a][b] = min(g[a][b], s);
    }
    if (G == 1) {
        vector<int> d(n, inf);
        d[0] = 0;
        set<pair<int, int>> st;
        st.insert({d[0], 0});
        while (!st.empty()) {
            auto [val, v] = *st.begin();
            st.erase(st.begin());
            if (val != d[v])
                continue;
            for (auto [u, w]: g[v])
                if (d[u] > val + w) {
                    d[u] = val + w;
                    st.insert({d[u], u});
                }
        }
        if (d[n - 1] == inf)
            cout << "-1\n";
        else
            cout << max(0ll, d[n - 1] - p) << "\n";
        return;
    }
    if (G == 2) {
        int mx = 0;
        int ans = 0;
        for (int i = 0; i < n - 1; ++i) {
            mx = max(mx, W[i]);
            int W = g[i].begin()->second;
            if (W <= p) {
                p -= W;
            } else {
                W -= p;
                int cnt = (W + mx - 1) / mx;
                p = -(W - mx * cnt);
                ans += cnt;
            }
        }
        cout << ans << "\n";
        return;
    }
    if (1) {
        vector<vector<int>> d(n, vector<int>(n, inf));
        for (int i = 0; i < n; ++i) {
            d[i][i] = 0;
            set<pair<int, int>> st;
            st.insert({0, i});
            while (!st.empty()) {
                auto [val, v] = *st.begin();
                st.erase(st.begin());
                if (val != d[i][v])
                    continue;
                for (auto [u, w]: g[v])
                    if (d[i][u] > val + w) {
                        d[i][u] = val + w;
                        st.insert({d[i][u], u});
                    }
            }
        }
        vector<int> pr(n - 1);
        iota(all(pr), 1);
        int ans = inf;
        do {
            int mx = W[0];
            int cur = p;
            int cnt = 0;
            int v = 0;
            for (auto u: pr) {
                int S = d[v][u];
                if (S == inf) {
                    cnt = inf;
                    break;
                }
                if (S <= cur) {
                    cur -= S;
                } else {
                    int c = (S - cur + mx - 1) / mx;
                    cur = -(S - cur - mx * c);
                    cnt += c;
                }
                mx = max(mx, W[u]);
                if (u == n - 1)
                    break;
                v = u;
            }
            ans = min(ans, cnt);
        } while (next_permutation(all(pr)));

        if (ans == inf)
            cout << "-1\n";
        else
            cout << ans << "\n";
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}
