//#pragma GCC optimize ("Ofast", "unroll-loops")
//#pragma GCC target ("avx2", "bmi", "bmi2", "popcnt")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <queue>
#include <cstdio>
#include <iomanip>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <random>
#include <bitset>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
const int N = 110, P = 1e4 + 10;

vector <pair <int, int> > g[N];
int w[N], d[N][P];
int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    for (int i = 1; i <= n; i++) {
        cin >> w[i];
        for (int j = 0; j < P; j++)
            d[i][j] = 1e9;
    }
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].push_back({ b, c });
    }
    set < pair <ll, pair <int, int> >> s;
    for (int i = p; i < P; i++) {
        d[1][i] = (i - p) / w[1] + bool((i - p) % w[1]);
        s.insert({ d[1][i], {1, i} });
    }
    while (s.size()) {
        auto v = s.begin()->second;
        s.erase(s.begin()); 
        for (auto& u : g[v.first]) {
            for (int sm = 0; sm < P; sm += w[v.first]) {
                int i = sm - u.second + v.second;   
                if (i >= 0) {
                    int cp = (u.second - v.second + i) / w[v.first];
                    if ((u.second - v.second + i) >= 0 && d[u.first][i] > d[v.first][v.second] + cp) {
                        s.erase({ d[u.first][i], {u.first, i} });
                        d[u.first][i] = d[v.first][v.second] + cp;
                        s.insert({ d[u.first][i], {u.first, i} });
                    }
                }
            }
        }
    }
    ll res = *min_element(d[n], d[n] + P);
    if (res == 1e18)
        cout << -1;
    else
        cout << res;
} ;