#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ff first
#define ss second
#define pb push_back
#define int long long
#define dl long double

const int inf = 2e18;

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    int w[n];
    for (auto &i: w) cin >> i;
    if (g == 0) {
        int d[n][n];
        for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) d[i][j] = inf;
        for (int i = 0; i < n; i++) d[i][i] = 0;
        int u, v, c;
        for (int i = 0; i < m; i++) {
            cin >> u >> v >> c;
            u--, v--;
            d[u][v] = min(d[u][v], c);
            d[v][u] = d[u][v];
        }
        vector<int> dist(n);
        vector<bool> used(n, false);
        dist[0] = 0;
        for (int i = 0; i < n; i++) {
            u = -1;
            for (int j = 0; j < n; j++)
                if (!used[j] && dist[j] != inf && (u == -1 || dist[j] < dist[u])) u = j;
            if (u == -1) break;
            used[u] = true;
            for (int to = 0; to < n; to++)
                if (!used[to])
                    dist[to] = min(dist[to], dist[u] + d[u][to]);
        }
        if (dist[n - 1] == inf) cout << "-1\n";
        else {
            int ans = dist[n - 1] / w[0];
            if (dist[n - 1] % w[0]) ans++;
            cout << ans;
        }
    }
}

signed main() {
#ifndef Bebra
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
#ifdef Bebra
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
    int tests = 1;
//    cin >> tests;
    while (tests--) solve();
}