#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int mod = 1e9 + 7;

vector<vector<pair<int, ll>>> g;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<ll> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];

    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v, s;
        cin >> u >> v >> s;
        u--; v--;
        g[u].emplace_back(v, s);
    }

    vector<vector<pair<ll, ll>>> dp(n, vector<pair<ll, ll>>(n, {1e18, -1}));
    dp[0][0] = {0, p};
    while (true) {
        bool changed = false;
        for (int j = 0; j < n; j++) {
            for (int i = 0; i < n; i++) {
                if (dp[i][j].first == 1e18) continue;

                for (auto [k, e] : g[i]) {
                    auto [ans, have] = dp[i][j];
                    if (have < e) {
                        int need = e - have;
                        int cnt = (need - 1) / w[j] + 1;
                        ans += cnt;
                        have += w[j] * cnt;
                    }
                    have -= e;

                    int mx = j;
                    if (w[k] > w[j]) {
                        mx = k;
                    }

                    if (ans < dp[k][mx].first || ans == dp[k][mx].first && have > dp[k][mx].second) {
                        dp[k][mx] = {ans, have};
                        changed = true;
                    }
                }
            }
        }
        if (!changed) break;
    }

    ll ans = 1e18;
    for (int i = 0; i < n; i++) ans = min(ans, dp[n - 1][i].first);
    if (ans == 1e18) {
        cout << -1 << '\n';
    } else {
        cout << ans << '\n';
    }

    return 0;
}