#include <bits/stdc++.h>

//#pragma GCC optimize(Ofast);
//#pragma GCC optimize(unroll-loops);
//#pragma GCC target(avx2);

#define int long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define eb emplace_back
#define For(i, n) for (int i = 0; i < n; i++)
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define vpi vector<pii>
#define ll long long
#define vch vector<char>
#define vvc vector<vch>
#define ld long double

using namespace std;

mt19937 rnd(time(0));

const int INF = 1e9 + 7;
const int INFLL = 1e15 + 3;

int n, m, p, group;

vector<vpi> gr;
vi used, cost, ord;

void dfs(int v) {
    used[v] = 1;
    for (auto [u, w] : gr[v]) {
        if (!used[u]) dfs(u);
    }
    ord.pb(v);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    string da = "YES\n";
    string net = "NO\n";
    string OK = "OK\n";

    cin >> n >> m >> p >> group;
    if (group == 1) {
        gr.resize(n);
        used.resize(n);
        cost.resize(n);
        For(i, n) cin >> cost[i];
        For(i, m) {
            int u, v, w;
            cin >> u >> v >> w;
            u--; v--;
            gr[u].eb(v, w);
        }
        dfs(0);
        reverse(all(ord));
        vpi dp(n, {-INFLL, INFLL});
        dp[0] = {p, 0};
        for (auto v : ord) {
            for (auto [u, w] : gr[v]) {
                auto [have, done] = dp[v];
                if (have < w) {
                    if (done + w - have < dp[u].second) {
                        dp[u] = {0, done + w - have};
                    }
                } else {
                    if (done < dp[u].second) {
                        dp[u] = {have - w, done};
                    }
                }
            }
        }
        if (dp[n - 1].second == INFLL) {
            cout << -1;
        } else {
            cout << dp[n - 1].second;
        }
    } else if (group == 2) {
        cost.resize(n);
        For(i, n) cin >> cost[i];

        vi s(n);
        vi pref(n);
        pref[0] = 0;
        For(i, m) {
            int u, v, w;
            cin >> u >> v >> w;
            pref[i + 1] = pref[i] + w;
        }
        vpi dp(n, {-INFLL, INFLL});
        dp[0] = {p, 0};
        for (int i = 1; i < n; i++) {
            for (int j = 0; j < i; j++) {
                auto [have, done] = dp[j];
                int need = pref[i] - pref[j];
                if (have >= need) {
                    if (done < dp[i].second) {
                        dp[i] = {have - need, done};
                    } else if (done == dp[i].second) {
                        if (have - need > dp[i].first) {
                            dp[i] = {have - need, done};
                        }
                    }
                } else {
                    need -= have;
                    int add = (need + cost[j] - 1) / cost[j];
                    int ost = (add * cost[j]) % need;
                    if (done + add < dp[i].second) {
                        dp[i] = {ost, done + add};
                    } else if (done + add == dp[i].second) {
                        if (ost > dp[i].first) {
                            dp[i] = {ost, done + add};
                        }
                    }
                }
            }
        }
        cout << dp[n - 1].second;
    } else {
        gr.resize(n);
        cost.resize(n);
        used.resize(n);
        For(i, n) cin >> cost[i];
        For(i, m) {
            int u, v, w;
            cin >> u >> v >> w;
            u--; v--;
            gr[u].eb(v, w);
        }
        dfs(0);
        reverse(all(ord));

        vvi dist(n, vi(n));
        For(i, n) {
            set<pii> st;
            st.insert({0, i});
            vi d(n, INFLL);
            d[i] = 0;
            while (!st.empty()) {
                auto [dd, v] = *st.begin();
                st.erase(st.begin());
                for (auto [u, w] : gr[v]) {
                    if (d[u] > d[v] + w) {
                        st.erase({d[u], u});
                        d[u] = d[v] + w;
                        st.insert({d[u], u});
                    }
                }
            }
            dist[i] = d;
        }

        vpi dp(n, {-INFLL, INFLL});
        dp[0] = {p, 0};
        For(aboba, 5 * n) {
            for (int i = 1; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    auto [have, done] = dp[j];
                    int need = dist[j][i];
                    if (need == INFLL || done == INFLL) continue;
                    if (have >= need) {
                        if (done < dp[i].second) {
                            dp[i] = {have - need, done};
                        } else if (done == dp[i].second) {
                            if (have - need > dp[i].first) {
                                dp[i] = {have - need, done};
                            }
                        }
                    } else {
                        need -= have;
                        int add = (need + cost[j] - 1) / cost[j];
                        int ost = (add * cost[j]) % need;
                        if (done + add < dp[i].second) {
                            dp[i] = {ost, done + add};
                        } else if (done + add == dp[i].second) {
                            if (ost > dp[i].first) {
                                dp[i] = {ost, done + add};
                            }
                        }
                    }
                }
            }
        }
        if (dp[n - 1].second == INFLL) {
            cout << -1;
        } else {
            cout << dp[n - 1].second;
        }
    }
    return 1337 / 2286942;
}