// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>


using namespace std;

#define int long long
#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


mt19937 rnd(24234);
const ll inf = 1e17;


const int mxn = 800;


int n, m, aboba;
ll p;
vector<ll> w;
vector<ll> a, b, s;
vector<vector<ll>> dsts0;
vector<vector<pair<int, ll>>> g;
vector<pair<ll, ll>> dsts1;


void djkstra(int v0, vector<ll> &d){
    d.assign(n, inf);
    d[v0] = 0;
    set<pair<ll, int>> st;
    for(int i = 0; i < n; i += 1){
        st.insert(make_pair(d[i], i));
    }
    while(!st.empty()){
        int v = st.begin()->second;
        st.erase(st.begin());
        for(auto [to, cst]: g[v]){
            if(d[to] > d[v] + cst){
                st.erase(make_pair(d[to], to));
                d[to] = d[v] + cst;
                st.insert(make_pair(d[to], to));
            }
        }
    }
}


void cnt_dsts0(){
    g.assign(n, vector<pair<int, ll>>());
    for(int i = 0; i < m; i += 1){
        int u = a[i];
        int v = b[i];
        g[u].push_back(make_pair(v, s[i]));

        // g[v].push_back(make_pair(u, s[i]));
    }
    dsts0.assign(n, {});
    for(int i = 0; i < n; i += 1){
        djkstra(i, dsts0[i]);
    }
}


ll solve(){
    cnt_dsts0();
    if(dsts0[0][n - 1] > inf / 2){
        return -1;
    }
    dsts1.assign(n, pair<ll, ll>(inf, inf));
    dsts1[0] = make_pair(0, -p);
    vector<int> gdu(n);
    for(int i = 0; i < n; i += 1){
        gdu[i] = i;
    }
    sort(all(gdu), [](int u, int v) {return w[u] < w[v];});
    for(int itr = 0; itr <= 2; itr += 1){
        for(auto u: gdu){
            if(dsts1[u].first > inf / 2){
                continue;
            }
            auto [cnt, rst] = dsts1[u];
            rst = -rst;
            assert(rst >= 0);
            auto mw = w[u];
            for(int v = 0; v < n; v += 1){
                if(u == v){
                    continue;
                }
                ll d = dsts0[u][v];
                ll dcnt = (max(d - rst, 0ll) + mw - 1) / mw;
                dsts1[v] = min(dsts1[v], make_pair(cnt + dcnt, -(rst + dcnt * mw - d)));
            }
        }
    }
    ll rs = inf;
    return dsts1[n - 1].first;
}


int32_t main(){
    if(1){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    cin >> n >> m >> p >> aboba;
    // assert(n <= 100);
    w.resize(n);
    for(int i = 0; i < n; i += 1){
        cin >> w[i];
    }
    a.resize(m);
    b.resize(m);
    s.resize(m);
    for(int i = 0; i < m; i += 1){
        cin >> a[i] >> b[i] >> s[i];
        a[i] -= 1;
        b[i] -= 1;
    }
    cout << solve() << "\n";
    return 0;
}