#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

#define vec vector
#define pb push_back
#define sz(x) (int) (x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using str = string;

template<typename key, typename comp = less<>>
using pbds = __gnu_pbds::tree<key, __gnu_pbds::null_type, comp, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

#ifdef Local
#define debug(x) cout << endl \
                      << "$ " << #x << " = " << x << endl
void print(pbds<pair<int, int>> os) {
    cout << "$ os = { ";
    int n = sz(os);
    auto it = os.begin();
    for (int i = 0; i < n - 1; ++i, ++it)
        cout << "{ " << (*it).first << ", " << (*it).second << " }, ";
    if (it == os.end())
        cout << "}\n";
    else
        cout << "{ " << (*it).first << ", " << (*it).second << " } }\n";
}
#else
#define debug(...) 1337
#define print(...) 1337
#endif

void solve() {
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    vec<int> c(n);
    for (int &i: c)
        cin >> i;
    vec<vec<pair<int, int>>> g(n);
    for (int i = 0, v, u, w; i < m; ++i)
        cin >> v >> u >> w, --v, --u, g[v].pb({u, w});
    if (gr == 1) {
        priority_queue<pair<int, int>> pq;
        pq.push({0, 0});
        vec<int> us(n), ds(n, (int) 1e16);
        ds[0] = 0;
        while (!pq.empty()) {
            auto [d, v] = pq.top();
            pq.pop();
            if (us[v])
                continue;
            us[v] = 1;
            for (auto &[u, w]: g[v])
                if (ds[u] > ds[v] + w)
                    ds[u] = ds[v] + w, pq.push({-(ds[v] + w), u});
        }
        if (ds.back() == (int) 1e16)
            cout << "-1\n";
        else
            cout << max(0ll, ds.back() - p);
    } else if (gr == 2) {
        int cr = 0, mx = c[0];
        for (int i = 0; i < n - 1; ++i) {
            mx = max(mx, c[i]);
            int t = (max(0ll, g[i][0].second - p) + mx - 1) / mx;
            cr += t, p += t * mx - g[i][0].second;
        }
        cout << cr << '\n';
    } else
        return;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();

    return 0;
}