#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <unordered_set>

using namespace std;
typedef unsigned long long  ull;
typedef pair < long long, long long > pll;
typedef long long ll;


vector < long long > w;
vector < long long > tout;
vector <  int > used;
vector < vector < pll > > gr;
long long tim;
long long n;
long long INF = 1e18;
/*void dfs(ll v) {
    used[v] = 1;
    for (auto pa : gr[v]) {
        ll to = pa.first;
        if (!used[to]) {
            dfs(to);
        }
    }
    tim++;
    tout[v] = tim;
}
*/

long long answer = 1e18;

void all_path(ll v, vector < ll > maxes, vector < int > used, ll sum, ll kol) {
    if (kol > answer)return;
    used[v] = 1;
    if (v == n - 1) {
        if (kol < answer) {
            answer = kol;
        }
        return;
    }

    long long ne = w[v];
    if (maxes.size() != 0) {
        ne = max(ne, maxes.back());
    }
    maxes.push_back(ne);

    for (auto pa : gr[v]) {
        ll to = pa.first, s = pa.second;
        if (!used[to]) {
            if (sum < s) {
                ll raz = s - sum;
                ll k = (raz + maxes.back() - 1) / maxes.back();


                //dolg.push_back({ maxes.size(), s - sum });
                all_path(to, maxes, used, maxes.back() * k - raz, kol + k);
                //dolg.pop_back();
            }
            else {
                all_path(to, maxes, used, sum - s, kol);
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long m, p, g;
    cin >> n >> m >> p >> g;

    w.resize(n);
    for (long long i = 0; i < n; i++) {
        cin >> w[i];
    }

    gr.resize(n);
    for (long long i = 0; i < m; i++) {
        long long u, v, s;
        cin >> u >> v >> s;
        u--; v--;
        bool fl = true;
        for (long long j = 0; j < gr[u].size(); j++) {
            if (gr[u][j].first == v) {
                fl = false;
                ll b = gr[u][j].second;
                gr[u][j].second = min(b, s);
                break;
            }
        }
        if (fl) {
            gr[u].push_back({ v, s });
        }
    }

    if (g == 1) {
        vector < long long > dp(n, INF);
        dp[0] = 0;
        vector < int > used(n, 0);
        for (long long i = 0; i < n; i++) {
            long long ind = -1;
            for (long long j = 0; j < n; j++) {
                if (!used[j] && (ind == -1 || dp[ind] > dp[j])) {
                    ind = j;
                }
            }

            for (auto pa : gr[ind]) {
                ll to = pa.first, s = pa.second;
                if (dp[to] > dp[ind] + s) {
                    dp[to] = dp[ind] + s;
                }
            }

            used[ind] = 1;
        }

        if (dp[n - 1] == INF) {
            cout << -1;
        }
        else if (dp[n - 1] > p) {
            cout << dp[n - 1] - p;
        }
        else {
            cout << 0;
        }
        return 0;
    }

    used.assign(n, 0);
    //tout.resize(n);
    //tim = 0;
    //dfs(0);

    all_path(0, {}, used, p, 0);
    if (answer != 1e18) {
        cout << answer;
    }
    else {
        cout << -1;
    }
}
