#include <iostream>
#include<iomanip>
#include <numeric>
#include<cmath>
#include<vector>
#include<map>
#include <queue>
#include<initializer_list>
typedef long long ll;
using namespace std;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;

#define INF 1999999999



int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, m, p, g;
	cin >> n >> m >> p >> g;
	vector<int> mw(n);
	for (int i = 0; i < n; i++)cin >> mw[i];
	vector<vector<pair<int, int>>> ADJLIST(n);
	for (int i = 0; i < m; i++) {
		int v1, v2, w; cin >> v1 >> v2 >> w;
		v1--; v2--;
		ADJLIST[v1].push_back(make_pair(v2, w));
		ADJLIST[v2].push_back(make_pair(v1, w));
	}
	if (g == 1) {
		vector<int> dist(n, INF); dist[0] = 0;
		priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> pq;
		pq.push(ii(0, 0));
		while (!pq.empty()) {
			ii poi = pq.top(); pq.pop();
			int vertex = poi.first;
			int dqs = poi.second;
			if (dist[vertex] < dqs)continue;
			for (int i = 0; i < ADJLIST[vertex].size(); i++) {
				if (dist[ADJLIST[vertex][i].first] > dist[vertex] + ADJLIST[vertex][i].second) {
					dist[ADJLIST[vertex][i].first] = dist[vertex] + ADJLIST[vertex][i].second;
					pq.push(make_pair(ADJLIST[vertex][i].first, dist[ADJLIST[vertex][i].first]));
				}
			}
		}
		if (dist[n - 1] == INF) {
			cout << "-1\n";
		}
		else
			cout << max(0, dist[n-1] - p);

	}
}