#include <bits/stdc++.h>

#define int long long
//g++ -std=c++17 -fsanitize=address -DLOCAL -D_GLIBCXX_DEBUG D.cpp -o D
using namespace std;
using ld = long double;
const int INF = 1e9 + 7;

int n, m, p, g, ans = 0;
vector<int> w, s;

int gen(int r) {
    //cerr << r << '\n';
    if (r == 0) return p;
    int mx = 0;
    for (int i = 0; i < r; ++i) if (w[i] > w[mx]) mx = i;
    auto left = gen(mx);
    int need = 0;
    for (int i = mx; i < r && i < n - 1; ++i) need += s[i];
    //cerr << r << ' ' << left << ' ' << need << '\n';
    if (need <= left) return left - need;
    need -= left;
    ans += max(0LL, (int)ceil((ld)need / w[mx]));
    return max(0LL, (int)ceil((ld)need / w[mx])) * w[mx] - need;
}

void solve() {
    cin >> n >> m >> p >> g;
    w.resize(n), s.resize(n - 1);
    for (auto &i : w) cin >> i;
    if (g == 2) {
        //cerr << "ABOBA\n";
        for (auto &i : s) {
            int a, b;
            cin >> a >> b;
            cin >> i;
        }
        gen(n);
        //for (auto i : s) cerr << i << ' ';
        cout << ans << '\n';
        return;
    }
    if (g == 1) {
        vector<vector<pair<int, int>>> g(n);
        for (int i = 0; i < m; ++i) {
            int a, b, c;
            cin >> a >> b >> c;
            g[--a].emplace_back(--b, c);
        }
        vector<int> d(n, INF), used(n);
        d[0] = 0;
        for (int i = 0; i < n; ++i) {
            int v = -1;
            for (int j = 0; j < n; ++j) {
                if (!used[j] && (v == -1 || d[v] > d[j])) v = j;
            }
            if (v == -1 || d[v] == INF) break; 
            used[v] = 1;
            for (auto [u, w] : g[v]) {
                d[u] = min(d[u], d[v] + w);
            }
        }
        cout << max(0LL, d[n - 1] - p) << '\n';
        return;
    }
    
}
int32_t main() {
    #ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif
    solve();
    return 0;
}