#include <bits/stdc++.h>
#include <cmath>

using namespace std;

#define int long long
#define F first
#define S second
#define endl '\n'
#define double long double

vector<vector<pair<int, int>>> gr(1000);

void solve1(int n, int m, int p) {
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }

    for (int i = 0; i < m; i++) {
        int u, v, ww;
        cin >> u >> v >> ww;

        gr[u].push_back({v, ww});
    }

    vector<int> dist(n + 1, 1e15);
    dist[1] = 0;

    set<pair<int, int>> st;

    st.insert({0, 1});

    while (!st.empty()) {
        int v = st.begin()->S;
        st.erase(st.begin());

        for (auto &[u, ww] : gr[v]) {
            if (dist[u] > dist[v] + ww) {
                st.erase({dist[u], u});
                dist[u] = dist[v] + ww;
                st.insert({dist[u], u});
            }
        }
    }

    if (dist[n] > 1e14) {
        cout << -1;
        return;
    }

    cout << max(0LL, dist[n] - p);
}

void solve2(int n, int m, int p) {
    vector<int> w(n + 1);

    for (int i = 0; i < n; i++) {
        cin >> w[i + 1];
    }

    int mx = w[1];
    int ans = 0;

    for (int i = 0; i < m; i++) {
        int u, v, ww;
        cin >> u >> v >> ww;

        if (p < ww) {
            ww -= p;
            int ff = (ww + mx - 1) / mx;
            p = ff * mx - ww;

            ans += ff;
        }

        else {
            p -= ww;
        }

        mx = max(mx, w[v]);
    }

    cout << ans;

}

signed main() {
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    cout << setprecision(17);

    int n, m, p, g;
    cin >> n >> m >> p >> g;

    if (g == 1) {
        solve1(n, m, p);
    }

    if (g == 2) {
        solve2(n, m, p);
    }

    return 0;
}

/*
3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5
 */

/*
 4 4
abcdca
ab
ca
bcd
opedrftghyj
1 5
2 2
2 6
1 6
 */