#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
ll n, m, p, tc;
vector<vector<pair<ll, ll>>> g;
vector<ll> w;
void solve1() {
    g.resize(n);
    w.resize(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    for (int i = 0; i < m; ++i) {
        ll u, v, c;
        cin >> u >> v >> c;
        --u; --v;
        g[u].push_back({ v, c });
    }
    vector<ll> d(n, 1e17);
    d[0] = 0;
    set<pair<ll, ll>> s;
    s.insert({ 0, 0 });
    while (!s.empty()) {
        ll v = s.begin()->second;
        s.erase(s.begin());
        for (auto to : g[v]) {
            if (d[v] + to.second < d[to.first]) {
                s.erase({ d[to.first], to.first });
                d[to.first] = d[v] + to.second;
                s.insert({ d[to.first], to.first });
            }
        }
    }
    cout << (d[n- 1] < 1e17 ? max(0LL, d[n - 1] - p) : -1);
}

void solve2() {
    g.resize(n);
    w.resize(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    vector<ll> a(n - 1);
    for (int i = 0; i < m; ++i) {
        ll x;
        cin >> x >> x >> a[i];
    }
    vector<ll> pref(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        pref[i] = w[i];
        if (i) pref[i] = min(pref[i], pref[i - 1]);
    }
    ll ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        if (p >= a[i]) {
            p -= a[i];
            continue;
        }
        ll need = a[i] - p;
        ans += (need + pref[i] - 1) / pref[i];
        p += ((need + pref[i] - 1) / pref[i]) * pref[i];
        p -= a[i];
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m >> p >> tc;
    if (tc == 1) {
        solve1();
    }
    else if (tc == 2) {
        solve2();
    }
}