#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int MAXN=804;
const ll INF=2e17;
vector<pair<int,ll> >g[MAXN];
ll w[MAXN];
ll dist[MAXN];
bool used[MAXN];
vector<pair<int,ll> >g1[MAXN];
ll w1[MAXN][MAXN];
ll n,m,p,group;
void dijkstra(int u)
{
    for(int i=0;i<MAXN;i++)dist[i]=INF;
    for(int i=0;i<MAXN;i++)used[i]=0;
    dist[u]=0;
    priority_queue<pair<ll,int> >pq;
    pq.push({0,u});
    while(!pq.empty())
    {
        int t=pq.top().second;
        pq.pop();
        if(used[t])continue;
        used[t]=1;
        for(auto xd:g[t])
        {
            if(dist[t]+xd.second<dist[xd.first])
            {
                dist[xd.first]=dist[t]+xd.second;
                pq.push({-dist[xd.first],xd.first});
            }
        }
    }
}
ll min_perf[MAXN],rem_money[MAXN];
void solve_full()
{
    for(int i=1;i<=n;i++)
    {
        dijkstra(i);
        for(int j=1;j<=n;j++)
        {
            if(j==i)continue;
            if(dist[j]==INF)continue;
            if(w[j]>w[i]||j==n)
            {
                //cout<<i<<" "<<j<<"  :  "<<dist[j]<<endl;
                g1[i].push_back({j,dist[j]});
                w1[i][j]=dist[j];
            }
        }
    }
    vector<pair<ll,int> >sorted;
    for(int i=1;i<=n;i++)
    {
        sorted.push_back({w[i],i});
    }
    sort(sorted.begin(),sorted.end());
    for(int i=1;i<=n;i++)
    {
        min_perf[i]=INF;
        rem_money[i]=0;
    }
    rem_money[1]=p;
    min_perf[1]=0;
    for(int i=0;i<sorted.size();i++)
    {
        int t=sorted[i].second;
        for(auto xd:g1[t])
        {
            ll new_perf=(xd.second-rem_money[t]+w[t]-1)/w[t];
            //cout<<t<<" "<<xd.first<<" "<<new_perf<<endl;
            if(make_pair(new_perf+min_perf[t], -(rem_money[t]+new_perf*w[t]-xd.second))<make_pair(min_perf[xd.first],-rem_money[xd.first]))
            {
                min_perf[xd.first]=new_perf+min_perf[t];
                rem_money[xd.first]=rem_money[t]+new_perf*w[t]-xd.second;
            }
        }
    }
    /*for(int i=1;i<=n;i++)
    {
        cout<<i<<" "<<min_perf[i]<<endl;
    }*/
    if(min_perf[n]==INF)
    {
        cout<<"-1\n";
    }
    else cout<<min_perf[n]<<endl;
}
void read()
{
    cin>>n>>m>>p>>group;
    for(int i=1;i<=n;i++)
    {
        cin>>w[i];
    }
    for(int i=1;i<=m;i++)
    {
        int a,b,s;
        cin>>a>>b>>s;
        g[a].push_back({b,s});
    }
}
int main()
{
    read();
    solve_full();
return 0;
}
