#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long

typedef unsigned long long ull;
typedef long double ld;

#define ff first
#define ss second

void solve() {
    int n, m, p, grp;
    cin >> n >> m >> p >> grp;
    if (grp > 1) {
        cout << "-1\n";
        return;
    }
    vector<int> v(n);
    for (auto &i : v)
        cin >> i;
    vector< vector< pair<int, int> > > g(n);
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--, b--;
        g[a].emplace_back(b, w);
    }

    vector<int> dp(n, (1ll << 60));
    dp[0] = 0;
    set< pair<int, int> > st;
    st.insert({dp[0], 0});
    while (!st.empty()) {
        int w = st.begin()->ss;
        st.erase(st.begin());
        for (auto &[to, c] : g[w]) {
            if (dp[to] > dp[w] + c) {
                if (st.find({dp[to], to}) != st.end())
                    st.erase({dp[to], to});
                dp[to] = dp[w] + c;
                st.insert({dp[to], to});
            }
        }
    }
    if (dp[n - 1] == (1ll << 60)) {
        cout << "-1";
        return;
    }
    cout << max(0ll, dp[n - 1] - p);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    for (; _; --_) {
        solve();
    }
    return 0;
}