#include <iostream>
#include "cstdio"
#include "iomanip"
#include "fstream"
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <set>
#include "map"

using namespace std;
#define map unordered_map
#define ll long long
#define int ll

void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

struct eds{
    int u, s, num;
};

vector<int> w;
vector<vector<eds>> gr;
void main0(){
    int n, m, p, q; cin >> n >> m >> p >> q;
    if (q == 2){
        w.resize(n);
        vector<int> to(n - 1);
        for (int i = 0; i < n; i++){
            cin >> w[i];
        }
        for (int& i : to){
            int v, u; cin >> v >> u >> i;
        }
        vector<int> pref = {0};
        for (int i : to) pref.push_back(pref.back() + i);
        int mx = 0;
        vector<int> nx(n);
        for (int i = 1; i < n; i++){
            if (w[i] > w[mx] || i == n-1){
                nx[mx] = i;
            }
        }
        int cnt = 0;
        int i = 0;
        while (i != n - 1){
            if (p < pref[nx[i]] - pref[i]){
                cnt += (pref[nx[i]] - pref[i] - p - 1) / w[i] + 1;
                p += ((pref[nx[i]] - pref[i] - p - 1) / w[i] + 1) * w[i];
            }
            i = nx[i];
        }cout << cnt;
    }
    if (q != 1) return;
    int mn = 1e9;
    vector<int> used(n+1);
    gr.resize(n+1);
    w.resize(n+1);
    for (int i = 1; i <= n; i++) cin >> w[i];
    for (int i = 0; i < m; i++){
        int v; eds e; cin >> v >> e.u >> e.s; e.num = i;
        gr[v].push_back(e);
    }
    set<pair<int, int>> bfs = {{0, 1}};
    while (bfs.size() && (*bfs.begin()).second != n){
        int s = (*bfs.begin()).first, v = (*bfs.begin()).second;
        bfs.erase(bfs.begin());
        if (used[v]) continue;
        used[v] = 1;
        for (eds e : gr[v]){
            int u = e.u;
            bfs.insert({s + e.s, u});
        }
    }
    if (bfs.size()){
        cout << max((*bfs.begin()).first - p, (int)0);
    } else {
        cout << -1;
    }
}

signed main() {
    speed();
    //cout << fixed << setprecision(10);
    int t = 1;
    while (t--){
        main0();
        cout << '\n';
    }
}