#include <bits/stdc++.h>
using namespace std;

int main() {
    int n, m, group;
    long long p;
    cin >> n >> m >> p >> group;
    vector<int> w(n);
    for (int &v : w) {
        cin >> v;
    }
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--, v--;
        g[u].emplace_back(v, c);
    }
    priority_queue<tuple<pair<long long, long long>, int, int>, vector<tuple<pair<long long, long long>, int, int>>, greater<>> q;
    q.emplace(make_pair(0, -p), 0, 0);
    vector dist(n, vector<pair<long long, long long>>(n, {LLONG_MAX, LLONG_MAX}));
    dist[0][0] = {0, -p};
    while (!q.empty()) {
        auto [d, u, mx] = q.top();
        q.pop();
        if (d > dist[u][mx]) {
            continue;
        }
        long long money = -dist[u][mx].second;
        for (auto [v, c]: g[u]) {
            int new_mx = (w[mx] >= w[v] ? mx : v);
            long long cost = max(0ll, c - money + w[mx] - 1) / w[mx];
            long long rem = money + cost * w[mx] - c;
            pair<long long, long long> new_d = {dist[u][mx].first + cost, -rem};
            if (new_d < dist[v][new_mx]) {
                dist[v][new_mx] = new_d;
                q.emplace(new_d, v, new_mx);
            }
        }
    }
    long long ans = LLONG_MAX;
    for (int i = 0; i < n; i++) {
        ans = min(ans, dist[n - 1][i].first);
    }
    cout << (ans == LLONG_MAX ? -1 : ans) << "\n";
}