#include <bits/stdc++.h>
using namespace std;

#define int long long

int w[1010];
pair<int, int> dist[1010][1010];
vector<vector<pair<int, int> > > d(1010);

signed main() {
    int n, m, k, p, g;

    cin >> n >> m >> p >> g;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        d[u].push_back({v, w});
        d[v].push_back({u, w});
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            dist[i][j] = {1e18, 0};
        }
    }

    set<pair<pair<int, int>, pair<int, int> > > s;
    dist[0][0] = {0, p};
    s.insert({dist[0][0], {0, 0}});
    while (s.size()) {
        auto j = *s.begin();
        s.erase(s.begin());
        int cnt = j.first.first, dd = j.first.second;
        int v = j.second.first, mx = j.second.second;
//        cout << cnt << ' ' << dd << ' ' << v << ' ' << mx << '\n';
        for (auto j : d[v]) {
            int i = mx;
            if (w[j.first] > w[i]) {
                i = j.first;
            }
            int t = max(0ll, (j.second - dd + w[mx] - 1) / w[mx]);
            if (cnt + t < dist[j.first][i].first ||
                cnt + t == dist[j.first][i].first && dd + t * w[mx] - j.second > dist[j.first][i].second) {
                s.erase({dist[j.first][i], {j.first, i}});
                dist[j.first][i] = {cnt + t, dd + t * w[mx] - j.second};
                s.insert({dist[j.first][i], {j.first, i}});
            }
        }
    }
    int ans = 1e18;
    for (int i = 0; i < n; i++) {
        ans = min(ans, dist[n - 1][i].first);
    }
    if (ans >= 1e18) {
        cout << "-1\n";
    } else {
        cout << ans << '\n';
    }

    return 0;
}
