#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long MAXN = 805;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}
long long n, m, p, gr;
long long w[MAXN];
vector < pair < long long , long long > > g[MAXN];

void read()
{
    cin >> n >> m;
    cin >> p >> gr;
    for (long long i = 1; i <= n; ++ i)
        cin >> w[i];
    long long a, b, c;
    for (long long i = 1; i <= m; ++ i)
    {
        cin >> a >> b >> c;
        g[a].push_back(make_pair(b, c));
    }
}
long long used[MAXN];
long long d[MAXN];

void init_dijkstra()
{
    for (long long i = 1; i <= n; ++ i)
        d[i] = 1e15 + 15;
}
long long dijkstra()
{
    init_dijkstra();
    priority_queue < pair < long long/**dist*/, long long /**node*/> > pq;
    d[1] = 0;
    pq.push(make_pair(0, 1));
    while(!pq.empty())
    {
        long long cost = -pq.top().first;
        long long node = pq.top().second;
        pq.pop();
        if(used[node])continue;
        used[node] = 1;
        long long nb, edge;
        for (long long i = 0; i < g[node].size(); ++ i)
        {
            nb = g[node][i].first;
            edge = g[node][i].second;
            if(d[nb] > d[node] + edge)
            {
                d[nb] = d[node] + edge;
                pq.push(make_pair(-d[nb], nb));
            }
        }
    }
    if(d[n] == 1e15 + 15)cout << -1 << endl;
    else cout << max(1LL * 0, d[n] - p) << endl;
}
int main()
{
    speed();

    read();
    dijkstra();
    return 0;
}
