#include<bits/stdc++.h>

using namespace std;
const int MAXN = 805;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int n, m, p, group;
int w[MAXN];
vector < pair < int, int > > g[MAXN];

void read()
{
    cin >> n >> m >> p >> group;
    for (int i = 1; i <= n; ++ i)
        cin >> w[i];
    int a, b, c;
    for (int i = 1; i <= m; ++ i)
    {
        cin >> a >> b >> c;
        g[a].push_back(make_pair(b, c));
    }
}
long long d[MAXN], used[MAXN];

void solve()
{
    for (int i = 1; i <= n; ++ i)
        d[i] = 1e15 + 15;
    d[1] = 0;
    priority_queue < pair < int, int > > pq;
    pq.push(make_pair(0, 1));

    while(!pq.empty())
    {
        int beg = pq.top().second;
        long long cost = -pq.top().first;
        pq.pop();
        if(used[beg])continue;
        used[beg] = 1;
        int nb, edge;
        for (int i = 0; i < g[beg].size(); ++ i)
        {
            nb = g[beg][i].first;
            edge = g[beg][i].second;
            if(d[nb] > d[beg]  + edge)
            {
                d[nb] = d[beg] + edge;
                pq.push(make_pair(-d[nb], nb));
            }
        }
    }
    if(d[n] == 1e15 + 15)cout << -1 << endl;
    else cout << max(1LL * 0, d[n] - p) << endl;
}
int main()
{

	speed();
	read();
	solve();
    return 0;
}
