#include <bits/stdc++.h>

using namespace std;

const int MAXA = 2e5 + 1;

vector<int> t;
void update(int v, int tl, int tr, int p, int x)
{
    if (tl == tr) {t[v] = max(t[v], x); return;}
    int tm = (tl + tr) >> 1;
    if (p <= tm) update(v * 2, tl, tm, p, x);
    else update(v * 2 + 1, tm + 1, tr, p, x);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}
int get(int v, int tl, int tr, int l, int r)
{
    if (l > r || l < tl || tr < r) return 0;
    if (tl == l && tr == r) return t[v];
    int tm = (tl + tr) >> 1;
    return max(get(v * 2, tl, tm, l, min(r, tm)), get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

int main()
{
    int n;
    cin >> n;
    vector<vector<int> > a(n);
    int sumk = 0;
    int mxa = 0;
    for (int i = 0; i < n; i++)
    {
        int k;
        cin >> k;
        sumk += k;
        a[i].resize(k);
        for (int j = 0; j < k; j++)
        {
            cin >> a[i][j];
            mxa = max(mxa, a[i][j]);
        }
    }
    if (n <= 7 && sumk <= 1000)
    {
        vector<int> ord(n);
        iota(ord.begin(), ord.end(), 0);
        int ans = 0;
        t.resize(4 * MAXA);
        do
        {
            fill(t.begin(), t.end(), 0);
            vector<int> b(sumk);
            int C = 0;
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < a[ord[i]].size(); j++) b[C++] = a[ord[i]][j];
            }
            int res = 0;
            int mx = 0;
            for (int i = 0; i < b.size(); i++)
            {
                if (b[i] > mx)
                {
                    res++;
                    mx = b[i];
                }
            }
            ans = max(ans, res);
        }while(next_permutation(ord.begin(), ord.end()));
        cout << ans;
        return 0;
    }
    if (mxa <= 2)
    {
        vector<int> cnt(n);
        int sum = 0;
        for (int i = 0; i < n; i++)
            for (int j=  0; j < a[i].size(); j++) cnt[i] += (a[i][j] == 2), sum += (a[i][j] == 2);
        bool kok = 0;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < a[i].size(); j++) if (a[i][j] == 1 && sum - cnt[i] > 0) kok = 1;
        int ans = (kok ? 2 : 1);
        for (int i = 0; i < n; i++)
        {
            int mx = 0;
            int res = 0;
            for (int j = 0; j < a[i].size(); j++)
            {
                if (a[i][j] > mx)
                {
                    res++;
                    mx = a[i][j];
                }
            }
            ans = max(ans, res);
        }
        cout << ans;
        return 0;
    }
    return 0;
}
