#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define pii pair<int, int>
#define pll pair<long long, long long>
#define all(v) v.begin(),v.end()

const ll mod = 1000000007;

vector<int> a[200005];
vector<int> mxs[200005];

void solve(){
    int n;
    cin >> n;
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        a[i].resize(k);
        for(int j = 0; j < k; j++) cin >> a[i][j];
        int mx = *max_element(all(a[i]));
        mxs[mx].push_back(i);
    }
    int ans = 0;
    int pr = 0;
    for(int i = 1; i <= 200000; i++){
        if(!(int)mxs[i].size()) continue;
        int maxval = 0;
        for(int u : mxs[i]){
            int res = 0, p = pr;
            for(int j : a[u]){
                if(j > p) res++;
                p = max(p, j);
            }
            maxval = max(maxval, res);
        }
        ans += maxval;
        pr = i;
    }
    cout << ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int tt;
    //cin >> tt;
    tt = 1;
    while(tt--){
        solve();
        #ifdef LOCAL
            cout << "________________________________________\n";
        #endif // LOCAL
    }
    #ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec\n";
    #endif // LOCAL
    return 0;
}



