#include <bits/stdc++.h>

using namespace std;

#define pii pair<int,int>
typedef long double ld;
//#define int int64_t

mt19937 gen(chrono::system_clock().now().time_since_epoch().count());

const int N = 2e5+10, K = 30;

int n;
vector <int> a[N];
vector <int> k[N];
int p[N];
int pans[N];
int pmx[N];

int cost (int mx, int i) {
    int l = 0, r = a[i].size()-1;
    if (a[i].back() <= mx) {
        return 0;
    }
    while (l < r) {
        int m = (l+r)/2;
        if (a[i][m] <= mx) {
            l = m+1;
        }
        else {
            r = m;
        }
    }
    return k[i][l];
}

int solve (int st) {
    for (int i=st;i<n;++i) {
        if (i > 0) {
            pans[i] = pans[i-1] + cost(pmx[i-1], p[i]);
            pmx[i] = max(pmx[i-1], a[p[i]].back());
        }
        else {
            pans[i] = cost(0, p[i]);
            pmx[i] = a[p[i]].back();
        }
    }
    return pans[n-1];
}

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> n;
    for (int i=0;i<n;++i) {
        int num;
        cin >> num;
        a[i].resize(num+1);
        k[i].resize(num+1);
        for (int j=1;j<=num;++j) {
            cin >> a[i][j];
            a[i][j] = max(a[i][j], a[i][j-1]);
        }
        for (int j=num;j>0;--j) {
            if (j < num) {
                k[i][j] = k[i][j+1];
            }
            if (a[i][j] > a[i][j-1]) {
                k[i][j]++;
            }
        }
    }
    for (int i=0;i<n;++i) {
        p[i] = i;
    }
    sort(p, p+n, [&](int x, int y) {return {a[x].back(), -k[x][0]} < {a[y].back(), k[x][0]};});
    int CL = CLOCKS_PER_SEC * 98 / 100;
    int ans = solve(0);
    ld t = 1;
    while (clock() <= CL) {
        int v = gen() % n, u = gen() % n;
        swap(p[v], p[u]);
//        for (int i=0;i<n;++i) {
//            cerr << p[i] << ' ';
//        }
//        cerr << '\n';
        int g = solve(min(v, u));
//        cerr << g << ' ' << t << '\n';
        if (g > ans || exp(ld(g - ans) / t) > 0.1) {
            ans = g;
        }
        else {
            swap(p[v], p[u]);
        }
        t = t * 0.996;
    }
    cout << ans;

    return 0;
}
