#include <bits/stdc++.h>

using namespace std;

#define int long long

bool cmp(vector <int> &a, vector <int> &b) {
    return a[0] < b[0];
}

mt19937 mt_rand(time(nullptr));

long double rnd() {
    return (long double)rand() / RAND_MAX;
}

long double t = 100;
long double mul = 0.99;

long double iters = 1000;

int f(vector < vector <int> > &a, vector <int> &p) {
    int res = 0;
    int mx = 0;
    for (int i = 0; i < a.size(); i++) {
        for (int j = 0; j < a[p[i]].size(); j++) {
            if (a[p[i]][j] > mx) {
                mx = a[p[i]][j];
                res++;
            }
        }
    }
    return res;
}


vector <int> deikstra(vector < vector < pair <int, int> > > &g, int start) {
    vector <int> d(g.size(), 1e9);
    d[start] = 0;
    set < pair <int, int> > s;
    s.insert({d[start], start});
    while (!s.empty()) {
        int v = s.begin()->second;
        s.erase(s.begin());
        for (int i = 0; i < g[v].size(); i++) {
            int u = g[v][i].first, w = g[v][i].second;
            if (d[v] + w < d[u]) {
                s.erase({d[u], u});
                d[u] = d[v] + w;
                s.insert({d[u], u});
            }
        }
    }
    return d;
}

vector <int> used;
vector <int> top;

void dfs(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    top.push_back(v);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n; cin >> n;
    int mxx = 0;
    vector < vector <int> > a(n);
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        for (int j = 0; j < k; j++) {
            int x; cin >> x;
            a[i].push_back(x);
            mxx = max(mxx, x);
        }
    }
    if (n <= 7 && 0) {
        vector <int> p;
        for (int i = 0; i < n; i++) {
            p.push_back(i);
        }
        int res = 0;
        do {
            vector <int> v;
            for (int i = 0; i < n; i++) {
                for (auto x : a[p[i]]) {
                    v.push_back(x);
                }
            }
            int mx = -1;
            int cnt = 0;
            for (int i = 0; i < v.size(); i++) {
                if (v[i] > mx) {
                    mx = v[i];
                    cnt++;
                }
            }
            res = max(res, cnt);
        } while (next_permutation(p.begin(), p.end()));
        cout << res << endl;
        return 0;
    }
    if (mxx <= 2 && 0) {
        int cnt1 = 0, cnt2 = 0;
        bool ok = false;
        for (int i = 0; i < n; i++) {
            if (a[i][0] == 1) ok = true;
            for (int j = 0; j < a[i].size(); j++) {
                if (a[i][j] == 1) {
                    cnt1++; 
                } else {
                    cnt2++;
                }
            }
        }
        if (ok && cnt2 > 0) {
            cout << 2;
        } else {
            cout << 1;
        }
    } else {
        used.resize(n);

        a.push_back({0, 0});
        vector < vector < pair <int, int> > > g(n + 1);
        for (int i = 0; i < n + 1; i++) {
            for (int j = 0; j < n + 1; j++) {
                auto it = upper_bound(a[j].begin(), a[j].end(), a[i].back());
                if (it != a[j].end()) {
                    g[i].push_back({j, it - a[j].begin() + 2});
                }
            } 
        }
        dfs(n);
        reverse(top.begin(), top.end());
        vector <int> d(n + 1);
        for (auto v : top) {
            for (auto u : g[v]) {
                d[u] = max(d[v] + 1, d[u]);
            }
        }
        int res = 0;
        for (auto x : d) res = max(res, x);
            cout << res;
    }
        
    return 0;
}