#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace std;
using namespace __gnu_pbds;

int calc_nvp_len(vector<int>& a, vector<int>& b) {
    vector<int> c = a;
    for (int i = 0; i < b.size(); ++i) {
        c.push_back(b[i]);
    }
    int ans = 0;
    int pref_max = a[0];
    for (int i = 0; i < c.size(); ++i) {
        if (c[i] > pref_max) {
            pref_max = c[i];
            ans++;
        }
    }
    /*vector<int> dp(c.size() + 1, INT_MAX);
    dp[0] = 0;
    int ans = 0;
    for (int i = 0; i < c.size(); ++i) {
        int now_len = lower_bound(dp.begin(), dp.end(), c[i]) - dp.begin();
        dp[now_len] = c[i];
        ans = max(ans, now_len);
    }*/
    return ans;
}

void top_sort(int u, vector<vector<int>>& g, vector<int>& topsort, vector<char>& used) {
    used[u] = 1;
    for (auto& v: g[u]) {
        if (used[v])
            continue;
        top_sort(v, g, topsort, used);
    }
    topsort.push_back(u);
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> max_val(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (calc_nvp_len(a[i], a[j]) > calc_nvp_len(a[j], a[i]))
                g[i].push_back(j);
            else
                g[j].push_back(i);
        }
    }
    vector<int> topsort;
    vector<char> used(n);
    for (int i = 0; i < n; ++i) {
        if (used[i])
            continue;
        top_sort(i, g, topsort, used);
    }
    reverse(topsort.begin(), topsort.end());
    vector<int> c;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < a[topsort[i]].size(); ++j) {
            c.push_back(a[topsort[i]][j]);
        }
    }
    int ans = 0;
    int pref_max = c[0];
    for (int i = 0; i < c.size(); ++i) {
        if (c[i] > pref_max) {
            pref_max = c[i];
            ans++;
        }
    }
    cout << ans;
}


signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}