#include <bits/stdc++.h>
 
using namespace std;

int bin_search(vector<int> a, int t) {
	int n = a.size();
	int l = -1, r = n;
	while(l < r - 1) {
		int m = (l + r) / 2;
		if (a[m] > t) r = m;
		else l = m;
	}
	return n - r;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

 	int n; cin >> n;
 	vector<vector<int>> a(n);
 	vector<int> mx(n);
 	for (int i = 0; i < n; i++) {
 		int k; cin >> k;
 		int v; cin >> v;
 		a[i].push_back(v);
 		for (int j = 1; j < k; j++) {
 			cin >> v;
 			if (v > a[i][a[i].size() - 1])
 				a[i].push_back(v);
 		}
 		mx[i] = a[i][a[i].size() - 1];
 	}

 	vector<bool> listened(n);
 	int res = 0;
 	int last = 0;
 	while(true) {
	 	int t = n;
	 	for (int i = 0; i < n; i++)
	 		if (!listened[i] && mx[i] >= last) { t = i; }
	 		else { listened[i] = true; }
	 	if (t == n) break;

	 	for (int i = 0; i < n; i++)
	 		if (!listened[i] && mx[i] < mx[t]) { t = i; }

	 	int ms = 0;
	 	for (int i = 0; i < n; i++)
	 		if (!listened[i]) ms = max(ms,
	 			(int)a[i].size() - bin_search(a[i], mx[t]));

	 	if (ms <= a[t].size()) {
		 	res += bin_search(a[t], last);
	 	}
	 	last = mx[t];
		listened[t] = true;
 	}
 
 	cout << res << "\n";

    return 0;
}