#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ft first
#define sd second
#define fbo find_by_order
#define ook order_of_key
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using oset=tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
typedef pair<int,int> pii;

const int N=5e5+228;
const int inf=1e9+1;
const ll Inf=1e18+1;
const int mod=1e9+7;

int binpow(int a,int b){
    int ans=1;
    while(b){
        if(b&1) ans*=a;
        a*=a;
        b/=2;
    }
    return ans;
}
int k[N],cnt[N];
int t[N*8];
bool lp[N*8];
vector<int> v[N],up[N],en[N];
ll ans=0;

void lazy_push(int v){
    if(lp[v]){
        t[v]=0;
        lp[v]=0;
        lp[v<<1]=1;
        lp[v<<1|1]=1;
    }
    return;
}
void upd1(int v,int tl,int tr,int ps){
    lazy_push(v);
    lazy_push(v<<1);
    lazy_push(v<<1|1);
    if(tl==tr){
        t[v]++;
        return;
    }
    int mid=(tl+tr)>>1;
    if(mid>=ps) upd1(v<<1,tl,mid,ps);
    else upd1(v<<1|1,mid+1,tr,ps);
    t[v]=max(t[v<<1],t[v<<1|1]);
}
int get(int v,int tl,int tr,int ps){
    lazy_push(v);
    lazy_push(v<<1);
    lazy_push(v<<1|1);
    if(tl==tr) return t[v];
    int mid=(tl+tr)>>1;
    if(ps<=mid) return get(v<<1,tl,mid,ps);
    else return get(v<<1|1,mid+1,tr,ps);
}
void solve(){
    int n;
    cin >> n;
    assert(n!=1);
    for(int i=1;i<=n;i++){
        cin >> k[i];
        for(int j=1;j<=k[i];j++){
            int x;
            cin >> x;
            if(j==1){
                v[i].pb(x);
                up[x].pb(i);
            }
            else if(v[i][sz(v[i])-1]<x){
                v[i].pb(x);
                up[x].pb(i);
            }
        }
        en[v[i][sz(v[i])-1]].pb(i);
    }
    for(int i=0;i<N;i++){
        for(auto x:up[i]) cnt[x]++;
        int mx=0;
        for(int j=1;j<=n;j++) mx=max(mx,cnt[j]);
        bool fl=0;
        for(auto x:en[i]){
            if(cnt[x]==mx){
                fl=1;
                ans+=mx;
                break;
            }
        }
        if(fl==1)
            for(int j=1;j<=n;j++) cnt[j]=0;
    }
    cout << ans << endl;
}
int main()
{
    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
