#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;

const ll INF = (ll)(1e18);

vector<vector<ll>> a;

bool cmp(const ll &i, const ll &j) {
    // for (ll i = 1; i <= min(a.size(), b.size()); ++i) {
    //     if (a[a.size() - i] < b[b.size() - i]) return true;
    //     if (a[a.size() - i] > b[b.size() - i]) return false;
    // }

    // if (a.size() >= b.size()) return true;
    // return false;

    return a[i].back() < a[j].back();
}

struct segtree {
    ll sz = 1;
    vector<ll> data;

    void init(ll n) {
        while (sz < n) sz *= 2;
        data.resize(2 * sz, 0);
    }

    ll get(ll v, ll ql, ll qr, ll vl, ll vr) {
        if (ql <= vl && vr <= qr) return data[v];
        if (qr <= vl || vr <= ql) return 0LL;

        ll mid = (vl + vr) / 2;

        ll fir = get(v * 2, ql, qr, vl, mid);
        ll sec = get(v * 2 + 1, ql, qr, mid, vr);
        
        return max(fir, sec);
    }

    void upd(ll v, ll val) {
        v += sz;
        data[v] = val;
        v /= 2;

        while (v) {
            data[v] = max(data[2 * v], data[2 * v + 1]);
            v /= 2;
        }
    }
};

void solve() {
    ll n;
    cin >> n;

    a.resize(n);

    ll MAXA = 0;

    for (ll i = 0; i < n; ++i) {
        ll k;
        cin >> k;

        for (ll j = 0; j < k; ++j) {
            ll x;
            cin >> x;

            if (!j || a[i].back() < x) {
                a[i].push_back(x);
                MAXA = max(MAXA, x);
            }
        }
    }

    // cout << cmp({4, 9}, {1});
    // return;

    vector<ll> b(n);
    for (ll i = 0; i < n; ++i) b[i] = i;

    sort(all(b), cmp);

    // vector<ll> dp(MAXA + 1, 0);
    segtree seg;
    seg.init(MAXA + 1);

    for (ll i = 0; i < n; ++i) {
        ll ind = b[i];

        ll fg = seg.data[a[ind].back() + seg.sz];
        for (ll j = 0; j < a[ind].size(); ++j) {
            ll ans = 0;

            // for (ll h = 0; h < a[ind][j]; ++h) ans = max(ans, dp[h]);
            ll cnt = seg.get(1, 0, a[ind][j], 0, seg.sz);

            fg = max(fg,  cnt + (ll)a[ind].size() - j);
        }

        seg.upd(a[ind].back(), fg);
    }

    ll ans = 0;

    for (auto i : seg.data) ans = max(ans, i);

    cout << ans;

    // for (auto i : dp) cout << i << ' ';
    // return;


    // ll biggest = -INF;
    // ll cnt = 0;

    // for (auto i : a) {
    //     for (auto j : i) {
    //         if (biggest < j) {
    //             biggest = j;
    //             ++cnt;
    //         }
    //     }
    // }

    // cout << cnt;
}

signed main() {
    int tests = 1;

    while (tests--) {
        solve();
    }
}

// cd "d:\open_olympiad\" ; if ($?) { g++ main.cpp -o main } ; if ($?) { .\main } 
