#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MAXN = 2e5 + 10;
const int MX = 0;

class Segtree {
public:
    Segtree() {
        upd(0, 0);
    }

    void upd(int x, int data, int v = 1, int l = 0, int r = MAXN) {
        if (x >= r || x < l)
            return;
        if (l + 1 == r) {
            tree_[v] = max(tree_[v], data);
            return;
        }
        int mid = (l + r) >> 1;
        upd(x, data, v + v, l, mid);
        upd(x, data, v + v + 1, mid, r);
        tree_[v] = max(tree_[v +v], tree_[v + v +1]);
    }

    int get(int tl, int tr, int v = 1, int l = 0, int r = MAXN) {
        if(tl <= l && r <= tr)
            return tree_[v];
        if(r <= tl || tr <= l)
            return -MX;
        int mid = (l + r) >> 1;
        return max(get(tl, tr, v + v, l, mid), get(tl, tr, v + v + 1, mid, r));
    }

private:
    vector<int> tree_ = vector<int>(4 * MAXN, -MX);
};

signed main() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<pair<int, int> > id;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; ++j)
            cin >> a[i][j];
        vector<int> b;
        int mx = 0;
        for (auto u: a[i])
            if (mx < u){
                mx = u; b.push_back(u);
            }
        a[i] = b;
        id.push_back({b.back(), i});
    }
    sort(id.begin(), id.end());
    Segtree segtree;
    for(int i = 0;i<n;++i){
        int mx = 0;
        for(int j = 0;j <a[id[i].second].size();++j){
            mx = max(mx, segtree.get(0, a[id[i].second][j]) + (int)a[id[i].second].size() - j);
        }
        segtree.upd(id[i].first, mx);
    }
    cout << segtree.get(0, MAXN);
}
