#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

constexpr int MAXV = 200000;

int main() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> mx(n);
    vector<vector<pair<int, int>>> vs(MAXV + 1);
    vector<int> bu(MAXV + 1);
    {
        int p = -1;
        for (auto &x: a) {
            ++p;
            int k;
            cin >> k;
            x.resize(k);
            for (auto &y: x) {
                cin >> y;
                --y;
                mx[p] = max(mx[p], y);
            }
            vector<int> vv;
            for (int i = k; i--;) {
                while(!vv.empty() && vv.back() <= x[i]) vv.pop_back();
                vv.push_back(x[i]);
            }
            vs[x[0]].emplace_back(mx[p], (int)vv.size());
        }
    }
    int cb = 0;
    for (int i = 0; i < MAXV; ++i) {
        for (auto [x, y] : vs[i]) {
            bu[x] = max(bu[x], cb + y);
        }
        cb = max(bu[i], cb);
    }
    cout << cb << endl;
    return 0;
}
