#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

constexpr int MAXV = 200000;

int main() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<vector<pair<int, int>>> vs(MAXV + 1);
    vector<int> bu(MAXV + 1);
    {
        int p = -1;
        for (auto &x: a) {
            ++p;
            int k;
            cin >> k;
            x.resize(k);
            vector<int> macc;
            macc.reserve(k);
            for (auto &y: x) {
                cin >> y;
                --y;
                if (macc.empty()) macc.push_back(y);
                else macc.push_back(max(macc.back(), y));
            }
            vector<int> vv;
            for (int i = k; i--;) {
                while(!vv.empty() && vv.back() <= x[i]) vv.pop_back();
                vv.push_back(x[i]);
            }
            reverse(vv.begin(), vv.end());
            int s = (int)vv.size();
            for (int i = k; i--;) {
                int l = -1, r = s;
                while (r - l > 1) {
                    int m = (l + r) / 2;
                    if (vv[m] < x[i]) l = m;
                    else r = m;
                }
                vs[x[i]].emplace_back(macc[k-1], (int)vv.size() - r);
            }
        }
    }
    int cb = 0;
    for (int i = 0; i < MAXV; ++i) {
        for (auto [x, y] : vs[i]) {
            bu[x] = max(bu[x], cb + y);
        }
        cb = max(bu[i], cb);
    }
    cout << cb << endl;
    return 0;
}
