#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define itn int
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define Int int
#define Itn int
#define pii pair<int, int>
#define X first
#define Y second

template<typename T>
istream &operator >> (istream &in, vector<T> &arr) {
    for(auto &to : arr) in >> to;
    return in;
}

template<typename T>
ostream &operator << (ostream &out, vector<T> &arr) {
    for(auto &to : arr) out << to << " ";
    return out;
}

const int INF = 1e9 + 7;
const int MOD = 998244353;
const int maxn = 1e6 + 1;

bool cmp(vector<itn> a, vector<int> b) {
    int ans1 = 0, ans2 = 0;
    int cur = *max_element(all(a));
    for(auto to : b) if(to > cur) cur = to, ++ans1;
    cur = *max_element(all(b));
    for(auto to : a) if(to > cur) cur = to, ++ans2;

    int ans11 = 0, ans22 = 0;
    cur = 0;
    for(auto to : a) if(to > cur) ++ans11, cur = to;
    for(auto to : b) if(to > cur) ++ans11, cur = to;
    cur = 0;
    for(auto to : b) if(to > cur) ++ans22, cur = to;
    for(auto to : a) if(to > cur) ++ans22, cur = to;
    return ans1 > ans2 && ans11 > ans22;
}

void dfs(int v, vector<vector<int>> &g, vector<int> &cur, vector<bool> &used) {
    used[v] = true;
    for(auto to : g[v]) {
        if(!used[to]) {
            dfs(to, g, cur, used);
        }
    }
    cur.pb(v);
}

void solve() {
    itn n;
    cin >> n;
    vector<vector<int>> a(n);
    for(int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        cin >> a[i];
    }
    if(n <= 1000) {
        vector<vector<int>> g(n);
        for(int i = 0; i < n; ++i) {
            for(int j = 0; j < n; ++j) {
                if(cmp(a[i], a[j])) {
                    g[i].pb(j);
                }
            }
        }
        vector<bool> used(n, false);
        vector<int> cur;
        dfs(0, g, cur, used);
        reverse(all(cur));
        int ans = 0;
        itn curmx = 0;
        for(auto i : cur) {
            for(auto to : a[i]) {
                if(to > curmx) ++ans, curmx = to;
            }
        }
        cout << ans << '\n';
        return;
    }
    sort(all(a), cmp);
    int ans = 0;
    int cur = 0;
    for(int i = 0; i < n; ++i) {
        for(auto to : a[i]) {
            if(to > cur) cur = to, ++ans;
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) {
        solve();
    }
}