#include "bits/stdc++.h"
using namespace std;

// cd /mnt/commons/
// g++ -DHOME -Wall -Wextra -DGLIBCXX_DEBUG 1.cpp && ./a.out 

#define int long long
#define ll long long


#define all(a) a.begin(), a.end()
#define vc vector
#define ld long double
#define forn(i , n) for(int i = 0; i < (int)n; i++)
#define fri(st , en , step) for(int i = st; i < (int)en ; i+=step)
#define frj(st , en , step) for(int j = st; j < (int)en ; j+=step)
#define sz(a) ((int)a.size())
#define pb push_back
#define mp make_pair


template<typename T>
ostream& operator<<(ostream& a, vc<T> b){
	forn(i , sz(b) - 1) a << b[i] << " ";
	if(sz(b)) a << b.back(); 
	return a;
}






#ifdef HOME
	#define o(a) << "[" << #a << ": " << a << "] "
#else
	#define o(a) ;
#endif



class debug{
public:
	debug(){}
	~debug(){
		#ifdef HOME
			cerr << endl;
		#endif
	}
	template<typename T>
	debug& operator<<(T a){
		#ifdef HOME
			cerr << a;
		#endif
		return *this;
	}
};

mt19937 rnd(1211);

template<typename T>
inline bool cmin(T &a, T b){
	if(a > b){
		a = b;
		return 1;
	}
	return 0;
}

template<typename T>
inline bool cmax(T &a, T b){
	if(a < b){
		a = b;
		return 1;
	}
	return 0;
}

const int MOD = 1e9 + 7;
const ld e = 1e-9;
const int inf = 1e18;
const int maxn = 2e5 + 10;






inline void run(){
	int n  ,k;
	cin >> n >> k;
	vc<int> A(n);
	forn(i , n) cin >> A[i];
	vc<vc<int>> dp(n + 1,  vc<int>(k + 1));
	dp[0][1] = 1;
	forn(i , n){
		vc<pair<int ,  int>> t = {{A[i] , 1ll}};
		for(int j = 1; j <= A[i] ; j++){
			if(t.back().first == A[j] / j) t[sz(t) - 1].second = j;
			else t.pb({A[i] / j ,  j});
		}
		debug() o(sz(t));
		for(auto x : t){
			for(int j = 1 ; j <= k ; j++){
				if(j * x.second >= k) cmax(dp[i + 1][k] , dp[i][j] * x.first);
				else cmax(dp[i + 1][j * x.second] , dp[i][j] * x.first);
			}
		}
	}
	if(dp[n][k] == 0) {
		cout << "0\n";
		return;
	}
	ld ans = dp[n][k] * k;
	forn(i , n) ans /= A[i];
	cout << setprecision(14) << fixed << ans << "\n";


}


signed main(){
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int tt = 1;
	// cin >> tt;
	while(tt--){
		run();
	}
	return 0;
}