#include <bits/stdc++.h>

typedef long long ll;

template<typename t> using vc = std::vector<t>;

const int N = 200005;

const int T = 1 << 18;
int t[T * 2];

void modify(int i, int x) {
    t[i += T] = std::max(t[i], x);
    while (i /= 2) t[i] = std::max(t[i * 2], t[i * 2 + 1]);
}

int get(int l, int r) {
    l += T, r += T;
    int ans = 0;
    while (l <= r) {
        if (l & 1) ans = std::max(ans, t[l++]);
        if (~r & 1) ans = std::max(ans, t[r--]);
        l /= 2, r /= 2;
    }
    return ans;
}

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    std::cin >> n;
    vc<vc<int>> a(n);
    for (auto &i: a) {
        int k;
        std::cin >> k;
        vc<int> dno(k);
        for (auto &j: dno) std::cin >> j;
        int max = -1;
        for (auto &j: dno) if (j > max) i.push_back(max = j);
    }
    std::sort(a.begin(), a.end(), [&](const auto &i, const auto &j) {
        return i.back() < j.back();
    });
    int max = -1;
    vc<int> pref = {max};
    for (int i = 0; i < n; ++i) {
        int my = get(0, N - 1);
        for (int j = 0; j < a[i].size(); ++j) {
            my = std::max(my, get(0, a[i][j] - 1) + (int) (a[i].size() - j));
        }
        pref.push_back(max = std::max(max, a[i].back()));
        modify(max, my);
    }
    std::cout << get(0, N - 1) << '\n';
}