#include <bits/stdc++.h>
///#include <ext/pb_ds/assoc_container.hpp>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define fi first
#define se second
#define all(v) (v).begin(), (v).end()

using namespace std;
///using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair <int, int>;

struct S{
    int mx;
    vector <int> v;
};

bool comp(S& a, S& b){
    return a.mx < b.mx;
}

int const N = 2e5 + 4;
int t[4 * N];

void update(int tl, int tr, int v, int pos, int x){
    if(pos < tl or tr < pos){
        return;
    }
    if(pos == tl and pos == tr){
        t[v] = max(t[v], x);
        return;
    }
    int tm = (tl + tr) >> 1;
    update(tl, tm, (v << 1) + 1, pos, x);
    update(tm + 1, tr, (v << 1) + 2, pos, x);
    t[v] = max(t[(v << 1) + 1], t[(v << 1) + 2]);
    return;
}

int get(int l, int r, int tl, int tr, int v){
    l = max(l, tl);
    r = min(r, tr);
    if(l > r or tl > tr){
        return 0;
    }
    if(l == tl and r == tr){
        return t[v];
    }
    int tm = (tl + tr) >> 1;
    return max(get(l, r, tl, tm, (v << 1) + 1), get(l, r, tm + 1, tr, (v << 1) + 2));
}

signed main(){
    ibase;
    int n;
    cin >> n;
    vector <S> a(n);
    for(int i = 0; i < n; ++i){
        int k;
        cin >> k;
        a[i].mx = -1;
        for(int j = 0; j < k; ++j){
            int x;
            cin >> x;
            if(a[i].mx < x){
                a[i].v.push_back(x);
                a[i].mx = x;
            }
        }
    }
    sort(all(a), comp);
    //vector < vector <int> > dp(n, vector <int>(n + 1, 0));
    vector <int> _dp(n, 0);
    int ans = 0;
    for(int i = 0; i < n; ++i){
//        for(int j = 0; j < i; ++j){
//            int mx = a[j].mx, cnt = (a[i].v.end() - upper_bound(all(a[i].v), mx));
//            dp[i][j] = max(dp[i][j], _dp[j] + cnt);
//        }
        for(int j = 0; j < (int)a[i].v.size(); ++j){
            int cnt = ((int)a[i].v.size() - j) + get(0, a[i].v[j] - 1, 0, N - 1, 0);
            _dp[i] = max(_dp[i], cnt);
        }
        _dp[i] = max(_dp[i], get(0, N - 1, 0, N - 1, 0));
        _dp[i] = max(_dp[i], (int)a[i].v.size());
        ans = max(ans, _dp[i]);
        update(0, N - 1, 0, a[i].mx, _dp[i]);
    }
    cout << ans;
}
