﻿#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

const int maxn = 1e5 + 5;

vector<vector<int>> v;

signed main() {
	int n;
	cin >> n;
	v.resize(n);
	int mxA = 0;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int x;
			cin >> x;
			mxA = max(mxA, x);
			v[i].push_back(x);
		}
	}
	if (n <= 7) {
		int ans = 0;
		sort(v.begin(), v.end());
		do {
			int mx = 0, res = 0;
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < v[i].size(); ++j) {
					if (v[i][j] > mx)
						++res, mx = v[i][j];
				}
			}
			ans = max(ans, res);
		} while (next_permutation(v.begin(), v.end()));
		cout << ans;
		return 0;
	}
	if (mxA <= 2) {
		int idx = -1, is2 = 0;
		for (int i = 0; i < n; ++i) {
			if (v[i][0] == 1)
				idx = i;
			if (v[i][0] == 2 || v[i][1] == 2)
				is2 = 1;
		}
		if (idx != -1 && is2 == 1)
			cout << 2;
		else
			cout << 1;
		return 0;
	}
	sort(v.begin(), v.end(), [](auto a, auto b) {
		int mx1 = 0, mx2 = 0;
		for (auto i : a)
			mx1 = max(mx1, i);
		for (auto i : b)
			mx2 = max(mx2, i);
		return mx1 < mx2;
	});
	int mx = 0, res = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < v[i].size(); ++j) {
			if (v[i][j] > mx)
				++res, mx = v[i][j];
		}
	}
	cout << res;
}