#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int k;
int *m;

bool comp(int i, int j)
{
    return m[i] > m[j];
}

int main()
{
    int n;
    cin >> n;
    int *p = new int[n];
    m = new int[n];
    vector<int> *a = new vector<int>[n];
    for(int i = 0; i < n; ++i){
        p[i] = i;
        int ma = 0;
        int k;
        cin >> k;
        for(int j = 0; j < k; ++j){
            int x;
            cin >> x;
            if(x > ma){
                ma = x;
                a[i].push_back(x);
            }
        }
        m[i] = ma;
    }
    sort(p, p + n, comp);
    k = m[p[0]];
    int *step = new int[k];
    for(int i = 0; i < k; ++i) step[i] = 0;
    for(int i = 0; i < n; ++i){
        int j = p[i];
        int l = 0, r = k - 1;
        while(l != r){
            int mid = (l + r)/2;
            if(step[mid] > m[j]) l = mid + 1;
            else r = mid;
        }
        int s = a[j].size();
        for(int d = 0; d < s; ++d){
            step[l + d] = max(step[l + d], a[j][s - 1 - d]);
        }
    }
    int l = 0, r = k;
    while(l != r){
        int mid = (l + r)/2;
        if(step[mid] > 0) l = mid + 1;
        else r = mid;
    }
    cout << l << endl;
    return 0;
}