#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <cmath>

typedef long long ll;
#define all(x) x.begin(), x.end()

const ll MOD = 1000000007;
//const ll MOD = 998244353;

using namespace std;

vector<pair<int, int>> prs[200005];
int dp[200005];

void solve() {
    int n; cin >> n;
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        vector<int> kr(k);
        for (int j = 0; j < k; ++j) {
            cin >> kr[j];
        }
        vector<int> v;
        int mx = 0;
        for (int j = 0; j < k; ++j) {
            if (kr[j] > mx) {
                v.push_back(kr[j]);
                mx = kr[j];
            }
        }
        for (int j = 0; j < (int)v.size(); ++j) {
            prs[v[j]].push_back({ v.back(), (int)v.size() - j });
        }
    }
    for (int i = 1; i <= 200003; ++i) {
        dp[i] = max(dp[i], dp[i - 1]);
        for (auto p : prs[i]) {
            dp[p.first + 1] = max(dp[p.first + 1], dp[i] + p.second);
        }
    }
    cout << dp[200003] << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}