#ifndef NT1E
#pragma GCC optimize("Ofast,unroll-loops")
#endif
#include "bits/stdc++.h"
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
#ifndef NT1E
#pragma GCC target("tune=native")
#endif

using namespace std;
using ll = long long;

int dp[200228];
vector<int> sus[200228];

constexpr int R = 262144;
int tree[R << 1];

void upd(int p, int v) {
    tree[p += R] = v;
    for (p /= 2; p > 0; p /= 2) {
        tree[p] = max(tree[2 * p], tree[2 * p + 1]);
    }
}

int get(int r) {
    int l = R;
    r += R;
    int m = 0;
    while (l < r) {
        if (l & 1) {
            m = max(m, tree[l++]);
        }
        if (r & 1) {
            m = max(m, tree[--r]);
        }
        r /= 2;
        l /= 2;
    }
    return m;
}


int main() {
#ifdef NT1E
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        sus[i].reserve(k);
        for (int ik = 0; ik < k; ++ik) {
            int to;
            cin >> to;
            if (sus[i].empty() || to > sus[i].back()) {
                sus[i].push_back(to);
            }
        }
        mx = max(mx, sus[i].back());
    }
    sort(sus, sus + n, [](const vector<int> &a1, const vector<int> &a2) {
        return a1.back() < a2.back();
    });
    for (int i = 0; i < n; ++i) {
        for (int start_track = 0; start_track < (int)sus[i].size(); ++start_track) {
            dp[sus[i].back()] = max(dp[sus[i].back()], (int)sus[i].size() - start_track + get(sus[i][start_track]));
        }
        upd(sus[i].back(), dp[sus[i].back()]);
    }
    cout << dp[mx] << '\n';
    return 0;
}
