#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<vector<int>>alb;
vector<pair<int, int>>ord;
int tree[800004];
int n;
int maxaij;

void bestgo(){
    vector<int>aboba(n);
    int ans = 0;
    for(int i=0;i<n;i++)
        aboba[i]=i;
    while(next_permutation(aboba.begin(), aboba.end())){
        int now = 0;
        int nm=-1;
        for(int i=0;i<n;i++){
            for(auto& k: alb[aboba[i]]) {
                if(k>nm){
                    nm = k;
                    now++;
                }
            }
        }
        ans=max(ans, now);
    }
    cout<<ans;
}

void smallai(){
    vector<int>dp(maxaij+1);
    int ans=0;
    for(int i=0;i<=maxaij;i++){
        for(int k = 0;k<n;k++){
            dp[alb[k].back()] = max(dp[alb[k].back()], (int)(dp[i]+ (int)alb[k].size()-(upper_bound(alb[k].begin(), alb[k].end(), i)-alb[k].begin())));
            ans = max(ans, dp[alb[k].back()]);
        }
    }
    cout<<ans;
}

int get(int ind, int l, int r, int need_l, int need_r) {
    if(l>need_r || r<need_l)
        return 0;
    if(l>=need_l && r<=need_r)
        return tree[ind];
    int m = (l+r)/2;
    return max(get(ind*2, l, m, need_l, need_r), get(ind*2+1, m+1, r, need_l, need_r));
}

void update(int ind, int l, int r, int need, int zn){
    if(l>need || r<need)
        return;
    if(l==r) {
        tree[ind] = zn;
        return;
    }
    int m = (l+r)/2;
    update(ind*2, l, m, need, zn);
    update(ind*2+1, m+1, r, need, zn);
    tree[ind]=max(tree[ind*2], tree[ind*2+1]);
}

void smart() {
    for(auto&i:ord){
        int now = 0;
        for(int k= 0; k < alb[i.second].size();k++) {
            now = max(now, get(1, 0, 200000, 0, alb[i.second][k]-1)+int(alb[i.second].size())-k);
        }
        update(1, 0, 200000, alb[i.second].back(), now);
    }
    cout<<get(1, 0, 200000, 0, 200000);
}

void solve() {
    cin>> n;
    alb.resize(n);
    ord.resize(n);
    for(int i=0; i < n; i++){
        int k;
        cin>>k;
        int prevmx=-1;
        while(k--) {
            int q;
            cin >> q;
            maxaij=max(maxaij, q);
            if (q > prevmx) {
                prevmx = q;
                alb[i].push_back(q);
            }
        }
        ord[i]={prevmx, i};
    }
    sort(ord.begin(), ord.end());
    /*if(n<=7){
        bestgo();
        return;
    }*/
    //smallai();
    smart();
}

int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}