#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll K = 2e5 + 10;

struct S{
    ll r, k, mx;
};

int main() {
    fastio();
    vector<ll> dp(K, 0);
    vector<vector<S>> sob(K);
    ll n;
    cin >> n;
    for (ll i = 0; i < n; i++) {
        ll x;
        cin >> x;
        vector<ll> a(x);
        vector<ll> mxx = {0};
        for (ll j = 0; j < x; j++) {
            cin >> a[j];
            if (a[j] > mxx.back()) mxx.push_back(a[j]);
        }
        for (ll j = 1;j<mxx.size();j++){
            sob[mxx[j]].push_back({mxx[j]-1, mxx.size() - j, mxx.back()});
        }
    }
    for (ll i = 1;i<K;i++){
        dp[i] = max(dp[i], dp[i-1]);
        for (auto& s : sob[i]){
            dp[s.mx] = max(dp[s.mx], dp[s.r] + s.k);
        }
    }
    cout << dp[K-1] << "\n";
    return 0;
}