#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

#define fi first
#define se second
#define pb push_back
#define ld long double
#define pii pair <int, int>
#define int int64_t
#define pw(x) (int64_t(1) << x)

using namespace std;
const int INF = 1e9, M = 2e5 + 5;
int dp[pw(7)][M];

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    vector <int> a[n];
    for(int i = 0; i < n; ++i) {
        int N;
        cin >> N;
        a[i].resize(N);
        for(int j = 0; j < N; ++j) {
            cin >> a[i][j];
        }
    }
    if(n <= 7) {
        for(int i = 0; i < pw(7); ++i) {
            for(int j = 0; j < M; ++j) {
                dp[i][j] = -INF;
            }
        }
        dp[0][0] = 0;
        for(int msk = 0; msk < pw(n); ++msk) {
            for(int last = 0; last < M; ++last) {
                for(int i = 0; i < n; ++i) {
                    if((msk >> i) & 1) {
                        continue;
                    }
                    if(dp[msk][last] == -INF) {
                        continue;
                    }
                    int Max = last, cur = dp[msk][last];
                    for(auto to : a[i]) {
                        if(to > Max) {
                            cur++;
                            Max = to;
                        }
                    }
                    dp[msk ^ pw(i)][Max] = max(dp[msk ^ pw(i)][Max], cur);
                }
            }
        }
        int ans = 0;
        for(int i = 0; i < pw(7); ++i) {
            for(int last = 0; last < M; ++last) {
                ans = max(ans, dp[i][last]);
            }
        }
        cout << ans;
        return 0;
    }
    int mx = 0;
    for(int i = 0; i < n; ++i) {
        for(auto to : a[i]) {
            mx = max(mx, to);
        }
    }
    if(mx == 1) {
        cout << 1;
        return 0;
    }
    if(mx <= 2) {
        for(int i = 0; i < n; ++i) {
            bool f = 0, ok = 0;
            for(auto to : a[i]) {
                if(to == 1 && !f) {
                    ok = 1;
                    break;
                }
                if(to == 2) {
                    f = 1;
                }
            }
            if(ok) {
                cout << 2;
                return 0;
            }
        }
        cout << 1;
        return 0;
    }
    cout << n;
    return 0;
}
