#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int inf = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 2e5 + 5;

vector<int> a[MAXN];
int k[MAXN];

vector<pair<pll, int>> prs;

void solve() {
    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> k[i];
        a[i].rs(k[i]);
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        prs.pb({make_pair(*max_element(all(a[i])), -*min_element(all(a[i]))), i});
    }
    sort(all(prs));
    ll mx = -inf;
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k[prs[i].Y]; j++) {
            if (a[prs[i].Y][j] > mx) {
                ans++;
                mx = a[prs[i].Y][j];
            }
        }
    }
    cout << ans << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}
