#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int inf = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 2e5 + 5;

int t[MAXN * 4];
int add[MAXN * 4];

vector<int> a[MAXN];
vector<int> b[MAXN];
int k[MAXN];
vector<pll> prs;

void push(int v) {
    if (add[v] == -1)return;
    add[v * 2 + 1] = add[v];
    add[v * 2 + 2] = add[v];
    t[v] = add[v];
    add[v] = -1;
}

int get(int v) {
    if (add[v] == -1)return t[v];
    return 0;
}

void upd(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr)return;
    if (ql <= l && r <= qr) {
        add[v] = 0;
        return;
    }
    push(v);
    int mid = (l + r) >> 1;
    upd(v * 2 + 1, l, mid, ql, qr);
    upd(v * 2 + 2, mid, r, ql, qr);
    t[v] = get(v * 2 + 1) + get(v * 2 + 2);
}

void upd(int v, int l, int r, int x) {
    if (r - l == 1) {
        t[v]++;
        return;
    }
    int mid = (l + r) >> 1;
    if (x < mid) {
        upd(v * 2 + 1, l, mid, x);
    } else {
        upd(v * 2 + 2, mid, r, x);
    }
    t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}

int ask(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr)return 0;
    if (ql <= l && r <= qr)return get(v);
    push(v);
    int mid = (l + r) >> 1;
    return ask(v * 2 + 1, l, mid, ql, qr) + ask(v * 2 + 2, mid, r, ql, qr);
}

int used[MAXN];

void solve() {
    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> k[i];
        a[i].rs(k[i]);
        cin >> a[i];
    }
    if (n <= 30000) {
        fill(add, add + MAXN * 4, -1);
        vector<int> mxs;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            int mx = -inf;
            mxs.pb(mx);
            for (int j = 0; j < k[i]; j++) {
                if (a[i][j] > mx) {
                    ans++;
                    mx = a[i][j];
                    b[i].pb(mx);
                    upd(0, 0, MAXN, mx);
                    mxs.back() = mx;
                }
            }
        }
        int mx = -inf;
        for (int i = 0; i < n; i++) {
            pair<pii, int> del = {{1e9, 1e9}, -1};
            for (int j = 0; j < n; j++) {
                if (used[j] == 0) {
                    int x1 = ask(0, 0, MAXN, 0, mxs[j] + 1);
                    int x2 = (b[j].end() - upper_bound(all(b[j]), mx));
                    del = min(del, {{x1 - x2, -mxs[j]}, j});
                }
            }
            ans -= del.X.X;
            used[del.Y] = 1;
            mx = mxs[del.Y];
            upd(0, 0, MAXN, 0, mxs[del.Y] + 1);
        }
        cout << ans << '\n';
    } else {
        for (int i = 0; i < n; i++) {
            prs.pb({*max_element(all(a[i])), i});
        }
        sort(all(prs));
        ll mx = -inf;
        ll ans = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < k[prs[i].Y]; j++) {
                if (a[prs[i].Y][j] > mx) {
                    ans++;
                    mx = a[prs[i].Y][j];
                }
            }
        }
        cout << ans << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}
