#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int inf = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 2e5 + 5;

vector<int> a[MAXN];
vector<int> b[MAXN];
int k[MAXN];
vector<pll> prs;

struct Node {
    int val;
    Node *l, *r;

    Node() {
        r = l = nullptr;
        val = 0;
    }
};

int sm(Node *rt) {
    return (rt ? rt->val : 0);
}

Node* upd(Node *rt, int l, int r, int x, int val) {
    if (!rt)rt = new Node();
    if (r - l == 1) {
        rt->val = max(rt->val, val);
        return rt;
    }
    int mid = (l + r) >> 1;
    if (x < mid) {
        rt->l = upd(rt->l, l, mid, x, val);
    } else {
        rt->r = upd(rt->r, mid, r, x, val);
    }
    rt->val = max(sm(rt->l), sm(rt->r));
    return rt;
}

int ask(Node *rt, int l, int r, int ql, int qr) {
    if (!rt || ql >= r || l >= qr)return 0;
    if (ql <= l && r <= qr)return rt->val;
    int mid = (l + r) >> 1;
    return max(ask(rt->l, l, mid, ql, qr), ask(rt->r, mid, r, ql, qr));
}


Node *dp[2];

void solve() {
    int n;
    cin >> n;
    vector<pii> mxs;
    dp[0] = nullptr;

    for (int i = 0; i < n; i++) {
        cin >> k[i];
        a[i].rs(k[i]);
        cin >> a[i];
        int mx = -1;
        for (int j = 0; j < k[i]; j++) {
            if (mx < a[i][j]) {
                mx = a[i][j];
                b[i].pb(mx);
            }
        }
        k[i] = sz(b[i]);
        mxs.pb({b[i].back(), i});
    }
    sort(all(mxs));
    for (int i = 0; i < n; i++) {
        int ind = mxs[i].Y;
        int cur = i & 1;
        int nxt = cur ^ 1;
        dp[nxt] = dp[cur];
        /*for (int j = 0; j < 11; j++) {
            cout << ask(dp[cur], 0, MAXN, j, j + 1) << ' ';
        }
        cout << '\n';*/
        for (int j = 0; j < k[ind]; j++) {
            int cdp = ask(dp[cur], 0, MAXN, 0, b[ind][j]);
            dp[nxt] = upd(dp[nxt], 0, MAXN, b[ind].back(), k[ind] - j + cdp);
        }
    }

    cout << ask(dp[n & 1], 0, n, 0, MAXN) << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}