#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

const int A = 1 << 18;

int mx[A << 1];
void update(int k, int x) {
    k += A;
    mx[k] = max(mx[k], x);
    while (k > 1) {
        k >>= 1;
        mx[k] = max(mx[k << 1], mx[k << 1 | 1]);
    }
}
int get(int l, int r) {
    int res = 0;
    for (l += A, r += A; l <= r; l >>= 1, r >>= 1) {
        if (l & 1) res = max(res, mx[l++]);
        if (~r & 1) res = max(res, mx[r--]);
    }
    return res;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n;
    cin >> n;
    map<int, vector<vector<int>>> qq;
    for (int c = 0; c < n; ++c) {
        int k;
        cin >> k;
        vector<int> x(k);
        for (int i = 0; i < k; ++i) cin >> x[i];
        for (int i = 1; i < k; ++i) x[i] = max(x[i], x[i - 1]);
        x.resize(unique(all(x)) - x.begin());
        qq[x.back()].push_back(x);
    }
    for (auto [x, vv] : qq) {
        for (auto v : vv) {
            for (int i = 0; i < v.size(); ++i) {
                update(v.back(), get(0, v[i] - 1) + v.size() - i);
            }
        }
    }
    cout << get(0, A - 1);
}
