﻿#include <iostream>
#include <random>
#include <vector>
#include<string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <stack>
#include <math.h>
#include <iomanip>

using namespace std;

#define int long long
#define all(arr) arr.begin(), arr.end()
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
mt19937 rnd(time(0));
vector<vector<int>> a;

vector<int> tree, b;
int MAXN = 2 * 1e5 + 4;

void build(int v, int tl, int tr) {
	if (tl == tr - 1) {
		tree[v] = b[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	build(2 * v + 1, tl, tm);
	build(2 * v + 2, tm, tr);
	tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

void upd(int v, int tl, int tr, int id, int val) {
	if (tl == tr - 1 && tl == id) {
		tree[v] = val;
		return;
	}
	int tm = (tl + tr) / 2;
	if (tl <= id && id < tm) upd(2 * v + 1, tl, tm, id, val);
	else upd(2 * v + 2, tm, tr, id, val);
	tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int get(int v, int tl, int tr, int l, int r) {
	if (r <= tl || tr <= l) return 0;
	if (l <= tl && tr <= r) return tree[v];
	int tm = (tl + tr) / 2;
	return max(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm, tr, l, r));
}

bool cmp(vector<int> a1, vector<int> a2) {
	int s1 = a1.size() - 1, s2 = a2.size() - 1;
	while (s1 >= 0 && s2 >= 0) {
		if (a1[s1] != a2[s2]) return a1[s1] < a2[s2];
		s1--;
		s2--;
	}
	if (s1 == -1) return 1;
	return 0;
}

signed main()
{
	int n; cin >> n;
	a.resize(n);
	int MAX = 0;
	for (int i = 0; i < n; ++i) {
		int k; cin >> k;
		int maxi = 0;
		for (int j = 0; j < k; ++j) {
			int x; cin >> x;
			if (x > maxi) {
				maxi = x;
				a[i].push_back(x);
			}
		}
		MAX = max(MAX, maxi);
	}

	if (MAX <= 2) {
		int ans = 0;
		for (int i = 0; i < n; ++i)
			if (a[i].size() && a[i][0] == 1) ans = 1;
		if (MAX == 2) ans++;
		cout << ans;
		return 0;
	}

	sort(all(a), cmp);

	int sz = MAXN;
	tree.resize(4 * sz, 0);
	b.resize(sz, 0);
	build(0, 0, sz);

	for (int i = 0; i < n; ++i) {
		int s = a[i].size();
		int maxi = 0;
		for (int j = 0; j < s; ++j) {
			int x = a[i][j];
			int cnt = get(0, 0, sz, 0, x);
			//cout << cnt << " ";
			maxi = max(maxi, cnt + s - j);
		}
		//cout << endl;
		//cout << a[i][s - 1] << " " << maxi << endl;
		//cout << endl;
		upd(0, 0, sz, a[i][s - 1], maxi);
	}

	cout << get(0, 0, sz, 0, sz);
	return 0;
}