// #pragma GCC optimize("O3")
// #pragma GCC target("avx,avx2,abm,popcnt,lzcnt,tune=native")
#include <algorithm>
#include <array>
#include <bitset>
#include <chrono>
#include <cmath>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

// #include <ext/rope>
// #include <ext/pb_ds/tree_policy.hpp>
// #include <ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_cxx;
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag,
// tree_order_statistics_node_update> ordered_set;

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        while (k--) {
            int x;
            cin >> x;
            a[i].pb(x);
        }
    }
    int ans = 0;
    vector<int> p(n);
    mt19937 rnd(
        chrono::high_resolution_clock().now().time_since_epoch().count());
    for (int i = 0; i < n; i++)
        p[i] = i;
    for (int _ = 0; _ < 500; _++) {
        shuffle(all(p), rnd);
        int mx = 0, cur = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < a[p[i]].size(); j++) {
                if (a[p[i]][j] > mx) {
                    cur++;
                    mx = a[p[i]][j];
                }
            }
        }
        ans = max(ans, cur);
    }
    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //    cin >> t;
    while (t--)
        solve();
    return 0;
}