// #pragma GCC optimize("O3")
// #pragma GCC target("avx,avx2,abm,popcnt,lzcnt,tune=native")
#include <algorithm>
#include <array>
#include <bitset>
#include <chrono>
#include <cmath>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

// #include <ext/rope>
// #include <ext/pb_ds/tree_policy.hpp>
// #include <ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_cxx;
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag,
// tree_order_statistics_node_update> ordered_set;

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const int inf = INT_MAX / 2;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n + 1);
    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        while (k--) {
            int x;
            cin >> x;
            a[i].pb(x);
        }
    }
    sort(all(a));
    int ans = 0, mx = 0;
    for (auto row : a) {
        for (auto x : row) {
            if (x > mx) {
                ans++;
                mx = x;
            }
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //    cin >> t;
    while (t--)
        solve();
    return 0;
}