#include <bits/stdc++.h>
using namespace std;

#define fout cerr
#define ll long long
#define ull unsigned long long
#define vi vector<int>
#define vl vector<ll>
#define vii vector<vi>
#define vll vector<vl>
#define all(arr) arr.begin(), arr.end()
#define rev(arr) arr.rbegin(), arr.rend()
#define lb(arr, val) int(lower_bound(all(arr), val) - arr.begin())
#define ub(arr, val) int(upper_bound(all(arr), val) - arr.begin())
#define _unique(arr) arr.erase(unique(all(arr)), arr.end())
#define pii pair<int, int>
#define pll pair<ll, ll>
#define vpi vector<pii>
#define vpl vector<pll>

ostream &operator<<(ostream& out, vi a) {
    for (auto u : a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream& in, vi& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

ostream &operator<<(ostream& out, vl a) {
    for (auto u : a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream& in, vl& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}
istream &operator>>(istream& in, pii& a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream& out, pii a) {
    out << a.first << " " << a.second;
    return out;
}

istream &operator>>(istream& in, pll& a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream& out, pll a) {
    out << a.first << " " << a.second;
    return out;
}

const int MAX_N = 2e5 + 1;
int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#else
    #define fout if (0) cout
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
#endif
    cout << setprecision(13) << fixed;

    int n;
    cin >> n;
    vii a(n);
    vpi b(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        cin >> a[i];
        int max = 0;
        for (auto u : a[i]) {
            if (u > max) max = u;
        }
        b[i] = {max, i};
    }

    sort(all(b));
    int j = 0;
    vi tmp(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        tmp[i + 1] = b[i].first;
    }
    _unique(tmp);
    vi c(MAX_N);
    for (int i = 0; i < n; ++i) {
        if (i != 0 && b[i].first != b[i - 1].first) j++;
        int cnt = 0;
        int prev = tmp[j];
        for (auto u : a[b[i].second]) {
            if (u > prev) {
                cnt++;
                prev = u;
            }
        }
        c[prev] = max(c[prev], cnt);

    }
//    for (int i =0; i < 10; ++i) cout << c[i] << " ";


    int cnt = 0;
    for (auto u : c) cnt += u;
    cout << cnt;

}
