#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> &a);
template<typename T>
ostream& operator << (ostream &out, set<T> &a);
template<typename T>
ostream& operator << (ostream &out, vector<T> &a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> &a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(2281337711);

void solve_case() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> mx(n);
    map<int, vector<int>> layers;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            chmax(mx[i], x);
            a[i].push_back(x);
        }
        layers[mx[i]].push_back(i);
    }
    int prv = -1;
    int ans = 0;
    for (auto v : layers) {
        vector<int> res;
        for (int ind : v.se) {
            int p = prv;
            int cur = 0;
            for (int i : a[ind]) {
                if (i > p) {
                    cur++;
                    p = i;
                }
            }
            res.push_back(cur);
        }
        ans += *max_element(res.begin(), res.end());
        prv = v.fi;
    }
    cout << ans << "\n";
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve_case();
    }
    return 0;
}