#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int num = 0; num < n; num++) {
        int k;
        cin >> k;
        vector<int> b(k);
        for (int& val : b)
            cin >> val;
        int cur = 0;
        for (int i = 0; i < k; i++) {
            if (b[i] > cur) {
                cur = b[i];
                a[num].push_back(cur);
            }
        }
    }
    sort(all(a), [](vector<int>& fir, vector<int>& sec) {
        return fir.back() < sec.back();
    });
    vector<int> lst(n + 1, 0), dp(n + 1, 0);
    for (int i = 0; i < n; i++)
        lst[i + 1] = a[i].back();
    for (int i = 0; i < n; i++) {
        dp[i + 1] = dp[i];
        for (int j = 0; j < a[i].size(); j++) {
            int p = lower_bound(all(lst), a[i][j]) - lst.begin() - 1;
            dp[i + 1] = max(dp[i + 1], dp[p] + (int)(a[i].size() - j));
        }
    }
    
    cout << dp.back();
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
}