#include<bits/stdc++.h>


using namespace std;
typedef long long ll;


int cnt(vector<int>& order, vector<bool>& free, vector<vector<int>>& k)
{
    int ans = 0;
    bool f = true;
    for (int i = 0; i < free.size(); i++)
    {
        if (!free[i])
        {
            f = false;
            free[i] = true;
            order.push_back(i);
            ans = max(ans, cnt(order, free, k));
            free[i] = false;
            order.pop_back();
        }
    }
    if (f)
    {
        int mx = 0;
        for (int i = 0; i < order.size(); i++)
        {
            for (int j = 0; j < k[order[i]].size(); j++)
            {
                if (k[order[i]][j] > mx)
                {
                    ans++;
                    mx = k[order[i]][j];
                }
            }
        }
    }
    return ans;
}


void solve1(int n, vector<vector<int>>& k)
{
    vector<bool> free(n, false);
    vector<int> order;
    cout << cnt(order, free, k);
    return;
}


void solve2(int n, vector<vector<int>>& k)
{
    vector<int> types(n);
    bool is_1 = false;
    bool is_2 = false;
    for (int i = 0; i < k.size(); i++)
    {
        int last = 0;
        for (auto el: k[i])
        {
            if (last == 1 && el == 2)
            {
                is_1 = true;
                is_2 = true;
            }
            if (el == 1 && last < 2)
            {
                is_1 = true;
            }
            if (el == 2)
            {
                is_2 = true;
            }
            last = max(last, el);
        }
    }
    int ans = 0;
    if (is_1)
    {
        ans++;
    }
    if (is_2)
    {
        ans++;
    }
    cout << ans;
    return;
}


int main()
{
    int n;
    cin >> n;
    vector<vector<int>> k(n);
    for (int i = 0; i < n; i++)
    {
        int s;
        cin >> s;
        k[i].resize(s);
        for (int j = 0; j < s; j++)
        {
            cin >> k[i][j];
        }
    }
    if (n <= 8)
    {
        solve1(n, k);
    }
    else
    {
        solve2(n, k);
    }
    return 0;
}
