#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <random>
#include <set>

#define int long long
#define double long double

using namespace std;

const int MAXN = 201'000;
const int inf = 1e18;
const int mod = 1e9 + 7;

mt19937 rnd;

vector <int> p[MAXN];
int dp[MAXN], pr[MAXN];
vector <int> y[MAXN];

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(11) << fixed;   cout.tie(0);
    int n; cin >> n;
    int mx = 0;
    for (int i = 0; i < n; i ++){
        int k; cin >> k;
        for (int j = 0; j < k; j ++){
            int x; cin >> x;
            if (p[i].size() == 0 || x > p[i].back()) p[i].push_back(x);
        }
        y[p[i].back()].push_back(i);
        mx = max(mx, p[i].back())
   ; }
    for (int i =0 ; i < MAXN; i ++){
        dp[i] = 0;
        pr[i] = 0;
    }
    for (int i = 1; i <= mx; i ++){
        for (int j : y[i]){
            for (int k = p[j].size() - 1; k >= 0; k --){
                dp[i] = max(dp[i], (int)(p[j].size() - k) + pr[p[j][k] - 1]);
            }
        }
        pr[i] = max(dp[i], pr[i - 1]);
    }
    cout << pr[mx];
}
