#include <iostream>
#include "array"
#include "climits"
#include "cmath"
#include "algorithm"
#include "vector"
#include "string"
#include "map"
using namespace std;
vector<vector<pair<int, int>>> g;
void solve() {
    int n;
    cin >> n;
    g.assign(200001, {});
    for (int i = 0; i + 1 < g.size(); ++i) {
        g[i].push_back({i + 1, 0});
    }
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        vector<int> t(k);
        for (int j = 0; j < k; ++j) {
            cin >> t[j];
        }
        int abob = 0;
        int res = 0;
        for (int j = 0; j < k; ++j) {
            if (t[j] > abob) {
                abob = t[j];
                res++;
            }
        }
        int mx = abob;
        abob = 0;
        for (int j = 0; j < k; ++j) {
            if (t[j] > abob) {
                g[t[j] - 1].push_back({mx, res});
                abob = t[j];
                res--;
            }
        }
    }
    vector<int> dp(g.size());
    for (int i = 0; i < g.size(); ++i) {
        for (auto [v, c] : g[i]) {
            dp[v] = max(dp[i] + c, dp[v]);
        }
    }
    cout << dp.back() << '\n';
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) solve();
    return 0;
}
