#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pp;

const int maxn = 2e5 + 11;
vector<int> arr[maxn];
int dp[maxn];

bool cmp(int a, int b) {
    return arr[a].back() < arr[b].back();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> inds(n);
    for (int i = 0; i < n; i++) {
        inds[i] = i;
        int k;
        cin >> k;
        arr[i].assign(k, 0);
        for (int j = 0; j < k; j++) {
            cin >> arr[i][j];
        }
        vector<int> tmp;
        int prv = 0;
        for (int j = 0; j < k; j++) {
            if (arr[i][j] > prv) {
                tmp.push_back(arr[i][j]);
            }
            prv = max(prv, arr[i][j]);
        }
        arr[i] = tmp;
        for (int el:arr[i]) {
            cout << el << ' ';
        }
        cout << '\n';
    }
    sort(inds.begin(), inds.end(), cmp);

    for (int id = 0; id < inds.size(); id++) {
        int el = inds[id];
        for (int j = arr[el].size() - 1; j >= 0; j--) {
            int left = arr[el].size() - j;
            dp[arr[el].back()] = max(dp[arr[el].back()], dp[arr[el][j] - 1] + left);
        }
        if (id + 1 < inds.size()){
            for (int f = arr[el].back() + 1; f <= arr[inds[id + 1]].back(); f++){
                dp[f] = dp[arr[el].back()];
            }
        }


    }
    int res = 0;
    for (int i = 0; i < maxn; i++){
        res = max(res, dp[i]);
    }
    cout << res;
}