#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define pb push_back
#define ff first
#define ss second
#define err(x) cerr << "[" << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[" << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "[" << ""#x"" << "] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}
using ll = long long;
using ld = long double;

using namespace std;

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}

mt19937 rnd(::std::chrono::high_resolution_clock::now().time_since_epoch().count());
const int MOD = 1e9 + 7;

/// actual code starts here

const int N = 2e5 + 5;

int f[N];

int get(int r) {
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) relaxma(res, f[r]);
    return res;
}

void upd(int p, int x) {
    for (; p < N; p |= (p + 1)) relaxma(f[p], x);
}

struct bebra {
    int mx, give, id;

    bool operator<(const bebra &oth) const {
        if (mx == oth.mx) return give > oth.give;
        return mx < oth.mx;
    }
};


void solve() {
    int n;
    vector<bebra> v;
    cin >> n;
    vector<vector<int>> cur(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        cur[i].resize(k);
        for (auto &j: cur[i]) cin >> j;
        int cnt = 0, mx = 0;
        vector<int> cur2;
        for (auto j: cur[i]) {
            if (relaxma(mx, j)) {
                cur2.pb(mx);
                cnt++;
            }
        }
        cur[i] = cur2;
        v.pb({mx, cnt, i});
    }
    sort(all(v));
    vector<int> now;
    for (auto [e, e2, id]: v) {
        int best = 0;
        for (int j = 0; j < cur[id].size(); j++) {
            relaxma(best, (int) cur[id].size() - j + get(cur[id][j] - 1));
        }
        upd(cur[id].back(), best);
    }
    cout << get(N - 1);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) solve();
}