#include <bits/stdc++.h>
#define int long long
#define double long double
#define x first
#define y second
#define inf (INT64_MAX / 2)

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n), ac;
    vector<pair<int, int>> s(n);
    for (int i = 0; i < n; i++) {
        int x, mx = -inf;
        cin >> x;
        for (int j = 0; j < x; j++) {
            int y;
            cin >> y;
            if (y > mx) {
                a[i].push_back(y);
                mx = y;
            }
        }
        s[i] = {mx, i};
    }
    sort(s.begin(), s.end());
    ac = a;
    for (int i = 0; i < n; i++) {
        a[i] = ac[s[i].y];
    }
    vector<int> dp(n + 1, 0), pr(n + 1, 0);
    dp[0] = 0;
    pr[0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < a[i - 1].size(); j++) {
            int l = -1, r = i - 1;
            while (r - l > 1) {
                int m = (r + l) / 2;
                if (a[m].back() >= a[i - 1][j]) {
                    r = m;
                } else {
                    l = m;
                }
            }
            dp[i] = max((int)dp[i], (int)(pr[l + 1] + a[i - 1].size() - j));
        }
        pr[i] = max(pr[i - 1], dp[i]);
    }
    cout << pr.back() << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}