#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define mem(x, y) memset(x, y, sizeof x)
#define int ll

bool cmp(vector <int> &a, vector <int> &b) {
	if (a.back() == b.back()) return a.front() < b.front();
	return a.back() < b.back();
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	
	int n;
	cin >> n;
	vector <vector <int>> a(n);
	
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		for (int j = 0; j < k; j++) {
			int x;
			cin >> x;
			if (a[i].empty() || a[i].back() < x) a[i].push_back(x);
		}
	}
	
	if (n <= 7) {
		vector <int> p(n);
		iota(all(p), 0);
		
		int ans = 0;
		do {
			int cur = -1, cnt = 0;
			for (int i: p) {
				for (int j: a[i]) {
					if (j > cur) {
						cur = j;
						cnt++;
					}
				}
			}
			ans = max(ans, cnt);
		} while (next_permutation(all(p)));
		cout << ans << endl;
		return 0;
	}
	
	sort(all(a), cmp);
	
	int cur = -1, cnt = 0;
	for (int i = 0; i < n; i++) {
		for (int j: a[i]) {
			if (j > cur) {
				cur = j;
				cnt++;
			}
		}
	}
	
	cout << cnt << endl;
	
	return 0;
}
