#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>

#pragma optimize("O2, inline, avx2");
using namespace std;
struct st {
    int x, y;
};

bool comp1(st a, st b) {
    if (a.x == b.x) {
        return a.y < b.y;
    }
    return a.x < b.x;
};

bool comp2(st a, st b) {
    if (a.y == b.y) {
        return a.x < b.x;
    }
    return a.y < b.y;
};
vector<int> tree;
vector<int> arr;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = arr[l];
        return;
    }
    int m = l + (r - l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void update(int v, int l, int r, int k, int x) {
    if (r - l == 1) {
        tree[v] = x;
        return;
    }
    int m = l + (r - l) / 2;
    if (k < m) {
        update(2 * v + 1, l, m, k, x);
    } else {
        update(2 * v + 2, m, r, k, x);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = l + (r - l) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

vector<long long> a;
double ans = 0;
int n;
long long k_ish = 0;
vector<long long> b_arr;

vector <int> h;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    mt19937 rnd(100);
    cin >> n;
    vector <vector <int>> arr(n);
    h.resize(n);
    if (n <= 7){
        for (int i = 0; i < n; i++){
            int k;
            cin >> k;
            for (int j = 0; j < k; j++){
                int x;
                cin >> x;
                arr[i].push_back(x);
            }
        }
        iota(h.begin(), h.end(), 0);
    }
    int ans = 0;
    for (int i = 0; i < 50000; i++){
        shuffle(h.begin(), h.end(), rnd);
        vector <int> all;
        for (int j = 0; j < h.size(); j++){
            for (int k = 0; k < arr[h[j]].size(); k++){
                all.push_back(arr[h[j]][k]);
            }
        }
        int num = 0;
        int counter = 0;
        for (int j = 0; j < all.size(); j++){
            if (all[j] > num){
                counter++;
                num = all[j];
            }
        }
        if (counter > ans){
            ans = counter;
        }
        all.clear();
    }
    cout << ans;
    return 0;
}
