#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
using namespace __gnu_pbds;
using namespace std;

template<typename Ty, class Compare = less<Ty>>
        using ordered_set = tree<Ty, null_type, Compare, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ull = unsigned long long;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using vll = vector<ll>;
using vvll = vector<vll>;
using pii = pair<int, int>;

#define mk make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

//#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,popcnt")

/*
4
5
4 9 4 6 8
1
7
2
8 6
1
1
*/

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n; cin >> n;
    vvi a(n);
    for (int i = 0; i < n; ++i)
    {
        int k; cin >> k;
        for (int j = 0; j < k; ++j)
        {
            int x; cin >> x;
            if (!a[i].empty())
            {
                if (a[i].back() < x)
                    a[i].push_back(x);
            }
            else
            {
                a[i].push_back(x);
            }
        }
    }
    auto comp = [&](vi& ai, vi& aj)
    {
        int N = ai.size(), M = aj.size();
        for (int i = 0; i < min(N, M); ++i)
        {
            if (ai[N - i - 1] != aj[M - i - 1])
            {
                return ai[N - i - 1] < aj[M - i - 1];
            }
        }
        return N > M;
    };
    sort(all(a), comp);
    int sum = 0;
    vi ps(n + 1);
    vi mv(n + 1, -1);
    ps[0] = 0;
    int x = 0;
    for (int i = 0; i < n; ++i)
    {
        int mi = 0;
        int l = 0;
        int k = a[i].size();
        int M = k;
        mv[x] = a[i].back();
        for (int j = 0; j <= x; ++j)
        {
            if (ps[j] + k - l > M)
            {
                mi = j;
                M = ps[j] + k - l;
            }
            while (l < k && a[i][l] <= mv[j])
                ++l;
        }
        x = mi + 1;
        mv[mi] = a[i].back();
        ps[x] = M;
    }
    /*
    for (int i = 0; i < n; ++i)
    {
        for (auto e: a[i])
            cerr << e << " ";
        cerr << endl;
    }
     */
    cout << ps[x] << "\n";
    return 0;
}
