#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <cmath>
#include <iomanip>

#define int long long

using namespace std;

vector <vector <int> > kek;

bool comp(vector <int> &a, vector <int> &b)
{
    if (a.back()<b.back()) return 1;
    return 0;
}

void solve()
{
    int n;
    cin>>n;
    vector <vector <int> > albums(n);
    for (int i=0; i<n; i++)
    {
        int k;
        cin>>k;
        int m=0;
        for (int j=0; j<k; j++)
        {
            int o;
            cin>>o;
            if (o>m)
            {
                albums[i].push_back(o);
                m=o;
            }
        }
    }
    sort(albums.begin(),albums.end(),comp);
    vector <int> dp(n,0);
    int maxsize=0;
    for (int i=0; i<n; i++)
    {
        dp[i]=albums[i].size();
        for (int j=0; j<i; j++)
        {
            dp[i]=max(dp[i],dp[j]+(int)albums[i].size()- (upper_bound(albums[i].begin(),albums[i].end(),albums[j].back())-albums[i].begin()));
        }
        maxsize=max(maxsize,dp[i]);
    }
    cout<<maxsize<<"\n";
}

signed main() {
    int t=1;
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    //cin>>t;
    while (t--)
    {
        solve();
    }
}
