#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, vector<ll>>> had(n);

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        had[i].second.resize(k);
        cin >> had[i].second;
        ll maxim = 0;
        for (auto el: had[i].second) {
            maxim = max(maxim, el);
        }
        had[i].first = maxim;
    }
    std::sort(had.begin(), had.end());
    vector<ll> stek_maximov = {0};
    vector<vector<ll>> real_stek = {{}};
    for (auto el: had) {
        int ind_last_maxim = stek_maximov.size() - 2;
        while (stek_maximov.size() > 1) {
            while (stek_maximov[ind_last_maxim] == stek_maximov.back()){
                ind_last_maxim--;
            }
            ll maxos = stek_maximov[ind_last_maxim];
            ll cnt = 0;
            for (int i = ind_last_maxim; i < stek_maximov.size(); i++){
                for (auto d : real_stek[i]){
                    if (d > maxos){
                        maxos = d;
                        cnt++;
                    }
                }
            }
            for (auto d : el.second){
                if (d > maxos){
                    maxos = d;
                    cnt++;
                }
            }
            maxos = stek_maximov[ind_last_maxim];
            ll cnt2 = 0;
            for (auto d : el.second){
                if (d > maxos){
                    maxos = d;
                    cnt2++;
                }
            }
            if (cnt2 > cnt){
                while (stek_maximov.size() - 1 != ind_last_maxim){
                    stek_maximov.pop_back();
                    real_stek.pop_back();
                }
            }
            else{
                break;
            }
        }
        stek_maximov.push_back(el.first);
        real_stek.push_back(el.second);
    }
    ll maxim = 0;
    ll cnt = 0;
    for (auto el: real_stek) {
        for (auto el2: el) {
            if (el2 > maxim) {
                maxim = el2;
                cnt++;
            }
        }
    }
    cout << cnt << "\n";

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

