#include <iostream>
#include <vector>
#include <random>
#define int long long
typedef long long ll;
using namespace std;

mt19937 rnd(time(0));

int dp[200001];

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    vector<pair<int, int>> z; // все треки с принадлежностью к альбому

    for (int i = 0; i < n; i++) {

        int k, prev = -1;
        cin >> k;

        for (int j = 0; j < k; j++) {
            int a;
            cin >> a;
            if (prev < a) {
                z.emplace_back(a, i);
                v[i].push_back(a);
                prev = a;
            }
        }
    }

    sort(z.begin(), z.end());
    int ind = 0;

    for (int i = 1; i <= 200000; i++) {
        dp[i] = max(dp[i], dp[i - 1]);

        while (ind < z.size() && z[ind].first == i) {
            int x = lower_bound(v[z[ind].second].begin(), v[z[ind].second].end(), i) - v[z[ind].second].begin();
            dp[v[z[ind].second].back()] =  max(dp[v[z[ind].second].back()], dp[i] + (ll) v[z[ind].second].size() - x - 1);
            dp[v[z[ind].second].back()] =  max(dp[v[z[ind].second].back()], dp[i - 1] + (ll) v[z[ind].second].size() - x);
            ind++;
        }
    }
    cout << dp[200000];
}

signed main () {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
