#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())
#define pb push_back

using namespace std;

template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }

typedef pair <int, int> pii;

const int N = 1000;
vector <pii> g[N];
int dp[N];

inline void solve () {
    int n; cin >> n;
    vector <vector <int>> a (n);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; ++j) cin >> a[i][j];
    }

    vector <vector <pii>> f (n);
    for (int i = 0; i < n; ++i) {
        f[i] = vector <pii> (sz(a[i]));
        for (int j = sz(a[i]) - 1; ~j; --j) {
            f[i][j] = {0, a[i][j]};
            for (int jj = j + 1; jj < sz(a[i]); ++jj) {
                if (a[i][j] < a[i][jj]) {
                    umax(f[i][j], f[i][jj]);
                    break;
                }
            }
            ++f[i][j].fr;
        }
    }

    vector <array <int, 3>> edge;
    for (int i = 0; i < n; ++i) {
        int lst = -1;
        for (int j = 0; j < sz(a[i]); ++j) {
            if (a[i][j] < lst) break;
            lst = a[i][j];
            auto [w, nxt] = f[i][j];
            g[nxt].pb({a[i][j], w});
        }
    }

    for (int i = N - 1; ~i; --i) {
        for (int ii = N - 1; ii > i; --ii) {
            for (auto [q, w] : g[i]) {
                if (q < ii) umax(dp[q], dp[ii] + w);
            }
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        umax(ans, dp[a[i][0]]);
    }
    cout << ans;
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t = 1; // cin >> t;
    while (t--) solve();
    return 0;
}
