#include <bits/stdc++.h>

#define ll long long

using namespace std;

struct node {
    int mx;
    int siz;
    int indx;
    node(int m1 = 0, int s1 = 1, int i = 0) {
        mx = m1;
        siz = s1;
        indx = i;
    }
};

bool comp(const node& a, const node& b) {
    return a.mx < b.mx;
}

int main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie();
    //cout.tie();
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    vector<node> mas;

    bool flag = false;

    unordered_map<int, node> xchk;

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        vector<int> arr(k);
        for (int j = 0; j < k; j++) {
            cin >> arr[j];
            if (arr[j] > 10) flag = true;
        }

        int mx = 0;
        for (int j = 0; j < k; j++) {
            if (mx < arr[j]) {
                v[i].push_back(arr[j]);
                mx = arr[j];
            }
        }
        if (xchk[mx].siz < arr.size()) {
            xchk[mx] = node(mx, int(v[i].size()), i);
        }
    }

    for (auto u : xchk) {
        mas.push_back(u.second);
    }

    sort(mas.begin(), mas.end(), comp);

    vector<vector<int>> dp(n, vector<int>(2, 0));
    dp[0][0] = 0;
    dp[0][1] = mas[0].siz;


    for (int i = 1; i < n; i++) {
        dp[i][0] = max(dp[i - 1][0], dp[i - 1][1]);
        dp[i][1] = dp[i][0];

        for (int j = 0; j < mas[i].siz; j++) {
            int l = -1, r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (mas[m].mx < v[mas[i].indx][j]) {
                    l = m;
                } else {
                    r = m;
                }
            }
            if (l != -1) dp[i][1] = max(dp[i][1], max(dp[l][1], dp[l][0]) + mas[i].siz - j);
            else dp[i][1] = max(dp[i][1], mas[i].siz - j);
        }
    }
    cout << max(dp[n - 1][0], dp[n - 1][1]);
    return 0;
}

/*
3
4
1 3 5 7
4
2 4 6 8
1
3
*/
