#include <bits/stdc++.h>

using namespace std;

const int C = 200010;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> a(n), inds(C);
    for (int i = 0; i < n; ++i) {
        int k, mx = 0;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            if (x > mx) a[i].push_back(x);
            mx = max(x, mx);
        }
        for (int j = 0; j < a[i].size(); ++j) {
            inds[a[i][j] - 1].push_back(i);
        }
    }
    vector<int> dp(C);
    for (int i = 0; i < C; ++i) {
        if (i != 0) dp[i] = max(dp[i], dp[i - 1]);
        for (int j: inds[i]) {
            int l = -1, r = a[j].size();
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                if (a[j][mid] <= i) l = mid;
                else r = mid;
            }
            dp[a[j].back()] = max(dp[a[j].back()], dp[i] + (int) a[j].size() - r);
        }
    }
    int ans = 0;
    for (int i: dp) ans = max(ans, i);
    cout << ans << endl;
}
