#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#include <stack>
#include <deque>
#include <cstdio>
#include <random>
#include <cmath>
#include <ctime>

using namespace std;
using ll = long long;
using vii = vector<int>;
using ld = long double;
using vvi = vector<vii>;
using vll = vector<ll>;
using vvll = vector<vll>;
using vbb = vector<bool>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vpii = vector<pii>;
using vld = vector<ld>;

void brute(vii& ord, vbb& used, vvi& a, int n, int& ans) {
	if (ord.size() == n) {
		vii res;
		for (auto& num : ord) {
			for (auto& elem : a[num]) {
				res.push_back(elem);
			}
		}
		int mx = 0;
		int tmp = 0;
		for (auto& elem : res) {
			tmp += elem > mx;
			mx = max(elem, mx);
		}
		ans = max(ans, tmp);
		return;
	}
	for (int i = 0; i < n; i++) {
		if (used[i]) {
			continue;
		}
		used[i] = 1;
		ord.push_back(i);
		brute(ord, used, a, n, ans);
		ord.pop_back();
		used[i] = 0;
	}
}

void solve(){
	int n;
	cin >> n;
	vvi a(n);
	bool flag = 1;
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		a[i].resize(k);
		for (auto& elem : a[i]) {
			cin >> elem;
			flag &= elem <= 2;
		}
	}
	int ans = 0;
	if (n <= 7) {
		vbb used(n);
		vii ord;
		brute(ord, used, a, n, ans);
		cout << ans;
		return;
	}
	if (flag) {
		for (auto& elem : a) {
			if (elem[0] == 1) {
				ans++;
				break;
			}
		}
		for (auto& arr : a) {
			bool f = 0;
			for (auto& elem : arr) {
				f |= (elem == 2);
			}
			if (f) {
				ans++;
				break;
			}
		}
		cout << ans;
		return;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	solve();
}