#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define int long long
#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back

struct fw {
    vc <int> t;
    int n;
    fw (int n) : n(n) {
        t.resize(n + 1);
    }
    void upd (int i, int x) {
        for (++i; i <= n; i += i & -i)
            t[i] = max(t[i], x);
    }
    int get (int i) {
        int ret = 0;
        for (++i; i > 0; i -= i & -i)
            ret = max(ret, t[i]);
        return ret;
    }
};

void solve () {
    int n;
    cin >> n;
    vc <vc <int>> v(n);
    vc <int> c;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        int mx = -1;
        for (int j = 0; j < k; ++j) {
            int x; cin >> x;
            if (x > mx) {
                v[i].pb(x);
                mx = x;
            }
        }
        reverse(all(v[i]));
        for (int j : v[i])
            c.pb(j);
    }
    sort(all(c)); c.resize(unique(all(c)) - c.begin());
    for (int i = 0; i < n; ++i) {
        for (int &j : v[i]) {
            j = lower_bound(all(c), j) - c.begin();
        }
    }
    sort(all(v));
    int ans = 0, mx = -1;
    fw dp(sz(c));
    for (int i = 0; i < n; ++i) {
        int ret = sz(v[i]);
        reverse(all(v[i]));
        for (int j = 0; j < sz(v[i]); ++j) {
            ret = max(ret, dp.get(v[i][j] - 1) + sz(v[i]) - j);
        }
        dp.upd(v[i].back(), ret);
    }
    cout << dp.get(sz(c) - 1) << '\n';
}

/*
2
2
2 3
3
1 2 4
 */

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}