#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
const int maxn = 1 << 18;
const int inf = 1e9;
const int mod = 1e9 + 7;

int bp(long long x, int n = mod - 2) {
    long long res = 1;
    while (n) {
        if (n & 1) {
            res *= x;
            res %= mod;
        }
        x *= x;
        x %= mod;
        n >>= 1;
    }
    return res;
}

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

int f[maxn];

int get(int i) {
    int ans = 0;
    while (i >= 0) {
        ans = max(ans, f[i]);
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

void upd(int i, int x) {
    while (i < maxn) {
        f[i] = max(f[i], x);
        i = i | (i + 1);
    }
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<pair<int, vector<int>>> b;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int& j : a[i]) cin >> j;
        vector<int> st;
        int curr = 0;
        for (int x : a[i]) {
            if (curr < x) {
                st.push_back(x);
            }
            curr = max(curr, x);
        }
        b.push_back({ curr, st });
    }
    sort(b.begin(), b.end());
    for (auto [x, v] : b) {
        for (int j = v.size() - 1; j >= 0; --j) {
            int mx = get(v[j] - 1);
            upd(x, mx + v.size() - j);
        }
    }
    cout << get(maxn);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
