#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <vector>

#define sz(a) int((int)a.size())

using namespace std;

struct VEC {
    vector<int> a;
    int a_mx;
};

bool comp(VEC& a, VEC& b) {
    return a.a_mx < b.a_mx;
}

void solve_smart(int n) {
    vector<VEC> vv(n);
    for (int i = 0; i < n; ++i) {
        int l;
        cin >> l;
        int prev = 0;
        for (int j = 0; j < l; ++j) {
            int x;
            cin >> x;
            if (x > prev) {
                vv[i].a.push_back(x);
                prev = x;
            }
        }
//        vv[i].a.resize(l);
//        int mx = 0;
//        for (int &el: vv[i].a) {
//            cin >> el;
//            mx = max(mx, el);
//        }
        vv[i].a_mx = prev;
    }
    sort(vv.begin(), vv.end(), comp);
    int mx = 0, cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int el: vv[i].a) {
            if (el > mx) {
                mx = el;
                cnt++;
            }
        }
    }
    cout << cnt;
}

vector<vector<int>> have;
vector<bool> used;
vector<int> comb;

int ANS = 0;

int CNT_KOL() {
    int mx = 0, ans = 0;
    for (int el : comb) {
        for (int i = 0; i < have[el].size(); ++i) {
            if (have[el][i] > mx) {
                mx = have[el][i];
                ans++;
            }
        }
    }
    return ans;
}

void rec(int n) {
    if (comb.size() == n) {
        ANS = max(ANS, CNT_KOL());
        return;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            comb.push_back(i);
            used[i] = true;
            rec(n);
            used[i] = false;
            comb.pop_back();
        }
    }
}

void solve_stupid(int n) {
    used.resize(n, false);
    have.resize(n);
    for (int i = 0; i < n; ++i) {
        int len;
        cin >> len;
        have[i].resize(len);
        for (int& el : have[i]) {
            cin >> el;
        }
    }
    rec(n);
    cout << ANS;
}

void solve() {
    int n;
    cin >> n;
    if (n <= 7) {
        solve_stupid(n);
        return;
    }
    solve_smart(n);
}

int32_t main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t-->0) {
        solve();
    }
    return 0;
}