#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <string>
#include <climits>
#include <math.h>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define pll pair<ll, ll>
#define mod 1000000007



int main()
{
	ll siz;
	ll max_mam;
	cin >> siz;
	vector<vector<ll>> arr(siz);
	vector<pll> mam(siz, { 0, 0 });
	for (ll i = 0; i < siz; i++)
	{
		ll len; cin >> len;
		for (int j = 0; j < len; j++)
		{
			ll tmp; cin >> tmp;
			if (arr[i].size() == 0 || tmp > *(arr[i].end() - 1)) {
				arr[i].push_back(tmp);
				mam[i].first = max(mam[i].first, tmp);
			}
		}
		mam[i].second = i;
		max_mam = max(max_mam, mam[i].first);
	}

	vector<ll> out(max_mam + 1, 0);
	for (int i = 0; i < siz; i++)
	{
		ll tmp_step = 0;
		ll tmp_out = 0;
		for (ll j = 0; j < arr[i].size(); j++)
		{
			if (arr[i][j] > tmp_step) {
				tmp_step = arr[i][j];
				tmp_out++;
			}
		}
		out[mam[i].first] = max(tmp_out, out[mam[i].first]);
	}

	sort(mam.begin(), mam.end());
	auto it = mam.begin();
	for (ll i = 0; i < max_mam + 1; i++)
	{
		if (i != 0 && out[i] <= out[i - 1]) { continue; }
		pair<ll, ll> t = { i, siz + 1 };
		it = upper_bound(it, mam.end(), t);
		if (it == mam.end()) { break; }
		for (auto k = it; k < mam.end(); k++) {
			int j = (*k).second;
			auto it = upper_bound(arr[j].begin(), arr[j].end(), i) - arr[j].begin();
			if (it >= arr[j].size()) { continue; }
			ll tmp = arr[j].size() - it;
			out[*(arr[j].end() - 1)] = max(out[*(arr[j].end() - 1)], tmp + out[i]);
		}
	}
	ll fin = 0;
	for (int i = 0; i < max_mam + 1; i++)
	{
		fin = max(fin, out[i]);
	}

	cout << fin << endl;
}







