#include <bits/stdc++.h>

#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> albums(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int tmp;
            cin >> tmp;
            if (albums[i].empty() || tmp > albums[i].back())
                albums[i].push_back(tmp);
        }
    }
    sort(albums.begin(), albums.end(), [&](const vector<int> &a, const vector<int> &b) {
        return a.back() < b.back();
    });
    map<int, int> mp;
    vector<int> dp(n);
    for (int i = 0; i < n; ++i) {
        dp[i] = albums[i].size();
        int curmx = 0;
        auto it = mp.begin();
        for (int j = 0; j < albums[i].size(); ++j) {
            int el = albums[i][j];
            while (it != mp.end() && it->first < el) {
                curmx = max(curmx, it->second);
                it = next(it);
            }
            dp[i] = max(dp[i], curmx + albums[i].size() - j);
        }
        mp[albums[i].back()] = max(mp[albums[i].back()], dp[i]);
    }
    cout << *max_element(dp.begin(), dp.end());
}