#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define dbg(x) cerr << #x << " : " << x << '\n';

using namespace std;
using ll = ::int64_t;
const int A = 200'100;
struct FT {
    vector<ll> t;
    FT(int n) : t(n) {}
    void update(int p, int x) {
        for (; p < sz(t); p |= p + 1)  {
            if (x > t[p]) t[p] = x;
        }
    }
    ll get(int p) {
        ll res = 0;
        for (; p > 0; p &= p - 1) res = max(res, t[p - 1]);
        return res;
    }
};
void solve() {
    int n;
    cin >> n;
    vector<int> a[n];
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        vector<int> tmp(k);
        for (int & el : tmp) cin >> el;
        for (int el : tmp) {
            if (a[i].empty() || a[i].back() < el) a[i].emplace_back(el);
        }
    }
    sort(a, a + n, [](auto & fst, auto & snd) {
        return fst.back() < snd.back();
    });
    FT ft(A);
    for (auto & b : a) {
        for (int i = 0; i < sz(b); ++i) {
            int x = b[i];
            int res = sz(b) - i + ft.get(x);
            ft.update(b.back(), res);
        }
    }
    cout << ft.get(A) << '\n';
}

int main() {
    int tt = 1;
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
    cin >> tt;
#else
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << fixed << setprecision(27);
#endif
    while (tt--) solve();
    return 0;
}