#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

struct Album {
	vector<int> a, good_els;
	int MaxEl;
	int get(int x) {
		int ind = upper_bound(good_els.begin(), good_els.end(), x) - good_els.begin();
		return good_els.size() - ind;
	}
};

bool cmp(Album a, Album b) {
	return a.MaxEl < b.MaxEl;
}

int n, k;

vector<Album> vc, answ;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	std::ios::sync_with_stdio(false);
	cin.tie(0);
#endif
	cin >> n;
	for (int I = 0; I < n; I++) {
		Album a;
		int k;
		cin >> k;
		int MX = 0;
		for (int i = 0; i < k; i++) {
			int v;
			cin >> v;
			a.a.push_back(v);
			if (v > MX) {
				MX = v;
				a.good_els.push_back(v);
			}
		}
		a.MaxEl = MX;
		vc.push_back(a);
	}
	sort(vc.begin(), vc.end(), cmp);
	for (auto u : vc) {
		while (true) {
			if (answ.empty()) {
				answ.push_back(u);
				break;
			}
			int answ_together = 0;
			if (answ.size() == 1) {
				answ_together = answ[0].good_els.size();
			}
			else {
				int mx = answ[answ.size() - 2].MaxEl;
				answ_together = answ[answ.size() - 1].get(mx);
			}
			int mx = answ[answ.size() - 1].MaxEl;
			answ_together += u.get(mx);
			if (answ.size() == 1) {
				mx = 0;
			}
			else {
				mx = answ[answ.size() - 2].MaxEl;
			}
			int answ_alone = u.get(mx);
			if (answ_alone > answ_together) {
				answ.pop_back();
			}
			else {
				break;
			}
		}
		answ.push_back(u);
	}
	int MX = 0, ANSW = 0;
	for (auto& v : answ) {
		for (auto u : v.a) {
			if (u > MX) {
				ANSW++;
				MX = u;
			}
		}
	}
	cout << ANSW;
}
