#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

ll n;

long long smart(vector<vector<ll>> all) {
    deque<vector<ll>> now;
    for (ll i = 0; i < n; i++) {
        ll gl = -1, index = -1;
        for (ll nw_pos = 0; nw_pos <= i; nw_pos++) {
            ll mx = -INF, val = 0;
            auto relax = [&] (ll l, ll r) {
                for (ll ind = l; ind < r; ind++) {
                    for (ll x: now[ind]) {
                        if (x > mx) val++;
                        mx = max(mx, x);
                    }
                }
            };
            relax(0, nw_pos);
            for (ll x : all[i]) {
                if (x > mx) val++;
                mx = max(mx, x);
            }
            relax(nw_pos, i);
            if (val > gl) index = nw_pos;
            gl = max(gl, val);
        }
        deque<vector<ll>> buf;
        assert(index >= 0);
        while ((ll) now.size() > index) {
            assert(!now.empty());
            buf.push_back(now.back());
            now.pop_back();
        }
        now.push_back(all[i]);
        while (!buf.empty()) {
            now.push_back(buf.back());
            buf.pop_back();
        }
    }
    ll mx = -INF, val = 0;
    for (vector<ll> &cur : now) {
        for (ll x : cur) {
            if (x > mx) val++;
            mx = max(mx, x);
        }
    }
    return val;
}

vector<vector<ll>> answer;

long long stup(vector<vector<ll>> all) {
    sort(all.begin(), all.end());
    ll gl = 0;
    do {
        ll mx = -INF, ans = 0;
        for (vector<ll> &cur : all) {
            for (ll x : cur) {
                if (x > mx) ans++;
                mx = max(mx, x);
            }
        }
        if (ans > gl) answer = all;
        gl = max(gl, ans);
    } while (next_permutation(all.begin(), all.end()));
    return gl;
}

mt19937 gen(572);

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
//    while (true) {
//        n = gen() % 7 + 1;
//        vector<vector<ll>> all;
//        map<vector<ll>, ll> ind;
//        ll was = 0;
//        for (ll i = 0; i < n; i++) {
//            ll k = gen() % 10 + 1;
//            while (was + k > 100) k = gen() % 10 + 1;
//            was += k;
//            vector<ll> cur;
//            ll mx = -INF, val = 0;
//            for (ll j = 0; j < k; j++) {
//                ll x = gen() % ((ll) 10) + 1;
//                cur.push_back(x);
//                if (x > mx) val++;
//                mx = max(mx, x);
//            }
//            all.push_back(cur);
//            ind[cur] = i + 1;
//        }
//        if (smart(all) != stup(all)) {
//            cout << n << endl;
//            for (vector<ll> &cur : all) {
//                cout << cur.size() << endl;
//                for (ll x : cur) cout << x << " ";
//                cout << endl;
//            }
//            cout << "smart: " << smart(all) << endl;
//            cout << "stupid: " << stup(all) << endl;
//            for (vector<ll> &cur : answer) {
//                for (ll x : cur) cout << x << " ";
//                cout << endl;
//            }
//            cout << endl;
//            return 0;
//        }
//    }
    ll n;
    cin >> n;
    vector<vector<ll>> all;
    map<vector<ll>, ll> ind;
    for (ll i = 0; i < n; i++) {
        ll k;
        cin >> k;
        vector<ll> cur;
        for (ll j = 0; j < k; j++) {
            ll x;
            cin >> x;
            cur.push_back(x);
        }
        all.push_back(cur);
        ind[cur] = i + 1;
    }
    sort(all.begin(), all.end(), [&] (vector<ll> &fir, vector<ll> &sec) {
        ll mx1 = *max_element(fir.begin(), fir.end()), mx2 = *max_element(sec.begin(), sec.end());
        if (mx1 != mx2) return mx1 < mx2;
        ll val1 = 0, val2 = 0;
        {
            ll mx = -INF;
            for (ll x : fir) {
                if (x > mx) val1++;
                mx = max(mx, x);
            }
            for (ll x : sec) {
                if (x > mx) val1++;
                mx = max(mx, x);
            }
        }
        {
            ll mx = -INF;
            for (ll x : sec) {
                if (x > mx) val2++;
                mx = max(mx, x);
            }
            for (ll x : fir) {
                if (x > mx) val2++;
                mx = max(mx, x);
            }
        }
        //   cout << "d: " << ind[fir] << " " << ind[sec] << endl;
        //   cout << val1 << " " << val2 << endl;
        return (val1 > val2);
    });
//    for (vector<ll> &cur : all) {
//        for (ll x : cur) cout << x << " ";
//    }
//    cout << endl;
    ll mx = -INF, ans = 0;
    for (vector<ll> &cur : all) {
        for (ll x : cur) {
            if (x > mx) ans++;
            mx = max(mx, x);
        }
    }
    cout << ans << endl;
    return 0;
}
