#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define sz(a) (int)a.size()
#define vc vector
#define pb push_back
#define ff first
#define ss second
#define all(a) (a).begin(), (a).end()

const int INFi = 1e9;
const ll INFl = 1e18;

template<class T>
bool inmin(T &x, T y) {
    if (y < x) {
        x = y;
        return true;
    }
    return false;
}

template<class T>
bool inmax(T &x, T y) {
    if (y > x) {
        x = y;
        return true;
    }
    return false;
}

mt19937 rnd(time(0));

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/Kek/read.txt", "r", stdin);
#endif
    //cout << fixed << setprecision(10);
    int tc = 1;
    //cin >> tc;
    forn(i, tc) solve();
    return 0;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    forn(i, n) {
        int k;
        cin >> k;
        int mx = -INFi;
        forn(j, k) {
            int v;
            cin >> v;
            if (v > mx) {
                a[i].pb(v);
                mx = v;
            }
        }
    }
    vector<int> ord(n);
    iota(all(ord), 0);
    sort(all(ord), [&](const int &i, const int &j) {
        return a[i].back() < a[j].back();
    });
    vector<int> vals;
    for (int x : ord) {
        for (int v : a[x]) {
            if (vals.empty() || v > vals.back())
                vals.pb(v);
        }
    }
    cout << sz(vals) << '\n';
}