#include <iostream>
#include<iomanip>
#include <numeric>
#include<cmath>
#include<vector>
#include<map>
#include <queue>
#include<initializer_list>
typedef long long ll;
using namespace std;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;

const ll MAXN = 200010;

ll dp[MAXN];
int t[4 * MAXN];

int get(int v, int tl, int tr, int l, int r) {
	if (l > r)return 0;
	if (tl == l && tr == r) {
		return t[v];
	}
	int mid = (tl + tr) / 2;
	return max(get(2 * v, tl, mid, l, min(mid, r)),
		get(2 * v + 1, mid + 1, tr, max(mid + 1, l), r));
}

void update(int v, int tl, int tr, int pos, int value) {
	if (tl == pos && tr == pos) { t[v] = value; return; }
	int mid = (tl + tr) / 2;
	int ret = t[v];
	if (pos <= mid)update(2 * v, tl, mid, pos, value);
	else  update(2 * v + 1, mid + 1, tr, pos, value);
	t[v] = max(t[2 * v], t[2 * v + 1]);
}


void solve2() {
	ll t; cin >> t;
	vector<vector<ll>> gipermass;
	while (t--) {
		ll n; cin >> n;
		vector<ll> mass;
		ll foo = 0;
		for (int i = 0; i < n; i++) {
			cin >> foo;
			if (mass.size() != 0) { if (mass[mass.size() - 1] < foo)mass.push_back(foo); }
			else if (mass.size() == 0) mass.push_back(foo);
		}
		ll mm = 0;
		for (int i = 0; i < mass.size(); i++) {
			mm = max(mass[i], mm);
		}
		mass.push_back(mm);
		gipermass.push_back(mass);
	}
	ll iter_gip = 0;
	sort(gipermass.begin(), gipermass.end(), [](vector<ll>& a, vector<ll>& b) {return a[a.size() - 1] < b[b.size() - 1]; });

	for (int i = 0; i < MAXN; i++) {
		if (iter_gip == gipermass.size())break;
		if (gipermass[iter_gip][gipermass[iter_gip].size() - 1] == i) {
			ll was_max = 0;
			ll coloc = 0;
			for (ll j = 0; j < gipermass[iter_gip].size() - 1; j++) {
				ll maxprev = get(1, 0, MAXN, 0, gipermass[iter_gip][j]-1);
				if (maxprev > coloc) coloc = maxprev; coloc++;
			}
			update(1, 0, MAXN, gipermass[iter_gip][gipermass[iter_gip].size() - 1], coloc);
			i--, iter_gip++;
		}
	}
	cout << get(1, 0, MAXN, 0, MAXN);
}


int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0); solve2();
}