#include <bits/stdc++.h>

#define int long long
//g++ -std=c++17 -fsanitize=address -DLOCAL -D_GLIBCXX_DEBUG D.cpp -o D
using namespace std;

bool cmp(vector<int> f, vector<int> s) {
    sort(f.rbegin(), f.rend());
    sort(s.rbegin(), s.rend());
    for (int i = 0; i < (int)min(f.size(), s.size()); ++i) {
        if (f[i] != s[i]) return f[i] < s[i];
    }
    return f.size() < s.size();
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int x;
         cin >> x;
         a[i].resize(x);
         for (auto &j : a[i]) cin >> j;
    }
    sort(a.begin(), a.end(), cmp);
    int ans = 0, mx = 0;
    for (auto i : a) {
        for (auto j : i) {
            if (j > mx) ans++, mx = j;
        }
    }
    cout << ans << '\n';
}
int32_t main() {
    #ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif
    solve();
    return 0;
}
 