#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define len(a) (int)a.size()
#define endl '\n'
#define debug(a) cout << #a << ": " << a << endl;

const int mod = 1e9 + 7;
const int mxl = 24;

// author: @cot-in

void fin() {
#ifdef cot_in
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), fin();
    int n;
    cin >> n;
    vector<bool> used(2, false);
    bool first_one = false;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int cur;
            cin >> cur;
            if (j == 0 && cur == 1)
                first_one = true;
            used[cur - 1] = true;
        }
    }
    cout << used[1] + (first_one && used[0]);
    return 0;
}