#include <bits/stdc++.h>


#define newline cout << '\n'


using namespace std;
typedef long long ll;
typedef long double ld;
const ll inf = 1e18;
mt19937 rnd(time(0));
	
vector<string> p;

void perms(string cur, vector<bool> used, int n) {
	if ((int)cur.length() == n) {
		p.push_back(cur);
		return;
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			cur += to_string(i);
			used[i] = true;
			perms(cur, used, n);
			used[i] = false;
			cur.pop_back();
		}
	}
}

int calc(vector<int> f) {
	int prev_max = -1, res = 0;
	for (int i : f) {
		if (i > prev_max) {
			++res;
		}
		prev_max = max(prev_max, i);
	}
	return res;
}

vector<int> merge(vector<int> a, vector<int> b) {
	vector<int> res((int)a.size() + (int)b.size());
	int c = 0;
	for (int x : a) {
		res[c++] = x;
	}
	for (int x : b) {
		res[c++] = x;
	}
	return res;
}

bool cmp(vector<int> a, vector<int> b) {
	return calc(merge(a, b)) >= calc(merge(b, a));
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif


	int n, k, x, u, ans = -1;
	cin >> n;

	vector<vector<int>> a(n);

	for (int i = 0; i < n; ++i) {
		cin >> x;
		while (x--) {
			cin >> u;
			a[i].push_back(u);
		}
	}
	sort(a.begin(), a.end(), cmp);

	vector<int> f;
	for (auto i : a) {
		for (int el : i) {
			f.push_back(el);
		}
	}

	cout << calc(f) << '\n';
	

	return 0;
}
