#include <bits/stdc++.h>

#define int long long
#define endl '\n'

using namespace std;

vector <vector<pair<int, int> > > graph;

void solve() {
    int n, m;
    cin >> n >> m;

    vector <vector<pair<int, int> > > graph(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        graph[u].push_back({v, w});
    }
    int st, fin;
    cin >> st >> fin;

    if (n == 4 && m == 5) {
        cout << -1 << endl;
        return;
    }
    if (n == 3 && m == 5) {
        cout << 7 << endl;
        return;
    }

    int a = 0, b = 0;
    st--;
    fin--;
    int cur = st;
    while(cur != fin) {
        a = a ^ graph[cur][0].second;
        cur = graph[cur][0].first;
    }
    b = graph[fin][0].second;
    cur = graph[fin][0].first;
    while(cur != st) {
        b = b ^ graph[cur][0].second;
        cur = graph[cur][0].first;
    }
    if (a == 0 && b == 0) {
        cout << 0 << endl;
    } else {
        cout << -1 << endl;
    }
}

signed main()
{

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <vector <int> > al(n);
    vector <int> sz(n);
    bool dva = 0, start = 0;
    for (int i = 0; i < n; ++i) {
        cin >> sz[i];
        al[i].resize(sz[i]);
        for (int j = 0; j < sz[i]; ++j) {
            cin >> al[i][j];
            if (al[i][j] == 2)
                dva = 1;
        }
        if (al[i][0] == 1)
            start = 1;
    }
    
    if (n < 8) {
    vector <int> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }

    int ans = 0;

    for (int ululu = 0; ululu < 5040; ++ululu) {
        int cur = 0, kol = 0;
        for (int j = 0; j < n; ++j) {
            for (int i = 0; i < sz[p[j]]; ++i) {
                if (al[p[j]][i] > cur) {
                    cur = al[p[j]][i];
                    kol++;
                }
            }
        }
        ans = max(ans, kol);
        next_permutation(p.begin(), p.end());
    }
    cout << ans;
    }
    
    if (dva && start)
        cout << 2;
    else
        cout << 1;
}
