#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const int N = 2e5 + 10;
vec<vec<int>> a;

bool cmp(const pii &A, const pii &B)
{
    return A.s < B.s;
}

void solve()
{
    int n;
    cin >> n;
    a.resize(n);
    vec<pii> mx(n);
    for (int i = 0; i < n; i++)
    {
        mx[i].f = i;
        int k;
        cin >> k;
        for (int j = 0; j < k; j++)
        {
            int x;
            cin >> x;
            mx[i].s = max(mx[i].s, x);
            a[i].pb(x);
        }
    }
    sort(all(mx), cmp);
    int last = 0;
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        int j = i;
        while (j < n && mx[i].s == mx[j].s) j++;
        int max_score = 0;
        for (int k = i; k < j; k++)
        {
            int cur = 0;
            int idx = mx[k].f;
            int cur_last = last;
            for (int it = 0; it < sz(a[idx]); it++)
            {
                if (a[idx][it] > cur_last)
                {
                    cur++;
                    cur_last = a[idx][it];
                }
            }
            max_score = max(max_score, cur);
        }
        ans += max_score;
        last = mx[i].s;
        i = j - 1;
    }
    cout << ans;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}
