#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
random_device rd;
mt19937 rnd(rd());

struct item {
    ll mn, mx, ind;
    item() : mn(1e18), mx(-1e18), ind(-1) {}
    item(ll mn, ll mx, ll ind) : mn(mn), mx(mx), ind(ind) {}
    bool operator < (item&n) {
        if(mx == n.mx)
            return mn > n.mn;
        return mx < n.mx;
    }
};

void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> a(n);
    vector<item> info;
    for (int i = 0; i < n; i++) {
        ll k;
        cin >> k;
        a[i].resize(k);
        ll mx = 0, mn = 1e18;
        for (auto &j: a[i]) {
            cin >> j, mx = max(mx, j), mn = min(mn, j);
        }
        info.emplace_back(mn, mx, i);
    }
    sort(all(info));

    ll ans = 0, best = 0;
    for(auto &i : info) {
        for(auto &j : a[i.ind]) {
            if(best < j) {
                best = j, ans++;
            }
        }
    }
    cout << ans;

}

int main() {
    cin.tie(0), cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}
