#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;



void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> tracks(n + 1);
    bool f3 = false;
    for (ll i = 1; i <= n; ++i) {
        ll q;
        cin >> q;
        while (q--) {
            ll x;
            cin >> x;
            tracks[i].push_back(x);
            if (x >= 3) {
                f3 = true;
            }
        }
    }

    if (n <= 7) {
        vector<ll> p;
        ll ans = 0;
        for (ll i = 1; i <= n; ++i) {
            p.push_back(i);
        }

        do {
            ll now = 0;
            ll mx = 0;
            for (auto x : p) {
                for (auto y : tracks[x]) {
                    if (y > mx) {
                        mx = y;
                        ++now;
                    }
                }
            }

            ans = max(ans, now);
        } while (next_permutation(p.begin(), p.end()));

        cout << ans << "\n";
        exit(0);
    }
    if (!f3) {
        set<ll> s1;
        set<ll> s2;
        
        for (ll i = 1; i <= n; ++i) {
            bool f1 = false;
            for (auto x : tracks[i]) {
                if (x == 1) {
                    f1 = true;
                    s1.insert(i);
                }
                
                if (x == 2) {
                    if (f1) {
                        cout << 2 << "\n";
                        exit(0);
                    }
                    s2.insert(i);
                }
            }
        }
        
        for (auto x : s1) {
            for (auto y : s2) {
                if (x != y) {
                    cout << 2 << "\n";
                    exit(0);
                }
            }
        }
        cout << 1 << "\n";
        exit(0);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
