#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <chrono>
#define int long long
#define all(a) a.begin(), a.end()
using namespace std;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
const int inf = 1e18;
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, k; cin >> n >> k;
	int	N = 0;
	vector<vector<int>> a(n);
	for (int i = 0; i < n; i++) {
		int  x; cin >> x;
		N += x;
		a[i].resize(x);
		for (int j = 0; j < x; j++) {
			cin >> a[i][j];
		}
	}
	auto count = [](const vector<int>& a, const vector<int>& b) {
		vector<int> dp((int)a.size() + (int)b.size() + 1, inf);
		dp[0] = -inf;
		int it = -inf;
		for (int j = 1; j <= (int)a.size(); j++) {
			int val = a[j - 1];
			int pos = upper_bound(all(dp), val) - dp.begin();
			if (dp[pos - 1] < val && val < dp[pos]) {
				dp[pos] = val;
				it = max(it, pos);
			}
		}
		for (int j = 1; j <= (int)b.size(); j++) {
			int val = b[j - 1];
			int pos = upper_bound(all(dp), val) - dp.begin();
			if (dp[pos - 1] < val && val < dp[pos]) {
				dp[pos] = val;
				it = max(it, pos);
			}
		}
		return it;
	};
	auto cmp = [&](const vector<int>& lhs, const vector<int>& rhs) {
		return count(lhs, rhs) < count(rhs, lhs);
	};
	sort(all(a), cmp);
	vector<int> dp(N + 1, inf);
	dp[0] = -inf;
	int res = -1;
	for (int i = 0; i < n; i++) {
		for (int& val : a[i]) {
			int pos = upper_bound(all(dp), val) - dp.begin();
			if (dp[pos - 1] < val && val < dp[pos]) {
				dp[pos] = val;
				res = max(res, pos);
			}
		}
	}
	cout << res;
}