#include <bits/stdc++.h>

#define int long long
#define double long double

using namespace std;

bool operator-(vector<int> a, vector<int> b) {
    sort(a.begin(), a.end()), sort(b.begin(), b.end());
    while (!a.empty() && !b.empty()) {
        if (a.back() < b.back()) {
            return true;
        } else if (a.back() > b.back()) {
            return false;
        } else {
            a.pop_back(), b.pop_back();
        }
    }
    if (a.empty()) {
        return true;
    }
    return false;
}

bool cmp(vector<int> &a, vector<int> &b) {
    int i, cnt_a = 0, cnt_b = 0, ma_a = 0, ma_b = 0;
    for (i = 0; i < a.size(); i++) {
        if (a[i] > ma_a) {
            cnt_a++;
        }
        ma_a = max(ma_a, a[i]);
    }
    for (i = 0; i < b.size(); i++) {
        if (b[i] > ma_a) {
            cnt_a++;
        }
        ma_a = max(ma_a, b[i]);
    }
    for (i = 0; i < b.size(); i++) {
        if (b[i] > ma_b) {
            cnt_b++;
        }
        ma_b = max(ma_b, b[i]);
    }
    for (i = 0; i < a.size(); i++) {
        if (a[i] > ma_b) {
            cnt_b++;
        }
        ma_b = max(ma_b, a[i]);
    }
    return cnt_a > cnt_b || (cnt_a == cnt_b && a - b);
}

signed main() {
    //ifstream cin("text.in");
    //ofstream cout("text.out");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    mt19937_64 gen(time(nullptr));
    int n, i, k, j;
    cin >> n;
    vector<vector<int>> arr(n);
    for (i = 0; i < n; i++) {
        cin >> k;
        vector<int> now(k);
        for (j = 0; j < k; j++) {
            cin >> now[j];
        }
        arr[i] = now;
    }
    for (i = 0; i < n; i++) {
        for (j = 0; j < n - 1; j++) {
            if (!cmp(arr[j], arr[j + 1])) {
                swap(arr[j], arr[j + 1]);
            }
        }
    }
    int ma = 0, cnt = 0;
    for (i = 0; i < n; i++) {
        for (int u : arr[i]) {
            if (u > ma) {
                ma = u, cnt++;
            }
        }
    }
    cout << cnt;
    return 0;
}
