#include <bits/stdc++.h>
using namespace std;

#define int long long

int t[1000100], u[1000100];
int maxa = 0, st[200100], maxx[200100], dp[200100], inf = 1e18;
vector<vector<int> > v(200100);
vector<vector<pair<int, int> > > v1(200100);

void push(int v, int tl, int tr) {
    if (u[v] == -1) {
        return;
    }
    t[v] = u[v];
    if (tl != tr) {
        u[2 * v + 1] = u[v];
        u[2 * v + 2] = u[v];
    }
    u[v] = -1;
}

int get(int v, int l, int r, int tl, int tr) {
    if (tl > r || tr < l) {
        return 0;
    }
    push(v, tl, tr);
    if (tl >= l && tr <= r) {
        return t[v];
    }

    int tm = (tl + tr) / 2;
    return max(get(2 * v + 1, l, r, tl, tm), get(2 * v + 2, l, r, tm + 1, tr));
}

void add(int v, int l, int r, int k, int tl, int tr) {
    if (tl > r ||tr < l) {
        return;
    }
    push(v, tl, tr);
    if (tl >= l && tr <= r) {
        u[v] = k;
        return;
    }

    int tm = (tl + tr) / 2;
    add(2 * v + 1, l, r, k, tl, tm);
    add(2 * v + 2, l, r, k, tm + 1, tr);
    push(2 * v + 1, tl, tm);
    push(2 * v + 2, tm + 1, tr);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

void add1(int v, int l, int k, int tl, int tr) {
    if (tl > l || tr < l) {
        return;
    }
    push(v, tl, tr);
    if (tl == tr) {
        t[v] = max(t[v], k);
        return;
    }

    int tm = (tl + tr) / 2;
    add1(2 * v + 1, l, k, tl, tm);
    add1(2 * v + 2, l, k, tm + 1, tr);
    push(2 * v + 1, tl, tm);
    push(2 * v + 2, tm + 1, tr);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

void countt(int k) {
    for (int i = 0; i < v[k].size(); i++) {
        maxx[k] = max(maxx[k], v[k][i]);
    }
    add(0, 0, maxx[k] + 1, 0, 0, maxa);
    for (int i = (int)v[k].size() - 1; i >= 0; i--) {
        int m = max(0ll, get(0, v[k][i] + 1, maxx[k] + 1, 0, maxa));
//        for (int j = maxx[k]; j > v[k][i]; j--) {
//            m = max(m, dp[j]);
//        }
        add1(0, v[k][i], m + 1, 0, maxa);
        add(0, 0, v[k][i] - 1, 0, 0, maxa);
//        dp[v[k][i]] = max(dp[v[k][i]], m + 1);
    }
//    vector<pair<int, int> > v1;
    set<int> s;
    for (int i = 0; i < v[k].size(); i++) {
        s.insert(v[k][i]);
    }
    for (auto j : s) {
        v1[k].push_back({j, get(0, j, j, 0, maxa)});
    }
    for (int i = (int)v1[k].size() - 2; i >= 0; i--) {
        v1[k][i].second = max(v1[k][i].second, v1[k][i + 1].second);
    }
//    cout << "k = " << k << '\n';
//    for (auto j : v1[k]) {
//        cout << j.first << ' ' << j.second << '\n';
//    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, k;

    cin >> n;
    for (int i = 0; i < 1e6; i++) {
        u[i] = -1;
    }
    for (int i = 0; i < n; i++) {
        cin >> k;
        while (k--) {
            int a;
            cin >> a;
            maxa = max(maxa, a);
            v[i].push_back(a);
        }
//        countt(i);
        st[i] = 0;
    }
    for (int i = 0; i < n; i++) {
        countt(i);
    }
    maxa++;

    vector<pair<int, int> > b;
    for (int i = 0; i < n; i++) {
        b.push_back({maxx[i], i});
    }
    sort(b.begin(), b.end());
    add(0, 0, maxa, -inf, 0, maxa);
    add1(0, 0, 0, 0, maxa);
    for (auto h : b) {
        int i = h.second, mx = 0;
        for (int j = 0; j < v1[i].size(); j++) {
            int m = get(0, 0, v1[i][j].first - 1, 0, maxa);
            mx = max(mx, m + v1[i][j].second);
        }
        add1(0, maxx[i], mx, 0, maxa);
    }

    cout << get(0, 0, maxa, 0, maxa) << '\n';

    return 0;
}
