#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <stack>
#include <queue>
#include <set>
#include <deque>
#include <chrono>
#include <random>
#include <iomanip>
#include <assert.h>
#include <numeric>
#include <bitset>
#include <string>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
using ll = long long;
using ld = long double;
#define int long long
ll inf = 1e9 + 7;
ll inf_ = 1e18 + 4;
const int mod = 1e9 + 7;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

/*
vector<vector<int>> g;
vector<pair<int, int>> c;
*/
vector<vector<pair<int, int>>> g;
vector<bool> used;
vector<int> ts;

void dfs(int v) {
    used[v] = 1;
    for (auto u: g[v]) {
        if (!used[u.first]) {
            dfs(u.first);
        }
    }
    ts.push_back(v);
}

vector<int> dp;

int rec(int v) {
    used[v] = 1;
    int max_ = dp[v];
    for (auto u: g[v]) {
        if (!used[u.first]) {
            max_ = max(max_, rec(u.first));
        }
    }
    return max_;
}

bool comp(vector<int> &a, vector<int> &b) { return a.back() < b.back(); }

signed main() {
    //freopen("collider.in", "r", stdin);
    //freopen("collider.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    int maxA = 0;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        int max_ = -1;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            maxA = max(maxA, x);
            if (max_ < x) a[i].push_back(x);
            max_ = max(max_, x);
        }
    }
    if (n <= 7 && 0) {
        sort(a.begin(), a.end());
        int ans = 0;
        do {
            int d = 0;
            int max_ = -1;
            for (auto s: a) {
                for (auto i: s) {
                    if (max_ < i) d++;
                    max_ = max(i, max_);
                }
            }
            ans = max(ans, d);
        } while (next_permutation(a.begin(), a.end()));
        cout << ans;
        return 0;
    }
    if (maxA <= 2 && 0) {
        bool f = 0, r = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][0] == 1) f = 1;
            for (auto j: a[i]) {
                if (j == 2) r = 1;
            }
        }
        if (f && r) cout << 2;
        else cout << 1;
        return 0;
    }
    if (n * n <= 1e8 && 0) {
        g.resize(n);
        vector<vector<pair<int, int>>> in(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (i == j) continue;
                int w = upper_bound(a[j].begin(), a[j].end(), a[i].back()) - a[j].begin();
                if (a[j].size() - w == 0) continue;
                g[i].push_back({j, a[j].size() - w});
                in[j].push_back({i, a[j].size() - w});
            }
        }
        used.resize(n);
        dp.resize(n);
        for (int i = 0; i < n; i++) {
            if (!used[i]) dfs(i);
            dp[i] = a[i].size();
        }
        reverse(ts.begin(), ts.end());
        for (auto i: ts) {
            for (auto j: in[i]) {
                dp[i] = max(dp[i], dp[j.first] + j.second);
            }
        }
        used.assign(n, 0);
        int ans = 0;
        for (auto i: ts) {
            if (!used[i]) {
                ans = max(ans, rec(i));
            }
        }
        cout << ans;
        return 0;
    }
    sort(a.begin(), a.end(), comp);
    for (int i = 0; i < n; i++) {
        
    }
    return 0;
}