#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1337, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> a[n];
    vector<int> t;
    for (int i = 0, k; i < n; ++i) {
        cin >> k;
        a[i].resize(k);
        for (auto &j : a[i]) {
            cin >> j;
            t.push_back(j);
        }
    }
    vector<int> nearest[n];
    for (int i = 0; i < n; ++i) {
        nearest[i].resize(a[i].size(), a[i].size() + 1);
        vector<int> d;
        for (int j = a[i].size() - 1; j >= 0; --j) {
            while (!d.empty() && a[i][d.back()] <= a[i][j]) d.pop_back();
            if (!d.empty()) {
                a[i][j] = d.back();
            }
            d.push_back(j);
        }
    }
    int cur = 0;
    int ans = 0;
    vector<int> usd(n, false);
    for (int s = 0; s < n; ++s) {
        int cmn = 1e9, len = 0, ind = -1;
        for (int i = 0; i < n; ++i) {
            if (usd[i]) continue;
            int nw = cur;
            int nlen = 0;
            for (int j = 0; j < a[i].size(); ++j) {
                if (a[i][j] > nw) {
                    nw = a[i][j];
                    ++nlen;
                }
            }
            if (nw < cmn || nw == cmn && nlen > len) {
                len = nlen, cmn = nw;
                ind = i;
            }
        }
        if (ind == -1) break;
        ans += len;
        usd[ind] = true;
        cur = cmn;
    }
    cout << ans;
}