#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1337, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

int get(vector<int> a, vector<int> b) {
    int cur = 0, ans = 0;
    for (auto &el : a) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    for (auto &el : b) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    return ans;
}

int get1(vector<int> a, vector<int> b) {
    int cur = 0, ans = 0;
    for (auto &el : a) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    for (auto &el : b) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    return cur;
}

int get2(vector<int> a, vector<int> b) {
    return min(a[0], a[1]);
}

void solve() {
    int n;
    cin >> n;
    vector<int> a[n];
    int mxall = 0;
    int mxsz = 0;
    for (int i = 0, k; i < n; ++i) {
        cin >> k;
        mxsz = max(mxsz, k);
        a[i].resize(k);
        for (auto &j : a[i]) {
            cin >> j;
            mxall = max(mxall, j);
        }
    }
    if (mxall <= 2) {
        int cnt1 = 0, cnt2 = 0;
        for (int i = 0; i < n; ++i) {
            int cn = count(all(a[i]), 1);
            for (auto &el : a[i]) {
                if (el == 1) {
                    --cn;
                } else {
                    if (cn) {
                        cout << 2;
                        return;
                    }
                }
            }
            if (count(all(a[i]), 1)) {
                ++cnt1;
            }
            if (count(all(a[i]), 2)) {
                ++cnt2;
            }
        }
        if (max(cnt1, cnt2) >= 2) {
            cout << 2;
        } else {
            cout << 1;
        }
        return;
    }
    if (mxsz <= 2) {
        sort(a, a + n, [&](const auto &x, const auto &y) {
            if (get(x, y) == get(y, x)) {
                if (get2(x, y) == get2(y, x)) {
                    return get1(x, y) < get1(y, x);
                }
                return get2(x, y) > get2(y, x);
            }
            return get(x, y) > get(y, x);
        });
        int cur = 0;
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            for (auto &el : a[i]) {
                if (el > cur) {
                    cur = el;
                    ++ans;
                }
            }
        }
        cout << ans;
        return;
    }
    vector<int> t(n);
    iota(all(t), 0);
    int mx = 1;
    do {
        vector<int> b;
        for (auto &el : t) {
            for (auto &i : a[el]) {
                b.push_back(i);
            }
        }
        int maxx = -1;
        int cnt = 0;
        for (auto &el : b) {
            if (el > maxx) {
                maxx = el;
                ++cnt;
            }
        }
        mx = max(mx, cnt);
    } while (next_permutation(all(t)));
    cout << mx;
}