#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"

using namespace std;

typedef long long ll;

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

vector<int> mx;

void upd(int x, int val, int l, int r, int ndx) {
    if (x < l || x >= r)
        return;
    if (l + 1 == r && x == l) {
        mx[ndx] = max(mx[ndx], val);
        return;
    }
    upd(x, val, l, (r + l) / 2, ndx * 2 + 1);
    upd(x, val, (r + l) / 2, r, ndx * 2 + 2);
    mx[ndx] = max(mx[ndx * 2 + 1], mx[ndx * 2 + 2]);
}

int get(int l, int r, int L, int R, int ndx) {
    if (l >= R || L >= r)
        return 0;
    if (l <= L && R <= r) {
        return mx[ndx];
    }
    return max(get(l, r, L, (R + L) / 2, ndx * 2 + 1), get(l, r, (R + L) / 2, R, ndx * 2 + 2));
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> v;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        v.push_back({});
        for (int j = 0; j < k; j++) {
            int a;
            cin >> a;
            v.back().push_back(a);
        }
    }
    vector<pair<int, int>> a(n);
    set<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < v[i].size(); j++) {
            if (v[i][j] >= a[i].first) {
                a[i].first = v[i][j];
                a[i].second++;
            }
        }
        s.insert({a[i].first, i});
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        auto[a, b] = *s.begin();
        s.erase(s.begin());
        for (int j: v[b])
            ans.push_back(j);
    }
    mx.resize(4 * n + 40);
    map<int, int> k;
    int t = 1;
    auto a1 = ans;
    std::sort(a1.begin(), a1.end());
    for (int i: a1) {
        k[i] = t++;
    }
    for (int &i: ans)
        i = k[i];
    for (int i: ans) {
        int x = get(0, i, 0, n + 10, 0);
        x++;
        upd(i, x, 0, n + 10, 0);
    }
    cout << get(0, n + 10, 0, n + 10, 0);


};