#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

#define LC(V) (2*(V)+1)
#define RC(V) (2*(V)+2)

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18;


ll solve(ll n, const vector<pair<ll, ll>> &a) {
    ll ans = INF;
    multiset<ll> dab;
    for (auto [x, y]: a) dab.insert(min(x, y));
    for (ll i = 0; i < n; i++) {
        dab.erase(dab.find(min(a[i].first, a[i].second)));
        ll ma = a[i].first;
        ll mb = -INF;
        if (dab.upper_bound(ma) != dab.end()) continue;
        for (ll j = 0; j < n; j++) {
            if (j == i) continue;
            if (a[j].second <= ma) mb = max(mb, a[j].second);
        }
        ans = min(ans, ma - mb);
        dab.insert(min(a[i].first, a[i].second));
    }
    return ans;
}

int main() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> a(n);
    for (auto &[x, y]: a) cin >> x >> y;
    ll ans = INF;
    ans = min(ans, solve(n, a));
    for (auto &[x, y]: a) swap(x, y);
    ans = min(ans, solve(n, a));
    cout << ans << '\n';
}