#include <iostream>
#include <cmath>
#include <iomanip>
#include <queue>
#include <vector>
#include <set>
#include <algorithm>
#define ll long long
using namespace std;
void FAST() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
vector <ll> p(0);
ll mod = 1e9 + 7;
ll binpow(ll a, ll b) {
    if (b == 0)
        return 1;
    ll q = binpow(a, b / 2);
    ll tq = q * q % mod;
    if (b % 2 == 0)
        return tq;
    else
        return (tq * a) % mod;
}
void solve() {
    ll n;
    cin >> n;
    vector <pair<ll, ll>> a(n);
    bool flag = true;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        if (a[i].first != a[i].second)
            flag = false;
    }
    sort(a.begin(), a.end());
    if (flag) {
        sort(a.begin(), a.end());
        cout << a[n - 1].first - a[n - 2].first;
        return;
    }
    ll ans = 1e9;
    vector <ll> b(n + 1, 0);
    b[1] = a[n - 1].second;
    for (ll i = 1; i < n; ++i) {
        b[i + 1] = max(b[i], a[n - 1 - i].second);
    }
    set <ll> s;
    for (ll i = 0; i < n; ++i) {
        ll mx1 = a[i].first;
        ll mx2 = b[n - i - 1];
        if (mx2 < mx1) {
            ll q = *s.lower_bound(a[i].first);
            if (q > mx2 and abs(mx1 - q) < abs(mx1 - mx2)) {
                mx2 = q;
            }
        }
        ans = min(ans, abs(mx1 - mx2));
        s.insert(a[i].second);
    }
    cout << ans;
}
int main()
{
    FAST();
    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}