#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    vector<pair<int, int>> all(2 * n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        all[i] = {a[i], i};
        all[i + n] = {b[i], i + n};
    }
    sort(all.begin(), all.end());
    int ans = 2e9 + 10;
    vector<int> alive(n);
    int aval = 0, maxa1 = -1, maxa2, maxb1 = -1, maxb2 = -1;
    for (auto [num, i] : all) {
        if (alive[i] == 0) {
            alive[i] = 1;
            ++aval;
        }
        int other = -1;
        if (i >= n) {
            // b
            i -= n;
            if (maxa1 != i) {
                other = maxa1;
            } else {
                other = maxa2;
            }
            if (aval == n && other != -1) {
                ans = min(ans, num - a[other]);
            }
            maxb2 = maxb1;
            maxb1 = i;
        } else {
            // a
            if (maxb1 != i) {
                other = maxb1;
            } else {
                other = maxb2;
            }
            if (aval == n && other != -1) {
                ans = min(ans, num - b[other]);
            }
            maxa2 = maxa1;
            maxa1 = i;
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
