#include <bits/stdc++.h>

using namespace std;

#define pii pair<int,int>
#define F first
#define S second
typedef long double ld;
//#define int int64_t

mt19937 gen(chrono::system_clock().now().time_since_epoch().count());

const int N = 5e5+10, K = 30;

int a[N], b[N];
int n;

int solve () {
    vector <pii> all;
    set <pii> need;
    set <pii> can;
    for (int i=0;i<n;++i) {
        all.push_back({a[i], i});
        need.insert({b[i], i});
    }
    sort(all.begin(), all.end());
    int ans = 1e9+100;
    for (int i=0;i<all.size();++i) {
        int x = all[i].F;
        int p = all[i].S;
        need.erase({b[p], p});
        can.insert({b[p], p});
        if (need.size() > 0 && (*need.rbegin()).F >= x) {
            ans = min(ans, (*need.rbegin()).F - x);
        }
        else {
            if (can.size() > 0) {
                auto it = can.lower_bound({x, 0});
                while (it != can.end() && it->S == p) {
                    it++;
                }
                if (it != can.end() && it->S != p) {
                    ans = min(ans, it->F-x);
                }
            }
        }
    }
    return ans;
}

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n;
    for (int i=0;i<n;++i) {
        cin >> a[i] >> b[i];
    }
    int ans = solve();
    for (int i=0;i<n;++i) {
        swap(a[i], b[i]);
    }
    ans = min(solve(), ans);
    cout << ans;
    return 0;
}
