#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;

const ll INF = (ll)(1e18);



bool cmp(pair<ll, ll> &a, pair<ll, ll> &b) {
    if (a.second != b.second) return a.second > b.second;
    return a.first < b.first;
}

void solve() {
    ll n;
    cin >> n;

    vector<pair<ll, ll>> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i].first >> a[i].second;

    sort(all(a), cmp);

    set<pair<ll, ll>> st;
    for (ll i = 0; i < n; ++i) {
        st.insert({a[i].first, i});
    }

    ll now_max = 0;
    ll ans = INF;

    for (ll i = 0; i < n; ++i) {
        st.erase({a[i].first, i});

        auto rt = st.lower_bound({a[i].second, -1});

        if (rt != st.end()) ans = min(ans, abs(a[i].second - max(now_max, rt->first)));

        if (rt != st.begin()) {
            --rt;

            ans = min(ans, abs(a[i].second - max(now_max, rt->first)));
        }

        now_max = max(now_max, a[i].first);
    }

    cout << ans;
}

signed main() {
    int tests = 1;

    while (tests--) {
        solve();
    }
}