#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int, int>> arr(n, pair<int, int> {});
    for (int i = 0; i < n; i++) cin >> arr[i].first >> arr[i].second;
    multimap<int, pair<int, int>> mp;
    for (auto p : arr) mp.insert({p.first, {p.second, 0}});
    auto it = mp.rbegin();
    int prev_mx = 0;
    while (it != mp.rend()) {
        it->second.second = max(it->second.first, prev_mx);
        prev_mx = max(it->second.first, prev_mx);
        it++;
    }
    multimap<int, int> s;
    for (int i = 0; i < n; i++) s.insert({arr[i].second, i});
    int ans = INT_MAX;
    for (int i = 0; i < n; i++) {
        int e = arr[i].first;
        auto u = mp.upper_bound(e);
        int mx;
        if (u == mp.end()) {
            auto t = s.lower_bound(e);
            t--;
            if (t == s.end()) t++;
            int j = 0;
            int diff = INT_MAX;
            while (j <= 4 && t != s.end()) {
                if (t->second != i) {
                    diff = min(diff, abs(t->first - e));
                }
                t++;
                j++;
            }
            ans = min(ans, diff);
        }
        else {
            mx = u->second.second;
            auto t = s.upper_bound(mx);
            if (t == s.end()) ans = min(ans, abs(mx - e));
            else if (t->second != i) ans = min(ans, min(abs(mx - e), abs(t->first - e)));
            else {
                t++;
                if (t == s.end()) ans = min(ans, abs(mx - e));
                else ans = min(ans, min(abs(mx - e), abs(t->first - e)));
            }
        }
    }
    cout << ans;
    return 0;
}