#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define fi first
#define se second

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const int N = 2e5 + 5;
const int MOD = 1e9 + 7;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define fbo find_by_order
#define ook order_of_key

mt19937 rng(time(0));

map<int, vector<int>> mp;
multiset<int> st;
vector<pair<int, int>> v;

bool comp(pair<int, int> a, pair<int, int> b){
    if(a.fi != b.fi){
        return a.fi < b.fi;
    } else {
        return a.se > b.se;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    int n;
    cin >> n;

    for(int i = 0; i < n; i++){
        int a, b;
        cin >> a >> b;
        v.pb({a, b});
        st.insert(b);
    }

    sort(all(v), comp);
    int ans = 2e9;
    set<int> st2;

    for(auto it : v){
        st.erase(st.find(it.se));
        if(sz(st)){
            ans = min(ans, abs(it.fi - *--st.end()));
        }
        if(sz(st2)){
            auto it2 = st2.lower_bound(it.fi);
            if(it2 != st.end()){
                if(sz(st) == 0 || *it2 > *--st.end()){
                    ans = min(ans, abs(*it2 - it.fi));
                }
            }
            if(it2 != st.begin()){
                it2--;
                if(sz(st) == 0 || *it2 > *--st.end()){
                    ans = min(ans, abs(*it2 - it.fi));
                }
            }
        }
        st2.insert(it.se);
    }

    cout << ans << "\n";

    return 0;
}
