#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<queue>
#include<deque>
#include<stack>
#include<string>
#include<cmath>
#include<climits>
#include<random>
#include<bitset>
#include<ctime>

#define ft first
#define sd second
#define mp make_pair
#define pb push_back
#define int long long

using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

bool cmp1 (ii a, ii b) {
    if (a.ft == b.ft) {
        if (a.sd > a.ft)
            return true;
        if (b.sd > a.ft)
            return false;
        return a.sd < b.sd;
    }
    return a.ft < b.ft;
}

bool cmp2 (ii a, ii b) {
    if (a.sd == b.sd) {
        if (a.ft > a.sd)
            return true;
        if (b.ft > a.sd)
            return false;
        return a.ft < b.ft;
    }
    return a.sd < b.sd;
}

void solve_stupid () {
    int n;
    cin >> n;
    int a[n];
    int b[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
    }
    int ans = 1e9 + 1;
    for (int i = 0; i < n; i++) {
        int max1 = -1e9;
        for (int j = 0; j < n; j++) {
            if (j == i)
                continue;
            if ((a[j] <= a[i]) && (b[j] <= a[i])) {
                max1 = max(max1, b[j]);
            } else if (a[j] > a[i]) {
                max1 = max(max1, b[j]);
            }
        }
        ans = min(ans, abs(a[i] - max1));
    }
    for (int i = 0; i < n; i++) {
        int max1 = -1e9;
        for (int j = 0; j < n; j++) {
            if (j == i)
                continue;
            if ((b[j] <= b[i]) && (a[j] <= b[i])) {
                max1 = max(max1, a[j]);
            } else if (b[j] > b[i]) {
                max1 = max(max1, a[j]);
            }
        }
        ans = min(ans, abs(b[i] - max1));
    }
    cout << ans << endl;
    return;
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    //solve_stupid();
    //return 0;
    int n;
    cin >> n;
    int a[n], b[n];
    vector<ii> v(n);
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];
    for (int i = 0; i < n; i++) {
        v[i] = mp(a[i], b[i]);
    }
    sort(v.begin(), v.end(), cmp1);

    int ans = 2e9;
    int max1[n + 1];
    max1[n - 1] = v[n - 1].sd;
    for (int i = n - 2; i >= 0; i--) {
        max1[i] = max(max1[i + 1], v[i].sd);
    }
    set<int> help;
    max1[n] = -2e9;
    for (int i = 0; i < n; i++) {
        int b_now = max1[i + 1];
        if (b_now > v[i].ft)
            continue;
        for (auto j : help) {
            if (j > v[i].ft)
                break;
            b_now = max(b_now, j);
        }
        /*auto it = help.upper_bound(v[i].ft);
        if (it != help.begin()) {
            it--;
            b_now = max(b_now, *it);
        }*/
        ans = min(ans, v[i].ft - b_now);
        help.insert(v[i].sd);
    }
    sort(v.begin(), v.end(), cmp2);
    help.clear();

    max1[n - 1] = v[n - 1].ft;
    for (int i = n - 2; i >= 0; i--) {
        max1[i] = max(max1[i + 1], v[i].ft);
    }
    for (int i = 0; i < n; i++) {
        int a_now = max1[i + 1];
        if (a_now > v[i].sd)
            continue;
        int last = 0;
        for (auto j : help) {
            if (j > v[i].sd)
                break;
            last = j;
        }
        /*auto it = help.upper_bound(v[i].sd);
        if (it != help.begin()) {
            it--;
            a_now = max(a_now, *it);
        }*/
        ans = min(ans, v[i].sd - max(a_now, last));
        help.insert(v[i].ft);
    }
    cout.precision(20);
    cout << ans << endl;
    return 0;
}