#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define itn int
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define Int int
#define Itn int
#define pii pair<int, int>
#define X first
#define Y second

template<typename T>
istream &operator >> (istream &in, vector<T> &arr) {
    for(auto &to : arr) in >> to;
    return in;
}

template<typename T>
ostream &operator << (ostream &out, vector<T> &arr) {
    for(auto &to : arr) out << to << " ";
    return out;
}

const int INF = 1e9 + 7;
const int MOD = 998244353;
const int maxn = 1e6 + 1;

void solve() {
    itn n;
    cin >> n;
    vector<itn> a(n), b(n);
    for(int i = 0; i < n; ++i) cin >> a[i] >> b[i];
    int ans = INF;
    for(int mask = 0; mask < (1 << n); ++mask) {
        int mx1 = -1, mx2 = -1;
        for(int i = 0; i < n; ++i) {
            if(mask & (1 << i)) mx1 = max(mx1, a[i]);
            else mx2 = max(mx2, b[i]);
        }
        ans = min(ans, abs(mx2 - mx1));
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) {
        solve();
    }
}