#include <bits/stdc++.h>
///#include <ext/pb_ds/assoc_container.hpp>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define fi first
#define se second
#define all(v) (v).begin(), (v).end()

#define int long long

using namespace std;
///using namespace __gnu_pbds;
using ll = long long;
using ld = double;
using pii = pair <int, int>;

mt19937 rnd(4);

int const inf = 1e9 + 7;

struct S{
    int x, id;
};

bool comp(S a, S b){
    return a.x > b.x;
}

int get(vector <int>& col, vector <S>& a, vector <S>& b){
    int n = col.size();
    int mx1 = 0, mx2 = 0;
    for(auto [x, id] : a){
        if(col[id] == 1){
            mx1 = max(mx1, x);
        }
    }
    for(auto [x, id] : b){
        if(col[id] == 2){
            mx2 = max(mx2, x);
        }
    }
    return abs(mx1 - mx2);
}

int solve(vector <S> a, vector <S> b){
    sort(all(a), comp);
    sort(all(b), comp);
    int n = a.size();
    vector <int> col(n, 0);
    int i = 0, j = 0, ans = 1e9 + 7;

    if(a[0].x == b[0].x){
        if(a[0].id == b[0].id){
            return a[0].x - max(a[1].x, b[1].x);
        }
        else{
            return 0;
        }
    }

    while(i < n and j < n){
        while(i < n and col[a[i].id] == 2){
            ++i;
        }
        while(j < n and col[b[j].id] == 1){
            ++j;
        }
        if(i >= n or j >= n){
            break;
        }
        if(a[i].id == b[j].id){
            //cout << a[i].id << endl;
            col[a[i].id] = 1;
            ans = min(ans, get(col, a, b));
            col[a[i].id] = 2;
            ans = min(ans, get(col, a, b));
            if(i > 0 and j > 0){
                //cout << "ADASD" << endl;
                col[a[i].id] = 1;
                ans = min(ans, get(col, a, b));
                col[a[i].id] = 2;
                ans = min(ans, get(col, a, b));
            }
            else if(i > 0){
                col[a[i].id] = 1;
                ans = min(ans, get(col, a, b));
            }
            else if(j > 0){
                col[a[i].id] = 2;
                ans = min(ans, get(col, a, b));
            }
            else{
                ans = min(ans, min(abs(a[i].x - a[i + 1].x), abs(a[i].x - b[i + 1].x)));
            }
            break;
        }
        //cout << a[i].x << "  " << b[j].x << endl;
        ans = min(ans, abs(a[i].x - b[j].x));
        col[a[i].id] = 2;
        col[b[j].id] = 1;
        if(a[i].x > b[j].x){
            ++i;
        }
        else if(b[j].x > a[i].x){
            ++j;
        }
        else{
            break;
        }
    }
    return ans;
}

int stupid(vector <S> a, vector <S> b){
    int n = a.size();
    int ans = 1e9 + 7;
    for(int mask = 0; mask < (1 << n); ++mask){
        int mx1 = 0, mx2 = 0;
        for(int i = 0; i < n; ++i){
            if(mask & (1 << i)){
                mx1 = max(mx1, a[i].x);
            }
            else{
                mx2 = max(mx2, b[i].x);
            }
        }
        ans = min(ans, abs(mx1 - mx2));
    }
    return ans;
}

bool gen(){
    int n = 2 + rnd()%5;
    vector <S> a(n), b(n);

}

signed main(){
    ibase;
    int n;
    cin >> n;
    vector <S> a(n), b(n);
    for(int i = 0; i < n; ++i){
        cin >> a[i].x >> b[i].x;
        a[i].id = b[i].id = i;
    }
    cout << solve(a, b);
}
