#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <random>
#include <chrono>

typedef long long ll;
typedef long double ld;

using namespace std;

const int MOD = 1e9 + 7;
const int MAXN = 5e5 + 5;
const int logn = 17;
const int INF = 2e9;

//vector<int> t[4 * MAXN];
//int b[MAXN];
//
//void build(int v, int l, int r) {
//    if (l + 1 == r) {
//        t[v] = {b[l]};
//        return;
//    }
//
//    int m = (l + r) / 2;
//    build(2 * v, l, m);
//    build(2 * v + 1, m, r);
//
//    t[v].assign(r - l, 0);
//    merge(t[2 * v].begin(), t[2 * v].end(), t[2 * v + 1].begin(), t[2 * v + 1].end(), t[v].begin());
//}
//
//int get(int v, int l, int r, int ql, int qr, int x) {
//    if (qr <= l || r <= ql) {
//        return -1;
//    }
//
//    if (ql <= l && r <= qr) {
//        return *lower_bound(t[v].begin(), t[v].end(), x);
//    }
//
//    return
//}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end());
    multiset<int> b, p;
    for (int i = 0; i < n; ++i) {
        b.insert(a[i].second);
    }

    int ans = INF;
    for (int i = 0; i < n; ++i) {
        b.erase(b.find(a[i].second));
        if (i) {
            p.insert(a[i - 1].second);
        }
        int mx = -1;
        if (!b.empty()) {
            mx = *b.rbegin();
        }
        if (a[i].first <= mx) {
            ans = min(ans, mx - a[i].first);
        } else {
            if (p.empty()) {
                continue;
            }
            auto it2 = p.lower_bound(a[i].first);
            if (it2 == p.end()) {
                auto it1 = p.rbegin();
                ans = min(ans, abs(*it1 - a[i].first));
            } else {
                auto it1 = it2;
                --it1;
                ans = min(ans, abs(*it1 - a[i].first));
                ans = min(ans, abs(*it2 - a[i].first));
            }
        }
    }

    cout << ans << '\n';
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int T = 1;
    //cin >> T;
    while (T --> 0) {
        solve();
    }

    return 0;
}
