#include <iostream>
#include <algorithm>
using namespace std;

const int inf = 2100000000;

struct ab{
    int a, b;
};

bool comp(ab x, ab y)
{
    return x.a > y.a;
}

struct v{
    int b, i;
};

bool comp2(v x, v y)
{
    return x.b < y.b;
}

int main()
{
    int n;
    cin >> n;
    ab *c = new ab[n];
    for(int i = 0; i < n; ++i){
        cin >> c[i].a >> c[i].b;
    }
    sort(c, c + n, comp);
    v *b = new v[n];
    for(int i = 0; i < n; ++i){
        b[i] = {c[i].b, i};
    }
    sort(b, b + n, comp2);
    int maxb = -inf;
    int ans = inf;
    for(int i = 0; i < n; ++i){
        int a = c[i].a;
        if(maxb >= a){
            ans = min(ans, maxb - a);
        }
        else{
            int i1, i2;
            int l = 0, r = n - 1;
            while(l != r){
                int mid = (l + r)/2;
                if(b[mid + 1].b > a){
                    r = mid;
                }
                else l = mid + 1;
            }
            i1 = b[l].i; // <= a
            if(i1 == i){
                if(l > 0) i1 = b[l - 1].i;
                else i1 = b[l + 1].i;
            }
            l = 0, r = n - 1;
            while(l != r){
                int mid = (l + r)/2;
                if(b[mid].b < a){
                    l = mid + 1;
                }
                else r = mid;
            }
            i2 = b[l].i; // >= a
            if(i2 == i){
                if(l < n - 1) i2 = b[l + 1].i;
                else i2 = b[l - 1].i;
            }
            ans = min(ans, min(abs(a - c[i1].b), abs(a - c[i2].b)));
        }
        maxb = max(maxb, c[i].b);
    }
    cout << ans << endl;
    return 0;
}