#include <bits/stdc++.h>

#define int long long
#define print(a) std::cout << (a) << std::endl

void print_mas(const std::vector<int>& c) {
    for (auto &i : c)
        std::cout << i << " ";
    std::cout << std::endl;
}

signed main() {
    std::ios_base::sync_with_stdio();
    std::cin.tie();
    std::cout.tie();

    int n;
    std::cin >> n;
    std::vector<std::pair<int, int>> fmas(n);
    for (int i = 0; i < n; ++i) {
        int t1, t2;
        std::cin >> t1 >> t2;
        fmas[i] = std::make_pair(t1, t2);
    }
    std::sort(fmas.begin(), fmas.end());
//    for (int i = 0; i < n; ++i)
//        std::cout << fmas[i].first << " " << fmas[i].second << std::endl;

    std::vector<int> mas_fshop(n);
    std::vector<std::pair<int, int>> mas_sshop(n);

    for (int i = 0; i < n; ++i) {
        mas_fshop[i] = fmas[i].first;
        mas_sshop[i] = std::make_pair(fmas[i].second, i);
    }
    std::sort(mas_sshop.begin(), mas_sshop.end());
//    print_mas(mas_fshop);
//    for (int i = 0; i < n; ++i)
//        std::cout << mas_sshop[i].first << " " << mas_sshop[i].second << std::endl;

int fp = 0, sp = 0, ans_min = abs(mas_fshop[0] - mas_sshop[0].first);
    while (fp < n and sp < n) {
        if (abs(mas_fshop[fp] - mas_sshop[sp].first) < ans_min and fp != mas_sshop[sp].second) {
            ans_min = abs(mas_fshop[fp] - mas_sshop[sp].first);
        }

        if (fp == mas_sshop[sp].second and fp == n - 1) {
            if (fp == n - 1) {
                ++sp;
                continue;
            } else if(sp == n - 1) {
                ++fp;
                continue;
            }
        }

        if (mas_fshop[fp] == mas_sshop[sp].first) { //!!!!!
            if (abs(mas_fshop[fp + 1] - mas_sshop[sp].first)
            < abs(mas_fshop[fp] - mas_sshop[sp + 1].first)) fp++;
            else if (abs(mas_fshop[fp + 1] - mas_sshop[sp].first)
                     == abs(mas_fshop[fp] - mas_sshop[sp + 1].first)) {
                if (mas_fshop[fp + 1] < mas_sshop[sp + 1].first) fp++;
                else sp++;
            } else sp++;
        }
        else if (mas_fshop[fp] < mas_sshop[sp].first) fp++;
        else sp++;

        if (ans_min == 0) break;

    }
    std::cout << ans_min;
    return 0;
}
