#ifndef LOCAL
#   include <bits/stdc++.h>
#   include <ext/pb_ds/assoc_container.hpp>
#   define debug(...)
#endif
#define int long long
using namespace std;

vector<int> Q;

int query(int p) {
    cout << "? " << p << endl;
    int res;
    cin >> res;
    for (int i : Q) {
        if (i <= p) {
            res += i;
        }
    }
    return res;
}

void solve() {
    int n, k;
    cin >> n >> k;
    while (k--) {
        int l = 0;
        int r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (query(m) != (1 + m) * m / 2) {
                r = m;
            } else {
                l = m;
            }
        }
        Q.push_back(r);
    }
    cout << "! ";
    for (int i : Q) {
        cout << i << " ";
    }
    cout << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
