#include <bits/stdc++.h>
using namespace std;

#define int long long 
#define forn(i,n) for(int i=0;i<n;++i)

#define pi pair<int,int>
#define f first
#define s second

#define pb push_back
#define all(x) x.begin(),x.end()
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

const int inf=1e18;
const int mod=1e9+7;

const int sz=1<<30;

struct sgt {
	sgt *L, *R;
	int val;
	sgt() {
		L=R=NULL; val=-1;
	}
	void add(int l, int r, int i, int x) {
		val=max(val,x);
		if (r-l==1) return;
		int m=(l+r)>>1;
		if (i<m) {
			if (!L) L=new sgt();
			L->add(l,m,i,x);
		} else {
			if (!R) R=new sgt();
			R->add(m,r,i,x);
		}
	}
	void set(int i, int x) {
		add(0,sz,i,x);
	}
	int query(int l, int r, int lx, int rx) {
		if (rx<=l || r<=lx) return -1;
		if (lx<=l && r<=rx) return val;
		int m=(l+r)>>1;
		int f=-1,s=-1;
		if (L) f=L->query(l,m,lx,rx);
		if (R) s=R->query(m,r,lx,rx);
		return max(f,s);
	}
	int query(int l, int r) {
		return query(0,sz,l,r);
	}
};

struct sgt2 {
	sgt2 *L, *R;
	int val;
	sgt2() {
		L=R=NULL; val=inf;
	}
	void add(int l, int r, int i, int x) {
		val=min(val,x);
		if (r-l==1) return;
		int m=(l+r)>>1;
		if (i<m) {
			if (!L) L=new sgt2();
			L->add(l,m,i,x);
		} else {
			if (!R) R=new sgt2();
			R->add(m,r,i,x);
		}
	}
	void set(int i, int x) {
		add(0,sz,i,x);
	}
	int query(int l, int r, int lx, int rx) {
		if (rx<=l || r<=lx) return inf;
		if (lx<=l && r<=rx) return val;
		int m=(l+r)>>1;
		int f=inf,s=inf;
		if (L) f=L->query(l,m,lx,rx);
		if (R) s=R->query(m,r,lx,rx);
		return min(f,s);
	}
	int query(int l, int r) {
		return query(0,sz,l,r);
	}
};

sgt stmax;
sgt2 stmin;

struct BIT {
	int n; vector<int> t;
	BIT(int _n) {
		n=_n;
		t.assign(n,0);
	}
	void add(int i, int x) {
		for( ; i<n; i=i|(i+1) ) {
			t[i]=max(t[i],x);
		}
	}
	int q(int r) {
		if (r<0) return -1;
		int ret=0;
		for(r; r>=0; r=(r&(r+1))-1) {
			ret=max(ret,t[r]);
		}
		return ret;
	}
};

void solve() {

	int n; cin>>n;
	vector<pi> a(n);
	forn(i,n) cin>>a[i].f>>a[i].s;
	int z=1;
	forn(i,n) z&=a[i].f==a[i].s;
	if (z) {
		sort(all(a));
		cout<<a[n-1].f-a[n-2].f<<'\n';
		return;
	}
	sort(all(a));
	BIT ft(n);
	for (int i=n-1; i>=0; --i) ft.add(n-1-i,a[i].s);
	int ans=inf;
	forn(i,n) {
		int f=a[i].f;
		int s=ft.q(n-i-2);
		if (s>=f) {
			ans=min(ans,s-f);
			stmax.set(a[i].s,a[i].s);
			stmin.set(a[i].s,a[i].s);
			continue;
		}
		if (s!=-1) ans=min(ans,abs(s-f));
		int L=stmax.query(0,f+1);
		int R=stmin.query(f,sz);
		if (L!=-1) ans=min(ans,f-L);
		if (R!=inf) ans=min(ans,R-f);
		stmax.set(a[i].s,a[i].s);
		stmin.set(a[i].s,a[i].s);
	}	
	cout<<ans;

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	//cin>>t;
	while (t--) solve();
	return 0;
}