#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

//#define int long long
int INF = 1e9;
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
    }

    int ans = INF;
    for (int i = 1; i < (1 << (n)) - 1; i++) {
        int maxa = 0;
        int maxb = 0;
        for (int j = 0; j < n; j++) {
            int x = (1 << j);
            if (x & i) {
                maxa = max(maxa, a[j]);
            } else {
                maxb = max(maxb, b[j]);
            }
        }
        if (maxa > 0 && maxb > 0) {
            ans = min(ans, abs(maxa - maxb));
        }
    }
    cout << ans;
    return 0;
}

