#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)
//#pragma GCC optimization("Ofast")
//#pragma GCC optimization("sse4")
void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

int main() {
    fastio();
    ll n;
    cin >> n;
    vector<pair<ll, ll>> a(n);
    for (ll i = 0;i<n;i++){
        cin >> a[i].first >> a[i].second;
    }
    sort(all(a));
    ll ans = INF;
    vector<ll> mx(n+1, -INF);
    for (ll i = n-1;i>=0;i--){
        mx[i]= max(mx[i+1], a[i].second);
    }
    multiset<ll> st;
    for (ll i = 0;i<n;i++){
        ll x = a[i].first;
        ll m  = mx[i+1];
        if (m >= x){
            ans = min(ans, m - x);
        }else{
            auto it = st.lower_bound(x);
            if (it != st.end()){
                ans = min(ans, abs(x - *it));
            }
            if (it != st.begin()){
                it--;
                ans = min(ans, abs(x - *it));
            }
        }
        st.insert(a[i].second);
    }
    cout << ans << "\n";
    return 0;
}