#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define mp make_pair
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
typedef long long ll;

const ll INF = 2e9;

void solve4(vector<pair<int, int> > v) {
    int n = v.size();
    sort(v.rbegin(), v.rend());
    cout << v[0].F - v[1].F;
}

int main() {
    int n; cin >> n;
    vector<pair<int, int> > v(n);
    int t4 = 1;
    for (int i = 0; i < n; i++) {
        cin >> v[i].F >> v[i].S;
        if (v[i].F != v[i].S) t4 = 0;
    }
    if (t4) {
        solve4(v);
        return 0;
    }
    sort(v.rbegin(), v.rend());
    vector<int> suf(n, -1);
    set<int> b;
    for (int i = n - 1; i > 0; i--) {
        b.insert(v[i].S);
        int a = v[i - 1].F;
        auto it = upper_bound(all(b), a);
        if (it != b.begin()) {
            it--;
            suf[i] = (*it);
        } 

    }
    int ans = INF, mxb = v[0].S;
    for (int i = 1; i < n; i++) {
        int a = v[i].F;
        if (a <= mxb) {
            ans = min(ans, mxb - a);
            continue;
        }
        if (i < n - 1) {
            if (suf[i + 1] != -1) {
                ans = min(ans, a - suf[i + 1]);
            }
        }
        mxb = max(mxb, v[i].S);
    } 
    for (int i = 1; i < n; i++) {
        ans = min(ans, abs(v[0].F - v[i].S));
    }
    cout << ans;
    return 0;
}