#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
using namespace std;

const int INF = 1e9;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;
    vector<int> a(n), b(n);
    vector<pair<int, int>> a_ind(n), b_ind(n);
    unordered_map<int, int> cnt_b;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        cnt_b[b[i]]++;
        a_ind[i] = {a[i], i};
        b_ind[i] = {b[i], i};
    }
    sort(a_ind.begin(), a_ind.end());
    sort(b_ind.begin(), b_ind.end());
    if (n <= 5000) {
        int ans = 1e9;
        for (int i = 0; i < n; ++i) {
            int max_b = 0;
            for (int k = 0; k < n; ++k) {
                if (a[k] > a[i])
                    max_b = max(max_b, b[k]);
            }
            if (max_b >= a[i]) {
                ans = min(ans, abs(a[i] - max_b));
            }
            else {
                if (upper_bound(b.begin(), b.end(), a[i]) != b.end()) {
                    int b1 = (*upper_bound(b.begin(), b.end(), a[i]));
                    if (b1 != b[i] || cnt_b[b1] > 1) {
                        ans = min(ans, abs(a[i] - b1));
                    } else if (upper_bound(b.begin(), b.end(), a[i]) != b.begin()) {
                        b1 = (*prev(upper_bound(b.begin(), b.end(), a[i])));
                        ans = min(ans, abs(a[i] - b1));
                    }
                    if (next(upper_bound(b.begin(), b.end(), a[i])) != b.end()) {
                        int b1 = (*next(upper_bound(b.begin(), b.end(), a[i])));
                        if (b1 != b[i] || cnt_b[b1] > 1) {
                            ans = min(ans, abs(a[i] - b1));
                        } else if (upper_bound(b.begin(), b.end(), a[i]) != prev(b.end())) {
                            b1 = (*next(next(upper_bound(b.begin(), b.end(), a[i]))));
                            ans = min(ans, abs(a[i] - b1));
                        }
                    }
                }
            }
        }
        cout << ans;
    }
    else {
        int max1 = 0, max2 = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] > max1) {
                max2 = max1;
                max1 = a[i];
            }
            else if (a[i] > max2) {
                max2 = a[i];
            }
        }
        cout << max1 - max2;
    }

    return 0;
}