#include <bits/stdc++.h>
using namespace std;

typedef long double ld;

#define fout cerr
#define ll long long
#define ull unsigned long long
#define vi vector<int>
#define vl vector<ll>
#define vii vector<vi>
#define vll vector<vl>
#define all(arr) arr.begin(), arr.end()
#define rev(arr) arr.rbegin(), arr.rend()
#define lb(arr, val) int(lower_bound(all(arr), val) - arr.begin())
#define ub(arr, val) int(upper_bound(all(arr), val) - arr.begin())
#define _unique(arr) arr.erase(unique(all(arr)), arr.end())
#define pii pair<int, int>
#define pll pair<ll, ll>
#define vpi vector<pii>
#define vpl vector<pll>
#define size(arr) int(arr.size())

ostream &operator<<(ostream& out, vi a) {
    for (auto u : a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream& in, vi& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

ostream &operator<<(ostream& out, vl a) {
    for (auto u : a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream& in, vl& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}
istream &operator>>(istream& in, pii& a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream& out, pii a) {
    out << a.first << " " << a.second;
    return out;
}

istream &operator>>(istream& in, pll& a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream& out, pll a) {
    out << a.first << " " << a.second;
    return out;
}

const int MAX_N = 2e5 + 5;
const int LOG_N = 25;
const int INF = 1e9 + 7;

ll mod = 1e9 + 7;



int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#else
    #define fout if (0) cout
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
#endif
    cout << setprecision(13) << fixed;

    int n;
    cin >> n;
    vpi v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    sort(all(v));
    set<int> s;
    vi sufmax(n);
    sufmax[n - 1] = v[n - 1].second;
    for (int i = n - 2; i >= 0; --i) {
        sufmax[i] = max(sufmax[i + 1], v[i].second);
    }

    int ans = INF;
    for (int i = 0; i < n - 1; ++i) {
//        cout << v[i].first << "\n";
        int tmp1 = sufmax[i + 1];
        auto it = s.lower_bound(v[i].first);
        int tmp2 = 0;
        if (it != s.end()) {
            if (*it != v[i].first) --it;
            if (it != s.begin())
                tmp2 = *it;
        }
        it = s.upper_bound(v[i].first);
        int tmp3 = 0;
        if (it != s.end()) tmp3 = *it;
        s.insert(v[i].second);
//        cout << tmp1 << " " << tmp2 << " " << tmp3 << "\n";
//        for (auto u : s) cout << u << " ";
//        cout << "\n";
        int tmp = tmp3;
        if (abs(tmp2 - v[i].first) < abs(tmp3 - v[i].first)) tmp = tmp2;
        if (abs(max(tmp2, tmp) - v[i].first) < ans) {
            ans = abs(max(tmp2, tmp) - v[i].first);
        }
    }
    int i = n - 1;
    auto it = s.lower_bound(v[i].first);
    int tmp2 = 0;
    if (it != s.end()) {
        if (*it != v[i].first) --it;
        if (it != s.begin())
            tmp2 = *it;
    }
    it = s.upper_bound(v[i].first);
    int tmp3 = 0;
    if (it != s.end()) tmp3 = *it;

    int tmp = tmp3;
    if (abs(tmp2 - v[i].first) < abs(tmp3 - v[i].first)) tmp = tmp2;
    if (abs(max(tmp2, tmp) - v[i].first) < ans) {
        ans = abs(max(tmp2, tmp) - v[i].first);
    }
    cout << ans << "\n";

}