#include "bits/stdc++.h"
#include<ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<ll> d1;
typedef vector<d1> d2;
typedef pair<ll, ll> pii;
typedef vector<pii> d1p;
typedef vector<d1p> d2p;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define stuff ios::sync_with_stdio(0); cin.tie(0);
#define fori(x, n) for(ll i = x; i < n; ++i)
#define forj(x, n) for(ll j = x; j < n; ++j)
#define fork(x, n) for(ll k = x; k < n; ++k)
#define  F first
#define  S second
#define B back()
#define endl "\n"
mt19937 rnd;
#define cur_time chrono::system_clock::now().time_since_epoch().count()
#define pb(a) push_back(a)

void squeeze(map<ll, ll> &mp1, map<ll, ll> &mp2, d1 &a, d1 &b){
    set<ll> s;
    for(ll i:a) s.insert(i);
    for(ll i:b) s.insert(i);
    ll cnt = 0;
    for(ll i:s){
        mp1[i] = cnt;
        mp2[cnt] = i;
        cnt++;
    }
}

int main() {
    stuff;
    ll n;
    cin >> n;
    d1p a(n);
    fori(0, n) cin >> a[i].F >> a[i].S;
    sort(a.begin(), a.end());
    d1 p(n+1);
    p[n] = 0;
    for(ll i = n-1; i >= 0; --i){
        p[i] = max(p[i+1], a[i].S);
    }
    set<ll> s;
    ll res = 1e18;
    fori(0, n){
        ll b = p[i+1];
        ll opt_b = 1e18;
        auto j = s.lower_bound(a[i].F);
        if(j != s.end()){
            if(abs(a[i].F - *j) < abs(a[i].F - opt_b)) opt_b = *j;
        }
        if(j != s.begin()){
            j--;
            if(abs(a[i].F - *j) < abs(a[i].F - opt_b)) opt_b = *j;
        }
        b = max(b, opt_b);
        res = min(res, abs(a[i].F - b));
        s.insert(a[i].S);
    }
    cout << res;
}
