#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <stdio.h>
#include <set>
#include <map>
#include <deque>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <climits>
#include <random>
#include <bitset>

using namespace std;

//#pragma GCC optimize("Ofast")

#define int long long
#define endl '\n'

mt19937_64 engine;

const long long mod = 1e9 + 7;
const long double pi = acosl(-1.0);
const long double eps = 1e-10;

long long gcd(long long x, long long y)
{
    if (y == 0) return x;
    return gcd(y, x % y);
}

long long lcm(long long x, long long y)
{
    return x / gcd(x, y) * y;
}

long long binpow(long long x, long long y)
{
    if (y == 0) return 1;
    if (y == 1) return x;
    int f = binpow(x, y / 2);
    if (y % 2 == 0) return (f * f) % mod;
    else return (((f * f) % mod) * x) % mod;
}

/*struct Node
{
    vector<pair<int, int>> to;
    int cnt = 0;
};

vector<Node> graph;
vector<Node> rgraph;

void task()
{
    int n, m;
    cin >> n >> m;
    graph.resize(n);
    rgraph.resize(n);

    bool flag = true;

    for (int i = 0; i < m; i++)
    {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;

        graph[u].cnt++;
        graph[v].to.push_back({ u,w });
        rgraph[v].cnt++;
        rgraph[u].to.push_back({ v,w });
    }

    for (int i = 0; i < n; i++)
    {
        if (graph[i].to.size() != 1 || graph[i].to[0].first != (i + 1) % n) flag = false;
    }

    int a, b;
    cin >> a >> b;
    a--;
    b--;

    if (flag)
    {
        int v = a;
        int curans = 0;
        while (v != b)
        {
            curans ^= graph[v].to[0].second;
            v++;
            v %= n;
        }

        int cycle = 0;
        do
        {
            cycle ^= graph[v].to[0].second;
            v++;
            v %= n;
        } while (v != a);

        if ((cycle ^ curans) != 0 || cycle != 0)
        {
            cout << -1 << endl;
        }
        else
        {
            cout << 0 << endl;
        }

        graph.clear();
        rgraph.clear();
        return;
    }

    queue<int> q;
    for (int i = 0; i < n; i++)
    {
        if (graph[i].cnt == 0)
        {
            q.push(i);
        }
    }

    vector<int> dp(n, 0);
    vector<bool> achieve(n, false);
    dp[a] = 1;
    achieve[a] = 1;
    while (!q.empty())
    {
        int v = q.front();
        q.pop();

        for (int i = 0; i < graph[v].to.size(); i++)
        {
            int u = graph[v].to[i].first;
            int w = graph[v].to[i].second;

            dp[u] ^= dp[v];
            achieve[u] = achieve[u] || achieve[v];
            graph[u].cnt--;
            if (graph[u].cnt  == 0)
            {
                q.push(u);
            }
        }
    }

    if (achieve[b] == 0)
    {
        cout << 0 << endl;
        graph.clear();
        rgraph.clear();
        return;
    }

    for (int i = 0; i < n; i++)
    {
        if (rgraph[i].cnt == 0)
        {
            q.push(i);
        }
    }

    vector<int> rdp(n, 0);
    rdp[b] = 1;
    while (!q.empty())
    {
        int v = q.front();
        q.pop();

        for (int i = 0; i < rgraph[v].to.size(); i++)
        {
            int u = rgraph[v].to[i].first;
            int w = rgraph[v].to[i].second;

            rdp[u] ^= rdp[v];
            rgraph[u].cnt--;
            if (rgraph[u].cnt == 0)
            {
                q.push(u);
            }
        }
    }

    int ans = 0;

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < graph[i].to.size(); j++)
        {
            int v = i;
            int u = graph[i].to[j].first;
            int w = graph[i].to[j].second;

            if (dp[v] % 2 == 1 && rdp[u] % 2 == 1)
            {
                ans ^= w;
            }
        }
    }

    cout << ans << endl;

    graph.clear();
    rgraph.clear();
}*/

/*void task()
{
    int n, k;
    cin >> n >> k;

    vector<int> v(n);
    for (int i = 0; i < n; i++)
    {
        cin >> v[i];
    }

    if (n == 1)
    {
        cout << (long double)((v[0] / k) * k) / (long double)v[0] << endl;
        return;
    }

    if (n == 2)
    {
        long double maxans = 0;
        for (int i = 1; i <= k; i++)
        {
            int b0 = i;
            int b1 = (k + i - 1) / i;
            int a0 = v[0];
            int a1 = v[1];
            maxans = max(maxans, (long double)(a0 / b0) * (long double)(a1 / b1) / (long double)(a0) / (long double)(a1)*k);
        }
        cout << maxans << endl;
        return;
    }

    //vector<vector<long double>> dp(n + 1, vector<long double>(k + 1, 0));
    vector<vector<long double>> dp(n + 1);
    dp[0].resize(k + 1, 0);
    dp[0][1] = 1;

    for (int i = 0; i < n; i++)
    {
        dp[i + 1].resize(k + 1, 0);
        for (int j = 1; j <= k; j++)
        {
            for (int f = 1; f <= (k + j - 1) / j; f++)
            {
                dp[i + 1][min(j * f, k)] = max(dp[i + 1][min(j * f, k)], dp[i][j] * (int)(v[i] / f) / (long double)v[i]);
                if (v[i] / f == 0) break;
            }
        }
        dp[i].clear();
    }

    cout << dp[n][k] * k << endl;
}*/

/*struct Node
{
    int tin, tout;
    vector<int> to;
    vector<int> up = vector<int>(22);
};

vector<Node> tree;
vector<int> parent;
vector<pair<int, int>> dm;

int ans = 1;

int get_parent(int x)
{
    if (x != parent[x])
    {
        parent[x] = get_parent(parent[x]);
        return parent[x];
    }
    return x;
}

bool in_one(int x, int y)
{
    return get_parent(x) == get_parent(y);
}

void merge(int x, int y)
{
    x = get_parent(x);
    y = get_parent(y);

    ans *= binpow(dm[x].second - dm[x].first + 1, mod - 2);
    ans %= mod;
    ans *= binpow(dm[y].second - dm[y].first + 1, mod - 2);
    ans %= mod;

    parent[y] = x;
    dm[x].first = max(dm[x].first, dm[y].first);
    dm[x].second = min(dm[x].second, dm[y].second);
    ans *= max((int)0, dm[x].second - dm[x].first + 1);
    ans %= mod;
}

int timer = 0;

void dfs(int v)
{
    tree[v].tin = ++timer;

    for (int u : tree[v].to)
    {
        dfs(u);
    }

    tree[v].tout = ++timer;
}

bool is_parent(int v, int u)
{
    return tree[v].tin <= tree[u].tin && tree[v].tout >= tree[u].tout;
}

int lca(int v, int u)
{
    if (is_parent(v, u)) return v;
    if (is_parent(u, v)) return u;

    for (int i = 21; i >= 0; --i)
    {
        if (!is_parent(tree[v].up[i], u))
        {
            v = tree[v].up[i];
        }
    }

    return tree[v].up[0];
}

void task()
{
    int n;
    cin >> n;

    tree.resize(n);
    tree[0].up[0] = 0;

    for (int i = 1; i < n; ++i)
    {
        int p;
        cin >> p;
        p--;
        tree[p].to.push_back(i);
        tree[i].up[0] = p;
    }

    dfs(0);

    parent.resize(n);
    for (int i = 0; i < n; ++i)
    {
        parent[i] = i;
    }
    dm.resize(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> dm[i].first >> dm[i].second;
    }

    for (int i = 1; i < 22; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            tree[j].up[i] = tree[tree[j].up[i - 1]].up[i - 1];
        }
    }

    for (int i = 0; i < n; ++i)
    {
        ans *= dm[i].second - dm[i].first + 1;
        ans %= mod;
    }

    int m;
    cin >> m;
    for (int i = 0; i < m; ++i)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;

        int l1 = lca(a, b);
        int l2 = lca(c, d);

        vector<int> p1, p2, p3, p4;
        while (a != l1)
        {
            p1.emplace_back(a);
            a = tree[a].up[0];
        }
        while (b != l1)
        {
            p2.emplace_back(b);
            b = tree[b].up[0];
        }
        while (c != l2)
        {
            p3.emplace_back(c);
            c = tree[c].up[0];
        }
        while (d != l2)
        {
            p4.emplace_back(d);
            d = tree[d].up[0];
        }

        reverse(p2.begin(), p2.end());
        reverse(p4.begin(), p4.end());

        p1.emplace_back(l1);
        p3.emplace_back(l2);

        int m1, m2;

        for (int j = 0; j < p1.size() + p2.size(); ++j)
        {
            if (j < p1.size()) m1 = p1[j];
            else m1 = p2[j - p1.size()];

            if (j < p3.size()) m2 = p3[j];
            else m2 = p4[j - p3.size()];

            if (!in_one(m1, m2))
            {
                merge(m1, m2);
            }
        }

        cout << ans << endl;
    }
}*/

void task()
{
    int n;
    cin >> n;
    //n = engine() % 9 + 2;
    //n = 10;
    vector<pair<int, int>> v(n);

    for (int i = 0; i < n; i++)
    {
        cin >> v[i].first >> v[i].second;
        //v[i].first = engine() % 1000000000 + 1;
        //v[i].second = engine() % 1000 + 1;
        //v[i].second = v[i].first;
    }

    sort(v.begin(), v.end());

    vector<int> maxsuf(n + 1, 0);
    for (int i = n - 1; i >= 0; i--)
    {
        maxsuf[i] = max(maxsuf[i + 1], v[i].second);
    }

    int ans1 = LLONG_MAX;
    int ans2 = LLONG_MAX;

    multiset<int> s;

    for (int i = 0; i < n; i++)
    {
        int cl = v[i].first;
        int cr = maxsuf[i + 1];

        if (i != n - 1)
        {
            ans1 = min(ans1, abs(cl - cr));
            ans2 = min(ans2, abs(cl - cr));
        }

        for (int j = 0; j < i; j++)
        {
            ans1 = min(ans1, abs(cl - v[j].second));
        }

        auto it = s.upper_bound(cl);
        if (it != s.end())
        {
            ans2 = min(ans2, abs(cl - *it));
        }
        if (it != s.begin())
        {
            it--;
            ans2 = min(ans2, abs(cl - *it));
        }

        s.insert(v[i].second);
    }

    /*cout << ans1 << ' ' << ans2 << endl;
    if (ans1 != ans2)
    {
        exit(0);
    }*/
    cout << ans1 << endl;
}

signed main()
{
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cout << fixed << setprecision(15);
    engine.seed(58);

    int t = 1;
    bool multitest = false;
    if (multitest) cin >> t;
    while (t--) task();

    return 0;
}
