#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>

using namespace std;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long n;
    cin >> n;
    vector<pair<long, long>> data1(n);
    vector<long> maxx(n);
    for (long i = 0; i < n; ++i) {
        cin >> data1[i].first >> data1[i].second;
    }
    sort(data1.begin(), data1.end());
    maxx.back() = data1.back().second;
    for (long i = n - 2; i >= 0; --i) {
        maxx[i] = max(maxx[i + 1], data1[i].second);
    }
    maxx.push_back(-1);
    long answer = abs(data1[0].first - maxx[1]);
    long prev = -1;
    long k = 1;
    for (long i = 1; i < n; ++i) {
        long curr = data1[i].first;
        while (k < n && data1[k].first == curr) {
            ++k;
        }
        if (k != n) {
            answer = min(answer, abs(maxx[k] - curr));
        }
        for (long j = 0; j < k; ++j) {
            if (j != i) {
                answer = min(answer, abs(max(maxx[k], data1[j].first) - curr));
            }
        }
    }
    cout << answer << endl;
    return 0;
}
