#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = 1e9;

void solve() {
    int n;
    cin >> n;

    vector <int> a(n), b(n);
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];

    int answer = 2 * INF;
    for (int mask = 0; mask < (1 << n); mask++) {
        int maxa = -INF, maxb = -INF;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                maxa = max(maxa, a[i]);
            } else {
                maxb = max(maxb, b[i]);
            }
        }

        answer = min(answer, abs(maxa - maxb));
    }

    cout << answer << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
