#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <queue>
#include <stack>
#include <tuple>
#include <bitset>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;
typedef double db;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

mt19937 rng(time(0));

const ll INF = 1e12 + 179;

void solve() {
    ll n;
    cin >> n;
    vector<pii> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].X >> a[i].Y;
    }
    sort(All(a));
    vector<ll> suff(n+1);
    suff[n] = -INF;
    for (ll i = n - 1; i >= 0; i--)
        suff[i] = max(suff[i + 1], a[i].Y);
    set<ll> vals;
    ll ans = INF;
    for (ll i = 0; i < n; i++) {
        ll s = suff[i + 1];
        ll x = a[i].X;
        if (s >= x) {
            ans = min(ans, s - x);
        }
        else {
            auto it = vals.lower_bound(x);
            ll opt = INF;
            if (it != vals.end()) {
                opt = *it;
            }
            if (it != vals.begin()) {
                --it;
                if (x - *it < opt - x)
                    opt = *it;
            }
            ans = min(ans, min(abs(opt - x), abs(s - x)));
        }
        vals.insert(a[i].Y);
    }
    cout << ans << '\n';
}

ll main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    solve();
}