#include <iostream>
#include <iomanip>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define sc second
#define coe cout<<"YES\n"
#define int long long
#define str string

const int INF = 1e9 + 10;

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr); cin.tie(nullptr);
    cout << fixed << setprecision(10);

    int n; cin >> n;
    vector<pair<int, int>> a(n);
    f (i, 0, n) {
        cin >> a[i].ff >> a[i].sc;
    }

    sort(all(a));
    multiset<int> st;
    f (i, 0, n) {
        st.insert(a[i].sc);
    }
    int mx = -1, ans = INF;
    for (int last = n - 1; last >= 0; last--) {
        st.erase(st.find(a[last].sc));
        if (mx > a[last].ff) {
            ans = min(ans, mx - a[last].ff);
        } else {
            auto it = st.lower_bound(a[last].ff);
            if (it != st.end()) {
                ans = min(ans, *it - a[last].ff);
            }
            if (it != st.begin()) {
                it--;
                ans = min(ans, a[last].ff - max(*it, mx));
            }

        }
        mx = max(mx, a[last].sc);
    }
    cout << ans << '\n';

    return 0;
}