#include <bits/stdc++.h>
#define int long long
#define double long double
#define x first
#define y second
#define inf (INT64_MAX / 2)

using namespace std;

const int mod = 1000000007;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    vector<int> s(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        s[i] = a[i].y;
    }
    sort(a.begin(), a.end(), greater<pair<int, int>>());
    sort(s.begin(), s.end());
    int mx = 0, ans = inf;
    for (int i = 0; i < n; i++) {
        if (mx >= a[i].x) {
            ans = min(ans, mx - a[i].x);
            continue;
        }
        int l = -1, r = n;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (s[m] <= a[i].x) {
                l = m;
            } else {
                r = m;
            }
        }
        bool b = false;
        for (int j = max(0ll, l - 100); j < min(n - 1, r + 101); j++) {
            if (s[j] == a[i].y && !b) {
                b = true;
                continue;
            }
            ans = min(ans, abs(max(mx, s[j]) - a[i].x));
        }
        mx = max(mx, a[i].y);
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cout << setprecision(100);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}