#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#define ss second
#define ff first
#define LOCAL

int n;
vector<pair<int, int>> p;

void solve2n() {
	int res = 1e18;
	for(int i = 0;i < (1 << n);i++) {
		int m1 = 0, m2 = 0;
		for(int j = 0;j < n;j++) {
			if((1 << j) & i) {
				m1 = max(m1, p[j].ff);
			} else {
				m2 = max(m2, p[j].ss);
			}
		}
		res = min(res, abs(m1 - m2));
	}
	cout << res << endl;
}

void solveab() {
	sort(p.begin(), p.end());
	int res = p.back().ff - p[p.size() - 2].ff;
	cout << res << endl;
}

void solvefullkind() {
	sort(p.rbegin(), p.rend(), [&] (auto a, auto b) {
		if(a.ff == b.ff) {
			return a.ss > b.ss;
		}
		return a.ff < b.ff;
	});
	multiset<int> f, s;
	for(int i = 0;i < n;i++) {
		f.insert(p[i].ss);
	}
	int res = 1e18;
	for(int i = 0;i < n - 1;i++) {
		f.erase(f.find(p[i].ss));
		s.insert(p[i].ff);
		res = min(res, abs(*(--f.end()) - *(--s.end())));
	}
	cout << res << endl;
}

void solve() {
	cin >> n;
	int ok = 0;
	for(int i = 0;i < n;i++) {
		int a, b;
		cin >> a >> b;
		p.push_back(make_pair(a, b));
		if(a != b) ok = 1;
	}
	if(!ok) solveab();
	else if(n <= 20) solve2n();
	else solvefullkind();
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int st = 1;
	// cin >> st;
	while(st--) {
		solve();
	}
}