#include <bits/stdc++.h>

using namespace std;

#ifdef DESPAIR101
#include "debug.h"
#define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"
#else
#define dbg(x)
#endif

typedef long long ll;
typedef long double ld;

// #define int ll
#define sz(x) int((x).size())

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

void solve() {
    int n;
    cin >> n;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }

    int ans = INT_MAX;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int a_max = INT_MIN, b_max = INT_MIN;
        for (int i = 0; i < n; ++i) {
            if (mask >> i & 1) {
                umax(a_max, a[i]);
            } else {
                umax(b_max, b[i]);
            }
        }
        if (min(a_max, b_max) != INT_MIN) {
            umin(ans, abs(a_max - b_max));
        }
    }

    cout << ans << '\n';
}

// void solve() {
//     int n;
//     cin >> n;

//     vector<int> a(n), b(n);
//     for (int i = 0; i < n; ++i) {
//         cin >> a[i] >> b[i];
//     }

//     vector<int> pmax(n);
//     pmax[0] = a[0];
//     for (int i = 1; i < n; ++i) {
//         pmax[i] = max(pmax[i - 1], a[i]);
//     }

//     dbg(pmax);

//     vector<int> smax(n);
//     smax[n - 1] = a[n - 1];
//     for (int i = n - 2; i >= 0; --i) {
//         smax[i] = max(smax[i + 1], a[i]);
//     }

//     dbg(smax);

//     int ans = INT_MAX;
//     for (int i = 0; i < n; ++i) {
//         int b_max = b[i];
//         int a_max = INT_MIN;
//         if (i > 0) {
//             umax(a_max, pmax[i - 1]);
//         }
//         if (i + 1 < n) {
//             umax(a_max, smax[i + 1]);
//         }
//         umin(ans, abs(a_max - b_max));
//     }

//     cout << ans << '\n';
// }

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    // cin >> T;

    while (T--) {
        solve();
    }
}