#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <iomanip>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int sz = 500500;
const ll mod = 1e9 + 7;

ll a[sz], b[sz], c[sz];

bool cmp(int i, int j) {
	return a[i] > a[j];
}

int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i];
		c[i] = i;
	}
	sort(c, c + n, cmp);
	multiset <int> s;
	for (int i = 0; i < n; ++i) {
		s.insert(b[i]);
	}
	ll ans = mod;
	ll mx = -mod;
	for (int i = 0; i < n; ++i) {
		int p = c[i];
		if (i != 0 && a[p] != a[c[i - 1]]) {
			for (int j = i - 1; j >= 0 && a[c[i - 1]] == a[c[j]]; --j) {
				mx = max(mx, b[c[j]]);
				s.erase(b[c[j]]);
			}
		}
		s.erase(b[p]);
		ans = min(ans, abs(a[p] - mx));
		ll x = a[p];
		if (s.find(x) != s.end()) {
			ans = 0;
			break;
		}
		if (s.upper_bound(x) != s.end()) {
			ans = min(ans, *s.upper_bound(x) - x);
		}
		if (s.upper_bound(x) != s.begin()) {
			ans = min(ans, x - *(--s.upper_bound(x)));
		}
		s.insert(b[p]);
	}
	cout << ans;
} 