#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>
#include <cstring>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

#define int long long

void solve() {
	int n; cin >> n;
	vector <pair <int, int>> v(n);
	for (auto& [a, b] : v) cin >> a >> b;

	int ans = 1e15;
	for (int i = 0; i < n; ++i) {
		int mx = -1;
		int cl = 1e15;
		for (int j = 0; j < n; ++j) {
			if (v[j].first > v[i].first) {
				mx = max(mx, v[j].second);
			}
			if (i != j && abs(cl - v[i].first) > abs(v[j].second - v[i].first)) {
				cl = v[j].second;
			}
		}

		if (mx == -1) {
			ans = min(ans, abs(cl - v[i].first));
		}
		else {
			ans = min(ans, abs(mx - v[i].first));
		}
	}

	cout << ans;
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}