#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>
#include <cstring>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

#define int long long

void solve() {
	int n; cin >> n;
	vector <pair <int, int>> v(n);
	for (auto& [a, b] : v) cin >> a >> b;
	sort(all(v));

	int ans = 1e15;
	if (v.back().first == v[v.size() - 2].first) {
		for (int i = 0; i < n; ++i) {
			ans = min(ans, abs(v.back().first - v[i].second));
		}
	}
	else {
		for (int i = 0; i < n - 1; ++i) {
			ans = min(ans, abs(v.back().first - v[i].second));
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (i != j) {
				bool flag = true;
				for (int u = 0; u < n; ++u) {
					if (v[u].first > v[i].first && v[u].second > v[j].second) {
						flag = false;
						break;
					}
				}
				if (flag) {
					ans = min(ans, abs(v[i].first - v[j].second));
				}
			}
		}
	}

	cout << ans;
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}