#include <bits/stdc++.h>
#define debug(x) cerr << (#x) << " : " << x << endl;
#define all(a) a.begin(), a.end()
#define int long long

typedef long long ll;
typedef double db;
using namespace std;
const int MOD = 1e9 + 7;
const int MAXL = 2e6;
const db eps = 1e-9;

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n; cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i].first >> a[i].second;
    sort(all(a));
    vector<int> suf(n + 1);
    suf[n] = 0;
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(suf[i + 1], a[i].second);
    }
    set<int> s;
    int ans = INT32_MAX;
    for (int i = 0; i < n; ++i) {
        int mxA = a[i].first;
        int mxB = suf[i + 1];
        if (mxB > mxA) {
            ans = min(ans, mxB - mxA);
            s.insert(a[i].second);
            continue;
        }
        auto it = s.lower_bound(mxA);
        if (it != s.end()) {
            ans = min(ans, abs(*it - mxA));
        }
        if (it != s.begin()) {
            --it;
            ans = min(ans, abs(*it - mxA));
        }
        s.insert(a[i].second);
    }
    cout << ans;
    return 0;
}