#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

const ll mod = 998244353;

const ll INF = 1e18;

vector<ll> used, cur1, cur2, a, b;
ll ans = INF;

void gen(ll i, ll n) {
    if (i == n) {
        ll k = INF;
        for (auto x : cur1) {
            for (auto y : cur2) {
                k = min(k, abs(x - y));
            }
        }
        ans = min(ans, k);
        return;
    }
    for (ll d = 0; d < n; d++) {
        if (!used[d]) {
            cur1.push_back(a[d]);
            used[d] = 1;
            gen(i + 1, n);
            cur1.pop_back();
            cur2.push_back(b[d]);
            gen(i + 1, n);
            cur2.pop_back();
            used[d] = 0;
        }
    }
}

void solve() {
    ll n;
    cin >> n;
    a.resize(n);
    b.resize(n);
    used.resize(n);
    bool f = true;
    for (ll i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        if (a[i] != b[i]) {
            f = false;
        }
    }
//    if (f) {
//        vector<ll> p = a;
//        sort(p.begin(), p.end());
//        ll mn = INF;
//        for (ll i = 1; i < n; i++) {
//            mn = min(mn, p[i] - p[i - 1]);
//        }
//        cout << mn;
//        return;
//    }
    gen(0, n);
    cout << ans;
    a.clear();
    b.clear();
    used.clear();
    ans = INF;
}

int main() {
#ifdef LOCAL
    ll clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif
    for (; tpk; tpk--) {
        solve();
        cout << '\n';
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}