#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

const ll mod = 998244353;

const ll INF = 1e18;

ll f1(ll n, vector<ll> &a, vector<ll> &b) {
    ll ans = INF;
    for (ll i = 0; i < n; i++) {
        ll mx1 = a[i];
        ll mx2 = -1;
        vector<ll> extr;
        for (ll j = 0; j < n; j++) {
            if (i == j) {
                continue;
            }
            if (a[j] > mx1) {
                mx2 = max(mx2, b[j]);
            }
            else {
                extr.push_back(b[j]);
            }
        }
        if (mx2 == -1) {
            ll d = INF;
            for (ll j = 0; j < n; j++) {
                if (i == j) {
                    continue;
                }
                if (abs(b[j] - mx1) <= d) {
                    d = abs(b[j] - mx1);
                    mx2 = b[j];
                }
            }
        }
        for (auto x : extr) {
            if (x <= mx2) {
                continue;
            }
            ans = min(ans, abs(x - mx1));
        }
        ans = min(ans, abs(mx2 - mx1));
    }
    return ans;
}

ll f2(ll n, vector<ll> &a, vector<ll> &b) {

}

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    bool f = true;
    for (ll i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        if (a[i] != b[i]) {
            f = false;
        }
    }
    if (f) {
        vector<ll> p = a;
        sort(p.begin(), p.end());
        cout << p[n - 1] - p[n - 2];
        return;
    }
    vector<pair<ll, ll>> pr;
    for (ll i = 0; i < n; i++) {
        pr.emplace_back(a[i], b[i]);
    }
    sort(pr.begin(), pr.end());
    vector<ll> suf(n);
    suf[n - 1] = pr.back().second;
    for (ll i = n - 2; i >= 0; --i) {
        suf[i] = max(suf[i + 1], pr[i].second);
    }
    multiset<ll> s;
    s.insert(-INF);
    for (ll i = 0; i < n; i++) {
        s.insert(b[i]);
    }
    s.insert(INF);
    multiset<ll> extra;
    extra.insert(-INF);
    extra.insert(INF);
    ll last =  -1;
    ll ans = INF;
    for (ll i = 0; i < n; i++) {
        if (last != pr[i].first) {
            last = pr[i].first;
            ll j = i;
            while (j < n && pr[j].first == pr[i].first) {
                extra.insert(pr[j].second);
                j++;
            }
        }
        extra.erase(extra.find(pr[i].second));
        ll mx1 = pr[i].first;
        pair<ll, ll> pr1 = make_pair(mx1 + 1, -1);
        ll mx2 = -INF;
        if (pr[i].first != pr.back().first)
            mx2 = suf[lower_bound(pr.begin(), pr.end(), pr1) - pr.begin()];
        ans = min(ans, abs(mx2 - mx1));
        auto it = extra.lower_bound(mx1);
        auto it2 = it;
        --it2;
        ans = min(ans, abs(max(*it, mx2) - mx1));
        ans = min(ans, abs(max(*it2, mx2) - mx1));
        extra.insert(pr[i].second);
    }
    cout << ans;
}

int main() {
    srand(time(0));
#ifdef LOCAL
    ll clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif
    for (; tpk; tpk--) {
        solve();
        cout << '\n';
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}