#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <algorithm>

using namespace std;

long long find(long long x, const vector<vector<long long>>& vect) {
	long long L = 0; long long R = vect.size(), c;
	while (R - L > 1) {
		c = (R + L) / 2;
		if (vect[c][0] <= x) {
			L = c;
		}
		else {
			R = c;
		}
	}
	return L;
}

void solve() {
	long long n, inp, mn = 1e18;
	vector<vector<long long>> a, b, vect;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> inp;
		a.push_back({inp, i});
		vect.push_back({inp});
		cin >> inp;
		b.push_back({inp, i});
		vect[i].push_back(inp);
	}

	sort(a.begin(), a.end());
	sort(b.begin(), b.end());
	long long L = n - 1, R = n - 1;
	set<long long> fr, sc;
	if (a[L][1] == b[R][1]) {
		if (a[L][0] > b[R][0]) {swap(a, b);}
		for (; R > -1; --R) {
			mn = min(mn, abs(b[R][0] - a[L][0]));
		}
		cout << mn << endl;
		return;
	}
	while (true) {
		while (L > 0 && a[L][0] >= b[R][0] && !(sc.count(a[L][1]))) {
			fr.insert(a[L][1]);
			--L;
			mn = min(mn, abs(a[L][0] - b[R][0]));
		}
		while (R > 0 && a[L][0] <= b[R][0] && !(fr.count(b[R][1]))) {
			sc.insert(b[R][1]);
			--R;
			mn = min(mn, abs(a[L][0] - b[R][0]));
		}
		if (!sc.count(a[L][1])) {
			fr.insert(a[L][1]);
			--L;
		}
		else if (fr.count(b[R][1])) {
			break;
		}
	}
	cout << mn << endl;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);cout.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	solve();

	return 0;
}