#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    int bestres = 2000000000;
    for (int max1 = 0; max1 < n; max1++) {
        set<pair<int, int>> second;
        for (int j = 0; j < n; j++) {
            if (j == max1) {
                continue;
            }
            second.emplace(a[j].second, a[j].first);
        }
        while (!second.empty()) {
            auto [m2, m1] = *(--second.end());
            bestres = min(bestres, abs(m2 - a[max1].first));
            if (m1 > a[max1].first) {
                break;
            }
            second.erase(--second.end());
        }
    }

    cout << bestres << "\n";

    return 0;
}
