#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) a.size()
#define dbg(a) cout << #a << " = " << a << endl
#define dbg1(a) cout << #a << " = [ "; for (auto e : a) cout << e << " "; cout << "]" << endl;
#define dbg2(a) cout << #a << " = [ "; for (auto [f, s] : a) cout << " { " << f << ' ' << s << " } " << ' '; cout << "]" << endl;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;

mt19937 rnd(1337);

const int INF = 1e9 + 7;


void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (auto &[a, b] : v) {
        cin >> a >> b;
    }

    sort(all(v));
    vector<int> suff(n + 1);
    suff[n] = -INF;
    for (int i = n - 1; i >= 0; i--)
        suff[i] = max(suff[i + 1], v[i].S);

    set<int> kek;
    int mn = INF;
    for (int i = 0; i < n; i++) {
        int mxa = v[i].F;
        int mxb = suff[i + 1], prv = mxb;
        auto it1 = kek.upper_bound(mxa);
        if (it1 != kek.end()) {
            if (*it1 > prv && abs(*it1 - mxa) < abs(mxb - mxa))
                mxb = *it1;
        }
        if (it1 != kek.begin()) {
            it1 = prev(it1);
            if (*it1 > prv && abs(*it1 - mxa) < abs(mxb - mxa))
                mxb = *it1;
        }
        mn = min(mn, abs(mxb - mxa));
        kek.insert(v[i].S);
    }
    cout << mn << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}