#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define dbg(x) cerr << #x << " : " << x << '\n';
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
using namespace std;
using ll = ::int64_t;
const int INF = 2e9;
void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (auto & [x, y] : a) cin >> x >> y;
    sort(a.begin(), a.end());
    unordered_map<int, int> cnt1;
    set<int> fst;
    map<int, int> s;
    cnt1.reserve(5e5);
    for (auto [x, y] : a) {
        cnt1[x]++;
        s[y]++;
    }
    vector<bool> good(n);
    for (int i = 0; i < n; ++i) {
        if (cnt1[a[i].first] >= 2) good[i] = true;
    }
    int ans = INF;
    for (int i = 0; i < n; ++i) {
        auto [x, y] = a[i];
        s[y]--;
        if (s[y] == 0) s.erase(y);
        if (good[i]) fst.insert(y);
        int b = s.empty() ? INF : s.rbegin()->first;
        if (b >= x) {
            ans = min(ans, b - x);
        } else {
            ans = min(ans, x - b);
        }
        if (b < x || s.empty()) {
            auto it = fst.lower_bound(x);
            if (it != fst.end()) {
                ans = min(ans, *it - x);
            }
            it = fst.upper_bound(x);
            if (it != fst.begin()) {
                --it;
                if (*it > b)
                    ans = min(ans, x - *it);
            }
        }
        if (!good[i]) fst.insert(y);
    }
    cout << ans << '\n';
}

int main() {
    int tt = 1;
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
    cin >> tt;
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    while (tt--) solve();
    return 0;
}