#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <stack>

#define all(x) x.begin(),x.end()
#define f first
#define s second

using namespace std;

const int maxn = 5e5;
int suffmax[maxn];

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    //cin >> tests;
    tests = 1;
    while (tests--) {
        int n;
        cin >> n;
        vector<pair<int, int> > a(n);
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            cin >> a[i].f >> a[i].s;
            if (a[i].f == a[i].s) {
                cnt++;
            }
        }
        sort(all(a));
        if (cnt == n) {
            cout << a[n - 1].f - a[n - 2].f;
            return 0;
        }
        int _a[maxn];
        for (int i = 0; i < n; ++i) _a[i] = n;
        stack<int> st;
        for (int i = 0; i < n; ++i) {
            while (!st.empty() && a[st.top()].f < a[i].f) {
                _a[st.top()] = i;
                st.pop();
            }
            st.push(i);
        }
        int ans = 1e9;
        suffmax[n - 1] = a[n - 1].s;
        for (int i = n - 2; i >= 0; --i) {
            suffmax[i] = max(suffmax[i + 1], a[i].s);
        }

        multiset<int> s1, s2;
        for (int i = 0; i < n; ++i) {
            s2.insert(a[i].s);
        }
        for (int i = 0; i < n; ++i) {
            s2.erase(s2.find(a[i].s));
            if (a[i].f < a.back().f) {
                int mx = suffmax[_a[i]];
                ans = min(ans, abs(a[i].f - mx));

                auto i1 = s1.upper_bound(mx);
                if (i1 == s1.end()) continue;
                auto i2 = lower_bound(i1, s1.end(), a[i].f);
                if (i2 != s1.end()) ans = min(ans, abs(a[i].f - *i2));
                if (i2 != s1.begin()) {
                    i2--;
                    if (*i2 > mx) {
                        ans = min(ans, abs(a[i].f - *i2));
                    }
                }
            } else {
                auto i1 = s1.lower_bound(a[i].f), i2 = s2.lower_bound(a[i].f);
                if (i1 != s1.end()) ans = min(ans, abs(a[i].f - *i1));
                if (i1 != s1.begin()) {
                    i1--;
                    ans = min(ans, abs(a[i].f - *i1));
                }
                if (i2 != s2.end()) ans = min(ans, abs(a[i].f - *i2));
                if (i2 != s2.begin()) {
                    i2--;
                    ans = min(ans, abs(a[i].f - *i2));
                }
            }
            s1.insert(a[i].s);
        }
        cout << ans;
    }
    return 0;
}