#pragma 'GCC-optimize'
#pragma 'unroll-loops'
#pragma 'avx'
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <stack>

using namespace std;

const int maxn = 5e5;
int suffmax[maxn];

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    //cin >> tests;
    tests = 1;
    while (tests--) {
        int n;
        cin >> n;
        vector<pair<int, int> > a(n);
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            cin >> a[i].first >> a[i].second;
            if (a[i].first == a[i].second) {
                cnt++;
            }
        }
        sort(a.begin(), a.end());
        if (cnt == n) {
            cout << a[n - 1].first - a[n - 2].first;
            return 0;
        }
        int _a[maxn];
        for (int i = 0; i < n; ++i) _a[i] = n;
        stack<int> st;
        for (int i = 0; i < n; ++i) {
            while (!st.empty() && a[st.top()].first < a[i].first) {
                _a[st.top()] = i;
                st.pop();
            }
            st.push(i);
        }
        int ans = 1e9;
        suffmax[n - 1] = a[n - 1].second;
        for (int i = n - 2; i >= 0; --i) {
            suffmax[i] = max(suffmax[i + 1], a[i].second);
        }

        multiset<int> s1, s2;
        for (int i = 0; i < n; ++i) {
            s2.insert(a[i].second);
        }
        for (int i = 0; i < n; ++i) {
            s2.erase(s2.find(a[i].second));
            if (a[i].first < a.back().first) {
                int mx = suffmax[_a[i]];
                ans = min(ans, abs(a[i].first - mx));

                auto i1 = s1.upper_bound(mx);
                auto i2 = lower_bound(i1, s1.end(), a[i].first);
                if (i2 != s1.end()) ans = min(ans, abs(a[i].first - *i2));
                if (i2 != s1.begin()) {
                    i2--;
                    if (*i2 > mx) {
                        ans = min(ans, abs(a[i].first - *i2));
                    }
                }
            } else {
                auto i1 = s1.lower_bound(a[i].first), i2 = s2.lower_bound(a[i].first);
                if (i1 != s1.end()) ans = min(ans, abs(a[i].first - *i1));
                if (i1 != s1.begin()) {
                    i1--;
                    ans = min(ans, abs(a[i].first - *i1));
                }
                if (i2 != s2.end()) ans = min(ans, abs(a[i].first - *i2));
                if (i2 != s2.begin()) {
                    i2--;
                    ans = min(ans, abs(a[i].first - *i2));
                }
            }
            s1.insert(a[i].second);
        }
        cout << ans;
    }
    return 0;
}