#include<bits/stdc++.h>

using namespace std;

struct Point
{
    int x,y;
    Point(){};
    Point(int xi, int yi)
    {
        x = xi;
        y = yi;
    }
};

const int maxn = 5*1e5+5;
int n;
long long a[maxn],b[maxn];
bool f1;
vector<Point>v;
multiset<long long>myset;
map<long long,int>mymap;

void read()
{
    f1 = true;
    cin >> n;
    for(int i=1;i<=n;i++)
    {
        cin >> a[i] >> b[i];
        if(a[i]!=b[i]) f1 = false;
        v.push_back({a[i],b[i]});
    }
}

bool cmp(Point p1, Point p2)
{
    if(p1.x<p2.x) return true;
    if(p1.x>p2.x) return false;
    return p1.y>p2.y;
}

void solve()
{
    sort(v.begin(),v.end(),cmp);
    int sz = v.size();
    if(f1)
    {
        cout << abs(v[sz-2].x-v[sz-1].x) << endl;
        return;
    }
    for(int i=0;i<sz;i++)
    {
        myset.insert(v[i].y);
        mymap[v[i].y]++;
    }
    long long maxb = -1;
    long long ans = 1e9;
    long long pom;
    long long ch1,ch2;
    for(int i=sz-1;i>=0;i--)
    {
        if(maxb== -1) pom = 1e9;
        else pom = abs(v[i].x-maxb);
        mymap[v[i].y]--;
        if(mymap[v[i].y]==0) myset.erase(v[i].y);
        if(v[i].x>maxb)
        {
            ch1 = ch2 = -1;
            mymap[v[i].x]++;
            myset.insert(v[i].x);
            auto it = myset.find(v[i].x);
            if(it!=myset.begin())
            {
                it--;
                ch1 = (*it);
                it++;
            }
            it++;
            if(it!=myset.end())
            {
                ch2 = (*it);
            }
            if(ch1!=-1&&ch1>maxb) pom = min(pom,abs(v[i].x-ch1));
            if(ch2!=-1&&ch2>maxb) pom = min(pom,abs(v[i].x-ch2));
            mymap[v[i].x]--;
            if(mymap[v[i].x]==0) myset.erase(v[i].x);
            //pom = min(pom,(long long)abs(v[i].x-v[j].y));
        }
        ans = min(ans,pom);
        maxb = max(maxb,(long long)v[i].y);
    }
    cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
	solve();
	return 0;
}

