#include <bits/stdc++.h>

using namespace std;

const int N = 5e5 + 7;

int n;
pair<int, int> a[N];
int b[N];

bool check(int d) {
	int ptr = n;
	int mx = 0;
	for (int i = n - 1; i >= 0; --i) {
		while (ptr > 0 && b[ptr - 1] >= a[i].first - d) {
			--ptr;
		}
		bool ok = ptr < n && b[ptr] <= a[i].first;
		if (ok && b[ptr] == a[i].second) {
			ok = ptr + 1 < n && b[ptr + 1] <= a[i].first;
		}
		if (ok && mx <= a[i].first) {
			return true;
		}
		mx = max(mx, a[i].second);
	}
	return false;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	int ans = 1e9;
	for (int it = 0; it < 2; ++it) {
		sort(a, a + n);
		for (int i = 0; i < n; ++i) {
			b[i] = a[i].second;
		}
		sort(b, b + n);
		int l = -1, r = 1e9;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (check(mid)) {
				r = mid;
			} else {
				l = mid;
			}
		}
		ans = min(ans, r);
		for (int i = 0; i < n; ++i) {
			swap(a[i].first, a[i].second);
		}
	}
	cout << ans << endl;
	return 0;
}