#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<iomanip>

using namespace std;

#define ll long long


/*void build(int idx, int tl, int tr, vector<pair<int, int>>& v, vector<int>& t) {
	if (tl == tr) {
		t[idx] = v[tl].second;
	}
	else {
		int tm = (tl + tr) / 2;

		build((idx << 1) + 1, tl, tm, v, t);
		build((idx << 1) + 2, tm + 1, tr, v, t);

		t[idx] = max(t[(idx << 1) + 1], t[(idx << 1) + 2]);
	}
}

int gets(int idx, int tl, int tr, int l, int r, vector<int>& t) {
	if (tl == l && tr == r) {
		return t[idx];
	}
	else if (l > r) {
		return -1;
	}
	else {
		int tm = (tl + tr) / 2;

		return max(gets((idx << 1) + 1, tl, tm, l, min(r, tm), t),
			gets((idx << 1) + 2, tm + 1, tr, max(tm + 1, l), r, t));
	}
}*/


int main() {
	int n;
	cin >> n;


	vector<pair<int, int>> v(n);
	for (int i = 0; i < n; i++) {
		int a, b;
		cin >> a >> b;

		v[i].first = a;
		v[i].second = b;
	}

	sort(v.begin(), v.end());

	vector<int> mx(n);
	mx[n - 1] = v[n - 1].second;
	for (int i = n - 2; i >= 0; i--) {
		mx[i] = max(mx[i + 1], v[i].second);
	}

	//vector<int> t(4 * n);

	//build(0, 0, n - 1, v, t);

	int ans = 1e9 + 10;

	set<int> s1;
	set<int> s2;

	for (int i = 0; i < n; i++) {

		int m1 = v[i].first;

		int m2 = -1;

		if (i < n - 1) {
			//m2 = gets(0, 0, n - 1, i + 1, n - 1, t);

			m2 = mx[i + 1];

			if (abs(m2 - m1) < ans) {
				ans = abs(m2 - m1);
			}
		}

		if (m2 < m1) {
			auto it1 = lower_bound(s1.begin(), s1.end(), m1);

			if (it1 != s1.end()) {
				int m1v = *it1;

				if (m1v > m2) {
					ans = min(ans, m1v - m1);
				}
			}

			auto it2 = lower_bound(s2.begin(), s2.end(), -m1);

			if (it2 != s2.end()) {
				int m1d = -(*it2);

				if (m1d > m2) {
					int k = abs(m1d - m1);
					ans = min(ans, abs(m1d - m1));
				}
			}
		}

		s1.insert(v[i].second);
		s2.insert(-v[i].second);
	}

	cout << ans;
}