#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<ll> t(2e6);

void build(ll v, ll l, ll r, vector<ll>& b) {
    if (r - l == 1) {
        t[v] = b[l];
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v + 1, l, m, b);
    build(2 * v + 2, m, r, b);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

ll get(ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || r <= ql) {
        return -1;
    }
    if (l >= ql && r <= qr) {
        return t[v];
    }
    ll m = (l + r) / 2;
    return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

signed main() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> tmp(n);
    for (ll i = 0; i < n; ++i) {
        cin >> tmp[i].first >> tmp[i].second;
    }
    sort(tmp.begin(), tmp.end());
    vector<ll> a(n), b(n);
    for (ll i  = 0; i < n; ++i) {
        a[i] = tmp[i].first;
        b[i] = tmp[i].second;
    }
    vector<ll> b_sorted = b;
    sort(b_sorted.begin(), b_sorted.end());
    build(0, 0, n, b);
    ll ans = 2e10;
    for (ll i = 0; i < n; ++i) {
        if (a[i] == a.back()) {
            ll ind1 = lower_bound(b_sorted.begin(), b_sorted.end(), a[i]) - b_sorted.begin();
            ll ind2 = ind1 - 1;
            if (ind1 >= 0 && ind1 < ll(b_sorted.size())) {
                if (b_sorted[ind1] == b[i]) {
                    ++ind1;
                }
                if (ind1 >= 0 && ind1 < ll(b_sorted.size())) {
                    ans = min(ans, abs(a[i] - b_sorted[ind1]));
                }
            }
            if (ind2 >= 0 && ind2 < ll(b_sorted.size())) {
                if (b_sorted[ind2] == b[i]) {
                    --ind2;
                }
                if (ind2 >= 0 && ind2 < ll(b_sorted.size())) {
                    ans = min(ans, abs(a[i] - b_sorted[ind2]));
                }
            }
            continue;
        }
        ll ub_i = upper_bound(a.begin(), a.end(), a[i]) - a.begin();
        ll least_good = get(0, 0, n, ub_i, n);
        if (least_good >= a[i]) {
            ans = min(ans, abs(least_good - a[i]));
        } else {
            ll ind1 = lower_bound(b_sorted.begin(), b_sorted.end(), a[i]) - b_sorted.begin();
            ll ind2 = ind1 - 1;
            if (ind1 >= 0 && ind1 < ll(b_sorted.size())) {
                if (b_sorted[ind1] == b[i]) {
                    ++ind1;
                }
                if (ind1 >= 0 && ind1 < ll(b_sorted.size())) {
                    ans = min(ans, abs(a[i] - b_sorted[ind1]));
                }
            }
            if (ind2 >= 0 && ind2 < ll(b_sorted.size())) {
                if (b_sorted[ind2] == b[i]) {
                    --ind2;
                }
                if (ind2 >= 0 && ind2 < ll(b_sorted.size()) && b_sorted[ind2] >= least_good) {
                    ans = min(ans, abs(a[i] - b_sorted[ind2]));
                }
            }
        }
    }
    cout << ans;
}