#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define PB push_back

using namespace std;
ll t, n, k, m;

void solve() {
    cin >> n;
    vector <ll> a(n), b(n);
    vector <ll> used(n);
    vector <pair<ll, ll>> mas1, mas2;
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        mas1.PB({a[i], i});
        mas2.PB({b[i], i});
    }
    ll ans = LLONG_MAX;
    sort(mas1.begin(), mas1.end());
    sort(mas2.begin(), mas2.end());
    ll l = n - 1;
    for (int i = 0; i < n; i++) {
        used[mas1[i].S] = 1;
        while (l > 0 && used[mas2[l].S]) {
            l--;
        }
        if (l != -1) {
            ans = min(ans, abs(mas1[i].F - mas2[l].F));
        }
        if (l == -1 || mas2[l].F < mas1[i].F) {
            ll l1 = 0;
            ll r1 = n;
            while (l1 + 1 < r1) {
                ll x = (l1 + r1) / 2;
                if (mas2[x].F <= mas1[i].F) {
                    l1 = x;
                }
                else {
                    r1 = x;
                }
            }
            if (mas2[l1].S != mas1[i].S) {
                ans = min(ans, abs(mas2[l1].F - mas1[i].F));
            }
            else if (l1 != 0) {
                ans = min(ans, abs(mas2[l1 - 1].F - mas1[i].F));
            }
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) {
        solve();
    }
}
