#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,sse,ssse,sse2,sse3,tune=native")

#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <numeric>
#include <cassert>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;


int get(int mx, int a){
    if (mx == -1){
        return 0;
    }
    return abs(mx - a);
}

int ans(vector<int> &a, vector<int> &b){
    int n = a.size();
    int mn = 1000001303;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int mask1 = mask;
        int mx[2] = {-1000001303, -1000001303};
        for (int i = 0; i < n; ++i) {
            if (mask1 % 2){
                mx[1] = max(mx[1], b[i]);
            } else{
                mx[0] = max(mx[0], a[i]);
            }
            mask1 /= 2;
        }
        mn = min(mn, abs(mx[0] - mx[1]));
    }
    return mn;
}

int main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        v[i] = {a[i], b[i]};
//        cin >> v[i].first >>i v[i].second;
    }
    sort(v.rbegin(), v.rend());
    int l = -1;
    int r = 1e9;
    while (r - l > 1) {
        int m = (l + r) / 2;
        multiset<int> bb;
        for (int i = 0; i < n; ++i) {
            bb.insert(v[i].second);
        }
        int mx = -1;
        bool f = false;
        for (int i = 0; i < n; ++i) {
            bb.erase(bb.find(v[i].second));
            auto it = bb.lower_bound(v[i].first - m);
            int x = -1;
            if (it != bb.end()){
                x = *it;
            }
            if (mx != -1 && get(mx, v[i].first) <= m){
                f = true;
                break;
            }
            if (x != -1 && get(max(mx, x), v[i].first) <= m){
                f = true;
                break;
            }
            mx = max(mx, v[i].second);

        }
        if (f){
            r = m;
        } else{
            l = m;
        }
    }

    cout << r << endl;
//    assert(r == ans(a, b));
#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}