#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

#define vec vector
#define pb push_back
#define sz(x) (int) (x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using str = string;

#ifdef Local
#define debug(x) cout << endl \
                      << "$ " << #x << " = " << x << endl
#else
#define debug(...) 1337
#endif

void solve() {
    int n;
    cin >> n;
    vec<pair<int, int>> c(n);
    for (auto &[l, r]: c)
        cin >> l >> r;
    sort(all(c));
    multiset<int> ms;
    for (int i = 0; i < n - 1; ++i)
        ms.insert(c[i].second);
    auto it = ms.lower_bound(c.back().first);
    int ans = (int) 1e15;
    if (it != ms.end())
        ans = abs(c.back().first - *it);
    if (it != ms.begin())
        ans = min(ans, abs(c.back().first - *--it));
    int m = c.back().second;
    for (int i = n - 2; i >= 0; --i) {
        ms.erase(ms.find(c[i].second));
        m = max(m, c[i + 1].second);
        if (m >= c[i].first)
            ans = min(ans, m - c[i].first);
        else {
            it = ms.lower_bound(c[i].first);
            if (it != ms.end())
                ans = min(ans, abs(c[i].first - *it));
            if (it != ms.begin())
                ans = min(ans, abs(c[i].first - *--it));
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();

    return 0;
}