#include <bits/stdc++.h>

using namespace std;

#define int long long
#define F first
#define S second
#define endl '\n'
#define double long double

bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.S < b.S;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    cout << setprecision(17);

    int n;
    cin >> n;

    vector<pair<int, int>> a(n);

    multiset<int> mp;

    for (int i = 0; i < n; i++) {
        cin >> a[i].F >> a[i].S;

        mp.insert(a[i].S);
    }

    sort(a.begin(), a.end());

    int ans = 1e10;

    int mx = -1e10;

    for (int i = n - 1; i >= 0; i--) {
        int x = a[i].F;

        int aabs = abs(x - mx);

        mp.erase(mp.find(a[i].S));

        auto it1 = mp.upper_bound(x);
        auto it2 = mp.upper_bound(x);

        int x1 = -1;
        int x2 = -1;

        if (it1 != mp.end()) {
            x1 = *it1;

            if (aabs > abs(x - x1) and x1 > mx) {
                aabs = abs(x - x1);
            }
        }
        if (it2 != mp.begin()) {
            it2--;
            x2 = *it2;

            if (aabs > abs(x - x2) and x2 > mx) {
                aabs = abs(x - x2);
            }
        }

        mx = max(mx, x);

        ans = min(ans, aabs);
    }

    cout << ans;

    return 0;
}

/*
 5
1 5
2 7
3 3
4 10
2 5
 */
