#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <deque>
#include <queue>
#include <memory.h>
#include <iomanip>
#include <random>
#include <ctime>
#define int long long
#define pii pair<int,int>
#define pb push_back
#define fir first
#define sec second
#define endl '\n'
#define double long double
#define INF 10000000009
#define itn int
#define swpa swap
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
using namespace std;

const int N = 100005, MOD = 1e9 + 7, R = 1 << 20;

mt19937 rnd(228);

bool cmp(pii a, pii b) {
	return a.second < b.second;
}
void solve(int n, vector<pii>& vc) {
	int ans = INF;
	sort(rall(vc));
	cout << vc[0].first - vc[1].first;
	return;
}

vector<vector<int>> tree(2 * R + 1);
int ans = INF;
void build() {
	for (int i = R - 1; i > 0; i--) {
		int p1 = 0, p2 = 0;
		while (p1 < tree[i * 2].size() && p2 < tree[i * 2 + 1].size()) {
			if (tree[i * 2][p1] < tree[i * 2 + 1][p2]) {
				tree[i].pb(tree[i * 2][p1]); p1++;
			}
			else {
				tree[i].pb(tree[i * 2 + 1][p2]);
				p2++;
			}
		}
		while (p1 < tree[i * 2].size()) {
			tree[i].pb(tree[i * 2][p1]);
			p1++;
		}
		while (p2 < tree[i * 2 + 1].size()) {
			tree[i].pb(tree[i * 2 + 1][p2]);
			p2++;
		}
	}
}

void operation(int ql, int qr, int v, itn nl, int nr, int mx1, int mx2) {
	if (ql <= nl && nr <= qr) {
		auto u = upper_bound(all(tree[v]), max(mx1, mx2));
		if (u != tree[v].end())
			ans = min(ans, abs(mx1 - *u));
		if (u != tree[v].begin()) {
			u--;
			if (*u >= max(mx1,mx2))
			ans = min(ans, abs(mx1 - *u));
		}
		return;
	}
	if (nr < ql || nl > qr)
		return;
	int nm = (nl + nr) / 2;
	operation(ql, qr, 2 * v, nl, nm, mx1, mx2);
	operation(ql, qr, 2 * v + 1, nm + 1, nr, mx1, mx2);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(17);
	srand(time(0));

	int n = 5;
	cin >> n;
	vector<pii>vc(n);
	for (auto& i : vc) //i.first = rnd() % 100 + 1, i.second = rnd() % 100 + 1;
		cin >> i.first >> i.second;

	bool lol = 1;
	for (pii i : vc)
		lol &= (i.fir == i.sec);
	if (lol) {
		solve(n, vc);
		return 0;
	}
	//sort(all(vc), cmp);
	sort(all(vc));
	vector<int> two;
	for (itn i = 0; i < n; i++) {
		tree[R + i].pb(vc[i].sec);
		two.pb(vc[i].fir);
	}
	vector<int> sufmax(n);
	sufmax[n - 1] = vc[n - 1].second;
	for (itn i = n - 2; i >= 0; i--)
		sufmax[i] = max(vc[i].second, sufmax[i + 1]);
	build();
	for (int i = 0; i < n; i++) {
		int mx1 = vc[i].first;
		auto u = upper_bound(all(two), mx1) - two.begin();
		int mx2 = -INF;
		if (u != n)
			mx2 = sufmax[u];
		ans = min(ans, abs(mx1 - mx2));
		operation(0, u - 2, 1, 0, R - 1, mx1, mx2);
	}
	cout << ans;
	return 0;
}
/*
5
19 20
38 48
51 93
54 21
81 96

5
5 95
37 59
48 30
59 98
66 7
*/