#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
const int N = 500001;

bool cmp(pair<int, int> &a, pair<int, int> &b) {
    if (a.first != b.first)return a < b;
    return b.first > b.second;
}

int sufmx[N];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int, int>> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i].first >> c[i].second;
    }
    sort(c.begin(), c.end(), cmp);
    sufmx[n - 1] = c[n - 1].second;
    for (int i = n - 2; i >= 0; --i) {
        sufmx[i] = max(sufmx[i + 1], c[i].second);
    }
    int ans = 2e9;
    set<int> d;
    set<int> d1;
    int x1, y1;
    for (int i = 0; i < n; ++i) {
        int x = c[i].first;
        int mx = sufmx[i + 1];
        if (i == 0) {
            ans = min(ans, abs(x - mx));
            d.insert(c[i].second);
            d1.insert(-c[i].second);
            continue;
        }
        if (i == n - 1) {
            x1 = INT_MAX;
            auto z1 = d.lower_bound(x);
            auto z2 = d1.lower_bound(-x);
            if (z1 != d.end()) {
                x1 = *z1;
            }
            y1 = INT_MAX;
            if (z2 != d1.end()) {
                y1 = -*z2;
            }
            ans = min(ans, min(abs(x1 - x), abs(y1 - x)));
        } else {
            if (mx >= x) {
                ans = min(ans, mx - x);
                d.insert(c[i].second);
                d1.insert(-c[i].second);
                continue;
            }
            if (mx < x) {
                x1 = INT_MAX;
                auto z1 = d.lower_bound(x);
                auto z2 = d1.lower_bound(-x);
                if (z1 != d.end()) {
                    x1 = *z1;
                }
                y1 = INT_MAX;
                if (z2 != d1.end()) {
                    y1 = -*z2;
                }
                if (y1 == INT_MAX || y1 < mx) {
                    y1 = mx;
                }
                ans = min(ans, min(x1 - x, min(x - mx, x - y1)));
            }
        }
        d.insert(c[i].second);
        d1.insert(-c[i].second);
    }
    cout << ans;
}
/*
 *
1 0
3
2 4
0 0
4 3
 */