#include <bits/stdc++.h>
#define newline cout << '\n'
#define f first
#define s second
#define all(x) x.begin(), x.end()


using namespace std;
typedef long long ll;
typedef long double ld;


const int inf = 2e9;
const int logn = 22;
const int nmax = 1e5 + 5;
const ll linf = 2e18;
mt19937 rnd(time(0));


bool cmp(pair<int, int> a, pair<int, int> b) {
	return (a.s < b.s || (a.s == b.s && a.f >= b.f));
}


void display(multiset<ll> &l) {
	for (auto it = l.begin(); it != l.end(); ++it) {
		cout << *it << ' ';
	}
	newline;
}

vector<string> g;

void gen(string cur, int &n) {
	if (int(cur.length()) == n) {
		g.push_back(cur);
		return;
	}
	cur += '1';
	gen(cur, n);
	cur.pop_back();
	cur += '0';
	gen(cur, n);
}

void stupid(int &n, vector<pair<ll, ll>> &a) {
	string cur;
	gen(cur, n);

	ll ans = linf;

	for (string k : g) {
		ll l = -linf, r = -linf;
		for (int j = 0; j < n; ++j) {
			if (k[j] == '1') {
				l = max(l, a[j].f);
			} else {
				r = max(r, a[j].s);
			}
		}
		ans = min(ans, abs(r - l));
	}

	cout << ans << '\n';
}


void solve() {
	int n;
	cin >> n;

	ll ans = linf, tmp = linf;
	vector<pair<ll, ll>> a(n);
	unordered_map<ll, ll> cnt;
	multiset<ll> l;

	for (int i = 0; i < n; ++i) {
		// a[i].f = rnd() % 80, a[i].s = rnd() % 80;
		cin >> a[i].f >> a[i].s;
		cnt[a[i].s]++;
	}

	sort(all(a), cmp);
	

	vector<ll> max_suf(n + 1, 0);
	for (int i = n - 1; i > -1; --i) {
		max_suf[i] = max(max_suf[i + 1], a[i].f);
	}

	for (int i = 0; i < n - 1; ++i) {
		if (a[i].s > max_suf[i + 1]) {
			auto it = l.lower_bound(a[i].s);
			if (it != l.end()) {
				ans = min(ans, abs(a[i].s - *it));
				auto it1 = --it;
				if (it != l.begin() && *it1 >= max_suf[i + 1]) {
					ans = min(ans, abs(a[i].s - *it1));
				}
			} else {
				ll lval = *(--l.end());
				ans = min(ans, abs(a[i].s - lval));
			}
		}
		ans = min(ans, abs(a[i].s - max_suf[i + 1]));
		l.insert(a[i].f);
	}

	ll max_val = a[n - 1].s;
	for (int i = 0; i < n; ++i) {
		if (a[i].s == max_val) {
			if (cnt[max_val] > 1) {
				ans = min(ans, abs(a[i].f - max_val));
			}
		} else {
			ans = min(ans, abs(a[i].f - max_val));
		}
	}
	// stupid(n, a);
	cout << ans << '\n';
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
	}

	

	return 0;
}
