#include <bits/stdc++.h>
#define newline cout << '\n'
#define f first
#define s second
#define all(x) x.begin(), x.end()


using namespace std;
typedef long long ll;
typedef long double ld;


const int inf = 2e9;
const int logn = 22;
const int nmax = 1e5 + 5;
const ll linf = 1e18;
mt19937 rnd(time(0));


bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
	return (a.s <= b.s);
}


/*
780661028 2787102752
3291856150 3057977192
3432956247 3381497549
723257380 3671954441
2481595939 215679346
513297504 954942771
805804214 1116026830
4012388928 1401292460
*/


void solve() {
	int n;
	cin >> n;

	ll ans = linf;
	vector<pair<ll, ll>> a(n);

	for (int i = 0; i < n; ++i) {
		cin >> a[i].f >> a[i].s;
	}

	sort(all(a), cmp);

	vector<ll> max_suf(n + 1, 0);
	for (int i = n - 1; i > -1; --i) {
		max_suf[i] = max(max_suf[i + 1], a[i].f);
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (a[j].f > max_suf[i + 1]) {
				ans = min(ans, abs(a[i].s - a[j].f));
			}
		}
		ans = min(ans, abs(a[i].s - max_suf[i + 1]));
	}

	// stupid(n, a);
	cout << ans << '\n';
}


int main() {

#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
	}

	

	return 0;
}
