#include <bits/stdc++.h>


using namespace std;
typedef long long ll;
mt19937 rnd(time(0));
const ll inf = 1e18;


bool cmp(pair<ll, ll> p, pair<ll, ll> b) {
	return (p.second <= b.second);
}



int main() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n;
	cin >> n;

	vector<pair<int, int>> a(n);
	vector<int> suf_max(n + 1, 0);

	for (int i = 0; i < n; ++i) {
		cin >> a[i].second >> a[i].first;
	}

	sort(a.begin(), a.end());

	int ans = 2e9;
	
	for (int i = n - 1; i > -1; --i) {
		suf_max[i] = max(suf_max[i + 1], a[i].second);
	}

	multiset<int> ml;

	for (int i = 0; i < n; ++i) {
		auto it = ml.lower_bound(suf_max[i + 1]);
		if (it != ml.end()) {
			ans = min(ans, abs(a[i].first - *it));
		}
		ans = min(ans, abs(a[i].first - suf_max[i + 1]));
		ml.insert(a[i].second);
	}

	cout << ans << '\n';


	return 0;
}
