#include "bits/stdc++.h"
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2,fma,bmi,bmi2,mmx,tune=native")
#include "bits/extc++.h"
#define all(x) begin(x), end(x)
#define rall(x) x.rbegin(), x.rend()
#define frl(i, x) for(auto& i : x)
#define rep(i, j, k) for(int i = j; i < k; i++)
#define rrep(i, j, k) for(int i = k - 1; i >= j; i--)
#define S second
#define F first

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = double;
using ull = unsigned long long;
using treap = tree<int, null_type>;

int solve1(vector<pair<int, int>> v){
    int n = v.size();
    frl(i, v) i.S = -i.S;
    sort(all(v));
    frl(i, v) i.S = -i.S;
    vector<int> sf_mx;
    int mx = 0;
    rrep(i, 0, n){
        sf_mx.push_back(mx);
        mx = max(mx, v[i].S);
    }
    reverse(all(sf_mx));
    set<int> s;
    int opt = 1e9;
    rep(i, 0, n - 1){
        auto [a,b] = v[i];
        mx = sf_mx[i];
        if(mx >= b){
            opt = min(opt, mx - b);
        }
        else{
            auto it = s.lower_bound(a);
            if(it != s.end()){
                opt = min(opt, abs(a - max(*it, mx)));
            }
            if(it != s.begin()) {
                --it;
                 opt = min(opt, abs(a - max(*it, mx)));
            }
        }
        s.insert(b);
    }
    return opt;
}
int solve2(vector<pair<int, int>> v){
    int n =v.size();
    int opt = 1e9;
    rep(mask, 1, (1<<n)-1){
        int mx1 = 0, mx2 = 0;
        rep(i, 0, n){
            if(mask>>i&1) mx1 = max(mx1, v[i].F);
            else mx2 = max(mx2, v[i].S);
        }
        opt = min(opt, abs(mx1 - mx2));
    }
    return opt;
}

int main(){
    cin.tie(0)->ios::sync_with_stdio(0);
    cout << setprecision(15) << fixed;
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    frl(i,v) cin >>i.F >> i.S;
    cout << (n <= 20 ? solve2(v)  :solve1(v));
}