#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

vector <vector <int> > graph;
vector <bool> used;

void dfs(int v, vector <int> & a) {
    used[v] = 1;
    a.push_back(v);
    for (int i = 0; i < graph[v].size(); ++i) {
        if (!used[graph[v][i]]) {
            dfs(graph[v][i], a);
        }
    }
}

const int mod = 1000000007;

signed main() {

    /*set<int> s;
    s.insert(-1);
    s.insert(-2);
    s.insert(-5);
    s.insert(-6);
    s.insert(-7);
    s.insert(-10);

    cout << *s.lower_bound(-4);*/

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <int> a(n);
    vector <int> b(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }

    int ans = 1e10;

    for (int i = 0; i < (1 << n); ++i) {
        int c = 0, d = 0;
        for (int j = 0; j < n; ++j) {
            if (1 & (i >> j))
                c = max(c, a[j]);
            else
                d = max(d, b[j]);
        }
        ans = min(ans, abs(c - d));
    }

    cout << ans;
}

