#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;

long long a[500000], b[500000], bs[500000], sufm[500000];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    vector<pair<long long, long long>> sr(n);
    for(int i = 0; i <  n; i ++){
        cin >> a[i] >> b[i];
        sr[i] = {a[i], i};
    }

    sort(sr.begin(), sr.end());
    for(int i = 0; i < n; i ++)
        bs[i] = b[sr[i].second];


    sufm[n - 1] = bs[n - 1];
    sufm[n] = 3000000000;
    for(int i = n - 2; i > -1; i --)
        sufm[i] = max(sufm[i + 1], bs[i]);

    set<long long> s;

    long long ans = abs(sr[0].first - sufm[1]);
    s.insert(bs[0]);
    for(int i = 1; i < n; i ++){

        long long a = abs(sr[i].first - sufm[i + 1]);
        auto it1 = s.upper_bound(sr[i].first);
        if(it1 != s.end()){
            if(i == n - 1)
                a = min(a, abs(*it1 - sr[i].first));
            else if(*it1 > sufm[i + 1])
                a = min(a, abs(*it1 - sr[i].first));
        }

        if(it1 != s.begin()){
            it1 --;
            if(i == n - 1)
                a = min(a, abs(*it1 - sr[i].first));
            else if(*it1 >= sufm[i + 1])
                a = min(a, abs(*it1 - sr[i].first));
        }

        ans = min(ans, a);
        s.insert(bs[i]);
    }
    cout<< ans << "\n";

  return 0;
}
