#include <bits/stdc++.h>

using namespace std;

vector<int> tree_max(2e6, 0);

void build(int v, int tl, int tr, vector<vector<int>> &arr) {
    if (tl + 1 == tr) {
        tree_max[v] = arr[tl][1];
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v + 1, tl, tm, arr), build(2 * v + 2, tm, tr, arr);
    tree_max[v] = max(tree_max[2 * v + 1], tree_max[2 * v + 2]);
}

int get_max(int v, int tl, int tr, int x) {
    if (tl + 1 == tr) {
        return tl;
    }
    int tm = (tl + tr) / 2;
    if (tree_max[2 * v + 2] <= x) {
        return get_max(2 * v + 1, tl, tm, x);
    } else {
        return get_max(2 * v + 2, tm, tr, x);
    }
}

void update(int v, int tl, int tr, int pos, int val) {
    if (tl + 1 == tr) {
        tree_max[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos < tm) {
        update(2 * v + 1, tl, tm, pos, val);
    } else {
        update(2 * v + 2, tm, tr, pos, val);
    }
}

signed main() {
    //ifstream cin("text.in");
    //ofstream cout("text.out");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, i, mi = 2e9, j, k;
    cin >> n;
    if (n > 5000) {
        vector<int> c(n);
        for (i = 0; i < n; i++) {
            cin >> c[i] >> c[i];
        }
        sort(c.begin(), c.end());
        cout << c[n - 1] - c[n - 2];
        return 0;
    }
    vector<int> a(n), b(n), to_ind(n);
    vector<vector<int>> c(n);
    vector<unordered_map<int, int>> dp(n);
    for (i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        c[i] = {b[i], a[i], i};
    }
    sort(c.begin(), c.end());
    for (i = 0; i < n; i++) {
        to_ind[c[i][2]] = i;
    }
    build(0, 0, n, c);
    for (i = 0; i < n; i++) {
        update(0, 0, n, to_ind[i], -1e9);
        int pos = get_max(0, 0, n, a[i]);
        for (; pos < n; pos++) {
            mi = min(mi, abs(a[i] - c[pos][0]));
        }
        update(0, 0, n, to_ind[i], a[i]);
    }
    cout << mi;
}