#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <stack>
#include <queue>
#include <set>
#include <deque>
#include <chrono>
#include <random>
#include <iomanip>
#include <assert.h>
#include <numeric>
#include <bitset>
#include <string>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
using ll = long long;
using ld = long double;
#define int long long
ll inf = 1e9 + 7;
ll inf_ = 1e18 + 4;
const int mod = 1e9 + 7;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

signed main() {
    //freopen("collider.in", "r", stdin);
    //freopen("collider.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    bool f = 1;
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        if (a[i] != b[i]) f = 0;
    }
    if (f) {
        sort(a.begin(), a.end());
        cout << a[n - 1] - a[n - 2];
        return 0;
    }
    vector<pair<int, int>> t;
    for (int i = 0; i < n; i++) {
        t.push_back({a[i], b[i]});
    }
    sort(t.begin(), t.end());
    int ans = inf_;
    for (int i = 0; i < n; i++) {
        int max_ = -inf_;
        for (int j = i + 1; j < n; j++) max_ = max(max_, t[j].second);
        for (int j = 0; j < i; j++) {
            if (abs(t[i].first - t[j].second) < abs(t[i].first - max_) && t[j].second < max_) max_ = t[j].second;
        }
        ans = min(ans, abs(t[i].first - max_));
    }
    cout << ans;
    return 0;
}