#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <set>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

int mx[MAXN + 5];

bool cmp(pair<int, int> x, pair<int, int> y)
{
    if (x.first != y.first) return (x.first < y.first);
    return (x.second > y.second);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    vector< pair<int, int> > v;
    for (int i = 1; i <= n; ++ i)
    {
        int a, b;
        cin >> a >> b;
        v.push_back({a, b});
    }

    sort(v.begin(), v.end(), cmp);

    mx[n] = -1;
    for (int i = n - 1; i >= 0; -- i)
    {
        mx[i] = max(mx[i + 1], v[i].second);
    }

    set<int> s;
    int ans = 1e9 + 1;
    for (int i = 0; i < n; ++ i)
    {
        int mxb = mx[i + 1];
        if (mxb >= v[i].first) ans = min(ans, mxb - v[i].first);
        else
        {
            ans = min(ans, v[i].first - mxb);
            auto it = lower_bound(s.begin(), s.end(), v[i].first);
            if (it != s.end()) ans = min(ans, (*it) - v[i].first);
            if (it != s.begin())
            {
                it--;
                ans = min(ans, v[i].first - max((*it), mxb));
            }
        }
        s.insert(v[i].second);
    }

    cout << ans << endl;

    return 0;
}
