#include<bits/stdc++.h>
using namespace std;

int const MAXN=5001;
int n;
bool dp[MAXN][MAXN];

struct edge
{
    int l, r;
};

edge a[500001];

void fill_dp(int pos, int i, int j)
{
    if(pos == n)
    {
        dp[i][j] = 1;
        return;
    }
    if(a[pos+1].l > a[i].l) fill_dp(pos+1, pos+1, j);
    if(a[pos+1].r > a[j].r) fill_dp(pos+1, i, pos+1);
    if(a[pos+1].l <= a[i].l || a[pos+1].r <= a[j].r) fill_dp(pos+1, i, j);
}

void read()
{
    cin>>n;
    int max1 = 0, max2 = 0;
    for(int i=1; i<=n; i++)
    {
        cin>>a[i].l>>a[i].r;
        if(a[i].l >= max1)
        {
            max2 = max1;
            max1 = a[i].l;
        }
        else if(a[i].l > max2) max2 = a[i].l;
    }
    if(n <= 5000)
    {
        fill_dp(1, 0, 1);
        fill_dp(1, 1, 0);
        int ans = 1e9+7;
        for(int i=1; i<=n; i++)
        {
            for(int j=1; j<=n; j++)
            {
                if(dp[i][j] == 1)
                {
                    ans = min(ans, abs(a[i].l - a[j].r));
                }
            }
        }
        cout<<ans<<endl;
    }
    else
    {
        cout<<max1 - max2<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
