#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

#define LC(V) (2*(V)+1)
#define RC(V) (2*(V)+2)

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

map<ll, ll> cache;

ll query(ll p) {
    if (cache.find(p) != cache.end()) return cache[p];
    cout << "? " << p << endl;
    ll res;
    cin >> res;
    if (res == -1) exit(0);
    return cache[p] = res;
}


ll cont(ll p) {
    if (p == 0) return 0;
    ll res1 = query(p);
    ll res2 = p * (p + 1) / 2;
    return res2 - res1;
}

ll cont(ll l, ll r) {
    return cont(r - 1) - cont(l - 1);
}

void solve(vector<ll> &ans, ll l, ll r) {
    ll cur = cont(l, r);
    if (cur == 0) return;
    if (l + 1 == r || 2 * l + 1 > cur) {
        ans.push_back(cur);
        return;
    }
    ll m = (l + r) / 2;
    solve(ans, l, m);
    solve(ans, m, r);
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    ll t;
    cin >> t;
    while (t--) {
        cache.clear();
        ll n, k;
        cin >> n >> k;
        vector<ll> ans;
        solve(ans, 1, n + 1);
        cout << "! ";
        for (ll e: ans) cout << e << ' ';
        cout << endl;
        int result;
        cin >> result;
        if (result == -1) exit(0);
    }
}