#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using ll = long long;
using vi = vector<int>;

int test = 1, n, k;
ll a;
unordered_map<int, ll> dict;
vi ans;

bool is_full(int l, int r, ll ps, ll ss) {
    return 1LL * r * (r + 1) / 2 - 1LL * l * (l - 1) / 2 == ss - ps;
}

bool calc(int l, int r, ll ps, ll ss, int k1, int k2) {
    bool changed = true;
    debug(l << " " << r << " " << ps << " " << ss << " " << k1 << " " << k2);
    while (changed) {
        if (l > r || k1 > k2)
            return true;
        if (is_full(l, r, ps, ss))
            return true;
        if (ss - ps == 0 || (k1 == k2 && k1 == r - l + 1)) {
            for (int i = l; i <= r; i++)
                ans.push_back(i);
            return true;
        }
        ll exp = 1LL * r * (r + 1) / 2 - 1LL * l * (l - 1) / 2 - ss + ps;
        if (k1 == k2 && k1 == 1) {
            ans.push_back(exp);
            return true;
        }
        if (exp <= 2 * l) {
            ans.push_back(exp);
            return true;
        }
        changed = false;
        exp = 1LL * r * (r + 1) / 2 - 1LL * l * (l - 1) / 2 - ss + ps;
        exp -= 1LL * (2 * l + k1 - 1) * (k1 - 1) / 2;
        if (exp < r) {
            ss -= 1LL * r * (r + 1) / 2 - 1LL * exp * (exp + 1) / 2;
            debug(r << " " << exp);
            r = exp;
            changed = true;
        }
        exp = 1LL * r * (r + 1) / 2 - 1LL * l * (l - 1) / 2 - ss + ps;
        exp -= 1LL * (2 * r - k2 + 2) * (k2 - 1) / 2;
        if (l < exp) {
            ps += 1LL * (exp - 1) * exp / 2 - 1LL * (l - 1) * l / 2;
            debug(l << " " << exp);
            l = exp;
            changed = true;
        }
    }
    int m = (l + r) / 2;
    ll a;
    auto it = dict.find(m);
    if (it == dict.end()) {
        cout << "? " << m << endl;
        cin >> a;
        if (a == -1)
            return false;
        dict[m] = a;
    } else {
        a = it->second;
    }
    debug(l << " " << m << " " << r << " " << ps << " " << a << " " << ss);
    if (is_full(l, m, ps, a)) {
        debug(1);
        if (!calc(m + 1, r, a, ss, k1, k2))
            return false;
    } else if (is_full(m + 1, r, a, ss)) {
        debug(2);
        if (!calc(l, m, ps, a, k1, k2))
            return false;
    } else {
        debug(3);
        int cur = ans.size();
        if (!calc(l, m, ps, a, 1, k2 - 1))
            return false;
        if (!calc(m + 1, r, a, ss, max(1, k1 - (int)ans.size() + cur), k2 - ans.size() + cur))
            return false;
    }
    return true;
}

bool solve() {
    dict.clear();
    ans.clear();
    cin >> n >> k;
    cout << "? " << n << endl;
    cin >> a;
    if (a == -1)
        return false;
    dict[n] = a;
    if (!calc(1, n, 0, a, k, k))
        return false;
    cout << "!";
    for (int i = 0; i < k; i++)
        cout << " " << ans[i];
    cout << endl;
    cin >> a;
    return a == 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> test;
    while (test--) {
        if (!solve())
            return 0;
    }
    return 0;
}
