#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

void solve() {
    int n, k;
    cin >> n >> k;
    ll carry = 0;
    int begin = 0;
    vector<int> p;
    vector<ll> used(n + 1, -1);
    for (int i = 0; i < k; i++) {
        int l = begin, r = n + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            ll x;
            if (used[m] == -1) {
                cout << "? " << m << endl;
                cin >> x;
                if (x == -1) {
                    exit(1);
                }
            } else {
                x = used[m];
            }
            used[m] = x;
            if (m * 1ll * (m + 1) / 2 - carry != x) {
                r = m;
            } else {
                l = m;
            }
        }
        p.push_back(r);
        carry += r;
        begin = r;
    }
    cout << "! ";
    for (int i = 0; i < p.size(); i++) {
        cout << p[i] << ' ';
    }
    cout << endl;
    int x;
    cin >> x;
    if (x == -1) {
        exit(1);
    }
}

int main() {
//    freopen("C:\\Users\\olymp\\CLionProjects\\day_2\\input.txt", "r", stdin);
//    freopen("C:\\Users\\olymp\\CLionProjects\\day_2\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << setprecision(20) << fixed;
    int t;
    cin >> t;
    while (t--)
        solve();
}
