#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ft first
#define sd second
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
typedef pair<int,int> pii;

const int N=5e5+228;
const int inf=1e9+1;
const ll Inf=1e18+1;
const int mod=1e9+7;

vector<int> v;

bool comp(pll a,pll b){
    return a.ft<b.ft || (a.ft==b.ft && a.sd>b.sd);
}

bool ask(int x,ll mn){
    cout << "? " << x << endl;
    ll y;
    cin >> y;
    ll k=1LL*x*(x+1)>>1;
    k-=mn;
    return k==y;
}
void write_ans(){
    cout << "! ";
    for(auto x:v) cout << x << " ";
    cout << endl;
}
void solve(){
    int n,k;
    cin >> n >> k;
    v.clear();
    ll mn=0;
    for(int i=0;i<k;i++){
        int l=0,r=n-1;
        while(l<r){
            int mid=(l+r+1)>>1;
            if(ask(mid,mn)==1) l=mid;
            else r=mid-1;
        }
        v.pb(l+1);
        mn+=l+1;
    }
    write_ans();
}
int main()
{
//    #ifdef LOCAL
//    freopen("input.txt","r",stdin);
//    freopen("output.txt","w",stdout);
//    #endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t=1;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
