#include <bits/stdc++.h>

using namespace std;
#define int long long
#define double long double

int getsum(int x, int y) {
    return y * (y + 1) / 2 - x * (x - 1) / 2;
}

int findans(int tl, int tr, int data) {
    int l = tl - 1, r = tr;
    while(l + 1 < r){
        int mid = (l + r) >> 1;
        cout << "? " << mid << endl;
        int x;
        cin >> x;
        x -= data;
        if (getsum(tl, mid) != x)
            r = mid;
        else
            l = mid;
    }
    return r;
}

void solve() {
    int n, k;
    cin >> n >> k;
    if (n <= 1000) {
        int cur_sum = 0;
        vector<int> ans;
        for(int i = 2;i<=n;i += 2){
            cout << "? " << i << endl;
            int x;
            cin >> x;
            if(cur_sum == x)
            {
                ans.push_back(i - 1);
                ans.push_back(i);
            }
            else if(x == cur_sum + i)
                ans.push_back(i - 1);
            else if(x == cur_sum + i - 1)
                ans.push_back(i);
            cur_sum = x;
        }
        if(ans.size() < k)
            ans.push_back(n);
        cout << "! ";
        for(auto u: ans)
            cout << u << " ";
        cout << endl;
        int x;
        cin >> x;
        if(x != 1)
            exit(0);
        return;
    }
    vector<int> ans;
    int cur_sum = 0, l = 1;
    for(int i = 0;i<k;++i){
        int pos = findans(l, n + 1, cur_sum);
        ans.push_back(pos);
        cur_sum += getsum(l, pos - 1);
        l = pos + 1;
    }
    cout << "! ";
    for(auto u: ans)
        cout << u << " ";
    cout << endl;
    int x;
    cin >> x;
    if(x != 1)
        exit(0);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
