#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<queue>
#include<deque>
#include<stack>
#include<string>
#include<cmath>
#include<climits>
#include<random>
#include<bitset>
#include<ctime>

#define ft first
#define sd second
#define mp make_pair
#define pb push_back
#define int long long
using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

map<int, int> qu;
int need1 (int n) {
    return n * (n + 1ll) / 2ll;
}

vector<int> glob_ans(0);

int ask (int p) {
    if (p == 0ll)
        return 0;
    if (qu[p] != 0) {
        return qu[p] - 1ll;
    } else {
        cout << "? " << p << endl;
        cin >> qu[p];
        if (qu[p] == -1)
            exit(90);
        qu[p] += 1ll;
        return qu[p] - 1ll;
    }
}
void solve1 (int l, int r, int cnt) {
    //cout << l << " " << r << " " << cnt << endl;
    if (cnt == 0)
        return;
    if (l == r)
        return;
    if (r - l == cnt) {
        for (int i = l + 1ll; i <= r; i++) {
            glob_ans.pb(i);
        }
        return;
    }
    if (cnt == 1) {
        int ans1 = need1(r) - ask(r);
        int ans2 = need1(l) - ask(l);
        glob_ans.pb(ans1 - ans2);
        return;
    }
    if ((l + 1ll == r) && (cnt != 0ll)) {
        glob_ans.pb(r);
        return;
    }
    if (cnt == 0ll)
        return;
    int d = (l + r) / 2ll;
    cnt--;
    long long dshka = 2ll * cnt * r - cnt * cnt - 2ll * cnt - 2ll;
    if (dshka >= 0) {
        int znam = 2ll * cnt + 2ll;
        int d1 = (dshka + znam - 1ll) / znam;
        d1 = min(d1, r - 1ll);
        if (d1 > d) {
            d = d1;
        }
    }
    cnt--;

   // cout << l << " " << r << " " << d << " " << cnt << endl;
    int ans1 = need1(d) - ask(d);
    int ans2 = need1(r) - ask(r);
    int ans3 = need1(l) - ask(l);
    if (ans1 == ans2) {
        solve1(l, d, cnt);
        return;
    } else if (ans1 == ans3) {
        solve1(d, r, cnt);
        return;
    }
    int k = ans2 - ans1;
    int lk, rk;
    lk = 0;
    rk = cnt + 1;
    while (lk + 1ll < rk) {
        int dk = (lk + rk) / 2ll;
        if (d * dk + need1(dk) <= k) {
            lk = dk;
        } else {
            rk = dk;
        }
    }
    //cout << k << " " << lk << " " << rk << endl;

    solve1(l, d, cnt - lk);
    solve1(d, r, lk);
}
void solve() {
    glob_ans.assign(0, 0);
    qu.clear();
    int n, k;
    cin >> n >> k;
    if (k != -2) {
        solve1(0, n, k);
        cout << "! ";
        for (auto j : glob_ans) {
            cout << j << " ";
        }
        cout << endl;
        if (glob_ans.size() != k) {
            exit(18);
        }
        cin >> k;

        if (k == -1) {
            exit(0);
        }
        return;
    }
    if (n <= 1000) {
        int last = 0;
        vector<int> ans1(0);
        vector<int> in_every(0);
        for (int i = 0; i < (n / 2); i++) {
            cout << "? " << (i + 1) * 2 << endl;
            int ans;
            cin >> ans;
            in_every.pb(ans - last);
            last = ans;
        }
        for (int i = 0; i < (n / 2); i++) {
            if (in_every[i] == 0) {
                ans1.pb(2 * i + 1);
                ans1.pb(2 * i + 2);
            } else if (in_every[i] == 4 * i + 3) {
                continue;
            } else if (in_every[i] % 2) {
                ans1.pb(2 * i + 2);
            } else {
                ans1.pb(2 * i + 1);
            }
        }
        cout << "! ";
        for (int i = 0; i < ans1.size(); i++) {
            cout << ans1[i] << " ";
        }
        if (ans1.size() < k) {
            cout << n;
        }
        cout << endl;
        int a1;
        cin >> a1;
        return;
    }
    int del = 0;
    vector<int> ANS(0);
    for (int i = 0; i < k; i++) {
        int l = 0;
        int r = n;
        while (l + 1 < r) {
            int d = (l + r) / 2;
            cout << "? " << d << endl;
            int ansik;
            cin >> ansik;
            int mb = need1(d) - del;
            if (mb > ansik) {
                r = d;
            } else {
                l = d;
            }
        }
        ANS.pb(r);
        int tt = r;
        del += r;
    }
    cout << "! " << endl;
    for (int i = 0; i < k; i++) {
        cout << ANS[i] << " ";
    }
    cout << endl;
    cin >> k;

}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tt;
    cin >> tt;
    while (tt--)
        solve();
    return 0;
}