//#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <algorithm>

#define all(a) a.begin(), a.end()
#define forall(iiii, aaaa) for(auto& iiii: aaaa)
#define print(aaaa) forall(aaa, aaaa) cout << aaa << ' '; cout << '\n'

typedef long long ll;
typedef long double ld;

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll mod = 1e9+7, INF = 1e10 + 1;

ll bin_pow(ll n, ll p) {
    if (p == 0) return 1;
    if (p & 1) return n * bin_pow(n, p - 1) % mod;
    return bin_pow(n * n % mod, p / 2);
}

ll gcd(ll a, ll b) {
    while (b %= a) swap(a, b);
    return a;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector < ll > id;
    map < ll, ll > mp;
    for (ll i = 0; i < k; i++) {
        ll l = 0, r = n + 1;
        while (r - l > 1) {
            ll m = (l + r) / 2;
            ll x;
            if (mp.count(m)) x = mp[m];
            else {
                cout << "? " << m << endl;
                cin >> x;
                mp[m] = x;
            }
            forall(j, id) if (j <= m) x += j;
            if (x != m * (m + 1) / 2) r = m;
            else l = m;
        }
        id.push_back(r);
    }
    cout << "! ";
    forall(i, id) cout << i << ' ';
    cout << endl;
    ll x;
    cin >> x;
    if (x == -1) return;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
//    cout << fixed << setprecision(12);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}