#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <iomanip>
#include <queue>
#include <deque>
#include <stack>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 500007;
ll n, m, k;

ll ask(int p) {
	cout << "? " << p << endl;
	ll vl;
	cin >> vl;
	if (vl == -1)
		exit(0);
	return vl;
}

void answer(vector<int>ind) {
	cout << "! ";
	for (int x : ind) {
		cout << x << " ";
	}
	cout << endl;
	int res;
	cin >> res;
	if (res == -1)
		exit(0);
}

// inclusive
ll pref_sum(ll x) {
	if (x == -1)return 0;
	if (x == 0)return 0;
	return x * (x + 1) / 2;
}

// inclusive
ll range_sum(ll x, ll y) {
	return pref_sum(y) - pref_sum(x - 1);
}

int bin_search(int l, int r, ll pl) {
	int tl = l;
	while (l < r) {
		int mid = (l + r) / 2;
		ll vl = ask(mid);
		if (vl - pl == range_sum(tl, mid)) {
			l = mid + 1;
		}
		else {
			r = mid;
		}
	}
	return l;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> ttt;
	while (ttt--) {
		cin >> n >> k;
		vector<int>ans;
		ll pl = 0;
		int cur = 1;
		while (k--) {
			int vl = bin_search(cur, n, pl);
			//cout << "RES: " << vl << endl;
			pl += range_sum(cur, vl) - vl;
			cur = vl + 1;
			ans.push_back(vl);
		}
		answer(ans);
	}
}