#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <iomanip>
#include <queue>
#include <deque>
#include <stack>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 500007;
ll n, m, k;
map<ll, bool>is_asked;
map<ll, ll>response;

ll ask(ll p) {
	if (p <= 0)return 0;
	if (is_asked[p]) {
		return response[p];
	}
	cout << "? " << p << endl;
	ll vl;
	cin >> vl;
	if (vl == -1)
		exit(0);
	is_asked[p] = true;
	response[p] = vl;
	return vl;
}

void answer(vector<ll>ind) {
	cout << "! ";
	for (ll x : ind) {
		cout << x << " ";
	}
	cout << endl;
	ll res;
	cin >> res;
	if (res == -1)
		exit(0);
}

// inclusive
ll pref_sum(ll x) {
	if (x == -1)return 0;
	if (x == 0)return 0;
	return x * (x + 1) / 2;
}

// inclusive
ll range_sum(ll x, ll y) {
	return pref_sum(y) - pref_sum(x - 1);
}

ll bin_search(ll l, ll r, ll pl) {
	ll tl = l;
	while (l < r) {
		ll mid = (l + r) / 2;
		ll vl = ask(mid);
		ll x = vl - pl;
		if (x == range_sum(tl, mid)) {
			l = mid + 1;
		}
		else {
			ll tv = range_sum(tl, mid) - x;
			if (tv >= l && tv <= mid) {
				r = tv;
			}
			else {
				r = mid;
			}
		}
	}
	return l;
}

ll calc_vl(ll l, ll r) {
	ll res = ask(r) - ask(l - 1);
	ll rng_sum = range_sum(l, r);
	return rng_sum - res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> ttt;
	while (ttt--) {
		cin >> n >> k;
		vector<ll>ans;
		if (n <= 1000) {
			ll lst = 0;
			for (int i = 1; i < n; i += 2) {
				ll cur = ask(i + 1ll);
				ll vl = cur - lst;
				if (vl == i + 1) {
					ans.push_back(i);
				}
				else if (vl == i) {
					ans.push_back(i + 1);
				}
				else if (vl == 0) {
					ans.push_back(i);
					ans.push_back(i + 1);
				}
				lst = cur;
			}
			if (ans.size() != k) {
				ans.push_back(n);
			}
			answer(ans);
			is_asked.clear();
			response.clear();
		}
		else if (k == 3) {
			ll a1 = bin_search(1, n, 0);
			ll vl = calc_vl(a1 + 1, n);
			ll a2 = calc_vl(a1 + 1, vl / 2);
			ll a3 = vl - a2;
			answer({ a1,a2,a3 });
		}
		else {
			ll pl = 0;
			ll cur = 1;
			while (k--) {
				ll vl = bin_search(cur, n, pl);
				//cout << "RES: " << vl << endl;
				pl += range_sum(cur, vl) - vl;
				cur = vl + 1;
				ans.push_back(vl);
			}
			answer(ans);
			is_asked.clear();
			response.clear();
		}
	}
	/*ll cur = 3;
	int cnt = 1;
	cout << "(1, 2), ";
	while (cur <= 1e9) {
		cout << "(" << cur << ", ";
		ll vl = (cur + 1) * 3;
		cur = vl / 2;
		cout << cur << "), ";
		cur++;
		cnt++;
	}
	cout << endl << cnt << endl;*/
}