#include <bits/stdc++.h>

#define int long long

#ifndef DDD
#define cerr if(0) cerr
#endif

using namespace std;

template<typename T>
istream& operator>>(istream& is, vector<T>& v) {
    for (auto &u : v) {
        is >> u;
    }
    return is;
}

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) {
    for (auto &u : v) {
        os << u << ' ';
    }
    return os;
}

map<int, int> res;

#ifdef DDD
vector<int> ans = {0, 1, 2, 3, 4, 5, 6, 7, 8, 0, 0, 11, 0, 13, 14, 15, 16};
int get(int p) {
    int r = 0;
    for (int i = 1; i <= p; ++i) {
        r += ans[i];
    }
    res[p] = r;
    return r;
}
#else
int get(int p) {
    if (!res.count(p)) {
        cout << "? " << p << endl;
        cin >> res[p];
    }
    return res[p];
}
#endif

int less_by(int l, int r, int val) {
    int right = r * (r + 1) / 2 - l * (l - 1) / 2;
    return right - val;
}

void solve() {
    res.clear();
    int n, k;
    cin >> n >> k;

    vector<int> out;
    res[0] = 0;
    {
        int l = 1;
        int r = 0;
        int i = 0;
        while (r < n) {
            r += (1 << i);
            r = min(r, n);
            i += 1;

            get(r);

            int lby = less_by(l, r, res[r] - res[l - 1]);

            int curk = 1;
            while (lby != 0) {

                int pref = 0;
                for (int j = 0; j < curk - 2; ++j) {
                    pref += (l + j);
                }
                int two = lby - pref;
                int v = (two - 1) / 2;
                get(v);
                if (lby == less_by(l, v, res[v] - res[l - 1])) {
                    curk += 1;
                } else {
                    int newlby = less_by(l, v, res[v] - res[l - 1]);
                    out.push_back(lby - newlby);
                    lby = newlby;
                    curk -= 1;
                }
            }
            l = r + 1;
        }

        cout << "! " <<  out << endl;
        int is_right;
        cin >> is_right;
        if (is_right == -1) {
            exit(0);
        }
    }

}

int32_t main() {
#ifdef DDD
    freopen("/mnt/commons/day2/input.txt", "r", stdin);
#else
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}