//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3")

#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define INF (int) 1e18 / 2

using namespace std;

mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

void solve() {
	int n, k;
	cin >> n >> k;
	auto ask = [&](int x) {
		cout << "? " << x << endl;
		int res;
		cin >> res;
		return res;
	};

	map<int, int> mp;
	vector<int> res;
	int last = 0;
	auto pref = [&](int l, int r) {
		return r * (r + 1) / 2 - l * (l + 1) / 2;
	};
	int pos = 0;
	while (k--) {
		int l = pos, r = n + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			int x = mp.find(m) == mp.end() ? ask(m) : mp[m];
			mp[m] = x;
			if (pref(pos, m) == x - last) l = m;
			else r = m;
		}
		res.push_back(r);
		last += pref(pos, r - 1);
		pos = r;
	}
	cout << "! ";
	for (int i: res) cout << i << " ";
	cout << endl;
	int tmp;
	cin >> tmp;
	assert(tmp != -1);
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(20);

	int tt = 1;
	cin >> tt;
	while (tt--)
		solve();
}