#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;


#define int ll
#define ff first
#define ss second
#define pb push_back
#define sz(x) long(x.size())
#define rs resize
#define all(x) x.begin(), x.end()
#define qmn(a, b) a = min(a, b)
#define qmx(a, b) a = max(a, b)
#define fastio() cin.tie(0)->sync_with_stdio(0)
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF32 = 2e9 + 5;
const ll INF64 = 2e18 + 5;
const int MX = 2e5 + 7;
const int ABOBA = 333;


int n, k;


int sum(int x) {
    return x * (x + 1) / 2;
}


int ask(int x) {
    cout << "? " << x << "\n";
    cout.flush();
    int res;
    cin >> res;
    return res;
}


void out(vector<int> &ans) {
    cout << "! ";
    for (int el : ans) cout << el << " ";
    cout << "\n";
    cout.flush();
    int xxx;
    cin >> xxx;
    if (xxx == -1) exit(0);
}


void solve1() {
    if (n == 1) {
        int x = ask(1);
        cout << "! 1\n";
        cout.flush();
        int xxx;
        cin >> xxx;
        if (xxx == -1) exit(0);
        return;
    }
    vector<int> ans;
    int s1 = ask(2);
    if (s1 == 1) {
        ans.pb(2);
    }
    else if (s1 == 2) {
        ans.pb(1);
    }
    else if (s1 == 0) {
        ans.pb(1);
        ans.pb(2);
    }
    int t = s1;
    for (int i = 4; i <= n; i += 2) {
        int cur = ask(i);
        if (cur == t) {
//            add += i - 1;
//            add += i;
            ans.pb(i - 1);
            ans.pb(i);
        }
        else if (cur == t + (i - 1)) {
//            add += i;
            ans.pb(i);
            t = cur;
        }
        else if (cur == t + i) {
//            add += i - 1;
            ans.pb(i - 1);
            t = cur;
        }
        else {
            t = cur;
        }
    }
    if (n % 2) {
        int lst = ask(n);
        if (lst == t) {
            ans.pb(n);
        }
    }
    out(ans);
}


void solve2() {
    int add = 0;
    vector<int> ans;
    for (int i = 0; i < k; i++) {
        int l = 0;
        int r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            int x = ask(m);
//            cout << "searching " << i << "\n";
//            cout.flush();
            add = 0;
            for (int el : ans) {
                if (el <= m) {
                    add += el;
                }
            }
            if (x + add != sum(m)) r = m;
            else l = m;
        }
        ans.pb(r);
    }
    out(ans);
}


void solve3() {
    int l = 0;
    int r = n;
    int suma = sum(n) - ask(n);
    while (r - l > 1) {
        int m = (l + r) / 2;
        int x = ask(m);
        if (x != sum(m)) r = m;
        else l = m;
    }
    int f = r;
    suma -= f;
    int cur = ask(suma / 2) + f;
    int s = sum(suma / 2) - cur;
    int t = suma - s;
    vector<int> ans = {f, s, t};
    out(ans);
}


void solve() {
    //solve here
    cin >> n >> k;
    if (k == 3) {
        solve3();
        return;
    }
    if (k <= 30) {
        solve2();
        return;
    }
    if (n <= 1000) {
        solve1();
        return;
    }
}


int32_t main() {
    fastio();
    int tests = 1;
    cin >> tests;
    while (tests--) solve();
    return 0;
}