#include<iostream>
#include<vector>
#include<map>
#include<algorithm>
#define vec vector
#define sz(v) ((int)v.size())
#define all(v) v.begin(), v.end()
typedef long long ll;
using namespace std;
map<int, ll> mem;
vec<int> res;

ll ask(int p) {
	if (mem.find(p) != mem.end())
		return mem[p];
	cout << "? " << p << endl;
	ll x;
	cin >> x;
	if (x == -1)
		exit(0);
	mem[p] = x;
	return x;
}

void answer(vec<int>& p) {
	cout << "! ";
	for (int i = 0; i < sz(p); i++) {
		cout << p[i] << " ";
	}
	cout << endl;
	int x;
	cin >> x;
	if (x == -1)
		exit(0);
}

ll ar(ll l, ll r) {
	return (l + r) * (r - l + 1) / 2;
}

void rec(ll l, ll r, ll pl, ll pr) {
	ll s = pr - pl;
	if (l > r)
		return;
	if (l == 0 && r == 0)
		return;
	if (l == r) {
		if (pr - pl == 0)
			res.push_back(l);
		return;
	}
	if (ar(l, r) - s == 0)
		return;
	if (l <= ar(l, r) - s && ar(l, r) - s <= r) {
		res.push_back(ar(l, r) - s);
		return;
	}
	ll mid = (l + r) / 2;
	ll pmid = ask(mid);
	rec(l, mid, pl, pmid);
	rec(mid + 1, r, pmid, pr);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		mem.clear();
		res.clear();
		int n, k;
		cin >> n >> k;
		rec(1, n, 0, ask(n));
		answer(res);
		/*
		ll pos, summ;
		vec<int> ans;
		{
		int l = 0, r = n;
		while (l + 1 < r) {
			int mid = (l + r) / 2;
			if (ar(1, mid) != ask(mid))
				r = mid;
			else
				l = mid;
		}
		pos = r;
		ans.push_back(pos);
		summ = ask(r);
		}
		for (int i = 0; i < k - 1; i++) {
			int l = pos, r = n;
			while (l + 1 < r) {
				int mid = (l + r) / 2;
				if (ar(pos + 1, mid) != ask(mid) - summ)
					r = mid;
				else
					l = mid;
			}
			pos = r;
			summ = ask(r);
			ans.push_back(pos);
		}
		answer(ans);
		*/
	}
}