#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<random>
#include<algorithm>
#define vec vector
#define sz(v) ((int)v.size())
#define all(v) v.begin(), v.end()
//#define STRESS
typedef long long ll;
using namespace std;
map<int, ll> mem;
vec<int> res;
int n, k;
vec<int> a;
vec<int> b;
mt19937 rnd(30);

ll ask(int p) {
	if (mem.find(p) != mem.end())
		return mem[p];
#ifndef STRESS
	cout << "? " << p << endl;
	ll x;
	cin >> x;
	if (x == -1)
		exit(0);
	mem[p] = x;
	return x;
#else
	ll summ = 0;
	for (int i = 0; i <= p - 1; i++)
		summ += a[i];
	return summ;
#endif
}

void answer(vec<int>& p) {
#ifndef STRESS
	cout << "! ";
	for (int i = 0; i < sz(p); i++) {
		cout << p[i] << " ";
	}
	cout << endl;
	int x;
	cin >> x;
	if (x == -1)
		exit(0);
#else
	sort(all(p));
	if (p != b) {
		for (int i = 0; i < sz(a); i++)
			cout << a[i] << " ";
		ll summ = 0;
		cout << "\n";
		for (int i = 0; i < sz(a); i++) {
			summ += a[i];
			cout << summ << " ";
		}
		cout << "\n";
		for (int i = 0; i < sz(p); i++)
			cout << p[i] << " ";
		cout << '\n';
		for (int i = 0; i < sz(b); i++)
			cout << b[i] << " ";
		exit(0);
	}
#endif
}

ll ar(ll l, ll r) {
	return (l + r) * (r - l + 1) / 2;
}

void rec(ll l0, ll r0, ll pl0, ll pr0) {
	queue<vec<ll>> q;
	k--;
	q.push({ l0, r0, pl0, pr0 });
	while (!q.empty()) {
		auto el = q.front();
		ll l = el[0], r = el[1];
		ll s = el[3] - el[2];
		ll pl = el[2], pr = el[3];
		q.pop();
		if (l == r && s == 0) {
			res.push_back(l);
			continue;
		}
		if (k == 0) {
			res.push_back(ar(l, r) - s);
			continue;
		}
		ll mid = (l + r) / 2;
		ll pmid = ask(mid);
		k++;
		if (ar(l, mid) - (pmid - pl) > 0) {
			k--;
			q.push({l, mid, pl, pmid});
		}
		if (ar(mid + 1, r) - (pr - pmid) > 0) {
			k--;
			q.push({ mid + 1, r, pmid, pr });
		}
	}
}
//1 2 0 4 5 0 7 0 9 0
//1 3 3 7 12 12 19 19 28 28

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
#ifdef STRESS
		n = rnd() % 13 + 1;
		k = rnd() % n + 1;
		a.resize(n);
		b.clear();
		set<int> bs;
		for (int i = 0; i < k; i++) {
			int x;
			x = rnd() % n + 1;
			if (bs.find(x) == bs.end()) {
				b.push_back(x);
				bs.insert(x);
			}
		}
		sort(all(b));
		for (int i = 0; i < n; i++) {
			if (bs.find(i + 1) == bs.end())
				a[i] = i + 1;
			else
				a[i] = 0;
		}
#endif
		mem.clear();
		res.clear();
#ifndef STRESS
		cin >> n >> k;
#endif
		rec(1, n, 0, ask(n));
		answer(res);
		/*
		ll pos, summ;
		vec<int> ans;
		{
		int l = 0, r = n;
		while (l + 1 < r) {
			int mid = (l + r) / 2;
			if (ar(1, mid) != ask(mid))
				r = mid;
			else
				l = mid;
		}
		pos = r;
		ans.push_back(pos);
		summ = ask(r);
		}
		for (int i = 0; i < k - 1; i++) {
			int l = pos, r = n;
			while (l + 1 < r) {
				int mid = (l + r) / 2;
				if (ar(pos + 1, mid) != ask(mid) - summ)
					r = mid;
				else
					l = mid;
			}
			pos = r;
			summ = ask(r);
			ans.push_back(pos);
		}
		answer(ans);
		*/
	}
}