#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
#define pb emplace_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;
typedef long double ld;
typedef pair<ld, ld> ptld;

void fastio(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,ssse3,sse3,sse4,sse4.1")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
*/

mt19937 rnd(31);

ll getsum(ll x){
    cout << "? " << x << endl;
    ll res;
    cin >> res;
    return x * (x + 1) / 2 - res;
}

void have_ans(vector<ll> res){
    cout << "! ";
    for (int x: res)
        cout << x << " ";
    cout << endl;
    int x;
    cin >> x;
    if (x == -1)
        exit(0);
}

void solve1000(int n, int k){
    vector<ll> res;
    ll curr = 0;
    for (int i = 2; i <= n; i += 2){
        ll nw = getsum(i) - curr;
        if (nw == i - 1){
            res.push_back(i - 1);
        } else if (nw == i){
            res.push_back(i);
        } else if (nw == 2 * i - 1){
            res.push_back(i - 1);
            res.push_back(i);
        }
        curr += nw;
    }
    if (sz(res) != k)
        res.push_back(n);
    have_ans(res);
}

void solve_bp(int n, int k){
    vector<ll> res;
    ll curr = 0;
    for (int i = 0; i < k; i++){
        int l = 0, r = n;
        if (i > 0)
            l = res.back();
        while (r - l > 1){
            int mid = (l + r) >> 1;
            if (getsum(mid) != curr)
                r = mid;
            else
                l = mid;
        }
        res.push_back(r);
        curr = getsum(r);
    }
    have_ans(res);
}

vector<ll> solve3(int n, ll add){
    ll sum = getsum(n) - add;
    ll pos = sum / 3;
    ll s1 = getsum(pos) - add;
    vector<ll> res;
    if (s1 > n || (s1 > 1 && getsum(s1 - 1) - add != 0)){
        ll c = sum - s1;
        ll a = getsum(s1 / 2) - add;
        ll b = sum - a - c;
        res = {a, b, c};
    } else {
        ll a = s1;
        ll b = getsum((sum - s1) / 2) - a - add;
        ll c = sum - a - b;
        res = {a, b, c};
    }
    return res;
}

vector<ll> solve4(int n, int k){
    ll sum = getsum(n);
    ll pos = sum / 4;
    ll val = getsum(pos);
    if (val == 1 || getsum(val - 1) == 0){
        ll a = val;
        vector<ll> vals = solve3(n, a);
        return {a, vals[0], vals[1], vals[2]};
    } else {
        ll d1 = sum - val;
        if (d1 > 1 && d1 <= n && getsum(d1 - 1) == sum - d1 && getsum(d1) == sum){
            ll d = d1;
            vector<ll> vals = solve3(d - 1, 0);
            return {vals[0], vals[1], vals[2], d};
        } else {
            ll a = getsum(val / 2);
            ll b = val - a;
            ll c = getsum((sum - val) / 2) - a - b;
            ll d = sum - a - b - c;
            return {a, b, c, d};
        }
    }
}

void solve(){
    int n, k;
    cin >> n >> k;
    if (k == 3){
        have_ans(solve3(n, 0));
    } else if (k == 4){
        have_ans(solve4(n, k));
    } else if (n <= 1000 && k > 55){
        solve1000(n, k);
    } else {
        solve_bp(n, k);
    }
    /*if (k == 3)
        solve3(n);*/

}

void run(){
    int t;
    cin >> t;
    while (t--)
        solve();
}

int main() {
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
#else
    //fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
#ifdef LOCAL
    cerr << "\nProgram finished in " << (stop - start) / CLOCKS_PER_SEC << " sec\n";
#endif
    return 0;
}
