#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> a);
template<typename T>
ostream& operator << (ostream &out, set<T> a);
template<typename T>
ostream& operator << (ostream &out, vector<T> a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#ifdef LOCAL
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
#else
#define debug(x...) 7
#endif
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(21281337711);
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}
int divide(int a, int b) {
    return mul(a, binpow(b, mod - 2));
}
vector<int> P = {1, 0, 3, 4, 5, 0, 7, 0, 9, 0};
ll ask(int x) {
#ifdef LOCAL
    ll ans = 0;
    for (int i = 0; i < x; i++) ans += P[i];
    return ans;
#else
    cout << "? " << x << endl;
    ll ans;
    cin >> ans;
    return ans;
#endif
}
void solve_case() {
    int n;
#ifdef LOCAL
    n = P.size();
#else
    cin >> n;
#endif
    ll sum = 0;
    vector<int> ans;
    for (int i = 1; i <= n;) {
        int left = i - 1, right = n + 1;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            if (ask(mid) == sum + 1ll * (i + mid) * (mid - i + 1) / 2) {
                left = mid;
            } else {
                right = mid;
            }
        }
        if (right != n + 1) ans.push_back(right);
        sum += (i + left) * 1ll * (left - i + 1) / 2;
        i = right + 1;
    }
    cout << "! ";
    for (int i : ans) cout << i << " ";
    cout << endl;
    int ret;
#ifndef LOCAL
    cin >> ret;
    assert(ret == 1);
#endif
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve_case();
    }
    return 0;
}