#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>

#define int long long
#define double long double

using namespace std;

const int MAXN = 201'000;
const long long inf = 1e18;

int f(int n){
    return (n + 1) * n / 2;
}

void solve(){
    int n, k; cin >> n >> k;
    vector <int> ans;
    int d = 0;
    if (n <= 1000){
        for (int i = 1; i <= n - 1; i += 2){
            cout << "? " << i + 1 << endl;
            int res; cin >> res;
            int delta = (f(i + 1) - d) - res;
            if (delta >= i + 1) ans.push_back(i + 1);
            if (delta != i + 1 && delta != 0) ans.push_back(i);
            d += delta;
        }
        if (n % 2 == 1){
            cout << "? " << n << endl;
            int res; cin >> res;
            int delta = f(n) - d;
            if (delta != 0) ans.push_back(n);
        }
        cout << "! ";
        for (int i : ans) cout << i << ' ';
        cout << endl;
        int res; cin >> res;
        if (res == -1) exit(0);
        return;
    }
    for (int i = 0; i < k; i ++){
        int l = (ans.size() ? ans.back() + 1 : 0), r = n + 1;
        while (l + 1 < r){
            int m = (l + r) / 2;
            cout << "? " << m << endl;
            int res; cin >> res;
            if (res >= f(m) - d - m) l = m;
            else r = m;
        }
        d += l;
        ans.push_back(l);
    }
    cout << "! ";
    for (int i : ans) cout << i << ' ';
    cout << endl;
    int res; cin >> res;
    if (res == -1) exit(0);
    return;
}

signed main() {
    ios_base::sync_with_stdio((0)); cin.tie(0); cout.tie(0);
    cout << setprecision(11) << fixed;
    int t; cin >> t;
    while (t--){
        solve();
    }
    return 0;
}