#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;
typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

int sum_ar(int p) {
    return p * (p + 1) / 2;
}

unordered_map<int, int> d;

int ask(int p) {
    if (d.count(p) != 0) return d[p];
    cout << "? " << p << endl;
    int a; cin >> a;
    if (a == -1) exit(0);
    int val = sum_ar(p) - a;
    d[p] = val;
    return val;
}

bool check(int p) {
    if (p == 1) return ask(p) == 1;
    return ask(p) != ask(p - 1);
}

void solve(int n, int k) {
    d = {};
    int cnt = 0, prev = 0, sm = 0;
    vector<int> ans;
    while (cnt < k) {
        int l = prev, r = n;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int res = ask(mid);
            if (res == sm) l = mid;
            else r = mid;
        }
        sm += r;
        prev = r;
        cnt++;
        ans.push_back(r);
    }
    cout << "! ";
    for (auto u: ans) cout << u << ' ';
    cout << endl;
    int a; cin >> a;
    if (a == -1) exit(0);
}

void solve_for_3(int n, int k) {
    d = {};
    int l = 0, r = n, sm = ask(n);
    vector<int> ans;
    while (r - l > 1) {
        if (ans.size() == 3) break;
        int mid = (l + r) / 2;
        int left = ask(mid);
        if (left == 0) l = mid;
        else if (left == sm) r = mid;
        else {
            if (left > mid) {
                r = mid;
                ans.push_back(sm - left);
            }
            else {
                if (check(left)) {
                    ans.push_back(left);
                    l = mid;
                }
                else {
                    ans.push_back(sm - left);
                    r = mid;
                }
            }
        }
    }
    if (ans.size() == 2) ans.push_back(sm - ans[0] - ans[1]);
    cout << "! " << ans[0] << ' ' << ans[1] << ' ' << ans[2] << endl;
    int a; cin >> a;
    if (a == -1) exit(0);
}

signed main() {
    int t; cin >> t;
    while (t--) {
        int n, k; cin >> n >> k;
        if (k != 3) solve(n, k);
        else solve_for_3(n, k);
    }
}