#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

#define int ll

vector<int> have = {  3, 4, 5, 7, 9 };
vector<int> know;

int ask(int p) {
	int need = p * (p + 1) / 2;
	for (int x : know)
		if (x <= p)
			need -= x;

	int sum = 0;
#ifdef LOCAL
	for (int x : have)
		if (x <= p)
			sum += x;
#else
	cout << "? " << p << endl;
	cin >> sum;
#endif
	return need - sum;
}

void solve_case() {
	know.clear();

	int n, k; cin >> n >> k;
	int pastL = 0;
	while (sz(know) < k) {
		int l = pastL, r = n;
		while (r - l > 1) {
			int m = (l + r) / 2;

			int sum = ask(m);
			if (sum)
				r = m;
			else
				l = m;
		}

		know.push_back(r);
		pastL = l;
	}

	cout << "! ";
	for (int x : know)
		cout << x << " ";
	cout << endl;

	int a; cin >> a;
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
#ifndef LOCAL
	cin >> T;
#endif

	while (T--) {
		solve_case();
	}

	return 0;
}
