#include "bits/stdc++.h"
#include <chrono>
#include <random>

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

#define int ll

//vector<int> have = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
vector<int> have = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
vector<int> know;

int ask(int p) {
	int need = p * (p + 1) / 2;
	for (int x : know)
		if (x <= p)
			need -= x;

	int sum = 0;
#ifdef LOCAL
	for (int x : have)
		if (x <= p)
			sum += x;
#else
	cout << "? " << p << endl;
	cin >> sum;
#endif
	return need - sum;
}

void solve_case() {
	know.clear();

	int n, k; cin >> n >> k;
#ifdef LOCAL
	int a = rnd() % sz(have) + 1, b = rnd() % sz(have) + 1, c = rnd() % sz(have) + 1;
	while (a == b)
		b = rnd() % sz(have) + 1;
	while (a == c || b == c)
		c = rnd() % sz(have) + 1;

	have.erase(find(all(have), a));
	have.erase(find(all(have), b));
	have.erase(find(all(have), c));

	cout << "| " << a << " " << b << " " << c << endl;
#endif

	if (k == 3) {
		int sum = ask(n);
		int mid = (sum + 3) / 3;
		int left = ask(mid), right = sum - left;

		int a = -1, b = -1, c = -1;

		int m2 = ask(left / 2);
		if (m2 != left && m2) {
			a = m2;
			b = left - m2;
			c = right;
		}
		else {
			a = left;
			int m3 = ask(right / 2);
			b = m3;
			c = right - m3;
		}

		cout << "! " << a << " " << b << " " << c << endl;

		int useless; cin >> useless;
		return;
	}

	int pastL = 0;
	while (sz(know) < k) {
		int l = pastL, r = n;
		while (r - l > 1) {
			int m = (l + r) / 2;

			int sum = ask(m);
			if (sum)
				r = m;
			else
				l = m;
		}

		know.push_back(r);
		pastL = l;
	}

	cout << "! ";
	for (int x : know)
		cout << x << " ";
	cout << endl;

	int useless; cin >> useless;
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
#ifndef LOCAL
	cin >> T;
#endif

	while (T--) {
		solve_case();
	}

	return 0;
}
