#include <bits/stdc++.h>
#define int long long
using namespace std;

struct answer {
    int n, k;
    vector<int> bad;
    answer(int N = 0, int K = 0) {
        n = N;
        k = K;

    }
};


struct checker {
    vector<int> bad;
    vector<int> pref;
    checker() {}
    void add(int x) {
        bad.push_back(x);
        sort(bad.begin(), bad.end());
        pref = bad;
        for (int i = 1; i < (int)pref.size(); ++i)
            pref[i] += pref[i - 1];
    }

    int size() {
        return (int)bad.size();
    }

    int sum() {
        return (pref.empty() ? 0 : pref.back());
    }

    int back() {
        if (bad.empty())
            return 0;
        return bad.back();
    }

    int get_leftest(int i) {
        if (bad.empty())
            return 1;
        if (bad[0] >= i)
            return i;
        int ind = (int)(upper_bound(bad.begin(), bad.end(), i) - bad.begin()) - 1;
        return bad[ind];
    }

    int get(int i) {
        if (pref.empty())
            return i * (i + 1) / 2;
        int ind = (int)(upper_bound(bad.begin(), bad.end(), i) - bad.begin()) - 1;
        if (ind < 0)
            return i * (i + 1) / 2;
        return i * (i + 1) / 2 - (ind < (int)pref.size() ? pref[ind] : pref.back());
    }
};




map<int, int> mp;
void try_obious(int i, checker c) {
    if (mp.empty())
        return;
    if (mp.count(i))
        return;
    auto it = mp.lower_bound(i);
    auto p = *it;
    pair<int, int> p1 = {0, 0};
    if (it != mp.begin()) {
        --it;
        p1 = *it;
    }

    int a = p1.first, b = p.first;
    if (p.second == p1.second + b * (b + 1) / 2 - a * (a + 1) / 2)
        mp[i] = c.get(i);
}
bool check(int i, checker &c) {
    try_obious(i, c);
    int res;

    if (mp.count(i))
        res = mp[i];
    else {
        cout << "? " << i << endl;
        cin >> res;
    }
    if (res == -1)
        exit(0);
    mp[i] = res;
    if (res != c.get(i))
        return false;
    return true;
}


void print(checker &c) {
    cout << "! ";
    for (auto &x : c.bad) {
        cout << x << ' ';
    }
    cout << endl;
    int a; cin >> a;
    if (a == 1)
        return;
    exit(0);
}

void go(int l, int r, checker &c) {
    if (l == r) {
        if (!check(l, c))
            c.add(l);
        return;
    }
    int m = (l + r) / 2;
    while (!check(m, c)) {
        go(max(l, c.get_leftest(m)), m, c);
    }
    while (!check(r, c)) {
        go(max(m + 1, c.get_leftest(r)), r, c);
    }
}


void solve() {
    mp = {};
    int n, k;
    cin >> n >> k;
    checker c;
//    go(1, n, c);
    check(n, c);
    int mns = (n * (n + 1)) / 2 - mp[n];

    while (c.size() < k - 1) {
        int l = c.back(), r = min(n, (mns - c.sum()) / (k - (int)c.size()) + 1);
        while (l + 1 < r) {
            int m = (l + r) / 2;
            if (check(m, c))
                l = m;
            else
                r = m;
        }
        c.add(r);
    }
    c.bad.push_back(mns - c.sum());
    print(c);
}

signed main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}