#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

#ifdef DESPAIR101
#include "debug.h"
#define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"
#else
#define dbg(x)
#endif

typedef long long ll;
typedef long double ld;

#define int ll
#define sz(x) int((x).size())

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

ll ask(int x) {
    cout << "?" << ' ' << x << endl;
    ll res;
    cin >> res;
    return res;
}

void answer(vector<int> ans) {
    cout << "!" << ' ';
    for (int x : ans) cout << x << ' ';
    cout << endl;

    int res;
    cin >> res;
    if (res == -1) {
        assert(false && "NASRAL");
    }
}

void solve() {
    int n, k;
    cin >> n >> k;

    vector<int> ans;

    {
        int l = 0, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (ask(m) == m * (m + 1) / 2) {
                l = m;
            } else {
                r = m;
            }
        }

        ans.push_back(r);
    }

    int sum = n * (n + 1) / 2 - ask(n) - ans[0];

    for (int i = 1; i < k; ++i) {
        int l = ans.back(), r = sum / (k - i);
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (m * (m + 1) / 2 == ask(m) + accumulate(ans.begin(), ans.end(), 0ll)) {
                l = m;
            } else {
                r = m;
            }
        }
        ans.push_back(r);
        sum -= ans[i];
    }

    answer(ans);
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    cin >> T;

    while (T--) {
        solve();
    }
}