#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}

map<__int128, __int128> ans;
vector<__int128> bad_find;
vector<__int128> rela_bad;

__int128 quest(__int128 i) {
    if (ans.find(i) == ans.end()) {
        cout << "? " << ll(i) << endl;
        ll x;
        cin >> x;
        ans[i] = x;
        return x;
    }
    return ans[i];
}

__int128 get_sum_pidor(__int128 l, __int128 r, __int128 need_sum_pidor) {
    if (r - l == 1) {
        bad_find.push_back(l);
        return l;
    }
    if (l + (l + 1) > need_sum_pidor) {
        bad_find.push_back(need_sum_pidor);
        return need_sum_pidor;
    }
    __int128 can = (r - 1 + l);
    can = can * (r - l) / 2;
    if (need_sum_pidor == can) {
        for (__int128 i = l; i < r;i++){
            bad_find.push_back(i);
        }
        return need_sum_pidor;
    }
    __int128 mid = (r + l) / 2;
    __int128 x = quest(mid - 1);
    __int128 real = (mid);
    real = real * (real - 1) / 2;
    for (auto el: bad_find) {
        if (el < mid) {
            x += el;
        }
    }
    if (x != real) {
        __int128 f = get_sum_pidor(l, mid, real - x);
        if (f == need_sum_pidor) {
            return f;
        }
        x = quest(r - 1);
        real = r;
        real = (real) * (real - 1) / 2;
        for (auto el: bad_find) {
            if (el < r) {
                x += el;
            }
        }
        if (x != real) {
            f += get_sum_pidor(mid, r, real - x);
        }
        return f;
    } else {
        return get_sum_pidor(mid, r, need_sum_pidor);
    }
}

void solve() {
    ans.clear();
    bad_find.clear();
    ll n, k;
    cin >> n >> k;
    __int128 x = quest(n);
    __int128 a = n;
    a = a * (a + 1) / 2;
    get_sum_pidor(1, n + 1, a - x);
    cout << "! ";
    for (auto el: bad_find) {
        cout << ll(el) << " ";
    }
    cout << endl;
    ll c;
    cin >> c;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
