#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <iomanip>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int sz = 500500;
const ll mod = 1e9 + 7;

bool fl = 0;

void solve() {
	ll n, k;
	cin >> n >> k;
	ll last = 0;
	ll p = 0;
	vector <int> ans;
	ll sum;
	while (k--) {
		ll l = last, r = n;
		while (r - l > 1) {
			ll m = (r + l) / 2;
			cout << "? " << m << endl;
			cin >> sum;
			if (sum == -1) {
				fl = 1;
				return;
			}
			if (sum + p == m * (m + 1) / 2) {
				l = m;
			}
			else {
				r = m;
			}
		}
		ans.push_back(r);
		last = r;
		p += r;
	}
	cout << "! ";
	for (int i : ans) cout << i << ' ';
	cout << endl;
	cin >> sum;
	if (sum == -1) {
		fl = 1;
	}
}

int main() {
	int t;
	cin >> t;
	while (t-- && !fl) {
		solve();
	}
}