#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>
#include <cstring>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

#define int long long

map <int, int> mem;
int ask(int n) {
	if (mem.count(n)) return mem[n];
	cout << "? " << n << endl;
	int ans; cin >> ans;
	if (ans == -1) exit(0);
	return mem[n] = ans;
}

void calc(int l, int r, int sm, vector <int>& ans, int prsm) {
	if (sm == 0) return;
	if (sm == r * (r - 1) / 2 - l * (l - 1) / 2) {
		for (int i = l; i < r; ++i) {
			ans.push_back(i);
		}
		return;
	}
	if (r - l == 1) {
		ans.push_back(sm);
		return;
	}

	int lcnt = (sm + l - 1) / l;
	int rcnt = sm / (r - 1);
	if (lcnt == 1 && rcnt == 1) {
		ans.push_back(sm);
		return;
	}


	int m = (l + r) / 2;
	int a = ask(m - 1);
	a += prsm;
	int b = m * (m - 1) / 2 - a;

	calc(l, m, b, ans, prsm);
	calc(m, r, sm - b, ans, prsm + b);
}

void solve() {
	int n, k; cin >> n >> k;

	vector <int> ans;
	int d = 0;
	auto expec = [&](int r) {
		return r * (r + 1) / 2 - d;
	};

	if (k == 3) {
		int l = 0, r = n;
		while (l + 1 != r) {
			int m = (l + r) / 2;
			if (ask(m) == expec(m)) l = m;
			else r = m;
		}
		ans.push_back(r);
		d += r;

		int sm = expec(n) - ask(n);
		int mid = sm / 2;
		int a = expec(mid) - ask(mid);
		ans.push_back(a);
		d += a;
		ans.push_back(sm - a);
		d += sm - a;
	}
	else {
		int a = ask(n);
		int b = n * (n + 1) / 2 - a;
		calc(1, n + 1, b, ans, 0);
	}


	cout << "! ";
	for (auto x : ans) cout << x << ' ';
	cout << endl;
	int verd; cin >> verd;
	if (verd == -1) exit(0);
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		//cout << '\n';
		mem.clear();
	}

	return 0;
}