#include "iostream"
#include "vector"
#include "algorithm"
#include "iomanip"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"

using namespace std;

#define ll long long
#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

ll right(ll r, vector<int> &fake) {
    ll res = (r * (r + 1)) / 2;
    for (auto i: fake) {
        if (i > r) break;
        res -= (ll)i;
    }
    return res;
}

bool is_ok(int r, vector<int> &fake) {
    cout << "? " << r << endl;
    ll a; cin >> a;
    if (a == -1) exit(0);
    return a == right(r, fake);
}

void solve() {
    int n, k; cin >> n >> k;
    vector<int> fake;
    int last = 0;
    while (fake.size() < k) {
        int l = last, r = n + 1;
        while (r - l > 1) {
            int md = (r + l) / 2;
            if (is_ok(md, fake)) {
                l = md;
            } else {
                r = md;
            }
        }
        fake.push_back(r);
        last = r;
    }
    cout << "! ";
    for (auto el: fake) {
        cout << el << " ";
    }
    cout << endl;
    int a; cin >> a;
    if (a == -1) exit(0);
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int test; cin >> test;
    while (test--) {
        solve();
    }
}