#include "iostream"
#include "vector"
#include "algorithm"
#include "iomanip"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"

using namespace std;

#define ll long long
#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

vector<int> fake;
map<int, ll> mp;
int k;

ll sumseg(ll l, ll r) {
    return (r * (r + 1)) / 2 - (l * (l - 1)) / 2;
}

ll get_res(int r) {
    if (mp.find(r) != mp.end()) return mp[r];
    cout << "? " << r << endl;
    ll a; cin >> a;
    if (a == -1) exit(0);
    return mp[r] = a;
}

void calc(int l, int r, ll suml, ll sumr) {
    if (fake.size() == k) return;
    ll sums = sumseg(l, r);
    if (l > r or sumr - suml == sums) return;
    if (l == r) {
        fake.push_back(l);
        return;
    } else if (sums - (sumr - suml) < 2 * l + 1 or fake.size() + 1 == k) {
        fake.push_back(sums - (sumr - suml));
        return;
    }
    int md = (r + l) / 2;
    ll sum = get_res(md);
    calc(l, md, suml, sum);
    calc(md + 1, r, sum, sumr);
}

void solve() {
    int n; cin >> n >> k;
    if (k == 3) {
        ll full = get_res(n);
        ll dif = sumseg(0, n) - full;
        int l = 0, r = n + 1;
        while (r - l > 1) {
            int md = (r + l) / 2;
            ll tr = sumseg(0, md) - get_res(md);
            if (tr == dif) {
                r = md;
            } else {
                l = md;
            }
        }
        ll tr2 = sumseg(0, (dif - r) / 2) - get_res((dif - r) / 2);
        cout << "! " << tr2 << " " << r << " " << dif - tr2 - r << endl;
        int a; cin >> a;
        if (a == -1) exit(0);
        return;
    }
    //if (n <= 1000 or k <= 30) exit(1);
    ll sum = get_res(n);
    calc(1, n, 0, sum);
    cout << "! ";
    for (auto el: fake) {
        cout << el << " ";
    }
    cout << endl;
    int a; cin >> a;
    if (a == -1) exit(0);
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int test; cin >> test;
    while (test--) {
        mp.clear(); fake.clear();
        solve();
    }
}