#include <iostream>
#include <vector>
#include <random>
#include <set>

#define int long long
typedef long  long ll;
using namespace std;

//
// mt19937 rnd(time(0));

vector<int> answers;

int ask(int x) {
    if (answers[x] != -1) {
        return answers[x];
    }
    cout << "? " << x << endl;
    int res;
    cin >> res;
    if (res == -1) {
        exit(0);
    }
    answers[x] = res;
    return res;
}

void solve() {
    int n, k;
    cin >> n >> k;
    answers.assign(n + 1, -1);
    vector<int> ans;
    int z = 0;
    int l = 1, r;
    while (k) {
        k--;
        r = n;
        while (l != r) {
            int mid = (l + r) / 2;
            if (ask(mid) + z == mid * (mid + 1) / 2) {
                l = mid + 1;
            } else {
                r = mid;
            }
        }
        ans.push_back(r);
        z += r;
        l = r + 1;
    }
    cout << "! ";
    for (int i: ans) {
        cout << i << " ";
    }
    cout << endl;
    int res;
    cin >> res;
    if (res == -1) {
        exit(0);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
//
//vect a.x * b.y - b.x * a.y
//scal a.x * b.x + a.y * b.y
