#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long
#define ld long double
#define pii pair<int,int>
#define pll pair<ll,ll>
#define ve vector
#define mpp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(x)          ((int)((x).size()))
#define all(x)          (x).begin(),(x).end()
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;
using namespace __gnu_pbds;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }
template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

const bool debug = 0;

ve<int> bad;
inline ll sum(const int &x) {
    return x * 1ll * (x + 1) / 2ll;
}

ve<int> ans;
map<int,ll> cash;

int Q = 0;

inline ll ask(int pos) {
    if (!pos) {
        return 0;
    }
    if (cash.count(pos)) {
        ll res = cash[pos];
        for (const auto &x : ans) {
            if (x <= pos) {
                res += x;
            }
        }
        return res;
    }
    ++Q;

    if (!debug) {
        cout << "? " << pos << endl;
        fflush(stdout);
    }

    ll res;

    if (!debug) {
        cin >> res;
        if (res == -1) {
            exit(0);
        }
    }
    else {
        res = sum(pos);
        for (const auto &x : bad) {
            if (x <= pos) {
                res -= x;
            }
        }
    }

    cash[pos] = res;

    for (const auto &x : ans) {
        if (x <= pos) {
            res += x;
        }
    }
    return res;
}

inline void slv1(int n, int k) {
    ans.clear();
    cash.clear();

    int last_found = 0;

    Q = 0;

    int mx = 0;

    while (k--) {
        int l = 0, r = n, m, F;
        while (l <= r) {
            m = l + r >> 1;
            if (m <= last_found || ask(m) == sum(m)) {
                F = m, l = m + 1;
            }
            else {
                r = m - 1;
            }
        }
        ans.pb(F + 1);
        last_found = F + 1;
    }
}
inline void slv2(int n, int k) {
    ans.clear();
    cash.clear();
    Q = 0;

    for (int i = 2; i <= n; ++++i) {
        ll c = sum(i) - ask(i);
        if (c == 2 * i - 1) {
            ans.pb(i - 1);
            ans.pb(i);
        }
        else if (c == i - 1) {
            ans.pb(i - 1);
        }
        else if (c == i) {
            ans.pb(i);
        }
    }
    if (n & 1) {
        if (ask(n) != sum(n)) {
            ans.pb(n);
        }
    }
}

inline void solve() {
    int n, k;
    cin >> n >> k;

    if (debug) {
        bad.clear();
        bad.resize(k);

        map<int,int> us;
        for (int i = 0; i < k; ++i) {
            int x = 1 + rng() % n;
            while (us.count(x)) {
                x = 1 + rng() % n;
            }

            bad[i] = x;
            us[x] = 1;
        }
    }

    if (n <= 1000 && (k * 30 > n / 2)) slv2(n, k);
    else slv1(n, k);

    cerr << Q << " queries" << endl;

    if (!debug) {
        cout << "! ";
        for (auto &x : ans) cout << x << " ";
        cout << endl;
        fflush(stdout);

        int res;
        cin >> res;
        if (res == -1) exit(0);
    }
    else {
        sort(all(bad));
        sort(all(ans));
        assert(bad == ans);
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; cin >> q;
    while (q--) solve();
}
