#include <iostream>
#include "vector"
#include "set"
#include "random"
#include "map"
#include "string"
#include "math.h"
#include "algorithm"
#define all(a) a.begin(), a.end()
#define ll long long
#define len(a) (int)a.size()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fort(a, b) for(int a = 0; a < b; a++)
#define f first
#define s second
#define rd (int)ran()
using namespace std;

mt19937 ran;
int mod = 1e9+7;
int modsum(int a, int b){
    if(a + b < mod){
        return a + b;
    }
    return a + b - mod;
}
int modrazn(int a, int b){
    if(a - b < 0){
        return a - b + mod;
    }
    return a - b;
}
int modmult(int a, int b){
    return (int)1ll*a*b%mod;
}
int modpow(int a, int n){
    if(n == 0){
        return 1;
    }
    if(n % 2 == 0){
        return modpow(modmult(a,a), n/2);
    }
    return modmult(a, modpow(a, n - 1));
}
int moddel(int a, int b){
    return modmult(a, modpow(b, mod - 2));
}

struct dots {
    int x, y;
};
int scalar(dots a, dots b){
    return a.x*b.x + a.y*b.y;
}
int psevd(dots a, dots b){
    return a.x * b.y - a.y * b.x;
}

ll ask(ll p){
    cout << "? " << p << endl;
    ll temp;
    cin >> temp;
    if(temp == -1){
        exit(0);
    }
    return temp;
}

ll alg(ll l, ll r){
    return r*(r + 1)/2 - l*(l - 1)/2;
}

vector<ll> ans;
ll now = 0;
map<ll, ll> znach;

void dfs(ll l, ll r, ll sum){
    if(l == r){
        ans[now] = l;
        now++;
        return;
    }
    ll m = (l + r)/2;
    ll nado = alg(l, m);
    ll est = ask(m);
    znach[m] = est;
    if(l != 1) est -= znach[l - 1];
    if(est == 0){
        for(ll i = l; i <= m; i++){
            ans[now] = i;
            now++;
        }
        if(sum - est != alg(l, r) - nado){
            dfs(m + 1, r, sum - est);
        }
    }
    else if(sum - est == 0){
        for(ll i = m + 1; i <= r; i++){
            ans[now] = i;
            now++;
        }
        if(est != nado){
            dfs(l, m, est);
        }
    }
    else{
    if(est != nado){
        dfs(l, m, est);
    }
    if(sum - est != alg(l, r) - nado){
        dfs(m + 1, r, sum - est);
    }
}}

void otv(){
    cout << "! ";
    for(ll i = 0; i < len(ans); i++){
    cout << ans[i] << " ";
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while(t--){
        ans = {};
        ll n, k;
        now = 0;
        cin >> n >> k;
        ans.resize(k);
        dfs(1, n, ask(n));
        otv();
        ll prov;
        cin >> prov;
        if(prov == -1){
            exit(0);
        }
    }
    return 0;
}
