#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <random>
#include <chrono>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back
#define int long long

const int N = 5e5 + 1;
const int mod = 1e9 + 7;
const int inf = 1e12;

map <int, int> mp;

int ask (int p) {
    if (p <= 0)
        return 0;
    if (mp.find(p) != mp.end())
        return mp[p];
    cout << "? " << p << endl;
    int x;
    cin >> x;
    return mp[p] = x;
}

int g (int l, int r) {
    return (l + r) * (r - l + 1) / 2;
}
vc <int> ans;
int n, k;

mt19937 rnd(chrono::high_resolution_clock().now().time_since_epoch().count());

void dfs (int l, int r, int mx) {
    int sum = ask(r) - ask(l - 1);
    int diff = g(l, r) - sum;
    if (mx == 1) {
        ans.pb(diff);
        return;
    }
    if (mx == r - l + 1) {
        for (int j = l; j <= r; ++j)
            ans.pb(j);
        return;
    }
    int m = diff / mx;
    if (mx % 2 == 0)
        m = (diff + mx - 1) / mx;
    if (ask(m - 1) - ask(l - 1) != g(l, m - 1))
        dfs(l, m - 1, mx / 2);
    if (ask(r) - ask(m - 1) != g(m, r))
        dfs(m, r, (mx + 1) / 2);
}

void solve () {
    mp.clear();
    cin >> n >> k;
    dfs(1, n, k);
    cout << "! ";
    for (int i : ans)
        cout << i << ' ';
    cout << endl;
    ans.clear();
    int a;
    cin >> a;
    if (a != 1)
        exit(1);
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}