#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>

using namespace std;

long long find(long long x, const vector<long long> vect) {
	long long L = 0, R = vect.size(), c;
	while (R - L > 1) {
		c = (R + L) / 2;
		if (vect[c] - vect[c - 1] > x) {
			R = c;
		}
		else {
			L = c;
		}
	}
	return vect[L];
}

void solve() {
	long long t, n, k, inp, R, L, c;
	vector<long long> ans, pref;
	map<long long, long long> mp;
	set<long long> st;
	cin >> t;
	while (t--) {
		cin >> n >> k;
		// cout << n << endl;
		ans = {};
		mp = {};
		st = {};
		pref = {0};
		while (k--) {
			R = n;
			L = 0;
			if (ans.size() > 0) {
				L = ans[ans.size() - 1];
			}
			while (R - L > 1) {
				c = (R + L) / 2;
				if (!st.count(c)) {
					cout << "? " << c << endl;
					cin >> inp;
					st.insert(c);
					mp[c] = inp;
					if (inp == -1) {
						break;
					}
				}
				else {
					inp = mp[c];
				}
				if (find(c, pref) + inp == c * (c + 1) / 2) {
					L = c;
				}
				else {
					R = c;
				}
			}
			if (inp == -1) {
				break;
			}
			ans.push_back(R);
			pref.push_back(pref[pref.size() - 1] + R);
		}
		if (inp == -1) {
			break;
		}
		cout << "!";
		for (int i : ans) {
			cout << ' ' << i;
		}
		cout << endl;
		cin >> inp;
		if (inp == -1) {
			break;
		}
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);cout.tie(0);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);

	solve();

	return 0;
}