#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
const int maxn = 1 << 20;
const int inf = 2e9;
const int mod1 = 1e9 + 9;
vector<int> res;
#define int long long
map<int, int> mem;
int pref = 0;
int ask(int p) {
    if (mem.count(p)) return mem[p];
    cout << "? " << p << endl;
    int x;
    cin >> x;
    if (x == -1) assert(0);
    return mem[p] = x;
}

void solve2(int l, int r);
void solve4(int l, int r);

void solve(int l, int r, int k) {
    if (l > r) return;
    if (!k) return;
    if (k == 1) {
        int x = r * (r + 1) / 2 - ask(r) - pref;
        res.push_back(x);
        pref += x;
        return;
    }
    if (k == 2) {
        solve2(l, r);
        return;
    }
    if (k == 4) {
        solve4(l, r);
        return;
    }
    int L = l - 1, R = r;
    while (L + 1 < R) {
        int m = (L + R) / 2;
        if (m * (m + 1) / 2 - ask(m) - pref) {
            R = m;
        } else {
            L = m;
        }
    }
    res.push_back(R);
    pref += R;
    solve(R + 1, r, k - 1);
}

void solve2(int l, int r) {
    int s = r * (r + 1) / 2 - pref - ask(r);
    int div = s / 2;
    solve(l, div, 1);
    solve(div + 1, r, 1);
}

void solve4(int l, int r) {
    int L = l, R = r + 1;
    int sum = r * (r + 1) / 2 - ask(r) - pref;
    while (L + 1 < R) {
        int m = (L + R) / 2;
        if (m * (m + 1) / 2 - ask(m) - pref < sum / 2) {
            L = m;
        } else {
            R = m;
        }
    }
    solve2(l, L);
    solve2(L + 1, r);
}

void solve() {
    mem.clear();
    int n, k;
    cin >> n >> k;
    res.clear();
    pref = 0;
    solve(1, n, k);
    assert(res.size() == k);
    cout << "! ";
    for (int i : res) {
        cout << i << ' ';
    }
    cout << endl;
    int x;
    cin >> x;
    if (x == -1) exit(0);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
