#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

#define int long long

typedef long long ll;

#ifdef LOCAL
int N = 100000, K = 4;
vector<int> secret = {100, 2345, 7654, 98766};
ll ask(int p) {
    cout << "? " << p << endl;
    ll res = (ll)p * (p + 1) / 2;
    for (auto x : secret) {
        if (x <= p) res -= x;
    }
    cout << res << endl;
    return res;
}

void answer(vector<int> &v) {
    cout << "!";
    for (auto el : v) {
        cout << ' ' << el;
    }
    cout << endl;
    sort(v.begin(), v.end());
    int res;
    if (secret == v) {
        res = 1;
    } else {
        res = -1;
    }
    cout << res << endl << '\n';
    if (res == -1) assert(false);
}
#else
ll ask(int p) {
    cout << "? " << p << endl;
    ll secret;
    cin >> secret;
    if (secret == -1) assert(false);
    return secret;
}

void answer(vector<int> &v) {
    cout << "!";
    for (auto el : v) {
        cout << ' ' << el;
    }
    cout << endl;
    int secret;
    cin >> secret;
    if (secret == -1) assert(false);
}
#endif

ll diff(int p) {
    if (p == 0) return 0;
    return ((ll)p * (p + 1) / 2) - ask(p);
}

void solve() {
#ifdef LOCAL
    int n = N, k = K;
#else
    int n, k;
    cin >> n >> k;
#endif
    vector<int> ans;
    if (k == 3) {
        int l = 0, r = n;
        ll d = diff(n);
        ll d_l = 0;
        while (r - l > 1) {
            int m = (l + r) / 2;
            ll d_m = diff(m);
            if (d_m == d) {
                r = m;
            } else {
                l = m;
                d_l = d_m;
            }
        }
        ans.push_back(r);
        ll d1 = diff(d_l / 2);
        ans.push_back(d1);
        ans.push_back(d_l - d1);
        answer(ans);
        return;
    }
    if (k == 4) {
        ans.assign(4, 0);
        int cur = 0;
        int diff_n = diff(n);
        for (int pw = 29; pw > 0; --pw) {
            if (cur + (1 << pw) < n) {
                int cur_diff = diff(cur + (1 << pw));
                if (cur_diff == 0) {
                    cur += (1 << pw);
                    continue;
                }
                if (cur_diff == diff_n) {
                    continue;
                }
                if (cur_diff == ans[0]) {
                    cur += (1 << pw);
                    continue;
                }
                if (diff_n - cur_diff == ans[3]) {
                    continue;
                }
                int d1 = cur_diff;
                if (d1 <= cur + (1 << pw)) {
                    if (diff(d1 - 1) == 0 && diff(d1) > 0) {
                        ans[0] = d1;
                        cur += (1 << pw);
                        continue;
                    }
                }
                if (ans[0] != d1) {
                    int d4 = diff_n - cur_diff;
                    if (d4 > cur + (1 << pw)) {
                        if (diff(d4) == diff_n && diff(d4 - 1) < diff_n) {
                            ans[3] = d4;
                            continue;
                        }
                    }

                    if (ans[0] != d1 && ans[3] != d4) {
                        int sum1 = cur_diff;
                        if (ans[0] == 0) {
                            int mid1 = sum1 / 2;
                            ans[0] = diff(mid1);
                            ans[1] = sum1 - ans[0];
                        } else {
                            ans[1] = sum1 - ans[0];
                        }
                        int sum2 = diff_n - cur_diff;
                        if (ans[3] == 0) {
                            int mid2 = sum2 / 2;
                            ans[2] = diff(mid2) - cur_diff;
                            ans[3] = sum2 - ans[2];
                        } else {
                            ans[2] = sum2 - ans[3];
                        }
                        if (ans[2] == 0)
                        answer(ans);
                        return;
                    }
                }
            }
        }
        return;
    }
    int left = n;
    ll d = diff(n);
    set<pair<ll, int>> answers = {{0, 0}, {d, n}};
    for (int i = 0; i < k; ++i) {
        int l = (--answers.lower_bound({d, 0}))->second;
        int r = answers.lower_bound({d, 0})->second;
        ll d_l = (--answers.lower_bound({d, 0}))->first;
        while (r - l > 1) {
            int m = (l + r) / 2;
            ll d_m = diff(m);
            answers.emplace(d_m, m);
            if (d_m == d) {
                r = m;
            } else {
                l = m;
                d_l = d_m;
            }
        }
        left = l;
        d = d_l;
        ans.push_back(r);
    }
    answer(ans);
}

signed main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}