#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

#ifdef LOCAL
const bool DEBUG = 1;
#else
const bool DEBUG = 0;
#endif

int n, k;

ll sum(ll n) {
    return n * (n + 1) / 2;
}

ve<int> ANS;

ll ask(int p) {
    cout << "? " << p << "\n" << flush;
    if (DEBUG) {
        ll res = sum(p);
        fe (cur, ANS) {
            if (cur <= p) {
                res -= cur;
            }
        }
        return res;
    }
    ll x;
    cin >> x;
    return x;
}

void solve() {

    cin >> n >> k;
    if (DEBUG) {
        set<int> s;

        fr (i, 1, k) {
            int x = rng() % n + 1;
            while (s.count(x)) {
                x = rng() % n + 1;
            }
            ANS.pb(x);
            s.insert(x);
//            int x;
//            cin >> x;
//            ANS.pb(x);
        }
    }

    ll total = sum(n) - ask(n);

    ve<int> ans;
    fr (i, 1, k) {

        int rem = k - i + 1;

        int l = sz(ans) ? ans.back() + 1 : 1;
        int r = total / rem;

        if (i == k) l = total;

        while (l < r) {
            int mid = l + ((r - l) >> 1);

            ll need = sum(mid);
            fe (cur, ans) {
                if (cur <= mid) {
                    need -= cur;
                }
            }

            if (ask(mid) != need) {
                r = mid;
            } else {
                l = mid + 1;
            }
        }
        ans.pb(l);
        total -= l;
    }

    cout << "! ";
    fe (x, ans) cout << x << " ";
    cout << "\n" << flush;
    {
        int a;
        cin >> a;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    ios::sync_with_stdio(0);
//    cin.tie(0);
#endif

    int test;
    cin >> test;

    while (test--) {
        solve();
    }

    return 0;
}
