#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;
const int MOD = 1e9 + 7;

vector<int> mem;

int ask(int x) {
    if (mem[x] != -1)
        return mem[x];
    cout << "? " << x << endl;
    int q;
    cin >> q;
    assert(q >= 0);
    return mem[x] = q;
}

inline void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    mem = vector<int>(n + 1, -1);
    for (int i = 0; i < k; ++i) {
        int l = 1, r = n + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            int q = ask(m);
            for (auto j : ans) {
                if (j <= m)
                    q += j;
            }
            if (q != (m + 1) * (m) / 2)
                r = m;
            else
                l = m;
        }
        if (ask(l) == ask(r))
            ans.push_back(r);
        else
            ans.push_back(l);
    }
    cout << "! ";
    for (auto i : ans) {
        cout << i << ' ';
    }
    cout << endl;
    int a;
    cin >> a;
}

signed main() {
    // ios_base::sync_with_stdio(false);
    // cin.tie(nullptr);
    // cout.tie(nullptr);
#ifdef LOCAL
    // auto f1 = freopen("input.txt", "r", stdin);
    // auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
#ifdef LOCAL

#endif
    cin >> tests;
    for (int i = 1; i <= tests; ++i)
        solve();
}
