﻿// B.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

struct game
{
    ll n;
    long long sum(ll l, ll r)
    {
        return ((l + r) * (r - l + 1ll)) >> 1;
    }
    unordered_map<int, ll> buffer;
    long long ask(int p)
    {
        if (!p)
            return 0;
        if (p > n)
        {
            return sum(n + 1, p) + ask(n);
        }
        if (buffer.count(p))
            return buffer[p];
        ll tmp;
        cout << "? " << p << endl;
        cin >> tmp;
        if (tmp == -1)
            exit(0);
        buffer[p] = tmp;
        return tmp;
    }

    set<int> mines;
    // [l,r)
    ll q(ll l, ll r)
    {
        ll ans = ask(r) - ask(l);
        for (auto& i : mines)
        {
            if (l <= i && i < r)
                ans += i + 1ll;
        }
        return ans;
    }

    bool check(int ql, int qr)
    {
        return q(ql, qr) != sum(ql + 1ll, qr);
    }
};

void play()
{
    game g;
    ll k;
    cin >> g.n >> k;
    // algoritrhtm
    // algorithm
    while (g.check(0, 1ll << 30))
    {
        ll l = 0, r = 1ll << 30;
        while (r > l + 1)
        {
            ll m = (r + l) >> 1;
            if (g.check(l, m))
                r = m;
            else
                l = m;
        }
        g.mines.insert(l);
    }
    if (g.mines.size() != k)
        return;
    cout << "! ";
    for (auto& i : g.mines)
    {
        cout << i + 1ll << ' ';
    }
    cout << endl;
    int a;
    cin >> a;
    if (a == -1)
        exit(-1);
}

int main()
{
    ll t;
    cin >> t;
    while (t--)
        play();
    return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
