#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define str to_string
#define pb push_back

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef long double ld;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template <typename T>
inline ll len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 2e5 + 9;
map<ll, ll> asked;
ll ask(ll x) {
    if(asked.count(x)) return asked[x];
    cout << "? " << x << endl;
    ll res; cin >> res;
    assert(res != -1);
    return asked[x] = res;
}
ll sles(vector<ll>& a, ll x) {
    ll res = 0;
    for(auto &i: a) {
        if(i > x) return res;
        res += i;
    }
    return res;
}
void solvedumb(ll n, ll k) {
    asked.clear();
    vector<ll> ans;
    ll csb = 0;
    set<ll> difs;
    for(int cc = 0; cc < k && len(difs) < k; ++cc) {
        ll L = 0, R = n + 1;
        while(R - L > 1) {
            ll M = (L + R) / 2;
            ll nid = M * (M + 1) / 2 - sles(ans, M);
            ll ril = ask(M);
            difs.insert(M * (M + 1) / 2 - ril);
            difs.erase(0);
            if(len(difs) == k) break;

            if(ril != nid) R = M;
            else L = M;
        }
        csb += R;
        ans.pb(R);
    }

    if(len(difs) == k) {
        ans.clear();
        ll pr = 0;
        for(auto &i: difs) {
            ans.pb(i - pr);
            pr = i;
        }
    }

    cout << "! ";
    for(auto &i: ans) cout << i << ' ';
    cout << endl;
    ll kok; cin >> kok;
    assert(kok == 1);
}

void solve() {
    ll n, k; cin >> n >> k;
    solvedumb(n, k);
}
int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int tc; cin >> tc;
    while(tc--) solve();
}
/*

10 2
3 8


2
3 1
2
4 2
1 4


 */