#include <iostream>
#include <iomanip>
#include <set>
#include <vector>
#include <algorithm>
#include <cmath>
#include <tuple>
#include <random>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;
ll get(ll l, ll r) {
	return (l + r) * (r - l + 1) / 2;
}
int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	int t; cin >> t;
	while (t--) {
		int n, k; cin >> n >> k;
		vector <int> ans;
		ll ind = 0;
		map <int, ll> sum;
		sum[-1] = 0;
		for (int i = 0; i < k; i++) {
			ll l = ind - 1, r = n;
			while (l < r - 1) {
				ll m = (l + r) / 2;
				if (sum.find(m) == sum.end()) {
					cout << "? " << m + 1 << endl;
					ll x; cin >> x;
					if (x == -1) return 0;
					sum[m] = x;
				}
				if (get(ind + 1, m + 1) == sum[m] - sum[ind - 1]) l = m;
				else r = m;
			}
			ans.push_back(l + 1);
			ind = l + 2;
			if (sum.find(ind - 1) == sum.end()) {
				cout << "? " << ind << endl;
				ll x; cin >> x;
				if (x == -1) return 0;
				sum[ind - 1] = x;
			}
		}
		cout << "! ";
		for (auto i : ans) cout << i + 1 << ' ';
		cout << endl;
		ll x; cin >> x;
		if (x == -1) return 0;
	}
	return 0;
}