#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int mod = 1e9 + 7;

ll sum(ll l, ll r) {
    return (l + r) * (r - l + 1) / 2;
}

ll ask(ll p) {
    cout << '?' << ' ' << p << endl;
    ll a;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    return a;
}

vector<int> ans;
void find(ll l, ll r, ll all_s, ll s) {
    if (l + 1 == r) {
        ans.push_back(l);
        return;
    }

    ll m = (l + r) / 2;
    ll a = ask(m - 1);

    ll ls = sum(l, m - 1);
    ll rs = sum(m, r - 1);

    ll real_ls = a - s;
    ll real_rs = all_s - real_ls;

    if (ls != real_ls) {
        find(l, m, real_ls, s);
    }
    if (rs != real_ls) {
        find(m, r, real_rs, a);
    }
}

void solve() {
    ans.clear();
    int n, k;
    cin >> n >> k;
    find(1, n + 1, ask(n), 0);
    cout << '!' << ' ';
    for (int i = 0; i < k; i++) cout << ans[i] << ' '; cout << endl;
    int a;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}