#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()

const int INF32 = 0x3f3f3f3f;
const int INF64 = 0x3f3f3f3f3f3f3f3f;
const int MOD = 1000000007;

int question(int p) {
    cout << "? " << p << endl;
    int res;
    cin >> res;
    return (p + 1) * p / 2 - res;
}

vector<int> ans;

void f(int l, int r, int sum_l, int sum_r) {
    if (r - l == 0) {
        return;
    }
    if (r - l == 1) {
        if (sum_r != sum_l) {
            ans.push_back(r);
        }
        return;
    }
    int m = (l + r) / 2;
    int sum_m = question(m);
    if (sum_m != sum_l) {
        f(l, m, sum_l, sum_m);
    }
    if (sum_m != sum_r) {
        f(m, r, sum_m, sum_r);
    }
}

void solve3(int n) {
    int l = 0, r = n;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (question(mid) > 0) {
            r = mid;
        } else {
            l = mid;
        }
    }
    int all = question(n);
    int sum = all - r;
    int q = question(sum / 2);
    cout << "! " << r << ' ' << q - r << ' ' << all - q << endl;
}

void solve() {
    ans.clear();
    int n, k;
    cin >> n >> k;
    if (k == 3) {
        solve3(n);
    } else {
        f(0, n, 0, question(n));
        cout << "! ";
        sort(all(ans));
        for (int x : ans) {
            cout << x << ' ';
        }
        cout << endl;
    }
    int res;
    cin >> res;
    if (res == -1) {
        exit(0);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solve();
}