#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define sz(a) (int)a.size()
#define pb push_back
#define ff first
#define ss second
#define all(a) (a).begin(), (a).end()

const int INFi = 1e9 + 256;
const ll INFl = 1e18;

template<class T>
bool inmin(T &x, T y) {
    if (y < x) {
        x = y;
        return true;
    }
    return false;
}

template<class T>
bool inmax(T &x, T y) {
    if (y > x) {
        x = y;
        return true;
    }
    return false;
}

mt19937 rnd(time(0));

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    //freopen("/home/olymp/CLionProjects/Kek/read.txt", "r", stdin);
#endif
    cout << fixed << setprecision(15);
    int tc = 1;
    cin >> tc;
    forn(i, tc) solve();
    return 0;
}

ll get_sm(ll pref, vector<int> &ans) {
    ll res = pref * (pref + 1) / 2;
    for (auto x : ans) res -= x;
    return res;
}

ll ask(int pref) {
    cout << "? " << pref << endl;
    ll ans;
    cin >> ans;
    return ans;
}

void print(vector<int> &ans) {
    cout << "! ";
    for (auto x : ans) {
        cout << x << ' ';
    }
    cout << endl;
}

#define int long long
void solve() {
    int n, k;
    cin >> n >> k;
    if (k == 3) {
        vector<int> ans;
        int last = 0;
        int lhs = last, rhs = n;
        while (rhs - lhs > 1) {
            int mid = (lhs + rhs) / 2;
            if (ask(mid) != get_sm(mid, ans)) rhs = mid;
            else lhs = mid;
        }
        ans.pb(rhs);
        last = rhs;
        ll sm = -ask(n) + get_sm(n, ans);
        ll mid = sm / 2;
        ans.pb(-ask(mid) + get_sm(mid, ans));
        ans.pb(sm - ans.back());
        print(ans);
        int a;
        cin >> a;
        if (a == -1) exit(0);
        return;
    }
    vector<int> ans;
    int last = 0;
    ll sm = ask(n);
    while (sz(ans) < k - 1) {
        ll rem = (get_sm(n, ans) - sm) / (k - sz(ans));
        ll lhs = last, rhs = min(rem, (ll)n);
        while (rhs - lhs > 1) {
            int mid = (lhs + rhs) / 2;
            if (ask(mid) != get_sm(mid, ans)) rhs = mid;
            else lhs = mid;
        }
        ans.pb(rhs);
        last = rhs;
    }
    ans.pb(get_sm(n, ans) - sm);
    print(ans);
    int a;
    cin >> a;
    if (a == -1) exit(0);
}