#include <bits/stdc++.h>
using namespace std;
map <int, long long int> m;
long long int ask(int p) {
    if (m.find(p) != m.end()) return m[p];
    cout << "? " << p << endl;
    long long int ans;
    cin >> ans;
    m[p] = ans;
    return ans;
}
void answer(set <int> &ans) {
    cout << "! ";
    for (auto e: ans) {
        cout << e << " ";
    }
    cout << endl;
    int a;
    cin >> a;
    if (a == -1) exit(0);
}
int n, k;
void solution_1() {
    set <int> ans;
    long long int delta = 0, pred = 0;
    for (int i = 0; i < k; i++) {
        long long int L = pred, R = n, M;
        while (R - L > 1) {
            M = (R + L) / 2;
            if (ask(M) < (M * (M + 1)) / 2 - delta) R = M;
            else L = M;
        }
        pred = R;
        ans.insert(pred);
        delta += pred;
    }
    answer(ans);
    m.clear();
}
void solution_2() {
    int C;
    if (n <= 1000) C = int(sqrt(n));
    else C = 1e6;
    set <int> ans;
    long long int delta = 0, pred = 0;
    for (int l = 1; l <= n; l += C) {
        int r = min(l + C - 1, n);
        while (ask(r) != (r * (r + 1)) / 2 - delta) {
            long long int L = max(int(pred), l - 1), R = r, M;
            while (R - L > 1) {
                M = (R + L) / 2;
                if (ask(M) < (M * (M + 1)) / 2 - delta) R = M;
                else L = M;
            }
            pred = R;
            ans.insert(pred);
            delta += pred;
        }
    }
    answer(ans);
    m.clear();
}
int main() {
    int t;
    cin >> t;
    for (; t > 0; t--) {
        cin >> n >> k;
        if (k <= 30) solution_1();
        else solution_2();
    }
    return 0;
}