#include <bits/stdc++.h>

#define int long long
//g++ -std=c++17 -fsanitize=address -DLOCAL -D_GLIBCXX_DEBUG D.cpp -o D
using namespace std;

void outans(vector<int> &ans) {
    cout << "! ";
    for (auto i : ans) cout << i << ' ';
    cout << endl;
    int a;
    cin >> a;
    if (a == -1) exit(0);
}
unordered_map<int, int> prev_guesses;

int guess(int p) {
    if (prev_guesses.count(p)) return prev_guesses[p];
    cout << "? " << p << endl;
    int a;
    cin >> a;
    if (a == -1) exit(1);
    prev_guesses[p] = a;
    return a;
}

void solve() {
    prev_guesses.clear();
    int n, k;
    cin >> n >> k;
    vector<int> pw(30);
    vector<int> ans;
    int d = 0, prv = 0;
    pw[0] = guess(1);
    int cur = 1;
    if (pw[0] == 0) d++, cur--;
    for (int i = 1; (1LL << (i - 1)) < n; ++i) {
        int sz = min((1LL << (i + 1)) - 1, n) - ((1LL << i) - 1);
        pw[i] = guess(min((1LL << (i + 1)) - 1, n)) - cur;
        cur += pw[i];
        int cnt = sz - pw[i] / ((1LL << i) + 1);
        //cerr << i << ' ' << pw[i] << ' ' << sz << ' ' << cnt << ' ' << cur << '\n';
        for (int j = 0; j < cnt; ++j) {
            int l = (1LL << i) - 1, r = min((1LL << (i + 1)), n + 1);
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (guess(m) != m * (m + 1) / 2 - d) r = m;
                else l = m;
            }
            ans.push_back(r);
            d += r;
        }
    }
    sort(ans.begin(),ans.end());
    ans.erase(unique(ans.begin(), ans.end()), ans.end());
    outans(ans);
}

int32_t main() {
    #ifdef LOCAL
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}