#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define len(a) int(a.size())

// author: @cot-in

void fin() {
#ifdef cot_in
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
}

void solve() {
    ll n, k;
    cin >> n >> k;
    if (n <= 1000) {
        ll cnt = 0;
        vector<ll> bads;
        ll i = 0;
        while (i + 2 <= n) {
            cout << "? " << i + 2 << endl;
            ll cur;
            cin >> cur;
            if (cnt == cur) {
                bads.push_back(i + 1);
                bads.push_back(i + 2);
            } else if (cnt + i + 1 == cur) {
                bads.push_back(i + 2);
            } else if (cnt + i + 2 == cur) {
                bads.push_back(i + 1);
            }
            cnt = cur;
            i += 2;
        }
        i++;
        for (; i <= n; i++) {
            cout << "? " << i << endl;
            ll cur;
            cin >> cur;
            if (cnt + i != cur) {
                bads.push_back(i);
            }
            cnt = cur;
        }
        cout << "! ";
        for (auto el: bads)
            cout << el << ' ';
        cout << endl;
        ll cur;
        cin >> cur;
        if (cur == -1) {
            exit(0);
        }
    } else {
        vector<ll> bads;
        ll last = 0;
        ll cnt = 0;
        map < ll, ll > q;
        for (ll i = 0; i < k; i++) {
            ll l = last, r = n;
            while (r - l > 1) {
                ll mid = (l + r) / 2;
                cout << "? " << mid << endl;
                ll cur;
                cin >> cur;
                if (cur == -1) {
                    exit(0);
                }
                q[mid] = cur;
                ll s = ((mid * (mid + 1)) / 2) - (((last) * (last + 1)) / 2);
                if (cnt + s != cur) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            bads.push_back(r);
            last = r;
            cnt = q[r];
        }
        cout << "! ";
        for (auto el: bads)
            cout << el << ' ';
        cout << endl;
        ll cur;
        cin >> cur;
        if (cur == -1) {
            exit(0);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}