#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

vector<ll> ans;
vector<ll> save;
ll n, k;

ll get(ll len) {
    if (len == 0) {
        return 0;
    }
    if (save[len] != -1) {
        return save[len];
    }
    cout << "? " << len << endl;
    ll x;
    cin >> x;

    save[len] = x;
    return x;
}

ll sum(ll n) {
    return n * (n + 1) / 2;
}

ll sum(ll l, ll r) {
    return sum(r) - sum(l - 1);
}

void check(ll l, ll r) {
    if (ans.size() == k) {
        return;
    }
    if (l > r) {
        return;
    }

    ll m = (l + r) / 2;

    ll w = get(m) - get(l - 1);

    if (l == r) {
        if (w == 0) {
            ans.push_back(l);
        }

        return;
    }

    if (w == sum(l, m)) {
        check(m + 1, r);
    } else {
        check(l, m);
        check(m + 1, r);
    }
}

void solve() {
    cin >> n >> k;
    save.assign(n + 1, -1);
    ans.clear();

    check(1, n);
    cout << "! ";
    for (auto x : ans) {
        cout << x << " ";
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t;
    cin >> t;
    while (t--) {
        solve();
        ll res;
        cin >> res;
    }

    return 0;
}