#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

vector<int> gg{2, 6, 8, 10};
map<int, ll> cache;

ll ask(int p) { // p in 1-numeration
    if (cache.find(p) != cache.end()) {
        return cache[p];
    }
#ifndef LOCAL
    cout << "? " << p << endl;
    ll ans;
    cin >> ans;
    assert(ans >= 0);
    return cache[p] = ans;
#endif
    ll sum = p * 1ll * (p + 1) / 2;
    for (int i = 0; i < (int) gg.size(); ++i) {
        if (gg[i] <= p) {
            sum -= gg[i];
        }
    }
    return cache[p] = sum;
}

bool full(int l, int r) {
    ll sum = ask(r) - (l == 1 ? 0 : ask(l - 1));
    if (sum == (l + r) * 1ll * (r - l + 1) / 2) {
        return 1;
    }
    return 0;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
//#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//#endif
    int t = 1;
    cin >> t;
    while (t--) {
        int n = 11, k = gg.size();
        cin >> n >> k;
        if (n / 2 < k * 30) {
            vector<int> ans;
            for (int i = 2; i <= n; i += 2) { // check i and i - 1
                ll cur = ask(i) - (i == 2 ? 0 : ask(i - 2));
                if (cur == 0) {
                    ans.push_back(i - 1);
                    ans.push_back(i);
                } else if (cur == i) {
                    ans.push_back(i - 1);
                } else if (cur == i - 1) {
                    ans.push_back(i);
                }
            }
            if (n % 2 == 1) {
                ll cur = ask(n) - (n == 1 ? 0 : ask(n - 1));
                if (cur == 0) {
                    ans.push_back(n);
                }
            }
            cout << "! ";
            for (auto i : ans) {
                cout << i << " ";
            }
            cout << endl;
        } else {
            int st = 1;
            vector<int> ans;
            for (int _ = 0; _ < k - 1; ++_) {
                if (!full(st, st)) {
                    ans.push_back(st);
                    ++st;
                    continue;
                }
                int cur = st;
                for (int i = 30; i >= 0; --i) {
                    if (cur + (1 << i) <= n && full(st, cur + (1 << i))) {
                        cur += (1 << i);
                    }
                }
                if (cur + 1 <= n) {
                    ans.push_back(cur + 1);
                    st = cur + 2;
                }
            }
            ll lst = n * 1ll * (n + 1) / 2;
            for (auto i : ans) {
                lst -= i;
            }
            ans.push_back(lst - ask(n));
            cout << "! ";
            for (auto i : ans) {
                cout << i << " ";
            }
            cout << endl;
        }
        int a;
        cin >> a;
        cache.clear();
        assert(a == 1);
    }
}
