#include <bits/stdc++.h>

using namespace std;

vector<int> tree(2e6);

void build(int v, int tl, int tr, vector<vector<int>> &arr) {
    if (tl + 1 == tr) {
        tree[v] = arr[tl][1];
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v + 1, tl, tm, arr), build(2 * v + 2, tm, tr, arr);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

void update(int v, int tl, int tr, int pos, int val) {
    if (tl + 1 == tr) {
        tree[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos < tm) {
        update(2 * v + 1, tl, tm, pos, val);
    } else {
        update(2 * v + 2, tm,tr, pos, val);
    }
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int get_ma(int v, int tl, int tr, int l, int r) {
    if (l >= tr || r <= tl) {
        return -1e9;
    }
    if (l <= tl && r >= tr) {
        return tree[v];
    }
    int tm = (tl + tr) / 2;
    return max(get_ma(2 * v + 1, tl, tm, l, r), get_ma(2 * v + 2, tm, tr, l, r));
}

signed main() {
    //ifstream cin("text.in");
    //ofstream cout("text.out");
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr), cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, k, i, cnt = 0, in;
        cin >> n >> k;
        string ans = "! ";
        for (i = 1; i <= n; i++) {
            cout << "?" << i << endl;
            cin >> in;
            if (in + cnt != i) {
                ans += to_string(i  ) + " ";
                cnt++;
            }
        }
        cout << ans << endl;
        cin >> in;
    }
}