#include <bits/stdc++.h>
#include <bit>

using namespace std;

#define get_time() ((double)clock() / (double)CLOCKS_PER_SEC)

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

vector<int> ans;

int request(int pos) {
    cout << "? " << pos << endl;
    int ans;
    cin >> ans;
    return ans;
}

void rec(int l, int cnt_l, int r, int cnt_r) {
    if (cnt_l == cnt_r) {
        for (int i = l + 1; i <= r; ++i) {
            ans.push_back(i);
        }
        return;
    }
    int mid = (l + r) >> 1;
    int cnt_mid = request(mid);
    rec(l, cnt_l, mid, cnt_mid);
    rec(r, cnt_r, mid, cnt_mid);
}

void solve() {
    int n, k;
    cin >> n >> k;
    ans.clear();
    rec(0, 0, n, n - k);
    cout << "! ";
    for (int x : ans) {
        cout << x << ' ';
    }
    cout << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}