#include<bits/stdc++.h>
using namespace std;

int t,n,k;
vector<int> ans;
long long res;

long long query(int pos){
    cout<<"? "<<pos<<"\n";
    fflush(stdout);
    cin>>res;
    return res;
}

long long calc(long long x){
    return x*(x+1)/2;
}

bool ok(int l,int r,long long lp,long long rp){
    return rp-lp==calc(r)-calc(l-1);
}

long long guess(int l,int r,long long lp,long long rp){
    long long x=(calc(r)-calc(l-1))-(rp-lp);
    if(2*l>=x)return x;
    return -1;
}

long long wild_guess(int l,int r,long long lp,long long rp){
    long long x=(calc(r)-calc(l-1))-(rp-lp);
    return x;
}

void solve(long long l,long long r,long long lp,long long rp){
    long long newr=min(r,wild_guess(l,r,lp,rp));
    rp-=calc(r)-calc(newr);
    r=newr;

    if(ans.size()==k)return;

    if(ans.size()==k-1){
        ans.push_back(wild_guess(l,r,lp,rp));
        return;
    }

    if(rp-lp==0){
        for(int i=l;i<=r;i++){
            ans.push_back(i);
        }
        return;
    }


    if(l==r){
        ans.push_back(l);
        return;
    }

    int mid=(l+r)/2;
    long long curr=query(mid);

    if(!ok(mid+1,r,curr,rp)){
        if(guess(mid+1,r,curr,rp)!=-1){
            ans.push_back(guess(mid+1,r,curr,rp));
        }else{
            solve(mid+1,r,curr,rp);
        }
    }

    if(!ok(l,mid,lp,curr)){
        if(guess(l,mid,lp,curr)!=-1){
            ans.push_back(guess(l,mid,lp,curr));
        }else{
            solve(l,mid,lp,curr);
        }
    }
}

int main(){

    cin>>t;
    for(int i=1;i<=t;i++){
        cin>>n>>k;
        if(k>4){
            for(int i=1;i<=10;i++)query(rand()%k+1);
        }

        ans.clear();
        solve(1,n,0,query(n));

        cout<<"! ";
        for(int i=0;i<ans.size();i++){
            cout<<ans[i]<<" ";
        }
        cout<<"\n";
        fflush(stdout);
        cin>>res;

        if(res==-1)break;
    }

    return 0;
}