#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define ll long long
#define int ll
#define pb push_back
#define ull unsigned long long
#define pii pair<int, int>
#define F first
#define S second

using namespace std;
const int MOD = 1e9 + 7;
const int N = 1e5 + 10;
int P = 37;
int st[N], h[N];
int pref[110][50500];

int HASH(string &s) {
    int H = s[0] - 'a' + 1;
    for (int i = 1; i < (int)s.size(); ++i) {
        H = (H * P) + (s[i] - 'a' + 1);
        H %= MOD;
    }
    return H;
}
void make_hash(string &s) {
    int sz = s.size();
    h[0] = s[0] - 'a' + 1;
    for (int i = 1; i < sz; ++i) {
        h[i] = (h[i - 1] * P) + (s[i] - 'a' + 1);
        h[i] %= MOD;
    }
}
int get_hash(int l, int r) {
    int ans = h[r];
    int len = r - l + 1;
    if (l) ans -= h[l - 1] * st[len] % MOD;
    ans = (ans + MOD * 10) % MOD;
    return ans;
}
int32_t main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    st[0] = 1;
    for (int i = 1; i < N; ++i) {
        st[i] = (st[i - 1] * P) % MOD;
    }
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int sz = t.size();
    make_hash(t);
//    map <int, int> mp;
    vector <pii> H(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        int now = HASH(s);
        int k = s.size();
        H[i] = {now, k};
//        mp[now]++;
    }
    for (int i = 0; i < sz; ++i) {
        if (i != 0) {
            for (int j = 0; j < n; ++j) {
                pref[j][i] = pref[j][i - 1];
            }
        }
        for (int j = 0; j < n; ++j) {
            if (i + H[j].S > sz) continue;
            bool ok = (H[j].F == get_hash(i, i +  H[j].S - 1));
            pref[j][i] += ok;
//            cout << pref[j][i] << ' ';
        }
//        cout << endl;
    }
    while(m--) {
        int l, r;
        cin >> l >> r;
        l--; r--;
        int ans = 0;
        for (int j = 0; j < n; ++j) {
            int R = r - H[j].S + 1;
            if (R < l) continue;
            ans += pref[j][R];
            if (l) ans -= pref[j][l - 1];
        }
        cout << ans << " ";
    }
    return 0;
}
