#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int mod = 1e9 + 7;
const int mod1 = 998244353;
const int b = 31;
const int p = 27;

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<ll> hash(t.size() + 1), hash1(t.size() + 1);
    vector<ll> p_pow(t.size() + 1), p_pow2(t.size() + 1);
    p_pow[0] = 1;
    p_pow2[0] = 1;
    for (int i = 1; i <= t.size(); i++) {
        p_pow[i] = p_pow[i - 1] * b;
        p_pow2[i] = p_pow2[i - 1] * b;
        p_pow[i] %= mod;
        p_pow2[i] %= mod1;
    }
    hash[0] = 0;
    for (int i = 0; i < t.size(); i++) {
        hash[i + 1] = hash[i] + (t[i] - 'a' + 1) * p_pow[i];
        hash1[i + 1] = hash1[i] + (t[i] - 'a' + 1) * p_pow2[i];
        hash[i + 1] %= mod;
        hash1[i + 1] %= mod1;
    }
    unordered_set<ll> ss, ss1;
    set<int> lens;
    for (int i = 0; i < n; i++) {
        ll h = 0, h1 = 0;
        string s;
        cin >> s;
        if (s.size() > t.size()) {
            continue;
        }
        for (int i = 0; i < s.size(); i++) {
            h = h + (s[i] - 'a' + 1) * p_pow[i];
            h1 = h1 + (s[i] - 'a' + 1) * p_pow2[i];
            h %= mod;
            h1 %= mod1;
        }
        ss.insert(h * p_pow[t.size() - s.size()] % mod);
        ss1.insert(h1 * p_pow2[t.size() - s.size()] % mod1);
        lens.insert(s.size());
    }
    vector<vector<int> > ans(t.size());
    for (auto it : lens) {
        int len = it;
        for (int i = len - 1; i < t.size(); i++) {
            ll h = ((hash[i + 1] - hash[i + 1 - len]) % mod + mod) % mod;
            ll h1 = ((hash1[i + 1] - hash1[i + 1 - len]) % mod1 + mod1) % mod1;
            if (ss.count(h * p_pow[t.size() - i - 1] % mod) && ss1.count(h1 * p_pow2[t.size() - i - 1] % mod1)) {
                ans[i + 1 - len].push_back(len);
            }
        }
    }
    map<pair<int, int>, ll> w;
    for (int test = 0; test < m; test++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        if (w.count({l, r})) {
            cout << w[{l, r}] << endl;
            continue;
        }
        ll res = 0;
        for (int i = l; i <= r; i++) {
            int x = r - i + 1;
            int g = upper_bound(ans[i].begin(), ans[i].end(), x) - ans[i].begin();
            res += g;
        }
        w[{l, r}] = res;
        cout << res << endl;
    }
}

int main() {
//    freopen("C:\\Users\\olymp\\CLionProjects\\day_2\\input.txt", "r", stdin);
//    freopen("C:\\Users\\olymp\\CLionProjects\\day_2\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << setprecision(20) << fixed;
    solve();
}
