#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);



void solve() {
    ll n, m;
    cin >> n >> m;

    string s;
    cin >> s;

    vector<ll> step_p(1e6 + 1);
    step_p[0] = 1;

    for (ll i = 1; i < 1e6 + 1; ++i) {
        step_p[i] = step_p[i - 1] * 31;
        step_p[i] %= MOD;
    }

    vector<ll> pref_hash(s.size() + 1);
    pref_hash[0] = 0;

    for (ll i = 1; i <= s.size(); ++i) {
        pref_hash[i] = pref_hash[i - 1] + (ll(s[i - 1] - 'a' + 1) * step_p[i - 1]) % MOD;
        pref_hash[i] %= MOD;
    }

    vector<ll> lenn(n);
    vector<vector<ll>> vhod(n);

    for (ll i = 0; i < n; ++i) {
        string h;
        cin >> h;

        lenn[i] = h.size();

        ll rt = 0;

        for (ll j = 0; j < h.size(); ++j) {
            rt += (step_p[j] * ll(h[j] - 'a' + 1)) % MOD;
            rt %= MOD;
        }

        for (ll j = 0; j <= (ll)s.size() - (ll)h.size(); ++j) {
            ll fg = pref_hash[j + h.size()] - pref_hash[j];
            if (fg < 0) fg += MOD;

            if (fg == (rt * step_p[j]) % MOD) {
                vhod[i].push_back(j);
            }
        }
    }

    for (auto i : vhod) {
        for (auto j : i) {
            cout << j << ' ';
        }
        cout << endl;
    }

    // while (m--) {
    //     ll left, right;
    //     cin >> left >> right;

    //     --left;

    //     ll ans = 0;

    //     for (ll i = 0; i < n; ++i) {
    //         ll ind1 = lower_bound(all(vhod[i]), left) - vhod[i].begin();
    //         ll ind2 = lower_bound(all(vhod[i]), right - lenn[i] + 1) - vhod[i].begin();

    //         ans += ind2 - ind1;
    //     }

    //     cout << ans << ' ';
    // }

    vector<ll> start(s.size(), 0);

    for (auto i : vhod) {
        for (auto j : i) start[j]++;
    }

    for (ll i = 1; i < s.size(); ++i) start[i] += start[i - 1];

    vector<ll> end(s.size() + 1, 0);

    for (ll i = 0; i < n; ++i) {
        for (auto j : vhod[i]) {
            end[j + lenn[i]]++;
        }
    }

    for (ll i = 1; i <= s.size(); ++i) end[i] += end[i - 1];

    // for (auto i : start) cout << 

    while (m--) {
        ll left, right;
        cin >> left >> right;

        ll ans = end[right];

        if (left > 1) {
            ans -= start[left - 2];
        }

        cout << ans << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;

    while (tests--) {
        solve();
    }
}

/*

5 4 3 2
1 2 1 10 6
1 2 5

2 3 3
3 4 4
4 5 20

*/