#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "lzcnt", "popcnt")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
//#define int ll

const int MOD = 1e9 + 7, BASE = 101;
const int MAXN = 1e5;

ll my_hash(const string& s) {
    ll ans = 0;
    for (int i = 0; i < s.size(); ++i)
        ans = (ans * BASE + s[i] - 'a' + 1) % MOD;
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;assert(n >= 500);
    string t;
    cin >> t;
    vector<string> a(n);
    for (auto& i : a)
        cin >> i;

    unordered_map<int, int> ha;
    for (int i = 0; i < n; ++i) {
        ll tmp = my_hash(a[i]);
        ha[tmp] = 1;
    }

    vector<vector<ll>> h(t.size(), vector<ll>(t.size() + 1));
    for (int i = 0; i < t.size(); ++i)
        h[i][i + 1] = t[i] - 'a' + 1;
    for (int l = t.size() - 1; l > -1; --l)
        for (int r = l + 2; r <= t.size(); ++r)
            h[l][r] = (h[l][r - 1] * BASE + t[r - 1] - 'a' + 1) % MOD;

    vector<vector<int>> dp(t.size() + 1, vector<int>(t.size() + 1));
    for (int i = 0; i < t.size(); ++i)
        dp[i][i + 1] = ha[h[i][i + 1]];
    for (int l = t.size() - 2; l > -1; --l)
        for (int r = l + 2; r <= t.size(); ++r)
            dp[l][r] = dp[l + 1][r] + dp[l][r - 1] - dp[l + 1][r - 1] + ha[h[l][r]];
    /*
    for (auto i : dp) {
        for (auto j : i)
            cout << j << " ";
        cout << endl;
    }
     */
    while (m--) {
        int l, r;
        cin >> l >> r;
        --l;
        cout << dp[l][r] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}
