#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int MOD = 1e9 + 7;
const int MAXN = 5e5 + 5;
const ll inf = 1e18;

pll a[MAXN];
int n;
ll t[MAXN * 4];
vector<ll> mst[MAXN * 4];

void build(int v, int l, int r) {
    if (r - l == 1) {
        t[v] = a[l].Y;
        return;
    }
    int mid = (l + r) >> 1;
    build(v * 2 + 1, l, mid);
    build(v * 2 + 2, mid, r);
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

ll ask(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr)return -inf;
    if (ql <= l && r <= qr)return t[v];
    int mid = (l + r) >> 1;
    return max(ask(v * 2 + 1, l, mid, ql, qr), ask(v * 2 + 2, mid, r, ql, qr));
}

//void buildmst(int v, int l, int r) {
//    if (r - l == 1) {
//        mst[v] = {a[l].X};
//        return;
//    }
//    int mid = (l + r) >> 1;
//    buildmst(v * 2 + 1, l, mid);
//    buildmst(v * 2 + 2, mid, r);
//
//    int i = 0, j = 0, N = sz(mst[v * 2 + 1]), M = sz(mst[v * 2 + 2]);
//    while (i < N || j < M) {
//        if (i == N) {
//            mst[v].pb(mst[v * 2 + 2][j++]);
//        } else if (j == M) {
//            mst[v].pb(mst[v * 2 + 1][i++]);
//        } else if (mst[v * 2 + 2][j] < mst[v * 2 + 1][i]) {
//            mst[v].pb(mst[v * 2 + 2][j++]);
//        } else {
//            mst[v].pb(mst[v * 2 + 1][i++]);
//        }
//    }
//}
//
//ll ask(int v, int l, int r, int ql, int qr) {
//    if (ql >= r || l >= qr)return -inf;
//    if (ql <= l && r <= qr)return t[v];
//    int mid = (l + r) >> 1;
//    return max(ask(v * 2 + 1, l, mid, ql, qr), ask(v * 2 + 2, mid, r, ql, qr));
//}

ll calc() {
    ll ans = inf;
    set<ll> ns;
    for (int i = 0; i < n; i++) {
        ll mx = (i == n - 1 ? -inf : ask(0, 0, n, i + 1, n));
        auto it = ns.upper_bound(a[i].X);
        ll Mn = (it == ns.end() ? inf : *it);
        ll Mx = (it == ns.begin() ? -inf : *prev(it));
        ans = min(ans, llabs(mx - a[i].X));
        if (Mn > mx)ans = min(ans, llabs(Mn - a[i].X));
        if (Mx > mx)ans = min(ans, llabs(Mx - a[i].X));
        ns.insert(a[i].Y);
    }
    return ans;
}

void solve() {
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    sort(a, a + n);
    build(0, 0, n);
    ll ans = calc();

    for (int i = 0; i < n; i++) {
        swap(a[i].X, a[i].Y);
    }
    sort(a, a + n);
    build(0, 0, n);
    cout << min(calc(), ans) << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}