// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long
#define ld long double

int q;

constexpr int MOD1 = 1e9 + 1329, P1 = 37, MOD2 = 1e9 + 9, P2 = 59;

vector<vector<ll>> dp;

void solve() {
    int n;
    cin >> n >> q;
    string s;
    cin >> s;
    set<pair<ll, ll>> arr;
    for (int i = 0; i < n; i++) {
        string t;
        cin >> t;
        pair<ll, ll> hsh = { 0, 0 };
        for (char c : t)
            hsh = { (hsh.F * P1 + (c - 'a') + 1) % MOD1, (hsh.S * P2 + (c - 'a') + 1) % MOD2 };
        arr.insert(hsh);
    }

    n = s.size();
    vector<int> arr_l(n), arr_r(n);
    dp.assign(n + 1, vector<ll>(n + 1, 0));
    for (int i = 0; i < n; i++) {
        pair<ll, ll> hsh = { 0, 0 };
        for (int j = i; j < n; j++) {
            hsh = { (hsh.F * P1 + (s[j] - 'a') + 1) % MOD1, (hsh.S * P2 + (s[j] - 'a') + 1) % MOD2 };
            if (arr.find(hsh) != arr.end()) {
                arr_r[j]++;
                dp[i + 1][j + 1]++;
            }
        }
    }
    vector<ll> pref(n + 1, 0);
    for (int i = 0; i < n; i++)
        pref[i + 1] = pref[i] + arr_r[i];

    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= n; j++)
            dp[i + 1][j] += dp[i][j];
    }
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j < n; j++)
            dp[i][j + 1] += dp[i][j];
    }
    while (q--) {
        int l, r;
        cin >> l >> r; l--;
        cout << pref[r] - dp[l][r] << ' ';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
}