#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
using namespace std;

/*#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
typedef tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;*/

const int mxs = 'z' - 'a' + 1;

struct node{
    node *c[mxs];
    char sym = '$';
    bool isTerm = false;
    node() {
        for (auto *&q: c) q = nullptr;
    }
    node(char sym, bool term = false) : sym(sym), isTerm(term) {
        for (auto *&q: c) q = nullptr;
    }
};

void add_string(node *root, string &s, int i = 0) {
    if (i == (int)s.size()) {
        root->isTerm = true;
        return;
    }
    if (root->c[s[i] - 'a']) return add_string(root->c[s[i] - 'a'], s, i + 1);
    root->c[s[i] - 'a'] = new node(s[i]);
    add_string(root->c[s[i] - 'a'], s, i + 1);
}

void getCnt(node *cur, string &s, int i, vector<int> &ans) {
    if (cur->isTerm) ans.push_back(i - 1);
    if (i == (int)s.size()) {
        return;
    }
    if (cur->c[s[i] - 'a']) {
        return getCnt(cur->c[s[i] - 'a'], s, i + 1, ans);
    }
}

signed main(){
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/kek/input.txt", "r", stdin);
    freopen("/home/olymp/CLionProjects/kek/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    node *cur = new node();
    int n, m; cin >> n >> m;
    string s; cin >> s;
    for (int i = 0; i < n; ++i) {
        string t; cin >> t;
        add_string(cur, t);
    }
    vector<vector<int>> cnt((int)s.size());
    for (int i = 0; i < (int)s.size(); ++i) {
        getCnt(cur, s, i, cnt[i]);
    }
    for (int i = 0; i < m; ++i) {
        int l, r; cin >> l >> r;
        l--; r--;
        int ans = 0;
        for (int j = l; j <= r; ++j){
            int v = (int)(upper_bound(all(cnt[j]), r) - cnt[j].begin());
            ans += v;
        }
        cout << ans << " ";
    }
    cout << "\n";

}