#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
using namespace std;

/*#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
typedef tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;*/

const int mxs = 'z' - 'a' + 1;

struct node{
    node *c[mxs];
    char sym = '$';
    bool isTerm = false;
    node() {
        for (auto *&q: c) q = nullptr;
    }
    node(char sym, bool term = false) : sym(sym), isTerm(term) {
        for (auto *&q: c) q = nullptr;
    }
};

vector<int> evs;

void add_string(node *root, string &s, int i = 0) {
    if (i == (int)s.size()) {
        root->isTerm = true;
        return;
    }
    if (root->c[s[i] - 'a']) return add_string(root->c[s[i] - 'a'], s, i + 1);
    root->c[s[i] - 'a'] = new node(s[i]);
    add_string(root->c[s[i] - 'a'], s, i + 1);
}

void getCnt(node *cur, string &s, int i, int l) {
    if (cur->isTerm) {
        evs.push_back(i - 1);
    }
    if (i == (int)s.size()) {
        return;
    }
    if (cur->c[s[i] - 'a']) {
        return getCnt(cur->c[s[i] - 'a'], s, i + 1, l);
    }
}

const int xc = 400;

signed main(){
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/kek/input.txt", "r", stdin);
    freopen("/home/olymp/CLionProjects/kek/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    node *cur = new node();
    int n, m; cin >> n >> m;
    string s; cin >> s;
    for (int i = 0; i < n; ++i) {
        string t; cin >> t;
        add_string(cur, t);
    }
    vector<pair<int, int>> ids((int)s.size());
    for (int i = 0; i < (int)s.size(); ++i) {
        ids[i].first = (int)evs.size();
        getCnt(cur, s, i, i);
        ids[i].second = (int)evs.size() - 1;
    }
    vector<vector<int>> b;
    for (int i = 0; i < (int)evs.size(); ++i) {
        if (i / xc >= (int)b.size()) b.emplace_back();
        b[i / xc].push_back(evs[i]);
    }
    for (auto &u: b) sort(all(u));
    for (int i = 0; i < m; ++i) {
        int l, r; cin >> l >> r;
        l--; r--;
        int lx = ids[l].first;
        int rx = ids[r].second;
        int V = r + 1;
        int ans = 0;
        for(int j = lx; (j / xc) == (lx / xc) && (j <= rx); ++j) {
            if (evs[j] < V) ans++;
        }
        if (lx / xc == rx / xc) {
            cout << ans << " ";
            continue;
        }
        for (int j = rx; (j / xc) == (rx / xc); --j) {
            if (evs[j] < V) ans++;
        }
        for (int j = lx / xc + 1; j < rx / xc; ++j) {
            int add = (int)(lower_bound(all(b[j]), V) - b[j].begin());
            ans += add;
        }
        cout << ans << " ";
    }
    cout << "\n";

}