#include <bits/stdc++.h>
#define int long long
#define double long double
#define x first
#define y second
#define inf (INT64_MAX / 2)

using namespace std;

const int mod = 1000000009, prime = 32;
int prime_obr;

int bin_pow(int a, int x) {
    int res = 1;
    while (x) {
        if (x % 2) {
            res *= a;
            res %= mod;
        }
        a *= a;
        a %= mod;
        x /= 2;
    }
    return res;
}

void solve() {
    prime_obr = bin_pow(prime, mod - 2);
    int n, q;
    string t;
    cin >> n >> q >> t;
    vector<string> str(n);
    int hashes[500000], p_power[1000100], hashT[5000001], p_obr[1000100], i2[64];
    i2[0] = 1;
    for (int i = 1; i < 64; i++) {
        i2[i] = i2[i - 1] * 2;
    }
    p_power[0] = 1;
    p_obr[0] = 1;
    for (int i = 1; i < 1000100; i++) {
        p_power[i] = (p_power[i - 1] * prime) % mod;
        p_obr[i] = (p_obr[i - 1] * prime_obr) % mod;
    }
    hashT[0] = 0;
    for (int i = 1; i <= t.size(); i++) {
        hashT[i] = (hashT[i - 1] + (t[i - 1] - 'a' + 1) * p_power[i - 1]) % mod;
    }
    set<int> sizes;
    for (int i = 0; i < n; i++) {
        cin >> str[i];
        sizes.insert(str[i].size());
        hashes[i] = 0;
        for (int j = 0; j < str[i].size(); j++) {
            hashes[i] += (str[i][j] - 'a' + 1) * p_power[j];
            hashes[i] %= mod;
        }
    }
    int f[3000], cnt = 0;
    for (int i : sizes) {
        f[cnt++] = i;
    }
    int bitset[15625006];
    for (int i = 0; i < 15625006; i++) {
        bitset[i] = 0;
    }
    for (int i = 0; i < n; i++) {
        bitset[hashes[i] / 64] |= i2[hashes[i] % 64];
    }
    if (t.size() <= 50000) {
        int32_t pr[50001][1500];
        for (int i = 0; i < 1500; i++) {
            pr[0][i] = 0;
        }
        int hsh = 0, cnt1 = cnt;
        for (int i = 0; i < t.size(); i++) {
            for (int j = 0; j < cnt1; j++) {
                if (i + f[j] > t.size()) {
                    cnt1 = j;
                    break;
                }
                hsh = ((hashT[i + f[j]] - hashT[i] + mod) * p_obr[i]) % mod;
                pr[i + 1][j] = pr[i][j];
                if ((bitset[hsh / 64] & i2[hsh % 64])) {
                    pr[i + 1][j]++;
                }
            }
        }
        while (q--) {
            int x, y, ans = 0;
            cin >> x >> y; x--;
            for (int i = 0; i < cnt; i++) {
                if (x + f[i] > y) {
                    break;
                }
                ans += pr[y - f[i] + 1][i] - pr[x][i];
            }
            cout << ans << ' ';
        }
        return;
    }
    int32_t pr[250001][448];
    for (int i = 0; i < 448; i++) {
        pr[0][i] = 0;
    }
    int hsh = 0, cnt1 = cnt;
    for (int i = 0; i < t.size(); i++) {
        for (int j = 0; j < cnt1; j++) {
            if (i + f[j] > t.size()) {
                cnt1 = j;
                break;
            }
            hsh = ((hashT[i + f[j]] - hashT[i] + mod) * p_obr[i]) % mod;
            pr[i + 1][j] = pr[i][j];
            if ((bitset[hsh / 64] & i2[hsh % 64])) {
                pr[i + 1][j]++;
            }
        }
    }
    while (q--) {
        int x, y, ans = 0;
        cin >> x >> y; x--;
        for (int i = 0; i < cnt; i++) {
            if (x + f[i] > y) {
                break;
            }
            ans += pr[y - f[i] + 1][i] - pr[x][i];
        }
        cout << ans << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cout << setprecision(100);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}