#include <iostream>
#include <vector>


using namespace std;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int num_of_strings, num_of_reqs;
    cin >> num_of_strings >> num_of_reqs;
    string s;
    cin >> s;
    int s_size = s.size();
    vector<int> lenths(num_of_strings);
    vector<vector<int>> arr(num_of_strings, vector<int> (s_size + 1, 0));
    for (int i = 0; i < num_of_strings; ++i) {
        string s0;
        cin >> s0;
        int s0_size = s0.size();
        lenths[i] = s0_size;
        for (int j = 0; j < s_size; ++j) {
            if ( j + s0_size - 1 < s_size) {
                bool f = true;
                for (int x = 0; x < s0_size; ++x) {
                    if (s0[x] != s[j + x]) {
                        f = false;
                        break;
                    }
                }
                arr[i][j + s0_size] = (int) f;
            }
            arr[i][j + 1] += arr[i][j];
        }
    }
    for (int i = 0; i < num_of_reqs; ++i) {
        int l;
        int r;
        cin >> l >> r;
        int ans = 0;
        for (int j = 0; j < num_of_strings; ++j) {
            if (r - l + 1 >= lenths[j]) {
                ans += arr[j][r] - arr[j][l - 2 + lenths[j]];
            }
        }
        cout << ans << "\n";
    }
    return 0;
}
