#include <bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define all(x) x.rbegin(), x.rend()
#define endl '\n'
typedef long long ll;
using namespace std;

const ll MOD = 1e9 + 7;
const ll p = 239;

ll bin_pow(ll x, ll k) {
    if (k == 0) {
        return 1;
    }
    ll y = bin_pow(x, k / 2);
    y = (y * y) % MOD;
    if (k % 2) {
        return (y * x) % MOD;
    }
    return y;
}

void solve() {
    int n, m, q;
    string t;
    cin >> m >> q >> t;

    n = t.size();

    vector<ll> h(n + 1);
    for (int i = 1; i <= n; i++) {
        h[i] = (h[i - 1] * p + t[i - 1] - 96) % MOD;
    }

    map<ll, bool> d;
    for (int i = 0; i < m; i++) {
        string s;
        cin >> s;
        ll h = 0;
        for (int i = 1; i <= s.size(); i++) {
            h = (h * p + s[i - 1] - 96) % MOD;
        }
        d[h] = 1;
    }

    vector<vector<int>> ans(n + 1, vector<int> (n + 1));
    for (int j = 1; j <= n; j++) {
        int pl = 0;
        for (int i = j; i > 0; i--) {

            ll s = (h[j] - (h[i - 1] * bin_pow(p, j - i + 1)) % MOD + MOD) % MOD;
            pl += d[s];
            ans[i][j] = ans[i][j - 1] + pl;
        }
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        cout << ans[l][r] << " ";
    }
    cout << endl;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
