#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#define ss second
#define ff first
#define LOCAL

vector<int> pw;

struct HashTab {
	vector<int> hs;
	int n, md = 12481274987;

	HashTab (string s) {
		n = s.size();
		pw.resize(n);
		hs.resize(n, 0);
		pw[0] = 1;
		for(int i = 1;i < n;i++) {
			pw[i] = (pw[i - 1] * 31);
			pw[i] %= md;
			pw[i] += md;
			pw[i] %= md;
		}
		int h = 0;
		for(int i = 0;i < n;i++) {
			h += s[i];
			h *= 31;
			h %= md;
			hs[i] = h;
		}
	}
	int get(int l, int r) {
		if(l == 0) {
			return hs[r];
		} else {
			return (hs[r] - hs[l - 1] * pw[r - l + 1] % md + md) % md;
		}
	}
};

void solve() {
	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	HashTab S(t);
	vector<HashTab> a;
	for(int i = 0;i < n;i++) {
		string s;
		cin >> s;
		a.push_back(HashTab(s));
	}
	while(m--) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		int res = 0;
		for(int i = l;i <= r;i++) {
			for(int j = i;j <= r;j++) {
				for(auto k : a) {
					if(S.get(i, j) == k.get(0, j - i)) {
						res++;
					}
				}
			}
		}
		cout << res << " ";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int st = 1;
	// cin >> st;
	while(st--) {
		solve();
	}
}