#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define f(n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
#define pb push_back

typedef long long ll;
typedef vector<int> vei;
typedef string str;


struct Hashes {
    ll p = 179, mod = 1e9+7;
    vector<ll> ps;
    vector<ll> hash;
    int n;
    Hashes(string s) {
        n = s.size();
        ps.resize(n+1);
        ps[0] = 1;
        hash.resize(n+1);
        for(int i = 0; i < n; ++i) {
            ps[i+1] = ps[i] * p % mod;
            hash[i+1] = (hash[i] * p + (s[i] - 'a' + 1)) % mod;
        }
    }

    int get_hash(int l, int sz) {
        return ((hash[l + sz] - hash[l] * ps[sz])%mod+mod)%mod;
    }
};



void solve() {
    int n, m;
    cin>>n>>m;
    str s;
    cin>>s;
    Hashes au(s);
    map<int, int> gt2;
    vector<pair<int, map<int, int>>> gt;
    gt.pb({-1, {}});
    f(n) {
//        cout<<i<<endl;
        str t;
        cin>>t;
        Hashes tt(t);
        if(!gt2[t.size()]) {
            gt2[t.size()] = gt.size();
            gt.pb({t.size(), {}});
        }
        gt[gt2[t.size()]].second[tt.get_hash(0, t.size())] = 1;
    }
    vector<int> op(n+1), cl(n+1);
    vector<pair<int, vector<int>>> prs;
    for(auto e : gt) {
        if(e.first==-1) continue;
        int j = prs.size();
        prs.pb({e.first, {}});
        prs[j].second.resize(s.size()+1);
        for(int i = 0; i + e.first <= s.size(); ++i) {
            prs[j].second[i+1] = prs[j].second[i] + e.second[au.get_hash(i, e.first)];
        }
    }
    f(m) {
//        cout<<i<<endl;
        int l, r;
        cin>>l>>r;
        int ans = 0;
        --l;
        for(auto e : prs) {
            if(e.first > r-l) continue;
            ans += e.second[r-e.first+1] - e.second[l];
        }
        cout<<ans<<' ';
    }
}

signed main() {
    cout<<fixed<<setprecision(15);
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int tc = 1;
//    cin>>tc;
    for(int i = 0; i < tc; ++i) {
        // cout << "Test case: " << i+1 << endl;
        solve();
    }
    return 0;
}
