#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define fast ios::sync_with_stdio(false);cin.tie(0);
#define int ll

const int N = 2e5;

int powers[N];

struct Hash {
    string s;

    vector<int> h, powers;

    int MOD, p;


    int add(int a, int b) {
        if (a + b >= MOD) {
            return a + b - MOD;
        }
        return a + b;
    }

    int mult(int a, int b) {
        return (1ll * a * b) % MOD;
    }

    int diff(int a, int b) {
        if (a - b >= 0)
            return a-b;
        return a-b + MOD;
    }

    Hash (string _s, int _MOD, int _p) {
        MOD = _MOD;
        p = _p;
        s = _s;
        int n = s.size();
        h.resize(n);
        powers.resize(n);
        build();
    }

    void build() {
        int n = s.size();
        h[0] = s[0];
        powers[0] = 1;
        for (int i = 1; i < n; i++) {
            powers[i] = (powers[i - 1] * p) % MOD;
            h[i] = add(mult(h[i - 1], p), s[i]);
        }

    }

    int get(int l, int r) {
        if (l == 0)
            return h[r];
        return diff(h[r], mult(h[l-1], powers[r - l + 1]));
    }
};

signed main() {
    fast;
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<string> sx;
    map<pair<int, int>, int> bx;
    for (int i = 0; i < n; i++) {
        string t;
        cin >> t;
        sx.push_back(t);
        auto d = Hash(t, 1e9 + 7, 251).h.back();
        auto d1 = Hash(t, 1e9 + 9, 251).h.back();
        bx[{d, d1}]++;
    }
    Hash hr(s, 1e9 + 7, 251);
    Hash hr1(s, 1e9 + 9, 251);

    vector<pair<int, int>> good;
    for (int l = 0; l < s.size(); l++) {
        for (int r = l; r < s.size(); r++) {
            if (bx.find({hr.get(l, r), hr1.get(l, r)}) != bx.end()) {
                good.push_back({l, r});
            }
        }
    }
    for (int i = 0; i < m; i++) {
        int l1, r1;
        cin >> l1 >> r1;
        l1--;r1--;
        int ans = 0;
        for (auto [l, r] : good) {
            if (l1 <= l && r <= r1) {
                ans++;
            }
        }
        cout << ans << ' ';
    }
}