#include <bits/stdc++.h>
#define debug(x) cerr << (#x) << " : " << x << endl;
#define all(a) a.begin(), a.end()
#define int long long

typedef long long ll;
typedef double db;
using namespace std;
const int MOD = 1e9 + 7;
const int MAXL = 2e6;
const db eps = 1e-9;

struct Node {
    int go[26];
    int cntEnd;
};

int borSz = 1;
Node bor[MAXL];

void insertToBor(string s) {
    int v = 0;
    for (auto c : s) {
        if (bor[v].go[c - 'a'] != 0) {
            v = bor[v].go[c - 'a'];
        } else {
            bor[v].go[c - 'a'] = borSz;
            v = bor[v].go[c - 'a'];
            borSz++;
        }
    }
    bor[v].cntEnd++;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m; cin >> n >> m;
    string t; cin >> t;
    vector<vector<int>> gr(t.size());
    for (int i = 0; i < n; ++i) {
        string s; cin >> s;
        insertToBor(s);
    }
    for (int i = 0; i < (int)t.size(); ++i) {
        int v = 0;
        for (int j = i; j < (int)t.size(); ++j) {
            if (bor[v].go[t[j] - 'a'] == 0) break;
            v = bor[v].go[t[j] - 'a'];
            if (bor[v].cntEnd) {
                gr[i].push_back(j);
            }
        }
    }
    for (int t = 0; t < m; ++t) {
        int l, r; cin >> l >> r; l--; r--;
        int ans = 0;
        for (int i = l; i <= r; ++i) {
            auto it = upper_bound(all(gr[i]), r);
            ans += (it - gr[i].begin());
        }
        cout << ans << ' ';
    }
    return 0;
}