#include <bits/stdc++.h>

using namespace std;
#define eb emplace_back

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

const ll BASE = 72, MOD = 1e9 + 7;

#define int ll

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<ll> hashes(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        ll hash = 0;
        for (char j : s) {
            hash = (hash * BASE + (ll)((ll)j - 'a' + 1ll)) % MOD;
        }
        hashes[i] = hash;
    }
    sort(hashes.begin(), hashes.end());
    vll tHash(t.length() + 1), power(n + 1);
    power[0] = 1ll;
    for (int i = 1; i <= n; ++i)
        power[i] = (power[i - 1] * BASE) % MOD;
    tHash[0] = 0ll;
    for (int i = 0; i < (int)t.length(); ++i)
        tHash[i + 1] = (tHash[i] * BASE + (ll)((ll)t[i] - 'a' + 1ll)) % MOD;
    vector<vll> strings(t.length() + 1, vll (t.length() + 1));
    for (int i = 0; i < (int)t.length(); ++i) {
        for (int j = i + 1; j <= (int)t.length(); ++j) {
            ll th = ((tHash[j] - tHash[i] * power[j - i]) % MOD + MOD) % MOD;
            if (binary_search(hashes.begin(), hashes.end(), th)) {
                strings[i][j]++;
            }
        }
    }
    for (int i = (int)t.length() - 1; i >= 0; --i) {
        for (int j = i; j <= (int)t.length(); ++j) {
            strings[i][j] += strings[i + 1][j];
        }
    }
    for (int i = 0; i <= (int)t.length(); ++i) {
        for (int j = 1; j <= (int)t.length(); ++j) {
            if (j)
                strings[i][j] += strings[i][j - 1];
        }
    }
    int a, b;
    while (m--) {
        cin >> a >> b;
        cout << strings[a - 1][b] << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tests = 1;
//    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
