#include <bits/stdc++.h>

using namespace std;

#define pikachu push_back
#define mp make_pair
#define st first
#define nd second
#define pll pair<ll, ll>
#define pii pair<int, int>
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;

template<typename A, typename B>
string to_string(pair<A, B> p);

string to_string(string s) {
    return s;
}

string to_string(char s) {
    return "'" + string(1, s) + "'";
}

template<typename A>
string to_string(A v) {
    string res = "{";
    bool fl = 1;
    for (auto x: v) {
        if (!fl) {
            res += ", ";
        }
        fl = 0;
        res += to_string(x);
    }
    res += "}";
    return res;
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

void debug_out() {
    cerr << endl;
}

template<typename H, typename... T>
void debug_out(H h, T... t) {
    cerr << " " << to_string(h);
    debug_out(t...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

template<typename A, typename B>
bool cmin(A &a, const B &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename A, typename B>
bool cmax(A &a, const B &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
typedef unsigned long long ull;

struct HASH {
    size_t operator()(const pair<ull, ull> &p) const {
        return p.st ^ p.nd;
    }
};

ull bpow(ull a, ull n) {
    ull res = 1;
    while (n) {
        if (n & 1) res *= a;
        a *= a;
        n /= 2;
    }
    return res;
}

void run();

signed main() {
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
}

const ull b = 567;
const ull b2 = 1337;

ull getH(const string &s) {
    ull h = 0;
    for (auto e: s) {
        h = h * b + e;
    }
    return h;
}

ull getH2(const string &s) {
    ull h = 0;
    for (auto e: s) {
        h = (h * b2 + e);
    }
    return h;
}

void run() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<int> lens;
    vector<string> s(n);
    for (auto &e: s) {
        cin >> e;
        lens.pikachu(sz(e));
    }
    sort(all(lens));
    lens.resize(unique(all(lens)) - lens.begin());
    vector<unordered_set<pll, HASH>> heshs(sz(lens));
    for (auto &e: s) {
        ll pos = lower_bound(all(lens), sz(e)) - lens.begin();
        heshs[pos].insert({getH(e), getH2(e)});
    }
    vector<vector<int>> pref(sz(lens), vector<int>(sz(t) + 1));
    vector<ll> prefL(sz(t) + 1);
    vector<ll> prefR(sz(t) + 1);
    for (int cur = 0; cur < sz(lens); ++cur) {
        int len = lens[cur];
        ull h = 0, h2 = 0;
        for (int i = 0; i < len; ++i) {
            h = (h * b + t[i]);
            h2 = (h2 * b2 + t[i]);
        }
        if (heshs[cur].count({h, h2})) pref[cur][1] = 1;
        ll S = bpow(b, len);
        ll S2 = bpow(b2, len);
        for (int i = 0; i + len < sz(t); ++i) {
            h = (h * b + t[i + len]);
            h -= (S * t[i]);
            /////////
            h2 = (h2 * b2 + t[i + len]);
            h2 -= (S2 * t[i]);
            if (heshs[cur].count({h, h2})) pref[cur][i + 2] = 1;
        }
        for (int i = 1; i < sz(pref[cur]); ++i) {
            pref[cur][i] += pref[cur][i - 1];
        }
    }
    //debug(pref);
    vector<ll> ans(m);
    vector<array<int, 3>> z;
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        z.pikachu({l, r, i});
    }
    auto comp = [&](array<int, 3> a, array<int, 3> b) {
        return a[1] - a[0] < b[1] - b[0];
    };
    sort(all(z), comp);
    int cur = -1;
    for (auto [l, r, id]: z) {
        while (cur + 1 < sz(lens) && lens[cur + 1] <= r - l + 1) {
            ++cur;
            for (int i = 0; i <= sz(t); ++i) {
                prefL[i] += pref[cur][i];
                if (i - lens[cur] + 1 < 0) continue;
                prefR[i] += pref[cur][i - lens[cur] + 1];
            }
        }
        ans[id] = prefR[r] - prefL[l - 1];
    }
    for (auto e: ans) cout << e << ' ';
}