#include <bits/stdc++.h>
using namespace std;
#define int long long
#define fi first
#define se second
#define lwb lower_bound
#define upb upper_bound
#define em emplace_back
#define all(x) x.begin(), x.end()
#define ll long long
const int N = 1e6, C = 200, K = 28, INF = 0x3f3f3f3f, P1 = 179, P2 = 57, M1 = 1e9 + 7, M2 = 1e9 + 9;
const double EPS = 1e-5;
ifstream fin("input.txt");
ofstream fout("output.txt");
#define cin fin
#define cout fout

/*
random_device r;
default_random_engine e1(r());
seed_seq seed2{r(), r(), r(), r(), r(), r(), r(), r()};
mt19937 rnd(seed2);
*/

struct segtree {
    int size = 1;
    vector<int> tree;

    void init(int n) {
        while (size < n)
            size <<= 1;
        tree.resize(2 * size - 1);
    }

    void set(int i, int val, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] += val;
            return;
        }
        int m = (rx + lx) / 2;
        if (i < m)
            set(i, val, 2 * x + 1, lx, m);
        else
            set(i, val, 2 * x + 2, m, rx);
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    void set(int i, int val) {
        set(i, val, 0, 0, size);
    }

    int sum(int l, int r, int x, int lx, int rx) {
        if (l <= lx && rx <= r)
            return tree[x];
        if (r <= lx || rx <= l)
            return 0;
        int m = (rx + lx) / 2;
        return sum(l, r, 2 * x + 1, lx, m) + sum(l, r, 2 * x + 2, m, rx);
    }

    int sum(int l, int r) {
        return sum(l, r + 1, 0, 0, size);
    }
};

vector<int> z_func(string &s) {
    int n = (int) s.size();
    vector<int> z(n);
    for (int i = 1, l = 0, r = 0; i < n; i++) {
        if (i < r)
            z[i] = min(z[i - l], r - i);
        while (i + z[i] < n && s[z[i]] == s[i + z[i]])
            z[i]++;
        if (i + z[i] >= r) {
            r = i + z[i];
            l = i;
        }
    }
    return z;
}

struct seg {
    int l, r, ind;
};

bool cmp(seg a, seg b) {
    return a.r < b.r;
}

int n, m, k;
string s;
vector<string> a;
vector<int> big_list, pref, pow1, pow2, pos, start;
vector<vector<pair<int, int>>> small;
vector<vector<int>> big;
vector<seg> evs;
map<pair<int, int>, int> mp;
segtree tree;

void init() {
    sort(all(evs), cmp);
    k = (int) s.size();
    pref.resize(k + 1);
    start.resize(k + 1);
    small.resize(k, vector<pair<int, int>> (C + 1));
    big.resize(n);
    pos.resize(n);
    pow1.resize(C + 100);
    pow2.resize(C + 100);
    pow1[0] = 1;
    pow2[0] = 1;
    for (int i = 1; i < C + 100; i++) {
        pow1[i] = (pow1[i - 1] * P1) % M1;
        pow2[i] = (pow2[i - 1] * P2) % M2;
    }

    tree.init(k);

    for (int i = 0; i < n; i++) {
        int len = (int) a[i].size();
        if (len > C) {
            string str = a[i] + "#" + s;
            vector<int> z = z_func(str);
            for (int j = 0; j < k; j++) {
                if (z[j + len + 1] >= len)
                    big[i].em(j);
            }
        }
        else {
            pair<int, int> p = {0, 0};
            for (int j = 0; j < len; j++) {
                p.fi = (p.fi + (int) (a[i][j] - 'a' + 1) * pow1[j]) % M1;
                p.se = (p.se + (int) (a[i][j] - 'a' + 1) * pow2[j]) % M2;
            }
            mp[p]++;
        }
    }
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < C && i + j < k; j++) {
            small[i][j + 1].fi = (small[i][j].fi + (int) (s[i + j] - 'a' + 1) * pow1[j]) % M1;
            small[i][j + 1].se = (small[i][j].se + (int) (s[i + j] - 'a' + 1)  * pow2[j]) % M1;
        }
    }
}


void update(int i) {
    pref[i + 1] = pref[i];
    start[i + 1] = start[i];
    for (auto it : big_list) {
        while (pos[it] < big[it].size() && big[it][pos[it]] + a[it].size() - 1 <= i) {
            tree.set(big[it][pos[it]], 1);
            pref[i + 1]++;
            pos[it]++;
        }
    }
    for (int j = max(0LL, i - C + 1); j <= i; j++) {
        int value = mp[small[j][i - j + 1]];
        pref[i + 1] += value;
        tree.set(j, value);
    }
}

void solve() {
    cin >> n >> m >> s;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i].size() >= C)
            big_list.em(i);
    }
    evs.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> evs[i].l >> evs[i].r;
        evs[i].l--;
        evs[i].r--;
        evs[i].ind = i;
    }

    init();

    vector<int> ans(m);
    int j = 0;
    for (int i = 0; i < m; i++) {
        while (j <= evs[i].r) {
            update(j);
            j++;
        }
        ans[evs[i].ind] = pref[evs[i].r + 1] - tree.sum(0, evs[i].l - 1);
    }
    for (int i = 0; i < m; i++) {
        cout << ans[i] << " ";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    //cout << fixed << setprecision(15);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}