#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <random>
#include <ctime>
#include <cassert>
#include <algorithm>
#define int long long
using namespace std;

vector<vector<int>> sobs;

void pr(string t, int x) {
	vector<int> p(t.size());
	p[0] = 0;
	for (int i = 1; i < t.size(); ++i) {
		int cur = p[i - 1];
		while (cur != 0 && t[cur] != t[i]) {
			cur = p[cur - 1];
		}
		if (t[cur] == t[i]) {
			p[i] = cur + 1;
		}		
		if (p[i] == x) {
			sobs[i - 2 * x].push_back(x);
		}
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	string s;
	sobs.resize(t.size());
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		string y = s;
		y += '#';
		y += t;
		pr(y, s.size());
	}
	for (int i = 0; i < t.size(); ++i) {
		sort(sobs[i].begin(), sobs[i].end());
	}
	int l, r, ans;
	for (int i = 0; i < m; ++i) {
		cin >> l >> r;
		l--;
		ans = 0;
		for (int j = l; j < r; ++j) {
			int ll = -1;
			int rr = sobs[j].size();
			int mm;
			while (rr - ll > 1) {
				mm = (rr + ll) / 2;
				if (sobs[j][mm] + j <= r) {
					ll = mm;
				}
				else {
					rr = mm;
				}
			}
			ans += ll + 1;
		}
		cout << ans << '\n';
	}
}

/*
4 3 7 2
5 1 6 2
1 2 5
2 3 10
3 4 50
*/

/*
3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5
*/

/*
4 4
abcdca
ab
ca
bcd
openolympiad
1
5
2
2 2
0
2 6
2
1 6
3
*/