#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <random>
#include <ctime>
#include <cassert>
#include <algorithm>
#define int long long
using namespace std;

vector<pair<int,pair<int, int>>> sobs;

void pr(string t, int x) {
	vector<int> p(t.size());
	p[0] = 0;
	for (int i = 1; i < t.size(); ++i) {
		int cur = p[i - 1];
		while (cur != 0 && t[cur] != t[i]) {
			cur = p[cur - 1];
		}
		if (t[cur] == t[i]) {
			p[i] = cur + 1;
		}		
		if (p[i] == x) {
			sobs.push_back({ i - 2 * x, {1, x} });
			sobs.push_back({ i - x - 1, {2, x} });
		}
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	string s;
	sobs.resize(t.size());
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		string y = s;
		y += '#';
		y += t;
		pr(y, s.size());
	}
	vector<int> anses(m);
	int l, r, ans;
	for (int i = 0; i < m; ++i) {
		cin >> l >> r;
		l--;
		r--;
		sobs.push_back({ l, {0, i} });
		sobs.push_back({ r, {3, i} });
		if (sobs.size() > 5e6) {
			assert(false);
		}
	}
	sort(sobs.begin(), sobs.end());
	int got = 0;
	int inp = 0;
	for (int i = 0; i < sobs.size(); ++i) {
		if (sobs[i].second.first == 0) {
			anses[sobs[i].second.second] = got + inp;
		}
		else if (sobs[i].second.first == 1) {
			inp++;
		}
		else if (sobs[i].second.first == 2) {
			inp--;
			got++;
		}
		else {
			anses[sobs[i].second.second] = (got - anses[sobs[i].second.second]);
		}
	}
	for (int i : anses) {
		cout << i << ' ';
	}
}

/*
4 3 7 2
5 1 6 2
1 2 5
2 3 10
3 4 50
*/

/*
3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5
*/

/*
4 4
abcdca
ab
ca
bcd
openolympiad
1 5
2 2
2 6
1 6
*/