#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
using namespace std;
const int mod = 10000019;
const int base = 31;
const int base2 = 57;
const int mod2 = 10000079;


int pows[2500 * 101];
int pref[2000 * 101];
int pows2[2500 * 101];
int pref2[2000 * 101];

pair<int, int> sub(int i, int j) {
    return {((pref[j] - (long long)pref[i] * pows[j - i]) % mod + mod) % mod,
            ((pref2[j] - (long long)pref2[i] * pows2[j - i]) % mod2 + mod2) % mod2};
}

vector<int> cnt[2500 * 101];
vector<int> cnt2[2500 * 101];

int was[mod];
int was2[mod2];

signed main() {

    pows[0] = 1;
    for (int i = 1; i < 2500 * 101; i++) {
        pows[i] = (long long)pows[i - 1] * base % mod;
    }

    pows2[0] = 1;
    for (int i = 1; i < 2500 * 101; i++) {
        pows2[i] = (long long)pows2[i - 1] * base2 % mod2;
    }

    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<pair<int, int>> have;
    vector<int> sz;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        sz.push_back(s.size());
        int h = 0;
        int h2 = 0;
        for (int i = 0; i < s.size(); i++) {
            h = (long long)(h + (s[i] - 'a' + 1)) * base % mod;
            h2 = (long long)(h2 + (s[i] - 'a' + 1)) * base2 % mod2;
        }
        was[h] = 1;
        was2[h2] = 1;
    }
    sort(sz.begin(), sz.end());
    sz.erase(unique(sz.begin(), sz.end()), sz.end());
    sort(have.begin(), have.end());
    for (int i = 0; i <= t.size(); i++) {
        cnt[i].resize(sz.size());
        cnt2[i].resize(sz.size());
    }
    pref[0] = 0;
    for (int i = 1; i <= t.size(); i++) {
        pref[i] = (long long)((pref[i - 1] + (t[i - 1] - 'a' + 1))) * base % mod;
        pref2[i] = (long long)((pref2[i - 1] + (t[i - 1] - 'a' + 1))) * base2 % mod2;
    }
    int j = 0;
    for (auto x : sz) {
        for (int i = 0; i <= (int)t.size() - x; i++) {
            pair<int, int> now = sub(i, i + x);
            if (was[now.first] && was2[now.second]) {
                cnt[i + 1][j] = 1;
            }
        }
        j++;
    }
    for (int i = 1; i <= t.size(); i++) {
        for (int j = 0; j < sz.size(); j++) {
            cnt[i][j] += cnt[i - 1][j];
        }
    }
    for (int i = 0; i <= t.size(); i++) {
        int j = 0;
        for (auto x : sz) {
            if (i - x + 1 >= 0) {
                cnt2[i][j] = cnt[i - x + 1][j];
            }
            j++;
        }
    }
    for (int i = 0; i <= t.size(); i++) {
        for (int j = 1; j < sz.size(); j++) {
            cnt2[i][j] += cnt2[i][j - 1];
        }
    }
    for (int i = 0; i <= t.size(); i++) {
        for (int j = 1; j < sz.size(); j++) {
            cnt[i][j] += cnt[i][j - 1];
        }
    }
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        int j = 0;
        int last = lower_bound(sz.begin(), sz.end(), r - l + 2) - sz.begin();
        last--;
        int pr = 0;
        if (last >= 0) {
            pr = cnt2[r][last];
        }
        int pl = 0;
        if (last >= 0) {
            pl = cnt[l - 1][last];
        }

        cout << pr - pl << ' ';
    }
}

/*
 3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5
 */