#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 1e6 + 5;

const int MOD = 1e9 + 9;
const int P = 227;

int add(int a, int b) {
    a += b;
    if (a >= MOD) {
        return a - MOD;
    }
    return a;
}

int mult(int a, int b) {
    return 1LL * a * b % MOD;
}

int sub(int a, int b) {
    a -= b;
    if (a < 0) {
        return a + MOD;
    }
    return a;
}

int pref[N];

int n, m;
string t;
ve<string> a;
ve<int> Q[N];
ve<pii> good;
int ans[N];
ve<array<int, 3>> query;

int T[N];

void upd(int pos, int x) {
    while (pos < sz(t)) {
        T[pos] += x;
        pos = pos | (pos + 1);
    }
}

int get(int pos) {
    int ans = 0;
    while (pos >= 0) {
        ans += T[pos];
        pos = (pos & (pos + 1)) - 1;
    }
    return ans;
}

int bpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) {
            res = mult(res, a);
        }
        a = mult(a, a);
        b >>= 1;
    }
    return res;
}

int inv[N];

int getHash(int l, int r) {
    int res = pref[r];
    if (l > 0) res = sub(res, pref[l - 1]);
    res = mult(res, inv[l]);
    return res;
}

gp_hash_table<int, bool> have;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    inv[0] = 1;
    inv[1] = bpow(P, MOD - 2);
    fr (i, 2, N - 1) {
        inv[i] = mult(inv[i - 1], inv[1]);
    }

    cin >> n >> m;

    cin >> t;

    fr (i, 1, n) {
        string s;
        cin >> s;

        a.pb(s);
        Q[sz(s)].pb(i - 1);
    }

    {
        int p = 1;
        fr (i, 0, sz(t) - 1) {
            pref[i] = mult(p, t[i] - 'a' + 1);
            pref[i] = add(pref[i], pref[i - 1]);

            p = mult(p, P);
        }
    }

    fr (len, 1, N - 1) {
        if (sz(Q[len])) {
            have.clear();
            fe (x, Q[len]) {
                int h = 0;
                int p = 1;
                fr (i, 0, sz(a[x]) - 1) {
                    h = add(h, mult(p, a[x][i] - 'a' + 1));
                    p = mult(p, P);
                }
                have[h] = 1;
            }

            fr (i, 0, sz(t) - len) {
                if (have.find(getHash(i, i + len - 1)) != have.end()) {
                    good.pb({i, i + len - 1});
                }
            }
        }
    }

    fr (i, 1, m) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;

        query.pb({l, r, i});
    }

    sort(all(good));
    reverse(all(good));

    sort(all(query));
    reverse(all(query));
    int ptr = 0;

    fe (cur, query) {
        int l = cur[0];
        int r = cur[1];
        int idx = cur[2];

        while (ptr < sz(good) && good[ptr].fi >= l) {
            upd(good[ptr].se, 1);
            ptr++;
        }
        ans[idx] = get(r) - get(l - 1);
    }

    fr (i, 1, m) {
        cout << ans[i] << "\n";
    }

    return 0;
}
