#include <bits/stdc++.h>

using namespace std;
#define int long long

const int INF = 1e9;
const int MOD = 1e9 + 7;
const int MOD2 = 1e9 + 9;

const int p = 29;
const int p2 = 1009;

vector<int> ps;
vector<int> ps2;

vector<int> build_hash(string s) {
    vector<int> hash;
    hash.push_back(0);
    for (auto i : s) {
        hash.push_back((hash.back() * p + (int)(i - 'a' + 1)) % MOD);
    }
    return hash;
}

vector<int> build_hash2(string s) {
    vector<int> hash;
    hash.push_back(0);
    for (auto i : s) {
        hash.push_back((hash.back() * p2 + (int)(i - 'a' + 1)) % MOD2);
    }
    return hash;
}

int substr_hash(vector<int>& hash1, int l, int r) {
    return ((hash1[r] % MOD - (hash1[l - 1] * ps[r - l + 1]) % MOD) + MOD) % MOD;
}

int substr_hash2(vector<int>& hash1, int l, int r) {
    return ((hash1[r] % MOD2 - (hash1[l - 1] * ps2[r - l + 1]) % MOD2) + MOD2) % MOD2;
}

inline void solve() {
    int n, m;
    cin >> n >> m;
    ps.push_back(1);
    for (int i = 0; i < 6e6; ++i)
        ps.push_back(((ps.back() * p) % MOD));
    ps2.push_back(1);
    for (int i = 0; i < 6e6; ++i)
        ps2.push_back(((ps2.back() * p2) % MOD2));
    string t;
    cin >> t;
    vector<int> thash = build_hash(t);
    vector<int> thash2 = build_hash2(t);
    vector<pair<int, int>> ocs;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        vector<int> shash = build_hash(s);
        vector<int> shash2 = build_hash2(s);
        for (int j = 1; j + s.length() - 1 <= t.length(); j++) {
            if (substr_hash(thash, j, j + s.length() - 1) == shash.back() && substr_hash2(thash2, j, j + s.length() - 1) == shash2.back()) {
                ocs.emplace_back(j, j + s.length() - 1);
            }
        }
    }
    sort(ocs.begin(), ocs.end());
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        pair<int, int> to = {l, -1};
        auto it = lower_bound(ocs.begin(), ocs.end(), to);
        int j = it - ocs.begin();
        int ans = 0;
        while (j < ocs.size()) {
            if (ocs[j].first > r)
                break;
            if (ocs[j].second <= r)
                ans++;
            j++;
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
#ifdef LOCAL
    cin >> tests;
#endif
    for (int i = 1; i <= tests; ++i)
        solve();
}