#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <string>
#include <climits>
#include <math.h>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define pll pair<ll, ll>
#define p 39
#define mod 1000000007

int siz_t;

vector<ll> arr_p{ 1 };

vector<ll> build_pref(string s) {
	vector<ll> ret(s.size() + 1, 0);
	for (ll i = 1; i < ret.size(); i++)
	{
		ret[i] = ((ret[i - 1] * p) % mod + s[i - 1] - 'a' + 1) % mod;
	}
	return ret;
}

ll get_pref(ll l, ll r, vector<ll> pref) {
	if (l == 0) { return pref[r]; }
	return (pref[r] - (pref[l - 1] * arr_p[r - l + 1]) % mod + mod) % mod;
}



int main()
{
	int siz, get;
	cin >> siz >> get;
	string t;
	cin >> t;
	siz_t = t.size() + 1;

	for (int i = 1; i < siz_t; i++)
	{
		arr_p.push_back((arr_p[i - 1] * p + mod) % mod);
	}

	vector<ll> pref_t = build_pref(t);

	vector<vector<int>> arr(siz);
	vector<int> siz_s(siz);
	for (int g = 0; g < siz; g++)
	{
		string s;
		cin >> s;
		siz_s[g] = s.size();
		if (s.size() > t.size()) {
			continue;
		}
		//vector<ll> pref = build_pref(s);
		ll pr = 0;
		for (int i = 0; i < s.size(); i++)
		{
			pr = ((pr * p) % mod + s[i] - 'a' + 1) % mod;
		}
		for (int i = 0; i < s.size(); i++)
		{
			arr[g].push_back(0);
		}

		for (int i = s.size(); i < siz_t; i++)
		{
			ll tm = (get_pref(i - s.size() + 1, i, pref_t));
			ll tmp = (arr[g][i - 1]) + (tm == pr);
			arr[g].push_back(tmp);
		}
	}

	for (int g = 0; g < get; g++)
	{
		int l, r;
		cin >> l >> r;
		ll out = 0;
		for (int i = 0; i < siz; i++)
		{
			if (siz_s[i] > t.size()) {
				continue;
			}
			ll tmp = arr[i][r] - arr[i][l - 2 + siz_s[i]];
			out += tmp;
		}
		cout << out << ' ';
	}


}







