#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 2e5, MOD = 1e9 + 9, INF = 1e18, P = 911;

void solve() {
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> v(n);
    vector<ll> h(n);
    for(ll i = 0; i < n; i++){
        cin >> v[i];
    }
    for(ll i = 0; i < n; i++){
        for(ll j = 0; j < (ll)v[i].size(); j++){
            h[i] *= P;
            h[i] += (v[i][j] - 'a' + 1);
            h[i] %= MOD;
        }
    }
    map<ll, ll> mp;
    for(ll i = 0; i < n; i++){
        mp[h[i]]++;
    }
    vector<ll> hs((ll)t.size() + 1), step((ll)t.size() + 1);
    step[0] = 1;
    for(ll i = 1; i <= (ll)t.size(); i++){
        step[i] = step[i - 1] * P % MOD;
        hs[i] = hs[i - 1] * P + (t[i - 1] - 'a' + 1) % MOD;
    }
    for(ll i = 0; i < m; i++){
        ll l, r, ans = 0;
        cin >> l >> r;
        for(ll j = l; j <= r; j++){
            for(ll g = j; g <= r; g++){
                ll L = j - 1, R = g;
                ll x = hs[R] - (hs[L] * step[R - L] % MOD);
                if(x < 0){
                    x += MOD;
                }
                ans += mp[x];
            }
        }
        cout << ans << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}
