//#pragma 'GCC-optimize'
#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(),x.end()
#define vi vector <int>
#define vvi vector <vector <int> >
#define fi(n) for (int i = 0; i < n; ++i)
#define f first
#define s second

using namespace std;

const int maxt = 100000, p = 31, mod = 1e9+7;
int n, m; string t;
vector <int> h(maxt);
vector <int> pw(maxt, 1);
vector <int> s;

int mul(int a, int b) {
    if (a * b < mod) return a * b;
    return (a * b) % mod;
}

int add(int a, int b) {
    if (a + b < mod) return a + b;
    return a + b - mod;
}

int sub(int a, int b) {
    if (a >= b) return a - b;
    return a - b + mod;
}

int hsh(string &x) {
    int hsh = 0;
    for (int i = 0; i < (int)x.size(); ++i) {
        hsh =  add(mul(hsh, p), (x[i] - 'a' + 1));
    }
    return hsh;
}

void calc() {
    h[0] = 0;
    for (int i = 0; i < (int)t.size(); ++i) {
        h[i + 1] = add(mul(h[i], p), (t[i] - 'a' + 1));
        pw[i + 1] = mul(pw[i], p);
    }
}

int subb(int l, int r) { // [l, r)
    return sub(h[r], mul(h[l], pw[r - l]));
}

void Solve() {
    int l, r; cin >> l >> r; l--;
    multiset <int> q;
    for (int i = l; i < r; ++i) {
        for (int j = i + 1; j <= r; ++j) {
            q.insert(subb(i, j));
            //cout << "{" << i << " " << j << "}: " << subb(i, j) << "\n";
        }
    }
    //cout << '\n';
    int ans = 0;
    for (auto x: s) {
        //cout << x << " ";
        ans += q.count(x);
    }
    //cout << '\n';
    cout << ans << " ";
}

void solve() {
    cin >> n >> m >> t;
    calc();
    for (int i = 0; i < n; ++i) {
        string x; cin >> x;
        s.push_back(hsh(x));
    }
    while (m--) {
        Solve();
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    //cin >> tests;
    tests = 1;
    while (tests--) {
        // stress();
        solve();
    }
    return 0;
}