//#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,bmi,bmi2,fma,lzcnt,popcnt")
#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<bool> vb;
// const ll mod = 1e9 + 7;


//#include<ext/pb_ds/assoc_container.hpp>
//#include<ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//typedef tree<int, less<int>, null_type, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


struct hsh {
    int n;
    string s;
    const ll q = 29;
    vll h1, h2;
    vll p1, p2;


    const ll __mod1 = 1e9 + 7;
    const ll __mod2 = (1ll << 31) + 45;

    ll mod1(ll x) {
        return (__mod1 + x % __mod1) % __mod1;
    }
    ll mod2(ll x) {
        return (__mod2 + x % __mod2) % __mod2;
    }

    ll ctoi(char c) {
        return c - 'a' + 1;
    }


    hsh(const string &_s) {
        s = _s;
        n = s.size();

        h1.resize(n+1);
        h2.resize(n+1);
        p1.resize(n+1);
        p2.resize(n+1);

        h1[0] = 0;
        h2[0] = 0;
        p1[0] = 1;
        p2[0] = 1;

        for (int i = 0; i < n; i++) {
            p1[i+1] = mod1(p1[i] * q);
            p2[i+1] = mod2(p2[i] * q);

            h1[i+1] = mod1(q * h1[i] + ctoi(s[i]));
            h2[i+1] = mod2(q * h2[i] + ctoi(s[i]));
        }
    }

    pll operator()(int l = 0, int r = -1) {
        if (r == -1) r = n;
        return {mod1(h1[r] - h1[l] * p1[r - l]), mod2(h2[r] - h2[l] * p2[r - l])};
    }
};


struct query {
    int l, r;
    int id;

    query() {}

    query(int _l, int _r, int _id) {
        l = _l;
        r = _r;
        id = _id;
    }

    bool operator<(const query &other) const {
        return r < other.r;
    }
};


struct ST {
    int n;
    vll t;

    ST(int _n) {
        n = _n;
        t.resize(4 * n);
    }

    ll get(int ql, int qr, int v = 0, int l = 0, int r = -1) {
        if (r == -1) r = n;

        if (ql <= l && r <= qr) {
            return t[v];
        }

        if (qr <= l || r <= ql) {
            return 0;
        }

        int m = l + (r - l) / 2;

        return get(ql, qr, 2 * v + 1, l, m) + get(ql, qr, 2 * v + 2, m, r);
    }

    void upd(int pos, int v = 0, int l = 0, int r = -1) {
        if (r == -1) r = n;

        if (r - l == 1) {
            t[v]++;
            return;
        }

        int m = l + (r - l) / 2;

        if (pos < m) {
            upd(pos, 2 * v + 1, l, m);
        } else {
            upd(pos, 2 * v + 2, m, r);
        }

        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }
};


void solve() {
    int n, m;
    cin >> n >> m;

    string t;
    cin >> t;

    hsh ht(t);

    vector<hsh> s;
    for (int i = 0; i < n; i++) {
        string x;
        cin >> x;

        s.emplace_back(x);
    }

    vector<query> qy(m);
    for (int i = 0; i < m; i++) {
        cin >> qy[i].l >> qy[i].r;
        qy[i].l--;
        qy[i].id = i;
    }

    sort(all(qy));
    vll ans(m);

    ST starts(t.size());
    int pos = 0;

    for (query cur : qy) {
        while (pos < cur.r) {

            for (int i = 0; i < n; i++) {
                if (s[i].n > pos+1) {
                    continue;
                }

                if (ht(pos - s[i].n + 1, pos+1) == s[i]()) {
                    starts.upd(pos - s[i].n + 1);
                }
            }
            pos++;
        }

        ans[cur.id] = starts.get(cur.l, cur.r);
    }

    for (int i : ans) {
        cout << i << ' ';
    }
    cout << '\n';
}


int main() {
    //ios_base::sync_with_stdio(0); cin.tie(); cout.tie();

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}


