#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3,inline,unroll-loops")
//#pragma GCC target("avx2,sse,sse2,popcnt")
using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define ll long long
#define ld long double
#define pt pair<int, int>
#define fi first
#define x first
#define se second
#define y second
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
///=================================================///
const int MX = 1e6 + 100;
const int INF = 2e9;
const int MOD = 1e9 + 9;
const int Q = 239;

///=================================================///
int n, m;
string T;


int hs[MX], pw[MX];

int get(int l, int r) {
    int x = (hs[r] - hs[l] * pw[r - l]);
    x %= MOD;
    if (x < 0) x += MOD;
    return x;
}

set<int> globals;

vector<int> pos[MX];
int dlin[MX];

void solve() {
    cin >> n >> m; cin >> T;
    for (int i = 0; i < sz(T); i++) {
        hs[i + 1] = (hs[i] * Q + (T[i] - 'a' + 1)) % MOD;
    }
    set<int> dlins;
    for (int i = 0; i < n; i++) {
        string s; cin >> s;
        dlins.insert(sz(s));
        int hasher = 0;
        for (int j = 0; j < sz(s); j++) {
            hasher = (hasher * Q + (s[j] - 'a' + 1)) % MOD;
        }
        globals.insert(hasher);
    }
    int last = 0;
    for (int d : dlins) {
        dlin[last] = d;
        for (int i = 0; i + d <= sz(T); i++) {
            int H = get(i, i + d);
            if (globals.count(H)) {
                pos[last].push_back(i);
            }
        }
        last++;
    }

    while (m--) {
        int l, r; cin >> l >> r; l--;
        int res = 0;
        for (int i = 0; i < last; i++) {
            int d = dlin[i];
            if (r - l < d) continue;
            int add = (int)(lower_bound(all(pos[i]), r - d + 1) - lower_bound(all(pos[i]), l));
            //cout << add << " " << d << "\n";
            assert(add >= 0);
            res += add;
        }
        cout << res << " ";
    }



}

signed main() {
    pw[0] = 1;
    for (int i = 1; i < MX; i++) {
        pw[i] = (pw[i - 1] * Q) % MOD;
    }
#ifndef LOCAL
    ios::sync_with_stdio(0); cin.tie();
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int tests = 1;
    // cin >> tests;
    ld starts = clock();
    while (tests--) solve();
    ld endd = clock();
#ifdef LOCAL
    cout << "\nEND: " << (endd - starts) / (ld) (CLOCKS_PER_SEC) << " sec\n";
#endif
    return 0;
}