#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

#define vec vector
#define pb push_back
#define sz(x) (int) (x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using str = string;

#ifdef Local
#define debug(x) cout << endl \
                      << "$ " << #x << " = " << x << endl
#else
#define debug(...) 1337
#endif

template<typename key, typename comp = less<>>
using pbds = __gnu_pbds::tree<key, __gnu_pbds::null_type, comp, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void print(pbds<pair<int, int>> os) {
    cout << "$ os = { ";
    int n = sz(os);
    auto it = os.begin();
    for (int i = 0; i < n - 1; ++i, ++it)
        cout << "{ " << *it << ", ";
    if (it == os.end())
        cout << "}\n";
    else
        cout << *it << " }\n";
}

void solve() {
    int n, m;
    cin >> n >> m;
    str t;
    cin >> t;
    vec<pair<int, int>> c;
    str s;
    vec<int> z;
    for (int tt = 0, ln, x; tt < n; ++tt) {
        cin >> s;
        x = sz(s);
        s.append("$").append(t);
        ln = sz(s);
        z.resize(ln);
        z.assign(ln, 0);
        for (int i = 1, l = 0, r = 0; i < ln; ++i) {
            if (i <= r) z[i] = min(r - z[i] + 1, z[i - l]);
            while (i + z[i] < ln && s[i + z[i]] == s[z[i]]) ++z[i];
            if (i + z[i] - 1 > r) l = i, r = i + z[i] - 1;
            if (z[i] == x)
                c.pb({i - x - 1, i - 2});
        }
    }
    sort(all(c));
    vec<pair<int, int>> q(m);
    for (auto &[l, r]: q)
        cin >> l >> r, --l, --r;
    map<pair<int, int>, int> mp;
    vec<pair<int, int>> qp = q;
    sort(all(q));
    q.erase(unique(all(q)), q.end());
    pbds<pair<int, int>> os;
    for (int i = 0; i < sz(c); ++i)
        os.insert({c[i].second, c[i].first});
    for (int i = 0, j = 0; i < sz(q); ++i) {
        auto &[l, r] = q[i];
        while (j < sz(c) && c[j].first < l)
            assert(os.upper_bound({c[i].second, c[i].first}) != os.end()), os.erase(os.upper_bound({c[i].second, c[i].first})), ++j;
        mp[q[i]] = os.order_of_key({r + 1, -1});
        // print(os);
    }
    for (int i = 0; i < m; ++i)
        cout << mp[qp[i]] << ' ';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();

    return 0;
}