#pragma GCC optimization("Ofast")
#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace     std;
using namespace     __gnu_pbds;
#define int         long long
#define popcnt      __builtin_popcount
#define clz         __builtin_clz
#define ctz         __builtin_ctz
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
const int pr = 37, mod = 1000000007;
inline int MUL(int x, int y) {
    return (x * y) % mod;
}
inline int ADD(int x, int y) {
    return (x + y) % mod;
}
inline int SUB(int x, int y) {
    return ((x - y) % mod + mod) % mod;
}
void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    vector<vector<int>> hs(n), prefs(n);
    vector<int> p(t.size() + 1, 1), h(t.size() + 1);
    for (int i = 0; i < t.size(); ++i) {
        h[i + 1] = ADD(MUL(h[i], pr), t[i] - 'a' + 1);
        p[i + 1] = MUL(p[i], pr);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        hs[i].resize(s[i].size() + 1);
        prefs[i].resize(t.size() + 1);
        for (int j = 0; j < s[i].size(); ++j) {
            hs[i][j + 1] = ADD(MUL(hs[i][j], pr), s[i][j] - 'a' + 1);
        }
        for (int j = 0; j <= (int)t.size() - (int)s[i].size(); ++j) {
            prefs[i][j + 1] = hs[i].back() == SUB(h[j + s[i].size()], MUL(h[j], p[(int)s[i].size()]));
        }
        partial_sum(prefs[i].begin(), prefs[i].end(), prefs[i].begin());
    }
    while (m--) {
        int l, r, ans = 0;
        cin >> l >> r;
        for (int i = 0; i < n; ++i) {
            if (r - l + 1 >= (int)s[i].size()) {
                ans += prefs[i][r - (int)s[i].size() + 1] - prefs[i][l - 1];
            }
        }
        cout << ans << ' ';
    }
}
signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int Tc = 1;
    // cin >> Tc;
    while (Tc--) {
        solve(), cout << '\n';
    }
}