#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#include <unordered_set>
#define ll long long
#define ul unsigned long long
#define ld long double

// login: open-2023-382
// passw: 6tgd8wpk

using namespace std;

const ll inf = 1e18;

ll n, m;
string t;
vector<string> s;
vector<ll> l, r, ans;

const ll MOD = 1e9 + 7, p = 4242;

void read() {
	cin >> n >> m;
	cin >> t;
	l = r = vector<ll>(m);
	s = vector<string>(n);
	for (ll i = 0; i < n; i++) {
		cin >> s[i];
	}
	for (ll i = 0; i < m; i++) {
		cin >> l[i] >> r[i];
	}
}

set<ll> sizes;
set<pair<ll, ul>> H[100001];
vector<pair<ll, ul>> hashT;
ll step1[800001];
ul step2[800001];

pair<ll, ll> getT(ll l, ll r) {
	l--;
	return { (hashT[r].first - (hashT[l].first *
		step1[r - l] % MOD) + 2 * MOD) % MOD, hashT[r].second -
			(hashT[l].second * step2[r - l]) };
}

void build() {
	step1[0] = 1;
	step2[0] = 1;
	for (ll i = 1; i <= 800000; i++) {
		step1[i] = (step1[i - 1] * p) % MOD;
		step2[i] = step2[i - 1] * p;
	}

	for (ll i = 0; i < n; i++) {
		if ((ll)s[i].size() > (ll)t.size()) continue;
		ll h1 = 0;
		ul h2 = 0;
		for (ll j = 0; j < (ll)s[i].size(); j++) {
			h1 = (h1 * p) % MOD;
			h1 += s[i][j];

			h2 = h2 * p;
			h2 += s[i][j];
		}
		H[(ll)s[i].size()].insert({ h1, h2 });
		sizes.insert((ll)s[i].size());
	}
	hashT = vector<pair<ll, ul>>((ll)t.size() + 1);
	hashT[0] = { 0 , 0 };
	for (ll i = 1; i <= (ll)t.size(); i++) {
		hashT[i].first = (hashT[i - 1].first * p + t[i - 1]) % MOD;
		hashT[i].second = hashT[i - 1].second * p + t[i - 1];
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);

	read();
	build();
	ans = vector<ll>(m);
	for (auto& cur : sizes) {
		vector<ll> cnt((ll)t.size() + 1, 0);
		for (ll i = cur; i <= (ll)t.size(); i++) {
			pair<ll, ul> suf = getT(i - cur + 1, i);
			if (H[cur].find(suf) != H[cur].end()) {
				cnt[i] = 1;
			}
		}
		vector<ll> pref((ll)t.size() + 1);
		for (ll i = 1; i <= (ll)t.size(); i++) {
			pref[i] = pref[i - 1] + cnt[i];
		}
		for (ll i = 0; i < m; i++) {
			ll curR = r[i];
			ll curL = l[i] + cur - 1;
			if (curR < curL) {
				continue;
			}
			ans[i] += pref[curR] - pref[curL - 1];
		}
	}
	for (ll i = 0; i < m; i++) {
		cout << ans[i] << ' ';
	}

	return 0;
}