//#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <vector>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>

using namespace std;

#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC target("avx")
#pragma GCC target("avx2")

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;

//mt19937 rnd(time(NULL));

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector
#define pb push_back
#define int long long

const int INF = 2e9 + 333, N = 5e5 + 10;

vec<int> p(N, 1);

struct Hash {
    vec<int> h;
    int n;
    void init(string& s) {
        n = (int)s.size();
        h.assign(n + 1, 0);
        for (int i = 1; i <= n; ++i) {
            h[i] = (h[i - 1] + (s[i - 1] - 'a' + 1) * p[i - 1]) % INF;
        }
    }
    int get(int l, int r) {
        return (((h[r + 1] - h[l] + INF) % INF) * p[N - l - 1]) % INF;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vec<unordered_map<int, int>> mp(1e5 + 1);
    set<int> lenn;
    string t;
    cin >> t;
    Hash hsh;
    hsh.init(t);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        if ((int)s.size() > (int)t.size()) continue;
        int h = 0;
        for (int j = 1; j <= (int)s.size(); ++j) {
            h = (h + (s[j - 1] - 'a' + 1) * p[j - 1]) % INF;
        }
        h = (h * p[N - 1]) % INF;
        mp[(int)s.size()][h] = 1;
        lenn.insert((int)s.size());
    }
    vec<int> ln;
    for (int i : lenn) ln.push_back(i);
    vec<vec<pair<int, pair<int, int>>>> rs((int)ln.size());
    vec<int> res(m);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        int it = upper_bound(all(ln), r - l + 1) - ln.begin();
        it--;
        if (it != -1) {
            rs[it].push_back({ i, {l, r} });
            //res[i] = e[it][r + 1] - d[it][l];
        }
    }
    vec<int> d((int)t.size() + 1), e((int)t.size() + 1), k((int)t.size() + 1);
    for (int i = 0; i < (int)ln.size(); ++i) {
        int s = 0;
        int su = 0;
        for (int j = (int)t.size(); j >= 0; --j) e[j] = 0;
        for (int j = 0; j < (int)t.size(); ++j) {
            e[j + 1] += k[j + 1];
            if (ln[i] + j <= (int)t.size()) {
                int ee = mp[ln[i]][hsh.get(j, ln[i] + j - 1)];
                s += ee;
                e[ln[i] + j] += ee;
            }
            int h = e[j + 1];
            e[j + 1] += su;
            su += h - k[j + 1];
            d[j + 1] += s;
        }
        for (auto& j : rs[i]) {
            res[j.first] = e[j.second.second + 1] - d[j.second.first];
        }
        swap(e, k);
    }
    for (int i = 0; i < m; ++i) cout << res[i] << " ";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (int i = 1; i < N; ++i) p[i] = (p[i - 1] * 37) % INF;
    for (; t > 0; --t) {
        solve();
    }
    return 0;
}