#include<bits/stdc++.h>
using namespace std;
using ll = long long;
const ll inf = 1e8;
ll n, a, b;
vector<map<ll, pair<ll, ll>>> g;
set<pair<ll, pair<ll, ll>>> s;
vector<bool> used;
vector<pair<ll, pair<ll, ll>>> cnt;
bool fl = true;
void dfs(ll v) {
    if (v == b) {
        for (auto x : cnt) {
            s.insert(x);
        }
        return;
    }
    used[v] = 1;
    for (auto [u, h] : g[v]) {
        if (!used[u]) {
            cnt.push_back({v, {u, h.second % 2}});
            dfs(u);
            cnt.pop_back();
        }
    }
    used[v] = 0;
}
void solve() {
    ll n, m;
    cin >> n >> m;
    g.resize(n);
    used.resize(n, 0);
    for (int i = 0; i < m; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        g[u][v].first ^= w;
        ++g[u][v].second;
    }
    cin >> a >> b;
    --a; --b;
    dfs(a);
    ll kol = 0;
    for (auto x : s) {
        if (x.second.second == 0) {
            ++kol;
        }
    }
    if (kol >= 2) {
        cout << 0 << '\n';
        return;
    }
    if (kol == 1) {
        ll ans = 0;
        for (auto x : s) {
            if (x.second.second == 0) {
                ans = g[x.first][x.second.first].first;
                break;
            }
        }
        cout << ans << '\n';
        return;
    }
    ll ans = 0;
    for (auto x : s) {
        ans ^= g[x.first][x.second.first].first;
    }
    cout << ans << '\n';
    g.clear(); s.clear();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
