#include <iostream>
#include <cmath>
#include <iomanip>
#include <queue>
#include <vector>
#include <set>
#include <algorithm>
#define ll long long
using namespace std;
void FAST() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
vector <ll> p(0);
ll mod = 1e9 + 7;
ll binpow(ll a, ll b) {
    if (b == 0)
        return 1;
    ll q = binpow(a, b / 2);
    ll tq = q * q % mod;
    if (b % 2 == 0)
        return tq;
    else
        return (tq * a) % mod;
}
void solve() {
    ll n, m, ans1 = 0;
    cin >> n >> m;
    bool flag = false;
    if (m != n)
        flag = true;
    vector <vector <pair<ll, pair<ll, ll>>> > g(n);
    for (ll i = 0; i < m; ++i) {
        ll s, f, l;
        cin >> s >> f >> l;
        ans1 ^= l;
        s--; f--;
        if (s != i || f != ((i + 1) % n))
            flag = true;
        g[s].push_back({ f, {l, 0} });
    }
    for (ll i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end());
        vector <pair<ll, pair<ll, ll> > > q(0);
        ll last = -1;
        for (auto j : g[i]) {
            if (j.first == last) {
                q[q.size() - 1].second.first ^= j.second.first;
                q[q.size() - 1].second.second ^= 1;
            }
            else {
                last = j.first;
                q.push_back({ last, {j.second.first, 0} });
            }
        }
        g[i] = q;
    }
    ll st, fn; cin >> st >> fn;
    st--;
    fn--;
    if (!flag) {
        ll ans = 0, p1 = st;
        while (p1 != fn) {
            ans ^= g[p1][0].second.first;
            p1++;
            p1 %= n;
        }
        if (ans != 0) {
            cout << -1 << endl;
            return;
        }
        if (ans1 != 0) {
            cout << -1 << endl;
            return;
        }
        cout << 0 << endl;
        return;
    }
    queue <pair<ll, ll>> q;
    q.push({ st , 0ll });
    ll ans = 0;
    vector <pair<ll, ll>> par(n, { -1, -1 });
    while (!q.empty()) {
        auto now = q.front();
        q.pop();
        for (auto i : g[now.first]) {
            if (i.first == fn) {
                if (i.second.second == 0) {
                    ll ts = now.second ^ i.second.first;
                    ans ^= ts;
                }
                else {
                    ans ^= i.second.first;
                }
            }
            if (i.second.second == 0) {
                q.push({ i.first, now.second ^ i.second.first });
            }
            else {
                q.push({ i.first, i.second.first });
            }
        }
    }
    cout << ans << endl;
}
int main()
{
    FAST();
    int tt = 1; cin >> tt;
    while (tt--) {
        solve();
    }
}
