#include <bits/stdc++.h>

using namespace std;

void top_sort(int v, vector <int>& ord, vector <int>& used, vector <vector <pair <int, int>>>& gg, int lvl) {
    used[v] = lvl;
    for (auto i : gg[v]) {
        if (used[i.first] != lvl) top_sort(i.first, ord, used, gg, lvl);
    }
    ord.push_back(v);
}

vector <vector <pair <int, int>>> g, gg;
vector <vector <int>> rg;
vector <int> used, num, bad;
vector <array <int, 2>> ok, val;

void dfs1(int v, int lvl) {
    num[v] = lvl;
    for (int i : rg[v]) {
        if (num[i] == -1) dfs1(i, lvl);
    }
}

void dfs(int v, int type) {
    for (auto i : g[v]) {
        int ntype = type | bad[num[i.first]];
        if (!ok[i.first][ntype]) continue;
        if (!ok[v][type]) {
            if (ok[i.first][ntype]) {
                ok[i.first][ntype] = 0;
                dfs(i.first, ntype);
            }
        } else {
            bool flex = false;
            if (val[i.first][ntype] != -1 && val[i.first][ntype] != (val[v][type] ^ i.second)) {
                ok[i.first][ntype] = 0;
                flex = true;
            }
            if (val[i.first][ntype] == -1) {
                val[i.first][ntype] = (val[v][type] ^ i.second);
                flex = true;
            }
            if (flex) dfs(i.first, ntype);
        }
    }
}

inline void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    rg.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w; --x; --y;
        g[x].emplace_back(y, w);
        rg[y].emplace_back(x);
    }
    ok.assign(n, {1, 1});
    val.assign(n, {-1, -1});
    vector <int> ord;
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) top_sort(i, ord, used, g, 1);
    }
    reverse(ord.begin(), ord.end());
    num.assign(n, -1);
    int cur = 0;
    for (int i : ord) {
        if (num[i] == -1) {
            dfs1(i, cur++);
        }
    }
    bad.assign(cur, 0);
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (num[i] == num[j.first]) bad[num[i]] = 1;
        }
    }
    gg.assign(cur, {});
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (num[i] != num[j.first]) gg[num[i]].emplace_back(num[j.first], j.second);
        }
    }
    int a, b;
    cin >> a >> b; --a; --b;
    int type = bad[num[a]];
    val[a][type] = 0;
    dfs(a, type);
    if (val[b][0] == -1 && val[b][1] == -1) {
        cout << "0\n";
        return;
    }
    if (!ok[b][1] || val[b][1] > 0) {
        cout << "-1\n";
        return;
    }
    a = num[a];
    b = num[b];
    ord = {};
    for (int i = 0; i < cur; ++i) {
        if (used[i] == 1) {
            top_sort(i, ord, used, gg, 2);
        }
    }
    vector <int> ca(cur), cb(cur);
    for (int i : ord) {
        if (i == b) cb[i] = 1;
        for (auto j : gg[i]) {
            cb[i] ^= cb[j.first];
        }
        if (bad[i]) cb[i] = 0;
    }
    reverse(ord.begin(), ord.end());
    for (int i : ord) {
        if (i == a) ca[i] = 1;
        if (bad[i]) ca[i] = 0;
        for (auto j : gg[i]) {
            ca[j.first] ^= ca[i];
        }
    }
    int ans = 0;
    for (int i = 0; i < cur; ++i) {
        for (auto j : gg[i]) {
            if (ca[i] + cb[j.first] == 2) ans ^= j.second;
        }
    }
    cout << ans << "\n";
}

signed main() {
    if (0) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        int t;
        cin >> t;
        while (t--) {
            solve();
        }
    }
    return 0;
}

/*
 5
 1 1
 1 1 0
 1 1

 3 5
 1 2 0
 1 2 1
 1 2 3
 2 3 5
 2 3 2
 1 3

 2 2
 1 2 1
 2 1 2
 1 2

 3 3
 1 2 7
 2 3 0
 3 1 7
 2 3

 4 5
 1 1 0
 1 2 3
 2 2 0
 2 3 1
 3 4 1
 1 4

 */