#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <vector>
#include <string>
using namespace std;

int n;
int q = 0 , q1 = 0 , q2 = 0;

void dfs(vector<vector<pair<int , long long>>> &g , int v , vector<char> &c , vector<char> &used) {
    c[v] = true;
    used[v] = true;
    for (int i = 0; i < g[v].size(); i++) {
        int to = g[v][i].first;
        if (!used[to]) {
            dfs(g , to , c , used);
        }
    }
}

void dfs2(vector<vector<pair<int , long long>>> &g , int v , int s , vector<char> &used1 , int q1 , int &w , vector<char> &used2) {
    used1[v] = true;
    if (v != q1) {
        used2[v] = true;
    }
    for (int i = 0; i < g[v].size(); i++) {
        int to = g[v][i].first;
        if (to == q1) {
            s = (s ^ g[v][i].second);
            w = s;
            break;
        }
        else if (!used1[to]) {
            s = (s ^ g[v][i].second);
            dfs2(g , to , s , used1 , q1 , w , used2);
        }
    }
}

void dfs1(vector<vector<pair<int , long long>>> &g , int v , vector<char> &c , int a , int b , vector<char> used , vector<char> &used2) {
    used[v] = true;
    for (int i = 0; i < g[v].size(); i++) {
        int to = g[v][i].first;
        if (c[to]) {
            if (used[to]) {
                vector<char> used1(n);
                int w = -1;
                dfs2(g , to , 0 , used1 , to , w , used2);
                if (w > 0) {
                    q = -1;
                } else if (w == 0) {
                    q1 = -1;
                }
            } else {
                dfs1(g , to , c , a , b , used , used2);
            }
        }
    }
}

void dfs4(vector<vector<pair<int , long long>>> &g , int v , vector<char> &c , int a , int b , int r , int &e , vector<int> &p , vector<char> used1) {
    used1[v] = true;
    if (v == b) {
        e = (e ^ r);
        p.push_back(r);
    } else {
    for (int i = 0; i < g[v].size(); i++) {
        int to = g[v][i].first;
        if (c[to]) {
                if (!used1[to]) {
                    //used1[to] = true;
                dfs4(g , to , c , a , b , (r ^ g[v][i].second) , e , p , used1);
                }
        }
    }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
            q = 0 , q1 = 0 , q2 = 0;
        int m;
        cin >> n >> m;
        vector<vector<pair<int , long long>>> gt(n) , g(n);
        for (int i = 0; i < m; i++) {
            int v , to , w;
            cin >> v >> to >> w;
            v--; to--;
            g[v].push_back(make_pair(to , w));
            gt[to].push_back(make_pair(v , w));
        }
        int a , b;
        vector<char> used2(n);
        for (int i = 0; i < n; i++) {
            used2[i] = false;
        }
        cin >> a >> b;
        a--; b--;
        vector<char> c(n);
        vector<char> used(n);
        dfs(gt , b , c , used);
        if (!c[a]) {
            cout << 0 << endl;
            continue;
        }
        for (int i = 0; i < n; i++) {
            used[i] = false;
        }
        dfs1(g , a , c , a , b , used , used2);
        if (q == -1) {
            cout << -1 << endl;
            continue;
        }
        int ans = 0;
        vector<int> p;
        dfs4(g , a , c , a , b , 0 , ans , p , used2);
        int sum = 0;
        for (int i = 0; i < p.size(); i++) {
            sum += p[i];
        }
        if (q1 == -1) {
            if (sum == 0) {
                cout << 0 << endl;
            } else {
                cout << -1 << endl;
            }
        } else {
            cout << ans << endl;
        }

    }
}
