#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 100, MOD = 1e9 + (1000 - 7), MAXN = 2e5;
const ld EPS = 1e-8;

random_device rd;
mt19937 rnd(rd());

#define max3(a, b, c) max(max(a, b), c)
#define min3(a, b, c) min(min(a, b), c)
#define pow2(x) ((x) * (x));
#define mod(x, m) (((x) % (m) + (m)) % (m))
#define debug(x) cerr << (#x) << " : " << x << endl

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> g[n];
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].push_back({v, w});
    }
    int a, b;
    cin >> a >> b;
    a--, b--;
    vector<int> xr(n);
    vector<bool> used(n);
    vector<int> q;
    q.push_back(a);
    int u = 0;
    while (u < q.size()) {
        int v = q[u];
        for (auto [ver, w] : g[v]) {
            xr[ver] = (xr[ver] ^ (xr[v] ^ w));
            if (!used[ver]) {
                q.push_back(ver);
                used[ver] = true;
            }
        }
        ++u;
    }
    cout << xr[b] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    //freopen("ALO.in", "r", stdin);
    //freopen("ALO.out", "w", stdout);

    ll test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}