#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 100, MOD = 1e9 + (1000 - 7), MAXN = 2e5;
const ld EPS = 1e-8;

random_device rd;
mt19937 rnd(rd());

#define max3(a, b, c) max(max(a, b), c)
#define min3(a, b, c) min(min(a, b), c)
#define pow2(x) ((x) * (x));
#define mod(x, m) (((x) % (m) + (m)) % (m))
#define debug(x) cerr << (#x) << " : " << x << endl

void solve() {
    ll n, m;
    cin >> n >> m;
    bool flag = true;
    vector<pair<ll, ll>> g[n];
    ll allxr = 0;
    for (ll i = 0; i < m; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        if (u >= v) flag = false;
        allxr = (allxr ^ w);
        g[u].push_back({v, w});
    }
    ll a, b;
    cin >> a >> b;
    a--, b--;
    if (!flag) {
        int ver = a;
        ll xr = 0;
        while (ver != b) {
            xr = (xr ^ g[ver][0].second);
            ver = g[ver][0].first;
        }
        if (xr > 0 || (allxr ^ xr) > 0) cout << -1 << '\n';
        else cout << 0 << '\n';
    } else {
        vector<ll> xr(n);
        vector<bool> used(n);
        vector<ll> vari(n);
        vari[a] = 1;
        vector<ll> q;
        q.push_back(a);
        ll u = 0;
        while (u < q.size()) {
            ll v = q[u];
            for (auto [ver, w] : g[v]) {
                if (vari[v] % 2 == 1) xr[ver] = (xr[ver] ^ w);
                vari[ver] = (vari[ver] + vari[v]) % 2;
                xr[ver] = (xr[ver] ^ xr[v]);
                if (!used[ver]) {
                    q.push_back(ver);
                    used[ver] = true;
                }
            }
            ++u;
        }
        cout << xr[b] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    //freopen("ALO.in", "r", stdin);
    //freopen("ALO.out", "w", stdout);

    ll test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}