#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define debug(x) cerr << "[" << #x << "]: " << x << endl
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

vector<vector<pair<ll, pll>>> gr, gr1, gr2;
vector<bool> used;
vector<int> ord;
vector<int> dp, col;

void dfs1(int v){
    used[v] = true;
    for (auto i : gr[v]){
        if (!used[i.ff]) dfs1(i.ff);
    }
    ord.pb(v);
}

vector<int> cl;
int c = 0;

void dfs2(int v){
    cl[v] = c;
    for (auto i : gr1[v]){
        if (cl[i.ff] != -1) continue;
        dfs2(i.ff);
    }
}

ll res = 0;
bool cn = true;
vector<pll> comp;

void dfs3(int v){
    used[v] = true;
    for (auto i : gr2[v]){
        if (!used[i.ff]) dfs3(i.ff);
        dp[v] += dp[i.ff];
        dp[v] = max(dp[v], 1);
        if (col[i.ff]) res ^= i.ss.ff;
        col[v] += col[i.ff] * i.ss.ss % 2;
    }
}

void check(int v, ll cur){
    used[v] = true;
    if (comp[cl[v]].ff > 0 && dp[cl[v]] && cur != 0) cn = false;
    for (auto i : gr[v]){
        if (!used[i.ff]) check(i.ff, cur ^ i.ss.ff);
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    cn = true;
    gr.assign(n, vector<pair<ll, pll>>());
    gr1.assign(n, vector<pair<ll, pll>>());
    map<pii, pll> edg;
    for (int i = 0; i < m; i++){
        ll u, v, w;
        cin >> u >> v >> w; u--, v--;
        edg[{u, v}].ff ^= w;
        edg[{u, v}].ss++;
    }
    for (auto i : edg){
        gr[i.ff.ff].pb({i.ff.ss, i.ss});
        gr1[i.ff.ss].pb({i.ff.ff, i.ss});
    }
    used.assign(n, false);
    cl.assign(n, -1);
    for (int i = 0; i < n; i++) if (!used[i]) dfs1(i);
    reverse(all(ord));
    for (int i : ord){
        if (cl[i] == -1) dfs2(i), c++;
    }
    comp.assign(c, {0, 0});
    for (auto i : edg){
        if (cl[i.ff.ff] == cl[i.ff.ss]){
            comp[cl[i.ff.ff]].ff++;
            comp[cl[i.ff.ff]].ss ^= i.ss.ff;
        }
    }
    int a, b;
    cin >> a >> b; a--, b--;
    gr2.assign(c, vector<pair<ll, pll>>());
    for (auto i : edg){
        if (cl[i.ff.ff] == cl[i.ff.ss]) continue;
        int u = cl[i.ff.ff], v = cl[i.ff.ss];
        gr2[u].pb({v, i.ss});
    }
    dp.assign(c, 0);
    col.assign(c, 0);
    dp[cl[b]] = 1;
    col[cl[b]] = 1;
    used.assign(c, false);
    for (int i = 0; i < c; i++) {
        if (!used[i]) dfs3(i);
    }
    if (dp[cl[a]] == 0) {
        cout << -1 << endl;
        return;
    }
    used.assign(n, false);
    check(a, 0);
    if (!cn){
        cout << -1 << endl;
        return;
    }
    cout << res << endl;
    res = 0;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    cin >> n;
    while(n--) solve();
}
