#include <iostream>
#include <vector>
#include <stack>
using namespace std;
const int MAXN=2e5+10;
vector <pair <int,int> > v[MAXN], op[MAXN];
stack <int> st;
int dp[MAXN];
bool used[MAXN];
void dfs(int x) {
    used[x]=true;
    for (auto i:v[x]) {
        if (used[i.first]) continue;
        dfs(i.first);
    }
    st.push(x);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t, n, m, a, b, c;
    cin >> t;
    for (int test=0;test<t;test++) {
        cin >> n >> m;
        for (int i=1;i<=n;i++) {
            if (!v[i].empty()) v[i].clear();
            if (!op[i].empty()) op[i].clear();
            dp[i]=0;
            used[i]=false;
        }
        for (int i=0;i<m;i++) {
            cin >> a >> b >> c;
            v[a].push_back({b,c});
            op[b].push_back({a,c});
        }
        cin >> a >> b;
        for (int i=1;i<=n;i++) {
            if (!used[i]) dfs(i);
        }
        bool fl=false, imp=false;
        while (!st.empty()) {
            int x=st.top();
            st.pop();
            if (!fl) {
                if (x!=a) continue;
                if (x==b && a!=b) imp=true;
                fl=true;
            }
            dp[x]=0;
            for (auto i:op[x]) {
                dp[x]=(dp[x]^(i.second^dp[i.first]));
            }
        }
        if (imp) cout << 0 << endl;
        else cout << (dp[a]^dp[b]) << endl;
    }
    return 0;
}
/*
3
1 1
1 1 0
1 1
3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
2 3
4 3
1 2 3
2 3 1
3 4 1
1 4
*/