#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O2")

#define int long long
#define double long double
using ll = long long;
#define forn(i,n) for(int i=0;i<n;++i)

#define pi pair<int,int>
#define f first
#define s second

#define pb push_back
#define all(x) x.begin(),x.end()

#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

const int inf=1e18;
const int mod=1e9+7;
const int N=2e5;

vector<vector<pi>> adj(N);
int mem[1000][1024];
int n;

void p1() {
	int a,b; cin>>a>>b; --a, --b;
	if (a==b) {
		int x=0;
		forn(i,n) x^=adj[i][0].s;
		if (x) {
			cout<<"-1\n";
		} else {
			cout<<"0\n";
		}
		return;
	}

	int f=0, s=0;
	int x=a, y=b;
	while (x!=y) {
		f^=adj[x][0].s;
		x=adj[x][0].f;
	}
	x=a, y=b;
	while (x!=y) {
		s^=adj[y][0].s;
		y=adj[y][0].f;
	}
	if (f==0 && f==0) {
		cout<<0<<'\n';
	} else {
		cout<<-1<<'\n';
	}
}

void dfs(int u, int x) {
	if (mem[u][x]) return;
	for(auto&v:adj[u]);
}

void p2() {
	int a,b; cin>>a>>b; --a, --b;
	dfs(a,0);
	int ans=0;
	forn(i,1024) if (mem[b][i]) ans^=i;
	cout<<ans<<'\n';
}

void solve() {

	int m; cin>>n>>m;
	forn(i,n) adj[i].clear();
	if (n<=1000) forn(i,n) forn(j,1024) mem[i][j]=0;
	int paiu=1;
	int mx=0;
	forn(i,m) {
		int u,v,w; cin>>u>>v>>w; --u, --v;
		paiu&=(u==i)&&(v==((i+1)%n));
		mx=max(mx,w);
		adj[u].pb({v,w});
	}
	if (paiu) {
		p1();
		return;
	}
	if (mx<1024 && max(n,m)<=1000) {
		p2();
		return;
	}

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	cin>>t;
	while (t--) solve();
	return 0;
}