#include <bits/stdc++.h>
#define int long long
#define pii pair < int, int >
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

const int maxn = 2e5 + 100, mam = 1e7 + 100, L = 20, mod = 1e9 + 7;

int used[maxn];
vector < int > st;
vector < pii > g[maxn], gr[maxn];
int we, a, b, cnt[2][maxn];

void dfs(int v)
{
    if (v == b)
    {
        return;
    }
    for (auto [x, y] : g[v])
    {
        we = (we ^ y);
        dfs(x);
    }
}

void dfs1(int v)
{
    used[v] = 1;
    for (auto [x, y] : g[v])
    {
        gr[x].pb({v, y});
        if (used[x] == 0)
            dfs1(x);
    }
    st.pb(v);
}

void solve()
{
    int n, m;
    cin >> n >> m;
    int k = 0, ww = 0;
    for (int i = 0; i < m; ++i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        ww ^= w;
        g[u].pb({v, w});
        if (u < v)
            k++; 
    }
    cin >> a >> b;
    if (k == m)
    {
        dfs1(a);
        reverse(all(st));
        int ans = 0;
        for (int l = 0; l < 3; ++l)
        {
            for (int i = 1; i <= n; ++i)
            {
                cnt[0][i] = cnt[1][i] = 0;
            }
            cnt[0][a] = 1;
            for (auto i : st)
            {
                for (auto [j, x] : gr[i])
                {
                    if (x & (1 << l))
                    {
                        cnt[1][i] += cnt[0][j];
                        cnt[1][i] %= 2;
                        cnt[0][i] += cnt[1][j];
                        cnt[0][i] %= 2;
                    }
                    else
                    {
                        cnt[1][i] += cnt[1][j];
                        cnt[1][i] %= 2;
                        cnt[0][i] += cnt[0][j];
                        cnt[0][i] %= 2;
                    }
                }
            }
            // for (int i = 1; i <= n; ++i)
            //     cout << cnt[0][i] << ' ' << cnt[1][i] << endl;
            // cout << endl;
            if (cnt[1][b] % 2)
                ans |= (1 << l);
        }
        cout << ans;
    }
    else
    {
        we = 0;
        dfs(a);
        int tmp = we ^ ww;
        if (we == 0 && tmp == 0)
            cout << 0 << endl;
        else
            cout << -1 << endl;
    }
    for (int i = 1; i <= n; ++i)
    {
        cnt[0][i] = cnt[1][i] = 0;
        used[i] = 0;
        g[i].clear();
        gr[i].clear();
    }
    st.clear();
}

signed main()
{
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
        cout << endl;
    }
    return 0;
}