#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>


using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)
void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = ((1LL<<31)-1)*2;
const ll MOD = 1e9 + 7;

ll n, m, a, b;
vector<vector<pair<ll, ll>>> g;

void solve1(){
    ll ans = 0;
    ll v = a;
    while(v != b){
        ans ^= g[v][0].second;
        v = g[v][0].first;
    }
    ll ful = 0;
    for (ll i  =0;i<n;i++) ful^=g[i][0].second;
    if (ful == 0 && ans == 0)
        cout << 0 << "\n";
    else
        cout << -1 << "\n";
}

void solve2(){
    vector<ll> x(n, 0), k(n, 0);
    k[a] = 1;
    for (ll i = 0;i<n;i++){
        for (auto& p : g[i]){
            k[p.first]=(k[p.first]+k[i])%2;
            x[p.first]^=x[i];
            if (k[i]) x[p.first] ^= p.second;
        }
    }
    cout << x[b] << "\n";
}

void solve3(){
    ll ans = 0;
    for (ll f = 0;f<13;f++) {
        vector<vector<ll>> k(n, vector<ll>(2, 0));
        k[a][0] = 1;
        ll ansb = 0;
        bool relax_b = 1;
        for (ll i = 0; i < max(n, m) * 4; i++) {
            relax_b = 0;
            for (ll v = 0; v < n; v++) {
                vector<ll> sft = k[v];
                k[v] = {0, 0};
                for (auto &p : g[v]) {
                    ll e = (p.second >> f) & 1;
                    for (ll x = 0; x <= 1; x++) {
                        if (sft[x] > 0) {
                            k[p.first][e ^ x] = (k[p.first][e ^ x] + sft[x]) % 2;
                            if (k[p.first][e ^ x] == 0) k[p.first][e ^ x] = 2;
                            if (p.first == b && (e ^ x) == 1) {
                                relax_b = 1;
                            }
                        }
                    }
                }
                if (v == b){
                    ansb = (ansb + sft[1])%2;
                }
            }
        }
        if (relax_b) {
            cout << "-1\n";
            return;
        }
        ans |= (1LL << f) * ansb;
    }
    cout << ans << "\n";
}

int main() {
    fastio();
    ll t;
    cin >> t;
    while(t--){
        cin >> n >> m;
        g.assign(n, {});
        bool ok1 = (n == m), ok2 = 1;
        for (ll i = 0;i<m;i++){
            ll u, v, w;
            cin >> u >> v >> w;
            u--;v--;
            g[u].push_back({v, w});
            ok1 &= (u == i && v == (i+1)%n);
            ok2&=(u<v);
        }
        cin >> a >> b;
        a--;b--;
        if (n <= 1000 && m <= 1000){
            solve3();
            continue;
        }
        if (ok1) {
            solve1();
            continue;
        }
        if (ok2) {
            solve2();
            continue;
        }
    }
    return 0;
}