#include <bits/stdc++.h>
#include <unordered_map>
#include <unordered_set>

#define umap unordered_map
#define uset unordered_set

#define spc << ' ' <<
#define space << ' '
#define newl << '\n'
#define endl << endl

#define pb push_back
#define elif else if
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define repeat(a) for (int i31 = 0; i31 < a; ++i31)

using namespace std;
using str = string;
using ll = long long;
using vi = vector <int>;
using vl = vector <ll>;
using vvi = vector <vi>;
using vvl = vector <vl>;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

template <typename T>
istream& operator>>(istream& in, pair <T, T>& p) {
    in >> p.first >> p.second;
    return in;
}
template <typename T>
istream& operator>>(istream& in, vector <T>& a) {
    for (int i = 0; i < (int)a.size(); ++i) {
        in >> a[i];
    }
    return in;
}
template <typename T>
ostream& operator<<(ostream& out, pair <T, T>& p) {
    out << p.first << p.second;
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, vector <T>& a) {
    for (auto c : a) {
        out << c space;
    }
    return out;
}

const int INF = INT_MAX;
const ll LINF = LLONG_MAX;
const ll hash_power = 29;
const ll mod = 1e9 + 7;

void dfs(int x, vi & used, vector <vector <pii>> & gr, vi & topsort) {
    used[x] = 1;
    for (auto p : gr[x]) {
        int to = p.first;
        if (used[to]) continue;
        dfs(to, used, gr, topsort);
    }
    topsort.pb(x);
}

int dfs_used(int x, vi & used, vector <vector <pii>> & gr) {
    used[x] = 1;
    for (auto p : gr[x]) {
        if (used[p.first]) continue;
        dfs_used(p.first, used, gr);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    int ok = (n == m);
    vector <vector <pii>> gr(n), rev_gr(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w; u--, v--;
        if (i < n - 1 && (u != i || v != i + 1) || i == n - 1 && (u != n - 1 || v != 0)) ok = 0;
        gr[u].pb({v, w});
        rev_gr[v].pb({u, w});
    }

    int s, t;
    cin >> s >> t; s--, t--;

    if (ok) {
        int t1 = 0, t2 = 0;
        for (int i = 0; i < n; ++i) {
            for (auto p : gr[i]) {
                t1 ^= p.second;
            }
        }
        while (s != t) {
            for (auto p : gr[s]) {
                t1 ^= p.second;
                t2 ^= p.second;
                s = p.first;
            }
        }

        if (t1 == 0 && t2 == 0) {
            cout << 0;
        }
        else {
            cout << -1;
        }
    }
    else {
        vi topsort, used(n, 0);
        for (int i = 0; i < n; ++i) {
            if (used[i]) continue;
            dfs(i, used, gr, topsort);
        }

        vl cntl(n, 0), cntr(n, 0);
        cntr[t] = 1;
        for (auto x : topsort) {
            for (auto p : rev_gr[x]) {
                cntr[p.first] += cntr[x];
            }
        }

        reverse(all(topsort));

        cntl[s] = 1;
        for (auto x : topsort) {
            for (auto p : gr[x]) {
                cntl[p.first] += cntl[x];
            }
        }

        int ans = 0;
        for (int i = 0; i < n; ++i) {
            for (auto p : gr[i]) {
                if (cntl[i] * cntr[p.first] % 2) {
                    ans ^= p.second;
                }
            }
        }
        cout << ans;
    }
}

void tests() {
    int t;
    cin >> t;
    for (int i = 1; i <= t; ++i) {
        //cout << "Test number:" spc i newl;
        solve();
        cout newl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    /**/
    freopen("inputC.txt", "r", stdin);
    tests();

    //solve();
}
