#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

#define fi first
#define se second
#define pb push_back
#define ld long double
#define pii pair <int, int>
#define endl '\n'
#define int int64_t
#define pw(x) (int64_t(1) << x)

using namespace std;
mt19937 gen(time(0));
const int N = 2e5 + 50;
set <pii> g[N];
int dp[N][2];

bool can (int a, int b) {
    queue <int> q;
    q.push(a);
    vector <int> r(N, -1);
    r[a] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for(auto to : g[v]) {
            if(r[to.fi] == -1) {
                r[to.fi] = r[v] ^ to.se;
                q.push(to.fi);
            }
        }
    }
    return (r[b] != -1);
}

void solve () {
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; ++i) {
        g[i].clear();
        dp[i][0] = dp[i][1] = 0;
    }
    bool fl = 1;
    int xr = 0;
    for(int i = 0; i < m; ++i) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;
        y--;
        xr ^= c;
        int nxt = (x + 1) % n;
        if(y != nxt) {
            fl = 0;
        }
        g[x].insert({y, c});
    }
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    if(n == m && fl) {
        if(a == b && xr > 0) {
            cout << -1 << endl;
            return;
        }
        queue <int> q;
        q.push(a);
        vector <int> r(n, -1);
        r[a] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for(auto to : g[v]) {
                if(r[to.fi] == -1) {
                    r[to.fi] = r[v] ^ to.se;
                    q.push(to.fi);
                }
            }
        }
        if(r[b] || (xr ^ r[b])) {
            cout << -1 << endl;
        } else {
            cout << 0 << endl;
        }
        return;
    }
    if(!can(a, b)) {
        cout << -1 << endl;
        return;
    }
    if(a == b) {
      cout << 0 <<endl;
      return;
    }
    dp[a][0] = 1;
    for(int i = a; i < n; ++i) {
        for(auto to : g[i]) {
            dp[to.fi][to.se] += dp[i][0];
            dp[to.fi][1 ^ to.se] += dp[i][1];
        }
    }
    cout << dp[b][1] % 2 << endl;
}
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int q;
    cin >> q;
    while (q --) {
        solve();
    }
    return 0;
}