#include <iostream>
#include <vector>
using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n, m;
		cin >> n >> m;
		vector<vector<pair<int, ll>>> g(n);
		vector<ll> weight(n);
		ll all_xor = 0;
		for (int _ = 0; _ < m; ++_) {
			int u, v; ll w;
			cin >> u >> v >> w;
			u--; v--;
			g[u].push_back({ v, w });
			g[v].push_back({ u, w });
			weight[u] = w;
			all_xor = (all_xor ^ w);
		}
		int a, b;
		cin >> a >> b;
		a--; b--;
		ll xor1 = 0;
		int u = a;
		while (u != b) {
			xor1 = (xor1 ^ weight[u]);
			u = (u + 1) % n;
		}
		if (xor1 == 0 && all_xor == 0)
			cout << 0 << "\n";
		else
			cout << -1 << "\n";
	}

	return 0;
}