#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ull unsigned long long
#define ll long long
#define ld long double
#define x first
#define y second

const ll INF = 1e17 + 2, MOD = 1e9 + 7, MOD1 = 228228227, N = 2e5 + 2;

random_device rd;
mt19937 rnd(rd());

vector<vector<pair<int, int>>> g(N);
vector<int> used(N);
vector<map<int, int>> mp;

int ans = 0, a, b;

void dfs(int v, int xr = 0) {
    mp[v][xr]++;
    for (auto &e : g[v]) {
        dfs(e.first, (xr ^ e.second));
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    int k = 0;
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }
    mp.clear();
    used.assign(n, false);
    bool fl = (n == m);
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        if (!((u == v - 1) || (u == n && v == 1))) {
            fl = false;
        }
        k = max(k, c);
        u--, v--;
        g[u].emplace_back(v, c);
    }
    cin >> a >> b;
    a--, b--;
    if (fl) {
        if (a == b) {
            int xr = g[a][0].second;
            for (int i = g[a][0].first; i != a; i = g[i][0].first) {
                xr ^= g[i][0].second;
            }
            if (xr == 0) {
                cout << "0\n";
            } else {
                cout << "-1\n";
            }
            return;
        }
        ans = 0;
        int xr = 0;
        for (int i = a; i != b; i = g[i][0].first) {
            xr ^= g[i][0].second;
        }
        int xr1 = g[b][0].second;
        for (int i = g[b][0].first; i != b; i = g[i][0].first) {
            xr1 ^= g[i][0].second;
        }
        if ((xr == 0 && xr1 == 0) || k == 0) {
            cout << "0\n";
            return;
        }
        cout << "-1\n";
        return;
    }
    mp.resize(n);
    dfs(a);
    ans = 0;
    for (auto e : mp[b]) {
        e.second %= 2;
        if (e.second) {
            ans ^= e.first;
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}