#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <string.h>
#include <queue>
#include <stdio.h>
#include <algorithm>
#include <math.h>
#include <deque>
#define int ll
using ll = long long;
#define all(x) x.begin(), x.end()
using namespace std;

struct edge {
	int to, weight;
	edge() {};
	edge(int to, int weight) :
		to(to), weight(weight) {};
};

int used[200010];
map<pair<int, int>, int> edges;
int color = 1;
vector<vector<edge>> g;
vector<vector<edge>> g_r;
vector<vector<edge>> g_new;
//map<int, int> d1;
void dfs(int v, vector<vector<edge>>& gg, int fin) {
	/*if (v == fin) {
		if (color == 2)
			used[fin] = 3;
		else {
			used[fin] = color;
		}
		return;
	}*/
	if (used[v] == color || used[v] == 3)
		return;
	if (used[v] == 0 || color == 1)
		used[v] = color;
	else {
		used[v] = 3;
	}
	for (auto i : gg[v])
		dfs(i.to, gg, fin);
}

bool cycle = 0;

vector<int> parent;
int f = -1;
int s = -1;
vector<set<int>> compress;
map<int, int> dict;
map<int, int> dict1;
void dfs1(int v, int p, int ind) {
	if (cycle || used[v] == 2) {

		return;
	}
	if (used[v] == 1) {
		cycle = 1;
		f = v;
		s = p;
		//dict1[p] = f;
		int ok = 0;
		set<int> st;
		int xr = 0;
		while (s != f) {
			if (edges[{parent[s], s}] != 0) {
				ok = 1;
			}
			xr = xr ^ edges[{parent[s], s}];
			st.insert(s);

			s = parent[s];

			dict[s] = f;
		}
		xr = xr ^ edges[{p, v}];
		dict[f] = f;
		//d1[f] = xr;
		st.insert(f);
		if (xr != 0)
			return;
		else {
			cycle = 0;
			compress[f] = st;
			s = -1;
			f = -1;
			return;
		}
	}
	int idx = 0;
	used[v] = 1;
	for (auto i : g_new[v]) {
		parent[i.to] = v;
		dfs1(i.to, v, idx);
		idx += 1;
	}
	used[v] = 2;
}

vector<vector<edge>> g2;

pair<int, int> dfs_dp(int v, int fin) {
	if (v == fin) {
		return { 0, 0 };
	}
	int ans = 0;
	int cnt = 0;
	used[v] = 1;
	for (auto i : g_new[v]) {
		if (used[i.to] == 1)
			continue;
		cnt += 1;
		pair<int, int> p = dfs_dp(i.to, fin);
		ans = ans ^ p.first;
		if (p.second % 2 != 0 || p.second == 0)
			ans = ans ^ i.weight;

	}
	used[v] = 2;
	return { ans, cnt };
}
bool ch = 0;
void check(int v, int fin, int ok1, int ok2) {
	if (ch)
		return;
	if (used[v])
		return;
	if (v == fin) {
		if (ok1 && ok2) {
			ch = 1;
		}
		return;
	}
	used[v] = 1;
	for (auto i : g_new[v]) {
		int b1 = 0;
		int b2 = 0;
		if (dict.find(v) != dict.end()) {
			b1 = 1;
			//b2 = d1[dict[v]];
		}
		b2 = i.weight;
		
		check(i.to, fin, ok1 | b1, ok2 ^ b2);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	g = {};
	g_new = {};
	g2 = {};
	g_r = {};
	parent = {};
	fill(used, used + n, 0);
	g.resize(n);
	g_r.resize(n);
	g2.resize(n);
	parent.resize(n);
	compress = {};
	compress.resize(n);
	g_new.resize(n);
	edges = {};

	dict = {};
	f = -1;
	s = -1;
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u;
		--v;
		g[u].push_back({ v, w });
		g_r[v].push_back({ u, v });
		edges[{u, v}] = w;
	}
	int a, b;
	cin >> a >> b;
	--a;
	--b;
	color = 1;
	dfs(a, g, b);
	color = 2;
	dfs(b, g_r, a);
	//g_new.resize(n);
	for (int i = 0; i < n; ++i) {
		for (auto j : g[i]) {
			if (used[i] == 3 && used[j.to] == 3) {
				g_new[i].push_back(j);
			}
		}
	}
	fill(used, used + n, 0);
	cycle = 0;
	parent.resize(n);
	compress.resize(n);
	dfs1(a, -1, 0);
	if (cycle) {
		cout << -1 << endl;
		return;
	}
	//g2.resize(n);
	//map<pair<int, int>, int> can;
	//for (int i = 0; i < n; ++i) {
	//	for (auto j : g_new[i]) {
	//		int vert = i;
	//		/*if (dict.find(i) != dict.end()) {
	//			vert = dict[i];
	//		}*/
	//		int vert1 = j.to;
	//		/*if (dict.find(j.to) != dict.end()) {
	//			vert1 = dict[j.to];
	//		}*/

	//		if (dict1.find(vert) != dict1.find(vert1) && dict1.find(vert1)
	//			!= dict1.end()) {
	//			if (vert != vert1)
	//		}

	//		if (dict1.find(vert) != dict1.end()) {
	//			if (dict1.find(vert1) != dict1.end()) {
	//				g2[vert].push_back({ vert1, j.weight });
	//			}
	//			else if (dict.find(vert1) != dict.end()){
	//				if (dict1[vert] == dict[vert1] &&
	//					can.find({ vert, vert1 }) == can.end()) {
	//					g2[vert].push_back({ dict[vert1], j.to });
	//				}
	//			}
	//			else {
	//				g2[vert].push_back({ vert1, j.to });
	//			}
	//		}
	//		
	//		/*if (dict.find(i) != dict.end() && dict.find(j.to) != dict.end()) {
	//			continue;
	//		}
	//		if (dict.find(i) != dict.end()) {
	//			g2[dict[i]].push_back(j);
	//		}
	//		else if (dict.find(j.to) != dict.end()) {
	//			g2[i].push_back({ dict[j.to], j.weight });
	//		}
	//		else {
	//			g2[i].push_back(j);
	//		}*/
	//	}
	//}

	ch = 0;
	fill(used, used + n, 0);
	check(a, b, 0, 0);
	if (ch) {
		cout << -1 << endl;
		return;
	}
	fill(used, used + n, 0);
	/*int dist[200];
	int INF = 1e9;
	fill(dist, dist + n, INF);
	queue<int> q;
	q.push(a);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		if (used[v])
			continue;
		for (auto i : g_new[v]) {

		}
	}*/
	cout << dfs_dp(a, b).first << endl;
}

signed main() {
#ifdef LOCAL
	freopen("C:\\Users\\olymp\\source\\repos\\Project1\\input.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}