#include "bits/stdc++.h"

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
#define endl '\n'

using namespace std;

mt19937 gen(time(0));
const int base = 177013;
const int mod = 1e9 + 7;

vector<vector<pair<int, int>>> gr_rev;
vector<vector<pair<int, int>>> gr_right;
vector<int> weight;

int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while(t--){
        int n, m;
        cin >> n >> m;
        weight.assign(m, 0);
        gr_rev.assign(n, {});
        gr_right.assign(n, {});
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin  >> a >> b;
            cin >> weight[i];
            --a, --b;
            gr_rev[b].emplace_back(a, i);
            gr_right[a].emplace_back(b, i);
        }
        int a, b;
        cin >> a >> b;
        --a, --b;
        vector<int> dp(m, 0);
        vector<int> dp2(m, 0);
        queue<int> vertexs;
        vector<bool> was(n, false);
        vector<bool> was2(n, false);
        vertexs.emplace(b);
        while (!vertexs.empty()){
            int g = vertexs.front();
            vertexs.pop();
            if(was[g])
                continue;
            was[g] = true;
            if(g == b){
                for(auto [u, i] : gr_rev[g]){
                    vertexs.emplace(u);
                    dp[i] = 1;
                }
            }else{
                int sx = 0;
                for(auto [u, i] : gr_right[g]){
                    sx += dp[i];
                }
                for(auto [u, i] : gr_rev[g]){
                    vertexs.emplace(u);
                    dp[i] = sx;
                }
            }
        }
        vertexs.emplace(a);
        while (!vertexs.empty()){
            int g = vertexs.front();
            vertexs.pop();
            if(was2[g])
                continue;
            was2[g] = true;
            if(g == a){
                for(auto [u, i] : gr_right[g]){
                    vertexs.emplace(u);
                    dp2[i] = 1;
                }
            }else{
                int sx = 0;
                for(auto [u, i] : gr_rev[g]){
                    sx += dp2[i];
                }
                for(auto [u, i] : gr_right[g]){
                    vertexs.emplace(u);
                    dp2[i] = sx;
                }
            }
        }
        int ans = 0;
        for (int i = 0; i < m; ++i) {
            if(dp[i] % 2 != 0 and dp2[i] % 2 != 0)
                ans ^= weight[i];
        }
        cout << ans << endl;
    }
}
