#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <iostream>
#include <fstream>
#include <climits>
using namespace std;
#define int long long
vector <int> t;
vector <int> used;
vector <vector <pair <int,int>>> g;
vector <int> pred;
vector <int> de;
const int del = 1e9 + 7;
int ot;
int a, b;
int n, m;
int flag = 0;
void dfs(int v,int kol,int sum,int last) {
    if (flag == 1)
        return;
    for (int i = 0; i < g[v].size(); i++) {
        if (g[v][i].first == last) {
            cout << -1 << endl;
            flag = 1;
            return;
        }
    }
    if (kol > n) 
    {
        cout << -1<<endl;
        flag = 1;
        return;
    }
    if (v == b) {
        ot = ot^sum;
        return;
    }
    for (int i = 0; i < g[v].size(); i++) {
        if( g[v][i].first!=last) {
            dfs(g[v][i].first,kol+1,sum^g[v][i].second,v);
        }
        else {
            cout << -1 << endl;
            flag = 1;
            exit(0);
        }
    }
}

int32_t main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        g.clear();
        g.resize(n);
        for (int i = 0; i < m; i++) {
            int x, y, w;
            cin >> x >> y >> w;
            x--;
            y--;
            g[x].push_back({ y,w });
        }
         ot = 0;
         cin >> a >> b;
         a--;
         b--;
         flag = 0;
         dfs(a, 0, 0, -1);
         if (flag == 1)
             continue;
         else
             cout << ot<<endl;
    }
}
