#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

void solve() {
  int n, m;
  cin >> n >> m;
  int allxr = 0;
  bool test1 = n == m;
  vector<int> WE(n);
  vector<vector<pair<int, int>>> g(n), gr(n);
  for (int i = 0; i < m; ++i) {
    int x, y, z;
    cin >> x >> y >> z;
    --x, --y;
    allxr ^= z;
    WE[i] = z;
    test1 &= x == i && y == (i + 1) % n;
    g[x].emplace_back(y, z);
    gr[y].emplace_back(x, z);
  }
  int a, b;
  cin >> a >> b;
  --a, --b;
  if (test1) {
    int xr = 0;
    if (a < b) {
      for (int i = a; i < b; ++i) xr ^= WE[i];
    } else {
      for (int i = a; i < n; ++i) xr ^= WE[i];
      for (int i = 0; i < b; ++i) xr ^= WE[i];
    }
    if (xr == 0 && xr == allxr) cout << xr << '\n';
    else cout << -1 << '\n';
    return;
  }
  vector<int> cnt(n);
  cnt[a] = 1;
  function<void(int)> Dfs = [&](int v) {
    for (auto [u, w] : g[v]) {
      cnt[u] ^= cnt[v];
      Dfs(u);
    }
  };
  Dfs(a);
  vector<int> rcnt(n);
  rcnt[b] = 1;
  function<void(int)> rDfs = [&](int v) {
    for (auto [u, w] : gr[v]) {
      rcnt[u] ^= rcnt[v];
      rDfs(u);
    }
  };
  rDfs(a);
  int ans = 0;
  for (int x = 0; x < n; ++x) {
    for (auto [y, z] : g[x]) {
      if (cnt[x] * rcnt[y] == 1) {
        ans ^= z;
      }
    }
  }
  cout << ans << '\n';
}
int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}