#include <bits/stdc++.h>
#define __GLIBCXX_DEBUG

using namespace std;
typedef long long ll;
typedef long double ld;

void solve() {
    int n, m;
    cin >> n >> m;

    int u, v, w;
    vector <vector <pair <int, ll>>> graph(n);
    for (int i =0 ; i < m; i++) {
        cin >> u >> v >> w;
        u--, v--;

        graph[u].emplace_back(v, w);
        graph[v].emplace_back(u, w);
    }

    assert(n == m);

    int a, b;
    cin >> a >> b;
    a--, b--;

    if (n == 1) {
        cout << graph[0][0].second << '\n';
        return;
    }
    ll answer = 0;

    for (int i = 0; i < n; i++) {
        for (auto [j, w]: graph[i]) {
            if (i < j) {
                answer ^= w;
            }
        }
    }

    cout << answer << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    int t;
    cin >> t;

    while (t--)
    solve();
}
