#include <iostream>
#include <iomanip>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define sc second
#define coe cout<<"YES\n"
#define str string
#define int ll

vector<vector<pii>> g, gr;
vector<int> used, cnt, cnt2;
int s,f;

void dfs(int v) {
    //cout<<v<<":\n";
    used[v] = 1;
    for (auto &u : g[v]) {
        //cout<<u.ff<<' ';
        if (!used[u.ff]) {
            dfs(u.ff);
        }
        //cout<<u.ff<<' '<<cnt[u.ff]<<'\n';
        cnt[v] += cnt[u.ff];
        cnt[v] %= 2;
    }
}

void dfs2(int v) {
    used[v] = 1;
    for (auto &u : gr[v]) {
        if (!used[u.ff]) {
            dfs2(u.ff);
        }
        cnt2[v] += cnt2[u.ff];
        cnt2[v] %= 2;
    }
}



void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int>> e;
    g.assign(n, {});
    gr.assign(n, {});
    used.assign(n, 0);
    cnt.assign(n, 0);
    cnt2.assign(n, 0);
    map<pii, int> cost;
    int bxor = 0;
    bool flag = true;
    f(i,0,m){
        int u,v,w;cin>>u>>v>>w;
        u--;v--;
        bxor ^= w;
        if (u!=i||v!=(i+1)%n)flag=false;
        e.pb({u,v,w});
        g[u].pb({v, w});
        gr[v].pb({u, w});
    }

    cin >> s >> f;
    s--; f--;
    if(!flag) {
        cnt[f] = 1;
        cnt2[s] = 1;
        dfs(s);
        used.assign(n, 0);
        dfs2(f);
        int ans = 0;
        for (auto &u : e) {
            if (cnt2[u[0]] * cnt[u[1]] == 1) {
                ans ^= u[2];
            }
        }
        cout << ans << '\n';
        return;
    }
    cout<<"-1\n";
    return ;

    int nw = s, COST = 0;
    while (nw != f) {
        COST ^= cost[{nw, (nw+1)%n}];
        nw += 1;
        nw %= n;
    }

    if (COST > 0 || (bxor ^ COST) > 0) {
        cout << "-1\n";
    } else {
        cout << "0\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr); cin.tie(nullptr);
    cout << fixed << setprecision(10);

    int tt; cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}