#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include<bits/stdc++.h>
#define int long long
#define sz(a) (int)a.size()

using namespace std;

vector<vector<pair<int, int>>> g, gr;
vector<int> ts, used, dp, dpr;

void dfs1(int v) {
    used[v] = 1;
    for (auto i : g[v]) {
        if (!used[i.first])
            dfs1(i.first);
    }
    ts.push_back(v);
}

void dfs2(int v) {
    used[v] = 1;
    for (auto i : gr[v]) {
        if (!used[i.first])
            dfs2(i.first);
    }
    ts.push_back(v);
}

void sas(int v) {
    used[v] = 1;
    for (auto i : g[v]) {
        if (!used[i.first])
            sas(i.first);
    }
}

int sus(int v, int x, int cur) {
    if (v == x) return cur;
    return sus(g[v][0].first, x, cur ^ g[v][0].second);
}

void solve() {
    int n, m;
    cin >> n >> m;
    gr.clear();
    ts.clear();
    g.clear();
    dp.clear();
    dpr.clear();
    used.clear();
    g.resize(n);
    gr.resize(n);
    used.resize(n);
    dp.resize(n);
    dpr.resize(n);
    bool test = 1;
    bool kek = 1;
    if (n != m) kek = 0;
    int hor = 0;
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        --u;
        --v;
        hor ^= c;
        if (kek) {
            if (i == n - 1) {
                if (u != n - 1 || v != 0) {
                    kek = 0;
                }
            }
            else {
                if (u != i || v != i + 1) {
                    kek = 0;
                }
            }
        }
        if (u > v) {
            test = 0;
        }
        g[u].push_back({v, c});
        gr[v].push_back({u, c});
    }
    int st, fin;
    cin >> st >> fin;
    --st;
    --fin;
    sas(st);
    if (!used[fin]) {
        cout << 0 << '\n';
        return;
    }
    fill(used.begin(), used.end(), 0);
    if (test) {
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs1(i);
            }
        }
        reverse(ts.begin(), ts.end());
        dp[st] = 1;
        for (int v : ts) {
            for (auto i : g[v]) {
                dp[i.first] += dp[v];
                dp[i.first] %= 2;
            }
        }
        fill(used.begin(), used.end(), 0);
        ts.clear();
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs2(i);
            }
        }
        reverse(ts.begin(), ts.end());
        dpr[fin] = 1;
        for (int v : ts) {
            for (auto i : gr[v]) {
                dpr[i.first] += dpr[v];
                dpr[i.first] %= 2;
            }
        }
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            for (auto j : g[i]) {
                if (dp[i] % 2 == 1 && dpr[j.first] % 2 == 1) {
                    ans ^= j.second;
                }
            }
        }
        cout << ans << '\n';
        return;
    }
    if (true) {
        if (hor != 0) {
            cout << -1 << '\n';
            return;
        }
        int xo = sus(st, fin, 0);
        if (xo != 0) {
            cout << -1 << '\n';
            return;
        }
        cout << 0 << '\n';
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
