#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace __gnu_pbds;
using namespace std;
using idexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

vector<vector<pair<int, int>>> g;
vector<int> vis;
int a, b;

int dfs(int v) {
    if (v == b) return 0;
    vis[v] = 1;
    for (auto [i, w]: g[v]) {
        if (vis[i]) continue;
        return w ^ dfs(i);
    }
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        g.assign(n + 1, {});
        int x = 0;
        for (int i = 0; i < n; i++) {
            int c;
            cin >> a >> b >> c;
            g[a].push_back({b, c});
            g[b].push_back({a, c});
        }
        cin >> a >> b;
        vis.assign(n + 1, 0);
        vis[a] = 1;
        int p = g[a][0].second ^ dfs(g[a][0].first);
        int r = g[a][1].second ^ dfs(g[a][1].first);
        if (p != 0 || r != 0) {
            cout << -1;
        } else cout << 0;
        cout << '\n';
    }
}