#include <bits/stdc++.h>
#define int long long
#define double long double
#define x first
#define y second
#define inf (INT64_MAX / 2)

using namespace std;

//bool isInf = false;

void dfs1(int s, vector<int>& used, vector<vector<int>>& g) {
    used[s] = 1;
    for (int i : g[s]) {
        if (used[i]) {
            //isInf = true;
        } else {
            dfs1(i, used, g);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n), h(n);
    vector<pair<int, int>> e(m), goodE;
    vector<int> a(m), used(n, 0);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y >> a[i]; x--; y--;
        h[y].push_back(x);
        e[i] = {x, y};
    }
    int s, f;
    cin >> s >> f; s--; f--;
    dfs1(f, used, h);
//    if (isInf) {
//        cout << "-1\n";
//        return;
//    }
    if (!used[s]) {
        cout << "0\n";
        return;
    }
    for (int i = 0; i < m; i++) {
        if (used[e[i].x] && used[e[i].y]) {
            goodE.emplace_back(e[i].x, a[i]);
            g[e[i].x].push_back(e[i].y);
        }
    }
    vector<int> dp(n, 0);
    dp[s] = 1;
    for (int i = 0; i < n; i++) {
        for (int j : g[i]) {
            dp[j] ^= dp[i];
        }
    }
    int ans = 0;
    for (auto i : goodE) {
        if (dp[i.x] % 2) {
            ans ^= i.y;
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
}