#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;
typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

void solve() {
    int n, m; cin >> n >> m;
    if (n != m) return;
    int sm = 0;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        int u, v, x; cin >> u >> v >> x;
        sm ^= x; --u, --v;
        if (i < n - 1 && (u != i || v != (i + 1))) return;
        if (i == n - 1 && (u != n - 1 || v != 0)) return;
        p[i] = x;
    }
    int a, b; cin >> a >> b; --a, --b;
    if (sm != 0) {
        cout << -1 << '\n';
        return;
    }
    sm = 0;
    for (int i = a; i != b; i = (i + 1) % n) {
        sm ^= p[i];
    }
    cout << (sm == 0 ? 0: -1) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t; cin >> t;
    while (t--) solve();
}