#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2e5;

vector <pair <int, ll>> g[MAXN];
vector <pair <int, ll>> revg[MAXN];
vector <int> deg(MAXN, 0);
vector <int> rdeg(MAXN, 0);
vector <int> cnts(MAXN, 0), cntf(MAXN, 0);
vector <bool> used(MAXN, false);
vector <bool> rused(MAXN, false);

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        g[i].clear();
        revg[i].clear();
        deg[i] = 0;
        rdeg[i] = 0;
        cnts[i] = 0;
        cntf[i] = 0;
        used[i] = false;
        rused[i] = false;
    }
    int v, u;
    ll w;
    bool ok = true;
    for (int i = 0; i < m; i++) {
        cin >> v >> u >> w;
        v--;
        u--;
        if (v > u) {
            ok = false;
        }
        deg[u]++;
        rdeg[v]++;
        g[v].push_back({u, w});
        revg[u].push_back({v, w});
    }
    int s, f;
    cin >> s >> f;
    s--;
    f--;
    if (!ok) {
        int s1 = s;
        ll ans = g[s][0].second;
        s = g[s][0].first;
        while (s != f) {
            ans ^= g[s][0].second;
            s = g[s][0].first;
        }
        if (ans != 0) {
            cout << -1 << "\n";
            return;
        }
        while (s != s1) {
            ans ^= g[s][0].second;
            s = g[s][0].first;
        }
        if (ans != 0) {
            cout << -1 << "\n";
        } else {
            cout << 0 << "\n";
        }
        return;
    }
    cnts[s]++;
    cntf[f]++;
    vector <int> go;
    for (int i = 0; i < n; i++) {
        if (deg[i] == 0) {
            go.push_back(i);
        }
    }

    while (!go.empty()) {
        v = go.back();
        go.pop_back();
        for (auto [vv, c] : g[v]) {
            cnts[vv] ^= cnts[v];
            deg[vv]--;
            if (deg[vv] == 0) {
                go.push_back(vv);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (rdeg[i] == 0) {
            go.push_back(i);
        }
    }
    while (!go.empty()) {
        v = go.back();
        go.pop_back();
        for (auto [vv, c] : revg[v]) {
            cntf[vv] ^= cntf[v];
            rdeg[vv]--;
            if (rdeg[vv] == 0) {
                go.push_back(vv);
            }
        }
    }
    ll anss = 0;
    for (int i = 0; i < n; i++) {
        for (auto [vv, c] : g[i]) {
            if (cnts[i] & cntf[vv]) {
                anss ^= c;
            }
        }
    }
    cout << anss << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}