#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}

struct edge {
    ll to, weight;
};
const int sz = 31;
const vector<vector<ll>> mine(31, vector<ll>(2, 0));

struct xui {
    vector<vector<ll>> f = mine;

    xui operator+=(xui b) {
        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < 31; j++) {
                f[j][i] += b.f[j][i];
            }
        }
        return *this;
    }

    xui operator^(ll x) {
        xui ans;
        ans.f = f;
        int t = 0;
        while (x > 0){
            if (x % 2){
                swap(ans.f[t][0], ans.f[t][1]);
            }
            x /= 2;
            t++;
        }
        return ans;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> gr(n);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        gr[u].push_back({v, w});
    }
    vector<xui> dp(n);
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    for (int i = 0; i < 31; i++){
        dp[a].f[i][0] = 1;
    }
    for (int j = 0 ; j < n; j++){
        for (auto el : gr[j]){
            dp[el.to] += (dp[j] ^ el.weight);
        }
    }
    ll my_ans = 0;
    ll step = 1;
    for (int i = 0; i < 31; i++){
        my_ans += step * dp[b].f[i][1];
        step *= 2;
    }
    cout << my_ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}