#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
using namespace std;
typedef long long ll;
vector<vector<vector<ll>>> g, rg;
vector<ll> c1, c2;
ll ans1(ll v) {
	if (c1[v] != -1) return c1[v];
	c1[v] = 0;
	for (auto to : rg[v]) c1[v] = (c1[v] + ans1(to[0])) % 2;
	return c1[v];
}
ll ans2(ll v) {
	if (c2[v] != -1) return c2[v];
	c2[v] = 0;
	for (auto to : g[v]) c2[v] = (c2[v] + ans2(to[0])) % 2;
	return c2[v];
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll t;
	cin >> t;
	while(t--) {
		ll n, m, a, b;
		cin >> n >> m;
		g.assign(n, {});
		rg.assign(n, {});
		bool B = true;
		ll s = 0;
		for (ll i = 0; i < m; ++i) {
			ll u, v, w;
			cin >> u >> v >> w;
			g[--u].push_back({ --v, w });
			rg[v].push_back({ u, w });
			if (n != m || u != i || v != (i + 1) % n) B = false;
			s ^= w;
		}
		cin >> a >> b;
		--a, --b;
		if (!B) {
			c1.assign(n, -1);
			c2.assign(n, -1);
			c1[a] = c2[b] = 1;
			ll ans = 0;
			for (ll i = 0; i < n; ++i) {
				for (auto to : g[i]) {
					if (ans1(i) && ans2(to[0])) ans ^= to[1];
				}
			}
			cout << ans << "\n";
		}
		else {
			if (s == 0) {
				for (ll i = min(a, b); i < max(a, b); ++i) s ^= (g[i][0][1]);
				if (s == 0) cout << "0\n";
				else cout << "-1\n";
			}
			else cout << "-1\n";
		}
	}
	return 0;
}