#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cstring>
#include <cstdlib>
#include <map>
#include <unordered_map>
#include <set>
#include <iomanip>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define sqr(x) (x)*(x)
#define pw(x) (1LL << x)

struct Edge{
    int v, c;
};

int n, m;
vector<vector<Edge> > g;


main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while(t --){
        cin >> n >> m;
        g.assign(n, vector<Edge>(0));
        bool test_case_1 = n == m;
        for(int i = 0; i < m; i ++){
            int u, v, w;
            cin >> u >> v >> w;
            u --; v --;
            g[u].push_back({v, w});
            if (!(v == u + 1) && !(u == n - 1 && v == 0))
                test_case_1 = false;
        }
        int s, f;
        cin >> s >> f;
        s --; f --;

        if (test_case_1){
            int ans = 0;
            int pos = s;
            while(pos != f){
                ans ^= g[pos][0].c;
                pos = g[pos][0].v;
            }
            int now = 0;
            for(int i = 0; i < n; i ++)
                now ^= g[i][0].c;
//            if (s == f)
//                ans = now;
            if (now != 0)
                ans = -1;
            cout << ans << '\n';
            continue;
        }

//        cout << "miss" << '\n';
        return 42;
    }
}
