#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())
#define pb push_back

using namespace std;

template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }

typedef pair <int, int> pii;

const int N = 2e5 + 10;

inline void solve () {
    int n, m; cin >> n >> m;
    vector <vector <pii>> g (n);
    vector <int> in (n), out (n);
    int al = 0, xrr = 0;

    bool is_top_sorted = 1;

    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        --u, --v;
        is_top_sorted &= (u < v);
        g[u].pb({v, w});
        ++out[u];
        ++in[v];
        al ^= w;
    }
    int a, b; cin >> a >> b; --a; --b;

    if (is_top_sorted) {
        queue <int> q; q.push(a);
        vector <int> xr (n), cnt (n); cnt[a] = 1;
        while (sz(q)) {
            int v = q.front(); q.pop();
            for (auto [u, w] : g[v]) {
                cnt[u] += cnt[v];
                cnt[u] %= 2;
                q.push(u);
            }
        }
        int ans = 0; q.push(a);
        vector <bool> us (n);
        while (sz(q)) {
            int v = q.front(); q.pop();
            for (auto [u, w] : g[v]) {
                xr[u] ^= xr[v] ^ (w * cnt[v]);
                if (!us[u]) {
                    q.push(u);
                    us[u] = 1;
                }
            }
        }
        cout << xr[b] << endl;
        return;
    }

    while (a != b) {
        xrr ^= g[a][0].sc;
        a = g[a][0].fr;
    }

    if (!al && !xrr) cout << 0 << endl;
    else cout << -1 << endl;
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t = 1; cin >> t;
    while (t--) solve();
    return 0;
}
