#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <random>

#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

typedef long long ll;
typedef long double ld;

#define vec vector 
#define pii pair<ll, ll>
#define pll pair<ll, ll>

ll const mod = 1e9 + 7;
ll const INF = 2e9;
ll const LINF = 4e18;
ll const mod1 = 1000575179;

using namespace std;

#pragma warning(disable: 4996)

map<int, vec<pii>> g;

void solve() {
    g.clear();
    ll axor = 0;
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u - 1].push_back({ v - 1, w });
        axor ^= w;
    }
    int a, b; cin >> a >> b;
    a--;
    b--;
    ll now;


    ll var1 = 0;
    now = a;
    while (now != b) {
        var1 ^= g[now][0].second;
        now = g[now][0].first;
    }

    ll var2 = 0;
    now = b;
    while (now != a) {
        var2 ^= g[now][0].second;
        now = g[now][0].first;
    }

    if (var1 == 0 && var2 == 0) {
        cout << 0 << "\n";
        return;
    }
    cout << -1 << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG

    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}