#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const ll limit = 2e5 + 300, mod = 1e9 + 7;
vector<bool> used;
void solve(){
    ll n, m;
    cin >> n >> m;
    used = vector<bool>(n + 1, false);
    vector<vector<pair<ll, ll>>> graph(n + 1);
    vector<ll> XOR(n + 1), ways(n + 1);
    bool group_1 = true;
    for(int i = 0; i < m; i++){
        ll a, b, w;
        cin >> a >> b >> w;
        graph[a].push_back(make_pair(b, w));
        if(i < m - 1){
            if(a != i + 1 || b != i + 2)
                group_1 = false;
        }
        else{
            if(a != n || b != 1)
                group_1 = false;
        }
    }
    ll a, b;
    cin >> a >> b;
    if(group_1){
        ll all = 0;
        for(int i = 1; i <= n; i++)
            for(pair<ll, ll> edge : graph[i])
                all = (all ^ edge.second);
        if(all != 0){
            cout << -1 << "\n";
            return;
        }
        ll ans = 0;
        while(a != b) {
            ans = (ans ^ graph[a][0].second);
            a = graph[a][0].first;
        }
        if(ans > 0)
            ans = -1;
        cout << ans << "\n";
        return;
    }
    XOR[a] = 0;
    ways[a] = 1;
    for(int i = a; i <= b; i++){
        for(pair<ll, ll> nxt : graph[i]){
            XOR[nxt.first] = (XOR[nxt.first] ^ XOR[i]);
            if(ways[i] % 2)
                XOR[nxt.first] = (XOR[nxt.first] ^ nxt.second);
            ways[nxt.first] += ways[i];
            ways[nxt.first] %= 2;
        }
    }
    cout << XOR[b] << "\n";
}
int main(){
    srand(time(0));
    ll t = 1;
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    cin >> t;
    while(t--)
        solve();
    return 0;
}
