#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
// gp_hash_table

#define int long long
#define sz(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define ll long long
#define ld long double

#ifdef home
#define dbg(x) cout << #x << " = " << (x) << endl
#else
#define dbg(x) 42
#endif

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")

template <typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream& operator << (ostream &os, vector<T> v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1) os << " ";
    }
    return os;
}

mt19937_64 rng (chrono::high_resolution_clock::now().time_since_epoch().count());

int getRandom (int l, int r) {
    return (rng() % (r - l + 1)) + l;
}

const int N = 2e5 + 10;

int xr[N];
int X[N];
int cnt[N];
vector<pair<int, int>> g[N];
vector<pair<int, int>> r[N];
int n, m, a, b;

bool ok = true;

void read () {
    ok = true;
    cin >> n >> m;
    ok &= (n == m);
    for (int i = 0; i < n; i++) {
        g[i].clear();
        r[i].clear();
        xr[i] = 0;
        X[i] = 0;
    }
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;v--;
        if (i == m - 1) {
            ok &= (u == n - 1 && v == 0);
        } else {
            ok &= (u == i && v == i + 1);
        }
        g[u].emplace_back(v, w);
        r[v].emplace_back(u, w);
    }
    cin >> a >> b;
    a--;b--;
}

void solve_special () {
    int All_cycle = 0;
    for (int i = 0; i < n; i++) {
        for (auto v : g[i]) {
            All_cycle ^= v.second;
        }
    }
    if (All_cycle != 0) {
        cout << "-1\n";
        return;
    }
    int x = 0;
    for (int i = a; i != b; i = (i + 1) % n) {
        for (auto z : g[i]) {
            x ^= z.second;
        }
    }
    cout << x << "\n";
}

void solve() {
    read();
    if (ok) {
        solve_special();
        return;
    }
    vector<bool> used(n, false);
    vector<int> cnt(n, 0);
    vector<int> c2(n, 0);
    ok = true;
//    function<void(int, int )> find = [&] (int u, int x) {
//        used[u] = true;
//        if (u == a) {
//            X[u] = 0;
//            c2[u] = 1;
//            return;
//        }
//        for (auto [v, w] : r[u]) {
//            if (v < a) continue;
//            if (!used[v]) find(v, x ^ w);
//            else if (used[v] && (x ^ w) != X[v]) {
//                ok = false;
//                return;
//            }
//            X[u] ^= X[v];
//            X[u] ^= (w * c2[v]);
//            c2[u] += c2[v];
//            c2[u] %= 2;
//        }
//    };
//    find(b, 0);
    if (!ok) {
        cout << -1 << endl;
        return;
    }
    function<void(int)> dfs = [&] (int u) {
        used[u] = true;
        if (u == a) {
            xr[u] = 0;
            cnt[u] = 1;
            return;
        }
        for (auto [v, w] : r[u]) {
            if (v < a) continue;
            if (!used[v]) dfs(v);
            xr[u] ^= xr[v];
            xr[u] ^= (w * cnt[v]);
            cnt[u] += cnt[v];
            cnt[u] %= 2;
        }
    };
    dfs(b);
    cout << xr[b] << endl;
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}

/*
1)Time.
2) Нафарми баллы
3) порешай задачки
4) пофанься
 */