#include <iostream>
#include "vector"
#include "set"
#include "random"
#include "map"
#include "string"
#include "math.h"
#include "algorithm"
#define all(a) a.begin(), a.end()
#define ll long long
#define len(a) (int)a.size()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fort(a, b) for(int a = 0; a < b; a++)
#define f first
#define s second
using namespace std;

int mod = 1e9+7;
int modsum(int a, int b){
    if(a + b < mod){
        return a + b;
    }
    return a + b - mod;
}
int modrazn(int a, int b){
    if(a - b < 0){
        return a - b + mod;
    }
    return a - b;
}
int modmult(int a, int b){
    return (int)1ll*a*b%mod;
}

struct dots {
    int x, y;
};
int scalar(dots a, dots b){
    return a.x*b.x + a.y*b.y;
}
int psevd(dots a, dots b){
    return a.x * b.y - a.y * b.x;
}

vector<vector<pii>> g;
vector<bool> used, dr;
vector<int> sp;
vector<pii> otr;
int now = 0;


bool dfs(int v, int xo){
    used[v] = 1;
    dr[v] = 1;
    for(auto i : g[v]){
        int to = i.first, w = i.second;
        if(!used[to]) {
            if(!dfs(to, xo ^ w)){
                return false;
            }
            sp[v] += sp[to];
            sp[v] %= 2;
        }
        else if(dr[to]){
            if((xo ^ w) != 0){
            return false;}
            continue;

        } else{
            sp[v] += sp[to];
            sp[v] %= 2;
        }
        otr[now] = {w, sp[to]};
        now++;
    }
    dr[v] = 0;
    for(auto i: g[v]){
        if(i.first == v && sp[v] != 0){
            return false;
        }
    }
    return 1;
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t--){
        int n, m;
        cin >> n >> m;
        now = 0;
        g.resize(0);
        used.resize(0);
        dr.resize(0);
        sp.resize(0);
        otr.resize(0);
        g.resize(n);
        used.resize(n);
        dr.resize(n);
        sp.resize(n);
        otr.resize(m);
        fort(i, m){
            int a, b, c;
            cin >> a >> b >> c;
            a--; b--;
            g[a].push_back({b, c});
        }
        int a, b;
        cin >> a >> b;
        a--;b--;
        sp[b] = 1;
        if(!dfs(a, 0)){
            cout << "-1" << "\n";
            continue;
        }
        int ans = 0;
        fort(i, m){
            if(otr[i].second == 1){
                ans ^= otr[i].first;
            }
        }
        cout << ans << "\n";
    }
}