#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

vector<vector<pair<ll, ll>>> g;
ll st, fn;
ll ans = 0;
vector<ll> used, col;
vector<vector<ll>> last;
map<ll, ll> mp;
bool fl = false;

void dfs(ll u, ll xr) {
    col[u] = 1;
    if (u == fn) {
        if (mp.size() > 1) {
            fl = true;
        }
        if (xr != 0 && mp[0] > 0) {
            fl = true;
        }
        ans = (ans ^ xr);
    }
    used[u] = xr;
    for (auto [v, w] : g[u]) {
        if (col[v] == 1) {
            mp[0]++;
            last[v].push_back(0);
            if ((xr ^ w) != 0) {
                mp[(xr ^ w)]++;
                last[v].push_back((xr ^ w));
            }
            if (used[fn] != -1) {
                if (used[fn] != 0) {
                    fl = true;
                }
            }
        }
        else {
            dfs(v, xr ^ w);
        }
    }
    col[u] = 2;
    for (auto x : last[u]) {
        mp[x]--;
        if (mp[x] == 0) {
            mp.erase(mp.find(x));
        }
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    g.resize(n);
    used.resize(n, -1);
    col.resize(n, 0);
    last.resize(n);
    for (ll i = 0; i < m; i++) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].emplace_back(v, w);
    }
    cin >> st >> fn;
    st--;
    fn--;
    dfs(st, 0);
    if (fl) {
        cout << -1;
    }
    else {
        cout << ans;
    }
    g.clear();
    used.clear();
    col.clear();
    last.clear();
    mp.clear();
    fl = false;
    ans = 0;
}

int main() {
#ifdef LOCAL
    ll clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> tpk;
    while (tpk--) {
        solve();
        cout << endl;
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}