#include <bits/stdc++.h>
using namespace std;
#define int long long
#define fi first
#define se second
#define lwb lower_bound
#define upb upper_bound
#define em emplace_back
#define all(x) x.begin(), x.end()
#define ll long long
#define double long double
const int N = 1e6, C = 1000, K = 28, INF = 0x3f3f3f3f;
const double EPS = 1e-5;


random_device r;
default_random_engine e1(r());
seed_seq seed2{r(), r(), r(), r(), r(), r(), r(), r()};
mt19937 rnd(seed2);



struct ed {
    int i, u, v, w;
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n + 1);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].em(v, w);
    }
    int a, b;
    cin >> a >> b;
    vector<pair<int, int>> dp(n + 1);
    dp[b].se = 1;
    for (int i = b; i >= a; i--) {
        for (auto [to, w] : g[i]) {
            if (to > b)
                continue;
            dp[i].fi ^= dp[to].fi ^ (w * (dp[to].se % 2));
            dp[i].se += dp[to].se;
        }
    }
    if (dp[a].se == 0) {
        cout << -1 << endl;
        return;
    }
    cout << dp[a].fi << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    //cout << fixed << setprecision(15);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}