#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> gr_in(n), gr_out(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        gr_out[u].emplace_back(v, w);
        gr_in[v].emplace_back(u, w);
    }
    int a, b;
    cin >> a >> b;
    a--, b--;
    vector<int> cnt(n, 0);
    vector<int> xor_sum(n, 0);
    xor_sum[a] = 0;
    cnt[a] = 1;
    for (int i = 0; i < n; ++i) {
        for (auto [from, w] : gr_in[i]) {
            if (xor_sum[from] != -1) {
                xor_sum[i] ^= xor_sum[from] ^ (cnt[from] ? w : 0);
                cnt[i] ^= cnt[from];
            }
        }
    }
    if (xor_sum[b] == -1) {
        cout << "0\n";
    } else {
        cout << xor_sum[b] << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}