#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define double long double

typedef tree<
        pair <int, int>,
        null_type,
        less < pair <int, int> >,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

const int mod = 1000000007;

ll binpow(ll n, ll k){
    if(k == 0){
        return 1;
    }

    ll x = binpow(n, k / 2);
    if(k % 2 == 0){
        return (x * x) % mod;
    }else{
        return (((x * x) % mod) * n) % mod;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    vector < vector < pair <int, int> > > a(n);
    for(int i = 0; i < m; ++i){
        int x, y, z;
        cin >> x >> y >> z;
        --x; --y;

        a[x].push_back({y, z});
    }

    int s, t;
    cin >> s >> t;
    --s; --t;
    if(t < s){
        cout << 0 << '\n';
        return;
    }

    vector <int> dp(n), kol(n);
    dp[t] = 0;
    kol[t] = 1;
    for(int v = t - 1; v >= 0; --v){
        for(auto to : a[v]){
            dp[v] ^= dp[to.first];
            if(kol[to.first]){
                dp[v] ^= to.second;
            }
            kol[v] ^= kol[to.first];
        }
    }

    cout << dp[s] << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int tests = 1;
    cin >> tests;
    while(tests--) {
        solve();
    }
}
