#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define dbg(x) cerr << #x << " : " << x << '\n';

using namespace std;
using ll = ::int64_t;
const int N = 200000;
vector<pair<int, int>> g[N];
int x[N], cnt[N], st, trg;
void dfs(int v) {
    if (x[v] != -1) return;
    if (v == trg) {
        x[v] = 0, cnt[v] = 1;
        return;
    }
    x[v] = 0;
    for (auto [to, w] : g[v]) {
        dfs(to);
        cnt[v] += cnt[to];
        x[v] ^= x[to];
        if (cnt[to] & 1) x[v] ^= w;
    }
    cnt[v] %= 2;
}
void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) g[i].clear();
    bool firstg = n == m;
    bool dag = true;
    int all_x = 0;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        all_x ^= c;
        firstg &= a == i;
        firstg &= b == (i < n - 1 ? i + 1 : 0);
        dag &= a < b;
        g[a].emplace_back(b, c);
    }
    cin >> st >> trg;
    st--, trg--;
    if (firstg) {
        if (all_x != 0) {
            cout << -1 << '\n';
            return;
        }
        int v = st;
        int cur = 0;
        while (v != trg) {
            auto [to, w] = g[v][0];
            cur ^= w;
            v = to;
        }
        cout << (cur == 0 ? cur : -1) << '\n';
        return;
    }
    if (dag) {
        fill(x, x + n, -1);
        fill(cnt, cnt + n, 0);
        dfs(st);
        cout << x[st] << '\n';
        return;
    }
}

int main() {
    int tt = 1;
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << fixed << setprecision(27);
#endif
    cin >> tt;
    while (tt--) solve();
    return 0;
}