#include<bits/stdc++.h>

using namespace std;

struct edge
{
    int ver,dist;
    edge(){};
    edge(int vi, int di)
    {
        ver = vi;
        dist = di;
    }
};

const int maxn = 2*1e5+5;
int t;
int n,m,a,b;
int used[maxn];
int dp[maxn],br[maxn];
vector<edge>v[maxn];
bool f;
long long sum;

void pre()
{
    ///NE ZABRAVQJ DA MEMSETVASH
    memset(dp,0,sizeof(dp));
    memset(br,0,sizeof(br));
    memset(used,0,sizeof(used));
    for(int i=1;i<=n;i++)
    {
        v[i].clear();
    }
}

void dfs(int beg)
{
    used[beg] = 1;
    if(beg==a)
    {
        br[a] = 1;
        return;
    }
    edge nb;
    int sz = v[beg].size();
    for(int i=0;i<sz;i++)
    {
        nb = v[beg][i];
        if(!used[nb.ver]) dfs(nb.ver);
        if(br[nb.ver]%2) dp[beg] = dp[beg] ^ (dp[nb.ver] ^ nb.dist);
        else dp[beg] = dp[beg] ^ dp[nb.ver];
        br[beg] += br[nb.ver];
    }
}

/*void BFS(int beg)
{
    queue<int>q;
    q.push(beg);
    edge nb;
    int w,sz;
    while(!q.empty())
    {
        w = q.front();
        q.pop();
        sz = v[w].size();
        for(int i=0;i<sz;i++)
        {
            nb = v[w][i];
            if(br[w]%2) dp[nb.ver] = dp[nb.ver] ^ (dp[w] ^ nb.dist);
            else dp[nb.ver] = dp[nb.ver] ^ dp[w];
            br[nb.ver] += br[w];
            q.push(nb.ver);
        }
    }
}*/


long long dfs2(int beg)
{
    long long res = 0;
    bool nz = false;
    used[beg] = 1;
    edge nb;
    int sz = v[beg].size();
    for(int i=0;i<sz;i++)
    {
        nb = v[beg][i];
        if(used[nb.ver]==1)
        {
            f = true;
            nz = true;
            res += nb.dist;
        }
        else if(!used[nb.ver])
        {
            long long pom = dfs2(nb.ver);
            if(pom>0)
            {
                nz = true;
                pom -= 1;
                res += pom;
            }
        }
    }
    if(nz) res++;
    used[beg] = 2;
    return res;
}

void is_cycle()
{
    f = false;
    long long ch;
    for(int i=1;i<=n;i++)
    {
        if(f) return;
        if(!used[i])
        {
            ch = dfs2(i);
            if(ch<2) f = false;
        }
    }
}

void solve()
{
    /*is_cycle();
    if(f)
    {
        cout << -1 << endl;
        return;
    }
    memset(used,0,sizeof(used));*/
    //br[a] = 1;
    dfs(b);
    cout << dp[b] << endl;
}

void read()
{
    cin >> t;
    for(int i=1;i<=t;i++)
    {
        pre();
        cin >> n >> m;
        int x,y,d;
        for(int j=1;j<=m;j++)
        {
            cin >> x >> y >> d;
            v[y].push_back({x,d});
            sum ^= d;
        }
        cin >> a >> b;
        solve();
    }
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
	return 0;
}

