#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define double ld
#define int ll


using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v)
        os << e << " ";
    return os;
}

const int maxn = 3e5;

vector<pair<int, int>> g[maxn + 1];

vector<int> res(maxn + 1);
vector<int> cnt(maxn + 1);

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> w(m + 1);

    bool ok = true;
    for (int i = 1; i <= m; ++i) {
        int x, y;
        cin >> x >> y >> w[i];
        g[x].push_back({y, w[i]});

        if (i < m) {
            ok = ok & (x == i and y == i + 1);
        } else {
            ok = ok & (x == n and y == 1);
        }
    }

    int a, b;
    cin >> a >> b;
    if (ok) {
        if (a > b)
            swap(a, b);

        int alls = 0;
        for (int x: w)
            alls ^= x;

        if (alls != 0) {
            cout << -1 << endl;
            return;
        }
        cout << alls << endl;
    } else {
        if (a > b) {
            cout << 0 << endl;
            return;
        }

        fill(all(res), 0);
        cnt[a] = 1;

        for (int i = a; i <= b; ++i) {
            if (cnt[i] % 2 == 0)
                continue;

            for (auto [to, x] : g[i]) {
                cnt[to] = (cnt[to] + cnt[i]) % 2;
                res[to] ^= (res[i] ^ x);
            }
        }
        cout << res[b] << endl;
    };
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    cout.precision(40);
    cout << fixed;

    int t;
    cin >> t;

    while (t--)
        solve();

    return 0;
}