#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define PB push_back

using namespace std;
ll t, n, a, m, b, ans;
vector <vector<pair<ll, ll>>> g;
vector <ll> used1;

void dfs1(int now) {
    used1[now] = 1;
    for (auto to : g[now]) {
        if (!used1[to.F]) {
            dfs1(to.F);
        }
    }
}

void dfs(int now, ll x, int f) {
    used1[now]++;
    if (now == b) {
        ans ^= x;
        if (f == 1 && x != 0) {
            ans = -1;
            return;
        }
    }
    for (auto to : g[now]) {
        if (!used1[to.F]) {
            dfs(to.F, x ^ to.S, f);
            if (ans == -1) {
                return;
            }
        }
        else if (used1[to.F] == 1) {
            dfs(to.F, x ^ to.S, 1);
            if (ans == -1) {
                return;
            }
        }
    }
    used1[now]--;
}

void solve() {
    cin >> n >> m;
    ans = 0;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        ll u, w, v;
        cin >> u >> v >> w;
        u--; v--;
        g[u].PB({v, w});
    }
    cin >> a >> b;
    a--; b--;
    used1.resize(n);
    dfs1(a);
    if (!used1[b]) {
        cout << 0 << "\n";
    }
    else {
        used1.resize(0);
        used1.resize(n);
        dfs(a, 0, 0);
        cout << ans << "\n";
    }
    g.resize(0);
    used1.resize(0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}
