#pragma GCC optimize ("Ofast", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "popcnt")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <queue>
#include <cstdio>
#include <iomanip>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <random>
#include <bitset>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
const int N = 2e5 + 10;

struct node {
    int a, b, c;
};

vector <int> g[N], g2[N];
vector <int> o;
vector <node> G;
int us[N];
void dfs(int v) {
    us[v] = 1;
    for (auto& u : g[v]) {
        if (!us[u])
            dfs(u);
    }
    o.push_back(v);
}

int kl[N], kl2[N];
void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].push_back(b);
        g2[b].push_back(a);
        G.push_back({ a, b, c });
    }
    for (int i = 1; i <= n; i++)
        if (!us[i])
            dfs(i);
    int a, b;
    cin >> a >> b;
    kl[a] = 1;
    kl2[b] = 1;
    for (int i = 0; i < n; i++) {
        int v = o[i];
        for (auto& u : g[v])
            kl2[v] ^= kl2[u];
    }
    reverse(o.begin(), o.end());
    for (int i = 0; i < n; i++) {
        int v = o[i];
        for (auto& u : g2[v])
            kl[v] ^= kl[u];
    }
    int ans = 0;
    for (auto& r : G) {
        if (kl[r.a] == 1 && kl2[r.b] == 1)
            ans ^= r.c;
    }
    cout << ans;
    for (int i = 0; i <= n; i++) {
        g[i].clear(), g2[i].clear();
        kl[i] = kl2[i] = us[i] = 0;
    }
    o.clear();
    G.clear();
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << endl;
    }
} 
