#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3,inline,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,popcnt")
using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define ll long long
#define ld long double
#define pt pair<int, int>
#define fi first
#define x first
#define se second
#define y second
#define all(x) x.begin(), x.end()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
///=================================================///
const int MX = 3e5 + 100;
const int INF = 2e9;
const int MOD = 1e9 + 7;
///=================================================///
int n, m;
vector<pair<int, int>> g[MX], t[MX];
vector<int> put;

int used[MX];

void dfs(int u) {
    used[u] = 1;
    for (auto [v, w] : g[u]) {
        if (!used[v]) dfs(v);
    }
    put.push_back(u);
}

int comp[MX];
int last = 1;

void dfs2(int u) {
    comp[u] = last;
    for (auto [v, w] : t[u]) {
        if (!comp[v]) dfs2(v);
    }
}

int num_in_vertex[MX];
vector<pair<int, int>> g2[MX];

int need[MX];
vector<int> pp, dd;
void dfs3(int u, int T) {
    pp.push_back(u);
    if (u == T) dd = pp;
    for (auto [v, w] : g2[u]) {
        dfs3(v, T);
    }
    pp.pop_back();
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        t[v].emplace_back(u, w);
    }
    int S, T; cin >> S >> T;
    dfs(1);
    reverse(all(put));
    fill(used, used + n + 1, 0);
    last = 1;
    for (int x : put) {
        if (comp[x] == 0) {
            dfs2(x);
            last++;
        }
    }
    //for (int i = 1; i <= n; i++) cout << comp[i] << " ";
    for (int u = 1; u <= n; u++) {
        for (auto [v, w] : g[u]) {
            if (comp[u] == comp[v]) {
                num_in_vertex[comp[u]] |= w;
            } else {
                g2[comp[u]].emplace_back(comp[v], w);
            }
        }
    }
    fill(used, used + n + 1, 0);
    dfs3(comp[S], comp[T]);
    int res = 0;
    for (int x : dd) {
        res |= num_in_vertex[x];
        need[x] = 1;
    }
    cout << res << "\n";
    for (int u = 1; u <= n; u++) {
        g[u].clear();
        g2[u].clear();
        t[u].clear();
        need[u] = 0;
        num_in_vertex[u] = 0;
        comp[u] = 0;
        used[u] = 0;
    }
    last = 1;
    put.clear();
    pp.clear(), dd.clear();

}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(0); cin.tie();
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int tests = 1;
    cin >> tests;
    ld starts = clock();
    while (tests--) solve();
    ld endd = clock();
#ifdef LOCAL
    cout << "\nEND: " << (endd - starts) / (ld)(CLOCKS_PER_SEC) << " sec\n";
#endif
    return 0;
}
