#include <bits/stdc++.h>
using namespace std;
void solution() {
    int n, m, x, y, w;
    cin >> n >> m;
    vector <vector <pair <int, int>>> graph(n);
    vector <int> cnt(n, 0);
    for (int i = 0; i < m; i++) {
        cin >> x >> y >> w;
        x--; y--;
        graph[x].emplace_back(y, w);
        cnt[y]++;
    }
    int a, b;
    cin >> a >> b;
    a--; b--;
    if (a == b) {
        cout << -1 << "\n";
        return;
    }
    queue <int> q;
    vector <int> lst;
    for (int i = 0; i < n; i++) {
        if (cnt[i] == 0) q.push(i);
    }
    while (!q.empty()) {
        x = q.front();
        q.pop();
        lst.push_back(x);
        for (auto e: graph[x]) {
            cnt[e.first]--;
            if (cnt[e.first] == 0) q.push(e.first);
        }
    }
    vector <int> dp(n, 0), ans(n, 0);
    for (auto e: lst) {
        if (e == a) {
            dp[e] = 1;
            ans[e] = 0;
        }
        for (auto p: graph[e]) {
            dp[p.first] = (dp[p.first] + dp[e]) % 2;
            if (dp[e] == 1) ans[p.first] ^= ans[e] ^ p.second;
        }
    }
    cout << ans[b] << "\n";
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (; t > 0; t--) {
        solution();
    }
    return 0;
}