#include <bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define po pop_back
#define dl(s) ll(s.size())
#define all(s) s.begin(), s.end()
typedef long long ll;
typedef long double ld;
using namespace std;

mt19937 rnd(228);

vector <vector<pair<int, int>>> edge, edge2, edge3;

vector <int> p;

int rod(int v) {
    if (v == p[v]) return v;
    return p[v] = rod(p[v]);
}

int a, b;

vector <int> used, numb;

void dfs(int v) {
    numb.pb(v);
    used[v] = 1;
    for (auto i : edge[v]) {
        int x = rod(i.f);
        if (used[x] == 2) continue;
        if (used[x] == 0) {
            dfs(x);
            continue;
        }
        while (!numb.empty() and numb.back() != x) {
            p[rod(numb.back())] = x;
            numb.po();
        }
    }
    used[v] = 2;
    if (!numb.empty() and numb.back() == v) {
        numb.po();
    }
}

signed main() {
    //ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        edge.clear();
        edge.resize(n);
        p.clear();
        p.resize(n);
        used.clear();
        used.resize(n);
        numb.clear();
        for (int i = 0; i < n; i++) p[i] = i;
        for (int i = 0; i < m - 1; i++) {
            cin >> a >> b >> c;
            a--, b--;
            edge[a].pb({b, c});
        }
        cin >> a >> b;
        a--, b--;
        dfs(a);
        vector <int> u(n);
        for (int i = 0; i < n; i++) {
            u[rod(i)] = 1;
        }
        vector <int> x;
        for (int i = 0; i < n; i++) {
            if (u[i] == 1) x.pb(i);
        }
        a = rod(a);
        b = rod(b);
        edge2.clear();
        edge2.resize(dl(x));
        edge3.clear();
        edge3.resize(dl(x));
        vector <int> lol(dl(x)), lol2(dl(x));
        for (int i = 0; i < n; i++) {
            for (auto j : edge[i]) {
                int x1 = rod(i), x2 = rod(j.f);
                if (x1 != x2) {
                    edge2[x1].pb({x2, j.s});
                    edge3[x2].pb({x1, j.s});
                    lol[x2]++;
                    lol2[x1]++;
                }
            }
        }
        queue <int> q, q2;
        for (int i = 0; i < dl(x); i++) {
            if (lol[i] == 0) {
                q.push(i);
            }
            if (lol2[i] == 0) {
                q2.push(i);
            }
        }
        vector <int> dp(dl(x));
        dp[a] = 1;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (auto i : edge2[v]) {
                lol[i.f]--;
                dp[i.f] += dp[v];
                dp[i.f] %= 2;
                if (lol[i.f] == 0) {
                    q.push(i.f);
                }
            }
        }
        vector <int> dp2(dl(x));
        dp2[b] = 1;
        while (!q2.empty()) {
            int v = q2.front();
            q2.pop();
            for (auto i : edge3[v]) {
                lol2[i.f]--;
                dp2[i.f] += dp2[v];
                dp2[i.f] %= 2;
                if (lol2[i.f] == 0) {
                    q2.push(i.f);
                }
            }
        }
        int ans = 0;
        for (int i = 0; i < dl(x); i++) {
            for (auto j : edge2[i]) {
                if (dp[i] * dp2[j.f] == 1) {
                    ans = (ans^j.s);
                }
            }
        }
        cout << ans << "\n";
    }
}
