#include <bits/stdc++.h>

using namespace std;

const int N = 200'000;

vector<int> g[N], gr[N];

void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; i++) {
        g[i].clear();
        gr[i].clear();
    }

    struct edge {
        int u, v, w;
    };

    vector<edge> edges(m);

    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        edges[i] = {u, v, w};
        g[u].push_back(v);
        gr[v].push_back(u);
    }

    int a, b;
    cin >> a >> b;
    a--, b--;

    vector<int> dp(n), dpr(n);
    dp[b] = 1;
    for (int i = n - 1; i > -1; i--) {
        for (auto u : g[i]) {
            dp[i] ^= dp[u];
        }
    }
    dpr[a] = 1;
    for (int i = 0; i < n; i++) {
        for (auto u : gr[i]) {
            dpr[i] ^= dpr[u];
        }
    }
    int ans = 0;
    for (int i = 0; i < m; i++) {
        if (dp[edges[i].v] == 1 && dpr[edges[i].u] == 1) {
            ans ^= edges[i].w;
        }
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }
}