// good luck, champion!
#include <iostream>
#include <vector>
#include <math.h>
#define fs first
#define sc second
#define int long long

using namespace std;
using ll = long long;
const ll k = 316, mod = 1e9 + 7;

struct segtree {
    struct node {

    };
    vector<node> tree;
    int size;

    void init(int x) {
        size = 1;
        while (size < x)
            size *= 2;
        //
    }

    node combine(node a, node b) {

    };

    void build(vector<int>& a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            if (lx < a.size()) {
                //
            }
            return;
        }
        int m = (lx + rx) / 2;
        build(a, 2 * x + 1, lx, m);
        build(a, 2 * x + 2, m, rx);
        tree[x] = combine(tree[2 * x + 1], tree[2 * x + 2]);
    }

    void build(vector<int>& a) {
        init(a.size());
        build(a, 0, 0, size);
    }
};

ll bin_pow(ll a, ll n) {
    if (n == 0)
        return 1;
    if (n % 2)
        return (bin_pow(a, n - 1) * a) % mod;
    ll b = bin_pow(a, n / 2);
    return (b * b) % mod;
}

int gcd(int a, int b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

struct vect {
    double x, y;

    double len() {
        return sqrt(x * x + y * y);
    }

    void set_len(double l) {
        double tmp = len();
        x /= tmp;
        y /= tmp;
        x *= l;
        y *= l;
    }

    void build(vect a, vect b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }
};

double sc_multi(vect a, vect b) {
    return a.x * b.x - a.y * b.y;
}

double vc_multi(vect a, vect b) {
    return a.x * b.y - a.y * b.x;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        g[v].push_back({u, w});
    }
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    int tmp = 0;
    do {
        tmp ^= g[a][0].sc;
        a = g[a][0].fs;
    } while (a != a);
    if (tmp == 0) {
        do {
            tmp ^= g[a][0].sc;
            a = g[a][0].fs;
        } while (a != b);
        if (tmp != 0) {
            cout << -1 << '\n';
            return;
        }
        cout << tmp << '\n';
        return;
    }
    cout << -1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false),cin.tie(0),cout.tie(0);
    ll tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
