#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

// author: @cot-in

void fin() {
#ifdef cot_in
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> nxt(n);
    while (m--) {
        ll v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        nxt[v] = make_pair(u, w);
    }
    ll a, b;
    cin >> a >> b;
    a--;
    b--;
    ll xr = 0;
    while (a != b) {
        xr ^= nxt[a].second;
        a = nxt[a].first;
    }
    ll cycle = nxt[b].second;
    ll right_b = b;
    b = nxt[b].first;
    while (b != right_b) {
        cycle ^= nxt[b].second;
        b = nxt[b].first;
    }
    if (xr == 0 && cycle == 0) {
        cout << 0 << endl;
    } else {
        cout << -1 << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), fin();
    ll t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}