#include <bits/stdc++.h>
#define int long long

using namespace std;

void dfs(int v, vector<vector<pair<int, int>>> &g, vector<int> &down, vector<int> &used){
    used[v] = 1;
    for (auto p : g[v]){
        down[p.first] += down[v];
    }
    for (auto p : g[v]){
        if (used[p.first])continue;
        dfs(p.first, g, down, used);
    }
}

void dfs2(int v, vector<vector<pair<int, int>>> &rg, vector<int> &up, vector<int> &used){
    used[v] = 1;
    for (auto p : rg[v]){
        up[p.first] += up[v];
    }
    for (auto p : rg[v]){
        if (used[p.first]) continue;
        dfs2(p.first, rg, up, used);
    }
}

int ans;

void calc(int v, vector<vector<pair<int, int>>> &g, vector<int> &up, vector<int> &down, int to, vector<int> &used){
    used[v] = -1;
    for (auto p : g[v]){
        if (used[p.first] == -1) continue;
        if (used[p.first] == 0){
            calc(p.first, g, up, down, to, used);
        }
        if (used[p.first] == 1){
            int cnt = down[v] * up[p.first];
            if (cnt % 2 == 1){
                ans = (ans ^ p.second);
            }
            used[v] = 1;
        }
    }
    if (v == to) used[v] = 1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    while (t --) {
        int n, m;
        cin >> n >> m;
        vector<vector<pair<int, int>>> g(n), rg(n);
        int u, v, w;
        for (int i = 0; i < m; i ++){
            cin >> u >> v >> w;
            u --, v --;
            g[u].push_back({v, w});
            rg[v].push_back({u, w});
        }

        int a, b;
        cin >> a >> b;
        a --, b --;


        if (a >= b){
            cout << 0 << endl;
            continue;
        }

        vector<int> down(n, 0);
        down[a] = 1;
        vector<int> used(n, 0);
        dfs(a, g, down, used);

        vector<int> up(n, 0);
        up[b] = 1;
        used.assign(n, 0);
        dfs2(b, rg, up, used);

        ans = 0;
        used.assign(n, 0);
        calc(a, g, up, down, b, used);

        cout << ans;

    }
}

/*
1
3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
1 3
 */