#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector<pair<int, int> > > graph(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        graph[u].push_back({v, w});
    }

    int a, b;
    cin >> a >> b;
    a--;
    b--;

    if (a >= b)
    {
        cout << 0 << endl;
        return;
    }

    vector <pair<int, int> > hor(n, {0, 0});
    hor[a] = {0, 1};
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < graph[i].size(); ++j) {
            if (hor[i].second % 2 == 0) {
                hor[graph[i][j].first].first = hor[graph[i][j].first].first ^ hor[i].first;
            } else {
                hor[graph[i][j].first].first = hor[graph[i][j].first].first ^ hor[i].first ^ graph[i][j].second;
            }
            hor[graph[i][j].first].second += hor[i].second;
        }
    }
    cout << hor[b].first << endl;
}

const int mod = 1000000007;

signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}
