#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const int N = 2e5 + 10;
int n, m, a, b, cnt[N], cnt2[N];
vec<pii> g[N], g2[N];
bool used[N];

void dfs(int v, int f)
{
    used[v] = true;
    if (f)
    {
        for (auto &to : g[v])
        {
            if (!used[to.f]) dfs(to.f, f);
            (cnt2[v] += cnt2[to.f]) %= 2;
        }
    }
    else
    {
        for (auto &to : g2[v])
        {
            if (!used[to.f]) dfs(to.f, f);
            (cnt[v] += cnt[to.f]) %= 2;
        }
    }
}

void solve()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i++)
    {
        g[i].clear();
        g2[i].clear();
        cnt[i] = 0;
        used[i] = false;
    }
    for (int i = 0; i < m; i++)
    {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
        g2[v].pb({u, w});
    }
    cin >> a >> b;
    cnt[a] = 1;
    dfs(b, 0);
    for (int i = 1; i <= n; i++)
    {
        cnt2[i] = 0;
        used[i] = false;
    }
    cnt2[b] = 1;
    dfs(a, 1);
    int ans = 0;
    for (int v = 1; v <= n; v++)
    {
        for (auto &e : g[v])
        {
            if (cnt[v] * cnt2[e.f] % 2) ans ^= e.s;
        }
    }
    cout << ans << "\n";
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
