#include <bits/stdc++.h>
using namespace std;

int uu[200100], vv[200100], ww[200100], cnt1[200100], cnt2[200100];
vector<vector<pair<int, int> > > d(200100), g(200100);

void solve() {
    int n, m, k, a, b;

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        d[i].clear();
        g[i].clear();
        cnt1[i] = cnt2[i] = 0;
    }
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        uu[i] = u;
        vv[i] = v;
        ww[i] = w;
        d[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    cin >> a >> b;
    a--;
    b--;

    deque<int> q;
    q.push_back(a);
    cnt1[a] = 1;
    while (q.size()) {
        int k = q.front();
        q.pop_front();
        cnt1[k] %= 2;
        if (cnt1[k] == 0) {
            cnt1[k] = 2;
        }
        for (auto j : d[k]) {
            if (cnt1[j.first] == 0) {
                q.push_back(j.first);
            }
            cnt1[j.first] += cnt1[k];
        }
    }

    q.push_back(b);
    cnt2[b] = 1;
    while (q.size()) {
        int k = q.front();
        q.pop_front();
        cnt2[k] %= 2;
        if (cnt2[k] == 0) {
            cnt2[k] = 2;
        }
        for (auto j : g[k]) {
            if (cnt2[j.first] == 0) {
                q.push_back(j.first);
            }
            cnt2[j.first] += cnt2[k];
        }
    }

    for (int i = 0; i < n; i++) {
        cout << cnt1[i] << ' ' << cnt2[i] << '\n';
    }

    int ans = 0;
    for (int i = 0; i < m; i++) {
        if (cnt1[uu[i]] * cnt2[vv[i]] % 2) {
            ans ^= ww[i];
        }
    }
    cout << ans << '\n';
}

int main() {
    int t;

    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
