#include <bits/stdc++.h>
using namespace std;

int uu[200100], vv[200100], ww[200100], cnt1[200100], cnt2[200100], pr[200100];
vector<vector<pair<int, int> > > d(200100), g(200100);

void solve1(int n, int m) {
    int a, b, k;

    cin >> a >> b;
    a--;
    b--;
    pr[0] = 0;
    for (int i = 0; i < n; i++) {
        pr[i + 1] = pr[i] ^ d[i][0].second;
//        cout << pr[i + 1] << ' ';
    }
    cout << '\n';
    if (pr[n]) {
        cout << "-1\n";
        return;
    }
    if (a < b) {
        cout << (pr[b] ^ pr[a]) << '\n';
    } else {
        cout << (pr[n] ^ pr[a] ^ pr[b]) << '\n';
    }
}

void solve() {
    int n, m, k, a, b;
    bool r = 1;

    cin >> n >> m;
    if (n != m) {
        r = 0;
    }
    for (int i = 0; i < n; i++) {
        d[i].clear();
        g[i].clear();
        cnt1[i] = cnt2[i] = 0;
    }
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        if (u != i + 1 || v != (i + 1) % n + 1) {
            r = 0;
        }
        u--;
        v--;
        uu[i] = u;
        vv[i] = v;
        ww[i] = w;
        d[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    if (r) {
        solve1(n, m);
        return;
    }
    cin >> a >> b;
    a--;
    b--;
    cnt1[a] = 1;
    for (int i = a; i <= n; i++) {
        cnt1[i] %= 2;
        for (auto j : d[i]) {
            cnt1[j.first] += cnt1[i];
        }
    }
    cnt2[b] = 1;
    for (int i = b; i >= 0; i--) {
        cnt2[i] %= 2;
        for (auto j : g[i]) {
            cnt2[j.first] += cnt2[i];
        }
    }

    int ans = 0;
    for (int i = 0; i < m; i++) {
        if (cnt1[uu[i]] * cnt2[vv[i]] % 2) {
            ans ^= ww[i];
        }
    }
    cout << ans << '\n';
}

int main() {
    int t;

    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
