#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <stack>
#include <queue>
#include <set>
#include <deque>
#include <chrono>
#include <random>
#include <iomanip>
#include <assert.h>
#include <numeric>
#include <bitset>
#include <string>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
using ll = long long;
using ld = long double;
#define int long long
ll inf = 1e9 + 7;
ll inf_ = 1e18 + 4;
const int mod = 1e9 + 7;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

vector<vector<pair<int, int>>> g;
vector<int> dp;
vector<bool> used, h;
int b;

bool dfs(int v, int p = -1) {
    used[v] = 1;
    if (v == b) {
        dp[v] = 0;
        h[v] = 1;
        return 1;
    }
    for (auto u: g[v]) {
        if (!used[u.first]) {
            if (dfs(u.first, v)) h[v] = 1;
        } else if (p != u.first && h[u.first]) {
            dp[v] ^= (u.second ^ dp[u.first]);
        }
    }
    return h[v];
}

signed main() {
    //freopen("collider.in", "r", stdin);
    //freopen("collider.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        g.assign(n, {});
        used.assign(n, 0);
        dp.assign(n, -1);
        for (int i = 0; i < m; i++) {
            int u, v, x;
            cin >> u >> v >> x;
            u--;
            v--;
            g[u].push_back({v, u});
        }
        int a;
        cin >> a >> b;
        a--;
        b--;
        dfs(a);
        if (dp[a] < 0) cout << -1 << '\n';
        else
            cout << dp[a] << '\n';
    }
    return 0;
}