#include <iostream>
#include <vector>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> w(m);
    int xor_all = 0;
    range(i, m) {
        cin >> w[i] >> w[i] >> w[i]; 
        xor_all ^= w[i];
    }
    int a, b;
    cin >> a >> b;
    if (a == b) {
        if (xor_all) {
            cout << -1 << endl;
        } else {
            cout << 0 << endl;
        }
    } else {
        int xor1 = 0;
        if (a < b) {
            for (int i = a - 1; i < b - 1; i++) {
                xor1 ^= w[i];
            }
        } else {
            for (int i = a - 1; i < n; i++) {
                xor1 ^= w[i];
            }
            for (int i = 0; i < b - 1; i++) {
                xor1 ^= w[i];
            }
        }
        if (xor1 || (xor1 ^ xor_all)) {
            cout << -1 << endl;
        } else {
            cout << 0 << endl;
        }
    }
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    loop(t) {
        solve();
    }
}
