/**
 ____ ____ ____ ____ ____ ____
||l |||e |||i |||n |||a |||d ||
||__|||__|||__|||__|||__|||__||
|/__\|/__\|/__\|/__\|/__\|/__\|

**/

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 2e5 + 10;

struct edge
{
    int v, u, w;
} ed[maxn];

int n, m, a, b;

void input()
{
    cin >> n >> m;

    for (int i = 1; i <= m; i ++)
    {
        int v, u, w;
        cin >> v >> u >> w;
        ed[i].v = v;
        ed[i].u = u;
        ed[i].w = w;
    }
    cin >> a >> b;
}




void solve()
{
    input();
    int xor_all = 0;
    for (int i = 1; i <= m; i ++)
    {
        xor_all = (xor_all ^ ed[i].w);
    }
    if (xor_all != 0)
    {
        cout << -1 << endl;
        return;
    }

    int ans = 0;
    if (a <= b)
    {

        for (int i = a; i < b; i ++)
        {
            ans = (ans ^ ed[i].w);
        }
    }
    else
    {
        for (int i = a; i <= m; i ++)
        {
            ans = (ans ^ ed[i].w);
        }
        for (int i = 1; i < b; i ++)
        {
            ans = (ans ^ ed[i].w);
        }
    }

    cout << ans << endl;


}

int main()
{
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}

/**
2
2 2
1 2 1
2 1 2
1 2
3 3
1 2 7
2 3 0
3 1 7
3 2

*/
