/**
 ____ ____ ____ ____ ____ ____
||l |||e |||i |||n |||a |||d ||
||__|||__|||__|||__|||__|||__||
|/__\|/__\|/__\|/__\|/__\|/__\|

**/

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 2e5 + 10;

struct edge
{
    int v, u, w;
} ed[maxn];

int n, m, a, b;  bool dag;
vector < pair < int, int > > graph[maxn], in_graph[maxn];
void input()
{
    cin >> n >> m;
  dag = true;
    for (int i = 1; i <= m; i ++)
    {
        int v, u, w;
        cin >> v >> u >> w;
        if (v >= u)
            dag = false;
        ed[i].v = v;
        ed[i].u = u;
        ed[i].w = w;
    }
    cin >> a >> b;
}



ll ways[2][maxn];
void solve()
{
    input();
    if (dag)
    {
        for (int i = 1; i <= n; i ++)
        {
            ways[0][i] = ways[1][i] = 0;
        }
        if (a >= b)
        {
            cout << 0 << endl;
            return;
        }

        for (int i = 1; i <= n; i ++)
        {
            graph[i].clear();
            in_graph[i].clear();
        }
        for (int i = 1; i <= m; i ++)
        {
            graph[ed[i].v].push_back({ed[i].u, ed[i].w});
            in_graph[ed[i].u].push_back({ed[i].v, ed[i].w});
        }

        ways[0][b] = 1;
        for (int i = b - 1; i > 0; i --)
        {
            for (pair < int, int > dest : graph[i])
            {
                int u = dest.first;
                ways[0][i] += ways[0][u];
                ways[0][i] %= 2;
            }
        }

        ways[1][a] = 1;
        for (int i = a + 1; a <= n; a ++)
        {
            for (pair < int, int > dest : in_graph[i])
            {
                int u = dest.first;
                ways[1][i] += ways[1][u];
                ways[1][i] %= 2;
            }
        }

        int ans = 0;
        for (int i = 1; i <= m; i ++)
        {
            int take = (ways[1][ed[i].v] & ways[0][ed[i].u]);
            if (take)
                ans = (ans ^ ed[i].w);
        }
        cout << ans << endl;
    }
    else
    {
        int xor_all = 0;
        for (int i = 1; i <= m; i ++)
        {
            xor_all = (xor_all ^ ed[i].w);
        }
        if (xor_all != 0)
        {
            cout << -1 << endl;
            return;
        }

        int ans = 0;
        if (a <= b)
        {

            for (int i = a; i < b; i ++)
            {
                ans = (ans ^ ed[i].w);
            }
        }
        else
        {
            for (int i = a; i <= m; i ++)
            {
                ans = (ans ^ ed[i].w);
            }
            for (int i = 1; i < b; i ++)
            {
                ans = (ans ^ ed[i].w);
            }
        }

        if (ans != 0)
        {
            cout << -1 << endl;
        }
        else
            cout << ans << endl;
    }

}

int main()
{
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}

/**
2
2 2
1 2 1
2 1 2
1 2
3 3
1 2 7
2 3 0
3 1 7
3 2

*/
