#include <bits/stdc++.h>

#define ll long long
#define ld long double

#define pll pair<ll, ll>
#define pii pair<int, int>
#define vll vector<ll>
#define vpl vector<pll>
#define vbo vector<bool>
#define vii vector<int>
#define vpi vector<pii>

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define sz(a) a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for (int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i : a)

#define fillv(a) F0R(i, sz(a)){cin>>a[i];}
#define outv(a) F0R(i, sz(a)){cout<<a[i]<<' ';}

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

vector<vpl> graph;

struct chis {
    vll bits;
    ll kol = 0;

    chis() {
        bits.resize(32, 0);
    }

    chis operator^(ll n) const {
        chis res = *this;
        F0R(i, 32){
            if (n & 1){
                res.bits[i] = kol - bits[i];
            }
            n >>= 1;
        }
        return res;
    }

    chis operator+(const chis &other) const {
        chis res = *this;
        res.kol += other.kol;
        F0R(i, 32){
            res.bits[i] += other.bits[i];
        }
        return res;
    }

    ll to_ll(){
        ll sm = 0;
        F0R(i, 32){
            sm += bits[i] * (1 << i);
        }
        return sm;
    }
};

vector<chis> res;
vll step;
ll s, f;
vbo used;
vbo dost;

void check_dost(ll v){
    dost[v] = true;
    each(i, graph[v]){
        if (dost[i.first]){
            continue;
        }
        check_dost(i.first);
    }
}

void bfs(ll x){
    deque<ll> que;
    que.pub(x);
    while(sz(que) > 0) {
        ll v = que[0];
        que.pof();
        F0R(i, sz(graph[v])) {
            ll u = graph[v][i].first;
            ll w = graph[v][i].second;
            step[u]--;
            if (step[u] == 0){
                que.pub(u);
            }
            res[u] = res[u] + (res[v] ^ w);
        }
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    graph.clear();
    graph.resize(n);
    used.clear();
    used.resize(n, false);
    step.clear();
    step.resize(n, 0);
    res.clear();
    res.resize(n);
    dost.clear();
    dost.resize(n, false);
    F0R(i, m){
        ll v, u, w;
        cin >> v >> u >> w;
        v--; u--;
        graph[v].pub({u, w});
    }
    cin >> s >> f;
    s--; f--;
    check_dost(s);
    F0R(i, n){
        if (dost[i]) {
            each(j, graph[i]) {
                step[j.first]++;
            }
        }
    }
    res[s].kol += 1;
    bfs(s);
    ll sm = 0;
    F0R(i, 32){
        if (res[f].bits[i] % 2 == 1){
            sm += (1 << i);
        }
    }
    cout << sm << '\n';
}

int main() {
    fastio;
    int t = 0;
    cin >> t;
    F0R(i, t) {
        solve();
    }
}