#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define pii pair<int, int>
#define pll pair<long long, long long>
#define all(v) v.begin(),v.end()

const ll mod = 1000000007;

ll binpow(ll n, ll m){
    if(m == 0) return 1ll;
    if(m & 1ll) return (n * binpow(n, m - 1ll)) % mod;
    ll b = binpow(n, m / 2ll);
    return (b * b) % mod;
}

int pr[200005], p[200005], l[200005], r[200005], sz[200005];

ll ans;

int getp(int v){
    return v == p[v] ? v : p[v] = getp(p[v]);
}

void dsu_unite(int a, int b){
    a = getp(a);
    b = getp(b);
    if(a == b) return;
    if(sz[a] > sz[b]) swap(a, b);
    if(l[a] > r[b] || l[b] > r[a]){
        ans = 0;
        return;
    }
    p[a] = b;
    sz[b] += sz[a];
    ans = (ans * binpow(r[a] - l[a] + 1ll, mod - 2ll)) % mod;
    ans = (ans * binpow(r[b] - l[b] + 1ll, mod - 2ll)) % mod;
    r[b] = min(r[b], r[a]);
    l[b] = max(l[b], l[a]);
    ans = (ans * (ll)(r[b] - l[b] + 1ll)) % mod;
}

void solve(){
    int n;
    cin >> n;
    for(int i = 1; i < n; i++) cin >> pr[i];
    ans = 1;
    for(int i = 0; i < n; i++){
        cin >> l[i] >> r[i];
        ans = (ans * (ll)(r[i] - l[i] + 1ll)) % mod;
        sz[i] = 1;
        p[i] = i;
    }
    int q;
    cin >> q;
    for(int i = 0; i < q; i++){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if(!ans){
            cout << 0 << '\n';
            continue;
        }
        a--; b--; c--; d--;
        int dir1 = (a > b ? -1 : 1);
        int dir2 = (c > d ? -1 : 1);
        while(true){
            cout << a << ' ' << c << '\n';
            dsu_unite(a, c);
            if(!ans || a == b) break;
            a += dir1;
            c += dir2;
        }
        cout << ans << '\n';
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int tt;
    tt = 1;
    while(tt--){
        solve();
        #ifdef LOCAL
            cout << "________________________________________\n";
        #endif // LOCAL
    }
    #ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec\n";
    #endif // LOCAL
    return 0;
}

