#include <bits/stdc++.h>

using namespace std;

#define pii pair<int,int>
typedef long double ld;
//#define int int64_t

mt19937 gen(chrono::system_clock().now().time_since_epoch().count());

const int N = 2e5+10, K = 30, M = 1e9+7;

int mul (int a, int b) {
    return (a * 1ll * b) % M;
}

int bp (int a, int b = M-2) {
    if (b == 0) {
        return 1;
    }
    if (b&1) {
        return mul(a, bp(a, b-1));
    }
    else {
        int x = bp(a, b/2);
        return mul(x, x);
    }
}

int n;
vector <int> g[N];
int p[N], l[N], r[N];
int o[N];
int d[N];

void dfs (int v, int p) {
    d[v] = d[p] + 1;
    for (int i:g[v]) {
        if (i != p)
            dfs(i, v);
    }
}

int pw[2][N];

struct node {
    int sz, h[2];
};

node t[N*8];

node merg (node a, node b) {
    node c;
    c.sz = a.sz + b.sz;
    c.h[0] = a.h[0] * pw[0][b.sz] + b.h[0];
    c.h[1] = a.h[1] * pw[1][b.sz] + b.h[1];
    return c;
}

node get (int v, int vl, int vr, int l, int r) {
    if (vl > r || vr < l) {
        return {0, 0, 0};
    }
    if (vl >= l && vr <= r){
        return t[v];
    }
    int m = (vl+vr)/2;
    return merg(get(v*2, vl, m, l, r), get(v*2+1, m+1, vr, l, r));
}

void upd (int v, int vl, int vr, int p, int x) {
    if (vl == vr) {
        t[v] = {1, x, x};
        return;
    }
    int m = (vl+vr)/2;
    if (p <= m)
        upd(v*2, vl, m, p, x);
    else
        upd(v*2+1, m+1, vr, p, x);
    t[v] = merg(t[v*2], t[v*2+1]);
}

node get (int l, int r) {
    if (l < r) {
        return get(1, 0, 2*N, l, r);
    }
    else {
        return get(1, 0, 2*N, N+n-r-1, N+n-l-1);
    }
}



struct dsu {
    int p[N];
    int ml[N], mr[N];
    int ans;
    vector <int> all[N];
    void build () {
        ans = 1;
        for (int i=0;i<n;++i) {
            p[i] = i;
            ml[i] = l[i];
            mr[i] = r[i];
            ans = mul(ans, r[i] - l[i] + 1);
            all[i].push_back(i);
            upd(1, 0, 2*N, i, i);
            upd(1, 0, 2*N, N+n-i-1, i);
        }
    }

    int get (int v) {
        if (p[v] == v) {
            return v;
        }
        else {
            return p[v] = get(p[v]);
        }
    }

    void un (int v, int u) {
        v = get(v);
        u = get(u);
        if (u == v) {
            return;
        }
        if ((all[v].size()+gen()%3) < (all[u].size()+gen()%3)) {
            swap(u, v);
        }
        ans = mul(ans, bp(mr[v] - ml[v] + 1));
        ans = mul(ans, bp(mr[u] - ml[u] + 1));
        ml[v] = max(ml[v], ml[u]);
        mr[v] = min(mr[v], mr[u]);
        mr[v] = max(mr[v], ml[v]-1);
        ans = mul(ans, mr[v] - ml[v] + 1);
        p[u] = v;
        for (int i:all[u]) {
            upd(1, 0, 2*N, i, v);
            upd(1, 0, 2*N, N+n-i-1, v);
            all[v].push_back(i);
        }
    }
};

dsu D;

void solve (int a, int b, int c, int _d) {
    vector <int> v1, v2, v;
    vector <int> u1, u2, u;
    while (a != b) {
        while (d[a] > d[b]) {
            v1.push_back(a);
            a = p[a];
        }
        while (d[b] > d[a]) {
            v2.push_back(b);
            b = p[b];
        }
        if (a != b) {
            v1.push_back(a);
            v2.push_back(b);
            a = p[a];
            b = p[b];
        }
    }
    for (int i:v1) {
        v.push_back(i);
    }
    v.push_back(a);
    reverse(v2.begin(), v2.end());
    for (int i:v2) {
        v.push_back(i);
    }
    while (c != _d) {
        while (d[c] > d[_d]) {
            u1.push_back(c);
            c = p[c];
        }
        while (d[_d] > d[c]) {
            u2.push_back(_d);
            _d = p[_d];
        }
        if (c != _d) {
            u1.push_back(c);
            u2.push_back(_d);
            c = p[c];
            _d = p[_d];
        }
    }
//    cerr << a << ' ' << b << ' ' << c << ' ' << _d << endl;
    for (int i:u1) {
        u.push_back(i);
    }
    u.push_back(c);
    reverse(u2.begin(), u2.end());
    for (int i:u2) {
        u.push_back(i);
    }
//    cerr << "!\n";
    for (int i=0;i<v.size();++i) {
        D.un(v[i], u[i]);
//        cerr << v[i] << ' ' << u[i] << endl;
    }
//    cerr << endl;
}

void solve1 (int a, int b, int c, int d) {
    int sz = (b - a);
    int go1 = 1, go2 = 1;
    if (b < a) go1 = -1;
    if (d < c) go2 = -1;
    int p = 0;
    while (p <= sz) {
        int l = 0, r = sz - p;
        while (l < r) {
            int m = (l+r)/2;
            node g1 = get(a+go1*(p), a+go1*(p+m));
            node g2 = get(c+go2*(p), c+go2*(p+m));
            if (pii{g1.h[0], g1.h[1]} != pii{g2.h[0], g2.h[1]}) {
                r = m;
            }
            else {
                l = m+1;
            }
        }
//        cout << p << ' ' << sz << ' ' << l << '\n';
        p += l;
        if (p <= sz) {
            D.un(a+go1*(p), c+go2*(p));
        }
        p++;
    }
}

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    for (int i=0;i<N;++i) {
        o[i] = bp(i, M-2);
    }
    pw[0][0] = 1;
    pw[1][0] = 1;
    for (int i=1;i<N;++i) {
        pw[0][i] = pw[0][i-1] * (N + 1) % M;
        pw[1][i] = pw[1][i-1] * (N + 3) % M;
    }
    cin >> n;
    bool ok = 1;
    for (int i=1;i<n;++i) {
        cin >> p[i];
        p[i]--;
        if (p[i] != i-1) {
            ok = 0;
        }
        g[p[i]].push_back(i);
    }
    dfs(0, 0);
    for (int i=0;i<n;++i) {
        cin >> l[i] >> r[i];
    }
    D.build();
    int q;
    cin >> q;
    for (int it=0;it<q;++it) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;b--;c--;d--;
        if (!ok) {
            solve(a, b, c, d);
        }
        else {
            solve1(a, b, c, d);
        }
        cout << D.ans << '\n';
    }
    return 0;
}
