#include <bits/stdc++.h>
using namespace std;
#define int long long
#define double long double

const int MOD = 1e9 + 7;

vector<vector<int> > gr;
vector<pair<int, int> > otr;

vector<int> put;
void dfs(int v, int fn, int pr = -1) {
    if(!put.empty() && put.back() == fn)
        return;
    put.push_back(v);
    if(v == fn)
        return;
    for(auto u : gr[v])
        if(u != pr)
            dfs(u, fn, v);
    if(!put.empty() && put.back() == fn)
        return;
    put.pop_back();
}

vector<vector<int> > gr2;

vector<int> used;

pair<int, int> pr = {1, MOD - 1};

void dfs2(int v, int cl){
    used[v] = cl;
    pr.first = max(pr.first, otr[v].first);
    pr.second = min(pr.second, otr[v].second);
    for(auto u : gr2[v]){
        if(used[u] == cl)
            continue;
        dfs2(u, cl);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    gr.resize(n);
    used.resize(n, -1);
    for(int i=  1;i<n;++i){
        int x;
        cin >> x;
        --x;
        gr[x].push_back(i);
        gr[i].push_back(x);
    }
    otr.resize(n);
    for(int i = 0;i<n;++i){
        cin >> otr[i].first >> otr[i].second;
    }
    int m;
    cin >> m;
    vector<vector<int> > peop(m, vector<int> (4));
    gr2.resize(n);
    for(int i =0 ;i<m;++i) {
        int ans = 1;
        for (int j = 0; j < 4; ++j) {
            cin >> peop[i][j];
            peop[i][j]--;
        }
        put.clear();
        dfs(peop[i][0], peop[i][1]);
        auto cur1 = put;
        put.clear();
        dfs(peop[i][2], peop[i][3]);
        auto cur2 = put;
        for(int j = 0;j<(int)cur1.size();++j) {
            gr2[cur1[j]].push_back(cur2[j]);
            gr2[cur2[j]].push_back(cur1[j]);
        }
        for(int j = 0;j < n;++j){
            if(used[j] != i)
            {
                pr = {1, MOD - 1};
                dfs2(j, i);
                ans *= max(0LL, pr.second - pr.first + 1);
                ans %= MOD;
            }
        }
        cout << ans << "\n";
    }
}
