#include <bits/stdc++.h>

using namespace std;
#define int long long
#define double long double

const int MOD = 1e9 + 7;

int fast(int a, int n){
    if(n == 0)
        return 1;
    if(n == 1)
        return a;
    if(n % 2 == 1) {
        return (fast(a, n - 1) * a) % MOD;
    }
    int b = fast(a, (n >> 1));
    return (b * b) % MOD;
}

vector<vector<int> > gr;
vector<pair<int, int> > otr;

vector<int> p, sz;
int ans = 1;

int take(const pair<int, int>& a) {
    return max(0LL, a.second - a.first + 1);
}

void mergee(pair<int, int> &a, pair<int, int> &b) {
    a.first = max(a.first, b.first);
    a.second = min(a.second, b.second);
}

int get(int x) {
    vector<int> now;
    while (p[x] != -1) {
        now.push_back(x);
        x = p[x];
    }
    for (auto u: now)
        p[u] = x;
    return x;
}

void uniq(int x, int y) {
    x = get(x);
    y = get(y);
    if (x == y)
        return;
    if (sz[x] < sz[y])
        swap(x, y);
    p[y] = x;
    sz[x] += sz[y];
    ans *= fast(take(otr[y]), MOD - 2);
    ans %= MOD;
    ans *= fast(take(otr[x]), MOD - 2);
    ans %= MOD;
    mergee(otr[x], otr[y]);

    ans *= take(otr[x]);
    ans %= MOD;
}

vector<int> put;

void dfs(int v, int fn, int pr = -1) {
    if (!put.empty() && put.back() == fn)
        return;
    put.push_back(v);
    if (v == fn)
        return;
    for (auto u: gr[v])
        if (u != pr)
            dfs(u, fn, v);
    if (!put.empty() && put.back() == fn)
        return;
    put.pop_back();
}

vector<int> used;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    gr.resize(n);
    used.resize(n, -1);
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        gr[x].push_back(i);
        gr[i].push_back(x);
    }
    otr.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> otr[i].first >> otr[i].second;
    }
    p.resize(n, -1);
    sz.resize(n, 0);
    int m;
    cin >> m;
    vector<vector<int> > peop(m, vector<int>(4));
    for(int i = 0;i<n;++i)
        ans = (ans * take(otr[i])) % MOD;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < 4; ++j) {
            cin >> peop[i][j];
            peop[i][j]--;
        }
        put.clear();
        dfs(peop[i][0], peop[i][1]);
        auto cur1 = put;
        put.clear();
        dfs(peop[i][2], peop[i][3]);
        auto cur2 = put;
        for (int j = 0; j < (int) cur1.size(); ++j) {
            uniq(cur1[j], cur2[j]);
        }
        cout << ans << "\n";
    }
}
