﻿#include <iostream>
#include <set>
#include <vector>

using namespace std;

const int maxn = 1e5 + 5;

struct unit {
	int gr, l, r;

	unit() = default;

	unit(int gr, int l, int r) : gr(gr), l(l), r(r) {}
};

vector <unit> v;

signed main() {
	int n, m;
	cin >> n;
	for (int i = 2; i <= n; ++i) {
		int x;
		cin >> x;
	}
	for (int i = 1; i <= n; ++i) {
		int l, r;
		cin >> l >> r;
		v.push_back({ -i, l, r });
	}
	cin >> m;
	int g = 0;
	while (m--) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		--a, --b, --c, --d;
		if (a > b)
			swap(a, b);
		if (c > d)
			swap(c, d);
		int st = g;
		++g;
		int i = a, j = c;
		while (i <= b) {
			int l1 = v[i].l, r1 = v[i].r, l2 = v[j].l, r2 = v[j].r;
			int nl = max(l1, l2), nr = min(r1, r2);
			v[i] = v[j] = { g++, nl, nr };
			++i, ++j;
		}
		i = b, j = d;
		while (i >= a) {
			int l1 = v[i].l, r1 = v[i].r, l2 = v[j].l, r2 = v[j].r;
			int nl = max(l1, l2), nr = min(r1, r2);
			v[i] = v[j] = { v[j].gr, nl, nr };
			--i, --j;
		}
		set<int> q;
		int res = 1;
		for (int i = 0; i < n; ++i) {
			if (!q.count(v[i].gr)) {
				res *= max(0, v[i].r - v[i].l + 1);
				q.insert(v[i].gr);
			}
		}
		cout << res << '\n';
	}
}
/*
7
1 2 3 4 5 6
1 2
1 5
3 5
2 6
4 6
6 6
1 10
100
2 4
3 5
*/