#include <iostream>
#include <unordered_set>
#include <vector>
using namespace std;
#define endl '\n'
const int MAXN=2e5+10;
const long long mod=1e9+7;
vector <int> ch[MAXN], path[2], cura, curb;
int par[MAXN], depth[MAXN];
long long l[MAXN], r[MAXN], ss[MAXN], ans;
int p[MAXN], d[MAXN];
unordered_set <int> vr;
bool fl;
void dfs(int x) {
    for (auto i:ch[x]) {
        depth[i]=depth[x]+1;
        dfs(i);
    }
}
void find_path(int a, int b, int ind) {
    bool sw=false;
    if (depth[a]<depth[b]) {
        swap(a,b);
        sw=true;
    }

    if (!cura.empty()) cura.clear();
    if (!curb.empty()) curb.clear();
    if (!path[ind].empty()) path[ind].clear();
    while (depth[a]>depth[b]) {
        cura.push_back(a);
        a=par[a];
    }
    while (a!=b) {
        cura.push_back(a);
        curb.push_back(b);
        a=par[a]; b=par[b];
    }
    cura.push_back(a);
    if (!sw) {
        for (int i=0;i<cura.size();i++) path[ind].push_back(cura[i]);
        for (int i=curb.size()-1;i>=0;i--) path[ind].push_back(curb[i]);
    } else {
        for (int i=0;i<curb.size();i++) path[ind].push_back(curb[i]);
        for (int i=cura.size()-1;i>=0;i--) path[ind].push_back(cura[i]);
    }
}
long long power(long long a, long long b) {
    if (b==0) return 1;
    if (b%2==0) {
        long long res=power(a,b/2);
        return (res*res)%mod;
    }
    return (a*power(a,b-1))%mod;
}
int root(int x) {
    if (x==p[x]) return x;
    return p[x]=root(p[x]);
}
void Union(int a, int b) {
    int ra, rb, newl, newr, cur_root;
    ra=root(a); rb=root(b);
    long long ss1, ss2;
    ss1=r[ra]-l[ra]+1;
    ss2=r[rb]-l[rb]+1;
    if (ra!=rb) {
        if (d[ra]>d[rb]) {
            p[ra]=rb;
            cur_root=rb;
            ss[rb]=(ss[rb]*ss[ra])%mod;
        } else if (d[rb]>d[ra]) {
            p[rb]=ra;
            cur_root=ra;
            ss[ra]=(ss[ra]*ss[rb])%mod;
        } else {
            p[ra]=rb;
            cur_root=rb;
            d[rb]++;
            ss[rb]=(ss[rb]*ss[ra])%mod;
        }
        if (l[rb]>r[ra] || r[rb]<l[ra] || l[rb]>r[rb] || l[ra]>r[ra]) {
            l[cur_root]=1; r[cur_root]=0;
            ans=0;
            return;
        }
        if (l[rb]<l[ra]) swap(ra,rb);
        newr=min(r[ra],r[rb]);
        newl=l[rb];
        l[cur_root]=newl;
        r[cur_root]=newr;
        fl=true;
        ans=(ans*power(ss1,mod-2))%mod;
        ans=(ans*power(ss2,mod-2))%mod;
        ans=(ans*(r[cur_root]-l[cur_root]+1))%mod;
    }
}
long long find_ans() {
    int a, b;
    for (int i=0;i<path[0].size();i++) {
        a=path[0][i]; b=path[1][i];
        Union(a,b);
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, a, b, c, d;
    cin >> n;
    par[1]=-1;
    for (int i=2;i<=n;i++) {
        cin >> par[i];
        ch[par[i]].push_back(i);
    }
    ans=1;
    for (int i=1;i<=n;i++) {
        cin >> l[i] >> r[i];
        ans=(ans*(r[i]-l[i]+1))%mod;
        p[i]=i;
    }
    depth[1]=0;
    dfs(1);
    int q;
    cin >> q;
    for (int i=0;i<q;i++) {
        cin >> a >> b >> c >> d;
        find_path(a,b,0); find_path(c,d,1);
        if (ans==0) cout << 0 << endl;
        else {
            find_ans();
            cout << ans << endl;
        }
    }
    return 0;
}
/*
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5
*/