#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

#ifdef CLOWN

void dbg(ll a) { cout << a << "\n"; }

void dbg(int a) { cout << a << "\n"; }

void dbg(string a) { cout << a << "\n"; }

void dbg(ll a, ll b) { cout << a << " " << b << "\n"; }

void dbg(int a, int b) { cout << a << " " << b << "\n"; }

void dbg(ll a, ll b, ll c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(int a, int b, int c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(vector<ll> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

void dbg(vector<int> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

#else
#define dbg(...)
#endif

const ll mod = 1e9 + 7;
const int LOG = 17;

int binpow(int a, int b) {
    if (a <= 0) return 0;
    int ans = 1;
    while (b) {
        if (b & 1) {
            ans = 1LL * ans * a % mod;
        }
        b /= 2;
        a = 1LL * a * a % mod;
    }
    return ans;
}

vector<vector<int>> g;
vector<int> tin, tout, acces;
int timer = 0;

void dfs(int u, int p) {
    acces[u] = p;
    tin[u] = timer++;
    for (auto v: g[u]) {
        dfs(v, u);
    }
    tout[u] = timer++;
}

int high(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int ans = 1;

void get(int &u, int &v, int &l, int &r, vector<int> &pos1, vector<int>&pos2) {
    if (u == v) return;
    if (high(u, v)) {
        v = acces[v];
        pos2.push_back(v);
        r--;
    } else {
        u = acces[u];
        pos1.push_back(u);
        l++;
    }
}

struct dsu {
    vector<int> p;
    vector<int> val;

    void build(int n) {
        p.resize(n);
        val.resize(n);
        iota(all(p), 0);
    }

    int fs(int u) {
        return u == p[u] ? u : p[u] = fs(p[u]);
    }

    int add(int u, int v) {
        u = fs(u);
        v = fs(v);
        if (u == v) return 0;
        p[u] = v;
        return 1;
    }
};
void solve() {
    int n;
    cin >> n;
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    acces.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
        dbg(p, i);
    }
    vector<int> L(n), R(n);
    for (int i = 0; i < n; i++) cin >> L[i] >> R[i];
    int m;
    cin >> m;
    dfs(0, 0);
    dsu d;
    d.build(n);
    for (int i = 0; i < n; i++) {
        ans = 1LL * ans * (R[i] - L[i] + 1) % mod;
        d.val[i] = R[i] - L[i] + 1;
    }
    dbg(ans);
    while (m--) {
        int u1, v1, u2, v2;
        cin >> u1 >> v1 >> u2 >> v2;
        u1--, v1--, u2--, v2--;
        int l = 0, r = n - 1;
        vector<vector<int>> seg(4);
        seg[0].push_back(u1);
        seg[1].push_back(v1);
        seg[2].push_back(u2);
        seg[3].push_back(v2);
        while (1) {
            get(u1, v1, l, r, seg[0], seg[1]);
            get(u2, v2, l, r, seg[2], seg[3]);
            if (u1 == v1) {
                if (v2 != u2) assert(false);
                break;
            }
        }
        for (int i = 0; i < 4; i += 2) {
            if (seg[i].back() == seg[i ^ 1].back()) seg[i].pop_back();
            reverse(all(seg[i ^ 1]));
            for (auto j : seg[i ^ 1]) seg[i].push_back(j);
        }
        dbg(seg[0]);
        dbg(seg[2]);
        if (seg[0].size() != seg[2].size()) assert(false);
        for (int i = 0; i < seg[0].size() && ans; i++) {
            int j = seg[0][i];
            int k = seg[2][i];
            if (d.fs(j) == d.fs(k)) {
                continue;
            }
            ans = 1LL * ans * binpow(d.val[d.fs(j)], mod - 2) % mod;
            ans = 1LL * ans * binpow(d.val[d.fs(k)], mod - 2) % mod;
            d.add(j, k);
            int LL = max(L[j], L[k]), RR = min(R[j], R[k]);
            int v = (RR - LL + 1 <= 0 ? 0 : RR - LL + 1);
            d.val[d.fs(j)] = v;
            ans = 1LL * ans * v % mod;
            L[j] = L[k] = LL;
            R[j] = R[k] = RR;
        }
        dbg("FINAL");
        cout << ans << "\n";
    }
}

int32_t main() {
#ifdef CLOWN
    freopen("C://Users//olymp//CLionProjects//untitled//input.txt", "r", stdin);
    freopen("C://Users//olymp//CLionProjects//untitled//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
