#include <iostream>
#include<vector>
#include<algorithm>
#include<math.h>
#include<iomanip>
using namespace std;
long long md = 1e9 + 7;
vector<vector<int>>r;
vector<bool>used;
vector<int>tin, tout;
vector<int>p;
vector<int>par;
int tm1 = 0;
long long ans = 1;
long long bnup(long long h, long long a) {
    if (h == 0) {
        return 0;
    }
    if (a == 0) {
        return 1;
    }
    if (a == 1) {
        return h;
    }
    if (a % 2 == 0) {
        return bnup((h * h) % md, a/2);
    }
    else {
        return h * bnup(h, a - 1)%md;
    }
}
void dfs(int i) {
    used[i] = true;
    tin[i] = tm1; tm1++;
    for (auto j : r[i]) {
        if (!used[j]) {
            dfs(j);
        }
    }
    tout[i] = tm1; tm1++;
}
vector<int> go(int a, int b) {
    vector<int>ans;
    ans.push_back(a);
    while (tin[a] > tin[b] or tout[a] < tout[b]) {
        ans.push_back(p[a]);
        a = p[a];
    }
    vector<int>ans1;
    ans1.push_back(b);
    while (b!=a) {
        ans1.push_back(p[b]);
        b = p[b];
    }
    for (int j = ans1.size() - 2; j >= 0; j--) {
        ans.push_back(ans1[j]);
    }
    return ans;
}
int get_par(int i) {
    if (par[i] == i) {
        return i;
    }
    par[i] = get_par(par[i]);
    return par[i];
}
vector<long long>lm, rm;
void pr(int a, int b) {
    if (get_par(a) != get_par(b)) {
        a = get_par(a); b = get_par(b);
        long long l1 = max(lm[a], lm[b]);
        long long r1 = min(rm[a], rm[b]);
        r1 = max(r1, l1 - 1);
        ans *= bnup(rm[a] - lm[a] + 1, md - 2);
        ans %= md;
        ans *= bnup(rm[b] - lm[b] + 1, md - 2);
        ans %= md;
        ans *= (r1 - l1 + 1);
        ans %= md;
        lm[a] = l1, rm[a] = r1;
        par[b] = a;
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    p.assign(n, 0);
    used.assign(n, 0);
    tin.assign(n, 0);
    tout.assign(n, 0);
    r.assign(n, {});
    par.assign(n, 0);
    for (int i = 0; i < n; i++) {
        par[i] = i;
    }
    for (int i = 1; i < n; i++) {
        cin >> p[i]; p[i]--;
        r[i].push_back(p[i]);
        r[p[i]].push_back(i);
    }
    dfs(0);
    rm.assign(n, 0);
    lm.assign(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> lm[i] >> rm[i];
        ans *= (rm[i] - lm[i] + 1);
        ans %= md;
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d; a--; b--; c--; d--;
        auto t1 = go(a, b);
        auto t2 = go(c, d);
        for (int i = 0; i < t1.size(); i++) {
            pr(t1[i], t2[i]);
        }
        cout << ans<<endl;
    }
}