#include<bits/stdc++.h>

using namespace std;

#define int long long

vector<vector<int>> g;
vector<vector<int>> path_to_root;
vector<int> up;

vector<int> l;
vector<int> r;
vector<int> parent;

const int MOD = (1e9)+7;

int get_head(int u){
    if(parent[u] == u) return u;
    else{
        parent[u] = get_head(parent[u]);
        return parent[u];
    }
}

void merg(int u, int v){
    int head_u = get_head(u);
    int head_v = get_head(v);
    if(head_u == head_v) return;
    if(rand()%2==0){
        parent[head_v] = head_u;
        l[head_u] = max(l[head_u], l[head_v]);
        r[head_u] = min(r[head_u], r[head_v]);
    }
    else{
        swap(head_u, head_v);
        parent[head_v] = head_u;
        l[head_u] = max(l[head_u], l[head_v]);
        r[head_u] = min(r[head_u], r[head_v]);
    }
}

int lca(vector<int>&f, vector<int>&s){
    int ans = 0;
    int id = 0;
    while(id < min(f.size(), s.size()) && f[id] == s[id]){
        ans = f[id];
        id++;
    }
    return ans;
}

signed main(){
    int n;
    cin >> n;
    g.resize(n);
    up.resize(n);
    l.resize(n);
    r.resize(n);
    parent.resize(n);
    up[0] = -1;
    path_to_root.resize(n);
    for(int i = 0; i < n-1; i++){
        int p;
        cin >> p;
        p--;
        up[i+1] = p;
        g[p].push_back(i+1);
    }
    for(int i = 0; i < n; i++){
        parent[i] = i;
        cin >> l[i];
        cin >> r[i];
    }
    for(int i = 0; i < n; i++){
        int now = i;
        while(now != -1){
            path_to_root[i].push_back(now);
            now = up[now];
        }
        reverse(path_to_root[i].begin(), path_to_root[i].end());
    }
    int m;
    cin >> m;
    while(m--){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        int lca1 = lca(path_to_root[a], path_to_root[b]);
        int lca2 = lca(path_to_root[c], path_to_root[d]);
        vector<int> path1;
        vector<int> path2;
        vector<int> partl;
        vector<int> partr;
        partl.clear();
        partr.clear();
        int now;
        now = a;
        while(now != lca1){
            partl.push_back(now);
            now = up[now];
        }
        now = b;
        while(now != lca1){
            partr.push_back(now);
            now = up[now];
        }
        for(auto x : partl) path1.push_back(x);
        path1.push_back(lca1);
        reverse(partr.begin(), partr.end());
        for(auto x : partr) path1.push_back(x);

        partl.clear();
        partr.clear();
        now = c;
        while(now != lca2){
            partl.push_back(now);
            now = up[now];
        }
        now = d;
        while(now != lca2){
            partr.push_back(now);
            now = up[now];
        }
        for(auto x : partl) path2.push_back(x);
        path2.push_back(lca2);
        reverse(partr.begin(), partr.end());
        for(auto x : partr) path2.push_back(x);
        for(int i = 0; i < path1.size(); i++){
            merg(path1[i], path2[i]);
        }
        int ans = 1;
        for(int i = 0; i < n; i++){
            if(parent[i] == i){
                int cnt = max(0ll, r[i]-l[i]+1);
                ans = ans*cnt;
                ans = ans%MOD;
            }
        }
        cout << ans << "\n";
    }
}

