#include <bits/stdc++.h>
#define int long long
#define pii pair < int, int >
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

const int maxn = 200100, L = 20, mod = 1e9 + 7;

int l[maxn], r[maxn], p[maxn], sz[maxn], up[L][maxn], tim = 0, tin[maxn], tout[maxn], ans = 0;
vector < int > g[maxn];

int mood(int x)
{
    x %= mod;
    if (x < 0)
        x += mod;
    return x;
}

int binpow(int a, int b)
{
    if (b == 0)
        return 1;
    int t = binpow(a, b / 2);
    t = mood(t * t);
    if (b % 2)
        t = mood(t * a);
    return t;
}

void dfs(int v)
{
    tin[v] = tim;
    tim++;
    for (int i = 1; i < L; ++i)
        up[i][v] = up[i - 1][up[i - 1][v]];
    for (auto u : g[v])
        dfs(u);
    tout[v] = tim;
    tim++;
}

bool pr(int a, int b)
{
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b)
{
    if (pr(a, b))
        return a;
    if (pr(b, a))
        return b;
    for (int i = L - 1; i >= 0; --i)
    {
        if (pr(up[i][a], b) == false)
            a = up[i][a];
    }
    return up[0][a];
}

int get(int x)
{
    if (p[x] == x)
        return x;
    return (p[x] = get(p[x]));
}

void match(int v, int u)
{
    v = get(v);
    u = get(u);
    if (v == u)
        return;
    int lx = l[v], rx = r[v];
    int l2 = l[u], r2 = r[u];
    int tmp = rx - lx + 1;
    tmp = binpow(tmp, mod - 2);
    ans = mood(ans * tmp);
    tmp = r2 - l2 + 1;
    tmp = binpow(tmp, mod - 2);
    ans = mood(ans * tmp);
    lx = max(lx, l2);
    rx = min(rx, r2);
    if (lx > rx)
    {
        ans = 0;
        return;
    }
    ans = mood(ans * (rx - lx + 1));
    if (sz[u] > sz[v])
    {
        p[v] = u;
        sz[u] += sz[v];
        l[u] = lx;
        r[u] = rx;
    }
    else
    {
        p[u] = v;
        sz[v] += sz[u];
        l[v] = lx;
        r[v] = rx;
    }
}

void solve()
{
    int n;
    cin >> n;
    up[0][1] = 1;
    for (int i = 2; i <= n; ++i)
    {
        cin >> up[0][i];
        g[up[0][i]].pb(i);
    }
    ans = 1;
    for (int i = 1; i <= n; ++i)
    {
        cin >> l[i] >> r[i];
        ans = mood(ans * (r[i] - l[i] + 1));
        p[i] = i;
        sz[i] = 1;
    }
    dfs(1);
    int q;
    cin >> q;
    deque < int > way1, way2, hlp;
    while (q--)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (ans == 0)
        {
            cout << 0 << endl;
            continue;
        }
        // cout << a << ' ' << b << ' ' << c << ' ' << d << endl;
        int l1 = lca(a, b), l2 = lca(c, d);
        // cout << l1 << ' ' << l2 << endl;
        while (a != l1)
        {
            way1.pb(a);
            a = up[0][a];
        }
        way1.pb(a);

        while (b != l1)
        {
            hlp.pb(b);
            b = up[0][b];
        }
        while (hlp.size())
        {
            way1.pb(hlp.back());
            hlp.pop_back();
        }
        
        // cout << "WAY1 : ";
        // for (auto i : way1)
        //     cout << i << ' ';
        // cout << endl;


        while (c != l2)
        {
            way2.pb(c);
            c = up[0][c];
        }
        way2.pb(c);

        while (d != l2)
        {
            hlp.pb(d);
            d = up[0][d];
        }
        while (hlp.size())
        {
            way2.pb(hlp.back());
            hlp.pop_back();
        }
        // cout << "WAY2 : ";
        // for (auto i : way2)
        //     cout << i << ' ';
        // cout << endl;
        int len = way1.size();
        for (int i = 0; i < len; ++i)
            match(way1[i], way2[i]);
        cout << ans << endl;
        way1.clear();
        way2.clear();
    }
}

signed main()
{
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
        cout << endl;
    }
    return 0;
}