#pragma GCC optimize("Ofast,unroll-loops")
#include<bits/stdc++.h>
using namespace std;

#define int long long
typedef long long ll; typedef long double ld;
typedef vector<int> vi; typedef pair<int, int> pii;
const ll mod = 1000000007;
const int MAXN = 200000;

int pr[MAXN];int l[MAXN];int r[MAXN];int used[MAXN];
int cl[MAXN];int cr[MAXN];
vi g[MAXN]; int tin[MAXN], tout[MAXN], h[MAXN];

int ct = 0;
void dfs(int v, int ch){
    tin[v] = ct++;h[v] = ch;
    for(int i : g[v]){
        dfs(i, ch+1);
    }
    tout[v] = ct++;
}
bool is_p(int a, int b){
    return tin[a] < tin[b] && tout[a] > tout[b];
}
int nxt1[MAXN], nxt2[MAXN];
vector<pii> ps;
void get_nxt1(int a, int b){
    if(h[a] > h[b]){
        int cn = h[a] - h[b];
        for(int i = 0; i < cn; i++){
            nxt1[a] = pr[a];
            a = pr[a];
        }
    }else{
        int cn = h[b] - h[a];
        for(int i = 0; i < cn; i++){
            nxt1[pr[b]] = b;
            b = pr[b];
        }
    }
    while(a != b){
        nxt1[a] = pr[a];
        nxt1[pr[b]] = b;
        a = pr[a];    
        b = pr[b];    
    }
}
void get_nxt2(int a, int b){
    if(h[a] > h[b]){
        int cn = h[a] - h[b];
        for(int i = 0; i < cn; i++){
            nxt2[a] = pr[a];
            a = pr[a];
        }
    }else{
        int cn = h[b] - h[a];
        for(int i = 0; i < cn; i++){
            nxt2[pr[b]] = b;
            b = pr[b];
        }
    }
    while(a != b){
        nxt2[a] = pr[a];
        nxt2[pr[b]] = b;
        a = pr[a];    
        b = pr[b];    
    }
}
int sp[MAXN];
int sz[MAXN];
pii cg[MAXN];
int get(int v){
    if(sp[v] == -1)return v;
    int tr = get(sp[v]);
    sp[v] = tr;
    return tr;
}
int pw(int c, int s){
    if(s == 0)return 1;
    if(s%2 == 0){
        int t = pw(c, s/2);
        return(t*t)%mod;
    }else{
        return (c*pw(c, s-1))%mod;
    }
}
int get_obr(int c){
    return pw(c, mod-2);
}
int get_len(pii a){
    return max(0LL, a.second - a.first + 1);
}
int ans = 1;
int cu = 1;
void mrg(int v1, int v2){
    v1 = get(v1);
    v2 = get(v2);
    if(v1 == v2)return;
    if(sz[v1] < sz[v2])swap(v1, v2);
    sp[v2] = v1;
    sz[v1] += sz[v2];
    if(ans != 0){
        cu *= (get_len(cg[v2]) * get_len(cg[v1]))%mod;
        cu %= mod;
    }
    cg[v1].first = max(cg[v1].first, cg[v2].first);
    cg[v1].second = min(cg[v1].second, cg[v2].second);
    ans *= get_len(cg[v1]);
    ans %= mod;
}
void get_ans(int a1, int b1, int a2, int b2){
    int c1 = a1;
    int c2 = a2;
    int ans = 1;
    while(1){
        mrg(c1, c2);
        if(c1 == b1)break;
        c1 = nxt1[c1];
        c2 = nxt2[c2];
    }
    // cout << ans << '\n';
    // return ans;
}
void run_case(){
    int n;cin >> n;
    for(int i = 1; i < n; i++){
        int cp;cin >> cp;cp--;pr[i] = cp;
        g[cp].push_back(i);
    }
    for(int i = 0; i < n; i++)cin >> l[i] >> r[i];
    dfs(0, 0);
    int qq;cin >> qq;
    ans = 1;
    for(int i = 0; i < n; i++){
        cg[i] = {l[i], r[i]};
        ans *= cg[i].second - cg[i].first + 1;
        ans %= mod;
        sp[i] = -1;
        sz[i] = 1;
    }
    while(qq--){
        int a1, a2, b1, b2; cin >> a1 >> b1 >> a2 >> b2;a1--;b1--;a2--;b2--;
        // int ans = 1;
        if(ans){
            cu = 1;
            get_nxt1(a1, b1);
            get_nxt2(a2, b2);
            get_ans(a1, b1, a2, b2);
            ans *= get_obr(cu);
            ans %= mod;
        }
        // for(int i = 0; i < n; i++)cout << nxt1[i] << ' '<< nxt2[i] << '\n';
        // for(int i = 0; i < n; i++){
        //     used[i] = 0;
        // }
        // for(int i = 0; i < n; i++){
        //     int c = get(i);
        //     if(used[c])continue;
        //     if(cg[c].second - cg[c].first + 1 <= 0)ans = 0;
        //     ans *= cg[c].second - cg[c].first + 1;
        //     ans %= mod;
        //     used[c] = 1;
        // }
        cout << ans << '\n';
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    #ifdef PAFIMOV
        freopen("input.txt" , "r", stdin);
        cin >> tt;
    #endif
    //cin >> tt;
    while(tt--){
        run_case();
    }
}