#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++ i)
#define rf(i, a, b) for (int i = (a); i >= (b); -- i)
#define fe(x, a) for (auto& x : a)

#define fi first
#define se second

#define pb push_back
#define pw(x) (1LL << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

template <typename T>
using oset = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn (T& a, T b) {return a > b ? (a = b, 1) : 0;}
template <typename T>
bool umx (T& a, T b) {return a < b ? (a = b, 1) : 0;}

using ll = long long;
using ld = long double;
using pll = pair <ll, ll>;
using pii = pair <int, int>;

mt19937_64 rnd (time (0));

const int N = 2e5 + 5;
const int oo = 1e9;
const ll OO = 1e18;
const int mod = 1e9 + 7;


int n, p[N], Q, l[N], r[N];
int up[N][22];

int tin[N];
int tout[N];
int timer = 0;

vector <int> g[N];

void dfs (int v, int pred) {
    tin[v] = ++ timer;

    fe (x, g[v]) if(x != pred) dfs (x, v);

    tout[v] = timer;
}

bool possible (int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca (int a, int b) {
    if (possible (a, b)) return a;
    if (possible (b, a)) return b;

    rf (l, 20, 0) {
        if (!possible (up[b][l], a)) b = up[b][l];
    }

    return up[b][0];
}

vector <int> va, vc;
vector <int> va1, vc1;


int mult (int a, int b) {
    return 1LL * a * b % mod;
}

int bpow (int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mult (res, a);
        a = mult (a, a);
        b >>= 1;
    }

    return res;
}

int del (int a, int b) {
    return mult (a, bpow (b, mod - 2));
}
int par[N];

int get (int a) {
    if (par[a] == a) return a;
    return par[a] = get (par[a]);
}
int lmx[N], rmn[N];

void uni (int a, int b) {
    int a1 = get (a);
    int b1 = get (b);

    if (a1 == b1) return;

    par[b1] = a1;

    lmx[a1] = max (lmx[a1], lmx[b1]);
    rmn[a1] = min (rmn[a1], rmn[b1]);
}

bool f[N];

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio (0); cin.tie(0);

    cin >> n;
    p[1] = 1;
    fr (i, 2, n) {
        cin >> p[i];
        g[p[i]].pb (i);
        g[i].pb (p[i]);
    }

    dfs (1, 1);

    fr (i, 1, n) {
        cin >> l[i] >> r[i];
        par[i] = i;

        lmx[i] = l[i];
        rmn[i] = r[i];
    }

    fr (i, 1, n) up[i][0] = p[i];

    fr (l, 1, 20) {
        fr (i, 1, n) up[i][l] = up[up[i][l - 1]][l - 1];
    }

    int res = 1;
    fr (i, 1, n) res = mult (res, r[i] - l[i] + 1);

    cin >> Q;
    while (Q --) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        if (!res) {
            cout << 0 << "\n";
            continue;
        }

        int la = lca (a, b);
        int lc = lca (c, d);

        va.clear();
        vc.clear();

        va1.clear();
        vc1.clear();


        int x = a;
        while (x > 1 && x != la) {
            va.pb (x);
            x = p[x];
        }
        va.pb (la);

        x = b;
        while (x != la && x > 1) {
            va1.pb (x);
            x = p[x];
        }


        reverse (all (va1));
        fe (x, va1) va.pb (x);


        x = c;
        while (x > 1 && x != lc) {
            vc.pb (x);
            x = p[x];
        }
        vc.pb (lc);

        x = d;
        while (x != lc && x > 1) {
            vc1.pb (x);
            x = p[x];
        }


        reverse (all (vc1));
        fe (x, vc1) vc.pb (x);

        fr (i, 0, sz(va) - 1) {

            int u = va[i];
            int v = vc[i];

            u = get (u);
            v = get (v);

            if (u == v) continue;

            res = del (res, rmn[u] - lmx[u] + 1);
            res = del (res, rmn[v] - lmx[v] + 1);

            uni (u, v);

            u = get (u);
            v = get (v);

            if (lmx[u] > rmn[u]) {
                res = 0;
                break;
            }

            res = mult (res, rmn [u] - lmx[u] + 1);
        }

        cout << res << "\n";
    }

    return 0;
}
