#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define _GLICXX_DEBUG
#define endl '\n'
#define ss second
#define ff first
#define all(a) (a).begin(), (a).end()
#define int long long

const ll INF = 2e18 + 10, mod = 1e9 + 7;

vector<pair<int, int>> a;
vector<int> g[200000];
int tin[200000], tout[200000], pr[200000];
int p[200000];
int t = 0, fl = 0;

void dfs(int v, int p) {
    tin[v] = t++;
    for (auto u: g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = t++;
}

bool check(int x, int b) {
    return tin[x] <= tin[b] && tout[x] >= tout[b];
}

int binpow(int x, int y) {
    if (y == 0) return 1;
    if (y % 2 == 0) {
        int tt = binpow(x, y / 2);
        return tt * tt % mod;
    }
    return binpow(x, y - 1) * x % mod;
}

pair<int, int> cr(pair<int, int> x, pair<int, int> y) {
    return {max(x.ff, y.ff), min(x.ss, y.ss)};
}

int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}
void un(int x, int y) {
    x = get(x);
    y = get(y);
    a[x] = cr(a[x], a[y]);
    p[y] = x;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        x--;
        g[i].push_back(x);
        g[x].push_back(i);
        pr[i] = x;
    }


    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        a.push_back({l, r});
        p[i] = i;
    }

    dfs(0, 0);

    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x1--, y1--, x2--, y2--;
        if (fl) {
            cout << 0 << endl;
            continue;
        }
        vector<int> t1;
        while (!check(x1, y1)) {
            t1.push_back(x1);
            x1 = pr[x1];
        }
        t1.push_back(x1);
        vector<int> t11;
        while (x1 != y1) {
            t11.push_back(y1);
            y1 = pr[y1];
        }
        reverse(all(t11));
        for (auto i: t11) {
            t1.push_back(i);
        }

        vector<int> t2;
        while (!check(x2, y2)) {
            t2.push_back(x2);
            x2 = pr[x2];
        }
        t2.push_back(x2);
        vector<int> t22;
        while (x2 != y2) {
            t22.push_back(y2);
            y2 = pr[y2];
        }
        reverse(all(t22));
        for (auto i: t22) {
            t2.push_back(i);
        }

        for (int i = 0; i < t1.size(); ++i) {
            un(t1[i], t2[i]);
        }

        if (fl) {
            cout << 0 << endl;
            continue;
        }

        vector<int> used(n);
        int ans = 1;
        for (int i = 0; i < n; ++i) {
            int x = get(i);
            if (!used[x]) {
                ans *= (a[x].ss - a[x].ff + 1);
                ans %= mod;
                used[x] = 1;
            }
        }
        cout << ans << endl;
    }
}
