#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n;
vector <vector <int>> g;
vector <int> l;
vector <int> r;
int s = 1e9 + 7;

map <int, vector<int>> mp;

void dfs(int v, int last, vector <int> & pred) {
    for (auto u : g[v]) {
        if (u != last) {
            pred[u] = v;
            dfs(u, v, pred);
        }
    }
}


int get_ans(int a, int b, int c, int d) {
    vector <int> pred1(n, -1);
    vector <int> pred2(n, -1);
    dfs(a, -1, pred1);
    dfs(c, -1, pred2);
    vector <int> path1;
    vector <int> path2;
    int p = b;
    while (p != -1) {
        path1.push_back(p);
        p = pred1[p];
    }
    p = d;
    while (p != -1) {
        path2.push_back(p);
        p = pred2[p];
    }
    for (int i = 0; i < path1.size(); ++i) {
        for (auto el : mp[path1[i]]) {
            mp[el].push_back(path2[i]);
        }
        mp[path1[i]].push_back(path2[i]);
        for (auto el : mp[path2[i]]) {
            mp[el].push_back(path1[i]);
        }
        mp[path2[i]].push_back(path1[i]);
    }
    vector <int> used(n);
    ll ans = 1;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            if (mp[i].empty()) {
                ans *= 1ll * (r[i] - l[i] + 1);
                ans %= s;
            } else {
                used[i] = 1;
                int l1 = l[i], r1 = r[i];
                for (auto el : mp[i]) {
                    used[el] = 1;
                    l1 = max(l1, l[el]);
                    r1 = min(r1, r[el]);
                }
                ans *= 1ll * max(0, r1 - l1 + 1);
                ans %= s;
            }
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    vector <int> p(n);
    g.resize(n);
    l.resize(n);
    r.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
        g[i].push_back(p[i]);
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        cout << get_ans(a - 1, b - 1, c - 1, d - 1) << "\n";
    }
    return 0;
}
