#pragma GCC optimize("Ofast")

#include<bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>

#define F first
#define S second
#define pii pair<int, int>
#define int long long
#define pb push_back
#define ins insert
#define ll long long
#define bpp __builtin_popcount
#define endl "\n"

using namespace std;
using namespace __gnu_pbds;

mt19937 gen(time(0));

const int N = 2e5 + 10;
const int mod = 1e9 + 7;


vector < int > g[N];

int ind[N];
int sz[N];
int l[N];
int r[N];
int L[N];
int R[N];

int tin[N];
int tout[N];

int p[N];

int timer = 0;

void dfs(int v, int pr)
{
     p[v] = pr;
     tin[v] = timer++;

     for(auto to : g[v])
        if(to != pr)
        dfs(to, v);

     tout[v] = timer ++;
}

bool upper(int a, int b)
{
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}


int res = 1;

int bp(int x, int y)
{
    int ans = 1;
    while(y > 0)
    {
        if(y % 2 == 0)
        {
            y /= 2;
            x *= x;
            x %= mod;
        }
        else
        {
            ans *= x;
            ans %= mod;
            y --;
        }
    }

    return ans;
}



int fnd(int x)
{
    if(ind[x] == x)
        return x;
    else
        return ind[x] = fnd(ind[x]);
}

int del(int x, int y)
{
    return (x * bp(y, mod - 2)) % mod;
}


void unt(int v, int u)
{
    v = fnd(v);
    u = fnd(u);

    if(u == v || !res)
        return;

    if(sz[v] < sz[u])
        swap(u, v);

    res = del(res, R[u] - L[u] + 1);
    res = del(res, R[v] - L[v] + 1);

    ind[u] = v;
    sz[v] += sz[u];

    L[v] = max(L[v], L[u]);
    R[v] = min(R[v], R[u]);

    res *= max(0ll, R[v] - L[v] + 1);
    res %= mod;


}


int32_t main()
{
    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #else

    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

//    int ans = 1;

    for(int i = 1; i < n; i++)
    {
        int p;
        cin >> p;
        p --;

        g[p].pb(i);
        g[i].pb(p);

    }

    for(int i = 0; i < n; i++)
        cin >> l[i] >> r[i],
        ind[i] = i,
        sz[i] = 1,
        L[i] = l[i],
        R[i] = r[i],
        res *= (r[i] - l[i] + 1),
        res %= mod;

//    cout << res << endl;

    dfs(0, 0);

    int m;
    cin >> m;

    for(int i = 0; i < m; i++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        a--;
        b--;
        c--;
        d--;
        if(!res)
            cout << res << endl;
        else
        {
            vector < int > path1;
            vector < int > path2;

            while(!upper(a, b))
                path1.pb(a),
                a = p[a];
            path1.pb(a);

            vector < int > vec1;

            while(b != a)
                vec1.pb(b),
                b = p[b];
            reverse(vec1.begin(), vec1.end());
            for(auto to : vec1)
                path1.pb(to);
            vec1.clear();


            a = c;
            b = d;


            while(!upper(a, b))
                path2.pb(a),
                a = p[a];

            path2.pb(a);
//            vector < int > vec1;

            while(b != a)
                vec1.pb(b),
                b = p[b];
            reverse(vec1.begin(), vec1.end());
            for(auto to : vec1)
                path2.pb(to);


            for(int i = 0; i < path1.size(); i++)
//                {
                    unt(path1[i], path2[i]);



        }

        cout << res << endl;


    }














    return 0;
}

