#include <bits/stdc++.h>
#define ll long long

#define F first
#define S second

#define all(f) f.begin(),f.end()
#define rall(f) f.rbegin(),f.rend()

#define fori(i,j,n) for(ll i = j; i < n; ++i)

using namespace std;

const ll MOD = 1e9 + 7;

vector<vector<int> > f;
vector<pair<ll,ll> > dt;

vector<int> comp;
vector<int> used;

bool DFS(int v, int last){
    used[v] = 1;
    if(v == last){
        comp.push_back(v);
        return 1;
    }
    bool z = 0;
    for(int u : f[v]){
        if(used[u])continue;
        bool z1 = DFS(u, last);
        if(z1)z = 1;
    }
    if(z)comp.push_back(v);
    return z;
}

pair<ll,ll> getInstersect(ll l1, ll r1, ll l2, ll r2){
    if(max(l1,l2) > min(r1,r2)){
        return {1,0};
    }
    return {max(l1,l2), min(r1,r2)};
}

vector<vector<int> > f2;
vector<int> used2;

pair<ll,ll> DFS2(int v){
    used2[v] = 1;
    pair<ll,ll> p = dt[v];
    for(int u : f2[v]){
        if(used2[u])continue;
        pair<ll,ll> p1 = DFS2(u);
        p = getInstersect(p.F, p.S, p1.F, p1.S);
    }
    return p;
}

int main() {
    /*
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
     */
    int n;
    cin >> n;
    f.resize(n);
    fori(i,0,n-1){
        int x;
        cin >> x;
        x--;
        f[i+1].push_back(x);
        f[x].push_back(i+1);
    }
    fori(i,0,n){
        ll l,r;
        cin >> l >> r;
        dt.push_back({l,r});
    }
    int m;
    cin >> m;
    fori(i,0,m){
        int a,b,c,d;
        cin >> a >> b >> c >> d;
        a--,b--,c--,d--;
        used.resize(n, 0);
        DFS(a, b);
        vector<int> c1 = comp;
        comp.clear();
        used.clear();
        used.resize(n, 0);
        DFS(c, d);
        vector<int> c2 = comp;
        comp.clear();
        ll ans = 1;
        f2.resize(n);
        used2.resize(n, 0);
        fori(j,0,c1.size()){
            f2[c1[j]].push_back(c2[j]);
            f2[c2[j]].push_back(c1[j]);
        }
        fori(j,0,n){
            if(!used2[j]){
                pair<ll,ll> p = DFS2(j);
                ans *= (p.S - p.F + 1);
                ans %= MOD;
            }
        }
        cout << ans << '\n';
        used.clear();
        used2.clear();
        f2.clear();
    }
    return 0;
}
