#include <iostream>
#include <fstream>
#include <cmath>
#include <map>
#include <vector>
#include <set>
#include <queue>
#include <random>
#include <numeric>
#include <ctime>
#include <bits/stdc++.h>
#pragma GCC optimize(3)
using namespace std;
#define vi vector<int>
#define ll long long
#define  int long long
#define ld long double
#define pi pair<int, int>
const int MOD = 1e9 + 7;
mt19937 MT(179);
const int NMAX = 1e5 + 5;
int ANS = 1;
const int P = 200029;
vector<int> ost;
int bpow(int num, int k) {
    if(k == 1) return num;
    int t = bpow(num, k / 2);
    t *= t; t %= MOD;
    if(k % 2) {
        t *=num; t %= MOD;
    }
    return t;
}
void precalc() {
    ost.assign(NMAX, 1);
    for(int i = 1; i < NMAX; ++i) {
        ost[i] = ost[i - 1] * P;
        ost[i] %= MOD;
    }
}
int TIMER = 0;
vector<vector<int>> g;
vector<int> pr;
vector<int> tin;
vector<int> tout;
vector<int> p;
vector<pair<int, int>> sg;
vector<vector<int>> belongs;
int getP(int a) {
    if(p[a] == a) return a;
    p[a] = getP(p[a]);
    return p[a];
}
void unite(int a, int b) {
    int p1 = getP(a);
    int p2 = getP(b);
    if(p1 == p2) return;
    int prr = 0;
    if(sg[p1].first <= sg[p1].second) {
        prr = sg[p1].second - sg[p1].first + 1;
    }
    int pr2 = 0;
    if(sg[p2].first <= sg[p2].second) pr2 = sg[p2].second - sg[p2].first + 1;
    sg[p1].first = max(sg[p1].first, sg[p2].first);
    sg[p1].second = min(sg[p1].second, sg[p2].second);
    if(sg[p1].first > sg[p1].second) {
        ANS = 0;
    } else {
        if(prr != 0) {
            ANS = ANS * bpow(prr, MOD - 2);
            ANS %= MOD;
            ANS *= (sg[p1].second - sg[p1].first + 1);
            ANS %= MOD;
        }
        if(pr2 != 0) {
            ANS = ANS * bpow(pr2, MOD - 2);
            ANS %= MOD;
        }
    }
    p[p2] = p1;
}
vector<int> gp(int a, int b) {
    vector<int> ret;
    int cp = a;
    while(tin[cp] > tin[b] || tout[cp] < tout[b]) {
        ret.push_back(cp); cp = pr[cp];
    }
    ret.push_back(cp);
    vector<int> b2;
    int cb = b;
    while(cb != cp) {
        b2.push_back(cb); cb = pr[cb];
    }
    reverse(b2.begin(), b2.end());
    for(auto x : b2) ret.push_back(x);
    return ret;
}
void DFS(int v, int p) {
    tin[v] = TIMER++;
    for(auto x : g[v]) {
        if(x == p) continue;
        DFS(x, v);
    }
    tout[v] = TIMER;
}
vector<pi> st;
void build(int v, int l, int r) {
    if(l == r) {
        st[v] = {l + 1, l + 1};
        return;
    }
    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    int szr = mid - l + 1;
    st[v].first = st[2 * v].first  +st[2 * v + 1].first * ost[szr];
    st[v].first %= MOD;
    st[v].second = st[2 * v].second * ost[r - mid] + st[2 * v + 1].second;
    st[v].second %= MOD;
}
pair<int, int> get(int v, int l, int r, int L, int R, bool b) {
    if (l > R || L > r) return {0, 0};
    if (l >= L && R >= r) {
        if (!b) {
            return {st[v].first, r - l + 1};
        } else {
            return {st[v].second, r - l + 1};
        }
    }
    int mid = (l + r) / 2;
    pi tmp1 = get(2 * v, l, mid, L, R, b);
    pi tmp2 = get(2 * v + 1, mid + 1, r, L, R, b);
    if (!b) {
        tmp1.first = tmp1.first + tmp2.first * ost[tmp1.second];

        tmp1.first %= MOD;
        tmp1.second += tmp2.second;
        return tmp1;
    } else {
        tmp1.first = tmp1.first * ost[tmp2.second] + tmp2.first; tmp1.first %= MOD;
        tmp1.second += tmp2.second;
        return tmp1;
    }
}
void upd(int v, int l, int r, int pos, int val) {
    if(l > pos || r < pos) return;
    if(l == pos && r == pos) {
        st[v] = {val, val};
        return;
    }
    int mid = (l +r ) / 2;
    upd(2 * v, l, mid, pos, val);
    upd(2 * v + 1, mid + 1, r, pos, val);
    int szr = mid + 1 - l;
    st[v].first  =st[2 * v ] .first+ st[2 * v + 1].first * ost[szr];
    st[v].first %= MOD;
    st[v].second = st[2 * v].second * ost[r - mid] + st[2 * v + 1].second;
    st[v].second %= MOD;
}
void unite2(int a, int b) {
    int p1 = getP(a);
    int p2 = getP(b);
    if(p1 == p2) return;
    int prr = 0;
    if(belongs[p1].size() < belongs[p2].size()) swap(p1, p2);
    if(sg[p1].first <= sg[p1].second) {
        prr = sg[p1].second - sg[p1].first + 1;
    }
    int pr2 = 0;
    if(sg[p2].first <= sg[p2].second) pr2 = sg[p2].second - sg[p2].first + 1;
    sg[p1].first = max(sg[p1].first, sg[p2].first);
    sg[p1].second = min(sg[p1].second, sg[p2].second);
    if(sg[p1].first > sg[p1].second) {
        ANS = 0;
    } else {
        if(prr != 0) {
            ANS = ANS * bpow(prr, MOD - 2);
            ANS %= MOD;
            ANS *= (sg[p1].second - sg[p1].first + 1);
            ANS %= MOD;
        }
        if(pr2 != 0) {
            ANS = ANS * bpow(pr2, MOD - 2);
            ANS %= MOD;
        }
    }
    for(auto x : belongs[p2]) {
        upd(1, 0, belongs.size() - 1, x, p1 + 1);
        belongs[p1].push_back(x);
    }
    p[p2] = p1;
}
void do_small(int N) {
    p.assign(N, 0); iota(p.begin(), p.end(), 0ll);
    sg.assign(N, pi());
    for(int i = 0; i < N; ++i) {
        int l  =0, r = 0; cin >> l >> r; sg[i] = {l, r};
        ANS = ANS * (r - l + 1); ANS %= MOD;
    }
    int M = 0; cin >> M;
    st.assign(4 * N, pi());
    build(1, 0, N - 1);
    belongs.assign(N, vi());
    for(int i = 0; i < N; ++i) belongs[i].push_back(i);
    for(int j = 0; j < M; ++j) {
        int l1 = 0, r1 = 0, l2 = 0, r2 = 0;
        cin >> l1 >> r1 >> l2 >> r2;
        l1--;
        r1--;
        l2--;
        r2--;
        if (l1 > r1) {
            swap(l1, r1);
            swap(l2, r2);
        }
        if (l2 <= r2) {
            while (true) {
                int t1 = get(1, 0, N - 1, l1, r1, false).first;
                int t2 = get(1, 0, N - 1, l2, r2, false).first;
                if (t1 == t2) break;
                int l = -1, r = r2 - l2;
                while (r - l > 1) {
                    int mid = (r + l) / 2;
                    if (get(1, 0, N - 1, l1, l1 + mid - 1, false) == get(1, 0, N - 1, l2, l2 + mid - 1, false)) l = mid;
                    else r = mid;
                }
                unite2(l1 + r, l2 + r);
            }
        } else {
            while (true) {
                int t1 = get(1, 0, N - 1, l1, r1, false).first;
                int t2 = get(1, 0, N - 1, r2, l2, true).first;
                if (t1 == t2) break;
                int l = -1, r = r2 - l2;
                while (r - l > 1) {
                    int mid = (r + l) / 2;
                    if (get(1, 0, N - 1, l1, l1 + mid - 1, false) == get(1, 0, N - 1, l2 - mid + 1, l2, true)) l = mid;
                    else r = mid;
                }
                unite2(l1 + r, l2 - r);
            }
        }

        cout << ANS << endl;
    }
}
void solve() {
    int N = 0; cin >> N;
    pr.assign(N, 0);
    tin.assign(N, 0);
    tout.assign(N, 0);
    g.assign(N, vi());
    bool all = true;
    for(int i = 0; i < N - 1; ++i) {
        cin >> pr[i + 1];
        if(pr[i + 1] != i + 1) {
            all = false;
        }
        pr[i + 1]--;
        g[pr[i + 1]].push_back(i + 1);
    }
    if(all) {
        do_small(N);
        return;
    }
    DFS(0, -1);
    p.assign(N, 0); iota(p.begin(), p.end(), 0ll);
    sg.assign(N, pi());
    for(int i = 0; i < N; ++i) {
        int l  =0, r = 0; cin >> l >> r; sg[i] = {l, r};
        ANS = ANS * (r - l + 1); ANS %= MOD;
    }
    int M = 0; cin >> M;
    for(int ind = 0; ind < M; ++ind) {
        int a = 0, b = 0, c = 0, d = 0; cin >> a >> b >> c >> d;
        if(ANS == 0) {
            cout << ANS << "\n";
            continue;
        }
        a--; b--; c--; d--;
        vector<int> v1 = gp(a, b);
        vector<int> v2 = gp(c, d);
        for(int i = 0; i < v2.size(); ++i) {
            unite(v1[i], v2[i]);
        }
        cout << ANS << "\n";
    }
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << setprecision(12);
    int T = 1;
    precalc();
    while(T--) {
        solve();
    }
    return 0;
}
