#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define fast ios::sync_with_stdio(false);cin.tie(0);

const int N = 2e5 + 100;

int deep[N];

int timer = 1;

int tin[N], tout[N];

vector<vector<int>> g;

bool is_ans(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

void dfs(int v, int d) {
    tin[v] = timer++;
    deep[v] = d;
    for (auto u : g[v]) {
        dfs(u, d + 1);
    }
    tout[v] = timer++;
}

const int MOD = 1e9 + 7;

int p[N];
vector<pair<int, int>> pr;

vector<int> get_path(int a, int b) {
    if (a == b) {
        return {a};
    }
    vector<int> curr, curr1;
    while (!is_ans(a, b)) {
        curr.push_back(a);
        a = p[a];
    }
    curr.push_back(a);
    while (a != b) {
        curr1.push_back(b);
        b = p[b];
    }
    vector<int> res;
    for (auto i : curr) res.push_back(i);
    for (int i = curr1.size() - 1; i >= 0; i--) res.push_back(curr1[i]);
    return res;
}


ll binpow(ll a, ll n) {
    if (n == 0)
        return 1;
    if (n % 2 == 0) {
        ll x = binpow(a, n/2);
        return (x * x) % MOD;
    }
    else {
        return (a * binpow(a, n-1)) % MOD;
    }
}

int pd[N], sz[N];

int minl[N], minr[N];

struct dsu {

    ll ans = 1;

    dsu (int n) {
        for (int i = 0; i < n; i++) {
            sz[i] = 1;
            pd[i] = i;
        }
    }

    void init() {
        for (int i = 0; i < pr.size(); i++) {
            ans = (ans * max(0, (minr[i] - minl[i] + 1))) % MOD;
        }
    }

    int find(int x) {
        if (pd[x] == x)
            return x;
        return x = find(pd[x]);
    }

    void unite(int a, int b) {
        a = find(a);
        b = find(b);
        if (a == b)
            return;
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        sz[a] += sz[b];
        pd[b] = a;
        if (ans != 0) {
            ans = (ans * binpow(minr[a] - minl[a] + 1, MOD-2)) % MOD;
            ans = (ans * binpow(minr[b] - minl[b] + 1, MOD-2)) % MOD;
        }
        minl[a] = max(minl[a], minl[b]);
        minr[a] = min(minr[a], minr[b]);
        ans = (ans * max(0, (minr[a] - minl[a] + 1))) % MOD;
    }
};


signed main() {
    fast;
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    dfs(0, 0);
    pr.resize(n);
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        pr[i] = {l, r};
    }
    int m;
    cin >> m;
    dsu q(n);
    for (int i = 0; i < n; i++) {
        minl[i] = pr[i].first;
        minr[i] = pr[i].second;
    }
    q.init();
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;b--;c--;d--;
        auto d1 = get_path(a, b);
        auto d2 = get_path(c, d);
        for (int j = 0; j < d1.size(); j++) {
            q.unite(d1[j], d2[j]);
        }
        cout << q.ans << '\n';
    }
}
