#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,fma")

#define ll long long
#define ld long double
#define pii pair<int,int>
#define pll pair<ll,ll>
#define ve vector
#define mpp make_pair
#define pb push_back
#define all(x)      (x).begin(),(x).end()
#define sz(x)       ((int)(x).size())
#define fi first
#define se second
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;

template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }

const int N = 2e5 + 100;
const int lg = 18;

constexpr int MD = 1e9 + 7;

inline int add(int a, int b) { if ((a += b) >= MD) a -= MD; return a; }
inline int sub(int a, int b) { if ((a -= b) < 0) a += MD; return a; }
inline int mul(int a, int b) { return a * 1ll * b % MD; }
inline int bp(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) res = mul(res, a);
        a = mul(a, a); n >>= 1;
    } return res;
}
inline int inv(int a) { return bp(a, MD - 2); }

const int ph = 1e9 + 3;

int pw[N];
inline void calc() {
    pw[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw[i] = mul(pw[i - 1], ph);
    }
}

int up[N][lg];

int ac[N];
ve<int> gr[N];

int ti = 0;
int in[N], out[N];
int h[N], sz[N], dep[N], nxt[N];

/// HLD
int nxt_h[N];
int pos_h[N];
int head_h[N];

inline void dfs(int v, int p) {
    sz[v] = 1;
    nxt[v] = -1;
    nxt_h[v] = -1;

    in[v] = ti++;

    up[v][0] = p;
    for (int i = 1; i < lg; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }

    for (const auto &to : gr[v]) {
        h[to] = h[v] + 1;
        dfs(to, v);
        sz[v] += sz[to];
        chmax(dep[v], dep[to] + 1);
        if (!~nxt[v] || dep[nxt[v]] < dep[to]) nxt[v] = to;
        if (!~nxt_h[v] || sz[nxt_h[v]] < sz[to]) nxt_h[v] = to;
    }
    out[v] = ti - 1;
}
inline bool anc(int a, int b) {
    return in[a] <= in[b] && out[b] <= out[a];
}
inline int lca(int a, int b) {
    if (anc(a, b)) return a;
    if (anc(b, a)) return b;
    for (int i = lg - 1; ~i; --i) {
        if (!anc(up[a][i], b)) {
            a = up[a][i];
        }
    } return up[a][0];
}
inline int dist(int a, int b, int l) {
    return h[a] + h[b] - 2 * h[l];
}
inline int dist(int a, int b) {
    return dist(a, b, lca(a, b));
}

int head[N];
int pos[N];

ve<int> path[N];

inline void build(int v, int p, int h) {
    head[v] = h;
    if (~nxt[v]) build(nxt[v], v, h);

    if (v == h) {
        ve<int> down, up;
        int u = v;

        while (~u) {
            down.pb(u);
            u = nxt[u];
        }
        if (v) {
            u = ac[v];
            while (sz(up) <= sz(down)) {
                up.pb(u);
                if (!u) break;
                u = ac[u];
            }
            reverse(all(up));
        }
        path[v] = up;
        for (const auto &x : down) {
            pos[x] = sz(path[v]);
            path[v].pb(x);
        }
    }
    for (const auto &to : gr[v]) {
        if (to == p || to == nxt[v]) continue;
        build(to, v, to);
    }
}
inline int get_kth(int v, int k) {
    if (!k) return v;
    int b = 31 - __builtin_clz(k);
//    assert(k >> b & 1);
    v = up[v][b]; k -= (1 << b);
    return path[head[v]][pos[v] - k];
}
inline int get_path(int a, int b, int l, int k) {
    if (h[a] - h[l] >= k) return get_kth(a, k);
    else return get_kth(b, (h[b] - h[l]) - (k - (h[a] - h[l])));
}

int timr = 0;
inline void build_hld(int v, int p, int h) {
    head_h[v] = v; pos_h[v] = timr++;
    if (~nxt_h[v]) build_hld(nxt_h[v], v, h);
    for (const auto &to : gr[v]) {
        if (to == p || to == nxt_h[v]) continue;
        build_hld(to, v, to);
    }
}

pair<pii,pii> t[4 * N];
inline pii mg(const pii &a, const pii &b) {
    int H = add(a.fi, mul(b.fi, pw[a.se]));
    return mpp(H, a.se + b.se);
}
inline void mg(int v) {
    t[v].fi = mg(t[2 * v + 1].fi, t[2 * v + 2].fi);
    t[v].se = mg(t[2 * v + 2].se, t[2 * v + 1].se);
}

inline void upd(int v, int vl, int vr, int pos, int x) {
    if (vl == vr) return void(t[v] = {{x, 1}, {x, 1}});
    int m = vl + vr >> 1;
    if (pos <= m) upd(2 * v + 1, vl, m, pos, x);
    else upd(2 * v + 2, m + 1, vr, pos, x);
    mg(v);
}
inline pii get_LR(int v, int vl, int vr, int l, int r) {
    if (vl == l && vr == r) return t[v].fi;
    int m = vl + vr >> 1;
    if (r <= m) return get_LR(2 * v + 1, vl, m, l, r);
    else if (l > m) return get_LR(2 * v + 2, m + 1, vr, l, r);
    else {
        pii a = get_LR(2 * v + 1, vl, m, l, m);
        pii b = get_LR(2 * v + 2, m + 1, vr, m + 1, r);
        return mg(a, b);
    }
}
inline pii get_RL(int v, int vl, int vr, int l, int r) {
    if (vl == l && vr == r) return t[v].se;
    int m = vl + vr >> 1;
    if (r <= m) return get_RL(2 * v + 1, vl, m, l, r);
    else if (l > m) return get_RL(2 * v + 2, m + 1, vr, l, r);
    else {
        pii a = get_RL(2 * v + 2, m + 1, vr, m + 1, r);
        pii b = get_RL(2 * v + 1, vl, m, l, m);
        return mg(a, b);
    }
}

int S;
inline void upd(int pos, int x) { upd(0, 0, S - 1, pos, x); }
inline pii get_LR(int l, int r) { return get_LR(0, 0, S - 1, l, r); }
inline pii get_RL(int l, int r) { return get_RL(0, 0, S - 1, l, r); }

inline pair<ve<pii>,ve<pii>> get_val(int a, int b) {
    ve<pii> sa, sb;
    while (head_h[a] != head_h[b]) {
        if (h[head_h[a]] > h[head_h[b]]) {
            sa.pb({pos_h[head_h[a]], pos_h[a]});
            a = ac[head_h[a]];
        }
        else {
            sb.pb({pos_h[head_h[b]], pos_h[b]});
            b = ac[head_h[b]];
        }
    }
    if (h[a] <= h[b]) sb.pb({pos_h[a], pos_h[b]});
    else sa.pb({pos_h[a], pos_h[b]});
    reverse(all(sb));
    return mpp(sa, sb);
}

inline int get_hash(const ve<pii> &a, const ve<pii> &b, const int &v) {
    pii res = {0, 0}; int p = pos_h[v];
    for (const auto &[l, r] : a) {
        if (l <= p && p <= r) {
            res = mg(res, get_RL( l, p ));
            return res.fi;
        }
        res = mg(res, get_RL(l, r));
    }
    for (const auto &[l, r] : b) {
        if (l <= p && p <= r) {
            res = mg(res, get_LR( l, p ));
            return res.fi;
        }
        res = mg(res, get_LR(l, r));
    }
}

pii seg[N];
int l[N], r[N];

int p[N], rnk[N];
ve<int> vec[N];

int answer, zr, comp;

inline void builds(int n) {
    answer = 1; zr = 0; comp = n;
    for (int i = 0; i < n; ++i) {
        p[i] = i, rnk[i] = 1;
        vec[i] = {i};

        upd(pos_h[i], i + 1);

        seg[i] = {l[i], r[i]};
        if (l[i] <= r[i]) answer = mul(answer, r[i] - l[i] + 1);
        else ++zr;
    }
}
inline int par(int v) {
    if (p[v] == v) return v;
    return (p[v] = par(p[v]));
}
inline bool uni(int a, int b) {
    a = par(a), b = par(b);
    if (a == b) return 0;

    if (rnk[a] > rnk[b]) swap(a, b);
    p[a] = b, rnk[b] += rnk[a];

    if (seg[a].fi <= seg[a].se) answer = mul(answer, inv(seg[a].se - seg[a].fi + 1));
    else --zr;

    if (seg[b].fi <= seg[b].se) answer = mul(answer, inv(seg[b].se - seg[b].fi + 1));
    else --zr;

    chmax(seg[b].fi, seg[a].fi);
    chmin(seg[b].se, seg[a].se);

    if (seg[b].fi <= seg[b].se) answer = mul(answer, seg[b].se - seg[b].fi + 1);
    else ++zr;

    for (const int &v : vec[a]) {
        upd(pos_h[v], b + 1);
        vec[b].pb(v);
    }
    --comp;
    return 1;
}

inline void solve() { calc();
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        gr[--p].pb(i); ac[i] = p;
    }

    dfs(0, 0);
    build(0, 0, 0);
    build_hld(0, 0, 0);

    S = timr;

    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }

    builds(n);

    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;

        int l1 = lca(a, b);
        int l2 = lca(c, d);

        int di = dist(a, b, l1);

        auto [sa1, sb1] = get_val(a, b);
        auto [sa2, sb2] = get_val(c, d);

        if (comp > 1) {
            int prev = 0;
            while (1) {
                int l = prev, r = di, m, ans = di + 1, A, B;
                while (l <= r) {
                    m = l + r >> 1;
                    int aa = get_path(a, b, l1, m);
                    int bb = get_path(c, d, l2, m);
                    if (get_hash(sa1, sb1, aa) != get_hash(sa2, sb2, bb)) ans = m, r = m - 1, A = aa, B = bb;
                    else l = m + 1;
                }

                if (ans == di + 1) break;
                assert(uni(A, B)); prev = ans;
            }
        }

        cout << (zr ? 0 : answer) << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
/**
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
1
1 2 2 1
*/
