#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef long long lll; // int128

//int R = (1 << 7);
//
//vector<lll> d(R * 2, 1);
//
//void st(int v, lll val) {
//    v += R;
//    d[v] = val;
//    v /= 2;
//    while (v) {
//        d[v] = min(10000001ll, d[v * 2] * d[v * 2 + 1]);
//        v /= 2;
//    }
//}
//
//lll get() {
//    return d[1];
//}
//
//lll get(int v) {
//    return d[v + R];
//}

int n;
vector<int> p;

struct sss {
    ll first = 0;
    ll second = 0;
    vector<int> a;
};

vector<sss *> lr;
ll MD = 1000000007;

ll b_pow(ll a, ll k) {
    if (k == 0) return 1;
    if (k % 2 == 1) {
        return (a * b_pow(a, k - 1)) % MD;
    } else {
        ll t = b_pow(a, k / 2);
        return (t * t) % MD;
    }
}

ll dv(ll a, ll b) {
    return (a * b_pow(b, MD - 2)) % MD;
}

//x^p-2 === x^-1
//        1 3 4 2 1 3

vector<vector<int>> bin_ups;
vector<int> lg;
vector<int> h;
vector<int> st;
vector<vector<int>> g;

void dfs1(int v) {
    for (int e: g[v]) {
        h[e] = h[v] + 1;
        dfs1(e);
    }
}


void build() {
    bin_ups.resize(n, vector<int>(22, 0));
    lg.resize((1 << 21) + 1);
    h.resize(n + 1);
    g.resize(n);
    st.resize(23);
    for (int i = 0; i <= 22; i++) {
        st[i] = (1 << i);
    }
    int q = 1;
    for (int i = 2; i <= (1 << 21); i++) {
        if ((1 << (q + 1)) == i) {
            q++;
        }
        lg[i] = q;
    }
    for (int i = 1; i < n; i++) {
        bin_ups[i][0] = p[i];
        g[p[i]].push_back(i);
    }
    for (int j = 1; j < 22; j++) {
        for (int i = 1; i < n; i++) {
            bin_ups[i][j] = bin_ups[bin_ups[i][j - 1]][j - 1];
        }
    }
    dfs1(0);
}

int up(int v, int k) {
    if (k == 0) {
        return v;
    }
    return up(bin_ups[v][lg[k]], k - st[lg[k]]);
}

int lca(int a, int b) {
    int r = min(h[a], h[b]) + 1;
    int l = -1;
    while (r - l > 1) {
        int m = (r + l) / 2;
        int a1 = up(a, h[a] - m);
        int b1 = up(b, h[b] - m);
        if (a1 == b1) {
            l = m;
        } else {
            r = m;
        }
    }
    return up(a, h[a] - (r - 1));
}


void solve() {
    cin >> n;
    p.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
    }
    ll ans = 1;
    lr.resize(n);
    for (int i = 0; i < n; i++) {
        lr[i] = new sss();
        cin >> lr[i]->first >> lr[i]->second;
        ans *= (lr[i]->second - lr[i]->first + 1);
        lr[i]->a = {i};
        ans %= MD;
    }
    build();
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        int l1 = lca(a, b);
        int l2 = lca(c, d);
        int g1, g2;
        if (h[a] - h[l1] > h[c] - h[l2]) { // a->g1 c->l2 +      (g1->l1 l2->g2 -)     l1<-b g2<-d
            g1 = up(a, h[c] - h[l2]);
            g2 = up(d, h[b] - h[l1]);
        } else {
            if (h[a] - h[l1] == h[c] - h[l2]) {
                g1 = l1;
                g2 = l2;
            } else {  // a->g1 c->l2 +      (l2->g2 g1->l1 -)     l1<-b g2<-d
                g2 = up(c, h[a] - h[l1]);
                g1 = up(b, h[d] - h[l2]);
                swap(l1, g1);
                swap(l2, g2);
            }
        }
        while (a != g1) {
            ll l = max(lr[a]->first, lr[c]->first);
            ll r = min(lr[a]->second, lr[c]->second);
            if (r < l) {
                ans = 0;
            } else {
                ans = dv(ans, b_pow(lr[a]->second - lr[a]->first + 1, 1));
                if (lr[c] != lr[a]) {
                    ans = dv(ans, b_pow(lr[c]->second - lr[c]->first + 1, 1));
                    if (lr[c]->a.size() > lr[a]->a.size()) {
                        for (auto i: lr[a]->a) {
                            lr[c]->a.push_back(i);
                            lr[i] = lr[c];
                        }
                    } else {
                        for (auto i: lr[c]->a) {
                            lr[a]->a.push_back(i);
                            lr[i] = lr[a];
                        }
                    }
                }
                lr[a]->first = l;
                lr[a]->second = r;
                ans = (ans * b_pow(r - l + 1, 1)) % MD;
            }
            a = p[a];
            c = p[c];
        }
        ll l = max(lr[a]->first, lr[c]->first);
        ll r = min(lr[a]->second, lr[c]->second);
        if (r < l) {
            ans = 0;
        } else {
            ans = dv(ans, b_pow(lr[a]->second - lr[a]->first + 1, 1));
            if (lr[c] != lr[a]) {
                ans = dv(ans, b_pow(lr[c]->second - lr[c]->first + 1, 1));
                if (lr[c]->a.size() > lr[a]->a.size()) {
                    for (auto i: lr[a]->a) {
                        lr[c]->a.push_back(i);
                        lr[i] = lr[c];
                    }
                } else {
                    for (auto i: lr[c]->a) {
                        lr[a]->a.push_back(i);
                        lr[i] = lr[a];
                    }
                }
            }
            lr[a]->first = l;
            lr[a]->second = r;
            ans = (ans * b_pow(r - l + 1, 1)) % MD;
        }

        a = p[a];
        c = p[c];
        while (b != l1) {
            l = max(lr[b]->first, lr[d]->first);
            r = min(lr[b]->second, lr[d]->second);
            if (r < l) {
                ans = 0;
            } else {
                ans = dv(ans, b_pow(lr[b]->second - lr[b]->first + 1, 1));
                if (lr[d] != lr[b]) {
                    ans = dv(ans, b_pow(lr[d]->second - lr[d]->first + 1, 1));
                    if (lr[b]->a.size() > lr[d]->a.size()) {
                        for (auto i: lr[d]->a) {
                            lr[b]->a.push_back(i);
                            lr[i] = lr[b];
                        }
                    } else {
                        for (auto i: lr[b]->a) {
                            lr[d]->a.push_back(i);
                            lr[i] = lr[d];
                        }
                    }
                }
                lr[b]->first = l;
                lr[b]->second = r;
                ans = (ans * b_pow(r - l + 1, 1)) % MD;
            }
            b = p[b];
            d = p[d];
        }

        l = max(lr[b]->first, lr[d]->first);
        r = min(lr[b]->second, lr[d]->second);
        if (r < l) {
            ans = 0;
        } else {
            ans = dv(ans, b_pow(lr[b]->second - lr[b]->first + 1, 1));
            if (lr[d] != lr[b]) {
                ans = dv(ans, b_pow(lr[d]->second - lr[d]->first + 1, 1));
                if (lr[b]->a.size() > lr[d]->a.size()) {
                    for (auto i: lr[d]->a) {
                        lr[b]->a.push_back(i);
                        lr[i] = lr[b];
                    }
                } else {
                    for (auto i: lr[b]->a) {
                        lr[d]->a.push_back(i);
                        lr[i] = lr[d];
                    }
                }
            }
            lr[b]->first = l;
            lr[b]->second = r;
            ans = (ans * b_pow(r - l + 1, 1)) % MD;
        }
        b = p[b];
        d = p[d];

        vector<int> a1;
        bool swp = false;
        if (h[g1] < h[l1]) {
            swap(l1, g1);
            swp = !swp;
        }
        while (g1 != l1) {
            a1.push_back(g1);
            g1 = p[g1];
        }
        a1.push_back(g1);
        if (swp) {

            reverse(a1.begin(), a1.end());
        }

        swp = false;
        if (h[l2] < h[g2]) {
            swap(l2, g2);
            swp = !swp;
        }
        vector<int> a2;
        while (l2 != g2) {
            a2.push_back(l2);
            l2 = p[l2];
        }
        a2.push_back(l2);
        if (swp) {
            reverse(a2.begin(), a2.end());
        }
        for (int i = 0; i < a1.size(); i++) {
            l = max(lr[a1[i]]->first, lr[a2[i]]->first);
            r = min(lr[a1[i]]->second, lr[a2[i]]->second);
            if (r < l) {
                ans = 0;
            } else {
                ans = dv(ans, b_pow(lr[a1[i]]->second - lr[a1[i]]->first + 1, 1));
                if (lr[a1[i]] != lr[a2[i]]) {
                    ans = dv(ans, b_pow(lr[a2[i]]->second - lr[a2[i]]->first + 1, 1));
                    if (lr[a1[i]]->a.size() > lr[a2[i]]->a.size()) {
                        for (auto I: lr[a2[i]]->a) {
                            lr[a2[i]]->a.push_back(i);
                            lr[I] = lr[a1[i]];
                        }
                    } else {
                        for (auto I: lr[a1[i]]->a) {
                            lr[a1[i]]->a.push_back(i);
                            lr[I] = lr[a2[i]];
                        }
                    }
                }
                lr[a1[i]]->first = l;
                lr[a1[i]]->second = r;
                ans = (ans * b_pow(r - l + 1, 1)) % MD;
            }
            a1[i] = p[a1[i]];
            a2[i] = p[a2[i]];
        }
        cout << ans << '\n';
    }

}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
//    ll n, k;
//    cin >> n >> k;
//    vector<ll> a(n);
//    ll s = 1;
//    lll S = 1;
//    for (int i = 0; i < n; i++) {
//        cin >> a[i];
//        s *= a[i];
//        S *= a[i];
//        S = min(S, 100000000000001ll);
//        s = min(k + 1, s);
//    }
//    sort(a.rbegin(), a.rend());
//    if (s < k) {
//        cout << 0;
//        return 0;
//    }
//
//    for (int i = 0; i < n; i++) {
//        d[R + i] = a[i];
//    }
//    for (int i = R - 1; i > 0; i--) {
//        d[i] = min(10000001ll, d[i * 2] * d[i * 2 + 1]);
//    }
//    for (int j = 2; j <= 20; j++) {
//    for (int i = 0; i < n; i++) {
//            lll x = get(i);
//            st(i, a[i] / j);
//            if (get() < k) {
//                st(i, x);
//                break;
//            }
//        }
//    }
//    long double ans = k;
//    for (int i = 0; i < n; i++) {
//        ans *= (a[i] / get(i)) / ld(a[i]);
//    }
//    cout << fixed;
//    cout << setprecision(10);
//    cout << ans;
    return 0;
}