#include <bits/stdc++.h>

#define ll long long
#define ld long double


using namespace std;

vector<ll> p(vector<vector<ll> >& g, ll u, ll f){
    queue<ll> q;
    q.push(u);
    vector<ll> frm(g.size(), -1);
    vector<bool> vis(g.size(), 0);
    while(!q.empty()){
        ll v = q.front();

        q.pop();
        vis[v] = 1;
        if(v == f)
            break;
        for(auto to : g[v]){
            if(!vis[to]){
                q.push(to);
                vis[to] = 1;
                frm[to] = v;
            }
        }
    }
    vector<ll> res;
    ll v = f;
    while(v != u){
        res.push_back(v);
        v = frm[v];
    }
    res.push_back(u);
    reverse(res.begin(), res.end());
    return res;

}

struct _set{
    ll l, r, p = -1;
};

const ll mod = 1e9+7;
vector<_set> par;

int findset(int a){
    if(par[a].p == -1)
        return a;
    else
        return par[a].p = findset(par[a].p);
}

void unionset(int a, int b){
    a = findset(a);
    b = findset(b);
    if(a != b){
        par[a].l = max(par[a].l, par[b].l);
        par[a].r = min(par[a].r, par[b].r);
        par[b].p = a;
    }
}

int main()
{
   // ios_base::sync_with_stdio(0); cin.tie(0);
    ll n;
    cin >> n;
    vector<vector<ll> > g(n);
    for(ll i = 1; i < n; i++){
        ll v;
        cin >> v;
        v--;
        g[i].push_back(v);
        g[v].push_back(i);
    }

    vector<pair<ll, ll> > v(n);
    ll pr = 1;
    for(auto& i : v){
        cin >> i.first >> i.second;
    }
    ll m;
    cin >> m;
    par.resize(n);
    for(int i = 0; i < n; i++){
        par[i].l = v[i].first;
        par[i].r = v[i].second;
    }
    while(m--){
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        vector<ll> p1 = p(g, a - 1, b - 1);
        vector<ll> p2 = p(g, c - 1, d - 1);
        ll res = 1;
        for(ll i = 0; i < p1.size(); i++){
            unionset(p1[i], p2[i]);
        }
        for(ll i = 0; i < n; i++)
            if(par[i].p == -1){
                res *= max(0ll, par[i].r - par[i].l + 1);
                res %= mod;
            }
        cout << res << "\n";
    }
    return 0;
}
