#include<bits/stdc++.h>

using namespace std;

#define ll long long

vector<vector<ll>> gr;
vector<pair<ll, ll>> a;
vector<ll> d1;
vector<ll> e;

void dfs(ll v, ll p = -1, ll d = 0) {
    d1[v] = d;
    e.push_back(v);
    for (auto u : gr[v]) {
        if (u != p) {
            dfs(u, v, d + 1);
            e.push_back(v);
        }
    }
}

vector<ll> a1;
ll mod = 1e9 + 7;

ll f(ll u) {
    if (a1[u] == u) {
        return u;
    }
    return a1[u] = f(a1[u]);
}

void f1(ll u, ll v) {
    u = f(u);
    v = f(v);
    if (u != v) {
        a1[u] = v;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    gr.resize(n);
    for (ll i = 1; i < n; i++) {
        ll x;
        cin >> x;
        x--;
        gr[i].push_back(x);
        gr[x].push_back(i);
    }
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    d1.resize(n);
    dfs(0);
    a1.resize(n);
    for (ll i = 0; i < n; i++) {
        a1[i] = i;
    }
    vector<ll> first(n, -1);
    for (ll i = 0; i < e.size(); i++) {
        if (first[e[i]] == -1) {
            first[e[i]] = i;
        }
    }
    ll m;
    cin >> m;
    while (m--) {
        ll x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x1--;
        y1--;
        x2--;
        y2--;
        ll d2 = max(d1[x1], d1[y1]);
        vector<ll> p1;
        vector<bool> used1(n);
        used1[e[min(first[x1], first[y1])]] = true;
        p1.push_back(e[min(first[x1], first[y1])]);
        for (ll i = min(first[x1], first[y1]) + 1; i < max(first[x1], first[y1]); i++) {
            if (d1[e[i]] < d2 && !used1[e[i]]) {
                p1.push_back(e[i]);
                used1[e[i]] = true;
            }
        }
        p1.push_back(e[max(first[x1], first[y1])]);
        used1[e[max(first[x1], first[y1])]] = true;
        ll d3 = max(d1[x2], d1[y2]);
        vector<ll> p2;
        vector<bool> used2(n);
        p2.push_back(e[min(first[x2], first[y2])]);
        used2[e[min(first[x2], first[y2])]] = true;
        for (ll i = min(first[x2], first[y2]) + 1; i < max(first[x2], first[y2]); i++) {
            if (d1[e[i]] < d3 && !used2[e[i]]) {
                p2.push_back(e[i]);
                used2[e[i]] = true;
            }
        }
        p2.push_back(e[max(first[x2], first[y2])]);
        used2[e[max(first[x2], first[y2])]] = true;
        if (first[x1] > first[y1]) {
            reverse(p1.begin(), p1.end());
        }
        if (first[x2] > first[y2]) {
            reverse(p2.begin(), p2.end());
        }
        for (ll i = 0; i < min(p1.size(), p2.size()); i++) {
            f1(p1[i], p2[i]);
        }
        map<ll, vector<ll>> m1;
        set<ll> s1;
        for (ll i = 0; i < n; i++) {
            m1[f(i)].push_back(i);
            s1.insert(f(i));
        }
        ll answer = 1;
        for (auto elem : s1) {
            ll l = a[m1[elem][0]].first;
            ll r = a[m1[elem][0]].second;
            for (ll i = 1; i < m1[elem].size(); i++) {
                l = max(a[m1[elem][i]].first, l);
                r = min(a[m1[elem][i]].second, r);
            }
            if (l > r) {
                answer = 0;
                break;
            }
            answer *= (r - l + 1);
            answer = answer % mod;
        }
        cout << answer << endl;
    }
}