#include<bits/stdc++.h>

using namespace std;

#define ll long long

vector<vector<ll>> gr;
vector<pair<ll, ll>> a;
vector<ll> d1;
vector<ll> e;

void dfs(ll v, ll p = -1, ll d = 0) {
    d1[v] = d;
    e.push_back(v);
    for (auto u : gr[v]) {
        if (u != p) {
            dfs(u, v, d + 1);
            e.push_back(v);
        }
    }
}

vector<ll> a1;
ll mod = 1e9 + 7;
vector<ll> b1;
unordered_set<ll> s1;
unordered_map<ll, pair<ll, ll>> m2;

ll min1(ll u, ll v) {
    if (d1[u] < d1[v]) {
        return u;
    } else {
        return v;
    }
}

const ll maxl = 20;
const ll maxn = 5 * 1e5;
ll sparse[maxl][maxn];
ll log1[maxn];

ll lca(ll u, ll v) {
    if (u > v) {
        swap(u, v);
    }
    ll l = log1[v - u + 1];
    return min1(sparse[l][u], sparse[l][v - (1 << l) + 1]);
}

ll f(ll u) {
    if (a1[u] == u) {
        return u;
    }
    return a1[u] = f(a1[u]);
}

void f1(ll u, ll v) {
    u = f(u);
    v = f(v);
    if (u != v) {
        if (b1[u] < b1[v]) {
            a1[u] = v;
            s1.erase(u);
            m2[v].first = max(m2[v].first, m2[u].first);
            m2[v].second = min(m2[v].second, m2[u].second);
            b1[v] += b1[u];
        } else {
            a1[v] = u;
            s1.erase(v);
            m2[u].first = max(m2[u].first, m2[v].first);
            m2[u].second = min(m2[u].second, m2[v].second);
            b1[u] += b1[v];
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    log1[0] = -1;
    for (ll i = 1; i < maxn; i++) {
        log1[i] = log1[i / 2] + 1;
    }
    ll n;
    cin >> n;
    gr.resize(n);
    vector<ll> prev(n, -1);
    for (ll i = 1; i < n; i++) {
        ll x;
        cin >> x;
        x--;
        gr[i].push_back(x);
        gr[x].push_back(i);
        prev[i] = x;
    }
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    d1.resize(n);
    dfs(0);
    a1.resize(n);
    b1.resize(n, 1);
    for (ll i = 0; i < n; i++) {
        a1[i] = i;
        m2[i] = a[i];
        s1.insert(i);
    }
    vector<ll> first(n, -1);
    for (ll i = 0; i < e.size(); i++) {
        if (first[e[i]] == -1) {
            first[e[i]] = i;
        }
    }
    for (ll i = 0; i < e.size(); i++) {
        sparse[0][i] = e[i];
    }
    for (ll l = 1; (1 << l) <= e.size(); l++) {
        for (ll i = 0; i + (1 << l) - 1 < e.size(); i++) {
            sparse[l][i] = min1(sparse[l - 1][i], sparse[l - 1][i + (1 << l)]);
        }
    }
    ll m;
    cin >> m;
    while (m--) {
        ll x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x1--;
        y1--;
        x2--;
        y2--;
        vector<ll> p1;
        ll l = lca(first[x1], first[y1]);
        while (x1 != -1 && x1 != l) {
            p1.push_back(x1);
            x1 = prev[x1];
        }
        p1.push_back(l);
        vector<ll> p3;
        while (y1 != -1 && y1 != l) {
            p3.push_back(y1);
            y1 = prev[y1];
        }
        reverse(p3.begin(), p3.end());
        for (auto elem : p3) {
            p1.push_back(elem);
        }
        vector<ll> p2;
        ll l2 = lca(first[x2], first[y2]);
        while (x2 != -1 && x2 != l2) {
            p2.push_back(x2);
            x2 = prev[x2];
        }
        p2.push_back(l2);
        vector<ll> p4;
        while (y2 != -1 && y2 != l2) {
            p4.push_back(y2);
            y2 = prev[y2];
        }
        reverse(p4.begin(), p4.end());
        for (auto elem : p4) {
            p2.push_back(elem);
        }
        for (ll i = 0; i < min(p1.size(), p2.size()); i++) {
            f1(p1[i], p2[i]);
        }
        ll answer = 1;
        for (auto elem : s1) {
            if (m2[elem].first > m2[elem].second) {
                answer = 0;
                break;
            }
            answer *= (m2[elem].second - m2[elem].first + 1);
            answer = answer % mod;
        }
        cout << answer << endl;
    }
}
