#include <bits/stdc++.h>
#define all(a) begin(a), end(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
typedef long long ll;
typedef long double ld;
using namespace std;

const ll R=1e9+7;
ll res=1;

ll bin_pow(ll a, ll b){
    if(b==0) return 1;
    if(b&1) return (a*bin_pow(a, b-1))%R;
    ll m=bin_pow(a, b>>1);
    return (m*m)%R;
}

class dsu{
    vector<ll> p, size;
    vector<pair<ll, ll>> &lr;

public:
    dsu(vector<pair<ll, ll>> &c) : lr(c) {
        p.resize(c.size());
        iota(all(p), 0);
        size.assign(c.size(), 1);
    }

    ll get(ll i){
        if(p[i]==i) return i;
        return p[i]=get(p[i]);
    }

    void merge(ll a, ll b){
        a=get(a);
        b=get(b);
        if(a==b) return;
        if(size[a]>size[b]) swap(a, b);
        p[a]=b;
        size[b]+=size[a];
        if(res!=0){
            res=(res*bin_pow(lr[a].second-lr[a].first+1LL, R-2LL))%R;
            if(lr[a].first>lr[b].first||lr[a].second<lr[b].second){
                res=(res*bin_pow(lr[b].second-lr[b].first+1LL, R-2LL))%R;
                lr[b].first=max(lr[b].first, lr[a].first);
                lr[b].second=min(lr[b].second, lr[a].second);
                res=(res*max(lr[b].second-lr[b].first+1LL, 0LL))%R;
            }
        }
    };
};

vector<ll> d;
vector<vector<ll>> g;

void set_d(ll v){
    for(ll &i:g[v]) {
        d[i]=d[v]+1;
        set_d(i);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n;
    cin>>n;
    vector<ll> p(n);
    p[0]=-1;
    for(ll i=1;i<n;++i) {
        cin>>p[i];
        --p[i];
    }
    vector<pair<ll, ll>> lr(n);
    for(auto &i:lr) cin>>i.first>>i.second;
    for(auto &i:lr) res=(res*(i.second-i.first+1))%R;
    dsu dd=lr;
    d.resize(n);
    g.resize(n);
    for(ll i=1;i<p.size();++i) g[p[i]].pb(i);
    d[0]=0;
    set_d(0);
    ll m;
    cin>>m;
    vector<ll> p1, p2, l, r;
    while(m--){
        ll a, b;
        if(res==0){
            cin>>a>>b>>a>>b;
            cout<<"0\n";
            continue;
        }
        cin>>a>>b;
        --a;
        --b;
        while(d[a] < d[b]) {
            r.pb(b);
            b=p[b];
        }
        while(d[a]>d[b]) {
            l.pb(a);
            a=p[a];
        }
        while(a!=b){
            l.pb(a);
            r.pb(b);
            a=p[a];
            b=p[b];
        }
        l.pb(a);
        p1=l;
        reverse(all(r));
        p1.resize(p1.size()+r.size());
        copy(all(r), p1.begin()+(ll)l.size());
        l.clear();
        r.clear();
        cin>>a>>b;
        --a;
        --b;
        while(d[a] < d[b]) {
            r.pb(b);
            b=p[b];
        }
        while(d[a]>d[b]) {
            l.pb(a);
            a=p[a];
        }
        while(a!=b){
            l.pb(a);
            r.pb(b);
            a=p[a];
            b=p[b];
        }
        l.pb(a);
        p2=l;
        reverse(all(r));
        p2.resize(p2.size()+r.size());
        copy(all(r), p2.begin()+(ll)l.size());
        for(ll i=0;i<p1.size();++i) dd.merge(p1[i], p2[i]);
        cout<<res<<'\n';
        l.clear();
        r.clear();
    }
    return 0;
}
