#include <bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define po pop_back
#define dl(s) ll(s.size())
#define all(s) s.begin(), s.end()
#define int ll
typedef long long ll;
typedef long double ld;
using namespace std;

mt19937 rnd(228);

const int mod = 1e9 + 7;

vector <vector<int>> edge;
vector <int> tin, tout, pa, l, r, p;

int x = 0;

void dfs(int v) {
    tin[v] = x;
    x++;
    for (auto i : edge[v]) {
        dfs(i);
    }
    tout[v] = x;
    x++;
}

bool vi(int a, int b) {
    if (tin[a] <= tin[b] and tout[a] >= tout[b]) return true;
    return false;
}

int rod(int a) {
    if (p[a] == a) return a;
    return p[a] = rod(p[a]);
}

vector <int> t;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    edge.resize(n);
    pa.resize(n);
    tin.resize(n);
    tout.resize(n);
    l.resize(n);
    r.resize(n);
    p.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x;
        cin >> x;
        x--;
        edge[x].pb(i + 1);
        pa[i + 1] = x;
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    int na = 1;
    while (na < n) na *= 2;
    t.resize(na * 2 + 1, 1);
    for (int i = na; i < na + n; i++) t[i] = r[i - na] - l[i - na] + 1;
    for (int j = na - 1; j > -1; j--) t[j] = (t[j * 2] * t[j * 2 + 1]) % mod;
    for (int i = 0; i < n; i++) p[i] = i;
    int q;
    cin >> q;
    int fl = 0;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector <int> st1, st2;
        while (!vi(a, b)) {
            st1.pb(a);
            a = pa[a];
        }
        while (b != a) {
            st2.pb(b);
            b = pa[b];
        }
        st2.pb(b);
        reverse(st2.begin(), st2.end());
        vector <int> st3, st4;
        while (!vi(c, d)) {
            st3.pb(c);
            c = pa[c];
        }
        while (d != c) {
            st4.pb(d);
            d = pa[d];
        }
        st4.pb(d);
        reverse(st4.begin(), st4.end());
        for (auto j : st2) st1.pb(j);
        for (auto j : st4) st3.pb(j);
        for (int i = 0; i < dl(st1); i++) {
            int aa = rod(st1[i]);
            int bb = rod(st3[i]);
            if (aa == bb) continue;
            if (aa > bb) swap(aa, bb);
            p[bb] = aa;
            int x = na + bb;
            t[x] = 1;
            x /= 2;
            while (x != 0) t[x] = (t[x * 2] * t[x * 2 + 1]) % mod, x /= 2;
            x = na + aa;
            l[aa] = max(l[aa], l[bb]);
            r[aa] = min(r[aa], r[bb]);
            if (l[aa] > r[aa]) fl = 1;
            t[x] = max(0ll, r[aa] - l[aa] + 1);
            x /= 2;
            while (x != 0) t[x] = (t[x * 2] * t[x * 2 + 1]) % mod, x /= 2;
        }
        if (fl == 1) {
            cout << "0\n";
        } else {
            cout << t[1] << "\n";
        }
    }
}
