#include <bits/stdc++.h>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long

typedef unsigned long long ull;
typedef long double ld;

#define ff first
#define ss second

const int LG = 21;
const int MOD = 1e9 + 7;

int ans;
vector<int> pr;
vector< pair<int, int> > pta, ptb;
vector<int> tin, tout;
vector< pair<int, int> > p;
vector<vector<int> > g, up;

void init(int n) {
    tin.resize(n);
    tout.resize(n);
    p.resize(n);
    pr.resize(n);
    g.resize(n);
    up.resize(LG, vector<int>(n));
}

void precalc(int w, int wp) {
    up[0][w] = wp;
    for (int i = 1; i < LG; i++) {
        up[i][w] = up[i - 1][up[i - 1][w]];
    }
    for (auto &i : g[w])
        precalc(i, w);
}

bool isa(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b) {
    if (isa(a, b))
        return a;
    if (isa(b, a))
        return b;
    for (int i = LG - 1; i >= 0; i--) {
        if (!isa(up[i][a], b))
            a = up[i][a];
    }
    return up[0][a];
}

void go_upa(int a, int la) {
    while (a != la) {
        pta.push_back(p[a]);
        a = pr[a];
    }
}

void go_upb(int a, int la) {
    while (a != la) {
        ptb.push_back(p[a]);
        a = pr[a];
    }
}

void solve() {
    int n;
    cin >> n;
    init(n);
    for (int i = 1; i < n; i++) {
        int k;
        cin >> k;
        k--;
        pr[i] = k;
        g[k].push_back(i);
    }
//    for (auto &i : pr)
//        cout << i << ' ';
//    cout << endl;
    for (auto &[l, r] : p) {
        cin >> l >> r;
//        cout << l << ' ' << r << endl;
    }
    precalc(0, 0);
    int q;
    cin >> q;
    for (; q; --q) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        int lab = lca(a, b);
        int lcd = lca(c, d);
        cout << lab << ' ' << lcd << endl;
        ans = 1;
        pta.clear();
        ptb.clear();
        go_upa(a, lab);
        pta.push_back(p[lab]);
        go_upa(b, lab);
        go_upb(c, lcd);
        ptb.push_back(p[lcd]);
        go_upb(d, lcd);
//        for (auto &i : pta)
//            cout << i.ff << ' ' << i.ss << endl;
//        cout << endl;
//        for (auto &i : ptb)
//            cout << i.ff << ' ' << i.ss << endl;
//        cout << endl;
        assert((int)pta.size() == (int)ptb.size());
        for (int i = 0; i < (int)pta.size(); i++) {
            int l = max(pta[i].ff, ptb[i].ff);
            int r = min(pta[i].ss, ptb[i].ss);
            cout << "%" << l << ' ' << r << endl;
            (ans *= max(0ll, r - l + 1)) %= MOD;
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
//    cin >> _;
    for (; _; --_) {
        solve();
    }
    return 0;
}