#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

vector <vector <int> > graph;
vector <bool> used;

void dfs(int v, vector <int> & a) {
    used[v] = 1;
    a.push_back(v);
    for (int i = 0; i < graph[v].size(); ++i) {
        if (!used[graph[v][i]]) {
            dfs(graph[v][i], a);
        }
    }
}

const int mod = 1000000007;

signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    graph.resize(n);
    used.resize(n);
    vector <int> p(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> p[i];
    }
    vector <int> l(n);
    vector <int> r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    int m;
    cin >> m;
    while(m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        if (a < b && c < d) {
            for (int i = 0; i <= b - a; ++i) {
                graph[a + i].push_back(c + i);
                graph[c + i].push_back(a + i);
            }
        }
        if (a > b && c < d) {
            for (int i = 0; i <= a - b; ++i) {
                graph[a - i].push_back(c + i);
                graph[c + i].push_back(a - i);
            }
        }
        if (a < b && c > d) {
            for (int i = 0; i <= b - a; ++i) {
                graph[a + i].push_back(c - i);
                graph[c - i].push_back(a + i);
            }
        }
        if (a > b && c > d) {
            for (int i = 0; i <= a - b; ++i) {
                graph[a - i].push_back(c - i);
                graph[c - i].push_back(a - i);
            }
        }

        int ans = 1;

        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                vector <int> a;
                dfs(i, a);
                int ml = 0, mr = 1e9;
                for (int i = 0; i < a.size(); ++i) {
                    ml = max(ml, l[a[i]]);
                    mr = min(mr, r[a[i]]);
                }
                if (mr < ml)
                    ans = 0;
                else {
                    ans = (ans * (mr - ml + 1)) % mod;
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            used[i] = 0;
        }
        cout << ans << endl;
    }
}
