#include <bits/stdc++.h>
using namespace std;

int ans = 1, del, mod = 1e9 + 7, p[200100], pr[200100], h[200100], l[200100], r[200100];
vector<vector<int> > d(200100);

int poww(int a, int p) {
    int k = 1;
    while (p) {
        if (p % 2) {
            k = 1ll * k * a % mod;
        }
        a = 1ll * a * a % mod;
        p /= 2;
    }
    return k;
}

void dfs(int v, int pr = -1, int hh = 0) {
    h[v] = hh;
    for (auto j : d[v]) {
        if (j != pr) {
            dfs(j, v, hh + 1);
        }
    }
}

int get_pr(int v) {
    if (p[v] == v) {
        return v;
    }
    return p[v] = get_pr(p[v]);
}

void add(int u, int v) {
    u = get_pr(u);
    v = get_pr(v);
    if (u == v) {
        return;
    }
    del = 1ll * del * (r[u] - l[u] + 1) % mod;
    del = 1ll * del * (r[v] - l[v] + 1) % mod;
    l[u] = max(l[u], l[v]);
    r[u] = min(r[u], r[v]);
    ans = 1ll * ans * (r[u] - l[u] + 1) % mod;
    p[v] = u;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, k, mod = 1e9 + 7;

    cin >> n;
    pr[0] = -1;
    p[0] = 0;
    for (int i = 1; i < n; i++) {
        p[i] = i;
        cin >> pr[i];
        pr[i]--;
        d[i].push_back(pr[i]);
        d[pr[i]].push_back(i);
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        ans = 1ll * ans * (r[i] - l[i] + 1) % mod;
    }

    cin >> m;
    while (m--) {
        int a, b, c, d;

        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        del = 1;
        vector<int> v1, v2;
        v1.push_back(a);
        while (a != b) {
            if (pr[b] == -1 || pr[a] != -1 && h[a] >= h[b]) {
                a = pr[a];
                v1.push_back(a);
            } else {
                v2.push_back(b);
                b = pr[b];
            }
        }
        for (int i = (int)v2.size() - 1; i >= 0; i--) {
            v1.push_back(v2[i]);
        }

        vector<int> v3, v4;
        v3.push_back(c);
        while (c != d) {
            if (pr[d] == -1 || pr[c] != -1 && h[c] >= h[d]) {
                c = pr[c];
                v3.push_back(c);
            } else {
                v4.push_back(d);
                d = pr[d];
            }
        }
        for (int i = (int)v4.size() - 1; i >= 0; i--) {
            v3.push_back(v4[i]);
        }
//        for (auto j : v1) {
//            cout << j << ' ';
//        }
//        cout << '\n';
//        for (auto j : v3) {
//            cout << j << ' ';
//        }
//        cout << '\n';

        for (int i = 0; i < (int)v1.size(); i++) {
            add(v1[i], v3[i]);
        }

//        int ans = 1;
//        for (int i = 0; i < n; i++) {
//            if (p[i] == i) {
////                cout << i + 1 << "   " << l[i] << ' ' << r[i] << '\n';
//                ans = 1ll * ans * max(0, r[i] - l[i] + 1) % mod;
//            }
//        }
//        cout << ans << ' ' << del << '\n';
        ans = 1ll * ans * poww(del, mod - 2) % mod;
        cout << ans << '\n';
    }

    return 0;
}
