#include <bits/stdc++.h>

using namespace std;

const long long mod = 1e9 + 7;
vector<long long> a;
vector<set<long long>> s;
vector<vector<long long>> c;

void solve(long long v) {
    for (long long i : c[v]) {
        solve(i);
        if (s[v].size() < s[i].size()) {
            set<long long> now = s[v];
            s[v] = s[i];
            s[v].merge(now);
        } else {
            set<long long> now = s[i];
            s[v].merge(now);
        }
        s[v].insert(i);
    }
}

long long next(long long v, long long u) {
    if (s[v].find(u) == s[v].end()) {
        return a[v - 1] - 1;
    }
    for (long long i : c[v]) {
        if (s[i].find(u) != s[i].end() || i == u) {
            return i;
        }
    }
    return -100;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n, m;
    cin >> n;
    a.resize(n - 1);
    vector<long long> par(n, -1);
    c.resize(n);
    s.resize(n);
    for (long long i = 0; i < n - 1; i++) {
        cin >> a[i];
        c[a[i] - 1].push_back(i + 1);
    }
    vector<pair<long long, long long>> b(n);
    for (long long i = 0; i < n; i++) {
        cin >> b[i].first >> b[i].second;
    }
    cin >> m;
    if (n <= 300 && m <= 300) {
        solve(0);
        long long ans = 1;
        for (long long i = 0; i < m; i++) {
            long long u1, v1, u2, v2;
            cin >> u1 >> v1 >> u2 >> v2;
            u1--, v1--, u2--, v2--;
            if (ans == 0) {
                cout << 0 << endl;
                continue;
            }
            ans = 1;
            if (v1 < u1) {
                swap(u1, v1);
                swap(u2, v2);
            }
            long long prev1= -1, prev2 = -1;
            long long now1 = u1, now2 = u2;
            while (prev1 != v1) {
                prev1 = now1, prev2 = now2;
                while (par[now1] != -1) {
                    now1 = par[now1];
                }
                while (par[now2] != -1) {
                    now2 = par[now2];
                }
                if (now1 < now2) {
                    par[now2] = now1;
                    b[now1].first = max(b[now1].first, b[now2].first);
                    b[now1].second = min(b[now1].second, b[now2].second);
                    if (b[now1].first > b[now1].second) {
                        cout << 0 << endl;
                        ans = 0;
                        break;
                    }
                } else if (now1 > now2) {
                    par[now1] = now2;
                    b[now2].first = max(b[now2].first, b[now1].first);
                    b[now2].second = min(b[now2].second, b[now1].second);
                    if (b[now2].first > b[now2].second) {
                        cout << 0 << endl;
                        ans = 0;
                        break;
                    }
                }
                if (prev1 != v1) now1 = next(prev1, v1), now2 = next(prev2, v2);
            }
            if (ans == 0) continue;
            for (long long j = 0; j < n; j++) {
                if (par[j] == -1) {
                    ans = (ans * (b[j].second - b[j].first + 1)) % mod;
                }
            }
            cout << ans << endl;
        }
    } else {
        long long ans = 1;
        for (long long i = 0; i < m; i++) {
            long long u1, v1, u2, v2;
            cin >> u1 >> v1 >> u2 >> v2;
            u1--, v1--, u2--, v2--;
            if (ans == 0) {
                cout << 0 << endl;
                continue;
            }
            ans = 1;
            if (v1 < u1) {
                swap(u1, v1);
                swap(u2, v2);
            }
            for (long long j = 0; j < v1 - u1 + 1; j++) {
                long long now1 = u1 + j, now2 = u2 + j;
                if (u2 > v2) now2 = u2 - j;
                while (par[now1] != -1) {
                    now1 = par[now1];
                }
                while (par[now2] != -1) {
                    now2 = par[now2];
                }
                if (now1 < now2) {
                    par[now2] = now1;
                    b[now1].first = max(b[now1].first, b[now2].first);
                    b[now1].second = min(b[now1].second, b[now2].second);
                    if (b[now1].first > b[now1].second) {
                        cout << 0 << endl;
                        ans = 0;
                        break;
                    }
                } else if (now1 > now2) {
                    par[now1] = now2;
                    b[now2].first = max(b[now2].first, b[now1].first);
                    b[now2].second = min(b[now2].second, b[now1].second);
                    if (b[now2].first > b[now2].second) {
                        cout << 0 << endl;
                        ans = 0;
                        break;
                    }
                }
            }
            if (ans == 0) continue;
            for (long long j = 0; j < n; j++) {
                if (par[j] == -1) {
                    ans = (ans * (b[j].second - b[j].first + 1)) % mod;
                }
            }
            cout << ans << endl;
        }
    }
}