#include<bits/stdc++.h>
#define MAXN 3007
using namespace std;

const long long inf=1e10,mod=1e9+7;

int n,m,a,b,c,d;
int parent[MAXN],dep[MAXN],li[MAXN],tim;
vector<int> v[MAXN],w[MAXN],ls,rs;
long long maxl,minr,ans,l[MAXN],r[MAXN];
int dsu[MAXN];

int root(int x){
    if(dsu[x]==x)return dsu[x];
    dsu[x]=root(dsu[x]);
    return dsu[x];
}

void dfs(int x,int dd){
    dep[x]=dd;
    for(int i=0;i<v[x].size();i++){
        dfs(v[x][i],dd+1);
    }
}

vector<int> path(int x,int y){
    vector<int> lp={},rp={};
    while(dep[x]>dep[y]){
        lp.push_back(x);
        x=parent[x];
    }
    while(dep[y]>dep[x]){
        rp.push_back(y);
        y=parent[y];
    }
    while(x!=y){
        lp.push_back(x);
        rp.push_back(y);
        x=parent[x];
        y=parent[y];
    }
    lp.push_back(x);
    while(!rp.empty()){
        if(lp.back()!=rp.back()){
            lp.push_back(rp.back());
        }
        rp.pop_back();
    }
    return lp;
}

void query(int a,int b,int c,int d){
    ls=path(a,b);
    rs=path(c,d);
    for(int i=0;i<ls.size();i++){
        if(root(ls[i])==root(rs[i]))continue;
        w[ls[i]].push_back(rs[i]);
        w[rs[i]].push_back(ls[i]);
        dsu[root(ls[i])]=root(rs[i]);
    }
}

void dfs2(int x){
    li[x]=tim;
    maxl=max(maxl,l[x]);
    minr=min(minr,r[x]);
    for(int i=0;i<w[x].size();i++){
        if(li[w[x][i]]==tim)continue;
        dfs2(w[x][i]);
    }
}

long long calc(){
    tim++; ans=1;
    for(int i=1;i<=n;i++){
        if(li[i]!=tim){
            minr=inf; maxl=-1;
            dfs2(i);
            ans*=max(minr-maxl+1,0LL);
            ans%=mod;
        }
    }
    return ans;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=2;i<=n;i++){
        cin>>parent[i];
        v[parent[i]].push_back(i);
    }
    dfs(1,1);

    for(int i=1;i<=n;i++){
        cin>>l[i]>>r[i];
        dsu[i]=i;
    }

    cin>>m;
    for(int i=1;i<=m;i++){
        cin>>a>>b>>c>>d;
        query(a,b,c,d);
        cout<<calc()<<"\n";
    }

    return 0;
}