#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

const long long inf=1e10,mod=1e9+7;

int n,m,a,b,c,d;
int parent[MAXN],dep[MAXN],li[MAXN],tim;
vector<int> v[MAXN],ls,rs;
long long ans,l[MAXN],r[MAXN],maxl[MAXN],minr[MAXN];
int dsu[MAXN];

int root(int x){
    if(dsu[x]==x)return dsu[x];
    dsu[x]=root(dsu[x]);
    return dsu[x];
}

void dfs(int x,int dd){
    dep[x]=dd;
    for(int i=0;i<v[x].size();i++){
        dfs(v[x][i],dd+1);
    }
}

vector<int> path(int x,int y){
    vector<int> lp={},rp={};
    while(dep[x]>dep[y]){
        lp.push_back(x);
        x=parent[x];
    }
    while(dep[y]>dep[x]){
        rp.push_back(y);
        y=parent[y];
    }
    while(x!=y){
        lp.push_back(x);
        rp.push_back(y);
        x=parent[x];
        y=parent[y];
    }
    lp.push_back(x);
    while(!rp.empty()){
        if(lp.back()!=rp.back()){
            lp.push_back(rp.back());
        }
        rp.pop_back();
    }
    return lp;
}

void mergev(int x,int y){
    minr[y]=min(minr[y],minr[x]);
    maxl[y]=max(maxl[y],maxl[x]);
    dsu[x]=y;
}

long long cost(int x){
    return max(0LL,minr[x]-maxl[x]+1);
}

long long power(long long a,long long b){
    if(b==0)return 1;
    if(b==1)return a;
    if(b==2)return (a*a)%mod;
    if(b%2==0)return power(power(a,b/2),2);
    return (power(power(a,b/2),2)*a)%mod;
}

void query(int a,int b,int c,int d){
    ls=path(a,b);
    rs=path(c,d);
    for(int i=0;i<ls.size();i++){
        a=root(ls[i]); b=root(rs[i]);
        if(a==b)continue;
        ans*=power(cost(a),mod-2); ans%=mod;
        ans*=power(cost(b),mod-2); ans%=mod;
        mergev(a,b);
        ans*=cost(b); ans%=mod;
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=2;i<=n;i++){
        cin>>parent[i];
        v[parent[i]].push_back(i);
    }
    dfs(1,1);

    ans=1;
    for(int i=1;i<=n;i++){
        cin>>l[i]>>r[i];
        dsu[i]=i;
        maxl[i]=l[i]; minr[i]=r[i];
        ans*=(r[i]-l[i]+1);
        ans%=mod;
    }

    cin>>m;
    for(int i=1;i<=m;i++){
        cin>>a>>b>>c>>d;
        query(a,b,c,d);
        cout<<ans<<"\n";
    }

    return 0;
}