#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

const int maxN = 1e2;

using ld = long double;
using ll = long long;

int test = 1, n, k, a[maxN];
ld ans;

void calc(int i, ld cur, ll temp) {
    if (temp >= k) {
        ans = max(ans, cur * k);
        return;
    }
    if (i == n)
        return;
    for (int j = 1; j <= a[i] && temp * (j - 1) < k && cur * ((ld)(a[i] / j) / a[i]) * k >= ans; j++)
        calc(i + 1, cur * ((ld)(a[i] / j) / a[i]), 1LL * temp * j);
}

void solve() {
    cin >> n >> k;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    ans = 0;
    calc(0, 1, 1);
    printf("%.20Lf\n", ans);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> test;
#endif
    while (test--)
        solve();
    return 0;
}
