#define _GLIBCXX_DEBUG

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <cassert>
#include <functional>
#include <set>
#include <algorithm>
#include <map>
#include <random>
#include <chrono>

using namespace std;

int main(){
    int n;
    cin >> n;
    uint64_t k;
    cin >> k;
    vector<uint64_t> arr(n);
    for (int i = 0; i < n; i++){
        cin >> arr[i];
    }
    sort(arr.begin(), arr.end());
    double ans = 0;
    double scs = 1;
//    uint64_t scs_in_min_start = 1;
    for (int i = 0; i < n; i++){
        scs /= static_cast<double>(arr[i]);
//        scs_in_min_start *= arr[i];
    }
    if (n == 1){
        if (k <= arr[0]){
            uint64_t p = arr[0] / k;
            ans = scs * p;
        }
    } else if (n == 2){
        for (uint64_t d1 = 1; d1 <= arr[0]; d1++){
            uint64_t min_req_d2 = k / d1 + ((k % d1) ? 1 : 0);
            if (min_req_d2 <= arr[1]){
                ans = max(ans, scs * static_cast<double>(arr[0] / d1) * static_cast<double>(arr[1] / min_req_d2));
            }
        }
    }
    printf("%.30f\n", ans * static_cast<double>(k));
}
