#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define pii pair<int, int>
#define pll pair<long long, long long>
#define all(v) v.begin(),v.end()

const ll mod = 1000000007;

ld dp[5000000] = {0}, newdp[5000000] = {0};
int a[1000];

void solve(){
    int n, k;
    cin >> n >> k;
    dp[1] = 1;
    for(int i = 0; i < n; i++) cin >> a[i];
    for(int i = 0; i < n; i++){
        int pr = -1;
        for(int j = a[i]; j >= 1; j--){
            int cc = a[i] / j;
            if(pr == cc) continue;
            for(int jj = 1; jj <= k; jj++){
                //cout << i << ' ' << j << ' ' << cc << ' ' << jj << ' ' << dp[jj] << ' ' << std::fixed << setprecision(10) << dp[jj] * (ld)(cc) << '\n';
                newdp[min(k, j * jj)] = max(dp[jj] * (ld)(cc), newdp[min(k, j * jj)]);
            }
            pr = cc;
        }
        for(int j = 1; j <= k; j++) dp[j] = newdp[j];
    }
    ld ans = dp[k];
    for(int i = 0; i < n; i++) ans = ans / (ld)(a[i]);
    ans = ans * (ld)(k);
    cout << std::fixed << setprecision(10) << ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int tt;
    tt = 1;
    while(tt--){
        solve();
        #ifdef LOCAL
            cout << "________________________________________\n";
        #endif // LOCAL
    }
    #ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec\n";
    #endif // LOCAL
    return 0;
}

