#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<queue>
#include<deque>
#include<stack>
#include<string>
#include<cmath>
#include<climits>
#include<random>
#include<bitset>
#include<ctime>

#define ft first
#define sd second
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

const ld inf = -1;

vector<vector<int>> to_check(0);
const int maxA = 2e3 + 2;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    ld k;
    cin >> n >> k;
    to_check.resize(maxA);
    for (int i = 1; i < maxA; i++) {
        set<int> s1;
        for (int j = 1; j < i; j++) {
            s1.insert((i + j - 1) / j);
        }
        for (auto k1 : s1) {
            to_check[i].pb(k1);
        }
    }
    if (n == 1) {
        ld a;
        cin >> a;
        cout.precision(16);
        cout << ld(ld(ll(a) / ll(k)) * k / a) << endl;
        return 0;
    }
    if (n == 2) {
        ld a1, a2;
        cin >> a1 >> a2;
        ld ans = 0;
        for (ll i = 1; i <= ll(k); i++) {
            ll ot = (ll(k) + ll(i) - 1ll) / ll(i);
            ld ans_now = ll(ll(a1) / i) * ll(ll(a2) / ot) * k;
            ans_now /= a1;
            ans_now /= a2;
            ans = max(ans, ans_now);
        }
        cout.precision(20);
        cout << ans << '\n';
        return 0;
    }
    ld dp[n + 1][ll(k) + 1];
    for (int i = 0; i <= ll(k); i++) {
        dp[0][i] = 0;
    }
    dp[0][1] = 1;
    int a[n];
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= ll(k); j++) {
            dp[i][j] = dp[i - 1][j];
            for (auto w : to_check[a[j]]) {
                int need = (j + w - 1) / w;
                if (need > j) {
                    break;
                }
                if (w > j)
                    break;
                dp[i][j] = max(dp[i][j], dp[i - 1][need] * ld(a[i - 1] / w) / ld(a[i - 1]));
            }
        }
    }
    cout.precision(20);
    cout << dp[n][ll(k)] * ld(k) << '\n';

    return 0;
}