//#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <random>
#include <chrono>
#include <set>
#include <map>

#define all(a) a.begin(), a.end()
#define forall(iiii, aaaa) for(auto& iiii: aaaa)
#define print(aaaa) forall(aaa, aaaa) cout << aaa << ' '; cout << '\n'

typedef long long ll;
typedef long double ld;

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll mod = 1e9+7;

ll bin_pow(ll n, ll p) {
    if (p == 0) return 1;
    if (p & 1) return n * bin_pow(n, p - 1) % mod;
    return bin_pow(n * n % mod, p / 2);
}

ll gcd(ll a, ll b) {
    while (b %= a) swap(a, b);
    return a;
}

void solve() {
    ll n, k, N = 1e5;
    cin >> n >> k;
    if (n == 1) {
        ll x;
        cin >> x;
        cout << ld(x / k) / x;
        return;
    }
    if (n == 2) {
        ll x, y;
        cin >> x >> y;
        ld ans = 0;
        for (ll i = 1; i <= k; i++) {
            ans = max(ans, (ld(x / i) / x) * (ld(y / i) / y));
        }
        cout << ans * k;
        return;
    }
    vector < ll > a(n);
    forall(i, a) cin >> i;
    vector < vector < ld >> dp(n, vector < ld > (k + 1, 0));
//    cout << dp[0][0] << endl;
    for (ll i = 1; i <= min(k, a[0]); i++) {
        dp[0][i] = (ld) (a[0] / i) / a[0];
    }
    for (ll i = 1; i < n; i++) {
        for (ll j = 1; j <= k; j++) {
            for (ll x = 1; x <= a[i]; x++) {
                dp[i][j] = max(dp[i][j], dp[i - 1][(j + x - 1) / x] * (ld)(a[i] / x) / a[i]);
            }
        }
    }

//    forall(i, dp) {print(i);}
    cout << dp[n - 1][k] * k << endl;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    cout << fixed << setprecision(12);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
