#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cmath>
#include <chrono>
#include <ctime>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <limits>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <fstream>
#include <functional>
#include <random>
#include <cassert>
using namespace std;

typedef long long ll;
typedef double ld;

#define ff first
#define ss second

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 107;
const ll K = 40007;
ll n, m, k;
ld dp[N][K];
ll a[N];
vector<int>divs[K];

int find_next(int cur, int x) {
	int l = cur + 1, r = x;
	int target = (x + cur - 1) / cur - 1;
	while (l < r) {
		int mid = (l + r) / 2;
		if ((x + mid - 1) / mid > target) {
			l = mid + 1;
		}
		else {
			r = mid;
		}
	}
	return l;
}

void precalc() {
	for (int x = 1; x <= k; x++) {
		//cout << x << ": ";
		int cur = 1;
		divs[x].push_back(cur);
		while ((x + cur - 1) / cur > 1) {
			cur = find_next(cur, x);
			divs[x].push_back(cur);
			//cout << cur << ", "
			//	<< (x + cur - 1) / cur << "; ";
		}
		//cout << endl;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> k;
	precalc();
	ld bj = 1;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		bj *= (1.0l / ld(a[i]));
	}
	dp[0][1] = k * bj;
	ld ans = 0;
	for (int i = 1; i <= n; i++) {
		for (int x = 1; x <= k; x++) {
			//cout << i << ", " << x << ": ";
			for (int y : divs[x]) {
				dp[i][x] = max(dp[i][x], dp[i - 1][(x + y - 1) / y] * (a[i] / y));
				//cout << y << ": " << dp[i - 1][(x + y - 1) / y] * (a[i] / y) << "; ";
			}
			//cout << dp[i][x] << "\n";
		}
		//cout << endl;
	}
	cout << setprecision(15) << fixed;
	cout << dp[n][k] << endl;
}
