#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3")

#include <bits/stdc++.h>

//#define int long long
#define double long double
#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define INF (int) 1e18 / 2

using namespace std;

mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int &i: a)
        cin >> i;
    vector<vector<int>> b(n);
    for (int i = 0; i < n; i++) {
        int x = a[i];
        for (int j = x; j; j--)
            if (b[i].empty() or x / b[i].back() != x / j) b[i].push_back(j);
        reverse(all(b[i]));
    }
    vector<double> dp(k + 1);
    dp[1] = 1;
    for (int i = 0; i < n; i++) {
        vector<double> ndp = dp;
        for (int l = 1; l <= k; l++) {
            for (int j: b[i]) {
                int u = min(k, l * j);
                ndp[u] = max(ndp[u], a[i] / j * dp[l] / a[i]);
                if (u == k) break;
            }
        }
        dp = ndp;
        for (int j = k; j > 1; j--)
            dp[j - 1] = max(dp[j - 1], dp[j]);
    }
    cout << dp[k] * k << '\n';
}

int32_t main() {
    ios::sync_with_stdio(NULL);
    cin.tie(0), cout.tie(0);
    cout << fixed << setprecision(12);

    solve();
}
