#include <bits/stdc++.h>
//#include <ext/pd_ds/assoc_container.hpp>
//#include <ext/pd_ds/tree_policy.hpp>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size();
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
//#define int long long

typedef int64_t ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
ostream& operator << (ostream& out, pair<T, T1> &pr) {
    out << pr.first << " " << pr.second;
    return out;
}

template<typename T, typename T1>
istream& operator >> (istream& in, pair<T, T1> &pr) {
    in >> pr.first >> pr.second;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &arr) {
    for (auto &i : arr) {out << i << " ";}
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &arr) {
    for (auto &i : arr) {in >> i;}
    return in;
}

//typedef tree<int, null_type, less<int>,
//        rb_tree_tag, tree_order_statistics_node> ordered_set;

const int maxk = 2e4;

int n, k;
vector<int> s;
vector<vector<int>> mn;

int dp[101][maxk];

void solve() {
    cin >> n >> k;
    s.rs(n); cin >> s;

    for (int i = 1; i <= max(s[0], k); i++) {
        dp[0][i] = s[0] / i;
        //cout << i << " " << s[0] / i << "\n";
    }
    //cout << "\n";

    for (int i = 1; i < n; i++) {
        for (int j = 0; j < maxk; j++) {
            for (int l = 1; l * l <= j; l++) {
                if (j % l == 0) {
                    //cout << j << " " << l << "\n";
                    dp[i][j] = max(dp[i][j], dp[i - 1][j / l] * (s[i] / l));
                    dp[i][j] = max(dp[i][j], dp[i - 1][l] * (s[i] / (j / l)));
                }
            }
        }
    }

    int ans = 0;
    for (int i = k; i < maxk; i++) {
        ans = max(ans, dp[n - 1][i]);
    }
//    if (ans == 0) {
//        cout << 0 << "\n";
//        return;
//    }
    ans *= k;
    //cout << ans << "\n";

    double ot = ans;
    for (int i = 0; i < n; i++) {
        ot /= s[i];
    }
    //cout << ot * 0.72 << "\n";
    cout << setprecision(50) << fixed << ot << "\n";
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double start_time = clock();
#endif
    int test = 1;
    //cin >> test;

    while (test--) {
        solve();
#ifdef LOCAL
        cout << "--------------\n";
#endif
    }
#ifdef LOCAL
    cout << "execution time: " << (clock() - start_time) / CLOCKS_PER_SEC;
#endif
}
