#include <bits/stdc++.h>

#define int long long
#define double long double

using namespace std;

const int MOD = 1e9 + 7;

double calc(vector<int> &a, vector<int> &b, int k) {
    int n = (int)a.size(), res = 1;
    for (int i = 0; i < n; i++) {
        res *= (a[i] / b[i]);
    }
    int under = 1;
    for (int i : a)
        under *= i;
    return (double)(res * k) / under;
}

inline void solve1(int n) {
    int k;
    cin >> k;
    vector<int> a(n), b(n);
    double max_res = 0;
    for (int &i : a)
        cin >> i;
    if (n == 1) {
        cout << setprecision(10) << (double)((a[0] / k) * k) / a[0] << "\n";
    } else {
        for (int i = 1; i <= k; i++) {
            b[0] = i;
            b[1] = (k + i - 1) / i;
            max_res = max(max_res, calc(a, b, k));
        }
        cout << setprecision(10) << max_res << "\n";
    };
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(10);
    int n;
    cin >> n;
    if (n <= 2) {
        solve1(n);
        return 0;
    }
}