#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>

#define int long long

void A1() {
    int n, k, max_k = 1;
    std::cin >> n >> k;
    std::vector<int> mas(n);
    for (int i = 0; i < n; ++i) {
        int tmp;
        std::cin >> tmp;
        mas[i] = tmp;
        max_k *= tmp;
    }
    if (max_k < k) {
        std::cout << 0;
        return;
    }

    if (mas.size() == 1) {
        std::cout << 1 - (mas[0] % k) / (long double)mas[0];
        return;
    }

    if (mas.size() > 2) {
        std::cout << 0;
        return;
    }

    std::sort(mas.begin(), mas.end());
    long double res = 0;
    for (int i = 1; i <= mas[0]; ++i) {
        for (int j = 1; j <= mas[1]; ++j) {
            if ((mas[0] / i) * (mas[1] / j) < k) {
                continue;
            }
            res = std::max((i * j * k / (long double)mas[0] / (long double)mas[1]), res);
        }
    }
    std::cout << std::setprecision(20);
    std::cout << res;

}


signed main() {
    std::ios_base::sync_with_stdio();
    std::cin.tie();
    std::cout.tie();

    A1();

    return 0;
}
