#ifndef LOCAL
#   include <bits/stdc++.h>
#   include <ext/pb_ds/assoc_container.hpp>
#   define debug(...)
#endif
typedef long double ld;
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    static clock_t START = clock();
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    ld ans = 0;
    for (int x = k; 1.l * (clock() - START) / CLOCKS_PER_SEC < 1.9; x++) {
        vector<int> d;
        for (int y = 1; y * y <= x; y++) {
            if (x % y == 0) {
                d.push_back(y);
            }
        }
        for (int i = (int)d.size() - 1; i >= 0; i--) {
            int y = d[i];
            if (y * y != x) {
                d.push_back(x / y);
            }
        }
        map<int, int> num;
        for (int i = 0; i < (int)d.size(); i++) {
            num[d[i]] = i;
        }

        vector<vector<ld>> dp(n, vector<ld>(d.size()));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < (int) d.size(); j++) {
                if (a[i] < d[j]) continue;
                dp[i][j] = max(dp[i][j], 1.l * (a[i] / d[j]) / a[i]);
                if (i != 0) {
                    for (int w = 0; w < (int)d.size(); w++) {
                        if (x % (d[w] * d[j]) == 0) {
                            dp[i][num[d[w] * d[j]]] = max(dp[i][num[d[w] * d[j]]], dp[i - 1][w] * (a[i] / d[j]) / a[i]);
                        }
                    }
                }
            }
        }
        ans = max(ans, dp[n - 1][(int)d.size() - 1] * k);
    }
    cout << setprecision(12) << fixed;
    cout << ans << "\n";
    return 0;
}
