#include <iostream>
#include <vector> 
#include <algorithm> 
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()
#define pb push_back
typedef long long ll;

const ll K = 5e4 + 1;

int main() {
    ll n, k; cin >> n >> k;
    vector<ll> a(n); 
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(all(a));
    vector<vector<ll> > dp(n, vector<ll> (K));
    for (int i = 1; i <= min(K - 1, a[0]); i++) {
        dp[0][i] = a[0] / i; 
    }
    vector<vector<ll> > d(K);
    for (ll i = 1; i < K; i++) {
        for (ll j = 1; j * j <= i; j++) {
            if (i % j == 0) {
                d[i].pb(j);
                if (j * j != i) d[i].pb(i / j);
            }
        }
    } 
    for (int i = 1; i < n; i++) {
        for (ll p = 1; p < K; p++) {
            for (auto q : d[p]) {
                ll b = p / q;
                if (b <= a[i]) dp[i][p] = max(dp[i][p], dp[i - 1][q] * (a[i] / b));
            }
        }
    }
    /*for (int i = 0; i < n; i++) {
        for (int j = 1; j <= k + 1; j++) {
            cout << dp[i][j] << " ";
        }
        cout << endl;
    }*/
    ll res = 0;
    for (int i = k; i < K; i++) res = max(res, dp[n - 1][i]);
    long double ans = res * k;
    for (int i = 0; i < n; i++) ans /= a[i];
    cout << setprecision(20) << fixed << ans;
    return 0;
}