#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
#define pb emplace_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;
typedef long double ld;
typedef pair<ld, ld> ptld;

void fastio(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,ssse3,sse3,sse4,sse4.1")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
*/

mt19937 rnd(31);

const int SQRTK = 1e4;
const int MAXN = 105;

vector<pt> vars[MAXN];
int a[MAXN];

vector<pt> precalc(int x){
    vector<pt> res;
    for (ll i = 1; i * i <= x + 1; i++){
        int b = x / i;
        int nw = x / b;
        if (res.empty() || res.back().x != b)
            res.pb(b, nw);
    }
    for (ll b = (int)(sqrt(x) + 1); b >= 1; b--){
        int l = x / (b + 1) + 1, r = x / b;
        if (l <= r){
            int nw = x / b;
            if (res.empty() || res.back().x > b)
                res.pb(b, nw);
        }
    }
    reverse(all(res));
    return res;
}

void run(){
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; i++){
        int ai;
        cin >> ai;
        a[i] = ai;
        vars[i] = precalc(ai);
    }
    vector<pair<int, ld>> prv;
    prv.pb(k, k);
    vector<int> dels = {k};
    for (int i = 2; i <= k; i++){
        int nw = (k + i - 1) / i;
        if (dels.back() != nw)
            dels.push_back(nw);
    }
    reverse(all(dels));
    for (int i = 0; i < n; i++){
        vector<pair<int, ld>> nw;
        for (auto [r, val]: prv){
            if (val == 0)
                continue;
            for (auto [b, d]: vars[i]){
                ld curr = val * d / a[i];
                int r1 = (r + b - 1) / b;
                nw.pb(r1, curr);
            }
        }
        sort(all(nw));
        prv.clear();
        for (auto [x, y]: nw){
            if (prv.empty() || x != prv.back().x)
                prv.pb(x, y);
            else
                prv.back().y = y;
        }
    }
    cout << setprecision(20) << fixed;
    if (prv[0].x != 1){
        cout << 0 << '\n';
    } else
        cout << prv[0].y << '\n';
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
#ifdef LOCAL
    cerr << "\nProgram finished in " << (stop - start) / CLOCKS_PER_SEC << " sec\n";
#endif
    return 0;
}
