#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> a);
template<typename T>
ostream& operator << (ostream &out, set<T> a);
template<typename T>
ostream& operator << (ostream &out, vector<T> a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(21281337711);
const int N = 1e7 + 1;
ld dp[N], ndp[N];
void solve_case() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    vector<ld> dp(k + 1);
    dp[k] = k;
    for (int i = 0; i < n; i++) {
        if (a[i] == 1) continue;
        fill(ndp, ndp + k + 1, 0);
        for (int l = 1, r; l <= min(k, a[i]); l = r + 1) {
            r = a[i] / (a[i] / l);
            for (int was = r; was <= k; was += r) {
                chmax(ndp[(was + r - 1) / r], dp[was] / a[i] * (a[i] / r));
            }
            chmax(ndp[(k + r - 1) / r], dp[k] / a[i] * (a[i] / r));
        }
        for (int v = 1; v <= k; v++) dp[v] = max(ndp[v], dp[v - 1]);
    }
    cout << fixed << setprecision(10);
    cout << dp[1] << "\n";
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    //freopen("inputik.txt", "r", stdin);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve_case();
    }
    return 0;
}