#include <bits/stdc++.h>

using namespace std;

const int mod = 998244353;
#define int long long
#define ld long double

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int &i: a) cin >> i;
    vector<vector<int>> dp(n + 1, vector<int>(k + 1, -1e9));

    dp[0][1] = 1;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= k; ++j) {
            if (dp[i][j] == -1e9) continue;
            for (int b = 1; b <= a[i]; ++b) {
                long long u = min(1ll * k, 1ll * j * b);
                dp[i + 1][u] = max(dp[i + 1][u], dp[i][j] * (a[i] / b));
            }
        }
    }
    ld ans = dp[n][k];
    for (ld i: a) ans /= i;
    cout.precision(20);
    cout << ans * k;
}


signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}