#pragma clang diagnostic push
#pragma ide diagnostic ignored "bugprone-integer-division"
#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n, k;
    vector<in<int>> a;

    vector<vector<double>> dp;

    solve() : a(n) {
        if (n > 2) {
            dp.resize(n + 1, vector<double>(2 * k));
            dp[0][1] = k;
            for (int i = 0; i < n; ++i) {
                for (int ik = 1; ik < 2 * k; ++ik) {
                    for (int bi = 1; bi <= a[i] && bi * ik < 2 * k; ++bi) {
                        dp[i + 1][bi * ik] = max(dp[i + 1][bi * ik], dp[i][ik] * (double) (a[i] / bi) / a[i]);
                    }
                }
            }
            cout.precision(20);
            cout << *max_element(dp.back().begin() + k, dp.back().end()) << "\n";
        } else {
            long double res = 0;
            for (int b1 = 1; b1 <= a[0]; ++b1) {
                int b2 = (k + b1 - 1) / b1;
                if (b2 > a[1]) {
                    continue;
                }
                res = max(res, k * (long double) (a[0] / b1) * (long double) (a[1] / b2) / a[0] / a[1]);
            }
            cout.precision(20);
            cout << res << "\n";
        }
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t = 1;
    while (t--) {
        solve();
    }
}

#pragma clang diagnostic pop