#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef std::pair<int, int> pii;

#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define time_now chrono::high_resolution_clock::now()
#define time_res(s, f) chrono::duration_cast<chrono::milliseconds>(f - s).count()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define pb push_back
#define ff first
#define sc second
#define str string
#define file_in freopen("input.txt", "r", stdin);
#define file_out freopen("output.txt", "w", stdout);
#define all(a) a.begin(), a.end()
#define sz(a) (int)a.size()

using namespace std;
using namespace __gnu_pbds;

template<typename T, typename T1> istream& operator>>(istream& in, pair<T, T1> &a) { in >> a.ff >> a.sc; return in; }
template<typename T, typename T1> ostream& operator<<(ostream& out, pair<T, T1> a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream& in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream& out, vector<T> a) { for (auto el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937 gen(mt_seed); int randint(int l, int r) { uniform_int_distribution<> random(l, r); return random(gen); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const {return x ^ RANDOM; }};

int bin_s(int x, int a, int k) {
    int l = 0, r = a;
    while (r > l + 1) {
        int m = (l + r) >> 1;
        if (1ll * x * m >= k) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}

int main() {
    fast
//    file_in

    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    cin >> a;

    if (n == 1 && a[0] < k || n == 2 && 1ll * a[0] * a[1] < k) { cout << 0; return 0; }

    if (n == 1) {
        for (int b = 1; b <= a[0]; ++b) {
            if (b >= k) {
                cout << fixed << setprecision(15) << (ld)(a[0] / b) / ld(a[0]) * k;
                return 0;
            }
        }
    } else {
        ll ans = 0;
        for (int b = 1; b <= a[0]; ++b) {
            if (1ll * b * a[1] >= k) {
                ans = max(ans, 1ll * (a[0] / b) * (a[1] / bin_s(b, a[1], k)));
            }
        }
        cout << fixed << setprecision(15) << ld(1ll * ans * k) / ld(1ll * a[0] * a[1]);
    }
    return 0;
}
