#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout << fixed << setprecision(20);
  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (int& x : a) cin >> x;
  bool ok = false;
  ll aux = 1;
  for (int x : a) {
    aux *= x;
    if (aux >= k) {
      ok = true;
      break;
    }
  }
  if (!ok) {
    cout << 0;
    return 0;
  }
  if (n == 1) {
    int val = a[0] / k;
    cout << ld(val * k) / a[0];
    return 0;
  }
  if (n == 2) {
    ld ans = 0;
    for (int b0 = 1; b0 <= a[0]; ++b0) {
      int b1 = (k + b0 - 1) / b0;
      ll val1 = a[0] / b0, val2 = a[1] / b1;
      ans = max(ans, ld(val1 * val2 * k) / a[0] / a[1]);
    }
    cout << ans;
    return 0;
  }
  ld coeff = k;
  for (int x : a) coeff /= x;
  vector<ld> dp(2 * k + 1);
  for (int b0 = 1; b0 <= min(k, a[0]); ++b0) {
    dp[b0] = (a[0] / b0) * coeff;
  }
  for (int i = 1; i < n; ++i) {
    vector<ld> ndp(2 * k + 1);
    for (int bi = 1; bi <= min(k, a[i]); ++bi) {
      for (int pr = 1; bi * pr <= 2 * k; ++pr) {
        ndp[pr * bi] = max(ndp[pr * bi], dp[pr] * (a[i] / bi));
      }
    }
    swap(dp, ndp);
  }
  ld ans = 0;
  for (int mul = k; mul <= 2 * k; ++mul) ans = max(ans, dp[mul]);
  cout << ans;
  return 0;
}