#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 2E5, sq = 447;
constexpr uint64_t MOD = 1E9 + 7;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	uint32_t ans;
	Mod_int(uint64_t ans = 0) :ans(ans% MOD) {}
	Mod_int operator* (const Mod_int& m) const
	{
		return uint64_t(ans) * m.ans;
	}
	Mod_int operator*= (const Mod_int& m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			t *= t;
			step >>= 1;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int& m) const
	{
		return *this * m.step(MOD - 2);
	}
	Mod_int operator/= (const Mod_int& m)
	{
		return *this = *this / m;
	}
};

long double min_sz[4001], min_sz_new[4001];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	int n, k;
	cin >> n >> k;

	if (n <= 2)
	{
		if (n==1)
		{
			int f;
			cin >> f;
			if (f < k)
			{
				cout << 0;
			}
			else
				cout << long double(f / k) / f * k;
		}
		else
		{
			int f, s;
			cin >> f >> s;
			long double ans = 0;
			for (int i = 1; i <= f; i++)
			{
				int p2 = (k + i - 1) / i;
				rmax(ans, (long double(f / i) / f) * (long double(s / p2) / s));
			}
			cout << ans * k;
		}

		exit(0);
	}

	min_sz[1] = 1;
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		for (int raz = 2; raz <= x; raz++)
		{
			for (int pred = 1; pred <= 2 * k / raz; pred++)
			{
				rmax(min_sz_new[pred * raz], min_sz[pred] * (x / raz) / x);
			}
		}

		for (int i = 0; i < 2 * k; i++)
		{
			rmax(min_sz[i], min_sz_new[i]);
			min_sz_new[i] = 0;
		}
	}

	long double answ = 0;
	for (int i = k; i <= 2 * k; i++)
	{
		rmax(answ, min_sz[i] * k);
	}
	cout << answ;
}