#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include<bits/stdc++.h>
#define int long long
#define double long double

using namespace std;

const double EPS = 1e-10;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (n == 2) {
        double ans = 0;
        for (int i = 1; i <= a[0]; ++i) {
            int need = (k + i - 1) / i;
            if (need > a[1]) continue;
            ans = max(ans, (int)(a[0] / i) * (int)(a[1] / need) * (double)(1.0 / a[0]) * (double)(1.0 / a[1]) * k);
        }
        cout << setprecision(12) << ans << '\n';
        return 0;
    }
    if (n == 1) {
        if (a[0] < k) {
            cout << 0 << '\n';
        }
        else {
            cout << setprecision(12) << (int)(a[0] / k) * (double)(1.0 / a[0]) * k << '\n';
        }
        return 0;
    }
    vector<vector<double>> dp(n, vector<double> (k + 1));
    for (int i = 1; i <= min(k, a[0]); ++i) {
        dp[0][i] = (int)(a[0] / i);
        dp[0][i] *= (double)(1.0 / a[0]);
        dp[0][i] *= k;
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j <= k; ++j) {
            if (abs(dp[i - 1][j]) < EPS) break;
            for (int ai = 1; ai <= a[i]; ++ai) {
                dp[i][min(k, ai * j)] = max(dp[i][min(k, ai * j)], dp[i - 1][j] * (int)(a[i] / ai) * (double)(1.0 / a[i]));
                if (j * ai >= k) break;
            }
        }
    }
    cout << setprecision(12) << dp[n - 1][k] << '\n';
}
