#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define pb push_back
#define ff first
#define ss second
#define err(x) cerr << "[" << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[" << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "[" << ""#x"" << "] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}
using ll = long long;
using ld = double;

using namespace std;

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}

mt19937 rnd(::std::chrono::high_resolution_clock::now().time_since_epoch().count());
const int MOD = 1e9 + 7;

/// actual code starts here

const int N = 101, K = 1e7 + 5;

ld dp[2][K];
vector<pair<int, ld>> w[N]; // give b, give a / b
int a[N];
int n, k;
const ld inf = 1000000;

void split(int x, int id) {
    for (int i = 1; i <= x;) {
        int ans = x / (x / i);
        w[id].pb({ans, log(x / ans)});
        i = ans + 1;
    }
    int l = 0, r = 50, l2 = (int) w[id].size() - 50, r2 = (int) w[id].size() - 1;
    vector<pair<int, ld>> w2;
    for (int i = 0; i < w[id].size(); i++) {
        if (i >= l && i <= r) {
            w2.pb(w[id][i]);
        } else if (i >= l2 && i <= r2) {
            w2.pb(w[id][i]);
        }
    }
    w[id].swap(w2);
}


void solve() {
    cin >> n >> k;
    int t = 1;
    ld mult = 0;
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        if (x != 1) {
            a[t++] = x;
            mult += log(x);
        }
    }
    if (mult < log(k)) {
        cout << 0;
        return;
    }
    if (k == 1 && t == 1) {
        cout << 1;
        return;
    }
    n = t - 1;
    sort(a + 1, a + n + 1);
    for (int i = 1; i <= n; i++) {
        split(a[i], i);
    }
    for (int i = 0; i < 2; i++)
        for (int j = 0; j < K; j++)
            dp[i][j] = -inf;
    dp[0][1] = 0;
    ld res = 0;
    for (int i = 1; i <= n; i++) {
        int c = i & 1;
        int pt = k;
        ld mx = -inf;
        for (auto [b, d]: w[i]) {
            int mul = 1, last = b;
            int ri = k / b;
            for (; mul <= ri; mul++, last += b) {
                if (dp[c ^ 1][mul] != -inf) {
                    relaxma(dp[c][last], dp[c ^ 1][mul] + d);
                }
            }
            while (pt > 0 && mul <= pt) {
                relaxma(mx, dp[c ^ 1][pt]);
                pt--;
            }
            if (mul <= k) {
                relaxma(dp[c][k], mx + d);
            }
        }
    }
    res = dp[n & 1][k];
    ld cof = 0;
    for (int i = 1; i <= n; i++) cof -= log(a[i]);
    cof += log(k);
    res += cof;
    cout.precision(20);
    cout << fixed << exp(res);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) solve();
}