#include <iostream>
#include <vector>

#if !defined LOCAL && !defined DEBUG
#define USE_FAST_IO
#endif

#ifdef USE_FAST_IO
#define endl '\n'
#endif

using namespace std;
using ld = long double;

int main() {
#ifdef USE_FAST_IO
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, k; cin >> n >> k;
    vector<int> as(n);
    for (int &i : as) {
        cin >> i;
    }
    vector<ld> dp(k + 1, 0);
    dp[1] = 1;
    for (int &a : as) {
        vector<ld> new_dp(k + 1, 0);
        
        for (int v = a; v > 0; v = a / (a / v + 1)) {
            int z = a / v;
            for (int i = 0; (i - 1) * z <= k; i++) {
                int t = min(i * z, k);
                new_dp[t] = max(new_dp[t], dp[i] * ((ld) v / (ld) a)); 
            }
        }
        
        dp.swap(new_dp);
        for (int i = k - 1; i >= 0; i--) {
            dp[i] = max(dp[i], dp[i + 1]);
        }
    }
    cout.precision(20);
    cout << dp[k]  * k << endl;
}
