//#pragma GCC optimize("Ofast")
#pragma GCC target("avx")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <cstring>

using namespace std;
#define ld long double
#define ll long long
#define int long long

ll t[(int) 1e7 + 1];

int p[(int) 1e7 + 1];
vector<int> pr;
vector<int> arr;
vector<int> result;

void rec(int now, int x) {
    if (now >= arr.size()) {
        result.push_back(x);
        return;
    }
    int l = now;
    int mult = 1;
    for (int i = now; i < arr.size(); i++) {
        if (i == l) {
            mult = 1;
        }
        while (l < arr.size() && arr[l] == arr[i]) {
            l++;
        }
        mult *= arr[i];
        rec(l,  x * mult);
    }
}

vector<int> get(int x) {
    arr.resize(0);
    result.resize(0);
    while (x > 1) {
        arr.push_back(p[x]);
        x /= p[x];
    }
    sort(arr.begin(), arr.end());

    rec(0, 1);
    result.push_back(1);
    //sort(result.begin(), result.end()); // ???????????????????????????????????????????????
    return result;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    memset(p, 0, sizeof(p));
    for (int i = 2; i < (int) 1e7 + 1; i++) {
        if (p[i] == 0) {
            p[i] = i;
            pr.push_back(i);
        }
        for (int j = 0; j < pr.size() && pr[j] * i < (int) 1e7 + 1; j++) {
            p[pr[j] * i] = pr[j];
        }
    }


    int n, k;
    cin >> n >> k;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }

    //memset(t[0], {0, 0}, sizeof(t[0]));
    //memset(t[1], {0, 0}, sizeof(t[1]));
    fill(t, t + (int) 1e7 + 1, 0);

    t[1] = 1;
    ll ans = (ll) 0;
    for (int i = 0; i < n; i++) {
        //vector<int> now = get(v[i]);
        ll kth = t[k];
        for (int j = k; j > 0; j--) {
            if (t[j] == 0) {
                continue;
            }
            for (int b = 2; b * b <= v[i]; b++) {
                ll y = t[j];
                if (j == k) {
                    y = kth;
                }
                t[min(k, j * b)] = max(t[min(k, j * b)], y * ((ll) v[i] / b));
                /*if (j * b >= 2 * k) {
                    break;
                }*/
            }

            for (int x = 1; x * x <= v[i]; x++) {
                int b = v[i] / x;
                if (b == 1) {
                    continue;
                }
                if (v[i] / (b + 1) == x) {
                    int e = 0;
                    cout << 1 / e << endl;
                    return 1;
                }
                ll y = t[j];
                if (j == k) {
                    y = kth;
                }
                t[min(k, j * b)] = max(t[min(k, j * b)], y * ((ll) v[i] / b));
            }

            int b = 1;
            ll y = t[j];
            if (j == k) {
                y = kth;
            }
            t[min(k, j * b)] = max(t[min(k, j * b)], y * ((ll) v[i] / b));
        }
    }

    ans = max(ans, t[k]);

    if (ans == (ll) 0) {
        cout << 0 << endl;
        return 0;
    }

    cout.precision(10);
    cout.setf(ios::fixed);
    ll mult = 1;
    for (int el : v) {
        mult *= (ll) el;
    }
    cout << (ld) (ans * (ll) k) / (ld) mult << endl;
}
