#include "iostream"
#include "vector"
#include "algorithm"
#include "iomanip"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"

using namespace std;

#define ll long long
#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

const ld EPS = 1e-8;
const int MAXN = 100, MAXK = 40000;

ld dp[MAXN][MAXK + 1];
int a[MAXN];
int n, k;

bool eq(ld a1, ld b1) {
    return abs(a1 - b1) < EPS;
}

ld get(int i, int l) {
    //cout << i << " " << l << '\n';
    if (not eq(dp[i][l], -1)) return dp[i][l];
    int prev = -1;
    for (int j = min(k, a[i]); j >= 1; --j) {
        int x = a[i] / j;
        //if (x == prev) continue;
        dp[i][l] = max(dp[i][l], get(i - 1, (l + j - 1) / j) * (ld)x);
        prev = x;
    }
    return dp[i][l];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (n == 2) {
        ld ans = 0;
        for (int j = 1; j <= a[0] and j <= k; ++j) {
            int x = (k + j - 1) / j;
            ans = max(ans, (ld)(a[0] / j) * (ld)(a[1] / x));
        }
        ans /= (ld)a[0];
        ans /= (ld)a[1];
        ans *= k;
        cout << setprecision(20) << ans << '\n';
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= k; ++j) {
            dp[i][j] = -1;
        }
    }
    for (int i = 1; i <= k; ++i) {
        dp[0][i] = a[0] / i;
    }
    ld ans = get(n - 1, k);
    for (int i = 0; i < n; ++i) {
        ans /= (ld)a[i];
    }
    ans *= (ld)k;
    cout << setprecision(20) << ans << '\n';
}