#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())
#define pb push_back

using namespace std;

template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }

typedef pair <int, int> pii;

inline void solve () {
    int n, k; cin >> n >> k;
    vector <int> a (n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    vector <vector <double>> dp;
    int M;

    if (n <= 2) {
        M = 2e7 + 10;
        dp = vector <vector <double>> (n, vector <double> (M));
    }
    if (k <= 40000) {
        M = 80010;
        dp = vector <vector <double>> (n, vector <double> (M));
    }

    dp[0][1] = k;
    for (int i = 0; i < n; ++i) dp[0][1] /= a[i];

    for (int i = 0; i < n; ++i) {
        for (int b = 1; b <= a[i]; ++b) {
            for (int pr = 1; pr <= M; ++pr) {
                if (pr * b < M) umax(dp[i + 1][pr * b], dp[i][pr] * (int)(a[i] / b));
            }
        }
    }

    double ans = 0;
    for (int i = k; i < M; ++i) {
        umax(ans, dp[n][i]);
    }
    cout << fixed << setprecision(9) << ans << endl;
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t = 1; // cin >> t;
    while (t--) solve();
    return 0;
}
