#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <random>

#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

typedef long long ll;
typedef long double ld;

#define vec vector 
#define pii pair<ll, ll>
#define pll pair<ll, ll>

ll const mod = 1e9 + 7;
ll const INF = 2e9;
ll const LINF = 4e18;
ll const mod1 = 1000575179;

using namespace std;

#pragma warning(disable: 4996)



void solve() {
    ll n, k; cin >> n >> k;

    ll prod = 1;
    vec<ll> a(n);
    for (int i = 0; i < n; i++) {
         cin >> a[i];
        prod *= a[i];
    }

    if (prod < k) {
        cout << 0 << "\n";
        return;
    }

    if (n == 1) {
        if (a[0] < k) {
            cout << 0 << "\n";
            return;
        }
        cout << ((ld)k / a[0]) * k << "\n";
        return;
    }

    ll ans = 0;
    for (ll i = 1; i <= a[0]; i++) {
        ll j = (k + i - 1) / i;
        ans = max(ans, a[0] / i * (a[1] / j));
    }
    ld res = ans;
    for (int i = 0; i < n; i++) {
        res *= (ld)1 / (ld)a[i];
    }
    res *= k;
    cout << fixed << setprecision(20) << res  << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG

    int tests = 1;
    //cin >> tests;

    while (tests--) {
        solve();
    }
}