#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

void solve() {
    cout << fixed;
    cout.precision(20);

    int n, k;
    cin >> n >> k;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    if (n == 1) {
        if (a[0] >= k) {
            cout << (a[0] / k) * ((ld) 1.0 / a[0]) * k << "\n";
        } else {
            cout << 0 << "\n";
        }
    } else if (n == 2) {
        ld ans = 0;
        for (int b0 = 1; b0 <= min(a[0], k); ++b0) {
            int b1 = (k + b0 - 1) / b0;
            if (b1 > a[1]) continue;
            ans = max(ans, (a[0] / b0) * (a[1] / b1) * ((ld) 1.0 / a[0] / a[1]) * k);
        }
        cout << ans << "\n";
    } else {
        int z = 2 * k + 1;
        vector<vector<ld>> dp(n + 1, vector<ld>(z));
        dp[0][1] = 1;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < z; ++j) {
                for (int x = 1; x <= min(z, a[i]); ++x) {
                    if (j % x != 0) continue;

                    dp[i + 1][j] = max(dp[i + 1][j], (ld) dp[i][j / x] * (a[i] / x) / a[i]);
                }
            }
        }

        for (auto y : dp) {
            for (auto x : y) {
                cerr << x << " ";
            }
            cerr << "\n";
        }

        ld ans = dp[n][k];
        for (int j = k; j < z; ++j) {
            ans = max(ans, dp[n][j]);
        }
        cout << ans * k << "\n";
    }
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
