#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define int long long
#define pb push_back
#define ld long double

const int N = 1e7 + 1;
const int mod = 1e9 + 7;

struct froak {
    int a, b;
    froak () {
        a = b = 1;
    }
    froak (int x) {
        a = x;
        b = 1;
    }
    froak (int a, int b): a(a), b(b) {
        this->normalize();
    }
    void normalize () {
        int gc = __gcd(a, b);
        a /= gc; b /= gc;
    }
    froak operator * (froak other) {
        froak c;
        c.a = other.a * a;
        c.b = other.b * b;
        c.normalize();
        return c;
    }
    bool operator < (froak &other) {
        return a * other.b < b * other.a;
    }
    ld val () {
        return a / (ld)(b);
    }
};


froak dp[N][2];

template <class T>
bool chmax (T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}


void solve () {
    int n, k;
    cin >> n >> k;
    vc <int> a(n);
    for (int &i : a)
        cin >> i;
    if (n == 2) {
        ld ans = 0;
        for (int i = 1; i <= a[0]; ++i) {
            if (a[0] / i == a[0] / (i + 1))
                continue;
            int nd = (k + i - 1) / i;
            if (nd * i >= k) {
                chmax(ans, k * (a[0] / i) * (a[1] / nd) / (ld)(a[0] * a[1]));
            }
        }
        cout << ans << '\n';
        return;
    }
    dp[1][0] = k;
    int was = 0;
    for (int i = 0; i < n; ++i) {
        int to = was ^ 1;
        for (int j = 1; j <= k; ++j) {
            dp[j][to] = 0;
        }
        for (int j = k - 1; j > 0; --j) {
            chmax(dp[j][was], dp[j + 1][was]);
        }
        vc <int> nd;
        for (int j = 1; j <= a[i];) {
            int l = j, r = a[i] + 1;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (a[i] / m == a[i] / j) {
                    l = m;
                } else {
                    r = m;
                }
            }
            nd.pb(l);
            j = r;
        }
        for (int j : nd) {
            for (int e = 1;; ++e) {
                chmax(dp[min(e * j, k)][to], dp[e][was] * froak(a[i] / j, a[i]));
                if (e * j >= k)
                    break;
            }
        }
        was = to;
    }
    cout << dp[k][was].val() << '\n';
}

signed main () {
    cout << fixed << setprecision(10);
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

/*
1
3 3
1 2 1
1 3 2
2 3 3
1 3
 */