#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

const int maxn = 1 << 18;
const int inf = 1e9;
const int mod = 1e9 + 7;

long long ans = 0;
long long optprod = 0;
long long minprod = inf;

void gen(int n, vector<int> &a, int k, long long prod, long long res) {
    if (n < 0) {
        if (prod >= k) {
            if (ans < res) {
                ans = res;
                optprod = prod;
            } else if (ans == res) {
                optprod = min(optprod, prod);
            }
            ans = max(ans, res);
            minprod = min(minprod, prod);
        }
        return;
    }
    gen(n - 1, a, k, prod, res * a[n]);
    if (prod < k) {
        for (int j = 1; j <= a[n]; ++j) {
            gen(n - 1, a, k, prod * j, res * (a[n] / j));
        }
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    ans = 0;
    gen(n - 1, a, k, 1, 1);
    long long all = 1;
    for (int i : a) {
        all *= i;
    }
    cout << fixed << setprecision(20) << ans * 1.0 * k / all << endl;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
