#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

#define double long double

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<vector<double>> dp(n, vector<double> (2 * k, 0));
    for (int i = 1; i < 2 * k; ++i) {
        dp[0][i] = (a[0] / i) * (1.0 / a[0]);
    }
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 1; j < 2 * k; ++j) {
            for (int l = 1; j * l < 2 * k; ++l) {
                dp[i + 1][j * l] = max(dp[i + 1][j * l], (a[i + 1] / l) * dp[i][j] * (1.0 / a[i + 1]));
            }
        }
    }
    double ans = 0;
    for (int i = k; i < 2 * k; ++i) {
        ans = max(ans, dp[n - 1][i] * k);
    }
    cout << fixed << setprecision(20) << ans << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}