#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

int n, k;
vector<int> a;
ld ans = 0.0;

void rec(int i, ll cnt, ll now, ld v) {
    if (cnt >= k) {
        ans = max(ans, now * v * k);
        return;
    }
    if (i == n) {
        return;
    }
    ld vv = v / a[i];
    vector<ll> used = {1, a[i], (ll)(k + cnt - 1) / cnt};
    for (auto x : used) {
        rec(i + 1, cnt * x, now * (a[i] / x), vv);
    }
}

void solve() {
    ans = 0.0;
    cin >> n >> k;
    a.resize(n);
    bool can = false;
    ll p = 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        p *= 1LL * a[i];
        if (p >= k) {
            can = true;
        }
    }
    if (!can) {
        cout << 0 << en;
        return;
    }
    if (n <= 2) {
        if (n == 1) {
            ld v = 1 / (ld) (a[0]);
            for (int i = 1; i <= a[0]; ++i) {
                if (i < k) {
                    continue;
                }
                ll now = a[0] / i;
                ans = max(ans, v * k * now);
            }
            cout << fixed << setprecision(12);
            cout << ans << en;
            return;
        }
        ld v = 1 / (ld) (a[0]) / (ld) (a[1]);
        for (int i = 1; i <= a[0]; ++i) {
            int need = k / i;
            for (int j = max(1, need - 3); j <= min(a[1], need + 3); ++j) {
                if (i * j < k) {
                    continue;
                }
                ll now = (a[0] / i) * (a[1] / j);
                ans = max(ans, v * k * now);
            }
        }
        cout << fixed << setprecision(12);
        cout << ans << en;
        return;
    }
    if (k <= 2000 || n <= 2) {
        sort(all(a));
        rec(0, 1, 1, 1);
        cout << fixed << setprecision(12);
        cout << ans << en;
    }
}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 6;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
