#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll INF = 2e9;
const ll MOD = 1e9 + 7;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

signed main(){
    //Fast();
    int n, k;
    cin >> n >> k;
    vector <int> a(n + 1);
    for (int i = 1; i <= n; i++){
        cin >> a[i];
    }
    vector <vector <int>> dp(n + 1, vector <int> (2 * k + 1)), pref(n + 1, vector <int> (2 * k + 1));
    for (int i = 0; i <= n; i++) {
        dp[i][0] = -INF;
        pref[i][0] = -INF;
    }
    dp[0][1] = 1;
    for (int i = 0; i <= n; i++) pref[i][1] = 1;
    for (int i = 2; i <= 2 * k; i++){
        dp[0][i] = -INF;
        pref[0][i] = -INF;
    }
    for (int j = 1;  j <= 2 * k; j++){
        for (int i = 1; i <= n; i++){
            for (int y = 1; y * y <= j; y++){
                if (j % y != 0) continue;
                int g = a[i] / y;
                dp[i][j] = max(dp[i][j], g * pref[i - 1][j / y]);
                g = (a[i] / (j / y));
                dp[i][j] = max(dp[i][j], g * pref[i - 1][y]);
            }
            pref[i][j] = max(pref[i - 1][j], dp[i][j]);
        }
    }
    int ma = 0;
    for (int i = k; i <= k * 2; i++) ma = max(ma, dp[n][i]);
    ld ans = ma * k;
    for (int i = 1; i <= n; i++){
        ans = ans / (ld)(a[i]);
    }
    cout << fixed << setprecision(10);
    cout << ans;
    return 0;
}
