#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


#pragma optimize("Ofast");
#pragma target("bmi, bmi2, avx, avx2");

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) a.size()
#define dbg(a) cout << #a << " = " << a << endl
#define dbg1(a) cout << #a << " = [ "; for (auto e : a) cout << e << " "; cout << "]" << endl;
#define dbg2(a) cout << #a << " = [ "; for (auto [f, s] : a) cout << " { " << f << ' ' << s << " } " << ' '; cout << "]" << endl;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;

mt19937 rnd(1337);

const int N = 100, K = 8e6 + 3, C = 2e3 + 10;

ld dp[2][K + 1];
vector<pair<int, int>> bebra[C + 1];

void solve() {
    int n, k;
    cin >> n >> k;
    for (int i = 1; i <= C; i++) {
        for (int j = 1; j * j <= i; j++) {
            bebra[i].emplace_back(i / j, j);
        }
    }

    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    if (n <= 2) {
        for (auto &i : a) {
            for (int j = 1; j * j <= i; j++) {
                bebra[i].emplace_back(i / j, j);
            }
        }
    }
    if (n == 1) {
        ll mx = 0;
        for (auto [c1, c2] : bebra[a[0]]) {
            if (c1 >= mx) mx = max(mx, c2);
            if (c2 >= mx) mx = max(mx, c1);
        }
        cout << fixed << setprecision(20) << mx * k / (ld)a[0];
        return;
    }
    if (n == 2) {
        ll mx = 0;
        for (auto [c1, c2] : bebra[a[0]]) {
            for (auto [b1, b2] : bebra[a[1]]) {
                if (c1 * b1 >= k) mx = max(mx, c2 * b2);
                if (c1 * b2 >= k) mx = max(mx, c2 * b1);
                if (c2 * b1 >= k) mx = max(mx, c1 * b2);
                if (c2 * b2 >= k) mx = max(mx, c1 * b1);
            }
        }
        cout << fixed << setprecision(20) << (ld)mx * k / a[0] / a[1];
        return;
    }
    dp[1][1] = k;
    for (int i = 0; i < n; i++) {
        int c = i & 1, nc = c ^ 1;
        fill(dp[c], dp[c] + 2 * k, 0);
        for (int last = 1; last <= 2 * k; last++) {
            for (auto [c1, c2] : bebra[a[i]]) {
                //if (last >= k && c1 != 1) continue;
                if (last * c1 <= 2 * k)
                    dp[c][last * c1] = max(dp[c][last * c1], dp[nc][last] * c2 / (ld)a[i]);
                if (last * c2 <= 2 * k)
                    dp[c][last * c2] = max(dp[c][last * c2], dp[nc][last] * c1 / (ld)a[i]);
            }
        }
    }
    ld ans = 0;
    for (int i = k; i <= 2 * k; i++)
        ans = max(ans, dp[n & 1 ^ 1][i]);
    cout << fixed << setprecision(20) << ans << '\n';
}

signed main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}