#include <bits/stdc++.h>

#define pb push_back
#define st string
#define ss second
#define ff first
#define all(a) a.begin(), a.end()
#define vout(a) for (auto u : a) cout << u << " ";
#define vec vector
#define ull unsigned long long
#define ld long double
#define int long long

using namespace std;
using vi = vec<int>;
using vvi = vec<vi>;
using vvvi = vec<vvi>;
using pi = pair<int, int>;
using vpi = vec<pi>;
using vvpi = vec<vpi>;
using vvvpi = vec<vvpi>;

int get(int a, int b) {
    swap(a, b);
    if (a > b) {
        return -1;
    }
    return (b / a);
}

void solve(int n, int k) {
    vi a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int mx = 1;
    for (auto u : a) {
        mx *= u;
    }
    if (mx < k) {
        cout << 0 << endl;
        return;
    }
    if (n == 1) {
        cout << (ld) (get(a[0], k) * k) / (ld) a[0] << endl;
        return;
    }
    ld ans = 0;
    for (int i = 1; i <= a[0]; i++) {
        int need = k / i + (k % i != 0);
        int f = get(a[0], i);
        int sec = get(a[1], need);
        if (sec == -1 || f == -1) {
            continue;
        }
        ans = max(ans, (ld) (f * sec * k) / (ld) (a[0] * a[1]));
    }
    cout << ans << endl;
}

int ans = 1;
int mxans = 0;

void gen(int r, vi &a, int cnt, int k) {
//    cout << r << " " << cnt << " " << k << " " << a.size() << endl;
    if (r == a.size()) {
        if (cnt >= k)
            mxans = max(mxans, ans);
        return;
    }
    for (int i = 1; i <= min(k / cnt + 1, a[r]); i++) {
        int d = i;
        if (d <= a[r]) {
            int add = get(a[r], d);
            ans *= add;
            gen(r + 1, a, cnt * i, k);
            ans /= add;
        }
        else {
            break;
        }
    }
}

void solve2(int n, int k) {
    vi a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    gen(0, a, 1, k);
    mxans *= k;
//    cout << mxans << endl;
    if (!mxans) {
        cout << 0;
        return;
    }
    int del = 1;
    for (auto u : a) {
        del *= u;
    }
    cout << (ld) mxans / (ld) del << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed;
    cout.precision(15);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        int n, k; cin >> n >> k;
        if (n <= 2) {
            solve(n, k);
        }
        else {
            solve2(n, k);
        }
    }
}
