#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <deque>
#include <random>
#include <iomanip>
#include <numeric>
#include <unordered_set>
using namespace std;

mt19937 rnd(1000 - 7);

using ll = long long;
using ld = long double;

const ll INF = 1e9;
const ll LLINF = 1e18;
const ll MOD = 1e9 + 7;

void solve1() {
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	if (n == 1) {
		cout << (ld)(a[0] / k) * (1.0 / (ld)a[0]) * k << "\n";
	} else if (n == 2) {
		ld res = 0;
		for (int i = 1; i <= k; ++i) {
			int other = (k + i - 1) / i;
			res = max(res, (ld)(a[0] / i) * (ld)(a[1] / other) * (1.0 / ((ld)a[0] * (ld)a[1])) * k);
		}
		cout << res << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed << setprecision(16);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);

	solve1();
}