#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef double ld;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
typedef pair<ll,ll> pll;
const ll INF=1e18+2;
const ll N=1e6+2;

namespace sieve
{
    ll lp[N];
    ve<ll> pr;

    void build()
    {
        for(ll i=2;i<N;i++)
        {
            if(lp[i]==0)
            {
                lp[i]=i;
                pr.PB(i);
            }

            for(ll j=0;j<pr.size()&&pr[j]<=lp[i]&&pr[j]*i<N;j++)
                lp[pr[j]*i]=pr[j];
        }
    }

    map<ll,ll> get_fact(ll x)
    {
        map<ll,ll> mp;

        while(x>=2)
        {
            mp[lp[x]]++;
            x/=lp[x];
        }

        return mp;
    }
}

ll arr[N];
ld dp[N];
ve<pll> fact;
ll cur;

void calc(ll i, ll j, ll pos)
{
    if(pos==fact.size())
    {
        if(cur!=1) dp[j]=max(dp[j],dp[j/cur]*(arr[i]/cur)/arr[i]);
        return;
    }

    for(ll y=0;y<=fact[pos].S;y++)
    {
        calc(i,j,pos+1);
        cur*=fact[pos].F;
    }

    for(ll y=0;y<=fact[pos].S;y++)
        cur/=fact[pos].F;
}

void solve()
{
    sieve::build();
    ll n=100,k=40000;
    cin>>n>>k;

    for(ll i=0;i<n;i++)
        /*arr[i]=gen()%ll(2000)+1;*/ cin>>arr[i];

    shuffle(arr,arr+n,gen);
    dp[1]=k;

    for(ll i=0;i<n;i++)
    {
        for(ll j=k*2;j>=1;j--)
        {
            map<ll,ll> mp=sieve::get_fact(j);
            fact.clear();
            for(pll i:mp) fact.PB(i);
            cur=1;
            calc(i,j,0);
        }
    }

    ld ans=0;

    for(ll i=k;i<=k*2;i++)
        ans=max(ans,dp[i]);

    cout<<fixed<<setprecision(12)<<ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
