#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3,inline,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,popcnt")
using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define ll long long
#define ld long double
#define pt pair<int, int>
#define fi first
#define x first
#define se second
#define y second
#define all(x) x.begin(), x.end()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
///=================================================///
const int MX = 700;
const int INF = 2e9;
const int MOD = 1e9 + 7;
///=================================================///
int n, k;
int a[MX], b[MX];

void solve() {
    cin >> n >> k;
    for (int i = 0; i < n; i++) cin >> a[i];
    int k2 = k;
    fill(b, b + n + 1, 1); vector<int> dels;
    for (int i = 2; i * i <= k; i++) {
        while (k % i == 0) {
            k /= i;
            dels.push_back(i);
        }
    }
    if (k != 1) dels.push_back(k);

    for (int d : dels) {
        int ind = -1;
        ld down = INF;
        for (int i = 0; i < n; i++) {
            int X = a[i] / b[i];
            int Y = a[i] / (b[i] * d);
            ld dw = (ld)X / Y;
            if (down > dw) {
                down = dw;
                ind = i;
            }
        }
        b[ind] *= d;
    }
    ld res = k2;
    for (int i = 0; i < n; i++) {
        int dt = a[i] / b[i];
        res *= dt;
        res /= a[i];
    }
    cout << setprecision(15) << res << "\n";
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(0); cin.tie();
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int tests = 1;
    // cin >> tests;
    ld starts = clock();
    while (tests--) solve();
    ld endd = clock();
#ifdef LOCAL
    cout << "\nEND: " << (endd - starts) / (ld)(CLOCKS_PER_SEC) << " sec\n";
#endif
    return 0;
}
