#include <iostream>
#include <string>
#include<vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <complex>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<vector<int> > vvi;
typedef vector<vector<ll>> vvl;
typedef vector<bool> vb;

#define int long long
#define all(v) v.begin(), v.end()
#define pb push_back();

/*

void build(vl & t, int v, int l, int r, vi & a) {
    if(l == r) t[v] = a[l];
    else {
        int m = (l + r) / 2;
        build(t, 2 * v, l, m, a);
        build(t, 2 * v + 1, m + 1, r, a);
        t[v] = (t[2 * v] + t[2 * v + 1]);
    }
}
int sum(vl & t, int v, int tl, int tr, int l, int r) {
    if(l == tl && r == tr) return t[v];
    // look out
    if(l > r) return 0;
    // look out
    int tm = (tl + tr) / 2;
    return sum(t, 2 * v, tl, tm, l, min(tm, r)) +
            sum(t, 2 * v + 1, tm + 1, tr, max(tm + 1, l), r);

}
void update(vl & t, int v, int tl, int tr, int pos, int x) {
    if(tl == tr) t[v] = x;
    else {
        int tm = (tl + tr) / 2;
        if(pos <= tm) update(t, 2 * v, tl, tm, pos, x);
        else update(t, 2 * v + 1, tm + 1, tr, pos, x);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}
*/
bool ansminus = false;

void dfs(ll v,vector<vector<pair<ll, ll>>> & g, vl & used, set<pair<int,int>> & circle, vl & dp) {
    used[v] = 1;
    for(auto u : g[v]) {
        if(used[u.first] == 1) {
            if((dp[v] ^ dp[u.first] ^ u.second) != 0) ansminus = true;
            circle.insert({v, u.first});
        }
        if(used[u.first]) continue;
        dp[u.first] ^= dp[v] ^ u.second;
        dfs(u.first, g, used, circle, dp);
    }
    used[v] = 2;
}
/*void dfs(ll v,vector<vector<pair<ll, ll>>> & g, vl & used) {
    used[v] = 1;
    for(auto u : g[v]) {
        if(used[u.first]) continue;
        dfs(u.first, g, used);
    }
}*/
void solve() {
    ll n;
    cin >> n;


    //ll ans = 0;

    ll k; cin >> k;
    // ll a, b, c; cin >> a >> b >> c;
    //ll d; cin >> d;
    // string s; cin >> s; n = s.length();
    vi a(n); for(int i =  0 ; i < n; ++i)cin >> a[i];
    sort(all(a));
    if(n == 2) {
        double ans = 0;
        for(int b = 1; b <= a[0]; ++b){
            int b2 = (k + b - 1)/ b;
            if(b2 <= a[1]) {
                ans = max(ans,double((a[0] / b) * (a[1] / b2)) / (double)a[0] / (double)a[1]  * (double)k );
            }
        }
        cout << ans;
    } else  if(n == 1){
        double ans = 0;
        if(a[0] >= k) {
            ans = double(a[0] / k) ;
            ans = ans / (double)a[0] * (double)k;
        }
        cout << ans;
    } else {
        double ans = 0;
        bool ok = true;
        ll pr = 1;
        for(int i = 0; i < n; ++i) {
            pr *= a[i];
        }
        if(pr < k) cout << 0;
        else cout << 1;
    }


    // cout << ans;
    // cout << (ans ? "YES" : "NO");
    // cout << ans.size() << '\n';
    // for(auto x : ans) cout << x << '\n';
    // for(auto p : ans) cout << p.first << ' ' << p.second << "\n";
    cout << "\n";
}
signed main() {
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}
