#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <vector>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC target("avx")
#pragma GCC target("avx2")

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;

mt19937 rnd(time(NULL));

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector
#define endl '\n'
#define pb push_back
//#define int long long

const int INF = 1e9 + 7, N = 1e8 + 5e7, N2 = 1e8 + 5e7;

void solve() {
    int n, k;
    cin >> n >> k;
    cout << fixed << setprecision(20);
    vec<int> a(n);
    int mx  = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        mx = max(a[i], mx);
    }
    if (n == 1) {
        cout << (ll(a[0] / k) / ld(a[0])) * k;
        return;
    }
    if (n == 2) {
        ld ans = 0;
        for (int i = 1; i <= 2e7; ++i) {
            int j = (k + i - 1) / i;
            ans = max(ans, (ll(a[0] / i) / ld(a[0])) * (ll(a[1] / j) / ld(a[1])));
        }
        cout << ans * k;
        return;
    }
    sort(rall(a));
    if (k > 2e5) {
        vec<ld> dp(k + 1), dp2(k + 1);
        dp2[1] = k;
        sort(rall(a));
        dp2[1] = k;
        vec<int> ind(k + 1);
        int c = 1;
        ind[0] = 1;
        int timer = 0;
        for (int i = 0; i < n && i < 30; ++i) {
            for (int j = min(mx, k); j >= 1; --j) {
                if (a[i] < j || (a[i] / j) == (a[i] / (j + 1))) continue;
                for (int e = 0; e < c; ++e) {
                    dp[min(k, j * ind[e])] = max(dp2[ind[e]] * (ll(a[i] / j) / ld(a[i])), dp[min(k, j * ind[e])]);
                    timer++;
                    if (j * ind[e] >= k) break;
                }
                if (timer >= N2) break;
            }
            c = 0;
            for (int j = 1; j <= k; ++j) if (dp[j] != dp2[j]) ind[c++] = i;
            for (int j = k - 1; j >= 0; --j) dp[j] = max(dp[j], dp[j + 1]);
            if (timer >= N2) break;
            swap(dp, dp2);
        }
        cout << dp[k];
        return;
    }
    vec<ld> dp(k + 1);
    dp[1] = k;
    int timer = 0;
    for (int i = 0; i < n; ++i) {
        auto dp2 = dp;
        for (int j = min(mx, k); j >= 1; --j) {
            if (a[i] < j || (a[i] / j) == (a[i] / (j + 1))) continue;
            for (int q = 1; q <= k; ++q) {
                dp[min(k, j * q)] = max(dp2[q] * (ll(a[i] / j) / ld(a[i])), dp[min(k, j * q)]);
                timer++;
                if (j * q >= k) break;
            }
            if (timer >= N) break;
        }
        for (int i = k - 1; i >= 0; --i) dp[i] = max(dp[i], dp[i + 1]);
        if (timer >= N) break;
    }
    //for (int i = 0; i <= k; ++i) if (dp[i] != 0) cout << i << " " << dp[i] << endl;
    cout << dp[k];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}