#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1337, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

//int a[100];
//ld dpn[(int) 1e7 + 1], dpw[(int) 1e7 + 1], pref[(int) 1e7 + 1];

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(all(a), greater<>());
    ld cnst = k;
    for (int i = 0; i < n; ++i) {
        cnst *= ((ld) 1 / a[i]);
    }
    vector<ld> dpn(k + 1, 0), dpw(k + 1, 0);
    for (int i = 1; i <= a[0] && i <= k; ++i) {
        i = a[0] / ((a[0]) / i);
        dpw[min(i, k)] = (ld) (a[0] / i);
    }
    vector<ld> pref(k + 1, 0);
    for (int i = 1; i < n; ++i) {
        for (int j = k; j >= 1; --j) {
            pref[j] = dpw[j];
            if (j + 1 <= k) {
                pref[j] = max(pref[j], pref[j + 1]);
            }
            dpn[j] = 0;
        }
        for (int nw = 1, j = k; nw <= a[i]; ++nw) {
            nw = a[i] / (a[i] / nw);
            ld cur = a[i] / nw;
            while (j >= 1 && j * nw >= k) {
                --j;
            }
            ++j;
            if (j * nw >= k) {
                dpn[k] = max(dpn[k], pref[j] * cur);
            }
            for (int was = 1; was < j; ++was) {
                dpn[nw * was] = max(dpn[nw * was], dpw[was] * cur);
            }
        }
        swap(dpn, dpw);
    }
    cout << fixed << setprecision(30);
    cout << dpw[k] * cnst;
}