#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"
#include "cmath"
#include "iomanip"

using namespace std;

typedef long long ll;
typedef long double ld;


void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

void solve() {
    cout << fixed << setprecision(10);
    int n, k;
    cin >> n >> k;
    vector<pair<int, int>> pr;
    ld ans = k;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        ans /= ld(a);
        pr.push_back({a, 1});
        for (int i = 2; i <= a; i++) {
            if (ll((ld) a / i) == 1)
                break;
            pr.push_back({ll((ld) a / i), i});
        }
    }
    if (ans > 1) {
        ans = 0;
    }
    set<pair<int, int>> s{{1, 1}};
    map<int, int> m;
    m[1] = 1;
    for (auto[p, x]: pr) {
        auto s1 = s;
        for (auto[i, x1]: s1) {
            if ((*--s.lower_bound({i * p, 0})).first >= k)
                break;
            s.erase({i * p, m[i * p]});
            if (m[i * p] < x1 * x)
                m[i * p] = x1 * x;
            s.insert({i * p, m[i * p]});
        }
    }
    ans *= ld(s.lower_bound({k, 0})->second);
    cout << ans;

}