#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <unordered_map>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <deque>
#define int long long
using namespace std;
vector <vector <pair <int, int> > > g;
vector <double> w;
int n, m;

vector <int> usd;
double st;

void dfs(int v) {
	usd[v] = 1;
	for (auto u : g[v]) {
		if (!usd[u.first]) {
			dfs(u.first);
		}
	}
}

bool check(double cnt) {
	vector <vector <double> > opt(n, { 0,0,-1 });
	opt[0] = { cnt, w[0], st };
	deque <pair <int, vector <double> >> uu;
	uu.push_back({ 0, opt[0] });
	while (uu.size()) {
		if (opt[n - 1][2] != -1) {
			return 1;
		}
		pair <int, vector <double> > op = uu.front();
		uu.pop_front();
		int v = op.first;
		if (op.second == opt[v]) {
			double cs = opt[v][2];
			int obs = opt[v][0] * opt[v][1] + opt[v][2];
			for (auto u : g[v]) {
				int tm = opt[u.first][0] * opt[u.first][1] + opt[u.first][2];
				if (obs - u.second >= 0) {
					if (u.second <= cs) {
						cs -= u.second;
						if (opt[v][0] * max(w[u.first], opt[v][1]) + cs > tm) {
							opt[u.first] = { opt[v][0], max(opt[v][1], w[u.first]), cs };
							uu.push_back({ u.first, opt[u.first] });
						}
					}
					else {
						double st = u.second;
						st -= cs;
						double cn = (int)(st + opt[v][1] - 1) / (int)opt[v][1];
						double pr = cn * opt[v][1] - st;
						if ((opt[v][0] - cn) * max(opt[v][1], w[u.first]) + pr > tm) {
							opt[u.first] = { opt[v][0] - cn,max(opt[v][1], w[u.first]), pr };
							uu.push_back({ u.first, opt[u.first] });
						}
					}
				}
			}
		}
	}
	if (opt[n - 1][2] >= 0) {
		return 1;
	}
	return 0;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int  gg;
	cin >> n >> m >> st >> gg;
	w.resize(n);
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	usd.resize(n);

	for (int i = 0; i < m; ++i) {
		int a, b, s;
		cin >> a >> b >> s;
		a--;
		b--;
		g[a].push_back({ b, s });
	}
	dfs(0);
	if (!usd[n - 1]) {
		cout << -1;
		return 0;
	}
	int l = -1, r = 10000;
	while (r - l > 1) {
		int mid = (r + l) / 2;
		if (check(mid)) {
			r = mid;

		}
		else {
			l = mid;
		}

	}
	cout << r;


}