#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 800;

pair<ll, ll> dist[N][N]; //first - opt_w, second - vertex

vector<pair<int, int>> adj[N];

bool used[N][N];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    memset(dist, -1, sizeof(dist));

    int n, m, p, g;
    cin >> n >> m >> p >> g;

    vector<int> w(n);

    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }

    vector<int> sw = w;

    sort(sw.begin(), sw.end());
    sw.resize(unique(sw.begin(), sw.end()) - sw.begin());

    const int s = sw.size();

    vector<int> pos(n);

    for (int i = 0; i < n; ++i) {
        pos[i] = lower_bound(sw.begin(), sw.end(), w[i]) - sw.begin();
    }

    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a -= 1, b -= 1;

        adj[a].push_back({b, c});
    }

    set<array<ll, 4>> pq;

    dist[pos[0]][0] = {0, -p};
    pq.insert({0, -p, pos[0], 0});

    while (!pq.empty()) {
        auto [d, mn, ord, v] = *pq.begin();
        pq.erase(pq.begin());
        mn = -mn;

        if (dist[ord][v] != pair{d, -mn}) {
            continue;
        }

        for (auto [to, we] : adj[v]) {
            ll add = max(0ll, we - mn);
            add = (add + sw[ord] - 1) / sw[ord];
            ll nd = d + add;
            ll nm = mn - we + add * sw[ord];
            nm = -nm;
            int nord = max<int>(ord, pos[to]);

            if (dist[nord][to].first == -1 || dist[nord][to] > pair{nd, nm}) {
                dist[nord][to] = {nd, nm};

                pq.insert({nd, nm, nord, to});
            }
        }
    }

    ll ans = 1e18;

    for (int o = 0; o < s; ++o) {
        if (dist[o][n - 1].first != -1) {
            ans = min(ans, dist[o][n - 1].first);
        }
    }

    cout << (ans == 1e18 ? -1 : ans) << '\n';

    return 0;
}
