#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

#define LC(V) (2*(V)+1)
#define RC(V) (2*(V)+2)

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18;

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    ll n, m, p, tp;
    cin >> n >> m >> p >> tp;
    vector<ll> a(n);
    for (ll &e: a) cin >> e;
    vector<vector<pair<ll, ll>>> g(n);
    for (ll j = 0; j < m; j++) {
        ll v, u, w;
        cin >> v >> u >> w;
        v--, u--;
        g[v].emplace_back(u, w);
    }
    if (tp == 1) {
        vector<ll> d(n, INF);
        set<pair<ll, ll>> q;
        d[0] = 0;
        q.emplace(0, 0);
        while (!q.empty()) {
            ll v = q.begin()->second;
            q.erase(q.begin());
            for (auto [u, w]: g[v]) {
                if (d[v] + w < d[u]) {
                    q.erase({d[u], u});
                    d[u] = d[v] + w;
                    q.insert({d[u], u});
                }
            }
        }
        if (d[n - 1] == INF) {
            cout << "-1\n";
            return 0;
        }
        ll ans = max(0ll, d[n - 1] - p);
        cout << ans << '\n';
        return 0;
    }
    if (tp == 2 || tp == 0) {
        ll ans = 0;
        ll mx = a[0];
        for (ll i = 0; i < n - 1; i++) {
            ll cost = g[i][0].second;
            ll kek = min(p, cost);
            cost -= kek;
            p -= kek;
            ll cnt = (cost + mx - 1) / mx;
            ans += cnt;
            p += cnt * mx - cost;
        }
        cout << ans << '\n';
    }
    return 1;
}