#include <iostream>
#include <vector>
#include <algorithm>
#include <stdio.h>
#include <set>
#include <queue>
#include <map>
#include <cstring>


#define sc second
#define fr first
#define ll long long
#define int long long
#define ld long double
#define int long long


//#pragma GCC optimize("acvx,bmi,bmi2")

using namespace std;
const ll inf = 1e18;

const int N = 808;
const int M = 3030;

int w[N];
vector<int> g[N];
pair<int, int> e[M];
ll dist0[N][N];
bool f[N];
int id[N];

int n, m, gr, p;

void input(){
    cin >> n >> m >> p >>  gr;
    for (int i = 1; i <= n; ++i){
        cin >> w[i];
        id[i] = i;
        for (int j = 1; j <= n; ++j){
            dist0[i][j] = inf;
        }
    }
    int u, v, s;
    for (int i = 0; i < m; ++i){
        cin >> u >> v >> s;
        e[i] = {u + v, s};
        g[u].push_back(i);
        g[v].push_back(i);
    }
}

void dik(int v, int*dist){
    priority_queue<pair<int, int> > q;
    q.push({0, v});
    int d, to, ww;;
    while (!q.empty()){
        v = q.top().sc;
        d = -q.top().fr;
        q.pop();
        if (dist[v] != inf){
            continue;
        }
        dist[v] = d;
        for (auto id : g[v]){
            to = e[id].fr - v;
            ww = e[id].sc;
            if (dist[to] == inf){
                q.push({-(d + ww), to});
            }
        }
    }
}

void precount(){
    for (int i = 1; i <= n; ++i){
        dik(i, dist0[i]);
    }
    if (dist0[n][0] == inf){
        cout << -1<<'\n';
        exit(0);
    }
    w[n] = inf;
    sort(id + 1, id + n + 1, [](int i, int j){
        return w[i] < w[j];
    });

}


map<int, int> ans[N];

void xmax(int& a, int &b){
    a = max(a, b);
}

void count(){
   // cout << '\n';
    int from, to;
    int source, fin;
    for (int i = 1; i <= n; ++i){
        if (id[i] == 1){
            source = i;
        }
        if (id[i] == n){
            fin = i;
        }
    }
    ans[1][0] = p;
    for (int idd = 1; idd <= n; ++idd){
        to = id[idd];
        for (int lastd = 1; lastd < idd; ++lastd){
            from = id[lastd];
            if (!ans[from].empty()){
                for (auto pr : ans[from]){
                    int cost = dist0[to][from];
                    int cnt = (max(cost - pr.sc, 0ll) + w[from] - 1) / w[from];
                    int left = pr.sc - cost + cnt * w[from];
               //     cout << to << ' ' << from << ' ' << cnt  + pr.fr << ' ' << left << '\n';
                    ans[to][pr.fr + cnt] = max(ans[to][pr.fr + cnt], left);
                }
            }
        }
    }


    pair<int, int> opt = *ans[n].begin();
    cout << opt.fr << '\n';
    /*
    for (int i = 1; i <= n; ++i){
        cout << "I : " << i << '\n';
        for (auto pr : ans[i]){
            cout << '(' << pr.fr << ": " << pr.sc <<") ";
        }
        cout << '\n';
    }
    for (int i = 1; i <= n; ++i){
        for (int j = 1; j <= n; ++j){
            cout << dist0[i][j] << ' ';
        }
        cout << '\n';
    }*/
}
signed main(){
    input();
    precount();
    count();
}
