#include <bits/stdc++.h>

using namespace std;

#define pii pair<int,int>
#define F first
#define S second
typedef long double ld;
#define int int64_t

mt19937 gen(chrono::system_clock().now().time_since_epoch().count());

const int N = 800+10, K = 30, inf = 1e18+100;

int n, m, p, gt;
vector <int> g[N];
int w[N];
int mt[N][N];

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n >> m >> p >> gt;
    for (int i=0;i<n;++i) {
        cin >> w[i];
    }
    for (int i=0;i<n;++i) {
        for (int j=0;j<n;++j) {
            mt[i][j] = inf;
        }
    }
    for (int i=0;i<m;++i) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;y--;
        mt[x][y] = min(mt[x][y], c);
        g[x].push_back(y);
    }
    if (n == 1) {
        cout << 0;
        return 0;
    }
    if (gt == 1) {
        priority_queue <pii> q;
        q.push({0, 0});
        int d[n];
        bool u[n];
        fill(d, d+n, inf);
        fill(u, u+n, 0);
        d[0] = 0;
        while (!q.empty()) {
            int v = q.top().S;
            q.pop();
            if (u[v]) {
                continue;
            }
            u[v] = 1;
//            cout << v << ' ' << d[v] << '\n';
            for (int i:g[v]) {
                if (d[i] > d[v] + mt[v][i]) {
                    d[i] = d[v] + mt[v][i];
                    q.push({-d[i], i});
                }
            }
        }
        if (d[n-1] == inf) {
            cout << -1;
        }
        else {
            cout << max(d[n-1]-p, int64_t(0));
        }
        return 0;
    }
    if (gt == 2) {
        int mx = w[0], ans = 0;
        for (int i=0;i<n-1;++i) {
            if (mt[i][i+1] > p) {
                int x = ((mt[i][i+1]-p + mx-1) / mx);
                p += x * mx;
                ans += x;
            }
            p -= mt[i][i+1];
            mx = max(mx, w[i+1]);
        }
        cout << ans;
        return 0;
    }
    if (gt == 3 || gt == 0) {
        int pm[n];
        for (int i=0;i<n;++i) {
            pm[i] = i;
        }
        int ans = inf;

        int p1 = p;
        while (pm[0] == 0) {
            p = p1;
            int mx = w[0], k = 0;
            bool ok = 1;
//            for (int i=0;i<n;++i) {
//                cout << pm[i] << ' ';
//            }
//            cout << '\n';
            for (int i=0;i<n-1;++i) {
                if (mt[pm[i]][pm[i+1]] == inf) {
//                    cout << pm[i] << ' ' << pm[i+1] << ' ' << mt[pm[i]][pm[i+1]] << '\n';
                    ok = 0;
                    break;
                }
                if (mt[pm[i]][pm[i+1]] > p) {
                    int x = ((mt[pm[i]][pm[i+1]]-p + mx-1) / mx);
                    p += x * mx;
                    k += x;
                }
                p -= mt[pm[i]][pm[i+1]];
                mx = max(mx, w[pm[i+1]]);
                if (pm[i+1] == n-1) {
                    break;
                }
            }
//            cout << ok << ' ' << k << '\n';
            if (ok) {
                ans = min(ans, k);
            }
            next_permutation(pm, pm+n);
        }
        if (ans == inf) ans = -1;
        cout << ans << '\n';
    }
    return 0;
}
