#pragma gcc optimize("O3,Ofast,no-stack-protector,inline")
#pragma gcc target("avx,avx2,popcnt,lzcnt,tune=native")
#include<bits/stdc++.h>
#include<vector>
#include<immintrin.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, std::less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
using namespace std;
typedef long long ll;
typedef long double ld;
typedef __int128 li;
#define ft first
#define sc second
#define all(x) begin(x),end(x)
const ll mod = 1e9+7, mod1 = 1e9+9, inf = 1e18, N = 1e7+10;
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
    mt19937 rnd(674939375);
    ll n, m, p, g, u, v, w;
    cin >> n >> m >> p >> g;
    vector<vector<pair<int, ll>>> rebra(n);
    vector<int> c(n);
    vector<pair<int, int>> vc(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
        vc[i] = {c[i], i};
    }
    sort(all(vc));
    for (int i = 0; i < m; i++) {
        cin >> u >> v >> w; u--; v--;
        rebra[u].push_back({v, w});
        //rebra[v].push_back({u, w});
    }
    for (int i = 0; i < n; i++) shuffle(all(rebra[i]), default_random_engine(rnd()));
    ll dp1[n][n];
    pair<ll, ll> dp2[n];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) dp1[i][j] = inf;
        dp1[i][i] = 0;
        vector<int> used(n, 0);
        queue<int> q; q.push(i);
        while (q.size() != 0) {
            int j = q.front();
            q.pop();
            used[j] = 0;
            for (auto [k, x] : rebra[j]) {
                if (dp1[i][k] > dp1[i][j] + x) {
                    dp1[i][k] = dp1[i][j] + x;
                    if (used[k] == 0) {
                        used[k] = 1;
                        q.push(k);
                    }
                }
            }
        }
    }
    if (dp1[0][n-1] == inf) {
        cout << -1;
        return 0;
    }
    for (int i = 0; i < n; i++) {
        if (dp1[0][i] == inf) continue;
        dp2[i].ft = max(0ll, (dp1[0][i]-p + c[0]-1)/c[0]);
        dp2[i].sc = p+c[0]*dp2[i].ft - dp1[0][i];
    }
    for (auto [x, i] : vc) {
        if (dp1[0][i] == inf) continue;
        ll cnt1 = dp2[i].ft, p1 = dp2[i].sc;
        for (int j = 0; j < n; j++) {
            if (dp1[0][j] == inf) continue;
            pair<ll, ll> f;
            f.ft = max(0ll, (dp1[i][j]-p1 + c[i]-1)/c[i]);
            f.sc = p1+c[i]*f.ft - dp1[i][j];
            f.ft += cnt1;
            if (f.ft < dp2[j].ft || (f.ft == dp2[j].ft && f.sc > dp2[j].sc)) dp2[j] = f;
        }
    }
    cout << dp2[n-1].ft;
}