#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define endl '\n'
#define len(a) (int)a.size()
#define allr(a) a.rbegin(), a.rend()
#define f first
#define s second

using namespace std;
typedef long long ll;
typedef long double ld;
const ll INF = 1e18;
const int MAXI = 1e9 + 1e7;

const int MAXN = 900;
ll dist[MAXN][MAXN];
pair<ll, ll> dp[MAXN];

void fill_dist(ll n) {
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++)
            dist[i][j] = i == j ? 0 : INF;
    }
}

ll dup(ll a, ll b) {
    return a / b + (a % b > 0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    fill_dist(n);
    vector<ll> b(n);
    for (ll i = 0; i < n; i++)
        cin >> b[i];
    for (ll i = 0; i < m; i++) {
        ll u, v, w;
        cin >> u >> v >> w;
        dist[u - 1][v - 1] = min(dist[u - 1][v - 1], (ll)w);
    }
    for (ll k = 0; k < n; k++) {
        for (ll u = 0; u < n; u++) {
            for (ll v = 0; v < n; v++) {
                if (dist[u][k] != INF && dist[k][v] != INF)
                    dist[u][v] = min(dist[u][v], dist[u][k] + dist[k][v]);
            }
        }
    }
    fill(dp, dp + n, make_pair(INF, -INF));
    dp[0] = {0, -p};
    vector<ll> order(n);
    iota(all(order), 0);
    sort(all(order), [&](ll i, ll j) { return b[i] < b[j]; });
    ll ans = INF;
    for (ll u : order) {
        for (ll v : order) {
            if (b[v] == b[u])
                break;
            if (dist[v][u] != INF) {
                ll x = dist[v][u] <= dp[v].s ? 0 : dup(dist[v][u] - dp[v].s, b[v]);
                ll leftover = b[v] * x - (dist[v][u] - dp[v].s);
                dp[u] = min(dp[u], make_pair(x + dp[v].f, -leftover));
            }
        }
        dp[u].s *= -1;
        if (dp[u].f != INF && dist[u][n - 1] != INF) {
            ll y = dp[u].s >= dist[u][n - 1] ? 0 : dup(dist[u][n - 1] - dp[u].s, b[u]);
            ans = min(ans, dp[u].f + y);
        }
    }
    if (ans != INF)
        cout << ans;
    else
        cout << -1;
}