#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pii pair < int, int >
#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define ll long long
#define _ << ' ' <<
#define int ll

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree < T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MOD = (int)1e9 + 7;
const int INF = (int)1e18;
const int N = (int)5e5 + 5;
const int p = 41;

int val[N];

struct fly {
    int a, b, c;
};

vector < fly > all;

vector < pii > g[N];

int nxt[N];

int32_t main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    for (int i = 1; i <= n; i++) {
        cin >> val[i];
    }
    all.resize(m + 1);
    for (int i = 1; i <= m; i++) {
        cin >> all[i].a >> all[i].b >> all[i].c;
    }

    if (gr == 1) {
        for (int i = 1; i <= m; i++) {
            g[all[i].a].push_back({ all[i].b, all[i].c });
        }
        priority_queue < pii, vector < pii >, greater < pii > > q;
        vector < int > dist(n + 1, INF);
        q.push({ 0, 1 });
        dist[1] = 0;
        while (!q.empty()) {
            int cur = q.top().second, cur_dist = q.top().first; q.pop();
            if (cur_dist > dist[cur]) continue;
            for (auto to: g[cur]) {
                if (to.second + dist[cur] < dist[to.first]) {
                    dist[to.first] = dist[cur] + to.second;
                    q.push({ dist[to.first], to.first });
                }
            }
        }
        int ans = max(0ll, dist[n] - p);
        if (dist[n] == INF) {
            ans = -1;
        }
        cout << ans << '\n';
        return 0;
    }
    if (gr == 2) {
        int ans = 0, cur = p;
        vector < int > vec = { 1 };
        for (int i = 2; i <= n; i++) {
            while (!vec.empty() && val[vec.back()] <= val[i]) {
                nxt[vec.back()] = i;
                vec.pop_back();
            }
            vec.push_back(i);
        }
        vector < int > sum(n + 1, 0);
        for (int i = 2; i <= n; i++) {
            sum[i] = sum[i - 1] + all[i - 1].c;
        }
        for (int i = 1; i < n; i++) {
            if (!nxt[i]) nxt[i] = n;
            int need = sum[nxt[i]] - sum[i];
            int r = min(cur, need);
            cur -= r; need -= r;
            int cnt = (need / val[i]) + (need % val[i] > 0);
            ans += cnt;
            cur += cnt * val[i] - need;
            i = nxt[i] - 1;
        }
        cout << ans << '\n';
        return 0;
    }
    return 0;
}
