#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
#define ll long long
#define all(x) (x).begin(), (x).end()

mt19937 rnd(179);
#define int long long

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    vector<int> w(n);
    for (int &i: w) {
        cin >> i;
    }
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int fr, to, ww;
        cin >> fr >> to >> ww;
        fr--;
        to--;
        g[fr].emplace_back(to, ww);
    }
    if (gr == 1) {
        const int INF = 1e18;
        vector<int> dist(n, INF);
        dist[0] = 0;
        vector<bool> used(n);
        for (int it = 0; it < n; it++) {
            int fr = -1;
            for (int v = 0; v < n; v++) {
                if (!used[v] && (fr == -1 || dist[v] < dist[fr])) {
                    fr = v;
                }
            }
            if (fr == -1 || dist[fr] == INF) {
                break;
            }
            assert(dist[fr] != INF);
            used[fr] = true;
            for (auto [to, cost]: g[fr]) {
                dist[to] = min(dist[to], dist[fr] + cost);
            }
        }
        int ans = dist[n - 1];
        if (ans == INF) {
            cout << -1 << '\n';
        } else {
            cout << max(0ll, ans - p);
        }
    } else if (gr == 2) {
        int mx = -1;
        int now = p;
        int ans = 0;
        for (int i = 0; i + 1 < n; i++) {
            int need = max(0ll, g[i][0].second - now);
            mx = max(mx, w[i]);
            ans += (need + mx - 1) / mx;
            now += mx * ((need + mx - 1) / mx);
            now -= g[i][0].second;
        }
        cout << ans;
    } else if (n <= 10) {
        int ans = 1e18;
        vector<int> order(n);
        iota(all(order), 0);
        const int INF = 1e9 + 10;
        vector<vector<int>> cost(n, vector<int> (n, INF));
        for (int v = 0; v < n; v++) {
            for (auto [to, ww] : g[v]) {
                cost[v][to] = min(cost[v][to], ww);
            }
        }
        do {
            if (order[0] != 0) {
                continue;
            }
            int mx = -1;
            int now = p;
            int anss = 0;
            for (int i = 0; i + 1 < n; i++) {
                if (order[i] == n - 1) {
                    break;
                }
                if (cost[order[i]][order[i + 1]] == INF) {
                    anss = 1e18 + 10;
                    break;
                }
                int need = max(0ll, cost[order[i]][order[i + 1]] - now);
                mx = max(mx, w[order[i]]);
                anss += (need + mx - 1) / mx;
                now += mx * ((need + mx - 1) / mx);
                now -= cost[order[i]][order[i + 1]];
            }
            ans = min(ans, anss);
        } while (next_permutation(all(order)));
        if (ans == 1e18) {
            cout << -1;
        } else {
            cout << ans;
        }
    }
//    const int INF = 1e9 + 10;
//    vector<array<int, 3>> dist(n, {INF, INF, INF});
//    vector<bool> used(n);
//    dist[0] = {0, w[0], p};
//    used[0] = true;
//    for (int it = 0; it < n; it++) {
//        int fr = -1, to = -1, cost = -1;
//        for (int frr = 0; frr < n; frr++) {
//            if (!used[frr]) {
//                continue;
//            }
//            auto [dis, mx, money] = dist[frr];
//            for (auto [too, costt] : g[frr]) {
//                if (used[too]) {
//                    continue;
//                }
//            }
//        }
//    }
//    int ans = dist[n - 1][0];
//    if (ans == INF) {
//        ans = -1;
//    }
//    cout << ans;
    return 0;
}