#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<stack>
#include<queue>
#include<deque>
#include<cmath>
#include<iomanip>
#include<algorithm>
#include<unordered_map>
#include<unordered_set>
using namespace std;

struct edge {
    long long to, w;
};

vector<vector<edge>> g;

set<long long> st;
vector<long long> pt;
void get(long long n, vector<vector<long long>>& newg, long long& res, long long p, vector<long long>& w) {
    long long pp = p;
    long long beg = 0, ok = 1, mx_for_one = w[0], ans = 0;
    for (int i = 0; i < pt.size(); i++) {
        if (newg[beg][pt[i]] == -1) {
            ok = 0;
            break;
        }

        mx_for_one = max(mx_for_one, w[beg]);
        long long need = newg[beg][pt[i]];
        if (need <= p) {
            p -= need;
        } else {
            long long cur = (need - p) / mx_for_one + (bool)((need - p) % mx_for_one);
            ans += cur;
            p = (cur * mx_for_one - (need - p)) % mx_for_one;
        }

        beg = pt[i];
        mx_for_one = max(mx_for_one, w[beg]);
    }

    if (ok && newg[beg][n - 1] != -1) {
        mx_for_one = max(mx_for_one, w[beg]);
        long long need = newg[beg][n - 1];
        if (need <= p) {
            p -= need;
        } else {
            long long cur = (need - p) / mx_for_one + (bool)((need - p) % mx_for_one);
            ans += cur;
            p = (cur * mx_for_one - (need - p)) % mx_for_one;
        }
    } else ok = 0;

    if (ok) {
        res = min(ans, res);
    }

    for (int i = 1; i + 1 < n; i++) {
        if (st.find(i) == st.end()) {
            st.insert(i);
            pt.push_back(i);
            get(n, newg, res, pp, w);
            pt.pop_back();
            st.erase(i);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    long long n, m, p, num;
    cin >> n >> m >> p >> num;

    vector<long long> w(n);
    for (int i = 0; i < n; i++)
        cin >> w[i];

    g.resize(n);
    for (int i = 0; i < m; i++) {
        long long a, b, s;
        cin >> a >> b >> s;
        a--; b--;
        g[a].push_back({b, s});
    }

    if (num == 1) {
        long long inf = 1000000000000000000;
        vector<long long> dist(n, inf);
        dist[0] = 0;

        set<pair<long long, long long>> st;
        st.insert({0, 0});
        while (!st.empty()) {
            pair<long long, long long> pr = *(st.begin());
            st.erase(st.begin());

            long long v = pr.second;
            long long length = pr.first;

            for (auto u : g[v]) {
                if (length < dist[u.to]) {
                    st.erase({dist[u.to], u.to});
                    dist[u.to] = min(dist[u.to], length + u.w);
                    st.insert({dist[u.to], u.to});
                }
            }
        }

        if (dist[n - 1] == inf) {
            cout << -1 << '\n';
            return 0;
        }

        cout << max(0ll, dist[n - 1] - p);
    }

    if (num == 2) {
        long long mx_for_one = -1, ans = 0;
        for (int i = 0; i + 1 < n; i++) {
            mx_for_one = max(mx_for_one, w[i]);

            long long need = g[i][0].w;
            if (need <= p) {
                p -= need;
            } else {
                long long cur = (need - p) / mx_for_one + (bool)((need - p) % mx_for_one);
                ans += cur;
                p = (cur * mx_for_one - (need - p)) % mx_for_one;
            }
        }

        cout << ans << '\n';
    }

    if (num == 3 || num == 0) {
        vector<vector<long long>> newg(n, vector<long long>(n, -1));
        for (int i = 0; i < n; i++) {
            for (auto u : g[i]) {
                if (newg[i][u.to] != -1)
                    newg[i][u.to] = min(u.w, newg[i][u.to]);
                else newg[i][u.to] = u.w;
            }
        }

        /*for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                cout << newg[i][j] << '\t';
            }
            cout << '\n';
        }*/

        long long ans = 2000000000;
        get(n, newg, ans, p, w);
        if (ans < 2000000000) cout << ans << '\n';
        else cout << "-1\n";
    }

    return 0;
}
