#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define itn int
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define Int int
#define Itn int
#define pii pair<int, int>
#define X first
#define Y second

template<typename T>
istream &operator >> (istream &in, vector<T> &arr) {
    for(auto &to : arr) in >> to;
    return in;
}

template<typename T>
ostream &operator << (ostream &out, vector<T> &arr) {
    for(auto &to : arr) out << to << " ";
    return out;
}

const int INF = 1e9 + 7;
const int MOD = 998244353;
const int maxn = 1e7 + 1;

void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    if(G == 2) {
        vector<int> w(n);
        cin >> w;
        vector<int> g(n - 1);
        for(itn i = 0; i < m; ++i) {
            int x, y;
            cin >> x >> y;
            --x; --y;
            cin >> g[x];
        }
        int cur = 0;
        int ans = 0;
        multiset<int> tmr;
        tmr.insert(w[cur]);
        while(true) {
            while(cur < n - 1 && p >= g[cur]) {
                p -= g[cur];
                ++cur;
                tmr.insert(w[cur]);
            }
            if(cur == n - 1) {
                cout << ans << '\n';
                return;
            }
            ans += (g[cur] - p - 1) / *tmr.rbegin() + 1;
            p += (*tmr.rbegin()) * ((g[cur] - p - 1) / *tmr.rbegin() + 1);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int tmr = 1;
    //cin >> tmr;
    while(tmr--) {
        solve();
    }
}