//#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <algorithm>
#include <queue>

#define all(a) a.begin(), a.end()
#define forall(iiii, aaaa) for(auto& iiii: aaaa)
#define print(aaaa) forall(aaa, aaaa) cout << aaa << ' '; cout << '\n'

typedef long long ll;
typedef long double ld;

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll mod = 1e9+7, INF = 1e10 + 1;

ll bin_pow(ll n, ll p) {
    if (p == 0) return 1;
    if (p & 1) return n * bin_pow(n, p - 1) % mod;
    return bin_pow(n * n % mod, p / 2);
}

ll gcd(ll a, ll b) {
    while (b %= a) swap(a, b);
    return a;
}

void solve() {
    ll n, m, p, t;
    cin >> n >> m >> p >> t;
    vector < ll > w(n);
    forall(i, w) cin >> i;
    vector < vector < pair < ll, ll >>> g(n);
    for (ll i = 0; i < m; i++) {
        ll x, y ,c;
        cin >> x >> y >> c;
        x--; y--;
        g[x].emplace_back(y, c);
    }
    
    vector < ll > dist(n, INF);
    dist[0] = 0;
    queue < ll > q;
    q.push(0);
    vector < bool > used(n, false);
    used[0] = true;
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        forall(i, g[v]) {
            if (used[i.first]) continue;
            dist[i.first] = dist[v] + 1;
            used[i.first] = true;
            q.push(i.first);
        }
    }
    if (dist[n - 1] == INF) cout << -1;
    else cout << max(dist[n - 1] - p, 0ll);
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
//    cout << fixed << setprecision(12);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}