#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "lzcnt", "popcnt")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
//#define int ll

cosnt ll INF = 1e18 + 42;

void solve() {
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;
    vector<vector<pair<int, ll>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
    }

    vector<ll> dist(n, INF);
    dist[0] = 0;
    set<pair<ll, int>> q;
    q.insert({0, 0});
    while (!q.empty()) {
        auto [x, v] = *q.begin();
        q.erase(q.begin());
        for (auto& [u, w] : g[v])
            if (dist[u] > dist[v] + w) {
                q.erase({dist[u], u});
                dist[u] = dist[v] + w;
                q.insert({dist[u], u});
            }
    }
    cout << (dist[n - 1] == INF ? -1 : dist[n - 1] - p) << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}
