#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "lzcnt", "popcnt")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
#define int ll

cosnt ll INF = 1e18 + 42;

int n, m, p, gr;
vector<int> a;
vector<vector<pair<int, ll>>> g;

void solve1() {
    vector<ll> dist(n, INF);
    dist[0] = 0;
    set<pair<ll, int>> q;
    q.insert({0, 0});
    while (!q.empty()) {
        auto [x, v] = *q.begin();
        q.erase(q.begin());
        for (auto& [u, w] : g[v])
            if (dist[u] > dist[v] + w) {
                q.erase({dist[u], u});
                dist[u] = dist[v] + w;
                q.insert({dist[u], u});
            }
    }
    cout << (dist[n - 1] == INF ? -1 : dist[n - 1] - p) << endl;
}

void solve2() {
    vector<int> w(n);
    for (int i = 0; i < n - 1; ++i)
        w[i] = g[i][0].second;
    ll ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        int tmp = (max(0, w[i] - p) + a[i] - 1) / a[i];
        ans += tmp;
        p += tmp * a[i];
    }
    cout << ans << endl;
}

void solve() {
    cin >> n >> m >> p >> gr;
    a.assing(n, 0);
    for (auto& i : a)
        cin >> i;
    g.assing(n, {});
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
    }

    if (gr == 1)
        solve1();
    else if (gr == 2)
        solve2();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}
