#include "bits/stdc++.h"
using namespace std;

// cd /mnt/commons/
// g++ -DHOME -Wall -Wextra -DGLIBCXX_DEBUG 1.cpp && ./a.out 

#define int long long
#define ll long long


#define all(a) a.begin(), a.end()
#define vc vector
#define ld long double
#define forn(i , n) for(int i = 0; i < (int)n; i++)
#define fri(st , en , step) for(int i = st; i < (int)en ; i+=step)
#define frj(st , en , step) for(int j = st; j < (int)en ; j+=step)
#define sz(a) ((int)a.size())
#define pb push_back
#define mp make_pair


template<typename T>
ostream& operator<<(ostream& a, vc<T> b){
	forn(i , sz(b) - 1) a << b[i] << " ";
	if(sz(b)) a << b.back(); 
	return a;
}






#ifdef HOME
	#define o(a) << "[" << #a << ": " << a << "] "
#else
	#define o(a) ;
#endif



class debug{
public:
	debug(){}
	~debug(){
		#ifdef HOME
			cerr << endl;
		#endif
	}
	template<typename T>
	debug& operator<<(T a){
		#ifdef HOME
			cerr << a;
		#endif
		return *this;
	}
};

mt19937 rnd(1211);

template<typename T>
inline bool cmin(T &a, T b){
	if(a > b){
		a = b;
		return 1;
	}
	return 0;
}

template<typename T>
inline bool cmax(T &a, T b){
	if(a < b){
		a = b;
		return 1;
	}
	return 0;
}

const int MOD = 1e9 + 7;
const ld e = 1e-9;
const int inf = 1e18;
const int maxn = 802;




int n , m , p , g1;


vc<array<int , 2>> g[maxn];
int D[maxn][maxn][2];
inline void run(){
	cin >> n >> m >> p >> g1;
	vc<int> W(n) , t(n);

	forn(i , n){
		cin >> W[i];
		t[i] = W[i];
	}
	sort(all(t));
	t.resize(unique(all(t)) - t.begin());
	vc<int> pos(n);
	forn(i , n) pos[i] = lower_bound(all(t), W[i]) - t.begin();
	forn(i , m){
		int a , b , w;
		cin >> a >> b >> w;
		a--;
		b--;
		g[a].pb({b , w});
	}
	forn(i , n + 1) forn(j , n + 1) D[i][j][0] = inf;
	D[0][pos[0]][0] = 0;
	D[0][pos[0]][1] = p;
	
	set<array<int , 3>> q;
	while(sz(q)){
		auto v = *q.begin();
		q.erase(q.begin());
		int a = v[1];
		int b = v[2];
		// debug() o(b);
		for(auto x : g[a]){
			int delta = max(0ll , (x[1] -  D[a][b][1] + t[b] - 1) / t[b]);
			int day = D[a][b][0] + delta;
			int balance = D[a][b][1] + delta * t[b] - x[1];
			// if(D[x[0]][max(b , pos[x[0]])][0] == day){
			// 	if(cmax(D[x[0]][max(b , pos[x[0]])][1] , balance)){
			// 		array<int , 3> tmp = {D[x[0]][max(b , pos[x[0]])][0] , x[0] , max(b , pos[x[0]])};
			// 		q.insert(tmp);
			// 	}
			// }
			if(cmin(D[x[0]][max(b , pos[x[0]])][0] , day)){
				D[x[0]][max(b , pos[x[0]])][1] = balance;
				array<int , 3> tmp = {D[x[0]][max(b , pos[x[0]])][0] , x[0] , max(b , pos[x[0]])};
				q.insert(tmp);
			}
		}
	}

	int ans = inf;
	forn(i , n){
		cmin(ans , D[n - 1][i][0]);
	}
	q.clear();

	forn(i , n + 1) forn(j , n + 1) D[i][j][0] = inf;
	D[0][pos[0]][0] = 0;
	D[0][pos[0]][1] = p;


	q.insert({0 , 0 , pos[0]});
	while(sz(q) && (double)clock() / CLOCKS_PER_SEC < (double)0.95){
		auto v = *q.begin();
		q.erase(q.begin());
		int a = v[1];
		int b = v[2];
		// debug() o(b);
		for(auto x : g[a]){
			int delta = max(0ll , (x[1] -  D[a][b][1] + t[b] - 1) / t[b]);
			int day = D[a][b][0] + delta;
			int balance = D[a][b][1] + delta * t[b] - x[1];
			if(D[x[0]][max(b , pos[x[0]])][0] == day){
				if(cmax(D[x[0]][max(b , pos[x[0]])][1] , balance)){
					array<int , 3> tmp = {D[x[0]][max(b , pos[x[0]])][0] , x[0] , max(b , pos[x[0]])};
					q.insert(tmp);
				}
			}
			if(cmin(D[x[0]][max(b , pos[x[0]])][0] , day)){
				D[x[0]][max(b , pos[x[0]])][1] = balance;
				array<int , 3> tmp = {D[x[0]][max(b , pos[x[0]])][0] , x[0] , max(b , pos[x[0]])};
				q.insert(tmp);
			}
		}
	}
	
	forn(i , n){
		cmin(ans , D[n - 1][i][0]);
	}
	cout << ans << "\n";
}


signed main(){
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int tt = 1;
	// cin >> tt;
	while(tt--){
		run();
	}
	return 0;
}