#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_map>
#include<random>
#include<stack>
#include<deque>
#include<iomanip>
#include <cstring>

using namespace std;

//#pragma optimize("O3")
//#pragma optimize("avx2")
//#pragma optimize("unrool-loops")

#define int long long

random_device rd;
mt19937 gen(rd());

int w[10005];
vector<pair<int,int>> gr[10005];
int dist[1005];

void Dijkstra(int n) {
	for (int i = 0; i < n; i++){
		dist[i] = 1e15;
	}
	dist[0] = 0;
	set<pair<int, int>>s;
	s.insert({ 0, 0 });
	while (!s.empty()) {
		auto v = *s.begin();
		s.erase(s.begin());
		for (auto u : gr[v.second]) {
			if (dist[u.first] > v.first + u.second) {
				s.erase({ dist[u.first], u.first });
				dist[u.first] = v.first + u.second;
				s.insert({ dist[u.first], u.first });
			}
		}
	}
	return;
}

int pref[1005];
int rmore[1005];

int ans = 0;
void rek(int i, int p, int n) {
	if (i == n - 1) {
		return;
	}
	if (pref[rmore[i]] - pref[i] <= p) {
		rek(rmore[i], p - (pref[rmore[i]] - pref[i]), n);
		return;
	}
	ans += (pref[rmore[i]] - pref[i] - p + w[i] - 1) / w[i];
	p += ((pref[rmore[i]] - pref[i] - p + w[i] - 1) / w[i]) * w[i];
	rek(rmore[i], p - (pref[rmore[i]] - pref[i]), n);
	return;
}

int tabl[805][805];
int dist2[805][805];

void Dijkstra2(int st, int n) {
	for (int i = 0; i < n; i++) {
		dist2[st][i] = 1e15;
	}
	dist2[st][0] = 0;
	set<pair<int, int>>s;
	s.insert({ 0, 0 });
	while (!s.empty()) {
		auto v = *s.begin();
		s.erase(s.begin());
		for (auto u : gr[v.second]) {
			if (dist2[st][u.first] > v.first + u.second) {
				s.erase({ dist2[st][u.first], u.first });
				dist2[st][u.first] = v.first + u.second;
				s.insert({ dist2[st][u.first], u.first });
			}
		}
	}
	return;
}

vector<int> per;
void rek2(int i, int p, int n) {
	if (i == n - 1) {
		return;
	}
	if (dist2[per[i]][per[rmore[i]]] <= p) {
		rek(rmore[i], p - (pref[rmore[i]] - pref[i]), n);
		return;
	}
	ans += (dist2[per[i]][per[rmore[i]]] - p + w[per[i]] - 1) / w[i];
	p += ((dist2[per[i]][per[rmore[i]]] - p + w[per[i]] - 1) / w[i]) * w[i];
	rek(rmore[i], p - dist2[per[i]][per[rmore[i]]], n);
	return;
}

void solve() {
	for (int i = 0; i < 803; i++) {
		for (int j = 0; j < 803; j++) {
			tabl[i][j] = 1e15;
		}
	}
	int n, m, p, g;
	cin >> n >> m >> p >> g;

	for (int i = 0; i < n; i++) {
		cin >> w[i];
	}
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--; v--;
		tabl[u][v] = min(tabl[u][v], w);
		gr[u].push_back({ v, w });
	}
	if (g == 1) {
		Dijkstra(n);
		if (dist[n - 1] > 1e14) {
			cout << "-1" << "\n";
			return;
		}
		cout << max(0ll, dist[n - 1] - p) << "\n";
		return;
	}
	if (g == 2) {
		pref[0] = 0;
		for (int i = 0; i < n - 1; i++) {
			pref[i + 1] = pref[i] + gr[i][0].second;
		}
		deque<pair<int,int>> d;
		d.push_back({ n - 1, 1e14 });
		for (int i = n - 2; i >= 0; i--) {
			while (d.back().second <= w[i]) {
				d.pop_back();
			}
			rmore[i] = d.back().first;
			d.push_back({ i, w[i] });
		}
		rek(0, p, n);
		cout << ans << "\n";
	}
	if (g == 3) {
		for (int i = 0; i < n; i++) {
			Dijkstra2(i, n);
		}
		for (int i = 0; i < n; i++) {
			per.push_back(i);
		}
		do {
			deque<pair<int, int>> d;
			d.push_back({ n - 1, 1e14 });
			for (int i = n - 2; i >= 0; i--) {
				while (d.back().second <= w[per[i]]) {
					d.pop_back();
				}
				rmore[i] = d.back().first;
				d.push_back({ i, w[per[i]] });
			}
			rek2(0, p, n);

		} while (next_permutation(per.begin(), per.end()));
	}
	return;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	//freopen("Text.txt", "r", stdin);
	//freopen("", "w", stdout)

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
	return 0;
}