#include <bits/stdc++.h>

using namespace std;

constexpr long long inf = 1e18 + 7;

const int maxn = 805;

long long cost[maxn][maxn];

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cost[i][j] = inf;
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        cost[i][i] = 0;
    }
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        a--, b--;
        cost[a][b] = min(cost[a][b], (long long)s);
    }
    for (int mid = 0; mid < n; ++mid) {
        for (int a = 0; a < n; ++a) {
            for (int b = 0; b < n; ++b) {
                cost[a][b] = min(cost[a][b], cost[a][mid] + cost[mid][b]);
            }
        }
    }
    if (cost[0][n - 1] == inf) {
        cout << -1 << '\n';
        return;
    }
    if (g == 1) {
        cout << max(0LL, cost[0][n - 1] - p) << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
