#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 1e15 + 7;

int n, m, p;
vector<int> wd;
vector<vector<pair<int, int>>> g;

int dijkstra(int end_v) {
    vector<pair<int, int>> d(n, pair<int, int>(INF, -INF));
    set<vector<int>> q;
    q.insert({0, -p, 0});
    d[0] = {0, p};
    while (!q.empty()) {
        int v = (*q.begin())[2],
        val = (*q.begin())[0],
        money = (*q.begin())[1];
        money = -money;
        q.erase(q.begin());
        for (auto [u, w] : g[v]) {
            while (money < w) {
                val++;
                money += wd[v];
            }
            money -= w;
            if (val < d[u].first || (val == d[u].first && money > d[u].second)) {
                d[u].first = val;
                d[u].second = money;
                q.insert({d[u].first, -d[u].second, u});
            }
        }
    }
    return d[end_v].first;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int G;
    cin >> n >> m >> p >> G;
    if (G == 2) {
        int res = 0;
        wd.resize(n);
        for (int &i : wd)
            cin >> i;
        vector<int> w(n);
        for (int i = 1; i < n; i++) {
            int a, b;
            cin >> a >> b >> w[i];
        }
        for (int i = 1; i < n; i++) {
            while (p < w[i]) {
                p += wd[i - 1];
                res++;
            }
            p -= w[i];
        }
        cout << res << "\n";
        return 0;
    } else if (G == 3) {
    }
    wd.resize(n);
    g.resize(n);
    for (int &i : wd)
        cin >> i;
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        g[a - 1].push_back({b - 1, s});
    }
}