#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define debug(x) cerr << "[" << #x << "]: " << x << endl
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

vector<vector<pll>> gr;

vector<ll> calc(int v){
    int n = sz(gr);
    vector<ll> d(n, 1e14);
    d[v] = 0;
    set<pll> q;
    for (int i = 0; i < n; i++) q.insert({d[i], i});
    while (!q.empty()){
        pii tp = *q.begin();
        q.erase(q.begin());
        int cnt = 0;
        for (auto i : gr[tp.ss]){
            if (tp.ff + i.ss < d[i.ff]){
                q.erase({d[i.ff], i.ff});
                d[i.ff] = tp.ff + i.ss;
                q.insert({d[i.ff], i.ff});
                cnt++;
            }
        }
        if (cnt == 0) break;
    }
    return d;
}

void solve(){
    int n, m, g;
    ll p;
    cin >> n >> m >> p >> g;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    gr.resize(n);
    for (int i = 0; i < m; i++){
        int u, v;
        ll x;
        cin >> u >> v >> x; u--, v--;
        gr[u].pb({v, x});
        //gr[v].pb({u, x});
    }
    vector<vector<ll>> d(n, vector<ll>(n));
    for (int i = 0; i < n; i++) d[i] = calc(i);
    vector<vector<pll>> dp(n + 1, vector<pll>(n, {1e12, -1e12}));
    dp[0][0] = {0, p};
    if (a[0] != 0){
        for (int i = 1; i < n; i++){
            ll c = (d[0][i] - p - 1) / a[0] + 1;
            c = max(c, 0ll);
            dp[0][i] = {c, c * a[0] + p - d[0][i]};
        }
    }
    for (int i = 1; i <= n; i++){
        for (int j = 0; j < n; j++){
            for (int k = 0; k < n; k++){
                if (j == k) continue;
                ll s = d[k][j];
                ll c = 0;
                ll cr = dp[i - 1][k].ss;
                if (s - cr > 0 && a[k] != 0) {
                    c = (s - cr - 1) / a[k] + 1;
                    c = max(c, 0ll);
                }
                pll cur = dp[i - 1][k];
                cur.ff += c;
                cur.ss = c * a[k] - s;
                if (cur.ff < dp[i][j].ff || cur.ff == dp[i][j].ff && cur.ss >= dp[i][j].ss) dp[i][j] = cur;
            }
        }
    }
    ll ans = 1e12;
    for (int i = 0; i <= n; i++) if (dp[i][n - 1].ff < ans) ans = dp[i][n - 1].ff;
    if (ans == 1e12){
        cout << -1 << endl;
        return;
    }
    cout << ans << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    //cin >> n;
    while(n--) solve();
}
