#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

#ifdef CLOWN
void dbg(ll a) {cout << a << "\n";}
void dbg(int a) {cout << a << "\n";}
void dbg(string a) {cout << a << "\n";}
void dbg(ll a, ll b) {cout << a << " " << b << "\n";}
void dbg(int a, int b) {cout << a << " " << b << "\n";}
void dbg(ll a, ll b, ll c) {cout << a << " " << b << " " << c << "\n";}
void dbg(int a, int b, int c) {cout << a << " " << b << " " << c << "\n";}
void dbg(vector<ll> & a) {for (auto i : a) cout << i << " "; cout << "\n";}
void dbg(vector<int> & a) {for (auto i : a) cout << i << " "; cout << "\n";}
#else
#define dbg(...)
#endif

#define int ll

void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    vector<vector<pair<int, int>>> g(n);
    vector<int> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--, v--;
        g[u].push_back({v, c});
    }
    vector<int> pref(n);
    for (int i = 0; i < n - 1; i++) {
        pref[i + 1] = g[i][0].second;
    }
    dbg(pref);
    int cur = p, amount = 0;
    for (int i = 1; i < n; i++) {
        dbg(cur, amount);
        if (cur >= pref[i]) {
            cur -= pref[i];
        } else {
            int v = pref[i] - cur, val = 1e9, st = 0;
            for (int j = 0; j <= i; j++) {
                int c = (w[j] + v - 1) / w[j];
                if (c < val || c == val && c * w[j] > st) {
                    val = c;
                    st = c * w[j];
                }
            }
            amount += val;
            cur = cur + st - pref[i];
        }
    }
    cout << amount << "\n";
}

int32_t main() {
#ifdef CLOWN
    freopen("C://Users//olymp//CLionProjects//untitled//input.txt", "r", stdin);
    freopen("C://Users//olymp//CLionProjects//untitled//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
