#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

#ifdef CLOWN

void dbg(ll a) { cout << a << "\n"; }

void dbg(int a) { cout << a << "\n"; }

void dbg(string a) { cout << a << "\n"; }

void dbg(ll a, ll b) { cout << a << " " << b << "\n"; }

void dbg(int a, int b) { cout << a << " " << b << "\n"; }

void dbg(ll a, ll b, ll c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(int a, int b, int c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(vector<ll> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

void dbg(vector<int> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

#else
#define dbg(...)
#endif

#define int ll

int ANS = 1e9;

int n, m, p, G, cnt = 2e6;

void rec(vector<int> &pref, vector<int> &cur, vector<int> &w, int id) {
    if (cnt == 0) return;
    if (id >= n) return;
    cnt--;
    int val = accumulate(all(cur), 0);
    int v = p + w[0] * cur[0];
    for (int i = 1; i < n; i++) {
        v -= pref[i];
        if (v < 0) {
            val = 1e9;
            break;
        }
        v += w[i] * cur[i];
    }
    if (ANS > val) {
        ANS = val;
        dbg(cur);
    }
    for (int i = 0; i < 20; i++) {
        int was = cur[id];
        cur[id] = i;
        rec(pref, cur, w, id + 1);
        cur[id] = was;
    }
}

void solve() {
    cin >> n >> m >> p >> G;
    vector<vector<pair<int, int>>> g(n);
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        w[i] = rnd() % 10 + 3;
        cin >> w[i];
    }
    dbg(w);
    for (int i = 0; i < m; i++) {
        int u = i, v = i + 1, c;
        c = rnd() % 50;
        cin >> u >> v >> c;
        u--, v--;
//        cout << u + 1 << " " << v + 1 << " " << c << "\n";
        g[u].push_back({v, c});
    }
    if (G == 2) {
        vector<int> pref(n);
        for (int i = 0; i < n - 1; i++) {
            pref[i + 1] = g[i][0].second;
        }
        int cur = p, amount = 0;
        vector<int> a(n);
//        rec(pref, a, w, 0);
//        dbg(ANS);
        int mx = w[0];
        for (int i = 1; i < n; i++) {
            if (cur >= pref[i]) {
                cur -= pref[i];
            } else {
                int v = pref[i] - cur, val = 1e18, st = 0;
                int c = (mx + v - 1) / mx;
                    val = c;
                    st = c * mx;
                amount += val;
                cur = cur + st - pref[i];
            }
            mx = max(mx, w[i]);
        }
        cout << amount << "\n";
    } else {
        vector<int> d(n, 1e18);
        d[0] = 0;
        set<pair<int, int>> s;
        s.insert({0, 0});
        while (!s.empty()) {
            auto [len, u] = *s.begin();
            s.erase(s.begin());
            for (auto [v, c]: g[u]) {
                if (d[v] > d[u] + c) {
                    s.erase({d[v], v});
                    d[v] = d[u] + c;
                    s.insert({d[v], v});
                }
            }
        }
        if (d[n - 1] == 1e18) {
            cout << "-1\n";
            return;
        }
        cout << max(0LL, d[n - 1] - p) << "\n";
    }
}

int32_t main() {
#ifdef CLOWN
    freopen("C://Users//olymp//CLionProjects//untitled//input.txt", "r", stdin);
    freopen("C://Users//olymp//CLionProjects//untitled//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}