#include <bits/stdc++.h>

using namespace std;

const long long INF=1e15;
vector<long long>w;
bool cmp(long long a, long long b) {
    return w[a] < w[b];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n,m,p,g;
    cin >> n >> m >> p >> g;
    w.resize(n);
    for (long long i = 0;i<n;i++) {
        cin >> w[i];
    }
    long long d[n][n];
    for (long long i =0;i<n;i++) {
        for( long long j = 0;j<n;j++) {
            d[i][j]= INF;
        }
        d[i][i] = 0;
    }
    for (long long i = 0;i<m;i++) {
        long long a,b,s;
        cin >> a >> b >> s;
        a--;
        b--;
        d[a][b] =min(s, d[a][b]);
    }
    for (long long k = 0;k<n;k++) {
        for (long long i = 0;i<n;i++) {
            for (long long j = 0;j<n;j++) {
                d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
            }
        }
    }
    if (g==1) {
        if (d[0][n-1] == INF) {
            cout << "-1\n";
        }
        else {
            cout << max(0ll, d[0][n-1] - p);
        }
    }
    else if (g==2){
        long long cnt = 0;
        long long mx = 0;
        for (long long i = 0;i<n-1;i++) {
            mx = max(mx, w[i]);
            if (p < d[i][i+1]) {
                cnt += (d[i][i+1] - p + mx-1) / mx;
                p += (d[i][i+1] - p + mx-1) / mx * mx;
            }
            p -= d[i][i+1];
        }
        cout << cnt;
    }
    else if (g==3){
        long long prev_p = p;
        long long mn =INF;
        for (long long mask = 1;mask <(1<<n);mask++){
            p = prev_p;
            vector<pair<long long, long long>> v;
            for (long long i = 0;i<n;i++) {
                if ((mask >> i)&1) {
                    v.push_back({w[i], i});
                }
            }
            sort(v.begin(), v.end());
            long long mx = 0;
            long long cnt=0;
            v.insert(v.begin(), {w[0], 0});
            v.push_back({w[n-1], n-1});
            for (long long i = 0;i<(long long)v.size()-1;i++) {
                long long a = v[i].second;
                long long b = v[i+1].second;
                if (d[a][b] == INF) {
                    cnt=-1;
                    break;
                }
                mx = max(mx, v[i].first);
                if (p < d[a][b]) {
                    cnt += (d[a][b] - p + mx-1) / mx;
                    p += (d[a][b] - p + mx-1) / mx * mx;
                }
                p -= d[a][b];
            }
            if (cnt != -1) {
                mn = min(mn, cnt);
            }
        }
        if (mn == INF) {
            cout << "-1\n";
        }
        else {
            cout << mn << "\n";
        }
    }
    else {
        vector<long long> v(n);
        iota(v.begin(), v.end(), 0);
        sort(v.begin(), v.end(), cmp);
        v.insert(v.begin(), 0);
        v.push_back(n-1);
        vector<pair<long long, long long>> dp(n+2, {INF, 0});
        dp[0] = {0, -p};
        for (long long i = 1;i<=n+1;i++) {
            for (long long j = 0;j<i;j++) {
                if (d[v[j]][v[i]]==INF) {
                    continue;
                }
                long long delta = d[v[j]][v[i]] + dp[j].second;
                long long new_p = -dp[j].second;
                long long new_c = dp[j].first;
                if (delta > 0) {
                    long long ww = max(w[v[j]], w[0]);
                    new_c +=(delta+ww-1)/ww;
                    new_p += (delta+ww-1)/ww*ww;
                }
                new_p -= d[v[j]][v[i]];
                if (make_pair(new_c, -new_p) < dp[i]) {
                    dp[i] = {new_c, -new_p};
                }
            }
        }
        if (dp[n+1].first==INF) {
            cout << "-1\n";
        }
        else {
            cout << dp[n+1].first << "\n";
        }

        
    }

}