#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

ll n, m, p, gro;
vector<ll>costs;

void w1() {
    vector<vector<pair<ll, ll>>> g(n);
    for(int i=0;i<m;i++){
        ll a, b, c;
        cin>>a>>b>>c;
        a--; b--;
        g[a].push_back({b, c});
    }
    vector<ll>dists(n, 1e18);
    dists[0]=0;
    set<pair<ll, ll>>go;
    go.insert({0, 0});
    while(!go.empty()) {
        auto p = *go.begin();
        go.erase(go.begin());
        for(auto &i:g[p.second]) {
            if(dists[i.first]>dists[p.second]+i.second) {
                go.erase({dists[i.first], i.first});
                dists[i.first]=dists[p.second]+i.second;
                go.insert({dists[i.first], i.first});
            }
        }
    }
    if(dists[n-1]==1e18)
        cout << -1;
    else
        cout << max(dists[n-1]-p, 0ll);
}

void mass(){
    vector<vector<pair<ll, ll>>> g(n);
    for(int i=0;i<m;i++){
        ll a, b, c;
        cin>>a>>b>>c;
        a--; b--;
        g[a].push_back({b, c});
    }
    ll prevm=costs[0];
    ll ans=0;
    for(int i=0;i<n-1;i++){
        if(p>=g[i].back().second){
            p-=g[i].back().second;
        }
        else{
            ans+=(g[i].back().second-p+prevm-1)/prevm;
            p+=(g[i].back().second-p+prevm-1)/prevm*prevm;
            p-=g[i].back().second;
        }
        prevm = max(costs[i+1], prevm);
    }
    cout<<ans;
}

void full() {
    vector<vector<pair<ll, ll>>> g(n);
    for (int i = 0; i < m; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].push_back({b, c});
    }
    vector<vector<ll>> dists(n);
    for (int i = 0; i < n; i++) {
        vector<ll> dist(n, 1e18);
        dist[i]=0;
        set<pair<ll, ll>> go={{0, i}};
        while(!go.empty()) {
            auto p = *go.begin();
            go.erase(go.begin());
            for(auto &k : g[p.second]) {
                if (dist[k.first] > dist[p.second]+k.second){
                    go.erase({dist[k.first], k.first});
                    dist[k.first] = dist[p.second]+k.second;
                    go.insert({dist[k.first], k.first});
                }
            }
        }
        for(auto&i:dist)
            if(i==1e18)
                i=-1;
        dists[i]=dist;
    }
    vector<pair<ll, ll>>dp(n, {1e18, -1});
    dp[0]={0, p};
    set<pair<ll, ll>>go;
    go.insert({0, 0});
    while(!go.empty()){
        auto p = *go.begin();
        go.erase(go.begin());
        for(int i=0;i<n;i++){
            if(dists[p.second][i]==-1)
                continue;
            pair<ll, ll>cango;
            if(dists[p.second][i]<=dp[p.second].second)
                cango = {dp[p.second].first, dp[p.second].second-dists[p.second][i]};
            else {
                ll need = (dists[p.second][i]-dp[p.second].second+costs[p.second]-1)/costs[p.second];
                cango =  {dp[p.second].first+need, dp[p.second].second+need*costs[p.second]-dists[p.second][i]};
            }
            if(dp[i].first>cango.first || dp[i].first==cango.first && dp[i].second<cango.second) {
                go.erase({dp[i].first, i});
                dp[i] = cango;
                go.insert({dp[i].first, i});
            }
        }
    }
    if(dp[n-1].second==-1){
        cout<<-1;
    }else
        cout<<dp[n-1].first;
}

void solve() {
    cin >> n >> m >> p >> gro;
    costs.resize(n);
    for(auto&i:costs) cin>>i;
    if(gro == 1)
        w1();
    if(gro==2)
        mass();
    if(gro>=3 || gro==0)
        full();
}

int main() {
    //cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}