#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define all(x) (x).begin(), (x).end()
#define p2(x) ((x)*(x))
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
constexpr int INF = (1ll << 60);
struct ed {
    int to, w;
};
vector<vector<ed>> g;
vector<int> w;
int n, m, p, G;

void solve1() {
    vector<int> d(n, INF);
    d[0] = 0;
    set<pair<int, int>> q;
    q.insert({0, 0});
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto w : g[v]) {
            if (d[w.to] > d[v] + w.w) {
                q.erase({d[w.to], w.to});
                d[w.to] = d[v] + w.w;
                q.insert({d[w.to], w.to});
            }
        }
    }
    if (d[n - 1] == INF) {
        cout << -1;
    } else {
        cout << max(0ll, d[n - 1] - p);
    }
}

void solve2() {
    set<int> s;
    int cnt = 0;
    for (int c = 0; c < n; ++c) {
        s.insert(w[c]);
        if (p < g[c][0].w) {
            int k = (g[c][0].w - p + *s.rbegin() - 1) / *s.rbegin();
            cnt += k;
            p += k * *s.rbegin();
        }
        p -= g[c][0].w;
    }
    cout << cnt;
}

signed main() {
    fastio;
    cin >> n >> m >> p >> G;
    w.resize(n);
    for (auto& i : w) cin >> i;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].push_back({b, c});
    }
    if (G == 1) {
        solve1();
    } else if (G == 2) {
        solve2();
    }
}
