#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int inf = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 800 + 5;
ll w[MAXN];

vector<pair<int, ll>> gr[MAXN];
ll d[MAXN];
int used[MAXN];

void solve() {
    int n, m, g;
    ll s;
    cin >> n >> m >> s >> g;

    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }

    for (int i = 0; i < m; i++) {
        int v, u;
        ll wi;
        cin >> v >> u >> wi;
        v--;
        u--;
        gr[v].pb({u, wi});
    }

    if (g == 1) {
        fill(d, d + MAXN, LLONG_MAX);
        set<pair<ll, int>> q;
        q.insert({d[0] = 0, 0});
        while (!q.empty()) {
            int v = q.begin()->Y;
            used[v] = 1;
            q.erase(q.begin());
            for (auto [u, e]: gr[v]) {
                if (used[u] == 0 && d[u] > d[v] + e) {
                    q.erase({d[u], u});
                    q.insert({d[u] = d[v] + e, u});
                }
            }
        }
        if (d[n - 1] == LLONG_MAX) {
            cout << "-1\n";
        } else {
            cout << max(0LL, d[n - 1] - s) << '\n';
        }
    } else if (g == 2) {
        vector<ll> a;
        vector<ll> D = {0};
        int cur = 0;
        bool metn = false;
        while (true) {
            a.pb(w[cur]);
            if (cur == n - 1) {
                metn = true;
                break;
            }
            if (sz(gr[cur]) == 0)break;
            D.pb(D.back() + gr[cur][0].Y);
            cur = gr[cur][0].X;
        }

        if (!metn) {
            cout << "-1\n";
        } else {
            int N = sz(a);
            ll ans = 0;
            for (int i = 0; i < N - 1;) {
                int j = i + 1;
                while (j < N - 1 && a[j] < a[i])j++;
                ll nd = max(0LL, D[j] - D[i] - s);
                ll by = (nd + a[i] - 1) / a[i];
                s -= D[j] - D[i];
                s += a[i] * by;
                ans += by;
                i = j;
            }
            cout << ans << '\n';
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}
