﻿#include <iostream>
#include <random>
#include <vector>
#include<string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <stack>
#include <iomanip>
#include <math.h>
#include <queue>
#include <deque>

using namespace std;

#define int long long

#define all(arr) arr.begin(), arr.end()
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

const int INF = 1e15;

#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
mt19937 rnd(time(0));

vector<vector<pii>> g;
vector<int> a;

signed main()
{
	int n, m, p, g0;
	cin >> n >> m >> p >> g0;
	g.resize(n);
	a.resize(n);
	
	for (auto& i : a) cin >> i;
	for (int i = 0; i < m; ++i) {
		int v, u, w;
		cin >> v >> u >> w;
		g[v-1].push_back({ u-1, w });
	}

	vector<int> dist(n, INF);
	dist[0] = 0;
	for (int t = 0; t < n; ++t) {
		for (int v = 0; v < n; ++v) {
			for (auto& e : g[v]) {
				dist[e.first] = min(dist[e.first], dist[v] + e.second);
			}
		}
	}

	int d = dist[n - 1];
	cout << max(0ll, d - p);
}
