#include <iostream>
#include <algorithm>
#include <fstream>

#include <vector>
#include <map>
#include <set>

#include <stack>
#include <queue>
#include <deque>

using namespace std;

using ll = long long;
using ld = long double;
using vl = vector<long long>;
using vvl = vector<vector<long long>>;

int main(){
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    if (g == 2){
        vl W(n);
        for (ll i = 0; i < n; i++){
            cin >> W[i];
            if (i != 0){
                W[i] = max(W[i], W[i - 1]);
            }
        }
        ll a, b;
        vl S(n);
        for (ll i = 0; i < m; i++){
            cin >> a >> b >> S[i];
        }

        vl ans(n);
        ans[0] = 0;
        ll curr_p = p;
        for (ll i = 1; i < n; i++){
            if (curr_p - S[i - 1] >= 0){
                ans[i] = ans[i - 1];
                curr_p -= S[i - 1];
                continue;
            }
            ll delta = S[i - 1] - curr_p;
            ans[i] = ans[i - 1] + (delta + W[i - 1] - 1) / W[i - 1];
            curr_p -= S[i - 1];
            curr_p += ((delta + W[i - 1] - 1) / W[i - 1]) * W[i - 1];
        }
        cout << ans.back();
    }
    return 0;
}