#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define int long long
//#define int __int128

const int N = 1000;
vector<pair<int, int>> g[N];

struct Node {
    int concert_cnt;
    int v;
    int maxpref;
    int bal;

};

int updiv(int a, int b){
    if(a <= 0) return 0;
    return (a - 1) / b + 1;
}
const int inf = 1e18;
int32_t main(){
    ll n, m, p, testik;
    cin >> n >> m >> p >> testik;

    vector<int> w(n + 1,0);
    for(int i=1;i<=n;++i){
        ll x;
        cin >> x;
        w[i] = x;
    }
    for(int i=0;i<m;++i){
        ll f1, f2, f3;
        cin >> f1 >> f2 >> f3;
        g[f1].push_back({f2, f3});
    }
    if(testik == 1){
        queue<Node> q;
        vector<int> mxpref(n + 1, -inf);
        vector<int> mncnt(n + 1, inf);
        vector<int> mxbal(n + 1, -inf);
        q.push({0,1,w[1],p});
        while(!q.empty()){
            auto [cnt, v, pref, bal] = q.front();
            q.pop();
            if(!(pref > mxpref[v] || cnt < mncnt[v] || bal > mxbal[v])) continue;
            mxpref[v] = max(mxpref[v], pref);
            mncnt[v] = min(mncnt[v], cnt);
            mxbal[v] = max(mxbal[v], bal);
            for(auto [to, cw]:g[v]){
                int needconc = updiv(cw-bal, pref);
                ll t1 = cnt + needconc;
                ll t2 = bal-cw+needconc*pref;
                q.push({t1, to, max(pref,w[to]), t2});
            }
        }
        if(mncnt[n] == inf){
            if(testik == 5) assert(0);
            cout << -1;
            return 0;
        }
        cout << (ll)mncnt[n];
        return 0;
    }

    vector<bool> used(n + 1, false);

    vector<vector<vector<int>>> tt(n + 1);
    int root;
    function<void(int, int,int,int)> dfs = [&](int v, int cnt, int pref, int bal){
        for(auto [to, cw]:g[v]){
            int needconc = updiv(cw-bal, pref);
            ll t1 = cnt + needconc;
            ll t2 = bal-cw+needconc*pref;
            if(used[to]){
                if(to == root){
                    bool fl = true;
                    for(auto &r:tt[v]){
                        if(r[0] <= cnt && pref <= r[1] && bal <= r[2]) {
                            fl = false;
                            break;
                        }
                    }
                }
                continue;
            }
            dfs(to, t1, max(pref, w[to]), t2);
        }
    };

    for(int i=1;i<=n;++i){
        dfs(i, 0, w[i], p);
    }

    queue<Node> q;
    vector<int> mncnt(n + 1, inf);
    q.push({0,1,w[1],p});
    while(!q.empty()){
        auto y = q.front();
        auto [cnt, v, pref, bal] = y;
        q.pop();
        bool fl = true;
//        if(tt[v].size() > 6500) continue;
        if(cnt > mncnt[n]) continue;
        for(auto &r:tt[v]){
            if(r[0] <= cnt && pref <= r[1] && bal <= r[2]) {
                fl = false;
                break;
            }
        }

        if(!fl) continue;
        mncnt[v] = min(cnt, mncnt[v]);
        tt[v].push_back({cnt, pref, bal});
        for(auto [to, cw]:g[v]){
            int needconc = updiv(cw-bal, pref);
            ll t1 = cnt + needconc;
            ll t2 = bal-cw+needconc*pref;
            q.push({t1, to, max(pref,w[to]), t2});
        }
    }
    if(mncnt[n] == inf){
//        if(testik == 5) assert(0);
        cout << -1;
        return 0;
    }
    cout << (ll)mncnt[n];
}