#include <bits/stdc++.h>

#pragma gcc target("avx2")

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long
#define ld long double

ll INF = 1e18;

int MAXN = 800;

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; i++)
        cin >> w[i];
    
    vector<vector<ll>> dist(n, vector<ll>(n, INF));
    for (int i = 0; i < n; i++)
        dist[i][i] = 0;

    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        a--; b--;
        dist[a][b] = min(dist[a][b], (ll)s);
    }

    for (int v = 0; v < n; v++) {
        for (int a = 0; a < n; a++) {
            for (int b = 0; b < n; b++) {
                dist[a][b] = min(dist[a][b], dist[a][v] + dist[v][b]);
            }
        }
    }
    if (dist[0][n - 1] == INF) {
        cout << "-1\n";
        return;
    }

    vector<pair<ll, ll>> dp(n, { INF, 0 });
    dp[0] = { 0, p };
    for (int i = 0; i < n; i++) {
        for (int v = 0; v < n; v++) {
            for (int p = 0; p < n; p++) {
                if (dist[p][v] == INF) continue;
                ll cnt = max(0ll, (dist[p][v] - dp[p].S + w[p] - 1) / w[p]);
                ll ost = dp[p].S + cnt * w[p] - dist[p][v];
                pair<ll, ll> cur = { dp[p].F + cnt, ost };
                if (dp[v].F > cur.F || dp[v].F == cur.F && dp[v].S < cur.S)
                    dp[v] = cur;
            }
        }
    }
    cout << dp[n - 1].F;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
}