#include "bits/stdc++.h"
//#pragma GCC optimize("Ofast,unroll-loops")

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
//#define endl '\n'

using namespace std;

mt19937 gen(time(nullptr));
const ll base = 177013;
const ll mod = 1e9 + 7;

struct S{
    int a, b;
    int g;
};

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }

    vector<S> ss(m);
    for (int i = 0; i < n; ++i) {
        cin >> ss[i].a >> ss[i].b >> ss[i].g;
        ss[i].a--, ss[i].b--;
    }

    if(g == 1){
        vector<ll> dp(n, INT64_MAX);
        dp[0] = 0;
        for (int i = 0; i < 10000; ++i) {
            for (auto u : ss) {
                if(dp[u.a] < INT64_MAX)
                    dp[u.b] = min(dp[u.b], dp[u.a] + u.g);
            }
        }
        if(dp[n - 1] == INT64_MAX){
            cout << -1 << endl;
        }else{
            cout << max(0LL, dp[n - 1] - p) << endl;
        }
    }else if (g == 2){
        vector<int> pr_max(m);
        pr_max[0] = w[0];
        for (int i = 1; i < n; ++i) {
            pr_max[i] = max(pr_max[i - 1], w[i]);
        }
        ll e = 0;
        for (int i = 0; i < n - 1; ++i) {
            while (p < ss[i].g){
                ld k = ss[i].g - p;
                ll f = ceill(k / pr_max[i]);
                p += f * pr_max[i];
                e += f;
            }
            p -= ss[i].g;
        }
        cout << e << endl;
    }
}