#include<bits/stdc++.h>

#define pb push_back
#define ld  double
#define all(a) a.begin(), a.end()
#define ll long long

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll INF = 1e18;
const int N = 801, M = 1024;
pair<ll, int> d[N][N];
vector<pair<int, int>> g[N];
vector<int> u;
int w[N];

array<ll, 3> t[2 * M];

array<ll, 3> cmp(array<ll, 3> &a, array<ll, 3> &b) {
    if (a[0] < b[0] || (a[0] == b[0] && a[1] > b[1])) {
        return a;
    } else {
        return b;
    }
}

pair<ll, int> cmp2(pair<ll, int> &a, pair<ll, int> &b) {
    if (a.first < b.first || (a.first == b.first && a.second > b.second)) {
        return a;
    } else {
        return b;
    }
}

bool better(pair<ll, int> &a, pair<ll, int> &b) {
    return (a.first < b.first || (a.first == b.first && a.second > b.second));
}

void upd(int i, pair<ll, int> val) {
    array<ll, 3> need{val.first, val.second, i};
    i += M;
    t[i] = need;
    for (; i > 1; i /= 2) {
        t[i / 2] = cmp(t[i], t[i ^ 1]);
    }
}

void clean() {
    for (int i = 0; i < 2 * M; i++) {
        t[i] = {INF, -1, -1};
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            d[i][j] = {INF, -1};
        }
    }
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        u.pb(w[i]);
    }
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        a--, b--;
        g[a].pb({b, s});
    }
    sort(all(u));
    u.erase(unique(all(u)), u.end());
    for (int i = 0; i < n; i++) {
        w[i] = lower_bound(all(u), w[i]) - u.begin();
    }
    d[0][w[0]] = {0, p};
    int sz = u.size();
    for (int i = 0; i < sz; i++) {
        clean();
        for (int v = 0; v < n; v++) {
            if (d[v][i].first != INF) {
                upd(v, d[v][i]);
            }
        }
        while (t[1][0] != INF) {
            int v = t[1][2];
            upd(v, {INF, -1});
            if (w[v] > i) {
                d[v][w[v]] = cmp2(d[v][w[v]], d[v][i]);
                continue;
            }
            for (auto to : g[v]) {
                pair<ll, int> p;
                if (to.second <= d[v][i].second) {
                    p = {d[v][i].first, d[v][i].second - to.second};
                } else {
                    int need = (to.second - d[v][i].second + u[i] - 1) / u[i];
                    p = {d[v][i].first + need, d[v][i].second + u[i] * need - to.second};
                }
                if (better(p, d[to.first][i])) {
                    upd(to.first, p);
                    d[to.first][i] = p;
                }
            }
        }
    }
    ll ans = INF;
    for (int i = 0; i < sz; i++) {
        ans = min(ans, d[n - 1][i].first);
    }
    cout << (ans == INF ? -1 : ans) << endl;
    return 0;
}
