#ifdef WIN64
    #define _GLIBCXX_DEBUG
#endif // WIN64
#include "bits/stdc++.h"

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple
#define isz(x) (int) x.size()
#define xx first
#define yy second

#ifdef WIN64
    #define check(x) cerr << (#x) << " = " << x << "\n"
    template<class T> void print(T* ar, int sz) {
        for (int i = 0; i < sz; ++i) cerr << ar[i] << " ";
        cerr << "\n";
    }
#else
    #define check(x) 17
    template<class T> void print(T* ar, int sz) {}
#endif // WIN64

const int N = (int) 800 + 1;
const int INF = (int) 1e9 + 117;
const int MOD = (int) 1e9 + 7;
const long long INFll = (long long) 2e18 + 117;
const double EPS = 1e-8;

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

template<class T> bool inmin(T& x, T y) {
    if (y < x) {
        x = y;
        return 1;
    }
    return 0;
}

template<class T> bool inmax(T& x, T y) {
    if (y > x) {
        x = y;
        return 1;
    }
    return 0;
}

#define int long long

using Pt = pair<int, int>;
using ll = long long;

int n, m, p, gt;

vector<pair<int, int>> g[N];
__int128 d[N], pp[N];
set<tuple<__int128, __int128, __int128, __int128>> st;
int w[N];

int solve14() {
    fill(d, d + n, INFll);
    fill(pp, pp + n, INFll);
    st.clear();
    st.insert(mkt(0, -p, w[0], 0));
    d[0] = 0;
    pp[0] = -p;
    while (isz(st)) {
        auto [curd, curp, mx, v] = *st.begin();
        st.erase(st.begin());
        for (auto [to, s] : g[v]) {
            if (curd + (curp + s > 0 ? (curp + s - 1) / mx + 1 : 0) < d[to]) {
                st.erase(mkt(d[to], pp[to], max(mx, (__int128) w[to]), to));
                d[to] = curd + (curp + s > 0 ? (curp + s - 1) / mx + 1 : 0);
                pp[to] = curp + s + (curp + s > 0 ? - (__int128) ((curp + s - 1) / mx + 1) * mx : 0);
                st.insert(mkt(d[to], pp[to], max(mx, (__int128) w[to]), to));
            }
        }
    }
    //print(d, n);
    if (d[n - 1] == INFll || pp[n - 1] > 0) cout << "-1\n";
    else cout << max(0ll, (ll) d[n - 1]) << "\n";
    return 0;
}

vector<int> ise[11][11]{};
int pr[11];

int solve3() {
    for (int i = 0; i < n; ++i) {
        for (auto [j, s] : g[i]) {
            ise[i][j].push_back(s);
        }
    }

    for (int i = 0; i < n; ++i) for (int j = 0; j < n; ++j) sort(all(ise[i][j]));

    iota(pr, pr + n, 0);

    int ans = INF;

    do {
        print(pr, n);
        bool ok = 1;
        for (int i = 0; i < n - 1; ++i) {
            if (pr[i] == n - 1) break;
            check(isz(ise[pr[i]][pr[i + 1]]));
            if (!isz(ise[pr[i]][pr[i + 1]])) {
                ok = 0;
            }
        }
        if (!ok) continue;
        int mx = w[0];
        int res = 0;
        __int128 cur = -p;
        for (int i = 0; i < n - 1; ++i) {
            if (pr[i] == n - 1) break;
            inmax(mx, w[pr[i]]);

            //check(ise)
            if (cur + ise[pr[i]][pr[i + 1]][0] > 0) {
                res += (cur + ise[pr[i]][pr[i + 1]][0] - 1) / mx + 1;
                cur -= (__int128) ((cur + ise[pr[i]][pr[i + 1]][0] - 1) / mx + 1) * mx;
            }
            check(res);
            cur += ise[pr[i]][pr[i + 1]][0];
            check(cur);
        }
        print(pr, n);
        check(res);
        inmin(ans, res);
    } while (next_permutation(pr + 1, pr + n));
    if (ans == INF) cout << "-1\n";
    else cout << ans << "\n";
    return 0;
}

vector<int> nd;

int solve2() {
    ll cur = p;
    int mx = 0;
    int ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        inmax(mx, w[i]);
        if (cur - nd[i] < 0) {
            int k = (nd[i] - cur - 1) / mx + 1;
            ans += k;
            cur += (ll) k * mx;
        }
        cur -= nd[i];
    }
    cout << ans << "\n";
    return 0;
}

signed main() {
#ifdef WIN64
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // WIN64
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        assert(cin >> n >> m >> p >> gt);
        for (int i = 0; i < n; ++i) assert(cin >> w[i]);
        for (int i = 0; i < m; ++i) {
            int u, v, s;
            assert(cin >> u >> v >> s);
            --u, --v;
            g[u].push_back(mkp(v, s));
            nd.push_back(s);
        }
        if (gt == 3) solve3();
        else if (gt == 2) solve2();
        else solve14();
    }
    return 0;
}
