#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<vector>
#include<string>
#include<math.h>
#include<bitset>
#include<random>

using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'
using ll = long long;
using ld = long double;

const int N = 800 + 9, X = 1 << 20, M = 1e9 + 7;
const long long INF = 1e18 + 9;

pair<int, int> dp[N][N];
pair<int, int> dp0[N][N];
int w[N];

struct edge {
	int v, u, s;
};

bool cmp(pair<int, int> a, pair<int, int> b) {
	if (a.first != b.first)
		return a.first < b.first;
	return a.second > b.second;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif

	
	int n, m, p, g;
	cin >> n >> m >> p >> g;
	for (int i = 1; i <= n; i++) {
		cin >> w[i];
	}
	vector<edge> e;
	for (int i = 0; i < m; i++) {
		int v, u, s;
		cin >> v >> u >> s;
		e.push_back({ v, u, s });
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			dp[i][j] = { INF, 0 };
			dp0[i][j] = { INF, 0 };
		}
	}
	dp0[1][1] = {0, p};
	for (int d = 0; d <= 2 * n; d++) {
		for (auto e : e) {
			int v = e.v, u = e.u, s = e.s;
			for (int k = 1; k <= n; k++) {
				if (dp0[v][k].first == INF)
					continue;
				if (dp0[v][k].second >= s) {
					dp[u][k] = min(dp[u][k], { dp0[v][k].first, dp0[v][k].second - s });
				}
				else {
					int cnt = (s - dp0[v][k].second) / w[k];
					if ((s - dp0[v][k].second) % w[k])
						cnt++;
					dp[u][k] = min(dp[u][k], { dp0[v][k].first + cnt, dp0[v][k].second + cnt * w[k] - s});
				}
				dp[u][u] = min(dp[u][u], dp[u][k]);
			}
		}
		for (int v = 1; v <= n; v++) {
			for (int u = 1; u <= n; u++) {
				dp0[v][u] = min(dp0[v][u], dp[v][u]);
			}
		}
	}
	if (dp[n][n].first != INF)
		cout << dp[n][n].first;
	else
		cout << -1;
}