#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

const ll inf = ll(1e18);

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, m, p, G;
  cin >> n >> m >> p >> G;
  vector<ll> w(n);
  for (int i = 0; i < n; ++i) cin >> w[i];
  vector<vector<tuple<int, ll, int>>> g(n);
  for (int i = 0; i < m; ++i) {
    int x, y; ll z;
    cin >> x >> y >> z;
    assert(x != y);
    --x, --y;
    g[x].emplace_back(y, z, i);
  }
  if (G == 1) {
    vector<ll> d(n, inf);
    vector<int> used(n);
    priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> q;
    q.emplace(0, 0);
    d[0] = 0;
    while (!q.empty()) {
      auto [dv, v] = q.top();
      q.pop();
      if (used[v]) continue;
      used[v] = 1;
      for (auto [u, z, id] : g[v]) {
        if (d[u] > d[v] + z) {
          d[u] = d[v] + z;
          q.emplace(d[u], u);
        }
      }
    }
    if (d.back() == inf) {
      cout << -1;
    } else {
      cout << max(0ll, d.back() - p);
    }
    return 0;
  }
  if (G == 2) {
    ll mx = 0, cur = 0, ans = 0, money = p;
    while (cur != n - 1) {
      mx = max(mx, w[cur]);
      auto [to, cost, id] = g[cur][0];
      if (money >= cost) {
        money -= cost;
      } else {
        ll need = cost - money;
        // mx * cnt >= need
        ll cnt = (need + mx - 1) / mx;
        ans += cnt;
        money -= cost;
        money += mx * cnt;
      }
      cur = to;
    }
    cout << ans;
    return 0;
  }
  assert(G == 0 || G == 3);
  ll ans = inf;
  vector<int> used(m);
  set<tuple<int, ll, ll, ll>> st;
  function<void(int, ll, ll, ll)> Dfs = [&](int v, ll money, ll mx, ll cnt) {
    if (st.find({v, money, mx, cnt}) != st.end()) return;
    st.emplace(v, money, mx, cnt);
    if (v == n - 1) {
      ans = min(ans, cnt);
      return;
    }
    mx = max(mx, w[v]);
    for (auto [u, cost, id] : g[v]) if (!used[id]) {
      used[id] = 1;
      if (money >= cost) {
        Dfs(u, money - cost, mx, cnt);
      } else {
        ll need = cost - money;
        ll more = (need + mx - 1) / mx;
        Dfs(u, money - cost + mx * more, mx, cnt + more);
      }
      //used[id] = 0;
    }
  };
  Dfs(0, p, 0, 0);
  cout << (ans == inf ? -1 : ans);
  return 0;
}