#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std; using namespace __gnu_pbds;
typedef long long ll; typedef long double ld;
#pragma GCC optimize("Ofast")
vector<vector<pair<int, int>>>graph; vector<ll>dist;
void deikstra(int start){
    dist[start] = 0; set<pair<ll, int>>good;
    good.insert({0, start});
    while(!good.empty()){
        auto u = *good.begin(); good.erase(good.begin());
        for(auto val: graph[u.second]){
            if(dist[val.first] > dist[u.second] + val.second){
                good.erase({dist[val.first], val.first});
                dist[val.first] = dist[u.second] + val.second;
                good.insert({dist[val.first], val.first});
            }
        }
    }
}
vector<ll>w; ll p; ll cnt = 0; int n;
void dfs(int start, ll mx){
    for(auto val: graph[start]){
        if(p > val.second){
            p -= val.second;
            dfs(val.first, max(mx, w[val.first]));
        }else{
            ll add = (val.second - p + mx - 1) / mx;
            p += add * mx - val.second; cnt += add;
            dfs(val.first, max(mx, w[val.first]));
        }
    }
}
vector<vector<ll>>dp;
void floyd(){
    for(int k = 0; k < n; k++){
        for(int i = 0; i < n; i++){
            for(int j = 0; j < n; j++){
                dp[i][j] = min(dp[i][j], dp[i][k] + dp[k][j]);
            }
        }
    }
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int m; int g; cin >> n >> m >> p >> g; dist.resize(n, 1e18); graph.resize(n); dp.resize(n);
    w.resize(n); vector<int>index;
    for(int i = 0; i < n; i++){
        cin >> w[i]; if(i != 0) index.push_back(i);
        dp[i].resize(n, 1e18); dp[i][i] = 0;
    }
    for(int i = 0; i < m; i++){
        ll a, b, s; cin >> a >> b >> s; a--; b--;
        graph[a].push_back({b, s}); dp[a][b] = min(dp[a][b], s);
    }
    deikstra(0); floyd();
    if(g == 1){
        if(dist[n - 1] == 1e18) cout << -1;
        else cout << max(0LL, dist[n - 1] - p);
    }else if(g == 2){
        dfs(0, w[0]); cout << cnt;
    }else if(g == 3 || g == 0){
        ll ans = 1e18; if(dp[0][n - 1] == 1e18) {cout << -1; return 0;}
        do{
            ll mx = w[0]; ll last = 0; ll answer = 0; ll thread = p;
            for(auto val: index){
                if(answer > 1e18) break;
                if(dp[last][val] == 1e18){ answer = 1e18; break;}
                if(dp[last][val] > thread){
                    ll add = (dp[last][val] - thread + mx - 1) / mx;
                    thread = add * mx + thread - dp[last][val];
                    answer += add;
                }else thread -= dp[last][val];
                last = val; mx = max(mx, w[val]);
                if(val == n - 1) break;
            }
            ans = min(ans, answer);
        }while(next_permutation(index.begin(), index.end()));
        cout << ans;
    }
}