//#pragma optimize("O3, unroll-loops")
//#pragma target("avx,bmi,bmi2,lzcnt,popcnt")
#include <bits/stdc++.h>
#define int long long
#define double long double
#define x first
#define y second
#define inf (INT64_MAX / 2)

using namespace std;

const int mod1 = 1000000009, mod2 = 1000000321, prime = 239;

void solve() {
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    if (gr == 1) {
        vector<int> w(n);
        for (int i = 0; i < n; i++) {
            cin >> w[i];
        }
        vector<vector<pair<int, int>>> g(n);
        for (int i = 0; i < m; i++) {
            int x, y, z;
            cin >> x >> y >> z; x--; y--;
            g[x].emplace_back(y, z);
        }
        vector<int> dist(n, inf), used(n, 0);
        dist[0] = 0;
        while (!used[n - 1]) {
            int mn = inf, x = -1;
            for (int i = 0; i < n; i++) {
                if (!used[i] && dist[i] < mn) {
                    mn = dist[i];
                    x = i;
                }
            }
            if (mn == inf) {
                break;
            }
            used[x] = 1;
            for (auto i : g[x]) {
                dist[i.x] = min(dist[i.x], dist[x] + i.y);
            }
        }
        if (!used[n - 1]) {
            cout << "-1\n";
            return;
        }
        cout << max(0ll, dist[n - 1] - p) << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    //cout << setprecision(100);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
}