#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define endl "\n"
#define eb emplace_back
#define lb(a, b) lower_bound(all(a), b)
#define ub(a, b) upper_bound(all(a), b)

int bubbleGum = 0;
#ifdef LOCAL
#include "Templates/DebugTemplate.cpp"
#define FAST_IO ;
#else
#define dbg(...) ++bubbleGum;
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif


const int N = 1000, INF = 1e15 + 10;
int w[N];
int g[N][N];
int n, m, p, group;


void input() {
    cin >> n >> m >> p >> group;
    for (int i = 0; i < n; ++i)
        cin >> w[i];
    for (auto& it : g)
        for (auto& jt : it) jt = -1;
    for (int i = 0; i < m; ++i) {
        int from, to, cost; cin >> from >> to >> cost;
        --from, --to;
        g[from][to] = g[to][from] = cost;
    }
}

void superSlow() {
    vec<int> arr(n);
    iota(all(arr), 0);

    int ans = INF;
    do {
        bool f = true;
        if (arr.front() != 0) continue;
        while (arr.back() != n - 1) 
            arr.pop_back();
        for (int i = 1; i < n; ++i) {
            if (g[arr[i - 1]][arr[i]] == -1) f = false;
        }
        dbg(arr, f);
        if (!f) continue;

        dbg(arr);

        int nxt = 0, val = 0;
        for (int i = 0; i < n; ++i) {
            if (i != nxt) continue;
            nxt = i + 1;
            while (nxt < n && w[nxt] < w[i]) ++nxt;
            int need = 0;
            for (int j = i; j + 1 < nxt; ++j) {
                need += g[arr[j]][arr[j + 1]];
            }
            if (need <= p) p -= need;
            else {
                need -= p;
                int days = (need + w[i] - 1) / w[i];
                val += days;
                p = days * w[i] - need;
            }
        }

        ans = min(ans, val);

    } while (next_permutation(all(arr)));

    cout << (ans == INF ? -1 : ans);
    exit(0);
}



int dist[N];
bool used[N];

void w1() {
    for (int from = 0; from < n; ++from) {
        for (int to = 0; to < n; ++to) {
            if (from == to || g[from][to] == -1) continue;
            int days = (g[from][to] + w[from] - 1) / w[from];
            g[from][to] = days;
        }
    }

    fill(dist, dist + n, INF);
    dist[0] = 0;

    for (int _ = 0; _ < n; ++_) {
        int miInd = -1;
        for (int i = 0; i < n; ++i) {
            if (!used[i] && (miInd == -1 || dist[i] < dist[miInd]))
                miInd = i;
        }
        used[miInd] = true;

        for (int to = 0; to < n; ++to) {
            if (g[miInd][to] == -1) continue;
            dist[to] = min(dist[to], dist[miInd] + g[miInd][to]);
        }

    }

    int ans = dist[n - 1];
    cout << (ans == INF ? -1 : ans);

}


signed main() {
#ifdef LOCAL
    freopen("C:\\Users\\user\\CLionProjects\\OpenOlymp\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    input();
    bool f = true;
    for (int i = 0; i < n; ++i)
        if (w[i] != 1) f = false;
    if (f) w1();
    //if (n <= 10) superSlow();

}