#include <bits/stdc++.h>
#define int long long
#define ll __int128_t
using namespace std;

struct edge {
    int a, b;
    ll s;
    edge(int A = 0, int B = 0, ll S = 0) {
        a = A; b = B; s = S;
    }
};

struct ans {
    ll cash, num, mx;
    ans(ll C = -1e18, ll N = 0, int M = -1e9) {
        cash = C; num = N; mx = M;
    }
};


int p;

vector<vector<ans>> dp;
vector<vector<edge>> rev;
vector<int> w;
vector<int> used;

inline int choose(int v1, int v2) {
    return (w[v1] > w[v2] ? v1 : v2);
}

inline ans best(ans a, ans b) {
    if (a.cash + a.num * a.mx != b.cash + b.num * b.mx)
        if (a.cash + a.num * a.mx > b.cash + b.num * b.mx)
            return a;
        else
            return b;
    return (a.num > b.num ? a : b);
}

inline void upd(int v1, int v2, ll e) {
    int n = (int)rev.size();
    for (int mx = 0; mx < n; ++mx) {
        ll cw = w[mx];
        ll need = max((ll)0, (e - dp[v2][mx].cash + cw - 1) / cw);
        if (need > dp[v2][mx].num)
            continue;
        dp[v1][choose(v1, mx)] = best(dp[v1][choose(v1, mx)], ans(dp[v2][mx].cash + need * cw - e, dp[v2][mx].num - need, max(w[v1], w[mx])));
    }
}

inline void get(int v, int num0) {
    if (used[v])
        return;
    used[v] = 1;
    if (v == 0) {
        dp[v][v] = { p, num0, w[v] };
        return;
    }
    for (auto &e : rev[v]) {
        get(e.b, num0);
        upd(v, e.b, e.s);
    }
}

inline bool check(ll m) {
    int n = (int)rev.size();
    dp.assign(n, vector<ans>(n, ans()));
    used.assign(n, 0);
    get(n - 1, m);
    if (dp[0][0].num != m) {
        cout << -1 << '\n';
        exit(0);
    }
    for (auto &x : dp.back()) {
        if (x.mx >= 0)
            return true;
    }
    return false;
}



signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m, g;
    cin >> n >> m >> p >> g;

    w.resize(n);
    for (auto &x : w)
        cin >> x;

    rev.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        --a; --b;
        rev[b].emplace_back(b, a, s);
    }

    used.resize(n);
    dp.resize(n, vector<ans>(n, ans()));

    ll l = -1, r = n * 1e9;
    while (l + 1 < r) {
        ll M = (l + r) / 2;
        if (check(M))
            r = M;
        else
            l = M;
    }
    cout << (long long)r << '\n';
}