#include <bits/stdc++.h>
#define int long long
using namespace std;
const int inf = 1e18;
int deijkstra(int n, vector<vector<pair<int, int>>> &gr) {
    vector<int> d(n, inf);
    d[0] = 0;
    set<pair<int, int>> st;
    st.insert({0, 0});
    while (!st.empty()) {
        auto p = *st.begin();
        st.erase(st.begin());
        int dst = p.first;
        int v = p.second;
        for (auto &x : gr[v]) {
            if (d[x.first] > dst + x.second) {
                st.erase({d[x.first], x.first});
                d[x.first] = dst + x.second;
                st.insert({d[x.first], x.first});
            }
        }
    }
    return d[n - 1];
}


void solve0(int n, int m, int p) {
    vector<vector<pair<int, int>>> gr(n);
    vector<int> w(n);
    for (auto &x : w)
        cin >> x;
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        --a; --b;
        gr[a].push_back({b, s});
    }

    int dst = deijkstra(n, gr);
    if (dst == inf) {
        cout << -1 << '\n';
        return;
    }

    cout << max(0ll, dst - p) << '\n';
}

void solve1(int n, int m, int p) {
    vector<int> w(n);
    for (auto &x : w)
        cin >> x;
    vector<int> s(n);
    for (auto &x : s) {
        int a; cin >> a >> a >> x;
    }

    int mx = w[0];
    int res = 0;
    int cash = p;
    for (int i = 0; i < n; ++i) {
        mx = max(mx, w[i]);
        int nd = (s[i] - cash + mx - 1) / mx;
        if (nd < 0)
            nd = 0;
        res += nd;
        cash = cash - s[i] + mx * nd;
    }
    cout << res << '\n';
}

signed main() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    if (g == 0) {
        solve0(n, m, p);
    } else {
        solve1(n, m, p);
    }
}