#include <iostream>
#include <fstream>
#include <cmath>
#include <map>
#include <vector>
#include <set>
#include <queue>
#include <random>
#include <numeric>
#include <ctime>
#include <bits/stdc++.h>
#pragma GCC optimize(3)
using namespace std;
#define vi vector<int>
#define ll long long
#define ld long double
#define pi pair<int, int>
#define int long long
mt19937 MT(179);
const int INF = 1e18;

vector<vector<pi>> g;
vector<vector<int>> d;
void BFS(int v) {
    int N = g.size();
    d[v].assign(N, INF);
    d[v][v] = 0;
    priority_queue<pair<int, int>> q;
    vector<bool> used;
    used.assign(N, false);
    q.push({0, v});
    while(!q.empty()) {
        int vv = q.top().second;
        q.pop();
        if(used[vv]) continue;
        used[vv] = true;
        for(auto x : g[vv]) {
            if(used[x.first]) continue;
            if(d[v][x.first] > d[v][vv] + x.second) {
                d[v][x.first] = d[v][vv] + x.second;
                q.push({-d[v][x.first], x.first});
            }
        }
    }
}
vector<int> w;
vector<pi> dp;

bool cmp1(int i, int j) {
    return w[i] < w[j];
}

void solve() {
    int N = 0, M = 0, P = 0, G = 0; cin >> N >> M >> P >> G;
    dp.assign(N, {INF, -INF});
    g.assign(N, vector<pi> ());
    w.assign(N, 0);
    for(int i = 0; i < N; ++i) cin >> w[i];
    dp[0] = {0, P};
    for(int i = 0; i < M; ++i) {
        int u = 0, v= 0 , ww = 0; cin >> u >> v >> ww;
        u--; v--;
        g[u].push_back({v, ww});
    }
    d.assign(N, vector<int> (N, 0));;
    for(int i = 0; i < N; ++i) {
        BFS(i);
    }
    vector<int> ind;
    ind.assign(N, 0);
    iota(ind.begin(), ind.end(), 0ll);
    sort(ind.begin(), ind.end(), cmp1);
    for(int i = 0; i < N; ++i) {
        int cur_v = ind[i];
        for(int j = 0; j < N; ++j) {
            if(d[cur_v][j] == INF) continue;
            int tmp = d[cur_v][j] - dp[cur_v].second;
            int cst = 0;
            if(tmp > 0) {
                cst = (tmp + w[cur_v] - 1) / w[cur_v];
            }
            if(dp[j].first > dp[cur_v].first + cst) {
                dp[j].first = dp[cur_v].first + cst;
                dp[j].second = dp[cur_v].second + cst * w[cur_v] - d[cur_v][j];
            }
            if(dp[j].first == dp[cur_v].first + cst) {
                dp[j].second = max(dp[j].second, dp[cur_v].second + cst * w[cur_v] - d[cur_v][j]);
            }
        }
    }
    if(dp[N - 1].first != INF) cout << dp[N - 1].first << "\n";
    else cout << "-1\n";
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << setprecision(12);
    int T = 1;
    while(T--) {
        solve();
    }
    return 0;
}

