#include <bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define all(x) x.rbegin(), x.rend()
#define endl '\n'
typedef long long ll;
using namespace std;

const ll INF = 1e15;
const int N = 8e2;

int n, m;
ll p;
ll w[N];
vector<pair<int, ll>> g[N];

void solve1() {
    set<pair<ll, int>> s;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        if (i) s.insert({INF, i});
    }

    while (m--) {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].push_back({b, c});
    }

    vector<ll> d(n, INF);
    d[0] = 0;
    s.insert({0, 0});
    for (int i = 0; i < n; i++) {
        int v = (*s.begin()).ss;

        if (d[v] == INF) {
            break;
        }
        s.erase(s.begin());
        for (auto [to, c] : g[v]) {
            if (d[to] > d[v] + c) {
                s.erase({d[to], to});
                d[to] = min(d[to], d[v] + c);
                s.insert({d[to], to});
            }
        }
    }
    if (d[n - 1] == INF) {
        cout << -1 << endl;
        return;
    }
    cout << max(0ll, d[n - 1] - p) << endl;
}

void solve2() {
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    vector<ll> s(n);
    while (m--) {
        int a, b;
        cin >> a >> b >> s[a];
    }

    ll ans = 0, mx = w[0];
    for (int i = 1; i < n; i++) {
        p -= s[i];
        if (p < 0) {
            ll k = (abs(p + 1) / mx) + 1;
            p += k * mx;
            ans += k;
        }
        mx = max(mx, w[i]);
    }
    cout << ans << endl;
}

void solve() {
    int gr;
    cin >> n >> m >> p >> gr;

    if (gr == 1) {
        solve1();
        return;
    }
    if (gr == 2) {
        solve2();
        return;
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
