#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<stack>
#include<queue>

using namespace std;

typedef long long ll;

int INF = 1e9, mod = 1e9 + 7;

vector<vector<pair<int, int>>> g;
vector<int> w, used;

void dfs_pit(int pos) {
	if (used[pos] == 1) return;
	used[pos] = 1;
	for (auto i : g[pos]) {
		dfs_pit(i.first);
	}
}

int n, m, p, ntest;
ll ans = 1e16;

void dfs(int pos, int calc, ll day, ll donate, ll sum) {
	if (pos == n - 1) {
		ans = min(ans, day);
	}
	if (calc >= 6000) return;
	if (donate < w[pos]) donate = w[pos];
	for (auto i : g[pos]) {
		if (i.second <= sum) {
			dfs(i.first, calc + 1, day, donate, sum - i.second);
		}
		else {
			int k = (i.second - sum) / donate;
			if ((i.second - sum) % donate != 0) k += 1;
			dfs(i.first, calc + 1, day + k, donate, sum + donate * k - i.second);
		}
	}
}


int main() {
	
	
	cin >> n >> m >> p >> ntest;
	w.resize(n);
	used.resize(n, 0);
	for (int i = 0; i < n; ++i) cin >> w[i];
	g.resize(n);
	for (int i = 0; i < m; ++i) {
		int a, b, s;
		cin >> a >> b >> s;
		a--;
		b--;
		g[a].push_back({ b, s });
	}
	dfs_pit(0);
	if (used[n - 1] == 0) {
		cout << -1;
		return 0;
	}
	if (ntest == 1) {
		vector<int> d(n, INF);
		vector<int> used(n, -1);
		d[0] = 0;
		for (int i = 0; i < n; ++i) {
			int mi = -1;
			for (int j = 0; j < n; ++j) {
				if (used[j] == -1 && (mi == -1 || d[mi] > d[j])) mi = j;
			}
			if (mi == -1) break;
			used[mi] = 1;
			for (auto j : g[mi]) {
				d[j.first] = min(d[j.first], d[mi] + j.second);
			}
		}
		cout << d[n - 1];
	}
	else if (ntest == 2) {
		dfs(0, 0, 0, w[0], p);
		cout << ans;
	}
	else {
		dfs(0, 0, 0, w[0], p);
		cout << ans;
	}
	
}