#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#define ss second
#define ff first
#define LOCAL

struct node {
	int to, cost;
	node () {};
	node (int _, int __) {
		to = _;
		cost = __;
	}
};

int n, m, p, group;
vector<vector<node>> g;
vector<int> salary, res;

void solvew1() {
	set<pair<int, int>> q;
	q.insert({-p, 0});
	res[0] = -p;
	while(!q.empty()) {
		auto nw = *q.begin();
		int w = nw.ff, v = nw.ss;
		q.erase(q.begin());
		for(auto i : g[v]) {
			if(res[i.to] > res[v] + i.cost) {
				res[i.to] = res[v] + i.cost;
				q.insert({res[i.to], i.to});
			}
		}
	}
	if(res[n - 1] == 1e18) {
		cout << -1 << endl;
	} else {
		cout << max((int)0, res[n - 1]) << endl;
	}
	return;
}

void solvemn1() {
	vector<int> dp(n, 1e18), pr(n, 0);
	dp[0] = 0;
	queue<int> q;
	int mx = salary[0];
	dp[g[0][0].to] = (g[0][0].cost - p + salary[0] - 1) / salary[0];
	p = dp[g[0][0].to] * salary[0] + p - g[0][0].cost;
	q.push(g[0][0].to);
	pr[1] = p;
	while(!q.empty()) {
		int now = q.front();
		q.pop();
		for(auto i : g[now]) {
			mx = max(mx, salary[now]);
			// cout << "now p mx cost: " << now + 1 << " " << p << " " << mx << " " << i.cost << endl;
			dp[i.to] = dp[now] + max((int)0, (i.cost - p + mx - 1) / mx);
			p = p - i.cost + mx * (dp[i.to] - dp[now]);
			pr[i.to] = p;
			q.push(i.to);
		}
	}
	// for(auto i : pr) {
	// 	cout << i << " ";
	// }
	// cout << endl;
	// for(auto i : dp) {
	// 	cout << i << " ";
	// }
	// cout << endl;
	if(dp[n - 1] == 1e18) {
		cout << -1 << endl;
	} else {
		cout << dp[n - 1] << endl;
	}
	return;
}

void solve() {
	cin >> n >> m >> p >> group;
	g.resize(n);
	salary.resize(n);
	res.resize(n, 1e18);
	for(auto &i : salary) {
		cin >> i;
	}
	for(int i = 0;i < m;i++) {
		int a, b, s;
		cin >> a >> b >> s;
		a--, b--;
		g[a].push_back({b, s});
	}
	if(group == 1) {
		solvew1();
	} else if(group == 2) {
		solvemn1();
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int st = 1;
	// cin >> st;
	while(st--) {
		solve();
	}
}