//#pragma GCC optimize("Ofast")
//#pragma GCC terget("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef __int128 ll;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

const ll INF64 = 9'000'000'000'000'000'000, INF32 = 2'000'000'000, MOD = 1'000'000'007;
const double PI = acos(-1);
bool l = false;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	long long n, m, p, g;
	cin >> n >> m >> p >> g;
	vector<ll> w(n);
	for (ll i = 0; i < n; i++) {
		long long x;
		cin >> x;
		w[i] = x;
	}
	vector<vector<pair<ll, ll>>> go(n);
	for (ll i = 0; i < m; i++) {
		long long a, b, c;
		cin >> a >> b >> c;
		a--;
		b--;
		go[a].emplace_back(b, c);
	}
	if (g == 1) {
		vector<ll> d(n, INF64);
		d[0] = 0;
		priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> q;
		q.push(make_pair(0, 0));
		while (!q.empty()) {
			auto[dx, x] = q.top();
			q.pop();
			if (d[x] != dx) {
				continue;
			}
			for (auto[b, c] : go[x]) {
				if (assign_min(d[b], d[x] + c)) {
					q.push(make_pair(d[b], b));
				}
			}
		}
		cout << (long long)(d.back() == INF64 ? -1 : max((ll)0, d.back() - p)) << '\n';
		return;
	}
	if (g == 2) {
		ll mc = 0;
		ll ans = 0;
		for (ll i = 0; i < n - 1; i++) {
			assign_max(mc, w[i]);
			ll np = (go[i][0].second - p + mc - 1) / mc;
			ans += np;
			p += np * mc;
			p -= go[i][0].second;
		}
		cout << (long long)ans << '\n';
		return;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef LOCAL
	l = true;
#endif
	if (!l) {
		solve();
	} else {
		solve();
	}
}
