#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 800;

ll rast[MAXN][MAXN];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, p, q;
    cin >> n >> m >> p >> q;
    vector <ll> w(n);
    vector <pair <ll, ll>> g[n];
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    ll a, b, c;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].push_back({b, c});
        if (rast[b][a] != 0) {
            rast[b][a] = min(rast[b][a], c);
        } else {
            rast[b][a] = c;
        }

    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            if (rast[i][k] == 0) {
                continue;
            }
            for (int j = 0; j < n; j++) {
                if (rast[k][j] == 0) {
                    continue;
                }
                if (rast[i][j] == 0) {
                    rast[i][j] = rast[i][k] + rast[k][j];
                } else {
                    rast[i][j] = min(rast[i][j], rast[i][k] + rast[k][j]);
                }
            }
        }
    }
    vector <pair <ll, ll>> dp(n, {-1, -1});
    vector <bool> used(n, false);
    dp[0] = {0, p};
    int v = 0;
    while (v != n - 1 && !used[v]) {
        used[v] = true;
        for (int i = 0; i < n; i++) {
            if (rast[i][v]) {
                if (dp[i] == pair <ll, ll>{-1, -1}) {
                    ll cnt1 = dp[v].first;
                    ll cnt2 = dp[v].second;
                    if (cnt2 < rast[i][v]) {
                        cnt1 += ((rast[i][v] - cnt2 + w[v] - 1) / w[v]);
                        cnt2 += (((rast[i][v] - cnt2 + w[v] - 1) / w[v]) * w[v]);
                    }
                    cnt2 -= rast[i][v];
                    dp[i] = {cnt1, cnt2};
                } else {
                    ll cnt1 = dp[v].first;
                    ll cnt2 = dp[v].second;
                    if (cnt2 < rast[i][v]) {
                        cnt1 += ((rast[i][v] - cnt2 + w[v] - 1) / w[v]);
                        cnt2 += (((rast[i][v] - cnt2 + w[v] - 1) / w[v]) * w[v]);
                    }
                    cnt2 -= rast[i][v];
                    dp[i] = min(dp[i], {cnt1, cnt2});
                }
            }
        }
        for (int i = 0; i < n; i++) {
            if (!used[i] && pair <ll, ll>{-1, -1} != dp[i]) {
                if (used[v]) {
                    v = i;
                } else if (dp[v] > dp[i]) {
                    v = i;
                }
            }
        }
    }
    cout << dp[n - 1].first;
}