#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <deque>


#pragma GCC optimize("avx2")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("179")


using namespace std;

#define int long long

const int inf = 2e18;







signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector <int> d1(n, 2e18);
    vector <int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    vector <vector <int>> por;
    for (int i = 0; i < w.size(); i++) {
        por.push_back({w[i], i});
    }
    sort(por.begin(), por.end());
    d1[0] = 0;
    vector <vector <vector <int>>> gr(n);
    for (int i = 0; i < m; i++) {
        int v, u, cst;
        cin >> v >> u >> cst;
        v--;
        u--;
        gr[v].push_back({u, cst});
    }
    set <vector <int>> bfs;
    bfs.insert({0, 0});
    while (bfs.size() != 0) {
        vector <int> y = *bfs.begin();
        int v = y[1];
        int ds = y[0];
        bfs.erase(y);
        for (auto nw : gr[v]) {
            int u = nw[0];
            int f = nw[1];
            if (ds + f < d1[u]) {
                bfs.erase({d1[u], u});
                d1[u] = ds + f;
                bfs.insert({d1[u], u});
            }
        }
    }
    int ans = -1;
    vector <vector <int>> mcst(n, vector <int> (2, 2e18));
    mcst[0] = {0, p};
    for (auto nw : por) {
        int i = nw[1];
        p = mcst[i][1];
        int alr = mcst[i][0];
        if (d1[i] != inf and alr != inf) {
            vector<int> d2(n, inf);
            d2[i] = 0;
            set<vector<int>> bfs;
            bfs.insert({0, i});
            while (bfs.size() != 0) {
                vector<int> y = *bfs.begin();
                int v = y[1];
                int ds = y[0];
                bfs.erase(y);
                for (auto nw: gr[v]) {
                    int u = nw[0];
                    int f = nw[1];
                    if (ds + f < d2[u]) {
                        bfs.erase({d2[u], u});
                        d2[u] = ds + f;
                        bfs.insert({d2[u], u});
                    }
                }
            }
            for (int u = 0; u < n; u++) {
                int dis = d2[u];
                if (dis != inf) {
                    int pl = dis - p;
                    vector<int> sr = {inf, inf};
                    if (pl <= 0) {
                        sr = {alr, p - dis};
                    } else {
                        int dop = (pl + w[i] - 1) / w[i];
                        sr = {alr + dop, p + w[i] * dop - dis};
                    }
                    if (mcst[u][0] > sr[0]) {
                        mcst[u] = sr;
                    }
                    else if (mcst[u][0] == sr[0] and sr[1] > mcst[u][1]) {
                        mcst[u] = sr;
                    }
                }
            }
        }
    }
    if (mcst[n - 1][0] == inf) {
        cout << -1 << "\n";
    }
    else {
        cout << mcst[n - 1][0] << "\n";
    }
}