#include<bits/stdc++.h>
#define pb push_back
#define fr first
#define sc second
#define ll long long
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

template<class T> using matrix = vector<vector<T>>;

ll N, M, P, group;
matrix<pair<int, int>> G;
vector<ll> W;

int main(){
	cin >> N >> M >> P >> group;
	if(group == 1){
		for(int i = 1; i <= N; i ++){
			int a; cin >> a;
		}
		G.resize(N + 1);
		for(int i = 0; i < M; i ++){
			int u, v, w; cin >> u >> v >> w;
			G[u].pb({v, w});
		}
		priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> pq;
		vector<ll> used(N + 1), dist(N + 1, 1e15);
		dist[1] = 0;
		pq.push({0, 1});
		while(!pq.empty()){
			int u = pq.top().sc;
			pq.pop();
			if(used[u]) continue;
			used[u] = true;
			for(auto [v, w] : G[u]){
				if(!used[v] && dist[u] + w < dist[v]){
					dist[v] = dist[u] + w;
					pq.push({dist[v], v});
				}
			}
		}
		if(dist[N] != 1e15) cout << max(0LL, dist[N] - P) << endl;
		else cout << "-1\n";
	}
	if(group == 2){
		W.resize(N + 1);
		for(int i = 1; i <= N; i ++){
			cin >> W[i];
		}
		vector<ll> costs(N + 1);
		for(int i = 0; i < M; i ++){
			int a, b; cin >> a >> b >> costs[i + 1];
		}
		ll ans = 0;
		for(int i = 1; i < N; i ++){
			ll e = i, cost = 0;
			while(e < N && W[e] <= W[i]){
				cost += costs[e];
				++ e;
			}
			-- e;
			if(P < cost){
				ll t = (cost - P + W[i] - 1) / W[i];
				ans += t;
				P += t * W[i];
			}
			P -= cost;
			i = e;
		}
		cout << ans << endl;
	}
}