//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
#define ll long long

int dp[(int) 1e4 + 10][100];

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, p, gr;
    cin >> n >> m >> p >> gr;

    if (gr == 1) {
        vector<int> v(n);
        vector<vector<pair<int, int>>> g(n);
        vector<ll> dp(n, (ll) 1e18);

        for (int i = 0; i < n; i++) {
            cin >> v[i];
        }
        for (int i = 0; i < m; i++) {
            int a,b,s;
            cin >> a >> b >> s;
            a--;
            b--;
            g[a].push_back({b, s});
        }
        dp[0] = 0;
        set<pair<int, int>> s;
        s.insert({0, 0});
        while (!s.empty()) {
            auto tmp = *s.begin();
            int now = tmp.second;
            s.erase(s.begin());

            for (auto ed : g[now]) {
                int c = ed.second;
                int to = ed.first;

                if (dp[to] > dp[now] + c) {
                    if (dp[to] != (ll) 1e18) {
                        s.erase({dp[to], to});
                    }
                    dp[to] = dp[now] + c;
                    s.insert({dp[to], to});
                }
            }
        }

        if (dp[n - 1] == (ll) 1e18) {
            cout << -1 << endl;
        } else {
            cout << dp[n - 1] << endl;
        }
        return 0;
    }

    if (gr == 4) {
        vector<vector<pair<int, int>>> g(n);
        vector<int> v(n);
        for (int i = 0; i < n; i++) {
            cin >> v[i];
        }
        for (int i = 0; i < m; i++) {
            int a, b, s;
            cin >> a >> b >> s;
            a--;
            b--;
            g[a].push_back({b, s});
        }

        for (int i = 0; i < (int) 1e4 + 10; i++) {
            fill(dp[i], dp[i] + 100, -1);
        }
        set<pair<int, pair<int, int>>> s;
        dp[0][0] = p;
        for (int q = 0; q < (int) 1e4 + 10; q++) {
            s.insert({-dp[q][0], {q, 0}});
            while (!s.empty()) {
                auto tmp = *s.begin();
                s.erase(s.begin());

                int now = tmp.second.second;
                int kol = tmp.second.first;

                for (auto ed: g[now]) {
                    int to = ed.first;
                    int c = ed.second;

                    if (dp[kol][now] >= c && dp[kol][to] < dp[kol][now] - c) {
                        if (dp[kol][to] != -1) {
                            s.erase({-dp[kol][to], {kol, to}});
                        }
                        dp[kol][to] = dp[kol][now] - c;
                        s.insert({-dp[kol][to], {kol, to}});
                    }
                }
            }

            int kol = q;
            for (int now = 0; now < n; now++) {
                if (dp[kol][now] != -1 && kol + 1 < (int) 1e4 + 10 && dp[kol + 1][now] < dp[kol][now] + v[now]) {
                    if (dp[kol + 1][now] != -1) {
                        s.erase({-dp[kol + 1][now], {kol + 1, now}});
                    }

                    dp[kol + 1][now] = dp[kol][now] + v[now];
                    s.insert({-dp[kol + 1][now], {kol + 1, now}});
                }
            }
        }

        for (int i = 0; i < (int) 1e4 + 10; i++) {
            if (dp[i][n - 1] != -1) {
                cout << i << endl;
                return 0;
            }
        }
        cout << -1 << endl;
    }
}
