#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>
#include <cstring>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

#define int long long

void solve() {
	int n, m, p, group; cin >> n >> m >> p >> group;
	vector <int> prib(n); for (auto& x : prib) cin >> x;
	vector <vector <pair <int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		int u, v, w; cin >> u >> v >> w;
		--u; --v;
		g[u].push_back({ v, w });
	}

	if (group == 1) {
		vector <int> dp(n, 1e18); dp[0] = 0;
		for (int iter = 0; iter < n; ++iter) {
			for (int v = 0; v < n; ++v) {
				for (auto [u, w] : g[v]) {
					dp[u] = min(dp[u], dp[v] + w);
				}
			}
		}

		if (dp[n - 1] > 1e17) cout << -1;
		else cout << max(dp[n - 1] - p, 0ll);
	}
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}