#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }

inline void solve () {
    int n, m, p, GR; cin >> n >> m >> p >> GR;
    vector <ll> w (n); for (auto &i : w) cin >> i;
    vector <vector <pii>> g (n);
    for (int i = 0; i < m; ++i) {
        int a, b, c; cin >> a >> b >> c; --a, --b;
        g[a].pb({b, c});
    }

    if (GR == 1) {
        vector <int> max_coin (n); max_coin[0] = p;
        queue <int> q; q.push(0);
        vector <int> ends;
        while (sz(q)) {
            int v = q.front(); q.pop();
            bool ok = 0;
            for (auto [u, c] : g[v]) {
                if (umax(max_coin[u], max_coin[v] - c)) {
                    q.push(u);
                    ok = 1;
                }
            }
            if (!ok) ends.pb(v);
        }

        if (max_coin[n - 1] > 0) {
            cout << 0 << endl;
            return;
        }

        for (auto v : ends) {
            for (auto &[u, w] : g[v]) {
                w -= max_coin[v];
            }
        }

        const ll inf = (ll)1e18 + 127;
        vector <ll> dist (n, inf);
        priority_queue <pii, vector <pii>, greater <pii>> pq;
        for (int i = 0; i < n; ++i) {
            if (max_coin[i] > 0) {
                dist[i] = -1;
            }
        }

        for (auto v : ends) {
            dist[v] = 0;
            pq.push({dist[v], v});
        }

        while (sz(pq)) {
            auto [di, v] = pq.top(); pq.pop();
            if (di > dist[v]) continue;
            for (auto [u, e] : g[v]) {
                if (umin(dist[u], dist[v] + e)) {
                    pq.push({dist[u], u});
                }
            }
        }

        ll ans = dist[n - 1];
        if (ans == inf) ans = -1;
        cout << ans;
        return;
    }

    if (GR == 2) {
        auto ok = [&] (ll days) {
            ll have = p;
            ll mx = 0;
            for (int i = 0; i + 1 < n; ++i) {
                umax(mx, w[i]);
                ll cost = g[i][0].sc;
                ll ned = max(0ll, (cost - have + mx - 1) / mx);
                if (ned > days) return 0;
                days -= ned;
                have += ned * mx;
                have -= cost;
            }
            return 1;
        };

        ll res = 0;
        for (int i = 60; ~i; --i) {
            res += (1ll << i);
            if (ok(res)) res -= (1ll << i);
        }
        cout << ++res << endl;
        return;
    }

    if (GR == 3) {

        return;
    }
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t = 1; // cin >> t;
    while (t--) solve();
    return 0;
}
