#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e14, mod = 1e9 + 7, maxn = 800 + 1;
int used[10];
vector<vector<pii>> g;
int n;
vector<int> earn;
map<pii, int> e;

int get(vector<int> ord, int bal) {
	int n2 = n - 2;
	int N = 1 << n2;
	int ANS = inf;
	for (int mask = 0; mask < N; ++mask) {
		vector<int> way = {0};
		for (int i = 0; i < n - 2; ++i) {
			if ((mask >> i) & 1) way.push_back(ord[i]);
		}

		way.push_back(n - 1);
		vector<int> W;
		vector<int> EARN = {earn[0]};
		int bad = 0;
		for (int i = 0; i < n - 2; ++i) {
			int u = way[i], v = way[i + 1];
			if (e.find({u, v}) == e.end()) {
				bad = 1;
				break;
			}
			W.push_back(e[{u, v}]);
			EARN.push_back(earn[v]);
		}
		if (bad)continue;
		int ans = 0, mx = earn[0], i = 1;
		reverse(all(W));
		while (!W.empty()) {
			int x = W.back();
			W.pop_back();
			if (bal < x) {
				int raz = x - bal, cnt = (raz + mx - 1) / mx;
				ans += cnt, bal += cnt * mx;
			}
			bal -= x, mx = max(mx, EARN[i++]);
		}
		ANS = min(ANS, ans);
	}
	return ANS;
}

void solve() {
	int m, bal, group;
	cin >> n >> m >> bal >> group;
	g.resize(n), earn.resize(n);
	for (int i = 0; i < n; ++i) cin >> earn[i];
	vector<int> W;
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w, u--, v--;
		int best = w;
		if (e.find({u, v}) != e.end()) best = min(best, e[{u, v}]);
		e[{u, v}] = best;
		W.push_back(w);
	}
	for (auto[r, w]: e) {
		auto[u, v] = r;
		g[u].push_back({v, w});
	}
	if (group == 1) {
		int ans = 0;
		vector<int> d(n, inf);
		d[0] = 0;
		set<pii > q = {{0, 0}};
		while (!q.empty()) {
			int v = q.begin()->second;
			q.erase(q.begin());
			for (auto[u, w]: g[v]) {
				if (d[u] > d[v] + w) {
					q.erase({d[u], u});
					d[u] = d[v] + w;
					q.insert({d[u], u});
				}
			}
		}
		if (d[n - 1] == inf) {
			cout << -1;
			return;
		}
		cout << max(0ll, d[n - 1] - bal);
		return;
	}
	if (group == 2) {
		int ans = 0, mx = earn[0], i = 1;
		reverse(all(W));
		while (!W.empty()) {
			int x = W.back();
			W.pop_back();
			if (bal < x) {
				int raz = x - bal, cnt = (raz + mx - 1) / mx;
				ans += cnt, bal += cnt * mx;
			}
			bal -= x, mx = max(mx, earn[i++]);
		}
		cout << ans;
		return;
	}
	if (group == 3 || group == 0) {
		vector<int> ord;
		for (int i = 1; i < n - 1; ++i) {
			ord.push_back(i);
		}
		int ans = get(ord, bal);
		while (next_permutation(all(ord))) ans = min(ans, get(ord, bal));
		if (ans == inf)ans = -1;
		cout << ans;
		return;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int _ = 1;
	//cin>>_;
	while (_--) {
		solve();
		cout << '\n';
	}
	return 0;
}
