#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#include <stack>
#include <deque>
#include <cstdio>
#include <random>
#include <cmath>
#include <ctime>

using namespace std;
using ll = long long;
using vii = vector<int>;
using ld = long double;
using vvi = vector<vii>;
using vll = vector<ll>;
using vvll = vector<vll>;
using vbb = vector<bool>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vpii = vector<pii>;
using vld = vector<ld>;
using vvpii = vector<vpii>;
using coor = int;

const ll INF = 1e18;

void solve() {
	int n, m, g;
	ll p;
	cin >> n >> m >> p >> g;
	vii a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	if (g == 1) {
		vector<vector<pair<int, ll>>> gr(n + 1);
		for (int i = 0; i < m; i++) {
			int v, u, s;
			cin >> v >> u >> s;
			gr[v].push_back({ u, s });
		}
		vll d(n + 1, INF);
		d[1] = 0;
		vbb used(n + 1);
		for (int i = 0; i <= n; i++) {
			int st = 0;
			for (int v = 1; v <= n; v++) {
				if (!used[v] && d[st] > d[v]) {
					st = v;
				}
			}
			used[st] = 1;
			for (auto& to : gr[st]) {
				d[to.first] = min(d[to.first], d[st] + to.second);
			}
		}
		if (d[n] == INF) {
			cout << -1;
			return;
		}
		cout << max((ll)0, d[n] - p);
	}
	if (g == 2) {
		ll sum = 0;
		vvpii gr(n + 1);
		for (int i = 0; i < m; i++) {
			int v, u, s;
			cin >> v >> u >> s;
			sum += (ll)s;
			gr[v].push_back({ u, s });
		}
		for (int i = 2; i <= n; i++) {
			a[i] = max(a[i], a[i - 1]);
		}
		ll ans = 0;
		for (int i = 1; i < n; i++) {
			if (p < gr[i][0].second) {
				ll tmp = (gr[i][0].second - p + a[i] - 1) / a[i];
				ans += tmp;
				p += tmp * a[i];
			}
			p -= gr[i][0].second;
		}
		cout << ans;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	solve();
}