#include <iostream>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

using namespace std;
#define int long long
#define _ << " " <<
#define ld long double
const int MAXN = 5e5 + 10, MAXA = 1e7 + 5, LOG = 33, mod = 1e9 + 7, INF = 1e15;
int n, m, k, pref[MAXN], dp[MAXN], p, group, cost[MAXN];
vector<pair<int, int>> g[MAXN];
void dijkstra(int start) {
	for (int i = 1; i <= n; i++) {
		dp[i] = INF;
	}
	dp[start] = 0;
	set<pair<int, int>> s;
	s.insert(make_pair(dp[start], start));
	while (s.size()) {
		auto p = *s.begin();
		s.erase(s.begin());
		int u = p.second;
		for (auto e : g[u]) {
			int v = e.first;
			int w = e.second;

			if (dp[v] > dp[u] + w) {
				s.erase(make_pair(dp[v], v));
				dp[v] = dp[u] + w;
				s.insert(make_pair(dp[v], v));
			}
		}
	}
}
void solve() {
	dijkstra(1);
	if (dp[n] == INF) {
		cout << -1 << '\n';
	}
	else cout << max(0ll, dp[n] - p) << '\n';
}
void solve2() {
	int mx = cost[1];
	int sum = p, ans = 0;
	for (int i = 1; i < n; i++) {
		if (g[i][0].second > sum) {
			int dist = g[i][0].second - sum;
			int cnt = (dist + mx - 1) / mx;
			ans += cnt;
			sum += cnt * mx;
		}
		sum -= g[i][0].second;
		mx = max(mx, cost[i]);
	}
	cout << ans << '\n';
}
int32_t main()
{
	//prepare({ 0, 2, 3, 4, 0, 6, 7, 8, 9, 0, 11, 12, 13, 14, 0 });
	int t;
	t = 1;
	//cin >> t;
	while (t--) {
		cin >> n >> m >> p >> group;
		for (int i = 1; i <= n; i++) {
			cin >> cost[i];
		}
		for (int i = 1; i <= m; i++) {
			int u, v, w;
			cin >> u >> v >> w;
			g[u].push_back(make_pair(v, w));
		}
		if (group == 1)solve();
		else solve2();
	}
}
