#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
#include <random>
#include <numeric>
#include <chrono>
using namespace std;
#define int long long

int d[800][800];
vector<pair<int, int>> g[800];
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;

    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            d[i][j] = 1e16;
        }
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        int s;
        cin >> s;
        a--;
        b--;
        d[a][b] = min(d[a][b], s);
        g[a].emplace_back(b, s);
    }

    for (int i = 0; i < n; i++) {
        d[i][i] = 0;
        set<pair<int, int>> st;
        for (int j = 0; j < n; j++) {
            st.insert({d[i][j], j});
        }
        for (int j = 0; j < n; j++) {
            auto v = st.begin()->second;
            st.erase(st.begin());
            for (auto [u, w] : g[v]) {
                if (d[i][u] > d[i][v] + w) {
                    st.erase({d[i][u], u});
                    d[i][u] = d[i][v] + w;
                    st.insert({d[i][u], u});
                }
            }
        }
    }

    vector<pair<int, int>> dp(n, {1e16, 0});
    dp[0] = {0, p};
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    mt19937 rng;
    shuffle(ord.begin(), ord.end(), rng);
    const int mxt = 1e8 / 2;
    for (int i = 0; i < min(n, mxt / n / n); i++) {
        for (auto j : ord) {
            for (int k = 0; k < n; k++) {
                if (d[j][k] >= 1e16) {
                    continue;
                }
                int sum = d[j][k];
                pair<int, int> now = {dp[j].first + (sum - dp[j].second + w[j] - 1) / w[j],
                                      dp[j].second + (sum - dp[j].second + w[j] - 1) / w[j] * w[j] - sum};
                if (sum <= dp[j].second) {
                    now = {dp[j].first, dp[j].second - sum};
                }
                if (dp[k].first > now.first || (dp[k].first == now.first && dp[k].second < now.second)){
                    dp[k] = now;
                }
            }
        }
    }
    if (dp.back().first >= 1e16) {
        cout << -1;
    } else {
        cout << dp.back().first;
    }
}

/*
4 4 2 0
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11
 */