#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<vector<pii>> g(n);
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < m; ++i) {
        int v, u, s;
        cin >> v >> u >> s;
        --v; --u;
        g[v].emplace_back(u, s);
    }
    vector<ll> d(n, INFLL);
    d[0] = 0;
    set<pii> q;
    q.emplace(0, 0);
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto [u, s] : g[v]) {
            if (d[u] > d[v] + s) {
                q.erase({d[u], u});
                d[u] = d[v] + s;
                q.emplace(d[u], u);
            }
        }
    }
    if (d[n - 1] == INFLL) {
        cout << -1 << en;
        return;
    }
    cout << max(0LL, d[n - 1] - p);
}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
