#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
//#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll P = 97;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int n;
vector <vector <pair <int, int>>> sm;
vector <int> w;

int bfs(){
    vector <int> dist(n, INF);
    dist[0] = 0;
    set <pair <int, int>> s = {{0, 0}};
    while (!s.empty()){
        pair <int, int> g = *s.begin();
        s.erase(s.begin());
        int v = g.second;
        for (int i = 0; i < sm[v].size(); i++){
            int to = sm[v][i].first, k = sm[v][i].second;
            if (dist[to] > dist[v] + k){
                s.erase({dist[to], to});
                dist[to] = dist[v] + k;
                s.insert({dist[to], to});
            }
        }
    }
    return dist[n - 1];
}

signed main(){
    Fast();
    int m, p, g;
    cin >> n >> m >> p >> g;
    w.resize(n);
    sm.resize(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    if (g == 1){
        for (int i = 0; i < m; i++){
            int a, b, c;
            cin >> a >> b >> c;
            a--, b--;
            sm[a].push_back({b, c});
        }
        int dist = bfs();
        if (dist == INF) cout << -1;
        else cout << max(0ll, dist - p);
    }else if (g == 2){
        vector <int> s(n);
        for (int i = 0; i < m; i++) {
            int a, b, c;
            cin >> a >> b >> c;
            s[b - 1] = c;
        }
        vector <int> ps(n), pm(n);
        for (int i = 0; i < n; i++){
            if (i == 0){
                pm[0] = w[0];
                continue;
            }
            ps[i] = ps[i - 1] + s[i];
            pm[i] = max(pm[i - 1], w[i]);
        }
        ps.push_back(ps.back());
        int cur = 0;
        int ans = 0;
        while (cur < n - 1){
            int l = cur, r = n;
            while (r - l > 1){
                int mid = (l + r) / 2;
                if (pm[mid] > w[cur]) r = mid;
                else l = mid;
            }
            int h = ps[r] - ps[cur];
            if (p >= h){
                p -= h;
                cur = r;
                continue;
            }
            int cnt = (h - p) / w[cur] + ((h - p) % w[cur] != 0);
            ans += cnt;
            p = p + (w[cur] * cnt) - h;
            cur = r;
        }
        cout << ans;
    }
    return 0;
}