﻿// D.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <bits/stdc++.h>
//#include "D.h"

using namespace std;
using ll = long long;

inline size_t zip(size_t n, size_t s)
{
	return n * 101 + s;
}

inline pair<size_t, size_t> unzip(size_t t)
{
	return { t / 101,t % 101 };
}

ll solvesvga(const ll& p, const ll& n, std::vector<ll>& v, std::vector<ll>& s)
{
	ll sum = -p, pr = 1, days = 0;
	for (size_t i = 0; i < n; i++)
	{
		if (v[i] > pr)
		{
			ll buy = max(0ll, (sum + pr - 1) / pr);
			days += buy;
			buy *= pr;
			sum -= buy;
			pr = v[i];
		}
		if (i != n - 1)
			sum += s[i];
	}
	days += max(0ll, (sum + pr - 1) / pr);
	return days;
}

int main()
{
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
	vector <ll> v(n);
	for (auto& i : v)
	{
		cin >> i;
	}
	switch (g)
	{
	case 1:
	{
		vector <vector<pair<size_t, ll>>> g(n);
		for (size_t i = 0; i < m; i++)
		{
			int a, b, s;
			cin >> a >> b >> s;
			a--; b--;
			g[a].emplace_back(b, s);
		}
		priority_queue<pair<ll, size_t>,vector<pair<ll,size_t>>,greater<pair<ll,size_t>>> q;
		vector <ll> dist(n, 1e16);
		dist.front() = 0;
		q.emplace(dist[0], 0);
		while (!q.empty())
		{
			ll w = q.top().first;
			size_t v = q.top().second;
			q.pop();
			if (dist[v] != w)
				continue;
			for (auto& i : g[v])
			{
				size_t u = i.first;
				ll s = i.second + w;
				if (dist[u] > s)
				{
					dist[u] = s;
					q.emplace(dist[u], u);
				}
			}
		}
		if (dist.back() == 1e16)
			cout << -1 << '\n';
		else
			cout << max(0ll, dist.back() - p) << '\n';
		break;
	}
	case 2:
	{
		vector <ll> s(n - 1);
		for (size_t i = 0; i < m; i++)
		{
			int unused;
			cin >> unused >> unused >> s[i];
		}
		cout << solvesvga(p, n, v, s) << '\n';
		break;
	}
	case 0: // everywhere? where need to be tested
	case 3:
	{
		map < pair<size_t, size_t>, ll> edge;
		for (size_t i = 0; i < m; i++)
		{
			int a, b, s;
			cin >> a >> b >> s;
			a--; b--;
			if (edge.count({ a,b }))
				edge[{a, b}] = min<ll>(s, edge[{a, b}]);
			else
				edge[{a, b}] = s;
		}
		vector <size_t> tmp;
		for (size_t i = 1; i < n; i++)
		{
			tmp.emplace_back(i);
		}
		ll best = 1e16;
		do
		{
			vector <ll> vt;
			vt.push_back(v[0]);
			for (auto& i : tmp)
			{
				vt.push_back(v[i]);
			}
			vector <ll>st;
			if (!edge.count({ 0,tmp[0] }))
				continue;
			bool flag = true;
			st.push_back(edge[{0, tmp[0]}]);
			for (size_t i = 0; i < n - 1; i++)
			{
				if (tmp[i] == n - 1)
					break;
				if (!edge.count({ tmp[i],tmp[i + 1] }))
				{
					flag = false;
					break;
				}
				st.push_back(edge[{tmp[i], tmp[i + 1]}]);
			}
			if (flag)
				best = min(best, solvesvga(p, st.size() + 1, vt, st));
			//_STL_ASSERT(best != 0, L"Some has been broken");
			/*if (!best)
				solvesvga(p, st.size() - 1, vt, st);*/
		} while (next_permutation(tmp.begin(), tmp.end()));
		if (best == 1e16)
			cout << -1 << '\n';
		else
			cout << best << '\n';
	}
	case 4:
	{
		vector <vector <size_t>> g(zip(n, 100));
		for (size_t i = 0; i < m; i++)
		{

		}
		break;
	}
	default:
		return -1;
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
