#include <bits/stdc++.h>

#define ll long long
#define ull H
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

int main(){
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);
	#ifdef ON_PC
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // ON_PC
	int T = 1;
//	cin >> T;
	while (T--){
		int n, m, p, G;
		cin >> n >> m >> p >> G;
		vector<int> w(n + 1);
		for (int i = 1; i <= n; i++){
			cin >> w[i];
		}
		vector<vector<pair<int, int>>> g(n + 1);
		for (int i = 0; i < m; i++){
			int u, v, s;
			cin >> u >> v >> s;
			g[u].push_back({v, s});
		}
		if (G == 1){
			vector<ll> dist(n + 1, 1e18);
			priority_queue<pair<ll, int>> q;
			q.push({0, 1});
			dist[1] = 0;
			while (!q.empty()){
				pair<ll, int> t = q.top();
				q.pop();
				if (-t.first > dist[t.second]){
					continue;
				}
				int v = t.second;
				for (auto& [u, s] : g[v]){
					if (dist[u] > dist[v] + s){
						dist[u] = dist[v] + s;
						q.push({-dist[u], u});
					}
				}
			}
			if (dist[n] == 1e18){
				cout << -1 << "\n";
			} else {
				cout << max(0ll, dist[n] - p) << "\n";
			}
			continue;
		}
		if (G == 2){
			ll cur = p;
			ll mx = w[1];
			ll res = 0;
			for (int i = 2; i <= n; i++){
				ll s = g[i - 1][0].second;
				ll k = (max(0ll, (s - p)) + mx - 1) / mx;
				res += k;
				p += k * mx;
				p -= s;
				mx = max(mx, (ll)w[i]);
			}
			cout << res << "\n";
			continue;
		}
	}
	return 0;
}
