#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 1e3 + 5;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

int n, m, p, G;
int a[MAX];
vector<pair<int, int>> g[MAX];

void solve_1() {
    vector<int> d(n + 1, inf);
    d[1] = 0;
    set<pair<int, int>> q;
    for(int i = 1; i <= n; i++) {
        q.insert({d[i], i});
    }
    while(sz(q)) {
        auto [dst, v] = *q.begin(); q.erase(q.begin());
        for(auto [to, w] : g[v]) {
            if(d[to] > dst + w) {
                q.erase({d[to], to});
                d[to] = dst + w;
                q.insert({d[to], to});
            }
        }
    }
    int ans = max(d[n] - p, 0LL);
    cout << ans << '\n';
}

void solve() {
    cin >> n >> m >> p >> G;
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    for(int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
    }
    if(G == 1) solve_1();
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) solve();
}
