#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

// #define endl "\n"
#define debug cout << "# sus\n"

signed main() {
  //  ios_base::sync_with_stdio(false), cin.tie(nullptr);
    ll n, m, p, group;
    cin >> n >> m >> p >> group;
    if (group) {
        vector<ll> w(n);
        for (ll i = 0; i < n; i++) cin >> w[i];
        vector<vector<Pair>> g(n);
        for (ll i = 0; i < m; i++) {
            ll u, v, c;
            cin >> u >> v >> c;
            u--, v--;
            g[u].push_back({v, c});
            g[v].push_back({u, c});
        }
        set<Pair> q;
        q.insert({0, 0});
        vector<ll> d(n, INF);
        d[0] = 0;
        while (!q.empty()) {
            ll v = q.begin()->second;
            q.erase(q.begin());
            for (auto[u, c] : g[v]) {
                if (d[u] == INF || d[u] > d[v] + c) {
                    q.erase({d[u], u});
                    d[u] = d[v] + c;
                    q.insert({d[u], u});
                }
            }
        }
        if (d[n - 1] != INF) {
            cout << max(0LL, d[n - 1] - p) << endl;
        } else {
            cout << "-1\n";
        }
    } else if (group == 3 || group == 0) {
        vector<ll> w(n);
        for (ll i = 0; i < n; i++) cin >> w[i];
        vector<vector<Pair>> g(n);
        for (ll i = 0; i < m; i++) {
            ll u, v, c;
            cin >> u >> v >> c;
            u--, v--;
            g[u].push_back({v, c});
            g[v].push_back({u, c});
        }
        ll gl = INF;
        for (ll mask = 0; mask < (1 << n); mask++) {
            set<ll> all;
            for (ll i = 0; i < n; i++) {
                if ((mask >> i) & 1) {
                    all.insert(i);
                }
            }
            if (!all.count(0) || !all.count(n - 1)) continue;
            ll node = 0, balance = p, ans = 0;
            bool flag = true;
            while (node != n - 1) {
                all.erase(node);
                ll cnt = 0;
                for (auto[u, c] : g[node]) {
                    if (all.count(u)) cnt++;
                }
                if (cnt != 1) {
                    flag = false;
                    break;
                }
                for (auto[u, c] : g[node]) {
                    if (all.count(u)) {
                        ll need = c;
                        if (balance >= need) {
                            balance -= need;
                        } else {
                            need -= balance;
                            balance = 0;
                            ll need_cnt = ((need + w[node] - 1) / w[node]);
                            ans += need_cnt;
                            balance = need_cnt * w[node] - need;
                        }
                        node = u;
                        break;
                    }
                }
            }
            if (!flag) continue;
            gl = min(gl, ans);
        }
        cout << (gl != INF ? gl : -1) << endl;
    }
    return 0;
}