#pragma GCC optimize ("Ofast", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "popcnt")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <queue>
#include <cstdio>
#include <iomanip>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <random>
#include <bitset>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
const int N = 810, P = 1e4 + 10;

vector <pair <int, int> > g[N];
ll w[N];
pair <ll, ll> d[N][N];
int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    for (int i = 1; i <= n; i++) {
        cin >> w[i];
        for (int j = 0; j <= n; j++)
            d[i][j] = {1e18, 0};
    }
    for (int i = 0; i < m; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        g[a].push_back({ b, c });
    }
    set <pair <pair <ll, ll>, pair <int, int> >> s;
    d[1][1] = {0, p};
    s.insert({ d[1][1], {1, 1}});
    while (s.size()) {
        auto v = s.begin()->second;
        s.erase(s.begin());
        for (auto& u : g[v.first]) {
            ll cp = max(0ll, (u.second - d[v.first][v.second].second)) / w[v.second] +
                bool(max(0ll, (u.second - d[v.first][v.second].second)) % w[v.second]);
            ll p1 = cp * w[v.second] + d[v.first][v.second].second - u.second;

            if (d[u.first][u.first] >= make_pair(d[v.first][v.second].first + cp, p1)) {
                w[u.first] = max(w[u.first], w[v.second]);
                s.erase({ d[u.first][u.first], {u.first, u.first} });
                d[u.first][u.first] = make_pair(d[v.first][v.second].first + cp, p1);
                s.insert({ d[u.first][u.first], {u.first, u.first} });
            }
        }
    }
    ll res = min_element(d[n], d[n] + n + 1)->first;
    if (res == 1e18)
        cout << -1;
    else
        cout << res;
}