#include <bits/stdc++.h>
#define ll long long
#define int long long
#define ld long double
#define pii pair <int, int>
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
using namespace std;



void solve1(ll n, ll m, ll p) {
    vector <vector <pii> > v(n);
    vector <pii> dp(n, {1e17, 0});
    vector <ll> w(n);
    for (auto & e : w) cin >> e;
    dp[0] = {0, p};
    for (int i = 0; i < m; i++) {
        ll a, b, c;
        cin >> a >> b >> c; a--; b--;
        v[a].push_back({b, c});
    }
    set <vector <ll> > s;
    s.insert({0, p,  0});
    while (!s.empty()) {
        auto h = (*(s.begin()))[2];
        s.erase(s.begin());
        for (auto [c, cost] : v[h]) {
            int ost = max(0ll, dp[h].y - cost);
            int delta = max(0ll, cost - dp[h].y);
            if (delta + dp[h].x < dp[c].x) {
                s.erase({dp[c].x, dp[c].y, c});
                dp[c] = {delta + dp[h].x, ost};
                s.insert({dp[c].x, dp[c].y, c});
            } else if (delta + dp[h].x == dp[c].x && ost > dp[c].y) {
                s.erase({dp[c].x, dp[c].y, c});
                dp[c].y = ost;
                s.insert({dp[c].x, dp[c].y, c});
            }
        }
    }
    if (dp[n - 1].x == 1e17) {
        cout << -1 << "\n";
    }
    else {
        cout << dp[n - 1].x;
    }
}

const int sz = 1e5;

pii tree[4 * sz];
int v[sz];

void build(int l, int r, int h) {
    if (l == r) {
        tree[h] = {v[l], -l};
        return;
    }
    int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
    build(l, m, h1);
    build(m + 1, r, h2);
    tree[h] = max(tree[h1], tree[h2]);
}

pii get(int l, int r, int h, int tl, int tr, int x) {
    int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
    if (tr <= l && r <= tr) {
        if (l == r) {
            if (tree[h].x >= x) {
                return tree[h];
            }
            else {
                return {-1, -1};
            }
        }
        if (tree[h1].x >= x) {
            return get(l, m, h1, tl, tr, x);
        }
        else {
            return get(m + 1, r, h2, tl ,tr, x);
        }
    }
    if (r < tl || tr < l) {
        return {-1, -1};
    }
//    int m = (r + l) / 2, h1 = 2 * h +1, h2 = 2 * h + 2;
}

void solve2(ll n, ll m, ll p) {
    vector <ll> w(n + 1);
    vector <pii> dp(n + 1, {1e17, 0});
    dp[1] = {0, p};
    for (int i = 1; i < n + 1; i++) {
        cin >> w[i];
    }
    vector <ll> pref(n + 1), cost(n + 1);
    for (int i = 1; i < m + 1; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        pref[a] = c;
        cost[b] = c;
    }
    for (int i = n - 1; i >= 1; i--) {
        pref[i] = pref[i + 1] + pref[i];
    }
    for (int i = 1; i < n; i++) {
        int s = 0;
        for (int j = i + 1; j < n + 1; j++) {
            s += cost[j];
            ll cnt = dp[i].x + (max(0ll, s - dp[i].y) + w[i] - 1) / w[i];
            ll ost = max(0ll, dp[i].y - s);
            if (dp[i].y - s < 0) {
                ost = ((s - dp[i].y) + w[i] - 1) % w[i];
            }
            if (dp[j].x > cnt) {
                dp[j].x = cnt;
                dp[j].y = ost;
            }
            else if (dp[j].x == cnt) {
                dp[j].y = max(dp[j].y, ost);
            }
        }
    }
//    for (int i = 1; i < n + 1; i++) {
//        cout << dp[i].x << " " << dp[i].y << endl;;
//    }
    cout << dp[n].x;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    if (g <= 1) {
        solve1(n, m, p);
    }
    else if (g == 2) {
        solve2(n, m, p);
    }
}



