#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937_64 gen(1908172);
const ll INF=1e18+2;
const ll N=802;

ll val[N],cost[N][N];

void solve()
{
    ll n,m,st,g;
    cin>>n>>m>>st>>g;

    for(ll i=0;i<n;i++)
        cin>>val[i];

    for(ll i=0;i<n;i++)
    {
        for(ll j=0;j<n;j++)
            cost[i][j]=INF;
    }

    for(ll i=0;i<m;i++)
    {
        ll a,b,w;
        cin>>a>>b>>w;
        a--, b--;
        cost[a][b]=min(cost[a][b],w);
    }

    for(ll k=0;k<n;k++)
    {
        for(ll i=0;i<n;i++)
        {
            for(ll j=0;j<n;j++)
                cost[i][j]=min(cost[i][j],cost[i][k]+cost[k][j]);
        }
    }

    if(g==0||g==3)
    {
        ve<ll> p(n);
        iota(all(p),0);
        ll ans=INF;

        do
        {
            ll mx=val[0],sum=0;
            bool ok=1;
            ve<pll> v;

            for(ll i=0;i<n-1;i++)
            {
                ll a=p[i],b=p[i+1];

                if(cost[a][b]==INF)
                {
                    ok=0;
                    break;
                }

                sum+=cost[a][b];

                if(val[b]>mx)
                {
                    v.PB({mx,sum});
                    mx=val[b];
                    sum=0;
                }

                if(b==n-1) break;
            }

            if(!ok) continue;
            if(sum!=0) v.PB({mx,sum});
            ll cur=0,sc=st;

            for(pll i:v)
            {
                ll add=max(0ll,(i.S-sc+i.F-1)/i.F);
                cur+=add;
                sc+=add*i.F;
                sc-=i.S;
            }

            ans=min(ans,cur);
        }
        while(next_permutation(p.begin()+1,p.end()));

        cout<<(ans==INF? -1:ans);
        return;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
