#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int mod = 1e9 + 7;

int n;
vector<vector<pair<int, ll>>> g;
ll res = 1e18;
vector<ll> cnt, w;
void dfs(int v, ll cur, ll mx, ll nw = 0) {
    if (nw > res) return;
    if (v == n - 1) {
        res = min(res, nw);
        return;
    }

    cnt[v]++;
    for (auto [u, s] : g[v]) {
        if (cnt[u] == n - 1) continue;
        ll x = cur, new_res = nw;
        if (x < s) {
            int need = s - x;
            int cnt = (need - 1) / mx + 1;
            new_res += cnt;
            x += mx * cnt;
        }
        x -= s;
        dfs(u, x, max(mx, w[u]), new_res);
    }
    cnt[v]--;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll m, p, group;
    cin >> n >> m >> p >> group;
    w.resize(n);
    for (int i = 0; i < n; i++) cin >> w[i];

    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v, s;
        cin >> u >> v >> s;
        u--; v--;
        g[u].emplace_back(v, s);
    }

    if (group == 1) {
        priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> pq;
        vector<ll> dist(n, 1e18);
        dist[0] = 0;
        pq.push({0, 0});
        while (!pq.empty()) {
            auto [d, v] = pq.top();
            pq.pop();
            if (dist[v] != d) continue;

            for (auto [u, s] : g[v]) {
                if (dist[v] + s < dist[u]) {
                    dist[u] = dist[v] + s;
                    pq.push({dist[u], u});
                }
            }
        }

        if (dist[n - 1] == 1e18) {
            cout << -1;
        } else {
            cout << max(0LL, dist[n - 1] - p);
        }
    } else if (group == 2) {
        ll ans = 0;
        ll mx = w[0];
        for (int i = 0; i < n - 1; i++) {
            ll cur = g[i][0].second;
            if (p < cur) {
                int need = cur - p;
                int cnt = (need - 1) / mx + 1;
                ans += cnt;
                p += mx * cnt;
            }
            p -= cur;
            mx = max(mx, w[i + 1]);
        }
        cout << ans;
    } else if (group == 0 || group == 3) {
        cnt.assign(n, 0);
        dfs(0, p, w[0]);
        if (res == 1e18) {
            cout << -1 << '\n';
        } else {
            cout << res << '\n';
        }
    }

    return 0;
}