#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m,p,t;
    cin >> n >> m >> p >> t;
    vector<int> a(n);
    for(int i=0;i<n;++i)
        cin >> a[i];
    vector<vector<pair<int,int> > > g(n);
    while(m--){
        int u,v,x;
        cin >> u >> v >> x;
        --u;
        --v;
        g[u].push_back(make_pair(v,x));
    }
    if(t == 1){
        vector<ll> dist(n,-1);
        priority_queue<pair<ll,int> > q;
        q.push(make_pair(0,0));
        while(!q.empty()){
            auto [d,u] = q.top();
            q.pop();
            if(dist[u] != -1)
                continue;
            dist[u] = -d;
            for(const auto& p:g[u])
                q.push(make_pair(d-p.second,p.first));
        }
        if(dist[n-1] == -1){
            cout << -1 << "\n";
            return 0;
        }
        cout << max(0LL,dist[n-1]-p) << "\n";
        return 0;
    }
    return 0;
}
