#define NDEBUG
#include<bits/stdc++.h>
using namespace std;
const int maxn = 810;
struct Node{
    int ver;
    long long mw;
    long long p, per;
    Node (){}
    Node (int _ver, long long _p){
        ver = _ver;
        p = _p;
        per = 0;
    }
    Node (int _ver, long long _p, long long _per, int _mw){
        ver = _ver;
        p = _p;
        per = _per;
        mw = _mw;
    }
    bool operator<(const Node &other)const{
        if (per != other.per) return per > other.per;
        return p < other.p;
    }
};
int n, m, p, g;
long long w[maxn];
int used[maxn];
long long money[maxn];
unsigned int d[maxn];
vector<Node>v[maxn];
void read(){
    cin >> n >> m >> p >> g;
    for (int i = 1; i <= n; ++i)
        cin >> w[i];
    for (int i = 0; i < m; ++i){
        int a, b, s;
        cin >> a >> b >> s;
        v[a].push_back(Node(b, s));
        //v[b].push_back(Node(a, s));
    }
}
void DFS(int ver){
    used[ver] = 1;
    for (auto i : v[ver])
        if (!used[i.ver])
            DFS(i.ver);
}
struct visitver{
    int ver;
    long long per;
    visitver(){}
    visitver(Node cur){
        ver = cur.ver;
        per = cur.per;
    }
    bool operator<(const visitver  &other)const{
        if (ver != other.ver) return ver < other.ver;
        return per < other.per;
    }
};

int Dijkstra(){
    map< visitver, long long>visited;
    memset(d, -1, sizeof(d));
    d[1] = 0;
    memset(money, -1, sizeof(money));
    money[1] = p;
    priority_queue<Node> q;
    q.push(Node(1, p, 0, w[1]));
    Node cur;
    while(!q.empty()){
        cur = q.top();
        q.pop();
        assert(cout<<"cur: "<<cur.ver<<" "<<cur.p<<" "<<cur.per<<" "<<cur.mw<<endl);
        if (cur.ver == n)break;
        //if (cur.p >= money[cur.ver]){
        bool pass = false;
        if (visited.find(visitver(cur)) == visited.end()){
            visited[visitver(cur)] = cur.p;
            pass = true;
        }
        else if (visited[visitver(cur)] < cur.p){
            visited[visitver(cur)] = cur.p;
            pass = true;
        }
        if (pass){
            //money[cur.ver] = cur.p;
            //q.push(Node(cur.ver, cur.p + w[cur.ver], cur.per+1));
            for (int i = 0; i < (int) v[cur.ver].size(); ++i){
                Node nb = v[cur.ver][i];
                assert(cout <<"nb :"<< nb.ver<< " " << nb.p << " "<< nb.per<<endl);
                if (cur.p >= nb.p)
                    q.push(Node(nb.ver, cur.p - nb.p, cur.per, max(cur.mw, w[nb.ver])));
                else{
                    long long diff = nb.p - cur.p;
                    long long addper = (diff % cur.mw)? diff / cur.mw + 1: diff/cur.mw;
                    long long addmoney = addper * cur.mw;
                    assert(cout <<"add info: "<< diff << " "<< addmoney << " "<<addper << endl);
                    q.push(Node(nb.ver, cur.p - nb.p + addmoney, cur.per + addper, max(cur.mw, w[nb.ver])));
                }
            }
        }
    }
    if (cur.ver != n)return -1;
    else return cur.per;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    DFS(1);
    if (!used[n])
        cout << "-1\n";
    else cout << Dijkstra() << endl;
    return 0;
}