#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize(Ofast)
#pragma GCC optimize(unroll - lops)

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

#define vec vector
#define pb push_back
#define sz(x) (int) (x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using str = string;

template<typename key, typename comp = less<>>
using pbds = __gnu_pbds::tree<key, __gnu_pbds::null_type, comp, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

#ifdef Local
#define debug(x) cout << endl \
                      << "$ " << #x << " = " << x << endl
void print(pbds<pair<int, int>> os) {
    cout << "$ os = { ";
    int n = sz(os);
    auto it = os.begin();
    for (int i = 0; i < n - 1; ++i, ++it)
        cout << "{ " << (*it).first << ", " << (*it).second << " }, ";
    if (it == os.end())
        cout << "}\n";
    else
        cout << "{ " << (*it).first << ", " << (*it).second << " } }\n";
}
#else
#define debug(...) 1337
#define print(...) 1337
#endif

void solve() {
    // int st = clock();
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    vec<int> c(n);
    for (int &i: c)
        cin >> i;
    map<pair<int, int>, int> mp;
    for (int i = 0, v, u, w; i < m; ++i) {
        cin >> v >> u >> w, --v, --u;
        if (mp.count({v, u}))
            mp[{v, u}] = min(mp[{v, u}], w);
        else
            mp[{v, u}] = w;
    }
    vec<vec<pair<int, int>>> g(n);
    for (auto &[key, w]: mp) {
        auto &[v, u] = key;
        g[v].pb({u, w});
    }
    const int inf = (int) 1e16;
    int ds[n][n];
    for (int v = 0; v < n; ++v) {
        ds[v][v] = 0;
        for (int u = 0; u < n; ++u)
            ds[v][u] = inf;
        for (auto &[u, w]: g[v])
            ds[v][u] = w;
    }
    for (int t = 0; t < n; ++t)
        for (int v = 0; v < n; ++v)
            for (int u = 0; u < n; ++u)
                ds[v][u] = min(ds[v][u], ds[v][t] + ds[t][u]);
    //        vec<int> ind(n);
    //        iota(all(ind), 0);
    //        sort(rall(ind), [&](int i, int j) {
    //            return c[i] < c[j];
    //        });
    //        vec<int> ng;
    if (ds[0][n - 1] >= inf) {
        cout << "-1\n";
        return;
    }
    priority_queue<pair<int, int>> pq;
    pq.push({0, 0});
    int us[n], ds3[n], pc[n], mx[n];
    fill(mx, mx + n, -1);
    fill(pc, pc + n, 0);
    fill(ds3, ds3 + n, inf);
    fill(us, us + n, 0);
    ds3[0] = 0;
    pc[0] = p;
    mx[0] = c[0];
    while (!pq.empty()) {
        auto [d, v] = pq.top();
        pq.pop();
        if (us[v])
            continue;
        us[v] = 1;
        for (auto &[u, w]: g[v]) {
            int t = (max(0ll, w - pc[v]) + mx[v] - 1) / mx[v];
            if (ds3[v] + t < ds3[u] || (ds3[v] + t == ds3[u] && (pc[v] + t * mx[v] - w > pc[u] || (pc[v] + t * mx[v] - w == pc[u] && mx[v] > mx[u]))))
                ds3[u] = ds3[v] + t, pc[u] = pc[v] + t * mx[v] - w, mx[u] = max(mx[v], c[u]), pq.push({-ds3[u], u});
        }
    }
    if (ds3.back() == inf) {
        cout << "-1\n";
        return;
    }
    int ds2[n][n];
    for (int v = 0; v < n; ++v)
        for (int u = 0; u < n; ++u)
            ds2[v][u] = (max(0ll, ds[v][u] - pc[v]) + c[v] - 1) / c[v];
    for (int t = 0; t < n; ++t)
        for (int v = 0; v < n; ++v)
            for (int u = 0; u < n; ++u)
                ds2[v][u] = min(ds2[v][u], ds2[v][t] + ds2[t][u]);
    cout << ds2[0][n - 1];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();

    return 0;
}