#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <deque>
#include <queue>
#include <memory.h>
#include <iomanip>
#include <random>
#include <ctime>
#define int long long
#define pii pair<int,int>
#define pb push_back
#define fir first
#define sec second
#define endl '\n'
#define double long double
#define INF 1e18+5
#define itn int
#define fro for
#define swpa swap
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
using namespace std;

const int N = 100005, R = 1 << 20;

mt19937 rnd(228);

/*void solve3(int n, int m, int p) {
	vector<vector<int>> gr(n, vector<int>(n, INF));
	vector<int> w(n);
	fro(int i = 0; i < n; i++)
		cin >> w[i];
	for (int i = 0; i < m; i++) {
		int a, b, s;
		cin >> a >> b >> s;
		a--;
		b--;
		gr[a][b] = min(gr[a][b], s);
	}
	int ans = INF;
	vector<int> per;
	for (int i = 0; i < n; i++)
		per.pb(i);

	do {
		int my = p;
		if (per[0] != 0)
			break;
		if (per.back() != n - 1)
			continue;
		bool flag = 1;
		for (int i = 0; i < n - 1; i++) {
			if (gr[per[i]][per[i + 1]] == INF)
				flag = 0;
		}
		if (!flag)
			continue;
		int mxw = 0;
		int lcl = 0;
		for (int i = 0; i < n - 1; i++) {
			mxw = max(mxw, w[per[i]]);
			if (my < gr[per[i]][per[i + 1]]) {
				lcl += (gr[per[i]][per[i + 1]] - my + mxw - 1) / mxw;
				my += (gr[per[i]][per[i + 1]] - my + mxw - 1) / mxw * mxw;
			}
			my -= gr[per[i]][per[i + 1]];
		}
		ans = min(ans, lcl);
	} while (next_permutation(all(per)));
	if (ans == 1e18)
		cout << -1 << endl;
	else
		cout << ans << endl;
	return;
}*/

void solve1(int n, int m, int p) {
	for (int i = 0; i < n; i++) { itn a;  cin >> a; }
	vector<vector<pii>> gr(n);
	for (int i = 0; i < m; i++) {
		itn a, b, w;
		cin >> a >> b >> w;
		a--;
		b--;
		gr[a].pb({ b,w });
		//gr[b].pb({ a,w });
	}

	vector<int> dist(n, INF);
	dist[0] = 0;
	set<pii> st;
	st.insert({ 0,0 });
	while (!st.empty()) {
		int v = st.begin()->second;
		st.erase(st.begin());
		for (pii i : gr[v]) {
			int u = i.fir, w = i.second;
			if (dist[u] > dist[v] + w) {
				st.erase({ dist[u], u });
				dist[u] = dist[v] + w;
				st.insert({ dist[u],u });
			}
		}
	}
	if (dist[n - 1] == INF) {
		cout << -1 << endl;
	}
	else
		cout << max(0LL, dist[n - 1] - p) << endl;
	return;
}

void solve2(int n, int m, int p) {
	vector<vector<int>> gr(n, vector<int>(n, INF));
	vector<int> w(n);
	fro(int i = 0; i < n; i++)
		cin >> w[i];
	for (int i = 0; i < m; i++) {
		int a, b, s;
		cin >> a >> b >> s;
		a--;
		b--;
		gr[a][b] = min(gr[a][b], s);
	}
	int ans = INF;

	int my = p;
	int mxw = 0;
	int lcl = 0;
	for (int i = 0; i < n - 1; i++) {
		mxw = max(mxw, w[i]);
		if (my < gr[i][i + 1]) {
			lcl += (gr[i][i + 1] - my + mxw - 1) / mxw;
			my += (gr[i][i + 1] - my + mxw - 1) / mxw * mxw;
		}
		my -= gr[i][i + 1];
	}
	ans = min(ans, lcl);

	cout << ans << endl;
	return;
}
signed main() { 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(17);
	srand(time(0));

	int n, m, p, g;
	cin >> n >> m >> p >> g;

	/*if (g == 3 || g == 0) {
		solve3(n, m, p);
	}*/
	if (g == 1)
		solve1(n, m, p);
	if (g == 2)
		solve2(n, m, p);
}

/*
4 4 100 1
1 1 1 1
1 2 60
2 4 5
1 3 4
3 4 100

*/