#include<bits/stdc++.h>
#define dbg(x) cout << #x << "=" << x << "\n";
using namespace std;

#define int long long

const int inf=2e18;

void solve1(int n, int m, int p, int g){
    vector<int> w(n);
    vector<int> s(n-1, 0);

    for(int i=0; i < n; i++){
        cin >> w[i];
    }

    for(int i=0; i < m; i++){
        int a, b; cin >> a >> b >> s[i];
    }

    int maxi = w[0];

    int ans = 0;

    for(int i=0; i < n-1; i++){
        if(p <= s[i]){
            int now = (s[i] - p + maxi - 1)/maxi;

            ans += now;

            p += maxi*now;
        }

        p -= s[i];

        maxi = max(maxi, w[i+1]);
    }

    cout << ans;
}

void solve2(int n, int m, int p, int g1){
    vector<int> w(n);

    for(int i=0; i < n; i++){
        cin >> w[i];
    }

    vector<vector<pair<int, int>>> g(n, vector<pair<int, int>> ());

    for(int i=0; i < m; i++){
        int a, b, s; cin >> a >> b >> s; a--; b--;

        g[a].push_back({b, s});
    }

    vector<int> dist(n, inf);

    dist[0] = 0;

    set<pair<int, int>> st;

    st.insert({0, 0});

    while(st.size()){
        int v = st.begin()->second;
        int d = st.begin()->first;

        st.erase(st.begin());

        for(auto el: g[v]){
            if(dist[el.first] > d + el.second){
                st.erase({dist[el.first], el.first});
                dist[el.first] = d + el.second;
                st.insert({dist[el.first], el.first});
            }
        }
    }

    if(dist[n-1] == inf){
        cout << -1;

        return;
    }else if(p - dist[n-1] >= 0){
        cout << 0;
    }else{
        cout << dist[n-1] - p;
    }
}

//solve 3

vector<int> w;
vector<int> p1;
map<pair<int, int>, int> mp;
int ans = inf;


void change(int p, int n){
    int start = 0;
    int maxi = w[0];
    int now=0;

    for(auto el: p1){
        if(mp[{start, el}] == 0){
            return;
        }

        int s = mp[{start, el}];
        start = el;

        if(s >= p){
            int pl = (maxi - 1 + s - p)/maxi;
            now += pl;
            p += maxi * pl;
        }

        p -= s;

        maxi = max(maxi, w[el]);

        if(el == maxi){
            break;
        }
    }

    ans = min(ans, now);
}

void solve3(int n, int m, int p, int g){
    w.resize(n);

    for(int i=0; i < n; i++){
        cin >> w[i];
    }

    for(int i=0; i < m; i++){
        int a, b, s; cin >> a >> b >> s;

        a--; b--;

        if(mp[{a, b}] == 0){
            mp[{a, b}] = s;
        }else{
            mp[{a, b}] = min(mp[{a, b}], s);
        }
    }

    p1.resize(n-1);

    for(int i=0; i < p1.size(); i++){
        p1[i] = i+1;
    }

    do{
        change(p, n);
    }while(next_permutation(p1.begin(), p1.end()));

    if(ans == inf){
        cout << -1;
    }else{
        cout << ans;
    }
}



// end

void solve(){
    int n, m, p, g; cin >> n >> m >> p >> g;

    solve3(n, m, p, g);

    /*if(g == 2){
        solve1(n, m, p, g);
    }else if(g == 1){
        solve2(n, m, p, g);
    }else{
        solve3(n, m, p, g);
    }*/
}

int32_t main(){
    /*ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cout.precision(20);*/




    int t=1; //cin >> t;

    for(int i=0; i < t; i++){
        solve();

        cout << "\n";
    }
}
