#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#define ll long long
#define ld long double

// login: open-2023-382
// passw: 6tgd8wpk

using namespace std;

const ll inf = 1e18;

ll n, m, p, g;
vector<vector<ll>> gr, cost;
vector<ll> w;

void read() {
	cin >> n >> m >> p >> g;
	w = vector<ll>(n);
	for (ll i = 0; i < n; i++) {
		cin >> w[i];
	}
	gr = cost = vector<vector<ll>>(n);
	for (ll i = 0; i < m; i++) {
		ll a, b, s;
		cin >> a >> b >> s;
		a--, b--;
		gr[a].push_back(b);
		cost[a].push_back(s);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);

	read();
	if (g == 1) {
		vector<ll> dp(n, inf);
		dp[0] = 0;
		set<pair<ll, ll>> q;
		q.insert({ dp[0], 0 });
		while (!q.empty()) {
			ll cur = q.begin()->second;
			q.erase(q.begin());
			for (ll i = 0; i < (ll)gr[cur].size(); i++) {
				ll to = gr[cur][i];
				ll c = cost[cur][i];
				if (dp[to] > dp[cur] + c) {
					q.erase({ dp[to], to });
					dp[to] = dp[cur] + c;
					q.insert({ dp[to], to });
				}
			}
		}
		if (dp[n - 1] >= inf) {
			cout << -1 << "\n";
		} else {
			cout << max(dp[n - 1] - p, 0ll) << "\n";
		}
	}

	return 0;
}