#include "bits/stdc++.h"
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2,fma,bmi,bmi2,mmx,tune=native")
#include "bits/extc++.h"
#define all(x) begin(x), end(x)
#define rall(x) x.rbegin(), x.rend()
#define frl(i, x) for(auto& i : x)
#define rep(i, j, k) for(int i = j; i < k; i++)
#define rrep(i, j, k) for(int i = k - 1; i >= j; i--)
#define S second
#define F first

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = double;
using ull = unsigned long long;
using treap = tree<int, null_type>;

void solve(){
    int n, m, p, t;
    cin >> n >> m >> p >> t;
    if(t == 1){
        const int inf = 1e9;
        vector<int> d(n, inf);
        vector<vector<int>> g(n);
        rep(i, 0, m){
            int a, b, c;
            cin >> a >> b >> c;
            a--, b--;
            g[a].push_back(b);
        }
        queue<int> q;
        d[0] = 0;
        while(!q.empty()){
            int x = q.front();
            q.pop();
            frl(i, g[x]){
                if(d[i] == inf){
                    d[i] = d[x] + 1;
                    q.push(i);
                }
            }
        }
        if(d[n-1] == inf) cout << -1;
        else cout << max(0, d[n-1] - p);
    }
}

int main(){
    cin.tie(0)->ios::sync_with_stdio(0);
    cout << setprecision(15) << fixed;
    int TT=1;
    //cin>>TT;
    while(TT--) solve();
}