#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <vector>

using namespace std;

const int MAXN = 807;

long long g[MAXN][MAXN];
int w[MAXN];

void solve() {
	int n, m, p, gr;
	cin >> n >> m >> p >> gr;
	int v, u, s;
	for (int i = 0; i < n; i++)
		cin >> w[i];
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			g[i][j] = 1e18;
	for (int i = 0; i < m; i++) {
		cin >> v >> u >> s;
		v--; u--;
		g[v][u] = min(g[v][u], 1ll * s);
	}
	for (int t = 0; t < n; t++)
		for (int s = 0; s < n; s++)
			for (int f = 0; f < n; f++)
				g[s][f] = min(g[s][f], g[s][t] + g[t][f]);
	set < pair <long long, pair <int, int>>> se;
	vector <map <int, long long>> dp(n);
	se.insert({ 0, {p, 0} });
	long long ans = 1e18;
	while (se.size()) {
		int v = se.begin()->second.second;
		int c = se.begin()->second.first;
		long long d = se.begin()->first;
		se.erase(se.begin());
		if (v == n - 1) {
			ans = min(ans, d);
			continue;
		}
		for (int to = 0; to < n; to++) {
			if (w[to] <= w[v] && to != n - 1)
				continue;
			long long need = max(0ll, g[v][to] - c);
			long long take = need / w[v];
			if (need % w[v])
				take++;
			int r = take * w[v] + c - g[v][to];
			if (dp[to].find(r) == dp[to].end()) {
				se.erase({ dp[to][r], {r, to} });
				dp[to][r] = d + take;
				se.insert({ dp[to][r], {r, to} });
			} 
			else if (dp[to][r] > d + take) {
				se.erase({ dp[to][r], {r, to} });
				dp[to][r] = d + take;
				se.insert({ dp[to][r], {r, to} });
			}
		}
	}
	if (ans >= 1e18)
		ans = -1;
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}