#include <bits/stdc++.h>
#include <bits/extc++.h>

#include <random>

#define int long long
//
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = 805;
const int INF = 1e18 + 7;
int izn_gr[N][N];
int vec[N];

vector<int> rev_gr[N];


int n, m, p, g;
bool used[N];

pair<int, int> ans[N];


pair<int, int> get_cost(pair<int, int> was, int want, int can) {
    if (was.first == INF) return was;
    int izn_want = want;
    want -= was.second;
    int have = (want + can - 1) / can;
//    cout << want << ' ' << can << " " << have << endl;
    was.first += have;
    was.second += have * can;
    was.second -= izn_want;
    return was;
}

pair<int, int> f(pair<int, int> a, pair<int, int> b) {
    if (a.first < b.first or (a.first == b.first and a.second > b.second)) {
        return a;
    }
    return b;
}

void dfs(int u) {
    used[u] = true;
    if (u == 0) {
        ans[0] = {0, p};
        return;
    }
    ans[u] = {INF, -INF};
    for (auto c : rev_gr[u]) {
        if (!used[c]) {
//            used[c] = true;
            dfs(c);
        }

        pair<int, int> here = get_cost(ans[c], izn_gr[c][u], vec[c]);
//        cout << c << " " << u << " " << here.first << " " << izn_gr[c][u] << " " << vec[c] << endl;
        ans[u] = f(here, ans[u]);
    }
}


void solve() {

    cin >> n >> m >> p >> g;
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            izn_gr[i][j] = INF;
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> vec[i];
    }
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        izn_gr[a][b] = min(izn_gr[a][b], c);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int k = 0; k < n; ++k) {
                if (izn_gr[i][j] > izn_gr[i][k] + izn_gr[k][j]) {
                    izn_gr[i][j] = izn_gr[i][k] + izn_gr[k][j];
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (i != n - 1 and izn_gr[i][n - 1] < INF) {
            rev_gr[n - 1].push_back(i);
        }
        for (int j = 0; j < n; ++j) {
            if (vec[j] < vec[i] and izn_gr[j][i] < INF) {
                rev_gr[i].push_back(j);
            }
        }
    }
    dfs(n - 1);
    if (!used[0]) {
        cout << -1;
        return;
    }
    cout << ans[n - 1].first;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << fixed;
    cout.precision(12);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}