#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>
#include <fstream>

using namespace std;

#define ll long long
#define eps 1e-10
#define inf 1e15
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), rend()
#define bit(i, n) ((n >> i) & 1)

#ifdef LOCAL_BOBER
#define preproc ifstream fl("sample.io")
#define cin fl
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr);
#else
#define preproc ;
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr); cin.tie(nullptr);
#endif

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

void solve1(int n, int m, ll p, vector<vector<pair<int, ll>>>& v) {
	set<pair<ll, ll>> st;
	vector<ll> len(n, inf);
	len[0] = 0;
	st.insert({ 0, 0 });
	while (st.size() > 0) {
		int x = st.begin()->second;
		st.erase(st.begin());

		for (auto i : v[x]) {
			if (len[x] + i.second < len[i.first]) {
				if (len[i.first] < 1e12) {
					st.erase({ len[i.first], i.first });
				}

				st.insert({ len[i.first], i.first });
				len[i.first] = len[x] + i.second;
			}
		}
	}

	if (len[n - 1] > 1e12)cout << "-1\n";
	else cout << max(0ll, len[n - 1] - p) << "\n";
}

void solve2(int n, int m, ll p, vector<vector<pair<int, ll>>>& v, vector<ll>& w) {

}

int main() {
	preproc; fast_io;

	ll n, m, p, g; cin >> n >> m >> p >> g;
	vector<ll> w(n);
	cin >> w;
	vector<vector<pair<int, ll>>> v(n);

	fori(m) {
		ll a, b, c;
		cin >> a >> b >> c;
		v[a - 1].push_back({ b - 1, c });
	}
	if (g == 1) solve1(n, m, p, v);
	if (g == 2) solve2(n, m, p, v, w);
}