#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 801, MOD = 1e9 + 7;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

#define int ll

vector<pair<int, int>> g[MAXN];

int w[MAXN];

vector<int> krd;

int get(int x) {
    return lower_bound(all(krd), x) - krd.begin();
}

const int INF = LLONG_MAX;

pair<int, int> d[MAXN][MAXN];

void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    for (int i = 1; i <= n; ++i) {
        cin >> w[i];
        krd.push_back(w[i]);
    }
    for (int i = 0, x, y, ww; i < m; ++i) {
        cin >> x >> y >> ww;
        g[x].emplace_back(y, ww);
    }
    sort(all(krd)), krd.resize(unique(all(krd)) - krd.begin());
    for (int i =1 ; i <= n; ++i) {
        w[i] = get(w[i]);
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < krd.size(); ++j) {
            d[i][j] = {INF, INF};
        }
    }
    d[1][w[1]] = {0, p};
    priority_queue<tuple<int, int, int>, vector<tuple<int, int, int>>, greater<>> q;
    q.push({0, 1, w[1]});
    while (!q.empty()) {
        auto [curd, v, vmn] = q.top();
        q.pop();
        for (auto &[to, s] : g[v]) {
            int have = d[v][vmn].Y;
            int nw = 0;
            if (have < s) {
                int add = krd[vmn];
                nw = (s - have + add - 1) / add;
                have += nw * add;
            }
            have -= s;
            pair<int, int> cur = {nw + d[v][vmn].X, have};
            int go = max(vmn, w[to]);
            if (cur.X < d[to][go].X || cur.X == d[to][go].X && cur.Y > d[to][go].Y) {
                d[to][go] = cur;
                q.push({cur.X, to, go});
            }
        }
    }
    int mn = INF;
    for (int i = 0; i < krd.size(); ++i) {
        mn = min(mn, d[n][i].X);
    }
    cout << (mn == INF ? -1 : mn);
}