#include<bits/stdc++.h>
#define MAXN 807
using namespace std;

const long long inf=1e15;

int n,m,g,a,b,minv,nxt[MAXN],curr;
long long w[MAXN],s,dist[MAXN],p,maxw,ans,z,pref[MAXN],sum,pp;
vector< pair<int,long long> > v[MAXN];
long long e[20][20];
bool li[MAXN],vis[20];
stack<int> st;
vector<int> path;

priority_queue< pair<long long,int>, vector< pair<long long,int> > , greater< pair<long long,int> > > q; 

void dijkstra(){
    for(int i=1;i<=n;i++){
        dist[i]=inf;
    }
    q.push({0,1});
    dist[1]=0;

    while(!q.empty()){
        minv=q.top().second;
        q.pop();

        if(li[minv])continue;

        for(int i=0;i<v[minv].size();i++){
            if(li[v[minv][i].first] or dist[minv]+v[minv][i].second>=dist[v[minv][i].first])continue;
            dist[v[minv][i].first]=dist[minv]+v[minv][i].second;
            q.push({dist[v[minv][i].first],v[minv][i].first});
        }
    }
}

void dfs(int x,long long dd){
    pref[x]=pref[x-1]+dd;
    if(x==n)return;
    dfs(v[x][0].first,v[x][0].second);
}

void check(){
    w[n]=inf; sum=0;

    while(!st.empty())st.pop();
    for(int i=path.size()-1;i>=0;i--){
        while(!st.empty() and w[path[i]]>=w[path[st.top()]]){
            st.pop();
        }
        if(!st.empty())nxt[i]=st.top();
        st.push(i);
    }

    for(int i=0;i<path.size();i++){
        if(i>0)pref[i]=pref[i-1]+e[path[i-1]][path[i]];
        else pref[i]=0;
    }

    curr=0; p=pp;
    while(curr!=path.size()-1){
        z=max((long long) ceil(1.0*(pref[nxt[curr]]-pref[curr]-p)/w[path[curr]]),0LL);
        sum+=z; p+=z*w[path[curr]];
        p-=(pref[nxt[curr]]-pref[curr]);
        curr=nxt[curr];
    }

    ans=min(ans,sum);
}

void brute(int x,int len){
    if(len>11)return;
    if(x==n){
        check();
    }else{
        for(int i=1;i<=n;i++){
            if(e[x][i]==inf)continue;
            path.push_back(i);
            brute(i,len+1);
            path.pop_back();
        }
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>p>>g; pp=p;
    for(int i=1;i<=n;i++){
        cin>>w[i];
        maxw=max(maxw,w[i]);
    }

    for(int i=1;i<=10;i++){
        for(int f=1;f<=10;f++){
            e[i][f]=inf;
        }
    }

    for(int i=1;i<=m;i++){
        cin>>a>>b>>s;
        v[a].push_back({b,s});
        if(n<=10){
            e[a][b]=min(e[a][b],s);
        }
    }

    if(maxw==1){
        dijkstra();
        if(dist[n]==inf){
            cout<<"-1\n";
        }else{
            cout<<max(dist[n]-p,0LL)<<"\n";
        }
    }else if(n<=10){
        path={1}; vis[1]=true;
        ans=inf; brute(1,1);

        if(ans==inf){
            cout<<"-1\n";
        }else{
            cout<<ans<<"\n";
        }

    }else{
        dfs(1,0);
        w[n]=inf;
        for(int i=n;i>=1;i--){
            while(!st.empty() and w[i]>=w[st.top()]){
                st.pop();
            }
            if(!st.empty())nxt[i]=st.top();
            st.push(i);
        }
        curr=1;
        while(curr!=n){
            z=max((long long) ceil(1.0*(pref[nxt[curr]]-pref[curr]-p)/w[curr]),0LL);
            ans+=z; p+=z*w[curr];
            p-=(pref[nxt[curr]]-pref[curr]);
            curr=nxt[curr];
        }
        cout<<ans<<"\n";
    }

    return 0;
}