#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
struct Node
{
    int to, t;
    Node(){};
    Node(int _to, int _t)
    {
        to=_to;
        t=_t;
    }
};
vector<Node> v[900];
int dist[900];
int used[900];
int w[900];
bool operator<(Node a, Node b)
{
    return a.t>b.t;
}
int n,m,p,g;
void Dijkstra(int vr)
{
    for(int i=0;i<=n;i++)dist[i]=2e9;
    priority_queue<Node> pq;
    pq.push({vr,0});
    used[vr]=1;
    dist[vr]=0;

    while(!pq.empty())
    {
        vr=pq.top().to;
        pq.pop();
        for(int i=0;i<v[vr].size();i++)
        {
            if(!used[v[vr][i].to])
            {
                if(dist[v[vr][i].to]>dist[vr]+v[vr][i].t)
                {
                    dist[v[vr][i].to]=dist[vr]+v[vr][i].t;
                    pq.push({v[vr][i].to,dist[v[vr][i].to]});
                }
            }
        }
        if(vr==n)return;
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>m>>p>>g;
    for(int i=0;i<n;i++)
    {
        cin>>w[i];
    }
    for(int i=0;i<m;i++)
    {
        int a,b,c;
        cin>>a>>b>>c;
        v[a].push_back({b,c});
    }
    if(g==1)
    {
        Dijkstra(1);
        if(dist[n]==2e9)cout<<-1<<endl;
        else cout<<dist[n]-p<<endl;
    }
    return 0;
}
/**
5 7 2 1
1 1 1 1 1
1 2 20
1 5 10
2 5 100
2 3 30
3 5 60
4 5 21
1 4 80
*/
