#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
struct Node
{
    long long to, t;
    Node(){};
    Node(long long _to, long long _t)
    {
        to=_to;
        t=_t;
    }
};
vector<Node> v[900];
long long dist[900];
long long used[900];
long long w[900];
bool operator<(Node a, Node b)
{
    return a.t>b.t;
}
long long n,m,p,g;
void Dijkstra(long long vr)
{
    for(long long i=0;i<=n;i++)dist[i]=2e18;
    priority_queue<Node> pq;
    pq.push({vr,0});
    used[vr]=1;
    dist[vr]=0;

    while(!pq.empty())
    {
        vr=pq.top().to;
        pq.pop();
        for(long long i=0;i<v[vr].size();i++)
        {
            if(!used[v[vr][i].to])
            {
                if(dist[v[vr][i].to]>dist[vr]+v[vr][i].t)
                {
                    dist[v[vr][i].to]=dist[vr]+v[vr][i].t;
                    pq.push({v[vr][i].to,dist[v[vr][i].to]});
                }
            }
        }
        if(vr==n)return;
    }
}
long long otg=2e18;
void dfs(long long vr, long long maxw, long long p, long long tmp)
{
    if(vr==n)
    {
        otg=min(otg,tmp);
        return;
    }
    for(long long i=0;i<v[vr].size();i++)
    {
        if(!used[v[vr][i].to])
        {
            used[v[vr][i].to]=1;
            long long k=(v[vr][i].t-p)/maxw;
            if((v[vr][i].t-p)%maxw)k++;
            p+=k*maxw;
            dfs(v[vr][i].to,max(maxw,w[v[vr][i].to]),p-v[vr][i].t,tmp+k);
            p-=k*maxw;
            used[v[vr][i].to]=0;
        }
    }
    //dfs(v[vr][0].to,max(maxw,w[vr]),p-v[vr][0].t);
}
int main()
{
    /*ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);*/

    cin>>n>>m>>p>>g;
    for(long long i=1;i<=n;i++)
    {
        cin>>w[i];
    }
    for(long long i=0;i<m;i++)
    {
        long long a,b,c;
        cin>>a>>b>>c;
        v[a].push_back({b,c});
    }
    if(g==1)
    {
        Dijkstra(1);
        if(dist[n]==2e18)cout<<-1<<endl;
        else cout<<max(dist[n]-p,(long long)0)<<endl;
    }
    if(g==2)
    {
        int otg1=0;
        long long maxw=w[1];
        for(int i=1;i<n;i++)
        {
            maxw=max(maxw,w[i]);
            if(p<v[i][0].t)
            {
                int k=(v[i][0].t-p)/maxw;
                if((v[i][0].t-p)%maxw)k++;
                p+=k*maxw;
                otg1+=k;
            }
            p-=v[i][0].t;

        }
        cout<<otg1<<endl;
    }
    if(g==0||g==3)
    {
        dfs(1, w[1], p, 0);
        if(otg==2e18)cout<<-1<<endl;
        else cout<<otg<<endl;
    }
    return 0;
}
/**
4 4 2 0
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11

*/
