#include<bits/stdc++.h>

using namespace std;
const long long MAXN = 805;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

long long n, m, p, group;
long long w[MAXN];
vector < pair < long long, long long > > g[MAXN];

void read()
{
    cin >> n >> m >> p >> group;
    for (long long i = 1; i <= n; ++ i)
        cin >> w[i];
    long long a, b, c;
    for (long long i = 1; i <= m; ++ i)
    {
        cin >> a >> b >> c;
        g[a].push_back(make_pair(b, c));
    }
}
long long d[MAXN], used[MAXN];

void solve()
{
    for (long long i = 1; i <= n; ++ i)
        d[i] = 1e15 + 15;
    d[1] = 0;
    priority_queue < pair < long long, long long > > pq;
    pq.push(make_pair(0, 1));

    while(!pq.empty())
    {
        long long beg = pq.top().second;
        long long cost = -pq.top().first;
        pq.pop();
        if(used[beg])continue;
        used[beg] = 1;
        long long nb, edge;
        for (long long i = 0; i < g[beg].size(); ++ i)
        {
            nb = g[beg][i].first;
            edge = g[beg][i].second;
            if(d[nb] > d[beg]  + edge)
            {
                d[nb] = d[beg] + edge;
                pq.push(make_pair(-d[nb], nb));
            }
        }
    }
    if(d[n] == 1e15 + 15)cout << -1 << endl;
    else cout << max(1LL * 0, d[n] - p) << endl;
}

void dfs(long long beg, long long maxx, long long cost, long long money)
{

    maxx = max(maxx, w[beg]);
    if(beg == n)
    {
        cout << cost << endl;
        exit(0);
    }
    long long nb = beg + 1;
    long long edge = g[beg].front().second;
    if(money < edge)
    {
        long long needed = (edge - money)/maxx;
        if((edge - money)%maxx != 0)needed ++;
        cost += needed;
        money += needed * maxx;

    }
    money -= edge;

    dfs(nb, maxx, cost, money);
}
long long visited[MAXN];
long long ans = 1e15+10;
long long possible = 0;
void dfs_can_reach(long long beg)
{
    visited[beg] = 1;
    if(beg == n)
    {
        possible = 1;
        return;
    }
    int nb;
    for (int i = 0; i < g[beg].size(); ++ i)
    {
        nb = g[beg][i].first;
        if(!visited[nb])
        {
            dfs_can_reach(nb);
        }
    }
}
void dfs0(long long beg, long long par, long long maxx, long long cost, long long money)
{
    visited[beg] = 1;
    if(cost >= ans)return;
    maxx = max(maxx, w[beg]);
    if(beg == n)
    {
        ans = min(ans, cost);
        visited[beg] = 0;
        return;
    }
    long long nb, edge;
    for (long long i = 0; i < g[beg].size(); ++ i)
    {
        nb = g[beg][i].first;
        edge = g[beg][i].second;
        if(!visited[nb] && nb != par && nb != beg)
        {
            long long money2 = money, cost2 = cost;
            if(money2 < edge)
            {
                if(maxx == 0)continue;
                long long needed = (edge - money2)/maxx;
                if((edge - money2)%maxx != 0)needed ++;
                cost2 += needed;
                money2 += needed * maxx;

            }
            money2 -= edge;
            if(money2 >= 0)dfs0(nb, beg, maxx, cost2, money2);
        }

    }
    visited[beg] = 0;
}

int main()
{

    speed();
    read();
    if(group == 1)
    {
        solve();
        exit(0);
    }
    if(group == 2)
    {
        dfs(1, 0, 0, p);
        exit(0);
    }
    dfs_can_reach(1);
    if(!possible)
    {
        cout << -1 << endl;
        exit(0);
    }
    memset(visited, 0, sizeof(visited));
    dfs0(1, 0, 0, 0, p);
    if(ans == 1e15 + 10)cout << -1 << endl;
    else cout << ans << endl;
    return 0;
}
/***
4 3 7 0
5 1 6 2
1 2 5
2 3 10
3 4 50

*/
