#include<bits/stdc++.h>
using namespace std;

int const MAXN=1000001;
int n, m, p, g, w[MAXN], inf = 1e9+7, used[MAXN], d[MAXN];

struct edge
{
    int ver, dist;
    bool operator<(const edge &ed)const
    {
        return dist > ed.dist;
    }
};

vector<edge> v[MAXN];

void dijkstra(int s)
{
    for(int i=0;i<=n;i++)
    {
        d[i] = inf;
    }
    d[s] = 0;
    priority_queue<edge> q;
    q.push({s,0});
    while(!q.empty())
    {
        edge u = q.top();
        q.pop();
        if(u.dist <= d[u.ver])
        {
            if(!used[u.ver])
            {
                used[u.ver] = 1;
                int sz = v[u.ver].size();
                for(int i=0;i<sz;i++)
                {
                    edge nb = v[u.ver][i];
                    if(nb.dist + u.dist < d[nb.ver])
                    {
                        nb.dist += u.dist;
                        d[nb.ver] = nb.dist;
                        q.push(nb);
                    }
                }
            }
        }
    }
}

void read()
{
    int x, y, ds;
    cin>>n>>m>>p>>g;
    for(int i=1;i<=n;i++)
    {
        cin>>w[i];
    }
    for(int i=1;i<=m;i++)
    {
        cin>>x>>y>>ds;
        v[x].push_back({y,ds});
    }
    dijkstra(1);
    if(d[n] == inf) cout<<-1<<endl;
    else cout<<max(0, d[n] - p)<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
