#include <bits/stdc++.h>

#define ll long long
#define ld long double

#define pll pair<ll, ll>
#define pii pair<int, int>
#define vll vector<ll>
#define vpl vector<pll>
#define vbo vector<bool>
#define vii vector<int>
#define vpi vector<pii>

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define sz(a) a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for (int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i : a)

#define fillv(a) F0R(i, sz(a)){cin>>a[i];}
#define outv(a) F0R(i, sz(a)){cout<<a[i]<<' ';}

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

vector<vpl> graph;
ll n;
ll ans = 1e16;
vll w;
vbo used;

void dfs(ll v, ll mx, ll p, ll cnt){
    if (v == n - 1){
        ans = min(ans, cnt);
    }
    used[v] = true;
    each(i, graph[v]){
        ll u = i.first;
        ll s = i.second;
        if (p >= s){
            dfs(u, max(mx, w[u]), p - s, cnt);
        }
        else{
            s -= p;
            ll d = s / mx;
            if (s % mx != 0){
                d++;
            }
            dfs(u, max(mx, w[u]), d * mx - s, cnt + d);
        }
    }
}

void solve() {
    ll m, p, g;
    cin >> n >> m >> p >> g;
    graph.resize(n);
    used.resize(n, false);
    w.resize(n);
    F0R(i, n) {
        cin >> w[i];
    }
    F0R(i, m) {
        ll v, u, s;
        cin >> v >> u >> s;
        v--;
        u--;
        graph[v].pub({u, s});
    }
    dfs(0, w[0], p, 0);
    if (ans == 1e16){
        cout << -1;
        return;
    }
    cout << ans;
}

int main() {
    fastio;
    int t = 1; //cin >> t;
    F0R(i, t) {
        solve();
    }
}