#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <unordered_map>
#include <string>
#include <algorithm>
#include <cmath>

#define int long long

using namespace std;

bool cmp(vector <int>& v1, vector <int>& v2) {
	if (v1.back() < v2.back()) {
		return 1;
	}
	return 0;
}
vector <int> tree;

int mx(int v, int l, int r, int ql, int qr) {
	if (ql <= l && r <= qr) {
		return tree[v];
	}
	if (r <= ql || l >= qr) {
		return 0;
	}
	int mid = (r + l) / 2;
	return max(mx(v * 2 + 1, l, mid, ql, qr), mx(v * 2 + 2, mid, r, ql, qr));
}

void upd(int v, int l, int r, int ql, int x) {
	if (r - l == 1) {
		tree[v] = max(tree[v], x);
		return;
	}
	int mid = (r + l) / 2;
	if (ql < mid) {
		upd(v * 2 + 1, l, mid, ql, x);
	}
	else {
		upd(v * 2 + 2, mid, r, ql, x);
	}

	tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);

	
	
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector <vector <int> > a;
	tree.resize(4 * 200001);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		vector <int> b;
		int pr = 0;
		for (int j = 0; j < k; ++j) {
			int x;
			cin >> x;
			if (x > pr) {
				pr = x;
				b.push_back(x);
			}
		}
		a.push_back(b);
	}
	sort(a.begin(), a.end(), cmp);
	int ans = 0;
	int pr = 0;
	for (int i = 0; i < n;) {
		int c = a[i].back();
		for (int j = 0; j < a[i].size(); ++j) {
			int mxx = mx(0, 0, 2e5 + 1, 0, a[i][j]);
			upd(0, 0, 2e5 + 1, c, a[i].size() - j + mxx);
		}
		i++;
		pr = c;
		
	}
	cout << tree[0];


}