#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for (int (i) = (a); (i) < (b); i++)
#define sz(x) int(size(x))
using vi = vector<int>;
using pii = pair<int, int>;
using ll = long long;

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;

    vector<vi> albs(n);
    rep(i, 0, n) {
        int k;
        cin >> k;

       rep(_, 0, k) {
           int x;
           cin >> x;

           if (albs[i].empty() || albs[i].back() < x) {
               albs[i].push_back(x);
           }
       }
    }

    vi p(n);
    iota(p.begin(), p.end(), 0);

    int ans = 0;
    do {
        vi as;
        rep(i, 0, n) {
            copy(albs[p[i]].begin(), albs[p[i]].end(), back_inserter(as));
        }
        vi cur;
        for (auto el: as) {
            if (cur.empty() || el > cur.back()) cur.push_back(el);
        }
        ans = max(ans, sz(cur));
    } while (next_permutation(p.begin(), p.end()));
    cout << ans << '\n';
}