#include <iostream>
#include <cmath>
#include <iomanip>
#include <queue>
#include <vector>
#include <set>
#include <algorithm>
#define ll long long
using namespace std;
void FAST() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
vector <ll> p(0);
ll mod = 1e9 + 7;
ll binpow(ll a, ll b) {
    if (b == 0)
        return 1;
    ll q = binpow(a, b / 2);
    ll tq = q * q % mod;
    if (b % 2 == 0)
        return tq;
    else
        return (tq * a) % mod;
}
void solve() {
    ll n;
    cin >> n;
    vector <vector <ll>> a(n);
    for (ll i = 0; i < n; ++i) {
        ll m; cin >> m;
        ll mx = -1;
        for (ll j = 0; j < m; ++j) {
            ll q; cin >> q;
            if (q > mx) {
                a[i].push_back(q);
                mx = q;
            }
        }
        reverse(a[i].begin(), a[i].end());
    }
    sort(a.begin(), a.end());
    for (ll i = 0; i < n; ++i) {
        reverse(a[i].begin(), a[i].end());
    }
    /*for (ll i = 0; i < n; ++i) {
        for (auto j : a[i])
            cout << j << " ";
        cout << endl;
    }*/
    ll ans = 0, last = -1;
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < a[i].size(); ++j) {
            if (a[i][j] > last) {
                last = a[i][j];
                ans++;
            }
        }
    }
    cout << ans;
}
int main()
{
    FAST();
    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}
