#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const int mod = 1e9 + 7;
const ld eps = 1e-6;

struct album {
    vector<int> a;
    int mx, prev, next_id;
    int ans1, ans2;
};

bool cmp(album &a, album &b) {
    return a.mx < b.mx;
}

int main() {
    int n;
    cin >> n;
    vector<album> a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].a.resize(k);
        a[i].mx = -1;
        for (int j = 0; j < k; j++) {
            cin >> a[i].a[j];
            a[i].mx = max(a[i].mx, a[i].a[j]);
        }
    }
    sort(a.begin(), a.end(), cmp);
    a[0].prev = 0;
    for (int i = 1; i < n; i++) {
        if (a[i].mx == a[i - 1].mx) {
            a[i].prev = a[i - 1].prev;
        } else {
            a[i].prev = a[i - 1].mx;
        }
    }
    for (int i = 0; i < n; i++) {
        int k = a[i].a.size();
        int pr = 0;
        for (int j = 0; j < k; j++) {
            if (a[i].a[j] > pr) {
                a[i].ans1++;
                pr = a[i].a[j];
            }
        }
        pr = a[i].prev;
        for (int j = 0; j < k; j++) {
            if (a[i].a[j] > pr) {
                a[i].ans2++;
                pr = a[i].a[j];
            }
        }
    }
    vector<int> suff_ans(n + 1);
    vector<int> best_in_block(n);
    vector<int> next(n);
    suff_ans[n] = 0;
    for (int i = n - 1; i >= 0; i--) {
        int j = i;
        int b = 0, c = 0;
        while (j >= 0 && a[j].mx == a[i].mx) {
            b = max(b, a[j].ans2);
            c = max(c, a[j].ans1);
            j--;
        }
        j++;
        next[j] = i + 1;
        best_in_block[j] = c;
        suff_ans[j] = b + suff_ans[next[j]];
        i = j;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        ans = max(ans, best_in_block[i] + suff_ans[next[i]]);
    }
    cout << ans;
    return 0;
}