#include <bits/stdc++.h>

using namespace std;

#define pii pair<int,int>
typedef long double ld;
//#define int int64_t

mt19937 gen(chrono::system_clock().now().time_since_epoch().count());

const int N = 2e5+10, K = 30;

int n;
vector <int> a[N];
vector <int> k[N];
int p[N];
int pans[N];
int pmx[N];

int cost (int mx, int i) {
    int l = 0, r = a[i].size()-1;
    if (a[i].back() <= mx) {
        return 0;
    }
    while (l < r) {
        int m = (l+r)/2;
        if (a[i][m] <= mx) {
            l = m+1;
        }
        else {
            r = m;
        }
    }
    return k[i][l];
}

int solve (int st) {
    for (int i=st;i<n;++i) {
        if (i > 0) {
            pans[i] = pans[i-1] + cost(pmx[i-1], p[i]);
            pmx[i] = max(pmx[i-1], a[p[i]].back());
        }
        else {
            pans[i] = cost(0, p[i]);
            pmx[i] = a[p[i]].back();
        }
    }
    return pans[n-1];
}

int f[N];

void upd (int i, int x) {
    while (i < N) {
        f[i] = max(f[i], x);
        i |= (i+1);
    }
}

int get (int i) {
    int ans = 0;
    while (i >= 0) {
        ans = max(ans, f[i]);
        i = (i&(i+1))-1;
    }
    return ans;
}

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    fill(f, f+N, 0);
    cin >> n;
    for (int i=0;i<n;++i) {
        int num;
        cin >> num;
        a[i].resize(num+1);
        k[i].resize(num+1);
        for (int j=1;j<=num;++j) {
            cin >> a[i][j];
            a[i][j] = max(a[i][j], a[i][j-1]);
        }
        for (int j=num;j>0;--j) {
            if (j < num) {
                k[i][j] = k[i][j+1];
            }
            if (a[i][j] > a[i][j-1]) {
                k[i][j]++;
            }
        }
    }
    for (int i=0;i<n;++i) {
        p[i] = i;
    }
    sort(p, p+n, [&](int x, int y){return a[x].back() < a[y].back();});
    for (int i=0;i<n;++i) {
        upd(i, get(i-1));
        upd(i, cost(0, p[i]));
//        cout << "! " << i << '\n';
        for (int j=1;j<a[p[i]].size();++j) {
//            cout << a[p[i]][j] << ' ';
            int l = 0, r = i-1;
            while (l < r) {
                int m = (l+r+1)/2;
                if (a[p[m]].back() < a[p[i]][j]) {
                    l = m;
                }
                else {
                    r = m-1;
                }
            }
            if (a[p[l]].back() < a[p[i]][j]) upd(i, get(l)+k[p[i]][j]);
        }
//        cout << '\n';
    }

    cout << get(n-1);

    return 0;
}
