#define pii pair < int, int >
#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define ld long double
#define ll long long
#define _ << ' ' <<
#define int ll

using namespace std;

const int N = (int)2e5 + 5;
const int MOD = (int)1e9 + 7;

mt19937_64 gen(chrono::system_clock::now().time_since_epoch().count());

vector < int > a[N];

int dp[N];

struct segmentTree {
    int s;
    vector < int > t;

    segmentTree(int n) {
        s = 1;
        while (s < n) {
            s *= 2;
        }
        t.resize(2 * s, 0);
    }

    void upd(int v, int vl, int vr, int pos, int x) {
        if (vl == vr) {
            t[v] = max(t[v], x);
            return;
        }

        int mid = (vl + vr) / 2;
        if (pos <= mid) {
            upd(v * 2, vl, mid, pos, x);
        }
        else {
            upd(v * 2 + 1, mid + 1, vr, pos, x);
        }
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void upd(int pos, int x) {
        upd(1, 1, s, pos, x);
    }

    int getMax(int v, int vl, int vr, int l, int r) {
        if (vl >= l && vr <= r) {
            return t[v];
        }
        if (vl > r || vr < l) {
            return 0;
        }

        int mid = (vl + vr) / 2;
        return max(getMax(v * 2, vl, mid, l, r), getMax(v * 2 + 1, mid + 1, vr, l, r));
    }

    int getMax(int l, int r) {
        return getMax(1, 1, s, l, r);
    }
};

int32_t main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector < pii > v;
    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        int mx = 0;
        vector < int > vec;
        while (k--) {
            int x;
            cin >> x;
            if (x > mx) {
                mx = x;
                vec.push_back(x);
            }
        }
        a[i] = vec;
        v.push_back({ vec.back(), i });
    }
    segmentTree t(N);
    int ans = 0;
    sort(v.begin(), v.end());
    for (auto cur: v) {
        int num = cur.second;
        for (int i = 0; i < (int)a[num].size(); i++) {
            int mx = t.getMax(1, a[num][i] - 1);
            dp[a[num].back()] = max(dp[a[num].back()], mx + (int)a[num].size() - i);
            t.upd(a[num].back(), dp[a[num].back()]);
            ans = max(ans, dp[a[num].back()]);
        }
    }
    cout << ans << '\n';
    return 0;
}
