#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;

const ll INF = (ll)(1e18);

bool cmp(const vector<ll> &a, const vector<ll> &b) {
    for (ll i = 1; i <= min(a.size(), b.size()); ++i) {
        if (a[a.size() - i] < b[b.size() - i]) return true;
        if (a[a.size() - i] > b[b.size() - i]) return false;
    }

    if (a.size() >= b.size()) return true;
    return false;
}

void solve() {
    ll n;
    cin >> n;

    vector<vector<ll>> a(n);

    for (ll i = 0; i < n; ++i) {
        ll k;
        cin >> k;

        for (ll j = 0; j < k; ++j) {
            ll x;
            cin >> x;

            if (!j || a[i].back() < x) {
                a[i].push_back(x);
            }
        }
    }

    // cout << cmp({4, 9}, {1});
    // return;

    sort(all(a), cmp);

    ll biggest = -INF;
    ll cnt = 0;

    for (auto i : a) {
        for (auto j : i) {
            if (biggest < j) {
                biggest = j;
                ++cnt;
            }
        }
    }

    cout << cnt;
}

signed main() {
    int tests = 1;

    while (tests--) {
        solve();
    }
}

// cd "d:\open_olympiad\" ; if ($?) { g++ main.cpp -o main } ; if ($?) { .\main } 
