#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define itn int
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define Int int
#define Itn int
#define pii pair<int, int>
#define X first
#define Y second

template<typename T>
istream &operator >> (istream &in, vector<T> &arr) {
    for(auto &to : arr) in >> to;
    return in;
}

template<typename T>
ostream &operator << (ostream &out, vector<T> &arr) {
    for(auto &to : arr) out << to << " ";
    return out;
}

const int INF = 1e9 + 7;
const int MOD = 998244353;
const int maxn = 1e6 + 1;

int get(vector<int> &a, vector<itn> &b) {
    int ans = 0;
    vector<itn> c;
    for(auto to : a) c.pb(to);
    for(auto to : b) c.pb(to);
    int curmx = -INF;
    for(auto to : c) {
        if(to > curmx) ++ans;
        curmx = max(curmx, to);
    }
    return ans;
}

bool cmp(vector<itn> &a, vector<int> &b) {
    itn ans1 = get(a, b);
    int ans2 = get(b, a);
    if(ans1 == ans2) {
        int mx1 = *max_element(all(a));
        int mx2 = *max_element(all(b));
        if(mx1 == mx2) return (int)a.size() < (int)b.size();
        return mx1 < mx2;
    }
    return ans1 > ans2;
}

void solve() {
    itn n;
    cin >> n;
    vector<vector<int>> a(n);
    for(int i = 0; i < n; ++i) {
        itn k;
        cin >> k;
        a[i].resize(k);
        cin >> a[i];
    }
    sort(all(a), cmp);
    vector<itn> c;
    for(int i = 0; i < n; ++i) {
        //cout << "# " << a[i] << '\n';
        for(int j = 0; j < (int)a[i].size(); ++j) {
            c.pb(a[i][j]);
        }
    }
    itn curmx = -INF;
    int ans = 0;
    for(int i = 0; i < (int)c.size(); ++i) {
        if(c[i] > curmx) ++ans;
        curmx = max(curmx, c[i]);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) {
        solve();
    }
}