#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define itn int
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define Int int
#define Itn int
#define pii pair<int, int>
#define X first
#define Y second

template<typename T>
istream &operator >> (istream &in, vector<T> &arr) {
    for(auto &to : arr) in >> to;
    return in;
}

template<typename T>
ostream &operator << (ostream &out, vector<T> &arr) {
    for(auto &to : arr) out << to << " ";
    return out;
}

const int INF = 1e9 + 7;
const int MOD = 998244353;
const int maxn = 1e6 + 1;

bool cmp(vector<itn> &a, vector<int> &b) {
    int ans1 = 0, ans2 = 0;
    int curmx1 = *max_element(all(a));
    for(auto to : b) {
        if(to > curmx1) ++ans1;
        curmx1 = max(curmx1, to);
    }
    int curmx2 = *max_element(all(b));
    for(auto to : a) {
        if(to > curmx2) ++ans2;
        curmx2 = max(curmx2, to);
    }
    int p1 = *max_element(all(a)) + *min_element(all(a));
    int p2 = *max_element(all(a)) +*min_element(all(b));
    return p1 > p2;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for(int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        cin >> a[i];
    }
    sort(all(a), cmp);
    int ans = 0;
    itn curmx = -INF;
    for(int i = 0; i< n; ++i) {
        for(int j = 0; j < (int)a[i].size(); ++j) {
            if(a[i][j] > curmx) ++ans;
            curmx = max(curmx, a[i][j]);
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) {
        solve();
    }
}