#include <bits/stdc++.h>

using namespace std;

const int R = 1 << 18;

int mx[R * 2];

int get(int l, int r) {
    l += R;
    r += R;
    int ans = 0;
    while (l < r) {
        if (l & 1) {
            ans = max(ans, mx[l++]);
        }
        if (r & 1) {
            ans = max(ans, mx[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

void change(int pos, int val) {
    for (pos += R; pos > 0; pos /= 2) {
        mx[pos] = max(mx[pos], val);
    }
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    map<int, vector<int>> vals;
    vector<int> b;
    for (int i = 0; i < n; ++i) {
        int sz;
        cin >> sz;
        a[i].resize(sz);
        int mx = 0;
        for (int j = 0; j < sz; ++j) {
            cin >> a[i][j];
            b.push_back(a[i][j]);
            mx = max(mx, a[i][j]);
        }
        vals[mx].push_back(i);
    }
    sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < (int)a[i].size(); ++j) {
            a[i][j] = lower_bound(b.begin(), b.end(), a[i][j]) - b.begin();
        }
    }
    for (auto [mx_nw, inds] : vals) {
        for (auto i : inds) {
            vector<int> ord;
            int mx_nw = -1;
            for (auto j : a[i]) {
                if (j > mx_nw) {
                    mx_nw = j;
                    ord.push_back(j);
                }
            }
            for (int j = 0; j < (int)ord.size(); ++j) {
                change(ord.back(), get(0, ord[j]) + (int)ord.size() - j);
            }
        }
    }
    cout << get(0, (int)b.size()) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
