#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;


#define int ll
#define ff first
#define ss second
#define pb push_back
#define sz(x) long(x.size())
#define rs resize
#define all(x) x.begin(), x.end()
#define fastio() cin.tie(0)->sync_with_stdio(0)
#define qmx(a, b) a = max(a, b)
#define qmn(a, b) a = min(a, b)
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF32 = 2e9 + 5;
const ll INF64 = 2e18 + 5;
const int MX = 2e5 + 7;
const int ABOBA = 333;


struct Tree {
    int n, ind = 1;
    vector<int> t, son;


    Tree(int n_ = 1) {
        t.rs(1, 0);
        son.rs(1, 0);
    }


    void create(int v) {
        if (son[v]) return;
        son[v] = ind;
        son.pb(0);
        son.pb(0);
        t.pb(0);
        t.pb(0);
        ind += 2;
    }


    void upd(int v, int tl, int tr, int i, int x) {
        if (tl == tr) {
            t[v] = x;
            return;
        }
        create(v);
        int tm = (tl + tr) >> 1;
        if (i <= tm) upd(son[v], tl, tm, i, x);
        else upd(son[v] + 1, tm + 1, tr, i, x);
        t[v] = max(t[son[v]], t[son[v] + 1]);
    }


    int get(int v, int tl, int tr, int l, int r) {
        if (l > r) return -INF32;
        if (l > tr || tl > r) return 0;
        if (l <= tl && tr <= r) return t[v];
        create(v);
        int tm = (tl + tr) / 2;
        return max(get(son[v], tl, tm, l, r), get(son[v] + 1, tm + 1, tr, l, r));
    }
};


int n;
vector<vector<int>> a;
vector<int> mx, mn;


int cnt(int i, int j) {
    int cur = 0, res = 0;
    for (int el : a[i]) {
        if (el > cur) res++;
        qmx(cur, el);
    }
    for (int el : a[j]) {
        if (el > cur) res++;
        qmx(cur, el);
    }
    return res;
}


bool cmp2(int i, int j) {
    return mx[i] < mx[j];
}


bool cmp(int i, int j) {
    return cnt(i, j) >= cnt(j, i);
}


int calc(vector<int> &ind) {
    int res = 0, cur = 0;
    for (int i = 0; i < n; i++) {
        for (int el : a[ind[i]]) {
            if (el > cur) {
                cur = el;
                res++;
            }
        }
    }
    return res;
}


void solve() {
    //solve here
    cin >> n;
    a.rs(n);
    mx.rs(n);
    mn.rs(n);
    int mxa = -1;
    int mxk = 0;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        int cur = 0;
        int mxx = 0;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            qmx(mxa, x);
            qmx(mxx, x);
            if (x > cur) {
                cur = x;
                a[i].pb(x);
            }
        }
        int sss = sz(a[i]);
        qmx(mxk, sss);
        mx[i] = mxx;
//        for (int el : a[i]) {
//            cout << el << " ";
//        }
//        cout << "\n";
    }
    vector<int> ind(n);
    if (n <= 7) {
        for (int i = 0; i < n; i++) ind[i] = i + 1;
        int ans = 0;
        do {
            for (int &el : ind) el--;
            qmx(ans, calc(ind));
            for (int &el : ind) el++;
        } while (next_permutation(all(ind)));
        cout << ans;
        return;
    }
    for (int i = 0; i < n; i++) ind[i] = i;
    if ((mxa <= 2 || mxk <= 2)) {
        sort(all(ind), cmp2);
        cout << calc(ind);
        return;
    }
//    vector<vector<int>> dp(mxa + 1, vector<int>(n + 1, 0));
    vector<pii> used;
    vector<int> rec;
    rec.pb(0);
    int ans = 0;
    vector<Tree> tr(mxa + 1);
    for (int t = 1; t <= mxa; t++) {
        for (int i = 0; i < n; i++) {
            if (mx[i] > t) continue;
            if (t > mx[i]) {
//                int tt = 0;
//                tr[t].upd(0, 0, n, i + 1, tr[t].get(0, 0, n, 0, i));
//                for (int j = 0; j < i; j++) qmx(tt, dp[t][j]);
//                dp[t][i + 1] = tt;
//                qmx(ans, tt);
//                if (tt) used.pb({t, i + 1});
                continue;
            }
            tr[t].upd(0, 0, n, i + 1, sz(a[i]));
            int cur = sz(a[i]);
            qmx(ans, cur);
//            dp[t][i + 1] = sz(a[i]);
            for (int prev : rec) {
                int cr = upper_bound(all(a[i]), prev) - a[i].begin();
                int add = sz(a[i]) - cr;
                int add2 = max(tr[prev].get(0, 0, n, 0, i), tr[prev].get(0, 0, n, i + 2, n));
                if (add + add2 > cur) {
                    cur = add + add2;
                    qmx(ans, cur);
                    tr[t].upd(0, 0, n, i + 1, cur);
                }
//                qmx(dp[t][i + 1], dp[p.ff][p.ss] + add);
//                qmx(ans, dp[t][i + 1]);
            }
//            for (auto p : used) {
//                int cr = upper_bound(all(a[i]), p.ff) - a[i].begin();
//                int add = sz(a[i]) - cr;
//                qmx(dp[t][i + 1], dp[p.ff][p.ss] + add);
//                qmx(ans, dp[t][i + 1]);
//            }
//            used.pb({t, i + 1});
        }
//        int mxind = 0;
//        for (int i = 1; i <= n; i++) {
//            if (dp[t][i] > dp[t][mxind]) mxind = i;
//        }
        rec.pb(t);
//        used.pb({t, mxind});
    }
    cout << ans;
}


int32_t main() {
    fastio();
    int tests = 1;
    //cin >> tests;
    while (tests--) solve();
    return 0;
}
/*
4
5
4 9 4 6 8
1
7
2
8 6
1
1

4
2
3 4
2
1 8
2
2 8
2
7 9

2
7
1 2 3 4 5 6 7
2
2 5
!!! 7
*/