#include <bits/stdc++.h>
//#include <ext/pd_ds/assoc_container.hpp>
//#include <ext/pd_ds/tree_policy.hpp>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define mp make_pair
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef int64_t ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
ostream& operator << (ostream& out, pair<T, T1> &pr) {
    out << pr.first << " " << pr.second;
    return out;
}

template<typename T, typename T1>
istream& operator >> (istream& in, pair<T, T1> &pr) {
    in >> pr.first >> pr.second;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &arr) {
    for (auto &i : arr) {out << i << " ";}
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &arr) {
    for (auto &i : arr) {in >> i;}
    return in;
}

//typedef tree<int, null_type, less<int>,
// rb_tree_tag, tree_order_statistics_node> ordered_set;


int n;
vector<vector<int>> s;

bool cmp(vector<int> &a, vector<int> &b) {
    int x1 = lower_bound(all(b), a.back()) - b.begin();
    int x2 = lower_bound(all(a), b.back()) - a.begin();

    return x1 <= x2;
}

void solve() {
    cin >> n;
    s.rs(n);

    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        for(int j = 0; j < k; j++) {
            int a; cin >> a;

            if (sz(s[i]) == 0 || s[i].back() < a) s[i].pb(a);
        }

        //cout << s[i] << "\n";
    }

    sort(all(s), cmp);
    //cout << s << "\n";

    int ans = 0, mx = 0;
    for (int i = 0; i < n; i++) {
        //cout << s[i].back() << "\n";
        for (int j = 0; j < sz(s[i]); j++) {
            ans += (mx < s[i][j]);
            mx = max(s[i][j], mx);
        }
    }

    cout << ans << "\n";
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double start_time = clock();
#endif
    int test = 1;
    //cin >> test;

    while (test--) {
        solve();
#ifdef LOCAL
        cout << "--------------\n";
#endif
    }
#ifdef LOCAL
    cout << "execution time: " << (clock() - start_time) / CLOCKS_PER_SEC;
#endif
}