#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define debug(x) cerr << "[" << #x << "]: " << x << endl
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

void solve(){
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; i++){
        int k; cin >> k;
        int mx = 0;
        for (int j = 0; j < k; j++){
            int x; cin >> x;
            if (x > mx) a[i].pb(x);
            mx = max(mx, x);
        }
    }
    sort(all(a), [](vi &a, vi &b){
        return a.back() < b.back();
    });
    vector<int> dp(n, 0);
    for (int i = 0; i < n; i++){
        dp[i] = a[i].size();
        for (int j = 0; j < sz(a[i]); j++){
            if (i == 0) break;
            if (a[i][j] <= a[0].back()) continue;
            int l = 0, r = i;
            while (r - l > 1){
                int m = (l + r) / 2;
                if (a[i][j] > a[m].back()) l = m;
                else r = m;
            }
            dp[i] = max(dp[i], dp[l] + sz(a[i]) - j);
        }
        if (i != 0) dp[i] = max(dp[i - 1], dp[i]);
    }
    int ans = 0;
    for (int i : dp) ans = max(ans, i);
    cout << ans << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    //cin >> n;
    while(n--) solve();
}
