#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

#ifdef CLOWN

void dbg(ll a) { cout << a << "\n"; }

void dbg(int a) { cout << a << "\n"; }

void dbg(string &a) { cout << a << "\n"; }

void dbg(ll a, ll b) { cout << a << " " << b << "\n"; }

void dbg(int a, int b) { cout << a << " " << b << "\n"; }

void dbg(ll a, ll b, ll c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(int a, int b, int c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(vector<ll> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

void dbg(vector<int> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

#else
#define dbg(...)
#endif

struct segtree {
    vector<int> tree;
    int n = 1;

    void build(int nn) {
        tree.resize(4 * nn);
        n = nn;
    }

    void upd(int x, int lx, int rx, int i, int v) {
        if (rx - lx == 1) {
            tree[x] = max(tree[x], v);
        } else {
            int mid = (lx + rx) / 2;
            if (i < mid) {
                upd(2 * x + 1, lx, mid, i, v);
            } else {
                upd(2 * x + 2, mid, rx, i, v);
            }
            tree[x] = max(tree[2 * x + 1], tree[2*x + 2]);
        }
    }
    void upd(int i, int v) {
        upd(0, 0, n, i, v);
    }

    int get(int x, int lx, int rx, int l, int r) {
        if (lx >= r || rx <= l) return 0;
        if (l <= lx && rx <= r) return tree[x];
        int mid = (lx + rx) / 2;
        return max(get(2 * x + 1, lx, mid, l, r), get(2 * x + 2, mid, rx, l, r));
    }
    int get(int l, int r) {
        r++;
        return get(0, 0, n, l, r);
    }
};
void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    map<int, vector<int>> b;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; j++) {
            a[i][j] = rnd() % 10 + 1;
            cin >> a[i][j];
        }
        b[*max_element(all(a[i]))].push_back(i);
    }
    int ans = 0;
    segtree st;
    st.build(2e5 + 10);
    for (auto [mx, ids]: b) {
        for (auto i: ids) {
            int ccur = 0, val = 0;
            vector<int> used(a[i].size());
            for (int j = 0; j < a[i].size(); j++) {
                if (a[i][j] > ccur) {
                    ccur = a[i][j];
                    val++;
                    used[j] = 1;
                }
            }
            for (int j = 0; j < a[i].size(); j++) {
                if (used[j]) {
                    int prev = st.get(0, a[i][j] - 1);
                    st.upd(mx, val + prev);
                    val--;
                }
            }
        }
    }
    ans = st.get(0, 2e5 + 1);
    cout << ans << "\n";
}

int32_t main() {
#ifdef CLOWN
    freopen("C://Users//olymp//CLionProjects//untitled//input.txt", "r", stdin);
    freopen("C://Users//olymp//CLionProjects//untitled//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
