#include <bits/stdc++.h>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

typedef int64_t ll;
typedef uint64_t ull;

const int INF = 1e9 + 117;

int n;
vector<vector<int>> alb;
vector<int> cur;
set<int> usd;
int ans = 0;

int get_ans(vector<int>& a) {
    int res = 1;
    int mx = a[0];
    for (int i = 1; i < a.size(); ++i) {
        if (mx < a[i]) {
            res++;
            mx = a[i];
        }
    }
    return res;
}

void f(int deep) {
    if (deep == n) {
        vector<int> res;
        for (auto e : cur) {
            for (int i = 0; i < alb[e].size(); ++i) res.push_back(alb[e][i]);
        }
        ans = max(ans, get_ans(res));
        return;
    }
    for (int i = 0; i < n; ++i) {
        if (usd.find(i) != usd.end()) continue;
        usd.insert(i);
        cur.push_back(i);
        f(deep + 1);
        cur.pop_back();
        usd.erase(i);
    }
}

int main() {
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fast();
    cin >> n;
    alb.resize(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        alb[i].resize(k);
        for (auto& e : alb[i]) cin >> e;
    }
    if (n <= 10) {
        f(0);
        cout << ans << '\n';
        return 0;
    }
    bool fl = false;
    for (auto& e : alb) {
        if (e[0] == 2) continue;
        fl = true;
        break;
    }
    if (fl) {
        cout << 2 << '\n';
        return 0;
    }
    bool is_all_zer = false;
    bool is_two = false;
    for (auto& e : alb) {
        bool fll = true;
        for (int i = 0; i < e.size(); ++i) {
            if (e[i] == 2) {
                is_two = true;
                fll = false;
            }
        }
        if (fll) is_all_zer = true;
    }
    if (is_all_zer && is_two) {
        cout << 2 << '\n';
    } else {
        cout << 1 << '\n';
    }
    return 0;
}
