
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cmath>
#include <random>

#define pll pair<long long, long long>
#define ll long long
#define ft first
#define sd second
#define sll set<long long>
#define msll multiset<long long> 
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define vll vector<ll>
#define ve vector
#define mp make_pair

using namespace std;

ll n;
ve<vll> a;

void solve() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		ll k;
		cin >> k;
		vll b(k);
		ll mx = 0;

		for (auto& j : b) {
			cin >> j;
			mx = max(mx, j);
		}
		b.push_back(mx);
		a.push_back(b);
	}

	sort(all(a), [&](vll aa, vll bb) {
		return aa.back() < bb.back();
		});
	
	ll prevmx = -1;
	ll prev = -1;
	ll st = -1;
	pll bst = { -1LL, -1LL };

	for (int i = 0; i < n; i++) {
		if (a[i].back() != prev) {
			prevmx = prev;
			if (bst != mp( -1LL, -1LL ) && bst.sd != st && st != -1) {
				swap(a[st], a[bst.sd]);
				//cout << st << ' ' << bst.sd << "\n";
			}
			bst = { -1LL, -1LL };
			st = i;
			//cout << i << "\n";
		}	

		ll cur = 0;

		ll kk = prevmx;

		for (auto& j : a[i]) {
			if (j > kk) {
				cur++;
			}
			kk = max(kk, j);
		}

		bst = max(bst, mp(cur, (ll)i));

		prev = a[i].back();
	}

	if (bst != mp(-1LL, -1LL) && bst.sd != st && st != -1) {
		swap(a[st], a[bst.sd]);
	}

	ll mx = 0;
	ll ans = 0;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < a[i].size(); j++) {
			if (a[i][j] > mx) {
				ans++;
			}

			mx = max(mx, a[i][j]);
			//cout << a[i][j] << " ";
		}
		//cout << "\n";
	}

	

	cout << ans << "\n";

}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 

	solve();

	return 0;
}
