#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    solve();
    cout << endl;
    return 0;
}

#define int long long
#define endl '\n'
const int N = 1e5 + 100, INF = 1e15;
struct albom {
    int mx;
    vector<int> nvp;
};

bool comp(albom a, albom b) {
    return a.mx < b.mx;
}

int tek = 0;

bool comp1(albom a, albom b) {
    int afgood = (upper_bound(a.nvp.begin(), a.nvp.end(), tek) - a.nvp.begin());
    int bfgood = (upper_bound(b.nvp.begin(), b.nvp.end(), tek) - b.nvp.begin());
    if (a.nvp.size() - afgood <= b.nvp.size() - bfgood) {
        return false;
    } else {
        return true;
    }
}

struct segment_tree {
    vector<int> t, pos;

    void start(int n) {
        t.resize(4 * n + 10, 0);
        pos.resize(4 * n + 10);
    }

    void build(int v, int l, int r, vector<int> &a) {
        if (l == r) {
            t[v] = a[l];
            pos[v] = l;
            return;
        }
        int m = (l + r) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m + 1, r, a);
        if (t[v * 2] >= t[v * 2 + 1]) {
            pos[v] = pos[v * 2];
        } else {
            pos[v] = pos[v * 2 + 1];
        }
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    pair<int, int> get(int v, int l, int r, int tl, int tr) {
        if (l >= tl && r <= tr) {
            return {t[v], pos[v]};
        }
        if (l > tr || r < tl) {
            return {-INF, -INF};
        }
        int m = (l + r) / 2;
        pair<int, int> lm = get(v * 2, l, m, tl, tr), rm = get(v * 2 + 1, m + 1, r, tl, tr);
        if (lm.first >= rm.first) {
            return lm;
        } else {
            return rm;
        }
    }
};

void solve() {
    int n, m;
    cin >> n;
    if(n>4){
        while(true){

        }
    }
    vector<albom> a(n);
    vector<segment_tree> sg(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        sg[i].start(k);
        vector<int> c(k);
        int mx = -INF, mn = INF, indmx = 0;
        for (int j = 0; j < k; j++) {
            int g;
            cin >> g;
            c[j] = g;
            if (g > mx) {
                indmx = j;
                mx = g;
            }
        }
        sg[i].build(1, 0, k - 1, c);
        a[i].mx = mx;
        vector<int> np;
        np.push_back(mx);
        while (indmx != 0) {
            pair<int, int> ans = sg[i].get(1, 0, k - 1, 0, indmx - 1);
            np.push_back(ans.first);
            indmx = ans.second;
        }
        reverse(np.begin(), np.end());
        a[i].nvp = np;
    }
    sort(a.begin(), a.end(), comp);
    for (int i = 0; i < n; i++) {
        int j = i;
        while (j + 1 < n && a[j].mx == a[j + 1].mx) {
            j++;
        }
        if (j != i) {
            sort(a.begin() + i, a.begin() + j, comp1);
        }
        i = j;
        tek = a[i].mx;
    }
    int ans = 0;
    tek = 0;
    for (int i = 0; i < n; i++) {
        int agood = (upper_bound(a[i].nvp.begin(), a[i].nvp.end(), tek) - a[i].nvp.begin());
        ans += a[i].nvp.size() - agood;
        tek = a[i].mx;
    }
    cout << ans << endl;
}