#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define dbg(x) cerr << #x << ": " << x << endl;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<vector<int>> a(n);
    vector<vector<int>> b(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (auto& x : a[i]) {
            cin >> x;
        }
        int curr_max = 0;
        for (auto x : a[i]) {
            if (x > curr_max) {
                b[i].push_back(x);
                curr_max = x;
            }
        }
    }

    sort(b.begin(), b.end(), [&](const auto& lhs, const auto& rhs) {
        int cnt1 = lhs.size();
        int cnt2 = rhs.size();
        int pos1 = upper_bound(rhs.begin(), rhs.end(), lhs.back()) - rhs.begin();
        int pos2 = upper_bound(lhs.begin(), lhs.end(), rhs.back()) - lhs.begin();
        cnt1 += rhs.size() - pos1;
        cnt2 += lhs.size() - pos2;
        return make_pair(cnt1, rhs.back()) > make_pair(cnt2, lhs.back());
    });

    int curr_max = 0;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (auto x : b[i]) {
            if (x > curr_max) {
                curr_max = x;
                ++ans;
            }
        }
    }
    cout << ans << '\n';

    return 0;
}