#include "bits/stdc++.h"

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
#define endl '\n'

using namespace std;

mt19937 gen(time(nullptr));
const int base = 177013;
const int mod = 1e9 + 7;

int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<vector<int>> data(n);
    vector<int> all_vals;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int u;
            cin >> u;
            if(j == 0 or u > data[i][data[i].size() - 1]){
                data[i].emplace_back(u);
                all_vals.emplace_back(u);
            }
        }
    }
    sort(all(all_vals));
    all_vals.erase(unique(all(all_vals)), all_vals.end());
    int m_val = all_vals.size() + 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < data[i].size(); ++j) {
            data[i][j] = lower_bound(all(all_vals), data[i][j]) - all_vals.begin() + 1;
        }
    }

    int ans = 0;
    vector<int> dp(m_val, 0);
    for (int i = 0; i < m_val; ++i) {
        for (int j = 0; j < n; ++j) {
            if(i < data[j][data[j].size() - 1]){
                int st = data[j].size() - (lower_bound(all(data[j]), i + 1) - data[j].begin());
                int to = data[j][data[j].size() - 1];
                dp[to] = max(dp[to], dp[i] + st);
                ans = max(ans, dp[to]);
            }
        }
        if(i != 1){
            dp[i] = max(dp[i], dp[i - 1]);
        }
    }
    cout << ans << endl;
}
