#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;

struct alb {
    vector<int> a;
    vector<int> mxs;
    alb(vector<int>& c) {
        a = c;
        mxs.push_back(a[0]);
        for (int i = 1; i < a.size(); ++i) {
            if (a[i] > mxs.back()) {
                mxs.push_back(a[i]);
            }
        }
    }
};

int main() {
    int n, x;
    cin >> n;
    vector<alb> a;
    int start = -1;
    for (int i = 0;i < n; ++i) {
        int k;
        cin >> k;
        vector<int> temp;
        for (int i = 0; i < k; ++i) {
            cin >> x;
            start = max(start, x);
            temp.push_back(x);
        }
        a.emplace_back(temp);
    }
    vector<int> dp(200001, 0);
    for (int i = start; i >= 0; --i) {
        dp[i] = dp[i + 1];
        for (alb al : a) {
            dp[i] = max(dp[i], (int)al.mxs.size() - (int)(lower_bound(al.mxs.begin(), al.mxs.end(), i) - al.mxs.begin()) + (al.mxs.back() + 1 < (int)(2e6 + 1) ? dp[al.mxs.back() + 1] : 0));
        }
    }
    cout << dp[0] << endl;
    return 0;
}
