#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

void solve() {
  int n;
  cin >> n;
  vector<vector<int>> a(n), b(n);
  for (int i = 0; i < n; ++i) {
    int k;
    cin >> k;
    a[i].resize(k);
    int last = 0;
    for (int j = 0; j < k; ++j) {
      cin >> a[i][j];
      if (a[i][j] > last) {
        last = a[i][j];
        b[i].push_back(a[i][j]);
      }
    }
    //for (int x : b[i]) cerr << x << ' ';
    //cerr << endl;
  }
  vector<int> order(n);
  iota(all(order), 0);
  sort(all(order), [&](int i, int j) {
    return b[i].back() < b[j].back();
  });
  vector<int> dp(n);
  for (int i = 0; i < n; ++i) {
    dp[i] = size(b[order[i]]);
    for (int j = 0; j < i; ++j) {
      int mx = b[order[j]].back();
      int id = upper_bound(all(b[order[i]]), mx) - b[order[i]].begin();
      dp[i] = max(dp[i], dp[j] + size(b[order[i]]) - id);
    }
  }
  cout << *max_element(all(dp));
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
