#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <queue>
#include <stack>
#include <tuple>
#include <bitset>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double db;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

mt19937 rng(time(0));

const int C = 2e3 + 5;

bool cmp(vector<int>& a, vector<int>& b) {
    return a.back() < b.back();
}

void solve() {
    int n, k, val;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> k;
        for (int j = 0; j < k; j++) {
            cin >> val;
            if (a[i].empty() || a[i].back() < val)
                a[i].push_back(val);
        }
    }
    vector<int> dp(C, 0);
    sort(All(a), cmp);
    for (int i = 0; i < n; i++) {
        int last = a[i].back(), s = sz(a[i]);
        for (int j = 0; j < s; j++) {
            for (int k = 0; k < a[i][j]; k++) {
                dp[last] = max(dp[last], dp[k] + s - j);
            }
        }
    }
    cout << *max_element(All(dp)) << '\n';
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    solve();
}