#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include<bits/stdc++.h>
#define int long long
#define sz(a) (int)a.size()

using namespace std;

const int N = 200005;

int t[4 * N], b[4 * N];

void push(int v, int l, int r) {
    if (b[v] != -1) {
        t[v] = b[v];
        if (l + 1 != r) {
            b[2 * v + 1] = b[2 * v + 2] = b[v];
        }
    }
    b[v] = -1;
}

void upd(int v, int l, int r, int ql, int qr, int x) {
    if (ql <= l && r <= qr) {
        b[v] = x;
        push(v, l, r);
        return;
    }
    if (ql >= r || qr <= l) {
        return;
    }
    push(v, l, r);
    int m = (l + r) / 2;
    upd(2 * v + 1, l, m, ql, qr, x);
    upd(2 * v + 2, m, r, ql, qr, x);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

void upd1(int v, int l, int r, int qi) {
    push(v, l, r);
    if (l + 1 == r) {
        t[v]++;
        return;
    }
    int m = (l + r) / 2;
    if (qi < m) {
        upd1(2 * v + 1, l, m, qi);
    }
    else {
        upd1(2 * v + 2, m, r, qi);
    }
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    push(v, l, r);
    if (ql <= l && r <= qr) {
        return t[v];
    }
    if (ql >= r || qr <= l) {
        return 0;
    }
    int m = (l + r) / 2;
    return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    fill(b, b + 4 * N, -1);
    int n;
    cin >> n;
    vector<vector<int>> in(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        in[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> in[i][j];
        }
    }
    vector<vector<int>> a(n);
    vector<int> pt(n);
    set<pair<int, int>> s;
    for (int i = 0; i < n; ++i) {
        int cur = 0;
        for (int j : in[i]) {
            if (j > cur) {
                cur = j;
                a[i].push_back(j);
                s.insert({j, i});
            }
        }
    }
    int ans = 0;
    for (int c = 1; c <= 200000; ++c) {
        if ((*s.begin()).first != c) continue;
        vector<int> allin;
        while (!s.empty()) {
            auto cur = *s.begin();
            if (cur.first != c) break;
            s.erase(cur);
            upd1(0, 0, n, cur.second);
            pt[cur.second]++;
            if (pt[cur.second] == sz(a[cur.second])) {
                allin.push_back(cur.second);
            }
        }
        int can = -1;
        for (int i : allin) {
            if (max(get(0, 0, n, 0, i), get(0, 0, n, i + 1, n)) > get(0, 0, n, i, i + 1)) {
                continue;
            }
            can = i;
            break;
        }
        if (can != -1) {
            ans += get(0, 0, n, can, can + 1);
            upd(0, 0, n, 0, n, 0);
        }
    }
    cout << ans << '\n';
}
