#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define endl "\n"
#define eb emplace_back
#define lb(a, b) lower_bound(all(a), b)
#define ub(a, b) upper_bound(all(a), b)

int bubbleGum = 0;
#ifdef LOCAL
#include "Templates/DebugTemplate.cpp"
#define FAST_IO ;
#else
#define dbg(...) ++bubbleGum;
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif

const int N = (1 << 18);


int n;
vec<int> a[N];
vec<int> comp[N];
vec<int> lis[N];
vec<int> tmps[N];
int ma[N];



void input() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        a[i].resize(k);
        for (auto& it : a[i])
            cin >> it;
        ma[i] = *max_element(all(a[i]));
    }
}

void precount() {
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < sz(a[i]); ++j)
            a[i][j] = max(a[i][j], a[i][j - 1]);
        vec<int> tmp;
        for (auto& it : a[i])
            tmp.eb(it);
        sort(all(tmp)); tmp.resize(unique(all(tmp)) - tmp.begin());
        tmp.insert(tmp.begin(), 0);
        for (int j = 0; j < sz(a[i]); ++j) {
            int ind = lb(tmp, a[i][j]) - tmp.begin();
            comp[i].eb(ind);
        }
        tmps[i] = tmp;
        dbg(i, comp[i]);

        lis[i].resize(sz(a[i]) + 5);
        for (int x = sz(tmp) - 1; x >= 0; --x)
            lis[i][x] = lis[i][x + 1] + 1;

        dbg(i, comp[i]);
        dbg(lis[i]);

    }
}







#define lson (v << 1)
#define rson (v << 1 | 1)

struct segmentTree {
    int tree[N << 1];
    segmentTree() {
        fill(tree, tree + (N << 1), 0);
    };

    void upd(int v) {
        tree[v] = max(tree[lson], tree[rson]);
    }

    void update(int v, int val) {
        v += N;
        tree[v] = max(tree[v], val);
        v >>= 1;
        while (v) {
            upd(v), v >>= 1;
        }
    }

    int getMax(int l, int r) const {
        l += N, r += N;
        int res = 0;
        while (l < r) {
            if (l & 1)
                res = max(res, tree[l++]);
            if (!(r & 1))
                res = max(res, tree[r--]);
            l >>= 1, r >>= 1;
        }
        if (l == r)
            res = max(res, tree[l]);
        return res;
    }

} braTree;





int dp[N];

void solve() {

    vec<int> arr(n); iota(all(arr), 0);
    sort(all(arr), [&](int one, int two){
        return ma[one] < ma[two];
    });
    dbg(arr);

    for (auto& i : arr) {
        int j = sz(tmps[i]) - 1;
        int best = 0;
        dbg(i, a[i], "-------------------");

        while (j >= 1) {

            int l = tmps[i][j - 1], r = tmps[i][j] - 1;
            dbg(j, l, r);

            int val = braTree.getMax(l, r);
            dbg(val, lis[i][j]);
            val += lis[i][j];
            best = max(best, val);

            --j;
        }
        dbg(ma[i], best);
        braTree.update(ma[i], best);
        dp[ma[i]] = max(dp[ma[i]], best);
    }

    cout << *max_element(dp, dp + N);
}




signed main() {
#ifdef LOCAL
    freopen("C:\\Users\\user\\CLionProjects\\OpenOlymp\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    input();
    precount();
    solve();

}

/*

2
1
100000
3
100000 1 99



 */