#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <iomanip>

using namespace std;
typedef long long ll;

int n;
vector <int> a[200010];
int ans;

vector <pair <int, int>> possible[200010];
int dp[200010];

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		int k;
		cin >> k;
		while (k--)
		{
			int x;
			cin >> x;
			if (a[i].empty() || a[i].back() < x) a[i].push_back(x);
		}

		for (int j = 0; j < a[i].size(); ++j)
		{
			possible[a[i].back()].push_back({ a[i][j], a[i].size() - j });
		}
	}

	for (int i = 1; i <= 200000; ++i)
	{
		dp[i] = dp[i - 1];
		for (auto j : possible[i])
		{
			dp[i] = max(dp[i], dp[j.first - 1] + j.second);
		}

		ans = max(ans, dp[i]);
	}

	cout << ans;

	return 0;
}