#include<bits/stdc++.h>
#define pb push_back
using namespace std;

const int MAXN = 2e5 + 5;

int N, max_x, dp[MAXN];
vector<vector<int>> A;

int larger(int x, vector<int> &A){
	int l = 0, r = A.size() - 1, ans = 0;
	while(l <= r){
		int m = (l + r) / 2;
		if(A[m] > x){
			ans = m;
			r = m - 1;
		}
		else{
			l = m + 1;
		}
	}
	return A.size() - ans;
}

int main(){
	cin >> N;
	A.resize(N);
	for(auto &v : A){
		int k; cin >> k;
		v.pb(0);
		for(int i = 0; i < k; i ++){
			int x; cin >> x;
			max_x = max(max_x, x);
			if(v.back() < x){
				v.pb(x);
			}
		}
	}
	for(int curr = 0; curr <= max_x; curr ++){
		for(auto jump : A){
			int next = jump.back();
			if(next <= curr) continue;
			dp[next] = max(dp[next], dp[curr] + larger(curr, jump));
		}
	}
	int ans = 0;
	for(int i = 0; i <= max_x; i ++){
		ans = max(ans, dp[i]);
	}
	cout << ans << endl;
}
/**
4
5 4 9 4 6 8
1 7
2 8 6
1 1

4
2 3 4
2 1 8
2 2 8
2 7 9

*/