#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a)  a.begin(), a.end()
#define rall(a)  a.rbegin(), a.rend()
#define sz(a) ((int)a.size())

random_device rd;

const long long mod = 1e9 + 7;
const long long inf = 9099999999999999999;
const long long nmax = 2e5 + 100;

struct ms{
    int x, y, k;
};

void solve() {
    int n;
    cin >> n;

    if (n <= 7) {
        vector <int> p(n);
        iota(all(p), 0);
        vector <vector <int>> arr(n);
        for (int i = 0; i < n; i++) {
            int k;
            cin >> k;
            while (k--) {
                int x;
                cin >> x;
                if (arr[i].empty() || arr[i].back() < x)
                    arr[i].emplace_back(x);
            }
        }

        int ans = 0, q = 20000;
        do {
            shuffle(all(p), rd);
            shuffle(all(p), rd);
            int res = 0, mx = -1;
            for (int i = 0; i < n; i++) {
                for (auto x : arr[p[i]]) {
                    if (x > mx) {
                        res++;
                        mx = x;
                    }
                }
            }
            ans = max(ans, res);
        } while (q--);
        cout << ans;
        return;
    }

    vector <ms> p(n);
    vector <vector <int>> arr(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        while (k--) {
            int x;
            cin >> x;
            if (arr[i].empty() || arr[i].back() < x)
                arr[i].emplace_back(x);
        }
        p[i] = {arr[i].back(), i, sz(arr[i]) - 1};
    }

    sort(all(p), [](ms a, ms b) {
        return a.x < b.x || (a.x == b.x && a.k < b.k);
    });

    int res = 0, mx = -1;
    for (int i = 0; i < n; i++) {
        for (auto x : arr[p[i].y]) {
            if (x > mx) {
                res++;
                mx = x;
            }
        }
    }
    cout << res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}
