#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef long long ll;
typedef long double ld;
//random_device rd;
//mt19937 gen(rd);

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> vec(n + 1), sum(n + 1);
    vector<pair<int, int>> srt = { {0, 0} };
    for (int i = 1; i <= n; i++) {
        int k, x;
        cin >> k;
        for (int j = 0; j < k; j++) {
            cin >> x;
            if (vec[i].empty() || vec[i].back() < x) {
                vec[i].push_back(x);
            }
        }
        srt.push_back({ vec[i].back(), i });
    }
    sort(srt.begin(), srt.end());
    vector<ll> dp(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        int j = i - 1, pos = vec[srt[i].second].size() - 1, sum = 0;
        while (j >= 0) {
            while (pos >= 0 && vec[srt[i].second][pos] > srt[j].first) {
                sum++; 
                pos--;
            }
            dp[i] = max(dp[i], dp[j] + sum);
            j--;
        }
    }
    cout << dp[n];
}