#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()
#define FASTIO ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
typedef long long ll;

struct node {
    ll mini, maxi, cnt;
    vector <ll> f;
};

bool cmp(node z1, node z2) {
    if (z1.maxi==z2.maxi) {
        if (z1.mini==z2.mini) {
            return z1.cnt>z2.cnt;
        }
        return z1.mini<z2.mini;
    }
    return z1.maxi<z2.maxi;
}

int main()
{
    FASTIO;
    ll n;
    cin >> n;
    vector <node> a(n);

    for (ll i=0; i<n; i++) {
        ll m;
        cin >> m;
        vector <ll> b;
        ll l=-1;
        for (ll j=0; j<m; j++) {
            ll x;
            cin >> x;
            if (x>l) b.push_back(x);
            l=max(l, x);
        }
        for (ll j=0; j<b.size(); j++) a[i].f.push_back(b[j]);
        a[i].cnt=b.size();
        a[i].mini=b[0];
        a[i].maxi=b.back();
    }
    if (n>30000) {
        sort(all(a), cmp);
        ll ans=0, l=-1;

        for (ll i=0; i<n; i++) {
            for (ll j=0; j<a[i].cnt; j++) {
                if (a[i].f[j]>l) ans++;
                l=max(l, a[i].f[j]);
            }
        }
        cout << ans;
        return 0;
    }
    sort(all(a), cmp);
    vector <ll> dp(n), pref(n);
    dp[0]=a[0].cnt;
    pref[0]=dp[0];

    for (ll i=1; i<n; i++) {
        for (ll j=i-1; j>=0; j--) {
            if (a[j].maxi<a[i].mini) {
                dp[i]=max(dp[i], pref[j]+a[i].cnt);
                break;
            }
            if (a[i].maxi==a[j].maxi) dp[i]=max(dp[i], dp[j]);
            else {
                ll k=upper_bound(all(a[i].f), a[j].maxi)-a[i].f.begin();
                k=a[i].cnt-k;
                dp[i]=max(dp[i], dp[j]+k);
            }
        }
        pref[i]=max(pref[i-1], dp[i]);
    }
    cout << pref[n-1];
    return 0;
}
