//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> v(n);
    bool small = true;
    bool small2 = true;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        v[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> v[i][j];
            if (v[i][j] > 2) {
                small = false;
            }
            if (v[i][j] > 10) {
                small2 = false;
            }
        }
    }

    if (small) {
        int ans = 1;
        bool ed = false;
        bool s = false;
        for (int i = 0; i < n; i++) {
            bool edl = false;
            bool sl = false;
            for (int j = 0; j < v[i].size(); j++) {
                if (v[i][j] == 1) {
                    edl = true;
                } else {
                    if (edl) {
                        ans = 2;
                    }
                    sl = true;
                }
            }
            if (edl && s) {
                ans = 2;
            }
            if (sl && ed) {
                ans = 2;
            }
            if (edl) {
                ed = true;
            }
            if (sl) {
                s = true;
            }
        }
        cout << ans << endl;
        return 0;
    }

    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        p[i] = i;
    }

    if (n <= 7) {
        int need = 1;
        for (int i = 1; i <= 7; i++) {
            need *= i;
        }
        need++;
        int ans = 0;
        for (int w = 0; w < need; w++) {
            int now = 0;
            int kol = 0;
            for (int i = 0; i < n; i++) {
                for (int el: v[p[i]]) {
                    if (el > now) {
                        kol++;
                        now = el;
                    }
                }
            }
            ans = max(ans, kol);
            next_permutation(p.begin(), p.end());
        }
        cout << ans << endl;
    } else {
        int ans = 0;
        for (int w = 0; w < 10; w++) {
            vector<int> dp((int) 2e5 + 1, (int) 1e9);
            for (int i = 0; i < n; i++) {
                for (int el: v[p[i]]) {
                    auto it = lower_bound(dp.begin(), dp.end(), el);
                    dp[(int) (it - dp.begin())] = el;
                    ans = max(ans, (int) (it - dp.begin()) + 1);
                }
            }

            for (int j = 0; j < 1000; j++) {
                swap(p[rand() % n], p[rand() % n]);
            }
        }
        cout << ans << endl;
    }
}
