#include <bits/stdc++.h>

#define ll long long

using namespace std;

struct block {
    vector<int> arr;
    int mx;
    block(vector<int>& mas) {
        mx = 0;
        for (int i = 0; i < mas.size(); i++) {
            if (mas[i] > mx) {
                arr.push_back(mas[i]);
                mx = mas[i];
            }
        }
    }
    void dbg() {
        for (int i = 0; i < arr.size(); i++) {
            cout << arr[i] << " ";
        }
        cout << "\n";
    }
};

bool comp(block a, block b) {
    if (a.mx == b.mx) {
        return int(a.arr.size()) >= int(b.arr.size());
    }
    return a.mx < b.mx;
}

int main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie();
    //cout.tie();
    int n;
    cin >> n;
    vector<block> v;

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        vector<int> arr(k);
        for (int j = 0; j < k; j++) {
            cin >> arr[j];
        }
        v.push_back(block(arr));
    }

    sort(v.begin(), v.end(), comp);
    vector<vector<int>> dp(n, vector<int>(2, 0));
    dp[0][0] = 0;
    dp[0][1] = int(v[0].arr.size());


    for (int i = 1; i < n; i++) {
        dp[i][0] = max(dp[i - 1][0], dp[i - 1][1]);
        dp[i][1] = dp[i][0];

        for (int j = 0; j < v[i].arr.size(); j++) {
            int l = -1, r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (v[m].mx < v[i].arr[j]) {
                    l = m;
                } else {
                    r = m;
                }
            }
            if (l != -1) dp[i][1] = max(dp[i][1], max(dp[l][1], dp[l][0]) + int(v[i].arr.size()) - j);
            else dp[i][1] = max(dp[i][1], int(v[i].arr.size()) - j);
        }
    }
    cout << max(dp[n - 1][0], dp[n - 1][1]);
    return 0;
}

/*
3
4
1 3 5 7
4
2 4 6 8
1
3
*/
