#include <iostream>
#include "vector"
#include "set"
#include "random"
#include "map"
#include "string"
#include "math.h"
#include "algorithm"
#define all(a) a.begin(), a.end()
#define ll long long
#define len(a) (int)a.size()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fort(a, b) for(int a = 0; a < b; a++)
#define f first
#define s second
using namespace std;

int mod = 1e9+7;
int modsum(int a, int b){
    if(a + b < mod){
        return a + b;
    }
    return a + b - mod;
}
int modrazn(int a, int b){
    if(a - b < 0){
        return a - b + mod;
    }
    return a - b;
}
int modmult(int a, int b){
    return (int)1ll*a*b%mod;
}
int modpow(int a, int n){
    if(n == 0){
        return 1;
    }
    if(n % 2 == 0){
        return modpow(modmult(a,a), n/2);
    }
    return modmult(a, modpow(a, n - 1));
}
int moddel(int a, int b){
    return modmult(a, modpow(b, mod - 2));
}

struct dots {
    int x, y;
};
int scalar(dots a, dots b){
    return a.x*b.x + a.y*b.y;
}
int psevd(dots a, dots b){
    return a.x * b.y - a.y * b.x;
}

bool cmp(vector<int>& a, vector<int>&b){
    if(a[len(a) - 1] != b[len(b) - 1]){
        return a[len(a) - 1] < b[len(b) - 1];
    }
    return len(a) < len(b);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> nabor(n);
    fort(i, n){
        int now = 0;
        int k;
        cin >> k;
        vector<int> temp;
        fort(j, k){
            int t;
            cin >> t;
            if(t > now){
                temp.push_back(t);
                now = t;
            }
        }
        nabor[i] = temp;
    }
    sort(all(nabor), cmp);
    int now = 0;
    int ans = 0;
    fort(i, n){
        fort(j, len(nabor[i])){
            if(nabor[i][j] > now){
                ans++;
                now = nabor[i][j];
            }
        }
    }
    cout << ans;
}