#include <bits/stdc++.h>

using namespace std;

#define pikachu push_back
#define mp make_pair
#define st first
#define nd second
#define pll pair<ll, ll>
#define pii pair<int, int>
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;

template<typename A, typename B>
string to_string(pair<A, B> p);

string to_string(string s) {
    return s;
}

string to_string(char s) {
    return "'" + string(1, s) + "'";
}

template<typename A>
string to_string(A v) {
    string res = "{";
    bool fl = 1;
    for (auto x: v) {
        if (!fl) {
            res += ", ";
        }
        fl = 0;
        res += to_string(x);
    }
    res += "}";
    return res;
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

void debug_out() {
    cerr << endl;
}

template<typename H, typename... T>
void debug_out(H h, T... t) {
    cerr << " " << to_string(h);
    debug_out(t...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

template<typename A, typename B>
bool cmin(A &a, const B &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename A, typename B>
bool cmax(A &a, const B &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

struct HASH {
    size_t operator()(const pll &p) const {
        return p.st ^ p.nd;
    }
};

ll bpow(ll a, ll n, ll MOD) {
    ll res = 1;
    while (n) {
        if (n & 1) (res *= a) %= MOD;
        (a *= a) %= MOD;
        n /= 2;
    }
    return res;
}

void run();

signed main() {
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
}
const ll N = 2e5 + 3;
struct SegT{
    ll n;
    vector<ll> T;
    SegT(ll t): n(t + 1){
        while(n & (n - 1)) ++n;
        T.resize(2 * n + 1, -1e9);
    }
    void upd(ll pos, ll x){
        pos += n - 1;
        cmax(T[pos], x);
        while(pos){
            pos = (pos - 1) / 2;
            T[pos] = max(T[pos * 2 + 1], T[pos * 2 + 2]);
        }
    }

    ll get(ll v, ll L, ll R, ll l, ll r){
        if (L >= r || R <= l) return -1e9;
        if (L >= l && R <= r) return T[v];
        ll m = (R + L) / 2;
        return max(get(v * 2 + 1, L, m, l, r), get(v * 2 + 2, m, R, l, r));
    }

    ll get(ll l, ll r){
        return get(0, 0, n, l, r);
    }
};
void run() {
    ll n;
    cin >> n;
    vector<vector<ll>> kek(n);
    ll last = -1;
    for (ll i = 0; i < n; ++i) {
        ll k;
        cin >> k;
        last = -1;
        while (k--) {
            ll x;
            cin >> x;
            if (x > last) kek[i].pikachu(x), last = x;
        }
    }
    auto comp = [&](const vector<ll>& a, const vector<ll>& b){
        return a.back() < b.back();
    };
    sort(all(kek), comp);
    SegT dp(N);
    dp.upd(0, 0);
    for(auto v: kek){
        for(ll i = 0; i < sz(v); ++i){
            dp.upd(v.back(), sz(v) - i + dp.get(0, v[i]));
        }
    }

    cout << dp.get(0, N);
}
