#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

const int MAX_A = 2e5 + 1;

void solve() {
    vector<vector<pair<int, int>>> in(MAX_A);
    for (int i = 0; i < MAX_A - 1; ++i) {
        in[i + 1].emplace_back(i, 0);
    }
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        vector<int> a(k);
        for (int j = 0; j < k; ++j) {
            cin >> a[j];
        }
        vector<int> b = {0};
        for (int j = 0; j < k; ++j) {
            if (a[j] > b.back()) {
                b.push_back(a[j]);
            }
        }
        for (int j = 1; j < sz(b); ++j) {
            in[b.back()].emplace_back(b[j] - 1, sz(b) - j);
        }
    }
    vector<int> dp(MAX_A, 0);
    for (int i = 0; i < MAX_A; ++i) {
        for (auto [j, w] : in[i]) {
            dp[i] = max(dp[i], dp[j] + w);
        }
    }
    cout << dp[MAX_A - 1] << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}