#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

#define ll long long

bool cmp(pair<int, int>& a, pair<int, int>& b) {
	return a.second < b.second;
}

#define N 200001

int main() {
	int n;
	cin >> n;
	vector<vector<pair<int, int>>> d(N);
	int k;
	for (int i = 0; i < n; i++) {
		cin >> k;
		vector<int> a(k);
		int mx = 0, cnt = 0;
		for (int j = 0; j < k;j++) {
			cin >> a[j];
			if (a[j] > mx) {
				cnt++;
				mx = a[j];
			}
		}
		int nmx = 0;
		for (int j = 0; j < k; j++) {
			if (a[j] > nmx) {
				d[mx].push_back({ a[j], cnt--});
			}
			nmx = max(nmx, a[j]);
		}
	}
	
	int mx = 0;
	vector<int> dp(N);
	for (int i = N - 1; i >= 0; i--) {
		for (auto p : d[i]) {
			int v = p.first;
			int w = p.second;
			dp[v] = max(dp[v], w + mx);
		}
		mx = max(mx, dp[i]);
	}
	cout << mx;


	return 0;
}