#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define double long double

typedef tree<
        pair <int, int>,
        null_type,
        less < pair <int, int> >,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;


void solve(){
    int n;
    cin >> n;

    vector < vector <int> > a(n);
    for(int i = 0; i < n; ++i){
        int k;
        cin >> k;

        int mx = 0;
        for(int j = 0; j < k; ++j){
            int x;
            cin >> x;

            if(x > mx){
                mx = x;
                a[i].push_back(x);
            }
        }
    }

    sort(a.begin(), a.end(), [](vector <int> & a, vector <int> & b){
        return a.back() < b.back();
    });

    vector < pair <int, int> > dp;
    int l = -1, x = -1, mx = 0;
    for(int i = 0; i < n; ++i){
        if(a[i].back() != x){
            ++l;
            dp.push_back({mx, x});
            x = a[i].back();
            mx = 0;
        }

        int otv = 0, r = a[i].size() - 1;
        for(int j = l; j >= 0 && l + 1 - j <= a[i].size(); --j){
            while(r >= 0 && a[i][r] > dp[j].second){
                --r;
            }

            otv = max(otv, dp[j].first + (int)a[i].size() - 1 - r);
        }

        mx = max(otv, mx);
    }

    dp.push_back({mx, x});

    cout << dp.back().first;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;
    //cin >> tests;
    while(tests--) {
        solve();
    }
}
