#pragma GCC target("avx2")
#pragma GCC optimize("Ofast,fast-math,unroll-loops,inline")
#include <bits/stdc++.h>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> albums(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int tmp;
            cin >> tmp;
            if (albums[i].empty() || tmp > albums[i].back())
                albums[i].push_back(tmp);
        }
    }
    sort(albums.begin(), albums.end(), [&](const vector<int> &a, const vector<int> &b) {
        return a.back() < b.back();
    });
    vector<int> dp(n);
    for (int i = 0; i < n; ++i) {
        dp[i] = albums[i].size();
        for (int j = 0; j < i; ++j) {
            int newln = dp[j];
            newln += albums[i].end() - upper_bound(albums[i].begin(), albums[i].end(), albums[j].back());
            dp[i] = max(dp[i], newln);
        }
    }
    cout << *max_element(dp.begin(), dp.end());
}