#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define int ll
#define double ld

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream& operator<<(ostream& os, vector<T> & v) {
    for (auto& e : v)
        os << e << " ";
    return os;
}

const int maxn = 2e5;

vector<int> arr[maxn];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            if (j == 0 or arr[i].back() < x)
                arr[i].push_back(x);
        }
    }

    vector<int> ord(n);
    iota(all(ord), 0);
    sort(all(ord), [&](int a, int b) {return arr[a].back() < arr[b].back(); });

    vector<int> dp(maxn + 1);
    for (int x : ord) {
        for (int i = 0; i < arr[x].size(); ++i) {
            int res = 0;
            for (int j = 0; j < arr[x][i]; ++j)
                res = max(res, dp[j]);

            int len = arr[x].size() - i;
            dp[arr[x].back()] = max(dp[arr[x].back()], res + len);
        }
    }

    cout << *max_element(all(dp)) << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}
