#include <iostream>
#include <iomanip>
#include <set>
#include <vector>
#include <algorithm>
#include <stack>
using namespace std;
typedef long long ll;
typedef long double ld;
struct st {
	vector <int> x;
	int ind;
};
bool comp(st& a, st& b) {
	return *max_element(a.x.begin(), a.x.end()) < *max_element(b.x.begin(), b.x.end());
}
int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	int n; cin >> n;
	vector <st> a(n);
	vector <vector <int>> dp1(n);
	vector <int> mx(n);
	for (int i = 0; i < n; i++) {
		int k; cin >> k;
		a[i].x.resize(k), dp1[i].resize(k, 1);
		vector <int> bs(k, k);
		a[i].ind = i;
		for (int j = 0; j < k; j++) cin >> a[i].x[j];
		stack <int> x;
		for (int j = k - 1; j >= 0; j--) {
			while (x.size() && a[i].x[x.top()] <= a[i].x[j]) x.pop();
			if (x.size()) bs[j] = x.top();
			x.push(j);
		}
		for (int j = k - 1; j >= 0; j--) {
			if (bs[j] != k) dp1[i][j] += dp1[i][bs[j]];
		}
	}
	sort(a.begin(), a.end(), comp);
	for (int i = 0; i < n; i++) mx[i] = *max_element(a[i].x.begin(), a[i].x.end());
	vector <int> dp(n), pref(n + 1);
	dp[0] = dp1[a[0].ind][0];
	pref[1] = dp[0];
	for (int i = 1; i < n; i++) {
		dp[i] = dp1[a[i].ind][0];
		for (int j = 0; j < a[i].x.size(); j++) {
			int ind = lower_bound(mx.begin(), mx.end(), a[i].x[j]) - mx.begin() - 1;
			if (ind < 0) continue;
			dp[i] = max(dp[i], dp1[a[i].ind][j] + pref[ind + 1]);
		}
		pref[i + 1] = max(pref[i], dp[i]);
	}
	cout << pref[n];
	return 0;
}