#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
//#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e9;
const int MAX = 2e3 + 5;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

int get(vector<int> &a, int mx) {
    int ans = 0;
    for(auto i : a) {
        ans += mx < i;
        umax(mx, i);
    }
    return ans;
}

int get(vector<vector<int>> &a) {
    int ans = 0;
    int mx = 0;
    for(auto x : a) {
        for(auto i : x) {
            ans += mx < i;
            umax(mx, i);
        }
    }
    return ans;
}

int stress = 1;

void out(vector<vector<int>> a) {
    cout << endl;
    for(auto x : a) {
        for(auto i : x) {
            cout << i << " ";
        }
        cout << '\n';
    }
    cout << endl;
}

int brute(vector<vector<int>> a) {
    vector<int> cmp;
    for(auto &x : a) {
        for(auto &i : x) {
            cmp.pb(i);
        }
    }
    cmp.pb(0);
    sort(all(cmp)); cmp.erase(unique(all(cmp)), cmp.end());
    for(auto &x : a) {
        for(auto &i : x) {
            i = lower_bound(all(cmp), i) - cmp.begin();
        }
    }
    int n = sz(a);
    auto comp = [&](vector<int> &f, vector<int> &s) {
        int mxf = *max_element(all(f));
        int mxs = *max_element(all(s));
        return mxf < mxs;
    };
    sort(all(a), comp);
    int v = *max_element(all(a.back())) + 1;
    vector<vector<int>> dp(n + 1, vector<int>(v));
    vector<vector<pair<int, int>>> p(n + 1, vector<pair<int, int>>(v));
    for(int i = 0; i < n; i++) {
        int mx = *max_element(all(a[i]));
        for(int j = 0; j < v; j++) {
            if(umax(dp[i + 1][mx], dp[i][j] + get(a[i], j))) p[i + 1][mx] = {j, 1};
            if(umax(dp[i + 1][j], dp[i][j])) p[i + 1][j] = {j, 0};
        }
    }
//    out(a);
    int j = max_element(all(dp[n])) - dp[n].begin();
    int ans = dp[n][j];
    vector<int> mask(n);
    for(int i = n; i; i--) {
        mask[i - 1] = p[i][j].s;
        j = p[i][j].f;
    }
//    for(auto i : mask) cout << i << " ";
//    cout << endl;
    return ans;
}

int my(vector<vector<int>> a) {
    int n = sz(a);
    vector<pair<pair<int, int>, int>> v;
    for(int i = 0; i < n; i++) {
        vector<vector<int>> curr = {a[i]};
        pair<int, int> val = {*max_element(all(a[i])), get(curr)};
        v.pb({val, i});
    }
    sort(all(v));
    vector<vector<int>> order;
    for(auto [useless, idx] : v) order.pb(a[idx]);
    int ans = get(order);
    return ans;
}

/*
3
3  1 10 1
3  6 5 10
1  3
*/

void solve() {
    int n = 3;
    if(!stress) cin >> n;
    vector<vector<int>> a(n);
    int m = 0;
    for(auto &i : a) {
        int k;
        k = dis(gen) % 5 + 1;
        if(!stress) cin >> k;
        umax(m, k);
        i.resize(k);
        for(auto &j : i) {
            j = dis(gen) % 10 + 1;
            if(!stress) cin >> j;
        }
    }
    if(m <= 2) {
        cout << my(a) << '\n';
        return;
    }
    vector<int> cmp;
    for(auto &x : a) {
        for(auto &i : x) {
            cmp.pb(i);
        }
    }
    cmp.pb(0);
    sort(all(cmp)); cmp.erase(unique(all(cmp)), cmp.end());
    for(auto &x : a) {
        for(auto &i : x) {
            i = lower_bound(all(cmp), i) - cmp.begin();
        }
    }
    auto comp = [&](vector<int> &f, vector<int> &s) {
        int mxf = *max_element(all(f));
        int mxs = *max_element(all(s));
        return mxf < mxs;
    };
    sort(all(a), comp);
    int ans = brute(a);
//    if(ans != exp) {
//        cout << n << '\n';
//        for(auto x : a) {
//            cout << sz(x) << "  ";
//            for(auto i : x) cout << i << " ";
//            cout << '\n';
//        }
//        cout << "Incorrect: " << ans << " " << exp << '\n';
//        cout << endl;
//    }
    if(!stress) cout << ans << '\n';
}

signed main() {
    stress = 0;
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    if(stress) cin >> ttt;
    while(ttt--) solve();
}
