#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

long long smart(vector<vector<ll>> all) {
    sort(all.begin(), all.end(), [&] (vector<ll> &fir, vector<ll> &sec) {
        ll mx1 = *max_element(fir.begin(), fir.end()), mx2 = *max_element(sec.begin(), sec.end());
        if (mx1 != mx2) return mx1 < mx2;
        ll val1 = 0, val2 = 0;
        {
            ll mx = -INF;
            for (ll x : fir) {
                if (x > mx) val1++;
                mx = max(mx, x);
            }
            for (ll x : sec) {
                if (x > mx) val1++;
                mx = max(mx, x);
            }
        }
        {
            ll mx = -INF;
            for (ll x : sec) {
                if (x > mx) val2++;
                mx = max(mx, x);
            }
            for (ll x : fir) {
                if (x > mx) val2++;
                mx = max(mx, x);
            }
        }
        //   cout << "d: " << ind[fir] << " " << ind[sec] << endl;
        //   cout << val1 << " " << val2 << endl;
        if (val1 != val2) return (val1 > val2);
        else return *min_element(fir.begin(), fir.end()) < *min_element(sec.begin(), sec.end());
    });
//    for (vector<ll> &cur : all) {
//        for (ll x : cur) cout << x << " ";
//    }
//    cout << endl;
    ll mx = -INF, ans = 0;
    for (vector<ll> &cur : all) {
        for (ll x : cur) {
            if (x > mx) ans++;
            mx = max(mx, x);
        }
    }
    return ans;
}

vector<vector<ll>> answer;

long long stup(vector<vector<ll>> all) {
    sort(all.begin(), all.end());
    ll gl = 0;
    do {
        ll mx = -INF, ans = 0;
        for (vector<ll> &cur : all) {
            for (ll x : cur) {
                if (x > mx) ans++;
                mx = max(mx, x);
            }
        }
        if (ans > gl) answer = all;
        gl = max(gl, ans);
    } while (next_permutation(all.begin(), all.end()));
    return gl;
}

mt19937 gen(572);

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
    ll n;
    cin >> n;
    vector<vector<ll>> all;
    map<ll, vector<vector<ll>>> to_mx;
    for (ll i = 0; i < n; i++) {
        ll k;
        cin >> k;
        vector<ll> cur;
        ll mx = -INF, val = 0;
        for (ll j = 0; j < k; j++) {
            ll x;
            cin >> x;
            cur.push_back(x);
            if (x > mx) val++;
            mx = max(mx, x);
        }
        all.push_back(cur);
        to_mx[mx].push_back(cur);
    }
    ll last = -1, ans = 0;
    for (auto[x, all_vec] : to_mx) {
        ll gl = 0;
        for (vector<ll> &cur : all_vec) {
            ll mx = last, val = 0;
            for (ll now : cur) {
                if (now > mx) {
                    val++;
                }
                mx = max(mx, now);
            }
            if (val > gl) gl = val;
        }
        ans += gl;
        last = x;
    }
    cout << ans << endl;
    return 0;
}
