#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

void solve()
{
	long long n;
	vector<vector<long long>> v;
	cin >> n;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		long long k;
		cin >> k;
		for (long long j = 0; j < k; j++)
		{
			long long x;
			cin >> x;
			if (!v[i].size() || v[i].back() < x)
			{
				v[i].push_back(x);
			}
		}
	}
	sort(v.begin(), v.end(),
		[](vector<long long>& x, vector<long long>& y)
		{
			return x.back() < y.back();
		}
	);
	
	vector<long long> dp(n + 1);
	for (long long i = 1; i < n + 1; i++)
	{
		dp[i] = v[i - 1].size();
		long long rest = 300;
		for (long long j = i - 1; j > 0 && rest; j--)
		{
			long long pos = upper_bound(v[i - 1].begin(), v[i - 1].end(), v[j - 1].back()) - v[i - 1].begin();
			dp[i] = max(dp[i], dp[j] + ((long long)v[i - 1].size() - pos));
			rest--;
		}
	}
	cout << *max_element(dp.begin(), dp.end()) << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*























*/
