#pragma GCC optimize ("Ofast", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "popcnt")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <queue>
#include <cstdio>
#include <iomanip>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <random>
#include <bitset>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;

bool cmp(vector <int> a, vector <int> b) {
    vector <int> x = a, y = b;
    for (auto& r : b)
        x.push_back(r);
    for (auto& r : a)
        y.push_back(r);
    int cx = 0, cy = 0, px = -1, py = -1;
    for (int i = 0; i < x.size(); i++) {
        if (x[i] > px) {
            px = x[i];
            cx++;
        }
        if (y[i] > py) {
            py = y[i];
            cy++;
        }
    }
    return cx > cy ||
        (cx == cy && *max_element(a.begin(), a.end()) < *max_element(b.begin(), b.end()));
}

bool cmp2(vector <int> a, vector <int> b) {
    if (a.size() != b.size())
        return a.size() < b.size();
    for (int i = 0; i < a.size(); i++)
        if (a[i] != b[i])
            return a[i] < b[i];
    return 0;
}

int get(vector <vector <int>> x) {
    vector <int> q;
    for (int i = 0; i < x.size(); i++)
        for (auto& r : x[i])
            q.push_back(r);
    int p = -1, k = 0;
    for (auto& r : q) {
        //cout << r << ' ';
        if (p < r) {
            p = r;
            k++;
        }
    }
    return k;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int n;
    cin >> n;
    vector <vector <int>> x(n);
    for (int i = 0; i < n; i++) {
        int k, c = -1;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int z;
            cin >> z;
            if (c < z) {
                c = z;
                x[i].push_back(z);
            }
        }
    }
    int ans = 0;
    if (n < 10) {
        for (int i = 0; i < 5040; i++) {
            ans = max(ans, get(x));
            next_permutation(x.begin(), x.end(), cmp2);
        }
    }

    sort(x.begin(), x.end(), cmp);
    
    //cout << endl;
    cout << max(ans, get(x));
}  