#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
const ll INF=1e18+2;
const ll N=1e6+2;

ve<ll> arr[N];
ll dp[N];

void solve()
{
    ll n,m=0;
    cin>>n;

    for(ll i=0;i<n;i++)
    {
        ll k,mx=-INF;
        cin>>k;

        for(ll j=0;j<k;j++)
        {
            ll x;
            cin>>x;
            m=max(m,x);

            if(x>mx)
            {
                arr[i].PB(x);
                mx=x;
            }
        }
    }

    auto cost = [&](ll pos, ll mx)
    {
        if(arr[pos].back()<=mx) return 0ll;
        ll l=0,r=ll(arr[pos].size())-1;

        while(l<r)
        {
            ll mid=(l+r)/2;
            if(arr[pos][mid]>mx) r=mid;
            else l=mid+1;
        }

        return ll(arr[pos].size())-l;
    };

    dp[0]=0;
    ll ans=0;

    for(ll i=0;i<m;i++)
    {
        ans=max(ans,dp[i]);

        for(ll j=0;j<n;j++)
        {
            if(arr[j].back()<=i)
                continue;

            dp[arr[j].back()]=max(dp[arr[j].back()],dp[i]+cost(j,i));
        }
    }

    ans=max(ans,dp[m]);
    cout<<ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
