#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
const ll INF=1e18+2;
const ll N=1e6+2;

struct segtree
{
    ve<ll> tree;
    ll sz;

    void init(ll n)
    {
        sz=1;
        while(sz<n) sz*=2;
        tree.assign(sz*2,0);
    }

    void upd(ll k, ll x, ll v, ll tl, ll tr)
    {
        if(tr-tl==1)
        {
            tree[v]=max(tree[v],x);
            return;
        }

        ll tm=(tl+tr)/2;
        if(k<tm) upd(k,x,v*2+1,tl,tm);
        else upd(k,x,v*2+2,tm,tr);
        tree[v]=max(tree[v*2+1],tree[v*2+2]);
    }

    void upd(ll k, ll x)
    {
        upd(k,x,0,0,sz);
    }

    ll rmq(ll l, ll r, ll v, ll tl, ll tr)
    {
        if(l>=tr||tl>=r) return 0;
        if(l<=tl&&tr<=r) return tree[v];

        ll tm=(tl+tr)/2;
        ll a=rmq(l,r,v*2+1,tl,tm);
        ll b=rmq(l,r,v*2+2,tm,tr);
        return max(a,b);
    }

    ll rmq(ll l, ll r)
    {
        return rmq(l,r+1,0,0,sz);
    }
};

bool cmp(const ve<ll> &a, const ve<ll> &b)
{
    return a.back()<b.back();
}

ve<ll> arr[N];
ll dp[N];

void solve()
{
    ll n,m=0;
    cin>>n;

    for(ll i=0;i<n;i++)
    {
        ll k,mx=-INF;
        cin>>k;

        for(ll j=0;j<k;j++)
        {
            ll x;
            cin>>x;
            m=max(m,x);

            if(x>mx)
            {
                arr[i].PB(x);
                mx=x;
            }
        }
    }

    sort(arr,arr+n,cmp);
    segtree st;
    st.init(m+1);
    ll ans=0;

    for(ll i=0;i<n;i++)
    {
        ll mx=0;

        for(ll j=0;j<arr[i].size();j++)
            mx=max(mx,st.rmq(0,arr[i][j]-1)+ll(arr[i].size())-j);

        st.upd(arr[i].back(),mx);
    }

    cout<<st.rmq(0,m);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
