#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(), v.end()

typedef long long ll;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> mx(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; j++) cin >> a[i][j];
    }

    vector<int> p(n);
    iota(all(p), 0);
    sort(all(p), [&](int x, int y) {
        int i = max_element(all(a[x])) - a[x].begin();
        int j = max_element(all(a[y])) - a[y].begin();
        if (a[x][i] < a[y][j]) {
            return true;
        } else if (a[x][i] > a[y][j]) {
            return false;
        }
        while (i != 0 && j != 0) {
            i = max_element(a[x].begin(), a[x].begin() + i) - a[x].begin();
            j = max_element(a[y].begin(), a[y].begin() + j) - a[y].begin();
            if (a[x][i] < a[y][j]) {
                return true;
            } else if (a[x][i] > a[y][j]) {
                return false;
            }
        }
        if (i == 0) {
            return false;
        } else {
            return true;
        }
    });

    int ans = 0;
    int max_el = 0;
    for (auto ind : p) {
        for (auto el : a[ind]) {
            if (el > max_el) {
                ans++;
                max_el = el;
            }
        }
    }
    cout << ans << '\n';

    return 0;
}