#include <bits/stdc++.h>


using namespace std;


#define ll int
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


mt19937 rnd(24234);
const ll inf = 1e18;


struct SGT{
    int n;
    vector<ll> t;


    void build(const vector<ll> &a){
        n = 1;
        while(n < (int)a.size()){
            n *= 2;
        }
        t.assign(n + n, 0);
        for(int i = 0; i < (int)a.size(); i += 1){
            t[i + n] = a[i];
        }
        for(int i = n - 1; i > 0; i -= 1){
            t[i] = max(t[i + i], t[i + i + 1]);
        }
    }


    void chng(int i, int x){
        int v = i + n;
        t[v] = x;
        for(v /= 2; v > 0; v /= 2){
            t[v] = max(t[v + v], t[v + v + 1]);
        }
    }


    int get_nxt_bgr(int v, int tl, int tr, int l, ll x){
        if(tr < l || t[v] <= x){
            return -1;
        }
        if(tl == tr){
            return tl;
        }
        int tm = (tl + tr) / 2;
        int rs = get_nxt_bgr(v + v, tl, tm, l, x);
        if(rs == -1){
            rs = get_nxt_bgr(v + v + 1, tm + 1, tr, l, x);
        }
        return rs;
    }


    int get_nxt_bgr(int l, ll x){
        return get_nxt_bgr(1, 0, n - 1, l, x);
    }


    ll get(int l, int r){
        l += n;
        r += n;
        ll rs = 0;
        while(l < r){
            if(l & 1){
                rs = max(rs, t[l]);
                l += 1;
            }
            if(r & 1){
                r -= 1;
                rs = max(rs, t[r]);
            }
            l /= 2;
            r /= 2;
        }
        return rs;
    }
};


int n;
vector<vector<int>> a;


int32_t main(){
    if(1){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    cin >> n;
    a.assign(n, vector<int>());
    int mxx = 0;
    for(int i = 0; i < n; i += 1){
        int k;
        cin >> k;
        a[i].reserve(k);
        for(int j = 0; j < k; j += 1){
            int x;
            cin >> x;
            mxx = max(mxx, x);
            if(a[i].empty() || a[i].back() < x){
                a[i].push_back(x);
            }
        }
    }
    sort(all(a), [](const vector<int> &x, const vector<int> &y){return x.back() < y.back();});
    vector<int> dp(mxx + 1);
    SGT sgt;
    sgt.build(dp);
    for(int i = n - 1; i >= 0; i -= 1){
        int t = sgt.get(a[i].back() + 1, mxx + 1);
        for(int j = (int)a[i].size() - 1; j >= 0; j -= 1){
            int f = t + ((int)a[i].size() - j);
            int pos = a[i][j];
            if(dp[pos] < f){
                dp[pos] = f;
                sgt.chng(pos, f);
            }
        }
    }
    cout << sgt.get(0, mxx + 1) << "\n";
    return 0;
}