#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define F first
#define S second
#define endl '\n'
#define pb push_back
#define vi vector <int>
#define pii pair <int, int>
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define RFOR(i, a, b) for (int i = a; i >= b; --i)
#define EACH(e, a) for (auto& e : a)
#define pbds tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>
#pragma GCC optimize("O3")
//mt19937 rng(228);
const int INF = 1e9 + 7, R = 1 << 18, B = 300;

int n;
vi a[200001];

void solve_n2() {
    sort(a, a + n, [&](vi& p, vi& q){ return p.back() < q.back(); });
    vi dp(n), ptr(n);
    FOR(i, 0, n) {
        dp[i] = max(dp[i], sz(a[i]));
        FOR(j, i + 1, n) {
            while (ptr[j] < sz(a[j]) && a[j][ptr[j]] <= a[i].back()) ++ptr[j];
            dp[j] = max(dp[j], dp[i] + sz(a[j]) - ptr[j]);
        }
    }
    int res = 0; FOR(i, 0, n) res = max(res, dp[i]);
    cout << res;
}

void solve_k2() {
    vi mx(n); FOR(i, 0, n) mx[i] = a[i].back();
    vi o(n); FOR(i, 0, n) o[i] = i;
    sort(all(o), [&](int i, int j){ return mx[i] < mx[j]; });
    int pr = 0, ans = 0;
    FOR(i, 0, n) {
        EACH(e, a[o[i]]) {
            if (e > pr) ++ans, pr = e;
        }
    }
    cout << ans;
}

void solve_wtf() {
    deque <int> mx[n];
    FOR(i, 0, n) EACH(e, a[i]) mx[i].pb(e);
    set <int> unused;
    FOR(i, 0, n) unused.insert(i);
    int pr = 0, ans = 0;
    while (true) {
        int best = INF, take = 0, id;
        EACH(p, unused) {
            while (!mx[p].empty() && mx[p][0] <= pr) mx[p].pop_front();
            if (!mx[p].empty()) {
                if (mx[p].back() - sz(mx[p]) < best) best = mx[p].back() - sz(mx[p]), take = sz(mx[p]), id = p;
            }
        }
        if (best == INF) break;
        ans += take, pr = best + take;
        unused.erase(id);
    }
    cout << ans;
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false); cin.tie(0);
    int n, x, flag_k2 = 1; cin >> n;
    FOR(i, 0, n) {
        int k; cin >> k;
        flag_k2 &= (k <= 2);
        while (k--) {
            cin >> x;
            if (a[i].empty() || a[i].back() < x) a[i].pb(x);
        }
    }
    if (n <= 5000) solve_n2();
    else if (flag_k2) solve_k2();
    else solve_wtf();

}

/* NEVER GIVE UP */
