#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long

typedef unsigned long long ull;
typedef long double ld;

#define ff first
#define ss second

void solve() {
    int n;
    cin >> n;
    vector< vector<int> > v(n);
    vector< pair< pair<int, int> , int> > p;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            if (v[i].empty() || v[i].back() < x)
                v[i].push_back(x);
        }
        p.push_back({{v[i].back(), -(int)v[i].size()}, i});
//        for (auto &j : v[i])
//            cout << j << ' ';
//        cout << '\n';
    }
    sort(p.begin(), p.end());
//    for (int i = 0; i < n; i++) {
//        cout << p[i].ss << ' ';
//    }
//    cout << '\n';
    vector<int> dp(n);
    dp[0] = (int)v[p[0].ss].size();
    int ans = dp[0];
    for (int i = 1; i < n; i++) {
        int ind = p[i].ss;
        dp[i] = (int)v[p[i].ss].size();
        for (int j = 0; j < i; j++) {
            int c = dp[j];
            int l = -1, r = (int)v[ind].size();
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (v[p[j].ss].back() < v[ind][m])
                    r = m;
                else
                    l = m;
            }
            c += ((int)v[ind].size() - r);
            dp[i] = max(dp[i], c);
        }
//        cout << dp[i] << '\n';
        ans = max(ans, dp[i]);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    for (; _; --_) {
        solve();
    }
    return 0;
}