#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
using namespace std;

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T x : v) out << x << " ";
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define ll long long
#define ld long double

void solve() {

    int n;
    cin >> n;

    vector<vector<int>> v(n);
    vector<int> ys;
    vector<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        int mx = 0;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            if (x > mx) {
                mx = x;
                v[i].push_back(x);
                ys.push_back(x);
            }
        }
        s.emplace_back(mx, i);
    }

    sort(all(ys));
    ys.resize(unique(all(ys)) - ys.begin());

    sort(all(s));

    vector<int> dp(ys.size());
    int t = 0;
    for (int i = 0; i < ys.size(); i++) {
        if (i > 0) dp[i] = dp[i - 1];
        while (t < n && s[t].first == ys[i]) {
            for (int j = 0; j < v[s[t].second].size(); j++) {
                int x = v[s[t].second][j];
                int p = lower_bound(all(ys), x) - ys.begin();
                dp[i] = max(dp[i], (p > 0 ? dp[p - 1] : 0) + (int)v[s[t].second].size() - j);
            }
            t++;
        }
    }

    cout << dp.back();

}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    solve();

}