#include <vector>
#include <set>
#include <map>
#include <string>
#include <iostream>
#include <deque>
#include <algorithm>

using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	if (n <= 7) {
		vector<vector<int>> v(n);
		vector<int> msk(n);
		for (int i = 0; i < n; ++i) {
			msk[i] = i;
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int c;
				cin >> c;
				v[i].push_back(c);
			}
		}
		bool fl = 1;
		int res = 0;
		while (fl) {
			int cur = 0;
			int mx = 0;
			for (int i = 0; i < n; ++i) {
				for (auto j : v[msk[i]]) {
					if (mx < j) {
						++cur;
						mx = j;
					}
				}
			}
			res = max(res, cur);
			fl = next_permutation(msk.begin(), msk.end());
		}
		cout << res;
	}
	else {
		vector<vector<int>> v(n);
		bool fl = 0;
		for (int i = 0; i < n; ++i) {
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int c;
				cin >> c;
				fl = fl && (c <= 2);
				v[i].push_back(c);
			}
		}
		if (fl) {
			bool fl1 = 0;
			bool fl2 = 0;
			bool fl3 = 0;
			for (int i = 0; i < n; ++i) {
				if (v[i][0] == 1) {
					fl1 = 1;
				}
				for (auto j : v[i]) {
					if (j == 2) {
						fl3 = 1;
					}
					else {
						fl2 = 1;
					}
				}
			}
			if (fl1 && fl2 && fl3) {
				cout << 2;
			}
			else {
				cout << 1;
			}
		}
	}
	return 0;
}