#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> g(n);
    vector<int> ma(n, 0);
    for(int i = 0; i < n; i ++){
        int k;
        cin >> k;
        while(k --){
            int t;
            cin >> t;
            ma[i] = max(ma[i], t);
            g[i].push_back(t);
        }
    }

    vector<pair<int, int>> sr(n);
    for(int i = 0; i < n; i ++){
        sr[i] = {ma[i], i};
    }

    sort(sr.begin(), sr.end());

    int ans = 0, lastm = 0;
    for(int i = 0; i < n; i ++){
        int q = sr[i].second;
        for(int j = 0; j < g[q].size(); j ++){
            if(g[q][j] > lastm){
                lastm = g[q][j];
                ans ++;
            }
        }
    }

    cout<< ans << "\n";

  return 0;
}
