#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;


bool cmp(pair<ll, ll> &a, pair<ll, ll> &b) {
    return make_pair(max(a.first, a.second), int(a.first < a.second)) <
           make_pair(max(b.first, b.second), int(b.first < b.second));
}


void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> tracks(n + 1);
    bool f3 = false;
    for (ll i = 1; i <= n; ++i) {
        ll q;
        cin >> q;
        while (q--) {
            ll x;
            cin >> x;
            tracks[i].push_back(x);
            if (x >= 3) {
                f3 = true;
            }
        }
    }

    if (n <= 7) {
        vector<ll> p;
        ll ans = 0;
        for (ll i = 1; i <= n; ++i) {
            p.push_back(i);
        }

        do {
            ll now = 0;
            ll mx = 0;
            for (auto x: p) {
                for (auto y: tracks[x]) {
                    if (y > mx) {
                        mx = y;
                        ++now;
                    }
                }
            }

            ans = max(ans, now);
        } while (next_permutation(p.begin(), p.end()));

        cout << ans << "\n";
        exit(0);
    }
    if (!f3) {
        set<ll> s1;
        set<ll> s2;

        for (ll i = 1; i <= n; ++i) {
            bool f1 = false;
            for (auto x: tracks[i]) {
                if (x == 1) {
                    f1 = true;
                    s1.insert(i);
                }

                if (x == 2) {
                    if (f1) {
                        cout << 2 << "\n";
                        exit(0);
                    }
                    s2.insert(i);
                }
            }
        }

        for (auto x: s1) {
            for (auto y: s2) {
                if (x != y) {
                    cout << 2 << "\n";
                    exit(0);
                }
            }
        }
        cout << 1 << "\n";
        exit(0);
    }

    vector<pair<ll, ll>> arr;
    for (ll i = 1; i <= n; ++i) {
        if (tracks[i].size() == 1) {
            arr.push_back({tracks[i][0], -1});
        } else {
            arr.push_back({tracks[i][0], tracks[i][1]});
        }
    }

    sort(arr.begin(), arr.end(), cmp);
    ll mx = 0;
    ll now = 0;
    for (auto x: arr) {
        if (x.first > mx) {
            mx = x.first;
            ++now;
        }
        if (x.second > mx) {
            mx = x.second;
            ++now;
        }
    }

    cout << now << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
