#include <iostream>
#include "cstdio"
#include "iomanip"
#include "fstream"
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <set>
#include "map"

using namespace std;
#define ll long long
#define int ll

void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}
const int MOD = 1e9 + 7;

bool comp(vector<int>& a, vector<int>& b){
    return a.back() < b.back();
}

void main0(){
    int n; cin >> n;
    vector<vector<int>> cools(n);
    for (int i = 0; i < n; i++){
        int k; cin >> k;
        while (k--){
            int a; cin >> a;
            if (!cools[i].size() || cools[i].back() < a) { cools[i].push_back(a); }
        }
    }
    sort(cools.begin(), cools.end(), comp);
    //cout << "ok";
    vector<int> dp(n);
    for (int i = 0; i < n; i++){
        dp[i] = cools[i].size();
        if (i < cools[i].size() || n <= 10000){
            for (int j = 0; j < i; j++){
                int l = -1, r = cools[i].size(); // size-r - cnt X in cool[i], that X > j.back(); l - index last X <= j.back()
                while (l + 1 != r){
                    int m = (l + r) / 2;
                    if (cools[j].back() >= cools[i][m]) l = m;
                    else r = m;
                }
                dp[i] = max(dp[i], dp[j] + (int)cools[i].size() - r);
            }
        } else {
            for (int j = 0; j < cools[i].size(); j++){
                int l = -1, r = i; // i-r - cnt X in cool[i], that X > j.back(); l - index last X <= j.back()
                while (l + 1 != r){
                    int m = (l + r) / 2;
                    if (cools[i][j] > cools[m].back()) l = m;
                    else r = m;
                }
                if (l == -1) continue;
                dp[i] = max(dp[i], dp[l] + (int)cools[i].size() - j);
            }
        }
    }
    int out = 0;
    for (int i = 0; i < n; i++){
        //cout << dp[i] << ' ';
        out = max(out, dp[i]);
    } cout << out;
}

signed main() {
    speed();
    cout << fixed << setprecision(10);
    int t = 1;
    while (t--){
        main0();
        cout << '\n';
    }
}
