#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <chrono>
#define int long long
#define all(a) a.begin(), a.end()
using namespace std;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
const int inf = 1e18;
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n; cin >> n;
	vector<int> p(n);
	vector<vector<int>> a(n);
	int N = 0;
	for (int i = 0; i < n; i++) {
		int x; cin >> x;
		N += x;
		a[i].resize(x);
		for (int j = 0; j < x; j++) {
			cin >> a[i][j];
			if (j > 0) {
				a[i][j] = max(a[i][j - 1], a[i][j]);
			}
		}
		sort(all(a[i]));
		a[i].resize(unique(all(a[i])) - a[i].begin());
		p[i] = i;
	}
	auto cmp = [&](const int& lhs, const int& rhs) {
		return a[lhs].back() < a[rhs].back();
	};
	sort(all(p), cmp);
	vector<int> conv;
	for (int i = 0; i < n; i++) {
		pair<int, int> update = { -1, -1 };
		for (int j = 0; j < (int)a[p[i]].size(); j++) {
			int pos = lower_bound(all(conv), a[p[i]][j]) - conv.begin();
			if (update.first < (int)a[p[i]].size() - j + pos) {
				update.first = (int)a[p[i]].size() - j + pos;
				update.second = j;
			}
		}
		int pos = lower_bound(all(conv), a[p[i]][update.second]) - conv.begin();
		while ((int)conv.size() > pos) { conv.pop_back(); }
		for (int j = update.second; j < (int)a[p[i]].size(); j++) {
			conv.push_back(a[p[i]][j]);
		}
	}
	cout << (int)conv.size();
}