#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

bool cmp(vector<int> a, vector<int> b)
{
    if (a.back() != b.back()) return (a.back() < b.back());
    return (a.size() < b.size());
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    vector< vector<int> > albums;
    for (int i = 1; i <= n; ++ i)
    {
        int k;
        cin >> k;

        vector<int> v;
        v.push_back(0);
        for (int j = 1; j <= k; ++ j)
        {
            int num;
            cin >> num;
            if (num > v.back()) v.push_back(num);
        }
        albums.push_back(v);
    }

    sort(albums.begin(), albums.end(), cmp);

    int cnt = 0, prv = 0;
    for (auto v : albums)
    {
        for (auto num : v)
        {
            if (num > prv)
            {
                cnt++;
                prv = num;
            }
        }
    }

    cout << cnt << endl;

    return 0;
}
