#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"

using namespace std;

typedef long long ll;

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

vector<int> mx;

void upd(int x, int val, int l, int r, int ndx) {
    if (x < l || x >= r)
        return;
    if (l + 1 == r && x == l) {
        mx[ndx] = max(mx[ndx], val);
        return;
    }
    upd(x, val, l, (r + l) / 2, ndx * 2 + 1);
    upd(x, val, (r + l) / 2, r, ndx * 2 + 2);
    mx[ndx] = max(mx[ndx * 2 + 1], mx[ndx * 2 + 2]);
}

int get(int l, int r, int L, int R, int ndx) {
    if (l >= R || L >= r)
        return 0;
    if (l <= L && R <= r) {
        return mx[ndx];
    }
    return max(get(l, r, L, (R + L) / 2, ndx * 2 + 1), get(l, r, (R + L) / 2, R, ndx * 2 + 2));
}


vector<vector<int>> p;

bool cmp(int a, int b) {
    return p[a].back() < p[b].back();
    return xa > xb;
}


void solve() {
    int n;
    cin >> n;
    vector<vector<int>> v;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        v.push_back({});
        for (int j = 0; j < k; j++) {
            int a;
            cin >> a;
            v.back().push_back(a);
        }
    }
    vector<pair<int, int>> a(n);
    set<pair<int, int>> s;
    vector<int> ndx(n);
    for (int i = 0; i < n; i++)
        ndx[i] = i;
    p.resize(n);
    for (int i = 0; i < n; i++) {
        int mx = 0;
        for (int j: v[i]) {
            if (j > mx) {
                mx = j;
                p[i].push_back(j);
            }
        }
    }
    std::sort(ndx.begin(), ndx.end(), cmp);
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        for (int j: v[ndx[i]])
            ans.push_back(j);
    }
    int l = 0, mx = 0;
    for (int i: ans) {
        if (mx < i) {
            mx = i;
            l++;
        }
    }
    cout << l;


};