#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<array<int, 2>> a(n);

    for (auto &[x, y] : a) {
        cin >> x >> y;

        if (x > y) {
            swap(x, y);
        }
    }

    vector<int> ord(2 * n);
    iota(ord.begin(), ord.end(), 0);

    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return a[i % n][i / n] < a[j % n][j / n];
    });

    set<pair<int, int>> st, tt[2];

    int ans = 1e9;

    for (int i : ord) {
        int t = i / n;
        i %= n;

        if (t > 0) {
            st.erase({a[i][0], i});
            tt[0].erase({a[i][0], i});
        }

        if (st.size() == n - 1 && !tt[t ^ 1].empty()) {
            ans = min(ans, a[i][t] - tt[t ^ 1].rbegin()->first);
        }

        st.emplace(a[i][t], i);
        tt[t].emplace(a[i][t], i);
    }

    cout << ans << '\n';

    return 0;
}
