#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using pi = pair<int, int>;

const int maxN = 5e5, INF = 1e9;

int test = 1, n, b[maxN], ans;
pi a[maxN];
set<int> s1, s2;

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
    sort(a, a + n);
    b[n - 1] = a[n - 1].second;
    for (int i = n - 2; i >= 0; i--)
        b[i] = max(b[i + 1], a[i].second);
    s1.clear();
    s2.clear();
    ans = INF;
    for (int i = 0; i < n; i++) {
        int m2 = -1;
        if (i != n - 1)
            m2 = b[i + 1];
        if (i != n - 1)
            ans = min(ans, abs(b[i + 1] - a[i].first));
        auto it = s1.lower_bound(-a[i].first);
        if (it != s1.end())
            ans = min(ans, abs(max(m2, -(*it)) - a[i].first));
        s1.insert(-a[i].second);
        it = s2.lower_bound(a[i].first);
        if (it != s2.end())
            ans = min(ans, abs(max(m2, *it) - a[i].first));
        s2.insert(a[i].second);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> test;
#endif
    while (test--)
        solve();
    return 0;
}
