#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

using namespace std;
using ll = long long;

int main() {
    bool flag = true;
    int n;
    cin >> n;
    vector <pair<int, int>> arr, brr;
    set <int> st1, st2;
    map <int, int> mp;
    pair <int, int> maxi{0, 0};
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        if (a != b){
            flag = false;
        }
        arr.push_back({a, i});
        brr.push_back({b, i});
        mp[a] = b;
        if (min(a, b) > min(maxi.first, maxi.second)){
            maxi = {a, b};
        }
    }
    std::sort(arr.begin(), arr.end());
    std::sort(brr.begin(), brr.end());
    std::reverse(arr.begin(), arr.end());
    std::reverse(brr.begin(), brr.end());
    if (flag){
        cout << arr[0].first - arr[1].first;
        return 0;
    }
    int ans = 1e9, i = 0, j = 0;
    while (i < n && j < n){
        if (ans > abs(arr[i].first - brr[j].first)) {
            if (arr[i].second == brr[j].second) {
                if (arr[i].first > brr[j].first) {
                    i++;
                }
                else{
                    j++;
                }
                continue;
            }
            int max1 = arr[i].first, max2 = brr[j].first;
            if (max1 < maxi.first && max2 < maxi.second){
                if (arr[i].first > brr[j].first) {
                    i++;
                }
                else{
                    j++;
                }
                continue;
            }
            if (max2 > brr[j].first){
                if (arr[i].first > brr[j].first) {
                    i++;
                }
                else{
                    j++;
                }
                continue;
            }
            ans = min(ans, abs(arr[i].first - brr[j].first));
        }
        if (arr[i].first > brr[j].first) {
            i++;
        }
        else{
            j++;
        }
    }
    cout << ans;
}
