#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int INF = 1e9;

vector<pair<int, int> > a;

bool check(int mid)
{
    set<int> free;
    for (int i = 0; i < a.size(); i++)
    {
        free.insert({a[i].second, i});
    }
    int mx = -1;
    for (int i = 0; i < a.size(); i++)
    {
        free.erase({a[i].second, i});
        int l = a[i].first - mid;
        int r = a[i].first + mid;
        if (mx > r)
        {
            mx = max(mx, a[i].second);
            continue;
        }
        auto it = free.lower_bound({l, -1});
        if (it != free.end())
        {
            auto [mn, pos] = *it;
            if (mn <= r)
            {
                return true;
            }
        }
        mx = max(mx, a[i].second);
    }
    return false;
}

void solve()
{
    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.rbegin(), a.rend());
    int lt = -1, rt = INF;
    while (rt - lt > 1)
    {
        int mid = (lt + rt) >> 1;
        if (check(mid))
        {
            rt = mid;
        }
        else
        {
            lt = mid;
        }
    }
    cout << rt;
}

signed main()
{
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
