#include <iostream>
#include <vector>
#include <algorithm>

#define sc second
#define fr first
#define ll long long
#define ld long double
#define db if(0)
#define int long long

using namespace std;
const int N = 5050;
pair<int, int>  a[N];
int n;

int count(int id){
    int mx = a[id].fr;
    int delta = 2e9;
    int delta0 = 0;

    for (int i = 0; i < n; ++i){
        if (id == i) continue;
        if (a[i].fr > mx){
            delta0 = max(delta0, a[i].sc);
            continue;
        }
        if (abs(a[i].sc - mx) <= delta){
            delta = min(abs(a[i].sc - mx), delta);
        }
    }
    return max(delta, delta0);
}
void input(){
    cin >> n;
    for (int i = 0; i < n; ++i){
        cin >> a[i].fr >> a[i].sc;
    }
}


void solve_1(){
    int mn = 2e9;
    for (int mask = 0; mask < (1 << n); ++mask){
        int m1 = 0;
        int m2 = 0;
        for (int i = 0; i < n; ++i){
            if (mask & (1 << i)){
                m1 = max(m1, a[i].fr);
            }
            else{
                m2 = max(m2, a[i].sc);
            }
        }
        mn = min(mn, abs(m1 - m2));
    }
    cout << mn << '\n';

}

void solve0(){
    int mn = 2e9;
    for (int i = 0; i < n; ++i){
        mn = min(mn, count(i));
    }
    cout << mn << '\n';

}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    input();
    solve_1();
}
