#include <bits/stdc++.h>

using namespace std;

#define pii pair<int,int>
#define F first
#define S second
typedef long double ld;
//#define int int64_t

mt19937 gen(chrono::system_clock().now().time_since_epoch().count());

const int N = 5e5+10, K = 30;

int a[N], b[N];
int n;

int solve () {
    vector <pii> all(n);
    priority_queue <pii> need;
    priority_queue <pii> can;
    bool u[n] = {0};
    for (int i=0;i<n;++i) {
        all[i] = {a[i], i};
        need.push({b[i], i});
    }
    sort(all.begin(), all.end());
    int ans = 1e9+100;
    for (int i=0;i<all.size();++i) {
        int x = all[i].F;
        int p = all[i].S;
        u[p] = 1;
        while (need.size() > 0 && u[need.top().S]) {
            need.pop();
        }
        can.push({-b[p], p});
        while (can.size() > 0 && (u[can.top().S] || -can.top().F < x)) {
            can.pop();
        }

        if (need.size() > 0){
            if (need.top().F >= x) {
                ans = min(ans, need.top().F - x);
            }
            else {
                need = {};
            }
        }
        if (need.size() == 0) {
            if (can.size() > 0) {
                auto it = can.top();
                bool f = 0;
                if (it.S == p) {
                    can.pop();
                    f = 1;
                }
                if (can.size() > 0) {
                    ans = min(ans, can.top().F-x);
                }
                if (f) {
                    can.push(it);
                }
            }
        }
    }
    return ans;
}

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n;
    for (int i=0;i<n;++i) {
        cin >> a[i] >> b[i];
    }
    int ans = solve();
    for (int i=0;i<n;++i) {
        swap(a[i], b[i]);
    }
    ans = min(solve(), ans);
    cout << ans;
    return 0;
}
