#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <random>

using namespace std;

#define int long long

int n;

void solve() {
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    sort(v.begin(), v.end());
    vector<int> suf_mx(n);
    for (int i = n - 1; i >= 0; --i) {
        suf_mx[i] = v[i].second;
        if (i + 1 < n) {
            suf_mx[i] = max(suf_mx[i], suf_mx[i + 1]);
        }
    }
    int ans = 1e18;
    for (int i = 0; i < n - 1; ++i) {
        ans = min(ans, abs(v[i].first - suf_mx[i + 1]));
    }
    for (int i = 0; i < n - 1; ++i) {
        ans = min(ans, abs(v.back().first - v[i].second));
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    while (cin >> n) {
        solve();
        cout << "\n";
    }
}