#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define watch(x) cout << #x << " : " << x << '\n';
#define watch_arr(arr) \
cout << #arr << " : "; \
forn(i, arr.size()) \
    cout << arr[i] << ' '; \
cout << '\n';

const int INF = 2e9;
vector<pair<int, int>> pair_cost;
multiset<int> not_del_b;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    forn (i, n) {
        int a, b;
        cin >> a >> b;
        pair_cost.push_back({a, b});
        not_del_b.insert(b);
    }

    sort(pair_cost.begin(), pair_cost.end());

    int best = INF, max_b = -INF;
    auto it = lower_bound(not_del_b.begin(), not_del_b.end(), pair_cost[n - 1].first);
    for (int i = n - 1; i >= 0; --i) {
        int a = pair_cost[i].first, b = pair_cost[i].second;

        best = min(best, abs(a - max_b));
        if(max_b >= a)
            break;
        max_b = max(max_b, b);

        while(it != not_del_b.begin() && *it >= a)
            --it;
        ++it;

        best = min(best, *it - a);
        --it;
        if(it != not_del_b.begin() && *it >= max_b)
            best = min(best, a - *it);
    }

    cout << best;
}
