#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<stack>
#include<queue>
#include<deque>
#include<cmath>
#include<iomanip>
#include<algorithm>
#include<unordered_map>
#include<unordered_set>
using namespace std;

struct edge {
    int a, b;
};

bool operator<(const edge& first, const edge& second) {
    return first.a < second.a;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    bool ok1 = 1;
    vector<edge> cost(n);
    for (int i = 0; i < n; i++) {
        cin >> cost[i].a >> cost[i].b;
        if (cost[i].a != cost[i].b)
            ok1 = 0;
    }

    if (ok1) {
        sort(cost.begin(), cost.end());
        cout << cost[n - 1].a - cost[n - 2].a << '\n';
        return 0;
    }

    int ans = 2000000000;
    for (int i = 0; i < n; i++) {
        int first = cost[i].a;
        int second = -1000000000;

        int res = 2000000000;
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (cost[j].a <= first)
                second = cost[j].b;
            res = min(res, abs(first - second));
        }

        ans = min(ans, res);
    }
    for (int i = 0; i < n; i++) {
        int first = cost[i].b;
        int second = -1000000000;

        int res = 2000000000;
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (cost[j].b <= first)
                second = cost[j].a;
            res = min(res, abs(first - second));
        }

        ans = min(ans, res);
    }

    cout << ans << '\n';

    return 0;
}
