#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<stack>
#include<queue>
#include<deque>
#include<cmath>
#include<iomanip>
#include<algorithm>
#include<unordered_map>
#include<unordered_set>
using namespace std;

struct edge {
    int a, b;
};

bool operator<(const edge& first, const edge& second) {
    return first.a < second.a;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    bool ok1 = 1;
    vector<edge> cost(n);
    for (int i = 0; i < n; i++) {
        cin >> cost[i].a >> cost[i].b;
        if (cost[i].a != cost[i].b)
            ok1 = 0;
    }

    if (ok1) {
        sort(cost.begin(), cost.end());
        cout << cost[n - 1].a - cost[n - 2].a << '\n';
        return 0;
    }

    int ans = 2000000000;
    for (int i = 0; i < n; i++) {
        int first = cost[i].a;
        int second = -1000000000;

        int res = 2000000000, les = 0;
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (cost[j].a > first) {
                second = max(second, cost[j].b);
            } else {
                les++;
            }
        }

        ans = min(ans, abs(first - second));

        if (les > 1) {
                for (int j = 0; j < n; j++) {
                if (i == j) continue;
                if (cost[j].a <= first && cost[j].b > second) {
                    ans = min(ans, abs(first - cost[j].b));
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        int first = cost[i].b;
        int second = -1000000000;

        int res = 2000000000, les = 0;
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (cost[j].b > first) {
                second = max(second, cost[j].a);
            } else {
                les++;
            }
        }

        ans = min(ans, abs(first - second));

        if (les > 1) {
                for (int j = 0; j < n; j++) {
                if (i == j) continue;
                if (cost[j].b <= first && cost[j].a > second) {
                    ans = min(ans, abs(first - cost[j].a));
                }
            }
        }
    }

    cout << ans << '\n';

    return 0;
}
