#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int, int>> arr(n, pair<int, int> {});
    for (int i = 0; i < n; i++) cin >> arr[i].first >> arr[i].second;
    multimap<int, pair<int, int>> mp;
    for (auto p : arr) mp.insert({p.first, {p.second, 0}});
    auto it = mp.rbegin();
    int prev_mx = 0;
    while (it != mp.rend()) {
        it->second.second = max(it->second.first, prev_mx);
        prev_mx = max(it->second.first, prev_mx);
        it++;
    }
    multiset<int> s;
    for (auto p : arr) s.insert(p.second);
    int ans = INT_MAX;
    for (int i = 0; i < n; i++) {
        int e = arr[i].first;
        auto u = mp.upper_bound(e);
        int mx;
        if (u == mp.end()) {
            int best_opt = 0, diff = INT_MAX;
            auto u = s.lower_bound(e);
            u--;
            if (u != s.end()) {
                best_opt = *u;
                diff = abs(*u - e);
            }
            u = s.upper_bound(e);
            if (u != s.end() && abs(*u - e) < diff) {
                best_opt = *u;
            }
            ans = min(ans, abs(best_opt - e));
        }
        else {
            mx = u->second.second;
            auto u = s.upper_bound(mx);
            if (u == s.end()) ans = min(ans, abs(mx - e));
            else ans = min(ans, min(abs(mx - e), abs(*u - e)));
        }
    }
    cout << ans;
    return 0;
}