#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <iomanip>
#include <queue>
#include <deque>
#include <stack>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 500007;
ll n, m, k;
pair<ll, ll>a[N];
multiset<ll>s;

ll find_closest(ll x) {
	auto it = s.lower_bound(x);
	ll res = INF;
	if (it != s.end()) {
		if (res > abs(x - *it)) {
			res = abs(x - *it);
		}
	}
	if (it != s.begin()) {
		it--;
		if (res > abs(x - *it)) {
			res = abs(x - *it);
		}
	}
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i].ff >> a[i].ss;
		s.insert(a[i].ss);
	}
	sort(a, a + n);
	reverse(a, a + n);
	ll cur = -1;
	ll ans = INF;
	for (int i = 0; i < n; i++) {
		s.erase(s.find(a[i].ss));
		ll vl = find_closest(a[i].ff);
		if (cur == -1) {
			ans = min(ans, vl);
		}
		else {
			if (cur < a[i].ff) {
				ans = min(ans, min(abs(cur - a[i].ff), vl));
			}
			else {
				ans = min(ans, abs(cur - a[i].ff));
			}
		}
		cur = max(cur, a[i].ss);
	}
	cout << ans << endl;
}