#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define inf (int)1e9
#define db double

void solve() {
    int n; cin >> n;
    int ans = inf;
    set<int> st;
    bool good = true;
    vector<pair<int, int>> v(n);
    for (auto& [x, y] : v) cin >> x >> y, st.insert(x), good &= (x == y);
    if (good) {
        int mx = *st.rbegin();
        st.erase(--st.end());
        int mx2 = *st.rbegin();
        cout << abs(mx - mx2) << "\n";
        return;
    }
    if (n <= 20) {
        for (int msk = 0; msk < (1 << n); msk++) {
            int ans1 = 0, ans2 = 0;
            for (int j = 0; j < n; j++) {
                if ((msk & (1 << j)) != 0) {
                    ans1 = max(v[j].first, ans1);
                } else {
                    ans2 = max(v[j].second, ans2);
                }
            }
            if (ans1 == 0 || ans2 == 0) continue;
            ans = min(abs(ans1 - ans2), ans);
        }
        cout << ans << "\n";
        return;
    }
    for (auto& x : st) {
        int mx = 0;
        vector<int> bad;
        vector<int> otd;
        for (int i = 0; i < n; i++) {
            if (v[i].first == x) {
                otd.push_back(v[i].second);
            } else if (v[i].first > x) {
                mx = max(v[i].second, mx);
            } else {
                bad.push_back(v[i].second);
            }
        }
        if (mx != 0) {
            ans = min(ans, abs(x - mx));
        }
        if (otd.size() != 1) {
            bad.insert(bad.end(), otd.begin(), otd.end());
        }
        if (bad.empty()) continue;
        sort(bad.begin(), bad.end());
        int lb = lower_bound(bad.begin(), bad.end(), x) - bad.begin();
        for (int i = lb; i >= lb - 2 && i >= 0; i--) {
            if (bad[i] < mx) continue;
            ans = min(ans, abs(x - bad[i]));
        }
        for (int i = lb; i <= lb + 2 && i < (int)bad.size(); i++) {
            if (bad[i] < mx) continue;
            ans = min(ans, abs(x - bad[i]));
        }
    }
    cout << ans << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}