#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

#ifdef CLOWN

void dbg(ll a) { cout << a << "\n"; }

void dbg(int a) { cout << a << "\n"; }

void dbg(string a) { cout << a << "\n"; }

void dbg(ll a, ll b) { cout << a << " " << b << "\n"; }

void dbg(int a, int b) { cout << a << " " << b << "\n"; }

void dbg(ll a, ll b, ll c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(int a, int b, int c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(vector<ll> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

void dbg(vector<int> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

#else
#define dbg(...)
#endif

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        a[i].first = rnd() % 10;
        a[i].second = rnd() % 10;
        cin >> a[i].first >> a[i].second;
    }
    sort(all(a));
    int delta = 1e9;
    for (auto i: a) {
        dbg(i.first, i.second);
    }
    vector<int> suff(n);
    suff[n - 1] = a[n - 1].second;
    for (int i = n - 2; i >= 0; i--) {
        suff[i] = max(suff[i + 1], a[i].second);
    }
    set<int> s;
    s.insert(1e9 + 1);
    for (int i = 0; i < n; i++) {
        int f = a[i].first;
        int l = (i == n - 1 ? -1 : suff[i + 1]);
        int cur = 1e9;
        if (l != -1) {
            cur = abs(l - f);
            auto it = *s.upper_bound(l);
            if (it != 1e9 + 1) {
                cur = min(cur, abs(it - f));
            }
//            for (int j = i - 1; j >= 0; j--) {
//                if (a[j].second >= l) {
//                    cur = min(cur, abs(f - a[j].second));
//                }
//            }
        } else {
            auto it = s.upper_bound(f);
            if (*it != 1e9) cur  = min(cur, abs(*it - f));
            if (it != s.begin()) {
                it--;
                cur = min(cur, abs(*it - f));
            }
//            for (int j = i - 1; j >= 0; j--) {
//                cur = min(cur, abs(f - a[j].second));
//            }
        }
        dbg(i, cur);
        delta = min(delta, cur);
        s.insert(a[i].second);
    }
    cout << delta << "\n";
}

int32_t main() {
#ifdef CLOWN
    freopen("C://Users//olymp//CLionProjects//untitled//input.txt", "r", stdin);
    freopen("C://Users//olymp//CLionProjects//untitled//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
