#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <unordered_map>
#include <set>

using namespace std;


int INF = 2e9;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int, int>> c(n);
    int minc = INF;
    int maxc = -INF;
    for (int i = 0; i < n; i++) {
        cin >> c[i].first >> c[i].second;
        minc = min(minc, c[i].first);
    }
    c.push_back({minc, -INF});
    n++;
    sort(c.begin(), c.end());
    vector<int> maxsuf(n);
    unordered_map<int, int> lastelem;
    for (int i = n - 2; i >= 0; i--) {
        maxsuf[i] = max(maxsuf[i + 1], c[i + 1].second);
    }
    for (int i = 0; i < n; i++) {
        lastelem[c[i].first] = i;
    }
    set<int> elem;
    unordered_map<int, int> ql, qr, cnt;
    elem.insert(c[0].second);
    cnt[c[0].first] = 1;
    for (int i = 1; i < n; i++) {
        cnt[c[i].first]++;
        while(i < n - 1 && c[i].first == c[i + 1].first) {
            elem.insert(c[i].second);
            i++;
            cnt[c[i].first]++;
        }
        if (cnt[c[i].first] >= 2) {
            elem.insert(c[i].second);
        }
        auto m = elem.lower_bound(c[i].first);
        int x = qr[c[i].first];
        if (x == 0) {
            x = INF;
        }
        int y = *m;
        if (abs(c[i].first - x) > abs(c[i].first - y) && y >= c[i].first) {
            qr[c[i].first] = y;
        }
        if (y == c[i].first) {
            qr[c[i].first] = y;
            ql[c[i].first] = y;
        } else if (m != elem.begin()) {
            x = ql[c[i].first];
            if (x == 0) {
                x = INF;
            }
            m--;
            y = *m;
            if (abs(c[i].first - x) > abs(c[i].first - y) && y <= c[i].first) {
                ql[c[i].first] = y;
            }
        }
        elem.insert(c[i].second);
    }
    int ans = INF;
    for (int i = 0; i < n; i++) {
        int ma = c[i].first;
        int mb = maxsuf[lastelem[c[i].first]];
        ans = min(ans, abs(ma - mb));
        int l = ql[c[i].first];
        int r = qr[c[i].first];
        if (ma > mb) {
            if (l > mb) {
                ans = min(ans, abs(ma - l));
            }
            if (r > mb) {
                ans = min(ans, abs(ma - r));
            }
        }
    }
    cout << ans;
    return 0;
}

