#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define mp make_pair
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
typedef long long ll;

const ll INF = 2e9;

void solve4(vector<pair<ll, ll> > v) {
    ll n = v.size();
    sort(v.rbegin(), v.rend());
    cout << v[0].F - v[1].F;
}

bool comp(pair<ll, ll> a, pair<ll, ll> b) {
    return a.F > b.F || (a.F == b.F && a.S < b.S);
}

signed main() {
    ll n; cin >> n;
    vector<pair<ll, ll> > v(n);
    ll t4 = 1;
    for (ll i = 0; i < n; i++) {
        cin >> v[i].F >> v[i].S;
        if (v[i].F != v[i].S) t4 = 0;
    }
    if (t4) {
        solve4(v);
        return 0;
    }
    sort(v.begin(), v.end(), comp);
    vector<ll> suf(n, -1);
    set<ll> b;
    for (ll i = n - 1; i > 0; i--) {
        b.insert(v[i].S);
        ll a = v[i - 1].F;
        auto it = upper_bound(all(b), a);
        if (it != b.begin()) {
            it--;
            suf[i] = (*it);
        } 
    }
    ll ans = INF, mxb = 0, lastb = v[0].S;
    for (ll i = 1; i < n; i++) {
        ll a = v[i].F;
        if (a != v[i - 1].F) {
            mxb = max(mxb, lastb);
            lastb = 0;
        }
        if (a <= mxb) {
            ans = min(ans, mxb - a);
            continue;
        }
        if (i < n - 1) {
            if (suf[i + 1] != -1) {
                ans = min(ans, a - suf[i + 1]);
            }
        }
        lastb = max(lastb, v[i].S);
    } 
    for (ll i = 1; i < n; i++) {
        ans = min(ans, abs(v[0].F - v[i].S));
    }
    cout << ans;
    return 0;
}