#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define mp make_pair
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
typedef long long ll;

const ll INF = 2e9;

void solve4(vector<pair<ll, ll> > v) {
    ll n = v.size();
    sort(v.rbegin(), v.rend());
    cout << v[0].F - v[1].F;
}

bool comp(pair<ll, ll> a, pair<ll, ll> b) {
    return a.F > b.F || (a.F == b.F && a.S < b.S);
}

signed main() {
    ll n; cin >> n;
    vector<pair<ll, ll> > v(n);
    ll t4 = 1;
    for (ll i = 0; i < n; i++) {
        cin >> v[i].F >> v[i].S;
        if (v[i].F != v[i].S) t4 = 0;
    }
    if (t4) {
        solve4(v);
        return 0;
    }
    sort(v.begin(), v.end(), comp);
    ll ans = INF, mxb = 0, first = 0, lastb = v[0].S;
    for (ll i = 1; i < n; i++) {
        int a = v[i].F;
        if (a == v[i - 1].F) {
            lastb = v[i].S;
        } else {
            mxb = max(mxb, lastb);
            first = i;
        }
        ans = min(ans, abs(a - mxb));
        for (int j = first; j < n; j++) {
            if (j == i) continue;
            if (v[i].S >= mxb) ans = min(ans, abs(a - v[i].S)); 
        }
    } 
    for (ll i = 1; i < n; i++) {
        ans = min(ans, abs(v[0].F - v[i].S));
    }
    cout << ans;
    return 0;
}