#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int inf = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 5e5 + 5;

pll a[MAXN];
int n;
ll t[MAXN * 4];

ll calc() {
    ll ans = LLONG_MAX;
    for (int i = 0; i < n - 1; i++) {
        ll mx = -1;
        for (int j = i + 1; j < n; j++) {
            mx = max(mx, a[j].Y);
        }
        for (int j = 0; j < i; j++) {
            if (abs(a[j].X - a[i].Y) < abs(mx - a[i].Y))mx = max(a[j].X, mx);
        }
        ans = min(ans, abs(mx - a[i].X));
    }
    return ans;
}

void solve() {
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    sort(a, a + n);

    ll ans = calc();

    for (int i = 0; i < n; i++) {
        swap(a[i].X, a[i].Y);
    }
    sort(a, a + n);

    cout << min(calc(), ans) << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}
