#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define ld long double
#define ull unsigned long long
#define x first
#define y second

const ll INF = 1e17 + 10, MOD1 = 1e9 + 7, MOD = 228228227, N = 2e5 + 2, MAXN = 1e5 + 2;
const ld EPS = 0.00000001;

random_device rd;
mt19937 rnd(rd());

struct HASH{
    int m, n, b;
    string s;
    vector<int> p, h;
    HASH(string s1, int B, int M) {
        b = B;
        m = M;
        s = s1;
        n = s.size();
        h.resize(n + 1);
        p.resize(n + 1);
        p[0] = 1;
        for (int i = 1; i <= n; i++) {
            p[i] = (p[i - 1] * b) % m;
        }
        for (int i = 1; i <= n; i++) {
            h[i] = ((h[i - 1] * b) % m + s[i - 1] - 'a' + m) % m;
        }
    }
    int get(int l, int r) {
        return (h[r] - (h[l - 1] * p[r - l + 1]) % m + m) % m;
    }
};

/*
vector<int> a, b;
vector<vector<int>> dp(2, vector<int>(1LL << 22));

void rek(int n, int mask = 0, int sum = 0, int sum1 = 0) {
    dp[0][mask] = sum;
    dp[1][mask] = sum1;
    for (int i = 0; i < n; i++) {
        if ((mask | (1LL << i)) == mask) {
            continue;
        }
        rek(n, (mask | (1LL << i)), sum + a[i], sum1 + b[i]);
    }
}
*/

int ask(int p) {
    cout << "? " << p << endl;
    int x;
    cin >> x;
    return x;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    bool fl = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        if (a[i] != b[i]) {
            fl = false;
        }
    }
    int ans = abs(a[0] - b[1]);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) {
                continue;
            }
            ans = min(ans, abs(a[i] - b[j]));
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}