#include <bits/stdc++.h>

#include <list>
#include <numeric>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
#define pb push_back
//typedef ordered_set<int> = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>


vector<pair<int, int>> p(500000);
vector<vector<int>> tr(2000000);

void build(int v, int l, int r) {
    if (l == r-1) {
        tr[v] = {p[l].second};
        return;
    }
    int m = (l+r)/2;
    build (v*2+1, l,m);
    build(v*2+2 , m, r);
    tr[v].resize(tr[v*2+1].size() + tr[v*2+2].size());
    merge(tr[v*2+1].begin(),tr[v*2+1].end(), tr[v*2+2].begin(), tr[v*2+2].end(), tr[v].begin());
}
int last_meb(int v, int l, int r, int lq, int rq, int val){
    if (lq <= l && r <= rq) {
        int pos = upper_bound(tr[v].begin(), tr[v].end(), val) - tr[v].begin();
        if(pos == 0) {
            return -1e9;
        }
        return tr[v][pos - 1];
    }
    if (lq >= r || rq <= l) {
         return -1e9;
   }
    int m = (l+r)/2;
    return max(last_meb(v*2+1, l ,m, lq, rq, val), last_meb(v*2+2, m, r, lq, rq, val));
}

int maxb(int v, int l, int r, int lq, int rq){
    if (lq <= l && r <= rq) {
        return tr[v].back();
    }
    if (lq >= r || rq <= l) {
        return -1e9;
    }
    int m = (l+r)/2;
    return max(maxb(v*2+1, l ,m, lq, rq), maxb(v*2+2, m, r, lq, rq));
}


void solve() {
    int n;
    cin >> n;
    p.resize(n);
    for (int i = 0; i < n;i++) {
        cin >> p[i].first >> p[i].second;
    }
    sort(p.begin(), p.end());
    build(0, 0,n);
    int ans = 1e9;
    for (int i = 0; i < n; i++) {
        if (maxb(0, 0, n, i+1, n) <= p[i].first) {
            ans = min(ans, p[i].first - max(last_meb(0, 0, n, 0, i, p[i].first), maxb(0, 0, n, i+1, n)));
        }
    }
    for (int i = 0; i < n;i++) {
        swap(p[i].first, p[i].second);
    }
    sort(p.begin(), p.end());
    build(0, 0,n);
    for (int i = 0; i < n; i++) {
        if (maxb(0, 0, n, i+1, n) <= p[i].first) {
            ans = min(ans, p[i].first - max(last_meb(0, 0, n, 0, i, p[i].first), maxb(0, 0, n, i+1, n)));
        }
    }
    cout << ans;
}


signed main() {
#ifdef LOCAL
    auto f = freopen("C:\\clion\\input.txt", "r", stdin);
    auto f1 = freopen("C:\\clion\\output.txt", "w", stdout);
#endif
    int t;
    t=1;//cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}