#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 5e5 + 10;
int n, a[maxn], b[maxn], maxx[maxn], pos[maxn];

struct fff{
    int a, b, idx;
}c[maxn], d[maxn];

bool cmp(fff f1, fff f2){
    if(f1.a != f2.a)
        return f1.a < f2.a;
    return f1.b < f2.b;
}

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> a[i] >> b[i];
        c[i] = {a[i], b[i], i};
        d[i] = {b[i], b[i], i};
    }
    sort(c + 1, c + n + 1, cmp);
    sort(d + 1, d + n + 1, cmp);
    for(int i = 1;i <= n;i++)
        pos[c[i].idx] = i;
    for(int i = n;i >= 1;i--)
        maxx[i] = max(maxx[i + 1], c[i].b);
}

void solve(){
    int ans = 1e9, k = 1;
    for(int i = 1;i <= n;i++){
        while(k <= n && c[k].a <= c[i].a)
            k++;
        int l = 1, r = n;
        while(l <= r){
            int mid = (l + r) / 2;
            if(d[mid].a >= maxx[k])
                r = mid - 1;
            else
                l = mid + 1;
        }
        int p1 = l, p2 = n;
        while(p1 <= p2){
            int mid = (p1 + p2) / 2;
            if(c[i].a > d[mid].a)
                p1 = mid + 1;
            else
                p2 = mid - 1;
        }
        if(pos[i] != p2){
            ans = min(ans, abs(c[i].a - d[p2].a));
        }
        p2--;
        if(pos[i] != p2 && p2 >= l){
            ans = min(ans, abs(c[i].a - d[p2].a));
        }
        p2 += 2;
        if(pos[i] != p2 && p2 <= n){
            ans = min(ans, abs(c[i].a - d[p2].a));
        }
        /**
        for(int j = 1;j <= n;j++){
            if(i == j)
                continue;
            if(maxx[k] <= c[j].b)
                ans = min(ans, abs(c[i].a - c[j].b));
        }
        */
    }
    cout << ans << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
