#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> a);
template<typename T>
ostream& operator << (ostream &out, set<T> a);
template<typename T>
ostream& operator << (ostream &out, vector<T> a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#ifdef LOCAL
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
#else
#define debug(x...) 7
#endif
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(21281337711);
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}
int divide(int a, int b) {
    return mul(a, binpow(b, mod - 2));
}


void solve_case() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) cin >> a[i] >> b[i];
    map<int, vector<int>> layer;
    int ans = inf;
    for (int i = 0; i < n; i++) {
        layer[a[i]].push_back(i);
    }
    multiset<int> in, out;
    for (int i = 0; i < n; i++) out.insert(b[i]);
    for (auto v : layer) {
        for (int i : v.se) {
            in.insert(b[i]);
            out.erase(out.find(b[i]));
        }
        int rt = 0;
        if (!out.empty()) rt = *out.rbegin();
        for (int i : v.se) {
            in.erase(in.find(b[i]));
            if (!in.empty() && in.upper_bound(a[i]) != in.begin()) {
                chmin(ans, abs(v.fi - max(rt, *prev(in.upper_bound(a[i])))));
            }
            if (!in.empty() && in.lower_bound(a[i]) != in.end()) {
                chmin(ans, abs(v.fi - max(rt, *in.lower_bound(a[i]))));
            }
            in.insert(b[i]);
        }
    }
    cout << ans << "\n";
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
    return 0;
}