#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <string.h>
#include <queue>
#include <stdio.h>
#include <algorithm>
#include <math.h>
#include <deque>
#include <random>
#define int ll
using ll = long long;
#define all(x) x.begin(), x.end()
using namespace std;
mt19937 rnd(time(0));

int solve(int n, vector<int>& a, vector<int>& b, vector<pair<int, int>>& v) {
	int ans = 1e18;
	for (int mask = 0; mask < (1 << n); ++mask) {
		int mx1 = -1;
		int mx2 = -1;
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				mx2 = max(mx2, v[i].second);
			}
			else {
				mx1 = max(mx1, v[i].first);
			}
		}
		if (mx1 != -1 && mx2 != -1) {
			ans = min(ans, abs(mx1 - mx2));
		}
	}
	return ans;
	//cout << ans;
}



int my(int n, vector<int>& a, vector<int>& b, vector<pair<int, int>>& v) {
	int l = -1;
	int r = 1e9 + 10;
	sort(all(v));
	while (l + 1 != r) {
		int m = (l + r) / 2;
		int ok1 = 0;
		multiset<int> st;
		for (int i = 0; i < n; ++i) {
			st.insert(v[i].second);
		}
		multiset<int> er;
		int ok = 0;
		for (int i = 0; i < n - 1; ++i) {
			ok = 0;

			if (st.size() != 0)
				st.erase(st.find(v[i].second));
			while (!er.empty()) {
				if (v[i].first - *er.begin() > m) {
					er.erase(er.begin());
				}
				else {
					break;
				}
			}
			if (!er.empty() && abs(*er.begin() - v[i].first) <= m) {
				ok = 1;
			}
			int val = *(--st.end());
			//pair<int, int> val1 = *(st.begin());
			if (val - v[i].first <= m && (ok ||
				abs(val - v[i].first) <= m)) {
				ok1 = 1;
				break;
			}
			er.insert(v[i].second);
		}
		//er.insert(*st.begin());
		for (auto i : er) {
			if (abs(i - v.back().first) <= m) {

				ok1 = 1;
				break;
			}
		}
		if (ok1) {
			r = m;
		}
		else {
			l = m;
		}
	}
	return r;
	//cout << r << endl;
}
signed main() {
#ifdef LOCAL
	freopen("C:\\Users\\olymp\\source\\repos\\Project1\\input.txt", "r", stdin);
#endif
	int t = 10000;
	while (t--) {
		int n = rnd() % 10 + 2;
		//cout << n << endl;
		vector<int> a(n);
		vector<int> b(n);
		vector<pair<int, int>> v(n, { 0, 0 });
		for (int i = 0; i < n; ++i) {
			int ai = rnd() % 10 + 1;
			int bi = rnd() % 10 + 1;
			a[i] = ai;
			b[i] = bi;
			v[i] = { ai, bi };
			//cout << a << ' ' << b << endl;
		}
		
		int v1 = solve(n, a, b, v);
		int v2 = my(n, a, b, v);
		
		if (v1 != v2) {
			cout << n << endl;
			for (int i = 0; i < n; ++i) {
				cout << a[i] << ' ' << b[i] << endl;
			}
			cout << v1 << endl;
			cout << v2 << endl;
			break;
		}
		cout << "OK" << endl;
	}
	/*int n;
	cin >> n;

	vector<int> a(n);
	vector<int> b(n);
	vector<pair<int, int>> v(n, { 0, 0 });
	for (int i = 0; i < n; ++i) {
		int ai, bi;
		cin >> ai >> bi;
		a[i] = ai;
		b[i] = bi;
		v[i].first = a[i];
		v[i].second = b[i];
	}*/
	
	return 0;
}