#include <iostream>
#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<signed, signed>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;
using vvi = vector<vi>;
using vvll = vector<vll>;
template<typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;


const ll MAX_MEMORY = 50 * 1024 * 1024;
char MEMORY[MAX_MEMORY];
int mem_pos = 0;
void* operator new(size_t n) {
    assert((mem_pos += n) <= MAX_MEMORY);
    return (void*)(MEMORY + mem_pos - n);
}
void* operator new[](size_t n) {
    assert((mem_pos += n) <= MAX_MEMORY);
    return (void*)(MEMORY + mem_pos - n);
}
void operator delete(void*) noexcept {}
void operator delete(void*, size_t) noexcept {}
void operator delete[](void*) noexcept {}
void operator delete[](void*, size_t) noexcept {}

const int MAXN = 500010;
/*
struct Mst {
    vector<int> t[4 * MAXN];
    void build(int tv, int tl, int tr) {
        if (tl + 1 == tr) {
            t[tv] = {b[tl]};
            return;
        }
        int tm = (tl + tr) / 2;
        build(tv * 2 + 1, tl, tm);
        build(tv * 2 + 2, tm, tr);
        merge(t[tv * 2 + 1].begin(), t[tv * 2 + 1].end(), t[tv * 2 + 2].begin(), t[tv * 2 + 2].end(), back_inserter(t[tv]));
    }
    void get_lowerbound(int tv, int tl, int tr, int ql, int qr, int qx) {
    }
};
 */

pair<int, int> arr[MAXN];
vi a;
vi b[MAXN];
const int INF = 1e9 + 57;
inline signed one() {
    multiset<int> cur_b_mandatory;
    multiset<int> cur_b_optional;
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].first >> arr[i].second;
    }
    sort(arr, arr + n);
    for (int i = 0; i < n; ++i) {
        cur_b_mandatory.insert(arr[i].second);
    }
    int i = 0;
    int ans = INF;
    while (i < n) {
        cur_b_mandatory.erase(cur_b_mandatory.find(arr[i].second));
        if (arr[i + 1].first == arr[i].first) {
            cur_b_optional.insert(arr[i].second);
            while (arr[i + 1].first != arr[i].first) {
                ++i;
                cur_b_optional.insert(arr[i].second);
            }
        }
        if (cur_b_mandatory.empty() && cur_b_optional.empty()) {
            break;
        }
        int mx_mandatory = (cur_b_mandatory.empty() ? 0 : *cur_b_mandatory.rbegin());
        auto it = cur_b_optional.lower_bound(arr[i].first);
        auto it2 = (it == cur_b_optional.begin() ? it : prev(it));
        if (it != cur_b_optional.end()) {
            ans = min(ans, abs(max(mx_mandatory, *it) - arr[i].first));
        }
        if (it2 != cur_b_optional.end()) {
            ans = min(ans, abs(max(mx_mandatory, *it) - arr[i].first));
        }
        ans = min(ans, abs(mx_mandatory - arr[i].first));
        ++i;
    }
    cout << ans << endl;
    return 0;
}


signed main() {
    signed t;
    t = 1;
    while (t--) {
        signed retcode = one();
        if (retcode) {
            return retcode;
        }
    }
    return 0;
}