#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <random>
#include <chrono>
#include <unordered_set>

using namespace std;
using pii = pair<int, int>;

int main() {
    int n, x, y;
    cin >> n;
    vector<int> a;
    vector<int> b;
    vector<pii> c, d;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        a.emplace_back(x);
        b.emplace_back(y);
        c.emplace_back(x, i);
        d.emplace_back(y, i);
    }
    vector<int> possible;
    for (int i = 0; i < n; ++i) {
        possible.push_back(i);
    }
    sort(c.rbegin(), c.rend());
    sort(d.rbegin(), d.rend());
    unordered_set<int> cannot;
    int ans = 1e9;
    int cur = 0;
    for (int i = 0; i < n ;++i) {
        x = c[i].first;
        if (i > 0) {
            cur = max(cur, b[c[i - 1].second]);
        }
        cannot.insert(c[i].second);
        int best = -1;
        for (int j = 0; j < n; ++j) {
            if (cannot.find(j) == cannot.end()) {
                if (best == -1 || abs(x - b[j]) < abs(x - b[best])) {
                    best = j;
                }
            }
        }
        ans = min(ans, abs(x - max(b[best], cur)));
    }
    cout << ans << endl;
    return 0;
}