#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define ld long double
#define all(a) a.begin(), a.end()

const long long INF = 1e18;
const long long MAXN = 1e5;
const long double EPS = 1e-10;


//----------СНМ-----------
/*
int pr[MAXN];

void add(int v) {
    pr[v] = v;
}

int get(int v) {
    if (v == pr[v]) return v;
    return get(pr[v]);
}

void union_sets(int v, int u) {
    v = get(v);
    u = get(u);
    if (v == u) return;
    pr[u] = v;
    union_sets(v, pr[u]);
}
*/

void solve() {
    int n;
    cin >> n;
    vector <pair <int, int>> a;
    vector <int> prefmax1(n, -1), prefmax2(n, -1);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a.pb(mp(x, y));
    }
    sort(all(a));
    for (int i = 0; i < n; i++) {
        int x = a[i].first, y = a[i].second;
        if (i == 0) prefmax1[i] = x, prefmax2[i] = y;
        else prefmax1[i] = max(prefmax1[i - 1], x), prefmax2[i] = max(prefmax2[i - 1], x);
    }
    vector <int> suffmax1(n, -1), suffmax2(n, -1);
    suffmax1[n - 1] = a[n - 1].first, suffmax2[n - 1] = a[n - 1].second;
    for (int i = n - 2; i >= 0; i--) {
        suffmax1[i] = max(suffmax1[i + 1], a[i].first);
        suffmax2[i] = max(suffmax2[i + 1], a[i].second);
    }

    int ans = INF;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            int tmp = abs(a[i].first - a[j].second);
            if (i + 1 < n and suffmax2[i + 1] > a[j].second) tmp = INF;
            ans = min(ans, tmp);
        }
    }
    cout << ans << endl;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    solve();
}