#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include<bits/stdc++.h>
//#define int long long
#define sz(a) (int)a.size()

using namespace std;

const int INF = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<pair<int, int>> a(n + 1);
    vector<int> sbmax(n + 2);
    sbmax[n + 1] = -INF;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end());
    for (int i = n; i >= 1; --i) {
        sbmax[i] = max(sbmax[i + 1], a[i].second);
    }
    set<int> cnt;
    int L = -1, R = INF;
    while (L + 1 < R) {
        int M = (L + R) / 2;
        bool ok = 0;
        cnt.clear();
        for (int i = 1; i <= n; ++i) {
            int LB = a[i].first - M;
            int RB = a[i].first + M;
            if (sbmax[i + 1] > RB) {
                cnt.insert(a[i].second);
                continue;
            }
            if (sbmax[i + 1] >= LB) {
                ok = 1;
                break;
            }
            auto it = cnt.lower_bound(LB);
            if (it == cnt.end()) {
                cnt.insert(a[i].second);
                continue;
            }
            if (*it <= RB) {
                ok = 1;
                break;
            }
            cnt.insert(a[i].second);
        }
        if (ok) {
            R = M;
        }
        else {
            L = M;
        }
    }
    cout << R << '\n';
}
