#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define pb push_back
#define ff first
#define ss second
#define err(x) cerr << "[" << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[" << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "[" << ""#x"" << "] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}
using ll = long long;
using ld = long double;

using namespace std;

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}

mt19937 rnd(::std::chrono::high_resolution_clock::now().time_since_epoch().count());
const int MOD = 1e9 + 7;

/// actual code starts here

const int N = 5e5 + 5;

int tr[8 * N][2];
int n;
vector<int> cord;


void upd(int id, int p, int x, int v = 0, int L = 0, int R = cord.size()) {
    if (R - L == 1) {
        tr[v][id] = x;
        return;
    }
    int M = (L + R) / 2;
    if (p < M) upd(id, p, x, v * 2 + 1, L, M);
    else upd(id, p, x, v * 2 + 2, M, R);
    tr[v][id] = max(tr[v * 2 + 1][id], tr[v * 2 + 2][id]);
}

int get(int id, int l, int r, int v = 0, int L = 0, int R = cord.size()) {
    if (l == L && r == R) return tr[v][id];
    int M = (L + R) / 2, res = -MOD;
    if (l < M) res = max(res, get(id, l, min(M, r), v * 2 + 1, L, M));
    if (M < r) res = max(res, get(id, max(l, M), r, v * 2 + 2, M, R));
    return res;
}

int cnt[2 * N];

void solve() {
    cin >> n;
    vector<pair<int, int>> v(n);
    for (auto &i: v) cin >> i.first >> i.second;
    for (auto i: v) {
        cord.pb(i.first);
        cord.pb(i.second);
    }
    cord.pb(-MOD);
    cord.pb(MOD);
    sort(all(cord));
    cord.resize(unique(all(cord)) - cord.begin());
    for (int i = 0; i < n; i++) {
        v[i].ff = lower_bound(all(cord), v[i].ff) - cord.begin();
        v[i].ss = lower_bound(all(cord), v[i].ss) - cord.begin();
    }
    int res = MOD;
    for (int it = 0; it < 2; it++) {
        for (int i = 0; i < 4 * cord.size(); i++) tr[i][0] = tr[i][1] = -MOD;
        for (int i = 0; i < cord.size(); i++) cnt[i] = 0;
        sort(all(v));
        for (int i = 0; i < n; i++) {
            cnt[v[i].ss]++;
            upd(1, v[i].ss, cord[v[i].ss]);
        }


        for (int i = 0; i < n; i++) {
            cnt[v[i].ss]--;
            if (cnt[v[i].ss] == 0)
                upd(1, v[i].ss, -MOD);
            int mx = max(get(1, 0, cord.size()), get(0, 0, v[i].ff + 1));
            relaxmi(res, abs(cord[v[i].ff] - mx));
            upd(0, v[i].ss, cord[v[i].ss]);
        }
        for (int i = 0; i < n; i++)
            swap(v[i].first, v[i].second);
    }
    cout << res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) solve();
}