#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,popcnt")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
#define mem(x, y) memset(x, y, sizeof x)
#define sz(x) int(x.size())
#define int ll

const int INF = 1e18;

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	
	int n;
	cin >> n;
	
	map <int, vector <int>> a;
	for (int i = 0; i < n; i++) {
		int l, r;
		cin >> l >> r;
		a[l].push_back(r);
	}
	
	multiset <int> s = {-INF, INF};
	for (auto &[x, y]: a) {
		for (int i: y) s.insert(i);
	}
	
	int ans = INF, R = 0;
	for (auto &[l, b]: a) {
		for (int r: b) {
			ans = min(ans, abs(l - R));
			auto it = --s.upper_bound(l);
			if (*it > R) ans = min(ans, abs(l - *it));
			it = s.upper_bound(max(l, R));
			if (*it != INF) ans = min(ans, abs(l - *it));
		}
		for (int r: b) {
			R = max(R, r);
			s.erase(s.find(r));
		}
	}
	cout << ans << '\n';
	
	return 0;
}
