#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define endl "\n"
#define eb emplace_back
#define lb(a, b) lower_bound(all(a), b)
#define ub(a, b) upper_bound(all(a), b)

int bubbleGum = 0;
#ifdef LOCAL
#include "Templates/DebugTemplate.cpp"
#define FAST_IO ;
#else
#define dbg(...) ++bubbleGum;
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif


const int INF = 2e9 + 10;


int n;
vec<int> a, b, sorted, sorted2;
map<int, vec<int>> bra;


bool check(int d) {
    int bound = -INF;
    for (auto& ma : sorted) {
        if (ma < bound) return false;
        for (auto& ind : bra[ma])
            bound = max(bound, b[ind] - d);
        int cnt = sz(bra[ma]);
        int le = ma - d, ri = ma + d;
        int cnt2 = ub(sorted2, ri) - lb(sorted2, le);
        int ind = -1;
        if (cnt == 1) ind = bra[ma].front();
        if (ind != -1 && (le <= b[ind] && b[ind] <= ri)) --cnt2;

        dbg(ma, ind, bra[ma], le, ri, cnt2, cnt);

        if (cnt2) return true;
    }

    return false;
}


signed main() {
#ifdef LOCAL
    freopen("C:\\Users\\user\\CLionProjects\\OpenOlymp\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    cin >> n;
    a.resize(n); b.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i] >> b[i];
    sorted = a; sort(all(sorted));
    sorted.resize(unique(all(sorted)) - sorted.begin());
    reverse(all(sorted));
    sorted2 = b;
    sort(all(sorted2));

    for (int i = 0; i < n; ++i)
        bra[a[i]].eb(i);

    int l = -1, r = INF;
    while (r > l + 1) {
        int mid = (l + r) / 2;
        if (check(mid)) r = mid;
        else l = mid;
    }

    cout << r;

}