#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cassert>
#include <cmath>

using namespace std;
typedef long long ll;

int n;
int a[500010];
int b[500010];

vector <pair <int, int>> x;
multiset <int> maybe;
multiset <int> must;

int ans = 1e9 + 10;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i] >> b[i];
		x.push_back({ a[i], b[i] });
		maybe.insert(b[i]);
	}


	sort(x.begin(), x.end());
	must.insert(0);
	maybe.insert(0);

	while (x.size())
	{
		auto got = x.back();
		x.pop_back();

		int u = got.first, v = got.second;
		maybe.erase(maybe.find(v));
		auto pt = maybe.upper_bound(u);

		if (pt != maybe.end())
		{
			must.insert(*pt);
			ans = min(ans, abs(*must.rbegin() - u));
			must.erase(must.find(*pt));
		}
		if (pt != maybe.begin())
		{
			--pt;
			must.insert(*pt);
			ans = min(ans, abs(*must.rbegin() - u));
			must.erase(must.find(*pt));
		}

		must.insert(v);
	}

	cout << ans;




	return 0;
}				