//#pragma GCC optimize("Ofast")
//#pragma GCC terget("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

const ll INF64 = 9'000'000'000'000'000'000, INF32 = 2'000'000'000, MOD = 1'000'000'007;
const double PI = acos(-1);
bool l = false;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n;
	cin >> n;
	vector<pair<ll, ll>> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i].first >> arr[i].second;
	}
	sort(arr.begin(), arr.end());
	multiset<ll> now;
	for (ll i = 0; i < n; i++) {
		now.insert(arr[i].second);
	}
	ll ans = INF32;
	ll nm = 0;
	for (ll i = n - 1; i >= 0; i--) {
		now.erase(now.find(arr[i].second));
		ll x = arr[i].first;
		auto it = now.lower_bound(x);
		if (it != now.end()) {
			assign_min(ans, abs(x - max(*it, nm)));
		}
		if (it != now.begin()) {
			it--;
			assign_min(ans, abs(x - max(*it, nm)));
		}
		assign_max(nm, arr[i].second);
	}
	cout << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef LOCAL
	l = true;
#endif
	if (!l) {
		solve();
	} else {
		solve();
	}
}
