#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sqr(x) (x)*(x)
#define pw(x) (1LL << x)

const int inf = 1e18;


int n;
vector<pair<int, int> > a, x, y;
bool test_case_4 = true;


main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    a.resize(n);
    for(int i = 0; i < n; i ++){
        cin >> a[i].first >> a[i].second;
        if (a[i].first != a[i].second)
            test_case_4 = false;
    }

    if (test_case_4){
        sort(rall(a));
        cout << a[0].first - a[1].second;
        return 0;
    }

    for(int i = 0; i < n; i ++){
        x.push_back({a[i].first, i});
        y.push_back({a[i].second, i});
    }
    sort(rall(x));
    sort(rall(y));

//    for(int i = 0; i < n; i ++){
//        cout << x[i].first << ' ' << x[i].second << " | " << y[i].first << ' ' << y[i].second << '\n';
//    }

    int ans = inf;
    int mi = -inf;
    int j = 0;
    for(int i = 0; i < n; i ++){
        if (j < 0)
            j = 0;
        while(j < n && abs(x[i].first - max(mi, y[j + 1].first)) <= abs(x[i].first - max(mi, y[j].first)))
            j ++;
        if (y[j].second == x[i].second){
            if (j > 0) ans = min(ans, abs(x[i].first - max(mi, y[j - 1].first)));
            if (j < n) ans = min(ans, abs(x[i].first - max(mi, y[j + 1].first)));
        } else
            ans = min(ans, abs(x[i].first - max(mi, y[j].first)));

        mi = max(mi, a[x[i].second].second);
        j -= 2;
    }

    cout << ans;
}

/*
5
1 5
2 7
5 5
2 10
2 5
*/
