B


#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a)  a.begin(), a.end()
#define rall(a)  a.rbegin(), a.rend()
#define sz(a) (a.size())

#define line cout<<'\n'

random_device rd;

const long long mod = 1e9 + 7;
const long long inf = 9099999999999999999;
const long long nmax = 2e5 + 100;

void solve() {
    int n;
    cin >> n;
    vector <int> a(n), b(n);
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];

    vector <pair<int, int>> p(n + 1);
    for (int i = 0; i < n; i++)
        p[i + 1] = {a[i], b[i]};

    vector <int> suf(n + 2);
    sort(all(p));
    vector <int> P(n + 1);
    for (int i = 1; i <= n; i++)
        P[i] = p[i].first;

    for (int i = n; i >= 1; i--) {
        suf[i] = max(suf[i + 1], p[i].second);
    }
    suf[n + 1] = -inf;

    map<int, int> mp;
    for (auto x : a)
        mp[x]++;

    int ans = inf;
    for (int i = 1; i <= n; i++) {
        ans = min(ans, abs(P[i] - suf[i + 1]));
        for (int j = 1; j <= i; j++) {
            if (j == i && mp[P[i]] == 1) continue;
            if (p[j].second >= suf[i + 1])
                ans = min(ans, abs(p[j].second - P[i]));
        }
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}
