#include "iostream"
#include "vector"
#include "algorithm"
#include "iomanip"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"

using namespace std;

#define ll long long
#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

const ll INF = 1e15;

bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
    if (a.first == b.first) return a.second > b.second;
    return a.first < b.first;
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int n; cin >> n;
    vector<pair<ll, ll>> l(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i].first >> l[i].second;
    }
    sort(l.begin(), l.end(), cmp);
    vector<ll> sufm(n);
    ll mx2 = 0;
    for (int i = n - 1; i >= 0; --i) {
        mx2 = max(mx2, l[i].second);
        sufm[i] = mx2;
    }
    set<ll> st;
    ll ans = INF;
    for (int i = 0; i < n; ++i) {
        ll mxn = -INF;
        if (i < n - 1) mxn = sufm[i + 1];
        auto it1 = st.lower_bound(l[i].first);
        ll low = -INF, up = -INF;
        if (not st.empty() and it1 != st.begin()) {
            low = *(--it1);
        }
        auto it2 = st.lower_bound(l[i].first);
        if (it2 != st.end()) {
            up = *it2;
        }
        if (mxn == -INF) {
            if (low != -INF) ans = min(ans, abs(l[i].first - low));
            if (up != -INF) ans = min(ans, abs(l[i].first - up));
        } else {
            ans = min(ans, abs(l[i].first - mxn));
            if (low != -INF) ans = min(ans, abs(l[i].first - max(low, mxn)));
            if (up != -INF) ans = min(ans, abs(l[i].first - max(up, mxn)));
        }
        st.insert(l[i].second);
    }
    cout << ans << '\n';
}