#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }

inline void solve () {
    int n; cin >> n;
    vector <pii> a (n);
    for (auto &[x, y] : a) cin >> x >> y;
    sort(all(a));
    set <int> s;
    int ans = 2e9;
    for (auto [x, y] : a) {
        auto it = s.upper_bound(x);
        if (it != s.end()) {
            umin(ans, *it - x);
        }
        if (it != s.begin()) {
            --it;
            umin(ans, x - *it);
        }
        s.insert(y);
    }
    cout << ans << endl;
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t = 1; // cin >> t;
    while (t--) solve();
    return 0;
}
