#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }

inline void solve () {
    int n; cin >> n;
    vector <pii> a (n);
    for (auto &[x, y] : a) cin >> x >> y;
    if (n > 20) return;
    int ans = 2e9;
    for (int i = 1; i < (1 << n); ++i) {
        int mx1 = 0, mx2 = 0;
        for (int j = 0; j < n; ++j) {
            if (i >> j & 1) umax(mx1, a[j].fr);
            else umax(mx2, a[j].sc);
        }
        umin(ans, abs(mx1 - mx2));
    }
    cout << ans;
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t = 1; // cin >> t;
    while (t--) solve();
    return 0;
}
