#include <bits/stdc++.h>

#define F first
#define S second
#define sz size()
#define pb push_back
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;


const int inf = 1e9 + 1;
const int N = 500500;
int t[4 * N];

void upd (int v, int l, int r, int pos, int val) {
    if (l > pos || r < pos) {
        return;
    }

    if (l == r) {
        t[v] = val;
        return;
    }

    int mid = (l + r) / 2;
    upd (2 * v, l, mid, pos, val);
    upd (2 * v + 1, mid + 1, r, pos, val);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

int get_max (int v, int l, int r, int tl, int tr) {
    if (l > tr || r < tl) {
        return -inf;
    }

    if (l >= tl && r <= tr) {
        return t[v];
    }

    int mid = (l + r) / 2;
    return max(get_max(2 * v, l, mid, tl, tr), get_max(2 * v + 1, mid + 1, r, tl, tr));
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    int a[n + 8], b[n + 8];
    vector <pii> vec;
    for (int i = 1; i <= n; i++) {
        cin >> a[i] >> b[i];
        vec.pb({a[i], i});
    }

    sort(all(vec));


    for (int i = 0; i < n; i++) {
        int pos = vec[i].S;
        upd (1, 1, n, pos, b[pos]);
    }

    set <pii> s;
    int ans = 1e9 + 1;
    for (int i = 0; i < vec.sz; i++) {
        int x = vec[i].F, pos = vec[i].S;

        while (s.sz > 0) {
            pii j = *s.begin();
            if (j.F <= x) {
                upd (1, 1, n, j.S, j.F);
                s.erase(s.begin());
            }
            else {
                break;
            }
        }

        if (pos == 1) {
            int mx = get_max(1, 1, n, i + 1, n);
            if (mx <= a[pos]) {
                ans = min(ans, abs(mx - a[pos]));
            }

        } else {
            if (i == n) {
                int mx = get_max(1, 1, n, 1, i - 1);
                if (mx <= a[pos]) {
                    ans = min(ans, abs(mx - a[pos]));
                }

            } else {
                int mx = max(get_max(1, 1, n, 1, i - 1), get_max(1, 1, n, i + 1, n));
                if (mx <= a[pos]) {
                    ans = min(ans, abs(mx - a[pos]));
                }
            }
        }

        upd (1, 1, n, pos, -inf);
        s.insert({b[pos], pos});
    }




    vec.clear();
    for (int i = 1; i <= n; i++) {
        vec.pb({b[i], i});
    }

    sort(all(vec));


    for (int i = 0; i < n; i++) {
        int pos = vec[i].S;
        upd (1, 1, n, pos, a[pos]);
    }

    s.clear();
    for (int i = 0; i < vec.sz; i++) {
        int x = vec[i].F, pos = vec[i].S;

        while (s.sz > 0) {
            pii j = *s.begin();
            if (j.F <= x) {
                upd (1, 1, n, j.S, j.F);
                s.erase(s.begin());
            }
            else {
                break;
            }
        }

        if (pos == 1) {
            int mx = get_max(1, 1, n, i + 1, n);
            if (mx <= b[pos]) {
                ans = min(ans, abs(mx - x));
            }

        } else {
            if (i == n) {
                int mx = get_max(1, 1, n, 1, i - 1);
                if (mx <= x) {
                    ans = min(ans, abs(mx - x));
                }

            } else {
                int mx = max(get_max(1, 1, n, 1, i - 1), get_max(1, 1, n, i + 1, n));
                if (mx <= x) {
                    ans = min(ans, abs(mx - x));
                }
            }
        }

        upd (1, 1, n, pos, -inf);
        s.insert({a[pos], pos});
    }

    cout << ans;


}
