#include <bits/stdc++.h>

#define F first
#define S second
#define sz size()
#define pb push_back
#define all(x) x.begin(), x.end()
//#define int long long

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;


const int inf = 1e9 + 1;
const int N = 500500;
int t[4 * N];

void upd (int v, int l, int r, int pos, int val) {
    if (l > pos || r < pos) {
        return;
    }

    if (l == r) {
        t[v] = val;
        return;
    }

    int mid = (l + r) / 2;
    upd (2 * v, l, mid, pos, val);
    upd (2 * v + 1, mid + 1, r, pos, val);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

int get_max (int v, int l, int r, int tl, int tr) {
    if (l > tr || r < tl) {
        return -inf;
    }

    if (l >= tl && r <= tr) {
        return t[v];
    }

    int mid = (l + r) / 2;
    return max(get_max(2 * v, l, mid, tl, tr), get_max(2 * v + 1, mid + 1, r, tl, tr));
}

int a[N], b[N];


bool comp (pii x, pii y) {
    if (x.F != y.F) {
        return x.F < y.F;
    }
    return b[x.S] < b[y.S];
}

bool comp1 (pii x, pii y) {
    if (x.F != y.F) {
        return x.F < y.F;
    }
    return a[x.S] < a[y.S];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector <pii> vec;
    for (int i = 1; i <= n; i++) {
        cin >> a[i] >> b[i];
        vec.pb({a[i], i});
    }

    sort(all(vec), comp);

    set <pii> r;
    r.insert({-inf, inf});
    for (int i = 0; i < n; i++) {
        int pos = vec[i].S;
        r.insert({b[pos], pos});
    }

    set <pii> s;
    int ans = 1e9 + 1;
    for (int i = 0; i < vec.sz; i++) {
        int x = vec[i].F, pos = vec[i].S;
        r.erase({b[pos], pos});
        while (s.sz > 0) {
            pii j = *s.begin();
            if (j.F <= x) {
                r.insert({j.F, j.S});
                s.erase(s.begin());
            }
            else {
                break;
            }
        }

        if (pos == 1) {
            int mx = (*--r.end()).F;
            if (mx <= a[pos]) {
                ans = min(ans, abs(mx - a[pos]));
            }

        } else {
            if (pos == n) {
                int mx = (*--r.end()).F;
                if (mx <= a[pos]) {
                    ans = min(ans, abs(mx - a[pos]));
                }

            } else {
                int mx = (*--r.end()).F;
                if (mx <= a[pos]) {
                    ans = min(ans, abs(mx - a[pos]));
                }
            }
        }
        s.insert({b[pos], pos});
    }

//    cout << ans << "\n";




    vec.clear();
    for (int i = 1; i <= n; i++) {
        vec.pb({b[i], i});
    }

    sort(all(vec), comp1);

    s.clear();
    r.clear();
    r.insert({-inf, inf});
   for (int i = 0; i < n; i++) {
        int pos = vec[i].S;
        r.insert({a[pos], pos});
    }

    for (int i = 0; i < vec.sz; i++) {
        int x = vec[i].F, pos = vec[i].S;
//        cout << i << " " << pos << " " << x << "\n";
        r.erase({a[pos], pos});

//        cout << "before:\n";
//        for (auto j : r) {
//            cout << j.F << " " << j.S << "\n";
//        }
        while (s.sz > 0) {
            pii j = *s.begin();
            if (j.F <= x) {
                r.insert({j.F, j.S});
                s.erase(s.begin());
            }
            else {
                break;
            }
        }
//        cout << "after:\n";
//        for (auto j : r) {
//            cout << j.F << " " << j.S << "\n";
//        }
//        cout << "max - " << (*--r.end()).F << " - ";
        if (pos == 1) {
            int mx = (*--r.end()).F;
            if (mx <= b[pos]) {
                ans = min(ans, abs(mx - b[pos]));
            }

        } else {
            if (pos == n) {
                int mx = (*--r.end()).F;
                if (mx <= b[pos]) {
                    ans = min(ans, abs(mx - b[pos]));
                }

            } else {
                int mx = (*--r.end()).F;
                if (mx <= b[pos]) {
                    ans = min(ans, abs(mx - b[pos]));
                }
            }
        }
//        cout << "ans - " << ans << "\n";
        s.insert({a[pos], pos});
    }
    cout << ans;


}
