#include <bits/stdc++.h>

#define F first
#define S second
#define sz size()
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;


const int inf = 1e9 + 1;
const int N = 500500;
int a[N], b[N];

bool comp (pii x, pii y) {
    if (x.F != y.F) {
        return x.F < y.F;
    }
    return b[x.S] < b[y.S];
}

bool comp1 (pii x, pii y) {
    if (x.F != y.F) {
        return x.F < y.F;
    }
    return a[x.S] < a[y.S];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector <pii> vec;
    for (int i = 1; i <= n; i++) {
        cin >> a[i] >> b[i];
        vec.pb({a[i], i});
    }

    sort(all(vec));

    multiset <int> r, s;
    for (int i = 0; i < n; i++) {
        int pos = vec[i].S;
        r.insert(b[pos]);
    }

    int ans = 1e9 + 1;
    for (int i = 0; i < vec.sz; i++) {
        int x = vec[i].F, pos = vec[i].S;
        r.erase(r.find(b[pos]));
        if (r.sz > 0) {
            int mx = (*--r.end());
            if (mx <= x) {
                ans = min(ans, abs(mx - x));
            }
        }

        if (s.sz > 0) {
            if (*s.begin() <= x) {
                int mx = *(--s.upper_bound(x));
                ans = min(ans, abs(mx - x));
            }
        }
        s.insert(b[pos]);
    }


    vec.clear();
    for (int i = 1; i <= n; i++) {
        vec.pb({b[i], i});
    }
    sort(all(vec));

    s.clear();
    r.clear();
   for (int i = 0; i < n; i++) {
        int pos = vec[i].S;
        r.insert(a[pos]);
    }

    for (int i = 0; i < vec.sz; i++) {
        int x = vec[i].F, pos = vec[i].S;
        r.erase(r.find(a[pos]));
        if (r.sz > 0) {
            int mx = (*--r.end());
            if (mx <= x) {
                ans = min(ans, abs(mx - x));
            }
        }
        if (s.sz > 0) {
            if (*s.begin() <= x) {
                int mx = *(--s.upper_bound(x));
                ans = min(ans, abs(mx - x));
            }
        }
        s.insert(a[pos]);
    }
    cout << ans;


}
