#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9+7, maxn = 2e5+1;
int n, N;
vector<vector<int>>t;
vector<int>B;
void merge(int v){
	int v1 = v*2, v2 = v1+1;
	int i1 = 0, i2 = 0;
	int n1 = sz(t[v1]), n2 = sz(t[v2]);
	while(i1 < n1 && i2 < n2){
		if(t[v1][i1] < t[v2][i2]) t[v].push_back(t[v1][i1++]);
		else t[v].push_back(t[v2][i2++]);
	}
	while(i1 < n1)t[v].push_back(t[v1][i1++]);
	while(i2 < n2)t[v].push_back(t[v2][i2++]);
}
void build(){
	N = 1;
	while(N<=n)N*=2;
	t.resize(2*N);
	for (int i = 0; i < n; ++i) {
		t[i+N] = {B[i]};
	}
	for (int i = N - 1; i > 0; --i) {
		merge(i);
	}
}
int get(int lq, int rq, int x, int v =1 , int l = 0, int r = N){
	if(rq <= l || r<=lq)return inf;
	if(lq <= l && r <= rq){
		int res = inf;
		int i = lower_bound(all(t[v]), x) - t[v].begin();
		if(i < sz(t[v])) res = min(res, t[v][i] - x);
		if(i) res = min(res, x - t[v][i-1]);
		return res;
	}
	int m = (l+r)/2;
	return min(get(lq, rq, v*2, l, m), get(lq, rq, v*2+1, m, r));
}
void solve(){
	cin>>n;
	vector<pii>c(n);
	for(auto&[a, b]:c)cin>>a>>b;
	sort(all(c));
	for (int i = 0; i < n; ++i) {
		B.push_back(c[i].second);
	}
	build();
	int ans = inf;
	set<int>var;
	for (int i = 0; i < n; ++i) {
		auto[a, b] = c[i];
		int i2 = upper_bound(all(c), make_pair(a, inf)) - c.begin();
		if(!var.empty()){
			auto ir = var.lower_bound(a);
			if(ir != var.end()) ans = min(ans, *ir - a);
			if(ir != var.begin()) ans = min(ans, a - *--ir);
		}
		ans = min(ans, get(i + 1, n, a));
		var.insert(b);
	}
	cout<<ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int _=1;
	//cin>>_;
	while(_--){
		solve();
		cout<<'\n';
	}
	return 0;
}
