#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>

#pragma warning(disable: 4996)


typedef long long ll;
typedef long double ld;

using namespace std;

#define vec vector
#define pii pair<int, int>
#define pll pair<ll, ll>

ll const mod = 1e9 + 7;
ll const INF = 2e9;
ll const LINF = 4e18;
ll const mod1 = 1000575179;

vec<pii> asd;


vec<int> tree;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = asd[l].second;
        return;
    }
    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
}

ll get(int v, int l, int r, int ql, int qr) {
    if (r <= ql || qr <= l) {
        return -LINF;
    }
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    int m = (l + r) / 2;
    return max(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
}

void solve() {
    int n; cin >> n;
    vec<pii> qwe(n);
    asd = vec<pii>(n);
    int mxa = 0, mxb = 0;
    bool submem = 1;
    for (int i = 0; i < n; i++) {
        cin >> qwe[i].first >> qwe[i].second;
        if (qwe[i].first != qwe[i].second)
            submem = 0;
        asd[i] = qwe[i];
        if (qwe[mxb].second < qwe[i].second) {
            mxb = i;
        }
        if (qwe[mxa].first < qwe[i].first) {
            mxa = i;
        }
    }

    if (submem) {
        sort(asd.begin(), asd.end());
        cout << asd[n - 1].first - asd[n - 2].second << "\n";
        return;
    }

    sort(asd.begin(), asd.end());
    tree = vec<int>(4 * n);
    build(0, 0, n);
    ll cnt = n * 4;
    ll ty = 0;
    vec<vec<int>> now(n * 4);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j) {
                if (mxa != i && mxa != j) {
                    if (qwe[mxa].first > qwe[i].first && qwe[mxa].second > qwe[j].second) {
                        continue;
                    }
                }
                if (mxb != i && mxb != j) {
                    if (qwe[mxb].first > qwe[i].first && qwe[mxb].second > qwe[j].second) {
                        continue;
                    }
                }
                if (ty < cnt) {
                    now[ty] = { abs(qwe[i].first - qwe[j].second), i, j };
                    ty++;
                }
                else {
                    now.push_back({ abs(qwe[i].first - qwe[j].second), i, j });
                }
            }
        }
    }
    sort(now.begin(), now.end());

    for (auto elem : now) {
        int i = elem[1];
        int j = elem[2];

        ll mx;
        if (asd[n - 1].first <= qwe[i].first) {
            cout << elem[0] << "\n";
            exit(0);
        }

        int l = 0, r = n - 1;
        while (l + 1 < r) {
            int  m = (l + r) / 2;
            if (asd[m].first > qwe[i].first) {
                r = m;
            }
            else {
                l = m;
            }
        }
        int q = ((asd[l].first > qwe[i].first) ? l : r);
        mx = get(0, 0, n, q, n);

        if (mx > qwe[j].second) {
            continue;
        }
        cout << elem[0] << "\n";
        exit(0);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}