#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
// gp_hash_table

#define int long long
#define sz(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define ll long long
#define ld double

#ifdef home
#define dbg(x) cout << #x << " = " << (x) << endl
#else
#define dbg(x) 42
#endif

//#pragma GCC optimize("Ofast") // O3 maybe
//#pragma GCC target("avx2")

template <typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream& operator << (ostream &os, vector<T> v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1) os << " ";
    }
    return os;
}

mt19937_64 rng (chrono::high_resolution_clock::now().time_since_epoch().count());

const int infll = 1e18;

struct SegTree {
    vector<int> tree;
    int n = 1;
    void init (int k) {
        n = 1;
        while (n < k) n *= 2;
        tree.resize(2 * n - 1, -1);
    }
    void set (int x, int i, int v, int l, int r) {
        if (r - l == 1) {
            tree[x] = v;
            return;
        }
        int m = (r + l) / 2;
        if (i < m) set(2 * x + 1, i, v, l, m);
        else set(2 * x + 2, i, v, m, r);
        tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
    }
    int get (int x, int lx, int rx, int l, int r) {
        if (l >= rx || lx >= r) return -1;
        if (l >= lx && r <= rx) return tree[x];
        int m = (r + l) / 2;
        return max(get(2 * x + 1, lx, rx, l, m), get(2 * x + 2, lx, rx, m, r));
    }
};

void solve() {
    int n;
    cin >> n;
    vector<array<int, 2>> a(n);
    vector<pair<int, int>> srt;
    SegTree t[2];
    t[0].init(n);
    t[1].init(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i][0] >> a[i][1];
        srt.push_back({a[i][0], 2 * i});
        srt.push_back({a[i][1], 2 * i + 1});
    }
    sort(all(srt));
    int cnt = 0;
    int ans = infll;
    vector<bool> used(n, false);
    for (int i = 0; i < sz(srt); i++) {
        int where = srt[i].second / 2;
        int who = srt[i].second % 2;
        if (!used[where]) cnt++, used[where] = true;
            if (cnt == n) {
            int mx = t[who ^ 1].get(0, 0, where, 0, t[who ^ 1].n);
            mx = max(mx, t[who ^ 1].get(0, where + 1, t[who ^ 1].n, 0, t[who ^ 1].n));
            if (mx == -1) continue;
            ans = min(ans, srt[i].first - mx);
        }
        t[who].set(0, where, srt[i].first, 0, t[who].n);
    }
    cout << ans << "\n";
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//   cin >> t;
    while (t--)
        solve();
}
/*
1)Time.
2) Нафарми баллы
3) порешай задачки
4) пофанься
 */