﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(2e9);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


#ifndef MSC_VER
ull __lg(ull x) {
	ull res = 0;
	for (; x > 1; x /= 2)
		++res;
	return res;
}
#endif


mt19937 rnd(0);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


void solve(istream& cin, ostream& cout) {
	ll n;
	cin >> n;
	vector<pair<ll, ll>> a(n);
	for (auto& [x, y] : a) {
		cin >> x >> y;
		if (x < y)
			swap(x, y);
	}
	sort(a.rbegin(), a.rend());

	multiset<ll> s;
	for (ll i = 0; i < n; ++i)
		s.insert(a[i].first);

	ll x = *(--s.end());
	ll y = *(--(--s.end()));
	ll res = abs(x - y);

	for (ll i = 0; i < n; ++i) {
		s.erase(s.find(a[i].first));
		s.insert(a[i].second);

		x = *(--s.end());
		y = *(--(--s.end()));
		res = min(res, abs(x - y));
	}

	cout << res << '\n';
}