#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#include <stack>
#include <deque>
#include <cstdio>
#include <random>
#include <cmath>
#include <ctime>

using namespace std;
using ll = long long;
using vii = vector<int>;
using ld = long double;
using vvi = vector<vii>;
using vll = vector<ll>;
using vvll = vector<vll>;
using vbb = vector<bool>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vpii = vector<pii>;
using vld = vector<ld>;
using coor = int;

const int INF = 1e9;

void solve() {
	int n;
	cin >> n;
	vpii a(n);
	for (auto& elem : a) {
		cin >> elem.first >> elem.second;
	}
	sort(a.begin(), a.end());
	multiset<int> q;
	for (auto& elem : a) {
		q.insert(elem.second);
	}
	int ans = INF;
	int cmx = 0;
	for (int i = n - 1; i >= 1; i--) {
		auto it2 = q.find(a[i].second);
		q.erase(it2);
		auto it = q.lower_bound(a[i].first);
		if (it != q.end()) {
			ans = min(ans, abs(a[i].first - max(cmx, *it)));
		}
		if (it != q.begin()) {
			it--;
			ans = min(ans, abs(a[i].first - max(cmx, *it)));
		}
		cmx = max(cmx, a[i].second);
	}
	ans = min(ans, abs(a[0].first - cmx));
	cout << ans;
} 

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	solve();
}