#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    sort(a.begin(), a.end(), [](const pair<int, int>& p1, const pair<int, int>& p2) {
        if (p1.second == p2.second) {
            return p1.first < p2.first;
        }
        return p1.second < p2.second;
    });

    int bestres = 2000000000;
    vector<pair<int, int>> second;
    second.reserve(n);
    for (int max1 = 0; max1 < n; max1++) {
        for (int j = 0; j < n; j++) {
            if (j == max1) {
                continue;
            }
            second.emplace_back(a[j].second, a[j].first);
        }
        while (!second.empty()) {
            auto [m2, m1] = second.back();
            bestres = min(bestres, abs(m2 - a[max1].first));
            if (m1 > a[max1].first) {
                break;
            }
            second.pop_back();
        }
        second.resize(0);
    }

    cout << bestres << "\n";

    return 0;
}
