#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    int ans = INF;

    vector<int> order(n);
    iota(all(order), 0);
    for (int iter = 0; iter < 2; ++iter) {
        sort(all(order), [&](int v, int u){
            return a[v] < a[u] || (a[v] == a[u] && b[v] < b[u]);
        });
        multiset<int> pref, suf;
        reverse(all(order));
        for (auto i : b) {
            pref.insert(i);
        }
        for (auto i : order) {
            pref.erase(pref.find(b[i]));

            int cur = INF;

            if (!suf.empty()) {
                cur = max(cur, abs(a[i] - *suf.rbegin()));
            } else {
                auto it = pref.lower_bound(a[i]);
                if (it != pref.end()) {
                    cur = min(cur, abs(a[i] - *it));
                }
                if (it != pref.begin()) {
                    --it;
                    cur = min(cur, abs(a[i] - *it));
                }
            }

            suf.insert(b[i]);
            ans = min(ans, cur);
        }
        swap(a, b);
    }
    cout << ans << en;
}

void stupid() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    int ans = INF;
    for (int mask = 1; mask < (1 << n) - 1; ++mask) {
        int A = -INF, B = -INF;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                A = max(A, a[i]);
            } else {
                B = max(B, b[i]);
            }
        }
        ans = min(ans, abs(A - B));
    }
    cout << ans << en;
}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
