#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <string>
#include <climits>
#include <math.h>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define pll pair<ll, ll>
#define mod 1000000007


int main()
{
	int siz;
	cin >> siz;
	vector<pii> arr(siz + 1);
	
	pii mim{ mod, mod };
	for (int i = 1; i < siz + 1; i++)
	{
		cin >> arr[i].first >> arr[i].second;
		if (arr[i].first < mim.first) {
			mim.first = arr[i].first;
		}
		else {
			mim.second = min(mim.second, arr[i].second);
		}
	}
	arr[0] = mim;

	vector<pii> dp(siz + 1);
	dp[0] = mim;
	for (int i = 1; i < siz + 1; i++)
	{
		dp[i] = dp[i - 1];
		int now = abs(dp[i].first - dp[i].second);
		pii one = { max(dp[i].first, arr[i].first), dp[i].second };
		pii two = { dp[i].first, max(dp[i].second, arr[i].second) };
		int one_val = abs(one.first - one.second);
		int two_val = abs(two.first - two.second);

		if (one_val < two_val) {
			dp[i] = one;
		}
		else {
			dp[i] = two;
		}

		//int one = abs(arr[i].first - dp[i].second);
		//if (one < now) { dp[i] = { arr[i].first, dp[i].second }; }
		//now = abs(dp[i].first - dp[i].second);
		//int two = abs(dp[i - 1].first - arr[i].second);
		//if (two < now) { dp[i] = { dp[i - 1].first, arr[i].second }; }
	}
	cout << abs(dp[siz].first - dp[siz].second) << endl;
}







