#pragma 'GCC-optimize'
#pragma 'unroll-loops'
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <stack>
#include <ctime>

#define all(x) x.begin(),x.end()
#define f first
#define s second

using namespace std;

const int maxn = 5e5;
int suffmax[maxn];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    //cin >> tests;
    tests = 1;
    while (tests--) {
        int n; cin >> n;
        vector <pair <int, int> > a(n);
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            cin >> a[i].f >> a[i].s;
            if (a[i].f == a[i].s) {
                cnt++;
            }
        }
        sort(all(a));
        if (cnt == n) {
            cout << a[n - 1].f - a[n - 2].f;
            return 0;
        }
        vector <pair <int, int> > B;
        map <pair <int, int>, int> M;
        for (auto x: a) {
            B.emplace_back(x.s, x.f);
            M[{x.s, x.f}]++;
        }
        sort(all(B));
        int _a[maxn]; for (int i = 0; i < n; ++i) _a[i] = n;
        stack <int> st;
        for (int i = 0; i < n; ++i) {
            while (!st.empty() && a[st.top()].f < a[i].f) {
                _a[st.top()] = i;
                st.pop();
            }
            st.push(i);
        }
        set <int> Q;
        int ans = 1e9;
        suffmax[n - 1] = a[n - 1].s;
        for (int i = n - 2; i >= 0; --i) {
            suffmax[i] = max(suffmax[i + 1], a[i].s);
        }
        for (int i = 0; i < n; ++i) {
            if (a.back().f > a[i].f) {
                int mx = suffmax[_a[i]];
                ans = min(ans, abs(a[i].f - mx));
                auto it = Q.upper_bound(mx);
                auto ff = lower_bound(it, Q.end(), a[i].f);
                if (ff != Q.end()) ans = min(ans, abs(a[i].f - *ff));
                if (ff != Q.begin()) {
                    ff--;
                    if (*ff > mx) ans = min(ans, abs(a[i].f - *ff));
                }
            }
            else {
                int l = 0, r = n;
                while (r - l > 1) {
                    int m = (l + r) >> 1;
                    if (B[m].f >= a[i].f) r = m;
                    else l = m;
                }
                for (int j = l - 1; j <= r + 1; ++j) {
                    ans = min(ans, abs(a[i].f - B[j].f));
                }
            }
            Q.insert(a[i].s);
        }
        cout << ans;
    }
    return 0;
}