#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,bmi,bmi2,fma,lzcnt,popcnt")
#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<bool> vb;
const int inf = 1e9 + 7;


//#include<ext/pb_ds/assoc_container.hpp>
//#include<ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//typedef tree<int, less<int>, null_type, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


bool f(const vi &a, const vi &b, int m) {
    int n = a.size();

    int ma = 0;
    int mb = 0;

    ma = a[0];

    int k = 1;
    for (; k < n; k++) {
        if (abs(b[k] - ma) <= m) {
            mb = b[k];
            break;
        }
        ma = max(ma, a[k]);
    }

    for (int i = k+1; i < n; i++) {
        if (abs(max(ma, a[i]) - mb) <= m) {
            ma = max(ma, a[i]);
        } else if (abs(ma - max(mb, b[i])) <= m) {
            mb = max(mb, b[i]);
        } else {
            return false;
        }
    }

    return (mb != 0 && ma != 0);
}


void solve() {
    int n;
    cin >> n;

    vi a(n);
    vi b(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
    }

    int ans;

    int l = -1;
    int r = inf;

    while (r - l > 1) {
        int m = l + (r - l) / 2;

        if (f(a, b, m) || f(b, a, m)) {
            r = m;
        } else {
            l = m;
        }
    }

    cout << r << '\n';
}


int main() {
    ios_base::sync_with_stdio(0); cin.tie(); cout.tie();

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}


