#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <climits>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

signed main() {
 //   ios_base::sync_with_stdio(false), cin.tie(nullptr);
    ll n;
    cin >> n;
    vector<Pair> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i].first >> a[i].second;
    sort(a.begin(), a.end());
    multiset<ll> pref, suff;
    for (ll i = 0; i < n; i++) suff.insert(a[i].second);
    ll ans = INF;
    for (ll i = 0; i < n; i++) {
     //   cout << "d: " << i << endl;
        suff.erase(suff.find(a[i].second));
        ll mx_suff;
        if (!suff.empty()) mx_suff = *suff.rbegin();
        else mx_suff = -INF;
        ll mx_pref;
        if (!pref.empty()) mx_pref = *pref.rbegin();
        else mx_pref = -INF;
        if (mx_suff > mx_pref) {
            ans = min(ans, abs(a[i].first - mx_suff));
        } else {
            ll mn = *suff.begin();
            auto it = pref.lower_bound(a[i].first);
            if (*it >= mn) {
                ans = min(ans, abs(a[i].first - *it));
                if (it != pref.begin()) {
                    auto it1 = it;
                    it1--;
                    if (*it1 >= mn) {
                        ans = min(ans, abs(a[i].first - *it1));
                    }
                }
            } else {
                auto it1 = pref.lower_bound(mn);
                ans = min(ans, abs(a[i].first - *it1));
            }
        }
        pref.insert(a[i].second);
    }
    cout << ans << endl;
    return 0;
}