#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

void solve()
{
	long long n;
	vector<pair<long long, long long>> v;
	cin >> n;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i].first >> v[i].second;
	}
	sort(v.begin(), v.end());

	vector<long long> suf(n + 1);
	suf[n] = -INF;
	for (long long i = n - 1; i > -1; i--)
	{
		suf[i] = max(suf[i + 1], v[i].second);
	}

	long long ans = INF;
	set<long long> sec = { -INF, INF };
	for (long long i = 0; i < n; i++)
	{
		long long mxa = v[i].first, mxb = suf[i + 1];
		ans = min(ans, abs(mxa - mxb));
		auto it = sec.lower_bound(mxa);
		if (*it >= mxb)
		{
			ans = min(ans, abs(*it - mxa));
		}
		it--;
		if (*it >= mxb)
		{
			ans = min(ans, abs(*it - mxa));
		}
		sec.insert(v[i].second);
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*























*/
