#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <numeric>
#include <cassert>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;


int get(int mx, int a){
    if (mx == -1){
        return 0;
    }
    return abs(mx - a);
}

int main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    sort(v.rbegin(), v.rend());
    int l = -1;
    int r = 2e9;
    while (r - l > 1) {
        int m = (l + r) / 2;
        multiset<int> bb;
        for (int i = 0; i < n; ++i) {
            bb.insert(v[i].second);
        }
        int mx = -1;
        bool f = false;
        for (int i = 0; i < n; ++i) {
            bb.erase(bb.find(v[i].second));
            auto it = bb.lower_bound(v[i].first);
            int x = -1;
            if (it != bb.end()){
                x = *it;
            }
            if (get(max(mx, x), v[i].first) <= m){
                f = true;
                break;
            }
            mx = max(mx, v[i].second);
        }
        if (f){
            r = m;
        } else{
            l = m;
        }
    }
    cout << r << endl;
#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}