#include <bits/stdc++.h>
#define ll long long
#define int long long
#define ld long double
#define pii pair <int, int>
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
using namespace std;

const int sz = 5e5 + 5;

int v[sz], tree[4 * sz];

void build(int  l, int r, int h) {
    if (l == r) {
        tree[h] = v[l];
        return;
    }
    int m = (r + l) / 2, h1 = 2 * h+ 1, h2 = 2 * h + 2;
    build(l, m, h1);
    build(m + 1, r, h2);
    tree[h] = max(tree[h1], tree[h2]);
}

ll get(int l, int r, int h, int tl, int tr) {
    if (tl <= l && r <= tr) {
        return tree[h];
    }
    if (r < tl || tr < l) {
        return -2e9;
    }
    int m = (r + l) / 2, h1  = 2 * h + 1, h2 = 2 * h + 2;
    return max(get(l, m, h1, tl, tr), get(m + 1, r, h2, tl, tr));
}

bool cmp1(pii a, pii b) {
    if (a.x != b.x) {
        return a.x < b.x;
    }
    return a.y > b.y;
}

bool cmp2(pii a, pii b) {
    if (a.y != b.y) {
        return a.y < b.y;
    }
    return a.x > b.x;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, ans = 2e9;
    cin >> n;
    vector <pii> vv(n);
    for (auto & e : vv) cin >> e.x >> e.y;
    sort(all(vv), cmp1);
    for (int i = 0; i < n; i++) {
        v[i] = vv[i].y;
    }
    build(0, n - 1, 0);
    for (int i = 0; i < n - 1; i++) {
        int x = get(0, n - 1, 0, i + 1, n - 1);
        ans = min(ans, abs(vv[i].x - x));
    }
    sort(all(vv), cmp2);
    for (int i = 0; i < n; i++) {
        v[i] = vv[i].x;
    }
    build(0, n - 1, 0);
    for (int i = 0; i < n - 1; i++) {
        int x = get(0, n - 1, 0, i + 1, n - 1);
        ans = min(ans, abs(vv[i].y - x));
    }
    cout << ans;
}
