#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ff first
#define ss second
#define pb push_back
//#define int long long
#define dl long double

const int inf = 2e9;

struct Magic {
    vector<int> a;

    Magic() {};

    void push(int x) {
        a.pb(x);
    }

    void remove(int x) {
        for (auto i = a.begin(); i != a.end(); i++) {
            if (*i == x) {
                a.erase(i);
                return;
            }
        }
    }

    int getmore(int x) {
        int ans = inf;
        for (auto i: a)
            if (i >= x && i < ans) ans = i;
        return ans;
    }

    int getmini(int x) {
        int ans = -inf;
        for (auto i: a)
            if (i <= x && i > ans) ans = i;
        return ans;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].ff >> a[i].ss;
    sort(a.begin(), a.end());
    multiset<int> st;
    for (int i = 0; i < n; i++) st.insert(a[i].ss);
    int r;
    Magic t;
    int ans = inf;
    for (int l = 0; l < n; l++) {
        r = l;
        t.push(a[l].ss);
        st.erase(st.find(a[l].ss));
        while (r + 1 < n && a[r + 1].ff == a[l].ff) {
            r++;
            t.push(a[r].ss);
            st.erase(st.find(a[r].ss));
        }
        for (int i = l; i <= r; i++) {
            t.remove(a[i].ss);
            if (!st.empty() && ((*st.rbegin()) >= a[i].ff)) ans = min(ans, *st.rbegin() - a[i].ff);
            else {
                ans = min(ans, t.getmore(a[i].ff) - a[i].ff);
                ans = min(ans, a[i].ff - t.getmini(a[i].ff));
            }
            t.push(a[i].ss);
        }
        l = r;
    }
    cout << ans;
}

signed main() {
#ifdef Bebra
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
#ifdef Bebra
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
    int tests = 1;
//    cin >> tests;
    while (tests--) solve();
}