#include <bits/stdc++.h>
#define all(a) begin(a), end(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
typedef long long ll;
typedef long double ld;
using namespace std;

ll sol1(ll n, vector<pair<ll, ll>> a){
    vector<pair<ll, ll>> b(n);
    sort(all(a), [](pair<ll, ll> x, pair<ll, ll> y){return x.first<y.first||(x.first==y.first&&x.second>y.second);});
    for(ll i=0;i<n;++i) b[i]={a[i].second, i};
    sort(all(b));
    vector<ll> pr(n), sf(n);
    sf[n-1]=-1;
    for(ll i=n-2;i>=0;--i) sf[i]=max(sf[i+1], a[i+1].second);
    ll j=n-1;
    for(ll i=n-1;i>=0;--i){
        while(j>=0&&(b[j].second>=i||b[j].first>a[i].first)) --j;
        if(j<0) pr[i]=-1;
        else pr[i]=b[j].first;
    }
    ll res=INT32_MAX;
    for(ll i=n-1;i>=0;--i){
        ll mx=max(sf[i], pr[i]);
        if(mx<a[i].first){
            auto it=upper_bound(all(b), mp(a[i].first, (ll)INT32_MIN));
            if(it!=b.end()){
                if(it->second==i){
                    it=upper_bound(all(b), *it);
                    if(it!=b.end()){
                        res=min(res, (it->first)-a[i].first);
                    }
                }else res=min(res, (it->first)-a[i].first);
            }
        }
        if(mx!=-1) res=min(res, abs(a[i].first-mx));
    }
    return res;
}

ll sol2(vector<pair<ll, ll>> &a){
    set<pair<ll, ll>> dp={{0, 0}}, ndp;
    for(auto &j:a){
        ll &x=j.first, &b=j.second;
        ndp.clear();
        for(auto &i:dp){
            ndp.insert({max(i.first, x), i.second});
            ndp.insert({i.first, max(i.second, b)});
        }
        swap(dp, ndp);
    }
    ll res=INT32_MAX;
    for(auto &i:dp) res=min(res, abs(i.first-i.second));
    return res;
}

bool fill(vector<pair<ll, ll>> &a, ll i){
    if(i==a.size()) return sol1(a.size(), a)!=sol2(a);
    for(ll f=0;f<5;++f) for(ll s=0;s<5;++s){
        a[i]={f, s};
        if(fill(a, i+1)) return true;
    }
    return false;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n;
    cin>>n;
    vector<pair<ll, ll>> a(n);
    for(auto &i:a) cin>>i.first>>i.second;
    cout<<sol1(n, a)<<'\n';
    /*if(fill(a, 0)){
        for(auto &i:a) cout<<i.first<<' '<<i.second<<'\n';
    }
    else cout<<"NO\n";*/
    return 0;
}
