#define _CRT_SECURE_NO_WARNINGS
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <random>
#include <vector>
#include <cmath>
#include <deque>
#include <set>
#include <map>
using namespace std;

using ll = long long;

const ll INF = 1e9;
const ll LLINF = 1e18;

void solve() {
	int n;
	cin >> n;
	vector<pair<int, int>> p(n);
	for (int i = 0; i < n; ++i) {
		cin >> p[i].first >> p[i].second;
	}

	sort(p.begin(), p.end());

	multiset<int> l;
	multiset<int> r;
	for (int i = 0; i < n; ++i) {
		r.insert(p[i].second);
	}
	int ans = INF;
	for (int i = 0; i < n; ++i) {
		int ma = p[i].first;
		r.erase(r.find(p[i].second));
		if (i == 0) {
			ans = min(ans, abs(ma - *prev(r.end())));
			continue;
		}
		if (i == n - 1) {
			if (l.lower_bound(ma) != l.end()) {
				int mbl1 = *l.lower_bound(ma);
				ans = min(ans, abs(ma - mbl1));
			}
			if (l.lower_bound(ma) != l.begin()) {
				int mbl2 = *prev(l.lower_bound(ma));
				ans = min(ans, abs(ma - mbl2));
			}
			continue;
		}
		l.insert(p[i - 1].second);
		int mbr = *prev(r.end());
		ans = min(ans, abs(ma - mbr));
		if (mbr > ma) {
			continue;
		}
		if (l.lower_bound(ma) != l.end()) {
			int mbl1 = *l.lower_bound(ma);
			ans = min(ans, abs(ma - max(mbl1, mbr)));
		}
		if (l.lower_bound(ma) != l.begin()) {
			int mbl2 = *prev(l.lower_bound(ma));
			ans = min(ans, abs(ma - max(mbl2, mbr)));
		}
	}
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);

	solve();
}