#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int mod = 1e9 + 7;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].first >> a[i].second;
    sort(all(a));

    vector<int> suf(n + 1, 0);
    for (int i = n - 1; i >= 0; i--) suf[i] = max(suf[i + 1], a[i].second);

    set<int> other;
    int ans = 1e9 + 1;
    for (int i = 0; i < n; i++) {
        int mx = suf[i + 1];
        auto it = other.lower_bound(a[i].first);
        if (it != other.end()) {
            ans = min(ans, abs(a[i].first - max(mx, *it)));
        }
        if (it != other.begin()) {
            it--;
            ans = min(ans, abs(a[i].first - max(mx, *it)));
        }
        other.insert(a[i].second);
    }

    cout << ans << '\n';

    return 0;
}