#include <bits/stdc++.h>
using namespace std;
long long int INF = 1e16;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector <pair <long long int, long long int>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
    }
    sort(v.begin(), v.end());
    long long int best = 1e18;
    set <long long int> s_down, s_up;
    s_down.insert(-INF);
    s_up.insert(INF);
    long long int suf[n];
    suf[n - 1] = -INF;
    for (int i = n - 2; i >= 0; i--) {
        suf[i] = max(suf[i + 1], v[i + 1].second);
    }
    long long int val;
    for (int i = 0; i < n; i++) {
        while ((*s_up.begin()) <= v[i].first) {
            s_down.insert(*s_up.begin());
            s_up.erase(s_up.begin());
        }
        val = suf[i];
        if (val >= v[i].first) {
            best = min(best, val - v[i].first);
        }
        else {
            val = max(val, *(--s_down.end()));
            best = min(best, -val + v[i].first);
            best = min(best, -val + v[i].first);
            best = min(best, (*s_up.begin()) - v[i].first);
        }
        s_up.insert(v[i].second);
    }
    cout << best << "\n";
    return 0;
}