#include <bits/stdc++.h>

#define int long long
const int INF = 1e9 + 7;
//g++ -std=c++17 -fsanitize=address -DLOCAL -D_GLIBCXX_DEBUG B.cpp -o B
using namespace std;

bool cmp(pair<int, int> f, pair<int, int> s) {
    return f.first < s.first || (f.first == s.first && f.second > s.second);
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (auto &[i, j] : a) cin >> i >> j;
    sort(a.begin(), a.end(), cmp);
    vector<int> mx(n + 1, -1);
    for (int i = n - 1; i >= 0; --i) mx[i] = max(mx[i + 1], a[i].second);
    set<int> cur;
    int ans = INF;
    for (int i = 0; i < n; ++i) {
        auto cur_mx = mx[i + 1];
        auto it = cur.lower_bound(a[i].first);
        int best = cur_mx;
        if (it != cur.end() && *it >= cur_mx && abs(*it - a[i].first) < abs(a[i].first - best)) best = *it;
        if (it != cur.begin() && *--it > cur_mx && abs(*it - a[i].first) < abs(a[i].first - best)) best = *it;
        ans = min(ans, abs(a[i].first - best));
        cur.insert(a[i].first);
        //cerr << a[i].first << " " << a[i].second << "  " << cur_mx << ' ' << best << '\n';
    }
    cout << ans;
}
int32_t main() {
    #ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif
    solve();
    return 0;
}
