#include <bits/stdc++.h>

#define int long long
const int INF = 1e9 + 7;
//g++ -std=c++17 -fsanitize=address -DLOCAL -D_GLIBCXX_DEBUG B.cpp -o B
using namespace std;

bool cmp(pair<int, int> f, pair<int, int> s) {
    return f.first < s.first || (f.first == s.first && f.second > s.second);
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    map<int, vector<int>> d;
    for (auto &[i, j] : a) cin >> i >> j, d[i].push_back(j);
    vector<pair<int, vector<int>>> b;
    for (auto [i, j] : d) b.emplace_back(i, j);
    vector<int> mx(n + 1, -1);
    for (int i = (int)b.size() - 1; i >= 0; --i) mx[i] = max(mx[i + 1], *max_element(b[i].second.begin(), b[i].second.end()));
    set<int> cur;
    int ans = INF;
    for (int i = 0; i < (int)b.size(); ++i) {
        auto cur_mx = mx[i + 1];
        if ((int)b[i].second.size() > 1) {
            for (auto j : b[i].second) cur.insert(j);
        }
        auto it = cur.lower_bound(b[i].first);
        int best = cur_mx;
        if (it != cur.end() && *it >= cur_mx && abs(*it - b[i].first) < abs(b[i].first - best)) best = *it;
        if (it != cur.begin() && *--it > cur_mx && abs(*it - b[i].first) < abs(b[i].first - best)) best = *it;
        ans = min(ans, abs(b[i].first - best));
        for (auto j : b[i].second) cur.insert(j);
    }
    cout << ans;
}
int32_t main() {
    #ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif
    solve();
    return 0;
}
