#include <bits/stdc++.h>

#define int int64_t

const int INF = 2e18;
const int MOD = 1e9 + 7;
const int MAXN = 1e5;
const long double EPS = 1e-5;
const long double EPS1 = 1e-6;

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve(){
    vector <pair<int, int>> a, b;
    int n;
    cin >> n;
    vector <pair<int, int>> vp;
    for(int i = 0; i < n; i++){
        int a1, b1;
        cin >> a1 >> b1;
        vp.push_back({a1, b1});
        a.push_back({a1, i});
        b.push_back({b1, i});
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    int l = -1, r = max(b[n - 1].first - a[0].first, a[n - 1].first - b[0].first);
    while(r - l > 1){
        int m = (l + r) / 2;
        int i = n - 1, j = n - 1;
        bool check = false;
        bool flag1 = false, flag2 = false;
        int mx1 = -1, mx2 = -1;
        while(i != -1 && j != -1){
            if(a[i].first == mx1){
                int mn = INF;
                for(; j >= 0; j--){
                    if(b[j].first == mx2){
                        mn = min(mn, abs(a[i].first - b[j].first));
                        break;
                    }
                    mn = min(mn, abs(a[i].first - b[j].first));
                }
                if(mn <= m){
                    check = 1;
                }
                break;
            }
            if(b[j].first == mx2){
                int mn = INF;
                for(; i >= 0; i--){
                    if(a[i].first == mx1){
                        mn = min(mn, abs(a[i].first - b[j].first));
                        break;
                    }
                    mn = min(mn, abs(a[i].first - b[j].first));
                }
                if(mn <= m){
                    check = 1;
                }
                break;
            }
            if(abs(a[i].first - b[j].first) > m){
                if(a[i].first < b[j].first){
                    mx1 = max(mx1, vp[b[j].second].second)
                    j--;
                }
                else{
                    mx2 = max(mx2, vp[a[i].second].first);
                    i--;
                }
            }
            else{
                if(a[i].second == b[j].second){
                    int aa = a[i].first;
                    int bb = b[j].first;
                    int mn = INF;
                    i--;
                    j--;
                    for(;i >= 0; i--){
                        if(a[i].first == mx1){
                            mn = min(mn, abs(a[i].first - bb));
                            break;
                        }
                        mn = min(mn, abs(a[i].first - bb));
                    }
                    for(;j >= 0; j--){
                        if(b[j].first == mx2){
                            mn = min(mn, abs(aa - b[j].first));
                            break;
                        }
                        mn = min(mn, abs(aa - b[j].first));
                    }
                    if(mn <= m){
                        check = 1;
                    }
                    break;
                }
                else{
                    check = 1;
                    break;
                }
            }
        }
        if(check){
            r = m;
        }
        else{
            l = m;
        }
    }
    cout << r;
}

signed main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
        cout << endl;
    }
    return 0;
}
