/*
Lisa
Jennie
Jisoo
Rose
 */

#pragma GCC optimize("03")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <cstring>
#include <chrono>
#include <random>
#include <bits/extc++.h>


using namespace std;
using namespace __gnu_pbds;

using ll = long long;
#define int ll
using pii = pair<int, int>;
using ld = long double;
using pll = pair<ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-8;

#define all(a) a.begin(), a.end()
#define pb push_back
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;
// #define int ll


int slv (int n, vector <int> a, vector <int> b) {
    vector <pii> c;
    for (int i = 0; i < n; ++i) {
        c.pb({b[i], a[i]});
    }
    sort(all(c));
    set <int> s;
    vector <int> suff(n);
    for (int i = n - 1; i >= 0; --i) {
        suff[i] = c[i].first;
        if (i + 1 < n) {
            suff[i] = max(suff[i], suff[i + 1]);
        }
    }
    ll ans = inf;
    for (int i = 0; i < n; ++i) {
        if (i - 1 >= 0) {
            s.insert(c[i - 1].first);
        }
        int dora = 0;
        if (i + 1 < n) {
            dora = max(dora, suff[i + 1]);
        }
        bool take = false;
        if (!s.empty()) {
            auto ind = s.upper_bound(c[i].second);
            if (ind != s.begin()) {
                take = true;
                --ind;
                dora = max(dora, (*ind));
            }
        }
        if (dora <= c[i].second && !(i == n - 1 && !take)) {
            ans = min(ans, c[i].second - dora);
        }
    }
    return ans;
}


void solve() {
    int n; cin >> n;
    vector <int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    cout << min(slv(n, a, b), slv(n, b, a)) << endl;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}