#pragma GCC target("avx2")
#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const int N = 2e5 + 10;
const int OO = 1e18;

void solve()
{
    int n;
    cin >> n;
    vec<pii> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].f >> a[i].s;
    sort(all(a));
    int ans = OO;
    multiset<int> every;
    multiset<int> choice;
    for (int i = 0; i < n; i++) every.insert(a[i].s);
    for (int i = 0; i < n; i++)
    {
        int j = i;
        while (j < n && a[j].f == a[i].f) j++;
        for (int k = i; k < j; k++)
        {
            every.erase(every.find(a[k].s));
            choice.insert(a[k].s);
        }
        int cur = OO;
        if (!every.empty())
        {
            int mx = *every.rbegin();
            if (mx > a[i].f) cur = mx - a[i].f;
            else
            {
                for (int k = i; k < j; k++)
                {
                    choice.erase(choice.find(a[k].s));
                    auto it = choice.upper_bound(a[i].f);
                    if (it != choice.begin())
                    {
                        --it;
                        if (*it > mx) cur = min(cur, a[i].f - *it);
                    }
                    it = choice.lower_bound(a[i].f);
                    if (it != choice.end())
                    {
                        cur = min(cur, *it - a[i].f);
                    }
                    choice.insert(a[k].s);
                }
            }
        }
        else
        {
            for (int k = i; k < j; k++)
            {
                choice.erase(choice.find(a[k].s));
                auto it = choice.upper_bound(a[i].f);
                if (it != choice.begin())
                {
                    --it;
                    cur = min(cur, a[i].f - *it);
                }
                it = choice.lower_bound(a[i].f);
                if (it != choice.end())
                {
                    cur = min(cur, *it - a[i].f);
                }
                choice.insert(a[k].s);
            }
        }
        ans = min(ans, cur);
        i = j - 1;
    }
    cout << ans;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}
