#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cstring>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

#define walk(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const int N = 5000;
int mask[N];

void solve() {
	int n;
	cin >> n;
	vector<int> arr(n), brr(n);
	for (int i = 0; i < n; i++)
		cin >> arr[i] >> brr[i];
	memset(mask, 0, sizeof mask);
	int ans = 1e9;
	for (int i = 0; i < n; i++) {
		int maxb = -1;
		for (int j = 0; j < n; j++) {
			if (arr[j] > arr[i]) {
				maxb = max(maxb, brr[j]);
				mask[j] = 1;
			}
		}
		if ((maxb - arr[i]) > 0) 
			ans = min(ans, maxb - arr[i]);
		else {
			for (int j = 0; j < n; j++) {
				if (i == j)
					continue;
				if (abs(brr[j] - arr[i]) < abs(maxb - arr[i]))
					maxb = brr[j];
			}
			ans = min(ans, abs(maxb - arr[i]));
		}
	}
	cout << ans;
}

signed main() {
	cin.tie(0)->sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);	
	solve();
}