#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#define ll long long
#define ld long double
using namespace std;
const string space=" ", slashn="\n";

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll n; cin >> n;
    bool g4=true;
    vector<ll> a(n);
    vector<ll> b(n);
    for (ll i=0; i<n; ++i) {
        cin >> a[i] >> b[i];
        if (a[i]!=b[i]) {
            g4 = false;
        }
    }

    if (g4) {
        ll first_max = a[0],
                second_max = a[1];
        if (second_max > first_max) {
            swap(first_max, second_max);
        }
        for (ll i=2; i<n; ++i) {
            if (a[i]>=first_max) {
                second_max=first_max;
                first_max=a[i];
            } else if (a[i] >= second_max) {
                second_max=a[i];
            }
        }

        cout << first_max-second_max;

        return 0;
    }


    vector<pair<ll, ll>> asorted(n);
    //{a, b}
    for (ll i=0; i<n; ++i) {
        asorted[i] = {a[i], b[i]};
    }

    sort(asorted.begin(), asorted.end());

    vector<pair<ll, ll>> b_and_inasorted_i(n);
    for (ll i=0; i<n; ++i) {
        b_and_inasorted_i[i] = {asorted[i].second, i};
    }
    sort(b_and_inasorted_i.begin(), b_and_inasorted_i.end());


    //ll afix_ind_in_asorted = n-1;
    ll best_dif = INT64_MAX;
    pair<ll, ll> current_max = {-1, INT64_MAX};

    for (ll afix_ind_in_asorted = n-1; afix_ind_in_asorted>=0; --afix_ind_in_asorted) {
        auto current_max_iterplus_in_bsorted = upper_bound(b_and_inasorted_i.begin(), b_and_inasorted_i.end(), current_max);

        auto it = lower_bound(current_max_iterplus_in_bsorted, b_and_inasorted_i.end(), asorted[afix_ind_in_asorted]);
        if (it!=b_and_inasorted_i.end()) {
            best_dif = min(best_dif, abs((*it).second-asorted[afix_ind_in_asorted].first));
        }
        if (it!=b_and_inasorted_i.begin()) {
            best_dif = min(best_dif, abs((*--it).second-asorted[afix_ind_in_asorted].first));
        }

        if (asorted[afix_ind_in_asorted].second > current_max.first) {
            current_max = {asorted[afix_ind_in_asorted].second, INT64_MAX};
        }

    }

    cout << best_dif << slashn;



/*
    ll best_dif = INT64_MAX;
    for (ll bfix=0; bfix<n; ++bfix) {
        // это значения!!!
        ll amax = INT64_MIN;
        ll a_optional_best = INT64_MAX;  // штуки, которые больше amax и лучше соотвествуют
        for (ll i=0; i<n; ++i) {
            if (i!=bfix) {
                if (b[i] > b[bfix]) {
                    // тогда этот подарок точно идет в a
                    amax = max(amax, a[i]);
                } else {
                    if (a[i] > amax && abs(b[bfix]-a[i]) < abs(b[bfix] - a_optional_best)) {
                        a_optional_best = a[i];
                    }
                }
            }
        }

        //cout << b[bfix] << space << amax << space << a_optional_best << slashn;

        if (amax!=INT64_MIN) {  // т.е. что для а выбран хотя бы один подарок
            best_dif = min(best_dif, abs(b[bfix]-amax));
            if (a_optional_best!=INT64_MAX && a_optional_best > amax) {
                best_dif = min(best_dif, abs(b[bfix]-a_optional_best));
            }
        } else if (a_optional_best!=INT64_MAX) {
            best_dif = min(best_dif, abs(b[bfix]-a_optional_best));
        }
    }

    cout << best_dif << slashn;
*/


    return 0;
}