#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <bit>

using namespace std;

#define get_time() ((double)clock() / (double)CLOCKS_PER_SEC)

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

const int INF = 2e9;

int ans = INF;

void relax_ans2(int max_val, multiset<int>& must, int val) {
    if (!must.empty()) {
        val = max(val, *must.rbegin());
    }
    ans = min(ans, abs(max_val - val));
}

void relax_ans(int max_val, multiset<int>& vozm, multiset<int>& must) {
    auto it = vozm.lower_bound(max_val);
    if (it != vozm.end()) {
        relax_ans2(max_val, must, *it);
    }
    if (it != vozm.begin()) {
        --it;
        relax_ans2(max_val, must, *it);
    }
    if ((vozm.empty()) && (!must.empty())) {
        relax_ans2(max_val, must, -1);
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }

    map<int, vector<int>> index1;
    for (int i = 0; i < n; ++i) {
        index1[a[i]].push_back(i);
    }

    multiset<int> vozm;
    multiset<int> must;

    for (int i = 0; i < n; ++i) {
        must.insert(b[i]);
    }
    for (const auto& [max_val, v] : index1) {
        for (int ind : v) {
            must.erase(must.find(b[ind]));
            vozm.insert(b[ind]);
        }
        for (int ind : v) {
            vozm.erase(vozm.find(b[ind]));
            relax_ans(max_val, vozm, must);
            vozm.insert(b[ind]);
        }
    }
    cout << ans << '\n';
}