#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <vector>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC target("avx")
#pragma GCC target("avx2")

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;

mt19937 rnd(time(NULL));

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector
//#define endl '\n'
#define pb push_back
#define int long long

const int INF = 2e9 + 333, N = 1e9;

map<int, int> tree;

void upd(int i, int a) {
    i++;
    for (; i <= N; i += i & -i) tree[i] += a;
}

int get(int x) {
    int s = 0;
    x++;
    for (; x > 0; x -= x & -x) s += tree[x];
    return s;
}

void solve() {
    int n;
    cin >> n;
    vec<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        //if (a[i].first > a[i].second) swap(a[i].first, a[i].second);
    }
    sort(all(a));
    int ans = INF;
    multiset<int> st, st2;
    for (int i = 0; i < n; ++i) {
        st2.insert(a[i].second);
    }
    for (int i = 0; i < n; ++i) {
        st2.erase(st2.find(a[i].second));
        int res = 0;
        int c = -1;
        if (st2.size() > 0) {
            auto it = st2.end();
            it--;
            c = (*it);
            res = max(abs((*it) - a[i].first), res);
        }
        if ((int)st.size() > 0) {
            if (c == -1) {
                auto it = st.lower_bound(a[i].first);
                res = INF;
                if (it != st.end()) {
                    res = min(res, abs((*it) - a[i].first));
                }
                if (it != st.begin()) {
                    it--;
                    res = min(res, abs((*it) - a[i].first));
                    it++;
                }
            }
            else {
                auto it = st.lower_bound(a[i].first);
                if (it != st.end()) {
                    if ((*it) >= c) res = min(res, abs((*it) - a[i].first));
                }
                if (it != st.begin()) {
                    it--;
                    if ((*it) >= c) res = min(res, abs((*it) - a[i].first));
                    it++;
                }
            }
        }
        st.insert(a[i].second);
        ans = min(ans, res);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}