#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1337, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

#define int ll

int n;

void solve() {
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    vector<pair<int, int>> c;
    for (int i = 0; i < n; ++i) {
        c.emplace_back(a[i], b[i]);
    }
    sort(all(c), greater<>());
    auto check = [&](int m) -> bool {
        for (int i = 0; i < n; ++i) {
            bool f = true;
            int mx = 0;
            for (int j = i - 1; j >= 0; --j) {
                mx = max(mx, c[j].Y);
            }
            for (int j = i + 1; j < n; ++j) {
                if (abs(max(mx, c[j].Y) - c[i].X) <= m) {
                    mx = max(mx, c[j].Y);
                }
            }
            if (abs(mx - c[i].X) <= m) return true;
        }
        return false;
    };
    int l = -1, r = 1e9 + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        check(m) ? r = m : l = m;
    }
    cout << r;
}