#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 2e18;

ll AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA;

vector<ll> ans;

ll f(ll r, ll l) {
	return r * (r + 1) / 2 - l * (l + 1) / 2;
}

void rec(ll l, ll r, ll sum_trash, ll all_sum) {
	if (l + 1 == r) {
		ans.push_back(r);
		return;
	}
	ll mid = (l + r) / 2, cur;
	cout << "? " << mid << endl;
	cin >> cur;
	ll sum_segs = cur - sum_trash; // сумма левого отрезка
	if (sum_segs != f(mid, l)) {
		rec(l, mid, sum_trash, sum_segs);
	}
	ll sum_segs2;

	sum_segs2 = all_sum - sum_segs; // сумма праваого отрезка
	if (sum_segs2 != f(r, mid)) { // pref[r] - pref[mid]
		rec(mid, r, cur, sum_segs2);
	}
}

void solve() {
	ll n, k;
	cin >> n >> k;
	if (n == 1) {
		cout << "! 1" << endl;
		cin >> AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA;
		if (AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA == -1)
			exit(0);
		return;
	}
	ans.clear();
	ll sum;
	cout << "? " << n / 2 << endl;
	cin >> sum;
	rec(0, n / 2, 0, sum); 
	ll sum2;
	cout << "? " << n << endl;
	cin >> sum2;
	rec(n / 2, n, sum, sum2 - sum);
	cout << "! ";
	for (auto elem : ans) {
		cout << elem << " ";
	}
	cout << endl;
	cin >> AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA;
	if (AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA == -1)
		exit(0);
}

int main() {
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}

/*
5
10 4
5 4
3 4
1 4
7 4

*/