#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

#define LC(V) (2*(V)+1)
#define RC(V) (2*(V)+2)

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

map<ll, ll> cache;

ll query(ll p) {
    if (cache.find(p) != cache.end()) return cache[p];
    cout << "? " << p << endl;
    ll res;
    cin >> res;
    if (res == -1) exit(0);
    return cache[p] = res;
}

ll add = 0;

ll cont(ll p) {
    if (p == 0) return 0;
    ll res1 = query(p) + add;
    ll res2 = p * (p + 1) / 2;
    return res2 - res1;
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    ll t;
    cin >> t;
    while (t--) {
        add = 0;
        cache.clear();
        ll n, k;
        cin >> n >> k;
        vector<ll> ans;
        for (ll i = 0; i < k; i++) {
            ll l = ans.empty() ? 0 : ans.back(), r = n;
            while (r - l > 1) {
                ll p = (l + r) / 2;
                bool kek = cont(p);
                if (kek) r = p;
                else l = p;
            }
            ll e = r;
            ans.push_back(e);
            add += e;
        }
        cout << "! ";
        for (ll e: ans) cout << e << ' ';
        cout << endl;
        int result;
        cin >> result;
        if (result == -1) exit(0);
    }
}