#include <iostream>
#include<algorithm>
#include<bitset>
#include<cassert>
#include<cmath>
#include<complex>
#include<ctime>
#include<deque>
#include<iomanip>
#include<iterator>
#include<list>
#include<map>
#include<queue>
#include<random>
#include<set>
#include<string>
#include<tuple>
#include<unordered_map>
#include<unordered_set>
#include<vector>

#define int int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> p) {
    return in >> p.first >> p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
mt19937 rnd(time(NULL));
const int inf = 1e18, MAXN = 2e5+10, mod = 998244353, mod1 = (int)1e9+7, mod2 = 1e9+1011;
const long double eps = 1e-9;

void solve() {
    int n, k; cin >> n >> k;
    vector<int> res(k);
    map<int, int> mp;
    for (int i = 0; i<k; ++i) {
        int l = 0, r = n;
        while (l+1 < r) {
            int m = (l+r)/2;
            if (!mp.count(m)) {
                cout << "? " << m << endl;
                int sum; cin >> sum;
                mp[m] = sum;
            }
            int real_sum = (m+1)*m/2;
            for (int j = 0; j<i; ++j) {
                if (res[j] <= m) real_sum -= res[j];
            }
            if (mp[m] < real_sum) r = m;
            else l = m;
        }
        res[i] = r;
    }
    cout << "! ";
    for (auto elem : res) cout << elem << " ";
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; cin >> t;
    while (t--) solve();
    return 0;
}
