#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>

using namespace std;

int k;

int t;
int T = 0;

int cnt = 0;
vector<int> imposter;
vector<int> pref;

int ask(int x) {
    cout << '?' << ' ' << x << endl;
    int ans;
    cin >> ans;
    if (ans == -1) {
//        exit(0);
    }
    return ans;
}

void ans() {
    cout << '!' << ' ';
    for (auto i : imposter) {
        cout << i << ' ';
    }
    cout << endl;
    int ans;
    cin >> ans;
    if (ans == -1) {
//        exit(0);
    } else {
        if (T == t) {
            exit(0);
        }
    }
}

void print() {
    for (auto i : pref) {
        cout << i << ' ';
    }
    cout << '\n';
}

//[l; r) -- 0-index
void play(int l, int r) {
    if (cnt == k) {
        return;
    }
    if (r - l == 1) {
        if (pref[r] == 0) {
            pref[r] = ask(r);
//            print();
        }
        if (r != pref[r] - pref[l]) {
            imposter.push_back(r);
//            cout << "IMPOSTER!" << '\n';
        } else {
//            cout << "NORMAL!" << '\n';
        }
        return;
    }
    int waited = (l + r + 1) * (r - l) / 2;
//    cout << l << ' ' << r << ' ' << "waited: " << waited << '\n';
    if (pref[r] == 0) {
        pref[r] = ask(r);
//        print();
    }
    if (pref[r] - pref[l] == waited) {
        return;
    }
    int m = (l + r) / 2;
//    cout << "1st half" << '\n';
    play(l, m);
//    cout << "2nd half" << '\n';
    play(m, r);
}

void solve() {
    T++;
    int n;
    cin >> n >> k;
    pref.assign(n + 1, 0);
    play(0, n);
    ans();
    imposter.clear();
    pref.clear();
    cnt = 0;
}

int main() {
#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
