#include <bits/stdc++.h>

using namespace std;
#define int long long
const bool LOCAL = false;
vector <int> my_ans;
int n;

inline int ask(int x) {
    if (x == 0) return 0;
    if (LOCAL) {
        assert(x >= 1 && x <= n);
        int sum = 0;
        for (int i : my_ans) {
            if (i <= x) sum += i;
        }
        return sum;
    } else {
        assert(x >= 1 && x <= n);
        cout << "? " << x << endl;
        int ans;
        cin >> ans;
        if (ans == -1) exit(0);
        return x * (x + 1) / 2 - ans;
    }
}

vector <int> ans;

int make_ans(int ql, int qr, int k, int sum, bool ok, int pref_sum) {
    if (k == 1) {
        ans.push_back(sum);
        return 1;
    }
    if (!ok && sum <= n && ask(sum - 1) == pref_sum) {
        ans.push_back(sum);
        return 1;
    }
    if (sum == (ql + qr) * (qr - ql + 1) / 2) {
        for (int i = ql; i <= qr; ++i) ans.push_back(i);
        return qr - ql + 1;
    }
    int l = 0, r = k + 1, rs, pans;
    if (ok) {
        l = k;
        pans = ask((sum - 1) / k);
    }
    while (r - l > 1) {
        int m = (l + r) / 2;
        int q = (sum - 1) / m;
        if (q < ql) {
            r = m;
            continue;
        }
        if (q > qr) {
            l = m;
            continue;
        }
        rs = ask(q);
        if (rs == pref_sum) {
            r = m;
        } else {
            l = m;
            pans = rs;
            if (rs != pref_sum + sum) break;
        }
    }
    rs = pans;
    k = r - 1;
    int cnt_left = make_ans(ql, (sum - 1) / l, k, rs - pref_sum, false, pref_sum);
    return cnt_left + make_ans((sum - 1) / l + 1, qr, k - cnt_left, sum + pref_sum - rs, ok, rs);
}

inline void solve() {
    int k;
    cin >> n >> k;
    if (LOCAL) {
        my_ans.assign(k, 0);
        for (int i = 0; i < k; ++i) cin >> my_ans[i];
    }
    ans.clear();
    make_ans(1, n, k, ask(n), true, 0);
    cout << "! ";
    sort(ans.begin(), ans.end());
    for (int i : ans) cout << i << " ";
    cout << endl;
    if (!LOCAL) {
        int rs;
        cin >> rs;
        if (rs == -1) exit(0);
    }
}

signed main() {
    if (0) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        int t;
        cin >> t;
        while (t--) solve();
    }
    return 0;
}

/*

 */