#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3")

#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define INF (int) 1e18 / 2

using namespace std;

mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

void solve() {
	int n, k;
	cin >> n >> k;
	auto ask = [&](int x) {
		cout << "? " << x << endl;
		int res;
		cin >> res;
		return res;
	};

	if (n <= 1000) {
		vector<int> pref(n + 1);
		for (int i = n; i > 0; i -= 2)
			pref[i] = ask(i);
		for (int i = n; i - 2 >= 0; i -= 2) {
			int d = pref[i] - pref[i - 2];
			int need = i - 1 + i;
			if (d == need) {
				pref[i - 1] = pref[i - 2] + i - 1;
			} else if (d == i - 1) {
				pref[i - 1] = pref[i - 2] + i - 1;
			} else {
				pref[i - 1] = pref[i - 2];
			}
		}
		vector<int> res;
		for (int i = 1; i <= n; i++)
			if (pref[i] - pref[i - 1] != i)
				res.push_back(i);
		cout << "! ";
		for (int i: res) cout << i << " ";
		cout << endl;
		int tmp;
		cin >> tmp;
		assert(tmp != -1);
		return;
	}

	int last = 0;
	auto pref = [&](int l, int r) {
		return r * (r + 1) / 2 - l * (l + 1) / 2;
	};
	vector<int> res;
	int s = ask(n);
	auto go = [&](auto go, int l, int r, int left, int right) -> void {
		if (r - l == 1) return (void) (k--, res.push_back(r));
		int pos = l;
		int m = (l + r) / 2;
		int x = ask(m);
		if (x - left != pref(l, m)) go(go, l, m, left, x);
		if (right - x != pref(m, r)) go(go, m, r, x, right);
	};
	go(go, 0, n, 0, s);
	cout << "! ";
	for (int i: res) cout << i << " ";
	cout << endl;
	int tmp;
	cin >> tmp;
	assert(tmp != -1);
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(20);

	int tt = 1;
	cin >> tt;
	while (tt--)
		solve();
}