#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <random>
#include <chrono>

typedef long long ll;
typedef long double ld;

using namespace std;

const int MOD = 1e9 + 9;
const int MAXN = 5e5 + 1;

void solve() {
    int n, k;
    cin >> n >> k;
    int prev = 0;

    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        cout << "? " << i + 1 << endl;
        int a;
        cin >> a;

        if (a == -1) {
            exit(0);
        }

        if (a > prev) {
            prev = a;
        } else {
            ans.push_back(i + 1);
        }
    }

    cout << "! ";
    for (auto x : ans) {
        cout << x << ' ';
    }
    cout << endl;

}

int main() {
    //cin.tie(0)->sync_with_stdio(0);

    int T = 1;
    cin >> T;
    while (T --> 0) {
        solve();
    }

    return 0;
}
