#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

#ifdef CLOWN
void dbg(ll a) {cout << a << "\n";}
void dbg(int a) {cout << a << "\n";}
void dbg(string a) {cout << a << "\n";}
void dbg(ll a, ll b) {cout << a << " " << b << "\n";}
void dbg(int a, int b) {cout << a << " " << b << "\n";}
void dbg(ll a, ll b, ll c) {cout << a << " " << b << " " << c << "\n";}
void dbg(int a, int b, int c) {cout << a << " " << b << " " << c << "\n";}
void dbg(vector<ll> & a) {for (auto i : a) cout << i << " "; cout << "\n";}
void dbg(vector<int> & a) {for (auto i : a) cout << i << " "; cout << "\n";}
#else
#define dbg(...)
#endif

#define int ll
map<int, int> val;

int ask(int x) {
    if (val.find(x) != val.end()) return val[x];
    cout << "? " << x << endl;
    int y;
    cin >> y;
    val[x] = y;
    if (y == -1) assert(false);
    return y;
}

set<int> s;

int get(int l) {
    int sum = 0;
    for (auto i : s) sum += (i <= l ? i : 0);
    return sum;
}

void rec(int l, int r) {
    if (r - l + 1 == 1) {
        int v = ask(r) + get(r);
        if (v != r * (r + 1) / 2) {
            s.insert(l);
        }
        return;
    }
    if (r - l + 1 == 2) {
        int v = ask(r) + get(r);
        if (r * (r + 1) / 2 == v) return;
        if (r * (r + 1) / 2 - v == 2 * r - 1) {
            s.insert(l);
            s.insert(r);
        } else {
            s.insert((r * (r + 1) / 2 - v));
        }
        return;
    }
    int mid = (l + r) / 2;
    int v = ask(mid) + get(mid);
    if (v != mid * (mid + 1) / 2) {
        rec(l, mid);
    }
    int rig = ask(r) + get(r);
    if (rig != rig * (rig + 1) / 2) {
        rec(mid + 1, r);
    }

}
void solve() {
    val.clear();
    int n, k;
    cin >> n >> k;
    int cur = ask(n);
    int total = n * (n + 1) / 2;
    vector<int> path;
    if (n <= 1000) {
        int prev = 0, sum = 0;
        for (int i = 2; i <= n; i += 2) {
            int v = ask(i) + sum - prev;
            if (v != 2 * i - 1) {
                if (v == 0) {
                    path.push_back(i);
                    path.push_back(i - 1);
                    sum += i + i - 1;
                } else {
                    sum += 2 * i - 1 - v;
                    path.push_back(2 * i - 1 - v);
                }
            }
            prev = i * (i + 1) / 2;
        }
        if (path.size() != k) path.push_back(n);
    } else {
        rec(1, n);
//        int side = 0, sum = 0;
//        while (cur + sum != total) {
//            if (path.size() == k - 1) {
//                path.push_back(total - cur - sum);
//                break;
//            }
//            int l = side + 1, r = n;
//            while (l + 1 < r) {
//                int mid = (l + r) / 2;
//                int v = ask(mid);
//                if (v + sum != mid * (mid + 1) / 2) {
//                    r = mid;
//                } else {
//                    l = mid;
//                }
//            }
//            l = r;
//            int v = ask(l) + sum;
//            if (l * (l + 1) / 2 == v) break;
//            path.push_back(l);
//            sum += l;
//            side = l;
//        }
    }
    for (auto i : s) path.push_back(i);
    cout << "! ";
    for (auto i : path) cout << i << " ";
    cout << endl;
    int verdict;
    cin >> verdict;
    if (verdict == -1) assert(false);
}

int32_t main() {
#ifdef CLOWN
//    freopen("C://Users//olymp//CLionProjects//untitled//input.txt", "r", stdin);
//    freopen("C://Users//olymp//CLionProjects//untitled//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
