#include <bits/stdc++.h>
#include <unordered_map>
#include <unordered_set>

#define umap unordered_map
#define uset unordered_set

#define spc << ' ' <<
#define space << ' '
#define newl << '\n'
#define endl << endl

#define pb push_back
#define elif else if
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define repeat(a) for (int i31 = 0; i31 < a; ++i31)

using namespace std;
using str = string;
using ll = long long;
using vi = vector <int>;
using vl = vector <ll>;
using vvi = vector <vi>;
using vvl = vector <vl>;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

template <typename T>
istream& operator>>(istream& in, pair <T, T>& p) {
    in >> p.first >> p.second;
    return in;
}
template <typename T>
istream& operator>>(istream& in, vector <T>& a) {
    for (int i = 0; i < (int)a.size(); ++i) {
        in >> a[i];
    }
    return in;
}
template <typename T>
ostream& operator<<(ostream& out, pair <T, T>& p) {
    out << p.first << p.second;
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, vector <T>& a) {
    for (auto c : a) {
        out << c space;
    }
    return out;
}

const int INF = INT_MAX;
const ll LINF = LLONG_MAX;
const ll hash_power = 29;
const ll mod = 1e9 + 7;

void solve() {
    ll n, k, c;
    cin >> n >> k;

    vi ans;
    ans.reserve(k);
    if (n <= 1000) {
        vi rq(n + 1);
        for (int i = n; i > 0; i -= 2) {
            cout << '?' spc i endl;
            cin >> c;
            if (c == -1) exit(0);
            rq[i] = c;
        }

        for (int i = n; i > 0; i -= 2) {
            ll res = rq[i];
            if (i - 2 > 0) res -= rq[i - 2];

            if (res == 0) {
                ans.pb(i);
                if (i - 1 != 0) ans.pb(i - 1);
            }
            elif (res == i - 1) {
                ans.pb(i);
            }
            elif (res == i && i - 1 != 0) {
                ans.pb(i - 1);
            }
        }
    }
    else {
        ll tl = 0, w = 0;
        repeat(k) {
            ll l = tl, r = n;
            while (r - l > 1) {
                ll m = (l + r) / 2;

                ll need = (1 + m) * m / 2 - w;

                cout << '?' spc m endl;
                cin >> c;
                if (c == -1) exit(0);

                if (c == need) {
                    l = m;
                }
                else {
                    r = m;
                }
            }

            w += r;
            ans.pb(r);
            tl = r;
        }
    }
    cout << '!' spc ans endl;
    cin >> c;
    if (c == -1) exit(0);
}

void tests() {
    int t;
    cin >> t;
    for (int i = 1; i <= t; ++i) {
        solve();
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    tests();
}
