#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int inf = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 3e5 + 5;

ll ask(int i) {
    ll ret = 0;
    cout << "? " << i << endl;
    cin >> ret;
    return ret;
}

void answer(vector<int>& ans) {
    cout << "! " << ans << endl;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> ans;
    for (int i = n; i >= 1; i--) {
        ans.pb(ask(i));
    }
    ans.pb(0);
    vector<int> out;
    reverse(all(ans));
    for (int i = n; i > 0; i--) {
        if (ans[i - 1] == ans[i])out.pb(i);
    }

    answer(out);
}

int main() {
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}

