#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int MAXN = 1e3 + 5;
int la = -1, lo = -1, n, k, out[MAXN];
ll ans[MAXN];

ll ask(int i) {
    ll ret = 0;
    cout << "? " << i << endl;
    cin >> ret;
    return ret;
}

void answer() {
    cout << "! ";
    for (int i = 0; i < k; i++) {
        cout << out[i];
        if (i != k - 1)cout << " ";
    }
    cout << endl;
    int ok;
    cin >> ok;
}


void solve() {
    cin >> n >> k;
    la = lo = -1;
    for (int i = n; i >= 1 && lo + 1 < k; i--) {
        if (la != -1) {
            ll sum = ans[la];
            if (lo != -1 && out[lo] != i + 1)sum -= i + 1;
            if (sum < i) {
                out[++lo] = i;
                ans[la + 1] = ans[la];
                la++;
                continue;
            }
        }
        ll cur = ask(i);
        if (la != -1 && ans[la] == cur) {
            out[++lo] = i + 1;
        }
        ans[++la] = cur;
    }
    if (ans[la] == 0)out[++lo] = 1;
    answer();
}

int main() {
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
#else
    //    ios_base::sync_with_stdio(false);
    //    cin.tie(nullptr);
#endif
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
//cout << "______________\n";
#endif
    }
    return 0;
}

