#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

void solve() {
    int n, k;
    cin >> n >> k;

    map <int, ll> memory;

    vector <int> answer;
    auto query = [&] (int p) {
        ll result;

        if (memory.find(p) != memory.end()) {
            result = memory[p];
        } else {
            cout << "? " << p << endl;

            cin >> result;
            memory[p] = result;
        }

        for (int x: answer) {
            if (x <= p) {
                result += x;
            }
        }

        return result;
    };

    auto get_expected = [&] (ll p) {
        return p * (p + 1) / 2;
    };

    while (answer.size() < k) {
        int mid, l = 0, r = n;
        while (r - l > 1) {
            mid = (l + r) / 2;

            if (get_expected(mid) != query(mid)) {
                r = mid;
            } else {
                l = mid;
            }
        }

        answer.push_back(r);
    }


    cout << "! ";
    for (int x: answer)
        cout << x << ' ';
    cout << endl;

    int a;
    cin >> a;

    assert(a == 1);
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;

    while (t--)
    solve();
}
