#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
//#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 800, sq = 317;
constexpr uint64_t MOD = 1E9 + 7;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	uint32_t ans;
	Mod_int(uint64_t ans = 0) :ans(ans% MOD) {}
	Mod_int operator+ (const Mod_int& m) const
	{
		return ans + m.ans;
	}
	Mod_int operator+= (const Mod_int& m)
	{
		return *this = *this + m;
	}
	Mod_int operator- (const Mod_int& m) const
	{
		return int32_t(ans) - int32_t(m.ans) + int32_t(MOD);
	}
	Mod_int operator-= (const Mod_int& m)
	{
		return *this = *this - m;
	}
	Mod_int operator* (const Mod_int& m) const
	{
		return uint64_t(ans) * m.ans;
	}
	Mod_int operator*= (const Mod_int& m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			t *= t;
			step >>= 1;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int& m) const
	{
		return *this * m.step(MOD - 2);
	}
	Mod_int operator/= (const Mod_int& m)
	{
		return *this = *this / m;
	}
	bool operator== (const Mod_int& m) const
	{
		return ans == m.ans;
	}
};



int main()
{
	/*#ifdef _DEBUG
		freopen("input.txt", "r", stdin);
	#endif // _DEBUG*/
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	int t;
	cin >> t;
	while (t--)
	{
		int n, k;
		cin >> n >> k;
		if (n <= 1000)
		{
			int pred = 0;
			vector <int> ans;
			for (int i = 0; i < n; i++)
			{
				cout << "? " << i + 1 << endl;
				int sum;
				cin >> sum;
				if (sum == pred)
				{
					ans.push_back(i + 1);
				}
				pred = sum;
			}
			cout << "! ";
			for (int i = 0; i < ans.size(); i++)
			{
				cout << ans[i] << ' ';
			}
			cout << endl;
			int res;
			cin >> res;
		}
		else
		{
			vector <int> ans;
			int last = 0;
			int64_t last_n = 0;
			int64_t res;
			for (int i = 0; i < k; i++)
			{
				int l = last, r = n;
				while (r - l > 1)
				{
					int64_t mid = (l + r) / 2;
					cout << "? " << mid << endl;
					cin >> res;
					if (res == mid * (mid + 1) / 2 - last_n)
					{
						l = mid;
					}
					else
						r = mid;
				}
				ans.push_back(r);
				last = r;
				cout << "? " << r << endl;
				cin >> res;
				last_n = int64_t(r) * (r + 1) / 2 - res;
			}
			cout << "! ";
			for (int i = 0; i < ans.size(); i++)
			{
				cout << ans[i] << ' ';
			}
			cout << endl;
			int v;
			cin >> v;
		}
	}
}