#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cassert>
#include <cmath>

using namespace std;
typedef long long ll;
#define int long long

int ask(int p)
{
	if (p <= 0) return 0;
	cout << "? " << p << endl;
	int got;
	cin >> got;
	if (got == -1) exit(0);
	return got;
}

void ans(vector <int> fal)
{
	cout << "! ";
	for (auto i : fal) cout << i << ' ';
	cout << endl;
	int got;
	cin >> got;
	if (got == -1) exit(0);
}

vector <int> glob;

int ask(int l, int r)
{
	auto got = ask(r) - ask(l - 1);
	return got;
}

void solve(int l, int r)
{
	if (l == r)
	{
		glob.push_back(l);
		return;
	}
	int m = (l + r) >> 1;
	
	if (ask(l, m) < (l + m) * (m - l + 1) / 2) solve(l, m);
	if (ask(m + 1, r) < (r + m + 1) * (r - m) / 2) solve(m + 1, r);
}

inline void solve()
{
	int n, k;
	cin >> n >> k;

	glob.clear();
	solve(1, n);
	ans(glob);
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}					