#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <climits>
#include <deque>

using namespace std;

#define ll long long
#define lll __int128
#define ld long double
#define lld __float128
#define endl '\n'
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

struct interactor {
    ll ans(vector<ll> what) {
        cout << '!' << " ";
        for (int i = 0; i < what.size(); ++i) cout << what[i] << " ";
        cout.flush();
        ll res;
        cin >> res;
        return res;
    }

    ll ask(ll what) {
        cout << "!" << " " << what << endl;
        cout.flush();
        ll ans;
        cin >> ans;
        return ans;
    }
};

ll formulo(ll index) {
    return ((index + 1) * index) / 2;
}

void solve() {
    int n, m;
    cin >> n >> m;
    ll curleft = -1, badSum = 0;
    interactor ask;
    vector<ll> answers;
    for (int i = 0; i < m; ++i) {
        int l = curleft, r = n + 1;
        while (r - l > 1) {
            int mid = (r+l) / 2;
            ll needed = formulo(needed) - badSum;
            (needed == ask.ask(mid) ? l : r) == mid;
        }
        answers.push_back(l + 1);
        badSum += l + 1;
        curleft = l;
    }
    ask.ans(answers);
}

int main() {
    fast;
    srand((int)time(nullptr));
    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}