#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

#ifdef DESPAIR101
#include "debug.h"
#define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"
#else
#define dbg(x)
#endif

typedef long long ll;
typedef long double ld;

#define int ll
#define sz(x) int((x).size())

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

ll ask(int x) {
    cout << "?" << ' ' << x << endl;
    ll res;
    cin >> res;
    return res;
}

void answer(vector<int> ans) {
    cout << "!" << ' ';
    for (int x : ans) cout << x << ' ';
    cout << endl;

    int res;
    cin >> res;
    if (res == -1) {
        assert(false && "NASRAL");
    }
}

void solve() {
    int n, k;
    cin >> n >> k;

    if (n <= 1000) {
        vector<int> ans;
        for (int i = 2; i <= n; i += 2) {
            ll sus = ask(i);
            for (int x : ans) {
                if (x <= i) {
                    sus += x;
                }
            }
            if (sus != i * (i + 1) / 2) {
                int de = i * (i + 1) / 2 - sus;
                if (de == i - 1) {
                    ans.push_back(i - 1);
                } else if (de == i) {
                    ans.push_back(i);
                } else {
                    ans.push_back(i - 1);
                    ans.push_back(i);
                }
            }
        }
        if (n & 1) {
            ll sus = ask(n);
            for (int x : ans) {
                if (x <= n) {
                    sus += x;
                }
            }
            if (sus != n * (n + 1) / 2) {
                ans.push_back(n);
            }
        }
        answer(ans);
    } else {
        vector<int> ans ;
        for (int i = 0; i < k; ++i) {
            int l = 0, r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                ll sus = ask(m);
                for (int x : ans) {
                    if (x <= m) {
                        sus += x;
                    }
                }
                if (sus == m * (m + 1) / 2) {
                    l = m;
                } else {
                    r = m;
                }
            }
            ans.push_back(r);
        }
        answer(ans);
    }
}

int32_t main() {
    // ios::sync_with_stdio(false);
    // cin.tie(nullptr);

    int T = 1;
    cin >> T;

    while (T--) {
        solve();
    }
}