#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}


void solve() {
    int n;
    cin >> n;
    vector<ll> a(n), b(n);
    for (int i  =0; i < n; i++){
        cin >> a[i] >> b[i];
    }
    set<ll> had;
    set<pair<ll, ll>> probably_had;
    vector<pair<ll, pair<ll, ll>>> mine;
    for (int i = 0; i < n; i++) {
        mine.push_back({a[i], {-b[i], i}});
        probably_had.insert({b[i], i});
    }
    std::sort(mine.begin(), mine.end());
    ll ans = 1e9;
    for (int i = n - 1; i > -1; i--) {
        if (!had.empty() && *had.rbegin()) {
            ans = min(ans, *had.rbegin() - mine[i].first);
        }
        auto it = probably_had.upper_bound({mine[i].first, -100});
        if (it != probably_had.end()) {
            if (it->second == mine[i].second.second) {
                it++;
            }
        }
        if (it != probably_had.end()) {
            ans = min(ans, it->first - mine[i].first);
        }
        it = probably_had.upper_bound({mine[i].first, -100});
        if (it != probably_had.begin()) {
            it--;
            if (it->second == mine[i].second.second) {
                if (it != probably_had.begin()) {
                    it--;
                    ans = min(ans, mine[i].first - it->first);
                }
            } else {
                ans = min(ans, mine[i].first - it->first);
            }
        }
        had.insert(b[mine[i].second.second]);
    }
    cout << ans << "\n";
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
