#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 1e9;

std::set <int> s;
int cntQuestions;
inline llong getSum(int l, int r)
{
    return 1LL * (l + r) * (r - l + 1) / 2;
}

int n;
inline llong makeQuestion(int to)
{
    assert(to <= n);
    // cntQuestions++;
    // llong sum = getSum(1, to);
    // for (auto i : s)
    // {
    //     if (i <= to)
    //     {
    //         sum -= i;
    //     }
    // }

    // return sum;
    llong res;
    std::cout << "? " << to << std::endl;
    std::cin >> res;
    return res;
}

int searchL, searchR;
std::vector <int> listFake;
llong sumOfFake;
llong currFound;
llong currSum;
int k;

void reset()
{
    listFake.clear();
    sumOfFake = currFound = currSum = 0;
    searchL = searchR = 0;
}

int search()
{
    int l = searchL - 1, r = searchR, mid;
    while (l < r - 1)
    {
        llong currTry;
        mid = (l + r) / 2;
        currTry = makeQuestion(mid);
        currTry -= getSum(1, l - 1) - sumOfFake;
        currTry += currFound;

        if (currTry == getSum(l, mid)) l = mid;
        else r = mid;
    }

    searchL = r + 1;
    return r;
}

int tests;
void solve()
{
    int bucketSize = n / k;
    int l = 0, r = 0;
    while (listFake.size() < k)
    {
        l = r + 1;
        r += bucketSize;
        r = std::min(r, n);
        if (l > n)
        {
            break;
        }

        currSum = makeQuestion(r);
        currSum -= getSum(1, l - 1) - sumOfFake;
        currFound = 0; searchL = l; searchR = r;
        if (currSum == 0)
        {
            for (int i = l ; i <= r ; ++i)
            {
                sumOfFake += i;
                listFake.push_back(i);
            }

            continue;
        }

        if (currSum < l + l + 1)
        {
            for (int i = l ; i <= r ; ++i)
            {
                if (i == currSum) continue;
                listFake.push_back(i);
                sumOfFake += i;
            }

            continue;
        }

        while (currSum + l + (l + 1) <= getSum(l, r))
        {
            int curr = search();
            listFake.push_back(curr);
            currFound += curr;
            currSum += curr;
        }

        if (currSum != getSum(l, r))
        {
            listFake.push_back(getSum(l, r) - currSum);
            currFound += listFake.back();
        }
    
        sumOfFake += currFound;
    }

    std::cout << "!";
    for (const int &i : listFake)
    {
        std::cout << ' ' << i;
    }

    std::cout << std::endl;
    int res;
    std::cin >> res;
    // // std::cout << "!";
    // for (const int &i : listFake)
    // {
    //     if (!s.count(i))
    //     {
    //         std::cout << "WA\n";
    //         return;
    //     }
    //     // std::cout << ' ' << i;
    // }

    // std::cout << "OK\n";
    // return;
}

void input()
{
    std::cin >> n >> k;
    // for (int i = 1 ; i <= k ; ++i)
    // {
    //     int idx;
    //     do idx = rand()%n + 1;
    //     while (s.count(idx));
    //     // std::cin >> idx;
    //     s.insert(idx);
    //     // std::cout << "idx: " << idx << '\n';
    // }
}

int main()
{
    // srand(1);
    std::cin >> tests;

    while (tests--)
    {
        reset();
        input();
        solve();
    }

    std::cout << "cntquestions: " << cntQuestions << '\n';
    return 0;
}