#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pii pair<int,int>
#define pll pair<ll,ll>
#define ve vector
#define mpp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(x)          ((int)((x).size()))
#define all(x)          (x).begin(),(x).end()
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }
template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }

const bool debug = 0;

ve<int> bad;
inline ll sum(const int &x) {
    return x * 1ll * (x + 1) / 2ll;
}

ve<int> ans;
map<int,ll> cash;

inline ll ask(int pos) {
    if (!pos) {
        return 0;
    }
    if (cash.count(pos)) {
        ll res = cash[pos];
        for (const auto &x : ans) {
            if (x <= pos) {
                res += x;
            }
        }
        return res;
    }

    cout << "? " << pos << endl;
    fflush(stdout);

    ll res;

    if (!debug) {
        cin >> res;
        if (res == -1) {
            exit(0);
        }
    }
    else {
        res = sum(pos);
        for (const auto &x : bad) {
            if (x <= pos) {
                res -= x;
            }
        }
    }

    cash[pos] = res;

    for (const auto &x : ans) {
        if (x <= pos) {
            res += x;
        }
    }
    return res;
}

inline void solve() {
    int n, k;
    cin >> n >> k;

    if (debug) {
        bad.clear();
        bad.resize(k);
        for (auto &x : bad) cin >> x;
    }

    ans.clear();
    cash.clear();

    int last_found = 0;

    while (k--) {
        int l = last_found, r = n, m, F;
        while (l <= r) {
            m = l + r >> 1;
            if (ask(m) == sum(m)) {
                F = m, l = m + 1;
            }
            else {
                r = m - 1;
            }
        }
        ans.pb(F + 1);
        last_found = F + 1;
    }

    cout << "! ";
    for (auto &x : ans) cout << x << " ";
    cout << endl;
    fflush(stdout);

    int res;
    cin >> res;
    if (res == -1) exit(0);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; cin >> q;
    while (q--) solve();
}
