#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>

#pragma warning(disable: 4996)

typedef long long ll;
typedef long double ld;

using namespace std;

#define vec vector
#define pii pair<int, int>
#define pll pair<ll, ll>
#define int ll

ll const mod = 1e9 + 7;
ll const INF = 2e9;
ll const LINF = 4e18;
ll const mod1 = 1000575179;

map<int, int> mem;

ll ask(ll x) {
    if (mem[x]) {
        return mem[x];
    }
    cout << "? " << x << endl;
    ll ans; cin >> ans;
    mem[x] = ans;
    return ans;
}

ll bp(ll l, ll r, ll minus) {
    while (l + 1 < r) {
        ll m = (l + r) / 2;
        ll x = ask(m);
        if (x == (1 + m) * m / 2 - minus) {
            l = m;
        }
        else {
            r = m;
        }
    }
    return ((ask(l) == (1 + l) * l / 2 - minus) ? r : l);
}

void solve() {
    int n, k; cin >> n >> k;
    vec<int> res;
    mem.clear();
    if (n == 1) {
        if (k == 1) {
            cout << "! 1" << endl;
        }
        int x; cin >> x;
        return;
    }

    if (n <= 1100) {
        int now = 2;
        ll total = 3;
        while (now <= n) {
            cout << "? " << now << endl;
            ll ans; cin >> ans;
            if (ans != total) {
                if (total - ans >= now) {
                    total -= now;
                    res.push_back(now);
                }
                if (total - ans >= now - 1) {
                    total -= now - 1;
                    res.push_back(now - 1);
                }
            }
            if (now + 1 == n) {
                total += now + 1;
                now += 1;
            }
            else {
                total += 2 * now + 3;
                now += 2;
            }
        }
        cout << "! ";
        for (auto elem : res) {
            cout << elem << " ";
        }
        cout << endl;
        int x; cin >> x;
    }
    ll l = 1, r = n, minus = 0;
    while (res.size() != k) {
        ll x = bp(l, r, minus);
        res.push_back(x);
        minus += x;
        l = x + 1;
    }
    cout << "! ";
    for (auto elem : res) {
        cout << elem << " ";
    }
    cout << endl;
    int x; cin >> x;
    return;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    //#ifdef _DEBUG
    //    freopen("input.txt", "r", stdin);
    //#endif // _DEBUG

    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}