#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e9 + 2;

set<int> ufo;

int request(int p) {
    if (p <= 0) return 1;
    cout << "? " << p << endl;
    int s;
    cin >> s;
    for (int i : ufo) s += (i <= p) * i;
    return s == ((p + 1) * p / 2);
}

void solve() {
    ufo.clear();
    int n, k;
    cin >> n >> k;
    while (k--) {
        int l = 0, r = n + 1;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (request(mid)) l = mid;
            else r = mid;
        }
        ufo.insert(r);
    }
    cout << "! ";
    for (int i : ufo) cout << i << " ";
    cout << endl;
    int a;
    cin >> a;
    if (a == -1) exit(0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) solve();
}