#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 2;

set<int> ufo;
//set<int> to_find;
map<int, long long> mem;
int CNT = 0;

long long request(int p) {
    if (p <= 0) return 1;
    long long s = (long long)(p + 1) * p / 2;
    if (mem[p] != 0) {
        s = mem[p] - 1;
    }
    else {
        cout << "? " << p << endl;
//        for (int i : to_find) s -= (i * (i <= p));
        cin >> s;
        mem[p] = s + 1;
        CNT++;
    }
    for (int i : ufo) s += (i <= p) * i;
    return s;
}

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    mem.clear();
    CNT = 0;
    ufo.clear();// to_find.clear();
    int n = 1000, k = 100;
    cin >> n >> k;
    int last = 0;
    while (k--) {
        int l = last, r = n + 1;
        while (l + 1 < r) {
            long long mid = (long long)(l + r) / 2;
            long long s = request(mid);
            if (s == (mid + 1) * mid / 2) l = mid;
            else {
                r = min(mid, (long long)(mid * (mid + 1) / 2 - s));
            }
        }
        last = r;
        ufo.insert(r);
    }
    cout << "! ";
    for (int i : ufo) cout << i << " ";
    cout << endl;
    int a = 1;
    cin >> a;
    if (a == -1) exit(0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) solve();
}