#include <bits/stdc++.h>

using namespace std;
#define eb emplace_back

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

//int asked = 0;
map<int, ll> s;

void ask(int p) {
    if (s.find(p) != s.end())
        return;
    cout << "? " << p << endl;
    cin >> s[p];
    if (s[p] == -1)
        exit(0);
}

ll askSum(int l, int r) {
    l--;
    if (l)
        ask(l);
    ask(r);
    if (l)
        return s[r] - s[l];
    return(s[r]);
}

ll calcSum(int l, int r) {
    return ((ll)r + (ll)l) * ((ll)r - (ll)l + 1) / 2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    s.clear();
    unordered_set<int> answer;
    set<ii> q;
    q.insert({1, n});
    while (answer.size() < k && !q.empty()) {
        ii qu = *q.begin();
        q.erase(q.begin());
        int m = (qu.first + qu.second) / 2;
        // left:
        ll askedSum = askSum(qu.first, m), calculatedSum = calcSum(qu.first, m);
        ll diff = calculatedSum - askedSum;
//        cerr << diff << '\n';
        if (diff || askedSum == 0) {
            ll lv = (diff % 2 ? diff / 2 : diff / 2 - 1);
            if (lv < qu.first && diff <= m) {
                answer.insert(diff);
                if (answer.size() == k)
                    break;
            } else {
                q.insert({qu.first, m});
            }
        }
        // right:
        askedSum = askSum(m + 1, qu.second), calculatedSum = calcSum(m + 1, qu.second);
        diff = calculatedSum - askedSum;
//        cerr << diff << '\n';
        if (diff || !askedSum) {
            ll lv = (diff % 2 ? diff / 2 : diff / 2 - 1);
            if (lv <= m && diff <= qu.second) {
                answer.insert(diff);
            } else {
                q.insert({m + 1, qu.second});
            }
        }
//        for (int i : answer)
//            cout << i << ' ';
//        cout << endl;
    }
    cout << "! ";
    for (int i : answer)
        cout << i << ' ';
    cout << endl;
    int a;
    cin >> a;
    if (a == -1)
        exit(0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tests = 1;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}