#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <limits>
#include <string>
#include <vector>
#include <climits>

#define sz(a) int((int)a.size())

//#define int long long

using namespace std;

vector<int> ans;

bool print_ans() {
    cout << "! ";
    for (auto el : ans) {
        cout << el << ' ';
    }
    cout << endl;
    int a;
    cin >> a;
    return a == 1;
}

long long get_res(int r) {
    cout << "? " << r << endl;
    long long x;
    cin >> x;
    return x;
}

bool good(int m) {
    long long supposed = m * (m + 1) / 2; // Переполнение???
    long long have = get_res(m);
    for (auto el : ans) {
        if (el <= m) {
            have += el;
        }
    }
    return supposed == have;
}

void solve() {
    ans.clear();
    int n, k;
    cin >> n >> k;
    while (ans.size() < k) {
        int l = 0, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (good(m)) {
                l = m;
            } else {
                r = m;
            }
        }
        ans.push_back(r);
    }
    if (!print_ans()) {
        exit(0);
    }
}

int32_t main() {
    //freopen("input.txt", "r", stdin);
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t-->0) {
        solve();
    }
    return 0;
}