#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <random>

using namespace std;

#define ll long long

map<int, ll> mp;

ll ask(int r) {
	//cout << r << ' ';
	if (r <= 0) return 0;
	if (mp.find(r) != mp.end()) return mp[r];
	cout << "? " << r << endl;
	ll ret;
	cin >> ret;
	if (ret == -1) exit(0);
	mp[r] = ret;
	return ret;
}

ll cor(int r) {
	if (r <= 0) return 0;
	return ((r + 1) * 1ll * r) / 2;
}

int bp(int l, int r) {
	int m;
	ll sm = ask(l), smn, cursm;
	ll pr = cor(l);
	while (r - l > 1) {
		m = (l + r) / 2;
		
		smn = ask(m) - sm;
		cursm = cor(m) - pr;
		//cout << m << ' ' << smn << ' ' << cursm << "\n";

		if (smn != cursm) r = m;
		else l = m;
	}
	return r;
}

int main() {


	int t;
	cin >> t;
	while (t--) {
		mp.clear();
		int n, k;
		cin >> n >> k;
		if (k == 3) {


			int l = 0;
			vector<int> ans;
			for (int i = 0; i < 1; i++) {
				ans.push_back(bp(l, n));
				l = ans.back();
			}

			int x = ans[0];

			ll s = cor(n) - ask(n) - x;
			int ind = s / 2;
			ll gt = ask(ind);

			ans.push_back(cor(ind) - gt - x);
			ans.push_back(s - ans[1]);
			cout << "! ";
			for (int v : ans) cout << v << ' ';
			cout << endl;
			int a;
			cin >> a;
			if (a == -1) exit(0);
		}
		else {
			int l = 0;
			vector<int> ans;
			for (int i = 0; i < k - 1; i++) {
				ans.push_back(bp(l, n));
				l = ans.back();
			}
			ll sm = 0;
			for (int v : ans) sm += v;
			ans.push_back(cor(n) - ask(n) - sm - 1);
			cout << "! ";
			for (int v : ans) cout << v << ' ';
			cout << endl;
			int a;
			cin >> a;
			if (a == -1) exit(0);
		}
	}




	return 0;
}