#include <bits/stdc++.h>

#define int long long

using namespace std;

int ask(int i) {
    cout << "? " << i << endl;
    int res;
    cin >> res;
    cout.flush();
    return res;
}

void say(vector<int> &a) {
    cout << "! ";
    for (auto el: a)
        cout << el << ' ';
    cout << endl;
    cout.flush();
}

int segsum(int l, int r) {
    int res = r * (r + 1) / 2;
    res -= l * (l - 1) / 2;
    return res;
}

vector<int> prefsum;
int pre = 0, curbeg = 0;

int spid(int l, int r) {
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (prefsum[m] == -1)
            prefsum[m] = ask(m);
        if (prefsum[m] == pre + segsum(curbeg, m))
            l = m;
        else
            r = m;
    }
    return l;
}

void solve() {
    pre = 0, curbeg = 0;
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    prefsum.assign(n + 1, -1);
    prefsum[0] = 0;
    while (ans.size() != k) {
        int tmp = spid(curbeg, n + 1);
        ++tmp;
        while (ans.size() < k) {
            if (prefsum[tmp] == -1)
                prefsum[tmp] = ask(tmp);
            if (prefsum[tmp - 1] == -1)
                prefsum[tmp - 1] = ask(tmp - 1);
            if (prefsum[tmp] - prefsum[tmp - 1] == tmp)
                break;
            ans.push_back(tmp++);
        }
        curbeg = tmp;
        pre = prefsum[tmp - 1];
    }
    say(ans);
    int tmp;
    cin >> tmp;
    cout.flush();
}

signed main() {
    int tc;
    cin >> tc;
    while (tc--)
        solve();
}