#include <bits/stdc++.h>

using namespace std;

int ask(int p) {
    cout << '?' << ' ' << p << endl;
    int x;
    cin >> x;
    return x;
}

unordered_map<int, int> t;

void update(int v, int l, int r, int p, int x) {
    if (l == r) {
        t[v] = x;
        return;
    }
    int mid = (l + r) / 2;
    if (p <= mid)
        update(v * 2, l, mid, p, x);
    else
        update(v * 2 + 1, mid + 1, r, p, x);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int get_sum(int v, int l, int r, int tl, int tr) {
    if (l >= tl && r <= tr)
        return t[v];
    int mid = (l + r) / 2;
    if (tr <= mid)
        return get_sum(v * 2, l, mid, tl, tr);
    if (tl > mid)
        return get_sum(v * 2 + 1, mid + 1, r, tl, tr);
    return get_sum(v * 2, l, mid, tl, mid) + get_sum(v * 2 + 1, mid + 1, r, mid + 1, tr);
}

void solve() {
    t.clear();
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    map<int, int> p;
    for (int i = 1; i <= k; i++) {
        int l = 1, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2, s = 0;
            if (p.find(m) != p.end()) {
                s = p[m];
            } else {
                s = ask(m);
                p[m] = s;
            }
            s += get_sum(1, 1, (int) 1e9 + 1, 1, m);
            if (l > 1) {
                if (p.find(l - 1) != p.end()) {
                    s -= p[l - 1];
                }else {
                    p[l - 1] = ask(l - 1);
                    s -= p[l - 1];
                }
                s -= get_sum(1, 1, (int) 1e9 + 1, 1, l - 1);
            }
            if (s != ((m + l) * (m - l + 1)) / 2)
                r = m;
            else
                l = m;
        }
        int m = l, s = 0;
        if (p.find(m) != p.end()) {
            s = p[m];
        } else {
            s = ask(m);
            p[m] = s;
        }
        s += get_sum(1, 1, (int) 1e9 + 1, 1, m);
        if (l > 1) {
            if (p.find(l - 1) != p.end()) {
                s -= p[l - 1];
            }else {
                p[l - 1] = ask(l - 1);
                s -= p[l - 1];
            }
            s -= get_sum(1, 1, (int) 1e9 + 1, 1, l - 1);
        }
        int pos;
        if (s != (m + l) * (m - l + 1) / 2)
            pos = l;
        else
            pos = r;
        update(1, 1, (int) 1e9 + 1, pos, pos);
        ans.emplace_back(pos);
    }
    cout << '!';
    for (int i = 0; i < (ans.size()); i++)
        cout << ' ' << ans[i];
    cout << endl;
}

int main() {
    int test;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}