#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3,inline,unroll-loops")
//#pragma GCC target("avx2,sse,sse2,popcnt")
using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define ll long long
#define ld long double
#define pt pair<int, int>
#define fi first
#define x first
#define se second
#define y second
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
///=================================================///
const int MX = 3e5 + 100;
const int INF = 2e9;
const int MOD = 1e9 + 7;
///=================================================///
int get(int p) {
    cout << "? " << p << endl;
    int x; cin >> x;
    if (x == -1) {
        assert(0);
    }
    return x;
}

int f(int p) {
    return p * (p + 1) / 2;
}

int n, k;

void solve() {
    cin >> n >> k;
    set<int> q;
    if (n <= 1000) {
        vector<int> v = {0};
        v.push_back(get(n));
        q.insert(n);
        for (int i = 0; i < min(n - 1, 599ll); i++) {
            int x = rnd() % n + 1;
            while (q.find(x) != q.end()) {
                x = rnd() % n + 1;
            }
            q.insert(x);
            v.push_back(get(x));
        }
        sort(all(v));
        vector<int> res;
        for (int i = 0; i < sz(v) - 1; i++) {
            if (v[i + 1] != v[i] || (i == 0 && v[0] == 0 && v[1] == 0)) {
                res.push_back(v[i + 1] - v[i] + 1);
            }
        }
        sort(all(v));
        cout << "! ";
        for (int x : res) cout << x << " ";
        cout << endl;
        int ans; cin >> ans;
        if (ans == -1) assert(0);
        return;
    }


    vector<int> res;
    int sum_bad = 0;
    int L = 0, R = n; // L - good -> R - bad;
    for (int i = 0; i < k; i++) {
        int l = L, r = R;
        while (r - l > 1) {
            int m = (l + r) / 2;
            int gt = get(m);
            if (f(m) == gt + sum_bad) {
                l = m;
            } else {
                r = m;
            }
        }
        res.push_back(r);
        sum_bad += r;
        L = r;
    }
    cout << "! ";
    for (int x : res) cout << x << " ";
    cout << endl;
    int ans; cin >> ans;
    if (ans == -1) assert(0);
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(0); cin.tie();
#endif
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
#endif
    int tests = 1;
    cin >> tests;
    ld starts = clock();
    while (tests--) solve();
    ld endd = clock();
#ifdef LOCAL
    cout << "\nEND: " << (endd - starts) / (ld)(CLOCKS_PER_SEC) << " sec\n";
#endif
    return 0;
}