#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

vector<ll> ans;
ll n, k;
map<ll, ll> save;

ll get(ll len) {
    if (len == 0) {
        return 0;
    }
    if (save.find(len) != save.end()) {
        return save[len];
    }
    cout << "? " << len << endl;
    ll x;
    cin >> x;
    if (x == -1) {
        exit(-1);
    }

    save[len] = x;
    return x;
}

ll sum(ll n) {
    return n * (n + 1) / 2;
}

ll sum(ll l, ll r) {
    return sum(r) - sum(l - 1);
}

mt19937 rnd;
ll get_rand(ll l, ll r) {
    return l + rnd() % (r - l + 1);
}

ll check(ll l, ll r) {
    if (ans.size() == k) {
        return 0;
    }
    if (l > r) {
        return 0;
    }


    ll m = (l + r) / 2;

    ll w = get(m) - get(l - 1);

    if (l == r) {
        if (w == 0) {
            ans.push_back(l);
            return l;
        }

        return 0;
    }

    ll fnd = 0;
    if (w == sum(l, m)) {
        fnd += check(m + 1, r);
    } else {
        fnd += check(l, m);
        if (w + fnd != sum(l, m)) {
            check(m + 1, r);
        }
    }
    return fnd;
}

void solve() {
    cin >> n >> k;
    save.clear();
    ans.clear();

    check(1, n);
    cout << "! ";
    for (auto x : ans) {
        cout << x << " ";
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t;
    cin >> t;
    while (t--) {
        solve();
        ll res;
        cin >> res;
        if (res == -1) {
            exit(0);
        }
    }

    return 0;
}