#include <bits/stdc++.h>
using namespace std;

int n, k;
long long delta;
vector<int> pos;
map<int, long long> queries;

long long ask(int p) {
    if (queries.count(p)) {
        return queries[p];
    }
    cout << "? " << p << endl;
    long long r;
    cin >> r;
    if (r == -1) {
        exit(0);
    }
    queries[p] = r;
    return r;
}

void answer() {
    cout << "!";
    for (int v : pos) {
        cout << " " << v;
    }
    cout << endl;
    int r;
    cin >> r;
    if (r == -1) {
        exit(0);
    }
}

struct search_tree {
    int L, R;
    search_tree* left = nullptr;
    search_tree* right = nullptr;
    long long value = -1;

    search_tree(int L, int R) : L(L), R(R) {}

    bool saturated() {
        if (k == 0) {
            return true;
        }
        if (value == -1) {
            value = ask(min(R, n));
        }
        return value + delta == 1ll * min(R, n) * (min(R, n) + 1) / 2;
    }

    void search() {
        int mid = (L + R) / 2;
        if (!saturated()) {
            if (R - L == 1) {
                delta += R;
                k--;
                pos.push_back(R);
                return;
            }
            left = new search_tree(L, mid);
            left->search();
        }
        if (!saturated()) {
            right = new search_tree(mid, R);
            right->search();
        }
    }
};

int main() {
    int t;
    cin >> t;
    while (t--) {
        delta = 0;
        queries = map<int, long long>();
        cin >> n >> k;
        search_tree tree(0, 2 << __lg(n));
        tree.search();
        answer();
        pos = vector<int>();
    }
}