#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cassert>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;

using ll = long long;
using ld = long double;

const int INT_INF = 2e9 + 10;
const ll LL_INF = 2e18 + 10;

template<typename T> istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

ll req(ll i) {
    cout << "? " << i << endl;
    ll res;
    cin >> res;
    assert(res != -1);
    return res;
}

void answer(const vector<int>& ans) {
    cout << "! ";
    for (auto i : ans) {
        cout << i << ' ';
    }
    cout << endl;
    int res;
    cin >> res;
    assert(res == 1);
}

int main() {
    int t_num;
    cin >> t_num;
    while (t_num--) {
        int n, k;
        cin >> n >> k;
        ll sum = 0;
        vector<int> ans;
        while (k--) {
            ll L = 0, R = n;
            while (R - L > 1) {
                ll M = (L + R) / 2;
                if (req(M) == (1 + M) * M / 2 - sum) {
                    L = M;
                } else {
                    R = M;
                }
            }
            ans.push_back(R);
            sum += R;
        }
        answer(ans);
    }
}
