#include <bits/stdc++.h>
using namespace std;

#define int long long

void solve1(int n, int k) {
    cout << "? " << n << endl;
    int a;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    cout << "! " << n * (n + 1) / 2 - a << endl;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
}

void solve2(int n, int k) {
    cout << "? " << n << endl;
    int a;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    int sum = n * (n + 1) / 2 - a;
    int l = (n * (n + 1) / 2 - a) / 2;
    cout << "? " << l << endl;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    cout << "! " << l * (l + 1) / 2 - a << ' ';
    cout << sum - l * (l + 1) / 2 + a << endl;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
}

void solve3(int n, int k) {
    int m, last = 0;
    vector<int> ans;

    int l = 1, r = n;
    while (l < r) {
        int mid = (l + r) / 2;
        int a;
        cout << "? " << mid << endl;
        cin >> a;
        if (a == -1) {
            exit(0);
        }
        for (auto j : ans) {
            if (j <= mid) {
                a += j;
            }
        }
        if (a == mid * (mid + 1) / 2) {
            l = mid + 1;
        } else if (mid * (mid + 1) / 2 - a < 2 * last + 3) {
            l = r = mid * (mid + 1) / 2 - a;
            break;
        } else {
            r = mid;
        }
    }
    ans.push_back(l);
    cout << "? " << n << endl;
    int a;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    a += l;
    int sum = n * (n + 1) / 2 - a;
    r = sum / 2;
    cout << "? " << r << endl;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    a += l;
    ans.push_back(r * (r + 1) / 2 - a);
    ans.push_back(sum - (r * (r + 1) / 2 - a));

    cout << "! ";
    for (auto j : ans) {
        cout << j << ' ';
    }
    cout << endl;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
}

void solve4(int n, int k) {
    int m, last = 0;
    vector<int> ans;

    int l = 1, r = n;
    while (l < r) {
        int mid = (l + r) / 2;
        int a;
        cout << "? " << mid << endl;
        cin >> a;
        if (a == -1) {
            exit(0);
        }
        for (auto j : ans) {
            if (j <= mid) {
                a += j;
            }
        }
        if (a == mid * (mid + 1) / 2) {
            l = mid + 1;
        } else if (mid * (mid + 1) / 2 - a < 2 * last + 3) {
            l = r = mid * (mid + 1) / 2 - a;
            break;
        } else {
            r = mid;
        }
    }
    ans.push_back(l);
    cout << "? " << n << endl;
    int a;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    a += l;
    int sum = n * (n + 1) / 2 - a;

    r = sum / 3;
    cout << "? " << r << endl;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    if (l <= r) {
        a += l;
    }
    int suml = r * (r + 1) / 2 - a;
    int sumr = sum - suml;

    cout << "? " << suml / 2 << endl;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    if (l <= suml / 2) {
        a += l;
    }
    if (a == (suml / 2) * (suml / 2 + 1) / 2) {
        ans.push_back(suml);
        r = sumr / 2;
        cout << "? " << r << endl;
        cin >> a;
        if (a == -1) {
            exit(0);
        }
        a += l + suml;
        ans.push_back(r * (r + 1) / 2 - a);
        ans.push_back(sumr - (r * (r + 1) / 2 - a));
    } else {
        ans.push_back(sumr);
        r = suml / 2;
        cout << "? " << r << endl;
        cin >> a;
        if (a == -1) {
            exit(0);
        }
        a += l;
        ans.push_back(r * (r + 1) / 2 - a);
        ans.push_back(suml - (r * (r + 1) / 2 - a));
    }

    cout << "! ";
    for (auto j : ans) {
        cout << j << ' ';
    }
    cout << endl;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
}

void solve() {
    int n, m = 0, k, last = 0;
    vector<int> ans;
    map<int, int> mp;

    cin >> n >> k;
    if (k == 3) {
        solve3(n, k);
        return;
    }
    if (k == 4) {
        solve4(n, k);
        return;
    }
    cout << "? " << n << endl;
    int a;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    int sum = n * (n + 1) / 2 - a;
    for (int i = 0; i < k - 1; i++) {
        int l = 1, r = n;
        while (l < r) {
            int mid = (l + r) / 2;
            int a;
            if (mp[mid]) {
                a = mp[mid] - 1;
            } else {
                cout << "? " << mid << endl;
                cin >> a;
                if (a == -1) {
                    exit(0);
                }
                mp[mid] = a + 1;
            }
//            for (auto j : ans) {
//                if (j <= mid) {
//                    a += j;
//                }
//            }
            int m = sum - (mid * (mid + 1) / 2 - a);
            for (auto j : ans) {
                if (j > mid) {
                    m -= j;
                }
            }
            cout << "m = " << m << '\n';
            if (m == 0) {
                r = mid;
            } else if (m < 2 * mid + 3) {
                l = r = m;
                break;
            } else {
                l = mid + 1;
            }
            cout << "    " << l << ' ' << r << '\n';
        }
//        cout << "l = " << l << '\n';
        ans.push_back(l);
        m += l;
        last = l;
    }
    for (auto j : ans) {
        sum -= j;
    }
    ans.push_back(sum);

    cout << "! ";
    for (auto j : ans) {
        cout << j << ' ';
    }
    cout << endl;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
}

signed main() {
    int t;

    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
