#include <iostream>
#include <vector>
#include <string>
#include <tuple>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif


template<typename T>
istream &operator>>(istream &in, pair<T, T> &p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &value: v) {
        in >> value;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (T &value: v) {
        out << value << " ";
    }
    return out;
}

vector<int> ans;
int k;


long long find(int L, int R, long long find_, long long lfound) {
    if (L + 1 == R) {
        ans.push_back(L);
        return L;
    }
    int c = (L + R) / 2;
    cout << "? " << c - 1 << endl;
    long long a;
    cin >> a;
    if (a < 0) {
        return -1;
    }
    long long l1 = 0;
    long long d = ((c - 1) * c / 2) - (a + lfound);
    if (d) {
        l1 = find(L, c, d, lfound);
        if (l1 < 0) {
            return -1;
        }
    }
    long long l2 = 0;
    d = find_ - l1;
    if (find_ != -1 && d) {
        l2 = find(c, R, d, lfound + l1);
    } else if (find_ == -1 && ans.size() != k) {
        l2 = find(c, R, -1, lfound + l1);
    }
    if (l2 < 0) {
        return -1;
    }
    return l1 + l2;
}

long long solve() {
    int n;
    cin >> n >> k;
    if (find(1, n + 1, -1, 0) < 0) {
        return -1;
    }
    cout << "! " << ans << endl;
    ans.clear();
    long long a;
    cin >> a;
    return a;
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    loop(t) {
        if (solve() < 0) {
            return 0;
        }
    }
}