#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"

using namespace std;

typedef long long ll;
const ll MOD = 1e9 + 7;

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    //freopen("input", "r", stdin);
#endif
    ll t = 1;
    cin >> t;
    while (t--)
        solve();
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    vector<int> pr{0};
    for (int i = 0; i < k; i++) {
        int l = 0, r = n;
        while (r - l > 1) {
            int to = (r + l) / 2;
            cout << '?' << to << endl;
            ll s;
            cin >> s;
            if (s < (to + 1) * (to) / 2 - pr[lower_bound(ans.begin(), ans.end(), to + 1) - ans.begin()])
                r = to;
            else
                l = to;
        }
        ans.push_back(r);
        pr.push_back(pr.back() + r);
    }
    cout << "! ";
    for (int i: ans)
        cout << i << ' ';
    cout << endl;
}