#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"

using namespace std;

typedef long long ll;
typedef long double ld;
const ll MOD = 1e9 + 7;

bool solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    //freopen("input", "r", stdin);
#endif
    ll t = 1;
    cin >> t;
    while (t--) {
        if (solve())
            return 0;
    }
}

void find(int l, int r, vector<int> &ans, vector<int> &pr) {
    int to = (r + l) / 2;
    cout << "? " << to << endl;
    ll s;
    cin >> s;
    if (s < (to + 1) * (to) / 2 - pr[lower_bound(ans.begin(), ans.end(), to + 1) - ans.begin()]) {
        find(l, to, ans, pr);
    }
    cout << "? " << r << endl;
    cin >> s;
    if (s < (r + 1) * (r) / 2 - pr[lower_bound(ans.begin(), ans.end(), r + 1) - ans.begin()]) {
        find(to + 1, r, ans, pr);
    }
}

bool solve() {
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    vector<int> pr{0};
    find(1, n, ans, pr);
    cout << "! ";
    for (int i: ans)
        cout << i << ' ';
    cout << endl;
    cin >> k;
    if (k == -1) {
        return 1;
    }
    return 0;
}