#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<stack>
#include<queue>
#include<deque>
#include<cmath>
#include<iomanip>
#include<algorithm>
#include<unordered_map>
#include<unordered_set>
using namespace std;

long long mod1 = 998'244'353ll, mod2 = 1'000'000'000ll;
vector<long long> pows_113, pows_119;
void calc() {
    pows_113.resize(100000);
    pows_119.resize(100000);

    pows_113[0] = pows_119[0] = 1;
    for (int i = 0; i < 100000; i++) {
        pows_113[i] = pows_113[i - 1] * 113 % mod1;
        pows_119[i] = pows_119[i - 1] * 119 % mod2;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    calc();

    int n, m;
    cin >> n >> m;

    string t;
    cin >> t;

    vector<vector<pair<long long, long long>>> hasht(t.size());
    for (int i = 0; i < t.size(); i++) {
        hasht[i].resize((int)t.size() - i);
        hasht[i][0].first = t[i];
        hasht[i][0].second = t[i];
        for (int j = i + 1; j < t.size(); j++) {
            hasht[i][j - i].first = (t[j] + hasht[i][j - i - 1].first * 113) % mod1;
            hasht[i][j - i].second = (t[j] + hasht[i][j - i - 1].second * 119) % mod2;
        }
    }

    vector<string> v(n);
    vector<pair<long long, long long>> hashstr(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];

        hashstr[i].first = v[i][0];
        hashstr[i].second = v[i][0];
        for (int j = 1; j < v[i].size(); j++) {
            hashstr[i].first = (v[i][j] + hashstr[i].first * 113) % mod1;
            hashstr[i].second = (v[i][j] + hashstr[i].second * 119) % mod2;
        }
    }

    while (m--) {
        int l, r;
        cin >> l >> r;
        l--; r--;

        int ans = 0;
        for (int i = 0; i < n; i++) {
            for (int j = l; j <= r - (int)v[i].size() + 1; j++) {
                int ll = j, rr = j + (int)v[i].size() - 1;

                int hash1 = hasht[ll][rr - ll].first;
                int hash2 = hasht[ll][rr - ll].second;

                if (hashstr[i].first == hash1 && hashstr[i].second == hash2) {
                    ans++;
                    //cout << i << ' ' << j << '\n';
                }
            }
        }

        cout << ans << ' ';
    }
    cout << '\n';

    return 0;
}
