#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

const int64_t p = 100;
const int64_t M = 1e9 + 7;

vector<int64_t> st = { 1 };
vector<int64_t> h = { 0 };

int64_t get(int l, int r) {
	return (M + h[r+1] - (h[l] * st[r - l + 1])%M)%M;
}

int main() {
	int n, m; cin >> n >> m;
	string s; cin >> s;
	int t = s.size();
	for (auto i = 0; i < t; ++i) {
		st.push_back((st[i] * p) % M);
	}
	for (auto i = 0; i < t; ++i) {
		h.push_back(((h[i] * p) % M + s[i]-'a' + 1)%M);
	}

	
	vector<int64_t> hs(n);
	vector<int> sz(n);
	for (auto i = 0; i < n; ++i) {
		string s1; cin >> s1;
		hs[i] = 0;
		sz[i] = s1.size();
		for (auto j = 0; j < s1.size(); ++j) {
			hs[i] = ((hs[i] * p) % M + s1[j] - 'a' + 1) % M;
		}
	}
	vector<vector<int>> pos(n);
	for (auto i = 0; i<n; ++i) {
		for (auto j = 0; j <= t - sz[i]; ++j) {
			if (get(j, j + sz[i] - 1) == hs[i]) {
				pos[i].push_back(j);
			}
		}
	}
	for (auto q = 0; q < m; ++q) {
		int l, r; cin >> l >> r;
		l--; r--;
		int64_t ans = 0;
		for (auto i = 0; i < n; ++i) {
			if (pos[i].empty()) {
				continue;
			}
			int ll = -1;
			int rr = pos[i].size();
			while (rr - ll > 1) {
				int mm = (rr + ll) / 2;
				if (pos[i][mm] >= l) {
					rr = mm;
				}
				else {
					ll = mm;
				}
			}
			int64_t lll = rr;
			ll = -1;
			rr = pos[i].size();
			while (rr - ll > 1) {
				int mm = (rr + ll) / 2;
				if (pos[i][mm] + sz[i] - 1 <= r) {
					ll = mm;
				}
				else {
					rr = mm;
				}
			}
			ans += max(int64_t(0), ll - lll+1);
		}
		cout << ans << ' ';
	}
	return 0;
}