#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pr;

#define all(v) v.begin(), v.end()
mt19937_64  rnd(50);
ll k1 = 31,mod1 = 1e9 + 7,k2 = 47,mod2 = 1e9+9;
vector<ll> p1(1e6,1),p2(1e6,1);
vector<ll> h1(1e6),h2(1e6);
ll mul (ll a,ll b,ll mod){
    return (a*b)%mod;
}
ll sub(ll a,ll b,ll mod){
    return ((a-b)+mod)%mod;
}
ll geth(ll l,ll r,ll mod, vector<ll> &p,vector<ll> &h){
    return sub(h[r],mul(h[l],p[r-l],mod),mod);
}
signed main(){
    ios_base::sync_with_stdio(0),cin.tie(0),cout.tie(0);
    for (int i = 1; i < 1e6; ++i) {
        p1[i] = (p1[i-1] * k1) % mod1;
        p2[i] = (p2[i-1] * k2) % mod2;
    }
    ll n,q;
    cin >> n >> q;
    string s;
    cin >> s;
    for (int i = 0; i < s.size(); ++i) {
        h1[i+1] = (h1[i]*k1 + s[i])%mod1;
        h2[i+1] = (h2[i]*k2 + s[i])%mod2;
    }
    unordered_set<ll> st;
    while(n--){
        ll hsh1 = 0,hsh2 = 0;
        string cur;
        cin >> cur;
        for (int i = 0; i < cur.size(); ++i) {
            hsh1 = (hsh1*k1 + cur[i])%mod1;
            hsh2 = (hsh2*k2 + cur[i])%mod2;
        }
        st.insert(hsh1),st.insert(hsh2);
    }
    n = s.size();
    vector<vector<ll>> calc(n,vector<ll> (n,0));
    for (int sz = 0; sz < n; ++sz) {
        for (int start = 0; start < n; ++start) {
            if(start + sz >= n){
                break;
            }
            ll to = start + sz;
            if(st.count(geth(start,to + 1,mod1,p1,h1)) && st.count(geth(start,to + 1,mod2,p2,h2))){
                calc[start][to]++;
            }
            if(sz >= 1){
                calc[start][to] += calc[start][to-1];
                calc[start][to] += calc[start + 1][to];
                calc[start][to] -= calc[start + 1][to-1];
            }
        }
    }
    while (q--){
        ll l,r;
        cin >> l >> r;
        l--,r--;
        cout << calc[l][r] << " ";
    }
}