//#pragma GCC optimize("O3", "inline", "unroll-loops", "no-stack-protector")
//#pragma GCC optimize("Os")
#pragma GCC comment("/linker:64000000")
//#pragma GCC targer("fma")
#include <bits/stdc++.h>
//
//#include <ext/rope>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//
//using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
//#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;


template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

const int MAXL = 1e6;
int tree[2 * MAXL];

void upd(int i) {
    i += MAXL;
    tree[i]++;
    for (; i > 1; i >>= 1) {
        tree[i >> 1] = tree[i] + tree[i ^ 1];
    }
}

int get(int l, int r) {
    int res = 0;

    for (l += MAXL, r += MAXL; l < r; l >>= 1, r >>= 1) {
        if (l & 1) {
            res += tree[l++];
        }
        if (r & 1) {
            res += tree[--r];
        }
    }
    return res;
}


const int MAXN = 1e7 + 1;
struct node {
    array<int, 26> go;
    bool term;
};

//node bor[MAXN];

const int K = 1000;

struct query {
    int x, y;
    int id;
};

int main() {
    fast;
    int n, m;
    cin >> n >> m;

    int ind = 1;
    string t;
    cin >> t;

    vector<node> bor;

    if (t.size() >= 1e5) {
        bor.resize(3e5);
    } else {
        bor.resize(1e6 + 1);
    }

    int q = n;

    n = t.size();
    vector<int> asks[n];
    vector<query> my_ask[n];
    bor[0].term = 0;
    bor[0].go.fill(-1);

    while (q--) {
        string s;
        cin >> s;
        int f = s.size();

        if (s.size() >= K) {
            s += "#" + t;
            vector<int> z(s.size());
            int n = s.size();
            int l = 0, r = 0;

            for (int i = 1; i < n; i++) {
                z[i] = max(0, min(r - i + 1, z[i - l]));
                while (i + z[i] < n && s[i + z[i]] == s[z[i]]) {
                    z[i]++;
                }

                if (i + z[i] - 1 > r) {
                    r = i + z[i] - 1;
                    l = i;
                }
            }
            for (int j = 0; j < t.size(); j++) {
                if (z[j + f + 1] >= f) {
                    asks[j].push_back(j + f - 1);
                }
            }
        } else {
            int rt = 0;

            for (char &it : s) {
                it -= 'a';

                if (bor[rt].go[it] == -1) {
                    bor[rt].go[it] = ind;
                    bor[ind].term = 0;
                    bor[ind].go.fill(-1);
                    ind++;
                    if (ind >= MAXN) {
                        cout << -1 << endl;
                        return 0;
                    }
                }
                rt = bor[rt].go[it];
            }

            bor[rt].term = 1;
        }
    }
    n = t.size();

    for (int i = 0; i < n; i++) {
        int rt = 0;

        for (int j = 1; j <= K && i + j <= n; j++) {
            int r = i + j - 1;

            rt = bor[rt].go[t[r] - 'a'];
            if (rt == -1) {
                break;
            }

            if (bor[rt].term) {
                asks[i].push_back(r);
            }
        }
    }

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        --a; --b;

        if (a != 0) {
            my_ask[a - 1].push_back({a, b, -i - 1});
        }

        my_ask[b].push_back({a, b, i + 1});
    }

    fill(tree, tree + 2 * MAXL, 0);

//    tree.init(1e6);
    vector<int> ans(m, 0);

    for (int i = 0; i < n; i++) {
        for (int &it : asks[i]) {
//            cout << i << ' ' << it << endl;
            upd(it);
        }

        for (query &it : my_ask[i]) {
            int val = get(it.x, it.y + 1);

            if (it.id < 0) {
                val *= -1;
                it.id *= -1;
            }

            ans[it.id - 1] += val;
        }
    }

    cout << ans << endl;
    return 0;
}