#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 3e5;
const ld EPS = 1e-8;

random_device rd;
mt19937 rnd(rd());

#define max3(a, b, c) max(max(a, b), c)
#define min3(a, b, c) min(min(a, b), c)
#define pow2(x) ((x) * (x));
#define mod(x, m) (((x) % (m) + (m)) % (m))
#define debug(x) cerr << (#x) << " : " << x << endl

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    map<string, bool> mp;
    for (int i = 0; i < n; ++i) {
        mp[s[i]] = true;
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ans = 0;
        for (int len = 1; len <= r - l + 1; ++len) {
            for (int i = l; i + len - 1 <= r; ++i) {
                if (mp.find(t.substr(i, len)) != mp.end()) ans++;
            }
        }
        cout << ans << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    //freopen("ALO.in", "r", stdin);
    //freopen("ALO.out", "w", stdout);

    int test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}