#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <deque>
using namespace std;
int st[25][8000000];
int logs[6000000];
void build(vector<int>& init) {
	int n = init.size();
	for (int i = 0; i < n; i++) {
		st[0][i] = init[i];
	}
	for (int i = 1; (1 << i) <= n; i++) {
		for (int j = 0; j + (1 << i) <= n; j++) {
			st[i][j] = min(st[i - 1][j], st[i - 1][j + (1 << (i - 1))]);
		}
	}
}
int ask(int l, int r) {
	int len = r - l + 1;
	int log = logs[len];
	return min(st[log][l], st[log][r - (1 << log) + 1]);
}

int main() {
	logs[1] = 0;
	for (int i = 2; i < 6000000; i++) {
		logs[i] = logs[i / 2] + 1;
	}
	int m, q;
	cin >> m >> q;
	string t;
	cin >> t;
	vector<string> ss;
	
	string s = t + '$';
	vector<int> spos(m);
	for (int i = 0; i < m; i++) {
		string sss;
		cin >> sss;
		ss.push_back(sss);
		spos[i] = s.size();
		s += sss;
		s += '$';
	}




	int n = s.size();
	vector<int> ecc(n);
	vector<vector<int> > byc(max(250, n));
	for (int i = 0; i < n; i++) {
		byc[s[i]].push_back(i);
		ecc[i] = s[i];
	}
	vector<int> sorted;
	for (int i = 0; i < max(250, n); i++) {
		for (auto h : byc[i]) {
			sorted.push_back(h);
		}
	}
	for (int i = 1; (1 << i) < n; i++) {
		vector<vector<int> > byec(max(250, n));
		for (int j = 0; j < n; j++) {
			int prev = (sorted[j] - (1 << (i - 1)) + n) % n;
			byec[ecc[prev]].push_back(prev);
		}
		vector<int> nsorted;
		for (int j = 0; j < max(250, n); j++) {
			for (auto h : byec[j]) {
				nsorted.push_back(h);
			}
		}
		sorted = nsorted;
		vector<int> necc(n);
		necc[sorted[0]] = 0;
		for (int j = 1; j < n; j++) {
			if (ecc[sorted[j - 1]] == ecc[sorted[j]] && ecc[((sorted[j - 1] + (1 << (i - 1)))) % n] == ecc[(sorted[j] + (1 << (i - 1))) % n]) {
				necc[sorted[j]] = necc[sorted[j - 1]];
			}
			else {
				necc[sorted[j]] = necc[sorted[j - 1]] + 1;
			}
		}

		ecc = necc;

	}

	vector<int> lcp(n);
	int cpos = 0;
	for (int i = 0; i < n; i++) {
		if (cpos > 0) {
			cpos--;
		}
		if (ecc[i] == n - 1) {
			lcp[ecc[i]] = -1;
			continue;
		}

		while (i + cpos < n && sorted[ecc[i] + 1] + cpos < n && s[i + cpos] == s[sorted[ecc[i] + 1] + cpos]) {
			cpos++;
		}
		lcp[ecc[i]] = cpos;
	}
	build(lcp);
	deque<pair<int, pair<int,int> > > evs;
	for (int i = 0; i < m; i++) {
		int pos = ecc[spos[i]];
		int L = 0;
		int R = n + 1;
		while (R - L > 1) {
			int med = (R + L) / 2;
			if (pos + med >= n) {
				R = med;
				continue;
			}
			if (ask(pos, pos + med - 1) >= ss[i].size()) {
				L = med;
			}
			else {
				R = med;
			}
		}
		int rborder = pos + L;

		L = 0;
		R = n + 1;
		while (R - L > 1) {
			int med = (R + L) / 2;
			if (pos - med < 0) {
				R = med;
				continue;
			}
			if (ask(pos - med, pos - 1) >= ss[i].size()) {
				L = med;
			}
			else {
				R = med;
			}

		}
		int lborder = pos - L;
		evs.push_back({ lborder,{1,i} });
		evs.push_back({ rborder+1,{-1,i} });

	}
	vector<vector<int> > ats(t.size());
	set<int> cur;
	sort(evs.begin(), evs.end());
	for (int i = 0; i < n; i++) {
		while (evs.size()>0&&evs.front().first == i) {
			if (evs.front().second.first == 1) {
				cur.insert(evs.front().second.second);
			}
			else {
				cur.erase(evs.front().second.second);
			}
			evs.pop_front();
		}
		
		if (sorted[i] < t.size()) {
			for (auto h : cur) {
				ats[sorted[i]].push_back(h);
			}

		}
	}



	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;

		int ans = 0;
		for (int j = l; j <= r; j++) {
			for (auto h : ats[j]) {
				int last = j + ss[h].size()-1;
				if (last <= r) {
					ans++;
				}
			}
		}
		cout << ans << ' ';
	} 

}