#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

#include <bits/stdc++.h>

#define int int_fast32_t
#define ll int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define INF (int) 1e18 / 2

using namespace std;

mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int N = 950000, alp = 26;

int to[N][alp];
int term[N], suff[N], super_suff[N], d[N];
int ptr = 0;

void add(string s) {
	int v = 0;
	for (char c: s) {
		c -= 'a';
		if (!to[v][c]) to[v][c] = ++ptr;
		d[to[v][c]] = d[v] + 1, v = to[v][c];
	}
	term[v] = 1;
}

void bfs() {
	queue<int> q;
	q.push(0);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int i = 0; i < alp; i++) {
			int u = to[v][i];
			if (u == 0) continue;
			q.push(u);
			if (term[u] == 1) super_suff[u] = u;
			if (v == 0) continue;
			int s = suff[v];
			while (s and !to[s][i]) s = suff[s];
			suff[u] = to[s][i];
			if (term[u]) super_suff[u] = u;
			else super_suff[u] = super_suff[suff[u]];
		}
	}
}

int t[N];

void upd(int i, int v) {
	for (; i < N; i += i & -i)
		t[i]++;
}

int get(int i) {
	if (i == 0) return 0;
	int res = 0;
	for (; i; i -= i & -i)
		res += t[i];
	return res;
}

int get(int l, int r) {
	int res = 0;
	return get(r) - get(l - 1);
}

void solve() {
	int n, m;
	cin >> n >> m;
	string str;
	cin >> str;
	int sz = str.size();
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		add(s);
	}
	bfs();
//	for (int i = 0; i <= ptr; i++) {
//		cout << "i:\t" << i << '\t' << suff[i] << '\t' << super_suff[i] << '\n';
//		for (int j = 0; j < alp; j++)
//			if (to[j][i])
//				cout << to[j][i] << '\t' << (char) (j + 'a') << '\n';
//	}
	vector qq(sz + 1, vector<pair<int, int>>());
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		qq[r].push_back({l, i});
	}
	vector<int> res(m);
	str = '$' + str;
	int v = 0;
	for (int i = 1; i <= sz; i++) {
		while (v and !to[v][str[i] - 'a']) v = suff[v];
		v = to[v][str[i] - 'a'];
		int s = super_suff[v];
		while (s) {
			if (term[s]) upd(i - d[s] + 1, term[s]);
			s = suff[s];
		}
		for (auto[l, id] : qq[i])
			res[id] = get(l, i + 1);
	}
	for (int i: res)
		cout << i << " ";
	cout << '\n';
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(20);

	solve();
}