#include <iostream>
#include <string>

using namespace std;

int mod = 1000000007;
const int x = 3;
int mat[26][x][x];


int main() {
    srand(846237234);
    for (int i = 0; i < 26; ++i) {
        for (int j = 0; j < x; ++j) {
            for (int k = 0; k < x; ++k) {
                mat[i][j][k] = (long long) rand() * rand() * rand() % mod;
            }
        }
    }
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int s = t.size();
    int ***a = new int **[s + 1];
    for (int i = 0; i <= s; ++i) {
        a[i] = new int *[x];
        for (int j = 0; j < x; ++j) {
            a[i][j] = new int[x];
        }
    }
    for (int i = 0; i < x; ++i)
        for (int j = 0; j < x; ++j) {
            if (i == j) a[0][i][j] = 1;
            else a[0][i][j] = 0;
        }
    for (int i = 0; i < s; ++i) {
        int ind = t[i] - 'a';
        for (int j = 0; j < x; ++j) {
            for (int k = 0; k < x; ++k) {
                a[i + 1][j][k] = 0;
                for (int p = 0; p < x; ++p) {
                    a[i + 1][j][k] += mat[ind][p][k] * a[i][j][p];
                }
            }
        }
    }
    int **ma = new int *[x];
    int **ma2 = new int *[x];
    int *z = new int[s + 1];
    int *w = new int[s + 1];
    int all = 0;
    for(int i = 0; i <= s; ++i){
        z[i] = 0;
        w[i] = 0;
    }
    for(int i = 0; i < n; ++i){
        string st;
        cin >> st;
        for (int i = 0; i < x; ++i) {
            ma[i] = new int[x];
            ma2[i] = new int[x];
            for (int j = 0; j < x; ++j) {
                if (i == j) {
                    ma[i][j] = 1;
                } else {
                    ma[i][j] = 0;
                }
            }
        }
        for(char ch : st){
            swap(ma, ma2);
            for (int j = 0; j < x; ++j) {
                for (int k = 0; k < x; ++k) {
                    ma[j][k] = 0;
                    for (int p = 0; p < x; ++p) {
                        ma[j][k] += mat[ch - 'a'][p][k] * ma2[j][p];
                    }
                }
            }
        }
        int l = st.size();
        for(int j = 0; j <= s - l; ++j){
            int b = true;
            for(int k = 0; k < x; ++k) for(int kk = 0; kk < x; ++kk){
                int sum = 0;
                for(int p = 0; p < x; ++p){
                    sum += ma[p][kk] * a[j][k][p];
                }
                b = b && (sum == a[j + l][k][kk]);
            }
            if(b){
//                cout << "st: " << st << "; j: " << j << '\n';
                ++z[j + l];
                ++w[j];
                ++all;
            }
        }
    }
    int *pre = new int[s + 2];
    pre[0] = 0;
    int *post = new int[s + 2];
    post[s + 1] = 0;
    for(int i = 0; i <= s; ++i){
        pre[i + 1] = pre[i] + z[i];
        post[s - i] = post[s - i + 1] + w[s - i];
    }
    for(int i = 0; i < m; ++i){
        int l, r;
        cin >> l >> r;
        cout << pre[r + 1] + post[l - 1] - all << '\n';
    }
    return 0;
}