#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define debug(x) cerr << "[" << #x << "]: " << x << endl
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

struct nd{
    vector<int> nxt = vector<int>(26, -1);
    vector<int> go = vector<int>(26, 0);
    int sf = 0;
    int fst = 0;
    int d = 0;
    int p = 0;
    int c = 0;
    bool term = false;
};

vector<nd> tr;

void add(string &s){
    int v = 0;
    for (char i : s){
        if (tr[v].nxt[i - 'a'] == -1){
            tr[v].nxt[i - 'a'] = sz(tr);
            tr.pb(nd());
            tr.back().p = v;
            tr.back().c = i - 'a';
            tr.back().d = tr[v].d + 1;
        }
        v = tr[v].nxt[i - 'a'];
    }
    tr[v].term = true;
}

void build(){
    queue<int> q;
    q.push(0);
    while (!q.empty()){
        int v = q.front();
        q.pop();
        if (v == 0 || tr[v].p == 0){
            tr[v].sf = 0;
        }
        else tr[v].sf = tr[tr[tr[v].p].sf].go[tr[v].c];
        for (int i = 0; i < 26; i++) {
            if (tr[v].nxt[i] != -1) tr[v].go[i] = tr[v].nxt[i];
            else tr[v].go[i] = tr[tr[v].sf].go[i];
        }
        if (tr[tr[v].sf].term) tr[v].fst = tr[v].sf;
        else tr[v].fst = tr[tr[v].sf].fst;
        for (int i = 0; i < 26; i++) if (tr[v].nxt[i] != -1) q.push(tr[v].nxt[i]);
    }
}

vector<pii> otr;

void get(int v, int i){
    while (v != 0){
        if (tr[v].term){
            otr.pb({i - tr[v].d + 1, i});
        }
        v = tr[v].fst;
    }
}

void solve(){
    tr.pb(nd());
    int n, m;
    cin >> n >> m;
    string t; cin >> t;
    for (int i = 0; i < n; i++) {
        string s; cin >> s;
        add(s);
    }
    build();
    int v = 0;
    for (int i = 0; i < sz(t); i++){
        v = tr[v].go[t[i] - 'a'];
        get(v, i);
    }
    for (int i = 0; i < m; i++){
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ans = 0;
        for (pii j : otr) if (j.ff >= l && j.ss <= r) ans++;
        cout << ans << " ";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    while(n--) solve();
}
