#include <bits/stdc++.h>
using namespace std;

#define int long long 
#define forn(i,n) for(int i=0;i<n;++i)

#define pi pair<int,int>
#define f first
#define s second

#define pb push_back
#define all(x) x.begin(),x.end()
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

//const int inf=1e18;
const int mod=1e9+7;

const int M=5e5, N=5e5;

int n=5e5,m=5e5;
string s;
vector<string> a(n);
const int len=1e5+1;//5e6+1;
int S=0;
int K;
//int cnt[len];
//int pref[len];

int nxt=0;
//vector<int> op[len];
//vector<int> cl[len];
//vector<int> L[len];
//vector<int> R[len];
//int qans[M];

vector<pi> seg;

struct trie {
	trie* c[26];
	int end;
	trie() {
		forn(i,26) c[i]=NULL;
		end=0;
	}
	void add(string&s, int i=0) {
		if (i>=s.size()) {
			++end; return;
		}
		int b=s[i]-'a';
		if (!c[b]) c[b]=new trie();
		c[b]->add(s,i+1);
	}
	void query(string&s, int ind, int i=0) {
		if (end) {
			//pref[ind]++;
			//cnt[ind+i-1]++;
			seg.pb({ind,ind+i-1});
		}
		if (i>=s.size()) {
			return;
		}
		int b=s[i]-'a';
		if (!c[b]) return;
		c[b]->query(s,ind,i+1);
	}
};

trie t;

vector<int> z(string&f) {
	string k=f+'#'+s;
	vector<int> z(k.size(),0);
	int r=1;
	int last=0;
	for (int i=1; i<k.size(); ++i) {
		r=max(r,i);
		z[i]=min(z[i-last],r-i);
		if (z[i]+i<r) continue;
		while (k[r]==k[r-i]) ++r;
		z[i]=r-i;
		last=i;
	}
	return z;
}

struct mst {
	vector<vector<int>> t;
	int sz;
	void merge(vector<int>&d, vector<int>&a, vector<int>&b) {
		int i=0, j=0;
		while (i<a.size() && j<b.size()) {
			if (a[i]<b[j]) {
				d.pb(a[i++]);
			} else {
				d.pb(b[j++]);
			}
		}
		while (i<a.size()) {
			d.pb(a[i++]);
		}
		while (j<b.size()) {
			d.pb(b[j++]);
		}
		//cout<<"merged: { ";
		//for(auto&x:a) cout<<x<<' ';
		//cout<<"} and { ";
		//for(auto&x:b) cout<<x<<' ';
		//cout<<"} into: { ";
		//for(auto&x:d) cout<<x<<' ';
		//cout<<"}\n";
	}
	void build(int v, int l, int r) {
		if (r-l==1) {
			sort(all(t[v]));
			return;
		}
		int m=(l+r)>>1;
		build(2*v+1,l,m);
		build(2*v+2,m,r);
		merge(t[v],t[2*v+1],t[2*v+2]);
	}
	mst(vector<pi>&a, int n) {
		sz=1; while (sz<n) sz<<=1;
		t.resize(2*sz-1);
		for(auto&x:a) {
			t[x.f+sz-1].pb(x.s);
		}
		build(0,0,sz);
	}
	int query(int v, int l, int r, int lx, int rx) {
		if (rx<=l || r<=lx) return 0;
		if (lx<=l && r<=rx) {
			int ls=0, rs=t[v].size();
			while (ls<rs) {
				int m=(ls+rs)>>1;
				if (t[v][m]>=rx) rs=m;
				else ls=m+1;
			}
			return rs;
		}
		int m=(l+r)>>1;
		int lq=query(2*v+1,l,m,lx,rx);
		int rq=query(2*v+2,m,r,lx,rx);
		return lq+rq;
	} 
	int query(int l, int r) {
		return query(0,0,sz,l,r);
	}
};

void solve() {

	cin>>n>>m>>s;
	forn(i,n) cin>>a[i];
	forn(i,n) S+=a[i].size();
	K=sqrt(S);

	forn(i,n) {
		if (a[i].size()>K) {
			auto v=z(a[i]);
			int sz=a[i].size();
			for (int j=sz+1; j<v.size(); ++j) {
				if (v[j]==sz) {
					//cnt[j-2]++;
					//pref[j-sz-1]++;
					seg.pb({j-sz-1,j-2});
				}
			}
		} else {
			t.add(a[i]);
		}
	}
	forn(i,s.size()) {
		string tmp;
		int lim=min(i+K,(int)s.size());
		for(int j=i;j<lim;++j) tmp+=s[j];
		t.query(tmp,i);
	}
	mst st(seg,len);

	while (m--) {
		int l,r; cin>>l>>r; --l, --r;
		cout<<st.query(l,r+1)<<' ';
	}

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	//cin>>t;
	while (t--) solve();
	return 0;
}