#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

set<int> lens;
int n, m;
ll mod = 1e9+7;
int lent;
ll mod2 = mod*mod;
ll p = 89;
vector<ll> hsh;
vector<ll> step;
unordered_map<int, bool> hashs;
vector<pair<int, int>> allin;
vector<int> sums;
vector<int> tree;

ll getHash(int a, int b) {
    return ((hsh[b]-hsh[a-1]*step[b-a+1])%mod+mod)%mod;
}

void build(int ind, int l, int r){
    if(l==r){
        tree[ind]=sums[l];
        return;
    }
    int m = (l+r)/2;
    build(ind*2, l, m);
    build(ind*2+1, m+1, r);
    tree[ind] = tree[ind*2]+tree[ind*2+1];
}

void update(int ind, int l, int r, int need) {
    if(l>need || r<need)
        return;
    if(l==r) {
        tree[ind]--;
        return;
    }
    int m = (l+r)/2;
    update(ind*2, l, m, need);
    update(ind*2+1, m+1, r, need);
    tree[ind] = tree[ind*2]+tree[ind*2+1];
 }

 int get(int ind, int l, int r, int need_l, int need_r){
    if(l> need_r || r<need_l)
        return 0;
    if(l>=need_l && r<=need_r)
        return tree[ind];
    int m = (l+r)/2;
    return get(ind*2, l, m, need_l, need_r)+get(ind*2+1, m+1, r, need_l, need_r);
}

void solve() {
    cin >> n >> m;
    string t;
    cin>>t;
    lent=t.size();
    step.resize(lent+1);
    hsh.resize(lent+1);
    step[0]=1;
    for(int i=0;i<t.size();i++){
        step[i+1]=step[i]*p%mod;
        hsh[i+1] = (hsh[i]*p+t[i]-'a'+1+mod)%mod;
    }
    tree.resize(4*lent+4);
    sums.resize(lent+1);
    for(int i=0;i<n;i++){
        string s;
        cin >> s;
        lens.insert(s.size());
        ll hs = 0;
        for(auto&i:s){
            hs*=p;
            hs+=i-'a'+1+mod;
            hs%=mod;
        }
        hashs[hs]=1;
    }
    for(auto&i:lens) {
        for(int k = i;k<=lent;k++) {
            ll nh = getHash(k-i+1, k);
            if(hashs.find(nh)!=hashs.end()) {
                allin.push_back({k - i + 1, k});
                sums[k]++;
            }
        }
    }
    sort(allin.begin(), allin.end());
    vector<pair<pair<int, int>, int>> que(m);
    for(int i = 0; i < m; i++) {
        cin >> que[i].first.first >> que[i].first.second;
        que[i].second=i;
    }
    sort(que.begin(), que.end());
    build(1, 0, lent);
    int kk = 0;
    vector<int> anses(m);
    for(auto &nowq : que) {
        while(kk!=allin.size()) {
            if(allin[kk].first<nowq.first.first){
                update(1, 0, lent, allin[kk].second);
                kk++;
            }
            else
                break;  
        }
        anses[nowq.second] = get(1, 0, lent, 0, nowq.first.second);
    }
    for(auto&i:anses) {
        cout<< i<<" ";
    }
}

int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}