#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < n; i++)
#define ff first
#define ss second

using namespace std;
typedef long long ll;
typedef long double ld;

const ll N = 2e6, MOD = 1e9 + 7, INF = 1e18;

ll mul(ll x, ll y) {
    return (x * y) % MOD;
}

ll pls(ll x, ll y) {
    return (x + y) % MOD;
}

ll mns(ll x, ll y) {
    return (x - y + MOD) % MOD;
}

struct qu{
    ll l, r, i;
};

bool cmp(qu x, qu y) {
    return x.r < y.r;
}

qu q[N];
ll n, m, p[N], h[N], pos, l1, r1, total[N];
string s, a;
vector<ll> ans[N];
ll t[N];


void update(ll v, ll tl, ll tr) {
    if (tr - tl == 1) {
        t[v]++;
        return;
    }
    ll m2 = (tl + tr) / 2;
    if (pos < m2)
        update(v * 2 + 1, tl, m2);
    else
        update(v * 2 + 2, m2, tr);
    t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}

ll cnt(ll v, ll tl, ll tr) {
    if (l1 <= tl && tr <= r1)
        return t[v];
    if (l1 >= tr || tl >= r1)
        return 0;
    ll m2 = (tl + tr) / 2;
    return cnt(v * 2 + 1, tl, m2) + cnt(v * 2 + 2, m2, tr);
}

ll gt(ll l, ll r) {
    return mns(h[r], h[l]);
}

int main() {
    cout << fixed << setprecision(12);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef ZHEGLOV
    freopen("inp.txt", "r", stdin);
#endif
    cin >> n >> m;
    cin >> s;
    p[0] = 1;
    forn(i, s.size() + 1000) {
        p[i + 1] = mul(p[i], 67);
    }
    forn(i, s.size())
        h[i + 1] = pls(h[i], mul(p[i], s[i] - 'a' + 1));
    forn(_, n) {
        cin >> a;
        ll hsh = 0;
        forn(i, a.size()) {
            hsh = pls(hsh, mul(p[i], a[i] - 'a' + 1));
        }
        forn(i, ll(s.size()) - ll(a.size()) + 1) {
            if (gt(i, i + a.size()) == hsh)
                ans[i + a.size() - 1].push_back(i);
            hsh = mul(hsh, p[1]);
        }
    }
    forn(i, m) {
        cin >> q[i].l >> q[i].r; q[i].l--; q[i].i = i;
    }
    sort(&q[0], &q[m], cmp);
    ll rr = 0;
    forn(i, m) {
        while (rr < q[i].r) {
            for (auto v : ans[rr]) {
                pos = v;
                update(0, 0, s.size());
            }
            rr++;
        }
        l1 = q[i].l;
        r1 = s.size();
        total[q[i].i] = cnt(0, 0, s.size());
    }
    forn(i, m) {
        cout << total[i] << " ";
    }
    return 0;
}