#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define int long long

const ll p = 239;
const ll mod = 1e9 + 7;
const int N = 5e4 + 10;
ll stp[N];

const int M = 1<<16;
vector<int> mstree[M<<1];

int get1(int v, int x){
    return upper_bound(mstree[v].begin(), mstree[v].end(), x) - mstree[v].begin();
}

int get(int l, int r){
    int xr = r;
    l+=M, r+=M;
    int ans = 0;
    while(l < r){
        if(l % 2==1){
            ans += get1(l, xr);
            l++;
        }
        if(r % 2 == 0){
            ans += get1(r, xr);
            r--;
        }
        l/=2,r/=2;
    }
    if(l == r) ans += get1(l, xr);
    return ans;
}

int32_t main() {
    stp[0] = 1;
    for(ll i=1;i<N;++i){
        stp[i] = (stp[i - 1] * p) % mod;
    }
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    int t = s.size();
    vector<ll> pref(t + 1, 0);
    for(int i=1;i<=t;++i){
        pref[i] = ((pref[i - 1] * p % mod) + (s[i - 1] - 'a' + 1)) %mod;
//        cerr << i << ' ' << pref[i] << "\n";
    }
    auto get_hash = [&](int l, int r){
//        cerr << l << ' ' << r + 1 << "\n";
        return (pref[r+1] - ((pref[l] * stp[r-l+1]) % mod) + mod) % mod;
    };

    for(int i=0;i<n;++i){
        string si;
        cin >> si;
        ll ch = 0;
        for(int j=0;j<si.size();++j){
            ch = ((ch * p) % mod + (si[j] - 'a' + 1)) % mod;
        }
        for(int j=0;j+si.size()<=t;++j){
//            cerr << get_hash(j, j + si.size() - 1) << ' ' << ch << "\n";
            if(get_hash(j, j + si.size() - 1) == ch){
                mstree[M + j].push_back(j+si.size()-1);
            }
        }
    }

    for(int i=M;i<M+M;++i){
        sort(mstree[i].begin(), mstree[i].end());
    }
    for(int i=M-1;i>0;--i){
        mstree[i].resize(mstree[i*2].size()+mstree[i*2+1].size());
        merge(mstree[i*2].begin(), mstree[i*2].end(), mstree[i*2+1].begin(), mstree[i*2+1].end(), mstree[i].begin());
//        cerr << i << ' ';
//        for(auto j:mstree[i]) cerr << j << ' ';
//        cerr << "\n";
    }

    while(m--){
        int l, r;
        cin >> l >> r;
        l--,r--;
        cout << get(l, r) << " ";
    }
}