#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> a);
template<typename T>
ostream& operator << (ostream &out, set<T> a);
template<typename T>
ostream& operator << (ostream &out, vector<T> a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#ifdef LOCAL
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
#else
#define debug(x...) 7
#endif
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(21281337711);
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}
int divide(int a, int b) {
    return mul(a, binpow(b, mod - 2));
}

const int N = 1e6 + 1, K = 26;
int go[N][K], suf[N], super[N], par[N], ch[N], term[N], depth[N];
int nv = 1;
void add(string &s) {
    int v = 0;
    for (char c : s) {
        int cc = c - 'a';
        if (go[v][cc] == 0) {
            depth[nv] = depth[v] + 1;
            par[nv] = v;
            ch[nv] = cc;
            go[v][cc] = nv++;
        }
        v = go[v][cc];
    }
    term[v]++;
}
void init(int v) {
    if (v == 0) return;
    suf[v] = go[suf[par[v]]][ch[v]];
    if (suf[v] == v) suf[v] = 0;
    if (term[suf[v]]) {
        super[v] = suf[v];
    } else {
        super[v] = super[suf[v]];
    }
    for (int c = 0; c < 26; c++) {
        if (go[v][c] == 0) {
            go[v][c] = go[suf[v]][c];
        }
    }
}
void bfs() {
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int c = 0; c < 26; c++) {
            if (go[v][c] != 0) {
                q.push(go[v][c]);
            }
        }
        init(v);
    }
}
const int NN = 5 * N, BL = 1024;
ll bl[NN / BL + 1], vv[NN];
void solve_case() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    depth[0] = -1;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        add(s);
    }
    bfs();
    vector<int> l(m), R(m);
    vector<int> q(m);
    for (int i = 0; i < m; i++) {
        cin >> l[i] >> R[i];
        l[i]--, R[i]--;
    }
    iota(q.begin(), q.end(), 0);
    sort(q.begin(), q.end(), [&](int left, int right){
        return R[left] < R[right] || (R[left] == R[right] && l[left] < l[right]);
    });
    vector<ll> ans(m);
    int v = 0;
    ll all = 0;
    int ptr = 0;
    for (int r = 0; r < t.size() && ptr != m; r++) {
        int cc = t[r] - 'a';
        v = go[v][cc];
        int u = v;
        if (!term[u]) u = super[u];
        while (u != 0) {
            all++;
            vv[r - depth[u]]++;
            bl[(r - depth[u]) / BL]++;
            //update(r - depth[u] + 1, 1);
            u = super[u];
        }
        while (ptr != m && R[q[ptr]] == r) {
            int ql = l[q[ptr]] - 1;
            ans[q[ptr]] = all;
            while ((ql + 1) % BL != 0) {
                ans[q[ptr]] -= vv[ql];
                ql--;
            }
            ql = (ql + 1) / BL;
            for (int s = 0; s < ql; s++) ans[q[ptr]] -= bl[s];
            ptr++;
        }
    }
    for (int i = 0; i < m; i++) cout << ans[i] << " ";
    cout << "\n";
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
    return 0;
}