#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <random>
#include <chrono>
#include <unordered_set>

using namespace std;
using pii = pair<int, int>;
using ll = long long;
vector<ll> pref;
vector<ll> pows;
ll mod = 1e9 + 7;
int b = 29;

void init() {
    pows.resize(200000, 1);
    for (int i = 1; i < 200000; ++i) {
        pows[i] = (pows[i - 1] * b) % mod;
    }
}

ll hh(string& s, int key=0) {
    ll res = 0;
    for (char c: s) {
        res = (res * b + (c - 'a' + 1)) % mod;
        if (key) {
            pref.push_back(res);
        }
    }
    return res;
}

ll substr(int l, int r) {
    return ((pref[r + 1] - (pref[l] * pows[r - l + 1]) % mod) + mod) % mod;
}

int main() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<string> p;
    init();
    for (int i = 0; i < n; ++i) {
        string t;
        cin >> t;
        p.push_back(t);
    }
    pref.push_back(0);
    int h = hh(s, 1);
    vector<ll> hs;
    for (string i : p) {
        hs.push_back(hh(i));
    }
    vector<int> ans;
    for (int i = 0; i < m; ++i) {
        int l, r;
        int res = 0;
        cin >> l >> r;
        --l, --r;
        for (int k = l; k <= r; ++k) {
            for (int q = k; q <= r; ++q) {
                ll temp = substr(k, q);
                for (ll z : hs) {
                    if (z == temp) {
                        ++res;
                    }
                }
            }
        }
        ans.push_back( res );
    }
    for (int i : ans) cout << i << " ";
    return 0;
}