#include<bits/stdc++.h>

#define pb push_back
#define ld  double
#define all(a) a.begin(), a.end()
#define ll long long

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 5e6 + 10, M = 1e6 + 10;
vector<pair<int, int>> need[N];
map<char, int> go[M];
bool term[M];
int Link[M], d[M], par[M];

int now = 2;
bool used[26];

void add(string &s) {
    int v = 1;
    for (auto to : s) {
        used[to - 'a'] = 1;
        if (!go[v].count(to)) {
            if (now >= M) while(1);
            d[now] = d[v] + 1;
            go[v][to] = now++;
        }
        v = go[v][to];
    }
    term[v] = 1;
}

int kek[N];

void inc(int i) {
    for (; i < N; i = (i | (i + 1))) {
        kek[i] += 1;
    }
}

int get(int r) {
    int ans = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        ans += kek[r];
    }
    return ans;
}

int get(int l, int r) {
    return get(r) - get(l - 1);
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    for (auto to : t) {
        used[to - 'a'] = 1;
    }
    vector<string> s(n);
    vector<int> ans(m);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        need[r].pb({l, i});
    }
    for (int i = 0; i < n; i++) {
        add(s[i]);
    }
    vector<char> mas;
    for (int i = 0; i < 26; i++) {
        if (used[i]) {
            mas.pb(i + 'a');
        }
    }
    deque<int> q{1};
    par[1] = 1;
    while (q.size() > 0) {
        int v = q.front();
        q.pop_front();
        for (auto c : mas) {
            if (!go[v].count(c)) {
                if (v == 1) {
                    go[v][c] = 1;
                } else {
                    go[v][c] = go[Link[v]][c];
                }
            } else {
                int u = go[v][c];
                q.pb(u);
                if (v == 1) {
                    Link[u] = 1;
                } else {
                    Link[u] = go[Link[v]][c];
                }
                if (term[Link[u]]) {
                    par[u] = Link[u];
                } else {
                    par[u] = par[Link[u]];
                }
            }
        }
    }
    int v = 1;
    for (int i = 0; i < t.size(); i++) {
        v = go[v][t[i]];
        int u = v;
        while (u != 1) {
            if (term[u]) {
                inc(i - d[u] + 1);
            }
            u = par[u];
        }
        for (auto to : need[i]) {
            ans[to.second] = get(to.first, i);
        }
    }
    for (int i = 0; i < m; i++) {
        cout << ans[i] << ' ';
    }
    cout << endl;
    return 0;
}
