#include <bits/stdc++.h>
#define int long long
#define double long double

using namespace std;

const int alphabet = 26;

struct vertex{
    int e[alphabet];
    int p, s_l;
    vertex() {
        for (int i = 0; i < alphabet; ++i) {
            e[i] = -1;
        }
        p = -1; s_l = -1;
    }
};

vector <vertex> sf;
int len = 1, last = 0;

void add(int c) {
    int new_last;
    if (sf[last].e[c] != -1) {
        if (sf[sf[last].e[c]].p == last) {
            last = sf[last].e[c];
            return;
        }
        int bad = sf[last].e[c];
        sf.emplace_back();
        for (int j = 0; j < alphabet; ++j) {
            sf[len].e[j] = sf[bad].e[j];
        }
        sf[len].p = last;
        sf[len].s_l = sf[bad].s_l;
        sf[bad].s_l = len;
        while (last >= 0 && sf[last].e[c] == bad) {
            sf[last].e[c] = len;
            last = sf[last].s_l;
        }
        last = len;
        len++;
        return;
    } else {
        sf.emplace_back();
        new_last = len;
        sf[new_last].p = last;
        sf[new_last].s_l = 0;
        len++;
    }
    for (int i = last; i >= 0; i = sf[i].s_l) {
        if (sf[i].e[c] == -1) {
            sf[i].e[c] = new_last;
        } else {
            if (sf[sf[i].e[c]].p == i) {
                sf[new_last].s_l = sf[i].e[c];
                break;
            }
            int bad = sf[i].e[c];
            sf.emplace_back();
            for (int j = 0; j < alphabet; ++j) {
                sf[len].e[j] = sf[bad].e[j];
            }
            sf[len].p = i;
            sf[len].s_l = sf[bad].s_l;
            sf[bad].s_l = len;
            sf[new_last].s_l = len;
            while (i >= 0 && sf[i].e[c] == bad) {
                sf[i].e[c] = len;
                i = sf[i].s_l;
            }
            len++;
            break;
        }
    }
    last = new_last;
}

const int maxn = 5e6;

vector <int> g[maxn], st[maxn];
int pr[maxn];

void calc_p(int v, int pref) {
    pr[v] = pref;
    //cout << v << ' ' << pref << "\n";
    int dt = st[v].size();
    for (auto u : g[v]) {
        calc_p(u, pref + dt);
    }
}

mt19937 rnd(time(0));

void solve() {
    sf.clear();
    len = 1; last = 0;
    sf.emplace_back();
    int n, m;
    if (1) cin >> n >> m;
    else {
        n = 3;
        m = 1;
    }
    string t = ""; int k;
    if (1) {
        cin >> t;
    } else {
        k = 5;
        for (int i = 0; i < k; ++i) {
            char dt = (rnd() % 2 + 'a');
            t = t + dt;
        }
    }
    k = t.size();
    for (int i = 0; i < k; ++i) {
        add(t[i] - 'a');
    }
    vector <string> str(n);
    for (int i = 0; i < n; ++i) {
        string s = ""; int ln;
        if (1) {
            cin >> s;
        } else {
            ln = 2;
            for (int i = 0; i < ln; ++i) {
                char dt = (rnd() % 2 + 'a');
                s = s + dt;
            }
        }
        last = 0;
        str[i] = s;
        ln = s.size();
        for (int j = 0; j < ln; ++j) {
            add(s[j] - 'a');
        }
        st[last].push_back(ln);
    }
    for (int i = 1; i < len; ++i) {
        g[sf[i].s_l].push_back(i);
    }
    calc_p(0, 0);
    for (int i = 0; i < m; ++i) {
        int l, r;
        if (1) {
            cin >> l >> r;
            l--; r--;
        } else {
            l = rnd() % k;
            r = rnd() % (k - l) + l;
        }
        int res = 0;
        int ind = 0;
        for (int j = l; j <= r; ++j) {
            ind = sf[ind].e[t[j] - 'a'];
            res += pr[ind];
            res += (upper_bound(st[ind].begin(), st[ind].end(), j - l + 1) - st[ind].begin());
        }
        
        cout << res << "\n";
        
    }
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    }
    int t; t = 1;
    while (t--) {
        solve();
    }
    return 0;
}

