#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <iostream>
#include <fstream>
#include <climits>
using namespace std;
#define int long long
int ot = LLONG_MAX;
vector <int> t;
int maxsize = 0;
int get(int v, int l, int r, int tl, int tr) {
    if (l > r)
        return 0;
    if (tl == l && tr == r) {
        return t[v];
    }
    int q = (l + r) / 2;
    if (tr<=q) {
      return  get(v*2+2, l, q, tl, tr);
    }
    if (q<tl) {
      return  get(v*2+1, q + 1, r, tl, tr);
    }
    return get(v * 2 + 2, l, q, tl, q) + get(v * 2 + 1, q + 1, r, q + 1, tr);
}

void update(int v, int l, int r, int tl, int tr) {
    if (l > r)
        return;
    if (tl == l && tr == r) {
        t[v]++;
        return;
    }
    int q = (l + r) / 2;
    if (q < tl) {
        update(v * 2 + 1, q+1, r, tl, tr);
    }
    else
    if (tr <= q) {
        update(v * 2 + 2, l, q, tl , tr);
    }
    else {
        update(v * 2 + 2, l, q, tl, q);
        update(v * 2 + 1, q + 1, r, q + 1, tr);
    }
    t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}
int n, m;
int32_t main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n>>m;
    string s;
    cin >> s;
    t.resize(s.size() * 4, 0);
    set <string> q;
    for (int i = 0; i < n; i++) {
        string r;
        cin >> r;
        maxsize = max(maxsize, int(r.size()));
        q.insert(r);
    }
    int kol = 0;
    vector <pair <int, int>> otvet;
    for (int i = 0; i < s.size(); i++) {
        string f = "";
        for (int j = i; j < min(i + maxsize, int(s.size())); j++) {
            f += s[j];
            if (q.find(f) != q.end()) {
                //update(0, 0, s.size() - 1, i, j);
                otvet.push_back({ i,j });
            }
        }
    }
   // cout << kol;
   //  cout << get(0, 0, s.size() - 1, 0, 4);
    cout << endl;
    sort(otvet.begin(), otvet.end());
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
         kol = 0;
        for (int c = 0; c < otvet.size(); c++) {
            if (x<=otvet[c].first && y>=otvet[c].second) {
                kol++;
            }
        }
        cout << kol<<" ";
    }
    int fsfs = 0;
 
}