#include <bits/stdc++.h>
#define ff first
#define ss second
#ifndef LOCAL
#define endl '\n'
#endif
//#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1000000009;
const ll inf18 = 1000000000000000018;

template <class T1, class T2> istream& operator>>(istream &is, pair <T1, T2> &a) {is >> a.ff >> a.ss; return is;}
template <class T1, class T2> ostream& operator<<(ostream &os, pair <T1, T2> a) {os << "(" << a.ff << ", " << a.ss << ")"; return os;}
template <class T> istream& operator>>(istream &is, vector <T> &a) {for (auto &x : a) is >> x; return is;}
template <class T> ostream& operator<<(ostream &os, vector <T> a) {for (auto x : a) os << x << " "; os << endl; return os;}

template <int M>
struct Modular{
    int value = 0;
    const static int MOD_value = M;
    Modular () {value = 0;}
    Modular (int x) {value = x;}
    Modular (ll x) {value = x % M;}

    Modular& operator+=(Modular x) {value += x.value; if (value >= M) value -= M; return *this;}
    Modular& operator-=(Modular x) {value -= x.value; if (value < 0) value += M; return *this;}
    Modular& operator*=(Modular x) {value = 1ll * value * x.value % M; return *this;}

    static Modular binpow(Modular x, int y) {Modular c = 1; while (y) {if (y & 1) c *= x; y >>= 1; x *= x;} return c;}
    static Modular inverse(Modular x) {return binpow(x, M - 2);}

    friend Modular operator+(Modular x, Modular y) {x += y; return x;}
    friend Modular operator-(Modular x, Modular y) {x -= y; return x;}
    friend Modular operator*(Modular x, Modular y) {x *= y; return x;}

    friend istream& operator>>(istream &is, Modular &x) {is >> x.value; return is;}
    friend ostream& operator<<(ostream &os, Modular x) {os << x.value; return os;}
};
const int M = 1000000007, B = 10;
const ll M2 = ll(M) * M;
using mint = Modular<M>;

const int N = 5000010, T = 50010, K = 1000;
mint hs[N], h[N], p[N];
string s[N];
int c[N], ln[N];
int val[T][K];

void solve(){
    p[0] = 1;
    for (int i = 1; i < N; i++) p[i] = p[i - 1] * B;
    int n, m;
    string t;
    cin >> n >> m >> t;
    for (int i = 0; i < t.size(); i++) h[i + 1] = h[i] * B + t[i] - 'a' + 1;
    int ind = 0;
    for (int i = 0; i < n; i++){
        cin >> s[ind];
        if (s[ind].size() > t.size()) continue;
        mint hi = 0;
        for (auto x : s[ind]) hi = hi * B + x - 'a' + 1;
        hs[ind] = hi;
        c[ind] = s[ind].size();
        ind++;
    }
    n = ind;
    sort(c, c + n);
    int len = 1;
    for (int i = 0; i < n; i++) if (c[i] != c[len - 1]) c[len++] = c[i];
    for (int i = 0; i < n; i++) ln[i] = lower_bound(c, c + len, s[i].size()) - c;
    for (int i = 0; i <= t.size(); i++){
        for (int j = 0; j < n; j++){
            int sz = s[j].size();
            if (sz <= i && (h[i] - h[i - sz] * p[sz]).value == hs[j].value){
                val[i][ln[j]]++;
            }
        }
        for (int j = 0; j < len; j++){
            val[i + 1][j] += val[i][j];
            //cout << val[i][j] << " ";
        }
        //cout << endl;
    }
    while (m--){
        int l, r;
        cin >> l >> r;
        l--;
        ll ans = 0;
        for (int i = 0; i < len; i++){
            int siz = c[i];
            if (l + siz > r) break;
            ans += val[r][i] - val[l + siz - 1][i];
        }
        cout << ans << " ";
    }
}

int32_t main(){
#ifdef LOCAL
    auto st = clock();
#else
    ios_base::sync_with_stdio(false); cin.tie(0);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) solve();
#ifdef LOCAL
    cout << endl << "TIME: " << (clock() - st) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
}