#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <unordered_set>
#include <deque>
#include <random>


using namespace std;

typedef long long ll;

mt19937 rnd('r' + 'o' + 'b' + 'i' + 'v' + 'i' + 'r' + 't');

const int buben = 190;
const int base1 = 179, mod1 = 1e9 + 1329;
const int base2 = 239, mod2 = 1e9 + 7;

int addm(int a, int b, int m) {
	return (a + b) % m;
}

int subm(int a, int b, int m) {
	return ((a - b) % m + m) % m;
}

int mulm(int a, int b, int m) {
	return (ll)a * b % m;
}

int bin_pow(int a, int n, int m) {
	if (n == 0) {
		return 1;
	}
	if (n % 2 == 0) {
		int b = bin_pow(a, n / 2, m);
		return mulm(b, b, m);
	}
	else {
		return mulm(a, bin_pow(a, n - 1, m), m);
	}
}

ll gcd(ll a, ll b) {
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}

vector<ll> gcdex(ll a, ll b) {
	if (b == 0) {
		return { a, 0, a };
	}
	else {
		vector<ll> aaa = gcdex(b, a % b);
		return { aaa[1], aaa[0] - (a / b) * aaa[1], aaa[2] };
	}
}

vector<int> solve(int l, int r, int k, ll summ_l = 0, ll summ_r = 0) {
	if (l == r) {
		return { l };
	}
	ll mid = (l + r) / 2;

	cout << '?' << ' ' << mid << endl;
	ll aaa;
	cin >> aaa;

	vector<int> a, b;
	if (aaa - summ_l != (ll)mid * (mid + 1) / 2 - (ll)l * (l - 1) / 2) {
		// cout << '@' << l << ' ' << r << ' ' << mid << ' ' << k << ' ' << summ_l << ' ' << summ_r << '\n';
		if (2 * mid + 1 > r && (ll)r * (r + 1) / 2 - (ll)mid * (mid + 1) / 2 - (summ_r - aaa) <= r) {
			a = solve(l, mid, k, summ_l, aaa);
		}
		else if (k == 3 && (summ_r - aaa != (ll)r * (r + 1) / 2 - (ll)mid * (mid + 1) / 2)) {
			a.push_back((ll)mid * (mid + 1) / 2 - (ll)l * (l - 1) / 2 - (aaa - summ_l));
		}
		else {
			a = solve(l, mid, k, summ_l, aaa);
		}
	}
	if (summ_r - aaa != (ll)r * (r + 1) / 2 - (ll)mid * (mid + 1) / 2) {
		if (2 * mid + 1 > r && (ll)r * (r + 1) / 2 - (ll)mid * (mid + 1) / 2 - (summ_r - aaa) <= r) {
			a.push_back((ll)r * (r + 1) / 2 - (ll)mid * (mid + 1) / 2 - (summ_r - aaa));
		}
		else {
			b = solve(mid + 1, r, k, aaa, summ_r);
		}
	}
	for (auto el : b) {
		a.push_back(el);
	}
	return a;
}

struct Node {
	int cnt = 0;
	Node* go[26] = { nullptr };

	Node() {

	}
};

void add_string(Node *v, string& s, int idx = 0) {
	if (idx == s.size()) {
		v->cnt = 1;
		return;
	}
	if (v->go[s[idx] - 'a'] == nullptr) {
		v->go[s[idx] - 'a'] = new Node();
	}
	add_string(v->go[s[idx] - 'a'], s, idx + 1);
}


int aaa[buben][(int)2e5 + 228];
string arr[(int)5e5 + 2];
int z[(int)1e6 + 228];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, q;
	cin >> n >> q;
	string t;
	cin >> t;
	
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	sort(arr, arr + n, [](string& a, string& b) {
		return a.size() < b.size();
		});
	vector<vector<int>> inds;
	int asdf = 0;
	for (int i = 0; i < n; i++) {
		if (arr[i].size() >= buben) {
			asdf++;
		}
	}
	inds.resize(asdf);
	for (int i = 0; i < asdf; i++) {
		inds[i].resize(t.size() + 1);
	}
	asdf = 0;
	vector<int> blabla;

	Node* root = new Node();
	for (int i = 0; i < n; i++) {
		if (arr[i].size() >= buben) {
			string p = arr[i] + "#" + t;
			for (int j = 1, l = 0, r = 0; j < p.size(); j++) {
				z[j] = 0;
				if (r >= j) {
					z[j] = min(r - j + 1, z[j - l]);
				}
				while (j + z[j] < p.size() && p[z[j]] == p[j + z[j]]) {
					z[j]++;
				}
				if (j + z[j] - 1 > r) {
					l = j;
					r = j + z[j] - 1;
				}
			}
			blabla.push_back(i);
			for (int j = arr[i].size() + 1; j < p.size(); j++) {
				if (z[j] == arr[i].size()) {
					inds[asdf][j - arr[i].size()]++;
				}
			}
			for (int j = 1; j <= t.size(); j++) {
				inds[asdf][j] += inds[asdf][j - 1];
			}
			asdf++;
		}
		else {
			add_string(root, arr[i], 0);
		}
	}
	for (int i = 0; i < t.size(); i++) {
		Node* tmp = root;
		for (int len = 1; len < buben && len + i <= t.size(); len++) {
			if (tmp->go[t[i + len - 1] - 'a'] == nullptr) {
				break;
			}
			tmp = tmp->go[t[i + len - 1] - 'a'];
			aaa[len][i + 1] = tmp->cnt;
		}
	}
	for (int len = 1; len < buben; len++) {
		for (int j = 1; j <= t.size(); j++) {
			aaa[len][j] += aaa[len][j - 1];
		}
	}

	vector<vector<int>> bbb(buben, vector<int>(t.size() + 1));
	for (int len = 1; len < buben; len++) {
		for (int i = 0; i <= t.size(); i++) {
			bbb[len][i] = bbb[len - 1][i] + aaa[len][i];
		}
	}
	vector<vector<int>> ccc(buben, vector<int>(t.size() + 5));
	for (int len = 1; len < buben; len++) {
		for (int i = len; i <= t.size(); i++) {
			ccc[len][i] = ccc[len - 1][i] + aaa[i - len + 1][i];
		}
	}

	while (q--) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		ll ans = 0;
		ans -= bbb[min(r - l + 1, buben - 1)][l];
		ans += ccc[min(r - l + 1, buben - 1)][r + 1];
		/*for (int len = 1; len < buben; len++) {
			int l1 = l, r1 = r - len + 1;
			// r - len + 1 >= l
			// r - l + 1 >= len
			if (l1 > r1) {
				break;	
			}
			ans += aaa[len][r1 + 1] - aaa[len][l1];
		}*/
		int ooo = 0;
		for (auto el : blabla) {
			int len = arr[el].size();
			if (r - len + 2 >= l) {
				ans += inds[ooo][r - len + 2] - inds[ooo][l];
			}
			ooo++;
		}

		cout << ans << '\n';
	}
	/*int t;
	cin >> t;
	while (t--) {
		int n, k;
		cin >> n >> k;
		cout << '?' << ' ' << n << endl;
		ll aaa;
		cin >> aaa;
		vector<int> ans = solve(1, n, k, 0, aaa);
		cout << '!' << ' ';
		for (auto el : ans) {
			cout << el << ' ';
		}
		cout << endl;
		cin >> aaa;
	}*/
	/*int  t;
	cin >> t;
	while (t--) {
		int n, k;
		cin >> n >> k;
		int idx = 0;
		vector<int> ans;
		map<int, ll > eee;
		ll summ = 0;
		ll LAST = 0;
		for (int i = 1; i <= n; i += k) {
			int L = i, R = min(i + k - 1, n);
			cout << '?' << ' ' << R << endl;
			ll aaa;
			cin >> aaa;
			if (aaa - LAST == (ll)R * (R + 1) / 2 - (ll)L * (L - 1) / 2) {
				LAST = aaa;
				continue;
			}
			else {
				ll idx = L - 1;
				while (1) {
					ll l = idx, r = R + 1;
					while (l + 1 < r) {
						ll mid = (l + r) / 2;
						cout << '?' << ' ' << mid << endl;
						ll aaa;
						cin >> aaa;
						if (mid * (mid + 1) / 2 - summ == aaa) {
							l = mid;
						}
						else {
							r = mid;
						}
					}
					if (l == R) {
						break;
					}
					idx = r;
					ans.push_back(r);
					summ += r;
				}
			}
		}
		cout << '!' << ' ';
		for (auto el : ans) {
			cout << el << ' ';
		}
		cout << endl;
		int aaa;
		cin >> aaa;
		for (int i = 0; i < k; i++) {
			if (i == k - 1) {
				cout << '?' << ' ' << n << endl;
				ll aaa;
				cin >> aaa;
				ans.push_back((ll)n * (n + 1) / 2 - aaa - summ);
			}
			else {
				int L = idx, R = n;
				while (L + 1 < R) {
					int mid = (L + R) / 2;
					cout << '?' << ' ' << mid << endl;
					ll aaa;
					if (eee.find(mid) != eee.end()) {
						aaa = eee[mid];
					}
					cin >> aaa;
					eee[mid] = aaa;
					if ((ll)mid * (mid + 1) / 2 - summ == aaa) {
						L = mid;
					}
					else {
						R = mid;
					}
				}
				summ += R;
				ans.push_back(R);
				idx = R;
			}
		}
		cout << '!' << ' ';
		for (auto el : ans) {
			cout << el << ' ';
		}
		cout << endl;
		int aaa;
		cin >> aaa;
		if (aaa == -1) {
			return 0;
		}
	}*/

	/*int n, m, p, g;
	cin >> n >> m >> p >> g;
	vector<int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector<vector<pair<int, int>>> graph(n);
	for (int i = 0; i < m; i++) {
		int a, b, w;
		cin >> a >> b >> w;
		a--, b--;
		graph[a].push_back({ b, w });
	}

	vector<pair<pair<int, int>, pair<int, int>>> dist(n, { {-1, -1}, {-1, -1} });
	dist[0] = { {0, 0}, {p, arr[0]}};
	deque<int> dq;
	dq.push_back(0);
	while (!dq.empty()) {
		int v = dq.front();
		dq.pop_front();
		for (auto to : graph[v]) {
			auto new_aaa = dist[v];
			int st_len = new_aaa.second.first;
			int base = new_aaa.first.second;
			int lenn = new_aaa.second.second;
			if (st_len >= to.second) {
				new_aaa = { {0, base}, {st_len - to.second, lenn} };
			}
			else {
				// переписать
				new_aaa = { {0, base + (to.second - st_len + lenn - 1) / lenn}, {
					lenn - ((to.second - st_len - 1) % lenn) % (new_aaa.second.second + 1), lenn}};
			}

			if (arr[to.first] > new_aaa.second.second) {
				new_aaa.second.second = arr[to.first];
			}

			if (better(dist[to.first], new_aaa)) {
				dist[to.first] = new_aaa;
				dq.push_back(to.first);
			}
		}
	}
	if (dist[n - 1].first.first == -1) {
		cout << -1 << '\n';
	}
	else {
		cout << dist[n - 1].first.second << '\n';
	}*/
	exit(0);
}