#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
#define all(x) x.begin(), x.end()
#define mem(x, y) memset(x, y, sizeof x)
#define sz(x) int(x.size())
#define int ll

const int maxn = 5010, k = 29, MOD = 1e9 + 7, MOD1 = 1e9 + 9;

int mod(int x) {
	x %= MOD;
	while (x < 0) x += MOD;
	return x;
}
int mod1(int x) {
	x %= MOD1;
	while (x < 0) x += MOD1;
	return x;
}

ull h[maxn], h1[maxn], p[maxn], p1[maxn];
ull substr(int l, int r) {
	return mod(h[r] - h[l - 1] * p[r - l + 1]);
}
ull substr1(int l, int r) {
	return mod1(h1[r] - h1[l - 1] * p1[r - l + 1]);
}

int dp[maxn][maxn];

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	
	p[0] = 1;
	for (int i = 1; i < maxn; i++) p[i] = mod(p[i - 1] * k);
	p1[0] = 1;
	for (int i = 1; i < maxn; i++) p1[i] = mod(p1[i - 1] * k);
	
	int m, q;
	cin >> m >> q;
	
	string s;
	cin >> s;
	int n = sz(s); s = " " + s;
	for (int i = 1; i <= n; i++) h[i] = mod(h[i - 1] * k + s[i] - 'a' + 1);
	for (int i = 1; i <= n; i++) h1[i] = mod1(h1[i - 1] * k + s[i] - 'a' + 1);
	
	set <ull> st, st1;
	for (int i = 0; i < m; i++) {
		string t;
		cin >> t;
		ull w = 0, e = 0;
		for (int i = 0; i < sz(t); i++) w = mod(w * k + t[i] - 'a' + 1);
		for (int i = 0; i < sz(t); i++) e = mod1(e * k + t[i] - 'a' + 1);
		st.insert(w);
		st1.insert(e);
	}
	
	for (int i = 1; i <= n; i++) dp[i][i] = st.count(substr(i, i)) * st1.count(substr1(i, i));
	for (int len = 2; len <= n; len++) {
		for (int l = 1, r = l + len - 1; r <= n; l++, r++) {
			dp[l][r] = dp[l + 1][r] + dp[l][r - 1] - dp[l + 1][r - 1] + st.count(substr(l, r)) * st1.count(substr1(l, r));
		}
	}
	
	while (q--) {
		int l, r;
		cin >> l >> r;
		cout << dp[l][r] << ' ';
	}
	
	return 0;
}
