#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
#define all(x) x.begin(), x.end()
#define mem(x, y) memset(x, y, sizeof x)
#define sz(x) int(x.size())
#define int ll

const int maxn = 5010;
int dp[maxn][maxn];

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	
	int m, q;
	cin >> m >> q;
	
	string s;
	cin >> s;
	int n = sz(s); s = " " + s;
	
	unordered_set <string> st;
	st.rehash(m);
	for (int i = 0; i < m; i++) {
		string t;
		cin >> t;
		st.insert(t);
	}
	
	for (int i = 1; i <= n; i++) dp[i][i] = st.count(s.substr(i, 1));
	for (int len = 2; len <= n; len++) {
		for (int l = 1, r = l + len - 1; r <= n; l++, r++) {
			dp[l][r] = dp[l + 1][r] + dp[l][r - 1] - dp[l + 1][r - 1] + st.count(s.substr(l, len));
		}
	}
	
	while (q--) {
		int l, r;
		cin >> l >> r;
		cout << dp[l][r] << ' ';
	}
	
	return 0;
}
