#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;


#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define endl "\n"
#define eb emplace_back
#define lb(a, b) lower_bound(all(a), b)
#define ub(a, b) upper_bound(all(a), b)

int bubbleGum = 0;
#ifdef LOCAL
#include "Templates/DebugTemplate.cpp"
#define FAST_IO ;
#else
#define dbg(...) ++bubbleGum;
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif


const int N = 5e5 + 10, K = 1100;
int MOD, p;



int n, q;
string t;
string words[N];
int l[N], r[N];
int lenInde[N];
vec<int> inde[K];
int answer[N];
vec<int> tmp;
map<int, int> cntHashes[K];
int pows[N];

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int dice(int a, int b) {
    return uniform_int_distribution<int>(a, b)(rnd);
}

bool isSimple(int x) {
    for (int i = 2; i * i <= x; ++i)
        if (x % i == 0) return false;
    return x != 1;
}


inline int add(int one, int two) {
    return (1LL * one + two) % MOD;
}

inline int mul(int one, int two) {
    return (1LL * one * two) % MOD;
}

void prepareMod() {
    MOD = dice(1e8, 1e9);
    while (!isSimple(MOD)) ++MOD;
    p = dice(31, 100);
    while (!isSimple(p)) ++p;

    pows[0] = 1;
    for (int i = 1; i < N; ++i)
        pows[i] = mul(pows[i - 1], p);

}




void countHashes() {
    for (int i = 0; i < sz(tmp); ++i) {
        for (auto& ind : inde[i]) {
            int heh = 0;
            for (auto& ch : words[ind]) {
                heh = mul(heh, p);
                heh = add(heh, ch - 'a' + 1);
            }
            dbg(i, tmp[i], ind, heh);
            cntHashes[i][heh] += 1;
        }
    }
}




void input() {
    cin >> n >> q;
    cin >> t;
    for (int i = 0; i < n; ++i) {
        cin >> words[i];
        tmp.eb(sz(words[i]));
    }
    sort(all(tmp)); tmp.resize(unique(all(tmp)) - tmp.begin());
    for (int i = 0; i < q; ++i)
        cin >> l[i] >> r[i],
        --l[i], --r[i];

    for (int i = 0; i < sz(tmp); ++i)
        lenInde[tmp[i]] = i;

    for (int i = 0; i < n; ++i) {
        int x = lenInde[sz(words[i])];
        inde[x].eb(i);
    }

}


int pref[N];
int hah[N];

void solve() {
    fill(answer, answer + N, 0);

    for (int i = 0; i < sz(tmp); ++i) {
        int len = tmp[i];
        fill(pref, pref + n, 0);
        fill(hah, hah + n, 0);

        hah[0] = t[0] - 'a' + 1;
        for (int j = 1; j < sz(t); ++j) {
            hah[j] = mul(hah[j - 1], p);
            hah[j] = add(hah[j], t[j] - 'a' + 1);
        }

        for (int j = 0; j + len <= sz(t); ++j) {
            int heh = hah[j + len - 1];
            if (j) heh = add(heh, -mul(hah[j - 1], pows[len]));
            dbg(j, heh);
            pref[j] = (j ? pref[j - 1] : (int)0) + cntHashes[i][heh];
        }
        dbg(i, len, pref);





        for (int j = 0; j < q; ++j) {
            int le = l[j], ri = r[j] - len + 1;
            if (le <= ri)
                answer[j] += pref[ri] - (le ? pref[le - 1] : (int)0);
        }



    }

    for (int i = 0; i < q; ++i)
        cout << answer[i] << " ";

}




signed main() {
#ifdef LOCAL
    freopen("C:\\Users\\user\\CLionProjects\\OpenOlymp\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    input();
    prepareMod();
    countHashes();
    solve();

}