#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;
typedef long long ll;

const int ALPHABET_SIZE = 26;

struct bor {
    struct node {
        int ad[ALPHABET_SIZE];
        bool finish;
        node() {
            fill(ad, ad + ALPHABET_SIZE, -1);
            finish = false;
        }
    };
    vector<node> q;
    bor() {
        q.emplace_back();
    }
    void push(string& s) {
        int ind = 0;
        for (auto c: s) {
            int x = c - 'a';
            if (q[ind].ad[x] == -1) {
                q[ind].ad[x] = q.size();
                q.emplace_back();
            }
            ind = q[ind].ad[x];
        }
        q[ind].finish = true;
    }
    int get(int ind, char c) {
        return q[ind].ad[c - 'a'];
    }
};

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m; cin >> n >> m;
    string t; cin >> t;
    bor b;
    for (int i = 0; i < n; ++i) {
        string s; cin >> s;
        b.push(s);
    }
    for (int i = 0; i < m; ++i) {
        int li, ri; cin >> li >> ri;
        --li; ll cnt = 0;
        for (int x = li; x < ri; ++x) {
            int ind = 0;
            for (int y = x; y < ri; ++y) {
                ind = b.get(ind, t[y]);
                if (ind == -1) break;
                if (b.q[ind].finish) ++cnt;
            }
        }
        cout << cnt << ' ';
    }
}