#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;
typedef long long ll;

vector<int> z_func(string& s) {
    int n = (int)s.size();
    vector<int> z(n, 0);
    int l = 0, r = 0;
    for (int i = 1; i < n; ++i) {
        z[i] = max(0, min(r - i, z[i - l]));
        while (i + z[i] < n && s[z[i]] == s[i + z[i]]) ++z[i];
        if (i + z[i] > r) l = i, r = i + z[i];
    }
    return z;
}

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m; cin >> n >> m;
    string t, e; cin >> t;
    vector<tuple<int, int, int>> q;
    int ind = 0, cnt = 0;
    for (int i = 0; i < n; ++i) {
        string s; cin >> s;
        e = s + "#" + t;
        auto z = z_func(e);
        for (size_t j = s.size() + 1; j < s.size() + t.size() + 1; ++j) {
            if (z[j] == s.size()) {
                q.emplace_back(j - s.size() - 1, 2, ind);
                q.emplace_back(j - 1, -2, ind++);
                cnt++;
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        int li, ri; cin >> li >> ri;
        --li;
        q.emplace_back(li, 1, i);
        q.emplace_back(ri, 0, i);
    }
    sort(all(q));
    vector<pair<pair<int, int>, pair<int, int>>> w(m);
    int left = 0, right = 0, sz = (int)q.size();
    for (int i = 0; i < sz; ++i) {
        auto [x, y, z] = q[i];
        if (abs(y) == 2) {
            if (y == 2) ++left;
            else ++right;
        }
        else {
            if (y == 1) w[z].first = {left, right};
        }
    }
    left = 0, right = 0;
    for (int i = sz - 1; i >= 0; --i) {
        auto [x, y, z] = q[i];
        if (abs(y) == 2) {
            if (y == 2) ++left;
            else ++right;
        }
        else {
            if (y == 0) w[z].second = {left, right};
        }
    }
    for (int i = 0; i < m; ++i) {
        cout << cnt - (w[i].first.first + w[i].second.second) << ' ';
    }
}