#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
using namespace __gnu_pbds;
using namespace std;

template<typename Ty, class Compare = less<Ty>>
using ordered_set = tree<Ty, null_type, Compare, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ull = unsigned long long;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using vll = vector<ll>;
using vvll = vector<vll>;
using pii = pair<int, int>;

#define mk make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

//#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,popcnt")

/*

*/

constexpr ll md = 1e9 + 9;
constexpr ll p = 31;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, m; cin >> n >> m;
    string t; cin >> t;
    int S = t.size();
    vector<string> s(n);
    vi pos(n);
    for (int i = 0; i < n; ++i) cin >> s[i];
    for (int i = 0; i < n; ++i)
    {
        pos[i] = t.size();
        t += s[i];
    }
    int T = t.size();
    vll pw(T + 1);
    pw[0] = 1;
    for (int i = 1; i < T + 1; ++i)
    {
        pw[i] = (pw[i - 1] * p) % md;
    }
    vll hs(T + 1);
    hs[0] = 0;
    for (int i = 0; i < T; ++i)
    {
        hs[i + 1] = hs[i] + ((t[i]-'a') + 1)*pw[i];
        hs[i + 1] %= md;
    }
    auto hs_substr = [&](int l, int r)->ll
    {
        ll diff = (hs[r] - hs[l] + md) % md;
        return (diff * pw[T - l]) % md;
    };
    vi hss(n);
    for (int i = 0; i < n; ++i)
    {
        hss[i] = hs_substr(pos[i], pos[i] + s[i].size());
    }
    vvi spos(n);
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j + s[i].size() <= S; ++j)
        {
            if (hs_substr(j, j + s[i].size()) == hss[i])
            {
                spos[i].push_back(j);
            }
        }
    }
    while (m--)
    {
        int l, r; cin >> l >> r;
        --l;
        ll ans = 0;
        for (int i = 0; i < n; ++i)
        {
            auto first = lower_bound(all(spos[i]), l);
            auto second = upper_bound(all(spos[i]), max(r - int(s[i].size()), 0));
            ans += second - first;
        }
        cout << ans << " ";
    }
    return 0;
}
