#include "bits/stdc++.h"
#include <chrono>
#include <random>

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

#define int ll

//vector<int> have = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
vector<int> have = { 1,3,4,5,7,9 };
vector<int> know;

int ask(int p) {
	int need = p * (p + 1) / 2;
	for (int x : know)
		if (x <= p)
			need -= x;

	int sum = 0;
#ifdef LOCAL
	for (int x : have)
		if (x <= p)
			sum += x;
#else
	cout << "? " << p << endl;
	cin >> sum;
#endif
	return need - sum;
}

void solve_case() {
	know.clear();

	int n, k; cin >> n >> k;

	if (n <= 1000) {
		for (int i = 1; i + 1 <= n; i += 2) {
			int sum = ask(i + 1);
			if (sum == i + 1) {
				know.push_back(i + 1);
			}
			else if (sum == i) {
				know.push_back(i);
			}
			else if (sum) {
				know.push_back(i);
				know.push_back(i + 1);
			}
		}

		if (n % 2 == 1) {
			int sum = ask(n);
			if (sum == n)
				know.push_back(n);
		}

		cout << "! ";
		for (int x : know)
			cout << x << " ";
		cout << endl;

		int useless; cin >> useless;

		return;
	}
	if (k == 3) {
		int sum = ask(n);
		int mid = (sum + 2) / 3;
		int left = ask(mid), right = sum - left;

		int a = -1, b = -1, c = -1;

		int m2 = ask(left / 2);
		if (m2 != left && m2) {
			a = m2;
			b = left - m2;
			c = right;
		}
		else {
			a = left;
			know.push_back(a);
			int m3 = ask(right / 2);
			b = m3;
			c = right - m3;
		}

		cout << "! " << a << " " << b << " " << c << endl;

		int useless; cin >> useless;

		return;
	}
	if (k == 4) {
		{
			int l = 0, r = n;
			while (r - l > 1) {
				int m = (l + r) / 2;

				int sum = ask(m);
				if (sum)
					r = m;
				else
					l = m;
			}

			know.push_back(r);
		}

		int sum = ask(n);
		int mid = (sum + 2) / 3;
		int left = ask(mid), right = sum - left;

		int a = -1, b = -1, c = -1;

		int m2 = ask(left / 2);
		if (m2 != left && m2) {
			a = m2;
			b = left - m2;
			c = right;
			know.push_back(a);
			know.push_back(b);
			know.push_back(c);
		}
		else {
			a = left;
			know.push_back(a);
			int m3 = ask(right / 2);
			b = m3;
			c = right - m3;
			know.push_back(b);
			know.push_back(c);
		}

		cout << "! ";
		for (int x : know)
			cout << x << " ";
		cout << endl;

		int useless; cin >> useless;

		return;
	}

	for (int i = 1; i <= 10; i++)
		if (ask(i))
			know.push_back(i);

	function<void(int, int, int)> solve = [&](int l, int r, int sum) {
		if (!sum) {
			return;
		}
		if (l <= sum && sum < r) {
			know.push_back(sum);
			return;
		}

		int m = (l + r) / 2;
		int left = ask(m - 1);
		int right = sum - left;

		solve(l, m, left);
		solve(m, r, right);
	};
	solve(1, n + 1, ask(n));

	cout << "! ";
	for (int x : know)
		cout << x << " ";
	cout << endl;

	int useless; cin >> useless;
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
#ifndef LOCAL
	cin >> T;
#endif

	while (T--) {
		solve_case();
	}

	return 0;
}