#include <bits/stdc++.h>

using namespace std;

const int mod = 1e9 + 7;
const int P = 31;

int sm(int a, int b) {
    return (a + b) % mod;
}
int mlt(int a, int b) {
    return (a * b) % mod;
}
int bp(int a, int n) {
    if (n == 0)
        return 1;
    if (n & 1)
        return mlt(a, bp(a, n - 1));
    int t = bp(a, n / 2);
    return mlt(t, t);
}
int dv(int a, int b) {
    return mlt(a, bp(b, mod - 2));
}

vector<int> pp;

int get_hash(string &s) {
    int n = (int)s.size();
    int p = 1;
    int hash = 0;
    for (int i = 0; i < n; ++i) {
        hash = sm(hash, mlt(s[i] - 'a' + 1, p));
        p = mlt(p, P);
    }
    return hash;
}

void add(int &hash, char c, int ln) {
    hash = sm(hash, mlt(c - 'a' + 1, pp[ln]));
}

signed main() {
//    cout << 100 * 100 * 100 / 1e8 << '\n';
    int n, m;
    cin >> n >> m;
    string t; cin >> t;

    pp.resize(1e6 + 5, 1);
    for (int i = 1; i < (int)pp.size(); ++i) {
        pp[i] = mlt(pp[i - 1], P);
    }
    vector<string> v(n);
    for (auto &s : v)
        cin >> s;

    set<pair<int, int>> hsh;
    for (auto &s : v)
        hsh.insert({(int)s.size(), get_hash(s)});

    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r; --l; --r;
        int res = 0;

        for (int st = l; st <= r; ++st) {
            int hash = 0;
            for (int fin = st; fin <= r; ++fin) {
                add(hash, t[fin], fin - st);
                if (hsh.count({fin - st + 1, hash}))
                    res++;
            }
        }
        cout << res << ' ';
    }
}