#include <bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define endl '\n'
typedef long long ll;
using namespace std;

const ll MOD = 1e9 + 7;
const ll p = 239;

void solve() {
    int n, m, q;
    string t;
    cin >> m >> q >> t;

    n = t.size();

    vector<ll> h(n + 1);

    vector<ll> ps(n + 1);
    ps[0] = 1;

    for (int i = 1; i <= n; i++) {
        ps[i] = (ps[i - 1] * p) % MOD;
        h[i] = (h[i - 1] * p + t[i - 1] - 96) % MOD;
    }

    map<ll, vector<pair<int, int>>> d;
    for (int j = 1; j <= n; j++) {
        for (int i = j; i > 0; i--) {
            ll s = (h[j] - (h[i - 1] * ps[j - i + 1]) % MOD + MOD) % MOD;
            d[s].push_back({i, j});
        }
    }

    vector<vector<int>> ans(n + 1);

    for (int i = 0; i < m; i++) {
        string s;
        cin >> s;
        ll h = 0;
        for (int i = 1; i <= s.size(); i++) {
            h = (h * p + s[i - 1] - 96) % MOD;
        }
        for (auto [l, r] : d[h]) {
            ans[r].push_back(l);
        }
    }


    while (q--) {
        int l, r;
        cin >> l >> r;
        int a = 0;
        for (int i = l; i <= r; i++) {
            a += ans[i].size() - (lower_bound(all(ans[i]), l) - ans[i].begin());
        }
        cout << a << " ";
    }
    cout << endl;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
