#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define f(n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ordered_set tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>
#define pb push_back

typedef long long ll;
typedef vector<int> vei;
typedef string str;


struct Hashes {
    ll p = 179, mod = 1e9+7;
    vector<ll> ps;
    vector<ll> hash;
    int n;
    Hashes(string s) {
        n = s.size();
        ps.resize(n+1);
        ps[0] = 1;
        hash.resize(n+1);
        for(int i = 0; i < n; ++i) {
            ps[i+1] = ps[i] * p % mod;
            hash[i+1] = (hash[i] * p + (s[i] - 'a' + 1)) % mod;
        }
    }

    int get_hash(int l, int sz) {
        return ((hash[l + sz] - hash[l] * ps[sz])%mod+mod)%mod;
    }
};

bool cmp(pair<int, gp_hash_table<int, int>> a, pair<int, gp_hash_table<int, int>> b) {
    return a.first < b.first;
}



void solve() {
    int n, m;
    cin>>n>>m;
    str s;
    cin>>s;
    Hashes au(s);
    map<int, int> gt2;
    vector<pair<int, gp_hash_table<int, int>>> gt;
    vector<int> szs(n);
    vector<vector<int>> prs(n, vector<int>(s.size()+1));
    gt.pb({-1, {}});
    f(n) {
        str t;
        cin>>t;
        szs[i] = t.size();
        if(t.size() > s.size()) continue;
        Hashes tt(t);
        for(int j = 0; j + t.size() <= s.size(); ++j) {
            if(au.get_hash(j, t.size())==tt.get_hash(0, t.size())) {
                prs[i][j+1]++;
            }
            prs[i][j+1] += prs[i][j];
        }
    }
    f(m) {
//        cout<<i<<endl;
        int l, r;
        cin>>l>>r;
        int ans = 0;
        --l;
        for(int j = 0; j < n; ++j) {
            if(szs[j] > r - l) continue;
            ans += prs[j][r-szs[j]+1] - prs[j][l];
        }
        cout<<ans<<' ';
    }
}

signed main() {
    cout<<fixed<<setprecision(15);
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int tc = 1;
//    cin>>tc;
    for(int i = 0; i < tc; ++i) {
        // cout << "Test case: " << i+1 << endl;
        solve();
    }
    return 0;
}