#include <bits/stdc++.h>

#define ff first
#define ss second
#define FASTIO ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
typedef long long ll;

const ll MOD=1e9;
const ll P=31;

vector <vector <ll> > h, ps, os;
vector <vector <vector <ll> > > a_h;
vector <ll> p={31, 37, 41, 43}, mod={MOD+7, MOD+9, MOD+21, MOD+33};
ll n;

ll bin_pow(ll x, ll n, ll mod) {
    if (n==0) return 1;
    if (n%2==1) return (x*bin_pow(x, n-1, mod))%mod;
    ll y=bin_pow(x, n/2, mod);
    return (y*y)%mod;
}

ll geth(ll i, ll l, ll r) {
    ll x=h[i][r];
    if (l-1>=0) x=(x-h[i][l-1]+mod[i])%mod[i];
    x=(x*os[i][l])%mod[i];
    return x;
}

ll getah(ll q, ll i, ll l, ll r) {
    ll x=a_h[q][i][r];
    if (l-1>=0) x=(x-a_h[q][i][l-1]+mod[i])%mod[i];
    x=(x*os[i][l-1])%mod[i];
    return x;
}

int main()
{
    FASTIO;
    ll m;
    cin >> n >> m;
    string t;
    cin >> t;
    ll sz=t.size();
    h.resize(p.size(), vector <ll> (sz+1));
    ps.resize(p.size(), vector <ll> (sz+1));
    os.resize(p.size(), vector <ll> (sz+1));
    for (ll i=0; i<p.size(); i++) {
        ps[i][0]=1;
        for (ll j=1; j<sz; j++) ps[i][j]=(ps[i][j-1]*p[i])%mod[i];
        os[i][0]=1;
        for (ll j=1; j<sz; j++) os[i][j]=bin_pow(ps[i][j], mod[i]-2, mod[i]);
        h[i][0]=t[0]-'a'+1;
        for (ll j=1; j<sz; j++) h[i][j]=(h[i][j-1]+((t[j]-'a'+1)*ps[i][j])%mod[i])%mod[i];
    }
    a_h.resize(n);

    for (ll q=0; q<n; q++) {
        string s;
        cin >> s;
        ll r=s.size();
        if (r>sz) continue;
        a_h[q].resize(p.size(), vector <ll> (r));
        for (ll i=0; i<p.size(); i++) {
            a_h[q][i][0]=s[0]-'a'+1;
            for (ll j=1; j<r; j++) a_h[q][i][j]=(a_h[q][i][j-1]+((s[j]-'a'+1)*ps[i][j])%mod[i])%mod[i];
        }
    }
    vector <vector <ll> > f(sz+1, vector <ll> (sz));

    for (ll i=0; i<sz; i++) {
        for (ll j=0; j<n; j++) {
            if (a_h[j].empty()) continue;
            ll r=a_h[j][0].size();
            if (r+j-1>=sz) continue;
            bool fl=1;
            for (ll q=0; q<p.size(); q++) {
                fl&=(geth(q, i, i+r-1)==a_h[j][q][r-1]);
            }
            if (fl) f[r][i]++;
        }
    }
    vector <vector <ll> > pref(sz+1, vector <ll> (sz));
    for (ll i=1; i<=sz; i++) {
        pref[i][0]=f[i][0];
        for (ll j=1; j<sz; j++) pref[i][j]=pref[i][j-1]+f[i][j];
    }
    while (m--) {
        ll l, r;
        cin >> l >> r;
        l--;
        r--;
        ll ans=0;
        for (ll i=1; i<=r-l+1; i++) {
            ll kol=pref[i][r-i+1];
            if (l-1>=0) kol-=pref[i][l-1];
            ans+=kol;
        }
        cout << ans << "\n";
    }
    return 0;
}
