//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <unordered_set>

using namespace std;

#define ll long long

int mod = (int) 1e9 - 7;
int k = 31;

int add(int a, int b) {
    a += b;
    if (a >= mod) {
        a -= mod;
    }
    return a;
}

int vych(int a, int b) {
    a -= b;
    if (a < 0) {
        a += mod;
    }
    return a;
}

int mult(ll a, ll b) {
    return (a * b) % (ll) mod;
}

int st[(int) 5e6 + 1000];

vector<int> hash_(string& s) {
    int n = s.size();
    vector<int> h(n + 1, 0);
    for (int i = 0; i < n; i++) {
        h[i + 1] = add(h[i], mult((int) (s[i] - 'a') + 1, st[i]));
    }
    return h;
}

int get(int l, int r, vector<int>& h) {
    r++;
    return mult(vych(h[r], h[l]), st[(int) 5e6 + 500 - r]);
}

int kol[2001][(int) 1e5 + 1]; // 1e6 want

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    st[0] = 1;
    for (int i = 1; i < (int) 5e6 + 1000; i++) {
        st[i] = mult(st[i - 1], k);
    }
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;

    vector<int> ht = hash_(t);
    vector<vector<int>> hs(n);
    vector<int> lens(n);
    unordered_set<int> hashes;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        hs[i] = hash_(s);
        lens[i] = s.size();
        hashes.insert(mult(st[(int) 5e6 + 500 - s.size()], hs[i][s.size()]));
    }

    sort(lens.begin(), lens.end());
    lens.erase(unique(lens.begin(), lens.end()), lens.end());
    vector<int> conv((int) 1e6 + 1, -1);
    for (int i = 0; i < lens.size(); i++) {
        conv[lens[i]] = i;
    }

    for (int i = 0; i < t.size(); i++) {
        for (int len : lens) {
            if (i + len - 1 >= t.size()) {
                continue;
            }
            if (hashes.find(get(i, i + len - 1, ht)) != hashes.end()) {
                kol[conv[len]][i + 1]++;
            }
        }
    }

    for (int len = 0; len <= 1000; len++) {
        for (int i = 1; i < t.size(); i++) {
            kol[len][i + 1] += kol[len][i];
        }
    }

    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;

        ll ans = 0;
        //cout << endl << endl;
        for (int len : lens) {
            if (len > (r - l + 1)) { // can break there !!!!!!!!!!!!!!11
                continue;
            }
            int ind = conv[len];

            ans += kol[ind][(r - len + 1) + 1] - kol[ind][l];
            //cout << len <<' ' << kol[ind][(r - len + 1) + 1] - kol[ind][l] << endl;
        }
        //cout << endl;
        cout << ans << '\n';
    }
}
