#include<bits/stdc++.h>

using namespace std;
#define ll long long
#define pr pair<ll, ll>
#define all(a) a.begin(), a.end()
const int k = 26;

struct Node{
    int c=0;
    int to[k] = {0}, go[k] = {0};
    int link=0;
    int p=0;
    int term = 0;
    Node(int c, int p) : c(c), p(p) {};
};
vector<Node> t;

void add(string &s){
    int v = 0;
    for(auto i: s){
        int c = i - 'a';
        if(!t[v].to[c]) {
            t[v].to[c] = t.size();
            t.push_back(Node(c, v));
        }
        v = t[v].to[c];
    }
    t[v].term++;
}

int main(){
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    t.push_back(Node(-1, 0));
    int n ,m; cin >> n >> m;
    string s; cin >> s;
    for(int i = 0; i < n;i++){
        string s2; cin >> s2;
        add(s2);
    }
    queue<int> q;
    q.push(0);
    while(!q.empty()){

        int v = q.front();
        q.pop();
        Node &nd = t[v];
        if(v && nd.p) {
            nd.link = t[t[nd.p].link].go[nd.c];
            nd.term += t[nd.link].term;
        }
        else nd.link = 0;
        for(int i = 0; i < k;i++){
            if(nd.to[i]) {
                nd.go[i] = nd.to[i];
                q.push(nd.to[i]);
            }
            else if (v) nd.go[i] = t[nd.link].go[i];
            else nd.go[i] = 0;
        }

    }

    for(int i = 0; i < m;i++){
        int l, r; cin >> l >> r;l--;
        int v = 0;
        int res = 0;
        for(; l < r;l++){
            v = t[v].go[s[l] - 'a'];
            res += t[v].term;
        }
        cout << res << ' ';
    }
}