#include <bits/stdc++.h>

#define F first
#define S second
#define sz size()
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;


const int p = 31, mod = 1e9 + 7, N = 200, block = 500, T = 5050, S = 1e6 + 1;
long long st[S], inv_st[S], a[N], h[T], siz[N], num[N];
int pref[block][T];
int pref_big[block][T];
map <int, int> have_hash;
vvi pos(N);
vi big;

int bp (int x, int st) {
    if (st == 0) {
        return 1ll;
    }

    long long t = bp(x, st / 2);
    t *= t;
    t %= mod;

    if (st % 2 == 1) {
        t *= x;
    }
    return t % mod;
}

int get_hash (int l, int r) {
    return (((h[r] - h[l - 1] + mod) % mod) * inv_st[l - 1]) % mod;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;

    st[0] = 1;
    for (int i = 1; i < T; i++) {
        st[i] = st[i - 1] * p;
        st[i] %= mod;
        inv_st[i] = bp(st[i], mod - 2);
    }

    for (int i = 1; i <= n; i++) {
        string s;
        cin >> s;
        int ts = s.sz;
        s = '+' + s;
        long long h = 0;
        for (int i = 1; i <= ts; i++) {
            h = h + (s[i] - 'a' + 1) * st[i];
            h %= mod;
        }
        a[i] = h;
        siz[i] = ts;
        have_hash[h] = 1;
    }

    inv_st[0] = 1;
    int ts = t.sz;
    t = '+' + t;
    for (int i = 1; i <= ts; i++) {
        h[i] = h[i - 1] + (t[i] - 'a' + 1) * st[i];
        h[i] %= mod;
    }

    for (int i = 1; i <= n; i++) {
        if (siz[i] >= block) {
            if (siz[i] > ts) {
                continue;
            }
            big.pb(i);
            num[i] = big.sz - 1;
            for (int j = 1; j + siz[i] - 1 <= ts; j++) {
                int hs = get_hash(j, j + siz[i] - 1);
                if (hs == a[i]) {
                    pref_big[num[i]][j] = 1;
                }
                pref_big[num[i]][j] += pref_big[num[i]][j - 1];
            }
        }
    }


    for (int len = 1; len < block; len++) {
        for (int j = 1; j + len - 1 <= ts; j++) {
            int hs = get_hash(j, j + len - 1);
            pref[len][j] = have_hash[hs];
            pref[len][j] += pref[len][j - 1];
        }
    }


    for (int it = 1; it <= m; it++) {
        int l, r;
        cin >> l >> r;

        int ans = 0;
        for (int len = 1; len < block; len++) {
            if (l + len - 1 > r) {
                break;
            }
            ans += pref[len][r - len + 1] - pref[len][l - 1];
        }

        for (int i = 0; i < big.sz; i++) {
            int cur_num = big[i];
            if (l + siz[cur_num] - 1 > r) {
                continue;
            }
            int cur_r = r - siz[cur_num] + 1;
            ans += pref_big[i][cur_r] - pref_big[i][l - 1];
        }
        cout << ans << " ";
    }
}

