#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9 + 7, mod2 = 228228227, maxn = 2e5 + 1;

struct HASH {
	vector<int> h, p;

	void build(string &s) {
		int n = sz(s), x = 31;
		h.resize(n), p.resize(n);
		p[0] = 1, h[0] = s[0] - 'a' + 1;
		for (int i = 1; i < n; ++i) {
			h[i] = (h[i - 1] * x % mod + (s[i] - 'a' + 1)) % mod;
			p[i] = (p[i - 1] * x) % mod;
		}
	}

	int get(int l, int r) {
		if (l < 0 || r >= sz(h) || l > r)return 0;
		if (l == 0)return h[r];
		return (h[r] - (h[l - 1] * p[r - l + 1]) % mod + mod) % mod;
	}
};

vector<pair<int, unordered_set<int>>> LEN;

void solve() {
	int n, q, m;
	string t;
	cin >> n >> q >> t, m = sz(t);
	vector<string> a(n);
	unordered_map<int, unordered_set<int>> ex;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		HASH f;
		f.build(a[i]);
		ex[sz(a[i])].insert(f.get(0, sz(a[i]) - 1));
	}
	HASH T;
	T.build(t);
	for (auto[N, hashes]: ex) LEN.push_back({N, hashes});
	vector<pair<int, vector<int>>> good;
	for (auto&[len, mas]: LEN) {
		good.push_back({len, {}});
		for (int i = 0; i + len - 1 < m; ++i) {
			int y = T.get(i, i + len - 1);
			if (mas.find(y) != mas.end())
				good.back().second.push_back(i);
		}
		if (good.back().second.empty()) good.pop_back();
	}
	while (q--) {
		int l, r;
		cin >> l >> r, l--, r--;
		int ans = 0;
		for (auto&[len, mas]: good) {
			if (len > r - l + 1)continue;
			int l1 = lower_bound(all(mas), l) - mas.begin();
			int r1 = upper_bound(all(mas), r - len + 1) - mas.begin();
			ans += r1 - l1;
		}
		cout << ans << ' ';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int _ = 1;
	//cin>>_;
	while (_--) {
		solve();
		cout << '\n';
	}
	return 0;
}
