//#pragma GCC target("avx2")
//#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define ll long long
#define ve vector
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pb push_back
#define INF1 INT32_MAX
#define eb emplace_back
#define ld long double

using namespace std;
using namespace __gnu_pbds;

template<typename key, typename cmp=less_equal<key>>
using pbds = tree<key, null_type, cmp, rb_tree_tag, tree_order_statistics_node_update>;

random_device rd;
mt19937 rnd(rd());

int rand(int l, int r) {
    return l + rnd()%(r-l+1);
}
int sz(string &s) {
    return (int)s.size();
}
int sz(ve<int> &s) {
    return (int)s.size();
}

//struct st{
//    void build() {
//
//    }
//    void build(int x, int lx, int rx){
//        if (rx - lx == 1) {
//            if (lx < n)
//            return;
//        }
//        int m = (lx + rx) / 2;
//        build(x*2+1, lx, m);
//        build(x*2+2, m, rx);
//        Tree[x] =
//    }
//};

const int Size = 1024*1024;
pbds<int> Tree[Size*2-1];

struct st{
    void pl(int x, int lx, int rx, int i, int r) {
        Tree[x].insert(r);
        if (rx - lx == 1) return;
        int m = (lx + rx) / 2;
        if (i < m) pl(x*2+1, lx, m, i, r);
        else pl(x*2+2, m, rx, i, r);
    }
    int sum(int x, int lx, int rx, int l, int r, int n) {
        if (lx >= r || rx <= l) return 0;
        if (l <= lx && rx <= r) {
            return (int)Tree[x].order_of_key(n);
        }
        int m = (lx + rx) / 2;
        return sum(x*2+1, lx, m, l, r, n) + sum(x*2+2, m, rx, l, r, n);
    }
};
const int maxn = 5*1e6+1, p = 31, mod = 1e9+7;
const int c = 1e3;
int ppow[maxn], hs[maxn];

int get_hash(string &s) {
    int res = s[0]-'a'+1;
    for (int i = 1; i < sz(s); ++i) res = (res + (s[i]-'a'+1)*ppow[i]) % mod;
    return res;
}

int bp(int a, int n) {
    int res = 1;
    while (n) {
        if (n&1) --n, res *= a;
        n /= 2, a*=a;
        a %= mod, res %= mod;
    }
    return res;
}

void solve() {
    int n, m; cin >> n >> m;
    string t; cin >> t;
    ppow[0] = 1;
    hs[0] = t[0]-'a'+1;
    for (int i = 1; i < sz(t); ++i) {
        ppow[i] = (ppow[i-1]*p)%mod;
        hs[i] = ((t[i]-'a'+1)*ppow[i]+hs[i-1]) % mod;
    }
    ve<string> v(n);
    ve<string> big;
    set<int> sm;
    for (auto &i : v) {
        cin >> i;
        if (sz(i) <= c) sm.emplace(get_hash(i));
        else big.eb(i);
    }
    st root;
    for (int i = 0; i < sz(t); ++i) {
        for (int j = i; j < min(i + c, sz(t)); ++j) {
            int cur = (hs[j] - (i ? hs[i-1] : 0)) * bp(bp(p, i), mod-2) % mod;
            if (sm.find(cur) != sm.end()) {
                root.pl(0, 0, Size, i, j);
            }
        }
    }
    for (auto &b : big) {
        string s = b;
        s += "#";
        s += t;
        int l = 0, r = 0;
        ve<int> z(sz(s));
        int N = sz(s);
        for (int i = 1; i < N; ++i) {
            if (i <= r) z[i] = min(r-i+1, z[i-l]);
            while (i+z[i] < N && s[i+z[i]] == s[z[i]]) ++z[i];
            if (i+z[i]-1 > r) {
                l = i, r = i + z[i] - 1;
            }
            if (z[i] == sz(b)) {
                root.pl(0, 0, Size, i-sz(b)-1, i-sz(b)-1+sz(b)-1);
            }
        }
    }
    while (m--) {
        int l, r; cin >> l >> r;
        --l;
        int ans = root.sum(0, 0, Size, l, r, r);
        cout << ans << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--) solve();
}