#include <bits/stdc++.h>

#define ll long long
#define all(x) x.begin(), x.end()
#define fi first
#define se second


using namespace std;

struct node{
    ll val = 0;
    map<ll, ll> k;
};

vector<node> t;
vector<node> a;
int sz;
void build(int v = 1, int tl = 0, int tr = sz - 1){
    if(tl == tr){
        t[v] = a[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm + 1, tr);
    t[v].val = t[v * 2].val + t[v * 2 + 1].val;
    for(auto i : t[v * 2].k)
        t[v].k[i.first] += i.second;
    for(auto i : t[v * 2 + 1].k)
        if(i.first > tm - tl + 1)
            t[v].k[i.first - (tm - tl + 1)] += i.second;
        else
            t[v].val++;
}

node get(int l, int r, int v = 1, int tl = 0, int tr = sz - 1){
    if(tl >= l && tr <= r)
        return t[v];
    if(tl > r || tr < l)
        return {0, map<ll, ll>()};
    int tm = (tl + tr) / 2;
    node g1 = get(l, r, v * 2, tl, tm);
    node g2 = get(l, r, v * 2 + 1, tm + 1, tr);
    node res;
    res.val = g1.val + g2.val;
    for(auto i : g1.k)
        res.k[i.first] += i.second;
    for(auto i : g2.k)
        if(i.first > tm - l + 1)
            res.k[i.first - (tm - l + 1)] += i.second;
        else
            res.val++;
    return res;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, m;
    cin >> n >> m;
    string temp;
    cin >> temp;
    sz = temp.size();
    a.resize(temp.size());
    t.resize(4*temp.size());
    for(int it = 0; it < n; it++){
        string st;
        cin >> st;
        string tt = st + "#" + temp;
        vector<int> pi(tt.size(), 0);
        for(int i = 1; i < tt.size(); i++){
            int j = pi[i - 1];
            while(j != 0 && tt[i] != tt[j])
                j = pi[j - 1];
            j += tt[i] == tt[j];
            pi[i] = j;
        }
        for(int i = st.size() + 1; i < tt.size(); i++)
            if(pi[i] == st.size()){
                if(st.size() == 1)
                    a[i - (st.size() + 1)].val++;
                else
                    a[i - (st.size() + 1)].k[st.size() - 1]++;
            }
    }
    build();
    //cout << t[1].val << "\n";
//    for(auto i : a)
//        cout << i.val << " ";
//    cout << "\n";
    while(m--){
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        cout << get(l, r).val << " ";
    }
    return 0;
}
