#include <bits/stdc++.h>

using namespace std;

#define pikachu push_back
#define mp make_pair
#define st first
#define nd second
#define pll pair<ll, ll>
#define pii pair<int, int>
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;

template<typename A, typename B>
string to_string(pair<A, B> p);

string to_string(string s) {
    return s;
}

string to_string(char s) {
    return "'" + string(1, s) + "'";
}

template<typename A>
string to_string(A v) {
    string res = "{";
    bool fl = 1;
    for (auto x: v) {
        if (!fl) {
            res += ", ";
        }
        fl = 0;
        res += to_string(x);
    }
    res += "}";
    return res;
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

void debug_out() {
    cerr << endl;
}

template<typename H, typename... T>
void debug_out(H h, T... t) {
    cerr << " " << to_string(h);
    debug_out(t...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

template<typename A, typename B>
bool cmin(A &a, const B &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename A, typename B>
bool cmax(A &a, const B &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

struct HASH {
    size_t operator()(const pll &p) const {
        return p.st ^ p.nd;
    }
};

ll bpow(ll a, ll n, ll MOD) {
    ll res = 1;
    while (n) {
        if (n & 1) (res *= a) %= MOD;
        (a *= a) %= MOD;
        n /= 2;
    }
    return res;
}

void run();

signed main() {
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
}

const int MOD = 1e9 + 7, b = 567;

int getH(const string &s) {
    int h = 0;
    for (auto e: s) {
        h = (1ll * h * b + e) % MOD;
    }
    return h;
}

void run() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<int> lens;
    vector<string> s(n);
    for (auto &e: s) {
        cin >> e;
        lens.pikachu(sz(e));
    }
    sort(all(lens));
    lens.resize(unique(all(lens)) - lens.begin());
    vector<unordered_set<int>> heshs(sz(lens));
    for (auto &e: s) {
        ll pos = lower_bound(all(lens), sz(e)) - lens.begin();
        heshs[pos].insert(getH(e));
    }
    vector<vector<int>> pref(sz(lens), vector<int>(sz(t) + 1));
    for (int cur = 0; cur < sz(lens); ++cur) {
        int len = lens[cur];
        int h = 0;
        for (int i = 0; i < len; ++i) {
            h = (1ll * h * b + t[i]) % MOD;
        }
        if (heshs[cur].count(h)) pref[cur][1] = 1;
        ll S = bpow(b, len, MOD);
        for (int i = 0; i + len < sz(t); ++i) {
            h = (1ll * h * b + t[i + len]) % MOD;
            h -= (1ll * S * t[i]) % MOD;
            h += MOD;
            h %= MOD;
            if (heshs[cur].count(h)) pref[cur][i + 2] = 1;
        }
        for (int i = 1; i < sz(pref[cur]); ++i) {
            pref[cur][i] += pref[cur][i - 1];
        }
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        ll ans = 0;
        for (int cur = 0; cur < sz(lens); ++cur) {
            int len = lens[cur];
            if (r - l + 1 < len) continue;
            ans += pref[cur][r - len + 1];
            ans -= pref[cur][l - 1];
        }
        cout << ans << '\n';
    }

}
