#include <iostream>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

using namespace std;
#pragma GCC optimize("Ofast")

#define int long long
#define _ << " " <<
#define ld long double
const int MAXN = 2e5 + 10, MAXA = 1e7 + 5, LOG = 33, mod = 1e9 + 7, base = 29;
int n, m, a[MAXN], pw[MAXN], rpw[MAXN], pref[MAXN];
string all[MAXN];
int fst_pow(int a, int b) {
	int ans = 1;
	while (b) {
		if (b & 1) {
			b--;
			ans *= a;
			ans %= mod;
		}
		else {
			b /= 2;
			a *= a;
			a %= mod;
		}
	}
	return ans;
}
int get(char c) {
	return c - 'a' + 1;
}
void prepare() {
	pw[0] = 1;
	for (int i = 1; i < MAXN; i++) {
		pw[i] = base * pw[i-1];
		pw[i] %= mod;
	}
	for (int i = 0; i < MAXN; i++) {
		rpw[i] = fst_pow(pw[i], mod - 2);
	}
}
int geth(string s) {
	int hash = 0;
	for (int i = 0; i < s.size(); i++) {
		hash += pw[i] * get(s[i]);
		hash %= mod;
	}
	return hash;
}
unordered_set<int> s;
int hashs[MAXN];
void setpref(string s) {
	pref[0] = get(s[0]);
	for (int i = 1; i < s.size(); i++) {
		pref[i] = pref[i - 1] + get(s[i]) * pw[i];
	}
}
int get(int l, int r) {
	int hash = pref[r];
	if (l) {
		hash -= pref[l - 1];
		hash += mod;
		hash %= mod;
		hash *= rpw[l];
		hash %= mod;
	}
	return hash;
}
int32_t main()
{
	//cout << fst_pow(2, 4);
	prepare();
	cin >> n >> m;
	string s;
	cin >> s;
	setpref(s);
	for (int i = 1; i <= n; i++) {
		cin >> all[i];
		hashs[i] = geth(all[i]);
	}
	for (int i = 1; i <= m; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		int ans = 0;
		for (int j = 1; j <= n; j++) {
			for (int cur = l; cur + all[j].size() - 1 <= r; cur++) {
				int hash1 = get(cur, cur + all[j].size() - 1);
				int hash2 = hashs[j];
				if (hash1 == hash2) ans++;
			}
		}
		cout << ans << '\n';
	}

}