#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <limits>
#include <string>
#include <vector>
#include <climits>

#define sz(a) int((int)a.size())

//#define int long long

using namespace std;

vector<string> vs;

int cnt(string& s, string& str) {
    int ans = 0;
    for (int i = 0; i <= sz(str) - sz(s); ++i) {
        if (s == str.substr(i, s.size())) {
            ans++;
        }
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vs.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> vs[i];
    }
    while (m-->0) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        long long ans = 0;
        for (string str : vs) {
            string have = t.substr(l, r - l + 1);
            ans += cnt(str, have);
        }
        cout << ans << ' ';
    }
}

int32_t main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    string s;
//    cin >> s;
//    vector<int> z_s = z_f(s);
//    for (auto el : z_s) {
//        cout << el << ' ';
//    }
//    string t;
//    cin >> t;
//    string s;
//    cin >> s;
//    cout << cnt(s, t);
    int t = 1;
//    cin >> t;
    while (t-->0) {
        solve();
    }
    return 0;
}