#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 1e6 + 5;

int n, m;
string t;
ve<string> a;
ve<int> Q[N];
ve<pii> good;
int ans[N];
ve<array<int, 3>> query;

int T[N];

void upd(int pos, int x) {
    while (pos < sz(t)) {
        T[pos] += x;
        pos = pos | (pos + 1);
    }
}

int get(int pos) {
    int ans = 0;
    while (pos >= 0) {
        ans += T[pos];
        pos = (pos & (pos + 1)) - 1;
    }
    return ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n >> m;

    cin >> t;

    fr (i, 1, n) {
        string s;
        cin >> s;

        a.pb(s);
        Q[sz(s)].pb(i - 1);
    }

    fr (len, 1, N - 1) {
        if (sz(Q[len])) {
            set<string> have;
            fe (x, Q[len]) have.insert(a[x]);

            fr (i, 0, sz(t) - len) {
                if (have.count(t.substr(i, len))) {
                    good.pb({i, i + len - 1});
                }
            }
        }
    }

    fr (i, 1, m) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;

        query.pb({l, r, i});
    }

    sort(all(good));
    reverse(all(good));

    sort(all(query));
    reverse(all(query));
    int ptr = 0;

    fe (cur, query) {
        int l = cur[0];
        int r = cur[1];
        int idx = cur[2];

        while (ptr < sz(good) && good[ptr].fi >= l) {
            upd(good[ptr].se, 1);
            ptr++;
        }
        ans[idx] = get(r) - get(l - 1);
    }

    fr (i, 1, m) {
        cout << ans[i] << "\n";
    }

    return 0;
}
