﻿// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct trie
{
	vector <int> word;
	//trie* childhood[26];
	map<char, trie*> m;

	trie()
	{
		//memset(childhood, 0, sizeof(childhood));
	}

	trie* move(char ch)
	{
		/*ch -= 'a';
		if (!childhood[ch])
			childhood[ch] = new trie();
		return childhood[ch];*/
		if (m.count(ch))
			return m[ch];
		trie* t = new trie();
		m[ch] = t;
		if (!t)
			exit(0);
		return t;
	}

	void push(int ind)
	{
		word.push_back(ind);
	}

	bool able(char ch)
	{
		//return childhood[ch - 'a'];
		return m.count(ch);
	}
}*root = new trie();

void trie_add(int ind, string& s, trie* root)
{
	do
	{
		root->push(ind);
		char tmp = s.back();
		s.pop_back();
		root = root->move(tmp);
	} while (!s.empty());
	root->push(ind);
}

void trie_add(size_t ind, string t)
{
	reverse(t.begin(), t.end());
	trie_add(ind, t, root);
}

vector <pair<int, int>> links;

void trie_find(string& s, trie* root, size_t sz)
{
	while (!s.empty() && root->able(s.back()))
	{
		char tmp = s.back();
		s.pop_back();
		root = root->move(tmp);
	}
	if (s.empty())
	{
		for (auto& i : root->word)
		{
			links.emplace_back(i, i + sz);
		}
		return;
	}
}

void trie_find(string& s)
{
	reverse(s.begin(), s.end());
	trie_find(s, root, s.size());
}

int main()
{
	ll n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	for (size_t i = 0; i < t.size(); i++)
	{
		trie_add(i, t.substr(i));
	}
	for (size_t i = 0; i < n; i++)
	{
		string s;
		cin >> s;
		trie_find(s);
	}
	for (size_t i = 0; i < m; i++)
	{
		size_t l, r;
		cin >> l >> r;
		l--;
		ll cnt = 0;
		for (auto& i : links)
		{
			if (l <= i.first && i.second <= r)
				cnt++;
		}
		cout << cnt << ' ';
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
