#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 2e5, MOD = 1e9 + 7, INF = 1e18, P = 37;

void solve() {
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    ll sz = (ll)t.size();
    vector<string> v(n);
    vector<ll> h(n);
    for(ll i = 0; i < n; i++){
        cin >> v[i];
    }
    for(ll i = 0; i < n; i++){
        for(ll j = 0; j < (ll)v[i].size(); j++){
            h[i] = (h[i] * P + (v[i][j] - 'a' + 1)) % MOD;
        }
    }
    map<ll, ll> mp;
    for(ll i = 0; i < n; i++){
        mp[h[i]]++;
    }
    vector<ll> hs((ll)t.size() + 1), step((ll)t.size() + 1);
    step[0] = 1;
    for(ll i = 1; i <= sz; i++){
        step[i] = step[i - 1] * P % MOD;
        hs[i] = (hs[i - 1] * P + (t[i - 1] - 'a' + 1)) % MOD;
    }
    vector<vector<pair<ll, ll>>> pref((ll)t.size() + 1, vector<pair<ll, ll>>((ll)t.size() + 1));
    for(ll l = 0; l < (ll)t.size(); l++){
        for(ll r = l + 1; r <= (ll)t.size(); r++){
            pref[l][r].first = (hs[r] - (hs[l] * step[r - l] % MOD) + MOD) % MOD;
            pref[l][r].second = mp[pref[l][r].first];
        }
    }
    for(ll i = 0; i < m; i++){
        ll l, r, ans = 0;
        cin >> l >> r;
        for(ll j = l - 1; j < r; j++){
            for(ll g = j + 1; g <= r; g++){
                ans += pref[j][g].second;
            }
        }
        cout << ans << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}
