#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define all(x) (x).begin(), (x).end()
#define str to_string
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef long double ld;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template <typename T>
inline ll len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD = 1e9 + 7;
const ll MOD1 = 1e9 + 7;
const ll MOD2 = 998244353;
const ll p = 41;
const ll p1 = 41;
const ll p2 = 53;
const int maxN = 5e5 + 9;
const int maxS = 6e6 + 9;
string t;
string a[maxN];
ll h[maxN];
ll pw[maxN];
void bh() {
    int n = len(t);
    pw[0] = 1;
    for(int i = 1; i <= n; ++i) {
        h[i] = (h[i - 1] * p + (t[i] - 'a' + 1)) % MOD;
        pw[i] = pw[i - 1] * p % MOD;
    }
}
ll gh(string& s) {
    ll res = 0;
    for(auto &i: s) {
        res = (res * p + (i - 'a' + 1)) % MOD;
    }
    return res;
}
ll gh(int l, int r) {
    ll res = h[r];
    res -= h[l - 1] * pw[r - l + 1] % MOD;
    if(res < 0) res += MOD;
    return res;
}




cc_hash_table<ll, int> who;

struct qry {
    int l, r, i;
    bool operator<(const qry& sec) const {
        return l < sec.l;
    }
};
qry qs[maxN];
ll ans[maxN];
ll fw[maxN];
void add(int i, ll x) {
    while(i <= len(t) - 1) {
        fw[i] += x;
        i |= i + 1;
    }
}
ll getsum(int r) {
    ll res = 0;
    while(r >= 0) {
        res += fw[r];
        r = (r & (r + 1)) - 1;
    }
    return res;
}
vector<int> les;
int n, q;
void go() {
    sort(qs + 1, qs + q + 1);
    reverse(qs + 1, qs + q + 1);
    int L = len(t);
    for(int cq = 1; cq <= q; ++cq) {
        while(qs[cq].l < L) {
            --L;
            for(auto &k: les) {
                ll th = gh(L, L + k - 1);
                if(who.find(th) != who.end()) {
                    add(L + k - 1, 1);
                }
            }
        }
        ans[qs[cq].i] = getsum(qs[cq].r);
    }
}

bool cmp(const string& a, const string& b) {
    return len(a) < len(b);
}
int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    cin >> n >> q;
    cin >> t;
    t.insert(t.begin(), 0);

    bh();
    for(int i = 1; i <= n; ++i) cin >> a[i];
    sort(a + 1, a + n + 1, cmp);
    for(int i = 1; i <= n; ++i) {
        ll ch = gh(a[i]);
        who[ch] = i;
    }
    int ple = -1;
    for(int i = 1; i <= n; ++i) {
        if(len(a[i]) != ple) {
            les.pb(len(a[i]));
        }
        ple = len(a[i]);
    }

    for(int i = 1; i <= q; ++i) {
        int l, r; cin >> l >> r;
        qs[i] = {l, r, i};
    }
    go();
    for(int i = 1; i <= q; ++i) cout << ans[i] << ' ';
    cout << '\n';
}
/*

3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5

4 4
abcdca
ab
ca
bcd
openolympiad
1 5
2 2
2 6
1 6

 */