#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define VC(vc) vc.begin(), vc.end()

ll request(ll p)
{
    ll ans;
    cout << "? " << p << endl;
    cin >> ans;
    return ans;
}

ll get_sum(ll ed)
{
    return (1ll + ed) * ed / 2ll;
}

const ll INF = 2e18 + 7;

struct Hash
{
    const ll MOD1 = 1e9 + 7;
    const ll MOD2 = 1e9 + 9;

    const ll p1 = 31;
    const ll p2 = 37;

    vector <ll> hashes1;
    vector <ll> hashes2;

    vector <ll> pp1;
    vector <ll> pp2;
    Hash(const string& s)
    {
        hashes1.resize(s.size());
        hashes2.resize(s.size());
        pp1.resize(s.size());
        pp2.resize(s.size());

        pp1[0] = 1;
        pp2[0] = 1;
        hashes1[0] = s[0] - 'a' + 1;
        hashes2[0] = s[0] - 'a' + 1;
        for (int i = 1; i < s.size(); i++)
        {
            pp1[i] = pp1[i - 1] * p1 % MOD1;
            pp2[i] = pp2[i - 1] * p2 % MOD2;
            hashes1[i] = (hashes1[i - 1] + (s[i] - 'a' + 1) * pp1[i] % MOD1) % MOD1;
            hashes2[i] = (hashes2[i - 1] + (s[i] - 'a' + 1) * pp2[i] % MOD2) % MOD2;
        }
    }

    ll get_1(int l, int r)
    {
        ll ans = ((hashes1[r] - (l == 0 ? 0 : hashes1[l - 1])) + MOD1 * MOD1);
        ans %= MOD1;
        return ans;
    }

    ll get_2(int l, int r)
    {
        ll ans = ((hashes2[r] - (l == 0 ? 0 : hashes2[l - 1])) + MOD2 * MOD2);
        ans %= MOD2;
        return ans;
    }

    bool isEqual(Hash& o, int l, int r)
    {
        ll ans1 = get_1(l, r);
        ll ans2 = get_2(l, r);
        if (o.hashes1[o.hashes1.size() - 1] * pp1[l] % MOD1 == ans1 && o.hashes2[o.hashes2.size() - 1] * pp2[l] % MOD2 == ans2)
        {
            return true;
        }
        return false;
    }
};

void solve()
{
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector <string> vc(n);
    vector <Hash> hs_vc;
    for (auto& i: vc) { cin >> i; hs_vc.push_back(Hash(i)); }
    Hash hs_t(t);
    /*for (auto i: hs_t.hashes2)
    {
        cout << i << ' ';
    }
    cout << endl;
    for (auto i: hs_t.pp2)
    {
        cout << i << ' ';
    }
    cout << endl;*/
    for (int i = 0; i < m; i++)
    {
        int l, r;
        cin >> l >> r;
        int ans = 0;
        l--;
        r--;
        for (int a = l; a <= r; a++)
        {
            for (int b = a; b <= r; b++)
            {
                for (int j = 0; j < n; j++)
                {
                    if (b - a + 1 == vc[j].size())
                    {
                        /*cout << a << ' ' << b << ' ' << vc[j] << endl;
                        cout << hs_vc[j].get_1(0, vc[j].size() - 1) << ' ' << hs_t.get_1(a, b) << ' ' <<
                            hs_vc[j].get_2(0, vc[j].size() - 1) << ' ' << hs_t.get_2(a, b) << endl;*/
                        if (hs_t.isEqual(hs_vc[j], a, b))
                        {
                            //cout << "TRUE" << endl;
                            ans++;
                        }
                    }
                }
            }
        }
        cout << ans << ' ';
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
