#include "bits/stdc++.h"

using namespace std;
#define sz(a) (int)a.size()
#define all(a)a.begin(),a.end()
#define int long long
const int inf = 1e18;
const int mod = 998244353;
const int p = 217;

int R;
vector<vector<int>> sg;

void upd(int x, vector<int> &a) {
    x += R;
    while (x > 0) {
        for (auto y: a)
            sg[x].push_back(y);
        x >>= 1;
    }
}

int get(int x, int xl, int xr, int ql, int qr, int TR) {
    if (xr <= ql || qr <= xl)
        return 0;
    if (ql <= xl && xr <= qr)
        return lower_bound(all(sg[x]), TR) - sg[x].begin();
    int mid = (xl + xr) >> 1;
    return get(x * 2, xl, mid, ql, qr, TR) + get(x * 2 + 1, mid, xr, ql, qr, TR);
}

struct info {
    vector<int> g;
    int term = 0;

    info() {
        g.assign(26, -1);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    R = 1 << (__lg(sz(t)) + 1);
    sg.assign(2 * R, {});
    int hash = 0;
    vector<int> h(sz(t));
    for (int i = 0; i < sz(t); ++i)
        h[i] = ((i > 0 ? h[i - 1] : 0) * p + t[i]) % mod;
    vector<int> P(sz(t) + 1, 1);
    for (int i = 1; i < sz(P); ++i)
        P[i] = (P[i - 1] * p) % mod;

    int B = min(sz(t), 1000ll);
//    vector<unordered_set<int>> light(B + 1);
    vector<pair<int, int>> heavy;
    vector<info> W(1);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        if (sz(s) <= B) {
            int cur = 0;
            for (auto c: s) {
                if (W[cur].g[c - 'a'] == -1) {
                    W.emplace_back();
                    W[cur].g[c - 'a'] = sz(W) - 1;
                }
                cur = W[cur].g[c - 'a'];
            }
            W[cur].term = 1;
        } else {
            int hash = 0;
            for (auto c: s)
                hash = (hash * p + c) % mod;
            heavy.emplace_back(sz(s), hash);
        }
    }
    sort(all(heavy));

    for (int i = 0; i < sz(t); ++i) {
        vector<int> add;
        for (auto [len, hs]: heavy) {
            if (i + len - 1 >= sz(t))
                break;
            hash = ((h[i + len - 1] - (i > 0 ? h[i - 1] : 0ll) * P[len] % mod) % mod + mod) % mod;
            if (hash == hs)
                add.push_back(i + len - 1);
        }
        int cur = 0;
        for (int j = i; j < min(sz(t), i + B); ++j) {
            if (W[cur].g[t[j] - 'a'] == -1)
                break;
            cur = W[cur].g[t[j] - 'a'];
            if (W[cur].term)
                add.push_back(j);
        }
        upd(i, add);
    }

    for (int i = 1; i < sz(sg); ++i)
        sort(all(sg[i]));
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        cout << get(1, 0, R, l - 1, r, r) << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}