#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

struct Hash {
    vector<__int128> hash, pows;

    ll n;

    const long long mod = 123456791;
    const long long P = 31;

    Hash(string &s) {
        n = (ll) s.size();
        hash.resize(n + 1);
        pows.resize(n + 1);
        hash[0] = 0;
        pows[0] = 1;
        for (ll i = 0; i < n; i++) {
            hash[i + 1] = (hash[i] * P + s[i]);
            pows[i + 1] = (pows[i] * P);
        }
    }

    __int128 get(ll l, ll r) {
        return ((hash[r + 1]) - (((hash[l]) * (pows[r - l + 1]))));
    }
};

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    Hash h(t);
    vector<string> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    vector<pair<__int128, __int128>> val(n);
    for (ll i = 0; i < n; i++) val[i].first = Hash(a[i]).get(0, (ll) a[i].size() - 1), val[i].second = (ll) a[i].size();
    //  cout << "d: ";
    //  for (ll x : val) cout << x << " ";
    //  cout << endl;
    vector<__int128> val1(n);
    for (ll i = 0; i < n; i++) val1[i] = Hash(a[i]).get(0, (ll) a[i].size() - 1);
    sort(val1.begin(), val1.end());
    vector<vector<ll>> res((ll) t.size(), vector<ll> ((ll) t.size(), 0LL));
    for (ll left = 0; left < (ll) t.size(); left++) {
        for (ll right = left; right < (ll) t.size(); right++) {
            __int128 hash = h.get(left, right);
            if (lower_bound(val1.begin(), val1.end(), hash) != val1.end()) {
                if (*lower_bound(val1.begin(), val1.end(), hash) == hash) {
                    res[left][right] = 1LL;
                }
            }
        }
    }
    vector<vector<ll>> pref((ll) t.size() + 1, vector<ll> ((ll) t.size() + 1, 0LL));
    for (ll i = 1; i <= (ll) t.size(); i++) {
        for (ll j = 1; j <= (ll) t.size(); j++) {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + res[i - 1][j - 1];
        }
    }
  //  debug;
    auto get = [&] (ll l1, ll r1, ll l2, ll r2) {
        ll ans = pref[l2 + 1][r2 + 1];
        ans -= pref[l1][r2 + 1];
        ans -= pref[l2 + 1][r1];
        ans += pref[l1][r1];
        return ans;
    };
    while (m--) {
        ll l, r;
        cin >> l >> r;
        l--, r--;
        cout << get(l, l, r, r)  << endl;
    }
    return 0;
}