#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()

const int INF32 = 0x3f3f3f3f;
const int INF64 = 0x3f3f3f3f3f3f3f3f;
const int MOD1 = 1000000007;
const int MOD2 = 1791791791;
const int k = 31;

const int maxn = 5000000;

int powk1[maxn + 1];
int powk2[maxn + 1];

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    powk1[0] = 1;
    for (int i = 1; i <= maxn; i++) {
        powk1[i] = (powk1[i - 1] * k) % MOD1;
    }
    vector<int> hashes1(t.size() + 1);
    for (int i = 0; i < (int)t.size(); i++) {
        hashes1[i + 1] = (hashes1[i] + (t[i] - 'a' + 1) * powk1[i]) % MOD1;
    }
    powk2[0] = 1;
    for (int i = 1; i <= maxn; i++) {
        powk2[i] = (powk2[i - 1] * k) % MOD2;
    }
    vector<int> hashes2(t.size() + 1);
    for (int i = 0; i < (int)t.size(); i++) {
        hashes2[i + 1] = (hashes2[i] + (t[i] - 'a' + 1) * powk2[i]) % MOD2;
    }
    vector<vector<int>> pos(n);
    for (int i = 0; i < n; i++) {
        int hash1 = 0;
        for (int j = 0; j < (int)s[i].size(); j++) {
            hash1 = (hash1 + (s[i][j] - 'a' + 1) * powk1[j]) % MOD1;
        }
        hash1 = (hash1 * powk1[maxn]) % MOD1;
        int hash2 = 0;
        for (int j = 0; j < (int)s[i].size(); j++) {
            hash2 = (hash2 + (s[i][j] - 'a' + 1) * powk2[j]) % MOD2;
        }
        hash2 = (hash2 * powk2[maxn]) % MOD2;
        for (int j = 0; j < (int)t.size() - (int)s[i].size() + 1; j++) {
            if (((((hashes1[j + (int)s[i].size()] - hashes1[j] + MOD1) % MOD1) * powk1[maxn - j]) % MOD1 == hash1) &&
                    ((((hashes2[j + (int)s[i].size()] - hashes2[j] + MOD2) % MOD2) * powk2[maxn - j]) % MOD2 == hash2)) {
                pos[i].push_back(j);
            }
        }
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            ans += upper_bound(all(pos[i]), r - (int)s[i].size() + 1) - lower_bound(all(pos[i]), l);
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}