#include<bits/stdc++.h>
#define dbg(x) cout << #x << "=" << x << "\n";
using namespace std;

struct node{
    int next[27];
    int suff=-1;
    int super_suff = -1;
    bool termal=false;
    int sz=0;

    void init(){
        for(int i=0; i < 27; i++){
            next[i] = -1;
        }
    }
};

vector<node> tree;
int next1 = 1;

void insert(int index_node, int i, string &s){
    if(i == s.size()){
        tree[index_node].termal = true;
        tree[index_node].sz = s.size();

        return;
    }

    int lol = s[i] - 'a';

    if(tree[index_node].next[lol] == -1){
        tree[index_node].next[lol] = next1;
        tree[next1].init();
        next1++;
    }

    insert(tree[index_node].next[lol], i+1, s);
}

void recalc(int v, deque<int> &d){
    if(v == 0){
        for(int i=0; i < 27; i++){
            if(tree[v].next[i] != -1){
                d.push_back(tree[v].next[i]);
                tree[tree[v].next[i]].suff = 0;
            }else{
                tree[v].next[i]=0;
            }
        }

        return;
    }

    for(int i=0; i < 27; i++){
        if(tree[v].next[i] != -1){
            d.push_back(tree[v].next[i]);

            int suff =tree[tree[v].suff].next[i];

            tree[tree[v].next[i]].suff = suff;


            tree[tree[v].next[i]].super_suff = tree[suff].super_suff;

            if(tree[suff].termal){
                tree[tree[v].next[i]].super_suff = suff;
            }
        }else{
            tree[v].next[i] = tree[tree[v].suff].next[i];
        }
    }
}

void aho(){
    deque<int> d(1, 0);

    while(d.size()){
        int v = d.front();
        d.pop_front();

        //dbg(v);

        recalc(v, d);
    }
}


void get_index(vector<pair<int, int>> &ind, string &s){
    //aho();



    int root = 0;

    for(int r=0; r < s.size(); r++){
        root = tree[root].next[s[r] - 'a'];

        int root1 = root;

        while(root1 != 0){
            if(tree[root1].termal){
                ind.push_back({1 + r - tree[root1].sz, r});
            }

            root1 = tree[root1].super_suff;
        }
    }
}

struct node1{
    int l;
    int r;
    int t;
};

bool operator<(node1 &f, node1 &s){
    if(f.l != s.l){
        return f.l > s.l;
    }

    return f.t < s.t;
}

struct bebrik{
    vector<int> t;

    bebrik(int n){
        t.resize(n+1, 0);
    }

    void u(int l){
        for(int i=l; i < t.size(); i += (i & (-i))){
            t[i]++;
        }
    }

    int get(int l){
        int ans = 0;

        for(int i=l; i > 0; i -=(i &(-i))){
            ans += t[i];
        }

        return ans;
    }
};

void solve(){
    int n, m; cin >> n >> m;

    tree.resize(2e5+1);

    tree[0].init();

    string t; cin >> t;

    vector<pair<int, int>> ind;

    vector<string> s(n);

    for(int i=0; i < n; i++){
        cin >> s[i];

        insert(0, 0, s[i]);
    }

    aho();

    get_index(ind, t);

    vector<node1> b;

    for(auto el: ind){
        b.push_back({el.first, el.second, -1});
    }

    for(int it=0; it < m; it++){
        int l, r; cin >> l >> r; l--; r--;

        b.push_back({l, r, it});
    }

    sort(b.begin(), b.end());

    vector<int> ans(m, 0);

    bebrik t1 = bebrik(t.size());

    for(auto el: b){
        if(el.t == -1){
            t1.u(el.r+1);
            //lol.push_back(el.r);
        }else{
            ans[el.t] = t1.get(el.r+1);
        }
    }

    for(auto el: ans){
        cout << el << " ";
    }
}

int32_t main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cout.precision(20);




    int t=1; //cin >> t;

    for(int i=0; i < t; i++){
        solve();

        cout << "\n";
    }
}
