#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll mod=1e9+7;
const ll base=37;
const int MAXN=1e5+6;
const int MAXM=1e5+6;
const int MAXQ=5e5+6;
int n,m;
string t;
ll fastpow(ll x,ll p,ll m)
{
    if(p==0)return 1;
    if(p==1)return x;
    ll t=fastpow(x,p/2,m);
    t*=t;t%=m;
    if(p%2==1)
    {
        t*=x;
        t%=m;
    }
    return t;
}
struct my_hash
{
    ll val;
    void append_letter(char c)
    {
        val=val*base+c-'a'+1;
        val%=mod;
    }
    void shift_left(ll p)
    {
        val=val*fastpow(base,p,mod);
        val%=mod;
    }
    void shift_right(ll p)
    {
        val=val*fastpow(base,mod-1-p,mod);
        val%=mod;
    }
}pref[MAXM],hashes[MAXN];
my_hash calc_hash(string s)
{
    my_hash ret;
    ret.val=0;
    for(int i=0;i<s.size();i++)
    {
        ret.append_letter(s[i]);
    }
    return ret;
}
my_hash get_hash(int l,int r)
{
    my_hash ret=pref[r];
    my_hash rem=pref[l-1];
    rem.shift_left(r-l+1);
    ret.val-=rem.val-mod;
    ret.val%=mod;
    return ret;
}
string s[MAXN];
struct query
{
    int l,r,idx;
    bool operator<(query const& other)const
    {
        if(l!=other.l)return l<other.l;
        if(r!=other.r)return r<other.r;
        if(idx!=other.idx)return idx<other.idx;
    }
};
vector<query>queries;
set<int>lens;
unordered_set<int>hashes1[MAXN];
void read()
{
    cin>>n>>m;
    cin>>t;
    for(int i=1;i<=n;i++)
    {
        cin>>s[i];
        lens.insert(s[i].size());
    }
    for(int i=1;i<=m;i++)
    {
        int l,r;
        cin>>l>>r;
        queries.push_back({l,r,i});
    }
}
struct BIT
{
    int tree[MAXM];
    void update(int idx,int val)
    {
        for(;idx<MAXM;idx+=idx&(-idx))
        {
            tree[idx]+=val;
        }
    }
    int query(int idx)
    {
        int ret=0;
        for(;idx>0;idx-=idx&(-idx))
        {
            ret+=tree[idx];
        }
        return ret;
    }
}fen;
vector<int>en[MAXM];
int ans[MAXQ];
void solve12345()
{
    vector<pair<int,int> >segments;
    for(int i=1;i<=n;i++)
    {
        hashes[i]=calc_hash(s[i]);
        hashes1[s[i].size()].insert(hashes[i].val);
    }
    pref[0].val=0;
    for(int i=1;i<=t.size();i++)
    {
        pref[i]=pref[i-1];
        pref[i].append_letter(t[i-1]);
    }
    for(int i=1;i<=t.size();i++)
    {
        for(auto len:lens)
        {
            int l=i,r=i+len-1;
            if(r>t.size())continue;
            ll alo=get_hash(l,r).val;
            if(hashes1[len].find(alo)!=hashes1[len].end())
            {
                segments.push_back({l,r});
                fen.update(r,+1);
                en[l].push_back(r);
            }
        }
    }
    sort(queries.begin(),queries.end());
    int last=0;
    for(int i=0;i<queries.size();i++)
    {
        while(last+1<queries[i].l)
        {
            last++;
            for(auto xd:en[last])
            {
                fen.update(xd,-1);
            }
        }
        ans[queries[i].idx]=fen.query(queries[i].r);
    }
    for(int i=1;i<=m;i++)
    {
        cout<<ans[i]<<" ";
    }
    cout<<endl;
}
int main()
{
    read();
    solve12345();
return 0;
}
