#include <bits/stdc++.h>

#define ll long long
#define F first
#define S second
#define ld long double
using namespace std;
const ll P = 31;
const ll mod = 1e9 + 7;
vector<ll> pows;
int n, m, maxn;
string t;
vector<int> a;
vector<ll> hashs;
vector<pair<int, int>> segs;
vector<vector<int>> tr;

inline vector<ll> H(string &s) {
    vector<ll> hs(s.size() + 1);
    hs[0] = 0;
    for (int i = 0; i < s.size(); ++i) {
        hs[i + 1] = (hs[i] * P % mod + s[i] - 'a' + 1) % mod;
    }
    return hs;
}

inline ll has(string &s) {
    ll last = 0;
    for (char i: s) {
        last = (last * P % mod + i - 'a' + 1) % mod;
    }
    return last;
}

vector<int> unite(vector<int> &v1, vector<int> &v2) {
    vector<int> nw;
    int id1 = 0, id2 = 0;
    while (id1 < v1.size() || id2 < v2.size()) {
        if (id1 == v1.size()) {
            nw.push_back(v2[id2]);
            id2++;
        } else if (id2 == v2.size()) {
            nw.push_back(v1[id1]);
            id1++;
        } else if (v1[id1] <= v2[id2]) {
            nw.push_back(v1[id1]);
            id1++;
        } else {
            nw.push_back(v2[id2]);
            id2++;
        }
    }
    return nw;
}

inline int query(int v, int lv, int rv, int l, int r, int x) {
    if (lv >= r || rv <= l)return 0;
    if (lv >= l && rv <= r)return upper_bound(tr[v].begin(), tr[v].end(), x) - tr[v].begin();
    int mid = (lv + rv) / 2;
    return query(v * 2, lv, mid, l, r, x) + query(v * 2 + 1, mid, rv, l, r, x);
}

inline int maxpow2(int x) {
    int y = 1;
    while (y < x)y *= 2;
    return y;
}

signed main() {
    pows.resize(10000000);
    pows[0] = 1;
    for (int i = 1; i < pows.size(); ++i) {
        pows[i] = pows[i - 1] * P % mod;
    }
    cin >> n >> m >> t;
    a.resize(n);
    string O;
    hashs.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> O;
        hashs[i] = has(O);
        a[i] = O.size();
    }
    vector<ll> hasht = H(t);
    for (int i = 0; i < n; ++i) {
        if (a[i] > t.size())continue;
        for (int j = 0; j < t.size() - a[i] + 1; ++j) {
            ll h = (hasht[j + a[i]] - hasht[j] * pows[a[i]] % mod + mod) % mod;
            if (h == hashs[i]) {
                segs.emplace_back(j, j + a[i]);
            }
        }
    }
    sort(segs.begin(), segs.end());
    maxn = maxpow2(segs.size());
    tr.resize(maxn * 2, {});
    for (int i = 0; i < segs.size(); ++i) {
        tr[i + maxn] = {segs[i].S};
    }
    for (int i = maxn - 1; i > 0; --i) {
        tr[i] = unite(tr[i * 2], tr[i * 2 + 1]);
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--;
        pair<int, int> e = {l, -1}, f = {r, 1e9};
        auto it = lower_bound(segs.begin(), segs.end(), e);
        if (it == segs.end()) {
            cout << "0 ";
            continue;
        }
        auto it1 = upper_bound(segs.begin(), segs.end(), f);
        if (it1 == segs.begin()) {
            cout << "0 ";
            continue;
        }
        it1--;
        cout << query(1, 0, maxn, it - segs.begin(), it1 - segs.begin() + 1, r) << '\n';
    }
    return 0;
}
