/*
Lisa
Jennie
Jisoo
Rose
 */

#pragma GCC optimize("03")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <cstring>
#include <chrono>
#include <random>
#include <bits/extc++.h>


using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;
using pll = pair<ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-8;

#define all(a) a.begin(), a.end()
#define pb push_back
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;
// #define int ll


struct segtree {
    vector<vector<int>> tree;
    int sz;

    void init (int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.resize(2 * sz - 1);
    }

    void update (int l, int r, int v, int x, int lx, int rx) {
        if (l >= rx || lx >= r) {
            return;
        }
        if (lx >= l && rx <= r) {
            tree[x].pb(v);
            return;
        }
        int m = (lx + rx) >> 1;
        update(l, r, v, 2 * x + 1, lx, m);
        update(l, r, v, 2 * x + 2, m, rx);
    }

    void dora (int x, int lx, int rx) {
        if (!tree[x].empty()) {
            sort(all(tree[x]));
        }
        if (rx - lx != 1) {
            int m = (lx + rx) >> 1;
            dora(2 * x + 1, lx, m);
            dora(2 * x + 2, m, rx);
        }
    }

    int get (int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            return (upper_bound(all(tree[x]), v) - tree[x].begin());
        }
        int m = (lx + rx) >> 1;
        if (i < m) {
            return get(i, v, 2 * x + 1, lx, m) + (upper_bound(all(tree[x]), v) - tree[x].begin());
        }
        else {
            return get(i, v, 2 * x + 2, m, rx) + (upper_bound(all(tree[x]), v) - tree[x].begin());
        }
    }
};


vector <int> c, c1;

bool cmp0 (int i, int j) {
    return c[i] < c[j];
}


int curr, nn;
bool cmp (int i, int j) {
    return c[i] < c[j] || (c[i] == c[j] && ((i + (1 << curr) < nn ? c[i + (1 << curr)] : -1) < ((j + (1 << curr) < nn ? c[j + (1 << curr)] : -1))));
}


vector <int> suffmas (string a) {
    int n = a.size(); nn = n;
    c.resize(n);
    for (int i = 0; i < n; ++i) {
        if (a[i] == 'A') {
            c[i] = 0;
        }
        else {
            c[i] = a[i] - 'a' + 1;
        }
    }
    c1.resize(n);
    // vout(c);
    vector <int> v(n); iota(all(v), 0); // sort(all(v), cmp0);
    for (int t = 0; (1 << t) <= n; ++t) {
        sort(all(v), cmp);
        int dora = 0;
        c1[v[0]] = dora;
        for (int i = 1; i < n; ++i) {
            if (cmp(v[i - 1], v[i])) {
                ++dora;
            }
            c1[v[i]] = dora;
        }
        c = c1;
    }
    return v;
}


const int N = 5e5 + 1, M = 6e6 + 1;
const ll base = 1e6 + 3;
ll pw[M];
ll n, q, S[N];
string t;
vector <pll> ask[N];
vector <ll> hsh[N];
vector <ll> ans;
vector <string> a;
pll gt[M]; // get the {index of string, position in that string} by pos in z


ll get (int index, ll l, ll r) {
    return (hsh[index][r + 1] - hsh[index][l] * pw[r - l + 1] % mod + mod) % mod;
}

ll nop (int i, int l1, int j, int l2) {
    int left = 0, right = min(S[i], S[j]) + 1;
    // cout << a[i] << ' ' << a[j] << endl;
    while (right - left > 1) {
        int mid = (left + right) >> 1;
        if (l1 + mid - 1 >= S[i] || l2 + mid - 1 >= S[j]) {
            right = mid;
        }
        else if (get(i, l1, l1 + mid - 1) == get(j, l2, l2 + mid - 1)) {
            left = mid;
        }
        else {
            right = mid;
        }
    }
    return left;
}


void solve() {
    for (auto &i : gt) {
        i = {-1, -1};
    }
    cin >> n >> q >> t;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        S[i] = a[i].size();
        hsh[i] = {0};
        for (int j = 0; j < S[i]; ++j) {
            hsh[i].pb((hsh[i][j] * base % mod + (a[i][j] - 'a' + 1)) % mod);
        }
    }
    ans.assign(q, 0);
    for (int i = 0; i < q; ++i) {
        int l, r; cin >> l >> r; --l; --r;
        for (int j = l; j <= r; ++j) {
            ask[j].pb({r, i});
        }
    }
    string z = t;
    for (int j = 0; j < t.size(); ++j) {
        gt[j] = {n, j};
    }
    a.pb(t);
    S[n] = t.size();
    hsh[n] = {0};
    for (int j = 0; j < S[n]; ++j) {
        hsh[n].pb((hsh[n][j] * base % mod + (a[n][j] - 'a' + 1)) % mod);
    }
    vector <int> pos(n); // get the position of string i in z
    for (int i = 0; i < n; ++i) {
        z += 'A';
        int curr = z.size();
        for (int j = 0; j < a[i].size(); ++j) {
            gt[curr + j] = {i, j};
        }
        pos[i] = curr;
        z += a[i];
    }
    int sz = z.size();
    auto v = suffmas(z);
    vector <int> vpos(1 + n);
    for (int i = 0; i < sz; ++i) {
        if (gt[v[i]].first != -1 && !gt[v[i]].second) {
            vpos[gt[v[i]].first] = i;
        }
    }
    // cout << nop(1, 0, 0, 2) << endl; return;
    // cout << z << endl;
    // vout(v);
    segtree st; st.init(sz);
    for (int ii = 0; ii < n; ++ii) {
        int i = vpos[ii], L, R;
        int left = 0, right = i;
        while (right - left > 1) {
            int mid = (left + right) >> 1;
            if (gt[v[mid]].first == -1) {
                left = mid;
            }
            else if (nop(ii, 0, gt[v[mid]].first, gt[v[mid]].second) == S[ii]) {
                right = mid;
            }
            else {
                left = mid;
            }
        }
        L = right;
        left = i; right = sz;
        while (right - left > 1) {
            int mid = (left + right) >> 1;
            if (gt[v[mid]].first == -1) {
                right = mid;
            }
            else if (nop(ii, 0, gt[v[mid]].first, gt[v[mid]].second) == S[ii]) {
                left = mid;
            }
            else {
                right = mid;
            }
        }
        R = left;
        // debug(ii << ' ' << S[ii] << ' ' << i << ' ' << L << ' ' << R);
        st.update(L, R + 1, S[ii], 0, 0, sz);
    }
    for (int i = 0; i < sz; ++i) {
        if (gt[v[i]].first == n) {
            for (auto j : ask[gt[v[i]].second]) {
                ans[j.second] += st.get(i, j.first - gt[v[i]].second + 1, 0, 0, sz);
            }
        }
    }
    vout(ans);
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    pw[0] = 1;
    for (int i = 1; i < M; ++i) {
        pw[i] = pw[i - 1] * base % mod;
    }
    // vout(suffmas("aaa")); exit(0);
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}