#include "bits/stdc++.h"
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2,fma,bmi,bmi2,mmx,tune=native")
#include "bits/extc++.h"
#define all(x) begin(x), end(x)
#define rall(x) x.rbegin(), x.rend()
#define frl(i, x) for(auto& i : x)
#define rep(i, j, k) for(int i = j; i < k; i++)
#define rrep(i, j, k) for(int i = k - 1; i >= j; i--)
#define S second
#define F first

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = double;
using ull = unsigned long long;
using treap = tree<int, null_type>;

const ll mod = 1e9+1000-7;
using hs = ll;
ll pp = 239;
const int maxn = 5e5+5;
ll p[maxn];

struct hasher{
    vector<hs> h;
    void build(string& s){
        h.resize(s.size() + 1);
        h[0] = 0;
        rep(i, 0, s.size()) h[i + 1] = (h[i] * pp + s[i]) % mod;
    }

    hs get(int l, int r){
        ll x = (h[r] - h[l] * p[r - l]) % mod;
        if(x < 0) return x + mod;
        else return x;
    }
};

hs get_str(string& s){
    hs h = 0;
    rep(i, 0, s.size()){
        h = (h * pp + s[i]) % mod;
    }
    return h;
}

vector<int> fw[maxn];
int l;
inline void add(int x, int y){
    for(x++;x<=l;x+=x&-x){
        fw[x].push_back(y);
    }
}
inline int getpref(int x, int r){
    int ans = 0;
    for(x++;x>0;x-=x&-x){
        ans += upper_bound(all(fw[x]), r) - fw[x].begin();
    }
    return ans;
}

inline int get(int tl, int tr, int r){
    return getpref(tr-1, r) - getpref(tl-1, r);
}
void solve(){
    p[0] = 1;
    rep(i, 1, maxn) p[i] = p[i-1] * pp % mod;
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    hasher hhh;
    hhh.build(t);
    l = t.size();
    unordered_map<int, cc_hash_table<hs, bool>> lens;
    rep(i, 0, n){
        string s;
        cin >> s;
        lens[s.size()].insert({get_str(s), 1});
    }
    vector<pair<int, int>> v;
    frl(i, lens){
        int len = i.F;
        auto& hashes = i.S;
        rep(j, 0, l - len + 1){
            hs h1 = hhh.get(j, j + len);
            if(hashes.find(h1) != hashes.end()){
                add(j, j+len);
            }
        }
    }
    rep(i, 0, maxn){
        if(!fw[i].empty()) sort(all(fw[i]));
    }
    rep(j, 0, m){
        int tl, tr;
        cin>>tl>>tr;tl--;
        cout << get(tl, tr, tr) << ' ';
    }
}

int main(){
    cin.tie(0)->ios::sync_with_stdio(0);
    cout << setprecision(15) << fixed;
    int TT=1;
    //cin>>TT;
    while(TT--) solve();
}