#include "bits/stdc++.h"
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2,fma,bmi,bmi2,mmx,tune=native")
#include "bits/extc++.h"
#define all(x) begin(x), end(x)
#define rall(x) x.rbegin(), x.rend()
#define frl(i, x) for(auto& i : x)
#define rep(i, j, k) for(int i = j; i < k; i++)
#define rrep(i, j, k) for(int i = k - 1; i >= j; i--)
#define S second
#define F first

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = double;
using ull = unsigned long long;
using treap = tree<int, null_type>;

const ll mod = 1e9+1000-7;
using hs = ll;
ll pp = 239;
const int maxn = 5e5+5;
ll p[maxn];
vector<int> blocks[1<<12][1<<8];
vector<int> kok[1<<12];
int mask = (1<<8) - 1;

struct hasher{
    vector<hs> h;
    void build(string& s){
        h.resize(s.size() + 1);
        h[0] = 0;
        rep(i, 0, s.size()) h[i + 1] = (h[i] * pp + s[i]) % mod;
    }

    hs get(int l, int r){
        ll x = (h[r] - h[l] * p[r - l]) % mod;
        if(x < 0) return x + mod;
        else return x;
    }
};

hs get_str(string& s){
    hs h = 0;
    rep(i, 0, s.size()){
        h = (h * pp + s[i]) % mod;
    }
    return h;
}

int get(int tl, int tr, int r){
    tr--;
    int lbl = tl>>8;
    int rbl = tr>>8;
    int ans = 0;
    if(lbl == rbl){
        rep(i, tl&mask, (tr&mask) + 1){
            ans += upper_bound(all(blocks[lbl][i]), r) - blocks[lbl][i].begin();
        }
        return ans;
    }
    rep(i, tl&mask, mask+1){
        ans += upper_bound(all(blocks[lbl][i]), r) - blocks[lbl][i].begin();
    }
    rep(i, 0, (tr&mask)+1){
        ans += upper_bound(all(blocks[rbl][i]), r) - blocks[rbl][i].begin();
    }
    rep(bl, lbl+1, rbl){
        ans += upper_bound(all(kok[bl]), r) - kok[bl].begin();
    }
    return ans;
}

void solve(){
    int l;
    p[0] = 1;
    rep(i, 1, maxn) p[i] = p[i-1] * pp % mod;
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    hasher hhh;
    hhh.build(t);
    l = t.size();
    unordered_map<int, vector<hs>> lens;
    rep(i, 0, n){
        string s;
        cin >> s;
        lens[s.size()].push_back(get_str(s));
    }
    frl(i, lens) sort(all(i.S));
    vector<pair<int, int>> v;
    frl(i, lens){
        int len = i.F;
        auto& hashes = i.S;
        rep(j, 0, l - len + 1){
            hs h1 = hhh.get(j, j + len);
            if(binary_search(all(hashes), h1)){
                blocks[j>>8][j&mask].push_back(j+len);
                kok[j>>8].push_back(j+len);
            }
        }
    }
    rep(i, 0, 1<<12) sort(all(kok[i]));
    rep(i, 0, 1<<12){
        rep(j, 0, 1<<8){
            sort(all(blocks[i][j]));
        }
    }

    rep(j, 0, m){
        int tl, tr;
        cin>>tl>>tr;tl--;
        cout << get(tl, tr, tr) << ' ';
    }
}

int main(){
    cin.tie(0)->ios::sync_with_stdio(0);
    cout << setprecision(15) << fixed;
    int TT=1;
    //cin>>TT;
    while(TT--) solve();
}