#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
random_device rd;
mt19937 rnd(rd());
const ll E = 26, N = 1e6 + 5; //AHAHAHAH SUKA

struct node {
    int go[E], len, p, ch, link, slink;
    bool term;
    vector<int> ind;

    node() = default;

    node(int len, int p, int ch) : len(len), p(p), ch(ch), link(-1), slink(-1), term(false) {
        memset(go, -1, sizeof go);
    }
};

int POS = 0, root = 0;
node t[N];

int make(int len, int p, int ch) {
    t[POS] = node(len, p, ch);
    return POS++;
}

void add(string &s, int ind) {
    int v = root;
    for (int i = 0; i < sz(s); i++) {
        int c = s[i] - 'a';
        if (t[v].go[c] == -1)
            t[v].go[c] = make(i, v, c);
        v = t[v].go[c];
    }
    t[v].term = true;
    t[v].ind.push_back(ind);
}

int go(int v, int c);

int get_link(int v) {
    if (t[v].link != -1)
        return t[v].link;
    if (v == root || t[v].p == root)
        return t[v].link = root;
    return t[v].link = go(get_link(t[v].p), t[v].ch);
}

int get_slink(int v) {
    if (t[v].slink != -1)
        return t[v].slink;
    int u = get_link(v);
    if (t[u].term)
        return t[v].slink = u;
    return t[v].slink = get_slink(u);
}

int go(int v, int c) {
    if (t[v].go[c] != -1)
        return t[v].go[c];
    if (v == root)
        return t[v].go[c] = root;
    return t[v].go[c] = go(get_link(v), c);
}

vector<ll> res[N];

vector<pair<int, int>> info[N];

void update(int v, int len) {
    for (; v != root; v = get_slink(v)) {
        if (!t[v].term)
            continue;
        info[len].emplace_back(len - t[v].len, sz(t[v].ind));
    }
}

void solve() {
    root = POS++;
    t[root] = node(0, -1, -1);
    t[root].term = true;

    ll n, m;
    cin >> n >> m;
    string TEXT;
    cin >> TEXT;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        add(s, i);
    }

    int v = root;
    for (int i = 0; i < sz(TEXT); i++) {
        v = go(v, TEXT[i] - 'a');
        update(v, i);
    }
    vector<vector<ll>> suf(sz(TEXT));
    for (int i = 0; i < sz(TEXT); i++) {
        suf[i].resize(sz(info[i]));
        for (int j = sz(info[i]) - 1; j >= 0; j--) {
            if (j + 1 <= (sz(info[i]) - 1))
                suf[i][j] = suf[i][j + 1];
            suf[i][j] += info[i][j].second;
        }
    }

    while (m--) {
        int l, r;
        cin >> l >> r, l--, r--;
        ll cnt = 0;
        for (int j = l; j <= r; j++) {
            int L = -1, R = sz(info[j]);
            while (R - L > 1) {
                int MID = (R + L) / 2;
                if (l <= info[j][MID].first)
                    R = MID;
                else
                    L = MID;
            }
            //if()
            if(R <= sz(suf[j]) - 1)
                cnt += suf[j][R];
        }
        cout << cnt << '\n';
    }
}

int main() {
    cin.tie(0), cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
