#include <bits/stdc++.h>

#define int long long

using namespace std;

const int p = 179, mod_1 = 1e9 + 7, mod_2 = 1e9 + 9;

bool is_ravno(string &in, string &s, int start) {
    for (int i = 0; i < in.size(); i++) {
        if (in[i] != s[start + i]) {
            return false;
        }
    }
    return true;
}

signed main() {
    //ifstream cin("text.in");
    //ofstream cout("text.out");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, m, i, l, r, j, now_hash_1, now_hash_2, cnt;
    string in, s;
    cin >> n >> m >> s;
    if (n <= 100) {
        vector<int> lens(n);
        vector<vector<int>> ans(n);
        for (i = 0; i < n; i++) {
            cin >> in;
            lens[i] = in.size();
            ans[i].push_back(-1e9);
            for (j = 0; j + in.size() - 1 < s.size(); j++) {
                if (is_ravno(in, s, j)) {
                    ans[i].push_back(j);
                }
            }
            ans[i].push_back(1e9);
        }
        while (m--) {
            cin >> l >> r;
            l--, r--;
            cnt = 0;
            for (i = 0; i < n; i++) {
                cnt += upper_bound(ans[i].begin(), ans[i].end(), r + 1 - lens[i]) - ans[i].begin() - 1;
                int low = lower_bound(ans[i].begin(), ans[i].end(), l) - ans[i].begin() - 1;
                cnt -= low;
            }
            cout << cnt << ' ';
        }
        return 0;
    }
    set<pair<int, int>> strings;
    vector<vector<int>> ans(s.size(), vector<int>(s.size(), 0)), pref(s.size(), vector<int>(s.size(), 0));
    while (n--) {
        cin >> in;
        now_hash_1 = 0, now_hash_2 = 0;
        for (char c : in) {
            now_hash_1 = (now_hash_1 * p + c - 'a' + 1) % mod_1;
            now_hash_2 = (now_hash_2 * p + c - 'a' + 1) % mod_2;
        }
        strings.insert({now_hash_1, now_hash_2});
    }
    for (i = 0; i < s.size(); i++) {
        now_hash_1 = 0, now_hash_2 = 0, cnt = 0;
        for (j = i; j < s.size(); j++) {
            now_hash_1 = (now_hash_1 * p + s[j] - 'a' + 1) % mod_1;
            now_hash_2 = (now_hash_2 * p + s[j] - 'a' + 1) % mod_2;
            cnt += strings.count({now_hash_1, now_hash_2});
            ans[i][j] = cnt;
        }
    }
    for (j = 0; j < s.size(); j++) {
        pref[j][0] = ans[0][j];
        for (i = 1; i <= j; i++) {
            pref[j][i] = pref[j][i - 1] + ans[i][j];
        }
    }
    while (m--) {
        cin >> l >> r;
        cnt = pref[r - 1][r - 1];
        if (l - 1) {
            cnt -= pref[r - 1][l - 2];
        }
        cout << cnt << ' ';
    }
}