#include <bits/stdc++.h>
using namespace std;

struct hashh {
    int n, pp = 29, mod = 1e9 + 7;
    vector<int> h, p;
    string s;

    void make() {
        n = s.size();
        p.resize(n + 1);
        h.resize(n + 1);
        p[0] = 1;
        h[0] = 0;
        for (int i = 0; i < n; i++) {
            h[i + 1] = (1ll * h[i] * pp + s[i] - 'a' + 1) % mod;
            p[i + 1] = 1ll * p[i] * pp % mod;
        }
    }

    int get_hash(int l, int r) {
        return (mod + h[r + 1] - 1ll * h[l] * p[r - l + 1] % mod) % mod;
    }
};

hashh s[500100];
int ans[500100], cnt = 0;
vector<vector<int> > st(1000100), f(1000100);
vector<vector<pair<pair<int, int>, int> > > g(100100);

void addr(int l, int r) {
    int ll = 0, rr = f[r].size();
    while (ll < rr) {
        int mm = (ll + rr) / 2;
        if (f[r][mm] > r - l + 1) {
            rr = mm;
        } else {
            ll = mm + 1;
        }
    }
    cnt += ll;
//    ll--;
//    while (ll >= 0 && f[r][ll] == r - l + 1) {
//        cnt++;
//        cout << ll << ' ' << f[r][ll] << '\n';
//        ll--;
//    }
}

void add(int l, int r) {
    int ll = 0, rr = st[l].size();
    while (ll < rr) {
        int mm = (ll + rr) / 2;
        if (st[l][mm] > r - l + 1) {
            rr = mm;
        } else {
            ll = mm + 1;
        }
    }
    cnt += ll;
//    ll--;
//    while (ll >= 0 && st[l][ll] == r - l + 1) {
//        cnt++;
//        ll--;
//    }
}

void erase(int l, int r) {
    int ll = 0, rr = st[l].size();
    while (ll < rr) {
        int mm = (ll + rr) / 2;
        if (st[l][mm] > r - l + 1) {
            rr = mm;
        } else {
            ll = mm + 1;
        }
    }
    cnt -= ll;
//    ll--;
//    while (ll >= 0 && st[l][ll] == r - l + 1) {
//        cnt--;
//        ll--;
//    }
}

int hh[500100];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, k = 300;
    hashh t;

    cin >> n >> m;
    cin >> t.s;
    t.make();
    for (int i = 0; i < n; i++) {
        cin >> s[i].s;
        s[i].make();
        hh[i] = s[i].get_hash(0, (int)s[i].s.size() - 1);
    }
    vector<pair<int, int> > b;
    for (int i = 0; i < n; i++) {
        b.push_back({s[i].s.size(), i});
    }
    sort(b.begin(), b.end());

    for (int j = 0; j < t.s.size(); j++) {
        for (auto h : b) {
            int i = h.second;
            if (j + (int)s[i].s.size() - 1 < t.s.size() && hh[i] == t.get_hash(j, j + (int)s[i].s.size() - 1)) {
                st[j].push_back(s[i].s.size());
            }
            if (j >= (int)s[i].s.size() - 1 && hh[i] == t.get_hash(j - (int)s[i].s.size() + 1, j)) {
                f[j].push_back(s[i].s.size());
            }
        }
//        cout << "j = " << j << ":\n";
//        for (auto i : st[j]) {
//            cout << i << ' ';
//        }
//        cout << '\n';
//        for (auto i : f[j]) {
//            cout << i << ' ';
//        }
//        cout << '\n';
//        cout << st[j] << ' ' << f[j] << '\n';
    }

    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        g[l / k].push_back({{r, l}, i});
    }
    int sz = t.s.size();
    for (int i = 0; i <= sz / k; i++) {
        sort(g[i].begin(), g[i].end());
        int l = i * k, r = i * k - 1;
        cnt = 0;
        for (auto j : g[i]) {
            while (r < j.first.first) {
                r++;
                addr(l ,r);
            }
            while (l < j.first.second) {
                erase(l, r);
                l++;
            }
            while (l > j.first.second) {
                l--;
                add(l, r);
            }
            ans[j.second] = cnt;
//            cout << l << ' ' << r << "    " << cnt << '\n';
        }
    }
    for (int i = 0; i < m; i++) {
        cout << ans[i] << ' ';
    }
    cout << '\n';

    return 0;
}
