#include<bits/stdc++.h>
using namespace std;
const long long maxn = 1000001;
long long n,m;
long long h[maxn];
long long pw[maxn];
long long base = 33;

string t,s;
long long sh[maxn];
long long slen[maxn];
vector<long long>v[33];

void make_hash()
{
    long long sz = t.size();
    for( long long i = 1; i <= sz; i ++ )
    {
        h[i] = h[i-1] * base + ( t[i-1] - 'a' + 1 );
    }
}

long long get_hash()
{
    long long th = 0;
    long long sz1 = s.size();
    for( long long i = 0; i < sz1; i ++ )
    {
        th = th * base + ( s[i] - 'a' + 1 );
    }
    return th;
}

void read()
{
    pw[0] = 1;
    for( long long i = 1; i < maxn; i ++ )
        pw[i] = pw[i-1] * base;

    cin >> n >> m;
    cin >> t;

    make_hash();
    for( long long i = 1; i <= n; i ++ )
    {
        cin >> s;
        sh[i] = get_hash();
        slen[i] = s.size();

        long long beg = s[0] - 'a' + 1;
        v[beg].push_back(i);
    }
}
void check( long long ql, long long qr )
{
    long long ans = 0;
    for( long long i = ql; i <= qr; i ++ )
    {
        long long beg = t[i-1] - 'a' + 1;
        for( long long k = 0; k < v[beg].size(); k ++ )
        {
            long long j = v[beg][k];
            if( i + slen[j] - 1 > qr ) continue;

            long long l = i;
            long long r = i + slen[j] - 1;

            long long sub = h[r] - h[l-1] * pw[slen[j]];
            if( sub == sh[j] ) ans += 1;
        }
    }
    cout << ans << " ";
}
void solve()
{
    long long ql,qr;
    for( long long i = 1; i <= m; i ++ )
    {
        cin >> ql >> qr;
        check(ql,qr);
    }
    cout << "\n";
}
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    speed();
    read();
    solve();
    return 0;
}
