#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

struct node
{
    int id[26], rm, par, lastch;
    int fail, lastok, ok;
    node() {}
};

string t, ns;
int n, q;

int sz=1;
node trie[1000006];

void trie_add()
{
    int tid=1;
    int br=ns.size();
    for(int i=0; i<br; i++)
    {
        if(trie[tid].id[ns[i]-'a']==0)
        {
            sz++;
            trie[tid].id[ns[i]-'a']=sz;
            trie[sz].rm=trie[tid].rm+1;
            trie[sz].par=tid;
            trie[sz].lastch=ns[i]-'a';
            tid=sz;
        }
        else tid=trie[tid].id[ns[i]-'a'];
    }
    trie[tid].ok=1;
}


void print_trie(int v, string s)
{
    cout<<v<<" "<<trie[v].rm<<": "<<s<<" ok="<<trie[v].ok<<" lastok="<<trie[v].lastok<<" fail="<<trie[v].fail<<endl;
    for(int i=0; i<26; i++) if(!trie[v].id[i]) continue; else print_trie(trie[v].id[i], s+char('a'+i));
}

queue<int> qu;

void fill_trie()
{
    for(int i=0; i<26; i++)
    {
        if(trie[1].id[i]) qu.push(trie[1].id[i]);
    }
    while(!qu.empty())
    {
        int id=qu.front();
        qu.pop();
        if(trie[id].rm==1)
        {
            trie[id].fail=1;
        }
        else
        {
            int fid=trie[trie[id].par].fail;
            while(fid!=0)
            {
                if(trie[fid].id[trie[id].lastch])
                {
                    trie[id].fail=trie[fid].id[trie[id].lastch];
                    if(trie[trie[id].fail].ok) trie[id].lastok=trie[id].fail;
                    else trie[id].lastok=trie[trie[id].fail].lastok;
                    break;
                }
                fid=trie[fid].fail;
            }
            if(!trie[id].fail) trie[id].fail=1;
        }
        for(int i=0; i<26; i++) if(trie[id].id[i]) qu.push(trie[id].id[i]);
    }
}
int ts;
int sqbr[3000];
int ist[5000005];

void update(int pos)
{
    sqbr[(pos-1)/3000+1]++;
    ist[pos]++;
}

int getsum(int pos)
{
    int id=1, ans=0;
    while(id*3000<=pos)
    {
        ans+=sqbr[id];
        id++;
    }
    for(int i=(id-1)*3000+1; i<=pos; i++) ans+=ist[i];
    return ans;
}


int ans[500005];
struct vypros
{
    int le, ri, nom;
    vypros() {}
    vypros(int a, int b, int c)
    {
        le=a;
        ri=b;
        nom=c;
    }
};
bool cmp(vypros p, vypros q)
{
    return p.ri<q.ri;
}
vypros z[500005];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    cin>>t;
    ts=t.size();
    for(int i=0; i<n; i++)
    {
        cin>>ns;
        trie_add();
    }
    fill_trie();
    ///print_trie(1, "");
    int totsm=0, id=1;
    for(int i=0; i<q; i++)
    {
        cin>>z[i].le>>z[i].ri;
        z[i].nom=i;
    }
    sort(z, z+q, cmp);
    int idz=0;
    for(int i=0; i<ts; i++)
    {
        while(id!=0)
        {
            if(trie[id].id[t[i]-'a'])
            {
                id=trie[id].id[t[i]-'a'];
                break;
            }
            id=trie[id].fail;
        }
        if(!id) id=1;
        int id2=id;
        if(!trie[id].ok) id2=trie[id].lastok;
        while(id2)
        {
            totsm++;
            update(i-trie[id2].rm+2);
            id2=trie[id2].lastok;
        }
        while(idz<q && z[idz].ri==i+1)
        {
            ans[z[idz].nom]=totsm-getsum(z[idz].le-1);
            idz++;
        }
    }
    for(int i=0; i<q; i++)
    {
        cout<<ans[i];
        if(i!=q-1) cout<<" ";
    }
    cout<<endl;
    return 0;
}
/**
10 5
abacaba

aba
a
ac
baa
acba
abab
cabaa
ba
aab
abbba
*/
