#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const int mod = 1e9 + 7;
const ld eps = 1e-6;

vector<vector<pair<int, int> > > g;
vector<int> dp;

bool dfs(int v, int finish) {
    if (v == finish) {
        return 1;
    }
    bool res = 0;
    for (auto to : g[v]) {
        if (dfs(to.first, finish)) {
            res = 1;
            dp[v] ^= dp[to.first] ^ to.second;
        }
    }
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    int h = 0;
    vector<int> w(n);
    g.resize(n);
    dp.resize(n);
    bool flag = 1;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        if (a >= b) {
            flag = 0;
        }
        cin >> w[i];
        g[a - 1].push_back({b - 1, w[i]});
        h ^= w[i];
    }
    if (!flag) {
        int a, b;
        cin >> a >> b;
        if (a > b) swap(a, b);
        a--, b--;
        int t = 0;
        for (int i = a; i < b; i++) {
            t ^= w[i];
        }
        if (t == 0 && (h ^ t) == 0) {
            cout << 0 << endl;
        } else {
            cout << -1 << endl;
        }
    } else {
        int a, b;
        cin >> a >> b;
        a--, b--;
        dfs(a, b);
        cout << dp[a] << endl;
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
        g.clear(), dp.clear();
    }
    return 0;
}