#include <bits/stdc++.h>
using namespace std;
const int maxn = 2e5;
vector<pair<int, int>> g[maxn];
char vis[maxn];
vector<int> top;

void dfs(int v) {
    vis[v] = true;
    for (const auto& [u, w] : g[v]) {
        if (!vis[u]) {
            dfs(u);
        }
    }
    top.emplace_back(v);
}
int dp[maxn], pty[maxn];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        dp[i] = -1, pty[i] = 0, vis[i] = false;
        g[i].clear();
    }
    bool isSingle = (n == m);
    int xorAll = 0;
    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        xorAll ^= w;
        --v, --u;
        g[v].emplace_back(u, w);
        if (isSingle && !((i != n - 1 && v == i && u == i + 1) || (i == n - 1 && v == i && u == 0))) {
            isSingle = false;
        }
    }
    int a, b;
    cin >> a >> b;
    --a, --b;
    if (isSingle) {
        int xorAB = 0;
        for (int v = a; v != b; v = g[v][0].first) {
            xorAB ^= g[v][0].second;
        }
        if (xorAB != 0 || xorAll != 0) {
            cout << -1 << '\n';
        } else {
            cout << 0 << '\n';
        }
        return;
    }
    top.clear();
    for (int v = 0; v < n; ++v) {
        if (!vis[v]) {
            dfs(v);
        }
    }
    reverse(top.begin(), top.end());
    dp[a] = 0, pty[a] = 1;
    for (const int& v : top) {
        if (dp[v] == -1) { continue; }
        for (const auto& [u, w] : g[v]) {
            if (dp[u] == -1) {
                dp[u] = 0;
            }
            dp[u] ^= (dp[v] ^ (w * pty[v]));
            pty[u] ^= pty[v];
        }
    }
    if (dp[b] == -1) {
        dp[b] = 0;
    }
    cout << dp[b] << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
