#include <bits/stdc++.h>

using namespace std;

#define pii pair<int,int>
#define F first
#define S second
typedef long double ld;
//#define int int64_t

mt19937 gen(chrono::system_clock().now().time_since_epoch().count());

const int N = 2e5+10, K = 30;


void solve ()
{
    int n, m;
    cin >> n >> m;
    vector <pii> g[n], g1[n];
    bool ok1 = (n == m), ok2 = 1;
    int X = 0;
    for (int i=0;i<m;++i) {
        int x, y, w;
        cin >> x >> y >> w;
        x--;y--;
        if (x != i || y != (i+1) % n) {
            ok1 = 0;
        }
        if (x >= y) {
            ok2 = 0;
        }
            g[x].push_back({y, w});
            g1[y].push_back({x, w});
        X ^= w;
    }
    int a, b;
    cin >> a >> b;
    a--;b--;
    if (!ok1 && !ok2) {
        cout << "!\n";
        exit(0);
    }
    if (ok1) {
        if (X > 0) {
            cout << -1;
        }
        else {
            cout << 0;
        }
        cout << '\n';
        return;
    }
    int k1[n], k2[n];
    fill(k1, k1+n, 0);
    fill(k2, k2+n, 0);
    k1[a] = 1;
    for (int i=0;i<n;++i){
        if (k1[i]&1) {
            for (pii j:g[i]) {
                k1[j.F] += k1[i];
                k1[j.F] &= 1;
            }
        }
    }
    k2[b] = 1;
    for (int i=n-1;i>=0;--i){
        if (k2[i]&1) {
            for (pii j:g1[i]) {
                k2[j.F] += k2[i];
                k2[j.F] &= 1;
            }
        }
    }
    int ans = 0;
    for (int i=0;i<n;++i){
        for (pii j:g[i]) {
//            cout << i << ' ' << j.F << ' ' << k1[i] << ' ' << k2[j.F] << '\n';
            if (k1[i]&1) {
                if (k2[j.F]&1) {
                    ans ^= j.S;
                }
            }
        }
    }
    cout << ans << '\n';
}

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int q;
    cin >> q;
    for (int it=0;it<q;++it) {
        solve();
    }


    return 0;
}

