#include <iostream>
#include <vector>
#include <deque>
#include <set>
#include <string>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <bitset>

#define f first
#define s second
#define int long long

using namespace std;

const int N = 2*1e5, mod = 1e9+7;
int t1 = 1;

void start();
void update();




signed main() {
    start();
    while(t1--){
        update();
    }
    return 0;
}
int n, k, m;
void start(){
    cin >> t1;

}

vector<int> used(N), used1(N), numer(N);
bool bad;
void DFS(int b, vector<vector<pair<int, pair<int, int>>>> &g, int a){
    for(auto& it : g[b]){
        if(it.s.f != -1){
            if(it.f == a){
                it.s.s = 1;
                numer[b] += it.s.s;
                continue;
            }
            DFS(it.f, g , a);
            it.s.s = numer[it.f];
            numer[b] += it.s.s;
        }
    }
}
map<pair<int, int>, bool> mp;
int xr = 0;
bool DEL_CYCLES(int v, vector<vector<int>> &g){
    used[v] = 1;
    bool great = 0;
    for(auto& it : g[v]){
        if(used[it] == 0){
            bool good = DEL_CYCLES(it, g);
            if(good and good-1 != v){
                great = good;
                mp[{v, it}] = 1;
            }
            else if(good){
                mp[{v, it}] = 1;
            }
        }
        if(used[it] == 1){
            mp[{v, it}] = 1;
            bad = true;
        }
    }
    used[v] = 2;
    return great;
}

void update(){
    bad = false;
    fill(used.begin(), used.end(), 0);
    fill(used1.begin(), used1.end(), 0);
    int n, m;
    cin >> n >> m;
    vector<int> v(m), u(m);
    vector<int> w(m);
    set<pair<int, int>> st;
    for(int i = 0; i<m; i++){
        cin >> v[i] >> u[i] >> w[i];
        st.insert({v[i], u[i]});
    }
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    vector<vector<pair<int, pair<int, int>>>> g(n), g1(n);
    vector<vector<int>> gc(n);
    for(int i = 0; i<m; i++) {
        if (v[i] != u[i]) {
            g[v[i] - 1].push_back({u[i] - 1, {w[i], 0}});
        }
        else{
            bad = true;
        }
    }
    for(auto& it : st){
        gc[it.f-1].push_back(it.s-1);
    }
    for(int i = 0; i<n; i++){
        if(used[i] == 0){
            xr = 0;
            DEL_CYCLES(i, gc);
        }
    }
    for(int i = 0; i<n; i++){
        for(int j = 0; j<g[i].size(); j++){
            if(mp[{i, g[i][j].f}]){
                g[i][j].s.f = -1;
            }
        }
    }
    for(int i = 0; i<n; i++){
        for(int j = 0; j<g[i].size(); j++){
            g1[g[i][j].f].push_back({i, g[i][j].s});
        }
    }
    DFS(b, g1, a);
    int ans = 0;
    for(int i = 0; i<n; i++){
        for(int j = 0; j<g1[i].size(); j++){
            if(g1[i][j].s.f != -1 and g1[i][j].s.s % 2 == 1){
                ans = ans ^ g1[i][j].s.f;
            }
        }
    }
    if(bad and ans != 0){
        cout << -1 << endl;
    }
    else{
        cout << ans << endl;
    }
}
