#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<queue>
#include<deque>
#include<stack>
#include<string>
#include<cmath>
#include<climits>
#include<random>
#include<bitset>
#include<ctime>

#define ft first
#define sd second
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

vector<vector<ii>> g(0);
vector<vector<ii>> t(0);

vector<int> tout(0);
vector<int> used(0);
vector<int> color(0);
vector<bool> good(0);
vector<int> way(0);

int timer = 0;

void dfs (int now) {
   // cout << now << '\n';
    if (used[now])
        return;
    used[now] = true;
    timer++;
    for (auto j : g[now]) {
        dfs(j.ft);
        timer++;
    }
    tout[now] = timer;
    timer++;

}

bool cmp (int i, int j) {
    return tout[i] > tout[j];
}

void dfs_color (int now, int c1) {
    if (used[now])
        return;
    color[now] = c1;
    used[now] = true;
    for (auto j : t[now]) {
        dfs_color(j.ft, c1);
    }
}

void dfs1 (int now, int in, int len) {
    if (used[now]) {
        if (way[now] != len) {
            good[in] = false;
        }
        return;
    }
    used[now] = true;
    way[now] = len;
    for (auto j : g[now]) {
        if (color[j.ft] != in)
            continue;
        dfs1(j.ft, in, j.sd ^ len);
        if (!good[in])
            return;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    t.assign(n, {});
    tout.assign(n, 0);
    int cor1 = 0;
    int w2[n];
    w2[0] = 0;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u - 1].pb(mp(v - 1, w));
        t[v - 1].pb(mp(u - 1, w));
        cor1 ^= w;
        w2[(i + 1) % m] = cor1;
    }
    used.assign(n, false);
    color.assign(n, 0);/*
    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs(i);
    }

    vector<int> order(n);
    for (int i = 0; i < n; i++) {
        order[i] = i;
    }
    sort(order.begin(), order.end(), cmp);
    used.assign(n, false);
    int cnt = 0;
    vector<int> main_in(0);
    for (auto j : order) {
        if (!used[j]) {
            color[j] = cnt;
            main_in.pb(j);
            cnt++;
            dfs_color(j, color[j]);
        }
    }
    //cout << cnt << endl;
    good.assign(n, true);
    way.assign(n, 0);
    used.assign(n, false);
    for (int i = 0; i < 1; i++) {
        dfs1(0, i, 0);
    }*/
    int a, b;
    cin >> a >> b;
    //cout << a << " " << b << " " << good.size() << " " << way.size() << " " << good[0] << endl;
    if (cor1) {
        cout << -1 << '\n';
    } else {
        cout << (w2[a - 1] ^ w2[b - 1]) << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tt;
    cin >> tt;
    while (tt--)
        solve();
    return 0;
}