#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<queue>
#include<deque>
#include<stack>
#include<string>
#include<cmath>
#include<climits>
#include<random>
#include<bitset>
#include<ctime>

#define ft first
#define sd second
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

int a, b;

vector<vector<ii>> g(0);
vector<vector<ii>> t(0);

vector<set<int>> g1(0);


vector<int> tout(0);
vector<int> used(0);
vector<int> color(0);
vector<bool> good(0);
vector<int> way(0);

int timer = 0;

void dfs (int now) {
   // cout << now << '\n';
    if (used[now])
        return;
    used[now] = true;
    timer++;
    for (auto j : g[now]) {
        dfs(j.ft);
        timer++;
    }
    tout[now] = timer;
    timer++;

}

vector<int> way_to_a(0);

bool cmp (int i, int j) {
    return tout[i] > tout[j];
}

void dfs_color (int now, int c1) {
    if (used[now])
        return;
    color[now] = c1;
    used[now] = true;
    for (auto j : t[now]) {
        dfs_color(j.ft, c1);
    }
}

void dfs1 (int now, int in, int len) {
    if (len != 0)
        good[in] = false;
    if (used[now]) {
        return;
    }
    used[now] = true;
    for (auto j : g[now]) {
        if (color[j.ft] != in)
            continue;
        dfs1(j.ft, in, j.sd ^ len);
        if (!good[in])
            return;
    }
}
bool x;
void find_a (int now) {
    if (used[now])
        return;
    if (now == color[b]) {
        x = true;
        return;
    }
    for (auto j : g1[now]) {
        way_to_a.pb(j);
        find_a(j);
        if (x) {
            return;
        }
        way_to_a.pop_back();
    }
}
void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    t.assign(n, {});
    tout.assign(n, 0);
    vector<pair<ii, int>> all(0);
    map<ii, vector<int>> m2;
    int cor1 = 0;
    int way2[n];
    bool x1 = (n == m);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        all.pb(mp(mp(u - 1, v - 1), w));
        m2[mp(u - 1, v - 1)].pb(w);
        g[u - 1].pb(mp(v - 1, w));
        t[v - 1].pb(mp(u - 1, w));
        if (x1) {
            cor1 ^= w;
            if ((u != i) || (v != (i + 1) % m))
                x1 = false;
            way2[(i + 1) % m] = cor1;
        }
    }
    if (x1) {
        cin >> a >> b;
        if ((way2[0] != 0) || (way2[a - 1] != way2[b - 1])) {
            cout << -1 << '\n';
        } else {
            cout << 0 << '\n';
        }
        return ;
    }
/*
   // cout << "done\n";
    //exit(0);
    used.assign(n, false);
    color.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs(i);
    }

    vector<int> order(n);
    for (int i = 0; i < n; i++) {
        order[i] = i;
    }
    sort(order.begin(), order.end(), cmp);
    used.assign(n, false);
    int cnt = 0;
    vector<int> main_in(0);
    for (auto j : order) {
        if (!used[j]) {
            color[j] = cnt;
            main_in.pb(j);
            cnt++;
            dfs_color(j, color[j]);
        }
    }
    //cout << cnt << endl;
    good.assign(n, true);
    way.assign(n, 0);
    used.assign(n, false);
    for (int i = 0; i < cnt; i++) {
        dfs1(main_in[i], i, 0);
    }
    cin >> a >> b;

    a--; b--;
    if (a >= b) {
        cout << 0 << '\n';
        return;
    }
    //cout << color[a - 1] << " " << color[b - 1] << " " << good[0] << " " << good[1] << " " << main_in[0] << " " << main_in[1] << endl;
    //cout << a << " " << b << " " << good.size() << " " << way.size() << " " << good[0] << endl;
    */
    cout.precision(20);
    g1.assign(n, {});
    map<ii, vector<int>> m1;
    for (int i = 0; i < all.size(); i++) {
       /* if (color[all[i].ft.ft] != color[all[i].ft.sd]) {
            g1[color[all[i].ft.ft]].insert(color[all[i].ft.sd]);
            m1[mp(color[all[i].ft.ft], color[all[i].ft.sd])].push_back(all[i].sd);
        }*/
       g1[all[i].ft.ft].insert(all[i].ft.sd);
    }

    cin >> a >> b;
    a--; b--;
    if (a >= b) {
        cout << 0 << '\n';
        return;
    }
    int dp[n];
    for (int i = 0; i < n; i++)
        dp[i] = 0;
    vector<bool> can(n, false);
    can[a] = true;
    vector<int> used1(n, false);
    vector<int> num_of_ways(n, 0);
    num_of_ways[a] = 1;
    for (int i = a; i < b; i++) {
        if (!can[i])
            continue;
        for (auto j : g1[i]) {
            int dp1 = 0;
            int cnt12 = 0;
            for (auto j1 : m2[mp(i, j)]) {
                if (num_of_ways[i] == 1) {
                    dp1 ^= (dp[i] ^ j1);
                }else {
                    dp1 ^= dp[i];
                }
                cnt12++;
            }
            num_of_ways[j] += (cnt12 * num_of_ways[i]) % 2;
            num_of_ways[j] %= 2;
            dp[j] ^= dp1;
            can[j] = true;
        }
    }
    cout.precision(20);
    cout << dp[b] << '\n';
    /*while (!q.empty()) {
        int now, pred;
        now = q.front().ft;
        pred = q.front().sd;
        q.pop();
        used1[now] = true;
        int dp1 = 0;
        for (auto j : g1[now]) {
            if (used[j]) {
                continue;
            }
            dp1 = 0;
            for (auto j1 : m1[mp(now, j)]) {
                dp1 = dp1 ^ (dp[now] ^ j1);
            }
            dp[j] ^= dp1;
        }
    }
    cout << dp[b] <<  '\n';*/
    return;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tt;
    cin >> tt;
    while (tt--)
        solve();
    return 0;
}