//#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

#define all(a) a.begin(), a.end()
#define forall(iiii, aaaa) for(auto& iiii: aaaa)
#define print(aaaa) forall(aaa, aaaa) cout << aaa << ' '; cout << '\n'

typedef long long ll;
typedef long double ld;

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll mod = 1e9+7;

ll bin_pow(ll n, ll p) {
    if (p == 0) return 1;
    if (p & 1) return n * bin_pow(n, p - 1) % mod;
    return bin_pow(n * n % mod, p / 2);
}

ll gcd(ll a, ll b) {
    while (b %= a) swap(a, b);
    return a;
}

void solve () {
    ll n, m;
    cin >> n >> m;
    vector < ll > a(n);
    for (ll i = 0; i < m; i++) {
        cin >> a[i % n] >> a[i % n] >> a[i % n];
    }
    ll x, y;
    cin >> x >> y;
    x--; y--;
    ll xx = 0;
    forall(i, a) xx ^= i;
    if (xx) {
        cout << -1 << '\n';
        return;
    }
    ll ans = 0;
    while (x != y) {
        ans ^= a[x];
        x = (x + 1) % n;
    }
    if (ans != 0) ans = -1;
    cout << ans << '\n';
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
//    cout << fixed << setprecision(12);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
