#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<>,
        rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ff first
#define ss second

using pii = pair <int, int>;

template <typename T>
void mxr(T& a, const T& b) {
    a = max(a, b);
}

template <typename T>
void mnr(T& a, const T& b) {
    a = min(a, b);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <pii> > g(n);
    bool f = true;
    int allx = 0;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        if (a == n && b != 1) {
            f = false;
        }
        if (a != n && b != a + 1) {
            f = false;
        }
        --a, --b;
        int w;
        cin >> w;
        g[a].emplace_back(b, w);
        allx ^= w;
    }
    int a, b;
    cin >> a >> b;
    if (f) {
        cout << allx;
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t --> 0) {
        solve();
        cout << "\n";
    }
}
