#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<>,
        rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ff first
#define ss second

using pii = pair <int, int>;

template <typename T>
void mxr(T& a, const T& b) {
    a = max(a, b);
}

template <typename T>
void mnr(T& a, const T& b) {
    a = min(a, b);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <pii> > g(n);
    bool f = (m == n);
    bool f2 = true;
    int allx = 0;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        if (i != a || b != (i + 1) % n) {
            f = false;
        }
        int w;
        cin >> w;
        if (w) {
            f2 = false;
        }
        g[a].emplace_back(b, w);
        allx ^= w;
    }
    int a, b;
    cin >> a >> b;
    --a, --b;
    if (f) {
        int x = 0;
        while (a != b) {
            x ^= g[0][a].ss;
            a = g[0][a].ff;
        }
        if (allx) {
            cout << -1;
        } else {
            cout << 0;
        }
        return;
    }
    vector <int> order;
    vector <bool> used(n);
    auto topsort = [&](auto& topsort, int cur) -> void {
        used[cur] = true;
        for (auto [to, w] : g[cur]) {
            if (!used[to]) {
                topsort(topsort, to);
            }
        }
        order.push_back(cur);
    };
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            topsort(topsort, i);
        }
    }
    vector <bool> calced(n);
    vector <int> res(n);
    for (auto i : order) {
        if (i == b) {
            calced[i] = true;
        }
        for (auto [to, w] : g[i]) {
            if (calced[to]) {
                calced[i] = true;
                res[i] ^= (w ^ res[to]);
            }
        }
    }
    if (!calced[a]) {
        cout << -1;
    } else {
        cout << res[a];
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t --> 0) {
        solve();
        cout << "\n";
    }
}
