#include "bits/stdc++.h"
using namespace std;

// cd /mnt/commons/
// g++ -DHOME -Wall -Wextra -DGLIBCXX_DEBUG 1.cpp && ./a.out 

#define int long long
#define ll long long


#define all(a) a.begin(), a.end()
#define vc vector
#define ld long double
#define forn(i , n) for(int i = 0; i < (int)n; i++)
#define fri(st , en , step) for(int i = st; i < (int)en ; i+=step)
#define frj(st , en , step) for(int j = st; j < (int)en ; j+=step)
#define sz(a) ((int)a.size())
#define pb push_back
#define mp make_pair


template<typename T>
ostream& operator<<(ostream& a, vc<T> b){
	forn(i , sz(b) - 1) a << b[i] << " ";
	if(sz(b)) a << b.back(); 
	return a;
}






#ifdef HOME
	#define o(a) << "[" << #a << ": " << a << "] "
#else
	#define o(a) ;
#endif



class debug{
public:
	debug(){}
	~debug(){
		#ifdef HOME
			cerr << endl;
		#endif
	}
	template<typename T>
	debug& operator<<(T a){
		#ifdef HOME
			cerr << a;
		#endif
		return *this;
	}
};

mt19937 rnd(1211);

template<typename T>
inline bool cmin(T &a, T b){
	if(a > b){
		a = b;
		return 1;
	}
	return 0;
}

template<typename T>
inline bool cmax(T &a, T b){
	if(a < b){
		a = b;
		return 1;
	}
	return 0;
}

const int MOD = 1e9 + 7;
const ld e = 1e-9;
const int inf = 1e18;
const int maxn = 2e5 + 10;



void dfs(int a , vc<int> &vis , vc<int> &el , vc<vc<pair<int ,int>>> &g){
	if(vis[a]) return;
	vis[a] = 1;
	for(auto x : g[a]) dfs(x.first, vis , el , g);
	el.pb(a);
}

void cdfs(int a , vc<int> &color , vc<int> &vis , vc<vc<pair<int ,int>>> &g , int c){
	if(vis[a]) return;
	vis[a] = 1;
	color[a] = c;
	for(auto x : g[a]) cdfs(x.first, color , vis , g , c);
}
void vdfs(int a , vc<int> &vis , vc<vc<pair<int ,int>>> &g){
	if(vis[a]) return;
	vis[a] = 1;
	for(auto x : g[a]) vdfs(x.first , vis , g);
}

bool edfs(int a , int p , vc<int> &vis , vc<vc<pair<int , int>>> &g , vc<int> &d){
	if(p != d[a] && vis[a]) {
		debug() o(a);
		return 1;
	}
	if(vis[a]) return 0;
	d[a] = p;
	vis[a] = 1;
	for(auto x : g[a]) {
		if(edfs(x.first , p ^ x.second ,vis , g , d)) return 1;
		
	}
	return 0;
}

inline void run(){
	int n , m;
	cin >> n >> m;
	vc<vc<pair<int , int>>> g(n) , gob(n);
	
	vc<array<int , 3>> G(m);
	forn(i , m){
		int a , b , w;
		cin >> a >> b >> w;
		a--;
		b--;
		G[i] = {a , b , w};
		g[a].pb({b, w});
		gob[b].pb({a, w});	
	
	}
	int a , b;
	cin >> a >> b;
	a--;
	b--;
	vc<int> vis(n) , el , color(n);
	dfs(a , vis , el , g);
	reverse(all(el));
	int bank = 0;
	vis = vc<int>(n);
	forn( i , sz(el)){
		if(vis[el[i]] == 0) {
			cdfs(el[i] , color , vis , gob , bank++);
		}
	}

	vc<int> tA(n) , tB(n);
	vdfs(a , tA , g);
	vdfs(b , tB , gob);

	if(tA[b] == 0){
		cout << "0\n";
		return;
	}

	vc<int> use(n);
	forn(i , n) use[i] = (tA[i] & tB[i]);
	
	vc<int> C(bank);
	vc<vc<pair<int , int>>> gg(n) , g1(bank) , g2(bank);

	for(auto x : G){
		if(use[x[0]] == 0 || use[x[1]] == 0) continue;
		if(color[x[0]] == color[x[1]]) {
			C[color[x[0]]]++;
			gg[x[0]].pb({x[1] , x[2]});
		}
		else{
			g1[color[x[0]]].pb({color[x[1]] , x[2]});
			g2[color[x[1]]].pb({color[x[0]] , x[2]});
		}
	}


	
	
	vc<int> mem(n);
	vis = vc<int>(n);

	forn(i , n){
		if(use[i] && vis[i] == 0){
			if(edfs(i , 0 , vis , gg , mem)){
				cout << "-1\n";
				return;
			}
		}
	}

	el = {};
	vis = vc<int>(bank);
	dfs(color[a] , vis , el , g1);
	reverse(all(el));


	vc<int> X1(bank , -2) , X2(bank , -2);
	X1[color[a]] = 0;
	forn(i , sz(el)){
		for(auto x : g1[el[i]]){
			if(X1[el[i]] == -1) X1[x.first] = -1;
			else{
				if(X1[x.first] == -2) X1[x.first] = (X1[el[i]] ^ x.second);
				else {
					if(X1[x.first] != (X1[el[i]] ^ x.second)) X1[x.first] = -1;
				} 
			}
		}
	}
	el = {};
	vis = vc<int>(bank);
	dfs(color[b] , vis , el , g2);
	reverse(all(el));

	X2[color[b]] = 0;
	forn(i , sz(el)){
		for(auto x : g2[el[i]]){
			if(X2[el[i]] == -1) X2[x.first] = -1;
			else{
				if(X2[x.first] == -2) X2[x.first] = (X2[el[i]] ^ x.second);
				else {
					if(X2[x.first] != (X2[el[i]] ^ x.second)) X2[x.first] = -1;
				} 
			}
		}
	}

	forn(i , n){
		if(use[i] && C[color[i]]){
			// assert(0);
			int c = color[i];
			if(X2[c] == -1 || X1[c] == -1 || X2[c] != X1[c]){
				cout << "-1\n";
				return;
			} 
		}
	}
	el = {};
	vis = vc<int>(n);

	dfs(a, vis , el , g);
	reverse(all(el));
	vc<int> ans(n) , d(n);
	d[a] = 1;

	forn(i , sz(el)){
		for(auto x : g[el[i]]) {
			ans[x.first] ^= ans[el[i]];
			if(d[el[i]] % 2) ans[x.first] ^= x.second;
			d[x.first] += d[el[i]];
			
		}
	}
	cout << ans[b] << "\n";


}


signed main(){
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int tt = 1;
	cin >> tt;
	while(tt--){
		run();
	}
	return 0;
}