#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
vector<vector<pair<int,int>  > > a, reva;
vector<int> col;
vector<vector<int> > bycol;
vector<int> ord;
vector<int> vis;
vector<int> roots;
void dfs(int v) {
	vis[v] = true;
	for (auto h : a[v]) {
		if (!vis[h.first])
			dfs(h.first);
	}
	ord.push_back(v);
}
void dfs1(int v,int cl) {
	vis[v] = true;
	bycol[cl].push_back(v);
	col[v] = cl;
	for (auto h : reva[v]) {
		if (!vis[h.first]) {
			dfs1(h.first,cl);
		}
	}
}

vector<int> inval;
vector<int> corr;
bool dfs2(int v,int oreg) {
	vis[v] = 1;
	inval[v] = oreg;
	for (auto h : a[v]) {
		if (col[h.first] == col[v]) {
			if (!vis[h.first]) {
				if (!dfs2(h.first, oreg ^ h.second)) {
					return false;
				}
			}
			else {
				if ((oreg ^ h.second) != inval[h.first]) {
					return false;
				}
			}
		}
	}
	return true;
}




vector < vector<pair<int, int>  > > revb,b;
vector<vector<int>  > onlyp1,onlyp2;


vector<pair<int,int> > ans;
vector<int> cantoa;
int s, t;
void dfs3(int v) {
	vis[v] = 1;
	if (v == col[s]) {
		cantoa[v] = 1;
		ans[v].first = 1;
	}
	for (auto h : revb[v]) {
		if (!vis[h.first]) {
			dfs3(h.first);
		}
		if (cantoa[h.first]) {
			cantoa[v] = 1;
		}
		if (ans[h.first] == pair<int,int>{-1, -1}) {
			ans[v] = { -1,-1 };
			return;
		}
		ans[v].first ^= ans[h.first].first;
		ans[v].second ^= ans[h.first].second;
		if (ans[h.first].first == 1) {
			ans[v].second ^= h.second;
		}
	}
	if (cantoa[v] && !corr[v]) {
		ans[v] = { -1,-1 };
	}
}

void dfs4(int v) {
	vis[v] = 1;
	if (v == col[s]) {
		onlyp1[v].push_back(0);
	}
	for (auto h : revb[v]) {
		if (!vis[h.first]) {
			dfs4(h.first);
		}

		for (auto hh : onlyp1[h.first]) {
			if (onlyp1[v].size() >= 2) {
				break;
			}

			if (onlyp1[v].size() == 0) {
				onlyp1[v].push_back(hh^h.second);
				
			}
			else if ((hh ^ h.second) != onlyp1[v][0]) {
				onlyp1[v].push_back(hh ^ h.second);
			}
		}
	}
}


void dfs5(int v) {
	vis[v] = 1;
	if (v == col[t]) {
		onlyp2[v].push_back(0);
	}
	for (auto h : b[v]) {
		if (!vis[h.first]) {
			dfs5(h.first);
		}

		for (auto hh : onlyp2[h.first]) {
			if (onlyp2[v].size() >= 2) {
				break;
			}

			if (onlyp2[v].size() == 0) {
				onlyp2[v].push_back(hh ^ h.second);

			}
			else if ((hh ^ h.second) != onlyp2[v][0]) {
				onlyp2[v].push_back(hh ^ h.second);
			}
		}

		
	}

	
}
vector<int> inself;


int main() {
	int tt;
	cin >> tt;
	for (int ttt = 0; ttt < tt; ttt++) {
		a.clear();
		reva.clear();
		b.clear();
		revb.clear();
		vis.clear();
		corr.clear();
		ans.clear();
		cantoa.clear();
		inval.clear(); roots.clear();
		col.clear();
		bycol.clear();
		ord.clear();
		onlyp1.clear();
		onlyp2.clear();
		inself.clear();
		int n, m;
		cin >> n >> m;
		inself.resize(n);
		a.resize(n);
		reva.resize(n);
		col.resize(n);
		vis.resize(n);


		a.resize(n);
		reva.resize(n);
		cantoa.resize(n);
		for (int i = 0; i < m; i++) {
			int t1, t2, w;
			cin >> t1 >> t2 >> w;
			t1--;
			t2--;
			if (t1 == t2) {
				inself[t1] = true;
			}
			reva[t2].push_back({ t1,w });
			a[t1].push_back({ t2,w });
		}
		for (int i = 0; i < n; i++) {
			if (!vis[i]) {
				dfs(i);
			}
		}
		reverse(ord.begin(), ord.end());
		int ctr = 0;
		vis.assign(n, 0);
		for (int i = 0; i < n; i++) {
			if (!vis[ord[i]]) {
				bycol.push_back({});
				dfs1(ord[i], ctr);
				ctr++;
			}
		}

		roots.resize(ctr);
		corr.resize(ctr);
		for (int i = 0; i < ctr; i++) {
			roots[i] = bycol[i][0];
		}
		vis.assign(n, 0);
		inval.resize(n);
		for (int i = 0; i < ctr; i++) {
			corr[i] = dfs2(roots[i], 0);
		}

		b.resize(ctr);
		revb.resize(ctr);

		for (int i = 0; i < n; i++) {
			for (auto h : a[i]) {
				if (col[i] != col[h.first]) {
					b[col[i]].push_back({ col[h.first],h.second ^ inval[i]^inval[h.first]});
				}
			}

			for (auto h : reva[i]) {
				if (col[i] != col[h.first]) {
					revb[col[i]].push_back({ col[h.first],h.second ^ inval[i]^inval[h.first]});
				}
			}
		}

		vis.assign(n, 0);

		cin >> s >> t;
		s--;
		t--;
		ans.resize(ctr);
		dfs3(col[t]);
		onlyp1.resize(n);
		onlyp2.resize(n);

		vis.assign(n, 0);
		dfs4(col[t]);
		vis.assign(n, 0);
		dfs5(col[s]);
		bool ok = true;

		if (ans[col[t]] == pair<int, int> {-1, -1}) {
			ok = false;
		}

		int addd = inval[s] ^ inval[t];
		for (int i = 0; i < ctr; i++) {
			if (bycol[i].size() != 1||inself[bycol[i][0]]) {
				if (onlyp1[i].size() >= 2)
					ok = false;
				if (onlyp1[i].size() >= 2)
					ok = false;
				
				if (onlyp1[i].size() == 1 && onlyp2[i].size() == 1) {
					int proc = addd ^ onlyp1[i][0] ^ onlyp2[i][0];
					if (proc != 0) {
						ok = false;
					}
				}
			}
		}

		if (!ok) {
			cout << "-1\n";
		}
		else {
			if (ans[col[t]].first == 1) {
				ans[col[t]].second ^= inval[t];
				ans[col[t]].second ^= inval[s];
			}
			cout << ans[col[t]].second << '\n';
		}
	}
}