#include <bits/stdc++.h>
///#include <ext/pb_ds/assoc_container.hpp>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define fi first
#define se second
#define all(v) (v).begin(), (v).end()

#define int long long

using namespace std;
///using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair <int, int>;

int const N = 1e5 + 4;

void dfsr(int v, vector <int>& used, vector < vector <pii> >& g, vector <bool>& isr, int f){
    used[v] = 1;
    if(v == f){
        isr[v] = 1;
    }
    for(auto [u, w] : g[v]){
        if(used[u] == 0){
            dfsr(u, used, g, isr, f);
        }
        //cout << v << ' ' << u << endl;
        if(isr[u]){ isr[v] = 1;}
    }
    used[v] = 2;
    return;
}

bool check_dfs(int v, vector <int>& used, vector < vector <pii> >& g, vector <bool>& isr, int xr = 0){
    used[v] = 1;
    //cout << v << endl;
    for(auto [u, w] : g[v]){
        if(used[u] == 2){ continue;}
        //cout << v + 1 << ' ' << u + 1 << ' ' << used[u] << ' ' << isr[u] << "  " << (xr ^ w) << endl;
        if(used[u] == 1 and isr[u] == 1 and (xr ^ w) != 0){
            return 1;
        }
        if(!used[u] and check_dfs(u, used, g, isr, xr ^ w)){
            return 1;
        }
    }
    used[v] = 2;
    return 0;
}

void dp_dfs(int v, vector <int>& used, vector < vector <pii> >& g, vector <bool>& isr, vector < vector <int> >& xrs){
    used[v] = 1;
    for(auto [u, w] : g[v]){
        if(!isr[u] or used[u]){ continue;}
        dp_dfs(u, used, g, isr, xrs);
    }
    for(auto [u, w] : g[v]){
        if(!isr[u]){ continue;}
        for(auto x : xrs[u]){
            xrs[v].push_back(x ^ w);
        }
    }
    used[v] = 2;
    return;
}

void solve(){
    int n, m, s, f;
    cin >> n >> m;
    vector < vector <pii> > g(n);
    for(int i = 0; i < m; ++i){
        int v, u, w;
        cin >> v >> u >> w;
        --v; --u;
        g[v].push_back({u, w});
    }
    cin >> s >> f;
    --s; --f;
    vector <int> used(n, 0);
    vector <bool> isr(n, 0);
    dfsr(s, used, g, isr, f);
    used.assign(n, 0);
    if(check_dfs(s, used, g, isr) or !isr[s]){
        cout << -1 << '\n';
        return;
    }

    used.assign(n, 0);
    vector < vector <int> > xrs(n);
    xrs[f].push_back(0);
    dp_dfs(s, used, g, isr, xrs);
    int ans = 0;
    for(auto w : xrs[s]){
        ans ^= w;
    }
    cout << ans << '\n';
}

signed main(){
    ibase;
    int t;
    cin >> t;
    while(t --> 0){
        solve();
    }
}
