#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n), _g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].emplace_back(v, w);
        _g[v].emplace_back(u, w);
    }
    int a, b;
    cin >> a >> b;
    a--, b--;
    vector<int> used1(n), used2(n);
    queue<int> q;
    used1[a] = 1;
    q.push(a);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            if (!used1[u]) {
                used1[u] = 1;
                q.push(u);
            }
        }
    }
    used2[b] = 1;
    q.push(b);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : _g[v]) {
            if (!used2[u]) {
                used2[u] = 1;
                q.push(u);
            }
        }
    }
    vector<int> dp1(n), dp2(n);
    vector<int> sz(n);
    for (int i = a; i < n; ++i) {
        if (used1[i]) {
            for (auto [j, w] : g[i]) {
                sz[j]++;
            }
        }
    }
    dp1[a] = 1;
    q.push(a);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            sz[u]--;
            dp1[u] ^= dp1[v];
            if (!sz[u]) {
                q.push(u);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        sz[i] = 0;
    }
    for (int i = b; i >= 0; --i) {
        if (used2[i]) {
            for (auto [j, w] : _g[i]) {
                sz[j]++;
            }
        }
    }
    dp2[b] = 1;
    q.push(b);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : _g[v]) {
            sz[u]--;
            dp2[u] ^= dp2[v];
            if (!sz[u]) {
                q.push(u);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (auto [j, w] : g[i]) {
            if (dp1[i] && dp2[j]) {
                ans ^= w;
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
