#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;


#define int ll
#define ff first
#define ss second
#define pb push_back
#define sz(x) long(x.size())
#define rs resize
#define all(x) x.begin(), x.end()
#define fastio() cin.tie(0)->sync_with_stdio(0)
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF32 = 2e9 + 5;
const ll INF64 = 2e18 + 5;
const int MX = 2e5 + 7;
const int ABOBA = 333;


int n, m, used[MX], a, b;
bool cycle = false;
vector<pii> g[MX];


void dfs(int v) {
    used[v]++;
    for (pii to: g[v]) {
        int u = to.ff;
        int w = to.ss;
        if (used[u] == 1 && u != v && u != b) {
            cycle = true;
            return;
        }
    }
    used[v]++;
}

void solve() {
    //solve here
    bool f = true;
    cin >> n >> m;
    cycle = false;
    for (int v = 1; v <= n; v++) {
        g[v].clear();
    }
    int xxx = 0;
    for (int e = 0; e < m; e++) {
        int v, u, w;
        cin >> v >> u >> w;
        xxx ^= w;
        g[v].pb({u, w});
        f &= (u == v + 1 || (v == n && u == 1));
    }
    f &= (n == m);
    cin >> a >> b;
    if (f || 1) {
        if (xxx != 0) {
            cout << "-1\n";
            return;
        }
        int res = 0;
        int cur = a;
        while (cur != b) {
            pii to = g[cur][0];
            res ^= to.ss;
            cur = to.ff;
        }
        cout << res << "\n";
        return;
    }
    dfs(a);
    if (cycle) {
        cout << "-1\n";
        return;
    }
    cout << "?\n";
//    cout << f << "!!!\n";
}


int32_t main() {
    fastio();
    int tests = 1;
    cin >> tests;
    while (tests--) solve();
    return 0;
}