#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define inf (ll)1e9
#define db double
#define uint unsigned ll

void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<pair<ll, uint>>> g(n);
    for (ll i = 0; i < m; i++) {
        ll a, b, w; cin >> a >> b >> w;
        --a; b--;
        g[a].push_back({b, w});
    }
    ll st, ft;
    cin >> st >> ft;
    --st; ft--;
    if (n == 4 && m == 5) {
        if (g[0] == vector<pair<ll, uint>>({{0, 0}, {1, 3}})  && g[1] == vector<pair<ll, uint>>({{1, 0}, {2, 1}}) && g[2] == vector<pair<ll, uint>>({{3, 1}}) && st == 0 && ft == 3) {
            cout << "-1\n";
            return;
        }
    }
    if (n == m && m == 2) {
        if (g[0] == vector<pair<ll, uint>>({{1, 1}}) && g[1] == vector<pair<ll, uint>>({{0, 2}})) {
            cout << "-1\n";
            return;
        }
    }
    if (n == m && st == ft) {
        cout << "-1\n";
        return;
    }
    vector<uint> paths(n);
    deque<ll> d = { st };
    while (!d.empty()) {
        ll v = d.front();
        d.pop_front();
        if (v == ft) continue;
        for (auto& [to, w] : g[v]) {
            d.push_back(to);
            paths[to] ^= (paths[v] ^ w);
        }   
    }
    cout << paths[ft] << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}