#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define debug(x) cerr << "[" << #x << "]: " << x << endl
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

vector<vector<pll>> gr, gr1;
vector<bool> used;
vector<ll> d;
map<pii, int> cnt;

ll res = 0;

void dfs(int v){
    used[v] = true;
    if (d[v] == 1) return;
    for (auto i : gr1[v]){
        if (!used[i.ff]) dfs(i.ff);
        (d[v] += d[i.ff]) %= 2;
        if (d[i.ff]) res ^= i.ss;
    }
}

void dfs1(int v){
    used[v] = true;
    if (d[v] == 1) return;
    for (auto i : gr[v]){
        if (!used[i.ff]) dfs1(i.ff);
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    map<pii, ll> edg;
    cnt.clear();
    gr.assign(n, vector<pll>());
    gr1.assign(n, vector<pll>());
    for (int i = 0; i < m; i++){
        int u, v; ll x;
        cin >> u >> v >> x; u--, v--;
        edg[{u, v}] ^= x;
        gr[u].pb({v, x});
        cnt[{u, v}]++;
    }
    used.assign(n, false);
    d.assign(n, 0);
    res = 0;
    //for (auto i : edg) gr[i.ff.ff].pb({i.ff.ss, i.ss});
    int a, b; cin >> a >> b;
    a--, b--;
    d[b] = 1;
    dfs1(a);

    for (int i = 0; i < n; i++){
        for (auto j : gr[i]){
            if (used[i] && used[j.ff]) gr1[j.ff].pb({i, j.ss});
        }
    }
    d.assign(n, 0);
    used.assign(n, false);
    d[a] = 1;
    dfs(b);
    cout << res << endl;

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    cin >> n;
    while(n--) solve();
}
