#pragma GCC target("avx2")
#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) x.begin(), x.end()
vector<int> order;
vector<bool> used;
void dfs(int cur, vector<vector<pair<int, int>>>& gr) {
    used[cur] = true;
    for (auto i : gr[cur]) {
        if (used[i.first]) continue;
        dfs(i.first, gr);
    }
    order.push_back(cur);
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int,int>>> gr(n);
    for (int i = 0; i < m; i++) {
        int u, v, t;
        cin >> u >> v >> t;
        u--;
        v--;
        gr[u].push_back({v, t});
    }
    used.assign(n, false);
    order.clear();
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfs(i, gr);
    }
    vector<vector<int>> dp(n, vector<int> (31));
    vector<int> amo(n);
    reverse(all(order));
    int x, y;
    cin >> x >> y;
    if (x > y) {
        cout << -1 << '\n';
        return;
    }
    x--;
    y--;
    amo[y] = 1;
    for (int i = n - 1; i >= 0; i--) {
        for (auto j : gr[order[i]]) {
            if (amo[j.first] != 0) {
                for (int k = 0; k < 31; k++) {
                    dp[order[i]][k] += dp[j.first][k] + (((j.second) & (1ll << k)) > 0) * amo[j.first]; 
                    amo[order[i]] += amo[j.first];
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < 31; i++) {
        if (dp[x][i] % 2) {
            ans |= (1ll << i);
        }
    }
    cout << ans << '\n';
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
} 
 