#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <algorithm>
#include <numeric>

using namespace std;


#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' '
#define debnl(x) cout << #x << '=' << x << endl
#define name(x) cout << #x << endl;
#define print(a) { for (auto x: a) cout << x << ' '; cout << endl; }
#define print2d(a) { for (auto x: a) {for (auto y: x) cout << y << ' '; cout << endl;} cout << endl; }
#define printpair(a) { for (auto x: a) cout << '(' << x.first << ' ' << x.second << ") "; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define name(x)
#define print(a)
#define print2d(a)
#define printpair(a)

#endif

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;

mt19937_64 rnd;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

void solve();

signed main() {
	int T = 1;
	cin >> T;
	while (T--) {
		solve();
	}
}

vvii gr;

void solve() {
    int n, m;
    cin >> n >> m;
    gr = vvii(n);
    int gen_x = 0;
    for (int i = 0; i < m; i++){
        int u, v, w;
        cin >> u >> v >> w, u--, v--;
        gen_x ^= w;
        gr[u].push_back({v, w});
    }
    if (gen_x > 0) {
        cout << -1 << nl;
        return;
    }
    int s, t;
    cin >> s >> t, s--, t--;
    int u = s;
    int ans = 0;
    while (u != t){
        ans ^= gr[u][0].second;
        u = gr[u][0].first;
    }
    cout << ans << nl;
}
















