
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cmath>
#include <random>
#include <deque>

#define pll pair<long long, long long>
#define ll long long
#define ft first
#define sd second
#define sll set<long long>
#define msll multiset<long long> 
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define vll vector<ll>
#define ve vector
#define dll deque<ll>

using namespace std;

void bfs(int v, ve<ve<pll>> g, vll& cnt) {
	dll q = { v };
	while (!q.empty()) {
		ll u = q.back();
		//cout << u << "\n";
		q.pop_back();
		cnt[u] = 2;
		for (auto& i : g[u]) {
			if (cnt[i.ft] != 2) {
				q.push_front(i.ft);
			}
		}
	}
}

bool dfs_find_good_v(int v, ve<ve<pll>>& g, vll &cnt, vll &ts, ve<bool> &good,vll &col, ll nd) {	
	bool ret = 0;

	//cout << v << "\n";
	
	if (v == nd) {
		ret = 1;
	}
	
	cnt[v] = max(cnt[v], 1LL);
	col[v] = 1;
	for (auto& i : g[v]) {
		if (col[i.ft] == 1) {
			bfs(i.ft, g, cnt);
			//break;
		}
		if (col[i.ft] == 0) {
			ret |= dfs_find_good_v(i.ft, g, cnt, ts, good, col, nd);
		}
		if (ret) {
			break;
		}
	}

	col[v] = 2;

	if (ret) {
		ts.push_back(v);
		good[v] = 1;
	}

	return ret;
}

void solve() {
	ll n, m, a, b;
	cin >> n >> m;
	ve<ve<pll>> g(n);

	for (int i = 0; i < m; i++) {
		ll u, v, w;
		cin >> u >> v >> w;
		u--; v--;
		//g[v].push_back({u, w});
		g[u].push_back({v, w});
	}

	vll cnt(n, 0);
	vll ts;
	vll ans(n);
	ve<bool> good(n);
	vll col(n);

	cin >> a >> b;
	a--; b--;

	//return;

	cnt[a] = 1;
	dfs_find_good_v(a, g, cnt, ts, good,col, b);
	

	//return;

	reverse(all(ts));
	for (auto& i : ts) {
		for (auto& j : g[i]) {
			if (good[j.ft]) {
				ans[j.ft] ^= j.sd;
			}
		}
	}
	//cout << "AHAHAH\n";
	if (cnt[b] == 1 && good[a]) {
		cout << ans[b] << "\n";
	}
	else {
		if (ans[b] == 0)
			cout << 0 << '\n';
		else 
			cout << -1 << "\n";
	}

	/*for (auto& i : ts) {
		cout << i << " ";
	}

	cout << "\n";

	for (auto& i : cnt) {
		cout << i << " ";
	}
	cout << "\n";*/
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 

	ll t;
	cin >> t;

	while (t--) {

		solve();

	}

	return 0;
}
