#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t;
    cin >> t;
    while (t--) solve();
}

#define int ll


void solve() {
    int n, m;
    cin >> n >> m;
    vector<set<int>> g(n), gr(n);
    map<pair<int, int>, set<int>> st;
    map<pair<int, int>, vector<int>> vec;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        st[{u, v}].insert(w);
        vec[{u, v}].push_back(w);
        g[u].insert(v);
    }
    int a, b;
    cin >> a >> b;
    --a, --b;
    vector<int> top;
    vector<int> used(n);
    auto dfs = [&](auto dfs, int u) -> void {
        used[u] = 1;
        for (auto to : g[u]) {
            if (!used[to]) dfs(dfs, to);
        }
        top.push_back(u);
    };
    dfs(dfs, a);
    reverse(all(top));
    used.assign(n, 0);
    vector<int> dp(n), cnt(n), kk(n), pt(n, -1);
    cnt[a] = 1;
    kk[a] = 1;
    pt[a] = 0;
    for (auto u : top) {
        used[u] = 1;
        for (auto to : g[u]) {
            if (!used[to] || u == to) {
                if (u == to) {
                    if (kk[to] == 1 && pt[to] == 0 && st[{u, to}].size() == 1 && kk[u] == 1 && (pt[u] ^ *st[{u, to}].begin()) == 0){}
                    else {
                        assert(*max_element(all(kk)) == 1);
                        cout << "-1\n";
                        return;
                    }
                }
                pt[to] = pt[u] ^ *st[{u, to}].begin();
                if (st[{u, to}].size() > 1) {
                    kk[to] = 2;
                }
                if (kk[u] == 1 && (pt[u] ^ *st[{u, to}].begin()) == pt[to]) {}
                else {
                    kk[to] += kk[u];
                    kk[to] = min(kk[to], 2ll);
                }
                for (auto w : vec[{u, to}]) {
                    dp[to] ^= dp[u] ^ (cnt[u] * w);
                    cnt[to] ^= cnt[u];
                }
            } else {
                if (kk[to] == 1 && pt[to] == 0 && st[{u, to}].size() == 1 && kk[u] == 1 && (pt[u] ^ *st[{u, to}].begin()) == 0){}
                else {
                    assert(*max_element(all(kk)) == 1);
                    cout << "-1\n";
                    return;
                }
            }
        }
    }
    assert(*max_element(all(kk)) == 1);
    cout << dp[b] << '\n';
}