#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;

vector<int> tin, tout;
int curt = 0;
vector<int> par;
vector<vector<pair<int, ll>>> g;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        g.clear();
        curt = 0;
        int n, m;
        cin >> n >> m;
        g.resize(n);
        for (int _ = 0; _ < m; ++_) {
            int u, v; ll w;
            cin >> u >> v >> w;
            u--; v--;
            g[u].push_back({ v, w });
        }
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        vector<map<ll, ll>> cnt(n);
        cnt[b][0] = 1;
        for (int i = b - 1; i >= a; --i) {
            for (auto el : g[i]) {
                int v = el.first; ll w = el.second;
                for (auto el2 : cnt[v]) {
                    ll w2 = el2.first; ll c = el2.second;
                    cnt[i][w2 ^ w] += c;
                }
            }
        }
        ll ans = 0;
        for (auto el2 : cnt[a]) {
            ll w2 = el2.first; int c = el2.second;
            if (c % 2 == 1)
                ans ^= w2;
        }
        cout << ans << "\n";

    }

    return 0;
}
