#include <bits/stdc++.h>
using namespace std;

typedef long double ld;

#define fout cerr
#define ll long long
#define ull unsigned long long
#define vi vector<int>
#define vl vector<ll>
#define vii vector<vi>
#define vll vector<vl>
#define all(arr) arr.begin(), arr.end()
#define rev(arr) arr.rbegin(), arr.rend()
#define lb(arr, val) int(lower_bound(all(arr), val) - arr.begin())
#define ub(arr, val) int(upper_bound(all(arr), val) - arr.begin())
#define _unique(arr) arr.erase(unique(all(arr)), arr.end())
#define pii pair<int, int>
#define pll pair<ll, ll>
#define vpi vector<pii>
#define vpl vector<pll>
#define size(arr) int(arr.size())

ostream &operator<<(ostream& out, vi a) {
    for (auto u : a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream& in, vi& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

ostream &operator<<(ostream& out, vl a) {
    for (auto u : a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream& in, vl& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}
istream &operator>>(istream& in, pii& a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream& out, pii a) {
    out << a.first << " " << a.second;
    return out;
}

istream &operator>>(istream& in, pll& a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream& out, pll a) {
    out << a.first << " " << a.second;
    return out;
}

const int MAX_N = 2e5 + 5;
const int LOG_N = 25;

ll mod = 1e9 + 7;


int n;
void cycle_solve(vi a, int s, int f) {
    int x = 0, y = 0, z = 0;
    for (int i = s; i < f; ++i) {
        i %= n;
        x ^= a[i];
    }
    for (int i = f; i < s; ++i) {
        i %= n;
        y ^= a[i];
    }
    for (int i = 0; i < n; ++i) {
        z ^= a[i];
    }
//    cout << x << " " << y << " " << z << "\n";
    if ((x ^ z) != 0 || (y ^ z) != 0) {
        cout << -1;
    } else {
        cout << (x ^ y);
    }
}
const int INF = 1e6;


int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#else
    #define fout if (0) cout
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
#endif
    cout << setprecision(13) << fixed;

    int T;
    cin >> T;
    while (T--) {
        cin >> n;
        int m;
        cin >> m;
        vi a(m);
        vpi g[n];
        vi rg[n];
        bool fl = true;
        for (int i =  0; i < m; ++i) {
            int u, v, x;
            cin >> u >> v >> x;
            u--;
            v--;
            g[u].push_back({v, x});
            rg[v].push_back(u);
            if (v != (u + 1) % n) fl = false;
            a[i] = x;
        }
        int s, f;
        cin >> s >> f;
        s--;
        f--;
        if (n == m && fl) {
            cycle_solve(a, s, f);
        } else {
            if (s > f) {
                cout << 0 << "\n";
                continue;
            }
            int ans = 0;
            vi d(n, 0);
            d[f] = 1;
            for (int i = f; i >= 0; --i) {
               for (auto u : rg[i]) {
                   d[u] += d[i];
               }
            }

            vi c(n, 0);
            c[s] = 1;
            for (int i = s; i < n; ++i) {
                for (auto [u, w] : g[i]) {
                    c[u] += c[i];
                }
            }
//            cout << c;

            for (int i = 0; i < n; ++i) {
                for (auto u : g[i]) {
                    ans += u.second * c[i] * d[u.first];
                }
            }
            cout << ans % 2;
        }


        cout << "\n";
    }

}