#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> a);
template<typename T>
ostream& operator << (ostream &out, set<T> a);
template<typename T>
ostream& operator << (ostream &out, vector<T> a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(21281337711);
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}
int divide(int a, int b) {
    return mul(a, binpow(b, mod - 2));
}


void solve_case() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    int all = 0;
    bool beb = (n == m);
    for (int i = 0; i < m; i++) {
        int a, b, x;
        cin >> a >> b >> x;
        a--, b--;
        all ^= x;
        if (beb) {
            if (i == n - 1) {
                beb &= a == n - 1;
                beb &= b == 0;
            } else {
                beb &= a == i;
                beb &= b == (i + 1);
            }
        }
        g[a].push_back({b, x});
        g[b].push_back({a, x});
    }
    int s, t;
    cin >> s >> t;
    s--, t--;
    if (beb) {
        if (all != 0) {
            cout << "-1\n";
            return;
        }
        int v = s;
        int ans = 0;
        while (v != t) {
            int u = (v + 1) % n;
            for (auto [z, w] : g[v]) {
                if (z == u) {
                    ans ^= w;
                }
            }
            v = (v + 1) % n;
        }
        if (ans != 0) {
            ans = -1;
        }
        cout << ans << "\n";
    } else {
        cout << "?\n";
    }
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    //freopen("inputik.txt", "r", stdin);
    int T = 1;
    cin >> T;
    while (T--) {
        solve_case();
    }
    return 0;
}
