#include<iostream>
#include<vector>
#include<algorithm>
#include<utility>
#include<cmath>


using namespace std;
typedef long long ll;


int count1(int v, int p, vector<vector<int>>& g, vector<int>& cnt1, int f, vector<bool>& color)
{
    int sm = 0;
    color[v] = true;
    cnt1[v] = 1;
    for (auto el: g[v])
    {
        if (el != p)
        {
            sm += count1(el, v, g, cnt1, f, color);
            sm %= 2;
        }
    }
    if (v == f)
    {
        return 1;
    }
    return sm;
}


void cntans(int v, int p, vector<vector<int>>& g, vector<vector<int>>& w, vector<bool>& color, int& ans, vector<int>& cnt1, vector<int>& cnt2)
{
    for (int i = 0; i < g[v].size(); i++)
    {
        if (g[v][i] != p && color[g[v][i]])
        {
            if (cnt1[v] * cnt2[g[v][i]] % 2 != 0)
            {
                ans ^= w[v][i];
            }
            cntans(g[v][i], v, g, w, color, ans, cnt1, cnt2);
        }
    }
    return;
}


int main()
{
    int T;
    cin >> T;
    for (int t = 0; t < T; t++)
    {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> g(n);
        vector<vector<int>> gr(n);
        vector<vector<int>> c(n);
        for (int i = 0; i < m; i++)
        {
            int u, v;
            cin >> u >> v;
            u--;
            v--;
            int w;
            cin >> w;
            g[u].push_back(v);
            gr[v].push_back(u);
            c[u].push_back(w);
        }
        vector<int> cnt1(n);
        vector<int> cnt2(n);
        vector<bool> clr(n);
        vector<bool> color(n);
        count1(0, 0, g, cnt1, n - 1, clr);
        count1(n - 1, n - 1, gr, cnt2, 0, color);
        int ans = 0;
        cntans(0, 0, g, c, color, ans, cnt1, cnt2);
        cout << ans << '\n';
   }
    return 0;
}
