#include <bits/stdc++.h>

using namespace std;

const int mod = 998244353;
//#define int long long
#define ld long double

vector<vector<array<int, 2>>> gr;
vector<vector<int>> rgr;
vector<int> vis;
vector<int> from_b;
vector<int> xrs;
vector<int> max_d;

int flag = 1;

void calc_max_d(int v, int d = 0) {
    vis[v] = 1;
    max_d[v] = d;
    for (auto p: gr[v]) {
        if (!vis[p[0]]) {
            calc_max_d(p[0], d + 1);
        } else {
            max_d[p[0]] = max(max_d[p[0]], d + 1);
        }
    }
    vis[v] = 2;
}

void can(int v, int b, int xr = 0, int fl = 0) {
    if (v == b && fl && xr != 0) {
        flag = 0;
    }
    vis[v] += 1;
    for (auto p: gr[v]) {
        if (vis[p[0]] == 0) {
            can(p[0], b, xr ^ p[1], fl);
        } else if (vis[p[0]] == 1) {
            can(p[0], b, xr ^ p[1], 1);
        }
    }
    vis[v] -= 1;
}


void fb(int v) {
    from_b[v] = 1;
    for (int i: rgr[v]) {
        if (!from_b[i]) {
            fb(i);
        }
    }
}


int count(int a, int b, int n) {
    deque<int> q;
    q.push_back(a);
    vector<int> cnt(n);
    vector<int> xx(n);
    vector<int> added(n);
    cnt[a] = 1;
    xx[a] = 0;
    added[a] = 1;
    while (!q.empty()) {
        int y = q.front();
        q.pop_front();
        for (auto p: gr[y]) {
            if (max_d[p[0]] - 1 == max_d[y]) {
                cnt[p[0]] += cnt[y];
                if (!added[p[0]]) {
                    added[p[0]] = 1;
                    q.push_back(p[0]);
                }
                if (cnt[y] % 2) {
                    xx[p[0]] ^= xx[y] ^ p[1];
                }
            }
        }
    }
    return xx[b];
}


void solve() {
    int n, m;
    cin >> n >> m;
    gr.assign(n, {});
    rgr.assign(n, {});
    from_b.assign(n, {});
    vis.assign(n, 0);
    xrs.assign(n, 0);
    max_d.assign(n, 0);
    flag = 1;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u;
        --v;
        gr[u].push_back({v, w});
        rgr[v].push_back(u);
    }
    int a, b;
    cin >> a >> b;
    --a;
    --b;
    fb(b);
//    cout << 1 << endl;
    can(a, b);
    vis.assign(n, 0);
//    cout << 1 << endl;
    if (!flag) {
        cout << -1 << '\n';
        return;
    }
    calc_max_d(a);
    cout << count(a, b, n) << '\n';
}


signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}