#ifdef WIN64
#define _GLIBCXX_DEBUG
#endif // WIN64
#include "bits/stdc++.h"

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple
#define isz(x) (int) x.size()
#define xx first
#define yy second

#ifdef WIN64
#define check(x) cerr << (#x) << " = " << x << "\n"
template<class T> void print(T* ar, int sz) {
    for (int i = 0; i < sz; ++i) cerr << ar[i] << " ";
    cerr << "\n";
}
#else
#define check(x) 17
    template<class T> void print(T* ar, int sz) {}
#endif // WIN64

const int N = (int) 2e5 + 1;
const int INF = (int) 1e9 + 117;
const int MOD = (int) 1e9 + 7;
const long long INFll = (long long) 2e18 + 117;
const double EPS = 1e-8;

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

#define int long long

using Pt = pair<int, int>;
using ll = long long;

int a[N], s, f, n, m;

int solve1() {
    int x = 0, y = 0;
    for (int i = 0; i < n; ++i) y ^= a[i];

    if (s > f) swap(s, f);
    for (int i = s; i < f; ++i) x ^= a[i];

    if (!x && !y) cout << 0 << "\n";
    else cout << -1 << "\n";
    return 0;
}

vector<int> dp, cnt;
vector<pair<int, int>> g[N];

int solve() {
    dp.assign(n, 0);
    cnt.assign(n, 0);
    cnt[s] = 1;
    for (int v = s; v <= f; ++v) {
        for (auto& [u, w] : g[v]) {
            if (u >= s) {
                cnt[v] += cnt[u];
                dp[v] ^= dp[u];
                if (cnt[u] & 1) {
                    dp[v] ^= w;
                }
            }
        }
    }
    cout << dp[f] << "\n";
    return 0;
}

signed main() {
#ifdef WIN64
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // WIN64
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        bool ok = 1;
        assert(cin >> n >> m);
        for (int i = 0; i < n; ++i) g[i].clear();
        for (int i = 0; i < m; ++i) {
            int x, y, val;
            assert(cin >> x >> y >> val);
            --x, --y;
            if (x > y) ok = 0;
            g[y].push_back(mkp(x, val));
            a[i] = val;
        }
        assert(cin >> s >> f);
        --s, --f;

        check(n);
        check(m);


        if (ok) solve();
        else solve1();
    }
    return 0;
}
