#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef std::pair<int, int> pii;

#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define time_now chrono::high_resolution_clock::now()
#define time_res(s, f) chrono::duration_cast<chrono::milliseconds>(f - s).count()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define pb push_back
#define ff first
#define sc second
#define str string
#define file_in freopen("input.txt", "r", stdin);
#define file_out freopen("output.txt", "w", stdout);
#define all(a) a.begin(), a.end()
#define sz(a) (int)a.size()

using namespace std;
using namespace __gnu_pbds;

template<typename T, typename T1> istream& operator>>(istream& in, pair<T, T1> &a) { in >> a.ff >> a.sc; return in; }
template<typename T, typename T1> ostream& operator<<(ostream& out, pair<T, T1> a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream& in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream& out, vector<T> a) { for (auto el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937 gen(mt_seed); int randint(int l, int r) { uniform_int_distribution<> random(l, r); return random(gen); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const {return x ^ RANDOM; }};

vector<vector<pii>> g, gr;

void banan() {
    int n, m;
    cin >> n >> m;
    bool check = (n == m);
    g.assign(n, {});
    gr.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        g[v - 1].pb({u - 1, w});
        gr[u - 1].pb({v - 1, w});
        if (v != n && u != v + 1) check = 0;
        if (v == n && u != 1) check = 0;
    }
    int a, b;
    cin >> a >> b;
    --a; --b;
    if (check) {
        int x = 0;
        vector<int> d(n);
        for (int i = a; i < n; ++i) {
            d[i] = x;
            x ^= g[i][0].sc;
        }
        if (d[b] != 0) { cout << -1 << '\n'; return; }
        for (int i = 0; i < n; ++i) {
            d[i] = x;
            x ^= g[i][0].sc;
        }
        if (d[b] != 0) { cout << -1 << '\n'; return; }
        for (int i = 0; i < n; ++i) {
            d[i] = x;
            x ^= g[i][0].sc;
        }
        if (d[b] != 0) { cout << -1 << '\n'; return; }
        cout << 0 << '\n';
    } else {
        vector<int> d(n);
        if (a >= b) { cout << -1 << '\n'; return; }
        for (int i = a + 1; i <= b; ++i)
            for (auto [to, w] : gr[i])
                d[i] ^= d[to] ^ w;
        cout << d[b] << '\n';
    }
}

int main() {
    fast
//    file_in

    int t;
    cin >> t;
    while (t--) {
        banan();
    }
    return 0;
}
