#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<vector>
#include<string>
#include<math.h>
#include<bitset>
#include<random>

using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'
using ll = long long;
using ld = long double;

const int N = 1e6 + 9, X = 1 << 20;
const long long INF = 1e18 + 9;

vector<pair<int, int>> g[N];
vector<pair<int, int>> in[N];
vector<int> ts;
int useda[N], usedb[N];
void dfs(int v, int* used) {
	used[v] = 1;
	for (auto e : g[v]) {
		if (!used[e.first])
			dfs(e.first, used);
	}
	ts.push_back(v);
}

int pos[N];
int ans[N];
int nxt[N];
int cnt[N];

void solve() {
	int n, m;
	ts.clear();
	cin >> n >> m;
	
	for (int i = 0; i <= n; i++) {
		useda[i] = 0;
		usedb[i] = 0;
		cnt[i] = 0;
		ans[i] = 0;
		g[i].clear();
		in[i].clear();
	}
	int all = 0;
	int f = n == m;
	for (int i = 0; i < m; i++) {
		int v, u, w;
		cin >> v >> u >> w;
		if (u != v % n + 1)
			f = 0;
		g[v].push_back({ u, w });
		in[u].push_back({ v, w });
		all ^= w;
	
	}
	int a, b;
	cin >> a >> b;

	if (f) {
		if (all)
			cout << "-1\n";
		else {	
			int ans = 0;
			while (a != b) {
				ans ^= g[a][0].second;
				a = g[a][0].first;
			}
			cout << ans << endl;
		}
		return;
	}
	dfs(a, useda);
	reverse(all(ts));
	if (!useda[b]) {
		cout << "0\n";
		return;
	}
	//for (auto v : ts)
	//	cout << v << " ";

	cnt[a] = 1;
	for (auto v : ts) {
		for (auto e : in[v]) {
			int u = e.first;
			if (cnt[u] % 2)
				ans[v] ^= ans[u] ^ e.second;
			else
				ans[v] ^= ans[u];
			cnt[v] = (cnt[v] + cnt[u]) % 2;

		}
	}
	cout << ans[b] << endl;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif


	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}