//#pragma GCC optimize("03,unroll-loops")
//#pragma GCC target("avx2,bmi2")
#include <bits/stdc++.h>
using namespace std;
#define pb push_back
vector<vector<pair<int, int>>> g;
vector<bool> used;
vector<int> cringe;
int start, ans;
void dfs(int u) {
    for (auto [v, w]: g[u]) {
        if (v == start) {
            if ((cringe[u] ^ w) != 0) {
                ans = -1;
                return;
            }
        } else {
            cringe[v] = cringe[u] ^ w;
            dfs(v);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n + 1, {});
    used.assign(n + 1, 0);
    cringe.assign(n + 1, 0);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
    }
    int a, b;
    cin >> a >> b;
    start = a;
    dfs(a);
    if (ans == -1) cout << ans << '\n';
    else cout << cringe[b] << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}