//#pragma GCC optimize("03,unroll-loops")
//#pragma GCC target("avx2,bmi2")
#include <bits/stdc++.h>
using namespace std;
#define pb push_back
vector<vector<pair<int, int>>> g;
vector<int> ans, cringe, used;
int endd, start;
int dfs(int u) {
    if (u == endd) {
        return 0;
    }
    for (auto [v, w]: g[u]) {
        if (ans[v] != 0) {
            ans[u] ^= (ans[v] ^ w);
        } else {
            ans[u] = (ans[u] ^ dfs(v) ^ w);
        }
    }
    return ans[u];
}

void dfs1(int u) {
    for (auto [v, w]: g[u]) {
        if (v == start) {
            cringe[v] = cringe[u] ^ w;
        } else {
            cringe[v] = cringe[u] ^ w;
            dfs(v);
        }
    }
}


void solve() {
    int n, m;
    cin >> n >> m;
    if (n == m) {
        g.assign(n + 1, {});
        used.assign(n + 1, 0);
        cringe.assign(n + 1, 0);
        for (int i = 0; i < m; ++i) {
            int u, v, w;
            cin >> u >> v >> w;
            g[u].pb({v, w});
        }
        int a, b;
        cin >> a >> b;
        start = a;
        dfs(a);
        if (cringe[a] == 0 && cringe[b] == 0) cout << cringe[b] << '\n';
        else cout << "-1\n" << '\n';
    }
    g.assign(n + 1, {});
    ans.assign(n + 1, 0);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
    }
    int a, b;
    cin >> a >> b;
    endd = b;
    cout << dfs(a) << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
