#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define endl "\n"
#define eb emplace_back
#define lb(a, b) lower_bound(all(a), b)
#define ub(a, b) upper_bound(all(a), b)

int bubbleGum = 0;
#ifdef LOCAL
#include "Templates/DebugTemplate.cpp"
#define FAST_IO ;
#else
#define dbg(...) ++bubbleGum;
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif



const int N = 2e5 + 10;


vec<int> e[N];
vec<pair<int, int>> g[N], rev[N];
int n, m, start, fin;
vec<int> order;
int used[N];
int toFin[N], fromStart[N];

void dfs(int v) {
    used[v] = 1;

    for (auto& [to, _] : g[v]) {
        if (used[to] == 0) dfs(to);
    }

    used[v] = 2;
    order.eb(v);
}

void clear() {
    for (int i = 0; i < m; ++i)
        e[i].clear();
    for (int i = 0; i < n; ++i) {
        fromStart[i] = toFin[i] = 0;
        g[i].clear();
        used[i] = 0;
    }
    order.clear();
}

void input() {
    cin >> n >> m;
    clear();
    for (int i = 0; i < m; ++i) {
        int from, to, w; cin >> from >> to >> w;
        --from, --to;
        e[i] = { from, to, w };
        rev[to].eb(mp(from, w));
        g[from].eb(mp(to, w));
    }
    cin >> start >> fin;
    --start, --fin;

    for (int i = 0; i < n; ++i)
        if (used[i] == 0) dfs(i);
    dbg(order);

}

void countWays() {
    for (auto& it : order) {
        for (auto& [to, _] : g[it])
            toFin[it] += toFin[to];
        if (it == fin) toFin[it] = 1;
    }

    reverse(all(order));
    for (auto& it : order) {
        for (auto& [from, _] : rev[it])
            fromStart[it] += fromStart[from];
        if (it == start) fromStart[it] = 1;
    }

    dbg(fromStart);
    dbg(toFin);

}

void solve() {
    
    input();
    countWays();

    int ans = 0;
    for (int i = 0; i < m; ++i) {
        int from = e[i][0], to = e[i][1], w = e[i][2];
        int cnt = (fromStart[from] & 1) * (toFin[to] & 1);
        int val = w * cnt;
        ans ^= val;
    }

    cout << ans << endl;

}




signed main() {
#ifdef LOCAL
    freopen("C:\\Users\\user\\CLionProjects\\OpenOlymp\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    int t; cin >> t;
    while (t--) solve();

}