#include <bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define endl '\n'
typedef long long ll;
using namespace std;

const ll MOD = 1e9 + 7;
const int N = 2e5;

vector<pair<int, int>> g[N];
int st[N];
bool u[N];
int d[N];
int k[N];

void solve2(int n, int m) {
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    if (a > b) {
        swap(a, b);
    }

    k[a] = 1;
    set<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        if (i == a) {
            s.insert({0, a});
            continue;
        }
        s.insert({st[i], i});
    }

    while (!s.empty()) {
        auto [qq, v] = *s.begin();
        if (qq != 0) {
            break;
        }
        s.erase(*s.begin());
        for (auto [to, w] : g[v]) {
            d[to] = (d[to] ^ d[v]);
            k[to] += k[v];
            k[to] %= 2;
            for (int j = 0; j < k[v]; j++) {
                d[to] = (d[to] ^ w);
            }
            s.erase(s.lower_bound({st[to], to}));
            st[to]--;
            s.insert({st[to], to});
        }
    }
    cout << d[b] << endl;
}

void solve() {
    int n, m;
    cin >> n >> m;

    bool f = 1;
    vector<int> w(m);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y >> w[i];
        x--;
        y--;
        g[x].push_back({y, w[i]});
        st[y]++;

        if ( !(x == i && y == i + 1) ) {
            f = 0;
        }
    }
    if (!f) {
        solve2(n, m);
    }

    int a, b;
    cin >> a >> b;
    a--;
    b--;

    if (a > b) {
        swap(a, b);
    }

    int s1 = 0;
    for (int i = a; i < b; i++) {
        s1 ^= w[i];
    }

    int s2 = 0;
    for (int i = b; i < m || i % m < a; i++) {
        s2 ^= w[i % m];
    }

    if (s2 == s1 && s1 == 0) {
        cout << 0 << endl;
        return;
    }
    cout << -1 << endl;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
