#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define all(A) A.begin(), A.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

int N, M;
matrix<pair<int, ll>> G;
vector<int> used, order, dp;

void dfs(int u){
	used[u] = true;
	for(auto [v, w] : G[u]){
		if(!used[v]){
			dfs(v);
		}
	}
	order.pb(u);
}

void s(){
	cin >> N >> M;
	G = matrix<pair<int, ll>>(N + 1);
	used = vector<int>(N + 1);
	dp = vector<int>(N + 1);
	for(int i = 0; i < M; i ++){
		int u, v, w; cin >> u >> v >> w;
		G[u].pb({v, w});
	}
	int a, b; cin >> a >> b;
	if(a > b){ cout << "0\n"; return; }
	int ans = 0;
	for(int u = b; u >= a; u --){
		if(u == b){
			dp[u] = 1;
		}
		else{
			for(auto [v, w] : G[u]){
				dp[u] += dp[v];
				if(dp[v] % 2 == 1){
					ans ^= w;
				}
			}
		}
	}
	cout << ans << endl;
}

int main(){
	int t; cin >> t; while(t --) s();
}