#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
using namespace std;
typedef long long ll;
vector<vector<vector<ll>>> g, rg;
vector<ll> c1, c2, C1, C2;
void  dfs1(ll v) {
	for (auto to : g[v]) {
		c1[to[0]] = (c1[to[0]] + c1[v]) % 2;
		--C1[to[0]];
		if (C1[to[0]] == 0) dfs1(to[0]);
	}
}
void  dfs2(ll v) {
	for (auto to : rg[v]) {
		c2[to[0]] = (c2[to[0]] + c2[v]) % 2;
		--C2[to[0]];
		if (C2[to[0]] == 0) dfs2(to[0]);
	}
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll t;
	cin >> t;
	while(t--) {
		ll n, m, a, b;
		cin >> n >> m;
		g.assign(n, {});
		rg.assign(n, {});
		C1.assign(n, 0);
		C2.assign(n, 0);
		bool B = true;
		ll s = 0;
		for (ll i = 0; i < m; ++i) {
			ll u, v, w;
			cin >> u >> v >> w;
			g[--u].push_back({ --v, w });
			rg[v].push_back({ u, w });
			++C1[v];
			++C2[u];
			if (n != m || u != i || v != (i + 1) % n) B = false;
			s ^= w;
		}
		cin >> a >> b;
		--a, --b;
		if (!B) {
			c1.assign(n, 0);
			c2.assign(n, 0);
			c1[a] = c2[b] = 1;
			dfs1(a);
			dfs2(b);
			ll ans = 0;
			for (ll i = 0; i < n; ++i) {
				for (auto to : g[i]) {
					if ((c1[i] * c2[to[0]]) == 1) ans ^= to[1];
				}
			}
			cout << ans << "\n";
		}
		else {
			if (s == 0) {
				for (ll i = min(a, b); i < max(a, b); ++i) s ^= (g[i][0][1]);
				if (s == 0) cout << "0\n";
				else cout << "-1\n";
			}
			else cout << "-1\n";
		}
	}
	return 0;
}