#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <string>
#include <chrono>
#include <fstream>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define ll long long
#define int ll
#define ld long double
#define pii pair<int, int>

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

void solve() {
    int n, m;
    cin >> n >> m;
    vector <int> task;
    task.resize(n);
    int t;
    for (int i = 0 ; i < n; i++) {
        cin >> t >> t >> t;
        task[i] = t;
    }
    int check = 0;
    for (int i = 0 ; i < task.size(); i++) {
        check ^= task[i];
    }
    if (check != 0) {
        cout << -1 << "\n";
        return;
    }
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    int ans = 0;
    if (a < b) {
        for (int i = a; i < b ; i++) {
            ans ^= task[i];
        }
    } else {
        for (int i = a; i < b + n; i++) {
            ans ^= task[i % n];
        }
    }
    cout << ans << "\n";
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}