#include <bits/stdc++.h>

#define ll long long
#define ld long double


using namespace std;

vector<int> p(vector<vector<pair<int, int> > >& g, int u, int f, vector<bool>& vis){
    queue<ll> q;
    q.push(u);
    vector<ll> frm(g.size(), -1);
    while(!q.empty()){
        ll v = q.front();

        q.pop();
        vis[v] = 1;
        if(v == f)
            break;
        for(auto t : g[v]){
                int to = t.first;
            if(!vis[to]){
                q.push(to);
                vis[to] = 1;
                frm[to] = v;
            }
        }
    }
    vector<int> res;
    ll v = f;
    while(v != u){
        res.push_back(v);
        v = frm[v];
    }
    res.push_back(u);
    reverse(res.begin(), res.end());
    return res;

}

void solve()
{
    ios_base::sync_with_stdio(0); cin.tie(0);
    ll n, m;
    cin >> n >> m;
    vector<vector<pair<int, int> > > g(n);
    int r2 = 0;
    for(ll i = 0; i < m; i++){
        ll u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        g[u].push_back({v, w});
        r2 ^= w;
    }
    int a, b;
    cin >> a >> b;
    a--; b--;
    int v = a, res = 0;
    while(v != b){
        res ^= g[v][0].second;
        v = g[v][0].first;
    }
    cout << (res == 0 && r2 == 0 ? 0 : -1) << "\n";

}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t;
    cin >> t;
    while(t--)
        solve();
    return 0;
}
