#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back

const int N = 5e5 + 1;
const int mod = 1e9 + 7;

void solve () {
    int n, m;
    cin >> n >> m;
    vc <vc <pii>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w; --u; --v;
        g[u].pb({ v , w });
    }
    int s, t;
    cin >> s >> t; --s; --t;
    if (s > t) {
        cout << "-1\n";
        return;
    }
    vc <int> dp1(n), dp2(n), is(n);
    dp2[t] = 1;
    is[t] = 1;
    for (int i = t; i >= s; --i) {
        for (auto [v, w] : g[i]) {
            dp2[i] ^= dp2[v];
            dp1[i] ^= dp1[v];
            dp1[i] ^= w * dp2[v];
            is[i] |= is[v];
        }
    }
//    if (!is[s]) {
//        cout << "-1\n";
//        return;
//    }
    cout << dp1[s] << '\n';
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}

/*
1
3 3
1 2 1
1 3 2
2 3 3
1 3
 */