#include <bits/stdc++.h>

using namespace std;
#define eb emplace_back

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

vector<vector<ii>> gr;
vector<bool> used;

int ans = 0;

void dfs(int v, int f, int path) {
    if (v == f) {
        ans ^= path;
    }
    used[v] = true;
    for (auto &[u, w]: gr[v]) {
        if (used[u] && path^w) {
            ans = -1;
            return;
        } else {
            dfs(u, f, path^w);
            if (ans == -1)
                return;
        }
    }
    used[v] = false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    ans = 0;
    gr.assign(n, {});
    used.assign(n, false);
    int u, v, w;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v >> w;
        u--;
        v--;
        gr[u].eb(v, w);
    }
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    dfs(a, b, 0);
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tests = 1;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
