#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

#define sz(x) (x).size()
#define all(x) (x).begin(), (x).end()

const int MOD = 1e9 + 7;

const int maxn = 2e5;

int n, m, s,t;
vector<pair<int, int>> g[maxn];
bool used[maxn];

void run_test(int test_case) {
   cin >> n >> m;
   for (int i = 0; i < n; i++) {
      g[i].clear();
      used[i] = false;
   }
   bool dag = true;
   for (int i = 0, x, y, w; i < m; i++) {
      cin >> x >> y >> w;
      dag &= (x < y);
      --x, --y;
      g[x].push_back(make_pair(y, w));
   }
   cin >> s >> t; --s, --t;
   if (dag) {
      vector<int> sizes(n), ans(n, 0);
      sizes[s] = 1;
      for (int v = s; v <= t; v++) {
         for (auto [u, w] : g[v]) {
            sizes[u] += sizes[v];
            ans[u] ^= (ans[v] ^ ((sizes[v] & 1) ? w : 0)); 
         }
      }
      if (!sizes[t]) {
         cout << "-1\n";
      } else {
         cout << ans[t] << '\n';
      }
   } else {
      assert(false);
   }
}

int main() {
   ios_base::sync_with_stdio(0);
   cin.tie(0);
   
   int test_cases = 1;
   cin >> test_cases;
   for (int test_case = 1; test_case <= test_cases; test_case++) {
      run_test(test_case);
   }
     
   return 0;
}