#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
using namespace std;
#define int long long

void solve() {
    int n, m;
    cin >> n >> m;
    int xr = 0;
    vector<int> nxt(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        nxt[a] = c;
        xr ^= c;
    }
    int a, b;
    cin >> a >> b;
    if (a == b) {
        if (xr != 0) {
            cout << -1 << '\n';
        } else {
            cout << 0 << '\n';
        }
        return;
    }
    xr = 0;
    while (a != b) {
        xr ^= nxt[a];
        if (a == n) {
            a = 1;
        } else {
            a++;
        }
    }
    if (xr != 0) {
        cout << -1 << '\n';
    } else {
        cout << 0 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}

/*
/home/olymp/PreDay/cmake-build-debug/PreDay
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
 3 4 4 3
 3 4 3 5
 */