#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;
const int MOD = 1e9 + 7;

vector<vector<pair<int, int>>> gr;
vector<int> anses;
vector<int> used;

void dfs(int u, int stop, int cur_xor = 0) {
    used[u] = 1;
    if (u == stop) {
        anses.push_back(cur_xor);
    }
    for (auto i : gr[u]) {
        if (used[i.first] == 1) {
            if ((cur_xor ^ i.second) != 0) {
                anses.push_back(-1);
                return;
            }
        } else {
            dfs(i.first, stop, cur_xor ^ i.second);
        }
    }
    used[u] = 2;
}

void dfs2(int u, int stop, int cur_xor = 0) {
    used[u] = 1;
    if (u == stop) {
        anses.push_back(cur_xor);
        return;
    }
    for (auto i : gr[u]) {
        if (used[i.first] == 1) {

        } else {
            dfs(i.first, stop, cur_xor ^ i.second);
        }
    }
    used[u] = 2;
}

inline void solve() {
    int n, m;
    cin >> n >> m;
    gr = vector<vector<pair<int, int>>>(n);
    anses = vector<int>();
    used = vector<int>(n);
    int maw = -INF;
    bool flag = true;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        gr[u - 1].emplace_back(v - 1, w);
        flag &= ((u + 1) % (n + 1) == v);
        maw = max(maw, w);
    }
    int a, b;
    cin >> a >> b;
    if (maw == 0) {
        cout << 0 << '\n';
        return;
    }
    dfs(a - 1, b - 1);
    if (find(anses.begin(), anses.end(), -1) != anses.end()) {
        cout << -1 << '\n';
        return;
    }
    if (a == b || anses.empty()) {
        cout << -1 << '\n';
        return;
    }
    int ans = 0;
    for (auto i : anses)
        ans ^= i;
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    cin >> tests;
    for (int i = 1; i <= tests; ++i)
        solve();
}
