#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 2e5, mod = 1e9 + 7, INF = 1e18;

struct str {
    ll v, u, c;
};

void solve() {
    bool fl = true;
    ll n, m, s1 = 0, s2 = 0;
    cin >> n >> m;
    if(m != n){
        fl = false;
    }
    vector<str> vert(m);
    vector<vector<ll>> gr(n), revgr(n);
    vector<ll> s(n), rs(n), dpa(n), dpb(n), ca(n), cb(n);
    for(ll i = 0; i < m; i++){
        cin >> vert[i].v >> vert[i].u >> vert[i].c;
        vert[i].v--, vert[i].u--;
        if((i != m - 1) && (vert[i].v != i || vert[i].u != i + 1)){
            fl = false;
        }
        s1 = s1 ^ vert[i].c;
        s[vert[i].u]++, rs[vert[i].v]++;
        gr[vert[i].v].push_back(vert[i].u);
        revgr[vert[i].u].push_back(vert[i].v);
    }
    if(vert.back().v != n - 1 || vert.back().u != 0){
        fl = false;
    }
    ll a, b;
    cin >> a >> b;
    a--, b--;
    
    if(a >= b){
        cout << 0 << '\n';
        return;
    }
    queue<ll> q;
    q.push(a);
    ca[a] = true;
    dpa[a] = 1;
    while(!q.empty()){
        ll t = q.front();
        q.pop();
        for(auto u : gr[t]){
            ca[u] = true;
            dpa[u] = (dpa[u] + dpa[t]) % 2;
            s[u]--;
            if(s[u] == 0){
                q.push(u);
            }
        }
    }
    cb[b] = true;
    dpb[b] = 1;
    q.push(b);
    while(!q.empty()){
        ll t = q.front();
        q.pop();
        for(auto u : revgr[t]){
            rs[u]--;
            cb[u] = true;
            dpb[u] = (dpb[u] + dpb[t]) % 2;
            if(rs[u] == 0){
                q.push(u);
            }
        }
    }
    vector<ll> ans(30);
    for(ll i = 0; i < m; i++){
        for(ll j = 0; j < 30; j++){
            if((vert[i].c >> j) & 1){
                ans[j] = (ans[j] + dpa[vert[i].v] * dpb[vert[i].u]) % 2;
            }
        }
    }
    ll ot = 0;
    for(ll i = 0; i < 30; i++){
        ot += ans[i] * (1 << i);
    }
    cout << ot << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while(t--){
        solve();
    }
}
