#include <bits/stdc++.h>

#define int long long

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    bool flag = 0;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        if (u >= v)
            flag = 1;
        g[u].push_back({v, w});
    }
    int a, b;
    cin >> a >> b;
    --a, --b;
    if (flag) {
        int path1 = 0;
        for (int i = a; i != b; i = g[i][0].first)
            path1 ^= g[i][0].second;
        int path2 = 0;
        int cnt = 0;
        for (int i = a; cnt != 2; i = g[i][0].first) {
            if (i == b) {
                cnt += 1;
                if (cnt == 2)
                    break;
            }
            path2 ^= g[i][0].second;
        }
        if (path1 != 0 || path2 != 0)
            cout << -1;
        else
            cout << 0;
        cout << '\n';
        return;
    }
    if (a > b) {
        cout << 0 << '\n';
        return;
    }
    vector<int> pathcnt(n);
    vector<int> dp(n);
    dp[a] = 0;
    pathcnt[a] = 1;
    for (int i = a; i < b; ++i) {
        for (auto [to, w]: g[i])
            dp[to] ^= (dp[i] ^ (pathcnt[i] % 2 ? w : 0));
        for (auto [to, w]: g[i])
            pathcnt[to] += pathcnt[i];
    }
    cout << dp[b] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--)
        solve();
}