#include <bits/stdc++.h>

#define pb push_back
#define st string
#define ss second
#define ff first
#define all(a) a.begin(), a.end()
#define vout(a) for (auto u : a) cout << u << " ";
#define vec vector
#define ull unsigned long long
#define ld long double
#define int long long

using namespace std;
using vi = vec<int>;
using vvi = vec<vi>;
using vvvi = vec<vvi>;
using pi = pair<int, int>;
using vpi = vec<pi>;
using vvpi = vec<vpi>;
using vvvpi = vec<vvpi>;

vvpi g;
vi used;
vi top;

int dfs(int v, int x) {
    used[v] = 1;
    int ans = 0;
    if (v == x) return 0;
    for (auto u : g[v]) {
        if (!used[u.ff]) {
            ans ^= dfs(u.ff, x) ^ u.ss;
        }
    }
    return ans;
}

void dfs2(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u.ff]) {
            dfs2(u.ff);
        }
    }
    top.pb(v);
}

void solve(int n, int m) {
    g = {};
    g.resize(n);
    int xorr = 0;
    for (int i = 0; i < m; i++) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].pb({v, w});
        xorr ^= w;
    }

    int a, b; cin >> a >> b;
    a--; b--;
    if (a == b) {
        cout << (!xorr ? 0 : -1) << "\n";
        return;
    }
    used.assign(n, 0);
    int ans1 = dfs(a, b);
    used.assign(n, 0);
    int ans2 = dfs(b, a);
    cout << (!ans1 && !ans2 ? 0 : -1) << "\n";
}

void solve2(int n, int m) {
    g = {};
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].pb({v, w});
    }
    int a, b; cin >> a >> b;
    a--; b--;

    top = {};
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs2(i);
        }
    }

    vi ans(n, 0);
    vi cnt(n, 0);
    for (auto u : top) {
        for (auto y : g[u]) {
            cnt[u] += cnt[y.ff];
            if (cnt[y.ff] % 2) {
                ans[u] ^= (ans[y.ff] ^ y.ss);
            }
            else {
                ans[u] ^= ans[y.ff];
            }
            if (y.ff == b) {
                cnt[u]++;
                ans[u] ^= y.ss;
            }
        }
//        cout << u + 1 << " " << ans[u] << endl;
    }
//    cout << ans[a] << endl;
    cout << (5 ^ 2) << endl;
}

signed main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);

    int tt = 1;
    cin >> tt;
    while (tt--) {
        int n, m; cin >> n >> m;
        if (n == m) {
            solve(n, m);
        }
        else {
            solve2(n, m);
        }
    }
}
