#include <bits/stdc++.h>
#define int long long
#define sz size()
#define vint vector<int>
#define vool vector<bool>

using namespace std;

vector<pair<int, int> > graph[200010];
int a, b;

int ans = 0;

bool used[200010];
bool can[200010];

void dfs(int v)
{
    if(v == b)
    {
        can[b] = 1;
        return;
    }
    for(auto x : graph[v])
    {
        int cur = x.first;
        if(!used[cur])
        {
            used[cur] = 1;
            dfs(cur);
        }
        can[v] = max(can[v], can[cur]);
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while(t --)
    {
        ans = 0;
        int n, m;
        cin >> n >> m;
        for(int i = 1; i <= n; i ++)
        {
            graph[i].clear();
        }
        bool sub_1 = 0;
        int sum = 0, xxx = 0;
        for(int i = 0; i < m; i ++)
        {
            int u, v, w;
            cin >> u >> v >> w;
            xxx ^= w;
            if(i == m - 1)
            {
                if(u != n || v != 1)
                    sub_1 = 1;
            }
            else
            {
                if(u != i + 1 || v != i + 2)
                    sub_1 = 1;
            }
            graph[u].push_back({v, w});
        }
        cin >> a >> b;
        if(sub_1 == 0)
        {
            if(xxx == 0)
            {
                int cur = 0;
                if(a < b)
                {
                    for(int i = a; i < b; i ++)
                    {
                        cur ^= graph[i][0].second;
                    }
                    if(cur != 0)
                    {
                        cout << -1 << endl;
                    }
                    else
                    {
                        cout << 0 << endl;
                    }
                }
                if(a > b)
                {
                    for(int i = a; i <= n; i ++)
                    {
                        cur ^= graph[i][0].second;
                    }
                    for(int i = 1; i < b; i ++)
                    {
                        cur ^= graph[i][0].second;
                    }
                    if(cur != 0)
                    {
                        cout << -1 << endl;
                    }
                    else
                    {
                        cout << 0 << endl;
                    }
                }
                if(a == b)
                {
                    cout << 0 << endl;
                }
            }
            else
            {
                cout << -1 << endl;
            }
            continue;
        }
        if(a >= b)
        {
            cout << 0 << endl;
            continue;
        }
        for(int i = 1; i <= n; i ++)
        {
            used[i] = 0;
            can[i] = 0;
        }
        used[a] = 1;
        dfs(a);
        if(can[a] == 0)
        {
            cout << 0 << endl;
            continue;
        }
        vint all(n + 1);
        all[a] = 1;
        for(int i = a; i < b; i ++)
        {
            if(can[i] == 0 || all[i] == 0)
                continue;
            for(auto x : graph[i])
            {
                int cur = x.first;
                ans ^= x.second;
                all[cur] += all[i];
                all[cur] %= 2;
            }
        }
        cout << ans << endl;
    }
}

/*

1
3 3
1 2 7
2 3 0
3 1 7
2 3

*/
