#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define sz(a) (int)a.size()
#define vc vector
#define pb push_back
#define ff first
#define ss second
#define all(a) (a).begin(), (a).end()

const int INFi = 1e9;
const ll INFl = 1e18;

template<class T>
bool inmin(T &x, T y) {
    if (y < x) {
        x = y;
        return true;
    }
    return false;
}

template<class T>
bool inmax(T &x, T y) {
    if (y > x) {
        x = y;
        return true;
    }
    return false;
}

mt19937 rnd(time(0));

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/Kek/read.txt", "r", stdin);
#endif
    //cout << fixed << setprecision(10);
    int tc = 1;
    cin >> tc;
    forn(i, tc) solve();
    return 0;
}

vector<vector<pair<int, ll>>> gr;
vector<ll> dp, pos, rem;

const int Mod = 1234567891;
ll add(ll x, ll y) {
    return (x + y) % Mod;
}
vector<bool> used;
vector<int> path;

void dfs(int v) {
    used[v] = true;
    for (auto [adj, c] : gr[v]) {
        if (!used[adj]) dfs(adj);
    }
    path.pb(v);
}

void solve() {
    int n;
    cin >> n;
    gr.assign(n, {});
    int m;
    cin >> m;
    bool gr1 = m == n;
    vector<ll> kek;
    ll xr = 0;
    forn(i, m) {
        int u, v;
        ll w;
        cin >> u >> v >> w;
        --u, --v;
        if (i == m - 1) {
            gr1 &= u == i && v == 0;
        } else {
            gr1 &= u == i && v == (i + 1);
        }
        kek.pb(w);
        gr[u].pb({v, w});
        xr ^= w;
    }
    int a, b;
    cin >> a >> b;
    --a, --b;
    if (gr1) {
        if (xr != 0) {
            cout << -1 << '\n';
            return;
        }
        ll ans = 0;
        for (int x = a; x != b; x = (x + 1) % m) {
            ans ^= kek[x];
        }
        if (ans != 0) {
            cout << -1 << '\n';
            return;
        } else {
            cout << 0 << '\n';
        }
        return;
    }
    dp.assign(n, 0);
    pos.assign(n, 0);
    rem.assign(n, 0);
    used.assign(n, 0);
    path.clear();
    dfs(a);
    pos[b] = rem[b] = 1;
    for (int v : path) {
        for (auto [adj, c] : gr[v]) {
            if (pos[adj]) {
                rem[v] ^= rem[adj];
                pos[v] = add(pos[v], pos[adj]);
                dp[v] ^= dp[adj];
                if (rem[adj]) dp[v] ^= c;
            }
        }
    }
    cout << dp[a] << '\n';
}