#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <unordered_map>
#include <set>
#include <algorithm>

using namespace std;

long long mod = 1e9 + 7;
vector < vector < pair < long long, long long > > > g;
long long a, b;

long long pr = -1;
bool fl = false;

void dfs(long long v, long long ans) {
    if (v == b && pr == -1) {
        pr = ans;
    }
    else if (v == b) {
        if (pr == 0 && ans == 0) {
            cout << 0 << '\n';
        }
        else {
            cout << -1 << '\n';
        }
        fl = true;
        return;
    }

    for (auto p : g[v]) {
        long long to = p.first, w = p.second;
        dfs(to, ans ^ w);
        if (fl)return;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long t;
    cin >> t;

    for (long long i = 0; i < t; i++) {
        long long n, m;
        cin >> n >> m;
        
        g.assign(n, vector < pair < long long, long long > > ());
        for (long long j = 0; j < m; j++) {
            long long a, b, w;
            cin >> a >> b >> w;
            a--; b--;
            g[a].push_back({ b, w });
        }

        cin >> a >> b;
        a--; b--;
        dfs(a, 0);
        fl = false;
        pr = -1;
    }

}
