#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef __int128 lll;
typedef long double ld;
ll inf = 1e15, mod = 1e9 + 7;
ld eps = 1e-9;
#define all(a) a.begin(), a.end()

ll binpow(ll n, ll k) {
    if (!k)
        return 1;
    if (k % 2)
        return (binpow(n, k - 1) * n) % mod;
    ll a = binpow(n, k / 2);
    return (a * a) % mod;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    ll xr = 0;
    vector<ll> t(m);
    for (ll i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y >> t[i];
        xr ^= t[i];
    }
    ll a, b;
    cin >> a >> b;
    a--;
    b--;
    ll p = 0;
    if (a > b)
        swap(a, b);
    for (ll i = a; i < b; i++)
        p ^= t[i];
    if (!p || p == xr)
        cout << "-1\n";
    else
        cout << xr << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll test;
    cin >> test;
    while (test--) {
        solve();
    }
}