#include<bits/stdc++.h>
#define dbg(x) cout << #x << "=" << x << "\n";
using namespace std;

#define int long long

struct edge{
    int u;
    int w;
};

struct node{
    int cnt;
    int x;
};

struct graph{
    vector<vector<edge>> g;
    vector<int> used;
    vector<node> ans;

    graph(int n){
        g.resize(n, vector<edge> ());
        used.resize(n, 0);
        ans.resize(n, {0, 0});
    }
};

void dfs(graph &g, int v){
    for(auto el: g.g[v]){
        if(!g.used[el.u]){
            g.ans[el.u].cnt++;
            g.ans[el.u].x = (g.ans[el.u].x ^ el.w);
            dfs(g, el.u);
        }
    }
}

void solve(){
    int n, m; cin >> n >> m;

    graph g = graph(n);

    int sum_ = 0;

    for(int i=0; i < m; i++){
        int u, v, w; cin >> u >> v >> w;

        u--; v--;

        g.g[u].push_back({v, w});

        sum_ = (sum_ ^ w);
    }

    /*int a, b; cin >> a >> b; a--;b--;

    dfs(g, a);

    if(sum_ != 0){
        cout << -1;
    }else{
        cout << g.ans[b].x;
    }*/
}

int32_t main(){
    /*ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    */

    int t=1; cin >> t;

    for(int i=0; i < t; i++){
        solve();

        cout << "\n";
    }
}
