#include <bits/stdc++.h>

using namespace std;

const int N = 200'000;

vector<int> g[N], gr[N];

void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; i++) {
        g[i].clear();
        gr[i].clear();
    }

    struct edge {
        int u, v, w;
    };

    map<pair<int, int>, int> mp;

    int sum = 0;

    vector<edge> edges(m);

    bool flag = true;

    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        if (u > v) {
            flag = false;
        }
        edges[i] = {u, v, w};
        g[u].push_back(v);
        gr[v].push_back(u);
        mp[{u, v}] = w;
        sum ^= w;
    }

    int a, b;
    cin >> a >> b;
    a--, b--;

    if (!flag) {
        if (a == b) {
            if (sum != 0) {
                cout << "-1\n";
            } else {
                cout << "0\n";
            }
            return;
        }

        if (n == 1) {
            if (mp[{0, 0}] != 0) {
                cout << "-1\n";
            } else {
                cout << "0\n";
            }
            return;
        }


        int sum1 = 0;
        int x1 = a;
        while (x1 != b) {
            sum1 ^= mp[{x1, (x1 + 1) % n}];
            x1++;
            x1 %= n;
        }

        int sum2 = 0;
        int x2 = b;
        while (x2 != a) {
            sum2 ^= mp[{x2, (x2 + 1) % n}];
            x2++;
            x2 %= n;
        }
        
        if (sum1 == 0 && sum2 == 0) {
            cout << sum1 << "\n";
        } else {
            cout << "-1\n";
        }
        return;
    }

    vector<int> dp(n), dpr(n);
    dp[b] = 1;
    for (int i = n - 1; i > -1; i--) {
        for (auto u : g[i]) {
            dp[i] ^= dp[u];
        }
    }
    dpr[a] = 1;
    for (int i = 0; i < n; i++) {
        for (auto u : gr[i]) {
            dpr[i] ^= dpr[u];
        }
    }
    int ans = 0;
    for (int i = 0; i < m; i++) {
        if (dp[edges[i].v] == 1 && dpr[edges[i].u] == 1) {
            ans ^= edges[i].w;
        }
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }
}