#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#define ll long long
#define ld long double

// login: open-2023-382
// passw: fx5mmuap

using namespace std;

const ll inf = 1e18;
const ll MOD = 1e9 + 7;

ll n, m;
vector<vector<ll>> gr1, gr2, cost;
ll A, B;

void read() {
	cin >> n >> m;
	gr1 = gr2 = vector<vector<ll>>(n);
	cost = vector<vector<ll>>(n);
	for (ll i = 0; i < m; i++) {
		ll a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		gr1[a].push_back(b);
		gr2[b].push_back(a);
		cost[a].push_back(c);
	}
	cin >> A >> B;
	A--, B--;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);

	ll t;
	cin >> t;
	while (t--) {
		read();
		if (A > B) {
			cout << 0 << "\n";
			continue;
		} 
		if (A == B) {
			cout << -1 << "\n";
			continue;
		}
		vector<ll> dp1(n, 0);
		dp1[A] = 1;
		for (ll i = 0; i < n; i++) {
			for (auto& to : gr2[i]) {
				dp1[i] += dp1[to];
			}
		}
		vector<ll> dp2(n, 0);
		dp2[B] = 1;
		for (ll i = n - 1; i >= 0; i--) {
			for (auto& to : gr1[i]) {
				dp2[i] += dp2[to];
			}
		}

		ll ans = 0;
		for (ll i = 0; i < n; i++) {
			for (ll j = 0; j < (ll)gr1[i].size(); j++) {
				ll to = gr1[i][j], c = cost[i][j];
				ans ^= (dp2[to] % 2) * (dp1[i] % 2) * c;
			}
		}
		cout << ans << "\n";
	}
	
	

	return 0;
}