#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/t_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

#define int long long

typedef long double ld;
typedef long long ll;
//#define oset tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>


const int INF = 1e9 + 2, MOD = 1e9 + 7, N = 2e5 + 100, K = 20;
mt19937 rnd(time(0));
vector<vector<pair<int, int>>> g, grev;
vector<int> used1, usedrev, used, id;

void dfs1(int v) {
    used1[v] = 1;
    for (auto [to, w]: g[v]) {
        if (!used1[to])
            dfs1(to);
    }
}

void dfsrev(int v) {
    usedrev[v] = 1;
    for (auto [to, w]: grev[v]) {
        if (!usedrev[to])
            dfsrev(to);
    }
}

bool cyc = 0;
vector<int> ts, xr;

void dfs(int v, int cur) {
    used[v] = 1;
    xr[v] = cur;
    for (auto [to, w]: g[v]) {
        if (used[to] == 2) continue;
        if (used[to] == 1) {
            if (cur ^ xr[to] ^ w) {
                cyc = 1;
                return;
            } else continue;
        } else if (used1[to] && usedrev[to]) {
            dfs(to, cur ^ w);
        }
    }
    used[v] = 2;
    id[v] = ts.size();
    ts.push_back(v);
}


void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n + 1, {});
    used.assign(n + 1, 0);
    used1.assign(n + 1, 0);
    usedrev.assign(n + 1, 0);
    grev.assign(n + 1, {});
    ts.clear();
    xr.assign(n + 1, 0);
    id.assign(n + 1, 0);
    cyc = 0;
    int xx = 0;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        xx ^= w;
        g[u].emplace_back(v, w);
        grev[v].emplace_back(u, w);
    }
    int a, b;
    cin >> a >> b;
//    dfs1(a);
//    dfsrev(b);
//    dfs(a, 0);
    int cur = 0;
    while (a != b) {
        cur ^= g[a][0].second;
        a = g[a][0].first;
    }
    if (cur != 0 || xx != 0)
        cout << -1 << endl;
    else
        cout << 0 << endl;

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}