#include <bits/stdc++.h>

#define int long long
#define F first
#define S second
using namespace std;
int n, m;
vector<vector<pair<int, int>>> g;
vector<int> ans;
vector<bool> used;

void dfs(int v) {
    used[v] = 1;
    for (auto[i, w]: g[v]) {
        if (!used[i]) {
            ans[i] = ans[v] ^ w;
            dfs(i);
        }
    }
}

signed main() {
    int _;
    cin >> _;
    while (_--) {
        cin >> n >> m;
        g.clear();
        g.resize(n);
        ans.clear();
        ans.resize(n, 0);
        used.assign(n, 0);
        for (int i = 0; i < m; ++i) {
            int v, u, w;
            cin >> v >> u >> w;
            v--;
            u--;
            g[v].push_back({u, w});
        }
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        dfs(a);
        cout << ans[b] << '\n';
    }
    return 0;
}