/*
Lisa
Jennie
Jisoo
Rose
 */

#pragma GCC optimize("03")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <cstring>
#include <chrono>
#include <random>
#include <bits/extc++.h>


using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;
using pll = pair<ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-8;

#define all(a) a.begin(), a.end()
#define pb push_back
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;


int n, m;
vector <bool> used;
vector<vector<pii>> g;
vector <int> ans, cnt;


void dfs (int k) {
    used[k] = true;
    for (auto i : g[k]) {
        if (!used[i.first]) {
            dfs(i.first);
        }
        if (ans[i.first] != -1) {
            cnt[k] += cnt[i.first];
            ans[k] ^= (ans[i.first] ^ (i.second * (cnt[i.first] % 2)));
        }
    }
}


void solve() {
    cin >> n >> m;
    g.clear();
    g.resize(m);
    ans.clear(); cnt.clear();
    ans.assign(n, 0); cnt.assign(n, 0);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        g[u].pb({v, w});
    }
    // a, b
    int a, b; cin >> a >> b;
    --a; --b;
    cnt[b] = 1; ans[b] = 0;
    used.clear(); used.assign(n, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    cout << ans[a] << endl;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}
