#include "bits/stdc++.h"
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2,fma,bmi,bmi2,mmx,tune=native")
#include "bits/extc++.h"
#define all(x) begin(x), end(x)
#define rall(x) x.rbegin(), x.rend()
#define frl(i, x) for(auto& i : x)
#define rep(i, j, k) for(int i = j; i < k; i++)
#define rrep(i, j, k) for(int i = k - 1; i >= j; i--)
#define S second
#define F first

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int maxn = 2e5+5;
vector<pair<int, int>> g1[maxn], g2[maxn];

int ka, kb;
char used1[maxn];
int dp1[maxn];
char used2[maxn];
int dp2[maxn];

void dfs1(int v){
    used1[v] = 1;
    if(v == ka){
        dp1[v] = 1;
    }
    else {
        frl(i, g1[v]) {
            if (used1[i.F]) dp1[v] += dp1[i.F];
            else {
                dfs1(i.F);
                dp1[v] += dp1[i.F];
            }
        }
    }
}

void dfs2(int v){
    used2[v] = 1;
    if(v == kb) dp2[v] = 1;
    else {
        frl(i, g2[v]) {
            if (used2[i.F]) dp2[v] += dp2[i.F];
            else {
                dfs2(i.F);
                dp2[v] += dp2[i.F];
            }
        }
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<int> v(m);
    int al_x = 0;
    bool f = (n == m);
    frl(i, v){
        int a, b;cin >>a>>b>>i;
        a--,b--;
        al_x ^= i;
        if((a + 1) % n != b) f = 0;
        g1[b].emplace_back(a, i);
        g2[a].emplace_back(b, i);
    }
    if(f) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        rotate(v.begin(), v.begin() + a, v.end());
        b -= a;
        if (b < 0) b += n;
        int px = 0;
        rep(i, 0, b) px ^= v[i];
        if (px == 0 && al_x == 0) cout << "0\n";
        else {
            cout << "-1\n";
        }
    }
    else{
        cin >> ka >> kb;
        ka--,kb--;
        dfs1(kb);
        dfs2(ka);
        int x = 0;
        rep(u, 0, n){
            frl(j, g2[u]){
                int w = j.F;
                int kok = dp1[u] * dp2[w];
                if(kok&1) x ^= j.S;
            }
        }
        cout << x << '\n';
        rep(i, 0, n){
            used1[i] = used2[i] = dp1[i] = dp2[i] = 0;
            g1[i].clear();
            g2[i].clear();
        }
    }
}

int main(){
    cin.tie(0)->ios::sync_with_stdio(0);
    cout << setprecision(15) << fixed;
    int TT=1;
    cin>>TT;
    while(TT--) solve();
}