#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

vector<ll> pref;
ll get(ll l, ll r) {
    if (l > r) {
        return 0;
    }
    return pref[r] ^ pref[l - 1];
}

void solve() {
    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;

        vector<ll> arr(n + 1);
        pref.resize(n + 1);
        while (m--) {
            ll a, b, w;
            cin >> a >> b >> w;
            arr[a] = w;
        }
        for (ll i = 1; i <= n; ++i) {
            pref[i] = pref[i - 1] ^ arr[i];
        }

        ll from, to;
        cin >> from >> to;
        if (from > to) {
            swap(from, to);
        }

        ll len1 = get(from, to - 1);
        ll len2 = get(1, from - 1) ^ get(to, n);
        if (len1 != 0 || len2 != 0) {
            cout << -1 << "\n";
        } else {
            cout << 0 << "\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}