#include <bits/stdc++.h>
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin >> tt;
    while (tt--) {
        int n, m;
        cin >> n >> m;
        vector<vector<tuple<int, int, int>>> g(n), ginv(n);
        for (int i = 0; i < m; i++) {
            int u, v, w;
            cin >> u >> v >> w;
            u--, v--;
            g[u].emplace_back(v, w, i);
            ginv[v].emplace_back(u, w, i);
        }
        int a, b;
        cin >> a >> b;
        a--, b--;
        queue<int> q;
        vector<bool> visited(n, false);
        auto DFS = [&](int u, auto&& DFS) -> void {
            visited[u] = true;
            for (auto [v, w, i] : g[u]) {
                if (!visited[v]) {
                    DFS(v, DFS);
                }
            }
        };
        DFS(a, DFS);
        if (!visited[b]) {
            cout << -1 << "\n";
            continue;
        }
        vector<int> path_a(n), path_b(n);
        visited.assign(n, false);
        visited[a] = true;
        q.push(a);
        path_a[a] = 1;
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (auto [v, w, i] : g[u]) {
                path_a[v] ^= path_a[u];
                if (!visited[v]) {
                    visited[v] = true;
                    q.push(v);
                }
            }
        }
        visited.assign(n, false);
        visited[b] = true;
        q.push(b);
        path_b[b] = 1;
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (auto [v, w, i] : ginv[u]) {
                path_b[v] ^= path_b[u];
                if (!visited[v]) {
                    visited[v] = true;
                    q.push(v);
                }
            }
        }
        int ans = 0;
        for (int u = 0; u < n; u++) {
            for (auto [v, w, i] : g[u]) {
                if (path_a[u] * path_b[v]) {
                    ans ^= w;
                }
            }
        }
        cout << ans << "\n";
    }
}