#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>

using namespace std;

#define ll long long
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), rend()
#define bit(i, n) ((n >> i) & 1)

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

ll dfs(int i, int e, vector<vector<pair<int, ll>>>& v) {
	if (i == e)re 0;

	for (auto j : v[i]) {
		re j.second^ dfs(j.first, e, v);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int t; cin >> t;
	while (t--) {
		int n, m; cin >> n >> m; 
		vector<vector<pair<int, ll>>> v(n);
		vector<bool> was(n), good(n);
		vector<ll> info(n);

		fori(m) {
			ll a, b, w; cin >> a >> b >> w;

			v[a - 1].push_back({ b - 1, w });
		}
		ll a, b; cin >> a >> b;

		ll c1 = dfs(a - 1, b - 1, v);
		ll c2 = dfs(b - 1, a - 1, v);

		if (c2 == 0 && c1 == 0)cout << "0\n";
		else cout << "-1\n";
	}
}