#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1337, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

vector<pair<int, int>> g[MAXN];

int cnt = 0, ans = 0;

bool fl = true;

int s, f;

void dfs(int v, int xr = 0) {
    if (v == f) {
        if (xr != 0) {
            fl = false;
        }
        ans ^= xr;
        ++cnt;
        if (cnt == 2) {
            return;
        }
    }
    for (auto &[to, w] : g[v]) {
        dfs(to, xr ^ w);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    fl = true;
    cnt = ans = 0;
    for (int i = 1; i <= n; ++i) {
        g[i].clear();
    }
    int sm = 0;
    for (int i = 0, x, y, w; i < m; ++i) {
        cin >> x >> y >> w;
        sm += w;
        g[x].emplace_back(y, w);
    }
    cin >> s >> f;
    dfs(s);
    if (fl) {
        cout << ans << "\n";
    } else {
        cout << "-1\n";
    }
}