#include <bits/stdc++.h>

#define int long long
#define f first
#define s second
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define sz(x) (int)(x).size()
#define vec vector
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<int, int>

using namespace std;

const int mod = 1e9 + 7;

void solve()
{
    int n;
    cin >> n;
    vec<vec<int>> g (n);
    vec<int> p (n);
    p[0] = -1;
    for(int i = 1; i < n; i++)
    {
        cin >> p[i];
        p[i]--;
        g[p[i]].pb(i);
        g[i].pb(p[i]);
    }

    vec<pii> segs (n);
    FOR(i, n)
        cin >> segs[i].f >> segs[i].s;

    vec<int> curpath;

    function<int(int, int, int)> calc_path = [&](int v, int p, int b) -> int
    {
        if(v == b)
        {
            curpath.pb(v);
            return 1;
        }

        for(auto u : g[v])
        {
            if(u == p) continue;
            int res = calc_path(u, v, b);
            if(res)
            {
                curpath.pb(v);
                return 1;
            }
        }
        return 0;
    };

    int q;
    cin >> q;
    vec<vec<int>> gr (n);

    while(q--)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        d--;
        c--;

        vec<int> path1, path2;

        {
            calc_path(a, -1, b);
            reverse(all(curpath));
            path1 = curpath;
            curpath.clear();
        }

        {
            calc_path(c, -1, d);
            reverse(all(curpath));
            path2 = curpath;
            curpath.clear();
        }
        assert(sz(path1) == sz(path2));

        FOR(i, sz(path1))
        {
            int v = path1[i];
            int u = path2[i];
            gr[v].pb(u);
            gr[u].pb(v);
        }

        vec<int> used (n);
        int ans = 1;
        int curl = 0, curr = mod;

        function<void(int)> calc_segs = [&](int v)
        {
            used[v] = 1;
            curl = max(curl, segs[v].f);
            curr = min(curr, segs[v].s);

            for(auto u : gr[v])
                if(!used[u])
                    calc_segs(u);
        };

        FOR(v, n)
        {
            if(!used[v])
            {
                curr = mod;
                curl = 0;
                calc_segs(v);
                int d = curr - curl + 1;
               // cout << v << ' ' << d << endl;
                if(d <= 0)
                    ans *= 0;
                else
                {
                    ans *= d;
                    ans %= mod;
                }
            }
        }

        cout << ans << endl;
    }


}

signed main() {
    int q = 1;
    //cin >> q;

    while(q--)
    {
        solve();
    }
}

