#include <iostream>
#include <cmath>
#include <iomanip>
#include <queue>
#include <vector>
#include <set>
#include <algorithm>
#define ll long long
using namespace std;
void FAST() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
vector <ll> p(0);
ll mod = 1e9 + 7;
ll binpow(ll a, ll b) {
    if (b == 0)
        return 1;
    ll q = binpow(a, b / 2);
    ll tq = q * q % mod;
    if (b % 2 == 0)
        return tq;
    else
        return (tq * a) % mod;
}
void solve() {
    ll n;
    cin >> n;
    vector <vector <ll>> g(n);
    vector <ll> par(n);
    par[0] = -1;
    for (ll i = 1; i < n; ++i) {
        ll q;
        cin >> q;
        par[i] = q - 1;
        g[q - 1].push_back(i);
    }
    vector <ll> h(n , -1);
    queue <ll> q;
    q.push(0);
    h[0] = 0;
    while (!q.empty()) {
        auto now = q.front();
        q.pop();
        for (auto i : g[now]) {
            h[i] = h[now] + 1;
            q.push(i);
        }
    }
    ll ans = 1;
    vector < pair<ll, ll>> a(n);
    vector <ll> mn(n);
    vector <ll> he(n, 0);
    for (ll i = 0; i < n; ++i) {
        ll q1, q2;
        mn[i] = i;
        cin >> q1 >> q2;
        a[i] = { q1, q2 };
        ans *= q2 - q1 + 1;
    }
    ll t; cin >> t;
    while (t--) {
        ll s1, s2, f1, f2;
        cin >> s1 >> f1 >> s2 >> f2;
        s1--; s2--; f1--; f2--;
        vector <ll> r1(0), r2(0), t1, t2, y1, y2;
        ll now1 = s1, now2 = f1;
        while (now1 != now2) {
            if (h[now1] >= h[now2]) {
                t1.push_back(now1);
                now1 = par[now1];
            }
            else {
                t2.push_back(now2);
                now2 = par[now2];
            }
        }
        t1.push_back(now1);
        reverse(t2.begin(), t2.end());
        for (auto i : t1)
            r1.push_back(i);
        for (auto i : t2)
            r1.push_back(i);
        now1 = s2, now2 = f2;
        while (now1 != now2) {
            if (h[now1] >= h[now2]) {
                y1.push_back(now1);
                now1 = par[now1];
            }
            else {
                y2.push_back(now2);
                now2 = par[now2];
            }
        }
        y1.push_back(now1);
        reverse(y2.begin(), y2.end());
        for (auto i : y1)
            r2.push_back(i);
        for (auto i : y2)
            r2.push_back(i);
        for (ll i = 0; i < r1.size(); ++i) {
            ll e1 = r1[i], e2 = r2[i];
            while (mn[e1] != e1)
                e1 = mn[e1];
            while (mn[e2] != e2)
                e2 = mn[e2];
            if (e1 != e2) {
                ll ns = max(a[e1].first, a[e2].first), nf = min(a[e1].second, a[e2].second);
                ans *= binpow(a[e1].second - a[e1].first + 1, mod - 2);
                ans %= mod;
                ans *= binpow(a[e2].second - a[e2].first + 1, mod - 2);
                ans %= mod;
                ans *= max(0ll, nf - ns + 1);
                ans %= mod;
                if (he[e2] > he[e1]) {
                    mn[e1] = e2;
                    a[e2] = { ns, nf };
                }
                else {
                    mn[e2] = e1;
                    a[e1] = { ns, nf };
                    he[e1] = max(he[e1], he[e2] + 1);
                }
            }
        }
        cout << ans << '\n';
    }
}
int main()
{
    FAST();
    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}
