#include <bits/stdc++.h>

using namespace std;

#define pii pair<int,int>
typedef long double ld;
//#define int int64_t

mt19937 gen(chrono::system_clock().now().time_since_epoch().count());

const int N = 2e5+10, K = 30, M = 1e9+7;

int mul (int a, int b) {
    return (a * 1ll * b) % M;
}

int bp (int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b&1) {
        return mul(a, bp(a, b-1));
    }
    else {
        int x = bp(a, b/2);
        return mul(x, x);
    }
}

int n;
vector <int> g[N];
int p[N], l[N], r[N];
int o[N];
int d[N];

void dfs (int v, int p) {
    d[v] = d[p] + 1;
    for (int i:g[v]) {
        if (i != p)
            dfs(i, v);
    }
}

struct dsu {
    int p[N];
    int ml[N], mr[N];
    int ans;
    void build () {
        ans = 1;
        for (int i=0;i<n;++i) {
            p[i] = i;
            ml[i] = l[i];
            mr[i] = r[i];
            ans = mul(ans, r[i] - l[i] + 1);
        }
    }

    int get (int v) {
        if (p[v] == v) {
            return v;
        }
        else {
            return p[v] = get(p[v]);
        }
    }

    void un (int v, int u) {
        v = get(v);
        u = get(u);
        if (u == v) {
            return;
        }
        if (gen()&1) {
            swap(u, v);
        }
        ans = mul(ans, o[mr[v] - ml[v] + 1]);
        ans = mul(ans, o[mr[u] - ml[u] + 1]);
        ml[v] = max(ml[v], ml[u]);
        mr[v] = min(mr[v], mr[u]);
        mr[v] = max(mr[v], ml[v]-1);
        ans = mul(ans, mr[v] - ml[v] + 1);
        p[u] = v;
    }
};

dsu D;

void solve (int a, int b, int c, int _d) {
    vector <int> v1, v2, v;
    vector <int> u1, u2, u;
    while (a != b) {
        while (d[a] > d[b]) {
            v1.push_back(a);
            a = p[a];
        }
        while (d[b] > d[a]) {
            v2.push_back(b);
            b = p[b];
        }
        if (a != b) {
            v1.push_back(a);
            v2.push_back(b);
            a = p[a];
            b = p[b];
        }
    }
    for (int i:v1) {
        v.push_back(i);
    }
    v.push_back(a);
    reverse(v2.begin(), v2.end());
    for (int i:v2) {
        v.push_back(i);
    }
    while (c != _d) {
        while (d[c] > d[_d]) {
            u1.push_back(c);
            c = p[c];
        }
        while (d[_d] > d[c]) {
            u2.push_back(_d);
            _d = p[_d];
        }
        if (c != _d) {
            u1.push_back(c);
            u2.push_back(_d);
            c = p[c];
            _d = p[_d];
        }
    }
//    cerr << a << ' ' << b << ' ' << c << ' ' << _d << endl;
    for (int i:u1) {
        u.push_back(i);
    }
    u.push_back(c);
    reverse(u2.begin(), u2.end());
    for (int i:u2) {
        u.push_back(i);
    }
    cerr << "!\n";
    for (int i=0;i<v.size();++i) {
        D.un(v[i], u[i]);
        cerr << v[i] << ' ' << u[i] << endl;
    }
    cerr << endl;
}

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    for (int i=0;i<N;++i) {
        o[i] = bp(i, M-2);
    }
    cin >> n;
    for (int i=1;i<n;++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    dfs(0, 0);
    for (int i=0;i<n;++i) {
        cin >> l[i] >> r[i];
    }
    D.build();
    int q;
    cin >> q;
    for (int it=0;it<q;++it) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;b--;c--;d--;
        solve(a, b, c, d);
        cout << D.ans << '\n';
    }
    return 0;
}
