#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

struct point{
    int x;
    int y;
};

int cp (point p1, point p2){
    return p1.x*p2.y - p1.y*p2.x;
}

point operator - (point& p1, point& p2){
    return {p1.x - p2.x, p1.y - p2.y};
}

/*
int n;
vector <ll> a;

struct node {
    ll mn;
    ll mx;
    ll sum;
};

struct segtree {
    int size = 1;
    vector <node> tree;

    int init (int n) {
        while (size<n) size*=2;
        tree.assign(2*size - 1, {(ll)1e9, (ll)-1e9, 0});
        return size;
    }

    void build (int x, int lx, int rx){
        if (rx-lx==1){
            if (lx<n) tree[x] = {a[lx], a[lx], a[lx]};
            return;
        }
        int m = (lx+rx)/2;
        build (2*x+1, lx, m);
        build (2*x+2, m, rx);

        node n1 = tree[2*x+1];
        node n2 = tree[2*x+2];

        tree[x] = {min(n1.mn, n2.mn), max(n1.mx, n2.mx), n1.sum+n2.sum};
    }

    node get (int x, int lx, int rx, int l, int r){
        if (r<=lx or l>=rx) return {(ll)1e9, (ll)-1e9, 0};
        if (l<=lx and r>=rx) return tree[x];

        int m = (lx+rx)/2;

        node n1 = get(2*x+1, lx, m, l, r);
        node n2 = get(2*x+2, m, rx, l, r);

        return {min(n1.mn, n2.mn), max(n1.mx, n2.mx), n1.sum+n2.sum};
    }

};
*/
int n;
vector <vector <int>> a;

vector <int> p;
vector <pair<ll ,ll>> cost;

int get(int x){
    if (p[x]!=x) p[x] = get(p[x]);
    return p[x];
}

void un(int x, int y){
    if (get(x)==get(y)) return;
    cost[get(y)].first = max(cost[get(y)].first, cost[get(x)].first);
    cost[get(y)].second = min(cost[get(y)].second, cost[get(x)].second);
    p[x] = get(y);
}
vector <int> vis;
vector <int> pred;
vector <int> vis1;
vector <int> pred1;
int t = 1;

void bfs(int v, int u, int v1, int u1){
    t++;
    queue <int> q;
    q.push(v);
    pred[v] = v;
    bool f1 = false;
    bool f2 = false;
    while (!q.empty()){
        int x = q.front();
        q.pop();
        for (auto to : a[x]){
            if (vis[to]!=t) {
                vis[to] = t;
                pred[to] = x;
                if (to==u) {
                    f1 = true;
                    break;
                }
                q.push(to);
            }
        }
        if (f1) break;
    }

    t++;
    queue <int> q1;
    q1.push(v1);
    pred1[v] = v1;
    while (!q1.empty()){
        int x = q1.front();
        q1.pop();
        for (auto to : a[x]){
            if (vis1[to]!=t) {
                vis1[to] = t;
                pred1[to] = x;
                if (to==u1) {
                    f2 = true;
                    break;
                }
                q1.push(to);
            }
        }
        if (f2) break;
    }
    while (u!=v){
        un(u, u1);
        u = pred[u];
        u1 = pred1[u1];
    }
    un(v, v1);
}

ll mod = 1e9+7;

int main() {
    cin.tie(0); cout.tie(0); ios::sync_with_stdio(0);
    cin >> n;
    a.resize(n);
    p.resize(n);
    cost.resize(n);
    vis.resize(n);
    vis1.resize(n);
    pred.resize(n);
    pred1.resize(n);
    for (int i = 0; i<n; i++) p[i] = i;
    for (int i=0; i<n-1; i++) {
        int x;
        cin >> x;
        x--;
        a[i+1].push_back(x);
        a[x].push_back(i+1);
    }
    for (int i = 0; i<n; i++) cin >> cost[i].first >> cost[i].second;
    int m;
    cin >> m;
    bool f = false;
    while (m--) {
        int v, u, v1, u1;
        cin >> v >> u >> v1 >> u1;
        v--; u--; v1--; u1--;
        if (f) {
            cout << "0\n";
            continue;
        }
        bfs(v, u, v1, u1);
        t++;
        ll ans = 1;
        for (int i = 0; i < n; i++) {
            if (vis[get(i)] != t) {
                vis[get(i)] = t;
                if (cost[get(i)].second < cost[get(i)].first) {
                    ans = 0;
                    f = true;
                    break;
                }
                ans *= (cost[get(i)].second - cost[get(i)].first + 1);
                ans %= mod;
            }
        }
        cout << ans << "\n";
    }
}