#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;


#define int ll
#define ff first
#define ss second
#define pb push_back
#define sz(x) long(x.size())
#define rs resize
#define all(x) x.begin(), x.end()
#define fastio() cin.tie(0)->sync_with_stdio(0)
#define qmx(a, b) a = max(a, b)
#define qmn(a, b) a = min(a, b)
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF32 = 2e9 + 5;
const ll INF64 = 2e18 + 5;
const int MOD = 1e9 + 7;
const int MX = 2e5 + 7;
const int ABOBA = 333;


bool flagg = false;
int n, curt = 0, up[MX][21], tin[MX], tout[MX], l[MX], r[MX], h[MX], p[MX], rk[MX], used[MX];
pair<pii, pii> sv[MX];
vector<int> g[MX];


pii intersect(pii a, pii b) {
    if (a.ss < b.ff) return {-INF32, 0};
    if (a.ff > b.ss) return {-INF32, 0};
    if (a.ff <= b.ff && b.ss <= a.ss) return b;
    if (b.ff <= a.ff && a.ss <= b.ss) return a;
    if (a.ff <= b.ff) return {b.ff, a.ss};
    return {a.ff, b.ss};
}


int findRoot(int v) {
    if (v == p[v]) return v;
    return p[v] = findRoot(p[v]);
}


void unite(int v, int u) {
    int a = findRoot(v);
    int b = findRoot(u);
    if (a == b) return;
    auto pp = intersect({l[a], r[a]}, {l[b], r[b]});
    l[a] = pp.ff;
    r[a] = pp.ss;
    l[b] = pp.ff;
    r[b] = pp.ss;
    if (pp.ff == -INF32) flagg = true;
    if (rk[a] == rk[b]) rk[a]++;
    if (rk[a] > rk[b]) p[a] = b;
    else p[a] = b;
}


void dfs(int v, int pr = 0, int curh = 0) {
    tin[v] = curt++;
    h[v] = curh;
    up[v][0] = pr;
    for (int k = 1; k <= 20; k++) up[v][k] = up[up[v][k - 1]][k - 1];
    for (int u : g[v]) {
        if (u == pr) continue;
        dfs(u, v, curh + 1);
    }
    tout[v] = curt++;
}


bool isPar(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}


int lca(int v, int u) {
    if (isPar(v, u)) return v;
    if (isPar(u, v)) return u;
    for (int k = 20; k >= 0; k--) {
        if (!isPar(up[v][k], u)) v = up[v][k];
    }
    return up[v][0];
}


int getD(int v, int u) {
    int lc = lca(v, u);
    return h[v] + h[u] - 2 * h[lc];
}


void getPath(int v, int u, vector<int> &path) {
    int lc = lca(v, u);
    while (v != lc) {
        path.pb(v);
        v = up[v][0];
    }
    vector<int> tt;
    while (u != lc) {
        tt.pb(u);
        u = up[u][0];
    }
    path.pb(lc);
    reverse(all(tt));
    for (int el : tt) path.pb(el);
}


void solve() {
    //solve here
    tout[0] = INF32;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        r[i] = 1;
        p[i] = i;
    }
    for (int v = 2; v <= n; v++) {
        int pr;
        cin >> pr;
        g[v].pb(pr);
        g[pr].pb(v);
    }
    for (int v = 1; v <= n; v++) {
        cin >> l[v] >> r[v];
    }
    dfs(1);
    int q;
    cin >> q;
    int lens = 0;
    for (int e = 0; e < q; e++) {
        cin >> sv[e].ff.ff >> sv[e].ff.ss >> sv[e].ss.ff >> sv[e].ss.ss;
        int v = sv[e].ff.ff, u = sv[e].ff.ss;
        lens += getD(v, u) * 2;
    }
    for (int e = 0; e < q; e++) {
        int a = sv[e].ff.ff;
        int b = sv[e].ff.ss;
        int c = sv[e].ss.ff;
        int d = sv[e].ss.ss;
        if (flagg) {
            cout << "0\n";
            continue;
        }
        ll res = 1;
        vector<int> path1, path2;
        getPath(a, b, path1);
        getPath(c, d, path2);
        for (int i = 0; i < sz(path1); i++) {
            if (flagg) break;
            unite(path1[i], path2[i]);
        }
        if (flagg) {
            cout << "0\n";
            continue;
        }
        fill(used + 1, used + n + 1, 0);
        for (int v = 1; v <= n; v++) {
            int root = findRoot(v);
            if (!used[root]) {
                used[root]++;
                res *= (r[root] - l[root] + 1);
                res %= MOD;
            }
        }
        cout << res << "\n";
    }
}


int32_t main() {
    fastio();
    int tests = 1;
    //cin >> tests;
    while (tests--) solve();
    return 0;
}
/*
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5

8
1 2 3 4 5 8 6
3 7
2 6
3 8
5 10
5 8
2 9
3 8
6 8
4
1 3 7 6
4 1 5 7
1 7 7 1
1 8 2 7
*/