﻿#include <iomanip>
#include <iostream>
#include <vector>

using namespace std;

const int maxn = 1e5 + 5;

int par[maxn], val[maxn];

pair<int, int> rng[maxn];

signed main() {
	int n, m;
	cin >> n;
	for (int i = 2; i <= n; ++i) {
		int x;
		cin >> x;
		par[i] = x;
	}
	for (int i = 1; i <= n; ++i) {
		int l, r;
		cin >> l >> r;
		val[i] = r - l + 1;
		rng[i] = { l, r };
	}
	cin >> m;
	while (m--) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		if (a > b)
			swap(a, b);
		if (c > d)
			swap(c, d);
		int i = a, j = c;
		while (i <= b) {
			int l1 = rng[i].first, r1 = rng[i].second, l2 = rng[j].first, r2 = rng[j].second;
			int nl = max(l1, l2), nr = min(r1, r2);
			rng[i] = rng[j] = { nl, nr };
			val[i] = val[j] = min(max(0, nr - nl + 1), 1);
			++i, ++j;
		}
		i = b, j = d;
		while (i >= a) {
			int l1 = rng[i].first, r1 = rng[i].second, l2 = rng[j].first, r2 = rng[j].second;
			int nl = max(l1, l2), nr = min(r1, r2);
			rng[i] = rng[j] = { nl, nr };
			val[i] = val[j] = min(max(0, nr - nl + 1), 1);
			--i, --j;
		}
		int res = 1;
		for (int i = 1; i <= n; ++i)
			res *= max(0, val[i]);
		cout << res << '\n';
	}
}