#include <bits/stdc++.h>
//#include <ext/pd_ds/assoc_container.hpp>
//#include <ext/pd_ds/tree_policy.hpp>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size();
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef int64_t ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
ostream& operator << (ostream& out, pair<T, T1> &pr) {
    out << pr.first << " " << pr.second;
    return out;
}

template<typename T, typename T1>
istream& operator >> (istream& in, pair<T, T1> &pr) {
    in >> pr.first >> pr.second;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &arr) {
    for (auto &i : arr) {out << i << " ";}
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &arr) {
    for (auto &i : arr) {in >> i;}
    return in;
}

const int mod = 1e9 + 7;
const int maxn = 2e5;
//typedef tree<int, null_type, less<int>,
//        rb_tree_tag, tree_order_statistics_node> ordered_set;

int binpow(int a, int b) {
    if (b == 0) return 1;

    if (b % 2 == 0) {
        int t = binpow(a, b / 2);
        return t * t % mod;
    } else {
        return binpow(a, b - 1) *  a % mod;
    }
}

int ans = 1;
int p[maxn], rang[maxn], l[maxn], r[maxn];

int get(int a) {
    if (p[a] == a) return a;

    p[a] = get(p[a]);
    return p[a];
}

void unite(int a, int b) {
    a = get(a);
    b = get(b);

    if (a != b) {
        if (rang[a] > rang[b]) swap(a, b);

        p[a] = b;
        rang[b] += rang[a];

        ans *= binpow(max(0LL, r[a] - l[a] + 1), mod - 2); ans %= mod;
        ans *= binpow(max(0LL, r[b] - l[b] + 1), mod - 2); ans %= mod;

        l[b] = max(l[a], l[b]);
        r[b] = min(r[a], r[b]);

        ans *= max(0LL, r[b] - l[b] + 1); ans %= mod;
    }
}

vector<vector<int>> g;
vector<int> pt;

int dfs(int v, int pr, int fn) {
    if (v == fn) {
        pt.pb(fn);
        return 1;
    }
    for (auto i : g[v]) {
        if (i != pr) {
            int a = dfs(i, v, fn);
            if (a == 1) {
                pt.pb(v);
                return 1;
            }
        }
    }
    return 0;
}

int dfs1(int v, int pr, int fn) {
    if (v == fn) {
        unite(v, pt.back());
        pt.pop_back();
        return 1;
    }
    for (auto i : g[v]) {
        if (i != pr) {
            int a = dfs1(i, v, fn);
            if (a == 1) {
                unite(v, pt.back());
                pt.pop_back();
                return 1;
            }
        }
    }
    return 0;
}

void solve() {
    int n; cin >> n;

    g.rs(n);
    for (int i = 1; i <= n - 1; i++) {
        int a; cin >> a; a--;
        g[a].pb(i);
        g[i].pb(a);
    }

    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        ans *= (r[i] - l[i] + 1);
        ans %= mod;

        p[i] = i; rang[i] = 1;
    }

    int m; cin >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c, d; cin >> a >> b >> c >> d;
        a--; b--; c--; d--;

        dfs(a, -1, b);
        reverse(all(pt));
        dfs1(c, -1, d);

        cout << ans << "\n";
    }
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double start_time = clock();
#endif
    int test = 1;
    //cin >> test;

    while (test--) {
        solve();
#ifdef LOCAL
        cout << "--------------\n";
#endif
    }
#ifdef LOCAL
    cout << "execution time: " << (clock() - start_time) / CLOCKS_PER_SEC;
#endif
}
