#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

#define fi first
#define se second
#define pb push_back
#define ld long double
#define pii pair <int, int>
#define endl '\n'
#define int int64_t
#define pw(x) (int64_t(1) << x)

using namespace std;
const int mod = 1e9 + 7;
mt19937 gen(time(0));
const int N = 2e5 + 50;
vector <int> g[N];
vector <int> gr[N];

vector <int> go (int a, int b, int n) {
    vector <bool> used(n);
    vector <int> pr(n, -1);
    used[a] = 1;
    queue <int> q;
    q.push(a);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for(auto to : g[v]) {
            if(!used[to]) {
                used[to] = 1;
                pr[to] = v;
                q.push(to);
            }
        }
    }
    vector <int> ans;
    ans.pb(b);
    while (pr[b] != -1) {
        ans.pb(pr[b]);
        b = pr[b];
    }
    return ans;
}

bool u[N];
void dfs (int v) {
    u[v] = 1;
    for(auto to : gr[v]) {
        if(!u[to]) {
            dfs(to);
        }
    }
}

vector <int> all;
void take (int v) {
    all.pb(v);
    u[v] = 1;
    for(auto to : gr[v]) {
        if(!u[to]) {
            take(to);
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    for(int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        g[p].pb(i);
        g[i].pb(p);
    }
    int l[n], r[n];
    for(int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    auto f = [&] (int l1, int r1, int l2, int r2) {
        if(l1 > l2) {
            swap(l1, l2);
            swap(r1, r2);
        }
        if(l1 == l2 && r1 > r2) {
            swap(r1, r2);
        }
        if(r1 < l2) {
            pii ans = {-1, -2};
            return ans;
        }
        if(l2 >= l1 && r2 <= r1) {
            pii ans = {l2, r2};
            return ans;
        }
        if(l1 >= l2 && r1 <= r2) {
            pii ans = {l1, r1};
            return ans;
        }
        pii ans = {l2, r1};
        return ans;
    };
    int q;
    cin >> q;
    while (q --) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        vector <int> p1 = go(a, b, n);
        vector <int> p2 = go(c, d, n);
//        for(auto to : p1) cerr << to << ' ';
//        cerr << endl;
        //        for(auto to : p2) cerr << to << ' ';
//        cerr << endl << endl;
//        cerr << p1.size() << ' ' << p2.size() << endl;
        int ans = 1;
        set <pii> used;
        for(int i = 0; i < p1.size(); ++i) {
            all.clear();
            fill(u, u + n, 0);
            gr[p1[i]].pb(p2[i]);
            gr[p2[i]].pb(p1[i]);
            take(p1[i]);
            take(p2[i]);
            pii p = {l[p1[i]], r[p1[i]]};
            for(auto to : all) {
                p = f(l[to], r[to], p.fi, p.se);
            }
            for(auto to : all) {
                l[to] = p.fi;
                r[to] = p.se;
            }
        }
//        for(int i = 0; i < n; ++i) {
//            cerr << l[i] << ' ' << r[i] << endl;
//        }
//        cerr << endl << endl;
//        cerr << endl;
        fill(u, u + n, 0);
        for(int i = 0; i < n; ++i) {
            if(!u[i]) {
                ans *= (r[i] - l[i] + 1);
                ans %= mod;
                dfs(i);
            }
        }
        cout << ans << endl;
    }
    return 0;
}
