#include <bits/stdc++.h>

#include <list>
#include <numeric>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long double ld;
typedef long long ll;
#define pb push_back
//typedef ordered_set<int> = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

vector<vector<int>> to(100000);
vector<int> par(100000);
vector<int> pard(100000);
vector<int> sz(100000);
vector<int> l(100000);
vector<int> r(100000);
vector<int> h(100000);
vector<int> real_(100000);
vector<bool> used(100000);
int n, m, c,a,b,d;

void dfs(int v, int p) {
    for (int u : to[v]) {
        if (u != p) {
            h[u] = h[v]+1;
            par[u] = v;
            dfs(u, v);
        }
    }
}

int find_(int v) {
    if (pard[v] == v) {
        return v;
    }
    return pard[v] = find_(pard[v]);
}

void unite(int v, int u) {
    u = find_(u);
    v = find_(v);
    if (u == v) {
        return;
    }
    if (sz[u] > sz[v]) {
        pard[v] = u;
    }
    else{
        pard[u] = v;
        if (sz[u] == sz[v]) {
            sz[u]++;
        }
    }
}

void set_(int a, int b, int c, int d) {
    vector<int> va;
    vector<int> var;
    while (h[a] > h[b]) {
        va.pb(a);
        a=par[a];
    }
    while (h[b] > h[a]) {
        var.pb(b);
        b=par[b];
    }
    while (a != b) {
        va.pb(a);
        a=par[a];
        var.pb(b);
        b=par[b];
    }
    va.push_back(a);
    reverse(var.begin(), var.end());
    for (auto i : var) {
        va.pb(i);
    }
    vector<int> vc;
    vector<int> vcr;
    while (h[c] > h[d]) {
        vc.pb(c);
        c=par[c];
    }
    while (h[d] > h[c]) {
        vcr.pb(d);
        d=par[d];
    }
    while (c != d) {
        vc.pb(c);
        c=par[c];
        vcr.pb(d);
        d=par[d];
    }
    vc.push_back(c);
    reverse(vcr.begin(), vcr.end());
    for (auto i : vcr) {
        vc.pb(i);
    }
    for (int i  = 0; i < va.size(); i++) {
        l[find_(va[i])] = l[find_(vc[i])] = max(l[find_(va[i])], l[find_(vc[i])]);
        r[find_(va[i])] = r[find_(vc[i])] = min(r[find_(va[i])], r[find_(vc[i])]);
        unite(va[i], vc[i]);
    }
}
const ll mod = 1e9+7;
void solve() {
    cin >> n;
    for (int i = 0; i <n-1; i++) {
        cin >> c;
        c--;
        par[i+1] = c;
        to[c].pb(i+1);
    }
    dfs(0, -1);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    cin >> m;
    iota(real_.begin(), real_.end(), 0);
    iota(pard.begin(), pard.end(), 0);
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        //a=real_[a];
        //b=real_[b];
        //c=real_[c];
        //d=real_[d];
        set_(a, b, c, d);
        ll ans = 1;
        set<int> se;
        for (int j = 0; j < n; j++) {
            if (se.find(find_(j)) == se.end()) {
                se.insert(find_(j));
                ans = ans * max(0, r[find_(j)] - l[find_(j)] + 1) % mod;
            }
        }
        cout << ans << '\n';
    }
}


signed main() {
#ifdef LOCAL
    auto f = freopen("C:\\clion\\input.txt", "r", stdin);
    auto f1 = freopen("C:\\clion\\output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
