#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 3001;
const long long mod = 1e9 + 7;
long long n, p[maxn], l[maxn], r[maxn], m, a[maxn], b[maxn], c[maxn], d[maxn];
long long pl[maxn], pr[maxn], used2[maxn][maxn];
vector<int> v[maxn];

void read(){
    cin >> n;
    for(int i = 2;i <= n;i++){
        cin >> p[i];
        v[p[i]].push_back(i);
        v[i].push_back(p[i]);
    }
    for(int i = 1;i <= n;i++){
        cin >> l[i] >> r[i];
        pl[i] = l[i], pr[i] = r[i];
    }
    cin >> m;
}

vector<int> path1, path2;
int used[maxn];

void dfs(int ver, int fin, vector<int> path, int idx){
    if(ver == fin){
        if(idx == 1)
            path1 = path;
        else
            path2 = path;
        return;
    }
    used[ver] = 1;
    for(int x : v[ver]){
        if(!used[x]){
            path.push_back(x);
            dfs(x, fin, path, idx);
            path.pop_back();
        }
    }
}

void query(int a, int b, int c, int d){
    memset(used, 0, sizeof(used));
    dfs(a, b, {a}, 1);
    memset(used, 0, sizeof(used));
    dfs(c, d, {c}, 2);
    memset(used, 0, sizeof(used));
    long long ans = 1;
    for(int i = 0;i < path1.size();i++){
        int x1 = path1[i], x2 = path2[i];
        if(pl[x1] > pr[x1] || pl[x2] > pr[x2]){
            ans = 0;
            continue;
        }
        if(pl[x1] <= pl[x2])
            pl[x1] = pl[x2];
        else
            pl[x2] = pl[x1];
        if(pr[x1] <= pr[x2])
            pr[x2] = pr[x1];
        else
            pr[x1] = pr[x2];
        if(pl[x1] > pr[x1] || pl[x2] > pr[x2]){
            ans = 0;
            continue;
        }
        if(!used2[x1][x2]){
            ans *= (pr[x1] - pl[x1] + 1);
            used[x1] = 1;
            used[x2] = 1;
            used2[x1][x2] = used2[x2][x1] = 1;
        }
        ans %= mod;
    }
    for(int i = 0;i < path1.size();i++)
        used2[path1[i]][path2[i]] = used2[path2[i]][path1[i]] = 0;
    for(int i = 1;i <= n;i++){
        if(!used[i]){
            if(pl[i] > pr[i]) ans = 0;
            else ans *= (pr[i] - pl[i] + 1);
            ans %= mod;
        }
    }
    cout << ans << endl;
}

void solve(){
    for(int i = 1;i <= m;i++){
        cin >> a[i] >> b[i] >> c[i] >> d[i];
        query(a[i], b[i], c[i], d[i]);
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
