#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n;
vector <vector <int>> g;
vector <int> l;
vector <int> r;
int s = 1e9 + 7;

vector <vector <int>> f;
map <int, vector<int>> mp;
vector <int> pr, t;

void dfs(int v, int last, vector <int> & pred) {
    for (auto u : g[v]) {
        if (u != last) {
            pred[u] = v;
            dfs(u, v, pred);
        }
    }
}

int get(int v) {
    int p = v;
    while (pr[p] != p) {
        p = pr[p];
    }
    return pr[v] = p;
}

bool merge(int x, int y) {
    int a = get(x);
    int b = get(y);
    if (a == b) return false;
    if (t[a] > t[b]) {
        swap(a, b);
    }
    pr[a] = b;
    t[b] += t[a];
    return true;
}

//pair <int, int> dfs1(int v, vector <int> & used) {
//    used[v] = 1;
//    int l1 = l[v], r1 = r[v];
//    for (auto u : f[v]) {
//        if (!used[u]) {
//            auto e = dfs1(u, used);
//            l1 = max(l1, e.first);
//            r1 = min(r1, e.second);
//        }
//    }
//    return {l1, r1};
//}


ll get_ans(int a, int b, int c, int d) {
    vector <int> pred1(n, -1);
    vector <int> pred2(n, -1);
    dfs(a, -1, pred1);
    dfs(c, -1, pred2);
    vector <int> path1;
    vector <int> path2;
    int p = b;
    while (p != -1) {
        path1.push_back(p);
        p = pred1[p];
    }
    p = d;
    while (p != -1) {
        path2.push_back(p);
        p = pred2[p];
    }
    for (int i = 0; i < path1.size(); ++i) {
        merge(path1[i], path2[i]);
    }
    vector <int> l1 = l;
    vector <int> r1 = r;
    for (int i = 0; i < n; ++i) {
        l1[get(i)] = max(l1[get(i)], l[i]);
        r1[get(i)] = min(r1[get(i)], r[i]);
    }
    ll ans = 1;
    for (int i = 0; i < n; ++i) {
        if (get(i) == i) {
            ans *= 1ll * max(0, r1[i] - l1[i] + 1);
            ans %= s;
        }
    }
    return ans;
}

ll get_ans1(int a, int b, int c, int d) {
    for (int i = 0; i < b - a + 1; ++i) {
        merge(a + i, c + i);
    }
    vector <int> l1 = l;
    vector <int> r1 = r;
    for (int i = 0; i < n; ++i) {
        l1[get(i)] = max(l1[get(i)], l[i]);
        r1[get(i)] = min(r1[get(i)], r[i]);
    }
    ll ans = 1;
    for (int i = 0; i < n; ++i) {
        if (get(i) == i) {
            ans *= 1ll * max(0, r1[i] - l1[i] + 1);
            ans %= s;
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    vector <int> p(n);
    g.resize(n);
    l.resize(n);
    r.resize(n);
    f.resize(n);
    pr.resize(n);
    t.resize(n, 1);
    for (int i = 0; i < n; ++i) {
        pr[i] = i;
    }
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
        g[i].push_back(p[i]);
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (n <= 3000 && m <= 3000) {
            cout << get_ans(a - 1, b - 1, c - 1, d - 1) << "\n";
        } else {
            cout << get_ans1(a - 1, b - 1, c - 1, d - 1) << "\n";
        }
        
    }
    return 0;
}
