#include "bits/stdc++.h"
#include<ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<ll> d1;
typedef vector<d1> d2;
typedef pair<ll, ll> pii;
typedef vector<pii> d1p;
typedef vector<d1p> d2p;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define stuff ios::sync_with_stdio(0); cin.tie(0);
#define fori(x, n) for(ll i = x; i < n; ++i)
#define forj(x, n) for(ll j = x; j < n; ++j)
#define fork(x, n) for(ll k = x; k < n; ++k)
#define  F first
#define  S second
#define B back()
#define endl "\n"
mt19937 rnd;
#define cur_time chrono::system_clock::now().time_since_epoch().count()
#define pb(a) push_back(a)

d2 g;
bool dfs(ll v, ll d, ll p, d1 &way){
    if(v == d){
        way.pb(v);
        return 1;
    }
    for(ll i:g[v]){
        if(i == p) continue;
        if(dfs(i, d, v, way)){
            way.pb(v);
            return 1;
        }
    }
    return 0;
}

d1p lr;
set<ll> head;

d1 p, s;

ll get(ll v){
    if(p[v] == v) return v;
    return p[v] = get(p[v]);
}

void merge(ll a, ll b){
    a = get(a);
    b = get(b);
    if(a == b) return;
    if(s[a] > s[b]){
        swap(a, b);
    }
    p[a] = b;
    s[b]+=s[a];
    lr[b] = {max(lr[a].F, lr[b].F), min(lr[a].S, lr[b].S)};
    if(head.count(a)) head.erase(a);
}

void solve(ll a, ll b, ll c, ll d){
    d1 way1, way2;
    dfs(a, b, -1, way1);
    dfs(c, d, -1, way2);
    fori(0, way1.size()){
        merge(way1[i], way2[i]);
    }
    ll res = 1;
    for(auto i:head){
        res*=max(0ll, lr[i].S-lr[i].F+1);
        res%=(ll)1e9+7;
    }
    cout << res << endl;
}

int main() {
    stuff;
    ll n;
    cin >> n;
    g.resize(n);
    p = s = d1(n, 1);
    fori(0, n){
        head.insert(i);
        p[i] = i;
    }
    fori(1, n){
        ll x;
        cin >> x;
        x--;
        g[i].pb(x);
        g[x].pb(i);
    }
    lr.resize(n);
    fori(0, n){
        cin >> lr[i].F >> lr[i].S;
    }
    ll m;
    cin >> m;
    while(m--){
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        solve(a, b, c, d);
    }
}
