#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std; using namespace __gnu_pbds;
typedef long long ll; typedef long double ld;
typedef tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
int INF = 1e9; ll ways = 1; ll MOD = 1e9 + 7;
struct line{
    int k, b;
    line() = default;
    line(int k, int b) : k(k), b(b) {};
    int get(int x){
        return k * x + b;
    }
};
int cross(line a, line b){
    if(a.k < b.k) swap(a, b);
    int x = (b.b - a.b) / (a.k - b.k);
    if(a.b > b.b) x--;
    return x;
}
vector<int>dots; vector<line>lines;
void add(line news){
    while(!lines.empty() && lines.back().get(dots.back()) > news.get(dots.back())){
        dots.pop_back(); lines.pop_back();
    }
    if(lines.empty()){
        dots.push_back(-INF);
    }else{
        dots.push_back(cross(news, lines.back()));
    }
    lines.push_back(news);
}
int get(int x){
    auto val = lower_bound(dots.begin(), dots.end(), x) - dots.begin() - 1;
    return lines[val].get(x);
}
vector<int>parents, tin, tout; vector<pair<ll, ll>>mas; vector<vector<int>>way(4); vector<vector<int>>sons;
ll step(int d, ll k){
    if(d == 0) return 1;
    if(d % 2 == 1) return step(d - 1, k) * k % MOD;
    auto val = step(d / 2, k);
    return val * val % MOD;
}
void up(int a, int b, bool take, int ind){
    while(tin[a] > tin[b] || tout[a] < tout[b]){
        way[ind].push_back(a); a = parents[a];
    }
    if(take) way[ind].push_back(a);
}
int timer = 0;
void dfs(int start){
    tin[start] = timer++;
    for(auto val: sons[start]){
        dfs(val);
    }
    tout[start] = timer++;
}
vector<pair<int, pair<ll, ll>>>comp;
vector<int>ranks;
pair<int, pair<int, int>>get_comp(int u){
    if(comp[u].first == u) return comp[u];
    else return comp[u] = get_comp(comp[u].first);
}
void join(int u, int v){
    auto first = get_comp(u); auto second = get_comp(v);
    if(first.first == second.first) return;
    if(ranks[first.first] > ranks[second.first]) swap(first, second);
    auto [l, r] = first.second; auto [l1, r1] = second.second;
    if(ranks[first.first] == ranks[second.first]) ranks[first.first]++;
    comp[first.first] = make_pair(first.first, make_pair(max(l1, l), min(r1, r))); comp[second.first] = comp[first.first];
    ways *= step(MOD - 2, r1 - l1 + 1); ways %= MOD; ways *= step(MOD - 2, r - l + 1); ways %= MOD;
    ways *= max(0LL, comp[first.first].second.second - comp[first.first].second.first + 1);
    ways %= MOD;
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n; cin >> n; parents.resize(n); tin.resize(n); tout.resize(n); sons.resize(n); mas.resize(n);
    for(int i = 0; i < n - 1; i++){
        cin >> parents[i + 1]; parents[i + 1]--; sons[parents[i + 1]].push_back(i + 1);
    }
    for(int i = 0; i < n; i++){
        ll l, r; cin >> l >> r;
        mas[i] = {l, r}; ways *= (r - l + 1); ways %= MOD;
    }
    comp.resize(n); ranks.resize(n);
    for(int i = 0; i < n; i++){
        comp[i] = {i, mas[i]};
    }
    dfs(0); int m; cin >> m;
    for(int i = 0; i < m; i++){
        int a, b, c, d; cin >> a >> b >> c >> d; a--; b--; c--; d--;
        up(a, b, true, 0); up(b, a, false, 1); up(c, d, true, 2); up(d, c, false, 3); int size = way[0].size() + way[1].size();
        if(ways == 0) {cout << 0 << "\n";
            continue;
        }
        int ind = -1; while(++ind < size){
            int first, second;
            if(ind < way[0].size()){
                first = way[0][ind];
            }else first = way[1][size - ind - 1];
            if(ind < way[2].size()){
                second = way[2][ind];
            }else second = way[3][size - ind - 1];
            join(first, second);
        }
        cout << ways << "\n";
        way[0].clear(); way[1].clear(); way[2].clear(); way[3].clear();
    }
}
