#include <iostream>
#include <fstream>
#include <cmath>
#include <map>
#include <vector>
#include <set>
#include <queue>
#include <random>
#include <numeric>
#include <ctime>
#include <bits/stdc++.h>
#pragma GCC optimize(3)
using namespace std;
#define vi vector<int>
#define ll long long
#define  int long long
#define ld long double
#define pi pair<int, int>
const int MOD = 1e9 + 7;
mt19937 MT(179);
int ANS = 1;
int bpow(int num, int k) {
    if(k == 1) return num;
    int t = bpow(num, k / 2);
    t *= t; t %= MOD;
    if(k % 2) {
        t *=num; t %= MOD;
    }
    return t;
}
int TIMER = 0;
vector<vector<int>> g;
vector<int> pr;
vector<int> tin;
vector<int> tout;
vector<int> p;
vector<pair<int, int>> sg;
int getP(int a) {
    if(p[a] == a) return a;
    p[a] = getP(p[a]);
    return p[a];
}
void unite(int a, int b) {
    int p1 = getP(a);
    int p2 = getP(b);
    if(p1 == p2) return;
    int prr = 0;
    if(sg[p1].first <= sg[p1].second) {
        prr = sg[p1].second - sg[p1].first + 1;
    }
    int pr2 = 0;
    if(sg[p2].first <= sg[p2].second) pr2 = sg[p2].second - sg[p2].first + 1;
    sg[p1].first = max(sg[p1].first, sg[p2].first);
    sg[p1].second = min(sg[p1].second, sg[p2].second);
    if(sg[p1].first > sg[p1].second) {
        ANS = 0;
    } else {
        if(prr != 0) {
            ANS = ANS * bpow(prr, MOD - 2);
            ANS %= MOD;
            ANS *= (sg[p1].second - sg[p1].first + 1);
            ANS %= MOD;
        }
        if(pr2 != 0) {
            ANS = ANS * bpow(pr2, MOD - 2);
            ANS %= MOD;
        }
    }
    p[p2] = p1;
}
vector<int> gp(int a, int b) {
    vector<int> ret;
    int cp = a;
    while(tin[cp] > tin[b] || tout[cp] < tout[b]) {
        ret.push_back(cp); cp = pr[cp];
    }
    ret.push_back(cp);
    vector<int> b2;
    int cb = b;
    while(cb != cp) {
        b2.push_back(cb); cb = pr[cb];
    }
    reverse(b2.begin(), b2.end());
    for(auto x : b2) ret.push_back(x);
    return ret;
}
void DFS(int v, int p) {
    tin[v] = TIMER++;
    for(auto x : g[v]) {
        if(x == p) continue;
        DFS(x, v);
    }
    tout[v] = TIMER;
}
void solve() {
    int N = 0; cin >> N;
    pr.assign(N, 0);
    tin.assign(N, 0);
    tout.assign(N, 0);
    g.assign(N, vi());
    for(int i = 0; i < N - 1; ++i) {
        cin >> pr[i + 1];
        pr[i + 1]--;
        g[pr[i + 1]].push_back(i + 1);
    }
    DFS(0, -1);
    p.assign(N, 0); iota(p.begin(), p.end(), 0ll);
    sg.assign(N, pi());
    for(int i = 0; i < N; ++i) {
        int l  =0, r = 0; cin >> l >> r; sg[i] = {l, r};
        ANS = ANS * (r - l + 1); ANS %= MOD;
    }
    int M = 0; cin >> M;
    for(int ind = 0; ind < M; ++ind) {
        int a = 0, b = 0, c = 0, d = 0; cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        vector<int> v1 = gp(a, b);
        vector<int> v2 = gp(c, d);
        for(int i = 0; i < v2.size(); ++i) {
            unite(v1[i], v2[i]);
        }
        cout << ANS << "\n";
    }
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << setprecision(12);
    int T = 1;
    while(T--) {
        solve();
    }
    return 0;
}
