#include <bits/stdc++.h>

#define F first
#define S second
#define sz size()
#define pb push_back
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

const int mod = 1e9 + 7;
const int N = 200200;
int n, m;
vvi g(N);
int a[N], b[N], c[N], d[N], par[N], _sz[N], can[N], cur_p[N], p[N];
pii diap[N];
int ans = 1;

int bp (int x, int st) {
    if (st == 0) {
        return 1ll;
    }

    int t = bp(x, st / 2);
    t *= t;
    t %= mod;
    if (st & 1) {
        t *= x;
    }
    return t % mod;
}


int inv (int x) {
    return bp(x, mod - 2);
}

pii inters (pii a, pii b) {
    if (a.F > b.S || b.F > a.S) {
        return {0, -1};
    }

    if (a.S < b.S) {
        swap(a, b);
    }

    if (a.S == -1 || b.S == -1) {
        return {0, -1};
    }

    int nr = min(a.S, b.S);
    int nl = max(a.F, b.F);
    return {nl, nr};
}

int get_p3000(int v) {
    if (par[v] == v) {
        return v;
    }
    return (par[v] = get_p3000(par[v]));
}

void _union3000 (int u, int v) {
//    cout << u << " " << v << " - ";
    u = get_p3000(u);
    v = get_p3000(v);
//    cout << u << " " << v << "\n";
    if (u == v) {
        return;
    }

    if (_sz[u] > _sz[v]) {
        swap(u, v);
    }

    ans *= inv(can[u]); ans %= mod;
    ans *= inv(can[v]); ans %= mod;
//    cout << diap[v].first << " " << diap[v].second << " ";
//    cout << diap[u].first << " " << diap[u].second << " - ";
    diap[v] =  inters(diap[v], diap[u]);
//    cout << diap[v].F << " " << diap[v].S << "\n";
    can[v] = diap[v].S - diap[v].F + 1;
    ans *= can[v]; ans %= mod;


    par[u] = v;
    _sz[v] += _sz[u];
}


void dfs3000 (int v, int pr) {
//    cout << v << "\n";
    for (auto i : g[v]) {
        if (i == pr) {
            continue;
        }
        cur_p[i] = v;
        dfs3000 (i, v);
    }
}


void solve3000 () {
    for (int i = 1; i <= m; i++) {

        for (int j = 1; j <= n; j++) {
            cur_p[j] = j;
        }

//        cout << a[i] << " " << b[i] << " dfs:\n";
        dfs3000 (a[i], a[i]);
//        cout << "\n";

        int v = b[i];
        vi vec1;
        vec1.pb(v);
        while (v != a[i]) {
            v = cur_p[v];
            vec1.pb(v);
        }
        reverse(all(vec1));

        for (int j = 1; j <= n; j++) {
            cur_p[j] = j;
        }
//        cout << c[i] << " " << d[i] << " dfs:\n";
        dfs3000 (c[i], c[i]);
//        cout << "\n";

        v = d[i];
        vi vec2;
        vec2.pb(v);
        while (v != c[i]) {
            v = cur_p[v];
            vec2.pb(v);
        }
        reverse(all(vec2));

//        for (auto i : vec1) {
//            cout << i << " ";
//        }
//        cout << "\n";
//        for (auto i : vec2) {
//            cout << i << " ";
//        }
//        cout << "\n\n";

        for (int i = 0; i < vec1.sz; i++) {
            _union3000 (vec1[i], vec2[i]);
        }

        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].pb(i);
        g[i].pb(p[i]);

    }

    for (int i = 1; i <= n; i++) {
        _sz[i] = 1, par[i] = i;
    }


    for (int i = 1; i <= n; i++) {
        cin >> diap[i].F >> diap[i].S;
        can[i] = diap[i].S - diap[i].F + 1;
        ans *= can[i];
        ans %= mod;
    }

    cin >> m;
    for (int i = 1; i <= m; i++) {
        cin >> a[i] >> b[i] >> c[i] >> d[i];
    }

    if (n <= 3000 && m <= 3000) {
//        cout << "ans - " << ans << "\n";
        solve3000();
        return 0;
    }
}
