#include <bits/stdc++.h>
using namespace std;
#define nt int
#define ector vector
#define it int
#define int long long
#define cnst const
const int maxn = 2e5 + 3;

const int mod = 1e9 + 7;
int pred[maxn];
vector <int> to[maxn];
int tin[maxn], tout[maxn], timer = 0;
void dfs(int v) {
    tin[v] = timer++;

    for (nt i: to[v]) dfs(i);

    tout[v] = timer++;
}
int l[maxn], r[maxn];
int ans = 1;
int bin(int x, int p) {
    if (p == 0) return  1;
    int d = bin(x, p / 2);
    d = (d * d) % mod;
    if (p & 1) d = (d * x) % mod;
    return d;
}
struct dsu{
    vector <nt> p;
    vector <int> sz;
    vector <int> ls, rs;
    dsu(int n) {
        p.resize(n + 1);
        sz.assign(n + 1, 1);
        std::iota(p.begin(), p.end(), 0);
        ls.resize(n + 1);
        rs.resize(n + 1);
    }
    int get(int v) {
        if (p[v] == v) return v;
        return p[v] = get(p[v]);
    }
    void uni(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return;
        if (sz[u] > sz[v]) swap(u, v);
        p[u] = v;
        sz[v] += sz[u];
        ans = (ans * bin(rs[u] - ls[u] + 1, mod - 2)) % mod;
        ans = (ans * bin(rs[v] - ls[v] + 1, mod - 2)) % mod;
        ls[v] = max(ls[v], ls[u]);
        rs[v] = min(rs[v], rs[u]);
        ans = (ans * (max(0ll, rs[v] - ls[v] + 1))) % mod;
    }
};
bool is_anc(int p, int v) {
    return tin[p] <= tin[v] && tout[v] <= tout[p];
}
vector <int> res1, res2;
void write(int u, int v, vector <nt> &x) {
    while (!is_anc(u, v)) {
        x.push_back(u);
        u = pred[u];
    }
    vector <nt> temp;
    x.push_back(u);
    while (v != u) {
        temp.push_back(v);
        v = pred[v];
    }
    std::reverse(temp.begin(), temp.end());
    for (int i: temp) x.push_back(i);
}
signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n; cin >> n;
    for (int i = 2; i <= n; i++) {
        cin >> pred[i];
        to[pred[i]].push_back(i);
    }
    dfs(1);
    dsu ds = dsu(n);
    for (int i = 1; i <= n; i++) {
        cin >> l[i] >> r[i];
        ds.ls[i] = l[i], ds.rs[i] = r[i];
        ans = ans * (r[i] - l[i] + 1);
        ans %= mod;
    }
    nt m; cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        write(a, b, res1);
        write(c, d, res2);
        for (int i = 0; i < res1.size(); i++) {
            ds.uni(res1[i], res2[i]);
        }
        res1.clear(), res2.clear();
        cout << ans << '\n';
        if (m > 0 && ans == 0) {
            for (int i = 0; i < m; i++) cout << 0 << '\n';
            return 0;
        }
    }
    return 0;
}
