#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#define F first
#define S second
#define endl '\n'
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

mt19937_64 rng(time(nullptr));
ll rnd(ll n) {
    uniform_int_distribution <ll> uid;
    return uid(rng) % n;
}

int l[200010], r[200010];
ll ans = 1, dl;
const ll mod = 1e9 + 7;

ll binpow(ll x, int k) {
    if (k == 0)
        return 1;
    ll ret = binpow(x, k / 2);
    ret = ret * ret % mod;
    if (k & 1)
        ret = ret * x % mod;
    return ret;
}

int p[200010];
int get(int x) {
    if (x == p[x])
        return x;
    return p[x] = get(p[x]);
}
void merge(int x, int y) {
    x = get(x), y = get(y);
    if (x == y)
        return;
    dl = dl * ll(r[x] - l[x] + 1) % mod * (r[y] - l[y] + 1) % mod;
    p[x] = y;
    l[y] = max(l[y], l[x]);
    r[y] = min(r[y], r[x]);
    if (l[y] > r[y])
        ans = 0;
    ans = ans * (r[y] - l[y] + 1) % mod;
}

int n;
int pr[200010], h[200010];
vector <int> g[200010];
int tmr = 0;
int tin[200010], tout[200010];

void dfs(int s) {
    tin[s] = tmr;
    tmr++;
    for (auto& e : g[s]) {
        h[e] = h[s] + 1;
        dfs(e);
    }
    tout[s] = tmr;
    tmr++;
}

int v1[200010], v2[200010];
int ind1, ind2;

void f1(int a, int b) {
    ind1 = 0;
    while (!(tin[a] <= tin[b] && tout[a] >= tout[b])) {
        v1[ind1] = a;
        ind1++;
        a = pr[a];
    }
    v1[ind1] = a;
    ind1++;
    vector <int> res;
    while (!(tin[b] <= tin[a] && tout[b] >= tout[a])) {
        res.push_back(b);
        b = pr[b];
    }
    reverse(res.begin(), res.end());
    for (auto& el : res) {
        v1[ind1] = el;
        ind1++;
    }
}

void f2(int a, int b) {
    ind2 = 0;
    while (!(tin[a] <= tin[b] && tout[a] >= tout[b])) {
        v2[ind2] = a;
        ind2++;
        a = pr[a];
    }
    v2[ind2] = a;
    ind2++;
    vector <int> res;
    while (!(tin[b] <= tin[a] && tout[b] >= tout[a])) {
        res.push_back(b);
        b = pr[b];
    }
    reverse(res.begin(), res.end());
    for (auto& el : res) {
        v2[ind2] = el;
        ind2++;
    }
}

void solve() {
    cin >> n;
    for (int i = 1; i < n; i++) {
        cin >> pr[i];
        pr[i]--;
        g[pr[i]].push_back(i);
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        ans = ans * (r[i] - l[i] + 1) % mod;
        p[i] = i;
    }
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        if (ans > 0) {
            f1(a, b);
            f2(c, d);
            dl = 1;
            for (int i = 0; i < ind1; i++)
                merge(v1[i], v2[i]);
            ans = ans * binpow(dl, mod - 2) % mod;
        }
        cout << ans << endl;
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    auto start_time = time(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    auto end_time = time(nullptr);
    cerr << "Ulyanovsk is the best" << endl;
    cerr << "Execution time: " << end_time - start_time << " ms" << endl;
}
