﻿// B.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#ifndef _DEBUG
#pragma optimize("O3")
#endif

#include <bits/stdc++.h>
#include <unordered_set>

using namespace std;
using ll = long long;

struct vertex
{
	ll l, r;
	//unordered_set <size_t> oth;
	vector <bool> is;
};

ll n, m;
vector <vertex> g;
const int MOD = 1e9 + 7;

vector <bool> used;
pair<ll, ll> dfs(int v)
{
	used[v] = true;
	pair <ll, ll> cur = { g[v].l,g[v].r };
	for (size_t i = 0; i < n; i++)
	{
		if (!g[v].is[i] || used[i])
			continue;
		auto ans = dfs(i);
		cur.first = max(cur.first, ans.first);
		cur.second = min(cur.second, ans.second);
	}
	return cur;
}

ll answer()
{
	ll cnt = 1;
	used.assign(n, 0);
	for (size_t i = 0; i < n; i++)
	{
		if (!used[i])
		{
			auto ans = dfs(i);
			if (ans.second < ans.first)
				return 0;
			cnt *= (ans.second - ans.first + 1);
			cnt %= MOD;
		}
	}
	return cnt;
}

vector <size_t>p;

void path(int v, vector <size_t>& tmp)
{
	while (v != -1)
	{
		tmp.push_back(v);
		v = p[v];
	}
}

vector <size_t> path(int v, int u)
{
	if (n <= 300 && m <= 300)
	{
		vector <size_t> p1, p2;
		path(v, p1);
		path(u, p2);
		while (p1.size() > 1 && p2.size() > 1 && p1[p1.size() - 2] == p2[p2.size() - 2])
		{
			p1.pop_back();
			p2.pop_back();
		}
		p2.pop_back();
		p1.insert(p1.end(), p2.rbegin(), p2.rend());
		return p1;
	}
	if (v <= u)
	{
		vector <size_t> p;
		for (size_t t = v; t <= u; t++)
		{
			p.push_back(v);
		}
		return p;
	}
	else
	{
		vector <size_t> p;
		for (size_t t = v; t >= u; t--)
		{
			p.push_back(v);
		}
		return p;
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cin >> n;
	p.resize(n, -1);
	for (size_t i = 1; i < n; i++)
	{
		cin >> p[i];
		p[i]--;
	}
	g.resize(n);
	for (size_t i = 0; i < n; i++)
	{
		cin >> g[i].l >> g[i].r;
		g[i].is.assign(n, 0);
	}
	cin >> m;
	for (size_t i = 0; i < m; i++)
	{
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--; b--; c--; d--;
		auto v1 = path(a, b), v2 = path(c, d);
		/*ll t = v1.size();
		if (v2.size() != t)
			return -1;*/
		ll t = min(v1.size(), v2.size());
		for (size_t i = 0; i < t; i++)
		{
			g[v1[i]].is[v2[i]] = true;
			g[v2[i]].is[v1[i]] = true;
		}
		cout << answer() << '\n';
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
