#include <bits/stdc++.h>
using namespace std;
#define int long long
const int N = 2e5 + 9;
const int MOD = 1e9 + 7;
vector < int > G[N],g[N];
int tin[N],tout[N];
int T = 0;
int l[N],r[N];
vector < int > A,B;
bool marked[N];
void mult(int &a,int b) {
    a *= b;
    a %= MOD;
}
void build(int v) {
    tin[v] = T++;
    for (auto u : G[v]) build(u);
    tout[v] = T;
}
bool gg = 0;
void dfs1(int v,int nd,int p) {
    A.push_back(v);
    if (v==nd) {gg = 1; return;}
    for (auto u : G[v]) if (u!=p) {
        dfs1(u,nd,v);
        if (gg) return;
    }
    A.pop_back();
}
void dfs2(int v,int nd,int p) {
    B.push_back(v);
    if (v==nd) {gg = 1; return;}
    for (auto u : G[v]) if (u!=p) {
        dfs2(u,nd,v);
        if (gg) return;
    }
    B.pop_back();
}
void cnt(int v,int &mn,int &mx) {
    marked[v] = 1;
    mn = max(mn,l[v]);
    mx = min(mx,r[v]);
    for (auto u : g[v]) if (!marked[u]) cnt(u,mn,mx);
}
int sz[N],p[N];
pair < int , int > pa[N];
int get(int x) {
    return (p[x]==x ? x : p[x] = get(p[x]));
}
void unite(int a,int b) {
    a = get(a);
    b = get(b);
    if (a==b) return;
    if (sz[a] < sz[b]) swap(a,b);
    sz[a] += sz[b];
    p[b] = a;
    pa[a].first = max(pa[a].first,pa[b].first);
    pa[a].second = min(pa[a].second,pa[b].second);
}
int32_t main() {
    int n;
    cin >> n;
    for (int i=1;i<n;i++) {
        int p;
        cin >> p;
        p--;
        G[p].push_back(i);
        G[i].push_back(p);
    }
    for (int i=0;i<n;i++) cin >> l[i] >> r[i];
    int m;
    cin >> m;
    int a[m],b[m],c[m],d[m];
    for (int i=0;i<m;i++) cin >> a[i] >> b[i] >> c[i] >> d[i];
    if (n <= 3000 && m <= 3000) {
        for (int i=0;i<n;i++) pa[i] = {l[i],r[i]};
        for (int i=0;i<n;i++) p[i] = i;
        for (int i=0;i<n;i++) sz[i] = 1;
        int ans[m];
        for (int i=0;i<m;i++) {
            a[i]--; b[i]--; c[i]--; d[i]--;
            A.clear(); B.clear();
            gg = 0;dfs1(a[i],b[i],-1);
            gg = 0;dfs2(c[i],d[i],-1);
            for (int j=0;j<A.size();j++) {
                unite(A[j],B[j]);
            }
            ans[i] = 1;
            for (int j=0;j<n;j++) marked[j] = 0;
            for (int j=0;j<n;j++) {
                int x = get(j);
                if (marked[x]) continue;
                marked[x] = 1;
                int mx = pa[x].second;
                int mn = pa[x].first;
                mult(ans[i],mx - mn + 1);
            }
        }
        for (int i=0;i<m;i++) cout << ans[i] << endl;
        return 0;
    }
}
