#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define str to_string
#define pb push_back

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef long double ld;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template <typename T>
inline ll len(const T& x) {
    return x.size();
}
const ll MOD = 1e9 + 7;
ll binpow(ll b, ll e) {
    ll r = 1;
    while(e > 0) {
        if(e & 1) r = r * b % MOD;
        b = b * b % MOD;
        e >>= 1;
    }
    return r;
}


const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const int maxN = 2e5 + 9;
int par[maxN];
vector<int> g[maxN];
int tin[maxN], tout[maxN];
int dep[maxN];
int tim = 0;
void dfs(int v) {
    tin[v] = ++tim;
    for(auto &i: g[v]) dep[i] = dep[v] + 1, dfs(i);
    tout[v] = ++tim;
}
inline bool isanc(int p, int v) {
    return tin[p] <= tin[v] && tout[v] <= tout[p];
}
int id[maxN];
pll seg[maxN];
ll cur = 1;
void init() {
    iota(id, id + maxN, 0);
}
int getp(int v) {
    return id[v] == v ? v : id[v] = getp(id[v]);
}
void merge(int u, int v) {
    if(cur == 0) return;
    u = getp(u), v = getp(v);
    if(u == v) return;
    ll mxl = max(seg[u].first, seg[v].first);
    ll mnr = min(seg[u].second, seg[v].second);
    if(mxl > mnr) {
        cur = 0;
        return;
    }
    cur = cur * binpow(seg[u].second - seg[u].first + 1, MOD - 2) % MOD;
    cur = cur * binpow(seg[v].second - seg[v].first + 1, MOD - 2) % MOD;
    id[v] = u;
    cur = cur * (mnr - mxl + 1) % MOD;
    seg[u] = {mxl, mnr};
}


int p1[maxN], p2[maxN];
int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    init();
    int n; cin >> n;
    for(int i = 2; i <= n; ++i) {
        int p; cin >> p;
        par[i] = p;
        g[p].pb(i);
    }
    for(int i = 1; i <= n; ++i) {
        cin >> seg[i].first >> seg[i].second;
        cur = cur * (seg[i].second - seg[i].first + 1) % MOD;
    }
    dfs(1);

    int q; cin >> q;
    while(q--) {
        int a, b, c, d; cin >> a >> b >> c >> d;
        int le = 0;
        if(cur != 0) {
            {
                int i = 0;
                int v = a;
                while(!isanc(v, b)) {
                    p1[i] = v; ++i;
                    v = par[v];
                }
                le = dep[a] + dep[b] - dep[v] + 1;
                i = 0;
                while(!isanc(b, v)) {
                    p1[le - 1 - i] = b; ++i;
                    b = par[b];
                }
                p1[le - 1 - i] = v;
            }
            {
                int i = 0;
                int v = c;
                while(!isanc(v, d)) {
                    p2[i] = v; ++i;
                    v = par[v];
                }
                i = 0;
                while(!isanc(d, v)) {
                    p2[le - 1 - i] = d; ++i;
                    d = par[d];
                }
                p2[le - 1 - i] = v;
            }


//            ll mxl, mnr, z;
            for(int i = 0; i < le; ++i) {
                int u = p1[i], v = p2[i];
                merge(u, v);
            }
        }

        cout << cur << '\n';
    }
}
/*
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5

8
1 2 3 4 5 8 6
3 7
2 6
3 8
5 10
5 8
2 9
3 8
6 8
4
1 3 7 6
4 1 5 7
1 7 7 1
1 8 2 7

 */