#pragma GCC optimize ("Ofast", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "popcnt")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <queue>
#include <cstdio>
#include <iomanip>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <random>
#include <bitset>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
const int N = 3e3 + 10, M = 1e9 + 7;
vector <int> g[N];
vector <int> l(N), r(N);
int p[N], gl[N];

void dfs(int v) {
    for (auto& u : g[v])
        gl[u] = gl[v] + 1, dfs(u);
}

vector <int> put(int a, int b) {
    vector <int> A, B;
    while (a != b) {
        if (gl[b] > gl[a]) {
            B.push_back(b);
            b = p[b];
        }
        else {
            A.push_back(a);
            a = p[a];
        }
    }
    A.push_back(a);
    reverse(B.begin(), B.end());
    for (auto& r : B) {
        A.push_back(r);
    }
    return A;
}

ll mypow(ll a, ll b) {
    if (!b)
        return 1;
    ll e = mypow(a, b / 2);
    if (b & 1)
        return (((e * e) % M) * a) % M;
    return (e * e) % M;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    ll rs = 1;
    for (int i = 1; i <= n; i++) {
        cin >> l[i] >> r[i];
        rs *= (r[i] - l[i] + 1);
        rs %= M;
    }
    dfs(1);
    int m;
    cin >> m;
    vector <int> L = l, R = r, fl(n + 1, 1e9);
    vector <int> z;
    vector <int> w;
    while (m--) {
        ll ans = 1, res = rs;
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        vector <int> x = put(a, b);
        vector <int> y = put(c, d);
        for (int i = 0; i < x.size(); i++) {
            L[x[i]] = max(L[x[i]], L[y[i]]);
            R[x[i]] = min(R[x[i]], R[y[i]]);

            L[y[i]] = max(L[x[i]], L[y[i]]);
            R[y[i]] = min(R[x[i]], R[y[i]]);
            fl[y[i]] = min(min(min(fl[y[i]], fl[x[i]]), x[i]), y[i]);
            fl[x[i]] = min(min(min(fl[y[i]], fl[x[i]]), x[i]), y[i]);
        
            L[fl[x[i]]] = max(L[x[i]], L[y[i]]);
            R[fl[x[i]]] = min(R[x[i]], R[y[i]]);

            L[fl[y[i]]] = max(L[x[i]], L[y[i]]);
            R[fl[y[i]]] = min(R[x[i]], R[y[i]]);
        }
        
        for (auto& r : x)
            w.push_back(fl[r]);
        for (auto& r : y)
            w.push_back(fl[r]);
        for (auto& r : x)
            z.push_back(r);
        for (auto& r : y)
            z.push_back(r);
        sort(z.begin(), z.end());
        z.erase(unique(z.begin(), z.end()), z.end());
        sort(w.begin(), w.end());
        w.erase(unique(w.begin(), w.end()), w.end());
        for (int i = 0; i < z.size(); i++) {
            res = (res * mypow(r[z[i]] - l[z[i]] + 1, M - 2)) % M;
        }
        for (int i = 0; i < w.size(); i++) {
            ans *= max(0, R[w[i]] - L[w[i]] + 1);
            ans %= M;
        }
        cout << (ans * res) % M << endl;
    }
} 
