#include <bits/stdc++.h>

//#pragma GCC optimize(Ofast);
//#pragma GCC optimize(unroll-loops);
//#pragma GCC target(avx2);

#define int long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define eb emplace_back
#define For(i, n) for (int i = 0; i < n; i++)
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define vpi vector<pii>
#define ll long long
#define vch vector<char>
#define vvc vector<vch>
#define ld long double

using namespace std;

mt19937 rnd(time(0));

const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
const int INFLL = 1e18 + 3;


int n;
vvi gr, who;
vi pr, dep, used;
vpi seg;

void dfs(int v, int d) {
    dep[v] = d++;
    used[v] = 1;
    for (auto u : gr[v]) {
        if (!used[u]) dfs(u, d);
    }
}

int log_ = 13;

void calc() {
    who.resize(log_ + 1, vi(n));
    For(i, n) {
        who[0][i] = pr[i];
    }
    for (int l = 1; l <= log_; l++) {
        For(i, n) {
            who[l][i] = who[l - 1][who[l - 1][i]];
        }
    }
}

int lca(int u, int v) {
    if (dep[v] > dep[u]) swap(u, v);
    for (int l = log_; l >= 0; l--) {
        if (dep[who[l][u]] >= dep[v]) {
            u = who[l][u];
        }
    }
    if (u == v) return v;
    for (int l = log_; l >= 0; l--) {
        if (who[l][v] != who[l][u]) {
            v = who[l][v];
            u = who[l][u];
        }
    }
    return pr[v];
}

vi path(int u, int v) {
    int lc = lca(u, v);
    int cur = u;
    vi path1;
    while (cur != lc) {
        path1.pb(cur);
        cur = pr[cur];
    }
    path1.pb(lc);
    vi path2;
    cur = v;
    while (cur != lc) {
        path2.pb(cur);
        cur = pr[cur];
    }
    reverse(all(path2));
    vi res = path1;
    for (auto x : path2) res.pb(x);
    return res;
}


pii intersect(pii p1, pii p2) {
    if (p2.second < p1.first || p2.first > p1.second) {
        return {-1, -1};
    } else {
        return {max(p1.first, p2.first), min(p1.second, p2.second)};
    }
}

struct dsu {
    int n;
    vi s, pr;
    vpi segs;
    dsu() {}
    dsu(int nn) {
        n = nn;
        s.resize(n, 1);
        segs.resize(n);
        For(i, n) {
            segs[i] = seg[i];
        }
        pr.resize(n);
        iota(all(pr), 0);
    }
    int id(int v) {
        return (pr[v] == v ? v : pr[v] = id(pr[v]));
    }
    void unite(int u, int v) {
        u = id(u);
        v = id(v);
        if (u != v) {
            if (s[v] < s[u]) swap(u, v);
            pr[u] = v;
            s[v] += s[u];
            segs[v] = intersect(segs[v], segs[u]);
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    string da = "YES\n";
    string net = "NO\n";
    string OK = "OK\n";

    cin >> n;
    gr.resize(n);
    pr.resize(n);
    dep.resize(n);
    used.resize(n);
    seg.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> pr[i];
        pr[i]--;
        gr[pr[i]].pb(i);
    }
    dfs(0, 0);
    calc();

    For(i, n) {
        cin >> seg[i].first >> seg[i].second;
    }
    dsu ds(n);
    int T;
    cin >> T;
    For(ttt, T) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        auto p1 = path(a, b);
        auto p2 = path(c, d);
        For(i, sz(p1)) {
            ds.unite(p1[i], p2[i]);
        }
        set<int> st;
        For(i, n) {
            st.insert(ds.id(i));
        }
        int ans = 1;
        for (auto x : st) {
            if (ds.segs[x].first == -1) {
                ans = 0;
                break;
            } else {
                ans *= (ds.segs[x].second - ds.segs[x].first + 1);
                ans %= MOD;
            }
        }
        cout << ans << endl;
    }
    return 1337 / 2286942;
}
