#include<iostream>
#include<vector>
#include<algorithm>
#include<queue>
using namespace std;
const int mod=1e9+7;
long long int ans=1;
int l,r;
vector<int>adj[200001],cadj[200001],d(200001);
vector<bool>vis(200001);
vector<pair<int,int>>interval(200001);
vector<int>path(int s,int f,int n)
{
  vector<int>res;
  for(int i=0;i<n;i++)vis[i]=false;
  queue<int>q;
  d[s]=0,vis[s]=true,q.push(s);
  while(!q.empty())
  {
      int x=q.front();q.pop();
      for(auto y:adj[x])if(!vis[y])vis[y]=true,d[y]=d[x]+1;
  }
  int x=f;
  while(d[x])
  {
      res.push_back(x);
      for(auto y:adj[x])if(d[y]==d[x]-1){x=y;break;}
  }
  res.push_back(s);
  reverse(res.begin(),res.end());
  return res;
}
void dfs(int x)
{
    if(vis[x])return;
    vis[x]=true;
    l=max(l,interval[x].first),r=min(r,interval[x].second);
    for(auto y:cadj[x])dfs(y);
}
int main()
{
  int n,m,i,temp,a,b,c,d;
  cin>>n;
  vector<int>ansa,ansb;
  for(i=0;i<n-1;i++)cin>>temp,temp--,adj[i].push_back(temp),adj[temp].push_back(i);
  for(i=0;i<n;i++)cin>>interval[i].first>>interval[i].second;
  while(m--)
  {
      cin>>a>>b>>c>>d,a--,b--,c--,d--;
      ansa=path(a,b,n),ansb=path(c,d,n);
      for(i=0;i<ansa.size();i++)cadj[ansa[i]].push_back(ansb[i]),cadj[ansb[i]].push_back(ansa[i]);
  }
  for(i=0;i<n;i++)vis[i]=false;
  for(i=0;i<n;i++)if(!vis[i])l=-1e9,r=1e9,dfs(i),ans*=max(0,r-l+1),ans%=mod;
  cout<<ans;
}