#include <bits/stdc++.h>
using namespace std;
int n;
int K = 20, t;
long long int MOD = 1000000007, ans;
vector <int> pr, l, r, tin, tout, p, sz, L, R;
vector <vector <int>> graph, up;
vector <long long int> obr;
long long int f(long long int x, long long int N) {
    if (N == 0) return 1;
    if (N % 2 == 0) return f((x * x) % MOD, N / 2);
    return (x * f(x, N - 1)) % MOD;
}
void dfs(int v) {
    tin[v] = t;
    t++;
    for (auto e: graph[v]) {
        dfs(e);
    }
    tout[v] = t;
    t++;
}
int LCA(int x, int y) {
    if (tin[y] <= tin[x] && tout[x] <= tout[y]) {
        return y;
    }
    if (tin[x] <= tin[y] && tout[y] <= tout[x]) {
        return x;
    }
    int z;
    for (int i = K - 1; i >= 0; i--) {
        z = up[i][x];
        if (z == -1) continue;
        if (tin[z] <= tin[y] && tout[y] <= tout[z]) {
            continue;
        }
        x = z;
    }
    return pr[x];
}
int get(int v) {
    if (p[v] == v) return v;
    p[v] = get(p[v]);
    return p[v];
}
bool merge(int a, int b) {
    a = get(a);
    b = get(b);
    if (a < 0 || a >= n) exit(0);
    if (b < 0 || b >= n) exit(0);
    if (a == b) return false;
    ans = (ans * obr[R[a] - L[a] + 1]) % MOD;
    ans = (ans * obr[R[b] - L[b] + 1]) % MOD;
    if (sz[a] > sz[b]) swap(a, b);
    p[a] = b;
    sz[b] += sz[a];
    L[b] = max(L[a], L[b]);
    R[b] = min(R[a], R[b]);
    if (R[b] < L[b]) ans = 0;
    else ans = (ans * (R[b] - L[b] + 1)) % MOD;
    return true;
}
int main() {
    cin >> n;
    pr.resize(n, -1);
    graph.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> pr[i];
        pr[i]--;
        graph[pr[i]].push_back(i);
    }
    l.resize(n);
    r.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    up.resize(K, vector <int> (n));
    for (int i = 0; i < n; i++) {
        up[0][i] = pr[i];
    }
    for (int i = 1; i < K; i++) {
        for (int j = 0; j < n; j++) {
            if (up[i - 1][j] == -1) up[i][j] = -1;
            else up[i][j] = up[i - 1][up[i - 1][j]];
        }
    }
    tin.resize(n);
    tout.resize(n);
    t = 0;
    dfs(0);
    p.resize(n);
    L.resize(n);
    R.resize(n);
    sz.resize(n, 1);
    for (int i = 0; i < n; i++) {
        p[i] = i;
        L[i] = l[i];
        R[i] = r[i];
    }
    obr.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        obr[i] = f(i, MOD - 2);
    }
    ans = 1;
    for (int i = 0; i < n; i++) {
        ans = (ans * (r[i] - l[i] + 1)) % MOD;
    }
    int q, a, b, c, d, lca;
    cin >> q;
    for (; q > 0; q--) {
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        vector <int> path_1, path_2;
        stack <int> st;
        lca = LCA(a, b);
        if (lca < 0 || lca >= n) return 0;
        while (a != lca) {
            path_1.push_back(a);
            a = pr[a];
        }
        while (b != lca) {
            st.push(b);
            b = pr[b];
        }
        st.push(lca);
        while (!st.empty()) {
            path_1.push_back(st.top());
            st.pop();
        }
        lca = LCA(c, d);
        if (lca < 0 || lca >= n) return 0;
        while (c != lca) {
            path_2.push_back(c);
            c = pr[c];
        }
        while (d != lca) {
            st.push(d);
            d = pr[d];
        }
        st.push(lca);
        while (!st.empty()) {
            path_2.push_back(st.top());
            st.pop();
        }
        for (int i = 0; i < path_1.size() && ans != 0; i++) {
            merge(path_1[i], path_2[i]);
        }
        cout << ans << "\n";
    }
    return 0;
}