#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef __int128 lll;
typedef long double ld;
ll inf = 1e15, mod = 1e9 + 7;
ld eps = 1e-9;
#define all(a) a.begin(), a.end()

ll binpow(ll n, ll k) {
    if (!k)
        return 1;
    if (k % 2)
        return (binpow(n, k - 1) * n) % mod;
    ll a = binpow(n, k / 2);
    return (a * a) % mod;
}

vector<ll> tr, lm, rm;

ll root(ll v) {
    if (tr[v] == v)
        return v;
    tr[v] = root(tr[v]);
    return tr[v];
}

void unite(ll a, ll b) {
    a = root(a);
    b = root(b);
    tr[b] = a;
    lm[a] = max(lm[a], lm[b]);
    rm[a] = min(rm[a], rm[b]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n;
    cin >> n;
    vector <ll> p(n, -1);
    for (ll i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
    }
    vector <ll> l(n), r(n);
    for (ll i = 0; i < n; i++)
        cin >> l[i] >> r[i];
    tr.resize(n);
    lm = l;
    rm = r;
    for (ll i = 0; i < n; i++)
        tr[i] = i;
    ll q;
    cin >> q;
    vector <vector<ll>> mp(n, vector<ll>(n));
    while (q--) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        vector <ll> u1(n), u2(n);
        ll x = a;
        while (x >= 0) {
            u1[x] = 1;
            x = p[x];
        }
        x = b;
        while (!u1[x])
            x = p[x];
        vector <ll> p1, p2;
        ll t = x;
        x = a;
        while (x != p[t]) {
            p1.push_back(x);
            x = p[x];
        }
        x = b;
        vector <ll> v;
        while (x != t) {
            v.push_back(x);
            x = p[x];
        }
        reverse(all(v));
        for (auto i: v)
            p1.push_back(i);
        /////////////
        x = c;
        while (x >= 0) {
            u2[x] = 1;
            x = p[x];
        }
        x = d;
        while (!u2[x])
            x = p[x];
        t = x;
        x = c;
        while (x != p[t]) {
            p2.push_back(x);
            x = p[x];
        }
        x = d;
        v.clear();
        while (x != t) {
            v.push_back(x);
            x = p[x];
        }
        reverse(all(v));
        for (auto i: v)
            p2.push_back(i);
        //////////////////
        ll an = 1;
        for (ll i = 0; i < p1.size(); i++)
            if (root(p1[i]) != root(p2[i]))
                unite(p1[i], p2[i]);
        set <ll> st;
        for (ll i = 0; i < n; i++) {
            ll s = root(i);
            if (st.find(s) == st.end()) {
                st.insert(s);
                an = (an * max(0ll, rm[s] - lm[s] + 1)) % mod;
                if (!an)
                    break;
            }
        }
        cout << an << '\n';
        if (!an || st.size() == 1) {
            while (q--)
                cout << an << '\n';
            return 0;
        }
    }
}