#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <deque>
#include <queue>
#include <memory.h>
#include <iomanip>
#include <random>
#include <ctime>
#define int long long
#define pii pair<int,int>
#define pb push_back
#define fir first
#define sec second
#define endl '\n'
#define double long double
#define INF 1000000009
#define itn int
#define swpa swap
using namespace std;

const int N = 100005, MOD = 1e9 + 7, R = 1 << 20;

mt19937 rnd(228);

void fun(vector<vector<int>>& gr, vector<int>& used, vector<int>& p, int v, int finish, bool &flag) {
	used[v] = 1;
	p.pb(v);
	if (v == finish) {
		flag = 1;
		return;
	}
	if (flag)
		return;
	for (int i : gr[v]) {
		if (!used[i])
			fun(gr, used, p, i, finish, flag);
		if (flag)
			return;
	}
	p.pop_back();
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(17);
	srand(time(0));

	int n;
	cin >> n;
	vector<int> pr(n);
	vector<vector<int>> gr(n);
	for (int i = 1; i < n; i++) {
		int a;
		cin >> a;
		a--;
		pr[i] = a;
		gr[a].pb(i);
		gr[i].pb(a);
	}

	vector<pii> vc(n);
	for (auto& i : vc)
		cin >> i.first >> i.second;
	int q;
	cin >> q;

	while (q--) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--, b--, c--, d--;
		vector<int>u1(n), u2(n), p1, p2;
		bool f1 = 0, f2 = 0;
		fun(gr, u1, p1, a, b, f1);
		fun(gr, u2, p2, c, d, f2);
		vector<int> used(n);
		for (int i = 0; i < p1.size(); i++) {
			int u = p1[i], v = p2[i];
			vc[u] = { max(vc[u].first, vc[v].fir), min(vc[v].second, vc[u].sec) };
			//vc[v] = vc[u];
			if (vc[u].first > vc[u].sec) {
				vc[u] = { 0,-1 };
			}
			vc[v] = vc[u];
			used[v] = 1;
			used[u] = 1;
		}
		int ans = 1;
		for (int i = 0; i < n; i++) {
			if (!used[i])
				ans *= vc[i].second - vc[i].first + 1;
		}
		used.assign(n, 0);
		for (int i = 0; i < p1.size(); i++) {
			if (!used[p1[i]])
				ans *= vc[i].second - vc[i].first + 1;
			used[p1[i]] = 1;
			used[p2[i]] = 1;
		}
		cout << ans << endl;
	}
	return 0;
}