#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define F first
#define S second
#define endl '\n'
#define pb push_back
#define vi vector <int>
#define pii pair <int, int>
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define RFOR(i, a, b) for (int i = a; i >= b; --i)
#define EACH(e, a) for (auto& e : a)
#define pbds tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>
#pragma GCC optimize("O3")
mt19937 rng(228);
constexpr int MAX = 200007, MOD = 1e9 + 7, LG = 18;

int T, l[MAX], r[MAX], w1[MAX], w2[MAX], tin[MAX], tout[MAX], dep[MAX], up[LG][MAX];
vi g[MAX];

void dfs(int v, int d) {
    tin[v] = T++, dep[v] = d;
    FOR(i, 1, LG) up[i][v] = up[i - 1][up[i - 1][v]];
    EACH(u, g[v]) dfs(u, d + 1);
    tout[v] = T;
}

bool upper(int u, int v) { return tin[u] <= tin[v] && tout[v] <= tout[u]; }
int lca(int u, int v) {
    if (upper(u, v)) return u;
    if (upper(v, u)) return v;
    int w = v;
    RFOR(i, LG - 1, 0) if (!upper(up[i][w], u)) w = up[i][w];
    return up[0][w];
}

int binpow(int x, int e) {
    long long r = 1, c = x;
    while (e) {
        if (e & 1) r = r * c % MOD;
        c = c * c % MOD, e >>= 1;
    }
    return r;
}
int inv(int x) { return binpow(x, MOD - 2); }

int p[MAX], s[MAX];
int get(int v) { return (p[v] == v) ? (v) : (p[v] = get(p[v])); }
void merge(int u, int v) {
    u = get(u), v = get(v);
    if (u == v) return;
    p[v] = u, s[u] += s[v];
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false); cin.tie(0);
    int n, f = 0; cin >> n;
    FOR(i, 0, n) p[i] = i, s[i] = 1;
    FOR(i, 1, n) cin >> up[0][i], g[--up[0][i]].pb(i);
    dfs(0, 0);
    FOR(i, 0, n) cin >> l[i] >> r[i];
    long long pr = 1;
    FOR(i, 0, n) pr = pr * (r[i] - l[i] + 1) % MOD;
    int q; cin >> q;
    while (q--) {
        int a, b, c, d; cin >> a >> b >> c >> d, --a, --b, --c, --d;
        if (f) {
            cout << 0 << endl;
            continue;
        }
        int p1 = 0, p2 = 0;
        int l1 = lca(a, b), l2 = lca(c, d);
        int dp = dep[a] + dep[b] - 2 * dep[l1];
        while (a != l1) w1[p1++] = a, a = up[0][a];
        while (c != l2) w2[p2++] = c, c = up[0][c];
        w1[p1] = l1, w2[p2] = l2;
        p1 = p2 = 0;
        while (b != l1) w1[dp - p1++] = b, b = up[0][b];
        while (d != l2) w2[dp - p2++] = d, d = up[0][d];
        long long bef = 1, aft = 1;
        FOR(i, 0, dp + 1) if (get(w1[i]) != get(w2[i])) {
            int x = get(w1[i]), y = get(w2[i]);
            bef = bef * (r[x] - l[x] + 1) % MOD;
            bef = bef * (r[y] - l[y] + 1) % MOD;
            if (s[x] > s[y]) {
                l[x] = max(l[x], l[y]), r[x] = min(r[x], r[y]);
                if (r[x] < l[x]) {
                    f = 1;
                    cout << 0 << endl;
                    break;
                }
                merge(x, y);
                aft = aft * (r[x] - l[x] + 1) % MOD;
            }
            else {
                l[y] = max(l[x], l[y]), r[y] = min(r[x], r[y]);
                if (r[y] < l[y]) {
                    f = 1;
                    cout << 0 << endl;
                    break;
                }
                merge(x, y);
                aft = aft * (r[y] - l[y] + 1) % MOD;
            }
        }
        if (f) continue;
        pr = (pr * inv(bef) % MOD) * aft % MOD;
        cout << pr << endl;
    }
}

/* NEVER GIVE UP */
