//#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>
#define int long long
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define fi first
#define se second

using namespace std;

vector<vector<int>> g;
vector<int> p, sz;
vector<pii> gr;
int ans = 1;

int mod = 1e9 + 7;
int findp(int v)
{
    if (v == p[v]) return v;
    return p[v] = findp(p[v]);
}

int bin_pow(int a, int p)
{
    if ( p == 0 ) return 1;
    if ( p == 1) return a;
    int bp = bin_pow(a, p/2);
    if (p % 2){
        return ((bp * bp) % mod  * a) % mod;
    }
    else{
        return (bp * bp) % mod;
    }
}

int divv(int a, int b)
{
    return ( a * ( bin_pow(b, mod - 2) % mod ) ) % mod;
}

void merg(int u, int v)
{

    u = findp(u);
    v = findp(v);
    if (v == u) return;
    if (sz[u] > sz[v]) swap(u, v);
    sz[v] += sz[u];
    ans = divv(ans, gr[u].se - gr[u].fi + 1);
    ans = divv(ans, gr[v].se - gr[v].fi + 1);

    gr[v].fi = max(gr[v].fi, gr[u].fi);
    gr[v].se = min(gr[v].se, gr[u].se);
    ans *= gr[v].se - gr[v].fi + 1;
    ans %= mod;
    p[u] = v;
}

int f;
vector<vector<int>> pt;
void dfs (int v, int pr, int mk)
{
    if (v == f) {
        pt[mk].pb(v);
        return;
    }
    for (int i=0; i<g[v].size(); i++)
        if (g[v][i] != pr)
        {
            dfs(g[v][i], v, mk);
            if (pt[mk].size())
            {
                pt[mk].pb(v);
                return;
            }
        }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    g.resize(n);
    for (int i=1; i<n; i++)
    {
        int c;
        cin >> c;
        c--;
        g[i].pb(c);
        g[c].pb(i);
    }
    sz.assign(n, 1);
    p.resize(n);
    gr.resize(n);
    for (int i=0; i<n; i++)
    {
        cin >> gr[i].fi >> gr[i].se;
        p[i] = i;
        ans *= gr[i].se - gr[i].fi + 1;
        ans %= mod;
    }
    int m;
    pt.resize(2);
    cin >> m;
    for (int i=0; i<m; i++)
    {
        pt[0].clear();
        pt[1].clear();
       // cout << pt[0].size() << ' ' << pt[1].size() << endl;
        pii a, b;
        cin >> a.fi >> a.se >> b.fi >> b.se;
        a.fi --, a.se--, b.fi--, b.se--;
        f = a.se;
        dfs(a.fi, -1, 0);
        f = b.se;
        dfs(b.fi, -1, 1);
        for (int j=0; j<pt[0].size(); j++)
            merg(pt[0][j], pt[1][j]);
        cout << ans << endl;
    }
    return 0;
}
