// good luck, champion!
#include <bits/stdc++.h>
#define fs first
#define sc second
//#define int long long

using namespace std;
using ll = long long;
const int k = 316, mod = 1e9 + 7;

struct segtree {
    struct node {

    };
    vector<node> tree;
    int size;

    void init(int x) {
        size = 1;
        while (size < x)
            size *= 2;
        //
    }

    node combine(node a, node b) {

    };

    void build(vector<int>& a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            if (lx < a.size()) {
                //
            }
            return;
        }
        int m = (lx + rx) / 2;
        build(a, 2 * x + 1, lx, m);
        build(a, 2 * x + 2, m, rx);
        tree[x] = combine(tree[2 * x + 1], tree[2 * x + 2]);
    }

    void build(vector<int>& a) {
        init(a.size());
        build(a, 0, 0, size);
    }
};

int bin_pow(int a, int n) {
    if (n == 0)
        return 1;
    if (n % 2)
        return (bin_pow(a, n - 1) * a) % mod;
    int b = bin_pow(a, n / 2);
    return (b * b) % mod;
}

int gcd(int a, int b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

struct vect {
    double x, y;

    double len() {
        return sqrt(x * x + y * y);
    }

    void set_len(double l) {
        double tmp = len();
        x /= tmp;
        y /= tmp;
        x *= l;
        y *= l;
    }

    void build(vect a, vect b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }
};

double sc_multi(vect a, vect b) {
    return a.x * b.x - a.y * b.y;
}

double vc_multi(vect a, vect b) {
    return a.x * b.y - a.y * b.x;
}
int n, t = 0;
vector<int> tin(n), tout(n);

void dfs(int v, vector<vector<int>>& g) {
    tin[v] = t;
    for (auto u : g[v]) {
        t++;
        dfs(u, g);
        t++;
    }
    tout[v] = t;
}

bool is_pr(int v, int u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

int ans = 1;

struct dsu {
    vector<int> p;
    vector<pair<int, int>> r;
    void init(vector<pair<int, int>>& a) {
        p.resize(a.size());
        for (int i = 0; i < n; ++i) {
            p[i] = i;
            ans *= a[i].sc - a[i].fs;
            ans %= mod;
        }
        r = a;
    }
    
    int get_root(int x) {
        if (p[x] == x)
            return x;
        return p[x] = get_root(p[x]);
    }
    
    void merge(int v, int u) {
        v = get_root(v), u = get_root(u);
        ans *= bin_pow(r[v].sc - r[v].fs, mod - 2);
        ans %= mod;
        ans *= bin_pow(r[u].sc - r[u].fs, mod - 2);
        ans %= mod;
        r[v].fs = max(r[v].fs, r[u].fs);
        r[v].sc = min(r[v].sc, r[u].sc);
        ans *= max(0, r[v].sc - r[v].fs);
        ans %= mod;
        p[u] = v;
    }
};


void solve() {
     cin >> n;
     vector<vector<int>> g(n);
     vector<int> p(n);
     for (int i = 0; i < n - 1; ++i) {
         int x; cin >> x;
         --x;
         g[x].push_back(i + 1);
         p[i + 1] = x;
     }
    vector<vector<int>> bin_up(n, vector<int> (20));
     for (int i = 0; i < n; ++i)
         bin_up[i][0] = p[i];
     for (int i = 1; i < 20; ++i) {
         for (int j = 0; j < n; ++j) {
             bin_up[j][i] = bin_up[bin_up[j][i - 1]][j - 1];
         }
     }
     vector<pair<int, int>> seg(n);
     for (int i = 0; i < n; ++i) {
         cin >> seg[i].fs >> seg[i].sc;
     }
     dsu d;
     d.init(seg);
     int m; cin >> m;
     while (m--) {
         int a1, b1, a2, b2;
         cin >> a1 >> b1 >> a2 >> b2;
         int lca1 = a1, lca2 = a2;
         for (int i = 19; i >= 0; --i) {
             if (!is_pr(bin_up[lca1][i], b1)) {
                 lca1 = bin_up[lca1][i];
             }
             if (!is_pr(bin_up[lca2][i], b2)) {
                 lca2 = bin_up[lca2][i];
             }
         }
         if (!is_pr(lca1, b1))
            lca1 = p[lca1];
         if (!is_pr(lca2, b2))
            lca2 = p[lca2];
         while (a1 != lca1 && a2 != lca2) {
             d.merge(a1, a2);
             a1 = p[a1];
             a2 = p[a2];
         }
         d.merge(a1, a2);
         while (b1 != lca1 && b2 != lca2) {
             d.merge(b1, b2);
             b1 = p[b1];
             b2 = p[b2];
         }
         d.merge(b1, b2);
         vector<int> w1, w2;
         while (a1 != lca1) {
             w1.push_back(a1);
             a1 = p[a1];
         }
         while (b1 != lca1) {
             w1.push_back(b1);
             b1 = p[b1];
         }
         while (a2 != lca2) {
             w2.push_back(a2);
             a2 = p[a2];
         }
         while (b2 != lca2) {
             w2.push_back(b2);
             b2 = p[b2];
         }
         for (int i = 0; i < w1.size(); ++i) {
             d.merge(w1[i], w2[w2.size() - i - 1]);
         }
         cout << ans << '\n';
     }
}

signed main() {
    ll tests = 1;
    // cin >> tests;
    while(tests--) {
        solve();
    }
    return 0;
}
