#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/t_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

typedef long double ld;
typedef long long ll;
#define oset tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>


const int INF = 1e9 + 2, MOD = 1e9 + 7, N = 2e5 + 100, K = 20;
mt19937 rnd(time(0));
vector<int> g[N], p(N), dp(N);
int t = 0;

void dfs(int v, int p) {
    dp[v] = dp[p] + 1;
    for (auto to : g[v])
        dfs(to, v);
}


void solve() {
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    dfs(1, 0);
    vector<int> l(n + 1), r(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> l[i] >> r[i];
    }
    int m;
    cin >> m;
    vector<int> lmax = l, rmin = r;
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        vector<int> wa, wb, wc, wd, used(n + 1);

        while (dp[a] > dp[b]) {
            wa.push_back(a);
            a = p[a];
        }
        while (dp[a] < dp[b]) {
            wb.push_back(b);
            b = p[b];
        }
        while (a != b) {
            wa.push_back(a);
            a = p[a];
            wb.push_back(b);
            b = p[b];
        }
        wa.push_back(a);
        while (dp[c] > dp[d]) {
            wc.push_back(c);
            c = p[c];
        }
        while (dp[c] < dp[d]) {
            wd.push_back(d);
            d = p[d];
        }
        while (c != d) {
            wc.push_back(c);
            c = p[c];
            wd.push_back(d);
            d = p[d];
        }
        wc.push_back(c);
        vector<int> way1 = wa, way2 = wc;
        while (!wb.empty()) {
            way1.push_back(wb.back());
            wb.pop_back();
        }
        while (!wd.empty()) {
            way2.push_back(wd.back());
            wd.pop_back();
        }
        int ans = 1;
        for (int tt = 0; tt < way1.size(); tt++) {
            for (int j = 0; j < way1.size(); j++) {
                int u = way1[j], v = way2[j];
                lmax[u] = max(lmax[u], lmax[v]);
                lmax[v] = max(lmax[u], lmax[v]);
                rmin[v] = min(rmin[v], rmin[u]);
                rmin[u] = min(rmin[v], rmin[u]);
            }
        }
        for (int j = 0; j < way1.size(); j++) {
            int u = way1[j], v = way2[j];
            lmax[u] = max(lmax[u], lmax[v]);
            lmax[v] = max(lmax[u], lmax[v]);
            rmin[v] = min(rmin[v], rmin[u]);
            rmin[u] = min(rmin[v], rmin[u]);
            if (!used[u] && !used[v]) {
                int ds = rmin[v] - lmax[v] + 1;
                ds = max(ds, 0ll);
                ans = (ans * ds) % MOD;
            }
            used[u] = 1;
            used[v] = 1;
        }
        for (int j = 1; j <= n; j++) {
            if (!used[j])
                ans = (ans * (r[j] - l[j] + 1)) % MOD;
        }
        cout << ans << "\n";
    }

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}