#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define f first
#define s second
#define pll pair<ll, ll>
using namespace std;
vector <vector<ll>> tree;
vector <pll> place;
vector <ll> parent;
vector <pll> gran;
vector <ll> timer;
vector <ll> height;
vector <ll> cnm, siz;
ll t;
ll inf = 1e9 + 7;
void dfs(ll x, ll h){
    timer.push_back(x);
    height.push_back(h);
    place[x].f = t;
    t++;
    for(auto g : tree[x]){
        dfs(g, h+1);
        timer.push_back(x);
        height.push_back(h);
        t++;
    }
}
ll find(ll x){
    if(x == cnm[x])return x;
    else return cnm[x] = find(cnm[x]);
}
void update(pll x, pll y, ll lca1, ll lca2, ll len){
    vector <ll> way1(len), way2(len);
    ll ind = 0;
    while(x.f != lca1){
        way1[ind] = x.f;
        x.f = parent[x.f];
        ind++;
    }
    way1[ind] = lca1;
    ind = len - 1;
    while(x.s != lca1){
        way1[ind] = x.s;
        x.s = parent[x.s];
        ind--;
    }
    ind = 0;
    while(y.f != lca2){
        way2[ind] = y.f;
        y.f = parent[y.f];
        ind++;
    }
    way2[ind] = lca2;
    ind = len - 1;
    while(y.s != lca2){
        way2[ind] = y.s;
        y.s = parent[y.s];
        ind--;
    }
    for(ll i = 0; i < len; i++){
        ll a = way1[i], b = way2[i];
        ll c = find(a), d = find(b);
        if(siz[c] < siz[d])swap(c, d);
        siz[c] += siz[d];
        cnm[d] = c;
        a = c, b = d;
        ll l = max(gran[a].f, gran[b].f), r = min(gran[a].s, gran[b].s);
        gran[a] = {l, r};
        gran[b] = {l, r};

    }

}
ll ans(ll n){
    ll cnt = 1;
    vector <bool> used(n, false);
    for(ll i = 0; i < n; i++){
        ll j = find(i);
        if(!used[j]) {
            used[j] = true;
            ll x = max((ll) 0, gran[j].s - gran[j].f + 1);
            cnt *= x;
            cnt %= inf;
        }
    }
    return cnt;
}
int main() {
    ll n;
    cin >> n;
    ll N = 2*n-1;
    tree.resize(n);
    parent.resize(n);
    gran.resize(n);
    place.resize(n);
    cnm.resize(n);
    siz.resize(n, 1);
    for(ll i = 0; i < n; i++)cnm[i] = i;
    for(ll i = 1; i < n; i++){
        ll a;
        cin >> a;
        tree[a-1].push_back(i);
        parent[i] = a-1;
    }
    for(ll i = 0; i < n; i++){
        cin >> gran[i].f >> gran[i].s;
    }
    dfs(0, 0);
    set <pll> logs;
    for(ll i = 0; i <= 20; i++){
        logs.insert({(1 << i), i});
    }
    vector <vector<pll>> st(20, vector<pll>(N));
    for(ll i = 0; i < N; i++)st[0][i] = {height[i], timer[i]};
    for(ll i = 1; (1 << i) <= N; i++){
        for(ll j = 0; j < N - (1 << i) + 1; j++){
            st[i][j] = min(st[i-1][j], st[i-1][j + (1 << (i - 1))]);
        }
    }
    ll q;
    cin >> q;
    while(q--){
        pll a, b;
        cin >> a.f >> a.s >> b.f >> b.s;
        a.f--, a.s--, b.f--, b.s--;
        pll aa = a, bb = b;
        if(place[a.f].f > place[a.s].f)swap(a.f, a.s);
        if(place[b.f].f > place[b.s].f)swap(b.f, b.s);
        ll len1 = place[a.s].f - place[a.f].f + 1, len2 = place[b.s].f - place[b.f].f + 1;
        ll ind1 = (*(logs.lower_bound({len1, inf}))).s - 1;
        ll ind2 = (*(logs.lower_bound({len2, inf}))).s - 1;
        ll lca1 = 0, lca2 = 0;
        lca1 = min(st[ind1][place[a.f].f], st[ind1][place[a.s].f - (1 << ind1) + 1]).s;
        lca2 = min(st[ind2][place[b.f].f], st[ind2][place[b.s].f - (1 << ind2) + 1]).s;
        ll len = height[place[a.f].f] - height[place[lca1].f] + height[place[a.s].f] - height[place[lca1].f] + 1;
        update(aa, bb, lca1, lca2, len);
        cout << ans(n) << "\n";
    }
    return 0;
}