#include<bits/stdc++.h>
using namespace std;
const int maxn = 100001;
int n,m;
int p[maxn];

int leader[maxn];
int rang[maxn];

pair<int,int>range[maxn];

vector<int>v[maxn];
int used[maxn];

int query;
vector<int>x;
vector<int>y;

int lamp = 0;

void read()
{
    cin >> n;
    for( int i = 2; i <= n; i ++ )
    {
        cin >> p[i];
        v[i].push_back(p[i]);
        v[p[i]].push_back(i);
    }

    for( int i = 1; i <= n; i ++ )
    {
        int l,r;
        cin >> range[i].first >> range[i].second;
    }
}

void dfs1( int w, vector<int>path )
{
    path.push_back(w);
    used[w] = 1;

    if( w == query )
    {
        x = path;
        return;
    }

    int sz = v[w].size();
    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i];
        if( used[nb] == 0 )
        {
            dfs1(nb,path);
        }
    }
    return;
}

void dfs2( int w, vector<int>path )
{
    path.push_back(w);
    used[w] = 1;

    if( w == query )
    {
        y = path;
        return;
    }

    int sz = v[w].size();
    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i];
        if( used[nb] == 0 )
        {
            dfs2(nb,path);
        }
    }
    return;
}

void init_dsu()
{
    for( int i = 1; i <= n; i ++ )
    {
        leader[i] = i;
        rang[i] = 1;
    }
}

int find_leader( int w )
{
    if( leader[w] == w ) return w;
    leader[w] = find_leader(leader[w]);
    return leader[w];
}

void DSU( int a, int b )
{
    int la = find_leader(a);
    int lb = find_leader(b);

    if( la == lb ) return;

    if( rang[lb] > rang[la] ) swap(la,lb);

    rang[la] += rang[lb];
    leader[lb] = la;

    range[la].first = max( range[la].first , range[lb].first ); /// NB!!!!!!!!!!!!!
    range[la].second = min( range[la].second , range[lb].second ); /// NB!!!!!!!!!!!!!

    if( range[la].first > range[la].second ) lamp = 1;
}

void solve()
{
    cin >> m;
    for( int i = 1; i <= m; i ++ )
    {
        int a,b,c,d;
        cin >> a >> b >> c >> d;

        if( lamp == 1 )
        {
            cout << 0 << endl;
            continue;
        }

        vector<int>path;
        memset(used,0,sizeof(used));

        query = b;
        dfs1(a,path);

        memset(used,0,sizeof(used));

        query = d;
        dfs2(c,path);

        int sz = x.size();
        for( int j = 0; j < sz; j ++ )
        {
            int nb1 = x[j];
            int nb2 = y[j];

            DSU(nb1,nb2);
        }

        if( lamp == 1 )
        {
            cout << 0 << endl;
            continue;
        }

        int ans = 1;
        for( int j = 1; j <= n; j ++ )
        {
            int lj = find_leader(j);
            if( lj == j )
            {
                ans *= ( range[j].second - range[j].first + 1 );
            }
        }

        cout << ans << endl;
    }
}
int main()
{
    read();
    init_dsu();
    solve();
    return 0;
}
