#include<bits/stdc++.h>
using namespace std;

int const MAXN=1000001;
int n, par[MAXN], m, used[MAXN];
vector<int> v[MAXN];

struct edge
{
    int l, r;
};

edge ver[MAXN], d[MAXN];
/*
void DFS(int i, int par)
{
    lvl[i] = lvl[par]+1;
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!lvl[nb])
        {
            DFS(nb, i);
        }
    }
}*/

void fill_array()
{
    for(int i=1;i<=MAXN;i++)
    {
        par[i] = i;
        d[i] = ver[i];
    }
}

int find_leader(int x)
{
    if(par[x] == x) return x;
    else return par[x] = find_leader(par[x]);
}

void DSU(int x, int y)
{
    x = find_leader(x);
    y = find_leader(y);
    if(x == y) return;
    d[x].l = max(d[x].l, d[y].l);
    d[y].l = d[x].l;
    d[x].r = min(d[x].r, d[y].r);
    d[y].r = d[x].r;
    par[y] = x;
}

void read()
{
    int lf, rf, a, b, c, e, ans = 1, x;
    cin>>n;
    for(int i=2;i<=n;i++)
    {
        cin>>x;
        v[x].push_back(i);
        v[i].push_back(x);
    }
    //DFS(1, 0);
    for(int i=1;i<=n;i++)
    {
        cin>>lf>>rf;
        ver[i] = {lf,rf};
    }
    fill_array();
    cin>>m;
    for(int i=1;i<=m;i++)
    {
        ans = 1;
        cin>>a>>b>>c>>e;
        if(a > b) swap(a, b);
        if(c > e) swap(c, e);
        for(int j=0;j<=(b-a);j++)
        {
            if(a+j != c+j) DSU(a+j, c+j);
        }
        for(int j=1;j<=n;j++)
        {
            x = find_leader(j);
            if(x == j)
            {
                if(d[x].r - d[x].l < 0)
                {
                    ans = 0;
                    break;
                }
                ans *= (d[x].r - d[x].l + 1);
            }
        }
        cout<<ans<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}

/*
8
1 2 3 4 5 6 7
3 7
2 6
3 8
5 10
5 8
2 9
3 8
6 8
4
1 3 8 6
4 1 5 8
1 8 8 1
1 7 2 8
*/
