#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
	ll n, k;
	cin >> n >> k;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<ld> prev(k + 1, 0), next(k + 1, 0);
	prev[1] = 1;

	set<ll> can;
	a.push_back(k);
	for (ll K : a) {
		for (ll i = 1; i * i <= K; i++) {
			if (K % i == 0) {
				can.insert(i);
				if (i * i != K) {
					can.insert(K / i);
				}
			}
		}
	}
	a.pop_back();

	for (ll i = 0; i < n; i++) {
		for (ll j = 1; j <= k; j++) {
			for (ll b : can) {
				next[j] = max(next[j], prev[(j - 1) / b + 1] * ld(a[i] / b) / ld(a[i]));
			}
		}
		prev = next;
		fill(next.begin(), next.end(), 0);
	}
	cout << fixed << setprecision(15) << prev[k] * k;
}

/*
1 2
5

2 6
5 10

2 7
4 4

2 3
4 5

4 444
57 179 239 2

2 5
2 2

*/