#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

const int maxN = 1e2, maxK = 1e7;

using ld = long double;
using ll = long long;
using vi = vector<int>;

struct State {
    ll cnt;
    ld res;
    State(ll cnt = 0, ld res = 0) : cnt(cnt), res(res) {}
    bool operator<(const State& other) const {
        return cnt < other.cnt;
    }
};

int test = 1, n, k, a[maxN], sz, hlp;
ld ans;
vector<State> dp1, dp2;
vi dw1, dw2;

void solve() {
    cin >> n >> k;
    dp1.clear();
    dp1.emplace_back(1, k);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        dp2.clear();
        for (int j = 1; j <= a[i]; j++) {
            int q = a[i] / j;
            j = a[i] / q;
            for (int h = 0; h < (int)dp1.size(); h++)
                dp2.emplace_back(dp1[h].cnt * j, (a[i] / j) * dp1[h].res / a[i]);
        }
        sort(dp2.begin(), dp2.end());
        int it = 0;
        for (int i = 0; i < (int)dp2.size(); i++) {
            while (it > 0 && dp2[it - 1].res < dp2[i].res)
                it--;
            if (it == 0 || dp2[it - 1].cnt != dp2[i].cnt)
                dp2[it++] = dp2[i];
        }
        while (it > 1 && dp2[it - 2].cnt >= k)
            it--;
        dp2.resize(it);
        swap(dp1, dp2);
    }
    if (dp1.back().cnt < k)
        ans = 0;
    else
        ans = dp1.back().res;
    printf("%.20Lf\n", ans);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> test;
#endif
    while (test--)
        solve();
    return 0;
}
