#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <cstring>
#include <ext/pb_ds/assoc_container.hpp>

#define sc second
#define fr first
#define ll long long
#define ld long double
#define div asd
//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC optimize("acvx,bmi,bmi2")


using namespace std;

const int N = 110;
int a[N];
const int lim = 2e7 + 2;

vector<int> pr;
int n, k;

int div[lim];
vector<int> divs[N];

void precount0(){
    memset(div, 0, sizeof(div));
    for (int i = 2; i < lim; ++i){
        if (!div[i]){
            pr.push_back(i);
            div[i] = i;
        }
        for (int j = 0; j < pr.size() && i * pr[j] < lim && pr[j] <= div[i]; ++j){
            div[i * pr[j]] = pr[j];
        }
    }
}
void precount1(){
    for (int i = 0; i< n; ++i){
        for (int j = 1; j * j <= a[i]; ++j){
            if (a[i] % j == 0){
                divs[i].push_back(j + 1);
                divs[i].push_back(a[i] / j + 1);
            }
        }
    }
}


void input(){
    cin >> n >> k;
    for (int i = 0; i < n; ++i){
        cin >> a[i];
    }
}


ld ans = 0;
void work(){
    int K;
    for (int i = 0; i < k; ++i){
        K = k + i;
        vector<int> divs;
        while (k != 1){
            divs.push_back(div[k]);
            k /= div[k];
        }
        if (divs.size() >= n){
            ;
        }
    }
}

void work1(){
    const int M = 3200;
    unordered_map<int, ld> dp[N];
    dp[0][k] = 1;
    for (int i = 0; i < n; ++i){
        for (int dv = 1; dv <= a[i]; ++dv){
            for (auto val : dp[i]){
                int nw = (val.fr + dv - 1) / dv;
                dp[i + 1][nw] = max(dp[i + 1][nw], val.sc * (a[i] / dv));
            }
        }
    }
    ld res = dp[n][1] * k;
    for (int i = 0; i < n; ++i){
        res /= a[i];
    }
    printf("%.20Lf\n", res);
}


int main(){
    input();
    precount1();
    work1();
}
