#pragma GCC optimize("O3,unroll-loops")


#include <stdio.h>
#include <vector>
#include <unordered_map>
#include <cmath>

#define sc second
#define fr first
#define ll long long
#define ld long double
#define div asd
//#pragma GCC optimize("acvx,bmi,bmi2")


using namespace std;

const int N = 110;
int a[N];

int n, k;

vector<int> divs[N];

void input(){
    scanf("%d%d", &n, &k);
    for (int i = 0; i < n; ++i){
        scanf("%d", a + i);
    }
}

void precount1(){
    for (int i = 0; i < n; ++ i){
        int sq = sqrt(a[i]) + 1;
        for (int j = 1; j <= sq; ++j){
            divs[i].push_back(j);
        }
        int dv = a[i] / sq;
        for (; dv > 0; --dv){
            divs[i].push_back(a[i] / dv);
        }
    }
}

void work1(){
    unordered_map<int, ld> dp[N];
    dp[0][k] = 1;
    for (int i = 0; i < n; ++i){
        for (auto dv : divs[i]){
            for (auto val : dp[i]){
                int& state = dp[i + 1][(val.fr + dv - 1) / dv];
                state = max(state, val.sc * (a[i] / dv));
            }
        }
    }
    ld res = dp[n][1] * k;
    for (int i = 0; i < n; ++i){
        res /= a[i];
    }
    printf("%.20Lf\n", res);
}


int main(){
    input();
    precount1();
    work1();
}
