#include <iostream>
#include <vector>
#include <deque>
#include <set>
#include <string>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <bitset>

#define f first
#define s second
#define int long long

using namespace std;

const int N = 2*1e5, mod = 1e9+7;
int t1 = 1;

void start();
void update();




signed main() {
    start();
    while(t1--){
        update();
    }
    return 0;
}
int n, k, m;
void start(){
    //cin >> t1;

}

map<pair<int, int>, double> mp;

double get_dp(int a1, int b1, vector<double> &a){
    if(a1 == 0){
        if(mp[{a1, b1}] == 0){
            mp[{a1, b1}] = (1-((int)a[a1]%((int)b1))/a[a1])/b1;
        }
        return mp[{a1, b1}];
    }
    else{
        double ans = 0;
        if(mp[{a1, b1}] == 0){
            for(int t = 1; t <= a[a1]; t++){
                ans = max(ans, get_dp(a1-1, ceil((double)b1/(double)t), a)*(1-((int)a[a1]%((int)t))/a[a1])/t);
            }
            mp[{a1, b1}] = ans;
        }
        return mp[{a1, b1}];
    }
}

void update(){
    cin >> n >> k;
    vector<double> a(n);
    for(int i = 0; i<n; i++){
        cin >> a[i];
    }
    if(n == 1){
        if(k > a[0]){
            cout << 0;
            return;
        }
        cout.precision(16);
        cout << floor(a[0]/k)/a[0]*k;
        return;
    }
    if(n == 2){
        double maxx = 0;
        for(double i = 1; i<=a[0]; i++){
            int b2 = ceil(k/i);
            if(b2 > a[1]){
                continue;
            }
            maxx = max(maxx, floor(a[0]/i)*floor(a[1]/b2)/a[0]/a[1] * k);
        }
        cout.precision(16);
        cout << maxx;
        return;
    }
    bool bad = true;
    int pr = 1;
    for(int i = 0; i<n; i++){
        pr *= a[i];
        if(pr >= k){
            bad = false;
            break;
        }
    }
    if(bad){
        cout << 0;
        return;
    }
    cout.precision(16);
    cout << get_dp(n-1, k, a)*k;
}
