#include <bits/stdc++.h>

using namespace std;

mt19937 mt_rand(time(nullptr));

long double rnd() {
    return (long double)rand() / RAND_MAX;
}

long double t = 100;
long double mul = 0.99;

long double iters = 10000;

int f(vector <int> &a, vector <int> &b, int k) {

    int res = 1;
    bool ok = false;
    int m = 1;
    for (int i = 0; i < a.size(); i++) {
        m *= b[i];
        if (m >= k) ok = true, m = 0;
        res *= (a[i] / b[i]);
    }
    if (!ok) return 0;
    return res;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    

    int n;
    cin >> n;
    int k;
    cin >> k;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector <int> b(n);  
    for (int i = 0; i < n; i++) {
        b[i] = a[i] - mt_rand() % a[i];
    }
    int best = f(a, b, k);
    int mx = 0;
    for (int i = 0; i < iters; i++) {
        mx = max(mx, best);
        int pos = mt_rand() % n;
        int new_val = a[pos] - mt_rand() % a[pos];
        int prev = b[pos];
        b[pos] = new_val;
        int now = f(a, b, k);
        if (now > best || exp((now - best) / t) > rnd()) {
            best = now;
        } else {
            b[pos] = prev;
        }
        t *= mul;
    }
    long double res = k * mx;
    for (int i = 0; i < n; i++) {
        res /= a[i];
    }
    cout << res;
    return 0;
}