#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<iomanip>
#include<algorithm>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    long long n, k;
    cin >> n >> k;

    vector<long long> v(n);
    for (int i = 0; i < n; i++)
        cin >> v[i];

    if (n == 1) {
        cout << fixed << setprecision(12) << (long double)(v[0] / k) / v[0] * k << '\n';
    } else if (n == 2) {
        long long total = v[0] * v[1];
        if (total < k) {
            cout << "0\n";
            return 0;
        }

        long long mx = -1;
        for (long long i = 0; i < min(v[0], k); i++) {
            long long a = v[0] / (i + 1);

            long long cur = (k + i) / (i + 1);
            if (cur > v[1]) continue;

            long long b = v[1] / cur;
            mx = max(mx, a * b);
        }

        cout << fixed << setprecision(12) << (long double)mx / v[0] / v[1] * k << '\n';
    }

    return 0;
}
