#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

#pragma GCC optimize "Ofast"
using namespace std;
typedef uint32_t uint;

constexpr uint MAXN = 100;
constexpr uint MAXK = 10000000;
double dp1[2 * MAXK + 7];
double dp2[2 * MAXK + 7];
double *d1 = dp1;
double *d2 = dp2;
uint a[MAXN];
int main() {
    cout << fixed << setprecision(12);
    uint n, k;
    cin >> n >> k;
    int kk = 2 * k + 2;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (auto &x : dp1) x = 0;
    for (auto &x : dp2) x = 0;
    dp2[1] = 1;
    for (uint i = 0; i < n; ++i) {
        swap(d2, d1);
        for (uint j = 0; j <= k; ++j) {
            d2[j] = (d2[j] > d1[j] ? d2[j] : d1[j]);
        }
        for (uint j = 2; j <= a[i]; ++j) {
            const double rm = ((double)(a[i] / j)) / a[i];
            uint j1, j2;
            for (j1 = 0, j2 = 0; j1 <= (k + (j - 1) - 1) / (j - 1); j1 += 1, j2 += j) {
                d2[j2] = (d1[j1] * rm > d2[j2] ? d1[j1] * rm : d2[j2]);
            }
        }
    }
    double mx = 0;
    for (uint i = k; i < 2 * k + 2; ++i) mx = max(mx, d2[i]);
    cout << mx * k << endl;
    return 0;
}
