#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<>,
        rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ff first
#define ss second

using pii = pair <int, int>;

template <typename T1, typename T2>
void mxr(T1& a, const T2& b) {
    if (a < b) {
        a = b;
    }
}

template <typename T1, typename T2>
void mnr(T1& a, const T2& b) {
    if (a > b) {
        a = b;
    }
}

const int MAXK = 2e5 + 1;
const int MAXN = 101;
long double dp[MAXN][MAXK];

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
#endif
    int n, k;
    cin >> n >> k;
    vector <int> v(n);
    for (auto &i : v) {
        cin >> i;
    }
    for (auto &i : dp) {
        for (auto &j : i) {
            j = -1;
        }
    }
    {
        bool flag = false;
        int cur = 1;
        for (int i = 0; i < n; ++i) {
            if (1ll * cur * v[i] >= k) {
                flag = true;
                break;
            }
            cur *= v[i];
        }
        if (!flag) {
            cout << 0;
            return 0;
        }
    }
    dp[0][1] = k;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= 2 * k; ++j) {
            for (int p = 1; p * p <= j && p <= v[i - 1]; ++p) {
                if (j % p == 0) {
                    mxr(dp[i][j], dp[i - 1][j / p] * (v[i - 1] / p) / (1.l * v[i - 1]));
                }
            }
            int t = sqrt(j) + 1;
            for (int p = t; p >= 0 && (j / p) <= v[i - 1]; --p) {
                if (j % p == 0) {
                    mxr(dp[i][j], dp[i - 1][p] * (v[i - 1] / (j / p)) / (1.l * v[i - 1]));
                }
            }
        }
    }
    long double res = -1;
    for (int t = 0; t < size(dp[n]); ++t) {
        if (t >= k) {
            mxr(res, dp[n][t]);
        }
    }
    cout << setprecision(15) << fixed << res;
}
