#include <bits/stdc++.h>

#define int long long

#ifndef DDD
#define cerr if(0) cerr
#endif

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &u: v) {
        is >> u;
    }
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &u: v) {
        os << u << ' ';
    }
    return os;
}

vector<int> a;

int n, k;

void solve() {
    cout.setf(ios::fixed);
    cout.precision(9);

    cin >> n >> k;
    a.resize(n);
    cin >> a;

    if (n <= 2) {
        if (n == 1) {
            cout << 1.0 * (a[0] / k) / a[0] * k;
            return;
        }
        double ans = 0;
        for (int i = 1; i <= a[0]; ++i) {
            ans = max(ans, k * 1.0 / a[0] * 1.0 / a[1] * (a[0] / i) * (a[1] / ((k + i - 1) / i)));
        }
        cout << ans << '\n';
        return;
    }

    vector<vector<double>> dp(n + 1, vector<double>(k + 1));
    dp[0][1] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= k; ++j) {
            int l = 1;
            dp[i][j] = max(dp[i][j], dp[i - 1][(j + l - 1) / l] * (a[i - 1] / l));
            while (l != a[i - 1] + 1) {
                int bsl = l, bsr = a[i - 1] + 1;
                while (bsl + 1 < bsr) {
                    int bsm = (bsl + bsr) / 2;
                    if (a[i - 1] / bsm < a[i - 1] / l) {
                        bsr = bsm;
                    } else {
                        bsl = bsm;
                    }
                }
                l = bsr - 1;
                dp[i][j] = max(dp[i][j], dp[i - 1][(j + l - 1) / l] * (a[i - 1] / l));
                l = bsr;
            }
        }
    }

    double ans = dp.back().back();
    ans *= k;
    for (int i = 0; i < n; ++i) {
        ans /= a[i];
    }
    cout << ans << '\n';
}

int32_t main() {
#ifdef DDD
    freopen("/mnt/commons/day1/input.txt", "r", stdin);
#else
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}