#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define inf (ll)1e9
#define db double

const db eps = 1e-9;

ll all, ans;
ll n, k;
vector<ll> rotor;
vector<ll> a;
void gen(ll pos) {
    if (pos == n) {
        ll get = 1, check = 1;
        for (ll i = 0; i < n; i++) get *= rotor[i], check *= (a[i] / rotor[i]);
        if (get * k > all || check < k) return;
        if ((get * k) > ans) {
            ans = (get * k);
        }
        return;
    }
    for (ll i = 1; i <= a[pos]; i++) {
        rotor[pos] = i;
        gen(pos + 1);
    }
}

void solve() {
    cin >> n >> k;
    all = 1;
    rotor.resize(n);
    a.resize(n);
    sort(a.begin(), a.end());
    for (ll& x : a) cin >> x, all *= x;
    if (n == 2) {
        for (ll i = 1; i <= a[0]; i++) {
            ll l = 1, r = a[1] + 1;
            while (r - l > 1) {
                ll mid = (r + l) >> 1;
                if (mid * k * i > all || (a[0] / i) * (a[1] / mid) < k) {
                    r = mid;
                    continue;
                }
                if (mid * k * i > ans) {
                    ans = mid * k * i;
                }
                l = mid;
            }
        }
        cout << (db)ans / (db)all << "\n";
        return;
    }
    gen(0);
    cout << (db)ans / (db)all << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cout << fixed << setprecision(20);

    ll t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}