#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <algorithm>
#include <numeric>

using namespace std;


//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' '
#define debnl(x) cout << #x << '=' << x << endl
#define name(x) cout << #x << endl;
#define print(a) { cout << #a << endl; for (auto x: a) cout << x << ' '; cout << endl; }
#define print2d(a) { cout << #a << endl; for (auto x: a) {for (auto y: x) cout << y << ' '; cout << endl;} cout << endl; }
#define printpair(a) { for (auto x: a) cout << '(' << x.first << ' ' << x.second << ") "; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define name(x)
#define print(a)
#define print2d(a)
#define printpair(a)

#endif

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;
typedef long double LD;

mt19937_64 rnd;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

void solve();

signed main() {
	int T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
}


void solve() {
	ll n, k;
	cin >> n >> k;
	
	vll a = vll(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	vll b = vll(n, 1);
	LD best = 0;
	int ev = 0;
	for (int ev = 0; ev < 1e7 / n; ev++) {
		ll product = 1;
		bool flag = false;
		b = vll(n, 1);
		for (int i = 0; i < n; i++) {
			b[i] = rnd() % a[i];
			product *= b[i];
			if (product >= k) {
				break;
			}
		}
		if (!flag) continue;
		LD res = k;
		for (int i = 0; i < n; i++) {
			res *= ((LD)(a[i] / b[i])) / ((LD)(a[i]));
		}
		best = max(best, res);
		shuffle(all(a), rnd);
	}

	cout.precision(20);
	cout << fixed;
	cout << best;
}
