#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>



using namespace std;
typedef long long ll;
typedef double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)
#pragma GCC optimization("Ofast")
#pragma GCC optimization("sse4")
void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll MX = 2e5+10;

int main() {
    fastio();
    /*ll sm = 0;
    for (ll i = 1;i<MX;i++){
        vector<ll> rev;
        for (ll j = 2;j*j<=i;j++){
            if (i % j == 0){
                dels[i].push_back(j);
                if (i *i < j) rev.push_back(i/j);
            }
        }
        reverse(all(rev));
        for (ll x : rev) dels[i].push_back(x);
        dels[i].push_back(i);
        sm+=dels[i].size();
    }*/
    ll n, k;
    cin >> n >> k;
    if (n == 2){
        ll a, b;
        cin >> a >> b;
        ld ans = 0;
        for (ll x = 1;x<=a;x++){
            ll y = (k+x-1) / x;
            if (y <= b){
                ans = max(ans, (a / x) * (b / y) * (ld)1 / a / b * k);
            }
        }
        fout(20) << ans << "\n";
        return 0;
    }else if(n==1){
        ll a;
        cin >> a;
        if (a < k) cout <<"0\n";
        else{
            fout(20) << k * (ld)1 / a * (a / k) << "\n";
        }
        return 0;
    }
    vector<ld> dp(k + 1, -1);
    dp[1] = k;
    vector<ll> a(n);
    for (ll i = 0;i<n;i++) cin >> a[i];
    ld ans = 0;
    for (ll i = 0;i<n;i++){
        for (ll j = k; j>=1; j--){
            if (dp[j] > 0) {
                ld key = (ld)1 / a[i];
                ll nj = 0;
                for (ll x = 2; x <= a[i]; x++) {
                    nj = j*x;
                    if (nj <= k){
                        dp[nj] = max(dp[nj], dp[j] * key * (a[i] / x));
                    }
                    if (nj >= k) {
                        ans = max(ans, dp[j] * key * (a[i] / x));
                        break;
                    }
                }
            }
        }
    }
    fout(20) << ans << "\n";
    return 0;
}