#include <iostream>
#include <vector> 
#include <algorithm> 
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define F first
#define S second
typedef long long ll;

signed main() {
    ll n, k; cin >> n >> k;
    vector<ll> a(n); 
    for (ll i = 0; i < n; i++) cin >> a[i];
    ll P = 1;
    for (ll i = 0; i < n; i++) P = P * a[i];
    if (P < k) {
        cout << 0;
        return 0;
    }
    sort(all(a));
    if (n == 2) {
        ll mx = 0;
        for (ll b1 = 1; b1 <= a[0]; b1++) {
            ll b2 = (k + b1 - 1) / b1;
            if (b2 == 0) b2 = 1;
            if (b2 <= a[1]) mx = max(mx, (a[0] / b1) * (a[1] / b2));
        }
        long double ans = mx * k;
        for (ll i = 0; i < n; i++) ans /= a[i];
        cout << setprecision(20) << fixed << ans;
        return 0;
    }
    if (n == 1) {
        long double ans = (a[0] / k) * k;
        for (ll i = 0; i < n; i++) ans /= a[i];
        cout << setprecision(20) << fixed << ans;
        return 0;
    }
    vector<vector<ll> > d(k + 1);
    for (ll i = 1; i <= k; i++) {
        for (ll j = 1; j * j <= i; j++) {
            if (i % j == 0) {
                d[i].pb(j);
                if (j * j != i) d[i].pb(i / j);
            }
        }
    } 
    vector<vector<ll> > dp(n, vector<ll> (k + 2));
    for (ll b = 1; b <= min(a[0], k + 1); b++) dp[0][b] = a[0] / b;
    for (ll i = 1; i < n; i++) {
        for (ll p = 1; p <= k; p++) {
            for (auto b : d[p]) {
                if (p % b != 0) continue;
                if (1 <= b && b <= a[i]) dp[i][p] = max(dp[i][p], dp[i - 1][p / b] * (a[i] / b));
            }
        }
        for (ll q = 1; q <= k; q++) {
            for (ll b = 1; b <= a[i]; b++) {
                if (q * b <= k) continue;
                dp[i][k + 1] = max(dp[i][k + 1], dp[i - 1][q] * (a[i] / b));
            }
        }
    }
    /*for (ll i = 0; i < n; i++) {
        for (ll j = 1; j <= k + 1; j++) {
            cout << dp[i][j] << " ";
        }
        cout << endl;
    }*/
    long double ans = max(dp[n - 1][k], dp[n - 1][k + 1]) * k;
    for (ll i = 0; i < n; i++) ans /= a[i];
    cout << setprecision(20) << fixed << ans;
    return 0;
}