#include <iostream>
#include <vector>
#include <iomanip>
using namespace std;
typedef long long ll;
typedef long double ld;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n; cin >> n;
	ll k; cin >> k;
	vector<ll> a(n);
	ll P = 1;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		P *= a[i];
	}
	if (n == 1) {
		if (k > a[0]) {
			cout << 0;
		}
		else {
			ld ans = (ld)(k * (a[0] / k)) / (ld)(a[0]);
			cout << ans;
		}
		return 0;
	}
	if (n == 2) {
		ll max_ans = 0;
		for (ll i = 1; i <= a[0]; ++i) {
			ll j = (k + i - 1) / i;
			if (j <= a[1]) {
				ll cur_ans = (a[0] / i) * (a[1] / j);
				max_ans = max(max_ans, cur_ans);
			}
		}
		ld ans = (ld)(max_ans * k) / (ld)(a[0] * a[1]);
		cout << setprecision(30) << ans;
		return 0;
	}
	ll K = 1e6;
	vector<vector<ll>> dp(n + 1, vector<ll>(K + 1, 0));
	for (ll i = 1; i <= a[0]; ++i) {
		dp[1][i] = a[0] / i;
	}
	for (int i = 2; i <= n; ++i) {
		for (ll j = 1; j <= a[i - 1]; ++j) {
			for (ll z = j; z <= K; z += j) {
				dp[i][z] = max(dp[i][z], dp[i - 1][z / j] * (a[i - 1] / j));
			}
		}
	}
	ll max_el = 0;
	for (ll z = k; z <= K; ++z) {
		max_el = max(max_el, dp[n][z]);
	}
	long double ans = (long double)max_el * (long double)k / (long double)P;
	cout << setprecision(30) << ans;

	return 0;
}