#pragma GCC optimize("fast-math")

#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define pb push_back
#define ff first
#define ss second
#define err(x) cerr << "[" << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[" << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "[" << ""#x"" << "] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}
using ll = long long;
using ld = double;

using namespace std;

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}

mt19937 rnd(::std::chrono::high_resolution_clock::now().time_since_epoch().count());
const int MOD = 1e9 + 7;

/// actual code starts here

const int N = 101, K = 1e7 + 5;

ld dp[2][K];
vector<pair<int, ld>> w[N]; // give b, give a / b
int a[N];
int n, k;
const ld inf = 1000000;

void split(int x, int id) {
    for (int i = 1; i <= x;) {
        int ans = x / (x / i);
        w[id].pb({ans, log(x / ans)});
        i = ans + 1;
    }
}

ld suf[N];


unordered_map<int, ld> mem[N];

ld go(int p, ll cur_mul) {
    if (cur_mul >= k) {
        return suf[p];
    }
    if (p == n + 1)
        return -inf;
    if (mem[p].find(cur_mul) != mem[p].end())
        return mem[p][cur_mul];
    ld res = -inf;
    for (auto [b, d]: w[p]) {
        res = max(res, go(p + 1, cur_mul * b) + d);
    }
    mem[p][cur_mul] = res;
    return res;
}

void solve() {
    cin >> n >> k;
    int t = 1;
    ld mult = 0;
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        if (x != 1) {
            a[t++] = x;
            mult += log(x);
        }
    }
    if (mult < log(k)) {
        cout << 0;
        return;
    }
    if (k == 1 && t == 1) {
        cout << 1;
        return;
    }
    n = t - 1;
    sort(a + 1, a + n + 1);
    for (int i = 1; i <= n; i++) {
        split(a[i], i);
    }
    for (int i = 1; i <= n; i++) suf[i] = log(a[i]);
    for (int i = n - 1; i >= 1; i--) suf[i] += suf[i + 1];
    ld res = go(1, 1);
    ld cof = 0;
    for (int i = 1; i <= n; i++) cof -= log(a[i]);
    cof += log(k);
    res += cof;
    cout.precision(20);
    cout << fixed << exp(res);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) solve();
}