#include <bits/stdc++.h>
#define int long long
#define double long double
#define x first
#define y second
#define inf (INT64_MAX / 2)

using namespace std;


void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (n == 1) {
        cout << (double)((a[0] / k) * k) / (double)a[0] << '\n';
        return;
    }
    if (n == 2) {
        int ans = 0;
        for (int i = 1; i <= a[0]; i++) {
            int j = (k + i - 1) / i;
            if (j > a[1]) {
                continue;
            } else {
                ans = max(ans, (a[0] / i) * (a[1] / j));
            }
        }
        cout << (double)ans * (double)k / (double)a[0] / (double)a[1] << '\n';
        return;
    }
    vector<vector<int>> dp(n, vector<int>(k + 1, 0));
    for (int i = 1; i < k + 1; i++) {
        dp[0][i] = a[0] / i;
    }
    for (int i = 1; i < n; i++) {
        for (int j = 1; j <= k; j++) {
            for (int l = 1; l <= a[i]; l++) {
                int ii = (j + l - 1) / l;
                dp[i][j] = max(dp[i][j], dp[i - 1][ii] * (a[i] / l));
            }
        }
    }
    auto ans = (double)(dp[n - 1][k] * k);
    for (int i = 0; i < n; i++) {
        ans /= (double)a[i];
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cout << setprecision(100);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}