#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

int n;
int k;

const int N = 3;
const int K = 10000010;

int a[N];
vector <pair <int, ld>> maybe[N];
ld dp[N][K];

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> n >> k;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
		int f = 1;
		int v = a[i];

		while (v)
		{
			int x = a[i] / v + 1;
			int nv = a[i] / x;
			maybe[i].push_back({ x - 1, (ld)(a[i] / f) / a[i] });
			f = x;
			v = nv;
		}
	}

	dp[0][1] = k;
	for (int i = 1; i <= n; ++i)
	{
		for (auto j : maybe[i])
		{
			for (int pre = 1;; ++pre)
			{
				int nv = min((ll)pre * j.first, (ll)k);
				dp[i][nv] = max(dp[i][nv], (ld)dp[i - 1][pre] * j.second);
				if (nv == k) break;
			}
		}
	}

	cout << fixed << setprecision(20) << dp[n][k];

	return 0;
}