#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <iomanip>
#include <cmath>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define setpr setprecision(15)

typedef int64_t ll;
typedef uint64_t ull;
typedef pair<int, int> pii;

int n, k;
vector<int> a;
double ans = 0;

void dfs(int i, int cur, double res) {
    if (i == n) {
        if (cur >= k) {
            ans = max(ans, res);
        }
        return;
    }
    dfs(i + 1, cur, res);
    for (int j = 2; j <= a[i] && cur < k; j++) {
        dfs(i + 1, cur * j, res * (a[i] / j) / a[i]);
    }
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    dfs(0, 1, 1);

    cout << setpr << ans * k;




    return 0;
}
