#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <iomanip>
#include <cmath>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define setpr setprecision(15)

typedef int64_t ll;
typedef uint64_t ull;
typedef pair<int, int> pii;

int n, k;
vector<int> a;
double ans = 0;

void dfs(int i, int cur, double res) {
    if (cur >= k) {
        ans = max(ans, res);
        return;
    }
    if (i == n) {
        return;
    }
    for (int j = i + 1; j <= n; j++) {
        dfs(j, cur, res);
    }
    for (int j = 2; j <= a[i]; j++) {
        dfs(i + 1, cur * j, res * (a[i] / j) / a[i]);
    }
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<vector<double>> dp(n + 1, vector<double> (k + 1, 0));
    for (int i = 0; i < n; i++) {
        dp[i][1] = 1;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= k; j++) {
            for (int d = 1; d <= a[i]; d++) {
                dp[i + 1][min(k, j * d)] = max(dp[i + 1][min(k, j * d)], dp[i][j] * (double)(a[i] / d) / a[i]);
                if (j * (d + 1) > k && j * d >= k) {
                    break;
                }
            }
        }
    }

    for (int i = 0; i <= n; i++) {
        ans = max(ans, dp[i][k]);
    }

    cout << setpr << ans * k;




    return 0;
}