//#pragma GCC optimize("Ofast")
//#pragma GCC terget("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

const ll INF64 = 9'000'000'000'000'000'000, INF32 = 2'000'000'000, MOD = 1'000'000'007;
const double PI = acos(-1);
bool l = false;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, k;
	cin >> n >> k;
	vector<double> adp(k + 1, 0), dp(k + 1, 0);
	dp[1] = 1;
	adp[1] = 1;
	ll nn = 1;
	vector<ll> all(n, 0);
	for (ll i = 0; i < n; i++) {
		cin >> all[i];
	}
	sort(all.begin(), all.end());
	for (ll i = 0; i < n - 1; i++) {
		ll x = all[i];
		vector<double> odp = dp;
		for (ll j = 2; j <= min(x, k); j++) {
			ll nm = x / j;
			if (j == k || nm > x / (j + 1)) {
				ll nk = 1;
				for (; nk * j <= k && nk <= nn; nk++) {
					assign_max(dp[nk * j], odp[nk] * nm / x);
				}
				assign_max(dp.back(), odp[nk] * nm / x);
			}
		}
		nn *= x;
		for (ll j = min(k, nn); j > 1; j--) {
			assign_max(dp[j - 1], dp[j]);
		}
		if (assign_min(nn, k)) {
			vector<double> oadp = adp;
			for (ll j = k; j > 1; j--) {
				ll nk = 1;
				for (; nk * j <= k; nk++) {
					assign_max(adp[nk * j], dp[j] * oadp[nk]);
				}
				assign_max(adp[k], dp[j] * oadp[nk]);
				dp[j] = 0;
			}
			for (ll j = k; j > 1; j++) {
				assign_max(adp[j - 1], adp[j]);
			}
			nn = 1;
		}
	}
	ll x = all.back();
	double ans = 0;
	for (ll j = 1; j <= x; j++) {
		ll nm = x / j;
		assign_max(ans, dp[(k + j - 1) / j] * nm / x);
	}
	cout << setprecision(20) << ans * k << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef LOCAL
	l = true;
#endif
	if (!l) {
		solve();
	} else {
		solve();
	}
}

