#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}


void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    cin >> a;
    vector<ll> dp(2 * k, 0);
    dp[1] = 1;
    for (int i = 0; i < n; i++) {
        vector<ll> n_dp(2 * k, 0);
        for (int per = 1; per < 2 * k; per++) {
            for (int b = 1; b <= a[i]; b++) {
                n_dp[per] = max(n_dp[per], dp[ceil(double(per) / b)] * (a[i] / b));
            }
        }
        dp = n_dp;
    }
    double ans = k;
    for (auto el: a) {
        ans /= double(el);
    }
    double maxim = 0;
    for (int i = k; i < 2 * k; i++) {
        maxim = max(maxim, double(dp[i]));
    }
    cout  << fixed << setprecision(9)<< maxim * ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}