#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back
#define int long long
#define ld long double

const int N = 1e5 + 1;
const int mod = 1e9 + 7;

ld dp[N][2];

template <class T>
bool chmax (T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

vc <int> get_nd (int x) {
    vc <int> nd;
    for (int j = 1; j <= x;) {
        int l = j, r = x + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (x / m ==x / j) {
                l = m;
            } else {
                r = m;
            }
        }
        nd.pb(l);
        j = r;
    }
    return nd;
}

void solve () {
    int n, k;
    cin >> n >> k; --k;
    vc <int> a(n);
    for (int &i : a)
        cin >> i;
    int was = 0;
    vc <int> ps = get_nd(k);
    vc <int> pos;
    for (int i : ps) {
        pos.pb(k / i);
    }
    pos.pb(0);
    reverse(all(pos));
    dp[sz(pos) - 1][0] = k + 1;
    for (int i = 0; i < n; ++i) {
        int to = was ^ 1;
        for (int j = 0; j < sz(pos); ++j) {
            dp[j][to] = 0;
        }
        for (int j = 1; j < sz(pos); ++j) {
            chmax(dp[j][was], dp[j - 1][was]);
        }
        vc <int> nd = get_nd(a[i]);

        for (int j : nd) {
            int u = sz(pos) - 1;
            for (int e = sz(pos) - 1; e >= 0; --e) {
                while (pos[e] / j < pos[u])
                    --u;
                chmax(dp[u][to], dp[e][was] * (a[i] / j) / (ld)(a[i]));
            }
        }
        was = to;
    }
    cout << dp[0][was] << '\n';
}

signed main () {
    cout << fixed << setprecision(10);
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}