#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    ll p = 1;
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        p *= a[i];
    }
    vector<vector<ll>> dp(n, vector<ll> (k + 1));
    for (ll j = 1; j <= a[0]; j++) {
        dp[0][j] = a[0] / j;
    }
    for (ll i = 1; i < n; i++) {
        for (ll j = 1; j <= k; j++) {
            for (ll b = 1; b <= a[i]; b++) {
                dp[i][j] = max(dp[i][j], dp[i - 1][(j + b - 1) / b] * (a[i] / b));
            }
        }
    }
    ll mx = 0;
    for (ll i = 0; i < n; i++) {
        mx = max(mx, dp[i][k]);
    }
    cout.precision(12);
    cout << fixed << double(mx) / double(p) * double(k);
}

int main() {
#ifdef LOCAL
    ll clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif
    while (tpk--) {
        solve();
        cout << endl;
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}