#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;
const int MOD = 1e9 + 7;

inline void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;
    vector<map<int, int>> dp(n);
    for (int i = 1; i <= a[0]; ++i) {
        dp[0][i] = max(dp[0][i], a[0] / i);
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j <= a[i]; ++j) {
            for (auto [kk, v] : dp[i - 1]) {
                if (v * a[i] / j < dp[i][j * kk] && j * kk > k)
                    break;
                dp[i][j * kk] = max(dp[i][j * kk], v * (a[i] / j));
            }
        }
    }
    long long ap = 1;
    for (auto i : a)
        ap *= i;
    long double con = k * (1. / ap);
    long double ans = 0;
    for (auto i : dp.back()) {
        if (i.first < k)
            continue;
        ans = max(ans, con * i.second);
    }
    cout << setprecision(10) << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    // cin >> tests;
    for (int i = 1; i <= tests; ++i)
        solve();
}
