#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define int ll
#define double ld

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v)
        os << e << " ";
    return os;
}

vector<int> factor(int x) {
    vector<int> res;
    for (int i = 2; i * i <= x; ++i) {
        while (x % i == 0) {
            x /= i;
            res.push_back(i);
        }
    }

    if (x != 1) {
        res.push_back(x);
    }
    return res;
}

string f(int a, int b, int c) {
    __int128_t x = a;
    x *= b;
    x *= inf;
    x *= inf;
    x /= c;

    string res = "";
    while (x > 0) {
        res += to_string(int(x % 10));
        x /= 10;
    }
    reverse(all(res));
    return res;
}

int solve_2(int k, int a, int b) {
    int res = 0;
    for (int i = 1; i <= a; ++i) {
        int other = (k + i - 1) / i;
        int x = a / i;
        int y = b / other;
        res = max(res, x * y);
    }

    return res;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int &e: a)
        cin >> e;

    if (k == 1) {
        cout << 1 << endl;
        return;
    }

    int m = 1;
    for (int i: a)
        m *= i;

    if (m < k) {
        cout << 0 << endl;
        return;
    }

    if (n == 2) {
        cout << 1.0 * k * solve_2(k, a[0], a[1]) / m << endl;
        return;
    }

    vector<vector<int>> dp(n + 1, vector<int>(k + 1));
    dp[0][1] = 1;

    for (int i = 1; i <= n; ++i) {
        for (int x = 1; x <= a[i - 1]; ++x) {
            for (int u = 1; u <= k; ++u) {
                dp[i][min(k, u * x)] = max(dp[i][min(k, u * x)], dp[i - 1][u] * (a[i - 1] / x));
            }
        }
    }

    if (k * dp[n][k] == m) {
        cout << 1 << endl;
        return;
    }

    cout << 1.0 * k * dp[n][k] / m << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    cout.precision(16);
    cout << fixed;
    solve();

    return 0;
}