#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
const ll INF=1e18+2;
const ll N=1e6+2;

ve<ll> getv(ll x)
{
    ve<ll> v;
    ll pos=1;

    while(x/pos>=2)
    {
        ll l=pos,r=x;

        while(l<r)
        {
            ll mid=(l+r+1)/2;
            if(x/mid==x/pos) l=mid;
            else r=mid-1;
        }

        v.PB(l);
        pos=l+1;
    }

    v.PB(x);
    return v;
}

ll arr[N];

void solve()
{
    ll n,k;
    cin>>n>>k;

    for(ll i=0;i<n;i++)
        cin>>arr[i];

    map<ll,ll> dp;
    dp[1]=1;

    for(ll i=0;i<n;i++)
    {
        map<ll,ll> dp1=dp;
        ve<ll> v=getv(arr[i]);

        for(pll j:dp)
        {
            for(ll y:v)
            {
                if(!dp1.count(min(k,j.F*y)))
                    dp1[min(k,j.F*y)]=j.S*(arr[i]/y);

                else dp1[min(k,j.F*y)]=max(dp1[min(k,j.F*y)],j.S*(arr[i]/y));
            }
        }

        dp=dp1;
    }

    if(!dp.count(k))
    {
        cout<<0;
        return;
    }

    ld ans=dp[k]*k;

    for(ll i=0;i<n;i++)
        ans/=arr[i];

    cout<<fixed<<setprecision(12)<<ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
