#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) r.begin(), r.end()

typedef long long ll;
typedef double ld;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cout << fixed << setprecision(9);

    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<vector<pair<int, int>>> m(n);
    for (int i = 0; i < n; i++) {
        int cur = a[i];
        while (true) {
            if (cur == 0) break;
            m[i].push_back({a[i] / cur, cur});
            cur = a[i] / (a[i] / cur + 1);
        }
        reverse(all(m[i]));
    }

    if (n <= 2) {
        if (n == 1) {
            a.push_back(1);
            n++;
        }

        map<ll, ll> m1, m2;
        for (int i = 1; i <= a[0]; i++) {
            m1[a[0] / i] = i;
        }
        for (int i = 1; i <= a[1]; i++) {
            m2[a[1] / i] = i;
        }

        ll mx = 0;
        for (auto [e1, b1] : m1) {
            for (auto [e2, b2]: m2) {
                if (b1 * b2 >= k) {
                    mx = max(mx, e1 * e2);
                }
            }
        }

        ld ans = mx * k;
        for (int i = 0; i < n; i++) ans = ans / a[i];
        cout << ans << '\n';
    } else {
        ld ans = 0;
        vector<ld> dp1(k), dp2(k);
        dp1[1] = k;
        for (int i = 0; i < n; i++) {
            for (int j = 1; j < k; j++) {
                for (auto [sz, nxt] : m[i]) {
                    if (j * nxt >= k) {
                        ans = max(ans, dp1[j] * sz / a[i]);
                        break;
                    } else if (i + 1 < n) {
                        dp2[j * nxt] = max(dp2[j * nxt], dp1[j] * sz / a[i]);
                    }
                }
            }
            swap(dp1, dp2);
            dp2.assign(k, 0);
        }

        cout << ans << '\n';
    }

    return 0;
}