#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

#define vec vector
#define pb push_back
#define sz(x) (int) (x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using str = string;

#ifdef Local
#define debug(x) cout << endl \
                      << "$ " << #x << " = " << x << endl
#else
#define debug(...) 1337
#endif

void solve() {
    int n, k;
    cin >> n >> k;
    vec<int> a(n);
    for (int &i: a)
        cin >> i;
    for (int s = 1, i = 0; i < n; ++i) {
        s *= a[i];
        if (s >= k)
            break;
        if (i == n - 1) {
            cout << "0\n";
            return;
        }
    }
    vec<vec<ld>> b(n);
    for (int i = 0; i < n; ++i) {
        b[i] = {1., (ld) a[i]};
        for (int s = 2; s < a[i]; ++s) {
            b[i].pb((ld) a[i] / s);
        }
    }
    unordered_set<ld> c, p = {1};
    ld m = (int) 1e18;
    for (int i = 0; i < n; ++i) {
        for (ld &t: b[i]) {
            for (const ld &x: p) {
                if (x * t >= k)
                    m = min(m, x * t);
                else
                    c.insert(x * t);
            }
        }
        swap(c, p);
        c = {};
    }
    cout << (ld) k / (ld) m;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(12);
    fixed(cout);

    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();

    return 0;
}