#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
using namespace std;

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T x : v) out << x << " ";
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define ll long long
#define ld long double

ll n, k;
vector<ll> v;
//ld mxr = 0;

//void calc(int i, int l, ll pr, ld ans) {
//    if (i == n || pr >= k) {
//        if (pr >= k && ans > mxr) mxr = ans;
//        return;
//    }
//    for (ll c = l; c <= v[i]; c++) {
//        calc(i + 1, c, pr * c, ans * (ll)(v[i] / c) / (ld)v[i]);
//    }
//}

vector<map<ll, ld>> dp;

ld calc(int i, ll j) {
    if (dp[i].find(j) == dp[i].end()) {
        if (i == 0) {
            if (j <= v[i]) dp[i][j] = v[i] / j;
        } else {
            for (ll c = 1; c <= v[i]; c++) {
                ll d = j / c + ((j / c) * c != j);
                dp[i][j] = max(dp[i][j], calc(i - 1, d) * (v[i] / c));

//                ll l = c, r = v[i] + 1;
//                while (l < r - 1) {
//                    ll m = (l + r) / 2;
//
//                    if (j / m + ((j / m) * m != j) || v[i] / m != v[i] / c) r = m;
//                    else l = m;
//                }
//                c = r;
            }
        }
        dp[i][j] /= (ld) v[i];
    }
    return dp[i][j];
}


void solve() {

    cin >> n >> k;

    v.resize(n);
    ll mxa = 0;
    for (ll& x : v) {
        cin >> x;
        mxa = max(mxa, x);
    }

    if (n <= 2) {
        if (n == 1) {
            cout << (ld)(v[0] / k) / (ld)v[0] * k;
        } else {
            if (v[0] * v[1] < k) cout << 0;
            else {
                ll mx = 0;
                for (ll c = 1; c <= min(k, v[0]); c++) {
                    ll d = k / c + (bool)(k % c);
                    if (d <= v[1]) mx = max(mx, (v[0] / c) * (v[1] / d));
                }

                cout << (ld)mx / (ld)v[0] / (ld)v[1] * k;
            }
        }

        return;
    }

    dp.resize(n, map<ll, ld>());

    cout << calc(n - 1, k) * k;

}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    cout << setprecision(10) << fixed;

    solve();

}