#include <bits/stdc++.h>

using namespace std;


#define int long long
//#define double long double
#define endl '\n'



vector <vector<pair<int, int> > > graph;

const int mod = 1000000007;


vector <int> Dejkastra(int s) {
    vector <int> dl(graph.size(), 1e9);
    vector <bool> used(graph.size());
    dl[s] = 0;
    int n = graph.size();
    for (int qwe = 0; qwe < n; ++qwe) {
        int v = -1;
        for (int i = 0; i < n; ++i) {
            if (v == -1 || (dl[v] > dl[i] && used[i] == 0)) {
                v = i;
            }
        }
        for (int i = 0; i < graph[v].size(); ++i) {
            int u = graph[v][i].first, w = graph[v][i].second;
            dl[u] = min(dl[u], dl[v] + w);
        }
    }
    return dl;
}

void solve(int & n, vector <vector <int> > & a, vector <int> & sz) {
    vector <int> maxi(n);
    graph.resize(n + 1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < sz[i]; ++j) {
            maxi[i] = max(maxi[i], a[i][j]);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j)
                continue;
            int cur = maxi[i], kol = 0;
            for (int k = 0; k < sz[j]; ++k) {
                if (a[j][k] > cur) {
                    kol++;
                    cur = a[j][k];
                }
            }
            graph[i].push_back({j, kol});
        }
    }
    for (int i = 0; i < n; ++i) {
        int cur = 0, kol = 0;
        for (int j = 0; j < sz[i]; ++j) {
            if (a[i][j] > cur) {
                kol++;
                cur = a[i][j];
            }
        }
        graph[n].push_back({i, kol});
    }
    vector <int> dl = Dejkastra(n);
    for (int i = 0; i < n; ++i) {
        cout << dl[i] << endl;;
    }
    int mx = 0;
    for (int i = 0; i < dl.size(); ++i) {
        mx = max(mx, dl[i]);
    }
    cout << mx;
}

signed main()
{

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (n == 1) {
        if (a[0] < k) {
            cout << 0;
            return 0;
        } else {
            long double qwe = (a[0] / k);
            cout << setprecision(15) << qwe * (long double)(1 / (long double)(a[0])) * (long double)(k);
        }
    }
    if (n == 2) {
        long double ans = 0;
        for (int i = 1; i <= min(k, a[0]); ++i) {
            int x = (k + i - 1) / i;
            if (x > a[1])
                continue;
            int qwe = (a[0] / i) * (a[1] / x);
            long double cnt =  (long double)(qwe) * (long double)(1 / (long double)(a[0] * a[1])) * (long double)(k);
            ans = max(ans, cnt);
        }
        cout << setprecision(15) << ans;
    }
}
