#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <queue>
#include <random>
#include <vector>

using namespace std;

long double eps = 1e-9;

long double ans = -1e9;

int n, k;
vector <int> b;
vector <int> a;

void f(int pos, long long curk = 1, long double res = 1) {
	if (pos == n) {
		if (curk >= k)
			ans = max(ans, res * k);
		return;
	}
	for (int i = 1; i <= a[pos]; i++) {
		if (curk * (i - 1) >= 1ll * k)
			break;
		long double resp = res;
		b.push_back(i);
		resp *= (int)(a[pos] / b[pos]);
		resp *= (1.0 / a[pos]);
		f(pos + 1, curk * i, resp);
		b.pop_back();
	}
}

void solve() {
	cin >> n >> k;
	a.resize(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	f(0);
	if (ans == -1e9)
		ans = 0;
	cout << fixed << setprecision(10) << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}