#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <bit>

using namespace std;

#define get_time() ((double)clock() / (double)CLOCKS_PER_SEC)

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << setprecision(30) << fixed;

    int n, k;
    cin >> n >> k;
    vector<vector<long double>> dp(n, vector<long double>(k));
    dp[0][1] = 1;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    long double ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < k; ++j) {
            if (dp[i][j] != 0) {
                for (int b = 1; b <= a[i]; ++b) {
                    long double val = dp[i][j] * (a[i] / b) / a[i];
                    if (j * b < k) {
                        if (i != n - 1) {
                            dp[i + 1][j * b] = max(dp[i + 1][j * b], val);
                        }
                    } else {
                        ans = max(ans, val);
                        break;
                    }
                }
            }
        }
    }
    ans *= k;
    cout << ans;
}