#include <iostream>
#include <iomanip>
#define endl '\n'
using namespace std;

const int MAXN = 100;
const int MAXK = 4000000;

int a[MAXN + 5];
long double dp[2][MAXK + 1];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, k;
    cin >> n >> k;

    long double x = 1.0 * k;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        x /= a[i];
    }

    if (x > 1)
    {
        cout << 0 << endl;
        return 0;
    }

    if (n == 1)
    {
        cout << fixed << setprecision(10) << (a[1] / k) * x << endl;
        return 0;
    }

    if (n == 2)
    {
        long double ans = 0;
        for (int i = 1; i <= a[1]; ++ i)
        {
            if ((k - 1) / i + 1 <= a[2])
            {
                int j = (k - 1) / i + 1;
                ans = max(ans, x * (a[1] / i) * (a[2] / j));
            }
        }
        cout << fixed << setprecision(10) << ans << endl;
        return 0;
    }

    for (int i = 1; i <= a[1]; ++ i)
    {
        dp[0][i] = x * (a[1] / i);
    }

    int curr = 0;
    for (int i = 2; i <= n; ++ i)
    {
        curr ^= 1;
        for (int pr = 1; pr <= k; ++ pr)
        {
            dp[curr][pr] = 0;
        }
        for (int pr = 1; pr <= k; ++ pr)
        {
            for (int j = 1; j <= a[i]; ++ j)
            {
                int pr1 = pr * j;
                if (pr1 > k)
                {
                    pr1 = k;
                    dp[curr][pr1] = max(dp[curr][pr1], dp[curr ^ 1][pr] * (a[i] / j));
                    break;
                }
                dp[curr][pr1] = max(dp[curr][pr1], dp[curr ^ 1][pr] * (a[i] / j));
            }
        }
    }

    cout << fixed << setprecision(10) << dp[curr][k] << endl;

    return 0;
}
