#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"
#include "cmath"
#include "iomanip"

using namespace std;

typedef long long ll;
typedef long double ld;


void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

void solve() {
    cout << fixed << setprecision(10);
    ld n, k;
    cin >> n >> k;
    vector<ld> v(n);
    for (ld &i: v)
        cin >> i;
    if (n == 1) {
        if (v[0] < k) {
            cout << 0;
            return;
        }
        cout << ll(v[0] / k) / v[0] * k;
        return;
    }
    if (v[0] * v[1] < k) {
        cout << 0;
        return;
    }
    ld ans = 0;
    for (ld j = 1; j <= v[0]; j++) {
        ld i = ceil(k / j);
        ans = max(ans, ll(v[0] / j) * ll(v[1] / i) / v[0] / v[1] * k);
    }
    cout << ans;

}